SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = core, pg_catalog;

INSERT INTO cip_sys_module VALUES (1, 'Media', 'media', 'Analyze MediaNet traffic collected from your devices', 1, 'Media settings');
INSERT INTO cip_sys_module VALUES (2, 'MIB', 'mib', 'MIB and SNMP manager', 15, 'MIB settings');
INSERT INTO cip_sys_module VALUES (3, 'MultiLog', 'multilog', 'Display syslog and SNMP trap messages', 5, 'MultiLog settings');
INSERT INTO cip_sys_module VALUES (4, 'Flow', 'flow', 'NetFlow', 25, 'Flow settings');
INSERT INTO cip_sys_module VALUES (5, 'NMS', 'nms', 'Network Management System', 30, 'NMS settings');
INSERT INTO cip_sys_module VALUES (6, 'Users', 'users', 'Users data and credentials', -1, NULL);
INSERT INTO cip_sys_module VALUES (7, 'General', 'misc', NULL, -1, NULL);

DO $$
DECLARE
	user_id login.principal.id_role%TYPE;
BEGIN
	INSERT INTO login.principal VALUES (DEFAULT, NULL, current_timestamp, NULL, NULL, 'User') RETURNING id_role INTO user_id;
	INSERT INTO login."user" VALUES (user_id, 'admin', '18c6d818ae35a3e8279b5330eda01498', 'Super', 'Administrator', true, false, false, '', '', '', '');

	-- ZA lite MIB i MULTILOG, ZA full SVI!
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (1, user_id, 'ADMIN');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (2, user_id, 'ADMIN');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (3, user_id, 'ADMIN');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (4, user_id, 'ADMIN');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (5, user_id, 'ADMIN');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (6, user_id, 'ADMIN');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (7, user_id, 'WRITE');
	
	INSERT INTO login.principal VALUES (DEFAULT, NULL, current_timestamp, NULL, NULL, 'User') RETURNING id_role INTO user_id;
	INSERT INTO login."user" VALUES (user_id, 'guest', 'd55b0f642e817eea24725d2f2a31dd08', 'Guest', 'Guest', true, false, false, '', '', '', '');
	
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (1, user_id, 'READ');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (2, user_id, 'READ');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (3, user_id, 'READ');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (4, user_id, 'READ');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (5, user_id, 'READ');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (6, user_id, 'NONE');
	INSERT INTO permission_module(id_cip_sys_module, id_role, security_level) VALUES (7, user_id, 'READ');
END$$;

SET search_path = filter, pg_catalog;

INSERT INTO action_set(service_name, default_action) VALUES ('SNMP', 'REJECT');
INSERT INTO action_set(service_name, default_action) VALUES ('MEDIA-EMPTY', 'REJECT');
INSERT INTO action_set(service_name, default_action) VALUES ('MEDIA', 'ACCEPT');

SET search_path = framework, pg_catalog;

INSERT INTO db_version(patch_number, patch_date) VALUES (0, current_timestamp);

SET search_path = public, pg_catalog;

INSERT INTO system_property VALUES ('EXPORTER_INTERVAL', 'media', 'INTEGER', '60');
INSERT INTO system_property VALUES ('REFRESH_INTERVAL', 'media', 'INTEGER', '5');
INSERT INTO system_property VALUES ('CLEANUP_INTERVAL', 'media', 'INTEGER', '45');
INSERT INTO system_property VALUES ('GB_TO_KEEP', 'media', 'DOUBLE', '1.0');
INSERT INTO system_property VALUES ('DAYS_TO_KEEP', 'media', 'INTEGER', '60');
INSERT INTO system_property VALUES ('SOCKET_PORT', 'media', 'INTEGER', '2055');

INSERT INTO system_property VALUES ('SEARCH_LIMIT', 'mib', 'INTEGER', '100');
INSERT INTO system_property VALUES ('LIST_REQ_LIMIT', 'mib', 'INTEGER', '100');
INSERT INTO system_property VALUES ('TABLE_REQ_LIMIT', 'mib', 'INTEGER', '200');

INSERT INTO system_property VALUES ('SHOW_NAVIGATION', 'multilog', 'BOOLEAN', 'true');
INSERT INTO system_property VALUES ('SYSLOG_CLEANUP_INTERVAL', 'multilog', 'INTEGER', '1');
INSERT INTO system_property VALUES ('SYSLOG_DEFAULT_SEV', 'multilog', 'INTEGER', '3');
INSERT INTO system_property VALUES ('SYSLOG_PORT', 'multilog', 'INTEGER', '33514');
INSERT INTO system_property VALUES ('TRAP_CLEANUP_INTERVAL', 'multilog', 'INTEGER', '1');
INSERT INTO system_property VALUES ('TRAP_PORT', 'multilog', 'INTEGER', '33162');
INSERT INTO system_property VALUES ('TRAP_DATABASE_SIZE', 'multilog', 'DOUBLE', '1.0');
INSERT INTO system_property VALUES ('TRAP_DAYS_TO_KEEP', 'multilog', 'INTEGER', '60');
INSERT INTO system_property VALUES ('SYSLOG_DATABASE_SIZE', 'multilog', 'DOUBLE', '1.0');
INSERT INTO system_property VALUES ('SYSLOG_DAYS_TO_KEEP', 'multilog', 'INTEGER', '60');

INSERT INTO system_property VALUES ('SERVICE_ARCHIVE_FOLDER', 'netflow', 'TEXT', '/var/lib/icmynet/flow/archive');
INSERT INTO system_property VALUES ('SERVICE_MAX_FILES', 'netflow', 'INTEGER', '2016');
INSERT INTO system_property VALUES ('SERVICE_MIN_FREE_SPACE', 'netflow', 'INTEGER', '3072');
INSERT INTO system_property VALUES ('SERVICE_TMP_FOLDER', 'netflow', 'TEXT', '/var/lib/icmynet/flow/temp');
INSERT INTO system_property VALUES ('SOCKET_TIMEOUT', 'netflow', 'INTEGER', '5');
INSERT INTO system_property VALUES ('SOCKET_PORT', 'netflow', 'INTEGER', '2055');

INSERT INTO system_property VALUES ('DATE_FORMAT', 'misc', 'TEXT', 'dd. MMM yyyy');
INSERT INTO system_property VALUES ('TIMEWINDOW', 'misc', 'TEXT', '1');

SET search_path = netflow, pg_catalog;

INSERT INTO default_config (type, top_as, top_conversation, top_host, top_protocol, top_qos, top_service, top_children) VALUES
('EXPORTER',10,10,10,10,10,10,10),
('INTERFACE',10,10,10,10,10,10,10),
('PATTERN',10,10,10,10,10,10,10),
('SUBNET',10,10,10,10,10,10,10),
('SUBNET_SET',10,10,10,10,10,10,10);
