SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = typology, pg_catalog;

INSERT INTO value_type (name) VALUES ('String');
INSERT INTO value_type (name) VALUES ('Int32');
INSERT INTO value_type (name) VALUES ('Int64');
INSERT INTO value_type (name) VALUES ('OID');

-- Dodavanje Network Device DTa i Interface SDTa sa pripadajucim resursima
begin;
	insert into core.criterion values (
		nextval('core.criterion_id_seq'), null, null, null, null, null, '', 'AND', 'CompositeCriterion'
	);
	insert into typology.device_type values (
		1, null, 'Network Device', 'A generic network device', true, true, currval('core.criterion_id_seq')
	);
	insert into core.criterion
	select nextval('core.criterion_id_seq'), id_test, 'OID', '.1.3.6.1.2.1.1.1.0', null, 'OID:IS_NOT_NULL', null, null, 'SimpleCriterion'
	from typology.device_type
	where id_device_type = 1;

	insert into typology.subdevice_category values (
		1, 'Interface', 'Interface', true
	);
	insert into typology.subdevice_type values (
		1, 1, 1, null, '.1.3.6.1.2.1.2.2.1.1', 1, true, true
	);

	insert into typology.resource_category values (
		1, null, 'Name', 'SNMP Resurs sysName', null, true
	);
	insert into typology.resource_category values (
		2, null, 'Description', 'SNMP Resurs sysDescr', null, true
	);
	insert into typology.resource_category values (
		3, 1, 'Name', 'SNMP Resurs ifName', null, true
	);
	insert into typology.resource_category values (
		4, 1, 'Interface description', 'SNMP Resurs ifDescr', null, true
	);
	insert into typology.resource_type values (
		3, null, 1, 3, 'DEVICE_SUBDEVICE_IDENT', 'Name', '.1.3.6.1.2.1.31.1.1.1.1', true, false, 1, 0, true, true
	);
	insert into typology.resource_type values (
		4, null, 1, 4, 'DEVICE_SUBDEVICE_IDENT', 'Description', '.1.3.6.1.2.1.2.2.1.2', false, true, 1, 1, true, true
	);
commit;
--------------------------------------------------------------------------------
