#!/bin/sh
# db patch script

# exit level
exit_level=0

# check for db version
db_version=`sudo -u postgres psql --quiet netvizura -c "SELECT MAX(patch_number) FROM framework.db_version;" -t -A`
# db_version_success=$? # this may be useful someday

if [ -z $db_version ]
then
        # there is an error with getting DB version
        exit_level=1
else
        echo "current DB version is $db_version"
        # apply patches
        for patch in ./patch/*
        do
                patch_num=`echo "$patch" | egrep --only-matching "patch_([0-9]){3}" | tail -c 4`
                if [ "$patch_num" -gt "$db_version" ]
                then
                        echo "applying patch $patch"
                        sudo -u postgres psql netvizura < $patch >> /var/log/netvizura/dbinit.log 2>&1
                fi
        done
fi

if [ $exit_level -gt "0" ]
then
        echo "ERROR: could not get DB version; the database has NOT been updated. Exiting!"
        exit $exit_level
fi
