-- Prosirenje value_type tabele
ALTER TABLE typology.value_type ADD COLUMN ind_evid boolean DEFAULT false;
ALTER TABLE typology.value_type ADD COLUMN ind_resource boolean DEFAULT false;
INSERT INTO typology.value_type (id_value_type, name, ind_evid) VALUES (5, 'Date', true);
update typology.value_type set ind_evid = true where id_value_type = 1;
update typology.value_type set ind_resource = true where id_value_type < 5;


-- device_type_property
CREATE TABLE typology.device_type_property
(
  id_device_type_property serial NOT NULL,
  id_device_type integer,
  name character varying(256),
  id_value_type integer,
  ordering integer,
  ind_system boolean DEFAULT false,
  ind_active boolean DEFAULT true,
  CONSTRAINT fk_device_type_property PRIMARY KEY (id_device_type_property),
  CONSTRAINT fk_device_type_property_device_type FOREIGN KEY (id_device_type)
      REFERENCES typology.device_type (id_device_type) MATCH FULL
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_device_type_property_value_type FOREIGN KEY (id_value_type)
      REFERENCES typology.value_type (id_value_type) MATCH FULL
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE typology.device_type_property
  OWNER TO postgres;
  
-- insert defaultnih redova u device_type_property za sve root device_typeove
insert into typology.device_type_property
select nextval('typology.device_type_property_id_device_type_property_seq'), dt.id_device_type, aux.name, aux.id_value_type, aux.ordering, true, true from
(
  SELECT 'Purchase no.' as name, 1 as id_value_type, 0 as ordering
    UNION
  SELECT 'Supplier' as name, 1 as id_value_type, 1 as ordering
    UNION 
  SELECT 'Date of delivery' as name, 5 as id_value_type, 2 as ordering
    UNION 
  SELECT 'Register no.' as name, 1 as id_value_type, 3 as ordering
    UNION 
  SELECT 'Warranty expiration date' as name, 5 as id_value_type, 4 as ordering
) aux inner join
(SELECT *
 FROM typology.device_type
 WHERE id_parent IS NULL
) dt on 1 = 1 ;


-- device_property
CREATE TABLE device.device_property
(
  id_device_property serial NOT NULL,
  id_device integer NOT NULL,
  id_device_type_property integer NOT NULL,
  value text,
  date_last_change timestamp without time zone,
  CONSTRAINT fk_device_property PRIMARY KEY (id_device_property),
  CONSTRAINT fk_device_property_device FOREIGN KEY (id_device) 
    REFERENCES device.device (id_device) MATCH FULL
    ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk_device_property_device_type_property FOREIGN KEY (id_device_type_property)
    REFERENCES typology.device_type_property (id_device_type_property) MATCH FULL
    ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);
ALTER TABLE device.device_property
  OWNER TO postgres;

INSERT INTO framework.db_version(patch_number, patch_date) VALUES(38, current_timestamp);