﻿CREATE TABLE typology.vendor_type
(
  id_vendor_type serial NOT NULL,
  oid text,
  name character varying(256),
  ind_system boolean DEFAULT false,
  CONSTRAINT pk_vendor_type PRIMARY KEY (id_vendor_type),
  CONSTRAINT uq_vendor_type_oid UNIQUE (oid),
  CONSTRAINT uq_vendor_type_name UNIQUE (name)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE typology.vendor_type
  OWNER TO postgres;

INSERT INTO typology.vendor_type (id_vendor_type, oid, name, ind_system) VALUES (1, '.1.3.6.1.4.1.9', 'Cisco', true);
INSERT INTO typology.vendor_type (id_vendor_type, oid, name, ind_system) VALUES (2, '.1.3.6.1.4.1.2636', 'Juniper', true);
INSERT INTO typology.vendor_type (id_vendor_type, oid, name, ind_system) VALUES (3, '.1.3.6.1.4.1.311', 'Microsoft', true);
INSERT INTO typology.vendor_type (id_vendor_type, oid, name, ind_system) VALUES (4, '.1.3.6.1.4.1.11', 'HP', true);
INSERT INTO typology.vendor_type (id_vendor_type, oid, name, ind_system) VALUES (5, '.1.3.6.1.4.1.318', 'APC', true);

SELECT setval('typology.value_type_id_value_type_seq', 5);

ALTER TABLE device.device
   ADD COLUMN id_vendor_type integer;

ALTER TABLE device.device
  ADD CONSTRAINT fk_device_vendor_type FOREIGN KEY (id_vendor_type) REFERENCES typology.vendor_type (id_vendor_type)
   ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX fki_device_vendor_type
  ON device.device(id_vendor_type);

INSERT INTO framework.db_version(patch_number, patch_date) VALUES(39, current_timestamp);
