ALTER TABLE device.subdevice
   ALTER COLUMN id_device DROP NOT NULL;
   
ALTER TABLE device.subdevice
  ADD COLUMN marked_time timestamp without time zone;
   
UPDATE device.subdevice
	SET id_device = null WHERE id_parent IS NOT null;


ALTER TABLE device.subdevice_ip_address
   ADD COLUMN date_exported timestamp without time zone;
   
UPDATE device.subdevice_ip_address SET date_exported = current_timestamp WHERE exporter = true;

ALTER TABLE device.subdevice_ip_address DROP COLUMN exporter;

ALTER TABLE device.subdevice 
ADD COLUMN netflow_interface BOOLEAN DEFAULT FALSE;

ALTER TABLE netflow.counter_config
	ADD COLUMN device bigint;

UPDATE netflow.counter_config c
	SET device = (SELECT id_device FROM device.device d WHERE c.exporter = d.ip_address);

DELETE FROM netflow.counter_config
	WHERE exporter NOT IN (SELECT DISTINCT ip_address FROM device.device);

ALTER TABLE netflow.counter_config
	DROP COLUMN exporter;

ALTER TABLE netflow.counter_config
	DROP CONSTRAINT counter_conf_fk_subnet_set;

ALTER TABLE netflow.counter_config
	ADD CONSTRAINT counter_conf_fk_subnet_set FOREIGN KEY (subnet_set)
	REFERENCES netflow.subnet_set (id) MATCH SIMPLE
	ON UPDATE NO ACTION ON DELETE CASCADE;

ALTER TABLE netflow.counter_config
	ADD CONSTRAINT counter_conf_fk_exporter FOREIGN KEY (device)
	REFERENCES device.device (id_device) MATCH SIMPLE
	ON UPDATE NO ACTION ON DELETE CASCADE;


UPDATE typology.resource_category SET name = 'ifAlias', description = 'SNMP Resurs ifAlias' WHERE id_resource_category = 4;
UPDATE typology.resource_type SET name = 'ifAlias' WHERE id_resource_type = 4;

INSERT INTO typology.resource_category
SELECT 6, 1, 'ifDescr', 'SNMP Resurs ifDescr', null, true
WHERE
    NOT EXISTS (
        SELECT id_resource_category FROM typology.resource_type WHERE oid_prefix = '.1.3.6.1.2.1.2.2.1.2'
);

INSERT INTO typology.resource_type
SELECT 6, null, 1, 6, 'DEVICE_SUBDEVICE_IDENT', 'ifDescr', '.1.3.6.1.2.1.2.2.1.2', false, true, 1, 2, true, true
WHERE
    NOT EXISTS (
        SELECT id_resource_category FROM typology.resource_type WHERE oid_prefix = '.1.3.6.1.2.1.2.2.1.2'
);

--za mac ordering povecati
UPDATE typology.resource_type SET ordering = 3 WHERE id_resource_type = 5 
AND EXISTS (
        SELECT id_resource_category FROM typology.resource_type WHERE oid_prefix = '.1.3.6.1.2.1.2.2.1.2' and id_resource_type = 6
);

INSERT INTO device.ignored_subnet(id_ignored_subnet, ip_address)
SELECT nextval('device.ignored_subnet_id_ignored_subnet_seq'), '127.0.0.0/8'
WHERE 
	NOT EXISTS (
		SELECT id_ignored_subnet FROM device.ignored_subnet WHERE ip_address = '127.0.0.0/8'
);

-- UPDATE 19.03.2015
UPDATE device.subdevice_ip_address
	SET date_exported = (select timestamp 'epoch')
	WHERE id_subdevice IN (
		SELECT id_subdevice FROM device.subdevice_ip_address
		WHERE host(ip_address::INET)::INET IN (
			SELECT DISTINCT exporter FROM netflow.exporter_device_total_g1
			UNION
			SELECT DISTINCT exporter FROM netflow.exporter_device_total_g2
			UNION 
			SELECT DISTINCT exporter FROM netflow.exporter_device_total_g3
			)
		AND date_exported IS NULL
		);
		
UPDATE netflow.alarm naa 
	SET scopeid = (
		SELECT sd.id_device
		FROM netflow.alarm na
		INNER JOIN device.subdevice_ip_address sa ON host(sa.ip_address::INET) = na.scopeid
		INNER JOIN device.subdevice sd ON sd.id_subdevice = sa.id_subdevice
		WHERE sd.marked_time IS NULL
		AND na.id = naa.id
		)
	WHERE naa.scopetype = 'EXPORTER'
	AND naa.scopeid IS NOT NULL;
	
DO $$DECLARE 
  alarm record;
  address varchar;
  snmpIndex varchar;
  device_id integer;
BEGIN
  FOR alarm IN SELECT * FROM netflow.alarm WHERE scopetype = 'INTERFACE' AND scopeid IS NOT NULL
  LOOP
	address = split_part(alarm.scopeid, '-', 1);
	snmpIndex = split_part(alarm.scopeid, '-', 2);
	SELECT id_device INTO device_id FROM (
		SELECT id_device FROM device.subdevice WHERE marked_time IS NULL AND id_subdevice IN (
			SELECT id_subdevice FROM device.subdevice_ip_address sa
			WHERE host(sa.ip_address::INET) = address)) pom;
	
	UPDATE netflow.alarm naa
		SET scopeid = device_id || '-' || snmpIndex
		WHERE naa.id = alarm.id;
  END LOOP;
END$$;
-- END OF UPDATE 19.03.2015


-- UPDATE 26.03.2015
ALTER TABLE netflow.sample_ratio
	ADD COLUMN id_device bigint;

ALTER TABLE netflow.sample_ratio
	ADD CONSTRAINT sample_ratio_fk_exporter FOREIGN KEY (id_device)
		REFERENCES device.device (id_device) MATCH SIMPLE
		ON UPDATE NO ACTION ON DELETE CASCADE;
		
UPDATE netflow.sample_ratio sr
	SET id_device = (SELECT id_device FROM device.device d WHERE sr.exporter = d.ip_address);
	
DELETE FROM netflow.sample_ratio
	WHERE exporter NOT IN (SELECT DISTINCT ip_address FROM device.device);
	
ALTER TABLE netflow.sample_ratio
	DROP COLUMN exporter;
-- END OF UPDATE 26.03.2015

-- UPDATE 09.04.2015
UPDATE typology.device_type SET name = 'QoS Device', description = 'QoS Device' WHERE id_device_type = 20;
-- END OF UPDATE 09.04.2015

INSERT INTO framework.db_version(patch_number, patch_date) VALUES(45, current_timestamp);