ALTER TABLE device.subdevice 
	DROP CONSTRAINT dist_subdevice_on_device ;

ALTER TABLE device.subdevice
	ADD CONSTRAINT dist_subdevice_on_device UNIQUE (id_device, id_subdevice_type, index) DEFERRABLE INITIALLY DEFERRED;

	
ALTER TABLE device.subdevice
	DROP CONSTRAINT fk_subdevice_parent;
	  
ALTER TABLE device.subdevice
	ADD CONSTRAINT fk_subdevice_parent FOREIGN KEY (id_parent)
		REFERENCES device.subdevice (id_subdevice) MATCH FULL
		ON UPDATE CASCADE ON DELETE CASCADE;
		

ALTER TABLE device.device_property
	DROP CONSTRAINT fk_device_property_device;
  
ALTER TABLE device.device_property
	ADD CONSTRAINT fk_device_property_device FOREIGN KEY (id_device)
		REFERENCES device.device (id_device) MATCH FULL
		ON UPDATE CASCADE ON DELETE CASCADE;
		

ALTER TABLE typology.device_device_type
	DROP CONSTRAINT fk_device_device_type;
		  
ALTER TABLE typology.device_device_type
	ADD CONSTRAINT fk_device_device_type FOREIGN KEY (id_device)
		REFERENCES device.device (id_device) MATCH FULL
		ON UPDATE CASCADE ON DELETE CASCADE;
		

ALTER TABLE device.resource  
	DROP CONSTRAINT fk_resource_monitor;
		
ALTER TABLE device.resource  
	ADD CONSTRAINT fk_resource_monitor FOREIGN KEY (id_monitor)
		REFERENCES device.monitor (id_monitor) MATCH FULL
		ON UPDATE CASCADE ON DELETE CASCADE;
		
ALTER TABLE device.resource_composite
	DROP CONSTRAINT fk_resource_composite_monitor;
	
ALTER TABLE device.resource_composite
	ADD CONSTRAINT fk_resource_composite_monitor FOREIGN KEY (id_monitor)
		REFERENCES device.monitor (id_monitor) MATCH FULL
		ON UPDATE CASCADE ON DELETE CASCADE;
		

ALTER TABLE device.monitor
	DROP CONSTRAINT fk_monitor_device;
		
ALTER TABLE device.monitor
	ADD CONSTRAINT fk_monitor_device FOREIGN KEY (id_device)
		REFERENCES device.device (id_device) MATCH FULL
		ON UPDATE CASCADE ON DELETE CASCADE;


ALTER TABLE device.monitor
	DROP CONSTRAINT fk_monitor_subdevice;
 
ALTER TABLE device.monitor
	ADD CONSTRAINT fk_monitor_subdevice FOREIGN KEY (id_subdevice)
		REFERENCES device.subdevice (id_subdevice) MATCH FULL
		ON UPDATE CASCADE ON DELETE CASCADE;
		
INSERT INTO framework.db_version(patch_number, patch_date) VALUES(47, current_timestamp);