ALTER TABLE device.device
	ADD COLUMN date_created timestamp without time zone NOT NULL DEFAULT CURRENT_TIMESTAMP;

DO $$DECLARE 
  cnt integer;
BEGIN
	SELECT COUNT(1) INTO cnt FROM typology.resource_category WHERE id_resource_category = 1;
	IF cnt > 0 THEN
		UPDATE typology.resource_category SET name = 'SysName', description = 'SNMP Resource SysName', ind_system = true WHERE id_resource_category = 1;
	ELSE
		INSERT INTO typology.resource_category (id_resource_category, name, description, ind_system) VALUES (1, 'SysName', 'SNMP Resource SysName', true);
	END IF;
	
	SELECT COUNT(1) INTO cnt FROM typology.resource_category WHERE id_resource_category = 2;
	IF cnt > 0 THEN
		UPDATE typology.resource_category SET name = 'SysDescription', description = 'SNMP Resource SysDescription', ind_system = true WHERE id_resource_category = 2;
	ELSE
		INSERT INTO typology.resource_category (id_resource_category, name, description, ind_system) VALUES (2, 'SysDescription', 'SNMP Resource SysDescription', true);
	END IF;
	
	SELECT COUNT(1) INTO cnt FROM typology.resource_type WHERE id_resource_type = 1;
	IF cnt > 0 THEN
		UPDATE typology.resource_type 
			SET name = 'SysName', id_device_type = 1, id_subdevice_type = null, id_resource_category = 1, oid_prefix = '.1.3.6.1.2.1.1.5.0', discriminator = 'DEVICE_TYPE',
			ind_system = true, ind_name = true, ind_description = false, id_value_type = 1, ordering = 0, ind_active = true, hidden = false, id_monitor_type = null
			WHERE id_resource_type = 1;
	ELSE
		INSERT INTO typology.resource_type (id_resource_type, name, id_device_type, id_subdevice_type, id_resource_category, oid_prefix, discriminator, 
			ind_system, ind_name, ind_description, id_value_type, ordering, ind_active, hidden, id_monitor_type) 
		VALUES (1, 'SysName', 1, null, 1, '.1.3.6.1.2.1.1.5.0', 'DEVICE_TYPE', true, true, false, 1, 0, true, false, null);
	END IF;
	
	SELECT COUNT(1) INTO cnt FROM typology.resource_type WHERE id_resource_type = 2;
	IF cnt > 0 THEN
		UPDATE typology.resource_type 
			SET name = 'SysDescription', id_device_type = 1, id_subdevice_type = null, id_resource_category = 2, oid_prefix = '.1.3.6.1.2.1.1.1.0', discriminator = 'DEVICE_TYPE',
			ind_system = true, ind_name = false, ind_description = true, id_value_type = 1, ordering = 1, ind_active = true, hidden = false, id_monitor_type = null
			WHERE id_resource_type = 2;
	ELSE
		INSERT INTO typology.resource_type (id_resource_type, name, id_device_type, id_subdevice_type, id_resource_category, oid_prefix, discriminator, 
			ind_system, ind_name, ind_description, id_value_type, ordering, ind_active, hidden, id_monitor_type) 
		VALUES (2, 'SysDescription', 1, null, 2, '.1.3.6.1.2.1.1.1.0', 'DEVICE_TYPE', true, false, true, 1, 1, true, false, null);
	END IF;
END$$;

UPDATE device.resource 
	SET id_resource_type = 1
	WHERE id_resource_type IN (
		SELECT id_resource_type FROM typology.resource_type WHERE oid_prefix LIKE '.1.3.6.1.2.1.1.5%' AND id_resource_type > 100
	);

UPDATE device.resource 
	SET id_resource_type = 2 
	WHERE id_resource_type IN (
		SELECT id_resource_type FROM typology.resource_type WHERE oid_prefix LIKE '.1.3.6.1.2.1.1.1%' AND id_resource_type > 100
	);

DELETE FROM typology.resource_type WHERE oid_prefix LIKE '.1.3.6.1.2.1.1.5%' AND id_resource_type > 100;

DELETE FROM typology.resource_type WHERE oid_prefix LIKE '.1.3.6.1.2.1.1.1%' AND id_resource_type > 100;

DELETE FROM typology.resource_category WHERE LOWER(name) = 'sysname' AND id_resource_category > 100;

DELETE FROM typology.resource_category WHERE LOWER(name) = 'sysdescription' AND id_resource_category > 100;

INSERT INTO framework.db_version(patch_number, patch_date) VALUES (48, current_timestamp);