DELETE FROM mib.mib_module_import s1 WHERE s1.id_mib_module_import NOT IN 
(SELECT MIN(m.id_mib_module_import) as id FROM mib.mib_module_import m GROUP BY (m.id_mib_module, m.import, m.id_mib_module_import_from));

ALTER TABLE mib.mib_module_import ADD CONSTRAINT uk_id_mib_module_import_id_mib_module_import_from UNIQUE(id_mib_module, import, id_mib_module_import_from);

-- UPDATE 27.11.2015
ALTER TABLE multilog_conf.alarm 
	ADD COLUMN period_type character varying(20);
	
ALTER TABLE multilog_conf.alarm 
	ADD COLUMN message_count_limit integer;

ALTER TABLE multilog_conf.alarm 
	ADD COLUMN time_limit integer;	
	
UPDATE multilog_conf.alarm 
	SET period_type = 'INSTANT';
-- END OF UPDATE 27.11.2015

-- UPDATE 10.12.2015
CREATE TABLE netflow."user"
(
 id bigserial NOT NULL,
 username character varying(100) NOT NULL,
 domain character varying(100) NOT NULL,
 CONSTRAINT user_pkey PRIMARY KEY (id),
 CONSTRAINT user_ukey UNIQUE (username, domain)
)
WITH (
 OIDS=FALSE
);
ALTER TABLE netflow."user"
 OWNER TO netvizura;

CREATE TABLE netflow.user_session
(
 id bigserial NOT NULL,
 user_id bigserial NOT NULL,
 ip_address inet NOT NULL,
 start_time timestamp without time zone,
 end_time timestamp without time zone,
 CONSTRAINT user_session_pkey PRIMARY KEY (id),
 CONSTRAINT user_session_fkey FOREIGN KEY (user_id)
	REFERENCES netflow.user (id) MATCH SIMPLE
	ON UPDATE CASCADE ON DELETE CASCADE
)
WITH (
 OIDS=FALSE
);
ALTER TABLE netflow.user_session
 OWNER TO netvizura;

 -- Table: netflow.user_mapping_host_g1

-- DROP TABLE netflow.user_mapping_host_g1;

CREATE TABLE netflow.user_mapping_host_g1
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  host inet NOT NULL,
  byte_upload bigint,
  byte_download bigint,
  pack_upload bigint,
  pack_download bigint,
  flow_upload bigint,
  flow_download bigint,
  CONSTRAINT user_mapping_host_g1_pkey PRIMARY KEY (id),
  CONSTRAINT user_mapping_host_g1_fkey FOREIGN KEY (user_id)
	REFERENCES netflow.user (id) MATCH SIMPLE
	ON UPDATE CASCADE ON DELETE CASCADE
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_host_g1
  OWNER TO netvizura;

-- Index: netflow.user_mapping_host_g1_time_idx

-- DROP INDEX netflow.user_mapping_host_g1_time_idx;

CREATE INDEX user_mapping_host_g1_time_idx
  ON netflow.user_mapping_host_g1
  USING btree
  ("time");
  
  
  CREATE TABLE netflow.user_mapping_total_g1
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  byte_upload bigint,
  byte_download bigint,
  pack_upload bigint,
  pack_download bigint,
  flow_upload bigint,
  flow_download bigint,
  CONSTRAINT user_mapping_total_g1_pkey PRIMARY KEY (id),
  CONSTRAINT user_mapping_total_g1_fkey FOREIGN KEY (user_id)
      REFERENCES netflow."user" (id) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_total_g1
  OWNER TO netvizura;

-- Index: netflow.user_mapping_host_g1_time_idx

-- DROP INDEX netflow.user_mapping_host_g1_time_idx;

CREATE INDEX user_mapping_total_g1_time_idx
  ON netflow.user_mapping_total_g1
  USING btree
  ("time");
  
  -- Table: netflow.user_mapping_host_g2

-- DROP TABLE netflow.user_mapping_host_g2;

CREATE TABLE netflow.user_mapping_host_g2
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  host inet NOT NULL,
  byte_upload bigint,
  byte_download bigint,
  pack_upload bigint,
  pack_download bigint,
  flow_upload bigint,
  flow_download bigint,
  CONSTRAINT user_mapping_host_g2_pkey PRIMARY KEY (id),
  CONSTRAINT user_mapping_host_g2_fkey FOREIGN KEY (user_id)
      REFERENCES netflow."user" (id) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_host_g2
  OWNER TO netvizura;

-- Index: netflow.user_mapping_host_g2_time_idx

-- DROP INDEX netflow.user_mapping_host_g2_time_idx;

CREATE INDEX user_mapping_host_g2_time_idx
  ON netflow.user_mapping_host_g2
  USING btree
  ("time");

-- Table: netflow.user_mapping_host_g3

-- DROP TABLE netflow.user_mapping_host_g3;

CREATE TABLE netflow.user_mapping_host_g3
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  host inet NOT NULL,
  byte_upload bigint,
  byte_download bigint,
  pack_upload bigint,
  pack_download bigint,
  flow_upload bigint,
  flow_download bigint,
  CONSTRAINT user_mapping_host_g3_pkey PRIMARY KEY (id),
  CONSTRAINT user_mapping_host_g3_fkey FOREIGN KEY (user_id)
      REFERENCES netflow."user" (id) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_host_g3
  OWNER TO netvizura;

-- Index: netflow.user_mapping_host_g3_time_idx

-- DROP INDEX netflow.user_mapping_host_g3_time_idx;

CREATE INDEX user_mapping_host_g3_time_idx
  ON netflow.user_mapping_host_g3
  USING btree
  ("time");

-- Table: netflow.user_mapping_total_g2

-- DROP TABLE netflow.user_mapping_total_g2;

CREATE TABLE netflow.user_mapping_total_g2
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  byte_upload bigint,
  byte_download bigint,
  pack_upload bigint,
  pack_download bigint,
  flow_upload bigint,
  flow_download bigint,
  CONSTRAINT user_mapping_total_g2_pkey PRIMARY KEY (id),
  CONSTRAINT user_mapping_total_g2_fkey FOREIGN KEY (user_id)
      REFERENCES netflow."user" (id) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_total_g2
  OWNER TO netvizura;

-- Index: netflow.user_mapping_total_g2_time_idx

-- DROP INDEX netflow.user_mapping_total_g2_time_idx;

CREATE INDEX user_mapping_total_g2_time_idx
  ON netflow.user_mapping_total_g2
  USING btree
  ("time");

-- Table: netflow.user_mapping_total_g3

-- DROP TABLE netflow.user_mapping_total_g3;

CREATE TABLE netflow.user_mapping_total_g3
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  byte_upload bigint,
  byte_download bigint,
  pack_upload bigint,
  pack_download bigint,
  flow_upload bigint,
  flow_download bigint,
  CONSTRAINT user_mapping_total_g3_pkey PRIMARY KEY (id),
  CONSTRAINT user_mapping_total_g3_fkey FOREIGN KEY (user_id)
      REFERENCES netflow."user" (id) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_total_g3
  OWNER TO netvizura;

-- Index: netflow.user_mapping_total_g3_time_idx

-- DROP INDEX netflow.user_mapping_total_g3_time_idx;

CREATE INDEX user_mapping_total_g3_time_idx
  ON netflow.user_mapping_total_g3
  USING btree
  ("time");
  
  

-- Agregacija total tabele

CREATE OR REPLACE FUNCTION netflow.bulk_agg_user_mapping_total(
    srcsuffix text,
    srcgrain text,
    dstsuffix text,
    dstgrain text,
    t1 timestamp without time zone,
    t2 timestamp without time zone)
  RETURNS void AS
$BODY$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.user_mapping_total_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.user_mapping_total_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' 
	(time, user_id, byte_upload, byte_download, pack_upload, pack_download, flow_upload, flow_download) 
	SELECT $2, user_id, SUM(byte_upload) AS byte_upload, SUM(byte_download) AS byte_download, SUM(pack_upload) AS pack_upload, SUM(pack_download) AS pack_download, SUM(flow_upload) AS flow_upload, SUM(flow_download) AS flow_download  
	FROM ' || srctable::regclass || ' 
	WHERE "time" > $1 AND "time" <= $2 GROUP BY user_id' USING t1, t2;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE STRICT
  COST 100;
ALTER FUNCTION netflow.bulk_agg_user_mapping_total(text, text, text, text, timestamp without time zone, timestamp without time zone)
  OWNER TO postgres;
  
-- Agregacija host tabele
  
CREATE OR REPLACE FUNCTION netflow.bulk_agg_user_mapping_host(
    srcsuffix text,
    srcgrain text,
    dstsuffix text,
    dstgrain text,
    t1 timestamp without time zone,
    t2 timestamp without time zone)
  RETURNS void AS
$BODY$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.user_mapping_host_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.user_mapping_host_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' 
	(time, user_id, host, byte_upload, byte_download, pack_upload, pack_download, flow_upload, flow_download) 
	SELECT $2, user_id, host, SUM(byte_upload) AS byte_upload, SUM(byte_download) AS byte_download, SUM(pack_upload) AS pack_upload, SUM(pack_download) AS pack_download, SUM(flow_upload) AS flow_upload, SUM(flow_download) AS flow_download  
	FROM ' || srctable::regclass || ' 
	WHERE "time" > $1 AND "time" <= $2 GROUP BY user_id, host' USING t1, t2;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE STRICT
  COST 100;
ALTER FUNCTION netflow.bulk_agg_user_mapping_host(text, text, text, text, timestamp without time zone, timestamp without time zone)
  OWNER TO postgres;
  
CREATE OR REPLACE FUNCTION netflow.register_new_table(
    tablename text,
    grain text)
  RETURNS void AS
$BODY$
DECLARE
  schematablename TEXT;
  sufix TEXT;
BEGIN
  
  sufix := (select substr(table_name, char_length(table_name) - 7) as d
		from INFORMATION_SCHEMA.TABLES where table_name like 'exporter_device_host_' || grain || '_%'
		order by d desc
		limit 1);

  schematablename := 'netflow.' || tablename || '_' || grain;

  IF sufix IS NOT NULL AND sufix <> '' THEN
	EXECUTE
        	'drop table if exists ' || schematablename || '_' || sufix || ';';

	EXECUTE 
		'CREATE TABLE ' || schematablename || '_' || sufix ||  
		' (CHECK ( ' || 
			'time >= ''' || to_timestamp(sufix, 'YYYYMMDD') || ''' AND ' || 
			'time < ''' || (to_timestamp(sufix, 'YYYYMMDD') + interval '7' day) || ''')) ' || 
		'inherits (' || schematablename || ');';

	EXECUTE
		'CREATE INDEX idx_' || tablename || '_' || grain || '_' || sufix || '_time ' ||
		'ON ' || schematablename || '_' || sufix || 
		' USING btree ' ||
		'("time");';
  END IF;
  
END;
$BODY$
  LANGUAGE plpgsql VOLATILE STRICT
  COST 100;
ALTER FUNCTION netflow.register_new_table(text, text)
  OWNER TO postgres;
  
  
SELECT netflow.register_new_table('user_mapping_host','g1');
SELECT netflow.register_new_table('user_mapping_host','g2');
SELECT netflow.register_new_table('user_mapping_host','g3');

SELECT netflow.register_new_table('user_mapping_total','g1');
SELECT netflow.register_new_table('user_mapping_total','g2');
SELECT netflow.register_new_table('user_mapping_total','g3');

-- END OF UPDATE 10.12.2015

-- UPDATE 13.01.2015.
-- Tabela za korisnicki definisane filtere
-- Table: netflow_conf.user_mapping_filter

-- Table: netflow_conf.user_mapping_filter

-- DROP TABLE netflow_conf.user_mapping_filter;

CREATE TABLE netflow_conf.user_mapping_filter
(
  id bigserial NOT NULL,
  filter_type character varying(50) NOT NULL,
  filter_name character varying(120) NOT NULL,
  filter_description text,
  match_string text NOT NULL,
  criterion bigint NOT NULL,
  active boolean NOT NULL DEFAULT false,
  CONSTRAINT pk_user_mapping_filter PRIMARY KEY (id),
  CONSTRAINT fk_filter_criterion FOREIGN KEY (criterion)
      REFERENCES filter.criterion (id) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow_conf.user_mapping_filter
  OWNER TO netvizura;

-- END OF UPDATE 13.01.2015

-- UPDATE 01.02.2016

-- Table: netflow.user_mapping_service_g1
-- DROP TABLE netflow.user_mapping_service_g1;

CREATE TABLE netflow.user_mapping_service_g1
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  port integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_service_g1_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_service_g1
  OWNER TO netvizura;

-- Index: netflow.user_mapping_service_g1_time_idx

-- DROP INDEX netflow.user_mapping_service_g1_time_idx;

CREATE INDEX user_mapping_service_g1_time_idx
  ON netflow.user_mapping_service_g1
  USING btree
  ("time");
  
  
-- Table: netflow.user_mapping_service_g2
-- DROP TABLE netflow.user_mapping_service_g2;

CREATE TABLE netflow.user_mapping_service_g2
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  port integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_service_g2_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_service_g2
  OWNER TO netvizura;

-- Index: netflow.user_mapping_service_g2_time_idx

-- DROP INDEX netflow.user_mapping_service_g2_time_idx;

CREATE INDEX user_mapping_service_g2_time_idx
  ON netflow.user_mapping_service_g2
  USING btree
  ("time");
  
  
-- Table: netflow.user_mapping_service_g3
-- DROP TABLE netflow.user_mapping_service_g3;

CREATE TABLE netflow.user_mapping_service_g3
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  port integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_service_g3_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_service_g3
  OWNER TO netvizura;

-- Index: netflow.user_mapping_service_g3_time_idx

-- DROP INDEX netflow.user_mapping_service_g3_time_idx;

CREATE INDEX user_mapping_service_g3_time_idx
  ON netflow.user_mapping_service_g3
  USING btree
  ("time");
  
-- kreira trenutne (aktulene) particicje
SELECT netflow.register_new_table('user_mapping_service','g1');
SELECT netflow.register_new_table('user_mapping_service','g2');
SELECT netflow.register_new_table('user_mapping_service','g3');
 

-- Agregacija service tabele
CREATE OR REPLACE FUNCTION netflow.bulk_agg_user_mapping_service(
    srcsuffix text,
    srcgrain text,
    dstsuffix text,
    dstgrain text,
    t1 timestamp without time zone,
    t2 timestamp without time zone)
  RETURNS void AS
$BODY$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.user_mapping_service_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.user_mapping_service_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' 
	(time, user_id, port, byte_download, pack_download, flow_download, byte_upload, pack_upload, flow_upload) 
	SELECT $2, user_id, port, SUM(byte_download) AS byte_download, SUM(pack_download) AS pack_download, SUM(flow_download) AS flow_download, SUM(byte_upload) AS byte_upload, SUM(pack_upload) AS pack_upload, SUM(flow_upload) AS flow_upload  
	FROM ' || srctable::regclass || '
	WHERE "time" > $1 AND "time" <= $2 GROUP BY user_id, port' USING t1, t2;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE STRICT
  COST 100;
ALTER FUNCTION netflow.bulk_agg_user_mapping_service(text, text, text, text, timestamp without time zone, timestamp without time zone)
  OWNER TO postgres;

-- END OF UPDATE 01.02.2016.

-- UPDATE 02.02.2016.

  -- Table: netflow.user_mapping_protocol_g1

-- DROP TABLE netflow.user_mapping_protocol_g1;

CREATE TABLE netflow.user_mapping_protocol_g1
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigint NOT NULL,
  protocol integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_protocol_g1_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_protocol_g1
  OWNER TO netvizura;

-- Index: netflow.user_mapping_protocol_g1_time_idx

-- DROP INDEX netflow.user_mapping_protocol_g1_time_idx;

CREATE INDEX user_mapping_protocol_g1_time_idx
  ON netflow.user_mapping_protocol_g1
  USING btree
  ("time");

  
-- Table: netflow.user_mapping_protocol_g2

-- DROP TABLE netflow.user_mapping_protocol_g2;

CREATE TABLE netflow.user_mapping_protocol_g2
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigint NOT NULL,
  protocol integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_protocol_g2_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_protocol_g2
  OWNER TO netvizura;

-- Index: netflow.user_mapping_protocol_g2_time_idx

-- DROP INDEX netflow.user_mapping_protocol_g2_time_idx;

CREATE INDEX user_mapping_protocol_g2_time_idx
  ON netflow.user_mapping_protocol_g2
  USING btree
  ("time");
  

-- Table: netflow.user_mapping_protocol_g3

-- DROP TABLE netflow.user_mapping_protocol_g3;

CREATE TABLE netflow.user_mapping_protocol_g3
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigint NOT NULL,
  protocol integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_protocol_g3_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_protocol_g3
  OWNER TO netvizura;

-- Index: netflow.user_mapping_protocol_g3_time_idx

-- DROP INDEX netflow.user_mapping_protocol_g3_time_idx;

CREATE INDEX user_mapping_protocol_g3_time_idx
  ON netflow.user_mapping_protocol_g3
  USING btree
  ("time");
  

-- kreira trenutne (aktulene) particicje
SELECT netflow.register_new_table('user_mapping_protocol','g1');
SELECT netflow.register_new_table('user_mapping_protocol','g2');
SELECT netflow.register_new_table('user_mapping_protocol','g3');
 
-- Agregacija protocol tabele
CREATE OR REPLACE FUNCTION netflow.bulk_agg_user_mapping_protocol(
    srcsuffix text,
    srcgrain text,
    dstsuffix text,
    dstgrain text,
    t1 timestamp without time zone,
    t2 timestamp without time zone)
  RETURNS void AS
$BODY$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.user_mapping_protocol_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.user_mapping_protocol_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' 
	(time, user_id, protocol, byte_download, pack_download, flow_download, byte_upload, pack_upload, flow_upload) 
	SELECT $2, user_id, protocol, SUM(byte_download) AS byte_download, SUM(pack_download) AS pack_download, SUM(flow_download) AS flow_download, SUM(byte_upload) AS byte_upload, SUM(pack_upload) AS pack_upload, SUM(flow_upload) AS flow_upload  
	FROM ' || srctable::regclass || '
	WHERE "time" > $1 AND "time" <= $2 GROUP BY user_id, protocol' USING t1, t2;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE STRICT
  COST 100;
ALTER FUNCTION netflow.bulk_agg_user_mapping_protocol(text, text, text, text, timestamp without time zone, timestamp without time zone)
  OWNER TO postgres;
  
-- END OF UPDATE 02.02.2016.


-- UPDATE 03.02.2016.

-- Table: netflow.user_mapping_as_g1

-- DROP TABLE netflow.user_mapping_as_g1;

CREATE TABLE netflow.user_mapping_as_g1
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  "as" integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_as_g1_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_as_g1
  OWNER TO netvizura;

-- Index: netflow.user_mapping_as_g1_time_idx

-- DROP INDEX netflow.user_mapping_as_g1_time_idx;

CREATE INDEX user_mapping_as_g1_time_idx
  ON netflow.user_mapping_as_g1
  USING btree
  ("time");

  
-- Table: netflow.user_mapping_as_g2

-- DROP TABLE netflow.user_mapping_as_g2;

CREATE TABLE netflow.user_mapping_as_g2
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  "as" integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_as_g2_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_as_g2
  OWNER TO netvizura;

-- Index: netflow.user_mapping_as_g2_time_idx

-- DROP INDEX netflow.user_mapping_as_g2_time_idx;

CREATE INDEX user_mapping_as_g2_time_idx
  ON netflow.user_mapping_as_g2
  USING btree
  ("time");


-- Table: netflow.user_mapping_as_g3

-- DROP TABLE netflow.user_mapping_as_g3;

CREATE TABLE netflow.user_mapping_as_g3
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  "as" integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_as_g3_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_as_g3
  OWNER TO netvizura;

-- Index: netflow.user_mapping_as_g3_time_idx

-- DROP INDEX netflow.user_mapping_as_g3_time_idx;

CREATE INDEX user_mapping_as_g3_time_idx
  ON netflow.user_mapping_as_g3
  USING btree
  ("time");
  
  
-- kreira trenutne (aktulene) particicje
SELECT netflow.register_new_table('user_mapping_as','g1');
SELECT netflow.register_new_table('user_mapping_as','g2');
SELECT netflow.register_new_table('user_mapping_as','g3');


-- Agregacija as tabele
CREATE OR REPLACE FUNCTION netflow.bulk_agg_user_mapping_as(
    srcsuffix text,
    srcgrain text,
    dstsuffix text,
    dstgrain text,
    t1 timestamp without time zone,
    t2 timestamp without time zone)
  RETURNS void AS
$BODY$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.user_mapping_as_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.user_mapping_as_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' 
	(time, user_id, "as", byte_download, pack_download, flow_download, byte_upload, pack_upload, flow_upload) 
	SELECT $2, user_id, "as", SUM(byte_download) AS byte_download, SUM(pack_download) AS pack_download, SUM(flow_download) AS flow_download, SUM(byte_upload) AS byte_upload, SUM(pack_upload) AS pack_upload, SUM(flow_upload) AS flow_upload  
	FROM ' || srctable::regclass || '
	WHERE "time" > $1 AND "time" <= $2 GROUP BY user_id, "as"' USING t1, t2;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE STRICT
  COST 100;
ALTER FUNCTION netflow.bulk_agg_user_mapping_as(text, text, text, text, timestamp without time zone, timestamp without time zone)
  OWNER TO postgres; 
  
-- END OF UPDATE 03.02.2016.

-- UPDATE 04.02.2016.

  -- Table: netflow.user_mapping_qos_g1

-- DROP TABLE netflow.user_mapping_qos_g1;

CREATE TABLE netflow.user_mapping_qos_g1
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  tos integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_qos_g1_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_qos_g1
  OWNER TO netvizura;

-- Index: netflow.user_mapping_qos_g1_time_idx

-- DROP INDEX netflow.user_mapping_qos_g1_time_idx;

CREATE INDEX user_mapping_qos_g1_time_idx
  ON netflow.user_mapping_qos_g1
  USING btree
  ("time");
  
-- Table: netflow.user_mapping_qos_g2

-- DROP TABLE netflow.user_mapping_qos_g2;

CREATE TABLE netflow.user_mapping_qos_g2
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  tos integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_qos_g2_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_qos_g2
  OWNER TO netvizura;

-- Index: netflow.user_mapping_qos_g2_time_idx

-- DROP INDEX netflow.user_mapping_qos_g2_time_idx;

CREATE INDEX user_mapping_qos_g2_time_idx
  ON netflow.user_mapping_qos_g2
  USING btree
  ("time");

-- Table: netflow.user_mapping_qos_g3

-- DROP TABLE netflow.user_mapping_qos_g3;

CREATE TABLE netflow.user_mapping_qos_g3
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  tos integer NOT NULL,
  byte_download bigint,
  pack_download bigint,
  flow_download bigint,
  byte_upload bigint,
  pack_upload bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_qos_g3_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_qos_g3
  OWNER TO netvizura;

-- Index: netflow.user_mapping_qos_g3_time_idx

-- DROP INDEX netflow.user_mapping_qos_g3_time_idx;

CREATE INDEX user_mapping_qos_g3_time_idx
  ON netflow.user_mapping_qos_g3
  USING btree
  ("time");
  
  
-- kreira trenutne (aktulene) particicje
SELECT netflow.register_new_table('user_mapping_qos','g1');
SELECT netflow.register_new_table('user_mapping_qos','g2');
SELECT netflow.register_new_table('user_mapping_qos','g3');


-- Agregacija qos tabele
CREATE OR REPLACE FUNCTION netflow.bulk_agg_user_mapping_qos(
    srcsuffix text,
    srcgrain text,
    dstsuffix text,
    dstgrain text,
    t1 timestamp without time zone,
    t2 timestamp without time zone)
  RETURNS void AS
$BODY$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.user_mapping_qos_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.user_mapping_qos_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' 
	(time, user_id, tos, byte_download, pack_download, flow_download, byte_upload, pack_upload, flow_upload) 
	SELECT $2, user_id, tos, SUM(byte_download) AS byte_download, SUM(pack_download) AS pack_download, SUM(flow_download) AS flow_download, SUM(byte_upload) AS byte_upload, SUM(pack_upload) AS pack_upload, SUM(flow_upload) AS flow_upload  
	FROM ' || srctable::regclass || '
	WHERE "time" > $1 AND "time" <= $2 GROUP BY user_id, tos' USING t1, t2;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE STRICT
  COST 100;
ALTER FUNCTION netflow.bulk_agg_user_mapping_qos(text, text, text, text, timestamp without time zone, timestamp without time zone)
  OWNER TO postgres;
  
-- END OF UPDATE 04.02.2016.

-- UPDATE 8.02.2016.
 
-- Table: netflow.user_mapping_conversation_g1

-- DROP TABLE netflow.user_mapping_conversation_g1;

CREATE TABLE netflow.user_mapping_conversation_g1
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  source inet NOT NULL,
  destination inet NOT NULL,
  service integer NOT NULL,
  protocol integer NOT NULL,
  byte_download bigint,
  byte_upload bigint,
  pack_download bigint,
  pack_upload bigint,
  flow_download bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_conversation_g1_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_conversation_g1
  OWNER TO netvizura;

-- Index: netflow.user_mapping_conversation_g1_time_idx

-- DROP INDEX netflow.user_mapping_conversation_g1_time_idx;

CREATE INDEX user_mapping_conversation_g1_time_idx
  ON netflow.user_mapping_conversation_g1
  USING btree
  ("time");
  
-- Table: netflow.user_mapping_conversation_g2

-- DROP TABLE netflow.user_mapping_conversation_g2;

CREATE TABLE netflow.user_mapping_conversation_g2
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  source inet NOT NULL,
  destination inet NOT NULL,
  service integer NOT NULL,
  protocol integer NOT NULL,
  byte_download bigint,
  byte_upload bigint,
  pack_download bigint,
  pack_upload bigint,
  flow_download bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_conversation_g2_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_conversation_g2
  OWNER TO netvizura;

-- Index: netflow.user_mapping_conversation_g2_time_idx

-- DROP INDEX netflow.user_mapping_conversation_g2_time_idx;

CREATE INDEX user_mapping_conversation_g2_time_idx
  ON netflow.user_mapping_conversation_g2
  USING btree
  ("time");

  
-- Table: netflow.user_mapping_conversation_g3

-- DROP TABLE netflow.user_mapping_conversation_g3;

CREATE TABLE netflow.user_mapping_conversation_g3
(
  id bigserial NOT NULL,
  "time" timestamp without time zone NOT NULL,
  user_id bigserial NOT NULL,
  source inet NOT NULL,
  destination inet NOT NULL,
  service integer NOT NULL,
  protocol integer NOT NULL,
  byte_download bigint,
  byte_upload bigint,
  pack_download bigint,
  pack_upload bigint,
  flow_download bigint,
  flow_upload bigint,
  CONSTRAINT user_mapping_conversation_g3_pkey PRIMARY KEY (id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE netflow.user_mapping_conversation_g3
  OWNER TO netvizura;

-- Index: netflow.user_mapping_conversation_g3_time_idx

-- DROP INDEX netflow.user_mapping_conversation_g3_time_idx;

CREATE INDEX user_mapping_conversation_g3_time_idx
  ON netflow.user_mapping_conversation_g3
  USING btree
  ("time");  
  
-- kreira trenutne (aktulene) particicje
SELECT netflow.register_new_table('user_mapping_conversation','g1');
SELECT netflow.register_new_table('user_mapping_conversation','g2');
SELECT netflow.register_new_table('user_mapping_conversation','g3');


-- Agregacija conversation tabele
CREATE OR REPLACE FUNCTION netflow.bulk_agg_user_mapping_conversation(
    srcsuffix text,
    srcgrain text,
    dstsuffix text,
    dstgrain text,
    t1 timestamp without time zone,
    t2 timestamp without time zone)
  RETURNS void AS
$BODY$
DECLARE
  srctable TEXT;
  dsttable TEXT;
BEGIN
  srctable := 'netflow.user_mapping_conversation_' || srcgrain || '_' || srcsuffix;
  dsttable := 'netflow.user_mapping_conversation_' || dstgrain || '_' || dstsuffix;
  EXECUTE 'INSERT INTO ' || dsttable::regclass || ' (time, user_id, source, destination, service, protocol, byte_download, byte_upload, pack_download, pack_upload, flow_download, flow_upload)  
  SELECT $2, user_id, source, destination, service, protocol, SUM(byte_download) AS byte_download, SUM(byte_upload) AS byte_upload, SUM(pack_download) AS pack_download, SUM(pack_upload) AS pack_upload, SUM(flow_download) AS flow_download, SUM(flow_upload) AS flow_upload 
  FROM ' || srctable::regclass || ' 
  WHERE "time" > $1 AND "time" <= $2 
  GROUP BY user_id, source, destination, service, protocol' USING t1, t2;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE STRICT
  COST 100;
ALTER FUNCTION netflow.bulk_agg_user_mapping_conversation(text, text, text, text, timestamp without time zone, timestamp without time zone)
  OWNER TO postgres;
  
  
-- Update funckije koja pozive sve ostale
-- Function: netflow.bulk_aggregate(text, text, text, text, timestamp without time zone, timestamp without time zone)

-- DROP FUNCTION netflow.bulk_aggregate(text, text, text, text, timestamp without time zone, timestamp without time zone);

CREATE OR REPLACE FUNCTION netflow.bulk_aggregate(
    srcsuffix text,
    srcgrain text,
    dstsuffix text,
    dstgrain text,
    t1 timestamp without time zone,
    t2 timestamp without time zone)
  RETURNS void AS
$BODY$
DECLARE
BEGIN
  PERFORM netflow.bulk_agg_exporter_device_total(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_as(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_conversation(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_host(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_protocol(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_qos(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_service(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);

  PERFORM netflow.bulk_agg_exporter_interface_total(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_as(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_conversation(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_host(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_protocol(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_qos(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_service(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);

  PERFORM netflow.bulk_agg_pattern_subnet_total(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_as(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_conversation(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_host(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_protocol(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_qos(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_service(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);

  PERFORM netflow.bulk_agg_user_mapping_total(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_host(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_service(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_protocol(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_as(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_qos(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_conversation(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
END;
$BODY$
  LANGUAGE plpgsql VOLATILE STRICT
  COST 100;
ALTER FUNCTION netflow.bulk_aggregate(text, text, text, text, timestamp without time zone, timestamp without time zone)
  OWNER TO postgres; 
-- END OF UPDATE 8.02.2016

  
-- UPDATE 8.02.2016
-- dodavanje unique key constraint-a za filter name kod user mapping filtera
ALTER TABLE netflow_conf.user_mapping_filter ADD CONSTRAINT uk_filter_name UNIQUE (filter_name);
-- END OF UPDATE 8.02.2016

-- UPDATE 23.02.2016
INSERT INTO framework.system_property VALUES ('END_USER_COLLECTION_PORT', 'netflow', 'INTEGER', '33515');
INSERT INTO framework.system_property VALUES ('END_USER_COLLECTION_PORT_TIMEOUT', 'netflow', 'INTEGER', '5');
-- END OF UPDATE 23.02.2016
  
-- UPDATE 03.03.2016
INSERT INTO netflow_conf.default_config 
(type, top_as, top_conversation, top_host, top_protocol, top_qos, top_service, top_children)
VALUES
('END_USER', 10, 10, 10, 10, 10, 10, 10);

ALTER TABLE netflow_conf.counter_config 
ADD COLUMN user_id bigint;

ALTER TABLE netflow_conf.counter_config
ADD CONSTRAINT counter_conf_fk_user_id FOREIGN KEY (user_id)
      REFERENCES netflow."user" (id) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE CASCADE;

-- NVDEV-121    
UPDATE mapping.protocol
SET protocoldescription = 'Generic Routing Encapsulation'
WHERE protocolname = 'GRE';
-- END OF UPDATE 03.03.2016

-- UPDATE 10.03.2016
INSERT INTO netflow_conf.default_config 
(type, top_as, top_conversation, top_host, top_protocol, top_qos, top_service, top_children)
VALUES
('ALL_USERS', 10, 10, 10, 10, 10, 10, 10);
-- END OF UPDATE 10.03.2016

-- UPDATE 11.03.2016
ALTER TABLE netflow_conf.counter_config 
ADD COLUMN domain character varying(100);

INSERT INTO netflow_conf.default_config 
(type, top_as, top_conversation, top_host, top_protocol, top_qos, top_service, top_children)
VALUES
('DOMAIN', 10, 10, 10, 10, 10, 10, 10);
-- END OF UPDATE 11.03.2016

-- UPDATE 24.03.2016
ALTER TABLE netflow_conf.report
  ADD COLUMN end_user bigint;
ALTER TABLE netflow_conf.report
  ADD CONSTRAINT report_fk_end_user FOREIGN KEY (end_user) REFERENCES netflow."user" (id) ON UPDATE NO ACTION ON DELETE CASCADE;
-- END UPDATE 24.03.2016

-- UPDATE 25.03.2016
ALTER TABLE netflow_conf.report ADD COLUMN end_user_domain character varying(100);
-- END UPDATE 25.03.2016

-- UPDATE 04.04.2016
ALTER TABLE netflow_conf.user_mapping_filter ADD COLUMN system boolean NOT NULL DEFAULT FALSE;
-- END UPDATE 04.04.2016

-- UPDATE 05.04.2016

-- Ubacujemo criterion za prvi rule
INSERT INTO filter.criterion (owner_id, simple_field_name, simple_param_1, simple_param_2, comparison_op, composite_name, logical_op, dtype) 
VALUES (NULL, 'SRC_IP', '0.0.0.0/0', NULL, 'ADDRESS_IN_SUBNET', NULL, NULL, 'SimpleCriterion');

-- Ubacujemo prvi rule
INSERT INTO netflow_conf.user_mapping_filter (filter_type, filter_name, filter_description, match_string, criterion, active, system) 
VALUES ('DOMAIN_CONTROLLER', 'Logon DC', 'Logon rule for Snare DC', 
	'* MSWinEventLog * 4624 Microsoft-Windows-Security-Auditing * Logon Type: 3 * Account Name: <USERNAME> * Account Domain: <DOMAIN> * Process Name: - * Source Network Address: <USER-IP> *', 
	(SELECT currval('filter.criterion_id_seq')), false, true);

-- Ubacujemo criterion za drugi rule
INSERT INTO filter.criterion (owner_id, simple_field_name, simple_param_1, simple_param_2, comparison_op, composite_name, logical_op, dtype) 
VALUES (NULL, 'SRC_IP', '0.0.0.0/0', NULL, 'ADDRESS_IN_SUBNET', NULL, NULL, 'SimpleCriterion');

-- Ubacujemo drugi rule
INSERT INTO netflow_conf.user_mapping_filter (filter_type, filter_name, filter_description, match_string, criterion, active, system) 
VALUES ('WORKING_STATION', 'Logon WS', 'Logon rule for Snare WS', 
	'* 4624 * An account was successfully logged on. * Account Name: * Logon Type: 7 * Account Name: <USERNAME> * Account Domain: <DOMAIN> * lsass.exe *', 
	(SELECT currval('filter.criterion_id_seq')), false, true);

-- END UPDATE 05.04.2016

-- UPDATE 11.04.2016

-- fix za database cleanup dok se korisnik ne uloguje u app i prikaže settings

DO $$
BEGIN
	IF NOT EXISTS (SELECT 1 FROM framework.system_property WHERE name = 'DATABASE_MIN_WEEKS' AND tag = 'netflow')
	THEN
	
		INSERT INTO framework.system_property VALUES ('DATABASE_MIN_WEEKS', 'netflow', 'INTEGER', 52);
		
	END IF;
END $$;

-- END UPDATE 11.04.2016

INSERT INTO framework.db_version(patch_number, patch_date) VALUES (52, current_timestamp);
