-- UPDATE 13.05.2016

CREATE SCHEMA wizard
  AUTHORIZATION netvizura;

CREATE TABLE wizard."step"
(
  id bigserial NOT NULL,
  name varchar(40) NOT NULL,
  step_content varchar(30),
  state varchar(30) NOT NULL,
  position_index integer NOT NULL,
  mandatory boolean NOT NULL,
  "type" varchar(30) NOT NULL,
  module_id integer NOT NULL,
  CONSTRAINT step_pkey PRIMARY KEY (id),
  CONSTRAINT framework_module_fkey FOREIGN KEY (module_id)
      REFERENCES framework.module (id_cip_sys_module) MATCH SIMPLE
      ON UPDATE CASCADE ON DELETE CASCADE
  
)
WITH (
  OIDS=FALSE
);

ALTER TABLE wizard."step"
  OWNER TO netvizura;
  
  
INSERT INTO wizard."step" (name, step_content, state, position_index, mandatory, "type", module_id) 
VALUES ('Setting NetFlow data collection', 'netflow', 'INCOMPLETE', 1, TRUE, 'NF_TRAFFIC_CHECK', 4);

INSERT INTO wizard."step" (name, step_content, state, position_index, mandatory, "type", module_id) 
VALUES ('Setting EventLog data collection', 'eventlog', 'INCOMPLETE', 2, TRUE, 'SYSLOG_RECEIVED_CHECK', 3);

INSERT INTO wizard."step" (name, step_content, state, position_index, mandatory, "type", module_id) 
VALUES ('Adding your first Traffic Pattern', 'pattern', 'INCOMPLETE', 3, FALSE, 'PATTERN_EXISTS_CHECK', 4);

INSERT INTO wizard."step" (name, step_content, state, position_index, mandatory, "type", module_id) 
VALUES ('Adding your first Subnet', 'subnet', 'INCOMPLETE', 4, FALSE, 'SUBNET_EXISTS_CHECK', 4);

-- END UPDATE 13.05.2016

-- UPDATE 27.05.2016.

CREATE INDEX idx_user_session_user_id_end_time
  ON netflow.user_session
  USING btree
  (user_id, end_time NULLS FIRST);
  
DELETE FROM netflow.user
	WHERE domain = 'NT';
  
-- ovaj indeks je manje bitan, ali možda i posluži
CREATE INDEX idx_event_time_start
   ON event_alarm_action.event (time_start DESC);
   
-- ovaj indeks se pokazalo da je izuzetno bitan!   
CREATE INDEX idx_event_time_end
   ON event_alarm_action.event (time_end DESC NULLS FIRST);

-- END UPDATE 27.05.2016.  
   
INSERT INTO framework.db_version(patch_number, patch_date) VALUES (54, current_timestamp);
