SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

SET search_path = mib, pg_catalog;

BEGIN;

-- disable triggers (temporarily)
ALTER TABLE element_module DISABLE TRIGGER ALL;
ALTER TABLE mib_app_property DISABLE TRIGGER ALL;
ALTER TABLE mib_capability DISABLE TRIGGER ALL;
ALTER TABLE mib_capability_support DISABLE TRIGGER ALL;
ALTER TABLE mib_capability_support_variation DISABLE TRIGGER ALL;
ALTER TABLE mib_compliance DISABLE TRIGGER ALL;
ALTER TABLE mib_compliance_module DISABLE TRIGGER ALL;
ALTER TABLE mib_compliance_module_group DISABLE TRIGGER ALL;
ALTER TABLE mib_compliance_module_object DISABLE TRIGGER ALL;
ALTER TABLE mib_element DISABLE TRIGGER ALL;
ALTER TABLE mib_favorite DISABLE TRIGGER ALL;
ALTER TABLE mib_identity DISABLE TRIGGER ALL;
ALTER TABLE mib_identity_revision DISABLE TRIGGER ALL;
ALTER TABLE mib_module DISABLE TRIGGER ALL;
ALTER TABLE mib_module_import DISABLE TRIGGER ALL;
ALTER TABLE mib_notification_group DISABLE TRIGGER ALL;
ALTER TABLE mib_notification_type DISABLE TRIGGER ALL;
ALTER TABLE mib_textual_convention DISABLE TRIGGER ALL;


INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (56, '.1.3.6.1.2.1.2.2.1.7', 'ifAdminStatus', 49, 'mandatory', NULL, 'The desired state of the interface. The testing(3) state indicates that no operational packets can be passed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (57, '.1.3.6.1.2.1.2.2.1.8', 'ifOperStatus', 49, 'mandatory', NULL, 'The current operational state of the interface. The testing(3) state indicates that no operational packets can be passed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1, '', 'root', NULL, 'current', NULL, 'The root of MIB structure', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (13, '.0', 'ccit', 1, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (14, '.0.0', 'zeroDotZero', 13, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (15, '.1', 'iso', 1, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (16, '.1.3', 'org', 15, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (17, '.1.3.6', 'dod', 16, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (18, '.1.3.6.1', 'internet', 17, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (19, '.1.3.6.1.1', 'directory', 18, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (20, '.1.3.6.1.2', 'mgmt', 18, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (21, '.1.3.6.1.2.1', 'mib-2', 20, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (22, '.1.3.6.1.2.1.10', 'transmission', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (23, '.1.3.6.1.3', 'experimental', 18, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (24, '.1.3.6.1.4', 'private', 18, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (25, '.1.3.6.1.4.1', 'enterprises', 24, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (26, '.1.3.6.1.5', 'security', 18, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (27, '.1.3.6.1.6', 'snmpV2', 18, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (28, '.1.3.6.1.6.1', 'snmpDomains', 27, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (29, '.1.3.6.1.6.2', 'snmpProxys', 27, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (30, '.1.3.6.1.6.3', 'snmpModules', 27, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (31, '.1.3.6.1.2.1.1', 'system', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (32, '.1.3.6.1.2.1.2', 'interfaces', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (33, '.1.3.6.1.2.1.3', 'at', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (34, '.1.3.6.1.2.1.4', 'ip', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (35, '.1.3.6.1.2.1.5', 'icmp', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (36, '.1.3.6.1.2.1.6', 'tcp', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (37, '.1.3.6.1.2.1.7', 'udp', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (38, '.1.3.6.1.2.1.8', 'egp', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (39, '.1.3.6.1.2.1.11', 'snmp', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (40, '.1.3.6.1.2.1.1.1', 'sysDescr', 31, 'mandatory', NULL, 'A textual description of the entity. This value should include the full name and version identification of the system''s hardware type, software operating-system, and networking software. It is mandatory that this only contain printable ASCII characters.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (41, '.1.3.6.1.2.1.1.2', 'sysObjectID', 31, 'mandatory', NULL, 'The vendor''s authoritative identification of the network management subsystem contained in the entity. This value is allocated within the SMI enterprises subtree (1.3.6.1.4.1) and provides an easy and unambiguous means for determining `what kind of box'' is being managed. For example, if vendor `Flintstones, Inc.'' was assigned the subtree 1.3.6.1.4.1.4242, it could assign the identifier 1.3.6.1.4.1.4242.1.1 to its `Fred Router''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (42, '.1.3.6.1.2.1.1.3', 'sysUpTime', 31, 'mandatory', NULL, 'The time (in hundredths of a second) since the network management portion of the system was last re-initialized.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (43, '.1.3.6.1.2.1.1.4', 'sysContact', 31, 'mandatory', NULL, 'The textual identification of the contact person for this managed node, together with information on how to contact this person.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (44, '.1.3.6.1.2.1.1.5', 'sysName', 31, 'mandatory', NULL, 'An administratively-assigned name for this managed node. By convention, this is the node''s fully-qualified domain name.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (45, '.1.3.6.1.2.1.1.6', 'sysLocation', 31, 'mandatory', NULL, 'The physical location of this node (e.g., `telephone closet, 3rd floor'').', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (46, '.1.3.6.1.2.1.1.7', 'sysServices', 31, 'mandatory', NULL, 'A value which indicates the set of services that this entity primarily offers.  The value is a sum. This sum initially takes the value zero, Then, for each layer, L, in the range 1 through 7, that this node performs transactions for, 2 raised to (L - 1) is added to the sum. For example, a node which performs primarily routing functions would have a value of 4 (2^(3-1)). In contrast, a node which is a host offering application services would have a value of 72 (2^(4-1) + 2^(7-1)). Note that in the context of the Internet suite of protocols, values should be calculated accordingly:  layer functionality 1 physical (e.g., repeaters) 2 datalink/subnetwork (e.g., bridges) 3 internet (e.g., IP gateways) 4 end-to-end (e.g., IP hosts) 7 applications (e.g., mail relays)  For systems including OSI protocols, layers 5 and 6 may also be counted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (47, '.1.3.6.1.2.1.2.1', 'ifNumber', 32, 'mandatory', NULL, 'The number of network interfaces (regardless of their current state) present on this system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (48, '.1.3.6.1.2.1.2.2', 'ifTable', 32, 'mandatory', NULL, 'A list of interface entries. The number of entries is given by the value of ifNumber.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (49, '.1.3.6.1.2.1.2.2.1', 'ifEntry', 48, 'mandatory', NULL, 'An interface entry containing objects at the subnetwork layer and below for a particular interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (50, '.1.3.6.1.2.1.2.2.1.1', 'ifIndex', 49, 'mandatory', NULL, 'A unique value for each interface. Its value ranges between 1 and the value of ifNumber. The value for each interface must remain constant at least from one re-initialization of the entity''s network management system to the next re- initialization.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (51, '.1.3.6.1.2.1.2.2.1.2', 'ifDescr', 49, 'mandatory', NULL, 'A textual string containing information about the interface. This string should include the name of the manufacturer, the product name and the version of the hardware interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (52, '.1.3.6.1.2.1.2.2.1.3', 'ifType', 49, 'mandatory', NULL, 'The type of interface, distinguished according to the physical/link protocol(s) immediately `below'' the network layer in the protocol stack.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (53, '.1.3.6.1.2.1.2.2.1.4', 'ifMtu', 49, 'mandatory', NULL, 'The size of the largest datagram which can be sent/received on the interface, specified in octets. For interfaces that are used for transmitting network datagrams, this is the size of the largest network datagram that can be sent on the interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (54, '.1.3.6.1.2.1.2.2.1.5', 'ifSpeed', 49, 'mandatory', NULL, 'An estimate of the interface''s current bandwidth in bits per second. For interfaces which do not vary in bandwidth or for those where no accurate estimation can be made, this object should contain the nominal bandwidth.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (55, '.1.3.6.1.2.1.2.2.1.6', 'ifPhysAddress', 49, 'mandatory', NULL, 'The interface''s address at the protocol layer immediately `below'' the network layer in the protocol stack. For interfaces which do not have such an address (e.g., a serial line), this object should contain an octet string of zero length.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (58, '.1.3.6.1.2.1.2.2.1.9', 'ifLastChange', 49, 'mandatory', NULL, 'The value of sysUpTime at the time the interface entered its current operational state. If the current state was entered prior to the last re- initialization of the local network management subsystem, then this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (59, '.1.3.6.1.2.1.2.2.1.10', 'ifInOctets', 49, 'mandatory', NULL, 'The total number of octets received on the interface, including framing characters.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (60, '.1.3.6.1.2.1.2.2.1.11', 'ifInUcastPkts', 49, 'mandatory', NULL, 'The number of subnetwork-unicast packets delivered to a higher-layer protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (61, '.1.3.6.1.2.1.2.2.1.12', 'ifInNUcastPkts', 49, 'mandatory', NULL, 'The number of non-unicast (i.e., subnetwork- broadcast or subnetwork-multicast) packets delivered to a higher-layer protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4981, '.1.3.6.1.2.1.16.20.1.2', 'rmon2MIBApplicationLayerCompliance', 4978, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (62, '.1.3.6.1.2.1.2.2.1.13', 'ifInDiscards', 49, 'mandatory', NULL, 'The number of inbound packets which were chosen to be discarded even though no errors had been detected to prevent their being deliverable to a higher-layer protocol. One possible reason for discarding such a packet could be to free up buffer space.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (63, '.1.3.6.1.2.1.2.2.1.14', 'ifInErrors', 49, 'mandatory', NULL, 'The number of inbound packets that contained errors preventing them from being deliverable to a higher-layer protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (64, '.1.3.6.1.2.1.2.2.1.15', 'ifInUnknownProtos', 49, 'mandatory', NULL, 'The number of packets received via the interface which were discarded because of an unknown or unsupported protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (65, '.1.3.6.1.2.1.2.2.1.16', 'ifOutOctets', 49, 'mandatory', NULL, 'The total number of octets transmitted out of the interface, including framing characters.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (66, '.1.3.6.1.2.1.2.2.1.17', 'ifOutUcastPkts', 49, 'mandatory', NULL, 'The total number of packets that higher-level protocols requested be transmitted to a subnetwork-unicast address, including those that were discarded or not sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (67, '.1.3.6.1.2.1.2.2.1.18', 'ifOutNUcastPkts', 49, 'mandatory', NULL, 'The total number of packets that higher-level protocols requested be transmitted to a non- unicast (i.e., a subnetwork-broadcast or subnetwork-multicast) address, including those that were discarded or not sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (68, '.1.3.6.1.2.1.2.2.1.19', 'ifOutDiscards', 49, 'mandatory', NULL, 'The number of outbound packets which were chosen to be discarded even though no errors had been detected to prevent their being transmitted. One possible reason for discarding such a packet could be to free up buffer space.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (69, '.1.3.6.1.2.1.2.2.1.20', 'ifOutErrors', 49, 'mandatory', NULL, 'The number of outbound packets that could not be transmitted because of errors.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (70, '.1.3.6.1.2.1.2.2.1.21', 'ifOutQLen', 49, 'mandatory', NULL, 'The length of the output packet queue (in packets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (71, '.1.3.6.1.2.1.2.2.1.22', 'ifSpecific', 49, 'mandatory', NULL, 'A reference to MIB definitions specific to the particular media being used to realize the interface. For example, if the interface is realized by an ethernet, then the value of this object refers to a document defining objects specific to ethernet. If this information is not present, its value should be set to the OBJECT IDENTIFIER { 0 0 }, which is a syntatically valid object identifier, and any conformant implementation of ASN.1 and BER must be able to generate and recognize this value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (72, '.1.3.6.1.2.1.3.1', 'atTable', 33, 'deprecated', NULL, 'The Address Translation tables contain the NetworkAddress to `physical'' address equivalences. Some interfaces do not use translation tables for determining address equivalences (e.g., DDN-X.25 has an algorithmic method); if all interfaces are of this type, then the Address Translation table is empty, i.e., has zero entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (73, '.1.3.6.1.2.1.3.1.1', 'atEntry', 72, 'deprecated', NULL, 'Each entry contains one NetworkAddress to `physical'' address equivalence.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (74, '.1.3.6.1.2.1.3.1.1.1', 'atIfIndex', 73, 'deprecated', NULL, 'The interface on which this entry''s equivalence is effective. The interface identified by a particular value of this index is the same interface as identified by the same value of ifIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (75, '.1.3.6.1.2.1.3.1.1.2', 'atPhysAddress', 73, 'deprecated', NULL, 'The media-dependent `physical'' address.  Setting this object to a null string (one of zero length) has the effect of invaliding the corresponding entry in the atTable object. That is, it effectively dissasociates the interface identified with said entry from the mapping identified with said entry. It is an implementation-specific matter as to whether the agent removes an invalidated entry from the table. Accordingly, management stations must be prepared to receive tabular information from agents that corresponds to entries not currently in use. Proper interpretation of such entries requires examination of the relevant atPhysAddress object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (76, '.1.3.6.1.2.1.3.1.1.3', 'atNetAddress', 73, 'deprecated', NULL, 'The NetworkAddress (e.g., the IP address) corresponding to the media-dependent `physical'' address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (77, '.1.3.6.1.2.1.4.1', 'ipForwarding', 34, 'mandatory', NULL, 'The indication of whether this entity is acting as an IP gateway in respect to the forwarding of datagrams received by, but not addressed to, this entity. IP gateways forward datagrams. IP hosts do not (except those source-routed via the host).  Note that for some managed nodes, this object may take on only a subset of the values possible. Accordingly, it is appropriate for an agent to return a `badValue'' response if a management station attempts to change this object to an inappropriate value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (78, '.1.3.6.1.2.1.4.2', 'ipDefaultTTL', 34, 'mandatory', NULL, 'The default value inserted into the Time-To-Live field of the IP header of datagrams originated at this entity, whenever a TTL value is not supplied by the transport layer protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (79, '.1.3.6.1.2.1.4.3', 'ipInReceives', 34, 'mandatory', NULL, 'The total number of input datagrams received from interfaces, including those received in error.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (80, '.1.3.6.1.2.1.4.4', 'ipInHdrErrors', 34, 'mandatory', NULL, 'The number of input datagrams discarded due to errors in their IP headers, including bad checksums, version number mismatch, other format errors, time-to-live exceeded, errors discovered in processing their IP options, etc.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (81, '.1.3.6.1.2.1.4.5', 'ipInAddrErrors', 34, 'mandatory', NULL, 'The number of input datagrams discarded because the IP address in their IP header''s destination field was not a valid address to be received at this entity. This count includes invalid addresses (e.g., 0.0.0.0) and addresses of unsupported Classes (e.g., Class E). For entities which are not IP Gateways and therefore do not forward datagrams, this counter includes datagrams discarded because the destination address was not a local address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (82, '.1.3.6.1.2.1.4.6', 'ipForwDatagrams', 34, 'mandatory', NULL, 'The number of input datagrams for which this entity was not their final IP destination, as a result of which an attempt was made to find a route to forward them to that final destination. In entities which do not act as IP Gateways, this counter will include only those packets which were Source-Routed via this entity, and the Source- Route option processing was successful.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (83, '.1.3.6.1.2.1.4.7', 'ipInUnknownProtos', 34, 'mandatory', NULL, 'The number of locally-addressed datagrams received successfully but discarded because of an unknown or unsupported protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (84, '.1.3.6.1.2.1.4.8', 'ipInDiscards', 34, 'mandatory', NULL, 'The number of input IP datagrams for which no problems were encountered to prevent their continued processing, but which were discarded (e.g., for lack of buffer space). Note that this counter does not include any datagrams discarded while awaiting re-assembly.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (85, '.1.3.6.1.2.1.4.9', 'ipInDelivers', 34, 'mandatory', NULL, 'The total number of input datagrams successfully delivered to IP user-protocols (including ICMP).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (86, '.1.3.6.1.2.1.4.10', 'ipOutRequests', 34, 'mandatory', NULL, 'The total number of IP datagrams which local IP user-protocols (including ICMP) supplied to IP in requests for transmission. Note that this counter does not include any datagrams counted in ipForwDatagrams.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (189, '.1.3.6.1.2.1.8.5.1.4', 'egpNeighInMsgs', 185, 'mandatory', NULL, 'The number of EGP messages received without error from this EGP peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (941, '.1.3.6.1.4.1.9.9.23.1.2', 'cdpCache', 939, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5538, '.1.3.6.1.4.1.9.9.168.1.1', 'cntpSystem', 5537, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (87, '.1.3.6.1.2.1.4.11', 'ipOutDiscards', 34, 'mandatory', NULL, 'The number of output IP datagrams for which no problem was encountered to prevent their transmission to their destination, but which were discarded (e.g., for lack of buffer space). Note that this counter would include datagrams counted in ipForwDatagrams if any such packets met this (discretionary) discard criterion.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (88, '.1.3.6.1.2.1.4.12', 'ipOutNoRoutes', 34, 'mandatory', NULL, 'The number of IP datagrams discarded because no route could be found to transmit them to their destination. Note that this counter includes any packets counted in ipForwDatagrams which meet this `no-route'' criterion. Note that this includes any datagarms which a host cannot route because all of its default gateways are down.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (89, '.1.3.6.1.2.1.4.13', 'ipReasmTimeout', 34, 'mandatory', NULL, 'The maximum number of seconds which received fragments are held while they are awaiting reassembly at this entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (90, '.1.3.6.1.2.1.4.14', 'ipReasmReqds', 34, 'mandatory', NULL, 'The number of IP fragments received which needed to be reassembled at this entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (91, '.1.3.6.1.2.1.4.15', 'ipReasmOKs', 34, 'mandatory', NULL, 'The number of IP datagrams successfully re- assembled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (92, '.1.3.6.1.2.1.4.16', 'ipReasmFails', 34, 'mandatory', NULL, 'The number of failures detected by the IP re- assembly algorithm (for whatever reason: timed out, errors, etc). Note that this is not necessarily a count of discarded IP fragments since some algorithms (notably the algorithm in RFC 815) can lose track of the number of fragments by combining them as they are received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (93, '.1.3.6.1.2.1.4.17', 'ipFragOKs', 34, 'mandatory', NULL, 'The number of IP datagrams that have been successfully fragmented at this entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (94, '.1.3.6.1.2.1.4.18', 'ipFragFails', 34, 'mandatory', NULL, 'The number of IP datagrams that have been discarded because they needed to be fragmented at this entity but could not be, e.g., because their Don''t Fragment flag was set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (95, '.1.3.6.1.2.1.4.19', 'ipFragCreates', 34, 'mandatory', NULL, 'The number of IP datagram fragments that have been generated as a result of fragmentation at this entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (96, '.1.3.6.1.2.1.4.20', 'ipAddrTable', 34, 'mandatory', NULL, 'The table of addressing information relevant to this entity''s IP addresses.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (97, '.1.3.6.1.2.1.4.20.1', 'ipAddrEntry', 96, 'mandatory', NULL, 'The addressing information for one of this entity''s IP addresses.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (98, '.1.3.6.1.2.1.4.20.1.1', 'ipAdEntAddr', 97, 'mandatory', NULL, 'The IP address to which this entry''s addressing information pertains.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (99, '.1.3.6.1.2.1.4.20.1.2', 'ipAdEntIfIndex', 97, 'mandatory', NULL, 'The index value which uniquely identifies the interface to which this entry is applicable. The interface identified by a particular value of this index is the same interface as identified by the same value of ifIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (100, '.1.3.6.1.2.1.4.20.1.3', 'ipAdEntNetMask', 97, 'mandatory', NULL, 'The subnet mask associated with the IP address of this entry. The value of the mask is an IP address with all the network bits set to 1 and all the hosts bits set to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (101, '.1.3.6.1.2.1.4.20.1.4', 'ipAdEntBcastAddr', 97, 'mandatory', NULL, 'The value of the least-significant bit in the IP broadcast address used for sending datagrams on the (logical) interface associated with the IP address of this entry. For example, when the Internet standard all-ones broadcast address is used, the value will be 1. This value applies to both the subnet and network broadcasts addresses used by the entity on this (logical) interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (102, '.1.3.6.1.2.1.4.20.1.5', 'ipAdEntReasmMaxSize', 97, 'mandatory', NULL, 'The size of the largest IP datagram which this entity can re-assemble from incoming IP fragmented datagrams received on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (103, '.1.3.6.1.2.1.4.21', 'ipRouteTable', 34, 'mandatory', NULL, 'This entity''s IP Routing table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (104, '.1.3.6.1.2.1.4.21.1', 'ipRouteEntry', 103, 'mandatory', NULL, 'A route to a particular destination.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (105, '.1.3.6.1.2.1.4.21.1.1', 'ipRouteDest', 104, 'mandatory', NULL, 'The destination IP address of this route. An entry with a value of 0.0.0.0 is considered a default route. Multiple routes to a single destination can appear in the table, but access to such multiple entries is dependent on the table- access mechanisms defined by the network management protocol in use.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (106, '.1.3.6.1.2.1.4.21.1.2', 'ipRouteIfIndex', 104, 'mandatory', NULL, 'The index value which uniquely identifies the local interface through which the next hop of this route should be reached. The interface identified by a particular value of this index is the same interface as identified by the same value of ifIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (107, '.1.3.6.1.2.1.4.21.1.3', 'ipRouteMetric1', 104, 'mandatory', NULL, 'The primary routing metric for this route. The semantics of this metric are determined by the routing-protocol specified in the route''s ipRouteProto value. If this metric is not used, its value should be set to -1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (108, '.1.3.6.1.2.1.4.21.1.4', 'ipRouteMetric2', 104, 'mandatory', NULL, 'An alternate routing metric for this route. The semantics of this metric are determined by the routing-protocol specified in the route''s ipRouteProto value. If this metric is not used, its value should be set to -1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (109, '.1.3.6.1.2.1.4.21.1.5', 'ipRouteMetric3', 104, 'mandatory', NULL, 'An alternate routing metric for this route. The semantics of this metric are determined by the routing-protocol specified in the route''s ipRouteProto value. If this metric is not used, its value should be set to -1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (110, '.1.3.6.1.2.1.4.21.1.6', 'ipRouteMetric4', 104, 'mandatory', NULL, 'An alternate routing metric for this route. The semantics of this metric are determined by the routing-protocol specified in the route''s ipRouteProto value. If this metric is not used, its value should be set to -1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (111, '.1.3.6.1.2.1.4.21.1.7', 'ipRouteNextHop', 104, 'mandatory', NULL, 'The IP address of the next hop of this route. (In the case of a route bound to an interface which is realized via a broadcast media, the value of this field is the agent''s IP address on that interface.)', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (112, '.1.3.6.1.2.1.4.21.1.8', 'ipRouteType', 104, 'mandatory', NULL, 'The type of route. Note that the values direct(3) and indirect(4) refer to the notion of direct and indirect routing in the IP architecture.  Setting this object to the value invalid(2) has the effect of invalidating the corresponding entry in the ipRouteTable object. That is, it effectively dissasociates the destination identified with said entry from the route identified with said entry. It is an implementation-specific matter as to whether the agent removes an invalidated entry from the table. Accordingly, management stations must be prepared to receive tabular information from agents that corresponds to entries not currently in use. Proper interpretation of such entries requires examination of the relevant ipRouteType object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (113, '.1.3.6.1.2.1.4.21.1.9', 'ipRouteProto', 104, 'mandatory', NULL, 'The routing mechanism via which this route was learned. Inclusion of values for gateway routing protocols is not intended to imply that hosts should support those protocols.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (114, '.1.3.6.1.2.1.4.21.1.10', 'ipRouteAge', 104, 'mandatory', NULL, 'The number of seconds since this route was last updated or otherwise determined to be correct. Note that no semantics of `too old'' can be implied except through knowledge of the routing protocol by which the route was learned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (942, '.1.3.6.1.4.1.9.9.23.1.3', 'cdpGlobal', 939, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5539, '.1.3.6.1.4.1.9.9.168.1.2', 'cntpPeers', 5537, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (115, '.1.3.6.1.2.1.4.21.1.11', 'ipRouteMask', 104, 'mandatory', NULL, 'Indicate the mask to be logical-ANDed with the destination address before being compared to the value in the ipRouteDest field. For those systems that do not support arbitrary subnet masks, an agent constructs the value of the ipRouteMask by determining whether the value of the correspondent ipRouteDest field belong to a class-A, B, or C network, and then using one of:  mask network 255.0.0.0 class-A 255.255.0.0 class-B 255.255.255.0 class-C  If the value of the ipRouteDest is 0.0.0.0 (a default route), then the mask value is also 0.0.0.0. It should be noted that all IP routing subsystems implicitly use this mechanism.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (116, '.1.3.6.1.2.1.4.21.1.12', 'ipRouteMetric5', 104, 'mandatory', NULL, 'An alternate routing metric for this route. The semantics of this metric are determined by the routing-protocol specified in the route''s ipRouteProto value. If this metric is not used, its value should be set to -1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (117, '.1.3.6.1.2.1.4.21.1.13', 'ipRouteInfo', 104, 'mandatory', NULL, 'A reference to MIB definitions specific to the particular routing protocol which is responsible for this route, as determined by the value specified in the route''s ipRouteProto value. If this information is not present, its value should be set to the OBJECT IDENTIFIER { 0 0 }, which is a syntatically valid object identifier, and any conformant implementation of ASN.1 and BER must be able to generate and recognize this value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (118, '.1.3.6.1.2.1.4.22', 'ipNetToMediaTable', 34, 'mandatory', NULL, 'The IP Address Translation table used for mapping from IP addresses to physical addresses.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (119, '.1.3.6.1.2.1.4.22.1', 'ipNetToMediaEntry', 118, 'mandatory', NULL, 'Each entry contains one IpAddress to `physical'' address equivalence.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (120, '.1.3.6.1.2.1.4.22.1.1', 'ipNetToMediaIfIndex', 119, 'mandatory', NULL, 'The interface on which this entry''s equivalence is effective. The interface identified by a particular value of this index is the same interface as identified by the same value of ifIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (121, '.1.3.6.1.2.1.4.22.1.2', 'ipNetToMediaPhysAddress', 119, 'mandatory', NULL, 'The media-dependent `physical'' address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (122, '.1.3.6.1.2.1.4.22.1.3', 'ipNetToMediaNetAddress', 119, 'mandatory', NULL, 'The IpAddress corresponding to the media- dependent `physical'' address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (123, '.1.3.6.1.2.1.4.22.1.4', 'ipNetToMediaType', 119, 'mandatory', NULL, 'The type of mapping.  Setting this object to the value invalid(2) has the effect of invalidating the corresponding entry in the ipNetToMediaTable. That is, it effectively dissasociates the interface identified with said entry from the mapping identified with said entry. It is an implementation-specific matter as to whether the agent removes an invalidated entry from the table. Accordingly, management stations must be prepared to receive tabular information from agents that corresponds to entries not currently in use. Proper interpretation of such entries requires examination of the relevant ipNetToMediaType object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (124, '.1.3.6.1.2.1.4.23', 'ipRoutingDiscards', 34, 'mandatory', NULL, 'The number of routing entries which were chosen to be discarded even though they are valid. One possible reason for discarding such an entry could be to free-up buffer space for other routing entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (125, '.1.3.6.1.2.1.5.1', 'icmpInMsgs', 35, 'mandatory', NULL, 'The total number of ICMP messages which the entity received. Note that this counter includes all those counted by icmpInErrors.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (126, '.1.3.6.1.2.1.5.2', 'icmpInErrors', 35, 'mandatory', NULL, 'The number of ICMP messages which the entity received but determined as having ICMP-specific errors (bad ICMP checksums, bad length, etc.).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (127, '.1.3.6.1.2.1.5.3', 'icmpInDestUnreachs', 35, 'mandatory', NULL, 'The number of ICMP Destination Unreachable messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (128, '.1.3.6.1.2.1.5.4', 'icmpInTimeExcds', 35, 'mandatory', NULL, 'The number of ICMP Time Exceeded messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (129, '.1.3.6.1.2.1.5.5', 'icmpInParmProbs', 35, 'mandatory', NULL, 'The number of ICMP Parameter Problem messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (130, '.1.3.6.1.2.1.5.6', 'icmpInSrcQuenchs', 35, 'mandatory', NULL, 'The number of ICMP Source Quench messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (131, '.1.3.6.1.2.1.5.7', 'icmpInRedirects', 35, 'mandatory', NULL, 'The number of ICMP Redirect messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (132, '.1.3.6.1.2.1.5.8', 'icmpInEchos', 35, 'mandatory', NULL, 'The number of ICMP Echo (request) messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (133, '.1.3.6.1.2.1.5.9', 'icmpInEchoReps', 35, 'mandatory', NULL, 'The number of ICMP Echo Reply messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (134, '.1.3.6.1.2.1.5.10', 'icmpInTimestamps', 35, 'mandatory', NULL, 'The number of ICMP Timestamp (request) messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (135, '.1.3.6.1.2.1.5.11', 'icmpInTimestampReps', 35, 'mandatory', NULL, 'The number of ICMP Timestamp Reply messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (136, '.1.3.6.1.2.1.5.12', 'icmpInAddrMasks', 35, 'mandatory', NULL, 'The number of ICMP Address Mask Request messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (137, '.1.3.6.1.2.1.5.13', 'icmpInAddrMaskReps', 35, 'mandatory', NULL, 'The number of ICMP Address Mask Reply messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (138, '.1.3.6.1.2.1.5.14', 'icmpOutMsgs', 35, 'mandatory', NULL, 'The total number of ICMP messages which this entity attempted to send. Note that this counter includes all those counted by icmpOutErrors.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (139, '.1.3.6.1.2.1.5.15', 'icmpOutErrors', 35, 'mandatory', NULL, 'The number of ICMP messages which this entity did not send due to problems discovered within ICMP such as a lack of buffers. This value should not include errors discovered outside the ICMP layer such as the inability of IP to route the resultant datagram. In some implementations there may be no types of error which contribute to this counter''s value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (140, '.1.3.6.1.2.1.5.16', 'icmpOutDestUnreachs', 35, 'mandatory', NULL, 'The number of ICMP Destination Unreachable messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (141, '.1.3.6.1.2.1.5.17', 'icmpOutTimeExcds', 35, 'mandatory', NULL, 'The number of ICMP Time Exceeded messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (142, '.1.3.6.1.2.1.5.18', 'icmpOutParmProbs', 35, 'mandatory', NULL, 'The number of ICMP Parameter Problem messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (143, '.1.3.6.1.2.1.5.19', 'icmpOutSrcQuenchs', 35, 'mandatory', NULL, 'The number of ICMP Source Quench messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (144, '.1.3.6.1.2.1.5.20', 'icmpOutRedirects', 35, 'mandatory', NULL, 'The number of ICMP Redirect messages sent. For a host, this object will always be zero, since hosts do not send redirects.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (145, '.1.3.6.1.2.1.5.21', 'icmpOutEchos', 35, 'mandatory', NULL, 'The number of ICMP Echo (request) messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (146, '.1.3.6.1.2.1.5.22', 'icmpOutEchoReps', 35, 'mandatory', NULL, 'The number of ICMP Echo Reply messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (147, '.1.3.6.1.2.1.5.23', 'icmpOutTimestamps', 35, 'mandatory', NULL, 'The number of ICMP Timestamp (request) messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (148, '.1.3.6.1.2.1.5.24', 'icmpOutTimestampReps', 35, 'mandatory', NULL, 'The number of ICMP Timestamp Reply messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (149, '.1.3.6.1.2.1.5.25', 'icmpOutAddrMasks', 35, 'mandatory', NULL, 'The number of ICMP Address Mask Request messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (150, '.1.3.6.1.2.1.5.26', 'icmpOutAddrMaskReps', 35, 'mandatory', NULL, 'The number of ICMP Address Mask Reply messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (151, '.1.3.6.1.2.1.6.1', 'tcpRtoAlgorithm', 36, 'mandatory', NULL, 'The algorithm used to determine the timeout value used for retransmitting unacknowledged octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (190, '.1.3.6.1.2.1.8.5.1.5', 'egpNeighInErrs', 185, 'mandatory', NULL, 'The number of EGP messages received from this EGP peer that proved to be in error (e.g., bad EGP checksum).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6238, '.1.0', 'std', 15, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (152, '.1.3.6.1.2.1.6.2', 'tcpRtoMin', 36, 'mandatory', NULL, 'The minimum value permitted by a TCP implementation for the retransmission timeout, measured in milliseconds. More refined semantics for objects of this type depend upon the algorithm used to determine the retransmission timeout. In particular, when the timeout algorithm is rsre(3), an object of this type has the semantics of the LBOUND quantity described in RFC 793.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (153, '.1.3.6.1.2.1.6.3', 'tcpRtoMax', 36, 'mandatory', NULL, 'The maximum value permitted by a TCP implementation for the retransmission timeout, measured in milliseconds. More refined semantics for objects of this type depend upon the algorithm used to determine the retransmission timeout. In particular, when the timeout algorithm is rsre(3), an object of this type has the semantics of the UBOUND quantity described in RFC 793.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (154, '.1.3.6.1.2.1.6.4', 'tcpMaxConn', 36, 'mandatory', NULL, 'The limit on the total number of TCP connections the entity can support. In entities where the maximum number of connections is dynamic, this object should contain the value -1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (155, '.1.3.6.1.2.1.6.5', 'tcpActiveOpens', 36, 'mandatory', NULL, 'The number of times TCP connections have made a direct transition to the SYN-SENT state from the CLOSED state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (156, '.1.3.6.1.2.1.6.6', 'tcpPassiveOpens', 36, 'mandatory', NULL, 'The number of times TCP connections have made a direct transition to the SYN-RCVD state from the LISTEN state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (157, '.1.3.6.1.2.1.6.7', 'tcpAttemptFails', 36, 'mandatory', NULL, 'The number of times TCP connections have made a direct transition to the CLOSED state from either the SYN-SENT state or the SYN-RCVD state, plus the number of times TCP connections have made a direct transition to the LISTEN state from the SYN-RCVD state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (158, '.1.3.6.1.2.1.6.8', 'tcpEstabResets', 36, 'mandatory', NULL, 'The number of times TCP connections have made a direct transition to the CLOSED state from either the ESTABLISHED state or the CLOSE-WAIT state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (159, '.1.3.6.1.2.1.6.9', 'tcpCurrEstab', 36, 'mandatory', NULL, 'The number of TCP connections for which the current state is either ESTABLISHED or CLOSE- WAIT.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (160, '.1.3.6.1.2.1.6.10', 'tcpInSegs', 36, 'mandatory', NULL, 'The total number of segments received, including those received in error. This count includes segments received on currently established connections.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (161, '.1.3.6.1.2.1.6.11', 'tcpOutSegs', 36, 'mandatory', NULL, 'The total number of segments sent, including those on current connections but excluding those containing only retransmitted octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (162, '.1.3.6.1.2.1.6.12', 'tcpRetransSegs', 36, 'mandatory', NULL, 'The total number of segments retransmitted - that is, the number of TCP segments transmitted containing one or more previously transmitted octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (163, '.1.3.6.1.2.1.6.13', 'tcpConnTable', 36, 'mandatory', NULL, 'A table containing TCP connection-specific information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (164, '.1.3.6.1.2.1.6.13.1', 'tcpConnEntry', 163, 'mandatory', NULL, 'Information about a particular current TCP connection. An object of this type is transient, in that it ceases to exist when (or soon after) the connection makes the transition to the CLOSED state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (165, '.1.3.6.1.2.1.6.13.1.1', 'tcpConnState', 164, 'mandatory', NULL, 'The state of this TCP connection.  The only value which may be set by a management station is deleteTCB(12). Accordingly, it is appropriate for an agent to return a `badValue'' response if a management station attempts to set this object to any other value.  If a management station sets this object to the value deleteTCB(12), then this has the effect of deleting the TCB (as defined in RFC 793) of the corresponding connection on the managed node, resulting in immediate termination of the connection.  As an implementation-specific option, a RST segment may be sent from the managed node to the other TCP endpoint (note however that RST segments are not sent reliably).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (166, '.1.3.6.1.2.1.6.13.1.2', 'tcpConnLocalAddress', 164, 'mandatory', NULL, 'The local IP address for this TCP connection. In the case of a connection in the listen state which is willing to accept connections for any IP interface associated with the node, the value 0.0.0.0 is used.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (167, '.1.3.6.1.2.1.6.13.1.3', 'tcpConnLocalPort', 164, 'mandatory', NULL, 'The local port number for this TCP connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (168, '.1.3.6.1.2.1.6.13.1.4', 'tcpConnRemAddress', 164, 'mandatory', NULL, 'The remote IP address for this TCP connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (169, '.1.3.6.1.2.1.6.13.1.5', 'tcpConnRemPort', 164, 'mandatory', NULL, 'The remote port number for this TCP connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (170, '.1.3.6.1.2.1.6.14', 'tcpInErrs', 36, 'mandatory', NULL, 'The total number of segments received in error (e.g., bad TCP checksums).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (171, '.1.3.6.1.2.1.6.15', 'tcpOutRsts', 36, 'mandatory', NULL, 'The number of TCP segments sent containing the RST flag.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (172, '.1.3.6.1.2.1.7.1', 'udpInDatagrams', 37, 'mandatory', NULL, 'The total number of UDP datagrams delivered to UDP users.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (173, '.1.3.6.1.2.1.7.2', 'udpNoPorts', 37, 'mandatory', NULL, 'The total number of received UDP datagrams for which there was no application at the destination port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (174, '.1.3.6.1.2.1.7.3', 'udpInErrors', 37, 'mandatory', NULL, 'The number of received UDP datagrams that could not be delivered for reasons other than the lack of an application at the destination port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (175, '.1.3.6.1.2.1.7.4', 'udpOutDatagrams', 37, 'mandatory', NULL, 'The total number of UDP datagrams sent from this entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (176, '.1.3.6.1.2.1.7.5', 'udpTable', 37, 'mandatory', NULL, 'A table containing UDP listener information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (177, '.1.3.6.1.2.1.7.5.1', 'udpEntry', 176, 'mandatory', NULL, 'Information about a particular current UDP listener.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (178, '.1.3.6.1.2.1.7.5.1.1', 'udpLocalAddress', 177, 'mandatory', NULL, 'The local IP address for this UDP listener. In the case of a UDP listener which is willing to accept datagrams for any IP interface associated with the node, the value 0.0.0.0 is used.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (179, '.1.3.6.1.2.1.7.5.1.2', 'udpLocalPort', 177, 'mandatory', NULL, 'The local port number for this UDP listener.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (180, '.1.3.6.1.2.1.8.1', 'egpInMsgs', 38, 'mandatory', NULL, 'The number of EGP messages received without error.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (181, '.1.3.6.1.2.1.8.2', 'egpInErrors', 38, 'mandatory', NULL, 'The number of EGP messages received that proved to be in error.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (182, '.1.3.6.1.2.1.8.3', 'egpOutMsgs', 38, 'mandatory', NULL, 'The total number of locally generated EGP messages.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (183, '.1.3.6.1.2.1.8.4', 'egpOutErrors', 38, 'mandatory', NULL, 'The number of locally generated EGP messages not sent due to resource limitations within an EGP entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (184, '.1.3.6.1.2.1.8.5', 'egpNeighTable', 38, 'mandatory', NULL, 'The EGP neighbor table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (185, '.1.3.6.1.2.1.8.5.1', 'egpNeighEntry', 184, 'mandatory', NULL, 'Information about this entity''s relationship with a particular EGP neighbor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (186, '.1.3.6.1.2.1.8.5.1.1', 'egpNeighState', 185, 'mandatory', NULL, 'The EGP state of the local system with respect to this entry''s EGP neighbor. Each EGP state is represented by a value that is one greater than the numerical value associated with said state in RFC 904.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (187, '.1.3.6.1.2.1.8.5.1.2', 'egpNeighAddr', 185, 'mandatory', NULL, 'The IP address of this entry''s EGP neighbor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (188, '.1.3.6.1.2.1.8.5.1.3', 'egpNeighAs', 185, 'mandatory', NULL, 'The autonomous system of this EGP peer. Zero should be specified if the autonomous system number of the neighbor is not yet known.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5531, '.1.3.6.1.4.1.9.9.84.3', 'ciscoIpStatMIBConformance', 5511, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (191, '.1.3.6.1.2.1.8.5.1.6', 'egpNeighOutMsgs', 185, 'mandatory', NULL, 'The number of locally generated EGP messages to this EGP peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (192, '.1.3.6.1.2.1.8.5.1.7', 'egpNeighOutErrs', 185, 'mandatory', NULL, 'The number of locally generated EGP messages not sent to this EGP peer due to resource limitations within an EGP entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (193, '.1.3.6.1.2.1.8.5.1.8', 'egpNeighInErrMsgs', 185, 'mandatory', NULL, 'The number of EGP-defined error messages received from this EGP peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (194, '.1.3.6.1.2.1.8.5.1.9', 'egpNeighOutErrMsgs', 185, 'mandatory', NULL, 'The number of EGP-defined error messages sent to this EGP peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (195, '.1.3.6.1.2.1.8.5.1.10', 'egpNeighStateUps', 185, 'mandatory', NULL, 'The number of EGP state transitions to the UP state with this EGP peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (196, '.1.3.6.1.2.1.8.5.1.11', 'egpNeighStateDowns', 185, 'mandatory', NULL, 'The number of EGP state transitions from the UP state to any other state with this EGP peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (197, '.1.3.6.1.2.1.8.5.1.12', 'egpNeighIntervalHello', 185, 'mandatory', NULL, 'The interval between EGP Hello command retransmissions (in hundredths of a second). This represents the t1 timer as defined in RFC 904.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (198, '.1.3.6.1.2.1.8.5.1.13', 'egpNeighIntervalPoll', 185, 'mandatory', NULL, 'The interval between EGP poll command retransmissions (in hundredths of a second). This represents the t3 timer as defined in RFC 904.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (199, '.1.3.6.1.2.1.8.5.1.14', 'egpNeighMode', 185, 'mandatory', NULL, 'The polling mode of this EGP entity, either passive or active.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (200, '.1.3.6.1.2.1.8.5.1.15', 'egpNeighEventTrigger', 185, 'mandatory', NULL, 'A control variable used to trigger operator- initiated Start and Stop events. When read, this variable always returns the most recent value that egpNeighEventTrigger was set to. If it has not been set since the last initialization of the network management subsystem on the node, it returns a value of `stop''.  When set, this variable causes a Start or Stop event on the specified neighbor, as specified on pages 8-10 of RFC 904. Briefly, a Start event causes an Idle peer to begin neighbor acquisition and a non-Idle peer to reinitiate neighbor acquisition. A stop event causes a non-Idle peer to return to the Idle state until a Start event occurs, either via egpNeighEventTrigger or otherwise.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (201, '.1.3.6.1.2.1.8.6', 'egpAs', 38, 'mandatory', NULL, 'The autonomous system number of this EGP entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (202, '.1.3.6.1.2.1.11.1', 'snmpInPkts', 39, 'mandatory', NULL, 'The total number of Messages delivered to the SNMP entity from the transport service.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (203, '.1.3.6.1.2.1.11.2', 'snmpOutPkts', 39, 'mandatory', NULL, 'The total number of SNMP Messages which were passed from the SNMP protocol entity to the transport service.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (204, '.1.3.6.1.2.1.11.3', 'snmpInBadVersions', 39, 'mandatory', NULL, 'The total number of SNMP Messages which were delivered to the SNMP protocol entity and were for an unsupported SNMP version.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (205, '.1.3.6.1.2.1.11.4', 'snmpInBadCommunityNames', 39, 'mandatory', NULL, 'The total number of SNMP Messages delivered to the SNMP protocol entity which used a SNMP community name not known to said entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (206, '.1.3.6.1.2.1.11.5', 'snmpInBadCommunityUses', 39, 'mandatory', NULL, 'The total number of SNMP Messages delivered to the SNMP protocol entity which represented an SNMP operation which was not allowed by the SNMP community named in the Message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (207, '.1.3.6.1.2.1.11.6', 'snmpInASNParseErrs', 39, 'mandatory', NULL, 'The total number of ASN.1 or BER errors encountered by the SNMP protocol entity when decoding received SNMP Messages.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (208, '.1.3.6.1.2.1.11.8', 'snmpInTooBigs', 39, 'mandatory', NULL, 'The total number of SNMP PDUs which were delivered to the SNMP protocol entity and for which the value of the error-status field is `tooBig''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (209, '.1.3.6.1.2.1.11.9', 'snmpInNoSuchNames', 39, 'mandatory', NULL, 'The total number of SNMP PDUs which were delivered to the SNMP protocol entity and for which the value of the error-status field is `noSuchName''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (210, '.1.3.6.1.2.1.11.10', 'snmpInBadValues', 39, 'mandatory', NULL, 'The total number of SNMP PDUs which were delivered to the SNMP protocol entity and for which the value of the error-status field is `badValue''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (211, '.1.3.6.1.2.1.11.11', 'snmpInReadOnlys', 39, 'mandatory', NULL, 'The total number valid SNMP PDUs which were delivered to the SNMP protocol entity and for which the value of the error-status field is `readOnly''. It should be noted that it is a protocol error to generate an SNMP PDU which contains the value `readOnly'' in the error-status field, as such this object is provided as a means of detecting incorrect implementations of the SNMP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (212, '.1.3.6.1.2.1.11.12', 'snmpInGenErrs', 39, 'mandatory', NULL, 'The total number of SNMP PDUs which were delivered to the SNMP protocol entity and for which the value of the error-status field is `genErr''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (213, '.1.3.6.1.2.1.11.13', 'snmpInTotalReqVars', 39, 'mandatory', NULL, 'The total number of MIB objects which have been retrieved successfully by the SNMP protocol entity as the result of receiving valid SNMP Get-Request and Get-Next PDUs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (214, '.1.3.6.1.2.1.11.14', 'snmpInTotalSetVars', 39, 'mandatory', NULL, 'The total number of MIB objects which have been altered successfully by the SNMP protocol entity as the result of receiving valid SNMP Set-Request PDUs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (215, '.1.3.6.1.2.1.11.15', 'snmpInGetRequests', 39, 'mandatory', NULL, 'The total number of SNMP Get-Request PDUs which have been accepted and processed by the SNMP protocol entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (216, '.1.3.6.1.2.1.11.16', 'snmpInGetNexts', 39, 'mandatory', NULL, 'The total number of SNMP Get-Next PDUs which have been accepted and processed by the SNMP protocol entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (217, '.1.3.6.1.2.1.11.17', 'snmpInSetRequests', 39, 'mandatory', NULL, 'The total number of SNMP Set-Request PDUs which have been accepted and processed by the SNMP protocol entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (218, '.1.3.6.1.2.1.11.18', 'snmpInGetResponses', 39, 'mandatory', NULL, 'The total number of SNMP Get-Response PDUs which have been accepted and processed by the SNMP protocol entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (219, '.1.3.6.1.2.1.11.19', 'snmpInTraps', 39, 'mandatory', NULL, 'The total number of SNMP Trap PDUs which have been accepted and processed by the SNMP protocol entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (220, '.1.3.6.1.2.1.11.20', 'snmpOutTooBigs', 39, 'mandatory', NULL, 'The total number of SNMP PDUs which were generated by the SNMP protocol entity and for which the value of the error-status field is `tooBig.''', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (221, '.1.3.6.1.2.1.11.21', 'snmpOutNoSuchNames', 39, 'mandatory', NULL, 'The total number of SNMP PDUs which were generated by the SNMP protocol entity and for which the value of the error-status is `noSuchName''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (222, '.1.3.6.1.2.1.11.22', 'snmpOutBadValues', 39, 'mandatory', NULL, 'The total number of SNMP PDUs which were generated by the SNMP protocol entity and for which the value of the error-status field is `badValue''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (223, '.1.3.6.1.2.1.11.24', 'snmpOutGenErrs', 39, 'mandatory', NULL, 'The total number of SNMP PDUs which were generated by the SNMP protocol entity and for which the value of the error-status field is `genErr''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (224, '.1.3.6.1.2.1.11.25', 'snmpOutGetRequests', 39, 'mandatory', NULL, 'The total number of SNMP Get-Request PDUs which have been generated by the SNMP protocol entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (225, '.1.3.6.1.2.1.11.26', 'snmpOutGetNexts', 39, 'mandatory', NULL, 'The total number of SNMP Get-Next PDUs which have been generated by the SNMP protocol entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5128, '.1.3.6.1.4.1.9.9.692.3', 'ciscoFlowMonitorMIBIds', 5124, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (226, '.1.3.6.1.2.1.11.27', 'snmpOutSetRequests', 39, 'mandatory', NULL, 'The total number of SNMP Set-Request PDUs which have been generated by the SNMP protocol entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (227, '.1.3.6.1.2.1.11.28', 'snmpOutGetResponses', 39, 'mandatory', NULL, 'The total number of SNMP Get-Response PDUs which have been generated by the SNMP protocol entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (228, '.1.3.6.1.2.1.11.29', 'snmpOutTraps', 39, 'mandatory', NULL, 'The total number of SNMP Trap PDUs which have been generated by the SNMP protocol entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (229, '.1.3.6.1.2.1.11.30', 'snmpEnableAuthenTraps', 39, 'mandatory', NULL, 'Indicates whether the SNMP agent process is permitted to generate authentication-failure traps. The value of this object overrides any configuration information; as such, it provides a means whereby all authentication-failure traps may be disabled.  Note that it is strongly recommended that this object be stored in non-volatile memory so that it remains constant between re-initializations of the network management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (230, '.1.3.6.1.6.3.1', 'snmpMIB', 30, 'current', NULL, 'The MIB module for SNMP entities.  Copyright (C) The Internet Society (2002). This version of this MIB module is part of RFC 3418; see the RFC itself for full legal notices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (231, '.1.3.6.1.6.3.1.1', 'snmpMIBObjects', 230, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (232, '.1.3.6.1.2.1.1.8', 'sysORLastChange', 31, 'current', NULL, 'The value of sysUpTime at the time of the most recent change in state or value of any instance of sysORID.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (233, '.1.3.6.1.2.1.1.9', 'sysORTable', 31, 'current', NULL, 'The (conceptual) table listing the capabilities of the local SNMP application acting as a command responder with respect to various MIB modules. SNMP entities having dynamically-configurable support of MIB modules will have a dynamically-varying number of conceptual rows.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (234, '.1.3.6.1.2.1.1.9.1', 'sysOREntry', 233, 'current', NULL, 'An entry (conceptual row) in the sysORTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (235, '.1.3.6.1.2.1.1.9.1.1', 'sysORIndex', 234, 'current', NULL, 'The auxiliary variable used for identifying instances of the columnar objects in the sysORTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (236, '.1.3.6.1.2.1.1.9.1.2', 'sysORID', 234, 'current', NULL, 'An authoritative identification of a capabilities statement with respect to various MIB modules supported by the local SNMP application acting as a command responder.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (237, '.1.3.6.1.2.1.1.9.1.3', 'sysORDescr', 234, 'current', NULL, 'A textual description of the capabilities identified by the corresponding instance of sysORID.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (238, '.1.3.6.1.2.1.1.9.1.4', 'sysORUpTime', 234, 'current', NULL, 'The value of sysUpTime at the time this conceptual row was last instantiated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (239, '.1.3.6.1.2.1.11.31', 'snmpSilentDrops', 39, 'current', NULL, 'The total number of Confirmed Class PDUs (such as GetRequest-PDUs, GetNextRequest-PDUs, GetBulkRequest-PDUs, SetRequest-PDUs, and InformRequest-PDUs) delivered to the SNMP entity which were silently dropped because the size of a reply containing an alternate Response Class PDU (such as a Response-PDU) with an empty variable-bindings field was greater than either a local constraint or the maximum message size associated with the originator of the request.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (240, '.1.3.6.1.2.1.11.32', 'snmpProxyDrops', 39, 'current', NULL, 'The total number of Confirmed Class PDUs (such as GetRequest-PDUs, GetNextRequest-PDUs, GetBulkRequest-PDUs, SetRequest-PDUs, and InformRequest-PDUs) delivered to the SNMP entity which were silently dropped because the transmission of the (possibly translated) message to a proxy target failed in a manner (other than a time-out) such that no Response Class PDU (such as a Response-PDU) could be returned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (241, '.1.3.6.1.6.3.1.1.4', 'snmpTrap', 231, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (242, '.1.3.6.1.6.3.1.1.4.1', 'snmpTrapOID', 241, 'current', NULL, 'The authoritative identification of the notification currently being sent. This variable occurs as the second varbind in every SNMPv2-Trap-PDU and InformRequest-PDU.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (243, '.1.3.6.1.6.3.1.1.4.3', 'snmpTrapEnterprise', 241, 'current', NULL, 'The authoritative identification of the enterprise associated with the trap currently being sent. When an SNMP proxy agent is mapping an RFC1157 Trap-PDU into a SNMPv2-Trap-PDU, this variable occurs as the last varbind.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (244, '.1.3.6.1.6.3.1.1.5', 'snmpTraps', 231, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (245, '.1.3.6.1.6.3.1.1.5.1', 'coldStart', 244, 'current', NULL, 'A coldStart trap signifies that the SNMP entity, supporting a notification originator application, is reinitializing itself and that its configuration may have been altered.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (246, '.1.3.6.1.6.3.1.1.5.2', 'warmStart', 244, 'current', NULL, 'A warmStart trap signifies that the SNMP entity, supporting a notification originator application, is reinitializing itself such that its configuration is unaltered.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (247, '.1.3.6.1.6.3.1.1.5.5', 'authenticationFailure', 244, 'current', NULL, 'An authenticationFailure trap signifies that the SNMP entity has received a protocol message that is not properly authenticated. While all implementations of SNMP entities MAY be capable of generating this trap, the snmpEnableAuthenTraps object indicates whether this trap will be generated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (248, '.1.3.6.1.6.3.1.1.6', 'snmpSet', 231, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (249, '.1.3.6.1.6.3.1.1.6.1', 'snmpSetSerialNo', 248, 'current', NULL, 'An advisory lock used to allow several cooperating command generator applications to coordinate their use of the SNMP set operation.  This object is used for coarse-grain coordination. To achieve fine-grain coordination, one or more similar objects might be defined within each MIB group, as appropriate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (250, '.1.3.6.1.6.3.1.2', 'snmpMIBConformance', 230, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (251, '.1.3.6.1.6.3.1.2.1', 'snmpMIBCompliances', 250, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (252, '.1.3.6.1.6.3.1.2.2', 'snmpMIBGroups', 250, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (253, '.1.3.6.1.6.3.1.2.1.2', 'snmpBasicCompliance', 251, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (254, '.1.3.6.1.6.3.1.2.1.3', 'snmpBasicComplianceRev2', 251, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (255, '.1.3.6.1.6.3.1.2.2.8', 'snmpGroup', 252, 'current', NULL, 'A collection of objects providing basic instrumentation and control of an SNMP entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (256, '.1.3.6.1.6.3.1.2.2.9', 'snmpCommunityGroup', 252, 'current', NULL, 'A collection of objects providing basic instrumentation of a SNMP entity which supports community-based authentication.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (257, '.1.3.6.1.6.3.1.2.2.5', 'snmpSetGroup', 252, 'current', NULL, 'A collection of objects which allow several cooperating command generator applications to coordinate their use of the set operation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (258, '.1.3.6.1.6.3.1.2.2.6', 'systemGroup', 252, 'current', NULL, 'The system group defines objects which are common to all managed systems.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (259, '.1.3.6.1.6.3.1.2.2.7', 'snmpBasicNotificationsGroup', 252, 'current', NULL, 'The basic notifications implemented by an SNMP entity supporting command responder applications.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (260, '.1.3.6.1.6.3.1.2.2.11', 'snmpWarmStartNotificationGroup', 252, 'current', NULL, 'An additional notification for an SNMP entity supporting command responder applications, if it is able to reinitialize itself such that its configuration is unaltered.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (261, '.1.3.6.1.6.3.1.2.2.12', 'snmpNotificationGroup', 252, 'current', NULL, 'These objects are required for entities which support notification originator applications.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (262, '.1.3.6.1.6.3.1.2.2.10', 'snmpObsoleteGroup', 252, 'obsolete', NULL, 'A collection of objects from RFC 1213 made obsolete by this MIB module.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (263, '.1.3.6.1.4.1.9', 'cisco', 25, 'current', NULL, 'The Structure of Management Information for the Cisco enterprise.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6239, '.1.0.8802', 'iso8802', 6238, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (264, '.1.3.6.1.4.1.9.1', 'ciscoProducts', 263, 'current', NULL, 'ciscoProducts is the root OBJECT IDENTIFIER from which sysObjectID values are assigned. Actual values are defined in CISCO-PRODUCTS-MIB.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (265, '.1.3.6.1.4.1.9.2', 'local', 263, 'current', NULL, 'Subtree beneath which pre-10.2 MIBS were built.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (266, '.1.3.6.1.4.1.9.3', 'temporary', 263, 'current', NULL, 'Subtree beneath which pre-10.2 experiments were placed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (267, '.1.3.6.1.4.1.9.4', 'pakmon', 263, 'current', NULL, 'reserved for pakmon', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (268, '.1.3.6.1.4.1.9.5', 'workgroup', 263, 'current', NULL, 'subtree reserved for use by the Workgroup Business Unit', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (269, '.1.3.6.1.4.1.9.6', 'otherEnterprises', 263, 'current', NULL, 'otherEnterprises provides a root object identifier from which mibs produced by other companies may be placed. mibs produced by other enterprises are typicially implemented with the object identifiers as defined in the mib, but if the mib is deemed to be uncontrolled, we may reroot the mib at this subtree in order to have a controlled version.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (270, '.1.3.6.1.4.1.9.7', 'ciscoAgentCapability', 263, 'current', NULL, 'ciscoAgentCapability provides a root object identifier from which AGENT-CAPABILITIES values may be assigned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (271, '.1.3.6.1.4.1.9.8', 'ciscoConfig', 263, 'current', NULL, 'ciscoConfig is the main subtree for configuration mibs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (272, '.1.3.6.1.4.1.9.9', 'ciscoMgmt', 263, 'current', NULL, 'ciscoMgmt is the main subtree for new mib development.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (273, '.1.3.6.1.4.1.9.10', 'ciscoExperiment', 263, 'current', NULL, 'ciscoExperiment provides a root object identifier from which experimental mibs may be temporarily based. mibs are typicially based here if they fall in one of two categories 1) are IETF work-in-process mibs which have not been assigned a permanent object identifier by the IANA. 2) are cisco work-in-process which has not been assigned a permanent object identifier by the cisco assigned number authority, typicially because the mib is not ready for deployment.  NOTE WELL: support for mibs in the ciscoExperiment subtree will be deleted when a permanent object identifier assignment is made.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (274, '.1.3.6.1.4.1.9.11', 'ciscoAdmin', 263, 'current', NULL, 'ciscoAdmin is reserved for administratively assigned OBJECT IDENTIFIERS, i.e. those not associated with MIB objects', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (275, '.1.3.6.1.4.1.9.12', 'ciscoModules', 263, 'current', NULL, 'ciscoModules provides a root object identifier from which MODULE-IDENTITY values may be assigned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (276, '.1.3.6.1.4.1.9.13', 'lightstream', 263, 'current', NULL, 'subtree reserved for use by Lightstream', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (277, '.1.3.6.1.4.1.9.14', 'ciscoworks', 263, 'current', NULL, 'ciscoworks provides a root object identifier beneath which mibs applicable to the CiscoWorks family of network management products are defined.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (278, '.1.3.6.1.4.1.9.15', 'newport', 263, 'current', NULL, 'subtree reserved for use by the former Newport Systems Solutions, now a portion of the Access Business Unit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (279, '.1.3.6.1.4.1.9.16', 'ciscoPartnerProducts', 263, 'current', NULL, 'ciscoPartnerProducts is the root OBJECT IDENTIFIER from which partner sysObjectID values may be assigned. Such sysObjectID values are composed of the ciscoPartnerProducts prefix, followed by a single identifier that is unique for each partner, followed by the value of sysObjectID of the Cisco product from which partner product is derived. Note that the chassisPartner MIB object defines the value of the identifier assigned to each partner.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (280, '.1.3.6.1.4.1.9.17', 'ciscoPolicy', 263, 'current', NULL, 'ciscoPolicy is the root of the Cisco-assigned OID subtree for use with Policy Management.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (281, '.1.3.6.1.4.1.9.17.2', 'ciscoPIB', 280, 'current', NULL, 'ciscoPIB is the root of the Cisco-assigned OID subtree for assignment to PIB (Policy Information Base) modules.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (282, '.1.3.6.1.4.1.9.18', 'ciscoPolicyAuto', 263, 'current', NULL, 'ciscoPolicyAuto is the root of the Cisco-assigned OID subtree for OIDs which are automatically assigned for use in Policy Management.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (283, '.1.3.6.1.4.1.9.18.2', 'ciscoPibToMib', 282, 'current', NULL, 'ciscoPibToMib is the root of the Cisco-assigned OID subtree for MIBs which are algorithmically generated/translated from Cisco PIBs with OIDs assigned under the ciscoPIB subtree. These generated MIBs allow management entities (other the current Policy Server) to read the downloaded policy. By convention, for PIB ''ciscoPIB.x'', the generated MIB shall have the name ''ciscoPibToMib.x''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (284, '.1.3.6.1.4.1.9.11.1', 'ciscoProxy', 274, 'current', NULL, 'ciscoProxy OBJECT IDENTIFIERS are used to uniquely name party mib records created to proxy for SNMPv1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (285, '.1.3.6.1.4.1.9.11.1.1', 'ciscoPartyProxy', 284, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (286, '.1.3.6.1.4.1.9.11.1.2', 'ciscoContextProxy', 284, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (287, '.1.3.6.1.4.1.9.11.2', 'ciscoRptrGroupObjectID', 274, 'current', NULL, 'ciscoRptrGroupObjectID OBJECT IDENTIFIERS are used to uniquely identify groups of repeater ports for use by the SNMP-REPEATER-MIB (RFC 1516) rptrGroupObjectID object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (288, '.1.3.6.1.4.1.9.11.2.1', 'ciscoUnknownRptrGroup', 287, 'current', NULL, 'The identity of an unknown repeater port group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (289, '.1.3.6.1.4.1.9.11.2.2', 'cisco2505RptrGroup', 287, 'current', NULL, 'The authoritative identity of the Cisco 2505 repeater port group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (290, '.1.3.6.1.4.1.9.11.2.3', 'cisco2507RptrGroup', 287, 'current', NULL, 'The authoritative identity of the Cisco 2507 repeater port group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (291, '.1.3.6.1.4.1.9.11.2.4', 'cisco2516RptrGroup', 287, 'current', NULL, 'The authoritative identity of the Cisco 2516 repeater port group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (292, '.1.3.6.1.4.1.9.11.2.5', 'ciscoWsx5020RptrGroup', 287, 'current', NULL, 'The authoritative identity of the wsx5020 repeater port group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (293, '.1.3.6.1.4.1.9.11.3', 'ciscoChipSets', 274, 'current', NULL, 'Numerous media-specific MIBS have an object, defined as an OBJECT IDENTIFIER, which is the identity of the chipset realizing the interface. Cisco-specific chipsets have their OBJECT IDENTIFIERS assigned under this subtree.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (294, '.1.3.6.1.4.1.9.11.3.1', 'ciscoChipSetSaint1', 293, 'current', NULL, 'The identity of the Rev 1 SAINT ethernet chipset manufactured for cisco by LSI Logic.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (295, '.1.3.6.1.4.1.9.11.3.2', 'ciscoChipSetSaint2', 293, 'current', NULL, 'The identity of the Rev 2 SAINT ethernet chipset manufactured for cisco by LSI Logic.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (296, '.1.3.6.1.4.1.9.11.3.3', 'ciscoChipSetSaint3', 293, 'current', NULL, 'The identity of the Rev 3 SAINT ethernet chipset manufactured for cisco by Plessey.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (297, '.1.3.6.1.4.1.9.11.3.4', 'ciscoChipSetSaint4', 293, 'current', NULL, 'The identity of the Rev 4 SAINT ethernet chipset manufactured for cisco by Mitsubishi.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (298, '.1.3.6.1.4.1.9.12.1', 'ciscoTextualConventions', 275, 'current', NULL, 'This module defines textual conventions used throughout cisco enterprise mibs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (299, '.1.3.6.1.2.1.30', 'ianaifType', 21, 'current', NULL, 'This MIB module defines the IANAifType Textual Convention, and thus the enumerated values of the ifType object defined in MIB-II''s ifTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (300, '.1.3.6.1.2.1.31', 'ifMIB', 21, 'current', NULL, 'The MIB module to describe generic objects for network interface sub-layers. This MIB is an updated version of MIB-II''s ifTable, and incorporates the extensions defined in RFC 1229.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (301, '.1.3.6.1.2.1.31.1', 'ifMIBObjects', 300, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (797, '.1.3.6.1.4.1.9.9.46', 'ciscoVtpMIB', 272, 'current', NULL, 'The MIB module for entities implementing the VTP protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (798, '.1.3.6.1.4.1.9.9.46.1', 'vtpMIBObjects', 797, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6240, '.1.0.8802.1', 'ieee802dot1', 6239, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (302, '.1.3.6.1.2.1.31.1.5', 'ifTableLastChange', 301, 'current', NULL, 'The value of sysUpTime at the time of the last creation or deletion of an entry in the ifTable. If the number of entries has been unchanged since the last re-initialization of the local network management subsystem, then this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (303, '.1.3.6.1.2.1.31.1.1', 'ifXTable', 301, 'current', NULL, 'A list of interface entries. The number of entries is given by the value of ifNumber. This table contains additional objects for the interface table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (304, '.1.3.6.1.2.1.31.1.1.1', 'ifXEntry', 303, 'current', NULL, 'An entry containing additional management information applicable to a particular interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (305, '.1.3.6.1.2.1.31.1.1.1.1', 'ifName', 304, 'current', NULL, 'The textual name of the interface. The value of this object should be the name of the interface as assigned by the local device and should be suitable for use in commands entered at the device''s `console''. This might be a text name, such as `le0'' or a simple port number, such as `1'', depending on the interface naming syntax of the device. If several entries in the ifTable together represent a single interface as named by the device, then each will have the same value of ifName. Note that for an agent which responds to SNMP queries concerning an interface on some other (proxied) device, then the value of ifName for such an interface is the proxied device''s local name for it.  If there is no local name, or this object is otherwise not applicable, then this object contains a zero-length string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (306, '.1.3.6.1.2.1.31.1.1.1.2', 'ifInMulticastPkts', 304, 'current', NULL, 'The number of packets, delivered by this sub-layer to a higher (sub-)layer, which were addressed to a multicast address at this sub-layer. For a MAC layer protocol, this includes both Group and Functional addresses.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (307, '.1.3.6.1.2.1.31.1.1.1.3', 'ifInBroadcastPkts', 304, 'current', NULL, 'The number of packets, delivered by this sub-layer to a higher (sub-)layer, which were addressed to a broadcast address at this sub-layer.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (308, '.1.3.6.1.2.1.31.1.1.1.4', 'ifOutMulticastPkts', 304, 'current', NULL, 'The total number of packets that higher-level protocols requested be transmitted, and which were addressed to a multicast address at this sub-layer, including those that were discarded or not sent. For a MAC layer protocol, this includes both Group and Functional addresses.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (309, '.1.3.6.1.2.1.31.1.1.1.5', 'ifOutBroadcastPkts', 304, 'current', NULL, 'The total number of packets that higher-level protocols requested be transmitted, and which were addressed to a broadcast address at this sub-layer, including those that were discarded or not sent.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (310, '.1.3.6.1.2.1.31.1.1.1.6', 'ifHCInOctets', 304, 'current', NULL, 'The total number of octets received on the interface, including framing characters. This object is a 64-bit version of ifInOctets.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (311, '.1.3.6.1.2.1.31.1.1.1.7', 'ifHCInUcastPkts', 304, 'current', NULL, 'The number of packets, delivered by this sub-layer to a higher (sub-)layer, which were not addressed to a multicast or broadcast address at this sub-layer. This object is a 64-bit version of ifInUcastPkts.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (312, '.1.3.6.1.2.1.31.1.1.1.8', 'ifHCInMulticastPkts', 304, 'current', NULL, 'The number of packets, delivered by this sub-layer to a higher (sub-)layer, which were addressed to a multicast address at this sub-layer. For a MAC layer protocol, this includes both Group and Functional addresses. This object is a 64-bit version of ifInMulticastPkts.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (313, '.1.3.6.1.2.1.31.1.1.1.9', 'ifHCInBroadcastPkts', 304, 'current', NULL, 'The number of packets, delivered by this sub-layer to a higher (sub-)layer, which were addressed to a broadcast address at this sub-layer. This object is a 64-bit version of ifInBroadcastPkts.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (314, '.1.3.6.1.2.1.31.1.1.1.10', 'ifHCOutOctets', 304, 'current', NULL, 'The total number of octets transmitted out of the interface, including framing characters. This object is a 64-bit version of ifOutOctets.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (315, '.1.3.6.1.2.1.31.1.1.1.11', 'ifHCOutUcastPkts', 304, 'current', NULL, 'The total number of packets that higher-level protocols requested be transmitted, and which were not addressed to a multicast or broadcast address at this sub-layer, including those that were discarded or not sent. This object is a 64-bit version of ifOutUcastPkts.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (316, '.1.3.6.1.2.1.31.1.1.1.12', 'ifHCOutMulticastPkts', 304, 'current', NULL, 'The total number of packets that higher-level protocols requested be transmitted, and which were addressed to a multicast address at this sub-layer, including those that were discarded or not sent. For a MAC layer protocol, this includes both Group and Functional addresses. This object is a 64-bit version of ifOutMulticastPkts.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (317, '.1.3.6.1.2.1.31.1.1.1.13', 'ifHCOutBroadcastPkts', 304, 'current', NULL, 'The total number of packets that higher-level protocols requested be transmitted, and which were addressed to a broadcast address at this sub-layer, including those that were discarded or not sent. This object is a 64-bit version of ifOutBroadcastPkts.  Discontinuities in the value of this counter can occur at re-initialization of the management system, and at other times as indicated by the value of ifCounterDiscontinuityTime.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (318, '.1.3.6.1.2.1.31.1.1.1.14', 'ifLinkUpDownTrapEnable', 304, 'current', NULL, 'Indicates whether linkUp/linkDown traps should be generated for this interface.  By default, this object should have the value enabled(1) for interfaces which do not operate on ''top'' of any other interface (as defined in the ifStackTable), and disabled(2) otherwise.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (799, '.1.3.6.1.4.1.9.9.46.1.1', 'vtpStatus', 798, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1194, '.1.3.6.1.2.1.27.3.2.5', 'applRFC2788Compliance', 1189, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5533, '.1.3.6.1.4.1.9.9.84.3.2', 'ciscoIpStatMIBGroups', 5531, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (319, '.1.3.6.1.2.1.31.1.1.1.15', 'ifHighSpeed', 304, 'current', NULL, 'An estimate of the interface''s current bandwidth in units of 1,000,000 bits per second. If this object reports a value of `n'' then the speed of the interface is somewhere in the range of `n-500,000'' to `n+499,999''. For interfaces which do not vary in bandwidth or for those where no accurate estimation can be made, this object should contain the nominal bandwidth. For a sub-layer which has no concept of bandwidth, this object should be zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (320, '.1.3.6.1.2.1.31.1.1.1.16', 'ifPromiscuousMode', 304, 'current', NULL, 'This object has a value of false(2) if this interface only accepts packets/frames that are addressed to this station. This object has a value of true(1) when the station accepts all packets/frames transmitted on the media. The value true(1) is only legal on certain types of media. If legal, setting this object to a value of true(1) may require the interface to be reset before becoming effective.  The value of ifPromiscuousMode does not affect the reception of broadcast and multicast packets/frames by the interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (321, '.1.3.6.1.2.1.31.1.1.1.17', 'ifConnectorPresent', 304, 'current', NULL, 'This object has the value ''true(1)'' if the interface sublayer has a physical connector and the value ''false(2)'' otherwise.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (322, '.1.3.6.1.2.1.31.1.1.1.18', 'ifAlias', 304, 'current', NULL, 'This object is an ''alias'' name for the interface as specified by a network manager, and provides a non-volatile ''handle'' for the interface.  On the first instantiation of an interface, the value of ifAlias associated with that interface is the zero-length string. As and when a value is written into an instance of ifAlias through a network management set operation, then the agent must retain the supplied value in the ifAlias instance associated with the same interface for as long as that interface remains instantiated, including across all re- initializations/reboots of the network management system, including those which result in a change of the interface''s ifIndex value.  An example of the value which a network manager might store in this object for a WAN interface is the (Telco''s) circuit number/identifier of the interface.  Some agents may support write-access only for interfaces having particular values of ifType. An agent which supports write access to this object is required to keep the value in non-volatile storage, but it may limit the length of new values depending on how much storage is already occupied by the current values for other interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (323, '.1.3.6.1.2.1.31.1.1.1.19', 'ifCounterDiscontinuityTime', 304, 'current', NULL, 'The value of sysUpTime on the most recent occasion at which any one or more of this interface''s counters suffered a discontinuity. The relevant counters are the specific instances associated with this interface of any Counter32 or Counter64 object contained in the ifTable or ifXTable. If no such discontinuities have occurred since the last re- initialization of the local management subsystem, then this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (324, '.1.3.6.1.2.1.31.1.2', 'ifStackTable', 301, 'current', NULL, 'The table containing information on the relationships between the multiple sub-layers of network interfaces. In particular, it contains information on which sub-layers run ''on top of'' which other sub-layers, where each sub-layer corresponds to a conceptual row in the ifTable. For example, when the sub-layer with ifIndex value x runs over the sub-layer with ifIndex value y, then this table contains:  ifStackStatus.x.y=active  For each ifIndex value, I, which identifies an active interface, there are always at least two instantiated rows in this table associated with I. For one of these rows, I is the value of ifStackHigherLayer; for the other, I is the value of ifStackLowerLayer. (If I is not involved in multiplexing, then these are the only two rows associated with I.)  For example, two rows exist even for an interface which has no others stacked on top or below it:  ifStackStatus.0.x=active ifStackStatus.x.0=active', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (325, '.1.3.6.1.2.1.31.1.2.1', 'ifStackEntry', 324, 'current', NULL, 'Information on a particular relationship between two sub- layers, specifying that one sub-layer runs on ''top'' of the other sub-layer. Each sub-layer corresponds to a conceptual row in the ifTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (326, '.1.3.6.1.2.1.31.1.2.1.1', 'ifStackHigherLayer', 325, 'current', NULL, 'The value of ifIndex corresponding to the higher sub-layer of the relationship, i.e., the sub-layer which runs on ''top'' of the sub-layer identified by the corresponding instance of ifStackLowerLayer. If there is no higher sub-layer (below the internetwork layer), then this object has the value 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (327, '.1.3.6.1.2.1.31.1.2.1.2', 'ifStackLowerLayer', 325, 'current', NULL, 'The value of ifIndex corresponding to the lower sub-layer of the relationship, i.e., the sub-layer which runs ''below'' the sub-layer identified by the corresponding instance of ifStackHigherLayer. If there is no lower sub-layer, then this object has the value 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (328, '.1.3.6.1.2.1.31.1.2.1.3', 'ifStackStatus', 325, 'current', NULL, 'The status of the relationship between two sub-layers.  Changing the value of this object from ''active'' to ''notInService'' or ''destroy'' will likely have consequences up and down the interface stack. Thus, write access to this object is likely to be inappropriate for some types of interfaces, and many implementations will choose not to support write-access for any type of interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (329, '.1.3.6.1.2.1.31.1.6', 'ifStackLastChange', 301, 'current', NULL, 'The value of sysUpTime at the time of the last change of the (whole) interface stack. A change of the interface stack is defined to be any creation, deletion, or change in value of any instance of ifStackStatus. If the interface stack has been unchanged since the last re-initialization of the local network management subsystem, then this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (330, '.1.3.6.1.2.1.31.1.4', 'ifRcvAddressTable', 301, 'current', NULL, 'This table contains an entry for each address (broadcast, multicast, or uni-cast) for which the system will receive packets/frames on a particular interface, except as follows:  - for an interface operating in promiscuous mode, entries are only required for those addresses for which the system would receive frames were it not operating in promiscuous mode.  - for 802.5 functional addresses, only one entry is required, for the address which has the functional address bit ANDed with the bit mask of all functional addresses for which the interface will accept frames.  A system is normally able to use any unicast address which corresponds to an entry in this table as a source address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (331, '.1.3.6.1.2.1.31.1.4.1', 'ifRcvAddressEntry', 330, 'current', NULL, 'A list of objects identifying an address for which the system will accept packets/frames on the particular interface identified by the index value ifIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (332, '.1.3.6.1.2.1.31.1.4.1.1', 'ifRcvAddressAddress', 331, 'current', NULL, 'An address for which the system will accept packets/frames on this entry''s interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (333, '.1.3.6.1.2.1.31.1.4.1.2', 'ifRcvAddressStatus', 331, 'current', NULL, 'This object is used to create and delete rows in the ifRcvAddressTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (334, '.1.3.6.1.2.1.31.1.4.1.3', 'ifRcvAddressType', 331, 'current', NULL, 'This object has the value nonVolatile(3) for those entries in the table which are valid and will not be deleted by the next restart of the managed system. Entries having the value volatile(2) are valid and exist, but have not been saved, so that will not exist after the next restart of the managed system. Entries having the value other(1) are valid and exist but are not classified as to whether they will continue to exist after the next restart.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5129, '.1.3.6.1.4.1.9.9.692.1.1', 'cfmFlowMonitors', 5126, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (335, '.1.3.6.1.6.3.1.1.5.3', 'linkDown', 244, 'current', NULL, 'A linkDown trap signifies that the SNMP entity, acting in an agent role, has detected that the ifOperStatus object for one of its communication links is about to enter the down state from some other state (but not from the notPresent state). This other state is indicated by the included value of ifOperStatus.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (336, '.1.3.6.1.6.3.1.1.5.4', 'linkUp', 244, 'current', NULL, 'A linkUp trap signifies that the SNMP entity, acting in an agent role, has detected that the ifOperStatus object for one of its communication links left the down state and transitioned into some other state (but not into the notPresent state). This other state is indicated by the included value of ifOperStatus.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (337, '.1.3.6.1.2.1.31.2', 'ifConformance', 300, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (338, '.1.3.6.1.2.1.31.2.1', 'ifGroups', 337, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (339, '.1.3.6.1.2.1.31.2.2', 'ifCompliances', 337, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (340, '.1.3.6.1.2.1.31.2.2.3', 'ifCompliance3', 339, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (341, '.1.3.6.1.2.1.31.2.1.10', 'ifGeneralInformationGroup', 338, 'current', NULL, 'A collection of objects providing information applicable to all network interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (342, '.1.3.6.1.2.1.31.2.1.2', 'ifFixedLengthGroup', 338, 'current', NULL, 'A collection of objects providing information specific to non-high speed (non-high speed interfaces transmit and receive at speeds less than or equal to 20,000,000 bits/second) character-oriented or fixed-length-transmission network interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (343, '.1.3.6.1.2.1.31.2.1.3', 'ifHCFixedLengthGroup', 338, 'current', NULL, 'A collection of objects providing information specific to high speed (greater than 20,000,000 bits/second) character- oriented or fixed-length-transmission network interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (344, '.1.3.6.1.2.1.31.2.1.4', 'ifPacketGroup', 338, 'current', NULL, 'A collection of objects providing information specific to non-high speed (non-high speed interfaces transmit and receive at speeds less than or equal to 20,000,000 bits/second) packet-oriented network interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (345, '.1.3.6.1.2.1.31.2.1.5', 'ifHCPacketGroup', 338, 'current', NULL, 'A collection of objects providing information specific to high speed (greater than 20,000,000 bits/second but less than or equal to 650,000,000 bits/second) packet-oriented network interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (346, '.1.3.6.1.2.1.31.2.1.6', 'ifVHCPacketGroup', 338, 'current', NULL, 'A collection of objects providing information specific to higher speed (greater than 650,000,000 bits/second) packet- oriented network interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (347, '.1.3.6.1.2.1.31.2.1.7', 'ifRcvAddressGroup', 338, 'current', NULL, 'A collection of objects providing information on the multiple addresses which an interface receives.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (348, '.1.3.6.1.2.1.31.2.1.11', 'ifStackGroup2', 338, 'current', NULL, 'A collection of objects providing information on the layering of MIB-II interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (349, '.1.3.6.1.2.1.31.2.1.13', 'ifCounterDiscontinuityGroup', 338, 'current', NULL, 'A collection of objects providing information specific to interface counter discontinuities.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (350, '.1.3.6.1.2.1.31.2.1.14', 'linkUpDownNotificationsGroup', 338, 'current', NULL, 'The notifications which indicate specific changes in the value of ifOperStatus.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (351, '.1.3.6.1.2.1.31.1.3', 'ifTestTable', 301, 'deprecated', NULL, 'This table contains one entry per interface. It defines objects which allow a network manager to instruct an agent to test an interface for various faults. Tests for an interface are defined in the media-specific MIB for that interface. After invoking a test, the object ifTestResult can be read to determine the outcome. If an agent can not perform the test, ifTestResult is set to so indicate. The object ifTestCode can be used to provide further test- specific or interface-specific (or even enterprise-specific) information concerning the outcome of the test. Only one test can be in progress on each interface at any one time. If one test is in progress when another test is invoked, the second test is rejected. Some agents may reject a test when a prior test is active on another interface.  Before starting a test, a manager-station must first obtain ''ownership'' of the entry in the ifTestTable for the interface to be tested. This is accomplished with the ifTestId and ifTestStatus objects as follows:  try_again: get (ifTestId, ifTestStatus) while (ifTestStatus != notInUse) /* * Loop while a test is running or some other * manager is configuring a test. */ short delay get (ifTestId, ifTestStatus) }  /* * Is not being used right now * to see who gets it. */ lock_value = ifTestId  if ( set(ifTestId = lock_value, ifTestStatus = inUse,  ifTestOwner = ''my-IP-address'') == FAILURE) /* * Another manager got the ifTestEntry * try again */ goto try_again;  /* * I have the lock */ set up any test parameters.  /* * This starts the test */ set(ifTestType = test_to_run);  wait for test completion by polling ifTestResult  when test completes, agent sets ifTestResult agent also sets ifTestStatus = ''notInUse''  retrieve any additional test results, and ifTestId  if (ifTestId == lock_value+1) results are valid  A manager station first retrieves the value of the appropriate ifTestId and ifTestStatus objects, periodically repeating the retrieval if necessary, until the value of ifTestStatus is ''notInUse''. The manager station then tries to set the same ifTestId object to the value it just retrieved, the same ifTestStatus object to ''inUse'', and the corresponding ifTestOwner object to a value indicating itself. If the set operation succeeds then the manager has obtained ownership of the ifTestEntry, and the value of the ifTestId object is incremented by the agent (per the semantics of TestAndIncr). Failure of the set operation indicates that some other manager has obtained ownership of the ifTestEntry.  Once ownership is obtained, any test parameters can be setup, and then the test is initiated by setting ifTestType. On completion of the test, the agent sets ifTestStatus to ''notInUse''. Once this occurs, the manager can retrieve the results. In the (rare) event that the invocation of tests by two network managers were to overlap, then there would be a possibility that the first test''s results might be overwritten by the second test''s results prior to the first results being read. This unlikely circumstance can be detected by a network manager retrieving ifTestId at the same time as retrieving the test results, and ensuring that the results are for the desired request.  If ifTestType is not set within an abnormally long period of time after ownership is obtained, the agent should time-out the manager, and reset the value of the ifTestStatus object back to ''notInUse''. It is suggested that this time-out period be 5 minutes.  In general, a management station must not retransmit a request to invoke a test for which it does not receive a response; instead, it properly inspects an agent''s MIB to determine if the invocation was successful. Only if the invocation was unsuccessful, is the invocation request retransmitted.  Some tests may require the interface to be taken off-line in order to execute them, or may even require the agent to reboot after completion of the test. In these circumstances, communication with the management station invoking the test may be lost until after completion of the test. An agent is not required to support such tests. However, if such tests are supported, then the agent should make every effort to transmit a response to the request which invoked the test prior to losing communication. When the agent is restored to normal service, the results of the test are properly made available in the appropriate objects. Note that this requires that the ifIndex value assigned to an interface must be unchanged even if the test causes a reboot. An agent must reject any test for which it cannot, perhaps due to resource constraints, make available at least the minimum amount of information after that test completes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (352, '.1.3.6.1.2.1.31.1.3.1', 'ifTestEntry', 351, 'deprecated', NULL, 'An entry containing objects for invoking tests on an interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (353, '.1.3.6.1.2.1.31.1.3.1.1', 'ifTestId', 352, 'deprecated', NULL, 'This object identifies the current invocation of the interface''s test.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (354, '.1.3.6.1.2.1.31.1.3.1.2', 'ifTestStatus', 352, 'deprecated', NULL, 'This object indicates whether or not some manager currently has the necessary ''ownership'' required to invoke a test on this interface. A write to this object is only successful when it changes its value from ''notInUse(1)'' to ''inUse(2)''. After completion of a test, the agent resets the value back to ''notInUse(1)''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (355, '.1.3.6.1.2.1.31.1.3.1.3', 'ifTestType', 352, 'deprecated', NULL, 'A control variable used to start and stop operator- initiated interface tests. Most OBJECT IDENTIFIER values assigned to tests are defined elsewhere, in association with specific types of interface. However, this document assigns a value for a full-duplex loopback test, and defines the special meanings of the subject identifier:  noTest OBJECT IDENTIFIER ::= ( 0 0 )  When the value noTest is written to this object, no action is taken unless a test is in progress, in which case the test is aborted. Writing any other value to this object is only valid when no test is currently in progress, in which case the indicated test is initiated.  When read, this object always returns the most recent value that ifTestType was set to. If it has not been set since the last initialization of the network management subsystem on the agent, a value of noTest is returned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (356, '.1.3.6.1.2.1.31.1.3.1.4', 'ifTestResult', 352, 'deprecated', NULL, 'This object contains the result of the most recently requested test, or the value none(1) if no tests have been requested since the last reset. Note that this facility provides no provision for saving the results of one test when starting another, as could be required if used by multiple managers concurrently.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (357, '.1.3.6.1.2.1.31.1.3.1.5', 'ifTestCode', 352, 'deprecated', NULL, 'This object contains a code which contains more specific information on the test result, for example an error-code after a failed test. Error codes and other values this object may take are specific to the type of interface and/or test. The value may have the semantics of either the AutonomousType or InstancePointer textual conventions as defined in RFC 2579. The identifier:  testCodeUnknown OBJECT IDENTIFIER ::= ( 0 0 )  is defined for use if no additional result code is available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (358, '.1.3.6.1.2.1.31.1.3.1.6', 'ifTestOwner', 352, 'deprecated', NULL, 'The entity which currently has the ''ownership'' required to invoke a test on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (359, '.1.3.6.1.2.1.31.2.1.1', 'ifGeneralGroup', 338, 'deprecated', NULL, 'A collection of objects deprecated in favour of ifGeneralInformationGroup.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (360, '.1.3.6.1.2.1.31.2.1.8', 'ifTestGroup', 338, 'deprecated', NULL, 'A collection of objects providing the ability to invoke tests on an interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (361, '.1.3.6.1.2.1.31.2.1.9', 'ifStackGroup', 338, 'deprecated', NULL, 'The previous collection of objects providing information on the layering of MIB-II interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (362, '.1.3.6.1.2.1.31.2.1.12', 'ifOldObjectsGroup', 338, 'deprecated', NULL, 'The collection of objects deprecated from the original MIB- II interfaces group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (363, '.1.3.6.1.2.1.31.2.2.1', 'ifCompliance', 339, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (364, '.1.3.6.1.2.1.31.2.2.2', 'ifCompliance2', 339, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (365, '.1.3.6.1.6.3.10', 'snmpFrameworkMIB', 30, 'current', NULL, 'The SNMP Management Architecture MIB  Copyright (C) The Internet Society (2002). This version of this MIB module is part of RFC 3411; see the RFC itself for full legal notices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (366, '.1.3.6.1.6.3.10.1', 'snmpFrameworkAdmin', 365, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (367, '.1.3.6.1.6.3.10.2', 'snmpFrameworkMIBObjects', 365, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (368, '.1.3.6.1.6.3.10.3', 'snmpFrameworkMIBConformance', 365, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (369, '.1.3.6.1.6.3.10.2.1', 'snmpEngine', 367, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (943, '.1.3.6.1.4.1.9.9.23.1.1.1', 'cdpInterfaceTable', 940, 'current', NULL, 'The (conceptual) table containing the status of CDP on the device''s interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5405, '.1.3.6.1.4.1.9.9.703.2.1', 'ciscoRtpMetricsMIBCompliances', 5351, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (370, '.1.3.6.1.6.3.10.2.1.1', 'snmpEngineID', 369, 'current', NULL, 'An SNMP engine''s administratively-unique identifier.  This information SHOULD be stored in non-volatile storage so that it remains constant across re-initializations of the SNMP engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (371, '.1.3.6.1.6.3.10.2.1.2', 'snmpEngineBoots', 369, 'current', NULL, 'The number of times that the SNMP engine has (re-)initialized itself since snmpEngineID was last configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (372, '.1.3.6.1.6.3.10.2.1.3', 'snmpEngineTime', 369, 'current', NULL, 'The number of seconds since the value of the snmpEngineBoots object last changed. When incrementing this object''s value would cause it to exceed its maximum, snmpEngineBoots is incremented as if a re-initialization had occurred, and this object''s value consequently reverts to zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (373, '.1.3.6.1.6.3.10.2.1.4', 'snmpEngineMaxMessageSize', 369, 'current', NULL, 'The maximum length in octets of an SNMP message which this SNMP engine can send or receive and process, determined as the minimum of the maximum message size values supported among all of the transports available to and supported by the engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (374, '.1.3.6.1.6.3.10.1.1', 'snmpAuthProtocols', 366, 'current', NULL, 'Registration point for standards-track authentication protocols used in SNMP Management Frameworks.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (375, '.1.3.6.1.6.3.10.1.2', 'snmpPrivProtocols', 366, 'current', NULL, 'Registration point for standards-track privacy protocols used in SNMP Management Frameworks.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (376, '.1.3.6.1.6.3.10.3.1', 'snmpFrameworkMIBCompliances', 368, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (377, '.1.3.6.1.6.3.10.3.2', 'snmpFrameworkMIBGroups', 368, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (378, '.1.3.6.1.6.3.10.3.1.1', 'snmpFrameworkMIBCompliance', 376, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (379, '.1.3.6.1.6.3.10.3.2.1', 'snmpEngineGroup', 377, 'current', NULL, 'A collection of objects for identifying and determining the configuration and current timeliness   values of an SNMP engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (380, '.1.3.6.1.2.1.16', 'rmon', 21, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (381, '.1.3.6.1.2.1.16.1', 'statistics', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (382, '.1.3.6.1.2.1.16.2', 'history', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (383, '.1.3.6.1.2.1.16.3', 'alarm', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (384, '.1.3.6.1.2.1.16.4', 'hosts', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (385, '.1.3.6.1.2.1.16.5', 'hostTopN', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (386, '.1.3.6.1.2.1.16.6', 'matrix', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (387, '.1.3.6.1.2.1.16.7', 'filter', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (388, '.1.3.6.1.2.1.16.8', 'capture', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (389, '.1.3.6.1.2.1.16.9', 'event', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (390, '.1.3.6.1.2.1.16.1.1', 'etherStatsTable', 381, 'mandatory', NULL, 'A list of Ethernet statistics entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (391, '.1.3.6.1.2.1.16.1.1.1', 'etherStatsEntry', 390, 'mandatory', NULL, 'A collection of statistics kept for a particular Ethernet interface. As an example, an instance of the etherStatsPkts object might be named etherStatsPkts.1', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (392, '.1.3.6.1.2.1.16.1.1.1.1', 'etherStatsIndex', 391, 'mandatory', NULL, 'The value of this object uniquely identifies this etherStats entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (393, '.1.3.6.1.2.1.16.1.1.1.2', 'etherStatsDataSource', 391, 'mandatory', NULL, 'This object identifies the source of the data that this etherStats entry is configured to analyze. This source can be any ethernet interface on this device. In order to identify a particular interface, this object shall identify the instance of the ifIndex object, defined in RFC 1213 and RFC 1573 [4,6], for the desired interface. For example, if an entry were to receive data from interface #1, this object would be set to ifIndex.1.  The statistics in this group reflect all packets on the local network segment attached to the identified interface.  An agent may or may not be able to tell if fundamental changes to the media of the interface have occurred and necessitate an invalidation of this entry. For example, a hot-pluggable ethernet card could be pulled out and replaced by a token-ring card. In such a case, if the agent has such knowledge of the change, it is recommended that it invalidate this entry.  This object may not be modified if the associated etherStatsStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (394, '.1.3.6.1.2.1.16.1.1.1.3', 'etherStatsDropEvents', 391, 'mandatory', NULL, 'The total number of events in which packets were dropped by the probe due to lack of resources. Note that this number is not necessarily the number of packets dropped; it is just the number of times this condition has been detected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (395, '.1.3.6.1.2.1.16.1.1.1.4', 'etherStatsOctets', 391, 'mandatory', NULL, 'The total number of octets of data (including those in bad packets) received on the network (excluding framing bits but including FCS octets).  This object can be used as a reasonable estimate of ethernet utilization. If greater precision is desired, the etherStatsPkts and etherStatsOctets objects should be sampled before and after a common interval. The differences in the sampled values are Pkts and Octets, respectively, and the number of seconds in the interval is Interval. These values are used to calculate the Utilization as follows:  Pkts * (9.6 + 6.4) + (Octets * .8) Utilization = --------------------------------- Interval * 10,000  The result of this equation is the value Utilization which is the percent utilization of the ethernet segment on a scale of 0 to 100 percent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (396, '.1.3.6.1.2.1.16.1.1.1.5', 'etherStatsPkts', 391, 'mandatory', NULL, 'The total number of packets (including bad packets, broadcast packets, and multicast packets) received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (397, '.1.3.6.1.2.1.16.1.1.1.6', 'etherStatsBroadcastPkts', 391, 'mandatory', NULL, 'The total number of good packets received that were directed to the broadcast address. Note that this does not include multicast packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (398, '.1.3.6.1.2.1.16.1.1.1.7', 'etherStatsMulticastPkts', 391, 'mandatory', NULL, 'The total number of good packets received that were directed to a multicast address. Note that this number does not include packets directed to the broadcast address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (399, '.1.3.6.1.2.1.16.1.1.1.8', 'etherStatsCRCAlignErrors', 391, 'mandatory', NULL, 'The total number of packets received that had a length (excluding framing bits, but including FCS octets) of between 64 and 1518 octets, inclusive, but but had either a bad Frame Check Sequence (FCS) with an integral number of octets (FCS Error) or a bad FCS with a non-integral number of octets (Alignment Error).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (400, '.1.3.6.1.2.1.16.1.1.1.9', 'etherStatsUndersizePkts', 391, 'mandatory', NULL, 'The total number of packets received that were less than 64 octets long (excluding framing bits, but including FCS octets) and were otherwise well formed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (401, '.1.3.6.1.2.1.16.1.1.1.10', 'etherStatsOversizePkts', 391, 'mandatory', NULL, 'The total number of packets received that were longer than 1518 octets (excluding framing bits, but including FCS octets) and were otherwise well formed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (402, '.1.3.6.1.2.1.16.1.1.1.11', 'etherStatsFragments', 391, 'mandatory', NULL, 'The total number of packets received that were less than 64 octets in length (excluding framing bits but including FCS octets) and had either a bad Frame Check Sequence (FCS) with an integral number of octets (FCS Error) or a bad FCS with a non-integral number of octets (Alignment Error).  Note that it is entirely normal for etherStatsFragments to increment. This is because it counts both runts (which are normal occurrences due to collisions) and noise hits.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (944, '.1.3.6.1.4.1.9.9.23.1.1.1.1', 'cdpInterfaceEntry', 943, 'current', NULL, 'An entry (conceptual row) in the cdpInterfaceTable, containing the status of CDP on an interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5406, '.1.3.6.1.4.1.9.9.703.2.2', 'ciscoRtpMetricsMIBGroups', 5351, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (403, '.1.3.6.1.2.1.16.1.1.1.12', 'etherStatsJabbers', 391, 'mandatory', NULL, 'The total number of packets received that were longer than 1518 octets (excluding framing bits, but including FCS octets), and had either a bad Frame Check Sequence (FCS) with an integral number of octets (FCS Error) or a bad FCS with a non-integral number of octets (Alignment Error).  Note that this definition of jabber is different than the definition in IEEE-802.3 section 8.2.1.5 (10BASE5) and section 10.3.1.4 (10BASE2). These documents define jabber as the condition where any packet exceeds 20 ms. The allowed range to detect jabber is between 20 ms and 150 ms.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (404, '.1.3.6.1.2.1.16.1.1.1.13', 'etherStatsCollisions', 391, 'mandatory', NULL, 'The best estimate of the total number of collisions on this Ethernet segment.  The value returned will depend on the location of the RMON probe. Section 8.2.1.3 (10BASE-5) and section 10.3.1.3 (10BASE-2) of IEEE standard 802.3 states that a station must detect a collision, in the receive mode, if three or more stations are transmitting simultaneously. A repeater port must detect a collision when two or more stations are transmitting simultaneously. Thus a probe placed on a repeater port could record more collisions than a probe connected to a station on the same segment would.  Probe location plays a much smaller role when considering 10BASE-T. 14.2.1.4 (10BASE-T) of IEEE standard 802.3 defines a collision as the simultaneous presence of signals on the DO and RD circuits (transmitting and receiving at the same time). A 10BASE-T station can only detect collisions when it is transmitting. Thus probes placed on a station and a repeater, should report the same number of collisions.  Note also that an RMON probe inside a repeater should ideally report collisions between the repeater and one or more other hosts (transmit collisions as defined by IEEE 802.3k) plus receiver collisions observed on any coax segments to which the repeater is connected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (405, '.1.3.6.1.2.1.16.1.1.1.14', 'etherStatsPkts64Octets', 391, 'mandatory', NULL, 'The total number of packets (including bad packets) received that were 64 octets in length (excluding framing bits but including FCS octets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (406, '.1.3.6.1.2.1.16.1.1.1.15', 'etherStatsPkts65to127Octets', 391, 'mandatory', NULL, 'The total number of packets (including bad packets) received that were between 65 and 127 octets in length inclusive (excluding framing bits but including FCS octets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (407, '.1.3.6.1.2.1.16.1.1.1.16', 'etherStatsPkts128to255Octets', 391, 'mandatory', NULL, 'The total number of packets (including bad packets) received that were between 128 and 255 octets in length inclusive (excluding framing bits but including FCS octets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (408, '.1.3.6.1.2.1.16.1.1.1.17', 'etherStatsPkts256to511Octets', 391, 'mandatory', NULL, 'The total number of packets (including bad packets) received that were between 256 and 511 octets in length inclusive (excluding framing bits but including FCS octets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (409, '.1.3.6.1.2.1.16.1.1.1.18', 'etherStatsPkts512to1023Octets', 391, 'mandatory', NULL, 'The total number of packets (including bad packets) received that were between 512 and 1023 octets in length inclusive (excluding framing bits but including FCS octets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (410, '.1.3.6.1.2.1.16.1.1.1.19', 'etherStatsPkts1024to1518Octets', 391, 'mandatory', NULL, 'The total number of packets (including bad packets) received that were between 1024 and 1518 octets in length inclusive (excluding framing bits but including FCS octets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (411, '.1.3.6.1.2.1.16.1.1.1.20', 'etherStatsOwner', 391, 'mandatory', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (412, '.1.3.6.1.2.1.16.1.1.1.21', 'etherStatsStatus', 391, 'mandatory', NULL, 'The status of this etherStats entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (413, '.1.3.6.1.2.1.16.2.1', 'historyControlTable', 382, 'mandatory', NULL, 'A list of history control entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (414, '.1.3.6.1.2.1.16.2.1.1', 'historyControlEntry', 413, 'mandatory', NULL, 'A list of parameters that set up a periodic sampling of statistics. As an example, an instance of the historyControlInterval object might be named historyControlInterval.2', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (415, '.1.3.6.1.2.1.16.2.1.1.1', 'historyControlIndex', 414, 'mandatory', NULL, 'An index that uniquely identifies an entry in the historyControl table. Each such entry defines a set of samples at a particular interval for an interface on the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (416, '.1.3.6.1.2.1.16.2.1.1.2', 'historyControlDataSource', 414, 'mandatory', NULL, 'This object identifies the source of the data for which historical data was collected and placed in a media-specific table on behalf of this historyControlEntry. This source can be any interface on this device. In order to identify a particular interface, this object shall identify the instance of the ifIndex object, defined in RFC 1213 and RFC 1573 [4,6], for the desired interface. For example, if an entry were to receive data from interface #1, this object would be set to ifIndex.1.  The statistics in this group reflect all packets on the local network segment attached to the identified interface.  An agent may or may not be able to tell if fundamental changes to the media of the interface have occurred and necessitate an invalidation of this entry. For example, a hot-pluggable ethernet card could be pulled out and replaced by a token-ring card. In such a case, if the agent has such knowledge of the change, it is recommended that it invalidate this entry.  This object may not be modified if the associated historyControlStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (417, '.1.3.6.1.2.1.16.2.1.1.3', 'historyControlBucketsRequested', 414, 'mandatory', NULL, 'The requested number of discrete time intervals over which data is to be saved in the part of the media-specific table associated with this historyControlEntry.  When this object is created or modified, the probe should set historyControlBucketsGranted as closely to this object as is possible for the particular probe implementation and available resources.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (418, '.1.3.6.1.2.1.16.2.1.1.4', 'historyControlBucketsGranted', 414, 'mandatory', NULL, 'The number of discrete sampling intervals over which data shall be saved in the part of the media-specific table associated with this historyControlEntry.  When the associated historyControlBucketsRequested object is created or modified, the probe should set this object as closely to the requested value as is possible for the particular probe implementation and available resources. The probe must not lower this value except as a result of a modification to the associated historyControlBucketsRequested object.  There will be times when the actual number of buckets associated with this entry is less than the value of this object. In this case, at the end of each sampling interval, a new bucket will be added to the media-specific table.  When the number of buckets reaches the value of this object and a new bucket is to be added to the media-specific table, the oldest bucket associated with this historyControlEntry shall be deleted by the agent so that the new bucket can be added.  When the value of this object changes to a value less than the current value, entries are deleted from the media-specific table associated with this historyControlEntry. Enough of the oldest of these entries shall be deleted by the agent so that their number remains less than or equal to the new value of this object.  When the value of this object changes to a value greater than the current value, the number of associated media- specific entries may be allowed to grow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1000, '.1.3.6.1.4.1.9.9.13', 'ciscoEnvMonMIB', 272, 'current', NULL, 'The MIB module to describe the status of the Environmental Monitor on those devices which support one.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5407, '.1.3.6.1.4.1.9.9.703.2.1.1', 'ciscoRtpMetricsCompliance01', 5405, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (419, '.1.3.6.1.2.1.16.2.1.1.5', 'historyControlInterval', 414, 'mandatory', NULL, 'The interval in seconds over which the data is sampled for each bucket in the part of the media-specific table associated with this historyControlEntry. This interval can be set to any number of seconds between 1 and 3600 (1 hour).  Because the counters in a bucket may overflow at their maximum value with no indication, a prudent manager will take into account the possibility of overflow in any of the associated counters. It is important to consider the minimum time in which any counter could overflow on a particular media type and set the historyControlInterval object to a value less than this interval. This is typically most important for the ''octets'' counter in any media-specific table. For example, on an Ethernet network, the etherHistoryOctets counter could overflow in about one hour at the Ethernet''s maximum utilization.  This object may not be modified if the associated historyControlStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (420, '.1.3.6.1.2.1.16.2.1.1.6', 'historyControlOwner', 414, 'mandatory', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (421, '.1.3.6.1.2.1.16.2.1.1.7', 'historyControlStatus', 414, 'mandatory', NULL, 'The status of this historyControl entry.  Each instance of the media-specific table associated with this historyControlEntry will be deleted by the agent if this historyControlEntry is not equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (422, '.1.3.6.1.2.1.16.2.2', 'etherHistoryTable', 382, 'mandatory', NULL, 'A list of Ethernet history entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (423, '.1.3.6.1.2.1.16.2.2.1', 'etherHistoryEntry', 422, 'mandatory', NULL, 'An historical sample of Ethernet statistics on a particular Ethernet interface. This sample is associated with the historyControlEntry which set up the parameters for a regular collection of these samples. As an example, an instance of the etherHistoryPkts object might be named etherHistoryPkts.2.89', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (424, '.1.3.6.1.2.1.16.2.2.1.1', 'etherHistoryIndex', 423, 'mandatory', NULL, 'The history of which this entry is a part. The history identified by a particular value of this index is the same history as identified by the same value of historyControlIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (425, '.1.3.6.1.2.1.16.2.2.1.2', 'etherHistorySampleIndex', 423, 'mandatory', NULL, 'An index that uniquely identifies the particular sample this entry represents among all samples associated with the same historyControlEntry. This index starts at 1 and increases by one as each new sample is taken.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (426, '.1.3.6.1.2.1.16.2.2.1.3', 'etherHistoryIntervalStart', 423, 'mandatory', NULL, 'The value of sysUpTime at the start of the interval over which this sample was measured. If the probe keeps track of the time of day, it should start the first sample of the history at a time such that when the next hour of the day begins, a sample is started at that instant. Note that following this rule may require the probe to delay collecting the first sample of the history, as each sample must be of the same interval. Also note that the sample which is currently being collected is not accessible in this table until the end of its interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (427, '.1.3.6.1.2.1.16.2.2.1.4', 'etherHistoryDropEvents', 423, 'mandatory', NULL, 'The total number of events in which packets were dropped by the probe due to lack of resources during this sampling interval. Note that this number is not necessarily the number of packets dropped, it is just the number of times this condition has been detected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (428, '.1.3.6.1.2.1.16.2.2.1.5', 'etherHistoryOctets', 423, 'mandatory', NULL, 'The total number of octets of data (including those in bad packets) received on the network (excluding framing bits but including FCS octets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (429, '.1.3.6.1.2.1.16.2.2.1.6', 'etherHistoryPkts', 423, 'mandatory', NULL, 'The number of packets (including bad packets) received during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (430, '.1.3.6.1.2.1.16.2.2.1.7', 'etherHistoryBroadcastPkts', 423, 'mandatory', NULL, 'The number of good packets received during this sampling interval that were directed to the broadcast address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (431, '.1.3.6.1.2.1.16.2.2.1.8', 'etherHistoryMulticastPkts', 423, 'mandatory', NULL, 'The number of good packets received during this sampling interval that were directed to a multicast address. Note that this number does not include packets addressed to the broadcast address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (432, '.1.3.6.1.2.1.16.2.2.1.9', 'etherHistoryCRCAlignErrors', 423, 'mandatory', NULL, 'The number of packets received during this sampling interval that had a length (excluding framing bits but including FCS octets) between 64 and 1518 octets, inclusive, but had either a bad Frame Check Sequence (FCS) with an integral number of octets (FCS Error) or a bad FCS with a non-integral number of octets (Alignment Error).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (433, '.1.3.6.1.2.1.16.2.2.1.10', 'etherHistoryUndersizePkts', 423, 'mandatory', NULL, 'The number of packets received during this sampling interval that were less than 64 octets long (excluding framing bits but including FCS octets) and were otherwise well formed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (434, '.1.3.6.1.2.1.16.2.2.1.11', 'etherHistoryOversizePkts', 423, 'mandatory', NULL, 'The number of packets received during this sampling interval that were longer than 1518 octets (excluding framing bits but including FCS octets) but were otherwise well formed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (435, '.1.3.6.1.2.1.16.2.2.1.12', 'etherHistoryFragments', 423, 'mandatory', NULL, 'The total number of packets received during this sampling interval that were less than 64 octets in length (excluding framing bits but including FCS octets) had either a bad Frame Check Sequence (FCS) with an integral number of octets (FCS Error) or a bad FCS with a non-integral number of octets (Alignment Error).  Note that it is entirely normal for etherHistoryFragments to increment. This is because it counts both runts (which are normal occurrences due to collisions) and noise hits.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (436, '.1.3.6.1.2.1.16.2.2.1.13', 'etherHistoryJabbers', 423, 'mandatory', NULL, 'The number of packets received during this sampling interval that were longer than 1518 octets (excluding framing bits but including FCS octets), and had either a bad Frame Check Sequence (FCS) with an integral number of octets (FCS Error) or a bad FCS with a non-integral number of octets (Alignment Error).  Note that this definition of jabber is different than the definition in IEEE-802.3 section 8.2.1.5 (10BASE5) and section 10.3.1.4 (10BASE2). These documents define jabber as the condition where any packet exceeds 20 ms. The allowed range to detect jabber is between 20 ms and 150 ms.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (449, '.1.3.6.1.2.1.16.3.1.1.9', 'alarmRisingEventIndex', 440, 'mandatory', NULL, 'The index of the eventEntry that is used when a rising threshold is crossed. The eventEntry identified by a particular value of this index is the same as identified by the same value of the eventIndex object. If there is no corresponding entry in the eventTable, then no association exists. In particular, if this value is zero, no associated event will be generated, as zero is not a valid event index.  This object may not be modified if the associated alarmStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (450, '.1.3.6.1.2.1.16.3.1.1.10', 'alarmFallingEventIndex', 440, 'mandatory', NULL, 'The index of the eventEntry that is used when a falling threshold is crossed. The eventEntry identified by a particular value of this index is the same as identified by the same value of the eventIndex object. If there is no corresponding entry in the eventTable, then no association exists. In particular, if this value is zero, no associated event will be generated, as zero is not a valid event index.  This object may not be modified if the associated alarmStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (437, '.1.3.6.1.2.1.16.2.2.1.14', 'etherHistoryCollisions', 423, 'mandatory', NULL, 'The best estimate of the total number of collisions on this Ethernet segment during this sampling interval.  The value returned will depend on the location of the RMON probe. Section 8.2.1.3 (10BASE-5) and section 10.3.1.3 (10BASE-2) of IEEE standard 802.3 states that a station must detect a collision, in the receive mode, if three or more stations are transmitting simultaneously. A repeater port must detect a collision when two or more stations are transmitting simultaneously. Thus a probe placed on a repeater port could record more collisions than a probe connected to a station on the same segment would.  Probe location plays a much smaller role when considering 10BASE-T. 14.2.1.4 (10BASE-T) of IEEE standard 802.3 defines a collision as the simultaneous presence of signals on the DO and RD circuits (transmitting and receiving at the same time). A 10BASE-T station can only detect collisions when it is transmitting. Thus probes placed on a station and a repeater, should report the same number of collisions.  Note also that an RMON probe inside a repeater should ideally report collisions between the repeater and one or more other hosts (transmit collisions as defined by IEEE 802.3k) plus receiver collisions observed on any coax segments to which the repeater is connected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (438, '.1.3.6.1.2.1.16.2.2.1.15', 'etherHistoryUtilization', 423, 'mandatory', NULL, 'The best estimate of the mean physical layer network utilization on this interface during this sampling interval, in hundredths of a percent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (439, '.1.3.6.1.2.1.16.3.1', 'alarmTable', 383, 'mandatory', NULL, 'A list of alarm entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (440, '.1.3.6.1.2.1.16.3.1.1', 'alarmEntry', 439, 'mandatory', NULL, 'A list of parameters that set up a periodic checking for alarm conditions. For example, an instance of the alarmValue object might be named alarmValue.8', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (441, '.1.3.6.1.2.1.16.3.1.1.1', 'alarmIndex', 440, 'mandatory', NULL, 'An index that uniquely identifies an entry in the alarm table. Each such entry defines a diagnostic sample at a particular interval for an object on the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (442, '.1.3.6.1.2.1.16.3.1.1.2', 'alarmInterval', 440, 'mandatory', NULL, 'The interval in seconds over which the data is sampled and compared with the rising and falling thresholds. When setting this variable, care should be taken in the case of deltaValue sampling - the interval should be set short enough that the sampled variable is very unlikely to increase or decrease by more than 2^31 - 1 during a single sampling interval.  This object may not be modified if the associated alarmStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (443, '.1.3.6.1.2.1.16.3.1.1.3', 'alarmVariable', 440, 'mandatory', NULL, 'The object identifier of the particular variable to be sampled. Only variables that resolve to an ASN.1 primitive type of INTEGER (INTEGER, Counter, Gauge, or TimeTicks) may be sampled.  Because SNMP access control is articulated entirely in terms of the contents of MIB views, no access control mechanism exists that can restrict the value of this object to identify only those objects that exist in a particular MIB view. Because there is thus no acceptable means of restricting the read access that could be obtained through the alarm mechanism, the probe must only grant write access to this object in those views that have read access to all objects on the probe.  During a set operation, if the supplied variable name is not available in the selected MIB view, a badValue error must be returned. If at any time the variable name of an established alarmEntry is no longer available in the selected MIB view, the probe must change the status of this alarmEntry to invalid(4).  This object may not be modified if the associated alarmStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (444, '.1.3.6.1.2.1.16.3.1.1.4', 'alarmSampleType', 440, 'mandatory', NULL, 'The method of sampling the selected variable and calculating the value to be compared against the thresholds. If the value of this object is absoluteValue(1), the value of the selected variable will be compared directly with the thresholds at the end of the sampling interval. If the value of this object is deltaValue(2), the value of the selected variable at the last sample will be subtracted from the current value, and the difference compared with the thresholds.  This object may not be modified if the associated alarmStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (445, '.1.3.6.1.2.1.16.3.1.1.5', 'alarmValue', 440, 'mandatory', NULL, 'The value of the statistic during the last sampling period. For example, if the sample type is deltaValue, this value will be the difference between the samples at the beginning and end of the period. If the sample type is absoluteValue, this value will be the sampled value at the end of the period.  This is the value that is compared with the rising and falling thresholds.  The value during the current sampling period is not made available until the period is completed and will remain available until the next period completes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (446, '.1.3.6.1.2.1.16.3.1.1.6', 'alarmStartupAlarm', 440, 'mandatory', NULL, 'The alarm that may be sent when this entry is first set to valid. If the first sample after this entry becomes valid is greater than or equal to the risingThreshold and alarmStartupAlarm is equal to risingAlarm(1) or risingOrFallingAlarm(3), then a single rising alarm will be generated. If the first sample after this entry becomes valid is less than or equal to the fallingThreshold and alarmStartupAlarm is equal to fallingAlarm(2) or risingOrFallingAlarm(3), then a single falling alarm will be generated.  This object may not be modified if the associated alarmStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (447, '.1.3.6.1.2.1.16.3.1.1.7', 'alarmRisingThreshold', 440, 'mandatory', NULL, 'A threshold for the sampled statistic. When the current sampled value is greater than or equal to this threshold, and the value at the last sampling interval was less than this threshold, a single event will be generated. A single event will also be generated if the first sample after this entry becomes valid is greater than or equal to this threshold and the associated alarmStartupAlarm is equal to risingAlarm(1) or risingOrFallingAlarm(3).  After a rising event is generated, another such event will not be generated until the sampled value falls below this threshold and reaches the alarmFallingThreshold.  This object may not be modified if the associated alarmStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (448, '.1.3.6.1.2.1.16.3.1.1.8', 'alarmFallingThreshold', 440, 'mandatory', NULL, 'A threshold for the sampled statistic. When the current sampled value is less than or equal to this threshold, and the value at the last sampling interval was greater than this threshold, a single event will be generated. A single event will also be generated if the first sample after this entry becomes valid is less than or equal to this threshold and the associated alarmStartupAlarm is equal to fallingAlarm(2) or risingOrFallingAlarm(3).  After a falling event is generated, another such event will not be generated until the sampled value rises above this threshold and reaches the alarmRisingThreshold.  This object may not be modified if the associated alarmStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (451, '.1.3.6.1.2.1.16.3.1.1.11', 'alarmOwner', 440, 'mandatory', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (452, '.1.3.6.1.2.1.16.3.1.1.12', 'alarmStatus', 440, 'mandatory', NULL, 'The status of this alarm entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (453, '.1.3.6.1.2.1.16.4.1', 'hostControlTable', 384, 'mandatory', NULL, 'A list of host table control entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1001, '.1.3.6.1.4.1.9.9.13.1', 'ciscoEnvMonObjects', 1000, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5537, '.1.3.6.1.4.1.9.9.168.1', 'ciscoNtpMIBObjects', 5536, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (454, '.1.3.6.1.2.1.16.4.1.1', 'hostControlEntry', 453, 'mandatory', NULL, 'A list of parameters that set up the discovery of hosts on a particular interface and the collection of statistics about these hosts. For example, an instance of the hostControlTableSize object might be named hostControlTableSize.1', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (455, '.1.3.6.1.2.1.16.4.1.1.1', 'hostControlIndex', 454, 'mandatory', NULL, 'An index that uniquely identifies an entry in the hostControl table. Each such entry defines a function that discovers hosts on a particular interface and places statistics about them in the hostTable and the hostTimeTable on behalf of this hostControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (456, '.1.3.6.1.2.1.16.4.1.1.2', 'hostControlDataSource', 454, 'mandatory', NULL, 'This object identifies the source of the data for this instance of the host function. This source can be any interface on this device. In order to identify a particular interface, this object shall identify the instance of the ifIndex object, defined in RFC 1213 and RFC 1573 [4,6], for the desired interface. For example, if an entry were to receive data from interface #1, this object would be set to ifIndex.1.  The statistics in this group reflect all packets on the local network segment attached to the identified interface.  An agent may or may not be able to tell if fundamental changes to the media of the interface have occurred and necessitate an invalidation of this entry. For example, a hot-pluggable ethernet card could be pulled out and replaced by a token-ring card. In such a case, if the agent has such knowledge of the change, it is recommended that it invalidate this entry.  This object may not be modified if the associated hostControlStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (457, '.1.3.6.1.2.1.16.4.1.1.3', 'hostControlTableSize', 454, 'mandatory', NULL, 'The number of hostEntries in the hostTable and the hostTimeTable associated with this hostControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (458, '.1.3.6.1.2.1.16.4.1.1.4', 'hostControlLastDeleteTime', 454, 'mandatory', NULL, 'The value of sysUpTime when the last entry was deleted from the portion of the hostTable associated with this hostControlEntry. If no deletions have occurred, this value shall be zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (459, '.1.3.6.1.2.1.16.4.1.1.5', 'hostControlOwner', 454, 'mandatory', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (460, '.1.3.6.1.2.1.16.4.1.1.6', 'hostControlStatus', 454, 'mandatory', NULL, 'The status of this hostControl entry.  If this object is not equal to valid(1), all associated entries in the hostTable, hostTimeTable, and the hostTopNTable shall be deleted by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (461, '.1.3.6.1.2.1.16.4.2', 'hostTable', 384, 'mandatory', NULL, 'A list of host entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (462, '.1.3.6.1.2.1.16.4.2.1', 'hostEntry', 461, 'mandatory', NULL, 'A collection of statistics for a particular host that has been discovered on an interface of this device. For example, an instance of the hostOutBroadcastPkts object might be named hostOutBroadcastPkts.1.6.8.0.32.27.3.176', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (463, '.1.3.6.1.2.1.16.4.2.1.1', 'hostAddress', 462, 'mandatory', NULL, 'The physical address of this host.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (464, '.1.3.6.1.2.1.16.4.2.1.2', 'hostCreationOrder', 462, 'mandatory', NULL, 'An index that defines the relative ordering of the creation time of hosts captured for a particular hostControlEntry. This index shall be between 1 and N, where N is the value of the associated hostControlTableSize. The ordering of the indexes is based on the order of each entry''s insertion into the table, in which entries added earlier have a lower index value than entries added later.  It is important to note that the order for a particular entry may change as an (earlier) entry is deleted from the table. Because this order may change, management stations should make use of the hostControlLastDeleteTime variable in the hostControlEntry associated with the relevant portion of the hostTable. By observing this variable, the management station may detect the circumstances where a previous association between a value of hostCreationOrder and a hostEntry may no longer hold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (465, '.1.3.6.1.2.1.16.4.2.1.3', 'hostIndex', 462, 'mandatory', NULL, 'The set of collected host statistics of which this entry is a part. The set of hosts identified by a particular value of this index is associated with the hostControlEntry as identified by the same value of hostControlIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (466, '.1.3.6.1.2.1.16.4.2.1.4', 'hostInPkts', 462, 'mandatory', NULL, 'The number of good packets transmitted to this address since it was added to the hostTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (467, '.1.3.6.1.2.1.16.4.2.1.5', 'hostOutPkts', 462, 'mandatory', NULL, 'The number of packets, including bad packets, transmitted by this address since it was added to the hostTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (468, '.1.3.6.1.2.1.16.4.2.1.6', 'hostInOctets', 462, 'mandatory', NULL, 'The number of octets transmitted to this address since it was added to the hostTable (excluding framing bits but including FCS octets), except for those octets in bad packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (469, '.1.3.6.1.2.1.16.4.2.1.7', 'hostOutOctets', 462, 'mandatory', NULL, 'The number of octets transmitted by this address since it was added to the hostTable (excluding framing bits but including FCS octets), including those octets in bad packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (470, '.1.3.6.1.2.1.16.4.2.1.8', 'hostOutErrors', 462, 'mandatory', NULL, 'The number of bad packets transmitted by this address since this host was added to the hostTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (471, '.1.3.6.1.2.1.16.4.2.1.9', 'hostOutBroadcastPkts', 462, 'mandatory', NULL, 'The number of good packets transmitted by this address that were directed to the broadcast address since this host was added to the hostTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (472, '.1.3.6.1.2.1.16.4.2.1.10', 'hostOutMulticastPkts', 462, 'mandatory', NULL, 'The number of good packets transmitted by this address that were directed to a multicast address since this host was added to the hostTable. Note that this number does not include packets directed to the broadcast address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (473, '.1.3.6.1.2.1.16.4.3', 'hostTimeTable', 384, 'mandatory', NULL, 'A list of time-ordered host table entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (474, '.1.3.6.1.2.1.16.4.3.1', 'hostTimeEntry', 473, 'mandatory', NULL, 'A collection of statistics for a particular host that has been discovered on an interface of this device. This collection includes the relative ordering of the creation time of this object. For example, an instance of the hostTimeOutBroadcastPkts object might be named hostTimeOutBroadcastPkts.1.687', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (475, '.1.3.6.1.2.1.16.4.3.1.1', 'hostTimeAddress', 474, 'mandatory', NULL, 'The physical address of this host.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (476, '.1.3.6.1.2.1.16.4.3.1.2', 'hostTimeCreationOrder', 474, 'mandatory', NULL, 'An index that uniquely identifies an entry in the hostTime table among those entries associated with the same hostControlEntry. This index shall be between 1 and N, where N is the value of the associated hostControlTableSize. The ordering of the indexes is based on the order of each entry''s insertion into the table, in which entries added earlier have a lower index value than entries added later. Thus the management station has the ability to learn of new entries added to this table without downloading the entire table.  It is important to note that the index for a particular entry may change as an (earlier) entry is deleted from the table. Because this order may change, management stations should make use of the hostControlLastDeleteTime variable in the hostControlEntry associated with the relevant portion of the hostTimeTable. By observing this variable, the management station may detect the circumstances where a download of the table may have missed entries, and where a previous association between a value of hostTimeCreationOrder and a hostTimeEntry may no longer hold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (477, '.1.3.6.1.2.1.16.4.3.1.3', 'hostTimeIndex', 474, 'mandatory', NULL, 'The set of collected host statistics of which this entry is a part. The set of hosts identified by a particular value of this index is associated with the hostControlEntry as identified by the same value of hostControlIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (478, '.1.3.6.1.2.1.16.4.3.1.4', 'hostTimeInPkts', 474, 'mandatory', NULL, 'The number of good packets transmitted to this address since it was added to the hostTimeTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (479, '.1.3.6.1.2.1.16.4.3.1.5', 'hostTimeOutPkts', 474, 'mandatory', NULL, 'The number of god packets transmitted by this address since it was added to the hostTimeTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (480, '.1.3.6.1.2.1.16.4.3.1.6', 'hostTimeInOctets', 474, 'mandatory', NULL, 'The number of octets transmitted to this address since it was added to the hostTimeTable (excluding framing bits but including FCS octets), except for those octets in bad packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (481, '.1.3.6.1.2.1.16.4.3.1.7', 'hostTimeOutOctets', 474, 'mandatory', NULL, 'The number of octets transmitted by this address since it was added to the hostTimeTable (excluding framing bits but including FCS octets), including those octets in bad packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (482, '.1.3.6.1.2.1.16.4.3.1.8', 'hostTimeOutErrors', 474, 'mandatory', NULL, 'The number of bad packets transmitted by this address since this host was added to the hostTimeTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (483, '.1.3.6.1.2.1.16.4.3.1.9', 'hostTimeOutBroadcastPkts', 474, 'mandatory', NULL, 'The number of good packets transmitted by this address that were directed to the broadcast address since this host was added to the hostTimeTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (484, '.1.3.6.1.2.1.16.4.3.1.10', 'hostTimeOutMulticastPkts', 474, 'mandatory', NULL, 'The number of good packets transmitted by this address that were directed to a multicast address since this host was added to the hostTimeTable. Note that this number does not include packets directed to the broadcast address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (485, '.1.3.6.1.2.1.16.5.1', 'hostTopNControlTable', 385, 'mandatory', NULL, 'A list of top N host control entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (486, '.1.3.6.1.2.1.16.5.1.1', 'hostTopNControlEntry', 485, 'mandatory', NULL, 'A set of parameters that control the creation of a report of the top N hosts according to several metrics. For example, an instance of the hostTopNDuration object might be named hostTopNDuration.3', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (487, '.1.3.6.1.2.1.16.5.1.1.1', 'hostTopNControlIndex', 486, 'mandatory', NULL, 'An index that uniquely identifies an entry in the hostTopNControl table. Each such entry defines one top N report prepared for one interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (488, '.1.3.6.1.2.1.16.5.1.1.2', 'hostTopNHostIndex', 486, 'mandatory', NULL, 'The host table for which a top N report will be prepared on behalf of this entry. The host table identified by a particular value of this index is associated with the same host table as identified by the same value of hostIndex.  This object may not be modified if the associated hostTopNStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (489, '.1.3.6.1.2.1.16.5.1.1.3', 'hostTopNRateBase', 486, 'mandatory', NULL, 'The variable for each host that the hostTopNRate variable is based upon.  This object may not be modified if the associated hostTopNStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (490, '.1.3.6.1.2.1.16.5.1.1.4', 'hostTopNTimeRemaining', 486, 'mandatory', NULL, 'The number of seconds left in the report currently being collected. When this object is modified by the management station, a new collection is started, possibly aborting a currently running report. The new value is used as the requested duration of this report, which is loaded into the associated hostTopNDuration object.  When this object is set to a non-zero value, any associated hostTopNEntries shall be made inaccessible by the monitor. While the value of this object is non-zero, it decrements by one per second until it reaches zero. During this time, all associated hostTopNEntries shall remain inaccessible. At the time that this object decrements to zero, the report is made accessible in the hostTopNTable. Thus, the hostTopN table needs to be created only at the end of the collection interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (491, '.1.3.6.1.2.1.16.5.1.1.5', 'hostTopNDuration', 486, 'mandatory', NULL, 'The number of seconds that this report has collected during the last sampling interval, or if this report is currently being collected, the number of seconds that this report is being collected during this sampling interval.  When the associated hostTopNTimeRemaining object is set, this object shall be set by the probe to the same value and shall not be modified until the next time the hostTopNTimeRemaining is set.  This value shall be zero if no reports have been requested for this hostTopNControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (492, '.1.3.6.1.2.1.16.5.1.1.6', 'hostTopNRequestedSize', 486, 'mandatory', NULL, 'The maximum number of hosts requested for the top N table.  When this object is created or modified, the probe should set hostTopNGrantedSize as closely to this object as is possible for the particular probe implementation and available resources.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (493, '.1.3.6.1.2.1.16.5.1.1.7', 'hostTopNGrantedSize', 486, 'mandatory', NULL, 'The maximum number of hosts in the top N table.  When the associated hostTopNRequestedSize object is created or modified, the probe should set this object as closely to the requested value as is possible for the particular implementation and available resources. The probe must not lower this value except as a result of a set to the associated hostTopNRequestedSize object.  Hosts with the highest value of hostTopNRate shall be placed in this table in decreasing order of this rate until there is no more room or until there are no more hosts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (494, '.1.3.6.1.2.1.16.5.1.1.8', 'hostTopNStartTime', 486, 'mandatory', NULL, 'The value of sysUpTime when this top N report was last started. In other words, this is the time that the associated hostTopNTimeRemaining object was modified to start the requested report.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (495, '.1.3.6.1.2.1.16.5.1.1.9', 'hostTopNOwner', 486, 'mandatory', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (496, '.1.3.6.1.2.1.16.5.1.1.10', 'hostTopNStatus', 486, 'mandatory', NULL, 'The status of this hostTopNControl entry.  If this object is not equal to valid(1), all associated hostTopNEntries shall be deleted by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (497, '.1.3.6.1.2.1.16.5.2', 'hostTopNTable', 385, 'mandatory', NULL, 'A list of top N host entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (498, '.1.3.6.1.2.1.16.5.2.1', 'hostTopNEntry', 497, 'mandatory', NULL, 'A set of statistics for a host that is part of a top N report. For example, an instance of the hostTopNRate object might be named hostTopNRate.3.10', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (499, '.1.3.6.1.2.1.16.5.2.1.1', 'hostTopNReport', 498, 'mandatory', NULL, 'This object identifies the top N report of which this entry is a part. The set of hosts identified by a particular value of this object is part of the same report as identified by the same value of the hostTopNControlIndex object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (500, '.1.3.6.1.2.1.16.5.2.1.2', 'hostTopNIndex', 498, 'mandatory', NULL, 'An index that uniquely identifies an entry in the hostTopN table among those in the same report. This index is between 1 and N, where N is the number of entries in this table. Increasing values of hostTopNIndex shall be assigned to entries with decreasing values of hostTopNRate until index N is assigned to the entry with the lowest value of hostTopNRate or there are no more hostTopNEntries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (501, '.1.3.6.1.2.1.16.5.2.1.3', 'hostTopNAddress', 498, 'mandatory', NULL, 'The physical address of this host.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5858, '.1.3.6.1.2.1.19.2.1', 'charPortEntry', 5857, 'current', NULL, 'Status and parameter values for a character port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6780, '.1.3.6.1.4.1.9.2.2.1.1.92', 'locIfmopInOctets', 6689, 'mandatory', NULL, 'MOP protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (502, '.1.3.6.1.2.1.16.5.2.1.4', 'hostTopNRate', 498, 'mandatory', NULL, 'The amount of change in the selected variable during this sampling interval. The selected variable is this host''s instance of the object selected by hostTopNRateBase.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (503, '.1.3.6.1.2.1.16.6.1', 'matrixControlTable', 386, 'mandatory', NULL, 'A list of information entries for the traffic matrix on each interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (504, '.1.3.6.1.2.1.16.6.1.1', 'matrixControlEntry', 503, 'mandatory', NULL, 'Information about a traffic matrix on a particular interface. For example, an instance of the matrixControlLastDeleteTime object might be named matrixControlLastDeleteTime.1', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (505, '.1.3.6.1.2.1.16.6.1.1.1', 'matrixControlIndex', 504, 'mandatory', NULL, 'An index that uniquely identifies an entry in the matrixControl table. Each such entry defines a function that discovers conversations on a particular interface and places statistics about them in the matrixSDTable and the matrixDSTable on behalf of this matrixControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (506, '.1.3.6.1.2.1.16.6.1.1.2', 'matrixControlDataSource', 504, 'mandatory', NULL, 'This object identifies the source of the data from which this entry creates a traffic matrix. This source can be any interface on this device. In order to identify a particular interface, this object shall identify the instance of the ifIndex object, defined in RFC 1213 and RFC 1573 [4,6], for the desired interface. For example, if an entry were to receive data from interface #1, this object would be set to ifIndex.1.  The statistics in this group reflect all packets on the local network segment attached to the identified interface.  An agent may or may not be able to tell if fundamental changes to the media of the interface have occurred and necessitate an invalidation of this entry. For example, a hot-pluggable ethernet card could be pulled out and replaced by a token-ring card. In such a case, if the agent has such knowledge of the change, it is recommended that it invalidate this entry.  This object may not be modified if the associated matrixControlStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (507, '.1.3.6.1.2.1.16.6.1.1.3', 'matrixControlTableSize', 504, 'mandatory', NULL, 'The number of matrixSDEntries in the matrixSDTable for this interface. This must also be the value of the number of entries in the matrixDSTable for this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (508, '.1.3.6.1.2.1.16.6.1.1.4', 'matrixControlLastDeleteTime', 504, 'mandatory', NULL, 'The value of sysUpTime when the last entry was deleted from the portion of the matrixSDTable or matrixDSTable associated with this matrixControlEntry. If no deletions have occurred, this value shall be zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (509, '.1.3.6.1.2.1.16.6.1.1.5', 'matrixControlOwner', 504, 'mandatory', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (510, '.1.3.6.1.2.1.16.6.1.1.6', 'matrixControlStatus', 504, 'mandatory', NULL, 'The status of this matrixControl entry.  If this object is not equal to valid(1), all associated entries in the matrixSDTable and the matrixDSTable shall be deleted by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (511, '.1.3.6.1.2.1.16.6.2', 'matrixSDTable', 386, 'mandatory', NULL, 'A list of traffic matrix entries indexed by source and destination MAC address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (512, '.1.3.6.1.2.1.16.6.2.1', 'matrixSDEntry', 511, 'mandatory', NULL, 'A collection of statistics for communications between two addresses on a particular interface. For example, an instance of the matrixSDPkts object might be named matrixSDPkts.1.6.8.0.32.27.3.176.6.8.0.32.10.8.113', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (513, '.1.3.6.1.2.1.16.6.2.1.1', 'matrixSDSourceAddress', 512, 'mandatory', NULL, 'The source physical address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (514, '.1.3.6.1.2.1.16.6.2.1.2', 'matrixSDDestAddress', 512, 'mandatory', NULL, 'The destination physical address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (515, '.1.3.6.1.2.1.16.6.2.1.3', 'matrixSDIndex', 512, 'mandatory', NULL, 'The set of collected matrix statistics of which this entry is a part. The set of matrix statistics identified by a particular value of this index is associated with the same matrixControlEntry as identified by the same value of matrixControlIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (516, '.1.3.6.1.2.1.16.6.2.1.4', 'matrixSDPkts', 512, 'mandatory', NULL, 'The number of packets transmitted from the source address to the destination address (this number includes bad packets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (517, '.1.3.6.1.2.1.16.6.2.1.5', 'matrixSDOctets', 512, 'mandatory', NULL, 'The number of octets (excluding framing bits but including FCS octets) contained in all packets transmitted from the source address to the destination address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (518, '.1.3.6.1.2.1.16.6.2.1.6', 'matrixSDErrors', 512, 'mandatory', NULL, 'The number of bad packets transmitted from the source address to the destination address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (519, '.1.3.6.1.2.1.16.6.3', 'matrixDSTable', 386, 'mandatory', NULL, 'A list of traffic matrix entries indexed by destination and source MAC address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (520, '.1.3.6.1.2.1.16.6.3.1', 'matrixDSEntry', 519, 'mandatory', NULL, 'A collection of statistics for communications between two addresses on a particular interface. For example, an instance of the matrixSDPkts object might be named matrixSDPkts.1.6.8.0.32.10.8.113.6.8.0.32.27.3.176', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (521, '.1.3.6.1.2.1.16.6.3.1.1', 'matrixDSSourceAddress', 520, 'mandatory', NULL, 'The source physical address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (522, '.1.3.6.1.2.1.16.6.3.1.2', 'matrixDSDestAddress', 520, 'mandatory', NULL, 'The destination physical address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (523, '.1.3.6.1.2.1.16.6.3.1.3', 'matrixDSIndex', 520, 'mandatory', NULL, 'The set of collected matrix statistics of which this entry is a part. The set of matrix statistics identified by a particular value of this index is associated with the same matrixControlEntry as identified by the same value of matrixControlIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (524, '.1.3.6.1.2.1.16.6.3.1.4', 'matrixDSPkts', 520, 'mandatory', NULL, 'The number of packets transmitted from the source address to the destination address (this number includes bad packets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (525, '.1.3.6.1.2.1.16.6.3.1.5', 'matrixDSOctets', 520, 'mandatory', NULL, 'The number of octets (excluding framing bits but including FCS octets) contained in all packets transmitted from the source address to the destination address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (526, '.1.3.6.1.2.1.16.6.3.1.6', 'matrixDSErrors', 520, 'mandatory', NULL, 'The number of bad packets transmitted from the source address to the destination address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (527, '.1.3.6.1.2.1.16.7.1', 'filterTable', 387, 'mandatory', NULL, 'A list of packet filter entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (528, '.1.3.6.1.2.1.16.7.1.1', 'filterEntry', 527, 'mandatory', NULL, 'A set of parameters for a packet filter applied on a particular interface. As an example, an instance of the filterPktData object might be named filterPktData.12', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (529, '.1.3.6.1.2.1.16.7.1.1.1', 'filterIndex', 528, 'mandatory', NULL, 'An index that uniquely identifies an entry in the filter table. Each such entry defines one filter that is to be applied to every packet received on an interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (530, '.1.3.6.1.2.1.16.7.1.1.2', 'filterChannelIndex', 528, 'mandatory', NULL, 'This object identifies the channel of which this filter is a part. The filters identified by a particular value of this object are associated with the same channel as identified by the same value of the channelIndex object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (531, '.1.3.6.1.2.1.16.7.1.1.3', 'filterPktDataOffset', 528, 'mandatory', NULL, 'The offset from the beginning of each packet where a match of packet data will be attempted. This offset is measured from the point in the physical layer packet after the framing bits, if any. For example, in an Ethernet frame, this point is at the beginning of the destination MAC address.  This object may not be modified if the associated filterStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5532, '.1.3.6.1.4.1.9.9.84.3.1', 'ciscoIpStatMIBCompliances', 5531, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (532, '.1.3.6.1.2.1.16.7.1.1.4', 'filterPktData', 528, 'mandatory', NULL, 'The data that is to be matched with the input packet. For each packet received, this filter and the accompanying filterPktDataMask and filterPktDataNotMask will be adjusted for the offset. The only bits relevant to this match algorithm are those that have the corresponding filterPktDataMask bit equal to one. The following three rules are then applied to every packet:  (1) If the packet is too short and does not have data corresponding to part of the filterPktData, the packet will fail this data match.  (2) For each relevant bit from the packet with the corresponding filterPktDataNotMask bit set to zero, if the bit from the packet is not equal to the corresponding bit from the filterPktData, then the packet will fail this data match.  (3) If for every relevant bit from the packet with the corresponding filterPktDataNotMask bit set to one, the bit from the packet is equal to the corresponding bit from the filterPktData, then the packet will fail this data match.  Any packets that have not failed any of the three matches above have passed this data match. In particular, a zero length filter will match any packet.  This object may not be modified if the associated filterStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (533, '.1.3.6.1.2.1.16.7.1.1.5', 'filterPktDataMask', 528, 'mandatory', NULL, 'The mask that is applied to the match process. After adjusting this mask for the offset, only those bits in the received packet that correspond to bits set in this mask are relevant for further processing by the match algorithm. The offset is applied to filterPktDataMask in the same way it is applied to the filter. For the purposes of the matching algorithm, if the associated filterPktData object is longer than this mask, this mask is conceptually extended with ''1'' bits until it reaches the length of the filterPktData object.  This object may not be modified if the associated filterStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (534, '.1.3.6.1.2.1.16.7.1.1.6', 'filterPktDataNotMask', 528, 'mandatory', NULL, 'The inversion mask that is applied to the match process. After adjusting this mask for the offset, those relevant bits in the received packet that correspond to bits cleared in this mask must all be equal to their corresponding bits in the filterPktData object for the packet to be accepted. In addition, at least one of those relevant bits in the received packet that correspond to bits set in this mask must be different to its corresponding bit in the filterPktData object.  For the purposes of the matching algorithm, if the associated filterPktData object is longer than this mask, this mask is conceptually extended with ''0'' bits until it reaches the length of the filterPktData object.  This object may not be modified if the associated filterStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (535, '.1.3.6.1.2.1.16.7.1.1.7', 'filterPktStatus', 528, 'mandatory', NULL, 'The status that is to be matched with the input packet. The only bits relevant to this match algorithm are those that have the corresponding filterPktStatusMask bit equal to one. The following two rules are then applied to every packet:  (1) For each relevant bit from the packet status with the corresponding filterPktStatusNotMask bit set to zero, if the bit from the packet status is not equal to the corresponding bit from the filterPktStatus, then the packet will fail this status match.  (2) If for every relevant bit from the packet status with the corresponding filterPktStatusNotMask bit set to one, the bit from the packet status is equal to the corresponding bit from the filterPktStatus, then the packet will fail this status match.  Any packets that have not failed either of the two matches above have passed this status match. In particular, a zero length status filter will match any packet''s status.  The value of the packet status is a sum. This sum initially takes the value zero. Then, for each error, E, that has been discovered in this packet, 2 raised to a value representing E is added to the sum. The errors and the bits that represent them are dependent on the media type of the interface that this channel is receiving packets from.  The errors defined for a packet captured off of an Ethernet interface are as follows:  bit # Error 0 Packet is longer than 1518 octets 1 Packet is shorter than 64 octets 2 Packet experienced a CRC or Alignment error  For example, an Ethernet fragment would have a value of 6 (2^1 + 2^2).  As this MIB is expanded to new media types, this object will have other media-specific errors defined.  For the purposes of this status matching algorithm, if the packet status is longer than this filterPktStatus object, this object is conceptually extended with ''0'' bits until it reaches the size of the packet status.  This object may not be modified if the associated filterStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (536, '.1.3.6.1.2.1.16.7.1.1.8', 'filterPktStatusMask', 528, 'mandatory', NULL, 'The mask that is applied to the status match process. Only those bits in the received packet that correspond to bits set in this mask are relevant for further processing by the status match algorithm. For the purposes of the matching algorithm, if the associated filterPktStatus object is longer than this mask, this mask is conceptually extended with ''1'' bits until it reaches the size of the filterPktStatus. In addition, if a packet status is longer than this mask, this mask is conceptually extended with ''0'' bits until it reaches the size of the packet status.  This object may not be modified if the associated filterStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (537, '.1.3.6.1.2.1.16.7.1.1.9', 'filterPktStatusNotMask', 528, 'mandatory', NULL, 'The inversion mask that is applied to the status match process. Those relevant bits in the received packet status that correspond to bits cleared in this mask must all be equal to their corresponding bits in the filterPktStatus object for the packet to be accepted. In addition, at least one of those relevant bits in the received packet status that correspond to bits set in this mask must be different to its corresponding bit in the filterPktStatus object for the packet to be accepted.  For the purposes of the matching algorithm, if the associated filterPktStatus object or a packet status is longer than this mask, this mask is conceptually extended with ''0'' bits until it reaches the longer of the lengths of the filterPktStatus object and the packet status.  This object may not be modified if the associated filterStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (538, '.1.3.6.1.2.1.16.7.1.1.10', 'filterOwner', 528, 'mandatory', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (539, '.1.3.6.1.2.1.16.7.1.1.11', 'filterStatus', 528, 'mandatory', NULL, 'The status of this filter entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (540, '.1.3.6.1.2.1.16.7.2', 'channelTable', 387, 'mandatory', NULL, 'A list of packet channel entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (541, '.1.3.6.1.2.1.16.7.2.1', 'channelEntry', 540, 'mandatory', NULL, 'A set of parameters for a packet channel applied on a particular interface. As an example, an instance of the channelMatches object might be named channelMatches.3', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (542, '.1.3.6.1.2.1.16.7.2.1.1', 'channelIndex', 541, 'mandatory', NULL, 'An index that uniquely identifies an entry in the channel table. Each such entry defines one channel, a logical data and event stream.  It is suggested that before creating a channel, an application should scan all instances of the filterChannelIndex object to make sure that there are no pre-existing filters that would be inadvertently be linked to the channel.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (543, '.1.3.6.1.2.1.16.7.2.1.2', 'channelIfIndex', 541, 'mandatory', NULL, 'The value of this object uniquely identifies the interface on this remote network monitoring device to which the associated filters are applied to allow data into this channel. The interface identified by a particular value of this object is the same interface as identified by the same value of the ifIndex object, defined in RFC 1213 and RFC 1573 [4,6].  The filters in this group are applied to all packets on the local network segment attached to the identified interface.  An agent may or may not be able to tell if fundamental changes to the media of the interface have occurred and necessitate an invalidation of this entry. For example, a hot-pluggable ethernet card could be pulled out and replaced by a token-ring card. In such a case, if the agent has such knowledge of the change, it is recommended that it invalidate this entry.  This object may not be modified if the associated channelStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5534, '.1.3.6.1.4.1.9.9.84.3.1.1', 'ciscoIpStatMIBCompliance', 5532, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (544, '.1.3.6.1.2.1.16.7.2.1.3', 'channelAcceptType', 541, 'mandatory', NULL, 'This object controls the action of the filters associated with this channel. If this object is equal to acceptMatched(1), packets will be accepted to this channel if they are accepted by both the packet data and packet status matches of an associated filter. If this object is equal to acceptFailed(2), packets will be accepted to this channel only if they fail either the packet data match or the packet status match of each of the associated filters.  In particular, a channel with no associated filters will match no packets if set to acceptMatched(1) case and will match all packets in the acceptFailed(2) case.  This object may not be modified if the associated channelStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (545, '.1.3.6.1.2.1.16.7.2.1.4', 'channelDataControl', 541, 'mandatory', NULL, 'This object controls the flow of data through this channel. If this object is on(1), data, status and events flow through this channel. If this object is off(2), data, status and events will not flow through this channel.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (546, '.1.3.6.1.2.1.16.7.2.1.5', 'channelTurnOnEventIndex', 541, 'mandatory', NULL, 'The value of this object identifies the event that is configured to turn the associated channelDataControl from off to on when the event is generated. The event identified by a particular value of this object is the same event as identified by the same value of the eventIndex object. If there is no corresponding entry in the eventTable, then no association exists. In fact, if no event is intended for this channel, channelTurnOnEventIndex must be set to zero, a non-existent event index.  This object may not be modified if the associated channelStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (547, '.1.3.6.1.2.1.16.7.2.1.6', 'channelTurnOffEventIndex', 541, 'mandatory', NULL, 'The value of this object identifies the event that is configured to turn the associated channelDataControl from on to off when the event is generated. The event identified by a particular value of this object is the same event as identified by the same value of the eventIndex object. If there is no corresponding entry in the eventTable, then no association exists. In fact, if no event is intended for this channel, channelTurnOffEventIndex must be set to zero, a non-existent event index.  This object may not be modified if the associated channelStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (548, '.1.3.6.1.2.1.16.7.2.1.7', 'channelEventIndex', 541, 'mandatory', NULL, 'The value of this object identifies the event that is configured to be generated when the associated channelDataControl is on and a packet is matched. The event identified by a particular value of this object is the same event as identified by the same value of the eventIndex object. If there is no corresponding entry in the eventTable, then no association exists. In fact, if no event is intended for this channel, channelEventIndex must be set to zero, a non-existent event index.  This object may not be modified if the associated channelStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (549, '.1.3.6.1.2.1.16.7.2.1.8', 'channelEventStatus', 541, 'mandatory', NULL, 'The event status of this channel.  If this channel is configured to generate events when packets are matched, a means of controlling the flow of those events is often needed. When this object is equal to eventReady(1), a single event may be generated, after which this object will be set by the probe to eventFired(2). While in the eventFired(2) state, no events will be generated until the object is modified to eventReady(1) (or eventAlwaysReady(3)). The management station can thus easily respond to a notification of an event by re-enabling this object.  If the management station wishes to disable this flow control and allow events to be generated at will, this object may be set to eventAlwaysReady(3). Disabling the flow control is discouraged as it can result in high network traffic or other performance problems.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (550, '.1.3.6.1.2.1.16.7.2.1.9', 'channelMatches', 541, 'mandatory', NULL, 'The number of times this channel has matched a packet. Note that this object is updated even when channelDataControl is set to off.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (551, '.1.3.6.1.2.1.16.7.2.1.10', 'channelDescription', 541, 'mandatory', NULL, 'A comment describing this channel.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (552, '.1.3.6.1.2.1.16.7.2.1.11', 'channelOwner', 541, 'mandatory', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (553, '.1.3.6.1.2.1.16.7.2.1.12', 'channelStatus', 541, 'mandatory', NULL, 'The status of this channel entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (554, '.1.3.6.1.2.1.16.8.1', 'bufferControlTable', 388, 'mandatory', NULL, 'A list of buffers control entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (555, '.1.3.6.1.2.1.16.8.1.1', 'bufferControlEntry', 554, 'mandatory', NULL, 'A set of parameters that control the collection of a stream of packets that have matched filters. As an example, an instance of the bufferControlCaptureSliceSize object might be named bufferControlCaptureSliceSize.3', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (556, '.1.3.6.1.2.1.16.8.1.1.1', 'bufferControlIndex', 555, 'mandatory', NULL, 'An index that uniquely identifies an entry in the bufferControl table. The value of this index shall never be zero. Each such entry defines one set of packets that is captured and controlled by one or more filters.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (557, '.1.3.6.1.2.1.16.8.1.1.2', 'bufferControlChannelIndex', 555, 'mandatory', NULL, 'An index that identifies the channel that is the source of packets for this bufferControl table. The channel identified by a particular value of this index is the same as identified by the same value of the channelIndex object.  This object may not be modified if the associated bufferControlStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (558, '.1.3.6.1.2.1.16.8.1.1.3', 'bufferControlFullStatus', 555, 'mandatory', NULL, 'This object shows whether the buffer has room to accept new packets or if it is full.  If the status is spaceAvailable(1), the buffer is accepting new packets normally. If the status is full(2) and the associated bufferControlFullAction object is wrapWhenFull, the buffer is accepting new packets by deleting enough of the oldest packets to make room for new ones as they arrive. Otherwise, if the status is full(2) and the bufferControlFullAction object is lockWhenFull, then the buffer has stopped collecting packets.  When this object is set to full(2) the probe must not later set it to spaceAvailable(1) except in the case of a significant gain in resources such as an increase of bufferControlOctetsGranted. In particular, the wrap-mode action of deleting old packets to make room for newly arrived packets must not affect the value of this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (559, '.1.3.6.1.2.1.16.8.1.1.4', 'bufferControlFullAction', 555, 'mandatory', NULL, 'Controls the action of the buffer when it reaches the full status. When in the lockWhenFull(1) state and a packet is added to the buffer that fills the buffer, the bufferControlFullStatus will be set to full(2) and this buffer will stop capturing packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (560, '.1.3.6.1.2.1.16.8.1.1.5', 'bufferControlCaptureSliceSize', 555, 'mandatory', NULL, 'The maximum number of octets of each packet that will be saved in this capture buffer. For example, if a 1500 octet packet is received by the probe and this object is set to 500, then only 500 octets of the packet will be stored in the associated capture buffer. If this variable is set to 0, the capture buffer will save as many octets as is possible.  This object may not be modified if the associated bufferControlStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (579, '.1.3.6.1.2.1.16.9.1.1', 'eventEntry', 578, 'mandatory', NULL, 'A set of parameters that describe an event to be generated when certain conditions are met. As an example, an instance of the eventLastTimeSent object might be named eventLastTimeSent.6', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (561, '.1.3.6.1.2.1.16.8.1.1.6', 'bufferControlDownloadSliceSize', 555, 'mandatory', NULL, 'The maximum number of octets of each packet in this capture buffer that will be returned in an SNMP retrieval of that packet. For example, if 500 octets of a packet have been stored in the associated capture buffer, the associated bufferControlDownloadOffset is 0, and this object is set to 100, then the captureBufferPacket object that contains the packet will contain only the first 100 octets of the packet.  A prudent manager will take into account possible interoperability or fragmentation problems that may occur if the download slice size is set too large. In particular, conformant SNMP implementations are not required to accept messages whose length exceeds 484 octets, although they are encouraged to support larger datagrams whenever feasible.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (562, '.1.3.6.1.2.1.16.8.1.1.7', 'bufferControlDownloadOffset', 555, 'mandatory', NULL, 'The offset of the first octet of each packet in this capture buffer that will be returned in an SNMP retrieval of that packet. For example, if 500 octets of a packet have been stored in the associated capture buffer and this object is set to 100, then the captureBufferPacket object that contains the packet will contain bytes starting 100 octets into the packet.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (563, '.1.3.6.1.2.1.16.8.1.1.8', 'bufferControlMaxOctetsRequested', 555, 'mandatory', NULL, 'The requested maximum number of octets to be saved in this captureBuffer, including any implementation-specific overhead. If this variable is set to -1, the capture buffer will save as many octets as is possible.  When this object is created or modified, the probe should set bufferControlMaxOctetsGranted as closely to this object as is possible for the particular probe implementation and available resources. However, if the object has the special value of -1, the probe must set bufferControlMaxOctetsGranted to -1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (564, '.1.3.6.1.2.1.16.8.1.1.9', 'bufferControlMaxOctetsGranted', 555, 'mandatory', NULL, 'The maximum number of octets that can be saved in this captureBuffer, including overhead. If this variable is -1, the capture buffer will save as many octets as possible.  When the bufferControlMaxOctetsRequested object is created or modified, the probe should set this object as closely to the requested value as is possible for the particular probe implementation and available resources. However, if the request object has the special value of -1, the probe must set this object to -1. The probe must not lower this value except as a result of a modification to the associated bufferControlMaxOctetsRequested object.  When this maximum number of octets is reached and a new packet is to be added to this capture buffer and the corresponding bufferControlFullAction is set to wrapWhenFull(2), enough of the oldest packets associated with this capture buffer shall be deleted by the agent so that the new packet can be added. If the corresponding bufferControlFullAction is set to lockWhenFull(1), the new packet shall be discarded. In either case, the probe must set bufferControlFullStatus to full(2).  When the value of this object changes to a value less than the current value, entries are deleted from the captureBufferTable associated with this bufferControlEntry. Enough of the oldest of these captureBufferEntries shall be deleted by the agent so that the number of octets used remains less than or equal to the new value of this object.  When the value of this object changes to a value greater than the current value, the number of associated captureBufferEntries may be allowed to grow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (565, '.1.3.6.1.2.1.16.8.1.1.10', 'bufferControlCapturedPackets', 555, 'mandatory', NULL, 'The number of packets currently in this captureBuffer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (566, '.1.3.6.1.2.1.16.8.1.1.11', 'bufferControlTurnOnTime', 555, 'mandatory', NULL, 'The value of sysUpTime when this capture buffer was first turned on.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (567, '.1.3.6.1.2.1.16.8.1.1.12', 'bufferControlOwner', 555, 'mandatory', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (568, '.1.3.6.1.2.1.16.8.1.1.13', 'bufferControlStatus', 555, 'mandatory', NULL, 'The status of this buffer Control Entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (569, '.1.3.6.1.2.1.16.8.2', 'captureBufferTable', 388, 'mandatory', NULL, 'A list of packets captured off of a channel.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (570, '.1.3.6.1.2.1.16.8.2.1', 'captureBufferEntry', 569, 'mandatory', NULL, 'A packet captured off of an attached network. As an example, an instance of the captureBufferPacketData object might be named captureBufferPacketData.3.1783', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (571, '.1.3.6.1.2.1.16.8.2.1.1', 'captureBufferControlIndex', 570, 'mandatory', NULL, 'The index of the bufferControlEntry with which this packet is associated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (572, '.1.3.6.1.2.1.16.8.2.1.2', 'captureBufferIndex', 570, 'mandatory', NULL, 'An index that uniquely identifies an entry in the captureBuffer table associated with a particular bufferControlEntry. This index will start at 1 and increase by one for each new packet added with the same captureBufferControlIndex.  Should this value reach 2147483647, the next packet added with the same captureBufferControlIndex shall cause this value to wrap around to 1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (573, '.1.3.6.1.2.1.16.8.2.1.3', 'captureBufferPacketID', 570, 'mandatory', NULL, 'An index that describes the order of packets that are received on a particular interface. The packetID of a packet captured on an interface is defined to be greater than the packetID''s of all packets captured previously on the same interface. As the captureBufferPacketID object has a maximum positive value of 2^31 - 1, any captureBufferPacketID object shall have the value of the associated packet''s packetID mod 2^31.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (574, '.1.3.6.1.2.1.16.8.2.1.4', 'captureBufferPacketData', 570, 'mandatory', NULL, 'The data inside the packet, starting at the beginning of the packet plus any offset specified in the associated bufferControlDownloadOffset, including any link level headers. The length of the data in this object is the minimum of the length of the captured packet minus the offset, the length of the associated bufferControlCaptureSliceSize minus the offset, and the associated bufferControlDownloadSliceSize. If this minimum is less than zero, this object shall have a length of zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (575, '.1.3.6.1.2.1.16.8.2.1.5', 'captureBufferPacketLength', 570, 'mandatory', NULL, 'The actual length (off the wire) of the packet stored in this entry, including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (576, '.1.3.6.1.2.1.16.8.2.1.6', 'captureBufferPacketTime', 570, 'mandatory', NULL, 'The number of milliseconds that had passed since this capture buffer was first turned on when this packet was captured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (577, '.1.3.6.1.2.1.16.8.2.1.7', 'captureBufferPacketStatus', 570, 'mandatory', NULL, 'A value which indicates the error status of this packet.  The value of this object is defined in the same way as filterPktStatus. The value is a sum. This sum initially takes the value zero. Then, for each error, E, that has been discovered in this packet, 2 raised to a value representing E is added to the sum.  The errors defined for a packet captured off of an Ethernet interface are as follows:  bit # Error 0 Packet is longer than 1518 octets 1 Packet is shorter than 64 octets 2 Packet experienced a CRC or Alignment error 3 First packet in this capture buffer after it was detected that some packets were not processed correctly. 4 Packet''s order in buffer is only approximate (May only be set for packets sent from the probe)  For example, an Ethernet fragment would have a value of 6 (2^1 + 2^2).  As this MIB is expanded to new media types, this object will have other media-specific errors defined.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (578, '.1.3.6.1.2.1.16.9.1', 'eventTable', 389, 'mandatory', NULL, 'A list of events to be generated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1195, '.1.3.6.1.2.1.27.3.2.6', 'assocRFC2788Compliance', 1189, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (580, '.1.3.6.1.2.1.16.9.1.1.1', 'eventIndex', 579, 'mandatory', NULL, 'An index that uniquely identifies an entry in the event table. Each such entry defines one event that is to be generated when the appropriate conditions occur.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (581, '.1.3.6.1.2.1.16.9.1.1.2', 'eventDescription', 579, 'mandatory', NULL, 'A comment describing this event entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (582, '.1.3.6.1.2.1.16.9.1.1.3', 'eventType', 579, 'mandatory', NULL, 'The type of notification that the probe will make about this event. In the case of log, an entry is made in the log table for each event. In the case of snmp-trap, an SNMP trap is sent to one or more management stations.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (583, '.1.3.6.1.2.1.16.9.1.1.4', 'eventCommunity', 579, 'mandatory', NULL, 'If an SNMP trap is to be sent, it will be sent to the SNMP community specified by this octet string. In the future this table will be extended to include the party security mechanism. This object shall be set to a string of length zero if it is intended that that mechanism be used to specify the destination of the trap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (584, '.1.3.6.1.2.1.16.9.1.1.5', 'eventLastTimeSent', 579, 'mandatory', NULL, 'The value of sysUpTime at the time this event entry last generated an event. If this entry has not generated any events, this value will be zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (585, '.1.3.6.1.2.1.16.9.1.1.6', 'eventOwner', 579, 'mandatory', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.  If this object contains a string starting with ''monitor'' and has associated entries in the log table, all connected management stations should retrieve those log entries, as they may have significance to all management stations connected to this device', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (586, '.1.3.6.1.2.1.16.9.1.1.7', 'eventStatus', 579, 'mandatory', NULL, 'The status of this event entry.  If this object is not equal to valid(1), all associated log entries shall be deleted by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (587, '.1.3.6.1.2.1.16.9.2', 'logTable', 389, 'mandatory', NULL, 'A list of events that have been logged.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (588, '.1.3.6.1.2.1.16.9.2.1', 'logEntry', 587, 'mandatory', NULL, 'A set of data describing an event that has been logged. For example, an instance of the logDescription object might be named logDescription.6.47', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (589, '.1.3.6.1.2.1.16.9.2.1.1', 'logEventIndex', 588, 'mandatory', NULL, 'The event entry that generated this log entry. The log identified by a particular value of this index is associated with the same eventEntry as identified by the same value of eventIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (590, '.1.3.6.1.2.1.16.9.2.1.2', 'logIndex', 588, 'mandatory', NULL, 'An index that uniquely identifies an entry in the log table amongst those generated by the same eventEntries. These indexes are assigned beginning with 1 and increase by one with each new log entry. The association between values of logIndex and logEntries is fixed for the lifetime of each logEntry. The agent may choose to delete the oldest instances of logEntry as required because of lack of memory. It is an implementation-specific matter as to when this deletion may occur.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (591, '.1.3.6.1.2.1.16.9.2.1.3', 'logTime', 588, 'mandatory', NULL, 'The value of sysUpTime when this log entry was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (592, '.1.3.6.1.2.1.16.9.2.1.4', 'logDescription', 588, 'mandatory', NULL, 'An implementation dependent description of the event that activated this log entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (593, '.1.3.6.1.2.1.16.0', 'rmonPrefix', 380, 'current', NULL, 'Prefix for TRAP-TYPE objects', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (594, '.1.3.6.1.2.1.16.0.1', 'risingAlarm', 593, 'current', NULL, 'The SNMP trap that is generated when an alarm entry crosses its rising threshold and generates an event that is configured for sending SNMP traps.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (595, '.1.3.6.1.2.1.16.0.2', 'fallingAlarm', 593, 'current', NULL, 'The SNMP trap that is generated when an alarm entry crosses its falling threshold and generates an event that is configured for sending SNMP traps.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (800, '.1.3.6.1.4.1.9.9.46.1.1.1', 'vtpVersion', 799, 'current', NULL, 'The version of VTP in use on the local system. A device will report its version capability and not any particular version in use on the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (801, '.1.3.6.1.4.1.9.9.46.1.1.2', 'vtpMaxVlanStorage', 799, 'current', NULL, 'An estimate of the maximum number of VLANs about which the local system can recover complete VTP information after a reboot. If the number of defined VLANs is greater than this value, then the system can not act as a VTP Server. For a device which has no means to calculate the estimated number, this value is -1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (802, '.1.3.6.1.4.1.9.9.46.1.1.3', 'vtpNotificationsEnabled', 799, 'current', NULL, 'An indication of whether the notifications/traps defined by the vtpConfigNotificationsGroup are enabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (803, '.1.3.6.1.4.1.9.9.46.1.2', 'vlanManagementDomains', 798, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (804, '.1.3.6.1.4.1.9.9.46.1.2.1', 'managementDomainTable', 803, 'current', NULL, 'The table containing information on the management domains in which the local system is participating. Devices which support only one management domain will support just one row in this table, and will not let it be deleted nor let other rows be created. Devices which support multiple management domains will allow rows to be created and deleted, but will not allow the last row to be deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (805, '.1.3.6.1.4.1.9.9.46.1.2.1.1', 'managementDomainEntry', 804, 'current', NULL, 'Information about the status of one management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (806, '.1.3.6.1.4.1.9.9.46.1.2.1.1.1', 'managementDomainIndex', 805, 'current', NULL, 'An arbitrary value to uniquely identify the management domain on the local system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (807, '.1.3.6.1.4.1.9.9.46.1.2.1.1.2', 'managementDomainName', 805, 'current', NULL, 'The management name of a domain in which the local system is participating. The zero-length name corresponds to the ''no management-domain'' state which is the initial value at installation-time if not configured otherwise. Note that the zero-length name does not correspond to an operational management domain, and a device does not send VTP advertisements while in the ''no management-domain'' state. A device leaves the ''no management-domain'' state when it obtains a management-domain name, either through configuration or through inheriting the management-domain name from a received VTP advertisement.  When the value of an existing instance of this object is modified by network management, the local system should re- initialize its VLAN information (for the given management domain) as if it had just been configured with a management domain name at installation time.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (808, '.1.3.6.1.4.1.9.9.46.1.2.1.1.3', 'managementDomainLocalMode', 805, 'current', NULL, 'An indication of whether the local system is acting as a VTP Client or as a VTP Server in this management domain. The value ''transparent'' is a read-only indication that a device is not supporting VTP for this VTP management domain, e.g., because the amount of VLAN information is too large for it to hold in DRAM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (809, '.1.3.6.1.4.1.9.9.46.1.2.1.1.4', 'managementDomainConfigRevNumber', 805, 'current', NULL, 'The current Configuration Revision Number as known by the local device for this management domain. This value is updated (if necessary) whenever a VTP advertisement is received or generated. When in the ''no management-domain'' state, this value is 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (810, '.1.3.6.1.4.1.9.9.46.1.2.1.1.5', 'managementDomainLastUpdater', 805, 'current', NULL, 'The IP-address (or one of them) of the VTP Server which last updated the Configuration Revision Number, as indicated in the most recently received VTP advertisement for this management domain. Before an advertisement has been received, this value is 0.0.0.0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5751, '.1.3.6.1.4.1.9.9.97.1.4.3.1', 'cseStatsFlowEntry', 5750, 'current', NULL, 'A conceptual row about slot based L3 flow statistics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (811, '.1.3.6.1.4.1.9.9.46.1.2.1.1.6', 'managementDomainLastChange', 805, 'current', NULL, 'The time at which the Configuration Revision Number was (last) increased to its current value, as indicated in the most recently received VTP advertisement for this management domain.  The value 0x0000010100000000 indicates that the device which last increased the Configuration Revision Number had no idea of the date/time, or that no advertisement has been received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (812, '.1.3.6.1.4.1.9.9.46.1.2.1.1.7', 'managementDomainRowStatus', 805, 'current', NULL, 'The status of this conceptual row.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (813, '.1.3.6.1.4.1.9.9.46.1.2.1.1.8', 'managementDomainTftpServer', 805, 'current', NULL, 'The IP address of a TFTP Server in/from which VTP VLAN information for this management domain is to be stored/retrieved. If the information is being locally stored in NVRAM, this object should take the value 0.0.0.0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (814, '.1.3.6.1.4.1.9.9.46.1.2.1.1.9', 'managementDomainTftpPathname', 805, 'current', NULL, 'The complete pathname of the file at the TFTP Server identified by the value of managementDomainTftpServer in/from which VTP VLAN information for this management domain is to be stored/retrieved. If the value of corresponding instance of managementDomainTftpServer is 0.0.0.0, the value of this object is ignored.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (815, '.1.3.6.1.4.1.9.9.46.1.2.1.1.10', 'managementDomainPruningState', 805, 'current', NULL, 'An indication of whether VTP pruning is enabled or disabled in this managament domain. This value can only be modified by local/network management when the value of the corresponding instance of managementDomainLocalMode is ''server''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (816, '.1.3.6.1.4.1.9.9.46.1.2.1.1.11', 'managementDomainVersionInUse', 805, 'current', NULL, 'The current version of the VTP that is in use by the designated management domain. This value can only be modified by local/network managment when the value of the corresponding instance of managementDomainLocalMode is ''server''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (817, '.1.3.6.1.4.1.9.9.46.1.3', 'vlanInfo', 798, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (818, '.1.3.6.1.4.1.9.9.46.1.3.1', 'vtpVlanTable', 817, 'current', NULL, 'This table contains information on the VLANs which currently exist. The creation, deletion or modification of entries occurs through: a) the receipt of VTP messages in VTP Clients and in VTP Servers, or, b) in VTP Servers (or in VTP transparent mode), through management operations acting upon entries in the vtpVlanEditTable and then issuing an ''apply'' command via the vtpVlanEditOperation object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (819, '.1.3.6.1.4.1.9.9.46.1.3.1.1', 'vtpVlanEntry', 818, 'current', NULL, 'Information about one current VLAN. The managementDomainIndex value in the INDEX clause indicates which management domain the VLAN is in.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (820, '.1.3.6.1.4.1.9.9.46.1.3.1.1.1', 'vtpVlanIndex', 819, 'current', NULL, 'The VLAN-id of this VLAN on ISL trunks.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (821, '.1.3.6.1.4.1.9.9.46.1.3.1.1.2', 'vtpVlanState', 819, 'current', NULL, 'The state of this VLAN.  The state ''mtuTooBigForDevice'' indicates that this device cannot participate in this VLAN because the VLAN''s MTU is larger than the device can support.  The state ''mtuTooBigForTrunk'' indicates that while this VLAN''s MTU is supported by this device, it is too large for one or more of the device''s trunk ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (822, '.1.3.6.1.4.1.9.9.46.1.3.1.1.3', 'vtpVlanType', 819, 'current', NULL, 'The type of this VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (823, '.1.3.6.1.4.1.9.9.46.1.3.1.1.4', 'vtpVlanName', 819, 'current', NULL, 'The name of this VLAN. This name is used as the ELAN-name for an ATM LAN-Emulation segment of this VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (824, '.1.3.6.1.4.1.9.9.46.1.3.1.1.5', 'vtpVlanMtu', 819, 'current', NULL, 'The MTU size on this VLAN, defined as the size of largest MAC-layer (information field portion of the) data frame which can be transmitted on the VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (825, '.1.3.6.1.4.1.9.9.46.1.3.1.1.6', 'vtpVlanDot10Said', 819, 'current', NULL, 'The value of the 802.10 SAID field for this VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (826, '.1.3.6.1.4.1.9.9.46.1.3.1.1.7', 'vtpVlanRingNumber', 819, 'current', NULL, 'The ring number of this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanType has a value of ''fddi'' or ''tokenRing'' and Source Routing (SRB) is configured for use on this VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (827, '.1.3.6.1.4.1.9.9.46.1.3.1.1.8', 'vtpVlanBridgeNumber', 819, 'current', NULL, 'The bridge number of the VTP-capable switches for this VLAN. This object is only instantiated for VLANs that are involved with emulating token ring segments.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (828, '.1.3.6.1.4.1.9.9.46.1.3.1.1.9', 'vtpVlanStpType', 819, 'current', NULL, 'The type of the Spanning Tree Protocol (STP) running on this VLAN. This object is only instanciated when the value of the corresponding instance of vtpVlanType has a value of ''fddiNet'' or ''trNet''.  The value returned by this object depends upon the value of the corresponding instance of vtpVlanEditStpType.  - ''ieee'' indicates IEEE STP is running exclusively.  - ''ibm'' indicates IBM STP is running exclusively.  - ''hybrid'' indicates a STP that allows a combination of IEEE and IBM is running.  The ''hybrid'' STP type results from tokenRing/fddi VLANs that are children of this trNet/fddiNet parent VLAN being configured in a combination of SRT and SRB vtpVlanBridgeTypes while the instance of vtpVlanEditStpType that corresponds to this object is set to ''auto''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (829, '.1.3.6.1.4.1.9.9.46.1.3.1.1.10', 'vtpVlanParentVlan', 819, 'current', NULL, 'The parent VLAN for this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanType has a value of ''fddi'' or ''tokenRing'' and Source Routing (SRB) is configured for use on this VLAN. The parent VLAN must have a vtpVlanType value of fddiNet(4) or trNet(5), respectively.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (830, '.1.3.6.1.4.1.9.9.46.1.3.1.1.11', 'vtpVlanTranslationalVlan1', 819, 'current', NULL, 'A VLAN to which this VLAN is being translational-bridged. If this value and the corresponding instance of vtpVlanTranslationalVlan2 are both zero, then this VLAN is not being translational-bridged.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (831, '.1.3.6.1.4.1.9.9.46.1.3.1.1.12', 'vtpVlanTranslationalVlan2', 819, 'current', NULL, 'Another VLAN, i.e., other than that indicated by vtpVlanTranslationalVlan1, to which this VLAN is being translational-bridged. If this value and the corresponding instance of vtpVlanTranslationalVlan1 are both zero, then this VLAN is not being translational-bridged.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (832, '.1.3.6.1.4.1.9.9.46.1.3.1.1.13', 'vtpVlanBridgeType', 819, 'current', NULL, 'The type of the bridging mode in use on this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanType has a value of fddi(2) or tokenRing(3).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (833, '.1.3.6.1.4.1.9.9.46.1.3.1.1.14', 'vtpVlanAreHopCount', 819, 'current', NULL, 'The maximum number of bridge hops allowed in All Routes Explorer frames on this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanType has a value of fddi(2) or tokenRing(3).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (834, '.1.3.6.1.4.1.9.9.46.1.3.1.1.15', 'vtpVlanSteHopCount', 819, 'current', NULL, 'The maximum number of bridge hops allowed in Spanning Tree Explorer frames on this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanType has a value of fddi(2) or tokenRing(3).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (835, '.1.3.6.1.4.1.9.9.46.1.3.1.1.16', 'vtpVlanIsCRFBackup', 819, 'current', NULL, 'True if this VLAN is of type trCrf and also is acting as a backup trCrf for the ISL distributed BRF', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (836, '.1.3.6.1.4.1.9.9.46.1.3.1.1.17', 'vtpVlanTypeExt', 819, 'current', NULL, 'The additional type information of this VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (837, '.1.3.6.1.4.1.9.9.46.1.4', 'vlanEdit', 798, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5408, '.1.3.6.1.4.1.9.9.703.2.2.1', 'cfmRtpMetricsGroup', 5406, 'current', NULL, 'This group contains objects that describe RTP metrics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (838, '.1.3.6.1.4.1.9.9.46.1.4.1', 'vtpEditControlTable', 837, 'current', NULL, 'This table provides the means to control the editing of the VLANs for a particular management domain. Each and every entry in this table augments its corresponding entry in the managementDomainTable; thus, an entry in this table is created/deleted only as a by-product of creating/deleting an entry in the managementDomainTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (839, '.1.3.6.1.4.1.9.9.46.1.4.1.1', 'vtpEditControlEntry', 838, 'current', NULL, 'Control information for editing the VLANs in one management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (840, '.1.3.6.1.4.1.9.9.46.1.4.1.1.1', 'vtpVlanEditOperation', 839, 'current', NULL, 'This object always has the value ''none'' when read. When written, each value causes the appropriate action:  ''copy'' - causes the creation of rows in the vtpVlanEditTable exactly corresponding to the current global VLAN information for this management domain. If the Edit Buffer (for this management domain) is not currently empty, a copy operation fails. A successful copy operation starts the deadman-timer.  ''apply'' - first performs a consistent check on the the modified information contained in the Edit Buffer, and if consistent, then tries to instanciate the modified information as the new global VLAN information. Note that an empty Edit Buffer (for the management domain) would always result in an inconsistency since the default VLANs are required to be present.  ''release'' - flushes the Edit Buffer (for this management domain), clears the Owner information, and aborts the deadman-timer. A release is generated automatically if the deadman-timer ever expires.  ''restartTimer'' - restarts the deadman-timer.  ''none'' - no operation is performed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (841, '.1.3.6.1.4.1.9.9.46.1.4.1.1.2', 'vtpVlanApplyStatus', 839, 'current', NULL, 'The current status of an ''apply'' operation to instanciate the Edit Buffer as the new global VLAN information (for this management domain). If no apply is currently active, the status represented is that of the most recently completed apply. The possible values are:  inProgress - ''apply'' operation in progress;  succeeded - the ''apply'' was successful (this value is also used when no apply has been invoked since the last time the local system restarted);  configNumberError - the apply failed because the value of vtpVlanEditConfigRevNumber was less or equal to the value of current value of vtpConfigRevNumber;  inconsistentEdit - the apply failed because the modified information was not self-consistent;  tooBig - the apply failed because the modified information was too large to fit in this VTP Server''s non-volatile storage location;  localNVStoreFail - the apply failed in trying to store the new information in a local non-volatile storage location;  remoteNVStoreFail - the apply failed in trying to store the new information in a remote non-volatile storage location;  editBufferEmpty - the apply failed because the Edit Buffer was empty (for this management domain).  someOtherError - the apply failed for some other reason (e.g., insufficient memory).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (842, '.1.3.6.1.4.1.9.9.46.1.4.1.1.3', 'vtpVlanEditBufferOwner', 839, 'current', NULL, 'The management station which is currently using the Edit Buffer for this management domain. When the Edit Buffer for a management domain is not currently in use, the value of this object is the zero-length string. Note that it is also the zero-length string if a manager fails to set this object when invoking a copy operation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (843, '.1.3.6.1.4.1.9.9.46.1.4.1.1.4', 'vtpVlanEditConfigRevNumber', 839, 'current', NULL, 'The Configuration Revision Number to be used for the next apply operation. This value is initialized (by the agent) on a copy operation to be one greater than the value of vtpConfigRevNumber. On an apply, if the number is less or equal to the value of vtpConfigRevNumber, then the apply fails. The value can be modified (increased) by network management before an apply to ensure than an apply does not fail for this reason.  This object is used to allow management control over whether a configuration revision received via a VTP advertisement after a copy operation but before the succeeding apply operation is lost by being overwritten by the (local) edit operation. By default, the apply operation will fail in this situation. By increasing this object''s value after the copy but before the apply, management can control whether the apply is to succeed (with the update via VTP advertisement being lost).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (844, '.1.3.6.1.4.1.9.9.46.1.4.2', 'vtpVlanEditTable', 837, 'current', NULL, 'The table which contains the information in the Edit Buffers, one Edit Buffer per management domain. The information for a particular management domain is initialized, by a ''copy'' operation, to be the current global VLAN information for that management domain. After initialization, editing can be performed to add VLANs, delete VLANs, or modify their global parameters. The information as modified through editing is local to this Edit Buffer. An apply operation using the vtpVlanEditOperation object is necessary to instanciate the modified information as the new global VLAN information for that management domain.  To use the Edit Buffer, a manager acts as follows:  1. ensures the Edit Buffer for a management domain is empty, i.e., there are no rows in this table for this management domain.  2. issues a SNMP set operation which sets vtpVlanEditOperation to ''copy'', and vtpVlanEditBufferOwner to its own identifier (e.g., its own IP address).  3. if this set operation is successful, proceeds to edit the information in the vtpVlanEditTable.  4. if and when the edited information is to be instantiated, issues a SNMP set operation which sets vtpVlanEditOperation to ''apply''.  5. issues retrieval requests to obtain the value of vtpVlanApplyStatus, until the result of the apply is determined.  6. releases the Edit Buffer by issuing a SNMP set operation which sets vtpVlanEditOperation to ''release''.  Note that the information contained in this table is not saved across agent reboots.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (845, '.1.3.6.1.4.1.9.9.46.1.4.2.1', 'vtpVlanEditEntry', 844, 'current', NULL, 'Information about one VLAN in the Edit Buffer for a particular management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (846, '.1.3.6.1.4.1.9.9.46.1.4.2.1.1', 'vtpVlanEditIndex', 845, 'current', NULL, 'The VLAN-id which this VLAN would have on ISL trunks.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (847, '.1.3.6.1.4.1.9.9.46.1.4.2.1.2', 'vtpVlanEditState', 845, 'current', NULL, 'The state which this VLAN would have.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (848, '.1.3.6.1.4.1.9.9.46.1.4.2.1.3', 'vtpVlanEditType', 845, 'current', NULL, 'The type which this VLAN would have. An implementation may restrict access to this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (849, '.1.3.6.1.4.1.9.9.46.1.4.2.1.4', 'vtpVlanEditName', 845, 'current', NULL, 'The name which this VLAN would have. This name would be used as the ELAN-name for an ATM LAN-Emulation segment of this VLAN.  An implementation may restrict access to this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (850, '.1.3.6.1.4.1.9.9.46.1.4.2.1.5', 'vtpVlanEditMtu', 845, 'current', NULL, 'The MTU size which this VLAN would have, defined as the size of largest MAC-layer (information field portion of the) data frame which can be transmitted on the VLAN.  An implementation may restrict access to this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (851, '.1.3.6.1.4.1.9.9.46.1.4.2.1.6', 'vtpVlanEditDot10Said', 845, 'current', NULL, 'The value of the 802.10 SAID field which would be used for this VLAN.  An implementation may restrict access to this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (852, '.1.3.6.1.4.1.9.9.46.1.4.2.1.7', 'vtpVlanEditRingNumber', 845, 'current', NULL, 'The ring number which would be used for this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanEditType has a value of ''fddi'' or ''tokenRing'' and Source Routing (SRB) is configured for use on this VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6289, '.1.0.8802.1.1.2.1.3.7', 'lldpLocPortTable', 6248, 'current', NULL, 'This table contains one or more rows per port information associated with the local system known to this agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (853, '.1.3.6.1.4.1.9.9.46.1.4.2.1.8', 'vtpVlanEditBridgeNumber', 845, 'current', NULL, 'The bridge number of the VTP-capable switches which would be used for this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanEditType has a value of fddiNet(4) or trNet(5).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (854, '.1.3.6.1.4.1.9.9.46.1.4.2.1.9', 'vtpVlanEditStpType', 845, 'current', NULL, 'The type of the Spanning Tree Protocol which would be running on this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanEditType has a value of fddiNet(4) or trNet(5).  If ''ieee'' is selected, the STP that runs will be IEEE.  If ''ibm'' is selected, the STP that runs will be IBM.  If ''auto'' is selected, the STP that runs will be dependant on the values of vtpVlanEditBridgeType for all children tokenRing/fddi type VLANs. This will result in a ''hybrid'' STP (see vtpVlanStpType).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (855, '.1.3.6.1.4.1.9.9.46.1.4.2.1.10', 'vtpVlanEditParentVlan', 845, 'current', NULL, 'The VLAN index of the VLAN which would be the parent for this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanEditType has a value of ''fddi'' or ''tokenRing'' and Source Routing (SRB) is configured for use on this VLAN. The parent VLAN must have a vtpVlanEditType value of fddiNet(4) or trNet(5), respectively.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (856, '.1.3.6.1.4.1.9.9.46.1.4.2.1.11', 'vtpVlanEditRowStatus', 845, 'current', NULL, 'The status of this row. Any and all columnar objects in an existing row can be modified irrespective of the status of the row.  A row is not qualified for activation until instances of at least its vtpVlanEditType, vtpVlanEditName and vtpVlanEditDot10Said columns have appropriate values.  The management station should endeavor to make all rows consistent in the table before ''apply''ing the buffer. An inconsistent entry in the table will cause the entire buffer to be rejected with the vtpVlanApplyStatus object set to the appropriate error value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (857, '.1.3.6.1.4.1.9.9.46.1.4.2.1.12', 'vtpVlanEditTranslationalVlan1', 845, 'current', NULL, 'A VLAN to which this VLAN would be translational-bridged. If this value and the corresponding instance of vtpVlanTranslationalVlan2 are both zero, then this VLAN would not be translational-bridged.  An implementation may restrict access to this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (858, '.1.3.6.1.4.1.9.9.46.1.4.2.1.13', 'vtpVlanEditTranslationalVlan2', 845, 'current', NULL, 'Another VLAN, i.e., other than that indicated by vtpVlanEditTranslationalVlan1, to which this VLAN would be translational-bridged. If this value and the corresponding instance of vtpVlanTranslationalVlan1 are both zero, then this VLAN would not be translational-bridged.  An implementation may restrict access to this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (859, '.1.3.6.1.4.1.9.9.46.1.4.2.1.14', 'vtpVlanEditBridgeType', 845, 'current', NULL, 'The type of bridging mode which would be in use on this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanEditType has a value of fddi(2) or tokenRing(3).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (860, '.1.3.6.1.4.1.9.9.46.1.4.2.1.15', 'vtpVlanEditAreHopCount', 845, 'current', NULL, 'The maximum number of bridge hops allowed in All Routes Explorer frames on this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanType has a value of fddi(2) or tokenRing(3).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (861, '.1.3.6.1.4.1.9.9.46.1.4.2.1.16', 'vtpVlanEditSteHopCount', 845, 'current', NULL, 'The maximum number of bridge hops allowed in Spanning Tree Explorer frames on this VLAN. This object is only instantiated when the value of the corresponding instance of vtpVlanType has a value of fddi(2) or tokenRing(3).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (862, '.1.3.6.1.4.1.9.9.46.1.4.2.1.17', 'vtpVlanEditIsCRFBackup', 845, 'current', NULL, 'True if this VLAN is of type trCrf and also is acting as a backup trCrf for the ISL distributed BRF. This object is only instantiated when the value of the corresponding instance of vtpVlanEditType has a value of tokenRing(3).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (863, '.1.3.6.1.4.1.9.9.46.1.4.2.1.18', 'vtpVlanEditTypeExt', 845, 'current', NULL, 'The additional type information of this VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (864, '.1.3.6.1.4.1.9.9.46.1.5', 'vtpStats', 798, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (865, '.1.3.6.1.4.1.9.9.46.1.5.1', 'vtpStatsTable', 864, 'current', NULL, 'A table of VTP statistics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (866, '.1.3.6.1.4.1.9.9.46.1.5.1.1', 'vtpStatsEntry', 865, 'current', NULL, 'VTP statistics for one management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (867, '.1.3.6.1.4.1.9.9.46.1.5.1.1.1', 'vtpInSummaryAdverts', 866, 'current', NULL, 'The total number of VTP Summary Adverts received for this management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (868, '.1.3.6.1.4.1.9.9.46.1.5.1.1.2', 'vtpInSubsetAdverts', 866, 'current', NULL, 'The total number of VTP Subset Adverts received for this management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (869, '.1.3.6.1.4.1.9.9.46.1.5.1.1.3', 'vtpInAdvertRequests', 866, 'current', NULL, 'The total number of VTP Advert Requests received for this management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (870, '.1.3.6.1.4.1.9.9.46.1.5.1.1.4', 'vtpOutSummaryAdverts', 866, 'current', NULL, 'The total number of VTP Summary Adverts sent for this management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (871, '.1.3.6.1.4.1.9.9.46.1.5.1.1.5', 'vtpOutSubsetAdverts', 866, 'current', NULL, 'The total number of VTP Subset Adverts sent for this management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (872, '.1.3.6.1.4.1.9.9.46.1.5.1.1.6', 'vtpOutAdvertRequests', 866, 'current', NULL, 'The total number of VTP Advert Requests sent for this management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (873, '.1.3.6.1.4.1.9.9.46.1.5.1.1.7', 'vtpConfigRevNumberErrors', 866, 'current', NULL, 'The number of occurrences of configuration revision number errors for this management domain. A configuration revision number error occurs when a device receives a VTP advertisement for which:  - the advertisement''s Configuration Revision Number is the same as the current locally-held value, and  - the advertisement''s digest value is different from the current locally-held value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (874, '.1.3.6.1.4.1.9.9.46.1.5.1.1.8', 'vtpConfigDigestErrors', 866, 'current', NULL, 'The number of occurrences of configuration digest errors for this management domain. A configuration digest error occurs when a device receives a VTP advertisement for which:  - the advertisement''s Configuration Revision Number is greater than the current locally-held value, and  - the advertisement''s digest value does not match the VLAN information assumed by the receiver of the advertisement, where the infomation assumed is the combination of the information explicitly contained in the advertisement plus any omitted information as currently known by the receiving device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (875, '.1.3.6.1.4.1.9.9.46.1.6', 'vlanTrunkPorts', 798, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (876, '.1.3.6.1.4.1.9.9.46.1.6.1', 'vlanTrunkPortTable', 875, 'current', NULL, 'The table containing information on the local system''s VLAN trunk ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (877, '.1.3.6.1.4.1.9.9.46.1.6.1.1', 'vlanTrunkPortEntry', 876, 'current', NULL, 'Information about one trunk port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (878, '.1.3.6.1.4.1.9.9.46.1.6.1.1.1', 'vlanTrunkPortIfIndex', 877, 'current', NULL, 'The value of ifIndex for the interface corresponding to this trunk port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (879, '.1.3.6.1.4.1.9.9.46.1.6.1.1.2', 'vlanTrunkPortManagementDomain', 877, 'current', NULL, 'The value of managementDomainIndex for the management domain on this trunk port. Devices which support only one management domain will support this object read-only.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (918, '.1.3.6.1.4.1.9.9.46.2.0.7', 'vlanTrunkPortDynamicStatusChange', 910, 'current', NULL, 'A vlanTrunkPortDynamicStatusChange notification is generated by a device when the value of vlanTrunkPortDynamicStatus object has been changed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1160, '.1.3.6.1.2.1.27', 'application', 21, 'current', NULL, 'The MIB module describing network service applications', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (880, '.1.3.6.1.4.1.9.9.46.1.6.1.1.3', 'vlanTrunkPortEncapsulationType', 877, 'current', NULL, 'The type of VLAN encapsulation desired to be used on this trunk port. It is either a particular type, or ''negotiate'' meaning whatever type results from the negotiation. negotiate(5) is not allowed if the port does not support negotiation or if its vlanTrunkPortDynamicState is set to on(1) or onNoNegotiate(5). Whether writing to this object in order to modify the encapsulation is supported is both device and interface specific.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (881, '.1.3.6.1.4.1.9.9.46.1.6.1.1.4', 'vlanTrunkPortVlansEnabled', 877, 'current', NULL, 'A string of octets containing one bit per VLAN in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 0 through 7; the second octet to VLANs 8 through 15; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet. If the bit corresponding to a VLAN is set to ''1'', then the local system is enabled for sending and receiving frames on that VLAN; if the bit is set to ''0'', then the system is disabled from sending and receiving frames on that VLAN.  To avoid conflicts between overlapping partial updates by multiple managers, i.e., updates which modify only a portion of an instance of this object (e.g., enable/disable a single VLAN on the trunk port), any SNMP Set operation accessing an instance of this object should also write the value of vlanTrunkPortSetSerialNo.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (882, '.1.3.6.1.4.1.9.9.46.1.6.1.1.5', 'vlanTrunkPortNativeVlan', 877, 'current', NULL, 'The VlanIndex of the VLAN which is represented by native frames on this trunk port. For trunk ports not supporting the sending and receiving of native frames, this value should be set to zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (883, '.1.3.6.1.4.1.9.9.46.1.6.1.1.6', 'vlanTrunkPortRowStatus', 877, 'current', NULL, 'The status of this row. In some circumstances, the creation of a row in this table is needed to enable the appropriate trunking/tagging protocol on the port, to enable the use of VTP on the port, and to assign the port to the appropriate management domain. In other circumstances, rows in this table will be created as a by-product of other operations.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (884, '.1.3.6.1.4.1.9.9.46.1.6.1.1.7', 'vlanTrunkPortInJoins', 877, 'current', NULL, 'The number of VTP Join messages received on this trunk port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (885, '.1.3.6.1.4.1.9.9.46.1.6.1.1.8', 'vlanTrunkPortOutJoins', 877, 'current', NULL, 'The number of VTP Join messages sent on this trunk port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (886, '.1.3.6.1.4.1.9.9.46.1.6.1.1.9', 'vlanTrunkPortOldAdverts', 877, 'current', NULL, 'The number of VTP Advertisement messages which indicated the sender does not support VLAN-pruning received on this trunk port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (887, '.1.3.6.1.4.1.9.9.46.1.6.1.1.10', 'vlanTrunkPortVlansPruningEligible', 877, 'current', NULL, 'A string of octets containing one bit per VLAN in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 0 through 7; the second octet to VLANs 8 through 15; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then the local system is permitted to prune that VLAN on this trunk port; if the bit is set to ''0'', then the system must not prune that VLAN on this trunk port.  To avoid conflicts between overlapping partial updates by multiple managers, i.e., updates which modify only a portion of an instance of this object (e.g., enable/disable a single VLAN on the trunk port), any SNMP Set operation accessing an instance of this object should also write the value of vlanTrunkPortSetSerialNo.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (888, '.1.3.6.1.4.1.9.9.46.1.6.1.1.11', 'vlanTrunkPortVlansXmitJoined', 877, 'current', NULL, 'A string of octets containing one bit per VLAN in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 0 through 7; the second octet to VLANs 8 through 15; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then this VLAN is presently being forwarded on this trunk port, i.e., it is not pruned; if the bit is set to ''0'', then this VLAN is presently not being forwarded on this trunk port, either because it is pruned or for some other reason.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (889, '.1.3.6.1.4.1.9.9.46.1.6.1.1.12', 'vlanTrunkPortVlansRcvJoined', 877, 'current', NULL, 'A string of octets containing one bit per VLAN in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 0 through 7; the second octet to VLANs 8 through 15; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then the local switch is currently sending joins for this VLAN on this trunk port, i.e., it is asking to receive frames for this VLAN; if the bit is set to ''0'', then the local switch is not currently sending joins for this VLAN on this trunk port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (890, '.1.3.6.1.4.1.9.9.46.1.6.1.1.13', 'vlanTrunkPortDynamicState', 877, 'current', NULL, 'For devices that allows dynamic determination of whether a link between two switches should be a trunk or not, this object allows the operator to mandate the behavior of that dynamic mechanism.  on(1) dictates that the interface will always be a trunk. This is the value for static entries (those that show no dynamic behavior). If the negotiation is supported on this port, negotiation will take place with the far end to attempt to bring the far end into trunking state.  off(2) allows an operator to specify that the specified interface is never to be trunk, regardless of any dynamic mechanisms to the contrary. This value is useful for overriding the default behavior of some switches. If the negotiation is supported on this port, negotiation will take place with the far end to attempt on the link to bring the far end into non-trunking state.  desirable(3) is used to indicate that it is desirable for the interface to become a trunk. The device will initiate any negotiation necessary to become a trunk but will not become a trunk unless it receives confirmation from the far end on the link.  auto(4) is used to indicate that the interface is capable and willing to become a trunk but will not initiate trunking negotiations. The far end on the link are required to either start negotiations or start sending encapsulated packets, on which event the specified interface will become a trunk.  onNoNegotiate(5) is used to indicate that the interface is permanently set to be a trunk, and no negotiation takes place with the far end on the link to ensure consistent operation. This is similar to on(1) except no negotiation takes place with the far end.  If the port does not support negotiation or its vlanTrunkPortEncapsulationType is set to negotiate(5), onNoNegotiate(5) is not allowed.  Devices that do no support dynamic determination (for just a particular interface, encapsulation or for the whole device) need only support the ''on'', and ''off'' values.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (891, '.1.3.6.1.4.1.9.9.46.1.6.1.1.14', 'vlanTrunkPortDynamicStatus', 877, 'current', NULL, 'Indicates whether the specified interface is either acting as a trunk or not. This is a result of the vlanTrunkPortDynamicState and the ifOperStatus of the trunk port itself.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (892, '.1.3.6.1.4.1.9.9.46.1.6.1.1.15', 'vlanTrunkPortVtpEnabled', 877, 'current', NULL, 'Some trunk interface modules allow VTP to be enabled/disabled seperately from that of the central device. In such a case this object provides management a way to remotely enable VTP on that module. If a module does not support a seperate VTP enabled state then this object shall always return ''true'' and will accept no other value during a SET operation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (893, '.1.3.6.1.4.1.9.9.46.1.6.1.1.16', 'vlanTrunkPortEncapsulationOperType', 877, 'current', NULL, 'The type of VLAN encapsulation in use on this trunk port. For intefaces with vlanTrunkPortDynamicStatus of notTrunking(2) the vlanTrunkPortEncapsulationOperType shall be notApplicable(6).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (917, '.1.3.6.1.4.1.9.9.46.2.0.6', 'vtpVersionOneDeviceDetected', 910, 'current', NULL, 'A VTP version one device detected notification is generated by a device when:  a) a management domain has been put into version 2 mode (as accessed by managementDomainVersionInUse). b) 15 minutes has passed since a). c) a version 1 PDU is detected on a trunk on the device that is in that management domain which has a lower revision number than the current configuration.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (938, '.1.3.6.1.4.1.9.9.23', 'ciscoCdpMIB', 272, 'current', NULL, 'The MIB module for management of the Cisco Discovery Protocol in Cisco devices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5540, '.1.3.6.1.4.1.9.9.168.1.3', 'cntpFilter', 5537, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (894, '.1.3.6.1.4.1.9.9.46.1.6.1.1.17', 'vlanTrunkPortVlansEnabled2k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 1024 through 2047 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 1024 through 1031; the second octet to VLANs 1032 through 1039; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet. If the bit corresponding to a VLAN is set to ''1'', then the local system is enabled for sending and receiving frames on that VLAN; if the bit is set to ''0'', then the system is disabled from sending and receiving frames on that VLAN. The default value is zero length string.  To avoid conflicts between overlapping partial updates by multiple managers, i.e., updates which modify only a portion of an instance of this object (e.g., enable/disable a single VLAN on the trunk port), any SNMP Set operation accessing an instance of this object should also write the value of vlanTrunkPortSetSerialNo.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (895, '.1.3.6.1.4.1.9.9.46.1.6.1.1.18', 'vlanTrunkPortVlansEnabled3k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 2048 through 3071 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 2048 through 2055; the second octet to VLANs 2056 through 2063; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet. If the bit corresponding to a VLAN is set to ''1'', then the local system is enabled for sending and receiving frames on that VLAN; if the bit is set to ''0'', then the system is disabled from sending and receiving frames on that VLAN. The default value is zero length string.  To avoid conflicts between overlapping partial updates by multiple managers, i.e., updates which modify only a portion of an instance of this object (e.g., enable/disable a single VLAN on the trunk port), any SNMP Set operation accessing an instance of this object should also write the value of vlanTrunkPortSetSerialNo.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (896, '.1.3.6.1.4.1.9.9.46.1.6.1.1.19', 'vlanTrunkPortVlansEnabled4k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 3072 through 4095 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 3072 through 3079; the second octet to VLANs 3080 through 3087; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet. If the bit corresponding to a VLAN is set to ''1'', then the local system is enabled for sending and receiving frames on that VLAN; if the bit is set to ''0'', then the system is disabled from sending and receiving frames on that VLAN. The default value is zero length string.  To avoid conflicts between overlapping partial updates by multiple managers, i.e., updates which modify only a portion of an instance of this object (e.g., enable/disable a single VLAN on the trunk port), any SNMP Set operation accessing an instance of this object should also write the value of vlanTrunkPortSetSerialNo.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (897, '.1.3.6.1.4.1.9.9.46.1.6.1.1.20', 'vtpVlansPruningEligible2k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 1024 through 2047 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 1024 through 1031; the second octet to VLANs 1032 through 1039; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then the local system is permitted to prune that VLAN on this trunk port; if the bit is set to ''0'', then the system must not prune that VLAN on this trunk port. The default value is zero length string.  To avoid conflicts between overlapping partial updates by multiple managers, i.e., updates which modify only a portion of an instance of this object (e.g., enable/disable a single VLAN on the trunk port), any SNMP Set operation accessing an instance of this object should also write the value of vlanTrunkPortSetSerialNo.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (898, '.1.3.6.1.4.1.9.9.46.1.6.1.1.21', 'vtpVlansPruningEligible3k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 2048 through 3071 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 2048 through 2055; the second octet to VLANs 2056 through 2063; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then the local system is permitted to prune that VLAN on this trunk port; if the bit is set to ''0'', then the system must not prune that VLAN on this trunk port. The default value is zero length string.  To avoid conflicts between overlapping partial updates by multiple managers, i.e., updates which modify only a portion of an instance of this object (e.g., enable/disable a single VLAN on the trunk port), any SNMP Set operation accessing an instance of this object should also write the value of vlanTrunkPortSetSerialNo.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (899, '.1.3.6.1.4.1.9.9.46.1.6.1.1.22', 'vtpVlansPruningEligible4k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 3072 through 4095 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 3072 through 3079; the second octet to VLANs 3080 through 3087; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then the local system is permitted to prune that VLAN on this trunk port; if the bit is set to ''0'', then the system must not prune that VLAN on this trunk port. The default value is zero length string.  To avoid conflicts between overlapping partial updates by multiple managers, i.e., updates which modify only a portion of an instance of this object (e.g., enable/disable a single VLAN on the trunk port), any SNMP Set operation accessing an instance of this object should also write the value of vlanTrunkPortSetSerialNo.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (900, '.1.3.6.1.4.1.9.9.46.1.6.1.1.23', 'vlanTrunkPortVlansXmitJoined2k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 1024 through 2047 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 1024 through 1031; the second octet to VLANs 1032 through 1039; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then this VLAN is presently being forwarded on this trunk port, i.e., it is not pruned; if the bit is set to ''0'', then this VLAN is presently not being forwarded on this trunk port, either because it is pruned or for some other reason.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (901, '.1.3.6.1.4.1.9.9.46.1.6.1.1.24', 'vlanTrunkPortVlansXmitJoined3k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 2048 through 3071 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 2048 through 2055; the second octet to VLANs 2056 through 2063; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then this VLAN is presently being forwarded on this trunk port, i.e., it is not pruned; if the bit is set to ''0'', then this VLAN is presently not being forwarded on this trunk port, either because it is pruned or for some other reason.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (939, '.1.3.6.1.4.1.9.9.23.1', 'ciscoCdpMIBObjects', 938, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (940, '.1.3.6.1.4.1.9.9.23.1.1', 'cdpInterface', 939, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (902, '.1.3.6.1.4.1.9.9.46.1.6.1.1.25', 'vlanTrunkPortVlansXmitJoined4k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 3072 through 4095 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 3072 through 3079; the second octet to VLANs 3080 through 3087; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then this VLAN is presently being forwarded on this trunk port, i.e., it is not pruned; if the bit is set to ''0'', then this VLAN is presently not being forwarded on this trunk port, either because it is pruned or for some other reason.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (903, '.1.3.6.1.4.1.9.9.46.1.6.1.1.26', 'vlanTrunkPortVlansRcvJoined2k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 1024 through 2047 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 1024 through 1031; the second octet to VLANs 1032 through 1039; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then the local switch is currently sending joins for this VLAN on this trunk port, i.e., it is asking to receive frames for this VLAN; if the bit is set to ''0'', then the local switch is not currently sending joins for this VLAN on this trunk port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (904, '.1.3.6.1.4.1.9.9.46.1.6.1.1.27', 'vlanTrunkPortVlansRcvJoined3k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 2048 through 3071 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 2048 through 2055; the second octet to VLANs 2056 through 2063; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then the local switch is currently sending joins for this VLAN on this trunk port, i.e., it is asking to receive frames for this VLAN; if the bit is set to ''0'', then the local switch is not currently sending joins for this VLAN on this trunk port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (905, '.1.3.6.1.4.1.9.9.46.1.6.1.1.28', 'vlanTrunkPortVlansRcvJoined4k', 877, 'current', NULL, 'A string of octets containing one bit per VLAN for VLANS with VlanIndex values of 3072 through 4095 in the management domain on this trunk port. The first octet corresponds to VLANs with VlanIndex values of 3072 through 3079; the second octet to VLANs 3080 through 3087; etc. The most significant bit of each octet corresponds to the lowest value VlanIndex in that octet.  If the bit corresponding to a VLAN is set to ''1'', then the local switch is currently sending joins for this VLAN on this trunk port, i.e., it is asking to receive frames for this VLAN; if the bit is set to ''0'', then the local switch is not currently sending joins for this VLAN on this trunk port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (906, '.1.3.6.1.4.1.9.9.46.1.6.1.1.29', 'vlanTrunkPortDot1qTunnel', 877, 'current', NULL, 'Indicates dot1qtunnel mode of the port.  If the portDot1qTunnel is set to ''trunk'' mode, the port''s vlanTrunkPortDynamicState will be changed to ''onNoNegotiate'' and the vlanTrunkPortEncapsulationType will be set to ''dot1Q''. These values cannot be changed unless dot1q tunnel is disabled on this port.  If the portDot1qTunnel mode is set to ''access'' mode, the port''s vlanTrunkPortDynamicState will be set to ''off''.And the value of vlanTrunkPortDynamicState cannot be changed unless dot1q tunnel is disabled on this port. 1Q packets received on this access port will remain.  Setting the port to dot1q tunnel ''disabled'' mode causes the dot1q tunnel feature to be disabled on this port. This object can''t be set to ''trunk'' or ''access'' mode, when vlanTrunkPortsDot1qTag object is set to ''false''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (907, '.1.3.6.1.4.1.9.9.46.1.6.2', 'vlanTrunkPortSetSerialNo', 875, 'current', NULL, 'An advisory lock used to allow several cooperating SNMPv2 managers to coordinate their use of the SNMPv2 set operation acting upon any instance of vlanTrunkPortVlansEnabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (908, '.1.3.6.1.4.1.9.9.46.1.6.3', 'vlanTrunkPortsDot1qTag', 875, 'current', NULL, 'An indication of whether the tagging on all VLANs including native VLAN for all 802.1q trunks is enabled.  If this object has a value of true(1) then all VLANs including native VLAN are tagged. If the value is false(2) then all VLANs excluding native VLAN are tagged.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (909, '.1.3.6.1.4.1.9.9.46.2', 'vtpNotifications', 797, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (910, '.1.3.6.1.4.1.9.9.46.2.0', 'vtpNotificationsPrefix', 909, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (911, '.1.3.6.1.4.1.9.9.46.2.1', 'vtpNotificationsObjects', 909, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (912, '.1.3.6.1.4.1.9.9.46.2.0.1', 'vtpConfigRevNumberError', 910, 'current', NULL, 'A configuration revision number error notification signifies that a device has incremented its vtpConfigRevNumberErrors counter.  Generation of this notification is suppressed if the vtpNotificationsEnabled has the value ''false''.  The device must throttle the generation of consecutive vtpConfigRevNumberError notifications so that there is at least a five-second gap between notification of this type. When notification are throttled, they are dropped, not queued for sending at a future time. (Note that ''generating'' a notification means sending to all configured recipients.)', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (913, '.1.3.6.1.4.1.9.9.46.2.0.2', 'vtpConfigDigestError', 910, 'current', NULL, 'A configuration digest error notification signifies that a device has incremented its vtpConfigDigestErrors counter.  Generation of this notification is suppressed if the vtpNotificationsEnabled has the value ''false''.  The device must throttle the generation of consecutive vtpConfigDigestError notifications so that there is at least a five-second gap between notification of this type. When notification are throttled, they are dropped, not queued for sending at a future time. (Note that ''generating'' a notification means sending to all configured recipients.)', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (914, '.1.3.6.1.4.1.9.9.46.2.0.3', 'vtpServerDisabled', 910, 'current', NULL, 'A VTP Server disabled notification is generated when the local system is no longer able to function as a VTP Server because the number of defined VLANs is greater than vtpMaxVlanStorage.  Generation of this notification is suppressed if the vtpNotificationsEnabled has the value ''false''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (915, '.1.3.6.1.4.1.9.9.46.2.0.4', 'vtpMtuTooBig', 910, 'current', NULL, 'A VTP MTU tooBig notification is generated when a VLAN''s MTU size is larger than can be supported either:  - by one or more of its trunk ports: the included vtpVlanState has the value ''mtuTooBigForTrunk'' and the included vlanTrunkPortManagementDomain is for the first (or only) trunk port, or  - by the device itself: vtpVlanState has the value ''mtuTooBigForDevice'' and any instance of vlanTrunkPortManagementDomain is included.  Devices which have no trunk ports do not send vtpMtuTooBig notifications.  Generation of this notification is suppressed if the vtpNotificationsEnabled has the value ''false''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (916, '.1.3.6.1.4.1.9.9.46.2.0.5', 'vtpVlanRingNumberConfigConflict', 910, 'current', NULL, 'A VTP ring number configuration conflict notification is generated if, and only at the time when, a device learns of a conflict between:  a) the ring number (vtpVlanPortLocalSegment) being used on a token ring segment attached to the port identified by ifIndex, and  b) the VTP-obtained ring number (vtpVlanRingNumber) for the VLAN identified by vtpVlanIndex.  When such a conflict occurs, the bridge port is put into an administrative down position until the conflict is resolved through local/network management intervention.  This notification is only applicable to VLANs of type ''tokenRing''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5448, '.1.3.6.1.2.1.47.3.2', 'entityGroups', 5446, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (919, '.1.3.6.1.4.1.9.9.46.2.1.1', 'vtpVlanPortLocalSegment', 911, 'current', NULL, 'The ring (segment) number in use on a 802.5 ring. For bridges supporting RFC 1525, this value is the same as given by dot1dSrPortLocalSegment for the bridge port attached to that ring. When tokenRing VLANs are in use, each ''trNet'' VLAN can/does have a different instance of dot1dSrPortLocalSegment for each physical port. Note that access to the particuler instance of dot1dSrPortLocalSegment requires knowledge of how the agent supports the multiple ''contexts'' required to implement RFC 1525 for multiple VLANs; also note that the assignment of ifIndex values may be different in different ''contexts''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (920, '.1.3.6.1.4.1.9.9.46.3', 'vtpMIBConformance', 797, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (921, '.1.3.6.1.4.1.9.9.46.3.1', 'vtpMIBCompliances', 920, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (922, '.1.3.6.1.4.1.9.9.46.3.2', 'vtpMIBGroups', 920, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (923, '.1.3.6.1.4.1.9.9.46.3.1.1', 'vtpMIBCompliance', 921, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (924, '.1.3.6.1.4.1.9.9.46.3.1.2', 'vtpMIBCompliance2', 921, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (925, '.1.3.6.1.4.1.9.9.46.3.1.3', 'vtpMIBCompliance3', 921, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (926, '.1.3.6.1.4.1.9.9.46.3.2.1', 'vtpBasicGroup', 922, 'current', NULL, 'A collection of objects providing basic status and control of a VTP implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (927, '.1.3.6.1.4.1.9.9.46.3.2.13', 'vtpVlanInfoGroup', 922, 'current', NULL, 'A collection of objects for monitoring VLAN information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (928, '.1.3.6.1.4.1.9.9.46.3.2.14', 'vtpVlanInfoEditGroup', 922, 'current', NULL, 'A collection of objects for editing VLAN information in VTP Servers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (929, '.1.3.6.1.4.1.9.9.46.3.2.4', 'vtpStatsGroup', 922, 'current', NULL, 'A collection of objects providing VTP statistics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (930, '.1.3.6.1.4.1.9.9.46.3.2.5', 'vtpTrunkPortGroup', 922, 'current', NULL, 'A collection of objects providing information on trunk ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (931, '.1.3.6.1.4.1.9.9.46.3.2.11', 'vtpTrunkPortGroup2', 922, 'current', NULL, 'Additional functionality added to the vlanTrunkPortTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (932, '.1.3.6.1.4.1.9.9.46.3.2.15', 'vtpTrunkPortGroup3', 922, 'current', NULL, 'Additional functionality added to the vlanTrunkPortTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (933, '.1.3.6.1.4.1.9.9.46.3.2.7', 'vtpTrunkPruningGroup', 922, 'current', NULL, 'A collection of objects providing information on VLAN pruning.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (934, '.1.3.6.1.4.1.9.9.46.3.2.10', 'vtpTrunkPruningGroup2', 922, 'current', NULL, 'A collection of object providing information on whether VLAN pruning is enabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (935, '.1.3.6.1.4.1.9.9.46.3.2.12', 'vtpVersion2BasicGroup', 922, 'current', NULL, 'The object required to indicate the version of VTP in use by a management domain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (936, '.1.3.6.1.4.1.9.9.46.3.2.16', 'vtp4kVlanGroup', 922, 'current', NULL, 'A collection of objects providing information for VLANS with VlanIndex from 1024 to 4095.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (937, '.1.3.6.1.4.1.9.9.46.3.2.17', 'vtpDot1qTunnelGroup', 922, 'current', NULL, 'A collection of objects providing information for dot1qtunnel feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5883, '.1.3.6.1.2.1.19.3.1.2', 'charSessIndex', 5881, 'current', NULL, 'The session index in the context of the port, a non-zero positive integer. Session indexes within a port need not be sequential. Session indexes may be reused for different ports. For example, port 1 and port 3 may both have a session 2 at the same time. Session indexes may have any valid integer value, with any meaning convenient to the agent implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5884, '.1.3.6.1.2.1.19.3.1.3', 'charSessKill', 5881, 'current', NULL, 'A control to terminate the session. In response to a get-request or get-next-request, the agent always returns ''ready'' as the value. Setting the value to ''execute'' causes termination.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5885, '.1.3.6.1.2.1.19.3.1.4', 'charSessState', 5881, 'current', NULL, 'The current operational state of the session, disregarding flow control. ''connected'' indicates that character data could flow on the network side of session. ''connecting'' indicates moving from nonexistent toward ''connected''. ''disconnecting'' indicates moving from ''connected'' or ''connecting'' to nonexistent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5886, '.1.3.6.1.2.1.19.3.1.5', 'charSessProtocol', 5881, 'current', NULL, 'The network protocol over which the session is running. Other OBJECT IDENTIFIER values may be defined elsewhere, in association with specific protocols. However, this document assigns those of known interest as of this writing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5887, '.1.3.6.1.2.1.19.4', 'wellKnownProtocols', 5855, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5888, '.1.3.6.1.2.1.19.4.1', 'protocolOther', 5887, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5889, '.1.3.6.1.2.1.19.4.2', 'protocolTelnet', 5887, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5890, '.1.3.6.1.2.1.19.4.3', 'protocolRlogin', 5887, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5891, '.1.3.6.1.2.1.19.4.4', 'protocolLat', 5887, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5892, '.1.3.6.1.2.1.19.4.5', 'protocolX29', 5887, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5893, '.1.3.6.1.2.1.19.4.6', 'protocolVtp', 5887, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5894, '.1.3.6.1.2.1.19.3.1.6', 'charSessOperOrigin', 5881, 'current', NULL, 'The session''s source of establishment.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5895, '.1.3.6.1.2.1.19.3.1.7', 'charSessInCharacters', 5881, 'current', NULL, 'This session''s subset of charPortInCharacters.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5896, '.1.3.6.1.2.1.19.3.1.8', 'charSessOutCharacters', 5881, 'current', NULL, 'This session''s subset of charPortOutCharacters.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5897, '.1.3.6.1.2.1.19.3.1.9', 'charSessConnectionId', 5881, 'current', NULL, 'A reference to additional local MIB information. This should be the highest available related MIB, corresponding to charSessProtocol, such as Telnet. For example, the value for a TCP connection (in the absence of a Telnet MIB) is the object identifier of tcpConnState. If an agent is not configured to have such values, the agent returns the object identifier:  nullConnectionId OBJECT IDENTIFIER ::= ( 0 0 )', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5898, '.1.3.6.1.2.1.19.3.1.10', 'charSessStartTime', 5881, 'current', NULL, 'The value of sysUpTime in MIB-2 when the session entered connecting state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5899, '.1.3.6.1.2.1.19.5', 'charConformance', 5855, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5900, '.1.3.6.1.2.1.19.5.1', 'charGroups', 5899, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5901, '.1.3.6.1.2.1.19.5.2', 'charCompliances', 5899, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5902, '.1.3.6.1.2.1.19.5.2.1', 'charCompliance', 5901, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5903, '.1.3.6.1.2.1.19.5.1.1', 'charGroup', 5900, 'current', NULL, 'A collection of objects providing information applicable to all Character interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5859, '.1.3.6.1.2.1.19.2.1.1', 'charPortIndex', 5858, 'current', NULL, 'A unique value for each character port, perhaps corresponding to the same value of ifIndex when the character port is associated with a hardware port represented by an ifIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5860, '.1.3.6.1.2.1.19.2.1.2', 'charPortName', 5858, 'current', NULL, 'An administratively assigned name for the port, typically with some local significance.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5861, '.1.3.6.1.2.1.19.2.1.3', 'charPortType', 5858, 'current', NULL, 'The port''s type, ''physical'' if the port represents an external hardware connector, ''virtual'' if it does not.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5862, '.1.3.6.1.2.1.19.2.1.4', 'charPortHardware', 5858, 'current', NULL, 'A reference to hardware MIB definitions specific to a physical port''s external connector. For example, if the connector is RS-232, then the value of this object refers to a MIB sub-tree defining objects specific to RS-232. If an agent is not configured to have such values, the agent returns the object identifier:  nullHardware OBJECT IDENTIFIER ::= ( 0 0 )', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5748, '.1.3.6.1.4.1.9.9.97.1.4.2.1.4', 'cseL3VlanOutPkts', 5744, 'current', NULL, 'Number of packets Layer-3 forwarded to this Vlan by this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5646, '.1.3.6.1.4.1.9.9.97.1.2.6.1.1', 'cseRouterMac', 5645, 'current', NULL, 'Mac address used by the router for this VLAN number.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (945, '.1.3.6.1.4.1.9.9.23.1.1.1.1.1', 'cdpInterfaceIfIndex', 944, 'current', NULL, 'The ifIndex value of the local interface.  For 802.3 Repeaters on which the repeater ports do not have ifIndex values assigned, this value is a unique value for the port, and greater than any ifIndex value supported by the repeater; in this case, the specific port is indicated by corresponding values of cdpInterfaceGroup and cdpInterfacePort, where these values correspond to the group number and port number values of RFC 1516.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (946, '.1.3.6.1.4.1.9.9.23.1.1.1.1.2', 'cdpInterfaceEnable', 944, 'current', NULL, 'An indication of whether the Cisco Discovery Protocol is currently running on this interface. This variable has no effect when CDP is disabled (cdpGlobalRun = FALSE).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (947, '.1.3.6.1.4.1.9.9.23.1.1.1.1.3', 'cdpInterfaceMessageInterval', 944, 'obsolete', NULL, 'The interval at which CDP messages are to be generated on this interface. The default value is 60 seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (948, '.1.3.6.1.4.1.9.9.23.1.1.1.1.4', 'cdpInterfaceGroup', 944, 'current', NULL, 'This object is only relevant to interfaces which are repeater ports on 802.3 repeaters. In this situation, it indicates the RFC1516 group number of the repeater port which corresponds to this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (949, '.1.3.6.1.4.1.9.9.23.1.1.1.1.5', 'cdpInterfacePort', 944, 'current', NULL, 'This object is only relevant to interfaces which are repeater ports on 802.3 repeaters. In this situation, it indicates the RFC1516 port number of the repeater port which corresponds to this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (950, '.1.3.6.1.4.1.9.9.23.1.1.2', 'cdpInterfaceExtTable', 940, 'current', NULL, 'This table contains the additional CDP configuration on the device''s interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (951, '.1.3.6.1.4.1.9.9.23.1.1.2.1', 'cdpInterfaceExtEntry', 950, 'current', NULL, 'An entry in the cdpInterfaceExtTable contains the values configured for Extented Trust TLV and COS (Class of Service) for Untrusted Ports TLV on an interface which supports the sending of these TLVs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (952, '.1.3.6.1.4.1.9.9.23.1.1.2.1.1', 'cdpInterfaceExtendedTrust', 951, 'current', NULL, 'Indicates the value to be sent by Extended Trust TLV.  If trusted(1) is configured, the value of Extended Trust TLV is one byte in length with its least significant bit equal to 1 to indicate extended trust. All other bits are 0.  If noTrust(2) is configured, the value of Extended Trust TLV is one byte in length with its least significant bit equal to 0 to indicate no extended trust. All other bits are 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (953, '.1.3.6.1.4.1.9.9.23.1.1.2.1.2', 'cdpInterfaceCosForUntrustedPort', 951, 'current', NULL, 'Indicates the value to be sent by COS for Untrusted Ports TLV.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (954, '.1.3.6.1.4.1.9.9.23.1.2.1', 'cdpCacheTable', 941, 'current', NULL, 'The (conceptual) table containing the cached information obtained via receiving CDP messages.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (955, '.1.3.6.1.4.1.9.9.23.1.2.1.1', 'cdpCacheEntry', 954, 'current', NULL, 'An entry (conceptual row) in the cdpCacheTable, containing the information received via CDP on one interface from one device. Entries appear when a CDP advertisement is received from a neighbor device. Entries disappear when CDP is disabled on the interface, or globally.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (956, '.1.3.6.1.4.1.9.9.23.1.2.1.1.1', 'cdpCacheIfIndex', 955, 'current', NULL, 'Normally, the ifIndex value of the local interface. For 802.3 Repeaters for which the repeater ports do not have ifIndex values assigned, this value is a unique value for the port, and greater than any ifIndex value supported by the repeater; the specific port number in this case, is given by the corresponding value of cdpInterfacePort.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (957, '.1.3.6.1.4.1.9.9.23.1.2.1.1.2', 'cdpCacheDeviceIndex', 955, 'current', NULL, 'A unique value for each device from which CDP messages are being received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (958, '.1.3.6.1.4.1.9.9.23.1.2.1.1.3', 'cdpCacheAddressType', 955, 'current', NULL, 'An indication of the type of address contained in the corresponding instance of cdpCacheAddress.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (959, '.1.3.6.1.4.1.9.9.23.1.2.1.1.4', 'cdpCacheAddress', 955, 'current', NULL, 'The (first) network-layer address of the device''s SNMP-agent as reported in the Address TLV of the most recently received CDP message. For example, if the corresponding instance of cacheAddressType had the value ''ip(1)'', then this object would be an IP-address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (960, '.1.3.6.1.4.1.9.9.23.1.2.1.1.5', 'cdpCacheVersion', 955, 'current', NULL, 'The Version string as reported in the most recent CDP message. The zero-length string indicates no Version field (TLV) was reported in the most recent CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (961, '.1.3.6.1.4.1.9.9.23.1.2.1.1.6', 'cdpCacheDeviceId', 955, 'current', NULL, 'The Device-ID string as reported in the most recent CDP message. The zero-length string indicates no Device-ID field (TLV) was reported in the most recent CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (962, '.1.3.6.1.4.1.9.9.23.1.2.1.1.7', 'cdpCacheDevicePort', 955, 'current', NULL, 'The Port-ID string as reported in the most recent CDP message. This will typically be the value of the ifName object (e.g., ''Ethernet0''). The zero-length string indicates no Port-ID field (TLV) was reported in the most recent CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (963, '.1.3.6.1.4.1.9.9.23.1.2.1.1.8', 'cdpCachePlatform', 955, 'current', NULL, 'The Device''s Hardware Platform as reported in the most recent CDP message. The zero-length string indicates that no Platform field (TLV) was reported in the most recent CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (964, '.1.3.6.1.4.1.9.9.23.1.2.1.1.9', 'cdpCacheCapabilities', 955, 'current', 'Cisco Discovery Protocol Specification, 10/19/94.', 'The Device''s Functional Capabilities as reported in the most recent CDP message. For latest set of specific values, see the latest version of the CDP specification. The zero-length string indicates no Capabilities field (TLV) was reported in the most recent CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (965, '.1.3.6.1.4.1.9.9.23.1.2.1.1.10', 'cdpCacheVTPMgmtDomain', 955, 'current', 'managementDomainName in CISCO-VTP-MIB', 'The VTP Management Domain for the remote device''s interface, as reported in the most recently received CDP message. This object is not instantiated if no VTP Management Domain field (TLV) was reported in the most recently received CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (966, '.1.3.6.1.4.1.9.9.23.1.2.1.1.11', 'cdpCacheNativeVLAN', 955, 'current', NULL, 'The remote device''s interface''s native VLAN, as reported in the most recent CDP message. The value 0 indicates no native VLAN field (TLV) was reported in the most recent CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (967, '.1.3.6.1.4.1.9.9.23.1.2.1.1.12', 'cdpCacheDuplex', 955, 'current', NULL, 'The remote device''s interface''s duplex mode, as reported in the most recent CDP message. The value unknown(1) indicates no duplex mode field (TLV) was reported in the most recent CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (968, '.1.3.6.1.4.1.9.9.23.1.2.1.1.13', 'cdpCacheApplianceID', 955, 'current', NULL, 'The remote device''s Appliance ID, as reported in the most recent CDP message. This object is not instantiated if no Appliance VLAN-ID field (TLV) was reported in the most recently received CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (969, '.1.3.6.1.4.1.9.9.23.1.2.1.1.14', 'cdpCacheVlanID', 955, 'current', NULL, 'The remote device''s VoIP VLAN ID, as reported in the most recent CDP message. This object is not instantiated if no Appliance VLAN-ID field (TLV) was reported in the most recently received CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (970, '.1.3.6.1.4.1.9.9.23.1.2.1.1.15', 'cdpCachePowerConsumption', 955, 'current', NULL, 'The amount of power consumed by remote device, as reported in the most recent CDP message. This object is not instantiated if no Power Consumption field (TLV) was reported in the most recently received CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5749, '.1.3.6.1.4.1.9.9.97.1.4.2.1.5', 'cseL3VlanOutOctets', 5744, 'current', NULL, 'Number of octets in packets Layer-3 forwarded to this Vlan by this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (971, '.1.3.6.1.4.1.9.9.23.1.2.1.1.16', 'cdpCacheMTU', 955, 'current', NULL, 'Indicates the size of the largest datagram that can be sent/received by remote device, as reported in the most recent CDP message. This object is not instantiated if no MTU field (TLV) was reported in the most recently received CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (972, '.1.3.6.1.4.1.9.9.23.1.2.1.1.17', 'cdpCacheSysName', 955, 'current', NULL, 'Indicates the value of the remote device''s sysName MIB object. By convention, it is the device''s fully qualified domain name. This object is not instantiated if no sysName field (TLV) was reported in the most recently received CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (973, '.1.3.6.1.4.1.9.9.23.1.2.1.1.18', 'cdpCacheSysObjectID', 955, 'current', NULL, 'Indicates the value of the remote device''s sysObjectID MIB object. This object is not instantiated if no sysObjectID field (TLV) was reported in the most recently received CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (974, '.1.3.6.1.4.1.9.9.23.1.2.1.1.19', 'cdpCachePrimaryMgmtAddrType', 955, 'current', NULL, 'An indication of the type of address contained in the corresponding instance of cdpCachePrimaryMgmtAddress.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (975, '.1.3.6.1.4.1.9.9.23.1.2.1.1.20', 'cdpCachePrimaryMgmtAddr', 955, 'current', NULL, 'This object indicates the (first) network layer address at which the device will accept SNMP messages as reported in the most recently received CDP message. If the corresponding instance of cdpCachePrimaryMgmtAddrType has the value ''ip(1)'', then this object would be an IP-address. If the remote device is not currently manageable via any network protocol, this object has the special value of the IPv4 address 0.0.0.0. If the most recently received CDP message did not contain any primary address at which the device prefers to receive SNMP messages, then this object is not instanstiated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (976, '.1.3.6.1.4.1.9.9.23.1.2.1.1.21', 'cdpCacheSecondaryMgmtAddrType', 955, 'current', NULL, 'An indication of the type of address contained in the corresponding instance of cdpCacheSecondaryMgmtAddress.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (977, '.1.3.6.1.4.1.9.9.23.1.2.1.1.22', 'cdpCacheSecondaryMgmtAddr', 955, 'current', NULL, 'This object indicates the alternate network layer address (other than the one indicated by cdpCachePrimaryMgmtAddr) at which the device will accept SNMP messages as reported in the most recently received CDP message. If the corresponding instance of cdpCacheSecondaryMgmtAddrType has the value ''ip(1)'', then this object would be an IP-address. If the most recently received CDP message did not contain such an alternate network layer address, then this object is not instanstiated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (978, '.1.3.6.1.4.1.9.9.23.1.2.1.1.23', 'cdpCachePhysLocation', 955, 'current', NULL, 'Indicates the physical location, as reported by the most recent CDP message, of a connector which is on, or physically connected to, the remote device''s interface over which the CDP packet is sent. This object is not instantiated if no Physical Location field (TLV) was reported by the most recently received CDP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (979, '.1.3.6.1.4.1.9.9.23.1.2.1.1.24', 'cdpCacheLastChange', 955, 'current', NULL, 'Indicates the time when this cache entry was last changed. This object is initialised to the current time when the entry gets created and updated to the current time whenever the value of any (other) object instance in the corresponding row is modified.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (980, '.1.3.6.1.4.1.9.9.23.1.3.1', 'cdpGlobalRun', 942, 'current', NULL, 'An indication of whether the Cisco Discovery Protocol is currently running. Entries in cdpCacheTable are deleted when CDP is disabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (981, '.1.3.6.1.4.1.9.9.23.1.3.2', 'cdpGlobalMessageInterval', 942, 'current', NULL, 'The interval at which CDP messages are to be generated. The default value is 60 seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (982, '.1.3.6.1.4.1.9.9.23.1.3.3', 'cdpGlobalHoldTime', 942, 'current', NULL, 'The time for the receiving device holds CDP message. The default value is 180 seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (983, '.1.3.6.1.4.1.9.9.23.1.3.4', 'cdpGlobalDeviceId', 942, 'current', NULL, 'The device ID advertised by this device. The format of this device id is characterized by the value of cdpGlobalDeviceIdFormat object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (984, '.1.3.6.1.4.1.9.9.23.1.3.5', 'cdpGlobalLastChange', 942, 'current', NULL, 'Indicates the time when the cache table was last changed. It is the most recent time at which any row was last created, modified or deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (985, '.1.3.6.1.4.1.9.9.23.1.3.6', 'cdpGlobalDeviceIdFormatCpb', 942, 'current', NULL, 'Indicate the Device-Id format capability of the device.  serialNumber(0) indicates that the device supports using serial number as the format for its DeviceId.  macAddress(1) indicates that the device supports using layer 2 MAC address as the format for its DeviceId.  other(2) indicates that the device supports using its platform specific format as the format for its DeviceId.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (986, '.1.3.6.1.4.1.9.9.23.1.3.7', 'cdpGlobalDeviceIdFormat', 942, 'current', NULL, 'An indication of the format of Device-Id contained in the corresponding instance of cdpGlobalDeviceId. User can only specify the formats that the device is capable of as denoted in cdpGlobalDeviceIdFormatCpb object.  serialNumber(1) indicates that the value of cdpGlobalDeviceId object is in the form of an ASCII string contain the device serial number.  macAddress(2) indicates that the value of cdpGlobalDeviceId object is in the form of Layer 2 MAC address.  other(3) indicates that the value of cdpGlobalDeviceId object is in the form of a platform specific ASCII string contain info that identifies the device. For example: ASCII string contains serialNumber appended/prepened with system name.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (987, '.1.3.6.1.4.1.9.9.23.2', 'ciscoCdpMIBConformance', 938, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (988, '.1.3.6.1.4.1.9.9.23.2.1', 'ciscoCdpMIBCompliances', 987, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (989, '.1.3.6.1.4.1.9.9.23.2.2', 'ciscoCdpMIBGroups', 987, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (990, '.1.3.6.1.4.1.9.9.23.2.1.1', 'ciscoCdpMIBCompliance', 988, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (991, '.1.3.6.1.4.1.9.9.23.2.1.2', 'ciscoCdpMIBComplianceV11R01', 988, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (992, '.1.3.6.1.4.1.9.9.23.2.1.3', 'ciscoCdpMIBComplianceV11R02', 988, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (993, '.1.3.6.1.4.1.9.9.23.2.1.4', 'ciscoCdpMIBComplianceV12R02', 988, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (994, '.1.3.6.1.4.1.9.9.23.2.2.1', 'ciscoCdpMIBGroup', 989, 'obsolete', NULL, 'A collection of objects for use with the Cisco Discovery Protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (995, '.1.3.6.1.4.1.9.9.23.2.2.2', 'ciscoCdpMIBGroupV11R01', 989, 'obsolete', NULL, 'A collection of objects for use with the Cisco Discovery Protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (996, '.1.3.6.1.4.1.9.9.23.2.2.3', 'ciscoCdpMIBGroupV11R02', 989, 'obsolete', NULL, 'A collection of objects for use with the Cisco Discovery Protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (997, '.1.3.6.1.4.1.9.9.23.2.2.5', 'ciscoCdpMIBGroupV12R02', 989, 'current', NULL, 'A collection of objects for use with the Cisco Discovery Protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (998, '.1.3.6.1.4.1.9.9.23.2.2.6', 'ciscoCdpV2MIBGroup', 989, 'current', NULL, 'A collection of objects for use with the Cisco Discovery Protocol version 2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (999, '.1.3.6.1.4.1.9.9.23.2.2.7', 'ciscoCdpV2IfExtGroup', 989, 'current', NULL, 'A collection of objects for use with the Cisco Discovery Protocol version 2 to configure the value for Extended Trust TLV and COS for Untrusted Port TLV.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5863, '.1.3.6.1.2.1.19.2.1.5', 'charPortReset', 5858, 'current', NULL, 'A control to force the port into a clean, initial state, both hardware and software, disconnecting all the port''s existing sessions. In response to a get-request or get-next-request, the agent always returns ''ready'' as the value. Setting the value to ''execute'' causes a reset.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5750, '.1.3.6.1.4.1.9.9.97.1.4.3', 'cseStatsFlowTable', 5598, 'current', NULL, 'A table of flow statistics per switch engine that is not covered in cseL3StatsTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1002, '.1.3.6.1.4.1.9.9.13.1.1', 'ciscoEnvMonPresent', 1001, 'current', NULL, 'The type of environmental monitor located in the chassis. An oldAgs environmental monitor card is identical to an ags environmental card except that it is not capable of supplying data, and hence no instance of the remaining objects in this MIB will be returned in response to an SNMP query. Note that only a firmware upgrade is required to convert an oldAgs into an ags card.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1003, '.1.3.6.1.4.1.9.9.13.1.2', 'ciscoEnvMonVoltageStatusTable', 1001, 'current', NULL, 'The table of voltage status maintained by the environmental monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1004, '.1.3.6.1.4.1.9.9.13.1.2.1', 'ciscoEnvMonVoltageStatusEntry', 1003, 'current', NULL, 'An entry in the voltage status table, representing the status of the associated testpoint maintained by the environmental monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1005, '.1.3.6.1.4.1.9.9.13.1.2.1.1', 'ciscoEnvMonVoltageStatusIndex', 1004, 'current', NULL, 'Unique index for the testpoint being instrumented. This index is for SNMP purposes only, and has no intrinsic meaning.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1006, '.1.3.6.1.4.1.9.9.13.1.2.1.2', 'ciscoEnvMonVoltageStatusDescr', 1004, 'current', NULL, 'Textual description of the testpoint being instrumented. This description is a short textual label, suitable as a human-sensible identification for the rest of the information in the entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1007, '.1.3.6.1.4.1.9.9.13.1.2.1.3', 'ciscoEnvMonVoltageStatusValue', 1004, 'current', NULL, 'The current measurement of the testpoint being instrumented.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1008, '.1.3.6.1.4.1.9.9.13.1.2.1.4', 'ciscoEnvMonVoltageThresholdLow', 1004, 'current', NULL, 'The lowest value that the associated instance of the object ciscoEnvMonVoltageStatusValue may obtain before an emergency shutdown of the managed device is initiated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1009, '.1.3.6.1.4.1.9.9.13.1.2.1.5', 'ciscoEnvMonVoltageThresholdHigh', 1004, 'current', NULL, 'The highest value that the associated instance of the object ciscoEnvMonVoltageStatusValue may obtain before an emergency shutdown of the managed device is initiated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1010, '.1.3.6.1.4.1.9.9.13.1.2.1.6', 'ciscoEnvMonVoltageLastShutdown', 1004, 'current', NULL, 'The value of the associated instance of the object ciscoEnvMonVoltageStatusValue at the time an emergency shutdown of the managed device was last initiated. This value is stored in non-volatile RAM and hence is able to survive the shutdown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1011, '.1.3.6.1.4.1.9.9.13.1.2.1.7', 'ciscoEnvMonVoltageState', 1004, 'current', NULL, 'The current state of the testpoint being instrumented.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1012, '.1.3.6.1.4.1.9.9.13.1.3', 'ciscoEnvMonTemperatureStatusTable', 1001, 'current', NULL, 'The table of ambient temperature status maintained by the environmental monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1013, '.1.3.6.1.4.1.9.9.13.1.3.1', 'ciscoEnvMonTemperatureStatusEntry', 1012, 'current', NULL, 'An entry in the ambient temperature status table, representing the status of the associated testpoint maintained by the environmental monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1014, '.1.3.6.1.4.1.9.9.13.1.3.1.1', 'ciscoEnvMonTemperatureStatusIndex', 1013, 'current', NULL, 'Unique index for the testpoint being instrumented. This index is for SNMP purposes only, and has no intrinsic meaning.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1015, '.1.3.6.1.4.1.9.9.13.1.3.1.2', 'ciscoEnvMonTemperatureStatusDescr', 1013, 'current', NULL, 'Textual description of the testpoint being instrumented. This description is a short textual label, suitable as a human-sensible identification for the rest of the information in the entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1016, '.1.3.6.1.4.1.9.9.13.1.3.1.3', 'ciscoEnvMonTemperatureStatusValue', 1013, 'current', NULL, 'The current measurement of the testpoint being instrumented.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1017, '.1.3.6.1.4.1.9.9.13.1.3.1.4', 'ciscoEnvMonTemperatureThreshold', 1013, 'current', NULL, 'The highest value that the associated instance of the object ciscoEnvMonTemperatureStatusValue may obtain before an emergency shutdown of the managed device is initiated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1018, '.1.3.6.1.4.1.9.9.13.1.3.1.5', 'ciscoEnvMonTemperatureLastShutdown', 1013, 'current', NULL, 'The value of the associated instance of the object ciscoEnvMonTemperatureStatusValue at the time an emergency shutdown of the managed device was last initiated. This value is stored in non-volatile RAM and hence is able to survive the shutdown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1019, '.1.3.6.1.4.1.9.9.13.1.3.1.6', 'ciscoEnvMonTemperatureState', 1013, 'current', NULL, 'The current state of the testpoint being instrumented.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1020, '.1.3.6.1.4.1.9.9.13.1.4', 'ciscoEnvMonFanStatusTable', 1001, 'current', NULL, 'The table of fan status maintained by the environmental monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1021, '.1.3.6.1.4.1.9.9.13.1.4.1', 'ciscoEnvMonFanStatusEntry', 1020, 'current', NULL, 'An entry in the fan status table, representing the status of the associated fan maintained by the environmental monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1022, '.1.3.6.1.4.1.9.9.13.1.4.1.1', 'ciscoEnvMonFanStatusIndex', 1021, 'current', NULL, 'Unique index for the fan being instrumented. This index is for SNMP purposes only, and has no intrinsic meaning.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1023, '.1.3.6.1.4.1.9.9.13.1.4.1.2', 'ciscoEnvMonFanStatusDescr', 1021, 'current', NULL, 'Textual description of the fan being instrumented. This description is a short textual label, suitable as a human-sensible identification for the rest of the information in the entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1024, '.1.3.6.1.4.1.9.9.13.1.4.1.3', 'ciscoEnvMonFanState', 1021, 'current', NULL, 'The current state of the fan being instrumented.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1025, '.1.3.6.1.4.1.9.9.13.1.5', 'ciscoEnvMonSupplyStatusTable', 1001, 'current', NULL, 'The table of power supply status maintained by the environmental monitor card.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1026, '.1.3.6.1.4.1.9.9.13.1.5.1', 'ciscoEnvMonSupplyStatusEntry', 1025, 'current', NULL, 'An entry in the power supply status table, representing the status of the associated power supply maintained by the environmental monitor card.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1027, '.1.3.6.1.4.1.9.9.13.1.5.1.1', 'ciscoEnvMonSupplyStatusIndex', 1026, 'current', NULL, 'Unique index for the power supply being instrumented. This index is for SNMP purposes only, and has no intrinsic meaning.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1028, '.1.3.6.1.4.1.9.9.13.1.5.1.2', 'ciscoEnvMonSupplyStatusDescr', 1026, 'current', NULL, 'Textual description of the power supply being instrumented. This description is a short textual label, suitable as a human-sensible identification for the rest of the information in the entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1029, '.1.3.6.1.4.1.9.9.13.1.5.1.3', 'ciscoEnvMonSupplyState', 1026, 'current', NULL, 'The current state of the power supply being instrumented.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1030, '.1.3.6.1.4.1.9.9.13.1.5.1.4', 'ciscoEnvMonSupplySource', 1026, 'current', NULL, 'The power supply source. unknown - Power supply source unknown ac - AC power supply dc - DC power supply externalPowerSupply - External power supply internalRedundant - Internal redundant power supply', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1031, '.1.3.6.1.4.1.9.9.13.1.6', 'ciscoEnvMonAlarmContacts', 1001, 'current', NULL, 'Each bit is set to reflect the respective alarm being set. The bit will be cleared when the respective alarm is cleared.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1032, '.1.3.6.1.4.1.9.9.13.2', 'ciscoEnvMonMIBNotificationEnables', 1000, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1033, '.1.3.6.1.4.1.9.9.13.2.1', 'ciscoEnvMonEnableShutdownNotification', 1032, 'current', NULL, 'This variable indicates whether the system produces the ciscoEnvMonShutdownNotification. A false value will prevent shutdown notifications from being generated by this system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1034, '.1.3.6.1.4.1.9.9.13.2.2', 'ciscoEnvMonEnableVoltageNotification', 1032, 'deprecated', NULL, 'This variable indicates whether the system produces the ciscoEnvMonVoltageNotification. A false value will prevent voltage notifications from being generated by this system. This object is deprecated in favour of ciscoEnvMonEnableStatChangeNotif.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5647, '.1.3.6.1.4.1.9.9.97.1.2.6.1.2', 'cseRouterVlan', 5645, 'current', NULL, 'The Vlan number associated with the router''s MAC address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1035, '.1.3.6.1.4.1.9.9.13.2.3', 'ciscoEnvMonEnableTemperatureNotification', 1032, 'deprecated', NULL, 'This variable indicates whether the system produces the ciscoEnvMonTemperatureNotification. A false value prevents temperature notifications from being sent by this entity. This object is deprecated in favour of ciscoEnvMonEnableStatChangeNotif.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1036, '.1.3.6.1.4.1.9.9.13.2.4', 'ciscoEnvMonEnableFanNotification', 1032, 'deprecated', NULL, 'This variable indicates whether the system produces the ciscoEnvMonFanNotification. A false value prevents fan notifications from being sent by this entity. This object is deprecated in favour of ciscoEnvMonEnableStatChangeNotif.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1037, '.1.3.6.1.4.1.9.9.13.2.5', 'ciscoEnvMonEnableRedundantSupplyNotification', 1032, 'deprecated', NULL, 'This variable indicates whether the system produces the ciscoEnvMonRedundantSupplyNotification. A false value prevents redundant supply notifications from being generated by this system. This object is deprecated in favour of ciscoEnvMonEnableStatChangeNotif.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1038, '.1.3.6.1.4.1.9.9.13.2.6', 'ciscoEnvMonEnableStatChangeNotif', 1032, 'current', NULL, 'This variable indicates whether the system produces the ciscoEnvMonVoltStatusChangeNotif, ciscoEnvMonTempStatusChangeNotif, ciscoEnvMonFanStatusChangeNotif and ciscoEnvMonSuppStatusChangeNotif. A false value will prevent these notifications from being generated by this system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1039, '.1.3.6.1.4.1.9.9.13.3', 'ciscoEnvMonMIBNotificationPrefix', 1000, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1040, '.1.3.6.1.4.1.9.9.13.3.0', 'ciscoEnvMonMIBNotifications', 1039, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1041, '.1.3.6.1.4.1.9.9.13.3.0.1', 'ciscoEnvMonShutdownNotification', 1040, 'current', NULL, 'A ciscoEnvMonShutdownNotification is sent if the environmental monitor detects a testpoint reaching a critical state and is about to initiate a shutdown. This notification contains no objects so that it may be encoded and sent in the shortest amount of time possible. Even so, management applications should not rely on receiving such a notification as it may not be sent before the shutdown completes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1042, '.1.3.6.1.4.1.9.9.13.3.0.2', 'ciscoEnvMonVoltageNotification', 1040, 'deprecated', NULL, 'A ciscoEnvMonVoltageNotification is sent if the voltage measured at a given testpoint is outside the normal range for the testpoint (i.e. is at the warning, critical, or shutdown stage). Since such a notification is usually generated before the shutdown state is reached, it can convey more data and has a better chance of being sent than does the ciscoEnvMonShutdownNotification. This notification is deprecated in favour of ciscoEnvMonVoltStatusChangeNotif.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1043, '.1.3.6.1.4.1.9.9.13.3.0.3', 'ciscoEnvMonTemperatureNotification', 1040, 'deprecated', NULL, 'A ciscoEnvMonTemperatureNotification is sent if the temperature measured at a given testpoint is outside the normal range for the testpoint (i.e. is at the warning, critical, or shutdown stage). Since such a Notification is usually generated before the shutdown state is reached, it can convey more data and has a better chance of being sent than does the ciscoEnvMonShutdownNotification. This notification is deprecated in favour of ciscoEnvMonTempStatusChangeNotif.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1044, '.1.3.6.1.4.1.9.9.13.3.0.4', 'ciscoEnvMonFanNotification', 1040, 'deprecated', NULL, 'A ciscoEnvMonFanNotification is sent if any one of the fans in the fan array (where extant) fails. Since such a notification is usually generated before the shutdown state is reached, it can convey more data and has a better chance of being sent than does the ciscoEnvMonShutdownNotification. This notification is deprecated in favour of ciscoEnvMonFanStatusChangeNotif.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1045, '.1.3.6.1.4.1.9.9.13.3.0.5', 'ciscoEnvMonRedundantSupplyNotification', 1040, 'deprecated', NULL, 'A ciscoEnvMonRedundantSupplyNotification is sent if the redundant power supply (where extant) fails. Since such a notification is usually generated before the shutdown state is reached, it can convey more data and has a better chance of being sent than does the ciscoEnvMonShutdownNotification. This notification is deprecated in favour of ciscoEnvMonSuppStatusChangeNotif.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1046, '.1.3.6.1.4.1.9.9.13.3.0.6', 'ciscoEnvMonVoltStatusChangeNotif', 1040, 'current', NULL, 'A ciscoEnvMonVoltStatusChangeNotif is sent if there is change in the state of a device being monitored by ciscoEnvMonVoltageState.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1047, '.1.3.6.1.4.1.9.9.13.3.0.7', 'ciscoEnvMonTempStatusChangeNotif', 1040, 'current', NULL, 'A ciscoEnvMonTempStatusChangeNotif is sent if there is change in the state of a device being monitored by ciscoEnvMonTemperatureState.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1048, '.1.3.6.1.4.1.9.9.13.3.0.8', 'ciscoEnvMonFanStatusChangeNotif', 1040, 'current', NULL, 'A ciscoEnvMonFanStatusChangeNotif is sent if there is change in the state of a device being monitored by ciscoEnvMonFanState.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1049, '.1.3.6.1.4.1.9.9.13.3.0.9', 'ciscoEnvMonSuppStatusChangeNotif', 1040, 'current', NULL, 'A ciscoEnvMonSupplyStatChangeNotif is sent if there is change in the state of a device being monitored by ciscoEnvMonSupplyState.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1050, '.1.3.6.1.4.1.9.9.13.4', 'ciscoEnvMonMIBConformance', 1000, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1051, '.1.3.6.1.4.1.9.9.13.4.1', 'ciscoEnvMonMIBCompliances', 1050, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1052, '.1.3.6.1.4.1.9.9.13.4.2', 'ciscoEnvMonMIBGroups', 1050, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1053, '.1.3.6.1.4.1.9.9.13.4.1.1', 'ciscoEnvMonMIBCompliance', 1051, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1054, '.1.3.6.1.4.1.9.9.13.4.1.2', 'ciscoEnvMonMIBComplianceRev1', 1051, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1055, '.1.3.6.1.4.1.9.9.13.4.2.1', 'ciscoEnvMonMIBGroup', 1052, 'deprecated', NULL, 'A collection of objects providing environmental monitoring capability to a cisco chassis. This group is deprecated in favour of ciscoEnvMonMIBGroupRev.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1056, '.1.3.6.1.4.1.9.9.13.4.2.2', 'ciscoEnvMonMIBGroupRev', 1052, 'current', NULL, 'A collection of objects providing environmental monitoring capability to a cisco chassis.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1057, '.1.3.6.1.4.1.9.9.13.4.2.3', 'ciscoEnvMonEnableStatChangeGroup', 1052, 'current', NULL, 'A collection of objects providing enabling/disabling of the status change notifications for environmental monitoring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1058, '.1.3.6.1.4.1.9.9.13.4.2.4', 'ciscoEnvMonMIBNotifGroup', 1052, 'current', NULL, 'A notification group providing shutdown notification for environmental monitoring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1059, '.1.3.6.1.4.1.9.9.13.4.2.5', 'ciscoEnvMonStatChangeNotifGroup', 1052, 'current', NULL, 'A collection of notifications providing the status change for environmental monitoring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1060, '.1.3.6.1.4.1.9.9.13.4.2.6', 'ciscoEnvMonMIBMiscNotifGroup', 1052, 'deprecated', NULL, 'A collection of various notifications for the enviromental monitoring mib module. The notifications the group and the group are both in deprecated state. The notifications in the group were deprecated in favour of notifications in ciscoEnvMonStatChangeNotifGroup.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1061, '.1.3.6.1.4.1.9.9.80', 'ciscoFtpClientMIB', 272, 'current', NULL, 'The MIB module for invoking Internet File Transfer Protocol (FTP) operations for network management purposes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1062, '.1.3.6.1.4.1.9.9.80.1', 'ciscoFtpClientMIBObjects', 1061, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1063, '.1.3.6.1.4.1.9.9.80.1.1', 'cfcRequest', 1062, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1161, '.1.3.6.1.2.1.27.1', 'applTable', 1160, 'current', NULL, 'The table holding objects which apply to all different kinds of applications providing network services. Each network service application capable of being monitored should have a single entry in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1162, '.1.3.6.1.2.1.27.1.1', 'applEntry', 1161, 'current', NULL, 'An entry associated with a single network service application.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5449, '.1.3.6.1.2.1.47.3.1.1', 'entityCompliance', 5447, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1064, '.1.3.6.1.4.1.9.9.80.1.1.1', 'cfcRequestMaximum', 1063, 'current', NULL, 'The maximum number of requests this system can hold in cfcRequestTable. A value of 0 indicates no configured limit.  This object may be read-only on some systems.  When an attempt is made to create a new entry but the table is full, the oldest completed entry is bumped out and cfcRequestsBumped is incremented.  Changing this number does not disturb existing requests that are not completed and bumps completed requests as necessary.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1065, '.1.3.6.1.4.1.9.9.80.1.1.2', 'cfcRequests', 1063, 'current', NULL, 'The current number of requests in cfcRequestTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1066, '.1.3.6.1.4.1.9.9.80.1.1.3', 'cfcRequestsHigh', 1063, 'current', NULL, 'The highest number of requests in cfcRequestTable since this system was last initialized.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1067, '.1.3.6.1.4.1.9.9.80.1.1.4', 'cfcRequestsBumped', 1063, 'current', NULL, 'The number of requests in cfcRequestTable that were bumped out to make room for a new request.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1068, '.1.3.6.1.4.1.9.9.80.1.1.5', 'cfcRequestTable', 1063, 'current', NULL, 'A table of FTP client requests.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1069, '.1.3.6.1.4.1.9.9.80.1.1.5.1', 'cfcRequestEntry', 1068, 'current', NULL, 'Information about an FTP client request. Management applications use cfcRequestEntryStatus to control entry modification, creation, and deletion.  Setting cfcRequestEntryStatus to ''active'' from any state including ''active'' causes the operation to be started.  The entry may be modified only when cfcRequestOperationState is ''stopped''.  The value of cfcRequestEntryStatus may be set to ''destroy'' at any time. Doing so will abort a running request.  Entries may not be created without explicitly setting cfcRequestEntryStatus to either ''createAndGo'' or ''createAndWait''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1070, '.1.3.6.1.4.1.9.9.80.1.1.5.1.1', 'cfcRequestIndex', 1069, 'current', NULL, 'An arbitrary integer to uniquely identify this entry. To create an entry a management application should pick a random number.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1071, '.1.3.6.1.4.1.9.9.80.1.1.5.1.2', 'cfcRequestOperation', 1069, 'current', NULL, 'The FTP operation to be performed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1072, '.1.3.6.1.4.1.9.9.80.1.1.5.1.3', 'cfcRequestLocalFile', 1069, 'current', NULL, 'The local file on which the operation is to be performed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1073, '.1.3.6.1.4.1.9.9.80.1.1.5.1.4', 'cfcRequestRemoteFile', 1069, 'current', NULL, 'The remote file on which the operation is to be performed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1074, '.1.3.6.1.4.1.9.9.80.1.1.5.1.5', 'cfcRequestServer', 1069, 'current', NULL, 'The domain name or IP address of the FTP server to use.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1075, '.1.3.6.1.4.1.9.9.80.1.1.5.1.6', 'cfcRequestUser', 1069, 'current', NULL, 'The user name to use at the FTP server.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1076, '.1.3.6.1.4.1.9.9.80.1.1.5.1.7', 'cfcRequestPassword', 1069, 'current', NULL, 'The password to use at the FTP server.  When read this object always returns a zero-length string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1077, '.1.3.6.1.4.1.9.9.80.1.1.5.1.8', 'cfcRequestResult', 1069, 'current', NULL, 'The result of the FTP operation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1078, '.1.3.6.1.4.1.9.9.80.1.1.5.1.9', 'cfcRequestCompletionTime', 1069, 'current', NULL, 'The value of sysUpTime when the operation completed. For an incomplete operation this value is zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1079, '.1.3.6.1.4.1.9.9.80.1.1.5.1.10', 'cfcRequestStop', 1069, 'current', NULL, 'The action control to stop a running request. Setting this to ''stop'' will begin the process of stopping the request. Setting it to ''ready'' or setting it to ''stop'' more than once have no effect. When read this object always returns ready.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1080, '.1.3.6.1.4.1.9.9.80.1.1.5.1.11', 'cfcRequestOperationState', 1069, 'current', NULL, 'The operational state of the file transfer. To short-terminate the transfer set cfcRequestStop to ''stop''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1081, '.1.3.6.1.4.1.9.9.80.1.1.5.1.12', 'cfcRequestEntryStatus', 1069, 'current', NULL, 'The control that allows modification, creation, and deletion of entries. For detailed rules see the DESCRIPTION for cfcRequestEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1082, '.1.3.6.1.4.1.9.9.80.3', 'ciscoFtpClientMIBConformance', 1061, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1083, '.1.3.6.1.4.1.9.9.80.3.1', 'ciscoFtpClientMIBCompliances', 1082, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1084, '.1.3.6.1.4.1.9.9.80.3.2', 'ciscoFtpClientMIBGroups', 1082, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1085, '.1.3.6.1.4.1.9.9.80.3.1.1', 'ciscoFtpClientMIBCompliance', 1083, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1086, '.1.3.6.1.4.1.9.9.80.3.2.1', 'ciscoFtpClientRequestGroup', 1084, 'current', NULL, 'FTP client request management.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1087, '.1.3.6.1.2.1.76', 'inetAddressMIB', 21, 'current', NULL, 'This MIB module defines textual conventions for representing Internet addresses. An Internet address can be an IPv4 address, an IPv6 address, or a DNS domain name. This module also defines textual conventions for Internet port numbers, autonomous system numbers, and the length of an Internet address prefix.  Copyright (C) The Internet Society (2005). This version of this MIB module is part of RFC 4001, see the RFC itself for full legal notices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1088, '.1.3.6.1.4.1.9.9.41', 'ciscoSyslogMIB', 272, 'current', NULL, 'The MIB module to describe and store the system messages generated by the IOS and any other OS which supports syslogs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1089, '.1.3.6.1.4.1.9.9.41.1', 'ciscoSyslogMIBObjects', 1088, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1090, '.1.3.6.1.4.1.9.9.41.1.1', 'clogBasic', 1089, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1091, '.1.3.6.1.4.1.9.9.41.1.2', 'clogHistory', 1089, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1092, '.1.3.6.1.4.1.9.9.41.1.3', 'clogServer', 1089, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1093, '.1.3.6.1.4.1.9.9.41.1.1.1', 'clogNotificationsSent', 1090, 'current', NULL, 'The number of clogMessageGenerated notifications that have been sent. This number may include notifications that were prevented from being transmitted due to reasons such as resource limitations and/or non-connectivity. If one is receiving notifications, one can periodically poll this object to determine if any notifications were missed. If so, a poll of the clogHistoryTable might be appropriate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1094, '.1.3.6.1.4.1.9.9.41.1.1.2', 'clogNotificationsEnabled', 1090, 'current', NULL, 'Indicates whether clogMessageGenerated notifications will or will not be sent when a syslog message is generated by the device. Disabling notifications does not prevent syslog messages from being added to the clogHistoryTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1095, '.1.3.6.1.4.1.9.9.41.1.1.3', 'clogMaxSeverity', 1090, 'current', NULL, 'Indicates which syslog severity levels will be processed. Any syslog message with a severity value greater than this value will be ignored by the agent. note: severity numeric values increase as their severity decreases, e.g. ''error'' is more severe than ''debug''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1096, '.1.3.6.1.4.1.9.9.41.1.1.4', 'clogMsgIgnores', 1090, 'current', NULL, 'The number of syslog messages which were ignored. A message will be ignored if it has a severity value greater than clogMaxSeverity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1097, '.1.3.6.1.4.1.9.9.41.1.1.5', 'clogMsgDrops', 1090, 'current', NULL, 'The number of syslog messages which could not be processed due to lack of system resources. Most likely this will occur at the same time that syslog messages are generated to indicate this lack of resources. Increases in this object''s value may serve as an indication that system resource levels should be examined via other mib objects. A message that is dropped will not appear in the history table and no notification will be sent for this message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1163, '.1.3.6.1.2.1.27.1.1.1', 'applIndex', 1162, 'current', NULL, 'An index to uniquely identify the network service application. This attribute is the index used for lexicographic ordering of the table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1164, '.1.3.6.1.2.1.27.1.1.2', 'applName', 1162, 'current', NULL, 'The name the network service application chooses to be known by.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5311, '.1.3.6.1.4.1.9.9.697.1.1', 'cfmIpCbrMetrics', 5308, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1098, '.1.3.6.1.4.1.9.9.41.1.1.6', 'clogOriginIDType', 1090, 'current', NULL, 'This object identifies the type of value that will be contained in clogOriginID object.  The possible value(s) are: ''none'' : do not send origin identifier in syslog messages. ''other'' : type that is not identified by other values specified in this object. ''hostName'' : Send hostname of the system in syslog messages. ''ipv4Address'': Send IP address of the sending interface. ''contextName'': Send context name of the security device. ''userDefined'': Send user configured string in syslog message.  The value ''other'' and ''none'' can not be set but can only be read.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1099, '.1.3.6.1.4.1.9.9.41.1.1.7', 'clogOriginID', 1090, 'current', NULL, 'This object is used for configuring the origin identifier for the syslog messages.  The origin identifier is useful for identifying the source of system logging messages in cases syslog messages from multiple devices are sent to a single syslog host. The origin identifier is added to the beginning of all system logging (syslog) messages sent to remote hosts.  The type of the identifier is specified by clogOriginIDType object.  This object can be written by the SNMP manager only when clogOriginIDType is set to ''userDefined''.  For following value(s) of clogOriginIDType, this object can not be set; the value of this object is derived by the system in these cases: ''contextName'' ''ipv4Address'' ''hostName'' ''other'' ''none''  This object contains the context name of the device, when clogOriginIDType is set to ''contextName''.  This object contains IPv4 address (in dotted decimal notation) of the sending interface when clogOriginIDType is set to ''ipv4Address''.  This object contains hostname of the system when clogOriginIDType is set to ''hostName''.  This object will contain zero length octet string when clogOriginIDType is either ''none'' or ''other''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1100, '.1.3.6.1.4.1.9.9.41.1.2.1', 'clogHistTableMaxLength', 1091, 'current', NULL, 'The upper limit on the number of entries that the clogHistoryTable may contain. A value of 0 will prevent any history from being retained. When this table is full, the oldest entry will be deleted and a new one will be created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1101, '.1.3.6.1.4.1.9.9.41.1.2.2', 'clogHistMsgsFlushed', 1091, 'current', NULL, 'The number of entries that have been removed from the clogHistoryTable in order to make room for new entries. This object can be utilized to determine whether your polling frequency on the history table is fast enough and/or the size of your history table is large enough such that you are not missing messages.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1102, '.1.3.6.1.4.1.9.9.41.1.2.3', 'clogHistoryTable', 1091, 'current', NULL, 'A table of syslog messages generated by this device. All ''interesting'' syslog messages (i.e. severity <= clogMaxSeverity) are entered into this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1103, '.1.3.6.1.4.1.9.9.41.1.2.3.1', 'clogHistoryEntry', 1102, 'current', NULL, 'A syslog message that was previously generated by this device. Each entry is indexed by a message index.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1104, '.1.3.6.1.4.1.9.9.41.1.2.3.1.1', 'clogHistIndex', 1103, 'current', NULL, 'A monotonically increasing integer for the sole purpose of indexing messages. When it reaches the maximum value the agent flushes the table and wraps the value back to 1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1105, '.1.3.6.1.4.1.9.9.41.1.2.3.1.2', 'clogHistFacility', 1103, 'current', NULL, 'Name of the facility that generated this message. For example: ''SYS''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1106, '.1.3.6.1.4.1.9.9.41.1.2.3.1.3', 'clogHistSeverity', 1103, 'current', NULL, 'The severity of the message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1107, '.1.3.6.1.4.1.9.9.41.1.2.3.1.4', 'clogHistMsgName', 1103, 'current', NULL, 'A textual identification for the message type. A facility name in conjunction with a message name uniquely identifies a message type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1108, '.1.3.6.1.4.1.9.9.41.1.2.3.1.5', 'clogHistMsgText', 1103, 'current', NULL, 'The text of the message. If the text of the message exceeds 255 bytes, the message will be truncated to 254 bytes and a ''*'' character will be appended - indicating that the message has been truncated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1109, '.1.3.6.1.4.1.9.9.41.1.2.3.1.6', 'clogHistTimestamp', 1103, 'current', NULL, 'The value of sysUpTime when this message was generated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1110, '.1.3.6.1.4.1.9.9.41.1.3.1', 'clogMaxServers', 1092, 'current', NULL, 'The maximum number of syslog servers that can be configured for the system in clogServerConfigTable.  A value of zero for this object indicates there is no specified limit for the system and is only dictated by system resources.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1111, '.1.3.6.1.4.1.9.9.41.1.3.2', 'clogServerConfigTable', 1092, 'current', NULL, 'This table contains entries that allow application to configure syslog servers for the system.  The maximum number of entries that can be created for this table is limited by the object clogMaxServers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1112, '.1.3.6.1.4.1.9.9.41.1.3.2.1', 'clogServerConfigEntry', 1111, 'current', NULL, 'An entry containing information about syslog servers configured for the system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1113, '.1.3.6.1.4.1.9.9.41.1.3.2.1.1', 'clogServerAddrType', 1112, 'current', NULL, 'The type of Internet address of this syslog server.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1114, '.1.3.6.1.4.1.9.9.41.1.3.2.1.2', 'clogServerAddr', 1112, 'current', NULL, 'The Internet address of this syslog server. The type of this address is determined by the value of the clogServerAddrType object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1115, '.1.3.6.1.4.1.9.9.41.1.3.2.1.3', 'clogServerStatus', 1112, 'current', NULL, 'The status object used to manage rows in this table.  A row may only be created by setting this object to ''createAndGo''.  A row may only be deleted by setting this object to ''destroy''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1116, '.1.3.6.1.4.1.9.9.41.2', 'ciscoSyslogMIBNotificationPrefix', 1088, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1117, '.1.3.6.1.4.1.9.9.41.2.0', 'ciscoSyslogMIBNotifications', 1116, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1118, '.1.3.6.1.4.1.9.9.41.2.0.1', 'clogMessageGenerated', 1117, 'current', NULL, 'When a syslog message is generated by the device a clogMessageGenerated notification is sent. The sending of these notifications can be enabled/disabled via the clogNotificationsEnabled object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1119, '.1.3.6.1.4.1.9.9.41.3', 'ciscoSyslogMIBConformance', 1088, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1120, '.1.3.6.1.4.1.9.9.41.3.1', 'ciscoSyslogMIBCompliances', 1119, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1121, '.1.3.6.1.4.1.9.9.41.3.2', 'ciscoSyslogMIBGroups', 1119, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1122, '.1.3.6.1.4.1.9.9.41.3.1.1', 'ciscoSyslogMIBCompliance', 1120, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1123, '.1.3.6.1.4.1.9.9.41.3.1.2', 'ciscoSyslogMIBComplianceRev1', 1120, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1124, '.1.3.6.1.4.1.9.9.41.3.2.1', 'ciscoSyslogMIBGroup', 1121, 'current', NULL, 'A collection of objects providing the syslog MIB capability.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1125, '.1.3.6.1.4.1.9.9.41.3.2.2', 'clogNotificationsGroup', 1121, 'current', NULL, 'A collection of notification(s) for syslog feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1126, '.1.3.6.1.4.1.9.9.41.3.2.3', 'clogServerGroup', 1121, 'current', NULL, 'A collection of objects providing syslog server information for the system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1127, '.1.3.6.1.4.1.9.9.41.3.2.4', 'clogOriginIDGroup', 1121, 'current', NULL, 'A collection of objects providing information on origin of syslog messages.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5864, '.1.3.6.1.2.1.19.2.1.6', 'charPortAdminStatus', 5858, 'current', NULL, 'The port''s desired state, independent of flow control. ''enabled'' indicates that the port is allowed to pass characters and form new sessions. ''disabled'' indicates that the port is allowed to pass characters but not form new sessions. ''off'' indicates that the port is not allowed to pass characters or have any sessions. ''maintenance'' indicates a maintenance mode, exclusive of normal operation, such as running a test.  ''enabled'' corresponds to ifAdminStatus ''up''. ''disabled'' and ''off'' correspond to ifAdminStatus ''down''. ''maintenance'' corresponds to ifAdminStatus ''test''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6377, '.1.3.6.1.2.1.15.5', 'bgpRcvdPathAttrTable', 6347, 'obsolete', NULL, 'The BGP Received Path Attribute Table contains information about paths to destination networks received from all peers running BGP version 3 or less.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6378, '.1.3.6.1.2.1.15.5.1', 'bgpPathAttrEntry', 6377, 'obsolete', NULL, 'Information about a path to a network.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6379, '.1.3.6.1.2.1.15.5.1.1', 'bgpPathAttrPeer', 6378, 'obsolete', NULL, 'The IP address of the peer where the path information was learned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6380, '.1.3.6.1.2.1.15.5.1.2', 'bgpPathAttrDestNetwork', 6378, 'obsolete', NULL, 'The address of the destination network.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6381, '.1.3.6.1.2.1.15.5.1.3', 'bgpPathAttrOrigin', 6378, 'obsolete', NULL, 'The ultimate origin of the path information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6382, '.1.3.6.1.2.1.15.5.1.4', 'bgpPathAttrASPath', 6378, 'obsolete', NULL, 'The set of ASs that must be traversed to reach the network. This object is probably best represented as SEQUENCE OF INTEGER. For SMI compatibility, though, it is represented as OCTET STRING. Each AS is represented as a pair of octets according to the following algorithm:  first-byte-of-pair = ASNumber / 256; second-byte-of-pair = ASNumber & 255;', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6383, '.1.3.6.1.2.1.15.5.1.5', 'bgpPathAttrNextHop', 6378, 'obsolete', NULL, 'The address of the border router that should be used for the destination network.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6384, '.1.3.6.1.2.1.15.5.1.6', 'bgpPathAttrInterASMetric', 6378, 'obsolete', NULL, 'The optional inter-AS metric. If this attribute has not been provided for this route, the value for this object is 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6385, '.1.3.6.1.2.1.15.6', 'bgp4PathAttrTable', 6347, 'current', NULL, 'The BGP-4 Received Path Attribute Table contains information about paths to destination networks received from all BGP4 peers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6386, '.1.3.6.1.2.1.15.6.1', 'bgp4PathAttrEntry', 6385, 'current', NULL, 'Information about a path to a network.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6387, '.1.3.6.1.2.1.15.6.1.1', 'bgp4PathAttrPeer', 6386, 'current', NULL, 'The IP address of the peer where the path information was learned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6388, '.1.3.6.1.2.1.15.6.1.2', 'bgp4PathAttrIpAddrPrefixLen', 6386, 'current', NULL, 'Length in bits of the IP address prefix in the Network Layer Reachability Information field.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6389, '.1.3.6.1.2.1.15.6.1.3', 'bgp4PathAttrIpAddrPrefix', 6386, 'current', NULL, 'An IP address prefix in the Network Layer Reachability Information field. This object is an IP address containing the prefix with length specified by bgp4PathAttrIpAddrPrefixLen. Any bits beyond the length specified by bgp4PathAttrIpAddrPrefixLen are zeroed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6390, '.1.3.6.1.2.1.15.6.1.4', 'bgp4PathAttrOrigin', 6386, 'current', NULL, 'The ultimate origin of the path information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6391, '.1.3.6.1.2.1.15.6.1.5', 'bgp4PathAttrASPathSegment', 6386, 'current', NULL, 'The sequence of AS path segments. Each AS path segment is represented by a triple <type, length, value>.  The type is a 1-octet field which has two possible values: 1 AS_SET: unordered set of ASs a route in the UPDATE message has traversed 2 AS_SEQUENCE: ordered set of ASs a route in the UPDATE message has traversed.  The length is a 1-octet field containing the number of ASs in the value field.  The value field contains one or more AS numbers, each AS is represented in the octet string as a pair of octets according to the following algorithm: first-byte-of-pair = ASNumber / 256; second-byte-of-pair = ASNumber & 255;', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6392, '.1.3.6.1.2.1.15.6.1.6', 'bgp4PathAttrNextHop', 6386, 'current', NULL, 'The address of the border router that should be used for the destination network.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6393, '.1.3.6.1.2.1.15.6.1.7', 'bgp4PathAttrMultiExitDisc', 6386, 'current', NULL, 'This metric is used to discriminate between multiple exit points to an adjacent autonomous system. A value of -1 indicates the absence of this attribute.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6394, '.1.3.6.1.2.1.15.6.1.8', 'bgp4PathAttrLocalPref', 6386, 'current', NULL, 'The originating BGP4 speaker''s degree of preference for an advertised route. A value of -1 indicates the absence of this attribute.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6395, '.1.3.6.1.2.1.15.6.1.9', 'bgp4PathAttrAtomicAggregate', 6386, 'current', NULL, 'Whether or not the local system has selected a less specific route without selecting a more specific route.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6396, '.1.3.6.1.2.1.15.6.1.10', 'bgp4PathAttrAggregatorAS', 6386, 'current', NULL, 'The AS number of the last BGP4 speaker that performed route aggregation. A value of zero (0) indicates the absence of this attribute.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6397, '.1.3.6.1.2.1.15.6.1.11', 'bgp4PathAttrAggregatorAddr', 6386, 'current', NULL, 'The IP address of the last BGP4 speaker that performed route aggregation. A value of 0.0.0.0 indicates the absence of this attribute.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6398, '.1.3.6.1.2.1.15.6.1.12', 'bgp4PathAttrCalcLocalPref', 6386, 'current', NULL, 'The degree of preference calculated by the receiving BGP4 speaker for an advertised route. A value of -1 indicates the absence of this attribute.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6399, '.1.3.6.1.2.1.15.6.1.13', 'bgp4PathAttrBest', 6386, 'current', NULL, 'An indication of whether or not this route was chosen as the best BGP4 route.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6400, '.1.3.6.1.2.1.15.6.1.14', 'bgp4PathAttrUnknown', 6386, 'current', NULL, 'One or more path attributes not understood by this BGP4 speaker. Size zero (0) indicates the absence of such attribute(s). Octets beyond the maximum size, if any, are not recorded by this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6401, '.1.3.6.1.2.1.15.7', 'bgpTraps', 6347, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6402, '.1.3.6.1.2.1.15.7.1', 'bgpEstablished', 6401, 'current', NULL, 'The BGP Established event is generated when the BGP FSM enters the ESTABLISHED state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6403, '.1.3.6.1.2.1.15.7.2', 'bgpBackwardTransition', 6401, 'current', NULL, 'The BGPBackwardTransition Event is generated when the BGP FSM moves from a higher numbered state to a lower numbered state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6328, '.1.0.8802.1.1.2.1.4.4', 'lldpRemOrgDefInfoTable', 6249, 'current', NULL, 'This table contains one or more rows per physical network connection which advertises the organizationally defined information.  Note that this table contains one or more rows of organizationally defined information that is not recognized by the local agent.  If the local system is capable of recognizing any organizationally defined information, appropriate extension MIBs from the organization should be used for information retrieval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6329, '.1.0.8802.1.1.2.1.4.4.1', 'lldpRemOrgDefInfoEntry', 6328, 'current', NULL, 'Information about the unrecognized organizationally defined information advertised by the remote system. The lldpRemTimeMark, lldpRemLocalPortNum, lldpRemIndex, lldpRemOrgDefInfoOUI, lldpRemOrgDefInfoSubtype, and lldpRemOrgDefInfoIndex are indexes to this table. If there is an lldpRemOrgDefInfoEntry associated with a particular remote system identified by the lldpRemLocalPortNum and lldpRemIndex, there must be an lldpRemEntry associated with the same instance (i.e, using same indexes.) When the lldpRemEntry for the same index is removed from the lldpRemTable, the associated lldpRemOrgDefInfoEntry should be removed from the lldpRemOrgDefInfoTable.  Entries may be created and deleted in this table by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5807, '.1.3.6.1.4.1.9.9.48.1.1.1.3', 'ciscoMemoryPoolAlternate', 5804, 'current', NULL, 'Indicates whether or not this memory pool has an alternate pool configured. Alternate pools are used for fallback when the current pool runs out of memory.  If an instance of this object has a value of zero, then this pool does not have an alternate. Otherwise the value of this object is the same as the value of ciscoMemoryPoolType of the alternate pool.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6287, '.1.0.8802.1.1.2.1.3.5', 'lldpLocSysCapSupported', 6248, 'current', 'IEEE 802.1AB-2005 9.5.8.1', 'The bitmap value used to identify which system capabilities are supported on the local system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1165, '.1.3.6.1.2.1.27.1.1.3', 'applDirectoryName', 1162, 'current', NULL, 'The Distinguished Name of the directory entry where static information about this application is stored. An empty string indicates that no information about the application is available in the directory.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1166, '.1.3.6.1.2.1.27.1.1.4', 'applVersion', 1162, 'current', NULL, 'The version of network service application software. This field is usually defined by the vendor of the network service application software.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1167, '.1.3.6.1.2.1.27.1.1.5', 'applUptime', 1162, 'current', NULL, 'The value of sysUpTime at the time the network service application was last initialized. If the application was last initialized prior to the last initialization of the network management subsystem, then this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1168, '.1.3.6.1.2.1.27.1.1.6', 'applOperStatus', 1162, 'current', NULL, 'Indicates the operational status of the network service application. ''down'' indicates that the network service is not available. ''up'' indicates that the network service is operational and available. ''halted'' indicates that the service is operational but not available. ''congested'' indicates that the service is operational but no additional inbound associations can be accommodated. ''restarting'' indicates that the service is currently unavailable but is in the process of restarting and will be available soon. ''quiescing'' indicates that service is currently operational but is in the process of shutting down. Additional inbound associations may be rejected by applications in the ''quiescing'' state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1169, '.1.3.6.1.2.1.27.1.1.7', 'applLastChange', 1162, 'current', NULL, 'The value of sysUpTime at the time the network service application entered its current operational state. If the current state was entered prior to the last initialization of the local network management subsystem, then this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1170, '.1.3.6.1.2.1.27.1.1.8', 'applInboundAssociations', 1162, 'current', NULL, 'The number of current associations to the network service application, where it is the responder. An inbound association occurs when another application successfully connects to this one.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1171, '.1.3.6.1.2.1.27.1.1.9', 'applOutboundAssociations', 1162, 'current', NULL, 'The number of current associations to the network service application, where it is the initiator. An outbound association occurs when this application successfully connects to another one.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1172, '.1.3.6.1.2.1.27.1.1.10', 'applAccumulatedInboundAssociations', 1162, 'current', NULL, 'The total number of associations to the application entity since application initialization, where it was the responder.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1173, '.1.3.6.1.2.1.27.1.1.11', 'applAccumulatedOutboundAssociations', 1162, 'current', NULL, 'The total number of associations to the application entity since application initialization, where it was the initiator.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1174, '.1.3.6.1.2.1.27.1.1.12', 'applLastInboundActivity', 1162, 'current', NULL, 'The value of sysUpTime at the time this application last had an inbound association. If the last association occurred prior to the last initialization of the network subsystem, then this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1175, '.1.3.6.1.2.1.27.1.1.13', 'applLastOutboundActivity', 1162, 'current', NULL, 'The value of sysUpTime at the time this application last had an outbound association. If the last association occurred prior to the last initialization of the network subsystem, then this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1176, '.1.3.6.1.2.1.27.1.1.14', 'applRejectedInboundAssociations', 1162, 'current', NULL, 'The total number of inbound associations the application entity has rejected, since application initialization. Rejected associations are not counted in the accumulated association totals. Note that this only counts associations the application entity has rejected itself; it does not count rejections that occur at lower layers of the network. Thus, this counter may not reflect the true number of failed inbound associations.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1177, '.1.3.6.1.2.1.27.1.1.15', 'applFailedOutboundAssociations', 1162, 'current', NULL, 'The total number associations where the application entity is initiator and association establishment has failed, since application initialization. Failed associations are not counted in the accumulated association totals.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1178, '.1.3.6.1.2.1.27.1.1.16', 'applDescription', 1162, 'current', NULL, 'A text description of the application. This information is intended to identify and briefly describe the application in a status display.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1179, '.1.3.6.1.2.1.27.1.1.17', 'applURL', 1162, 'current', NULL, 'A URL pointing to a description of the application. This information is intended to identify and describe the application in a status display.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1180, '.1.3.6.1.2.1.27.2', 'assocTable', 1160, 'current', NULL, 'The table holding a set of all active application associations.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1181, '.1.3.6.1.2.1.27.2.1', 'assocEntry', 1180, 'current', NULL, 'An entry associated with an association for a network service application.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1182, '.1.3.6.1.2.1.27.2.1.1', 'assocIndex', 1181, 'current', NULL, 'An index to uniquely identify each association for a network service application. This attribute is the index that is used for lexicographic ordering of the table. Note that the table is also indexed by the applIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1183, '.1.3.6.1.2.1.27.2.1.2', 'assocRemoteApplication', 1181, 'current', NULL, 'The name of the system running remote network service application. For an IP-based application this should be either a domain name or IP address. For an OSI application it should be the string encoded distinguished name of the managed object. For X.400(1984) MTAs which do not have a Distinguished Name, the RFC 2156 syntax ''mta in globalid'' used in X400-Received: fields can be used. Note, however, that not all connections an MTA makes are necessarily to another MTA.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1184, '.1.3.6.1.2.1.27.2.1.3', 'assocApplicationProtocol', 1181, 'current', NULL, 'An identification of the protocol being used for the application. For an OSI Application, this will be the Application Context. For Internet applications, OID values of the form {applTCPProtoID port} or {applUDPProtoID port} are used for TCP-based and UDP-based protocols, respectively. In either case ''port'' corresponds to the primary port number being used by the protocol. The usual IANA procedures may be used to register ports for new protocols.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1185, '.1.3.6.1.2.1.27.2.1.4', 'assocApplicationType', 1181, 'current', NULL, 'This indicates whether the remote application is some type of client making use of this network service (e.g., a Mail User Agent) or a server acting as a peer. Also indicated is whether the remote end initiated an incoming connection to the network service or responded to an outgoing connection made by the local application. MTAs and messaging gateways are considered to be peers for the purposes of this variable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1186, '.1.3.6.1.2.1.27.2.1.5', 'assocDuration', 1181, 'current', NULL, 'The value of sysUpTime at the time this association was started. If this association started prior to the last initialization of the network subsystem, then this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1187, '.1.3.6.1.2.1.27.3', 'applConformance', 1160, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1188, '.1.3.6.1.2.1.27.3.1', 'applGroups', 1187, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1189, '.1.3.6.1.2.1.27.3.2', 'applCompliances', 1187, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1190, '.1.3.6.1.2.1.27.3.2.1', 'applCompliance', 1189, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1191, '.1.3.6.1.2.1.27.3.2.2', 'assocCompliance', 1189, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1192, '.1.3.6.1.2.1.27.3.2.3', 'applRFC2248Compliance', 1189, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1193, '.1.3.6.1.2.1.27.3.2.4', 'assocRFC2248Compliance', 1189, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1196, '.1.3.6.1.2.1.27.3.1.7', 'applRFC1565Group', 1188, 'obsolete', NULL, 'A collection of objects providing basic monitoring of network service applications. This is the original set of such objects defined in RFC 1565.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1197, '.1.3.6.1.2.1.27.3.1.2', 'assocRFC1565Group', 1188, 'obsolete', NULL, 'A collection of objects providing basic monitoring of network service applications'' associations. This is the original set of such objects defined in RFC 1565.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1198, '.1.3.6.1.2.1.27.3.1.3', 'applRFC2248Group', 1188, 'deprecated', NULL, 'A collection of objects providing basic monitoring of network service applications. This group was originally defined in RFC 2248; note that applDirectoryName is missing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1199, '.1.3.6.1.2.1.27.3.1.4', 'assocRFC2248Group', 1188, 'deprecated', NULL, 'A collection of objects providing basic monitoring of network service applications'' associations. This group was originally defined by RFC 2248.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1200, '.1.3.6.1.2.1.27.3.1.5', 'applRFC2788Group', 1188, 'current', NULL, 'A collection of objects providing basic monitoring of network service applications. This is the appropriate group for RFC 2788 missing in RFC 2248.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1201, '.1.3.6.1.2.1.27.3.1.6', 'assocRFC2788Group', 1188, 'current', NULL, 'A collection of objects providing basic monitoring of network service applications'' associations. This is the appropriate group for RFC 2788.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1202, '.1.3.6.1.2.1.27.4', 'applTCPProtoID', 1160, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1203, '.1.3.6.1.2.1.27.5', 'applUDPProtoID', 1160, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5865, '.1.3.6.1.2.1.19.2.1.7', 'charPortOperStatus', 5858, 'current', NULL, 'The port''s actual, operational state, independent of flow control. ''up'' indicates able to function normally. ''down'' indicates inability to function for administrative or operational reasons. ''maintenance'' indicates a maintenance mode, exclusive of normal operation, such as running a test. ''absent'' indicates that port hardware is not present. ''active'' indicates up with a user present (e.g. logged in).  ''up'' and ''active'' correspond to ifOperStatus ''up''. ''down'' and ''absent'' correspond to ifOperStatus ''down''. ''maintenance'' corresponds to ifOperStatus ''test''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5866, '.1.3.6.1.2.1.19.2.1.8', 'charPortLastChange', 5858, 'current', NULL, 'The value of sysUpTime at the time the port entered its current operational state. If the current state was entered prior to the last reinitialization of the local network management subsystem, then this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5867, '.1.3.6.1.2.1.19.2.1.9', 'charPortInFlowType', 5858, 'deprecated', NULL, 'The port''s type of input flow control. ''none'' indicates no flow control at this level or below. ''xonXoff'' indicates software flow control by recognizing XON and XOFF characters. ''hardware'' indicates flow control delegated to the lower level, for example a parallel port.  ''ctsRts'' and ''dsrDtr'' are specific to RS-232-like ports. Although not architecturally pure, they are included here for simplicity''s sake.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5868, '.1.3.6.1.2.1.19.2.1.10', 'charPortOutFlowType', 5858, 'deprecated', NULL, 'The port''s type of output flow control. ''none'' indicates no flow control at this level or below. ''xonXoff'' indicates software flow control by recognizing XON and XOFF characters. ''hardware'' indicates flow control delegated to the lower level, for example a parallel port.  ''ctsRts'' and ''dsrDtr'' are specific to RS-232-like ports. Although not architecturally pure, they are included here for simplicy''s sake.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5869, '.1.3.6.1.2.1.19.2.1.11', 'charPortInFlowState', 5858, 'current', NULL, 'The current operational state of input flow control on the port. ''none'' indicates not applicable. ''unknown'' indicates this level does not know. ''stop'' indicates flow not allowed. ''go'' indicates flow allowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5870, '.1.3.6.1.2.1.19.2.1.12', 'charPortOutFlowState', 5858, 'current', NULL, 'The current operational state of output flow control on the port. ''none'' indicates not applicable. ''unknown'' indicates this level does not know. ''stop'' indicates flow not allowed. ''go'' indicates flow allowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5871, '.1.3.6.1.2.1.19.2.1.13', 'charPortInCharacters', 5858, 'current', NULL, 'Total number of characters detected as input from the port since system re-initialization and while the port operational state was ''up'', ''active'', or ''maintenance'', including, for example, framing, flow control (i.e. XON and XOFF), each occurrence of a BREAK condition, locally-processed input, and input sent to all sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5872, '.1.3.6.1.2.1.19.2.1.14', 'charPortOutCharacters', 5858, 'current', NULL, 'Total number of characters detected as output to the port since system re-initialization and while the port operational state was ''up'', ''active'', or ''maintenance'', including, for example, framing, flow control (i.e. XON and XOFF), each occurrence of a BREAK condition, locally-created output, and output received from all sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5873, '.1.3.6.1.2.1.19.2.1.15', 'charPortAdminOrigin', 5858, 'current', NULL, 'The administratively allowed origin for establishing session on the port. ''dynamic'' allows ''network'' or ''local'' session establishment. ''none'' disallows session establishment.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5874, '.1.3.6.1.2.1.19.2.1.16', 'charPortSessionMaximum', 5858, 'current', NULL, 'The maximum number of concurrent sessions allowed on the port. A value of -1 indicates no maximum. Setting the maximum to less than the current number of sessions has unspecified results.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5875, '.1.3.6.1.2.1.19.2.1.17', 'charPortSessionNumber', 5858, 'current', NULL, 'The number of open sessions on the port that are in the connecting, connected, or disconnecting state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5876, '.1.3.6.1.2.1.19.2.1.18', 'charPortSessionIndex', 5858, 'current', NULL, 'The value of charSessIndex for the port''s first or only active session. If the port has no active session, the agent returns the value zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5877, '.1.3.6.1.2.1.19.2.1.19', 'charPortInFlowTypes', 5858, 'current', NULL, 'The port''s types of input flow control at the software level. Hardware-level flow control is independently controlled by the appropriate hardware-level MIB.  A value of zero indicates no flow control. Depending on the specific implementation, any or all combinations of flow control may be chosen by adding the values:  128 xonXoff, recognizing XON and XOFF characters 64 enqHost, ENQ/ACK to allow input to host 32 enqTerm, ACK to allow output to port', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5878, '.1.3.6.1.2.1.19.2.1.20', 'charPortOutFlowTypes', 5858, 'current', NULL, 'The port''s types of output flow control at the software level. Hardware-level flow control is independently controlled by the appropriate hardware-level MIB.  A value of zero indicates no flow control. Depending on the specific implementation, any or all combinations of flow control may be chosen by adding the values:  128 xonXoff, recognizing XON and XOFF characters 64 enqHost, ENQ/ACK to allow input to host 32 enqTerm, ACK to allow output to port', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5879, '.1.3.6.1.2.1.19.2.1.21', 'charPortLowerIfIndex', 5858, 'current', NULL, 'The ifIndex value of the lower level hardware supporting this character port, zero if none.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5880, '.1.3.6.1.2.1.19.3', 'charSessTable', 5855, 'current', NULL, 'A list of port session entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5881, '.1.3.6.1.2.1.19.3.1', 'charSessEntry', 5880, 'current', NULL, 'Status and parameter values for a character port session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5840, '.1.3.6.1.4.1.9.9.92.1.1.1.7', 'ceAssetFirmwareID', 5833, 'current', NULL, 'This variable indicates the firmware installed on this entity.  For IOS devices, this variable''s value is in the IOS Image Naming Convention format.  IOS Image Naming Convention  Software images are named according to a scheme that identifies what''s in the image and what platform it runs on. The names have three parts, separated by dashes: e.g. xxxx-yyyy-ww. xxxx = Platform yyyy = Features ww = Where it executes from and if compressed', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5841, '.1.3.6.1.4.1.9.9.92.1.1.1.8', 'ceAssetFirmwareRevision', 5833, 'current', NULL, 'This variable indicates the revision of firmware installed on this entity.  For IOS devices, this variable''s value is in the NGRP external customer-visible format.  NGRP external customer-visible revision strings have this format: ''x.y (z [p] ) [A] [ [ u ( v [ p ] ) ] ] [ q ]'', where: - x.y Combination of two 1-2 digit numerics separated by a �.� that identify the Software major release - z 1-3 digit numeric that identifies the maintenance release of x.y - A 1-3 alpha letters, designator of the release train. - u 1-2 digit numeric that identifies the version of the ED-specific code - v 1-2 digit numeric that identifies the maintenance release of the ED-specific code - v 1-2 digit numeric that identifies the maintenance release of the ED-specific code - p 1 alpha letter that identifies the unusual special case SW Line Stop Fast Re-build by the Release Ops team to replace the posted/shipping release in CCO and Mfg with a version containing a critical catastrophic defect fix that cannot wait until the next maintenance release - q 3 alphanumeric optional suffix used as an indicator in the image banner by the SW Line Stop Re-build process used unusual special case situation when the renumber build has occurred but the images have not been released (value always blank unless these special circumstances require it�s use).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5842, '.1.3.6.1.4.1.9.9.92.1.1.1.9', 'ceAssetSoftwareID', 5833, 'current', NULL, 'This variable indicates the software installed on this entity.  For IOS devices, this variable''s value is in the IOS Image Naming Convention format.  IOS Image Naming Convention ----------------------- Software images are named according to a scheme that identifies what''s in the image and what platform it runs on. The names have three parts, separated by dashes: e.g. xxxx-yyyy-ww. xxxx = Platform yyyy = Features ww = Where it executes from and if compressed', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5843, '.1.3.6.1.4.1.9.9.92.1.1.1.10', 'ceAssetSoftwareRevision', 5833, 'current', NULL, 'This variable indicates the revision of software installed on this entity.  For IOS devices, this variable''s value is in the NGRP external customer-visible format.  NGRP external customer-visible revision strings have this format: ''x.y (z [p] ) [A] [ [ u ( v [ p ] ) ] ] [ q ]'', where: - x.y Combination of two 1-2 digit numerics separated by a �.� that identify the Software major release - z 1-3 digit numeric that identifies the maintenance release of x.y - A 1-3 alpha letters, designator of the release train. - u 1-2 digit numeric that identifies the version of the ED-specific code - v 1-2 digit numeric that identifies the maintenance release of the ED-specific code - p 1 alpha letter that identifies the unusual special case SW Line Stop Fast Re-build by the Release Ops team to replace the posted/shipping release in CCO and Mfg with a version containing a critical catastrophic defect fix that cannot wait until the next maintenance release - q 3 alphanumeric optional suffix used as an indicator in the image banner by the SW Line Stop Re-build process used unusual special case situation when the renumber build has occurred but the images have not been released (value always blank unless these special circumstances require it�s use).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5844, '.1.3.6.1.4.1.9.9.92.1.1.1.11', 'ceAssetCLEI', 5833, 'current', 'Bellcore Technical reference GR-485-CORE, COMMON LANGUAGE Equipment Processes and Guidelines, Issue 2, October, 1995.', 'This object represents the CLEI (Common Language Equipment Identifier) code for the physical entity.  If the physical entity is not present in the system, or does not have an associated CLEI code, then the value of this object will be a zero-length string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5845, '.1.3.6.1.4.1.9.9.92.1.1.1.12', 'ceAssetAlias', 5833, 'current', NULL, 'This object is an ''alias'' name for the physical entity as specified by a network manager, and provides a non-volatile ''handle'' for the physical entity.  On the first instantiation of an physical entity, the value of entPhysicalAlias associated with that entity is set to the zero-length string. However, agent may set the value to a locally unique default value, instead of a zero-length string.  If write access is implemented for an instance of entPhysicalAlias, and a value is written into the instance, the agent must retain the supplied value in the entPhysicalAlias instance associated with the same physical entity for as long as that entity remains instantiated. This includes instantiations across all re-initializations/reboots of the network management system, including those which result in a change of the physical entity''s entPhysicalIndex value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5846, '.1.3.6.1.4.1.9.9.92.1.1.1.13', 'ceAssetTag', 5833, 'current', NULL, 'This object is a user-assigned asset tracking identifier for the physical entity as specified by a network manager, and provides non-volatile storage of this information.  On the first instantiation of an physical entity, the value of ceasAssetID associated with that entity is set to the zero-length string.  Not every physical component will have a asset tracking identifier, or even need one. Physical entities for which the associated value of the ceAssetIsFRU object is equal to ''false'' (e.g., the repeater ports within a repeater module), do not need their own unique asset tracking identifier. An agent does not have to provide write access for such entities, and may instead return a zero-length string.  If write access is implemented for an instance of ceasAssetID, and a value is written into the instance, the agent must retain the supplied value in the ceasAssetID instance associated with the same physical entity for as long as that entity remains instantiated. This includes instantiations across all re-initializations/reboots of the network management system, including those which result in a change of the physical entity''s entPhysicalIndex value.  If no asset tracking information is associated with the physical component, then this object will contain a zero- length string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5847, '.1.3.6.1.4.1.9.9.92.1.1.1.14', 'ceAssetIsFRU', 5833, 'current', NULL, 'This object indicates whether or not this physical entity is considered a ''field replaceable unit'' by the vendor. If this object contains the value ''true'' then the corresponding entPhysicalEntry identifies a field replaceable unit. For all entPhysicalEntries which represent components that are permanently contained within a field replaceable unit, the value ''false'' should be returned for this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5848, '.1.3.6.1.4.1.9.9.92.2', 'ciscoEntityAssetMIBNotificationsPrefix', 5830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5849, '.1.3.6.1.4.1.9.9.92.2.0', 'ciscoEntityAssetMIBNotifications', 5848, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5850, '.1.3.6.1.4.1.9.9.92.3', 'ciscoEntityAssetMIBConformance', 5830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5851, '.1.3.6.1.4.1.9.9.92.3.1', 'ciscoEntityAssetMIBCompliances', 5850, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5852, '.1.3.6.1.4.1.9.9.92.3.2', 'ciscoEntityAssetMIBGroups', 5850, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5853, '.1.3.6.1.4.1.9.9.92.3.1.1', 'ciscoEntityAssetMIBCompliance', 5851, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5854, '.1.3.6.1.4.1.9.9.92.3.2.1', 'ceAssetGroup', 5852, 'current', NULL, 'The collection of objects which are used to describe and monitor asset-related data of ENTITY-MIB entPhysicalTable items.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5855, '.1.3.6.1.2.1.19', 'char', 21, 'current', NULL, 'The MIB module for character stream devices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5806, '.1.3.6.1.4.1.9.9.48.1.1.1.2', 'ciscoMemoryPoolName', 5804, 'current', NULL, 'A textual name assigned to the memory pool. This object is suitable for output to a human operator, and may also be used to distinguish among the various pool types, especially among dynamic pools.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5644, '.1.3.6.1.4.1.9.9.97.1.2.6', 'cseRouterVlanTable', 5596, 'current', NULL, 'The table listing the MAC address used by routers on particular VLANs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5808, '.1.3.6.1.4.1.9.9.48.1.1.1.4', 'ciscoMemoryPoolValid', 5804, 'current', NULL, 'Indicates whether or not the remaining objects in this entry contain accurate data. If an instance of this object has the value false (which in and of itself indicates an internal error condition), the values of the remaining objects in the conceptual row may contain inaccurate information (specifically, the reported values may be less than the actual values).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5809, '.1.3.6.1.4.1.9.9.48.1.1.1.5', 'ciscoMemoryPoolUsed', 5804, 'current', NULL, 'Indicates the number of bytes from the memory pool that are currently in use by applications on the managed device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5810, '.1.3.6.1.4.1.9.9.48.1.1.1.6', 'ciscoMemoryPoolFree', 5804, 'current', NULL, 'Indicates the number of bytes from the memory pool that are currently unused on the managed device.  Note that the sum of ciscoMemoryPoolUsed and ciscoMemoryPoolFree is the total amount of memory in the pool', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5811, '.1.3.6.1.4.1.9.9.48.1.1.1.7', 'ciscoMemoryPoolLargestFree', 5804, 'current', NULL, 'Indicates the largest number of contiguous bytes from the memory pool that are currently unused on the managed device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5812, '.1.3.6.1.4.1.9.9.48.2', 'ciscoMemoryPoolNotifications', 5801, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5813, '.1.3.6.1.4.1.9.9.48.3', 'ciscoMemoryPoolConformance', 5801, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5814, '.1.3.6.1.4.1.9.9.48.3.1', 'ciscoMemoryPoolCompliances', 5813, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5815, '.1.3.6.1.4.1.9.9.48.3.2', 'ciscoMemoryPoolGroups', 5813, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5816, '.1.3.6.1.4.1.9.9.48.3.1.1', 'ciscoMemoryPoolCompliance', 5814, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5817, '.1.3.6.1.4.1.9.9.48.3.2.1', 'ciscoMemoryPoolGroup', 5815, 'current', NULL, 'A collection of objects providing memory pool monitoring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5818, '.1.3.6.1.4.1.9.9.160', 'ciscoCircuitInterfaceMIB', 272, 'current', NULL, 'The MIB module to configure the circuit description for an interface. The circuit description can be used to describe and identify circuits on interfaces like ATM, frame-relay etc.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5819, '.1.3.6.1.4.1.9.9.160.1', 'ciscoCircuitInterfaceMIBObjects', 5818, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5820, '.1.3.6.1.4.1.9.9.160.1.1', 'cciDescription', 5819, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5821, '.1.3.6.1.4.1.9.9.160.1.1.1', 'cciDescriptionTable', 5820, 'current', NULL, 'This table contains a circuit description to identify circuit based interfaces like ATM, Frame-Relay etc. The circuit description could be used for example, to correlate performance statistics associated with the corresponding interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5822, '.1.3.6.1.4.1.9.9.160.1.1.1.1', 'cciDescriptionEntry', 5821, 'current', NULL, 'Each cciDescriptionEntry contains the circuit description for a particular circuit based interface. The entry is identified by the ifIndex which would typically correspond to circuit based interfaces. Interfaces with ifType equal to atm(37), frameRelay(32) frameRelayService(44) are some examples.  Entries can only be created by management station action. Entries can be deleted by setting the cciStatus object to destroy(6). The agent will delete any cciEntry if the corresponding ifEntry is deleted. Entries are not maintained in any kind of NV-storage, and will not be recreated by the agent after a reboot.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5823, '.1.3.6.1.4.1.9.9.160.1.1.1.1.1', 'cciDescr', 5822, 'current', NULL, 'The circuit description of the interface. It has no default value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5824, '.1.3.6.1.4.1.9.9.160.1.1.1.1.2', 'cciStatus', 5822, 'current', NULL, 'The row status object, but with restricted values. Only two values are allowed for this object: createAndGo(4) and destroy(6). The row is created by specifying the value for cciDescr and setting this object to createAndGo(4). If the row creation is succesfull, the cciStatus would be active(1). In the active(1) state, the cciDescr can be modifed. The row is deleted by setting this object to destroy(6).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5825, '.1.3.6.1.4.1.9.9.160.3', 'ciscoCircuitInterfaceMIBConformance', 5818, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5826, '.1.3.6.1.4.1.9.9.160.3.1', 'ciscoCircuitInterfaceMIBCompliances', 5825, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5827, '.1.3.6.1.4.1.9.9.160.3.2', 'ciscoCircuitInterfaceMIBGroups', 5825, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5828, '.1.3.6.1.4.1.9.9.160.3.1.1', 'ciscoCircuitInterfaceMIBCompliance', 5826, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5829, '.1.3.6.1.4.1.9.9.160.3.2.1', 'ciscoCircuitInterfaceGroup', 5827, 'current', NULL, 'The Cisco Circuit Interface MIB objects.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5830, '.1.3.6.1.4.1.9.9.92', 'ciscoEntityAssetMIB', 272, 'current', NULL, 'Monitor the asset information of items in the ENTITY-MIB (RFC 2037) entPhysical table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5831, '.1.3.6.1.4.1.9.9.92.1', 'ciscoEntityAssetMIBObjects', 5830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5832, '.1.3.6.1.4.1.9.9.92.1.1', 'ceAssetTable', 5831, 'current', NULL, 'This table lists the orderable part number, serial number, hardware revision, manufacturing assembly number and revision, firmwareID and revision if any, and softwareID and revision if any, of relevant entities listed in the ENTITY-MIB entPhysicalTable.  Entities for which none of this data is available are not listed in this table. This is a sparse table so some of these variables may not exist for a particular entity at a particular time. For example, a powered-off module does not have softwareID and revision; a power-supply would probably never have firmware or software information.  Although the data may have other items encoded in it (for example manufacturing-date in the serial number) please treat all data items as monolithic. Do not decompose them or parse them. Use only string equals and unequals operations on them.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5833, '.1.3.6.1.4.1.9.9.92.1.1.1', 'ceAssetEntry', 5832, 'current', NULL, 'An entAssetEntry entry describes the asset-tracking related data for an entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5834, '.1.3.6.1.4.1.9.9.92.1.1.1.1', 'ceAssetOEMString', 5833, 'current', NULL, 'This variable indicates the Original Equipment Manufacturer of the entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5835, '.1.3.6.1.4.1.9.9.92.1.1.1.2', 'ceAssetSerialNumber', 5833, 'current', NULL, 'This variable indicates the serial number of the entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5836, '.1.3.6.1.4.1.9.9.92.1.1.1.3', 'ceAssetOrderablePartNumber', 5833, 'current', NULL, 'This variable indicates the part number you can use to order the entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5837, '.1.3.6.1.4.1.9.9.92.1.1.1.4', 'ceAssetHardwareRevision', 5833, 'current', NULL, 'This variable indicates the engineering design revision of the hardware of the entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5838, '.1.3.6.1.4.1.9.9.92.1.1.1.5', 'ceAssetMfgAssyNumber', 5833, 'current', NULL, 'This variable indicates the manufacturing assembly number, which is the ''hardware'' identification.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5839, '.1.3.6.1.4.1.9.9.92.1.1.1.6', 'ceAssetMfgAssyRevision', 5833, 'current', NULL, 'This variable indicates the revision of the entity, within the ceAssetMfgAssyNumber.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5856, '.1.3.6.1.2.1.19.1', 'charNumber', 5855, 'current', NULL, 'The number of entries in charPortTable, regardless of their current state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5857, '.1.3.6.1.2.1.19.2', 'charPortTable', 5855, 'current', NULL, 'A list of port entries. The number of entries is given by the value of charNumber.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5782, '.1.3.6.1.4.1.9.9.97.1.7.1.1.5', 'cseMcastCacheRtrIp', 5777, 'current', NULL, 'The IP address of the router whose flows are currently being switched, and will be purged. An ''all-zero'' value is a wildcard IP address for any router. Its value can not be modified when the corresponding instance of cseMcastCacheStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5783, '.1.3.6.1.4.1.9.9.97.1.7.1.1.6', 'cseMcastCacheOwner', 5777, 'current', NULL, 'The manager entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5784, '.1.3.6.1.4.1.9.9.97.1.7.1.1.7', 'cseMcastCacheResult', 5777, 'current', NULL, 'state of the flow purging operation.  ''purging'' - purging operation is proceeding  ''notPurging'' - the purging operation completed, or not started yet.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5785, '.1.3.6.1.4.1.9.9.97.1.7.1.1.8', 'cseMcastCacheStatus', 5777, 'current', NULL, 'The status object used to manage rows in this table. When set to active(1), the flow purge is initiated, and the value of cseMcastCacheResult object becomes ''purging''. However, this object can be set to active(1) only after all the appropriate objects for this query as defined by the value set in the cseMcastCacheFlowType object, have also been set. Upon the completion of flow purge, the value of cseMcastCacheResult object changes to ''notPurging''. Once a row becomes active, values within the row cannot be modified, except by setting it to ''notInService'' first, or deleting and re-creating it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5786, '.1.3.6.1.4.1.9.9.97.2', 'cseMIBNotifications', 5593, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5787, '.1.3.6.1.4.1.9.9.97.3', 'cseMIBConformance', 5593, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5788, '.1.3.6.1.4.1.9.9.97.3.1', 'cseMIBCompliances', 5787, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5789, '.1.3.6.1.4.1.9.9.97.3.2', 'cseMIBGroups', 5787, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5790, '.1.3.6.1.4.1.9.9.97.3.1.1', 'cseMIBCompliance', 5788, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5791, '.1.3.6.1.4.1.9.9.97.3.2.1', 'cseStatisticsGroup', 5789, 'current', NULL, 'A collection of objects providing switch engine statistics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5792, '.1.3.6.1.4.1.9.9.97.3.2.2', 'cseStatisticsGroup2', 5789, 'current', NULL, 'A collection of objects providing switch engine statistics on aged/purged flows, and the cache utilizations.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5793, '.1.3.6.1.4.1.9.9.97.3.2.3', 'cseVlanStatisticsGroup', 5789, 'current', NULL, 'A collection of objects providing per-vlan switch engine statistics, if supported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5794, '.1.3.6.1.4.1.9.9.97.3.2.4', 'cseRouterGroup', 5789, 'current', NULL, 'A collection of objects providing information on routers which are used to support layer 3 switching in the system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5795, '.1.3.6.1.4.1.9.9.97.3.2.5', 'cseFlowMgmtGroup', 5789, 'current', NULL, 'A collection of objects providing information for determining the L3 flow switching performance in the switching engine. There may be some platform specific limitations when performing a SET on some of these objects.  The following are valid for Catalyst 5000 platforms:  - cseFlowEstablishedAgingTime has a default value of 256.  - cseFlowFastAgePktThreshold can only be set to 1, 3, 7, 15, 31 or 63 packets. If the packet threshold is not configured to one of these values, it will be adjusted to the closest value.  - cseFlowFastAgingTime can be set to only values that are multiples of 8 in the range (0..128). If it is set to a value that is not multiple of 8, then the closest value that is a multiple of 8 will take effect. The default value for fast aging time is 32 seconds. (i.e. less than cseFlowFastAgePktThreshold number of packets were switched within 32 seconds after the an L3 flow entry was established).  - cseFlowIPXEstablishedAgingTime has a default value of 256.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5796, '.1.3.6.1.4.1.9.9.97.3.2.6', 'cseNetflowLSGroup', 5789, 'current', NULL, 'A collection of objects providing information on the Netflow LAN switching Data Export feature, if supported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5797, '.1.3.6.1.4.1.9.9.97.3.2.7', 'cseProtocolFilterGroup', 5789, 'current', NULL, 'A collection of objects providing information on the Protocol filter feature, if supported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5798, '.1.3.6.1.4.1.9.9.97.3.2.8', 'cseFlowMcastMgmtGroup', 5789, 'current', NULL, 'A collection of objects for querying IP multicast flows stored in hardware switching cache.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5799, '.1.3.6.1.4.1.9.9.97.3.2.9', 'cseUcastCachePurgeGroup', 5789, 'current', NULL, 'A collection of objects providing IP/IPX unicast flow cache purging function.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5800, '.1.3.6.1.4.1.9.9.97.3.2.10', 'cseMcastCachePurgeGroup', 5789, 'current', NULL, 'A collection of objects providing IP multicast flow cache purge function.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5762, '.1.3.6.1.4.1.9.9.97.1.5.2.1.3', 'cseProtocolFilterPortOperStatus', 5759, 'current', NULL, 'An indication of the operational status of filtering for this protocol on this interface. - on(1) indicates that the interface will send and receive the protocol traffic. - off(2) indicates that the interface will drop all traffic belonging to this protocol. - notSupported(3) indicates the hardware does not support protocol filtering.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5763, '.1.3.6.1.4.1.9.9.97.1.6.1', 'cseUcastCacheTable', 5600, 'current', NULL, 'A control table used to purge certain types of IP/IPX layer 3 unicast flows stored in the cache pool.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5764, '.1.3.6.1.4.1.9.9.97.1.6.1.1', 'cseUcastCacheEntry', 5763, 'current', NULL, 'A conceptual row in the cseUcastCacheTable, used to set up flow clearing criteria. The actual purging is started by setting the value of cseUcastCacheStatus to ''active''. Once a row becomes active, values within the row cannot be modified, except by setting it to ''notInService'' first or deleting and re-creating the row.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5765, '.1.3.6.1.4.1.9.9.97.1.6.1.1.1', 'cseUcastCacheIndex', 5764, 'current', NULL, 'An arbitrary integer which uniquely identifies the flow purge contained in this row instance.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5766, '.1.3.6.1.4.1.9.9.97.1.6.1.1.2', 'cseUcastCacheFlowType', 5764, 'current', NULL, 'Setting each value causes the appropriate action:  ''dstOnly'' - causes purge of flows in the cache whose absolute destination IP addresses match the address part of the value set in the cseUcastCacheDest object. If cseUcastCacheDestMask is also specified at the same time, it will be applied to the address part of cseUcastCacheDest.  ''srcOrDst'' - causes purge of flows in the cache whose either absolute source or destination IP addresses match the address parts of the values set in cseUcastCacheSource or cseUcastCacheDest. If cseUcastCacheDestMask/cseUcastCacheSrcMask also specified, they will be applied to the address parts of cseUcastCacheSource/ cseUcastCacheDest appropriately.  ''srcAndDst'' - causes purge of flows in the cache whose both absolute source and destination IP addresses match the address parts of values set in cseUcastCacheSource and cseUcastCacheDest objects. If cseUcastCacheSrcMask and cseUcastCacheDestMask also specified, they will be applied to the address parts of cseUcastCacheSource and cseUcastCacheDest.  ''fullFlow'' - causes purge of IP flows whose IP addresses and transport port numbers match the values set in cseUcastCacheDest and cseUcastCacheSource objects. If either cseUcastCacheDestMask or cseUcastCacheSrcMask objects have valid values, they will be applied to the respective address parts of cseUcastCacheDest and cseUcastCacheSource objects. This option is typically used to purge flows relevant to specific applications such as FTP, WWW, TELNET, etc.  ''ipxDstOnly'' - causes purge of IPX flows in the cache whose absolute destination IPX address match the address part of the value set in cseUcastCacheDest object. if cseUcastCacheDestMask holds valid value at the same time, it will be applied to the address part of cseUcastCacheDest.  ''ipxSrcAndDst'' - causes purge of IPX flows in the cache whose both absolute source and destination IPX addresses match the address parts of the values set in cseUcastCacheSource and cseUcastCacheDest objects. If either of cseUcastCacheSrcMask or cseUcastCacheDestMask have valid values at the same time, they will be applied to the respective address parts of cseUcastCacheSource and cseUcastCacheDest objects.  ''any'' - causes purge of all established flows currently in the cache. The values of cseUcastCacheDest, cseUcastCacheSource, cseUcastCacheDestMask, cseUcastCacheSrcMask, and cseUcastCacheTransport should be ignored in this case.  Note: 1. When the row instance is initialized, the value of this object instance will be set to ''any''. 2. The rest flow parameter variables will not be instantiated until they get set by management applications based on the value of cseUcastCacheFlowType object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5767, '.1.3.6.1.4.1.9.9.97.1.6.1.1.3', 'cseUcastCacheTransport', 5764, 'current', NULL, 'The IP transport protocol type (if applicable) of the specified switched flows to be purged; it will be instantiated if and only if it gets set by the management applications and the value of cseUcastCacheFlowMask is equal to ''fullFlow''. Its value can not be modified when the corresponding instance of cseUcastCacheStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5768, '.1.3.6.1.4.1.9.9.97.1.6.1.1.4', 'cseUcastCacheDest', 5764, 'current', NULL, 'Destination network address and port number (if applicable). The port field is ignored for IPX flows and IP flows if the value of cseUcastCacheFlowMask is not equal to ''fullFlow''. Its value can not be modified when the corresponding instance of cseUcastCacheStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5769, '.1.3.6.1.4.1.9.9.97.1.6.1.1.5', 'cseUcastCacheDestMask', 5764, 'current', NULL, 'If instantiated, specified and applicable, the destination address mask will be applied to the value of cseUcastCacheDest in the same row instance. Its value can not be modified when the corresponding instance of cseUcastCacheStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5770, '.1.3.6.1.4.1.9.9.97.1.6.1.1.6', 'cseUcastCacheSource', 5764, 'current', NULL, 'Source network address and port number (if applicable). The port field is ignored for IPX flows and IP flows if the value of cseUcastCacheFlowMask is not equal to ''fullFlow''. Its value can not be modified when the corresponding instance of cseUcastCacheStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5771, '.1.3.6.1.4.1.9.9.97.1.6.1.1.7', 'cseUcastCacheSrcMask', 5764, 'current', NULL, 'If instantiated, specified and applicable, the source address mask will be applied to the value of cseUcastCacheSource in the same row instance. Its value can not be modified when the corresponding instance of cseUcastCacheStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5772, '.1.3.6.1.4.1.9.9.97.1.6.1.1.8', 'cseUcastCacheRtrIp', 5764, 'current', NULL, 'IP address of the router (internal or external) for which the flows are being switched, and need to be purged. An ''all-zero'' value is a wildcard IP address for any router. Its value can not be modified when the corresponding instance of cseUcastCacheStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5773, '.1.3.6.1.4.1.9.9.97.1.6.1.1.9', 'cseUcastCacheOwner', 5764, 'current', NULL, 'The manager entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5774, '.1.3.6.1.4.1.9.9.97.1.6.1.1.11', 'cseUcastCacheResult', 5764, 'current', NULL, 'state of the flow purging operation.  ''purging'' - purging operation is proceeding  ''notPurging'' - the purging operation completed, or not started yet.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5775, '.1.3.6.1.4.1.9.9.97.1.6.1.1.10', 'cseUcastCacheStatus', 5764, 'current', NULL, 'The status object used to manage rows in this table. When set to active(1), the flow purge is initiated, and the value of cseUcastCacheResult object becomes ''purging''. However, this object can be set to active(1) only after all the appropriate objects for this query as defined by the value set in the cseUcastCacheFlowType object, have also been set. Upon the completion of flow purge, the value of cseUcastCacheResult object changes to ''notPurging''. Once a row becomes active, values within the row cannot be modified, except by setting it to ''notInService'' first, or deleting and re-creating it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5776, '.1.3.6.1.4.1.9.9.97.1.7.1', 'cseMcastCacheTable', 5601, 'current', NULL, 'A control table used to purge specified IP multicast flows from the switch engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5777, '.1.3.6.1.4.1.9.9.97.1.7.1.1', 'cseMcastCacheEntry', 5776, 'current', NULL, 'A conceptual row in the cseMcastCacheTable, used to set up flow clearing criteria. The actual purging is started by setting the value of cseMcastCacheStatus to ''active''. Once a row becomes active, values within the row cannot be modified, except by setting it to ''notInService'' first, or deleting and re-creating the row.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5778, '.1.3.6.1.4.1.9.9.97.1.7.1.1.1', 'cseMcastCacheIndex', 5777, 'current', NULL, 'An arbitrary integer which uniquely identifies the flow purge contained in the current row instance.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5779, '.1.3.6.1.4.1.9.9.97.1.7.1.1.2', 'cseMcastCacheFlowType', 5777, 'current', NULL, 'Setting each value causes the appropriate action:  ''any'' - causes purge of all established IP multicast layer 3 flows in the cache. The value of cseMcastCacheGrp, and cseMcastCacheSrc will be ignored in this case.  ''group'' - causes purge of flows whose multicast group IP address match the values of cseMcastCacheGrp.  ''grpAndSrc'' - causes purge of multicast flows whose both group IP address and source Ip address match the values of cseMcastCacheGrp and cseMcastCacheSrc.  Note: 1. The instance of this object is initialized to ''any'' when the corresponding row instance is being instantiated. 2. Flow parameter variables, cseMcastCacheGrp, cseMcastCacheSrc, cseMcastCacheRtrIp will not be instantiated until they get set by management applications (in such cases, cseMcastCacheFlowType object should be set to a value other than ''any'').', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5780, '.1.3.6.1.4.1.9.9.97.1.7.1.1.3', 'cseMcastCacheGrp', 5777, 'current', NULL, 'Specifying multicast group IP address of the flows to be cleared. Its value can not be modified when the corresponding instance of cseMcastCacheStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5781, '.1.3.6.1.4.1.9.9.97.1.7.1.1.4', 'cseMcastCacheSrc', 5777, 'current', NULL, 'The source address of the IP multicast flows to be purged. Its value can not be modified when the corresponding instance of cseMcastCacheStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5805, '.1.3.6.1.4.1.9.9.48.1.1.1.1', 'ciscoMemoryPoolType', 5804, 'current', NULL, 'The type of memory pool for which this entry contains information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5730, '.1.3.6.1.4.1.9.9.97.1.3.8', 'cseNetflowLSExportDataProtocol', 5597, 'current', 'The protocol value is defined in the RFC 1700.', 'The protocol used as a filter for selecting the flows to which the netflow LAN switching data export feature is applied.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5731, '.1.3.6.1.4.1.9.9.97.1.3.9', 'cseNetflowLSExportDataFilterSelection', 5597, 'current', NULL, 'The filter set can be chosen either included(1) or excluded(2) mutually exclusive. If this object is set to included(1) - exports the flows that match cseNetflowLSExportDataSource, cseNetflowLSExportDataSourceMask, cseNetflowLSExportDataDest, cseNetflowLSExportDataDestMask and cseNetflowLSExportDataProtocol.  excluded(2) - exports the flows that don''t match cseNetflowLSExportDataSource, cseNetflowLSExportDataSourceMask, cseNetflowLSExportDataDest, cseNetflowLSExportDataDestMask and cseNetflowLSExportDataProtocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5732, '.1.3.6.1.4.1.9.9.97.1.3.10', 'cseNetflowLSExportNDEVersionNumber', 5597, 'current', NULL, 'the netflow data export version number which is supported by the device. The typical value of this object can be 1, 7 or 8.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5733, '.1.3.6.1.4.1.9.9.97.1.4.1', 'cseL3StatsTable', 5598, 'current', NULL, 'A table containing L3 statistics information on each switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5734, '.1.3.6.1.4.1.9.9.97.1.4.1.1', 'cseL3StatsEntry', 5733, 'current', NULL, 'A conceptual row of cseL3StatsTable, containing L3 statistics maintained by a switching engine entity (identified by entPhysicalIndex). Each switching engine managed by this MIB module has an entry in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5735, '.1.3.6.1.4.1.9.9.97.1.4.1.1.1', 'cseL3SwitchedTotalPkts', 5734, 'current', NULL, 'Total number of packets switched at Layer 3 by this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5736, '.1.3.6.1.4.1.9.9.97.1.4.1.1.2', 'cseL3SwitchedTotalOctets', 5734, 'current', NULL, 'Number of octets in the total packets switched at Layer 3 by this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5737, '.1.3.6.1.4.1.9.9.97.1.4.1.1.3', 'cseL3CandidateFlowHits', 5734, 'current', NULL, 'Number of L3 Cache hits for the candidate flow entries in this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5738, '.1.3.6.1.4.1.9.9.97.1.4.1.1.4', 'cseL3EstablishedFlowHits', 5734, 'current', NULL, 'Number of L3 Cache hits for established flow entries in this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5739, '.1.3.6.1.4.1.9.9.97.1.4.1.1.5', 'cseL3ActiveFlows', 5734, 'current', NULL, 'Number of active flows in the Layer 3 flow table of this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5740, '.1.3.6.1.4.1.9.9.97.1.4.1.1.6', 'cseL3FlowLearnFailures', 5734, 'current', NULL, 'Number of flows that failed to be learned because the Layer 3 flow table in this switching engine was full.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5741, '.1.3.6.1.4.1.9.9.97.1.4.1.1.7', 'cseL3IntFlowInvalids', 5734, 'current', NULL, 'Number of flow invalidation events received by this switching engine from the internal router(s).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5742, '.1.3.6.1.4.1.9.9.97.1.4.1.1.8', 'cseL3ExtFlowInvalids', 5734, 'current', NULL, 'Number of flow invalidation events received by this switching engine from external routers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5743, '.1.3.6.1.4.1.9.9.97.1.4.2', 'cseL3VlanStatsTable', 5598, 'current', NULL, 'A table containing per-VLAN, Layer 3 statistics information per switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5744, '.1.3.6.1.4.1.9.9.97.1.4.2.1', 'cseL3VlanStatsEntry', 5743, 'current', NULL, 'A conceptual row of cseL3VlanStatsTable, containing per-VLAN Layer 3 statistics maintained by a switching engine (identified by entPhysicalIndex). An entry exists for each known VLAN for each switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5745, '.1.3.6.1.4.1.9.9.97.1.4.2.1.1', 'cseL3VlanIndex', 5744, 'current', NULL, 'Vlan number for which the statistics are maintained by this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5746, '.1.3.6.1.4.1.9.9.97.1.4.2.1.2', 'cseL3VlanInPkts', 5744, 'current', NULL, 'Number of packets Layer 3 forwarded from this Vlan to some other VLAN by this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5747, '.1.3.6.1.4.1.9.9.97.1.4.2.1.3', 'cseL3VlanInOctets', 5744, 'current', NULL, 'Number of octets in packets Layer-3 forwarded from this Vlan to some other VLAN by this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5752, '.1.3.6.1.4.1.9.9.97.1.4.3.1.1', 'cseStatsFlowAged', 5751, 'current', NULL, 'Total number of layer 3 flows aged out by hardware. Management applications can control flow aging by setting the value of cseFlowEstablishedAgingTime object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5753, '.1.3.6.1.4.1.9.9.97.1.4.3.1.2', 'cseStatsFlowPurged', 5751, 'current', NULL, 'Total number of layer 3 flows purged by software; it may happen because a router invalidates certain flows, or a router for which flows are being switched has been excluded from cseRouterTable, or access-list has changed, or certain features have been enabled that would purge certain flows (TCP interception, Web cache are examples of such features).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5754, '.1.3.6.1.4.1.9.9.97.1.4.3.1.3', 'cseStatsFlowParityFail', 5751, 'current', NULL, 'Total number of memory parity errors on accessing flows in the cache pools. It may be due to the internal RAM reading error, not necessarily the corrupted flow data.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5755, '.1.3.6.1.4.1.9.9.97.1.4.4', 'cseCacheUtilTable', 5598, 'current', NULL, 'A table of utilization levels in percentage of cache capacity per switch engine. Each row instance is the current flow utilization percentage in the cache pool of the corresponding switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5756, '.1.3.6.1.4.1.9.9.97.1.4.4.1', 'cseCacheUtilEntry', 5755, 'current', NULL, 'A row instance represents layer 3 flow utilization of a particular cache pool on a switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5757, '.1.3.6.1.4.1.9.9.97.1.4.4.1.1', 'cseCacheUtilization', 5756, 'current', NULL, 'Flow utilization level in percentage in this switching engine. It includes the flow entries for both unicast and multicast. The lighter the utilization level, the less risk of dropping flows, i.e. the higher success-rate of flow insertion.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5758, '.1.3.6.1.4.1.9.9.97.1.5.2', 'cseProtocolFilterPortTable', 5599, 'current', NULL, 'A table containing the protocol filtering configuration and status information on ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5759, '.1.3.6.1.4.1.9.9.97.1.5.2.1', 'cseProtocolFilterPortEntry', 5758, 'current', NULL, 'A conceptual row in the cseProtocolFilterPortTable, representing a Protocol filter configuration and status information for a particular port (identified by ifIndex) and protocol type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5760, '.1.3.6.1.4.1.9.9.97.1.5.2.1.1', 'cseProtocolFilterPortProtocol', 5759, 'current', NULL, 'The protocol (group) to filter, used here as the secondary index.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5761, '.1.3.6.1.4.1.9.9.97.1.5.2.1.2', 'cseProtocolFilterPortAdminStatus', 5759, 'current', NULL, 'An indication of the administrative status of the protocol filtering on this interface. - on(1) indicates that the interface will send and receive the traffic for protocol specified in cseProtocolFilterPortProtocol. - off(2) indicates that the interface will not receive traffic for this protocol, or if this feature is not supported. - auto(3) indicates that the corresponding cseProtocolFilterPortOperStatus will transit to ''on'' after receiving one packet of this protocol type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5804, '.1.3.6.1.4.1.9.9.48.1.1.1', 'ciscoMemoryPoolEntry', 5803, 'current', NULL, 'An entry in the memory pool monitoring table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5701, '.1.3.6.1.4.1.9.9.97.1.2.12.1.11', 'cseFlowMcastQueryStatus', 5690, 'current', NULL, 'The status object used to manage rows in this table. When set to ''active'', the query of flows is initiated. This object can be set to active only after all the appropriate objects for this query as defined by the bits in the cseFlowMcastQueryMask object, have also been instantiated. The completion of the query is indicated by the value of cseFlowMcastQueryRows as soon as it becomes greater than or equal to 0. Once a row becomes active, values within the row cannot be modified without setting it to ''notInService'' first, or just deleting and re-creating it. To abort a lengthy on-going query, setting this object to ''notInService'', or ''destroy'' will terminate a search if one is in progress, and cause the associated rows in cseFlowMcastResultTable, if any, to be deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5702, '.1.3.6.1.4.1.9.9.97.1.2.12.1.12', 'cseFlowMcastQueryCreateTime', 5690, 'current', NULL, 'Time when this query was last set to active.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5703, '.1.3.6.1.4.1.9.9.97.1.2.13', 'cseFlowMcastResultTable', 5596, 'current', NULL, 'A table containing current IP multicast flow information corresponding to all the completed queries set up in the cseFlowMcastQueryTable, that were initiated on the switch engine(s). The query result will not become available until the current search completes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5704, '.1.3.6.1.4.1.9.9.97.1.2.13.1', 'cseFlowMcastResultEntry', 5703, 'current', NULL, 'A conceptual row of cseFlowMcastResultTable, containing information about an IP multicast layer 3 flow that matchs the search criteria set in the corresponding row of cseFlowMcastQueryTable. This row instance is indexed by the query index (cseFlowMcastQueryIndex), the switch engine entity (entPhysicalIndex), and data entry index (cseFlowMcastResultIndex). The value of entPhysicalIndex object is assigned by Entity-MIB, and uniquely identifies a switching engine on which the IP multicast flow is stored.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5705, '.1.3.6.1.4.1.9.9.97.1.2.13.1.1', 'cseFlowMcastResultIndex', 5704, 'current', NULL, 'A positive integer which uniquely identify a result entry on a specific switching engine matching a particular query.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5706, '.1.3.6.1.4.1.9.9.97.1.2.13.1.2', 'cseFlowMcastResultGrp', 5704, 'current', NULL, 'The multicast group IP address of the multicast layer 3 flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5707, '.1.3.6.1.4.1.9.9.97.1.2.13.1.3', 'cseFlowMcastResultSrc', 5704, 'current', NULL, 'The source address of the multicast layer 3 flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5708, '.1.3.6.1.4.1.9.9.97.1.2.13.1.4', 'cseFlowMcastResultSrcVlan', 5704, 'current', NULL, 'The source Vlan ID of the IP multicast layer 3 flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5709, '.1.3.6.1.4.1.9.9.97.1.2.13.1.5', 'cseFlowMcastResultRtrIp', 5704, 'current', NULL, 'The interface IP address of the router this multicast flow is switching for. Since IP multicast flows can only be established for a router''s trunk ports, it is the primary IP address of the router''s trunk link that connects to the switch.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5710, '.1.3.6.1.4.1.9.9.97.1.2.13.1.6', 'cseFlowMcastResultRtrMac', 5704, 'current', NULL, 'The default MAC address of the router the multicast flow is switching for. Different multicast flows switching different ports of the same router will have the identical value of this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5711, '.1.3.6.1.4.1.9.9.97.1.2.13.1.7', 'cseFlowMcastResultCreatedTS', 5704, 'current', NULL, 'Time when the IP multicast flow was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5712, '.1.3.6.1.4.1.9.9.97.1.2.13.1.8', 'cseFlowMcastResultLastUsedTS', 5704, 'current', NULL, 'Time when this IP multicast flow was last used.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5713, '.1.3.6.1.4.1.9.9.97.1.2.13.1.9', 'cseFlowMcastResultPkts', 5704, 'current', NULL, 'The total number of multicast traffic packets forwarded for this flow (replicated packets are not counted).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5714, '.1.3.6.1.4.1.9.9.97.1.2.13.1.10', 'cseFlowMcastResultOctets', 5704, 'current', NULL, 'The total number of multicast traffic octets forwarded for this flow (replicated packets are not counted).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5715, '.1.3.6.1.4.1.9.9.97.1.2.13.1.11', 'cseFlowMcastResultDstVlans', 5704, 'current', NULL, 'A string of octets containing one bit per VLAN. Each octet within the value of this object specifies a set of eight VLANs, e.g. the first octet corresponding to VLANs with VlanIndex values of 0 through 7, the second octet to VLANs 8 through 15, etc. Within each octet, the most significant bit represents the lowest numbered VLAN, and the least significant bit represents the highest numbered VLAN, thus each vlan is represented by a single bit within the octet. The bits in this object will be set to ''1'' if the corresponding Vlans are in the out-going interface (vlan) list of the IP multicast flow described by this row instance.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5716, '.1.3.6.1.4.1.9.9.97.1.2.14', 'cseFlowMcastSwitchStatus', 5596, 'current', NULL, 'The current status of the global IP multicast flow switching capability. When enabled, the switch engine will be able to install multicast flow entries in its L3 forwarding table, and perform hardware assisted switching for the flows.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5717, '.1.3.6.1.4.1.9.9.97.1.2.15', 'cseFlowIPXEstablishedAgingTime', 5596, 'current', NULL, 'The aging time for established IPX flows. The default value for this object is implementation specific.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5718, '.1.3.6.1.4.1.9.9.97.1.2.16', 'cseStaticIpxExtRouterTable', 5596, 'current', NULL, 'A table of external routers which are enabled for Layer 3 IPX switching by the switching engine. This table may contain routers that have not yet been discovered by the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5719, '.1.3.6.1.4.1.9.9.97.1.2.16.1', 'cseStaticIpxExtRouterEntry', 5718, 'current', NULL, 'A conceptual row in the cseStaticIpxExtRouterTable for enabling an external router to be installed in the switch''s router table. The entry is created and deleted by using cseStaticIpxRouterStatus.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5720, '.1.3.6.1.4.1.9.9.97.1.2.16.1.1', 'cseStaticIpxRouterName', 5719, 'current', NULL, 'DNS name (if available) of the external router.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5721, '.1.3.6.1.4.1.9.9.97.1.2.16.1.2', 'cseStaticIpxRouterOwner', 5719, 'current', NULL, 'String indicating the owner who created the static entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5722, '.1.3.6.1.4.1.9.9.97.1.2.16.1.3', 'cseStaticIpxRouterStatus', 5719, 'current', NULL, 'Used to manage creation and deletion of rows in this table. Once a row becomes active, values within that row cannot be modified except by deleting and creating the row.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5723, '.1.3.6.1.4.1.9.9.97.1.3.1', 'cseNetflowLSExportStatus', 5597, 'current', NULL, 'Status of the Netflow LAN Switching data export feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5724, '.1.3.6.1.4.1.9.9.97.1.3.2', 'cseNetflowLSExportHost', 5597, 'current', NULL, 'Network(IP) address in dotted decimal format or the DNS hostname of the host to which Netflow LAN switching statistics are exported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5725, '.1.3.6.1.4.1.9.9.97.1.3.3', 'cseNetflowLSExportTransportNumber', 5597, 'current', NULL, 'The transport(UDP) port number to be used for the Netflow LAN switching statistics being exported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5726, '.1.3.6.1.4.1.9.9.97.1.3.4', 'cseNetflowLSExportDataSource', 5597, 'current', NULL, 'The source network address used as a filter for selecting the flows to which the netflow LAN switching data export feature is applied.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5727, '.1.3.6.1.4.1.9.9.97.1.3.5', 'cseNetflowLSExportDataSourceMask', 5597, 'current', NULL, 'The mask to be applied to the corresponding instance of cseNetflowExportDataSource.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5728, '.1.3.6.1.4.1.9.9.97.1.3.6', 'cseNetflowLSExportDataDest', 5597, 'current', NULL, 'The destination network address used as a filter for selecting the flows to which the netflow LAN switching data export feature is applied.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5729, '.1.3.6.1.4.1.9.9.97.1.3.7', 'cseNetflowLSExportDataDestMask', 5597, 'current', NULL, 'The mask to be applied to its corresponding instance of cseNetflowExportDataDest.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5688, '.1.3.6.1.4.1.9.9.97.1.2.11', 'cseFlowMcastMaxQueries', 5596, 'current', NULL, 'Maximum number of query entries allowed to be outstanding at any time, in the cseFlowMcastQueryTable. The typical value for this object is 5.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5689, '.1.3.6.1.4.1.9.9.97.1.2.12', 'cseFlowMcastQueryTable', 5596, 'current', NULL, 'A control table used to query the switching engine by specifying retrieval criteria for IP multicast L3 flows. Each row instance in the table represents a query with its parameters. The resulting data for each instance of a query in this table is returned in the cseFlowMcastResultTable. The maximum number of entries (rows) in this table cannot exceed the value of cseFlowMcastMaxQueries object.  Unlike unicast switched layer 3 flows, an IP multicast switched flow is created and installed by software, and is uniquely identified by flow''s source IP address, and multicast group IP address. It is stored with input Vlan ID in the cache entry, so that the packets in the flow will not be replicated and forwarded to the receivers on the same (input) Vlan. Another difference is that all IP multicast hardware switched flows belonging to the same (source, group) are stored only on one switch engine on a Cisco L3 switch with distributed switch engines, whereas unicast flows identified by certain criterion may resident on multiple switch engines in the system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5690, '.1.3.6.1.4.1.9.9.97.1.2.12.1', 'cseFlowMcastQueryEntry', 5689, 'current', NULL, 'A conceptual row of the cesMcastFlowQueryTable used to setup retrieval criteria to search for IP multicast L3 flows on all switching engine entities in the device. The actual search is started by setting the value of cseFlowMcastQueryStatus to ''active''. Once a row becomes active, values within the row cannot be modified, without setting the associated RowStatus object to ''notInService'' first, or deleting and re-creating the row.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5691, '.1.3.6.1.4.1.9.9.97.1.2.12.1.1', 'cseFlowMcastQueryIndex', 5690, 'current', NULL, 'An arbitrary integer in the range of 1 to cseFlowMcastMaxQueries to identify this control query.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5692, '.1.3.6.1.4.1.9.9.97.1.2.12.1.2', 'cseFlowMcastQueryMask', 5690, 'current', NULL, 'This object is used to set up the query criterion for the multicast flows of interest. If any one of the four defined BITs is set, then the value of the corresponding object in the same row instance will be used for the search. Specifically, if the ''source(0)'' BIT is set, then the cseFlowMcastQuerySrc object will be included in the search criterion; if the group(1) BIT is set, then the cseFlowMcastQueryGrp object will be included in the search criterion; if the vlan(2) BIT is set, then the cseFlowMcastQuerySrcVlan object will be included in the search criterion; if the router(3) BIT is set, then the cseFlowMcastQueryRtrIndex object will be included in the search criterion.  If any of four BITs in this variable is cleared, the corresponding parameter object in the same row is treated as a wildcard. When the row is instantiated, the four BITs in the variable will be cleared, and none of four query parameter objects in this row will be instantiated. This is a wildcard search, i.e. it will return all rows corresponding to all established multicast flow entries in cseFlowMcastResultTable. It is SNMP managers'' responsibility to set certain bits on in this object instance, if necessary, and the corresponding flow parameter variables to the appropriate values in order to setup the desired query criteria. The value of this object can not be altered when the corresponding instance of cseFlowMcastQueryStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5693, '.1.3.6.1.4.1.9.9.97.1.2.12.1.3', 'cseFlowMcastQuerySrc', 5690, 'current', NULL, 'The source address of the IP multicast layer 3 flows. This object should be instantiated and assigned a proper IP address whenever the ''source'' bit of cseFlowMcastQueryMask object in the same row is on. If the ''source'' bit is set, and an appropriate IP address is assigned to this object, then only flows with the specified source address will be containing in the result table. If the ''source'' bit in the associated cseFlowMcastQueryMask is cleared, this object is ignored during the query, and all flows will be considered regardless of their source IP address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5668, '.1.3.6.1.4.1.9.9.97.1.2.9', 'cseFlowDataTable', 5596, 'current', NULL, 'A table containing L3 flow information corresponding to all the completed queries setup in the cseFlowQueryTable, that were initiated on the switch engine(s).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5645, '.1.3.6.1.4.1.9.9.97.1.2.6.1', 'cseRouterVlanEntry', 5644, 'current', NULL, 'A conceptual row of the cseRouterVlanTable. An entry exists for each known VLAN of each known router.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1524, '.1.3.6.1.2.1.54.1.1.2.1.3', 'sysApplInstallElmtType', 1521, 'current', NULL, 'The type of element that is part of the installed application.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5694, '.1.3.6.1.4.1.9.9.97.1.2.12.1.4', 'cseFlowMcastQueryGrp', 5690, 'current', NULL, 'The IP multicast group address of the queried flows. This object should be instantiated and set whenever the ''group'' bit of the associated cseFlowMcastQueryMask object is on. If the ''group'' bit is set, and a multicast group address is assigned to the object, only flows with the specified group address will be contained in the result table. If the ''group'' bit in the associated cseFlowMcastQueryMask is cleared, this object is ignored during the query, and all flows will be considered regardless of their group address', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5695, '.1.3.6.1.4.1.9.9.97.1.2.12.1.5', 'cseFlowMcastQuerySrcVlan', 5690, 'current', NULL, 'The source Vlan ID of the IP multicast layer 3 flows. This object should be instantiated and set whenever the ''vlan'' bit of the associated cseFlowMcastQueryMask object is on. If the ''vlan'' bit is set, and a Vlan ID is assigned to this object, only flows belonging to that vlan will be contained in the result table. If the ''vlan'' bit in the associated cseFlowMcastQueryMask object is cleared, this object is ignored during the query, and all flows will be considered regardless of their vlan IDs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5696, '.1.3.6.1.4.1.9.9.97.1.2.12.1.6', 'cseFlowMcastQueryRtrIndex', 5690, 'current', NULL, 'Index of the router for which the multicast flows are available, that is the flows would be replicated and routed by the specified router, should the flows did not get switched. This object should be instantiated and set whenever the ''router'' bit of the asociated cseFlowMcastQueryMask object is on. If the ''router'' bit is set, and a router''s IP address is assigned to this object, then only flows associated with that router will be contained in the result table. If the ''router'' bit in the cseFlowMcastQueryMask object is cleared, this object is ignored during the query, and all flows will be considered regardless of the routers being switched.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5697, '.1.3.6.1.4.1.9.9.97.1.2.12.1.7', 'cseFlowMcastQuerySkipNFlows', 5690, 'current', NULL, 'The number of searched flows to be skipped before storing any multicast flows in cseFlowMcastResultTable. This object can be used along with cseFlowMcastQueryTotalFlows object to skip previously found flows by setting the variable equal to the number of the associated rows in cseFlowMcastResultTable, and only query the remaining flows in the table. Note that due to the dynamical nature of the L3 flows, the queried flows may be missed or repeated by setting this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5698, '.1.3.6.1.4.1.9.9.97.1.2.12.1.8', 'cseFlowMcastQueryOwner', 5690, 'current', NULL, 'The manager entity that configured this entry and is therefore using the resources assigned to it. It is used to model an administratively assigned name of the owner of a resource. It is recommended that this object have one or more the following information: IP address, management station name, network manager''s name, location, or phone number.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5699, '.1.3.6.1.4.1.9.9.97.1.2.12.1.9', 'cseFlowMcastQueryTotalFlows', 5690, 'current', NULL, 'The number of flows matching the query criterion.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5700, '.1.3.6.1.4.1.9.9.97.1.2.12.1.10', 'cseFlowMcastQueryRows', 5690, 'current', NULL, 'Indicating the status of the query by following values: -1 - Either the query has not been started or the agent is still processing this query instance. It is the default value when the row is instantiated.  0..2147483647 - The search has ended and this is the number of rows in the cseFlowMcastResultTable, resulting from this query.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5803, '.1.3.6.1.4.1.9.9.48.1.1', 'ciscoMemoryPoolTable', 5802, 'current', NULL, 'A table of memory pool monitoring entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5655, '.1.3.6.1.4.1.9.9.97.1.2.8.1.4', 'cseFlowQuerySource', 5651, 'current', NULL, 'The source network address and port (if applicable). The value of this object cannot be modified when the corresponding instance of cseFlowQueryStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5656, '.1.3.6.1.4.1.9.9.97.1.2.8.1.5', 'cseFlowQuerySourceMask', 5651, 'current', NULL, 'The source address mask to be applied to the corresponding instance of cseFlowQuerySource. The value of this object cannot be modified when the corresponding instance of cseFlowQueryStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5657, '.1.3.6.1.4.1.9.9.97.1.2.8.1.6', 'cseFlowQueryDestination', 5651, 'current', NULL, 'The destination network address and port (if applicable). The value of this object cannot be modified when the corresponding instance of cseFlowQueryStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5658, '.1.3.6.1.4.1.9.9.97.1.2.8.1.7', 'cseFlowQueryDestinationMask', 5651, 'current', NULL, 'The destination address mask to be applied to the corresponding instance of cseFlowQueryDestination. The value of this object cannot be modified when the corresponding instance of cseFlowQueryStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5659, '.1.3.6.1.4.1.9.9.97.1.2.8.1.8', 'cseFlowQueryRouterIndex', 5651, 'current', NULL, 'Index of the router for which the flows are available. An ''all-zero'' IP address indicates that the query is for any router. The value of this object cannot be modified when the corresponding instance of cseFlowQueryStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5660, '.1.3.6.1.4.1.9.9.97.1.2.8.1.9', 'cseFlowQueryOwner', 5651, 'current', NULL, 'The manager entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5661, '.1.3.6.1.4.1.9.9.97.1.2.8.1.10', 'cseFlowQueryResultingRows', 5651, 'current', NULL, 'The result status of the query. Possible values are:  -1 - Either the query has not been initiated or the agent is busy processing this query instance. Time to completion of the query processing depends on the complexity of the query and the number of matches that satisfy this query.  0..2147483647 - The search has ended and this is the number of rows in the cseFlowDataTable, resulting from this query.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5662, '.1.3.6.1.4.1.9.9.97.1.2.8.1.11', 'cseFlowQueryResultTotalPkts', 5651, 'current', NULL, 'The aggregate number of total packets switched by the system on all the flows matching this query. This is a snapshot value and is valid only when the corresponding instance of cseFlowQueryResult is greater than or equal to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5663, '.1.3.6.1.4.1.9.9.97.1.2.8.1.12', 'cseFlowQueryResultTotalOctets', 5651, 'current', NULL, 'The aggregate number of total octets switched by the system on all the flows matching this query. This is a snapshot value and is valid only when the corresponding instance of cseFlowQueryResult is greater than or equal to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5664, '.1.3.6.1.4.1.9.9.97.1.2.8.1.13', 'cseFlowQueryResultAvgDuration', 5651, 'current', NULL, 'The average duration of the flows matching this query. This is a snapshot value and is valid only when the corresponding instance of cseFlowQueryResult is greater than or equal to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5665, '.1.3.6.1.4.1.9.9.97.1.2.8.1.14', 'cseFlowQueryResultAvgIdle', 5651, 'current', NULL, 'The elapsed time since the flows were last used, averaged over all flows matching this query. This is a snapshot value and is valid only when the corresponding instance of cseFlowQueryResult is greater than or equal to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5666, '.1.3.6.1.4.1.9.9.97.1.2.8.1.15', 'cseFlowQueryStatus', 5651, 'current', NULL, 'The status object used to manage rows in this table. When set to active(1), the query is initiated. Once initiated, the value may not be modified until the value of cseFlowQueryResult is greater than or equal to 0. However, this object can be set to active(1) only after all the appropriate objects for this query as defined by the value set in the cseFlowQueryMask object, have also been set. Once a row becomes active, values within the row cannot be modified, except by deleting and re-creating it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5667, '.1.3.6.1.4.1.9.9.97.1.2.8.1.16', 'cseFlowQueryCreateTime', 5651, 'current', NULL, 'Time when this query was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5669, '.1.3.6.1.4.1.9.9.97.1.2.9.1', 'cseFlowDataEntry', 5668, 'current', NULL, 'A conceptual row of the cseFlowDataTable used to return information about one of the L3 flows which matched the search criteria set by the cseFlowQueryMask object in the corresponding instance of the cseFlowQueryTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5670, '.1.3.6.1.4.1.9.9.97.1.2.9.1.1', 'cseFlowDataIndex', 5669, 'current', NULL, 'A number to uniquely identify a result entry that matches a particular query for a specific switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5671, '.1.3.6.1.4.1.9.9.97.1.2.9.1.2', 'cseFlowDataSrcMac', 5669, 'current', NULL, 'Source Mac Address of the router''s outgoing interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5672, '.1.3.6.1.4.1.9.9.97.1.2.9.1.3', 'cseFlowDataDstMac', 5669, 'current', NULL, 'Destination Mac Address used to forward the packets in this flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5673, '.1.3.6.1.4.1.9.9.97.1.2.9.1.4', 'cseFlowDataStaticFlow', 5669, 'current', NULL, 'Indicates whether this flow was software-installed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5674, '.1.3.6.1.4.1.9.9.97.1.2.9.1.5', 'cseFlowDataEncapType', 5669, 'current', NULL, 'Protocol encapsulation type used to forward packets in this flow to their destination.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5675, '.1.3.6.1.4.1.9.9.97.1.2.9.1.6', 'cseFlowDataSource', 5669, 'current', NULL, 'The source network address and the port (if appropriate) of this flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5676, '.1.3.6.1.4.1.9.9.97.1.2.9.1.7', 'cseFlowDataDestination', 5669, 'current', NULL, 'The destination network address and port (if appropriate) of this flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5677, '.1.3.6.1.4.1.9.9.97.1.2.9.1.8', 'cseFlowDataDestVlan', 5669, 'current', NULL, 'The vlan number on which packets belonging to this flow are forwarded.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5678, '.1.3.6.1.4.1.9.9.97.1.2.9.1.9', 'cseFlowDataIpQOS', 5669, 'current', NULL, 'Level of Quality of service for this IP flow. If it is not an IP flow, this object will not be instantiated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5679, '.1.3.6.1.4.1.9.9.97.1.2.9.1.10', 'cseFlowDataIpQOSPolicy', 5669, 'current', NULL, 'Level of the Quality of service policy for this IP flow. If it is not an IP flow, this object will not be instantiated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5680, '.1.3.6.1.4.1.9.9.97.1.2.9.1.11', 'cseFlowDataWhenCreated', 5669, 'current', NULL, 'Time when this flow was created in the switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5681, '.1.3.6.1.4.1.9.9.97.1.2.9.1.12', 'cseFlowDataLastUsed', 5669, 'current', NULL, 'Time since this flow was last used to forward a packet by the switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5682, '.1.3.6.1.4.1.9.9.97.1.2.9.1.13', 'cseFlowDataPkts', 5669, 'current', NULL, 'A snapshot value of the number of packets forwarded on this flow at the time of corresponding query.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5683, '.1.3.6.1.4.1.9.9.97.1.2.9.1.14', 'cseFlowDataOctets', 5669, 'current', NULL, 'A snapshot value of octets forwarded on this flow at the time of corresponding query.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5684, '.1.3.6.1.4.1.9.9.97.1.2.10', 'cseFlowSwitchControlTable', 5596, 'current', NULL, 'A table used to control the L3 flow switching operation, per protocol type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5685, '.1.3.6.1.4.1.9.9.97.1.2.10.1', 'cseFlowSwitchControlEntry', 5684, 'current', NULL, 'A conceptual row for the configuration of Flow switching feature for an L3 protocol type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5686, '.1.3.6.1.4.1.9.9.97.1.2.10.1.1', 'cseFlowSwitchProtocol', 5685, 'current', NULL, 'Protocol type for which this row instance. Only ip(1) and ipx(14) values are currently supported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5687, '.1.3.6.1.4.1.9.9.97.1.2.10.1.2', 'cseFlowSwitchStatus', 5685, 'current', NULL, 'The current status of the global flow switching capability for the specified L3 protocol type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5627, '.1.3.6.1.4.1.9.9.97.1.1.2.1.12', 'cseL2HCOtherProtoPkts', 5615, 'current', NULL, 'Number of packets belonging to all other protocol families, received by this switching engine from all sources. This value includes L3 switched packets. Incremented only when the applicable protocol filter feature is in effect.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5628, '.1.3.6.1.4.1.9.9.97.1.2.1', 'cseFlowEstablishedAgingTime', 5596, 'current', NULL, 'The aging time for IP established flows. The default value for this object is implementation specific.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5629, '.1.3.6.1.4.1.9.9.97.1.2.2', 'cseFlowFastAgingTime', 5596, 'current', NULL, 'The fast aging time for the established flow entries, that have less number of packets than the value set in the cseFlowFastAgePktThreshold, switched within this time. Setting to value of 0 turns off fast aging. The default value for this object is implementation specific.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5630, '.1.3.6.1.4.1.9.9.97.1.2.3', 'cseFlowFastAgePktThreshold', 5596, 'current', NULL, 'The packet threshold setting for the cseFlowFastAgingTime. The default for Fast Aging Packet Threshold is 0, i.e. no packets switched within the time set in cseFlowFastAgingTime, after an L3 flow was established.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5631, '.1.3.6.1.4.1.9.9.97.1.2.4', 'cseRouterTable', 5596, 'current', NULL, 'A table containing information about all routers that are discovered by the switch, including internal and external routers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5632, '.1.3.6.1.4.1.9.9.97.1.2.4.1', 'cseRouterEntry', 5631, 'current', NULL, 'A conceptual row in the cseRouterTable containing information about a router. A row appears either directly through dynamic learning or indirectly through management configuration (via SNMP, by creating an entry in the cseStaticExtRouterTable or via CLI).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5633, '.1.3.6.1.4.1.9.9.97.1.2.4.1.1', 'cseRouterIndex', 5632, 'current', NULL, 'The router''s IP address which is used to uniquely identify it for L3 flows.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5634, '.1.3.6.1.4.1.9.9.97.1.2.4.1.2', 'cseRouterFlowMask', 5632, 'current', NULL, 'The IP type of mask configured for the router represented by this row. Each flow known to the switching engine has a mask which is applied to all packets in order to compare them to that flow. Each hardware-learned flow has the mask configured for the router which logically forwards that flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5635, '.1.3.6.1.4.1.9.9.97.1.2.4.1.3', 'cseRouterName', 5632, 'current', NULL, 'DNS name (if available) of the router.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5636, '.1.3.6.1.4.1.9.9.97.1.2.4.1.4', 'cseRouterStatic', 5632, 'current', NULL, 'If the value of the object is true, this router was configured via SNMP or CLI. Otherwise, this router was learned automatically.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5637, '.1.3.6.1.4.1.9.9.97.1.2.4.1.5', 'cseRouterIpxFlowMask', 5632, 'current', NULL, 'The IPX type of mask configured for the router represented by this row. Each flow known to the switching engine has a mask which is applied to all packets in order to compare them to that flow. Each hardware-learned flow has the mask configured for the router which logically forwards that flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5638, '.1.3.6.1.4.1.9.9.97.1.2.5', 'cseStaticExtRouterTable', 5596, 'current', NULL, 'A table of external routers which are enabled for Layer 3 IP switching by the switching engine. This table may contain routers that have not yet been discovered by the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5639, '.1.3.6.1.4.1.9.9.97.1.2.5.1', 'cseStaticExtRouterEntry', 5638, 'current', NULL, 'A conceptual row in the cseStaticExtRouterTable for enabling an external router to be installed in the switch''s router table. The entry is created and deleted by using cseStaticRouterStatus.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5640, '.1.3.6.1.4.1.9.9.97.1.2.5.1.1', 'cseStaticRouterName', 5639, 'current', NULL, 'DNS name (if available) of the external router.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5641, '.1.3.6.1.4.1.9.9.97.1.2.5.1.2', 'cseStaticRouterOwner', 5639, 'current', NULL, 'String indicating the owner who created the static entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5642, '.1.3.6.1.4.1.9.9.97.1.2.5.1.3', 'cseStaticRouterStatus', 5639, 'current', NULL, 'Used to manage creation and deletion of rows in this table. Once a row becomes active, values within that row cannot be modified except by deleting and creating the row.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5643, '.1.3.6.1.4.1.9.9.97.1.2.5.1.4', 'cseStaticRouterType', 5639, 'current', NULL, 'Indicates if the router is included for unicast switching, or multicast switching, or both.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5648, '.1.3.6.1.4.1.9.9.97.1.2.6.1.3', 'cseRouterProtocol', 5645, 'current', NULL, 'Indicates which protocols are routed by this router on this VLAN using this Mac address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5649, '.1.3.6.1.4.1.9.9.97.1.2.7', 'cseFlowMaxQueries', 5596, 'current', NULL, 'Maximum number of query entries allowed to be outstanding at any time, in the cseFlowQueryTable. The typical value for this object is 5.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5650, '.1.3.6.1.4.1.9.9.97.1.2.8', 'cseFlowQueryTable', 5596, 'current', NULL, 'A control table used to query the switching engine by specifying retrieval criteria for L3 flows. The resulting data for each instance of a query in this table is returned in the cseFlowDataTable. The maximum number of entries (rows) in this table cannot exceed the value returned by cseFlowMaxQueries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5651, '.1.3.6.1.4.1.9.9.97.1.2.8.1', 'cseFlowQueryEntry', 5650, 'current', NULL, 'A conceptual row of the cesFlowQueryTable used to setup retrieval criteria to search for L3 flows on a particular switching engine entity identified by entPhysicalIndex. The actual search is started by setting the value of cseFlowQueryStatus to ''active''. Once a row becomes active, values within the row cannot be modified, except by deleting and re-creating the row.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5652, '.1.3.6.1.4.1.9.9.97.1.2.8.1.1', 'cseFlowQueryIndex', 5651, 'current', NULL, 'An arbitrary integer which uniquely identifies the control query among all those specified for the switching engine indicated by entPhysicalIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5653, '.1.3.6.1.4.1.9.9.97.1.2.8.1.2', 'cseFlowQueryMask', 5651, 'current', NULL, 'Setting each value causes the appropriate action:  ''dstOnly'' - causes the creation of rows in the cseFlowDataTable corresponding to the current L3 flow information for the absolute destination IP address set in the cseFlowQueryDestination object in this table. If cseFlowQueryDestinationMask is also specified at the same time, it will be applied to the address part of cseFlowQueryDestination.  ''srcOrDst'' - causes the creation of rows in the cseFlowDataTable corresponding to the current L3 flow information for EITHER of the absolute IP addresses set in the cseFlowQueryDestination or cseFlowQuerySource objects. If either of cseFlowQueryDestinationMask and cseFlowQuerySourceMask objects are also specified at the same time, they will be applied to the respective address parts of cseFlowQueryDestination and cseFlowQuerySource objects. This option is typically used to setup queries for flows on traffic in either directions.  ''srcAndDst'' - causes the creation of rows in the cseFlowDataTable corresponding to the current L3 flow information for BOTH the absolute IP addresses set in the cseFlowQueryDestination and cseFlowQuerySource objects. If either of cseFlowQueryDestinationMask and cseFlowQuerySourceMask objects are also specified at the same time, they will be applied to the respective address parts of cseFlowQueryDestination and cseFlowQuerySource objects. This option is typically used to setup queries for flows on traffic in one direction only.   ''fullFlow'' - causes the creation of row(s) in the cseFlowDataTable exactly corresponding to the current L3 flow information for the complete IP flow (including the transport port numbers) set in the cseFlowQueryDestination and cseFlowQuerySource objects. If either of cseFlowQueryDestinationMask and cseFlowQuerySourceMask objects are also specified at the same time, they will be applied to the respective address parts of cseFlowQueryDestination and cseFlowQuerySource objects. This option is typically used to setup queries for flows on traffic for specific (TCP/UDP) port numbers corresponding to standard protocols such as FTP, WWW, TELNET, etc.  ''ipxDstOnly'' - causes the creation of rows in the cseFlowDataTable corresponding to the current L3 flow information for the absolute destination IPX address set in the cseFlowQueryDestination object in this table. If cseFlowQueryDestinationMask is also specified at the same time, it will be applied to the address part of cseFlowQueryDestination.  ''ipxSrcAndDst'' - causes the creation of rows in the cseFlowDataTable corresponding to the current L3 flow information for BOTH the absolute IPX addresses set in the cseFlowQueryDestination and cseFlowQuerySource objects. If either of cseFlowQueryDestinationMask and cseFlowQuerySourceMask objects are also specified at the same time, they will be applied to the respective address parts of cseFlowQueryDestination and cseFlowQuerySource objects.  ''any'' - returns all rows corresponding to all established flow entries in the cseFlowDataTable.  Note: 1. The type FlowAddressComponent used for objects cseFlowQuerySource and cseFlowQueryDestination, has the network address part and also the transport port number part, if applicable. 2. The value of this object cannot be modified when the corresponding instance of cseFlowQueryStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5654, '.1.3.6.1.4.1.9.9.97.1.2.8.1.3', 'cseFlowQueryTransport', 5651, 'current', NULL, 'The IP transport protocol type specified for this query. Ignored for IPX flow queries. The value of this object cannot be modified when the corresponding instance of cseFlowQueryStatus is ''active''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5801, '.1.3.6.1.4.1.9.9.48', 'ciscoMemoryPoolMIB', 272, 'current', NULL, 'MIB module for monitoring memory pools', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5802, '.1.3.6.1.4.1.9.9.48.1', 'ciscoMemoryPoolObjects', 5801, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5585, '.1.3.6.1.4.1.9.9.168.1.3.2.1.4', 'cntpFilterPeersDispersion', 5581, 'current', NULL, 'The maximum error of the peer clock relative to the local clock over the network path between them, in seconds. Only positive values greater than zero are possible.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5586, '.1.3.6.1.4.1.9.9.168.3', 'ciscoNtpMIBConformance', 5536, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5587, '.1.3.6.1.4.1.9.9.168.3.1', 'ciscoNtpMIBCompliances', 5586, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5588, '.1.3.6.1.4.1.9.9.168.3.2', 'ciscoNtpMIBGroups', 5586, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5589, '.1.3.6.1.4.1.9.9.168.3.1.1', 'ciscoNtpMIBCompliance', 5587, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5590, '.1.3.6.1.4.1.9.9.168.3.2.1', 'ciscoNtpSysGroup', 5588, 'current', NULL, 'The NTP system variables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5591, '.1.3.6.1.4.1.9.9.168.3.2.2', 'ciscoNtpPeersGroup', 5588, 'current', NULL, 'The NTP peer variables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5592, '.1.3.6.1.4.1.9.9.168.3.2.3', 'ciscoNtpFilterGroup', 5588, 'current', NULL, 'The NTP clock-filter variables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5593, '.1.3.6.1.4.1.9.9.97', 'ciscoSwitchEngineMIB', 272, 'current', NULL, 'Added one High Capacity L2 Statistics table, an extension of cseL2StatsTable and new objects in NetflowLS group for new netflow export features. Also added a new enum type of cseRouterFlowMask to support L3 multicast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5594, '.1.3.6.1.4.1.9.9.97.1', 'cseMIBObjects', 5593, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5595, '.1.3.6.1.4.1.9.9.97.1.1', 'cseL2Objects', 5594, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5596, '.1.3.6.1.4.1.9.9.97.1.2', 'cseFlow', 5594, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5597, '.1.3.6.1.4.1.9.9.97.1.3', 'cseNetflowLS', 5594, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5598, '.1.3.6.1.4.1.9.9.97.1.4', 'cseL3Objects', 5594, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5599, '.1.3.6.1.4.1.9.9.97.1.5', 'cseProtocolFilter', 5594, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5600, '.1.3.6.1.4.1.9.9.97.1.6', 'cseUcastCache', 5594, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5601, '.1.3.6.1.4.1.9.9.97.1.7', 'cseMcastCache', 5594, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5602, '.1.3.6.1.4.1.9.9.97.1.1.1', 'cseL2StatsTable', 5595, 'current', NULL, 'A table containing switching engine''s L2 statistics counters.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5603, '.1.3.6.1.4.1.9.9.97.1.1.1.1', 'cseL2StatsEntry', 5602, 'current', NULL, 'A conceptual row containing L2 statistics maintained by a switching engine (identified by entPhysicalIndex). Each switching engine managed by this MIB module has an entry in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5604, '.1.3.6.1.4.1.9.9.97.1.1.1.1.1', 'cseL2ForwardedLocalPkts', 5603, 'current', NULL, 'Number of packets received from ports local to this switching engine and forwarded at layer 2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5605, '.1.3.6.1.4.1.9.9.97.1.1.1.1.2', 'cseL2ForwardedLocalOctets', 5603, 'current', NULL, 'Number of octets in the packets received from ports local to this switching engine and forwarded at layer 2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5606, '.1.3.6.1.4.1.9.9.97.1.1.1.1.3', 'cseL2ForwardedTotalPkts', 5603, 'current', NULL, 'Total number of packets received from all sources (local and over the fabric) and forwarded at layer 2 by this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5607, '.1.3.6.1.4.1.9.9.97.1.1.1.1.4', 'cseL2NewAddressLearns', 5603, 'current', NULL, 'Number of new MAC addresses learned by the switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5608, '.1.3.6.1.4.1.9.9.97.1.1.1.1.5', 'cseL2AddrLearnFailures', 5603, 'current', NULL, 'Number of MAC addresses failed to be learned because the L2 forwarding address table was full. If the value keeps increasing, the network topology should be reconfigured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5609, '.1.3.6.1.4.1.9.9.97.1.1.1.1.6', 'cseL2DstAddrLookupMisses', 5603, 'current', NULL, 'Number of misses during destination MAC address table lookups. A few misses happen normally. Large numbers of misses occur as a result of cseL2AddrLearnFailures.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5610, '.1.3.6.1.4.1.9.9.97.1.1.1.1.7', 'cseL2IpPkts', 5603, 'current', NULL, 'Number of packets belonging to the IP family received by this switching engine from all sources. This value includes L3 switched packets. Incremented only when the applicable protocol filter feature is in effect.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5611, '.1.3.6.1.4.1.9.9.97.1.1.1.1.8', 'cseL2IpxPkts', 5603, 'current', NULL, 'Number of packets belonging to the IPX family received by this switching engine from all sources. This value includes L3 switched packets. Incremented only when the applicable protocol filter feature is in effect.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5612, '.1.3.6.1.4.1.9.9.97.1.1.1.1.9', 'cseL2AssignedProtoPkts', 5603, 'current', NULL, 'Number of packets belonging to an assigned group of network protocols (typically AppleTalk, DecNet and Vines) received by this switching engine from all sources. This value includes L3 switched packets. Incremented only when the applicable protocol filter feature is in effect.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5535, '.1.3.6.1.4.1.9.9.84.3.2.1', 'ciscoIpStatMIBGroup', 5533, 'current', NULL, 'A collection of objects providing IP Statistics monitoring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5536, '.1.3.6.1.4.1.9.9.168', 'ciscoNtpMIB', 272, 'current', NULL, 'This MIB module defines a MIB which provides mechanisms to monitor an NTP server.  The MIB is derived from the Technical Report #Management of the NTP with SNMP# TR No. 98-09 authored by A.S. Sethi and Dave Mills in the University of Delaware.  Below is a brief overview of NTP system architecture and implementation model. This will help understand the objects defined below and their relationships.  NTP Intro: The Network Time Protocol (NTP) Version 3, is used to synchronize timekeeping among a set of distributed time servers and clients. The service model is based on a returnable-time design which depends only on measured clock offsets, but does not require reliable message delivery. The synchronization subnet uses a self-organizing, hierarchical master-slave configuration, with synchronization paths determined by a minimum-weight spanning tree. While multiple masters (primary servers) may exist, there is no requirement for an election protocol.  System Archiecture: In the NTP model a number of primary reference sources, synchronized by wire or radio to national standards, are connected to widely accessible resources, such as backbone gateways, and operated as primary time servers. The purpose of NTP is to convey timekeeping information from these servers to other time servers via the Internet and also to cross-check clocks and mitigate errors due to equipment or propagation failures. Some number of local-net hosts or gateways, acting as secondary time servers, run NTP with one or more of the primary servers. In order to reduce the protocol overhead, the secondary servers distribute time via NTP to the remaining local-net hosts. In the interest of reliability, selected hosts can be equipped with less accurate but less expensive radio clocks and used for backup in case of failure of the primary and/or secondary servers or communication paths between them.  NTP is designed to produce three products: clock offset, round-trip delay and dispersion, all of which are relative to a selected reference clock. Clock offset represents the amount to adjust the local clock to bring it into correspondence with the reference clock. Roundtrip delay provides the capability to launch a message to arrive at the reference clock at a specified time. Dispersion represents the maximum error of the local clock relative to the reference clock. Since most host time servers will synchronize via another peer time server, there are two components in each of these three products, those determined by the peer relative to the primary reference source of standard time and those measured by the host relative to the peer. Each of these components are maintained separately in the protocol in order to facilitate error control and management of the subnet itself. They provide not only precision measurements of offset and delay, but also definitive maximum error bounds, so that the user interface can determine not only the time, but the quality of the time as well.  Implementation Model: In what may be the most common client/server model a client sends an NTP message to one or more servers and processes the replies as received. The server interchanges addresses and ports, overwrites certain fields in the message, recalculates the checksum and returns the message immediately. Information included in the NTP message allows the client to determine the server time with respect to local time and adjust the local clock accordingly. In addition, the message includes information to calculate the expected timekeeping accuracy and reliability, as well as select the best from possibly several servers.  While the client/server model may suffice for use on local nets involving a public server and perhaps many workstation clients, the full generality of NTP requires distributed participation of a number of client/servers or peers arranged in a dynamically reconfigurable, hierarchically distributed configuration. It also requires sophisticated algorithms for association management, data manipulation and local-clock control.  Glossary: 1. Host: Refers to an instantiation of the NTP protocol on a local processor. 2. Peer: Refers to an instantiation of the NTP protocol on a remote processor connected by a network path from the local host.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5613, '.1.3.6.1.4.1.9.9.97.1.1.1.1.10', 'cseL2OtherProtoPkts', 5603, 'current', NULL, 'Number of packets belonging to all other protocol families, received by this switching engine from all sources. This value includes L3 switched packets. Incremented only when the applicable protocol filter feature is in effect.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5614, '.1.3.6.1.4.1.9.9.97.1.1.2', 'cseL2StatsHCTable', 5595, 'current', NULL, 'Contains the High Capacity L2 Statistics extensions to the cseL2StatsTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5615, '.1.3.6.1.4.1.9.9.97.1.1.2.1', 'cseL2StatsHCEntry', 5614, 'current', NULL, 'Contains the High Capacity L2 Statistics extensions to cseL2StatsEntry. These objects will be created by the agent for all cseL2StatsEntries it deems appropriate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5616, '.1.3.6.1.4.1.9.9.97.1.1.2.1.1', 'cseL2HCOverflowForwardedLocalPkts', 5615, 'current', NULL, 'The number of times the associated cseL2ForwardedLocalPkts counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5617, '.1.3.6.1.4.1.9.9.97.1.1.2.1.2', 'cseL2HCForwardedLocalPkts', 5615, 'current', NULL, 'Number of packets received from ports local to this switching engine and forwarded at layer 2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5618, '.1.3.6.1.4.1.9.9.97.1.1.2.1.3', 'cseL2HCOverflowForwardedTotalPkts', 5615, 'current', NULL, 'The number of times the associated cseL2ForwardeTotalPkts counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5619, '.1.3.6.1.4.1.9.9.97.1.1.2.1.4', 'cseL2HCForwardedTotalPkts', 5615, 'current', NULL, 'Total number of packets received from all sources (local and over the fabric) and forwarded at layer 2 by this switching engine.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5620, '.1.3.6.1.4.1.9.9.97.1.1.2.1.5', 'cseL2HCOverflowIpPkts', 5615, 'current', NULL, 'The number of times the associated cseL2IpPkts counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5621, '.1.3.6.1.4.1.9.9.97.1.1.2.1.6', 'cseL2HCIpPkts', 5615, 'current', NULL, 'Number of packets belonging to the IP family received by this switching engine from all sources. This value includes L3 switched packets. Incremented only when the applicable protocol filter feature is in effect.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5622, '.1.3.6.1.4.1.9.9.97.1.1.2.1.7', 'cseL2HCOverflowIpxPkts', 5615, 'current', NULL, 'The number of times the associated cseL2IpxPkts counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5623, '.1.3.6.1.4.1.9.9.97.1.1.2.1.8', 'cseL2HCIpxPkts', 5615, 'current', NULL, 'Number of packets belonging to the IPX family received by this switching engine from all sources. This value includes L3 switched packets. Incremented only when the applicable protocol filter feature is in effect.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5624, '.1.3.6.1.4.1.9.9.97.1.1.2.1.9', 'cseL2HCOverflowAssignedProtoPkts', 5615, 'current', NULL, 'The number of times the associated cseL2HCAssignedProtoPkts counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5625, '.1.3.6.1.4.1.9.9.97.1.1.2.1.10', 'cseL2HCAssignedProtoPkts', 5615, 'current', NULL, 'Number of packets belonging to an assigned group of network protocols (typically AppleTalk, DecNet and Vines) received by this switching engine from all sources. This value includes L3 switched packets. Incremented only when the applicable protocol filter feature is in effect.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5626, '.1.3.6.1.4.1.9.9.97.1.1.2.1.11', 'cseL2HCOverflowOtherProtoPkts', 5615, 'current', NULL, 'The number of times the associated cseL2HCOtherProtoPkts counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5541, '.1.3.6.1.4.1.9.9.168.1.1.1', 'cntpSysLeap', 5538, 'current', NULL, 'Two-bit code warning of an impending leap second to be inserted in the NTP timescale. This object can be set only when the cntpSysStratum has a value of 1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1504, '.1.3.6.1.2.1.54', 'sysApplMIB', 21, 'current', NULL, 'The MIB module defines management objects that model applications as collections of executables and files installed and executing on a host system. The MIB presents a system-level view of applications; i.e., objects in this MIB are limited to those attributes that can typically be obtained from the system itself without adding special instrumentation to the applications.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1505, '.1.3.6.1.2.1.54.1', 'sysApplOBJ', 1504, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1506, '.1.3.6.1.2.1.54.1.1', 'sysApplInstalled', 1505, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1507, '.1.3.6.1.2.1.54.1.2', 'sysApplRun', 1505, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1508, '.1.3.6.1.2.1.54.1.3', 'sysApplMap', 1505, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1509, '.1.3.6.1.2.1.54.2', 'sysApplNotifications', 1504, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1510, '.1.3.6.1.2.1.54.3', 'sysApplConformance', 1504, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1511, '.1.3.6.1.2.1.54.1.1.1', 'sysApplInstallPkgTable', 1506, 'current', NULL, 'The table listing the software application packages installed on a host computer. In order to appear in this table, it may be necessary for the application to be installed using some type of software installation mechanism or global registry so that its existence can be detected by the agent implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1512, '.1.3.6.1.2.1.54.1.1.1.1', 'sysApplInstallPkgEntry', 1511, 'current', NULL, 'The logical row describing an installed application package.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1513, '.1.3.6.1.2.1.54.1.1.1.1.1', 'sysApplInstallPkgIndex', 1512, 'current', NULL, 'An integer used only for indexing purposes. Generally monotonically increasing from 1 as new applications are installed.  The value for each installed application must remain constant at least from one re-initialization of the network management entity which implements this MIB module to the next re-initialization.  The specific value is meaningful only within a given SNMP entity. A sysApplInstallPkgIndex value must not be re-used until the next agent entity restart in the event the installed application entry is deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1514, '.1.3.6.1.2.1.54.1.1.1.1.2', 'sysApplInstallPkgManufacturer', 1512, 'current', NULL, 'The Manufacturer of the software application package.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1515, '.1.3.6.1.2.1.54.1.1.1.1.3', 'sysApplInstallPkgProductName', 1512, 'current', NULL, 'The name assigned to the software application package by the Manufacturer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1516, '.1.3.6.1.2.1.54.1.1.1.1.4', 'sysApplInstallPkgVersion', 1512, 'current', NULL, 'The version number assigned to the application package by the manufacturer of the software.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1517, '.1.3.6.1.2.1.54.1.1.1.1.5', 'sysApplInstallPkgSerialNumber', 1512, 'current', NULL, 'The serial number of the software assigned by the manufacturer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1518, '.1.3.6.1.2.1.54.1.1.1.1.6', 'sysApplInstallPkgDate', 1512, 'current', NULL, 'The date and time this software application was installed on the host.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1519, '.1.3.6.1.2.1.54.1.1.1.1.7', 'sysApplInstallPkgLocation', 1512, 'current', NULL, 'The complete path name where the application package is installed. For example, the value would be ''/opt/MyapplDir'' if the application package was installed in the /opt/MyapplDir directory.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1520, '.1.3.6.1.2.1.54.1.1.2', 'sysApplInstallElmtTable', 1506, 'current', NULL, 'This table details the individual application package elements (files and executables) which comprise the applications defined in the sysApplInstallPkg Table. Each entry in this table has an index to the sysApplInstallPkg table to identify the application package of which it is a part. As a result, there may be many entries in this table for each instance in the sysApplInstallPkg Table.  Table entries are indexed by sysApplInstallPkgIndex, sysApplInstallElmtIndex to facilitate retrieval of all elements associated with a particular installed application package.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1521, '.1.3.6.1.2.1.54.1.1.2.1', 'sysApplInstallElmtEntry', 1520, 'current', NULL, 'The logical row describing an element of an installed application. The element may be an executable or non-executable file.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1522, '.1.3.6.1.2.1.54.1.1.2.1.1', 'sysApplInstallElmtIndex', 1521, 'current', NULL, 'An arbitrary integer used for indexing. The value of this index is unique among all rows in this table that exist or have existed since the last agent restart.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1523, '.1.3.6.1.2.1.54.1.1.2.1.2', 'sysApplInstallElmtName', 1521, 'current', NULL, 'The name of this element which is contained in the application.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1525, '.1.3.6.1.2.1.54.1.1.2.1.4', 'sysApplInstallElmtDate', 1521, 'current', NULL, 'The date and time that this component was installed on the system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1526, '.1.3.6.1.2.1.54.1.1.2.1.5', 'sysApplInstallElmtPath', 1521, 'current', NULL, 'The full directory path where this element is installed. For example, the value would be ''/opt/EMPuma/bin'' for an element installed in the directory ''/opt/EMPuma/bin''. Most application packages include information about the elements contained in the package. In addition, elements are typically installed in sub-directories under the package installation directory. In cases where the element path names are not included in the package information itself, the path can usually be determined by a simple search of the sub-directories. If the element is not installed in that location and there is no other information available to the agent implementation, then the path is unknown and null is returned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1527, '.1.3.6.1.2.1.54.1.1.2.1.6', 'sysApplInstallElmtSizeHigh', 1521, 'current', NULL, 'The installed file size in 2^32 byte blocks. This is the size of the file on disk immediately after installation.  For example, for a file with a total size of 4,294,967,296 bytes, this variable would have a value of 1; for a file with a total size of 4,294,967,295 bytes this variable would be 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1528, '.1.3.6.1.2.1.54.1.1.2.1.7', 'sysApplInstallElmtSizeLow', 1521, 'current', NULL, 'The installed file size modulo 2^32 bytes. This is the size of the file on disk immediately after installation.  For example, for a file with a total size of 4,294,967,296 bytes this variable would have a value of 0; for a file with a total size of 4,294,967,295 bytes this variable would be 4,294,967,295.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1529, '.1.3.6.1.2.1.54.1.1.2.1.8', 'sysApplInstallElmtRole', 1521, 'current', NULL, 'An operator assigned value used in the determination of application status. This value is used by the agent to determine both the mapping of started processes to the initiation of an application, as well as to allow for a determination of application health. The default value, unknown(5), is used when an operator has not yet assigned one of the other values. If unknown(5) is set, bits 1 - 4 have no meaning. The possible values are:  executable(0), An application may have one or more executable elements. The rest of the bits have no meaning if the element is not executable. exclusive(1), Only one copy of an exclusive element may be running per invocation of the running application. primary(2), The primary executable. An application can have one, and only one element that is designated as the primary executable. The execution of this element constitutes an invocation of the application. This is used by the agent implementation to determine the initiation of an application. The primary executable must remain running long enough for the agent implementation to detect its presence. required(3), An application may have zero or more required elements. All required elements must be running in order for the application to be judged to be running and healthy. dependent(4), An application may have zero or more dependent elements. Dependent elements may not be running unless required elements are. unknown(5) Default value for the case when an operator has not yet assigned one of the other values. When set, bits 1, 2, 3, and 4 have no meaning.  sysApplInstallElmtRole is used by the agent implementation in determining the initiation of an application, the current state of a running application (see sysApplRunCurrentState), when an application invocation is no longer running, and the exit status of a terminated application invocation (see sysApplPastRunExitState).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1530, '.1.3.6.1.2.1.54.1.1.2.1.9', 'sysApplInstallElmtModifyDate', 1521, 'current', NULL, 'The date and time that this element was last modified. Modification of the sysApplInstallElmtRole columnar object does NOT constitute a modification of the element itself and should not affect the value of this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1531, '.1.3.6.1.2.1.54.1.1.2.1.10', 'sysApplInstallElmtCurSizeHigh', 1521, 'current', NULL, 'The current file size in 2^32 byte blocks. For example, for a file with a total size of 4,294,967,296 bytes, this variable would have a value of 1; for a file with a total size of 4,294,967,295 bytes this variable would be 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1532, '.1.3.6.1.2.1.54.1.1.2.1.11', 'sysApplInstallElmtCurSizeLow', 1521, 'current', NULL, 'The current file size modulo 2^32 bytes. For example, for a file with a total size of 4,294,967,296 bytes this variable would have a value of 0; for a file with a total size of 4,294,967,295 bytes this variable would be 4,294,967,295.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1533, '.1.3.6.1.2.1.54.1.2.1', 'sysApplRunTable', 1507, 'current', NULL, 'The table describes the applications which are executing on the host. Each time an application is invoked, an entry is created in this table. When an application ends, the entry is removed from this table and a corresponding entry is created in the SysApplPastRunTable.  A new entry is created in this table whenever the agent implementation detects a new running process that is an installed application element whose sysApplInstallElmtRole designates it as being the application''s primary executable (sysApplInstallElmtRole = primary(2) ).  The table is indexed by sysApplInstallPkgIndex, sysApplRunIndex to enable managers to easily locate all invocations of a particular application package.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1534, '.1.3.6.1.2.1.54.1.2.1.1', 'sysApplRunEntry', 1533, 'current', NULL, 'The logical row describing an application which is currently running on this host.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1547, '.1.3.6.1.2.1.54.1.2.3.1.2', 'sysApplElmtRunInvocID', 1545, 'current', NULL, 'Part of the index for this table, this value identifies the invocation of an application of which this process is a part. Provided that the ''parent'' application can be determined, the value of this object is the same value as the sysApplRunIndex for the corresponding application invocation in the sysApplRunTable.  If, however, the ''parent'' application cannot be determined, the value for this object is then ''0'', signifying that this process cannot be related back to an invocation of an application in the sysApplRunTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1548, '.1.3.6.1.2.1.54.1.2.3.1.3', 'sysApplElmtRunIndex', 1545, 'current', NULL, 'Part of the index for this table. A unique value for each process running on the host. Wherever possible, this should be the system''s native, unique identification number.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1549, '.1.3.6.1.2.1.54.1.2.3.1.4', 'sysApplElmtRunInstallID', 1545, 'current', NULL, 'The index into the sysApplInstallElmtTable. The value of this object is the same value as the sysApplInstallElmtIndex for the application element of which this entry represents a running instance. If this process cannot be associated with an installed executable, the value should be ''0''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1550, '.1.3.6.1.2.1.54.1.2.3.1.5', 'sysApplElmtRunTimeStarted', 1545, 'current', NULL, 'The time the process was started.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1551, '.1.3.6.1.2.1.54.1.2.3.1.6', 'sysApplElmtRunState', 1545, 'current', NULL, 'The current state of the running process. The possible values are running(1), runnable(2) but waiting for a resource such as CPU, waiting(3) for an event, exiting(4), or other(5).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1552, '.1.3.6.1.2.1.54.1.2.3.1.7', 'sysApplElmtRunName', 1545, 'current', NULL, 'The full path and filename of the process. For example, ''/opt/MYYpkg/bin/myyproc'' would be returned for process ''myyproc'' whose execution path is ''/opt/MYYpkg/bin/myyproc''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1553, '.1.3.6.1.2.1.54.1.2.3.1.8', 'sysApplElmtRunParameters', 1545, 'current', NULL, 'The starting parameters for the process.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5452, '.1.3.6.1.2.1.47.3.2.3', 'entityMappingGroup', 5448, 'current', NULL, 'The collection of objects which are used to represent the associations between multiple logical entities, physical components, interfaces, and port identifiers for which a single agent provides management information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1535, '.1.3.6.1.2.1.54.1.2.1.1.1', 'sysApplRunIndex', 1534, 'current', NULL, 'Part of the index for this table. An arbitrary integer used only for indexing purposes. Generally monotonically increasing from 1 as new applications are started on the host, it uniquely identifies application invocations.  The numbering for this index increases by 1 for each INVOCATION of an application, regardless of which installed application package this entry represents a running instance of.  An example of the indexing for a couple of entries is shown below.  : sysApplRunStarted.17.14 sysApplRunStarted.17.63 sysApplRunStarted.18.13 :  In this example, the agent has observed 12 application invocations when the application represented by entry 18 in the sysApplInstallPkgTable is invoked. The next invocation detected by the agent is an invocation of installed application package 17. Some time later, installed application 17 is invoked a second time.  NOTE: this index is not intended to reflect a real-time (wall clock time) ordering of application invocations; it is merely intended to uniquely identify running instances of applications. Although the sysApplInstallPkgIndex is included in the INDEX clause for this table, it serves only to ease searching of this table by installed application and does not contribute to uniquely identifying table entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1536, '.1.3.6.1.2.1.54.1.2.1.1.2', 'sysApplRunStarted', 1534, 'current', NULL, 'The date and time that the application was started.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1537, '.1.3.6.1.2.1.54.1.2.1.1.3', 'sysApplRunCurrentState', 1534, 'current', NULL, 'The current state of the running application instance. The possible values are running(1), runnable(2) but waiting for a resource such as CPU, waiting(3) for an event, exiting(4), or other(5). This value is based on an evaluation of the running elements of this application instance (see sysApplElmRunState) and their Roles as defined by sysApplInstallElmtRole. An agent implementation may detect that an application instance is in the process of exiting if one or more of its REQUIRED elements are no longer running. Most agent implementations will wait until a second internal poll has been completed to give the system time to start REQUIRED elements before marking the application instance as exiting.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1538, '.1.3.6.1.2.1.54.1.2.2', 'sysApplPastRunTable', 1507, 'current', NULL, 'A history of the applications that have previously run on the host computer. An entry''s information is moved to this table from the sysApplRunTable when the invoked application represented by the entry ceases to be running.  An agent implementation can determine that an application invocation is no longer running by evaluating the running elements of the application instance and their Roles as defined by sysApplInstallElmtRole. Obviously, if there are no running elements for the application instance, then the application invocation is no longer running. If any one of the REQUIRED elements is not running, the application instance may be in the process of exiting. Most agent implementations will wait until a second internal poll has been completed to give the system time to either restart partial failures or to give all elements time to exit. If, after the second poll, there are REQUIRED elements that are not running, then the application instance may be considered by the agent implementation to no longer be running.  Entries remain in the sysApplPastRunTable until they are aged out when either the table size reaches a maximum as determined by the sysApplPastRunMaxRows, or when an entry has aged to exceed a time limit as set by sysApplPastRunTblTimeLimit.  Entries in this table are indexed by sysApplInstallPkgIndex, sysApplPastRunIndex to facilitate retrieval of all past run invocations of a particular installed application.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1539, '.1.3.6.1.2.1.54.1.2.2.1', 'sysApplPastRunEntry', 1538, 'current', NULL, 'The logical row describing an invocation of an application which was previously run and has terminated. The entry is basically copied from the sysApplRunTable when the application instance terminates. Hence, the entry''s value for sysApplPastRunIndex is the same as its value was for sysApplRunIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1540, '.1.3.6.1.2.1.54.1.2.2.1.1', 'sysApplPastRunIndex', 1539, 'current', NULL, 'Part of the index for this table. An integer matching the value of the removed sysApplRunIndex corresponding to this row.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1541, '.1.3.6.1.2.1.54.1.2.2.1.2', 'sysApplPastRunStarted', 1539, 'current', NULL, 'The date and time that the application was started.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1542, '.1.3.6.1.2.1.54.1.2.2.1.3', 'sysApplPastRunExitState', 1539, 'current', NULL, 'The state of the application instance when it terminated. This value is based on an evaluation of the running elements of an application and their Roles as defined by sysApplInstallElmtRole. An application instance is said to have exited in a COMPLETE state and its entry is removed from the sysApplRunTable and added to the sysApplPastRunTable when the agent detects that ALL elements of an application invocation are no longer running. Most agent implementations will wait until a second internal poll has been completed to give the system time to either restart partial failures or to give all elements time to exit. A failed state occurs if, after the second poll, any elements continue to run but one or more of the REQUIRED elements are no longer running. All other combinations MUST be defined as OTHER.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1543, '.1.3.6.1.2.1.54.1.2.2.1.4', 'sysApplPastRunTimeEnded', 1539, 'current', NULL, 'The DateAndTime the application instance was determined to be no longer running.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1544, '.1.3.6.1.2.1.54.1.2.3', 'sysApplElmtRunTable', 1507, 'current', NULL, 'The table describes the processes which are currently executing on the host system. Each entry represents a running process and is associated with the invoked application of which that process is a part, if possible. This table contains an entry for every process currently running on the system, regardless of whether its ''parent'' application can be determined. So, for example, processes like ''ps'' and ''grep'' will have entries though they are not associated with an installed application package.  Because a running application may involve more than one executable, it is possible to have multiple entries in this table for each application. Entries are removed from this table when the process terminates. The table is indexed by sysApplElmtRunInstallPkg, sysApplElmtRunInvocID, and sysApplElmtRunIndex to facilitate the retrieval of all running elements of a particular invoked application which has been installed on the system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1545, '.1.3.6.1.2.1.54.1.2.3.1', 'sysApplElmtRunEntry', 1544, 'current', NULL, 'The logical row describing a process currently running on this host. When possible, the entry is associated with the invoked application of which it is a part.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1546, '.1.3.6.1.2.1.54.1.2.3.1.1', 'sysApplElmtRunInstallPkg', 1545, 'current', NULL, 'Part of the index for this table, this value identifies the installed software package for the application of which this process is a part. Provided that the process''s ''parent'' application can be determined, the value of this object is the same value as the sysApplInstallPkgIndex for the entry in the sysApplInstallPkgTable that corresponds to the installed application of which this process is a part.  If, however, the ''parent'' application cannot be determined, (for example the process is not part of a particular installed application), the value for this object is then ''0'', signifying that this process cannot be related back to an application, and in turn, an installed software package.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5542, '.1.3.6.1.4.1.9.9.168.1.1.2', 'cntpSysStratum', 5538, 'current', NULL, 'The stratum of the local clock. If the value is set to 1, i.e., this is a primary reference, then the Primary-Clock procedure described in Section 3.4.6, in RFC-1305 is invoked.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1554, '.1.3.6.1.2.1.54.1.2.3.1.9', 'sysApplElmtRunCPU', 1545, 'current', NULL, 'The number of centi-seconds of the total system''s CPU resources consumed by this process. Note that on a multi-processor system, this value may have been incremented by more than one centi-second in one centi-second of real (wall clock) time.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1555, '.1.3.6.1.2.1.54.1.2.3.1.10', 'sysApplElmtRunMemory', 1545, 'current', NULL, 'The total amount of real system memory measured in Kbytes currently allocated to this process.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1556, '.1.3.6.1.2.1.54.1.2.3.1.11', 'sysApplElmtRunNumFiles', 1545, 'current', NULL, 'The number of regular files currently open by the process. Transport connections (sockets) should NOT be included in the calculation of this value, nor should operating system specific special file types.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1557, '.1.3.6.1.2.1.54.1.2.3.1.12', 'sysApplElmtRunUser', 1545, 'current', NULL, 'The process owner''s login name (e.g. root).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1558, '.1.3.6.1.2.1.54.1.2.4', 'sysApplElmtPastRunTable', 1507, 'current', NULL, 'The table describes the processes which have previously executed on the host system as part of an application. Each entry represents a process which has previously executed and is associated with the invoked application of which it was a part. Because an invoked application may involve more than one executable, it is possible to have multiple entries in this table for each application invocation. Entries are added to this table when the corresponding process in the sysApplElmtRun Table terminates.  Entries remain in this table until they are aged out when either the number of entries in the table reaches a maximum as determined by sysApplElmtPastRunMaxRows, or when an entry has aged to exceed a time limit as set by sysApplElmtPastRunTblTimeLimit. When aging out entries, the oldest entry, as determined by the value of sysApplElmtPastRunTimeEnded, will be removed first.  The table is indexed by sysApplInstallPkgIndex (from the sysApplInstallPkgTable), sysApplElmtPastRunInvocID, and sysApplElmtPastRunIndex to make it easy to locate all previously executed processes of a particular invoked application that has been installed on the system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1559, '.1.3.6.1.2.1.54.1.2.4.1', 'sysApplElmtPastRunEntry', 1558, 'current', NULL, 'The logical row describing a process which was previously executed on this host as part of an installed application. The entry is basically copied from the sysApplElmtRunTable when the process terminates. Hence, the entry''s value for sysApplElmtPastRunIndex is the same as its value was for sysApplElmtRunIndex. Note carefully: only those processes which could be associated with an identified application are included in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1560, '.1.3.6.1.2.1.54.1.2.4.1.1', 'sysApplElmtPastRunInvocID', 1559, 'current', NULL, 'Part of the index for this table, this value identifies the invocation of an application of which the process represented by this entry was a part. The value of this object is the same value as the sysApplRunIndex for the corresponding application invocation in the sysApplRunTable. If the invoked application as a whole has terminated, it will be the same as the sysApplPastRunIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1561, '.1.3.6.1.2.1.54.1.2.4.1.2', 'sysApplElmtPastRunIndex', 1559, 'current', NULL, 'Part of the index for this table. An integer assigned by the agent equal to the corresponding sysApplElmtRunIndex which was removed from the sysApplElmtRunTable and moved to this table when the element terminated.  Note: entries in this table are indexed by sysApplElmtPastRunInvocID, sysApplElmtPastRunIndex. The possibility exists, though unlikely, of a collision occurring by a new entry which was run by the same invoked application (InvocID), and was assigned the same process identification number (ElmtRunIndex) as an element which was previously run by the same invoked application.  Should this situation occur, the new entry replaces the old entry.  See Section: ''Implementation Issues - sysApplElmtPastRunTable Entry Collisions'' for the conditions that would have to occur in order for a collision to occur.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1562, '.1.3.6.1.2.1.54.1.2.4.1.3', 'sysApplElmtPastRunInstallID', 1559, 'current', NULL, 'The index into the installed element table. The value of this object is the same value as the sysApplInstallElmtIndex for the application element of which this entry represents a previously executed process.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1563, '.1.3.6.1.2.1.54.1.2.4.1.4', 'sysApplElmtPastRunTimeStarted', 1559, 'current', NULL, 'The time the process was started.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1564, '.1.3.6.1.2.1.54.1.2.4.1.5', 'sysApplElmtPastRunTimeEnded', 1559, 'current', NULL, 'The time the process ended.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1565, '.1.3.6.1.2.1.54.1.2.4.1.6', 'sysApplElmtPastRunName', 1559, 'current', NULL, 'The full path and filename of the process. For example, ''/opt/MYYpkg/bin/myyproc'' would be returned for process ''myyproc'' whose execution path was ''/opt/MYYpkg/bin/myyproc''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1566, '.1.3.6.1.2.1.54.1.2.4.1.7', 'sysApplElmtPastRunParameters', 1559, 'current', NULL, 'The starting parameters for the process.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1567, '.1.3.6.1.2.1.54.1.2.4.1.8', 'sysApplElmtPastRunCPU', 1559, 'current', NULL, 'The last known number of centi-seconds of the total system''s CPU resources consumed by this process. Note that on a multi-processor system, this value may increment by more than one centi-second in one centi-second of real (wall clock) time.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1568, '.1.3.6.1.2.1.54.1.2.4.1.9', 'sysApplElmtPastRunMemory', 1559, 'current', NULL, 'The last known total amount of real system memory measured in Kbytes allocated to this process before it terminated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1569, '.1.3.6.1.2.1.54.1.2.4.1.10', 'sysApplElmtPastRunNumFiles', 1559, 'current', NULL, 'The last known number of files open by the process before it terminated. Transport connections (sockets) should NOT be included in the calculation of this value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1570, '.1.3.6.1.2.1.54.1.2.4.1.11', 'sysApplElmtPastRunUser', 1559, 'current', NULL, 'The process owner''s login name (e.g. root).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1571, '.1.3.6.1.2.1.54.1.2.5', 'sysApplPastRunMaxRows', 1507, 'current', NULL, 'The maximum number of entries allowed in the sysApplPastRunTable. Once the number of rows in the sysApplPastRunTable reaches this value, the management subsystem will remove the oldest entry in the table to make room for the new entry to be added. Entries will be removed on the basis of oldest sysApplPastRunTimeEnded value first.  This object may be used to control the amount of system resources that can used for sysApplPastRunTable entries. A conforming implementation should attempt to support the default value, however, a lesser value may be necessary due to implementation-dependent issues and resource availability.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1572, '.1.3.6.1.2.1.54.1.2.6', 'sysApplPastRunTableRemItems', 1507, 'current', NULL, 'A counter of the number of entries removed from the sysApplPastRunTable because of table size limitations as set in sysApplPastRunMaxRows. This counter is the number of entries the management subsystem has had to remove in order to make room for new entries (so as not to exceed the limit set by sysApplPastRunMaxRows) since the last initialization of the management subsystem.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1573, '.1.3.6.1.2.1.54.1.2.7', 'sysApplPastRunTblTimeLimit', 1507, 'current', NULL, 'The maximum time in seconds which an entry in the sysApplPastRunTable may exist before it is removed. Any entry that is older than this value will be removed (aged out) from the table.  Note that an entry may be aged out prior to reaching this time limit if it is the oldest entry in the table and must be removed to make space for a new entry so as to not exceed sysApplPastRunMaxRows.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5450, '.1.3.6.1.2.1.47.3.2.1', 'entityPhysicalGroup', 5448, 'current', NULL, 'The collection of objects which are used to represent physical system components, for which a single agent provides management information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1574, '.1.3.6.1.2.1.54.1.2.8', 'sysApplElemPastRunMaxRows', 1507, 'current', NULL, 'The maximum number of entries allowed in the sysApplElmtPastRunTable. Once the number of rows in the sysApplElmtPastRunTable reaches this value, the management subsystem will remove the oldest entry to make room for the new entry to be added. Entries will be removed on the basis of oldest sysApplElmtPastRunTimeEnded value first. This object may be used to control the amount of system resources that can used for sysApplElemPastRunTable entries. A conforming implementation should attempt to support the default value, however, a lesser value may be necessary due to implementation-dependent issues and resource availability.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1575, '.1.3.6.1.2.1.54.1.2.9', 'sysApplElemPastRunTableRemItems', 1507, 'current', NULL, 'A counter of the number of entries removed from the sysApplElemPastRunTable because of table size limitations as set in sysApplElemPastRunMaxRows. This counter is the number of entries the management subsystem has had to remove in order to make room for new entries (so as not to exceed the limit set by sysApplElemPastRunMaxRows) since the last initialization of the management subsystem.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1576, '.1.3.6.1.2.1.54.1.2.10', 'sysApplElemPastRunTblTimeLimit', 1507, 'current', NULL, 'The maximum time in seconds which an entry in the sysApplElemPastRunTable may exist before it is removed. Any entry that is older than this value will be removed (aged out) from the table.  Note that an entry may be aged out prior to reaching this time limit if it is the oldest entry in the table and must be removed to make space for a new entry so as to not exceed sysApplElemPastRunMaxRows.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1577, '.1.3.6.1.2.1.54.1.2.11', 'sysApplAgentPollInterval', 1507, 'current', NULL, 'The minimum interval in seconds that the management subsystem implementing this MIB will poll the status of the managed resources. Because of the non-trivial effort involved in polling the managed resources, and because the method for obtaining the status of the managed resources is implementation-dependent, a conformant implementation may chose a lower bound greater than 0.  A value of 0 indicates that there is no delay in the passing of information from the managed resources to the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1578, '.1.3.6.1.2.1.54.1.3.1', 'sysApplMapTable', 1508, 'current', NULL, 'The sole purpose of this table is to provide a ''backwards'' mapping so that, given a known sysApplElmtRunIndex (process identification number), the corresponding invoked application (sysApplRunIndex), installed element (sysApplInstallElmtIndex), and installed application package (sysApplInstallPkgIndex) can be quickly determined.  This table will contain one entry for each process that is currently executing on the system.  It is expected that management applications will use this mapping table by doing a ''GetNext'' operation with the known process ID number (sysApplElmtRunIndex) as the partial instance identifier. Assuming that there is an entry for the process, the result should return a single columnar value, the sysApplMapInstallPkgIndex, with the sysApplElmtRunIndex, sysApplRunIndex, and sysApplInstallElmtIndex contained in the instance identifier for the returned MIB object value.  NOTE: if the process can not be associated back to an invoked application installed on the system, then the value returned for the columnar value sysApplMapInstallPkgIndex will be ''0'' and the instance portion of the object-identifier will be the process ID number (sysApplElmtRunIndex) followed by 0.0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1579, '.1.3.6.1.2.1.54.1.3.1.1', 'sysApplMapEntry', 1578, 'current', NULL, 'A logical row representing a process currently running on the system. This entry provides the index mapping from process identifier, back to the invoked application, installed element, and finally, the installed application package. The entry includes only one accessible columnar object, the sysApplMapInstallPkgIndex, but the invoked application and installed element can be determined from the instance identifier since they form part of the index clause.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1580, '.1.3.6.1.2.1.54.1.3.1.1.1', 'sysApplMapInstallElmtIndex', 1579, 'current', NULL, 'The index into the sysApplInstallElmtTable. The value of this object is the same value as the sysApplInstallElmtIndex for the application element of which this entry represents a running instance. If this process cannot be associated to an installed executable, the value should be ''0''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1581, '.1.3.6.1.2.1.54.1.3.1.1.2', 'sysApplMapInstallPkgIndex', 1579, 'current', NULL, 'The value of this object identifies the installed software package for the application of which this process is a part. Provided that the process''s ''parent'' application can be determined, the value of this object is the same value as the sysApplInstallPkgIndex for the entry in the sysApplInstallPkgTable that corresponds to the installed application of which this process is a part.  If, however, the ''parent'' application cannot be determined, (for example the process is not part of a particular installed application), the value for this object is then ''0'', signifying that this process cannot be related back to an application, and in turn, an installed software package.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1582, '.1.3.6.1.2.1.54.3.1', 'sysApplMIBCompliances', 1510, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1583, '.1.3.6.1.2.1.54.3.2', 'sysApplMIBGroups', 1510, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1584, '.1.3.6.1.2.1.54.3.1.1', 'sysApplMIBCompliance', 1582, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1585, '.1.3.6.1.2.1.54.3.2.1', 'sysApplInstalledGroup', 1583, 'current', NULL, 'The system application installed group contains information about applications and their constituent components which have been installed on the host system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1586, '.1.3.6.1.2.1.54.3.2.2', 'sysApplRunGroup', 1583, 'current', NULL, 'The system application run group contains information about applications and associated elements which have run or are currently running on the host system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1587, '.1.3.6.1.2.1.54.3.2.3', 'sysApplMapGroup', 1583, 'current', NULL, 'The Map Group contains a single table, sysApplMapTable, that provides a backwards mapping for determining the invoked application, installed element, and installed application package given a known process identification number.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5560, '.1.3.6.1.4.1.9.9.168.1.2.1.1.8', 'cntpPeersMode', 5552, 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Section 3.3', 'The association mode of the NTP server, with values coded as followw, 0, unspecified 1, symmetric active - A host operating in this mode sends periodic messages regardless of the reachability state or stratum of its peer. By operating in this mode the host announces its willingness to synchronize and be synchronized by the peer 2, symmetric passive - This type of association is ordinarily created upon arrival of a message from a peer operating in the symmetric active mode and persists only as long as the peer is reachable and operating at a stratum level less than or equal to the host; otherwise, the association is dissolved. However, the association will always persist until at least one message has been sent in reply. By operating in this mode the host announces its willingness to synchronize and be synchronized by the peer 3, client - A host operating in this mode sends periodic messages regardless of the reachability state or stratum of its peer. By operating in this mode the host, usually a LAN workstation, announces its willingness to be synchronized by, but not to synchronize the peer 4, server - This type of association is ordinarily created upon arrival of a client request message and exists only in order to reply to that request, after which the association is dissolved. By operating in this mode the host, usually a LAN time server, announces its willingness to synchronize, but not to be synchronized by the peer 5, broadcast - A host operating in this mode sends periodic messages regardless of the reachability state or stratum of the peers. By operating in this mode the host, usually a LAN time server operating on a high-speed broadcast medium, announces its willingness to synchronize all of the peers, but not to be synchronized by any of them 6, reserved for NTP control messages 7, reserved for private use.  When creating a new peer association, if no value is specified for this object, it defaults to symmetricActive(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5561, '.1.3.6.1.4.1.9.9.168.1.2.1.1.9', 'cntpPeersStratum', 5552, 'current', NULL, 'The stratum of the peer clock.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5562, '.1.3.6.1.4.1.9.9.168.1.2.1.1.10', 'cntpPeersPeerPoll', 5552, 'current', NULL, 'The interval at which the peer polls the local host.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5563, '.1.3.6.1.4.1.9.9.168.1.2.1.1.11', 'cntpPeersHostPoll', 5552, 'current', NULL, 'The interval at which the local host polls the peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5451, '.1.3.6.1.2.1.47.3.2.2', 'entityLogicalGroup', 5448, 'current', NULL, 'The collection of objects which are used to represent the list of logical entities for which a single agent provides management information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5564, '.1.3.6.1.4.1.9.9.168.1.2.1.1.12', 'cntpPeersPrecision', 5552, 'current', NULL, 'Signed integer indicating the precision of the peer clock, in seconds to the nearest power of two. The value must be rounded to the next larger power of two; for instance, a 50-Hz (20 ms) or 60-Hz (16.67 ms) power-frequency clock would be assigned the value -5 (31.25 ms), while a 1000-Hz (1 ms) crystal-controlled clock would be assigned the value -9 (1.95 ms).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5565, '.1.3.6.1.4.1.9.9.168.1.2.1.1.13', 'cntpPeersRootDelay', 5552, 'current', NULL, 'A signed fixed-point number indicating the total round-trip delay in seconds, from the peer to the primary reference source at the root of the synchronization subnet.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5566, '.1.3.6.1.4.1.9.9.168.1.2.1.1.14', 'cntpPeersRootDispersion', 5552, 'current', NULL, 'The maximum error in seconds, of the peer clock relative to the primary reference source at the root of the synchronization subnet. Only positive values greater than zero are possible.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5567, '.1.3.6.1.4.1.9.9.168.1.2.1.1.15', 'cntpPeersRefId', 5552, 'current', NULL, 'The reference identifier of the peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5568, '.1.3.6.1.4.1.9.9.168.1.2.1.1.16', 'cntpPeersRefTime', 5552, 'current', NULL, 'The local time at the peer when its clock was last updated. If the peer clock has never been synchronized, the value is zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5569, '.1.3.6.1.4.1.9.9.168.1.2.1.1.17', 'cntpPeersOrgTime', 5552, 'current', NULL, 'The local time at the peer, when its latest NTP message was sent. If the peer becomes unreachable the value is set to zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5570, '.1.3.6.1.4.1.9.9.168.1.2.1.1.18', 'cntpPeersReceiveTime', 5552, 'current', NULL, 'The local time, when the latest NTP message from the peer arrived. If the peer becomes unreachable the value is set to zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5571, '.1.3.6.1.4.1.9.9.168.1.2.1.1.19', 'cntpPeersTransmitTime', 5552, 'current', NULL, 'The local time at which the NTP message departed the sender.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5572, '.1.3.6.1.4.1.9.9.168.1.2.1.1.20', 'cntpPeersUpdateTime', 5552, 'current', NULL, 'The local time, when the most recent NTP message was received from the peer that was used to calculate the skew dispersion. This represents only the 32-bit integer part of the NTPTimestamp.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5573, '.1.3.6.1.4.1.9.9.168.1.2.1.1.21', 'cntpPeersReach', 5552, 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Section 3.2.3', 'A shift register of used to determine the reachability status of the peer, with bits entering from the least significant (rightmost) end. A peer is considered reachable if at least one bit in this register is set to one i.e, if the value of this object is non-zero. The data in the shift register would be populated by the NTP protocol procedures.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5574, '.1.3.6.1.4.1.9.9.168.1.2.1.1.22', 'cntpPeersTimer', 5552, 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Section 3.2.3', 'The interval in seconds, between transmitted NTP messages from the local host to the peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5575, '.1.3.6.1.4.1.9.9.168.1.2.1.1.23', 'cntpPeersOffset', 5552, 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Section 3.2.5', 'The estimated offset of the peer clock relative to the local clock, in seconds. The host determines the value of this object using the NTP clock-filter algorithm.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5576, '.1.3.6.1.4.1.9.9.168.1.2.1.1.24', 'cntpPeersDelay', 5552, 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Section 3.2.5', 'The estimated round-trip delay of the peer clock relative to the local clock over the network path between them, in seconds. The host determines the value of this object using the NTP clock-filter algorithm.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5577, '.1.3.6.1.4.1.9.9.168.1.2.1.1.25', 'cntpPeersDispersion', 5552, 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Section 3.2.5', 'The estimated maximum error of the peer clock relative to the local clock over the network path between them, in seconds. The host determines the value of this object using the NTP clock-filter algorithm.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5578, '.1.3.6.1.4.1.9.9.168.1.2.1.1.26', 'cntpPeersFilterValidEntries', 5552, 'current', NULL, 'The number of valid entries for a peer in the Filter Register Table. Since, the Filter Register Table is optional, this object will have a value 0 if the Filter Register Table is not implemented.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5579, '.1.3.6.1.4.1.9.9.168.1.2.1.1.27', 'cntpPeersEntryStatus', 5552, 'current', NULL, 'The status object for this row. When a management station is creating a new row, it should set the value for cntpPeersPeerAddress atleast, before the row can be made active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5580, '.1.3.6.1.4.1.9.9.168.1.3.2', 'cntpFilterRegisterTable', 5540, 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Section 3.2.5', 'The following table contains NTP state variables used by the NTP clock filter and selection algorithms. This table depicts a shift register. Each stage in the shift register is a 3-tuple consisting of the measured clock offset, measured clock delay and measured clock dispersion associated with a single observation.  An important factor affecting the accuracy and reliability of time distribution is the complex of algorithms used to reduce the effect of statistical errors and falsetickers due to failure of various subnet components, reference sources or propagation media. The NTP clock-filter and selection algorithms are designed to do exactly this. The objects in the filter register table below are used by these algorthims to minimize the error in the calculated time.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5581, '.1.3.6.1.4.1.9.9.168.1.3.2.1', 'cntpFilterRegisterEntry', 5580, 'current', NULL, 'Each entry corresponds to one stage of the shift register, i.e., one reading of the variables clock delay, clock offset and clock dispersion.  Entries are automatically created whenever a peer is configured and deleted when the peer is removed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5582, '.1.3.6.1.4.1.9.9.168.1.3.2.1.1', 'cntpFilterIndex', 5581, 'current', NULL, 'An integer value in the specified range that is used to index into the table. The size of the table is fixed at 8. Each entry identifies a particular reading of the clock filter variables in the shift register.  Entries are added starting at index 1. The index wraps back to 1 when it reaches 8. When the index wraps back, the new entries will overwrite the old entries effectively deleting the old entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5522, '.1.3.6.1.4.1.9.9.84.1.2.1.1', 'cipMacEntry', 5521, 'current', NULL, 'An entry in the cipMacTable is created for each unique MAC address which receives/sends IP packets. Entries are deleted via the command line interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5523, '.1.3.6.1.4.1.9.9.84.1.2.1.1.1', 'cipMacDirection', 5522, 'current', NULL, 'The data source for the object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5524, '.1.3.6.1.4.1.9.9.84.1.2.1.1.2', 'cipMacAddress', 5522, 'current', NULL, 'The MAC address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5525, '.1.3.6.1.4.1.9.9.84.1.2.1.1.3', 'cipMacSwitchedPkts', 5522, 'current', NULL, 'The counter in packets with respect to cipMacAddress.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5526, '.1.3.6.1.4.1.9.9.84.1.2.1.1.4', 'cipMacSwitchedBytes', 5522, 'current', NULL, 'The counter in bytes with respect to cipMacAddress.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5527, '.1.3.6.1.4.1.9.9.84.1.2.2', 'cipMacFreeTable', 5514, 'current', NULL, 'A table of free space available to store new MAC address information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5528, '.1.3.6.1.4.1.9.9.84.1.2.2.1', 'cipMacFreeEntry', 5527, 'current', NULL, 'The MAC free space table entry. Entry is created when Entries are created and deleted via ip accounting command line interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5529, '.1.3.6.1.4.1.9.9.84.1.2.2.1.1', 'cipMacFreeDirection', 5528, 'current', NULL, 'The data source for the object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5530, '.1.3.6.1.4.1.9.9.84.1.2.2.1.2', 'cipMacFreeCount', 5528, 'current', NULL, 'Number of items in the MAC free space.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5543, '.1.3.6.1.4.1.9.9.168.1.1.3', 'cntpSysPrecision', 5538, 'current', NULL, 'Signed integer indicating the precision of the system clock, in seconds to the nearest power of two. The value must be rounded to the next larger power of two; for instance, a 50-Hz (20 ms) or 60-Hz (16.67 ms) power-frequency clock would be assigned the value -5 (31.25 ms), while a 1000-Hz (1 ms) crystal-controlled clock would be assigned the value -9 (1.95 ms).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5544, '.1.3.6.1.4.1.9.9.168.1.1.4', 'cntpSysRootDelay', 5538, 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Sections 2.2, 3.2.1', 'A signed fixed-point number indicating the total round-trip delay in seconds, to the primary reference source at the root of the synchronization subnet.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5545, '.1.3.6.1.4.1.9.9.168.1.1.5', 'cntpSysRootDispersion', 5538, 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Sections 2, 2.2, 3.2.1', 'The maximum error in seconds, relative to the primary reference source at the root of the synchronization subnet. Only positive values greater than zero are possible.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5546, '.1.3.6.1.4.1.9.9.168.1.1.6', 'cntpSysRefId', 5538, 'current', NULL, 'The reference identifier of the local clock.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5547, '.1.3.6.1.4.1.9.9.168.1.1.7', 'cntpSysRefTime', 5538, 'current', NULL, 'The local time when the local clock was last updated. If the local clock has never been synchronized, the value is zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5548, '.1.3.6.1.4.1.9.9.168.1.1.8', 'cntpSysPoll', 5538, 'current', NULL, 'The interval at which the NTP server polls other NTP servers to synchronize its clock.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5549, '.1.3.6.1.4.1.9.9.168.1.1.9', 'cntpSysPeer', 5538, 'current', NULL, 'The current synchronization source. This will contain the unique association identifier cntpPeersAssocId of the corresponding peer entry in the cntpPeersVarTable of the peer acting as the synchronization source. If there is no peer, the value will be 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5550, '.1.3.6.1.4.1.9.9.168.1.1.10', 'cntpSysClock', 5538, 'current', NULL, 'The current local time. Local time is derived from the hardware clock of the particular machine and increments at intervals depending on the design used.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5551, '.1.3.6.1.4.1.9.9.168.1.2.1', 'cntpPeersVarTable', 5539, 'current', NULL, 'This table provides information on the peers with which the local NTP server has associations. The peers are also NTP servers but running on different hosts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5552, '.1.3.6.1.4.1.9.9.168.1.2.1.1', 'cntpPeersVarEntry', 5551, 'current', NULL, 'Each peers'' entry provides NTP information retrieved from a particular peer NTP server. Each peer is identified by a unique association identifier.  Entries are automatically created when the user configures the NTP server to be associated with remote peers. Similarly entries are deleted when the user removes the peer association from the NTP server.  Entries can also be created by the management station by setting values for the following objects: cntpPeersPeerAddress, cntpPeersHostAddress and cntpPeersMode and making the cntpPeersEntryStatus as active(1). At the least, the management station has to set a value for cntpPeersPeerAddress to make the row active.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5553, '.1.3.6.1.4.1.9.9.168.1.2.1.1.1', 'cntpPeersAssocId', 5552, 'current', NULL, 'An integer value greater than 0 that uniquely identifies a peer with which the local NTP server is associated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5554, '.1.3.6.1.4.1.9.9.168.1.2.1.1.2', 'cntpPeersConfigured', 5552, 'current', NULL, 'This is a bit indicating that the association was created from configuration information and should not be de-associated even if the peer becomes unreachable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5555, '.1.3.6.1.4.1.9.9.168.1.2.1.1.3', 'cntpPeersPeerAddress', 5552, 'current', NULL, 'The IP address of the peer. When creating a new association, a value for this object should be set before the row is made active.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5556, '.1.3.6.1.4.1.9.9.168.1.2.1.1.4', 'cntpPeersPeerPort', 5552, 'current', NULL, 'The UDP port number on which the peer receives NTP mesages.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5557, '.1.3.6.1.4.1.9.9.168.1.2.1.1.5', 'cntpPeersHostAddress', 5552, 'current', NULL, 'The IP address of the local host. Multi-homing can be supported using this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5558, '.1.3.6.1.4.1.9.9.168.1.2.1.1.6', 'cntpPeersHostPort', 5552, 'current', NULL, 'The UDP port number on which the local host receives NTP messages.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5559, '.1.3.6.1.4.1.9.9.168.1.2.1.1.7', 'cntpPeersLeap', 5552, 'current', NULL, 'Two-bit code warning of an impending leap second to be inserted in the NTP timescale of the peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5584, '.1.3.6.1.4.1.9.9.168.1.3.2.1.3', 'cntpFilterPeersDelay', 5581, 'current', NULL, 'Round-trip delay of the peer clock relative to the local clock over the network path between them, in seconds. This variable can take on both positive and negative values, depending on clock precision and skew-error accumulation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5882, '.1.3.6.1.2.1.19.3.1.1', 'charSessPortIndex', 5881, 'current', NULL, 'The value of charPortIndex for the port to which this session belongs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5511, '.1.3.6.1.4.1.9.9.84', 'ciscoIpStatMIB', 272, 'current', NULL, 'Cisco IP Statistics MIB - Overview  This MIB incorporates objects to provide support for the Cisco IP statistics as implemented in command interfaces  ip accounting [ mac-address {input | ouput } | precedence { input | ouput } ]  The above CLI provides additional IP statistics categorized by precedence of IP packets, as well as the MAC address associated with IP packets. This is a supplement to those defined in OLD-CISCO-IP-MIB.my.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5512, '.1.3.6.1.4.1.9.9.84.1', 'ciscoIpStatMIBObjects', 5511, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5513, '.1.3.6.1.4.1.9.9.84.1.1', 'cipPrecedence', 5512, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5514, '.1.3.6.1.4.1.9.9.84.1.2', 'cipMacIf', 5512, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5515, '.1.3.6.1.4.1.9.9.84.1.1.1', 'cipPrecedenceTable', 5513, 'current', NULL, 'A table of entries sorted by the precedence of IP packets. The table is created and deleted via ip accounting command line interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5516, '.1.3.6.1.4.1.9.9.84.1.1.1.1', 'cipPrecedenceEntry', 5515, 'current', NULL, 'An entry in the cipPrecedenceTable is created for each IP precedence value. There are 8 precedences total.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5517, '.1.3.6.1.4.1.9.9.84.1.1.1.1.1', 'cipPrecedenceDirection', 5516, 'current', NULL, 'The data source for the object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5518, '.1.3.6.1.4.1.9.9.84.1.1.1.1.2', 'cipPrecedenceIpPrecedence', 5516, 'current', NULL, 'The ip precedence value this object is collected upon.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5519, '.1.3.6.1.4.1.9.9.84.1.1.1.1.3', 'cipPrecedenceSwitchedPkts', 5516, 'current', NULL, 'Traffic, in packets, at the cipPrecedenceIpPrecedence precedence.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5520, '.1.3.6.1.4.1.9.9.84.1.1.1.1.4', 'cipPrecedenceSwitchedBytes', 5516, 'current', NULL, 'Traffic, in bytes, at the cipPrecedenceIpPrecedence precedence.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5521, '.1.3.6.1.4.1.9.9.84.1.2.1', 'cipMacTable', 5514, 'current', NULL, 'A table is created and deleted via ip accounting command line interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5445, '.1.3.6.1.2.1.47.2.0.1', 'entConfigChange', 5444, 'current', NULL, 'An entConfigChange trap is sent when the value of entLastChangeTime changes. It can be utilized by an NMS to trigger logical/physical entity table maintenance polls.  An agent must not generate more than one entConfigChange ''trap-event'' in a five second period, where a ''trap-event'' is the transmission of a single trap PDU to a list of trap destinations. If additional configuration changes occur within the five second ''throttling'' period, then these trap-events should be suppressed by the agent. An NMS should periodically check the value of entLastChangeTime to detect any missed entConfigChange trap-events, e.g. due to throttling or transmission loss.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5446, '.1.3.6.1.2.1.47.3', 'entityConformance', 5409, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5447, '.1.3.6.1.2.1.47.3.1', 'entityCompliances', 5446, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5453, '.1.3.6.1.2.1.47.3.2.4', 'entityGeneralGroup', 5448, 'current', NULL, 'The collection of objects which are used to represent general entity information for which a single agent provides management information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5430, '.1.3.6.1.2.1.47.1.2.1.1.5', 'entLogicalTAddress', 5425, 'current', NULL, 'The transport service address by which the logical entity receives network management traffic, formatted according to the corresponding value of entLogicalTDomain.  For snmpUDPDomain, a TAddress is 6 octets long, the initial 4 octets containing the IP-address in network-byte order and the last 2 containing the UDP port in network-byte order. Consult ''Transport Mappings for Version 2 of the Simple      Network Management Protocol'' (RFC 1906 [8]) for further information on snmpUDPDomain.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5431, '.1.3.6.1.2.1.47.1.2.1.1.6', 'entLogicalTDomain', 5425, 'current', NULL, 'Indicates the kind of transport service by which the logical entity receives network management traffic. Possible values for this object are presently found in the Transport Mappings for SNMPv2 document (RFC 1906 [8]).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5432, '.1.3.6.1.2.1.47.1.3.1', 'entLPMappingTable', 5413, 'current', NULL, 'This table contains zero or more rows of logical entity to physical equipment associations. For each logical entity known by this agent, there are zero or more mappings to the physical resources which are used to realize that logical entity.  An agent should limit the number and nature of entries in this table such that only meaningful and non-redundant information is returned. For example, in a system which contains a single power supply, mappings between logical entities and the power supply are not useful and should not be included.  Also, only the most appropriate physical component which is closest to the root of a particular containment tree should be identified in an entLPMapping entry.  For example, suppose a bridge is realized on a particular module, and all ports on that module are ports on this bridge. A mapping between the bridge and the module would be useful, but additional mappings between the bridge and each of the ports on that module would be redundant (since the entPhysicalContainedIn hierarchy can provide the same information). If, on the other hand, more than one bridge was utilizing ports on this module, then mappings between each bridge and the ports it used would be appropriate.  Also, in the case of a single backplane repeater, a mapping      for the backplane to the single repeater entity is not necessary.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5433, '.1.3.6.1.2.1.47.1.3.1.1', 'entLPMappingEntry', 5432, 'current', NULL, 'Information about a particular logical entity to physical equipment association. Note that the nature of the association is not specifically identified in this entry. It is expected that sufficient information exists in the MIBs used to manage a particular logical entity to infer how physical component information is utilized.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5434, '.1.3.6.1.2.1.47.1.3.1.1.1', 'entLPPhysicalIndex', 5433, 'current', NULL, 'The value of this object identifies the index value of a particular entPhysicalEntry associated with the indicated entLogicalEntity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5435, '.1.3.6.1.2.1.47.1.3.2', 'entAliasMappingTable', 5413, 'current', NULL, 'This table contains zero or more rows, representing mappings of logical entity and physical component to external MIB identifiers. Each physical port in the system may be associated with a mapping to an external identifier, which itself is associated with a particular logical entity''s naming scope. A ''wildcard'' mechanism is provided to indicate that an identifier is associated with more than one logical entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5436, '.1.3.6.1.2.1.47.1.3.2.1', 'entAliasMappingEntry', 5435, 'current', NULL, 'Information about a particular physical equipment, logical entity to external identifier binding. Each logical entity/physical component pair may be associated with one alias mapping. The logical entity index may also be used as a ''wildcard'' (refer to the entAliasLogicalIndexOrZero object DESCRIPTION clause for details.)  Note that only entPhysicalIndex values which represent physical ports (i.e. associated entPhysicalClass value is ''port(10)'') are permitted to exist in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5437, '.1.3.6.1.2.1.47.1.3.2.1.1', 'entAliasLogicalIndexOrZero', 5436, 'current', NULL, 'The value of this object uniquely identifies the logical entity which defines the naming scope for the associated instance of the ''entAliasMappingIdentifier'' object.  If this object has a non-zero value, then it identifies the logical entity named by the same value of entLogicalIndex.  If this object has a value of zero, then the mapping between the physical component and the alias identifier for this entAliasMapping entry is associated with all unspecified logical entities. That is, a value of zero (the default mapping) identifies any logical entity which does not have an explicit entry in this table for a particular entPhysicalIndex/entAliasMappingIdentifier pair.  For example, to indicate that a particular interface (e.g. physical component 33) is identified by the same value of ifIndex for all logical entities, the following instance might exist:       entAliasMappingIdentifier.33.0 = ifIndex.5  In the event an entPhysicalEntry is associated differently for some logical entities, additional entAliasMapping entries may exist, e.g.:  entAliasMappingIdentifier.33.0 = ifIndex.6 entAliasMappingIdentifier.33.4 = ifIndex.1 entAliasMappingIdentifier.33.5 = ifIndex.1 entAliasMappingIdentifier.33.10 = ifIndex.12  Note that entries with non-zero entAliasLogicalIndexOrZero index values have precedence over any zero-indexed entry. In this example, all logical entities except 4, 5, and 10, associate physical entity 33 with ifIndex.6.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5438, '.1.3.6.1.2.1.47.1.3.2.1.2', 'entAliasMappingIdentifier', 5436, 'current', NULL, 'The value of this object identifies a particular conceptual row associated with the indicated entPhysicalIndex and entLogicalIndex pair.  Since only physical ports are modeled in this table, only entries which represent interfaces or ports are allowed. If an ifEntry exists on behalf of a particular physical port, then this object should identify the associated ''ifEntry''. For repeater ports, the appropriate row in the ''rptrPortGroupTable'' should be identified instead.  For example, suppose a physical port was represented by entPhysicalEntry.3, entLogicalEntry.15 existed for a repeater, and entLogicalEntry.22 existed for a bridge. Then there might be two related instances of entAliasMappingIdentifier: entAliasMappingIdentifier.3.15 == rptrPortGroupIndex.5.2 entAliasMappingIdentifier.3.22 == ifIndex.17 It is possible that other mappings (besides interfaces and repeater ports) may be defined in the future, as required.  Bridge ports are identified by examining the Bridge MIB and appropriate ifEntries associated with each ''dot1dBasePort'', and are thus not represented in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5439, '.1.3.6.1.2.1.47.1.3.3', 'entPhysicalContainsTable', 5413, 'current', NULL, 'A table which exposes the container/containee relationships between physical entities. This table provides equivalent information found by constructing the virtual containment tree for a given entPhysicalTable but in a more direct format.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5440, '.1.3.6.1.2.1.47.1.3.3.1', 'entPhysicalContainsEntry', 5439, 'current', NULL, 'A single container/containee relationship.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5441, '.1.3.6.1.2.1.47.1.3.3.1.1', 'entPhysicalChildIndex', 5440, 'current', NULL, 'The value of entPhysicalIndex for the contained physical entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6241, '.1.0.8802.1.1', 'ieee802dot1mibs', 6240, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5395, '.1.3.6.1.4.1.9.9.703.3.1.5', 'cfmeRtpCumulativeAvgLossDuration', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the average duration of a RTP loss interval for a traffic flow (cfmRtpMetricsAvgLD).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5442, '.1.3.6.1.2.1.47.1.4.1', 'entLastChangeTime', 5414, 'current', NULL, 'The value of sysUpTime at the time any of these events occur: * a conceptual row is created or deleted in any of these tables: - entPhysicalTable - entLogicalTable - entLPMappingTable      - entAliasMappingTable - entPhysicalContainsTable  * any instance in the following list of objects changes value: - entPhysicalDescr - entPhysicalVendorType - entPhysicalContainedIn - entPhysicalClass - entPhysicalParentRelPos - entPhysicalName - entLogicalDescr - entLogicalType - entLogicalCommunity - entLogicalTAddress - entLogicalTDomain - entAliasMappingIdentifier', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5415, '.1.3.6.1.2.1.47.1.1.1', 'entPhysicalTable', 5411, 'current', NULL, 'This table contains one row per physical entity. There is always at least one row for an ''overall'' physical entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5416, '.1.3.6.1.2.1.47.1.1.1.1', 'entPhysicalEntry', 5415, 'current', NULL, 'Information about a particular physical entity.  Each entry provides objects (entPhysicalDescr, entPhysicalVendorType, and entPhysicalClass) to help an NMS identify and characterize the entry, and objects (entPhysicalContainedIn and entPhysicalParentRelPos) to help an NMS relate the particular entry to other entries in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5417, '.1.3.6.1.2.1.47.1.1.1.1.1', 'entPhysicalIndex', 5416, 'current', NULL, 'The index for this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5418, '.1.3.6.1.2.1.47.1.1.1.1.2', 'entPhysicalDescr', 5416, 'current', NULL, 'A textual description of physical entity. This object should contain a string which identifies the manufacturer''s name for the physical entity, and should be set to a distinct value for each version or model of the physical entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5419, '.1.3.6.1.2.1.47.1.1.1.1.3', 'entPhysicalVendorType', 5416, 'current', NULL, 'An indication of the vendor-specific hardware type of the      physical entity. Note that this is different from the definition of MIB-II''s sysObjectID.  An agent should set this object to a enterprise-specific registration identifier value indicating the specific equipment type in detail. The associated instance of entPhysicalClass is used to indicate the general type of hardware device.  If no vendor-specific registration identifier exists for this physical entity, or the value is unknown by this agent, then the value { 0 0 } is returned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5420, '.1.3.6.1.2.1.47.1.1.1.1.4', 'entPhysicalContainedIn', 5416, 'current', NULL, 'The value of entPhysicalIndex for the physical entity which ''contains'' this physical entity. A value of zero indicates this physical entity is not contained in any other physical entity. Note that the set of ''containment'' relationships define a strict hierarchy; that is, recursion is not allowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5421, '.1.3.6.1.2.1.47.1.1.1.1.5', 'entPhysicalClass', 5416, 'current', NULL, 'An indication of the general hardware type of the physical entity.  An agent should set this object to the standard enumeration value which most accurately indicates the general class of the physical entity, or the primary class if there is more than one.  If no appropriate standard registration identifier exists for this physical entity, then the value ''other(1)'' is returned. If the value is unknown by this agent, then the value ''unknown(2)'' is returned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5422, '.1.3.6.1.2.1.47.1.1.1.1.6', 'entPhysicalParentRelPos', 5416, 'current', NULL, 'An indication of the relative position of this ''child'' component among all its ''sibling'' components. Sibling components are defined as entPhysicalEntries which share the same instance values of each of the entPhysicalContainedIn and entPhysicalClass objects.  An NMS can use this object to identify the relative ordering for all sibling components of a particular parent (identified by the entPhysicalContainedIn instance in each sibling entry).  This value should match any external labeling of the physical component if possible. For example, for a module labeled as ''card #3'', entPhysicalParentRelPos should have the value ''3''.  If the physical position of this component does not match any external numbering or clearly visible ordering, then user documentation or other external reference material should be used to determine the parent-relative position. If this is not possible, then the the agent should assign a consistent (but possibly arbitrary) ordering to a given set of ''sibling'' components, perhaps based on internal representation of the components.  If the agent cannot determine the parent-relative position for some reason, or if the associated value of entPhysicalContainedIn is ''0'', then the value ''-1'' is returned. Otherwise a non-negative integer is returned, indicating the parent-relative position of this physical entity.  Parent-relative ordering normally starts from ''1'' and continues to ''N'', where ''N'' represents the highest positioned child entity. However, if the physical entities (e.g. slots) are labeled from a starting position of zero, then the first sibling should be associated with a entPhysicalParentRelPos value of ''0''. Note that this ordering may be sparse or dense, depending on agent implementation.  The actual values returned are not globally meaningful, as each ''parent'' component may use different numbering algorithms. The ordering is only meaningful among siblings of the same parent component.      The agent should retain parent-relative position values across reboots, either through algorithmic assignment or use of non-volatile storage.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5423, '.1.3.6.1.2.1.47.1.1.1.1.7', 'entPhysicalName', 5416, 'current', NULL, 'The textual name of the physical entity. The value of this object should be the name of the component as assigned by the local device and should be suitable for use in commands entered at the device''s `console''. This might be a text name, such as `console'' or a simple component number (e.g. port or module number), such as `1'', depending on the physical component naming syntax of the device.  If there is no local name, or this object is otherwise not applicable, then this object contains a zero-length string.  Note that the value of entPhysicalName for two physical entities will be the same in the event that the console interface does not distinguish between them, e.g., slot-1 and the card in slot-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5424, '.1.3.6.1.2.1.47.1.2.1', 'entLogicalTable', 5412, 'current', NULL, 'This table contains one row per logical entity. At least one entry must exist.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5425, '.1.3.6.1.2.1.47.1.2.1.1', 'entLogicalEntry', 5424, 'current', NULL, 'Information about a particular logical entity. Entities may be managed by this agent or other SNMP agents (possibly) in the same chassis.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5426, '.1.3.6.1.2.1.47.1.2.1.1.1', 'entLogicalIndex', 5425, 'current', NULL, 'The value of this object uniquely identifies the logical entity. The value is a small positive integer; index values for different logical entities are are not necessarily contiguous.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5427, '.1.3.6.1.2.1.47.1.2.1.1.2', 'entLogicalDescr', 5425, 'current', NULL, 'A textual description of the logical entity. This object should contain a string which identifies the manufacturer''s name for the logical entity, and should be set to a distinct value for each version of the logical entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5428, '.1.3.6.1.2.1.47.1.2.1.1.3', 'entLogicalType', 5425, 'current', NULL, 'An indication of the type of logical entity. This will typically be the OBJECT IDENTIFIER name of the node in the SMI''s naming hierarchy which represents the major MIB module, or the majority of the MIB modules, supported by the logical entity. For example: a logical entity of a regular host/router -> mib-2 a logical entity of a 802.1d bridge -> dot1dBridge a logical entity of a 802.3 repeater -> snmpDot3RptrMgmt If an appropriate node in the SMI''s naming hierarchy cannot be identified, the value ''mib-2'' should be used.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5391, '.1.3.6.1.4.1.9.9.703.3.1.1', 'cfmeRtpSsrcMismatch', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the condition that arises when a flow monitor detects a RTP SSRC mismatch for a traffic flow during the last measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5392, '.1.3.6.1.4.1.9.9.703.3.1.2', 'cfmeRtpCumulativeLostPkts', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the cumulative number of lost RTP data packets for a traffic flow (cfmRtpMetricsLostPkts).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5393, '.1.3.6.1.4.1.9.9.703.3.1.3', 'cfmeRtpCumulativeLossFraction', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the cumulative RTP loss fraction for a traffic flow (cfmRtpMetricsFrac).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5394, '.1.3.6.1.4.1.9.9.703.3.1.4', 'cfmeRtpCumulativeLossIntervals', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the cumulative number of RTP loss intervals for a traffic flow (cfmRtpMetricsLIs).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5429, '.1.3.6.1.2.1.47.1.2.1.1.4', 'entLogicalCommunity', 5425, 'current', NULL, 'An SNMPv1 or SNMPv2C community-string which can be used to access detailed management information for this logical entity. The agent should allow read access with this community string (to an appropriate subset of all managed objects) and may also choose to return a community string based on the privileges of the request used to read this object. Note that an agent may choose to return a community string with read-only privileges, even if this object is accessed with a read-write community string. However, the agent must take care not to return a community string which allows more privileges than the community string used to access this object.  A compliant SNMP agent may wish to conserve naming scopes by representing multiple logical entities in a single ''main'' naming scope. This is possible when the logical entities represented by the same value of entLogicalCommunity have no object instances in common. For example, ''bridge1'' and ''repeater1'' may be part of the main naming scope, but at least one additional community string is needed to represent ''bridge2'' and ''repeater2''.  Logical entities ''bridge1'' and ''repeater1'' would be represented by sysOREntries associated with the ''main'' naming scope.  For agents not accessible via SNMPv1 or SNMPv2C, the value of this object is the empty-string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5443, '.1.3.6.1.2.1.47.2', 'entityMIBTraps', 5409, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5444, '.1.3.6.1.2.1.47.2.0', 'entityMIBTrapPrefix', 5443, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5583, '.1.3.6.1.4.1.9.9.168.1.3.2.1.2', 'cntpFilterPeersOffset', 5581, 'current', NULL, 'The offset of the peer clock relative to the local clock in seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5368, '.1.3.6.1.4.1.9.9.703.1.1.1.1.13', 'cfmRtpMetricsJitterPrecision', 5355, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmRtpMetricsJitter.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5369, '.1.3.6.1.4.1.9.9.703.1.1.1.1.14', 'cfmRtpMetricsJitter', 5355, 'current', NULL, 'This object indicates the inter-arrival jitter for the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5370, '.1.3.6.1.4.1.9.9.703.1.1.2', 'cfmRtpMetricsTableChanged', 5353, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device created/destroyed a row in the cfmRtpMetricsTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5371, '.1.3.6.1.4.1.9.9.703.1.1.3', 'cfmRtpMetricsIntTable', 5353, 'current', NULL, 'This table contains historic RTP metrics for the traffic flows monitored by each of the flow monitors supported by the device.  This table has an sparse dependent relationship on the cfmFlowMetricsIntTable (defined by the CISCO-FLOW-MONITOR-MIB), containing a row for each row in the cfmFlowMetricsIntTable having a corresponding instance of cfmFlowMetricsCollected with the ''rtp'' bit set to one.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5372, '.1.3.6.1.4.1.9.9.703.1.1.3.1', 'cfmRtpMetricsIntEntry', 5371, 'current', NULL, 'An entry describes RTP metrics collected for a previous measurement interval for a corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5373, '.1.3.6.1.4.1.9.9.703.1.1.3.1.1', 'cfmRtpMetricsIntValid', 5372, 'current', NULL, 'This object indicates which metrics are valid for the measurement interval:  ''expectedPkts'' If this bit is set to ''1'', then the corresponding instance of cfmRtpMetricsIntExpectedPkts is valid.  ''lostPkts'' If this bit is set to ''1'', then the corresponding instance of cfmRtpMetricsIntLostPkts is valid.  ''lossFraction'' If this bit is set to ''1'', then the corresponding instances of cfmRtpMetricsIntFracScale, cfmRtpMetricsIntFracPrecision, and cfmRtpMetricsIntFrac are valid.  ''lossIntervals'' If this bit is set to ''1'', then the corresponding instance of cfmRtpMetricsIntLIs is valid.  ''avgLossDuration'' If this bit is set to ''1'', then the corresponding instances of cfmRtpMetricsIntAvgLDScale, cfmRtpMetricsIntAvgLDPrecision, and cfmRtpMetricsIntAvgLD are valid.  ''avgLossDistance'' If this bit is set to ''1'', then the corresponding instance of cfmRtpMetricsIntAvgLossDistance is valid.  ''maxJitter'' If this bit is set to ''1'', then the corresponding instances of cfmRtpMetricsIntJitterScale, cfmRtpMetricsIntJitterPrecision, and cfmRtpMetricsIntJitter are valid.  ''maxMinTransit'' If this bit is set to ''1'', then the corresponding instances of cfmRtpMetricsIntTransitScale, cfmRtpMetricsIntTransitPrecision, and cfmRtpMetricsIntTransit are valid.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5374, '.1.3.6.1.4.1.9.9.703.1.1.3.1.2', 'cfmRtpMetricsIntExpectedPkts', 5372, 'current', NULL, 'This object indicates the number of RTP packets expected for the traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5375, '.1.3.6.1.4.1.9.9.703.1.1.3.1.3', 'cfmRtpMetricsIntLostPkts', 5372, 'current', NULL, 'This object indicates the number of RTP packets lost for the traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5376, '.1.3.6.1.4.1.9.9.703.1.1.3.1.4', 'cfmRtpMetricsIntFracScale', 5372, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmRtpMetricsIntFrac.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5377, '.1.3.6.1.4.1.9.9.703.1.1.3.1.5', 'cfmRtpMetricsIntFracPrecision', 5372, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmRtpmetricsIntFrac.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5378, '.1.3.6.1.4.1.9.9.703.1.1.3.1.6', 'cfmRtpMetricsIntFrac', 5372, 'current', NULL, 'This object indicates the loss fraction for traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5379, '.1.3.6.1.4.1.9.9.703.1.1.3.1.7', 'cfmRtpMetricsIntLIs', 5372, 'current', NULL, 'This object indicates the number of loss intervals for the traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5380, '.1.3.6.1.4.1.9.9.703.1.1.3.1.8', 'cfmRtpMetricsIntAvgLDScale', 5372, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmRtpMetricsIntAvgLD.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5381, '.1.3.6.1.4.1.9.9.703.1.1.3.1.9', 'cfmRtpMetricsIntAvgLDPrecision', 5372, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmRtpMetricsIntAvgLD.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5382, '.1.3.6.1.4.1.9.9.703.1.1.3.1.10', 'cfmRtpMetricsIntAvgLD', 5372, 'current', NULL, 'This object indicates the average loss duration for the traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5383, '.1.3.6.1.4.1.9.9.703.1.1.3.1.11', 'cfmRtpMetricsIntAvgLossDistance', 5372, 'current', NULL, 'This object indicates the average loss distance for the traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5384, '.1.3.6.1.4.1.9.9.703.1.1.3.1.12', 'cfmRtpMetricsIntJitterScale', 5372, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmRtpMetricsIntJitter.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5385, '.1.3.6.1.4.1.9.9.703.1.1.3.1.13', 'cfmRtpMetricsIntJitterPrecision', 5372, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmRtpMetricsIntJitter.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5386, '.1.3.6.1.4.1.9.9.703.1.1.3.1.14', 'cfmRtpMetricsIntJitter', 5372, 'current', NULL, 'This object indicates the maximum inter-arrival jitter for the traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5387, '.1.3.6.1.4.1.9.9.703.1.1.3.1.15', 'cfmRtpMetricsIntTransitScale', 5372, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmRtpMetricsIntTransit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5388, '.1.3.6.1.4.1.9.9.703.1.1.3.1.16', 'cfmRtpMetricsIntTransitPrecision', 5372, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmRtpMetricsIntTransit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5389, '.1.3.6.1.4.1.9.9.703.1.1.3.1.17', 'cfmRtpMetricsIntTransit', 5372, 'current', NULL, 'This object indicates the max-min transit time for the traffic flow during the measurement interval. The max-min transit is the difference between the maximum and minimum transit times observed for RTP data packets during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5390, '.1.3.6.1.4.1.9.9.703.3.1', 'cfmRtpMonitoredElements', 5352, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5362, '.1.3.6.1.4.1.9.9.703.1.1.1.1.7', 'cfmRtpMetricsLIs', 5355, 'current', NULL, 'This object indicates the number of loss intervals for the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5396, '.1.3.6.1.4.1.9.9.703.3.1.6', 'cfmeRtpCumulativeAvgLossDistance', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the average RTP loss distance for a traffic flow (cfmRtpMetricsAvgLossDistance).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5397, '.1.3.6.1.4.1.9.9.703.3.1.7', 'cfmeRtpCumulativeJitter', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the average inter-arrival jitter of RTP data packets for a traffic flow (cfmRtpMetricsJitter).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5335, '.1.3.6.1.4.1.9.9.697.1.1.3.1.10', 'cfmIpCbrMetricsIntMrvScale', 5325, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmIpCbrMetricsIntMrv.  The value of this column is valid if and only if the ''mediaRateVariation'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5336, '.1.3.6.1.4.1.9.9.697.1.1.3.1.11', 'cfmIpCbrMetricsIntMrvPrecision', 5325, 'current', NULL, 'This object indicates the precision for for the corresponding instance of cfmIpCbrMetricsIntMrv.  The value of this column is valid if and only if the ''mediaRateVariation'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5337, '.1.3.6.1.4.1.9.9.697.1.1.3.1.12', 'cfmIpCbrMetricsIntMrv', 5325, 'current', NULL, 'This object indicates the MRV for the traffic flow during the measurement interval.  The value of this column is valid if and only if the ''mediaRateVariation'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5338, '.1.3.6.1.4.1.9.9.697.3.1', 'cfmIpCbrMonitoredElements', 5310, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5339, '.1.3.6.1.4.1.9.9.697.3.1.1', 'cfmeIpCbrCumulativeLostPkts', 5338, 'current', 'The cfmConditionMonitoredElement defined in CISCO-FLOW-MONITOR-MIB.', 'This object identifier represents the monitored element describing the cumulative number of lost packets for a traffic flow (cfmIpCbrMetricsLostPkts). This obect identifier can be used as a value for cfmConditionMonitoredElement.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5340, '.1.3.6.1.4.1.9.9.697.3.1.2', 'cfmeIpCbrCumulativeMrv', 5338, 'current', 'The cfmConditionMonitoredElement defined in CISCO-FLOW-MONITOR-MIB.', 'This object identifier represents the monitored element describing the cumulative MRV for a traffic flow (cfmIpCbrMetricsMrv). This obect identifier can be used as a value for cfmConditionMonitoredElement.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5341, '.1.3.6.1.4.1.9.9.697.3.1.3', 'cfmeIpCbrLostPkts', 5338, 'current', 'The cfmConditionMonitoredElement defined in CISCO-FLOW-MONITOR-MIB.', 'This object identifier represents the monitored element describing the number of packets lost for a traffic flow during the last measurement interval (cfmIpCbrMetricsIntLostPkts). This obect identifier can be used as a value for cfmConditionMonitoredElement.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5342, '.1.3.6.1.4.1.9.9.697.3.1.4', 'cfmeIpCbrDf', 5338, 'current', 'The cfmConditionMonitoredElement defined in CISCO-FLOW-MONITOR-MIB.', 'This object identifier represents the monitored element describing the DF for a traffic flow during the last measurement interval (cfmIpCbrMetricsIntDf). This obect identifier can be used as a value for cfmConditionMonitoredElement.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5343, '.1.3.6.1.4.1.9.9.697.3.1.5', 'cfmeIpCbrMrv', 5338, 'current', 'The cfmConditionMonitoredElement defined in CISCO-FLOW-MONITOR-MIB.', 'This object identifier represents the monitored element describing the MRV for a traffic flow during the last measurement interval (cfmIpCbrMetricsIntMrv). This obect identifier can be used as a value for cfmConditionMonitoredElement.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5344, '.1.3.6.1.4.1.9.9.697.2.1', 'ciscoIpCbrMetricsMIBCompliances', 5309, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5345, '.1.3.6.1.4.1.9.9.697.2.2', 'ciscoIpCbrMetricsMIBGroups', 5309, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5346, '.1.3.6.1.4.1.9.9.697.2.1.1', 'ciscoIpCbrMetricsCompliance01', 5344, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5347, '.1.3.6.1.4.1.9.9.697.2.2.1', 'cfmIpCbrMetricsGroup', 5345, 'current', NULL, 'This group contains objects that describe IP CBR metrics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5348, '.1.3.6.1.4.1.9.9.703', 'ciscoRtpMetricsMIB', 272, 'current', NULL, 'This MIB module defines objects that describe the quality metrics of RTP streams, similar to those described by an RTCP Receiver Report packet [RFC3550].  GLOSSARY ============  Expected Packets - this value is formally defined as the extended last sequence number received less the initial sequence number received.  An extended last sequence number is a 32-bit value, where the most significant 16-bit word indicates the number of sequence number cycles, and the least significant 16-bit word indicates the highest sequence number received.  Flow Monitor - a hardware or software entity that classifies traffic flows, collects flow data, and periodically computes flow metrics.  Flow Metric - a measurement that reflects the quality of a traffic flow.  Inter-Arrival Jitter - an estimate of the statistical variance of the RTP data packet inter-arrival time.  The inter-arrival jitter, J, is formally defined to be the mean deviation (smoothed absolute value) of the difference, D, in packet spacing at the flow monitor compared to the sender for a pair of packets. This is equivalent to the difference in the relative transit time for two packets; the relative transit time is the difference between a packet''s RTP timestamp and the device''s clock at the time of arrival (measured in the same units):  D(i,j) = (Rj - Ri) - (Sj - Si) = (Rj - Sj) - (Ri - Si)  where Si is the RTP timestamp from packet i, and Ri is the time of arrival in RTP timestamp units for packet i.  The inter-arrival jitter SHOULD be calculated continuously for each RTP data packet received from source SSRCn, using this equation to compute difference for each packet and the previous packet (in order of arrival, not necessarily in sequence).  |D(i-1,i)| - J(i-1) J(i) = J(i-1) + --------------- 16  Measurement Interval - the length of time over which a flow monitor collects data related to a traffic flow, after which the flow monitor computes flow metrics using the collected data.  Loss Distance - the difference between the sequence numbers delimiting the start of two consecutive loss intervals.  Consider the following sequence of RTP data packets:  111111 111222 2233 33333 444 444 5 123456x890123xxxx8901xxx56789x123xx678x0  ^ ^ ^ ^ ^ ^ | | | | | | LI1 LI2 LI3 LI4 LI5 LI6  Loss Interval | Loss Distance ===============+=============== 1 | 2 | 7 3 | 8 4 | 8 5 | 4 6 | 5  Loss Fraction - the fraction of RTP data packets from source SSRCn lost during a measurement interval, expressed as a fixed-point number:  Li Fi = Ei  where Fi is the loss fraction for measurement interval i, Li is the lost packets during measurement interval i, and Ei is the expected packets during measurement interval i.  Observe that the number of packets lost includes packets that are late or duplicates, and hence this number can can have a theoretical theoretical value between negative infinity and one.  The cumulative loss fraction is the fraction of RTP data packets from source SSRCn lost over the duration monitoring the flow:  n sum [Li] i=1 Fn = ------ n sum [Ei] i=1  where Fn is the cumulative loss fraction over n measurement intervals.  Loss Interval - an interval in which consecutive packet losses were experienced.  Consider the following sequence of RTP data packets:  111111 111222 2233 33333 444 444 5 123456x890123xxxx8901xxx56789x123xx678x0  ^ ^ ^ ^ ^ ^ | | | | | | LI1 LI2 LI3 LI4 LI5 LI6  LI1 through LI6 indicate the start of loss intervals observed in this sequence.  Loss Interval Duration - the number of packets lost in a loss interval.  Consider the following sequence of RTP data packets:  111111 111222 2233 33333 444 444 5 123456x890123xxxx8901xxx56789x123xx678x0  ^ ^ ^ ^ ^ ^ | | | | | | LI1 LI2 LI3 LI4 LI5 LI6  Loss Interval | Duration ===============+========== 1 | 1 2 | 4 3 | 3 4 | 1 5 | 2 6 | 1  Lost Packets - this value is formally defined as the number of packets expected less the number of packets actually received, where the number of packets received includes those which are late or duplicates.  SSRCn - the SSRC identifier of the source.  Traffic Flow - a unidirectional stream of packets conforming to a classifier. For example, packets having a particular source IP address, destination IP address, protocol type, source port number, and destination port number.  Transit Time - the latency from the insertion into the network to the flow monitor. This value can be computed by taking the difference between a packet''s RTP timestamp and the device''s clock at the time of arrival (measured in the same units).  REFERENCES ==============  [RFC3550] H. Schlzrinne, S. Casner, R. Frederick, V. Jacobson, ''RTP: A Transport Protocol for Real-Time Applications'', RFC-3550, July 2003.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5349, '.1.3.6.1.4.1.9.9.703.0', 'ciscoRtpMetricsMIBNotifs', 5348, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5350, '.1.3.6.1.4.1.9.9.703.1', 'ciscoRtpMetricsMIBObjects', 5348, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5351, '.1.3.6.1.4.1.9.9.703.2', 'ciscoRtpMetricsMIBConform', 5348, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5352, '.1.3.6.1.4.1.9.9.703.3', 'ciscoRtpMetricsMIBIds', 5348, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5353, '.1.3.6.1.4.1.9.9.703.1.1', 'cfmRtpMetrics', 5350, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5354, '.1.3.6.1.4.1.9.9.703.1.1.1', 'cfmRtpMetricsTable', 5353, 'current', NULL, 'This table contains aggregate data maintained by a flow monitor for traffic flows for which it is computing RTP metrics.  This table has an sparse dependent relationship on the cfmFlowMetricsTable (defined by the CISCO-FLOW-MONITOR-MIB), containing a row for each row in the cfmFlowMetricsTable having a corresponding instance of cfmFlowMetricsCollected with the ''rtp'' bit set to one.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5355, '.1.3.6.1.4.1.9.9.703.1.1.1.1', 'cfmRtpMetricsEntry', 5354, 'current', NULL, 'An entry describes cumulative and aggregate RTP metrics for a single traffic flow.  The devices creates a row in the cfmRtpMetricsTable when a flow monitor starts monitoring a traffic flow and has been configured to compute RTP metrics for the same traffic flow. Likewise, the device destroys a row in the cfmRtpMetricsTable when the corresponding flow monitor has ceased monitoring the traffic flow (e.g., when a traffic flow has timed out).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5356, '.1.3.6.1.4.1.9.9.703.1.1.1.1.1', 'cfmRtpMetricsValid', 5355, 'current', NULL, 'This object indicates which metrics are valid for the traffic flow:  ''expectedPkts'' If this bit is set to ''1'', then the corresponding instance of cfmRtpMetricsExpectedPkts is valid.  ''lostPkts'' If this bit is set to ''1'', then the corresponding instance of cfmRtpMetricsLostPkts is valid.  ''lossFraction'' If this bit is set to ''1'', then the corresponding instances of cfmRtpMetricsFracScale, cfmRtpMetricsFracPrecision, and cfmRtpMetricsFrac are valid.  ''lossIntervals'' If this bit is set to ''1'', then the corresponding instance of cfmRtpMetricsLIs is valid.  ''avgLossIntervalDuration'' If this bit is set to ''1'', then the corresponding instances of cfmRtpMetricsAvgLDScale, cfmRtpMetricsAvgLDPrecision, and cfmRtpMetricsAvgLD are valid.  ''avgLossDistance'' If this bit is set to ''1'', then the corresponding instance of cfmRtpMetricsAvgLossDistance is valid.  ''jitter'' If this bit is set to ''1'', then the corresponding instances of cfmRtpMetricsJitterScale, cfmRtpMetricsJitterPrecision, and cfmRtpMetricsJitter are valid.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5357, '.1.3.6.1.4.1.9.9.703.1.1.1.1.2', 'cfmRtpMetricsExpectedPkts', 5355, 'current', NULL, 'This object indicates the number of RTP packets expected for the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5358, '.1.3.6.1.4.1.9.9.703.1.1.1.1.3', 'cfmRtpMetricsLostPkts', 5355, 'current', NULL, 'This object indicates the number of RTP packets lost for the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5359, '.1.3.6.1.4.1.9.9.703.1.1.1.1.4', 'cfmRtpMetricsFracScale', 5355, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmRtpMetricsFrac.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5360, '.1.3.6.1.4.1.9.9.703.1.1.1.1.5', 'cfmRtpMetricsFracPrecision', 5355, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmRtpmetricsFrac.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5361, '.1.3.6.1.4.1.9.9.703.1.1.1.1.6', 'cfmRtpMetricsFrac', 5355, 'current', NULL, 'This object indicates the loss fraction for traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5363, '.1.3.6.1.4.1.9.9.703.1.1.1.1.8', 'cfmRtpMetricsAvgLDScale', 5355, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmRtpMetricsAvgLD.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6716, '.1.3.6.1.4.1.9.2.2.1.1.27', 'locIfOutputQueueDrops', 6689, 'mandatory', NULL, 'The number of packets dropped because the output queue was full.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5364, '.1.3.6.1.4.1.9.9.703.1.1.1.1.9', 'cfmRtpMetricsAvgLDPrecision', 5355, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmRtpMetricsAvgLD.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5365, '.1.3.6.1.4.1.9.9.703.1.1.1.1.10', 'cfmRtpMetricsAvgLD', 5355, 'current', NULL, 'This object indicates the average loss duration for the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5414, '.1.3.6.1.2.1.47.1.4', 'entityGeneral', 5410, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5313, '.1.3.6.1.4.1.9.9.697.1.1.1.1', 'cfmIpCbrMetricsEntry', 5312, 'current', NULL, 'An entry describes cumulative and aggregate IP CBR metrics for a single traffic flow.  The devices creates a row in the cfmIpCbrMetricsTable when a flow monitor starts monitoring a traffic flow and has been configured to compute IP CBR metrics for the same traffic flow. Likewise, the device destroys a row in the cfmIpCbrMetricsMetricsTable when the corresponding flow monitor has ceased monitoring the traffic flow (e.g., when a traffic flow has timed out).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5314, '.1.3.6.1.4.1.9.9.697.1.1.1.1.1', 'cfmIpCbrMetricsCfgRateType', 5313, 'current', NULL, 'This object indicates how the corresponding flow monitor computes the DF for the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5315, '.1.3.6.1.4.1.9.9.697.1.1.1.1.2', 'cfmIpCbrMetricsCfgBitRate', 5313, 'current', NULL, 'This object indicates the units for the corresponding instance of cfmIpCbrMetricsCfgRate. The value of this column only has relevance if the corresponding instance of cfmIpCbrMetricsCfgRateType is ''ipBitRate'' or ''mediaRate''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5316, '.1.3.6.1.4.1.9.9.697.1.1.1.1.3', 'cfmIpCbrMetricsCfgRate', 5313, 'current', NULL, 'This object indicates the configured bit rate used by the flow monitor to compute the DF for the traffic flow. The value of this column only has relevance if the corresponding instance of cfmIpCbrMetricsCfgRateType is ''ipBitRate'' or ''mediaRate''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5317, '.1.3.6.1.4.1.9.9.697.1.1.1.1.4', 'cfmIpCbrMetricsCfgMediaPktSize', 5313, 'current', NULL, 'This object indicates the configured media packet size used by the flow monitor to compute the DF for the traffic flow. The value of this column only has relevance if the corresponding instance of cfmIpCbrMetricsCfgRateType is ''mediaRate''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5318, '.1.3.6.1.4.1.9.9.697.1.1.1.1.5', 'cfmIpCbrMetricsValid', 5313, 'current', NULL, 'This object indicates which metrics are valid for the traffic flow:  ''lostPkts'' If this bit is set to ''1'', then the corresponding instance of cfmIpCbrMetricsLostPkts is valid.  ''mediaRateVariation'' If this bit is set to ''1'', then the corresponding instances of cfmIpCbrMetricsMlrScale, cfmIpCbrMetricsMlrPrecision, and cfmIpCbrMetricsMlr are valid.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5319, '.1.3.6.1.4.1.9.9.697.1.1.1.1.6', 'cfmIpCbrMetricsLostPkts', 5313, 'current', NULL, 'This object indicates the number of packets lost for the traffic flow.  The value of this column is valid if and only if the ''lostPkts'' bit in the corresponding instance of cfmMdiMetricsValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5320, '.1.3.6.1.4.1.9.9.697.1.1.1.1.7', 'cfmIpCbrMetricsMrvScale', 5313, 'current', NULL, 'This object indicates the scale factor for the corresponding instance of cfmIpCbrMetricsMrv.  The value of this column is valid if and only if the ''mediaRateVariation'' bit in the corresponding instance of cfmMdiMetricsValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5321, '.1.3.6.1.4.1.9.9.697.1.1.1.1.8', 'cfmIpCbrMetricsMrvPrecision', 5313, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmIpCbrMetricsMrv.  The value of this column is valid if and only if the ''mediaRateVariation'' bit in the corresponding instance of cfmMdiMetricsValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5322, '.1.3.6.1.4.1.9.9.697.1.1.1.1.9', 'cfmIpCbrMetricsMrv', 5313, 'current', NULL, 'This object indicates the MRV for the traffic flow since the flow monitor started collecting data for the traffic flow.  The value of this column is valid if and only if the ''mediaRateVariation'' bit in the corresponding instance of cfmMdiMetricsValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5323, '.1.3.6.1.4.1.9.9.697.1.1.2', 'cfmIpCbrMetricsTableChanged', 5311, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device created/destroyed a row in the cfmIpCbrMetricsTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5324, '.1.3.6.1.4.1.9.9.697.1.1.3', 'cfmIpCbrMetricsIntTable', 5311, 'current', NULL, 'This table contains historic IP CBR metrics for the traffic flows monitored by each of the flow monitors supported by the device.  This table has an sparse dependent relationship on the cfmFlowMetricsIntTable (defined by the CISCO-FLOW-MONITOR-MIB), containing a row for each row in the cfmFlowMetricsIntTable having a corresponding instance of cfmFlowMetricsCollected with the ''ipCbr'' bit set to one.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5325, '.1.3.6.1.4.1.9.9.697.1.1.3.1', 'cfmIpCbrMetricsIntEntry', 5324, 'current', NULL, 'An entry describes IP CBR metrics collected for a previous measurement interval for a corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5326, '.1.3.6.1.4.1.9.9.697.1.1.3.1.1', 'cfmIpCbrMetricsIntValid', 5325, 'current', NULL, 'This object indicates which metrics are valid for the measurement interval:  ''lostPkts'' If this bit is set to ''1'', then the corresponding instance of cfmIpCbrMetricsIntLostPkts is valid.  ''vbMin'' If this bit is set to ''1'', then the corresponding instance of cfmIpCbrMetricsIntVbMin is valid.  ''vbMax'' If this bit is set to ''1'', then the corresponding instance of cfmIpCbrMetricsIntVbMax is valid.  ''mediaRate'' If this bit is set to ''1'', then the corresponding instances of cfmIpCbrMetricsIntMrUnits and cfmIpCbrMetricsIntMr are valid.  ''delayFactor'' If this bit is set to ''1'', then the corresponding instances of cfmIpCbrMetricsIntDfScale, cfmIpCbrMetricsIntDfPrecision, and cfmIpCbrMetricsIntDf are valid.  ''mediaRateVariation'' If this bit is set to ''1'', then the corresponding instances of cfmIpCbrMetricsIntMrvScale, cfmIpCbrMetricsIntMrvPrecision, and cfmIpCbrMetricsIntMrv are valid.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5327, '.1.3.6.1.4.1.9.9.697.1.1.3.1.2', 'cfmIpCbrMetricsIntLostPkts', 5325, 'current', NULL, 'This object indicates the number of lost packets for the traffic flow during the measurement interval.  The value of this column is valid if and only if the ''lostPkts'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5328, '.1.3.6.1.4.1.9.9.697.1.1.3.1.3', 'cfmIpCbrMetricsIntVbMin', 5325, 'current', NULL, 'This object indicates the minimum virtual buffer size computed for the traffic flow over the course of the measurement interval.  The value of this column is valid if and only if the ''vbMin'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5329, '.1.3.6.1.4.1.9.9.697.1.1.3.1.4', 'cfmIpCbrMetricsIntVbMax', 5325, 'current', NULL, 'This object indicates the maximum virtual buffer size computed for the traffic flow over the course of the measurement interval.  The value of this column is valid if and only if the ''vbMax'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5330, '.1.3.6.1.4.1.9.9.697.1.1.3.1.5', 'cfmIpCbrMetricsIntMrUnits', 5325, 'current', NULL, 'This object indicates the units for the corresponding instance of cfmIpCbrMetricsMr.  The value of this column is valid if and only if the ''mediaRate'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5273, '.1.3.6.1.4.1.9.9.692.1.6.2', 'cfmAlarmHistoryLastId', 5271, 'current', NULL, 'This object indicates the value of cfmAlarmHistoryId corresponding to the last row created in the cfmAlarmHistoryTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5274, '.1.3.6.1.4.1.9.9.692.1.6.3', 'cfmAlarmHistoryTable', 5271, 'current', NULL, 'This table lists a history of the changes in the state of alarm conditions monitored by the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1959, '.1.3.6.1.2.1.17.1.4.1.2', 'dot1dBasePortIfIndex', 1957, 'current', NULL, 'The value of the instance of the ifIndex object, defined in IF-MIB, for the interface corresponding to this port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5331, '.1.3.6.1.4.1.9.9.697.1.1.3.1.6', 'cfmIpCbrMetricsIntMr', 5325, 'current', NULL, 'This object indicates the media rate used by the flow monitor to compute the DF for the traffic flow. If the corresponding instance of cfmIpCbrMetricsCfgRateType is ''auto'', then the value of this column indicates the MR for the traffic flow during the measurement interval. Otherwise, the value of this column reflects the configured MR.  The value of this column is valid if and only if the ''mediaRate'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5332, '.1.3.6.1.4.1.9.9.697.1.1.3.1.7', 'cfmIpCbrMetricsIntDfScale', 5325, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmIpCbrMetricsIntDf.  The value of this column is valid if and only if the ''delayFactor'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5412, '.1.3.6.1.2.1.47.1.2', 'entityLogical', 5410, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5413, '.1.3.6.1.2.1.47.1.3', 'entityMapping', 5410, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5282, '.1.3.6.1.4.1.9.9.692.1.6.3.1.7', 'cfmAlarmHistoryTime', 5275, 'current', NULL, 'This object indicates the value of sysUpTime when the alarm condition changed state.  In the case the device updates standing/alarm conditions at the same time it captures a measurement interval, the value of this column should correlate with the corresponding value of cfmFlowMetricsIntTime. This assures that the EMS/NMS can easily correlate alarms with the metrics captured in the course of a measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5283, '.1.3.6.1.4.1.9.9.692.1.7', 'cfmNotify', 5126, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5284, '.1.3.6.1.4.1.9.9.692.1.7.1', 'cfmNotifyEnable', 5283, 'current', NULL, 'This object specifies whether the device generates a cfmNotifyAlarm notification when an alarm condition changes state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5285, '.1.3.6.1.4.1.9.9.692.0.1', 'cfmNotifyAlarm', 5125, 'current', NULL, 'The device generates this notification when an alarm condition has changed state and the value of cfmNOtifyEnable is ''true''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5286, '.1.3.6.1.4.1.9.9.692.3.1', 'cfmMonitoredElements', 5128, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5287, '.1.3.6.1.4.1.9.9.692.3.1.1', 'cfmeOther', 5286, 'current', NULL, 'This object identifier represents a monitored element not recognized by this implementation of the MIB module.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5288, '.1.3.6.1.4.1.9.9.692.3.1.2', 'cfmeFlowCount', 5286, 'current', NULL, 'This object identifier represents the monitored element describing the number of traffic flows currently monitored by a flow monitor (cfmFlowMonitorFlowCount).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5289, '.1.3.6.1.4.1.9.9.692.3.1.3', 'cfmeFlowTimeouts', 5286, 'current', NULL, 'This object identifier represents the monitored element describing the number of traffic flows that expired during the last measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5290, '.1.3.6.1.4.1.9.9.692.3.1.4', 'cfmeFlowStop', 5286, 'current', NULL, 'This object identifier represents the monitored element describing the condition that arises when a flow monitor does not receive any packets for a traffic flow during the last measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5291, '.1.3.6.1.4.1.9.9.692.3.1.5', 'cfmeFlowCumulativeBitRate', 5286, 'current', NULL, 'This object identifier represents the monitored element describing the average rate at which a flow monitor processes bits contained by packets for a traffic flow (cfmFlowMetricsBitRate).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5292, '.1.3.6.1.4.1.9.9.692.3.1.6', 'cfmeFlowCumulativePktRate', 5286, 'current', NULL, 'This object identifier represents the monitored element describing the average rate at which a flow monitor processes packets for a traffic flow (cfmFlowMetricsPktRate).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5293, '.1.3.6.1.4.1.9.9.692.3.1.7', 'cfmeFlowBitRate', 5286, 'current', NULL, 'This object identifier represents the monitored element describing the average rate at which a flow monitor processes bits contained by packets for a traffic flow during the last measurement interval (cfmFlowMetricsIntBitRate).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5294, '.1.3.6.1.4.1.9.9.692.3.1.8', 'cfmeFlowPktRate', 5286, 'current', NULL, 'This object identifier represents the monitored element describing the average rate at which a flow monitor processes packets for a traffic flow during the last measurement interval (cfmFlowMetricsIntPktRate).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5295, '.1.3.6.1.4.1.9.9.692.2.1', 'ciscoFlowMonitorMIBCompliances', 5127, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5296, '.1.3.6.1.4.1.9.9.692.2.2', 'ciscoFlowMonitorMIBGroups', 5127, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5297, '.1.3.6.1.4.1.9.9.692.2.1.1', 'ciscoFlowMonitorCompliance01', 5295, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5298, '.1.3.6.1.4.1.9.9.692.2.2.1', 'cfmFlowMonitorGroup', 5296, 'current', NULL, 'This group contains objects describing flow monitors.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5299, '.1.3.6.1.4.1.9.9.692.2.2.2', 'cfmFlowGroup', 5296, 'current', NULL, 'This group contains objects describing traffic flows.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5300, '.1.3.6.1.4.1.9.9.692.2.2.3', 'cfmFlowMetricsGroup', 5296, 'current', NULL, 'This group contains objects describing traffic flow metrics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5301, '.1.3.6.1.4.1.9.9.692.2.2.4', 'cfmFlowConditionsGroup', 5296, 'current', NULL, 'This group contains objects describing standing/alarm conditions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5302, '.1.3.6.1.4.1.9.9.692.2.2.5', 'cfmAlarmAggregationGroup', 5296, 'current', NULL, 'This group contains object describing alarm aggregation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5303, '.1.3.6.1.4.1.9.9.692.2.2.6', 'cfmAlarmHistoryGroup', 5296, 'current', NULL, 'This group contains objects describing alarm history.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5304, '.1.3.6.1.4.1.9.9.692.2.2.7', 'cfmNotifySupportGroup', 5296, 'current', NULL, 'This group contains objects supporting notification.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5305, '.1.3.6.1.4.1.9.9.692.2.2.8', 'cfmNotifyGroup', 5296, 'current', NULL, 'This group contains notifications supporting flow monitoring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5306, '.1.3.6.1.4.1.9.9.697', 'ciscoIpCbrMetricsMIB', 272, 'current', NULL, 'This MIB module defines objects that describe the a set of metrics used to measure the quality of a IP CBR traffic flow. An IP CBR traffic flow consists of a stream of IP datagrams sent from one application to another with a constant packet rate or bit rate.  GLOSSARY ============  CBR - Constant Bit Rate.  Delay Factor - the maximum observed value of the flow rate imbalance over a measurement interval.  DF - Delay Factor.  Flow Monitor - a hardware or software entity that classifies traffic flows, collects flow data, and periodically computes flow metrics.  Flow Metric - a measurement that reflects the quality of a traffic flow.  Measurement Interval - the length of time over which a flow monitor collects data related to a traffic flow, after which the flow monitor computes flow metrics using the collected data.  Media Rate - the effective bit rate of the media content carried by a traffic flow.  Media Rate Variation - a measure of loss (in bytes):  N RT - sum [Si] i=1 MRV = ----------- RT  where R is the nominal media rate, T is the measurement interval, Si is the size of packet[i] received during the measurement interval, and N is the number of media packets received during the measurement interval.  MR - Media Rate.  MRV - Media Rate Variation.  Traffic Flow - a unidirectional stream of packets conforming to a classifier. For example, packets having a particular source IP address, destination IP address, protocol type, source port number, and destination port number.  VB - Virtual Buffer.  Virtual Buffer - a virtual buffer is a construct used to simulate a real buffer used by a media application for the purpose of storing media packets until the the application can render their content.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5307, '.1.3.6.1.4.1.9.9.697.0', 'ciscoIpCbrMetricsMIBNotifs', 5306, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5308, '.1.3.6.1.4.1.9.9.697.1', 'ciscoIpCbrMetricsMIBObjects', 5306, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5309, '.1.3.6.1.4.1.9.9.697.2', 'ciscoIpCbrMetricsMIBConform', 5306, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5310, '.1.3.6.1.4.1.9.9.697.3', 'ciscoIpCbrMetricsMIBIds', 5306, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5312, '.1.3.6.1.4.1.9.9.697.1.1.1', 'cfmIpCbrMetricsTable', 5311, 'current', NULL, 'This table contains aggregate data maintained by a flow monitor for traffic flows for which it is computing IP CBR metrics.  This table has an sparse dependent relationship on the cfmFlowMetricsTable (defined by the CISCO-FLOW-MONITOR-MIB), containing a row for each row in the cfmFlowMetricsTable having a corresponding instance of cfmFlowMetricsCollected with the ''ipCbr'' bit set to one.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5333, '.1.3.6.1.4.1.9.9.697.1.1.3.1.8', 'cfmIpCbrMetricsIntDfPrecision', 5325, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmIpCbrMetricsIntDf.  The value of this column is valid if and only if the ''delayFactor'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5410, '.1.3.6.1.2.1.47.1', 'entityMIBObjects', 5409, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5411, '.1.3.6.1.2.1.47.1.1', 'entityPhysical', 5410, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5253, '.1.3.6.1.4.1.9.9.692.1.5.1.1', 'cfmAlarmGroupEntry', 5252, 'current', NULL, 'An entry describes an alarm group. An alarm group defines an alarm condition that is raised when a configured number of flows in a set of flows asserts a configured standing condition.  The figure below illustrates the relationship between an alarm group, a conditions profile, and a flow set.  +-------------------------------------+ | conditions profile 42 | | +---------------------------------+ | | | cfmConditionAlarm.42.9 = ''grouped'' |<---+ | | cfmConditionAlarmGroup.42.9 = 4 -+ | | | | +------------------------------|--+ |<--+ | | | | | | +--------------------------------|----+ | | | | | v | | +-------------------------------------+ | | | alarm group 4 | | | | | | | | cfmAlarmGroupConditionsProfile.4 = 42 --+ | | cfmAlarmGroupConditionId.4 = 9 ------------+ | cfmAlarmGroupFlowset.4 = 16 ---+ | | | | +--------------------------------|----+ | v +-------------------------------------+ | flow set 16 | | | | +--------------------------------+ | | | cfmAlarmGroupFlowId.16.100 | | | +--------------------------------+ | | +--------------------------------+ | | | cfmAlarmGroupFlowId.16.101 | | | +--------------------------------+ | | +--------------------------------+ | | | cfmAlarmGroupFlowId.16.102 | | | +--------------------------------+ | | : | | : | | +--------------------------------+ | | | cfmAlarmGroupFlowId.16.Y | | | +--------------------------------+ | +-------------------------------------+  A device creates a row in the cfmAlarmGroupTable when it configures a new alarm group. Likewise, the device destroys a row when the alarm group ceases to exist.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5254, '.1.3.6.1.4.1.9.9.692.1.5.1.1.1', 'cfmAlarmGroupId', 5253, 'current', NULL, 'This object indicates an arbitrary integer-value that uniquely identifies the alarm group. Observe that the value assigned to an alarm group does not necessarily persist across restarts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5255, '.1.3.6.1.4.1.9.9.692.1.5.1.1.2', 'cfmAlarmGroupDescr', 5253, 'current', NULL, 'This object indicates a human-readable description of the alarm group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5256, '.1.3.6.1.4.1.9.9.692.1.5.1.1.3', 'cfmAlarmGroupConditionsProfile', 5253, 'current', NULL, 'This object indicates the conditions profile that contains the description of the standing profile aggregated by the alarm group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5257, '.1.3.6.1.4.1.9.9.692.1.5.1.1.4', 'cfmAlarmGroupConditionId', 5253, 'current', NULL, 'This object indicates the standing condition aggregated by the alarm group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5258, '.1.3.6.1.4.1.9.9.692.1.5.1.1.5', 'cfmAlarmGroupFlowSet', 5253, 'current', NULL, 'This object indicates the set of traffic flows aggregated by the alarm group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5259, '.1.3.6.1.4.1.9.9.692.1.5.1.1.6', 'cfmAlarmGroupFlowCount', 5253, 'current', NULL, 'This object indicates the number of traffic flows in the set of traffic flows indicated by the corresponding instance of cfmAlarmGroupFlowSet.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5260, '.1.3.6.1.4.1.9.9.692.1.5.1.1.7', 'cfmAlarmGroupThresholdUnits', 5253, 'current', NULL, 'This object indicates the units for the corresponding instance of cfmAlarmGroupThreshold:  ''other'' The MIB implementation does not recognize the units in which the value of the corresponding instance of cfmAlarmGroupThreshold has been expressed.  ''flows'' The value of the corresponding instance of cfmAlarmGroupThreshold indicates a number of traffic flows.  ''percent'' The value of the corresponding instance of cfmAlarmGroupThreshold indicates a percentage of traffic flows.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5261, '.1.3.6.1.4.1.9.9.692.1.5.1.1.8', 'cfmAlarmGroupThreshold', 5253, 'current', NULL, 'This object indicates a number of flows that must assert the standing condition indicated by the corresponding instance of cfmAlarmGroupCondition before raising an alarm.  If the corresponding instance of cfmAlarmGroupThresholdUnits is ''percent'', then the value of this column must be greater than or equal to zero and less than or equal to ''100''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5262, '.1.3.6.1.4.1.9.9.692.1.5.1.1.9', 'cfmAlarmGroupRaised', 5253, 'current', NULL, 'This object indicates whether the alarm group has raised an alarm.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5263, '.1.3.6.1.4.1.9.9.692.1.5.1.1.10', 'cfmAlarmGroupCurrentCount', 5253, 'current', NULL, 'This object indicates the number of traffic flows currently asserting the standing condition aggregated by the alarm group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5264, '.1.3.6.1.4.1.9.9.692.1.5.2', 'cfmAlarmGroupTableChanged', 5251, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device made a change to the cfmAlarmGroupTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5265, '.1.3.6.1.4.1.9.9.692.1.5.3', 'cfmAlarmGroupFlowTable', 5251, 'current', NULL, 'This table lists the traffic flows contained by each set of flows configured for the alarm groups contained by the cfmAlarmGroupTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5266, '.1.3.6.1.4.1.9.9.692.1.5.3.1', 'cfmAlarmGroupFlowEntry', 5265, 'current', NULL, 'An entry describes a traffic flow contained by a set of flows.  An alarm group aggregates a standing condition from a set of flows. cfmAlarmFlowSetId uniquely identifies a set of traffic flows.  A device creates a row in the cfmAlarmGroupTable under one of the following circumstances:  - It has configured a new alarm group, and hence a new set of traffic flows.  - It has added a traffic flow to an existing set of flows.  Likewise, a device destroys a row under one of the following circumstances:  - It has destroyed the set of traffic flows.  - It has removed the traffic flow from an existing set of flows.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5267, '.1.3.6.1.4.1.9.9.692.1.5.3.1.1', 'cfmAlarmGroupFlowSetId', 5266, 'current', NULL, 'This object indicates an arbitrary integer-value that uniquely identifies the set of traffic flows that contains the traffic flow represented by the row. Observe that the value assigned to a flow set does not necessarily persist across restarts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5268, '.1.3.6.1.4.1.9.9.692.1.5.3.1.2', 'cfmAlarmGroupFlowMonitorId', 5266, 'current', NULL, 'This object identifies the flow monitor responsible for the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5269, '.1.3.6.1.4.1.9.9.692.1.5.3.1.3', 'cfmAlarmGroupFlowId', 5266, 'current', NULL, 'This object identifies the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5270, '.1.3.6.1.4.1.9.9.692.1.5.4', 'cfmAlarmGroupFlowTableChanged', 5251, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device made a change to the cfmAlarmGroupTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5271, '.1.3.6.1.4.1.9.9.692.1.6', 'cfmAlarmHistory', 5126, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5272, '.1.3.6.1.4.1.9.9.692.1.6.1', 'cfmAlarmHistorySize', 5271, 'current', NULL, 'This object specifies the maximum number of rows the cfmAlarmHistoryTable can contain at any given time. If the device raises or clears an alarm and the cfmAlarmHistoryTable already contains a number of rows equal to the value of this object, then it destroys the oldest row before creating a new one.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6717, '.1.3.6.1.4.1.9.2.2.1.1.28', 'locIfDescr', 6689, 'mandatory', NULL, 'User configurable interface description.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5275, '.1.3.6.1.4.1.9.9.692.1.6.3.1', 'cfmAlarmHistoryEntry', 5274, 'current', NULL, 'An entry describes the change in the state of an alarm condition observed by the device.  The device creates a row in the cfmAlarmHistoryTable when it observes a change in the state of an alarm condition.  The device destroys a row in the cfmAlarmHistoryTable when it needs to create a new row, but the number of rows contained by the cfmAlarmHistoryTable is equal to the value of cfmAlarmHistorySize.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5367, '.1.3.6.1.4.1.9.9.703.1.1.1.1.12', 'cfmRtpMetricsJitterScale', 5355, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmRtpMetricsJitter.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5237, '.1.3.6.1.4.1.9.9.692.1.4.1.1.5', 'cfmConditionType', 5232, 'current', NULL, 'This object indicates the type of condition:  ''other'' The implementation of the MIB does not recognize the condition described by this row.  ''boolean'' The value monitored only can have one of two values: ''false'' or ''true''. In this case, the condition itself evaluates to ''true'' if the value itself is ''true''.  ''risingThreshold'' The condition evaluates to ''true'' if the current sample of the monitored value is greater than the rising threshold and the last sample is less than or equal to the rising threshold.  ''fallingThreshold'' The condition evaluates to ''true'' if the current sample of the monitored value is less than the falling threshold and the last sample is greater than or equal to the falling threshold.  ''risingAndFallingThreshold'' The condition evaluates to ''true'' if one of the two criteria is satisfied:  1) The current sample of the monitored value is greater than the rising threshold and the last sample is less than or equal to the rising threhsold.  2) The current sample of the monitored value is less than the falling threshold and the last sample is greater than or equal to the falling threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6288, '.1.0.8802.1.1.2.1.3.6', 'lldpLocSysCapEnabled', 6248, 'current', 'IEEE 802.1AB-2005 9.5.8.2', 'The bitmap value used to identify which system capabilities are enabled on the local system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1943, '.1.3.6.1.4.1.9.9.688', 'ciscoFlowMonitorTcMIB', 272, 'current', NULL, 'This MIB module defines textual conventions used by the MIB modules defining objects describing flow monitoring.  GLOSSARY ============  Alarm Action - a method used by the device to signal changes in an alarm condition.  Alarm Aggregation - a technique used to efficiently monitor the same standing condition for a flow set.  Alarm Condition - a standing condition for which the device signals changes in state.  Alarm Group - a flow set for which the device monitors a configured standing condition, raising an alarm when a configured number of flows in the flow set assert the standing standing.  Alarm Severity - the relative disposition of an alarm condition when raised by the device. For example, a provider may regard a flow stop alarm as having a higher severity than a flow''s loss fraction exceeding a configured threshold.  Flow Monitor - a hardware or software entity that classifies traffic flows, collects flow data, and periodically computes flow metrics.  Flow Metric - a measurement that reflects the quality of a traffic flow.  Flow Point - represents the ingress or egress of a traffic flow.  Flow Set - a group of traffic flows.  Measurement Interval - the length of time over which a flow monitor collects data related to a traffic flow, after which the flow monitor computes flow metrics using the collected data.  Standing Condition - represents a lasting error, fault, or warning resulting from the application of a set of criteria to the state of an entity, such as a flow monitor or traffic flow. For example, a flow monitor may assert a standing condition if the number of traffic flows that expire in a meansurement interval exceeds a configured threshold.  Traffic Flow - a unidirectional stream of packets conforming to a classifier. For example, packets having a particular source IP address, destination IP address, protocol type, source port number, and destination port number.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1944, '.1.3.6.1.4.1.9.9.670', 'ciscoReportIntervalTcMIB', 272, 'current', NULL, 'This MIB module defines textual conventions used by MIB modules that define objects describing performance history data based on a configurable reporting interval.  Use of these textual conventions assumes the following:  - The SNMP entity supports performance history data collection based on a configurable interval.  - The SNMP entity is capable of maintaining a history of N report intervals. A MIB module using these textual conventions defines the value of N, which may be configurable.  - The SNMP entity may optionally support aggregation of performance data maintained by historic report intervals.  - A MIB module using these textual conventions may define separate tables for the current interval, historic intervals, and the aggregation of historic performance data.  - A MIB module using these textual conventions must define the following objects:  xxxReportInterval OBJECT-TYPE SYNTAX Unsigned32 (0..4294967295) UNITS ''xxx-units'' MAX-ACCESS read-only STATUS current DESCRIPTION ''This object indicates the duration of a report interval.'' ::= ( xxx )  xxxReportMaxIntervals OBJECT-TYPE SYNTAX Unsigned32 (0..4294967295) UNITS ''report intervals'' MAX-ACCESS read-only STATUS current DESCRIPTION ''This object indicates the maximum number of report intervals.'' ::= ( xxx )  xxxReportElapsedTime OBJECT-TYPE SYNTAX Gauge32 UNITS ''xxx-units'' MAX-ACCESS read-only STATUS current DESCRIPTION ''This object indicates the time that has elapsed since the beginning of the current report interval.'' ::= ( xxx )  xxxReportIntervals OBJECT-TYPE SYNTAX Gauge32 UNITS ''report intervals'' MAX-ACCESS read-only STATUS current DESCRIPTION ''This object indicates the number of report intervals for which data has been collected. The value of this column starts at 0 and increments at the end of each report interval until the number of report intervals is equal to the corresponding value of xxxReportMaxIntervals.'' ::= ( xxx )  xxxReportInvalidIntervals OBJECT-TYPE SYNTAX Gauge32 UNITS ''report intervals'' MAX-ACCESS read-only STATUS current DESCRIPTION ''This object indicates the number of report intervals, in the range of 0 to the value of the corresponding instance of xxxReportValidIntervals,  for which no data is available. The value of this column will typically be 0, except in certain circumstances when some intervals are not available. ::= ( xxx )  Observe that if the MIB module defines tables that maintain performance data for multiple instances of a measured entity (e.g., an interface), then the definition of these objects need to allow for the maintenance of these objects per instance of the measured entity.  A MIB module may choose to provide the write-access to xxxReportInterval and xxxReportMaxIntervals. In this case, the MIB module must consider the following:  - The MIB module may want to refine the data type to something more concise. Alternatively, an implementation may specify variations in an agent capabilities.  - If the definition of either of these objects specifies ''0'' as an acceptable value, then the descriptive text should describe the semantics of this value.  - The descriptive text of xxxReportInterval must explain, ''When this value changes, the SNMP entity should discard any previously collected report interval data.''  - The descriptive text of xxxReportMaxIntervals must explain, ''When this value changes to a value less than its current value, the SNMP entity should discard older report intervals to comply with the new value.''', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1945, '.1.3.6.1.2.1.17', 'dot1dBridge', 21, 'current', NULL, 'The Bridge MIB module for managing devices that support IEEE 802.1D.  Copyright (C) The Internet Society (2005). This version of this MIB module is part of RFC 4188; see the RFC itself for full legal notices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1946, '.1.3.6.1.2.1.17.0', 'dot1dNotifications', 1945, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1947, '.1.3.6.1.2.1.17.1', 'dot1dBase', 1945, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1948, '.1.3.6.1.2.1.17.2', 'dot1dStp', 1945, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1949, '.1.3.6.1.2.1.17.3', 'dot1dSr', 1945, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1950, '.1.3.6.1.2.1.17.4', 'dot1dTp', 1945, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1951, '.1.3.6.1.2.1.17.5', 'dot1dStatic', 1945, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1952, '.1.3.6.1.2.1.17.8', 'dot1dConformance', 1945, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1953, '.1.3.6.1.2.1.17.1.1', 'dot1dBaseBridgeAddress', 1947, 'current', 'IEEE 802.1D-1998: clauses 14.4.1.1.3 and 7.12.5', 'The MAC address used by this bridge when it must be referred to in a unique fashion. It is recommended that this be the numerically smallest MAC address of all ports that belong to this bridge. However, it is only  required to be unique. When concatenated with dot1dStpPriority, a unique BridgeIdentifier is formed, which is used in the Spanning Tree Protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1954, '.1.3.6.1.2.1.17.1.2', 'dot1dBaseNumPorts', 1947, 'current', 'IEEE 802.1D-1998: clause 14.4.1.1.3', 'The number of ports controlled by this bridging entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1955, '.1.3.6.1.2.1.17.1.3', 'dot1dBaseType', 1947, 'current', NULL, 'Indicates what type of bridging this bridge can perform. If a bridge is actually performing a certain type of bridging, this will be indicated by entries in the port table for the given type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1956, '.1.3.6.1.2.1.17.1.4', 'dot1dBasePortTable', 1947, 'current', NULL, 'A table that contains generic information about every port that is associated with this bridge. Transparent, source-route, and srt ports are included.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1957, '.1.3.6.1.2.1.17.1.4.1', 'dot1dBasePortEntry', 1956, 'current', 'IEEE 802.1D-1998: clause 14.4.2, 14.6.1', 'A list of information for each port of the bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1958, '.1.3.6.1.2.1.17.1.4.1.1', 'dot1dBasePort', 1957, 'current', NULL, 'The port number of the port for which this entry contains bridge management information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1960, '.1.3.6.1.2.1.17.1.4.1.3', 'dot1dBasePortCircuit', 1957, 'current', NULL, 'For a port that (potentially) has the same value of dot1dBasePortIfIndex as another port on the same bridge. This object contains the name of an object instance unique to this port. For example, in the case where multiple ports correspond one-to-one with multiple X.25 virtual circuits, this value might identify an (e.g., the first) object instance associated with the X.25 virtual circuit corresponding to this port.  For a port which has a unique value of dot1dBasePortIfIndex, this object can have the value { 0 0 }.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1961, '.1.3.6.1.2.1.17.1.4.1.4', 'dot1dBasePortDelayExceededDiscards', 1957, 'current', 'IEEE 802.1D-1998: clause 14.6.1.1.3', 'The number of frames discarded by this port due to excessive transit delay through the bridge. It is incremented by both transparent and source route bridges.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1962, '.1.3.6.1.2.1.17.1.4.1.5', 'dot1dBasePortMtuExceededDiscards', 1957, 'current', 'IEEE 802.1D-1998: clause 14.6.1.1.3', 'The number of frames discarded by this port due to an excessive size. It is incremented by both transparent and source route bridges.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1963, '.1.3.6.1.2.1.17.2.1', 'dot1dStpProtocolSpecification', 1948, 'current', NULL, 'An indication of what version of the Spanning Tree Protocol is being run. The value ''decLb100(2)'' indicates the DEC LANbridge 100 Spanning Tree protocol. IEEE 802.1D implementations will return ''ieee8021d(3)''. If future versions of the IEEE Spanning Tree Protocol that are incompatible with the current version are released a new value will be defined.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1964, '.1.3.6.1.2.1.17.2.2', 'dot1dStpPriority', 1948, 'current', 'IEEE 802.1D-1998 clause 8.10.2, Table 8-4, IEEE 802.1t clause 8.10.2, Table 8-4, clause 14.3.', 'The value of the write-able portion of the Bridge ID (i.e., the first two octets of the (8 octet long) Bridge ID). The other (last) 6 octets of the Bridge ID are given by the value of dot1dBaseBridgeAddress. On bridges supporting IEEE 802.1t or IEEE 802.1w, permissible values are 0-61440, in steps of 4096.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1965, '.1.3.6.1.2.1.17.2.3', 'dot1dStpTimeSinceTopologyChange', 1948, 'current', 'IEEE 802.1D-1998 clause 14.8.1.1., IEEE 802.1w clause 14.8.1.1.', 'The time (in hundredths of a second) since the last time a topology change was detected by the bridge entity. For RSTP, this reports the time since the tcWhile timer for any port on this Bridge was nonzero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1966, '.1.3.6.1.2.1.17.2.4', 'dot1dStpTopChanges', 1948, 'current', 'IEEE 802.1D-1998 clause 14.8.1.1.', 'The total number of topology changes detected by this bridge since the management entity was last reset or initialized.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1967, '.1.3.6.1.2.1.17.2.5', 'dot1dStpDesignatedRoot', 1948, 'current', 'IEEE 802.1D-1998: clause 8.5.3.1', 'The bridge identifier of the root of the spanning tree, as determined by the Spanning Tree Protocol, as executed by this node. This value is used as the Root Identifier parameter in all Configuration Bridge PDUs originated by this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1968, '.1.3.6.1.2.1.17.2.6', 'dot1dStpRootCost', 1948, 'current', 'IEEE 802.1D-1998: clause 8.5.3.2', 'The cost of the path to the root as seen from this bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1969, '.1.3.6.1.2.1.17.2.7', 'dot1dStpRootPort', 1948, 'current', 'IEEE 802.1D-1998: clause 8.5.3.3', 'The port number of the port that offers the lowest cost path from this bridge to the root bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1970, '.1.3.6.1.2.1.17.2.8', 'dot1dStpMaxAge', 1948, 'current', 'IEEE 802.1D-1998: clause 8.5.3.4', 'The maximum age of Spanning Tree Protocol information learned from the network on any port before it is discarded, in units of hundredths of a second. This is the actual value that this bridge is currently using.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1971, '.1.3.6.1.2.1.17.2.9', 'dot1dStpHelloTime', 1948, 'current', 'IEEE 802.1D-1998: clause 8.5.3.5', 'The amount of time between the transmission of Configuration bridge PDUs by this node on any port when it is the root of the spanning tree, or trying to become so, in units of hundredths of a second. This is the actual value that this bridge is currently using.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1972, '.1.3.6.1.2.1.17.2.10', 'dot1dStpHoldTime', 1948, 'current', 'IEEE 802.1D-1998: clause 8.5.3.14', 'This time value determines the interval length during which no more than two Configuration bridge PDUs shall be transmitted by this node, in units of hundredths of a second.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1973, '.1.3.6.1.2.1.17.2.11', 'dot1dStpForwardDelay', 1948, 'current', 'IEEE 802.1D-1998: clause 8.5.3.6', 'This time value, measured in units of hundredths of a second, controls how fast a port changes its spanning state when moving towards the Forwarding state. The value determines how long the port stays in each of the Listening and Learning states, which precede the Forwarding state. This value is also used when a topology change has been detected and is underway, to age all dynamic entries in the Forwarding Database. [Note that this value is the one that this bridge is currently using, in contrast to dot1dStpBridgeForwardDelay, which is the value that this bridge and all others would start using if/when this bridge were to become the root.]', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1974, '.1.3.6.1.2.1.17.2.12', 'dot1dStpBridgeMaxAge', 1948, 'current', 'IEEE 802.1D-1998: clause 8.5.3.8', 'The value that all bridges use for MaxAge when this bridge is acting as the root. Note that 802.1D-1998 specifies that the range for this parameter is related to the value of dot1dStpBridgeHelloTime. The granularity of this timer is specified by 802.1D-1998 to be 1 second. An agent may return a badValue error if a set is attempted to a value that is not a whole number of seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1975, '.1.3.6.1.2.1.17.2.13', 'dot1dStpBridgeHelloTime', 1948, 'current', 'IEEE 802.1D-1998: clause 8.5.3.9', 'The value that all bridges use for HelloTime when this bridge is acting as the root. The granularity of this timer is specified by 802.1D-1998 to be 1 second. An agent may return a badValue error if a set is attempted  to a value that is not a whole number of seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1976, '.1.3.6.1.2.1.17.2.14', 'dot1dStpBridgeForwardDelay', 1948, 'current', 'IEEE 802.1D-1998: clause 8.5.3.10', 'The value that all bridges use for ForwardDelay when this bridge is acting as the root. Note that 802.1D-1998 specifies that the range for this parameter is related to the value of dot1dStpBridgeMaxAge. The granularity of this timer is specified by 802.1D-1998 to be 1 second. An agent may return a badValue error if a set is attempted to a value that is not a whole number of seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1977, '.1.3.6.1.2.1.17.2.15', 'dot1dStpPortTable', 1948, 'current', NULL, 'A table that contains port-specific information for the Spanning Tree Protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1978, '.1.3.6.1.2.1.17.2.15.1', 'dot1dStpPortEntry', 1977, 'current', NULL, 'A list of information maintained by every port about the Spanning Tree Protocol state for that port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1979, '.1.3.6.1.2.1.17.2.15.1.1', 'dot1dStpPort', 1978, 'current', 'IEEE 802.1D-1998: clause 14.8.2.1.2', 'The port number of the port for which this entry contains Spanning Tree Protocol management information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1980, '.1.3.6.1.2.1.17.2.15.1.2', 'dot1dStpPortPriority', 1978, 'current', 'IEEE 802.1D-1998 clause 8.10.2, Table 8-4,  IEEE 802.1t clause 8.10.2, Table 8-4, clause 14.3.', 'The value of the priority field that is contained in the first (in network byte order) octet of the (2 octet long) Port ID. The other octet of the Port ID is given by the value of dot1dStpPort. On bridges supporting IEEE 802.1t or IEEE 802.1w, permissible values are 0-240, in steps of 16.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2003, '.1.3.6.1.2.1.17.4.4.1.5', 'dot1dTpPortInDiscards', 1998, 'current', 'IEEE 802.1D-1998: clause 14.6.1.1.3', 'Count of received valid frames that were discarded (i.e., filtered) by the Forwarding Process.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1981, '.1.3.6.1.2.1.17.2.15.1.3', 'dot1dStpPortState', 1978, 'current', 'IEEE 802.1D-1998: clause 8.5.5.2', 'The port''s current state, as defined by application of the Spanning Tree Protocol. This state controls what action a port takes on reception of a frame. If the bridge has detected a port that is malfunctioning, it will place that port into the broken(6) state. For ports that are disabled (see dot1dStpPortEnable), this object will have a value of disabled(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1982, '.1.3.6.1.2.1.17.2.15.1.4', 'dot1dStpPortEnable', 1978, 'current', 'IEEE 802.1D-1998: clause 8.5.5.2', 'The enabled/disabled status of the port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1983, '.1.3.6.1.2.1.17.2.15.1.5', 'dot1dStpPortPathCost', 1978, 'current', 'IEEE 802.1D-1998: clause 8.5.5.3', 'The contribution of this port to the path cost of paths towards the spanning tree root which include this port. 802.1D-1998 recommends that the default value of this parameter be in inverse proportion to  the speed of the attached LAN.  New implementations should support dot1dStpPortPathCost32. If the port path costs exceeds the maximum value of this object then this object should report the maximum value, namely 65535. Applications should try to read the dot1dStpPortPathCost32 object if this object reports the maximum value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1984, '.1.3.6.1.2.1.17.2.15.1.6', 'dot1dStpPortDesignatedRoot', 1978, 'current', 'IEEE 802.1D-1998: clause 8.5.5.4', 'The unique Bridge Identifier of the Bridge recorded as the Root in the Configuration BPDUs transmitted by the Designated Bridge for the segment to which the port is attached.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1985, '.1.3.6.1.2.1.17.2.15.1.7', 'dot1dStpPortDesignatedCost', 1978, 'current', 'IEEE 802.1D-1998: clause 8.5.5.5', 'The path cost of the Designated Port of the segment connected to this port. This value is compared to the Root Path Cost field in received bridge PDUs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1986, '.1.3.6.1.2.1.17.2.15.1.8', 'dot1dStpPortDesignatedBridge', 1978, 'current', 'IEEE 802.1D-1998: clause 8.5.5.6', 'The Bridge Identifier of the bridge that this port considers to be the Designated Bridge for this port''s segment.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1987, '.1.3.6.1.2.1.17.2.15.1.9', 'dot1dStpPortDesignatedPort', 1978, 'current', 'IEEE 802.1D-1998: clause 8.5.5.7', 'The Port Identifier of the port on the Designated Bridge for this port''s segment.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1988, '.1.3.6.1.2.1.17.2.15.1.10', 'dot1dStpPortForwardTransitions', 1978, 'current', NULL, 'The number of times this port has transitioned from the Learning state to the Forwarding state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1989, '.1.3.6.1.2.1.17.2.15.1.11', 'dot1dStpPortPathCost32', 1978, 'current', 'IEEE 802.1t clause 8.10.2, Table 8-5.', 'The contribution of this port to the path cost of paths towards the spanning tree root which include this port. 802.1D-1998 recommends that the default value of this parameter be in inverse proportion to the speed of the attached LAN.  This object replaces dot1dStpPortPathCost to support IEEE 802.1t.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1990, '.1.3.6.1.2.1.17.4.1', 'dot1dTpLearnedEntryDiscards', 1950, 'current', 'IEEE 802.1D-1998: clause 14.7.1.1.3', 'The total number of Forwarding Database entries that have been or would have been learned, but have been discarded due to a lack of storage space in the Forwarding Database. If this counter is increasing, it indicates that the Forwarding Database is regularly becoming full (a condition that has unpleasant performance effects on the subnetwork). If this counter has a significant value but is not presently increasing, it indicates that the problem has been occurring but is not persistent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1991, '.1.3.6.1.2.1.17.4.2', 'dot1dTpAgingTime', 1950, 'current', 'IEEE 802.1D-1998: clause 14.7.1.1.3', 'The timeout period in seconds for aging out dynamically-learned forwarding information. 802.1D-1998 recommends a default of 300 seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1992, '.1.3.6.1.2.1.17.4.3', 'dot1dTpFdbTable', 1950, 'current', NULL, 'A table that contains information about unicast entries for which the bridge has forwarding and/or filtering information. This information is used by the transparent bridging function in determining how to propagate a received frame.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1993, '.1.3.6.1.2.1.17.4.3.1', 'dot1dTpFdbEntry', 1992, 'current', NULL, 'Information about a specific unicast MAC address for which the bridge has some forwarding and/or filtering information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1994, '.1.3.6.1.2.1.17.4.3.1.1', 'dot1dTpFdbAddress', 1993, 'current', 'IEEE 802.1D-1998: clause 7.9.1, 7.9.2', 'A unicast MAC address for which the bridge has forwarding and/or filtering information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1995, '.1.3.6.1.2.1.17.4.3.1.2', 'dot1dTpFdbPort', 1993, 'current', NULL, 'Either the value ''0'', or the port number of the port on which a frame having a source address equal to the value of the corresponding instance of dot1dTpFdbAddress has been seen. A value of ''0'' indicates that the port number has not been learned, but that the bridge does have some forwarding/filtering information about this address (e.g., in the dot1dStaticTable). Implementors are encouraged to assign the port value to this object whenever it is learned, even for addresses for which the corresponding value of dot1dTpFdbStatus is not learned(3).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1996, '.1.3.6.1.2.1.17.4.3.1.3', 'dot1dTpFdbStatus', 1993, 'current', NULL, 'The status of this entry. The meanings of the values are: other(1) - none of the following. This would include the case where some other MIB object (not the corresponding instance of dot1dTpFdbPort, nor an entry in the dot1dStaticTable) is being used to determine if and how frames addressed to the value of the corresponding instance of dot1dTpFdbAddress are being forwarded. invalid(2) - this entry is no longer valid (e.g., it was learned but has since aged out), but has not yet been flushed from the table. learned(3) - the value of the corresponding instance of dot1dTpFdbPort was learned, and is being used. self(4) - the value of the corresponding instance of dot1dTpFdbAddress represents one of the bridge''s addresses. The corresponding instance of dot1dTpFdbPort indicates which of the bridge''s ports has this address. mgmt(5) - the value of the corresponding instance of dot1dTpFdbAddress is also the value of an existing instance of dot1dStaticAddress.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1997, '.1.3.6.1.2.1.17.4.4', 'dot1dTpPortTable', 1950, 'current', NULL, 'A table that contains information about every port that is associated with this transparent bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1998, '.1.3.6.1.2.1.17.4.4.1', 'dot1dTpPortEntry', 1997, 'current', NULL, 'A list of information for each port of a transparent bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (1999, '.1.3.6.1.2.1.17.4.4.1.1', 'dot1dTpPort', 1998, 'current', NULL, 'The port number of the port for which this entry contains Transparent bridging management information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2000, '.1.3.6.1.2.1.17.4.4.1.2', 'dot1dTpPortMaxInfo', 1998, 'current', NULL, 'The maximum size of the INFO (non-MAC) field that  this port will receive or transmit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2001, '.1.3.6.1.2.1.17.4.4.1.3', 'dot1dTpPortInFrames', 1998, 'current', 'IEEE 802.1D-1998: clause 14.6.1.1.3', 'The number of frames that have been received by this port from its segment. Note that a frame received on the interface corresponding to this port is only counted by this object if and only if it is for a protocol being processed by the local bridging function, including bridge management frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2002, '.1.3.6.1.2.1.17.4.4.1.4', 'dot1dTpPortOutFrames', 1998, 'current', 'IEEE 802.1D-1998: clause 14.6.1.1.3', 'The number of frames that have been transmitted by this port to its segment. Note that a frame transmitted on the interface corresponding to this port is only counted by this object if and only if it is for a protocol being processed by the local bridging function, including bridge management frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4554, '.1.3.6.1.2.1.16.1.3.1.5', 'tokenRingPStatsDataPkts', 4549, 'current', NULL, 'The total number of non-MAC packets in good frames received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2004, '.1.3.6.1.2.1.17.5.1', 'dot1dStaticTable', 1951, 'current', 'IEEE 802.1D-1998: clause 14.7.2', 'A table containing filtering information configured into the bridge by (local or network) management specifying the set of ports to which frames received from specific ports and containing specific destination addresses are allowed to be forwarded. The value of zero in this table, as the port number from which frames with a specific destination address are received, is used to specify all ports for which there is no specific entry in this table for that particular destination address. Entries are valid for unicast and for group/broadcast addresses.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2005, '.1.3.6.1.2.1.17.5.1.1', 'dot1dStaticEntry', 2004, 'current', 'IEEE 802.1D-1998: clause 14.7.2', 'Filtering information configured into the bridge by (local or network) management specifying the set of ports to which frames received from a specific port and containing a specific destination address are allowed to be forwarded.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2006, '.1.3.6.1.2.1.17.5.1.1.1', 'dot1dStaticAddress', 2005, 'current', 'IEEE 802.1D-1998: clause 7.9.1, 7.9.2', 'The destination MAC address in a frame to which this entry''s filtering information applies. This object can take the value of a unicast address, a group address, or the broadcast address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2007, '.1.3.6.1.2.1.17.5.1.1.2', 'dot1dStaticReceivePort', 2005, 'current', NULL, 'Either the value ''0'', or the port number of the port from which a frame must be received in order for this entry''s filtering information to apply. A value of zero indicates that this entry applies on all ports of the bridge for which there is no other applicable entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2008, '.1.3.6.1.2.1.17.5.1.1.3', 'dot1dStaticAllowedToGoTo', 2005, 'current', NULL, 'The set of ports to which frames received from a specific port and destined for a specific MAC address, are allowed to be forwarded. Each octet within the value of this object specifies a set of eight ports, with the first octet specifying ports 1 through 8, the second octet specifying ports 9 through 16, etc. Within each octet, the most significant bit represents the lowest numbered port, and the least significant bit represents the highest numbered port. Thus, each port of the bridge is represented by a single bit within the value of this object. If that bit has a value of ''1'', then that port is included in the set of ports; the port is not included if its bit has a value of ''0''. (Note that the setting of the bit corresponding to the port from which a frame is received is irrelevant.) The default value of this object is a string of ones of appropriate length.  The value of this object may exceed the required minimum maximum message size of some SNMP transport (484 bytes, in the case of SNMP over UDP, see RFC 3417, section 3.2). SNMP engines on bridges supporting a large number of ports must support appropriate maximum message sizes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2009, '.1.3.6.1.2.1.17.5.1.1.4', 'dot1dStaticStatus', 2005, 'current', NULL, 'This object indicates the status of this entry. The default value is permanent(3). other(1) - this entry is currently in use but the conditions under which it will remain so are different from each of the following values. invalid(2) - writing this value to the object removes the corresponding entry. permanent(3) - this entry is currently in use and will remain so after the next reset of the bridge. deleteOnReset(4) - this entry is currently in use and will remain so until the next reset of the bridge. deleteOnTimeout(5) - this entry is currently in use and will remain so until it is aged out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2010, '.1.3.6.1.2.1.17.0.1', 'newRoot', 1946, 'current', NULL, 'The newRoot trap indicates that the sending agent has become the new root of the Spanning Tree; the trap is sent by a bridge soon after its election as the new  root, e.g., upon expiration of the Topology Change Timer, immediately subsequent to its election. Implementation of this trap is optional.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2011, '.1.3.6.1.2.1.17.0.2', 'topologyChange', 1946, 'current', NULL, 'A topologyChange trap is sent by a bridge when any of its configured ports transitions from the Learning state to the Forwarding state, or from the Forwarding state to the Blocking state. The trap is not sent if a newRoot trap is sent for the same transition. Implementation of this trap is optional.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2012, '.1.3.6.1.2.1.17.8.1', 'dot1dGroups', 1952, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2013, '.1.3.6.1.2.1.17.8.2', 'dot1dCompliances', 1952, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2014, '.1.3.6.1.2.1.17.8.1.1', 'dot1dBaseBridgeGroup', 2012, 'current', NULL, 'Bridge level information for this device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2015, '.1.3.6.1.2.1.17.8.1.2', 'dot1dBasePortGroup', 2012, 'current', NULL, 'Information for each port on this device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2016, '.1.3.6.1.2.1.17.8.1.3', 'dot1dStpBridgeGroup', 2012, 'current', NULL, 'Bridge level Spanning Tree data for this device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2017, '.1.3.6.1.2.1.17.8.1.4', 'dot1dStpPortGroup', 2012, 'current', NULL, 'Spanning Tree data for each port on this device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2018, '.1.3.6.1.2.1.17.8.1.5', 'dot1dStpPortGroup2', 2012, 'current', NULL, 'Spanning Tree data for each port on this device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2019, '.1.3.6.1.2.1.17.8.1.6', 'dot1dStpPortGroup3', 2012, 'current', NULL, 'Spanning Tree data for devices supporting 32-bit path costs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2020, '.1.3.6.1.2.1.17.8.1.7', 'dot1dTpBridgeGroup', 2012, 'current', NULL, 'Bridge level Transparent Bridging data.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2021, '.1.3.6.1.2.1.17.8.1.8', 'dot1dTpFdbGroup', 2012, 'current', NULL, 'Filtering Database information for the Bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2022, '.1.3.6.1.2.1.17.8.1.9', 'dot1dTpGroup', 2012, 'current', NULL, 'Dynamic Filtering Database information for each port of the Bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2023, '.1.3.6.1.2.1.17.8.1.10', 'dot1dStaticGroup', 2012, 'current', NULL, 'Static Filtering Database information for each port of the Bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2024, '.1.3.6.1.2.1.17.8.1.11', 'dot1dNotificationGroup', 2012, 'current', NULL, 'Group of objects describing notifications (traps).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2025, '.1.3.6.1.2.1.17.8.2.1', 'bridgeCompliance1493', 2013, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2026, '.1.3.6.1.2.1.17.8.2.2', 'bridgeCompliance4188', 2013, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5238, '.1.3.6.1.4.1.9.9.692.1.4.1.1.6', 'cfmConditionThreshRiseScale', 5232, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmConditionThreshRise.  This value of this column only has relevance if the corresponding instance of cfmConditionType is ''risingThreshold'' or ''risingAndFallingThreshold''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5239, '.1.3.6.1.4.1.9.9.692.1.4.1.1.7', 'cfmConditionThreshRisePrecision', 5232, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmConditionThreshRise.  This value of this column only has relevance if the corresponding instance of cfmConditionType is ''risingThreshold'' or ''risingAndFallingThreshold''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5240, '.1.3.6.1.4.1.9.9.692.1.4.1.1.8', 'cfmConditionThreshRise', 5232, 'current', NULL, 'This object indicates the value of the rising threshold.  This value of this column only has relevance if the corresponding instance of cfmConditionType is ''risingThreshold'' or ''risingAndFallingThreshold''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5241, '.1.3.6.1.4.1.9.9.692.1.4.1.1.9', 'cfmConditionThreshFallScale', 5232, 'current', NULL, 'This object indicates the scaling factor for the corresponding instance of cfmConditionThreshFall.  The value of this column only has relevance if the corresponding instance of cfmConditionType is ''fallingThreshold'' or ''risingAndFallingThreshold''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4653, '.1.3.6.1.2.1.16.10.2.1.22', 'ringStationInsertions', 4631, 'current', NULL, 'The number of times the probe detected this station inserting onto the ring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5223, '.1.3.6.1.4.1.9.9.692.1.3.3.1.5', 'cfmFlowMetricsIntAlarms', 5218, 'current', NULL, 'This object indicates which alarm conditions were raised at least once during the measurement interval for the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5242, '.1.3.6.1.4.1.9.9.692.1.4.1.1.10', 'cfmConditionThreshFallPrecision', 5232, 'current', NULL, 'This object indicates the precision for the corresponding instance of cfmConditionThreshFall.  The value of this column only has relevance if the corresponding instance of cfmConditionType is ''fallingThreshold'' or ''risingAndFallingThreshold''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5243, '.1.3.6.1.4.1.9.9.692.1.4.1.1.11', 'cfmConditionThreshFall', 5232, 'current', NULL, 'This object indicates the value of the falling threshold.  The value of this column only has relevance if the corresponding instance of cfmConditionType is ''fallingThreshold'' or ''risingAndFallingThreshold''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5244, '.1.3.6.1.4.1.9.9.692.1.4.1.1.13', 'cfmConditionSampleType', 5232, 'current', NULL, 'This object indicates how the device samples the monitored value before determining whether to assert the condition:  ''other'' The implementation of the MIB does not recognize the how the device samples the monitored value.  ''raw'' The device samples the monitored value and uses this value to determine whether to assert the condition.  ''slidingWindowAvg'' The device samples the monitored value and maintains a average over a sliding window. It uses this value of this average to determine whether to assert the condition. The corresponding instance of cfmCOnditionSampleWindow indicates the length of the sliding window.  ''slidingWindowAverage'' The device samples the monitored value and maintains a exponentially decaying average over a sliding window. It uses this value of this average to determine whether to assert the condition. The corresponding instance of cfmCOnditionSampleWindow indicates the length of the sliding window.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5245, '.1.3.6.1.4.1.9.9.692.1.4.1.1.14', 'cfmConditionSampleWindow', 5232, 'current', NULL, 'This object indicates the sample window used by the device to compute an exponentially decaying average in the case that the corresponding instance of cfmConditionSampleType is ''averaged''.  The value of this column only has relevance if the corresponding instance of cfmConditionSampleWindow is ''slidingWindowAvg'' or ''expDecayingAvg.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5246, '.1.3.6.1.4.1.9.9.692.1.4.1.1.15', 'cfmConditionAlarm', 5232, 'current', NULL, 'This object indicates whether the device treats the standing condition as an alarm condition:  ''none'' The device does not treat the standing condition as an alarm condition.  ''discrete'' The device treats the standing condition as an alarm condition.  ''grouped'' The device aggregates the standing condition into an alarm group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5247, '.1.3.6.1.4.1.9.9.692.1.4.1.1.16', 'cfmConditionAlarmActions', 5232, 'current', NULL, 'This object indicates the actions taken by the device when the alarm condition changes state:  ''syslog'' The device sends a syslog message.  ''snmp'' The device sends a cfmNotifyAlarm notification if and only if cfmNotifyEnable is set to ''true''.  The value of this column only has relevance if the corresponding instance of cfmConditionAlarm is ''discrete''', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5248, '.1.3.6.1.4.1.9.9.692.1.4.1.1.17', 'cfmConditionAlarmSeverity', 5232, 'current', NULL, 'This object indicates the severity of the alarm condition.  The value of this column only have relevance if the corresponding instance of cfmConditionAlarm is ''discrete''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5249, '.1.3.6.1.4.1.9.9.692.1.4.1.1.18', 'cfmConditionAlarmGroup', 5232, 'current', NULL, 'This object indicates the alarm group the device aggregates the standing condition into.  The value of this column only has relevance if the corresponding instance of cfmConditionAlarm is ''grouped''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5250, '.1.3.6.1.4.1.9.9.692.1.4.2', 'cfmConditionTableChanged', 5230, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device made a change to the cfmConditionTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5251, '.1.3.6.1.4.1.9.9.692.1.5', 'cfmAlarmGroups', 5126, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5252, '.1.3.6.1.4.1.9.9.692.1.5.1', 'cfmAlarmGroupTable', 5251, 'current', NULL, 'This table lists alarm groups maintained by the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5278, '.1.3.6.1.4.1.9.9.692.1.6.3.1.3', 'cfmAlarmHistoryEntity', 5275, 'current', NULL, 'This object indicates the entity that caused the event.  If the alarm condition has an association with a flow monitor, then the value of this column is a row in the cfmFlowMonitorTable.  If the alarm condition has an association with a traffic flow, then the value of this column is a row in the cfmFlowTable.  If the alarm condition has an association with a alarm group, then the value of this column is a row in the cfmAlarmGroupTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5279, '.1.3.6.1.4.1.9.9.692.1.6.3.1.4', 'cfmAlarmHistoryConditionsProfile', 5275, 'current', NULL, 'This object indicates the conditions profile containing the description of the alarm condition that changed state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5280, '.1.3.6.1.4.1.9.9.692.1.6.3.1.5', 'cfmAlarmHistoryConditionId', 5275, 'current', NULL, 'This object indicates the alarm condition that changed state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5281, '.1.3.6.1.4.1.9.9.692.1.6.3.1.6', 'cfmAlarmHistorySeverity', 5275, 'current', NULL, 'This object indicates the severity of the alarm condition that changed state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5366, '.1.3.6.1.4.1.9.9.703.1.1.1.1.11', 'cfmRtpMetricsAvgLossDistance', 5355, 'current', NULL, 'This object indicates the average loss distance for the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5409, '.1.3.6.1.2.1.47', 'entityMIB', 21, 'current', NULL, 'The MIB module for representing multiple logical entities supported by a single SNMP agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5214, '.1.3.6.1.4.1.9.9.692.1.3.1.1.14', 'cfmFlowMetricsBitRate', 5200, 'current', NULL, 'This object indicates the average bit rate at which the corresponding flow monitor is processing data for the corresponding traffic flow. This value is cumulative over the lifetime of the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5215, '.1.3.6.1.4.1.9.9.692.1.3.1.1.15', 'cfmFlowMetricsPktRate', 5200, 'current', NULL, 'This object indicates the average packet rate at which the corresponding flow monitor is processing data for the corresponding traffic flow. This value is cumulative over the lifetime of the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5216, '.1.3.6.1.4.1.9.9.692.1.3.2', 'cfmFlowMetricsTableChanged', 5198, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device created or destroyed a row in cfmFlowMetricsTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5217, '.1.3.6.1.4.1.9.9.692.1.3.3', 'cfmFlowMetricsIntTable', 5198, 'current', NULL, 'This table contains historic metrics for the traffic flows monitored by each of the flow monitors supported by the device.  This table has an expansion dependent relationship on the cfmFlowMetricsTable, containing zero or more rows for each traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5218, '.1.3.6.1.4.1.9.9.692.1.3.3.1', 'cfmFlowMetricsIntEntry', 5217, 'current', NULL, 'An entry describes metrics collected for a previous measurement interval for a corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5219, '.1.3.6.1.4.1.9.9.692.1.3.3.1.1', 'cfmFlowMetricsIntNumber', 5218, 'current', NULL, 'This object indicates the interval number identifying the measurement interval. The measurement interval identified by the value ''1'' represents the most recent measurement interval, and the interval identified by the value (n) represents the interval immediately preceding the interval identified by the value (n-1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5220, '.1.3.6.1.4.1.9.9.692.1.3.3.1.2', 'cfmFlowMetricsIntValid', 5218, 'current', NULL, 'This object indicates whether the data for the measurement interval is valid.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5221, '.1.3.6.1.4.1.9.9.692.1.3.3.1.3', 'cfmFlowMetricsIntTime', 5218, 'current', NULL, 'This object indicates the value of sysUpTime when the measurement interval was captured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5222, '.1.3.6.1.4.1.9.9.692.1.3.3.1.4', 'cfmFlowMetricsIntConditions', 5218, 'current', NULL, 'This object indicates which standing conditions were asserted at least once during the measurement interval for the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6781, '.1.3.6.1.4.1.9.2.2.1.1.93', 'locIfmopOutOctets', 6689, 'mandatory', NULL, 'MOP protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5224, '.1.3.6.1.4.1.9.9.692.1.3.3.1.6', 'cfmFlowMetricsIntAlarmSeverity', 5218, 'current', NULL, 'This object indicates the highest severity alarm raised during the measurement interval for the corresponding traffic flow.  If no alarm was raised during the measurement interval for the corresponding traffic flow, then the value of this column is ''cleared''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5225, '.1.3.6.1.4.1.9.9.692.1.3.3.1.7', 'cfmFlowMetricsIntPkts', 5218, 'current', NULL, 'This object indicates the number of packets processed by the corresponding flow monitor for the corresponding traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5226, '.1.3.6.1.4.1.9.9.692.1.3.3.1.8', 'cfmFlowMetricsIntOctets', 5218, 'current', NULL, 'This object indicates the number of octets contained by the packets processed by the corresponding flow monitor for the corresponding traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5227, '.1.3.6.1.4.1.9.9.692.1.3.3.1.9', 'cfmFlowMetricsIntBitRateUnits', 5218, 'current', NULL, 'This object indicates the units for the corresponding instance of cfmFlowMetricsIntBitRate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5228, '.1.3.6.1.4.1.9.9.692.1.3.3.1.10', 'cfmFlowMetricsIntBitRate', 5218, 'current', NULL, 'This object indicates the bit rate at which the corresponding flow monitor processed data for the corresponding traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5229, '.1.3.6.1.4.1.9.9.692.1.3.3.1.11', 'cfmFlowMetricsIntPktRate', 5218, 'current', NULL, 'This object indicates the packet rate at which the corresponding flow monitor processed data for the corresponding traffic flow during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5230, '.1.3.6.1.4.1.9.9.692.1.4', 'cfmConditions', 5126, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5231, '.1.3.6.1.4.1.9.9.692.1.4.1', 'cfmConditionTable', 5230, 'current', NULL, 'This table lists the standing conditions monitored by the device. The table groups descriptions for standing conditions into condition profiles.  The figure below illustrates the relationship between a flow monitor and a conditions profile. Observe that a conditions profile can contain the descriptions for the standing conditions monitored for more than one flow monitor. In this case, the instance of cfmFlowMonitorConditionsProfile for each of these flow monitors would reference the same conditions profile.  +--------------------------------------------+ | flow monitor 1 | | | | cfmFlowMonitorConditionsProfile.1 = 42 -+ | | | | | cfmFlowMonitorConditions.1 | | | N 2 1 0 | | | +-+-...-+-+-+-+ | | | | | | | | | | | | +-+-...-+-+-+-+ | | | ^ ^ ^ ^ | | | | | | | | | +-----|-|-|------------------------------|--+ | | | | | | | | | V | | | | +-------------------------+ | | | | | conditions profile 42 | | | | | | +---------------------+ | | | | +-------------| cfmConditionsDescr.42.0 | | | | | | +---------------------+ | | | | | +---------------------+ | | | +---------------| cfmConditionsDescr.42.1 | | | | | +---------------------+ | | | | +---------------------+ | | +-----------------| cfmConditionsDescr.42.2 | | | | +---------------------+ | | | : | | | : | | | +---------------------+ | +-------------------------| cfmConditionsDescr.42.N | | | +---------------------+ | +-------------------------+  The figure below illustrates the relationship between a traffic flow and a conditions profile. Observe that a conditions profile can contain the descriptions for the standing conditions monitored for more than one traffic flow. In this case, the instance of cfmFlowMetricsConditionsProfile for each of these traffic flows would reference the same conditions profile.  +--------------------------------------------+ | traffic flow 201 | | | | cfmFlowMetricsConditionsProfile.1.201 = 54 -+ | | | | | cfmFlowMetricsConditions.1.201 | | | N 2 1 0 | | | +-+-...-+-+-+-+ | | | | | | | | | | | | +-+-...-+-+-+-+ | | | ^ ^ ^ ^ | | | | | | | | | +-----|-|-|------------------------------|--+ | | | | | | | | | V | | | | +-------------------------+ | | | | | conditions profile 54 | | | | | | +---------------------+ | | | | +-------------| cfmConditionsDescr.54.0 | | | | | | +---------------------+ | | | | | +---------------------+ | | | +---------------| cfmConditionsDescr.54.1 | | | | | +---------------------+ | | | | +---------------------+ | | +-----------------| cfmConditionsDescr.54.2 | | | | +---------------------+ | | | : | | | : | | | +---------------------+ | +-------------------------| cfmConditionsDescr.54.N | | | +---------------------+ | +-------------------------+  The figure below illustrates the relationship between the description of a standing condition and an alarm group if the standing condition indicates that the device aggregates the standing condition into an alarm group (i.e., the corresponding instance of cfmConditionAlarm is ''grouped'').  +-------------------------------------+ | conditions profile 42 | | +---------------------------------+ | | | cfmConditionAlarm.42.9 = ''grouped'' |<---+ | | cfmConditionAlarmGroup.42.9 = 4 -+ | | | | +------------------------------|--+ |<--+ | | | | | | +--------------------------------|----+ | | V | | +-------------------------------------+ | | | alarm group 4 | | | | | | | | cfmAlarmGroupConditionsProfile.4 = 42 --+ | | cfmAlarmGroupConditionId.4 = 9 ------------+ | | +-------------------------------------+', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5232, '.1.3.6.1.4.1.9.9.692.1.4.1.1', 'cfmConditionEntry', 5231, 'current', NULL, 'An entry describes a standing condition monitored by the device. The cfmConditionTable groups descriptions for standing conditions into condition profiles.  A device creates a row in the cfmConditionTable when it has been configured to monitor a standing condition for an entity, such as a flow monitor or traffic flow. Likewise, the device destroys a row when it has been configured to cease monitoring a previously configured standing condition.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5233, '.1.3.6.1.4.1.9.9.692.1.4.1.1.1', 'cfmConditionProfile', 5232, 'current', NULL, 'This object indicates an arbitrary integer-value that uniquely identifies the condition profile that contains the standing condition. Observe that the value assigned to a standing condition does not necessarily persist across restars.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5234, '.1.3.6.1.4.1.9.9.692.1.4.1.1.2', 'cfmConditionId', 5232, 'current', NULL, 'This object indicates an arbitrary integer-value that uniquely identifies the condition within the scope of the profile. The value of this column corresponds to the bit position in a binary string-value representing the standing (or alarm) conditions for an entity, such as a flow monitor or traffic flow. Observe that the value assigned to a standing condition does not necessarily persist across restarts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5235, '.1.3.6.1.4.1.9.9.692.1.4.1.1.3', 'cfmConditionDescr', 5232, 'current', NULL, 'This object indicates a human-readable description of the condition.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5236, '.1.3.6.1.4.1.9.9.692.1.4.1.1.4', 'cfmConditionMonitoredElement', 5232, 'current', NULL, 'This object indicates the monitored element used in determining the state of the standing condition.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5276, '.1.3.6.1.4.1.9.9.692.1.6.3.1.1', 'cfmAlarmHistoryId', 5275, 'current', NULL, 'This object indicates an arbitrary integer-value that uniquely identifies the event. Observe that the value assigned to a alarm history entry does not necessarily persist across restarts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5277, '.1.3.6.1.4.1.9.9.692.1.6.3.1.2', 'cfmAlarmHistoryType', 5275, 'current', NULL, 'This object indicates the type of event:  ''cleared'' The event signaled an alarm condition transitioning to the cleared state.  ''raised'' The event signalled an alarm condition transitioning to the raised state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5334, '.1.3.6.1.4.1.9.9.697.1.1.3.1.9', 'cfmIpCbrMetricsIntDf', 5325, 'current', NULL, 'This object indicates the DF for the traffic flow during the measurement interval.  The value of this column is valid if and only if the ''delayFactor'' bit in the corresponding instance of cfmIpCbrMetricsIntValid is set to ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5185, '.1.3.6.1.4.1.9.9.692.1.2.9', 'cfmFlowTcpTable', 5146, 'current', NULL, 'This table contains additional data relating to the TCP carrying the corresponding traffic flow.  This table has a sparse dependent relationship on the cfmFlowTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6237, '.1.3.6.1.2.1.72', 'ianaAddressFamilyNumbers', 21, 'current', NULL, 'The MIB module defines the AddressFamilyNumbers textual convention.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2087, '.1.3.6.1.2.1.17.6', 'pBridgeMIB', 1945, 'current', NULL, 'The Bridge MIB Extension module for managing Priority and Multicast Filtering, defined by IEEE 802.1D-1998, including Restricted Group Registration defined by IEEE 802.1t-2001.  Copyright (C) The Internet Society (2006). This version of this MIB module is part of RFC 4363; See the RFC itself for full legal notices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2088, '.1.3.6.1.2.1.17.4.5', 'dot1dTpHCPortTable', 1950, 'current', NULL, 'A table that contains information about every high- capacity port that is associated with this transparent bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2089, '.1.3.6.1.2.1.17.4.5.1', 'dot1dTpHCPortEntry', 2088, 'current', NULL, 'Statistics information for each high-capacity port of a transparent bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2090, '.1.3.6.1.2.1.17.4.5.1.1', 'dot1dTpHCPortInFrames', 2089, 'current', 'ISO/IEC 15802-3 Section 14.6.1.1.3', 'The number of frames that have been received by this port from its segment. Note that a frame received on the interface corresponding to this port is only counted by this object if and only if it is for a protocol being processed by the local bridging function, including bridge management frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2091, '.1.3.6.1.2.1.17.4.5.1.2', 'dot1dTpHCPortOutFrames', 2089, 'current', 'ISO/IEC 15802-3 Section 14.6.1.1.3', 'The number of frames that have been transmitted by this port to its segment. Note that a frame transmitted on the interface corresponding to this port is only counted by this object if and only if it is for a protocol being processed by the local bridging function, including bridge management frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2092, '.1.3.6.1.2.1.17.4.5.1.3', 'dot1dTpHCPortInDiscards', 2089, 'current', 'ISO/IEC 15802-3 Section 14.6.1.1.3', 'Count of valid frames that have been received by this port from its segment that were discarded (i.e., filtered) by the Forwarding Process.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4654, '.1.3.6.1.2.1.16.10.3', 'ringStationOrderTable', 4518, 'current', NULL, 'A list of ring station entries for stations in the ring poll, ordered by their ring-order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4557, '.1.3.6.1.2.1.16.1.3.1.8', 'tokenRingPStatsDataPkts18to63Octets', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were between 18 and 63 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2093, '.1.3.6.1.2.1.17.4.6', 'dot1dTpPortOverflowTable', 1950, 'current', NULL, 'A table that contains the most-significant bits of statistics counters for ports that are associated with this transparent bridge that are on high-capacity interfaces, as defined in the conformance clauses for this table. This table is provided as a way to read 64-bit counters for agents that support only SNMPv1.  Note that the reporting of most-significant and least-significant counter bits separately runs the risk of missing an overflow of the lower bits in the interval between sampling. The manager must be aware of this possibility, even within the same varbindlist, when interpreting the results of a request or asynchronous notification.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2094, '.1.3.6.1.2.1.17.4.6.1', 'dot1dTpPortOverflowEntry', 2093, 'current', NULL, 'The most significant bits of statistics counters for a high- capacity interface of a transparent bridge. Each object is associated with a corresponding object in dot1dTpPortTable that indicates the least significant bits of the counter.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2095, '.1.3.6.1.2.1.17.4.6.1.1', 'dot1dTpPortInOverflowFrames', 2094, 'current', 'ISO/IEC 15802-3 Section 14.6.1.1.3', 'The number of times the associated dot1dTpPortInFrames counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2096, '.1.3.6.1.2.1.17.4.6.1.2', 'dot1dTpPortOutOverflowFrames', 2094, 'current', 'ISO/IEC 15802-3 Section 14.6.1.1.3', 'The number of times the associated dot1dTpPortOutFrames counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2097, '.1.3.6.1.2.1.17.4.6.1.3', 'dot1dTpPortInOverflowDiscards', 2094, 'current', 'ISO/IEC 15802-3 Section 14.6.1.1.3', 'The number of times the associated dot1dTpPortInDiscards counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2098, '.1.3.6.1.2.1.17.6.1', 'pBridgeMIBObjects', 2087, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2099, '.1.3.6.1.2.1.17.6.1.1', 'dot1dExtBase', 2098, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2100, '.1.3.6.1.2.1.17.6.1.2', 'dot1dPriority', 2098, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2101, '.1.3.6.1.2.1.17.6.1.3', 'dot1dGarp', 2098, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2102, '.1.3.6.1.2.1.17.6.1.4', 'dot1dGmrp', 2098, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2103, '.1.3.6.1.2.1.17.6.1.1.1', 'dot1dDeviceCapabilities', 2099, 'current', NULL, 'Indicates the optional parts of IEEE 802.1D and 802.1Q that are implemented by this device and are manageable through this MIB. Capabilities that are allowed on a per-port basis are indicated in dot1dPortCapabilities.  dot1dExtendedFilteringServices(0),    dot1dTrafficClasses(1),   dot1qStaticEntryIndividualPort(2),    dot1qIVLCapable(3), dot1qSVLCapable(4), dot1qHybridCapable(5),  dot1qConfigurablePvidTagging(6),       dot1dLocalVlanCapable(7)    REFERENCE', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2104, '.1.3.6.1.2.1.17.6.1.1.2', 'dot1dTrafficClassesEnabled', 2099, 'current', NULL, 'The value true(1) indicates that Traffic Classes are enabled on this bridge. When false(2), the bridge operates with a single priority level for all traffic.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2105, '.1.3.6.1.2.1.17.6.1.1.3', 'dot1dGmrpStatus', 2099, 'current', NULL, 'The administrative status requested by management for GMRP. The value enabled(1) indicates that GMRP should be enabled on this device, in all VLANs, on all ports for which it has not been specifically disabled. When disabled(2), GMRP is disabled, in all VLANs and on all ports, and all GMRP packets will be forwarded transparently. This object affects both Applicant and Registrar state machines. A transition from disabled(2) to enabled(1) will cause a reset of all GMRP state machines on all ports.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2106, '.1.3.6.1.2.1.17.6.1.1.4', 'dot1dPortCapabilitiesTable', 2099, 'current', NULL, 'A table that contains capabilities information about every port that is associated with this bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2107, '.1.3.6.1.2.1.17.6.1.1.4.1', 'dot1dPortCapabilitiesEntry', 2106, 'current', NULL, 'A set of capabilities information about this port indexed by dot1dBasePort.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2108, '.1.3.6.1.2.1.17.6.1.1.4.1.1', 'dot1dPortCapabilities', 2107, 'current', NULL, 'Indicates the parts of IEEE 802.1D and 802.1Q that are optional on a per-port basis, that are implemented by this device, and that are manageable through this MIB.  dot1qDot1qTagging(0),  dot1qConfigurableAcceptableFrameTypes(1),   dot1qIngressFiltering(2)      REFERENCE', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2109, '.1.3.6.1.2.1.17.6.1.2.1', 'dot1dPortPriorityTable', 2100, 'current', NULL, 'A table that contains information about every port that is associated with this transparent bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2110, '.1.3.6.1.2.1.17.6.1.2.1.1', 'dot1dPortPriorityEntry', 2109, 'current', NULL, 'A list of Default User Priorities for each port of a transparent bridge. This is indexed by dot1dBasePort.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2111, '.1.3.6.1.2.1.17.6.1.2.1.1.1', 'dot1dPortDefaultUserPriority', 2110, 'current', NULL, 'The default ingress User Priority for this port. This only has effect on media, such as Ethernet, that do not support native User Priority.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2112, '.1.3.6.1.2.1.17.6.1.2.1.1.2', 'dot1dPortNumTrafficClasses', 2110, 'current', NULL, 'The number of egress traffic classes supported on this port. This object may optionally be read-only.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2113, '.1.3.6.1.2.1.17.6.1.2.2', 'dot1dUserPriorityRegenTable', 2100, 'current', 'ISO/IEC 15802-3 Section 6.4', 'A list of Regenerated User Priorities for each received User Priority on each port of a bridge. The Regenerated User Priority value may be used to index the Traffic Class Table for each input port. This only has effect on media that support native User Priority. The default values for Regenerated User Priorities are the same as the User Priorities.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2114, '.1.3.6.1.2.1.17.6.1.2.2.1', 'dot1dUserPriorityRegenEntry', 2113, 'current', NULL, 'A mapping of incoming User Priority to a Regenerated User Priority.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2115, '.1.3.6.1.2.1.17.6.1.2.2.1.1', 'dot1dUserPriority', 2114, 'current', NULL, 'The User Priority for a frame received on this port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2116, '.1.3.6.1.2.1.17.6.1.2.2.1.2', 'dot1dRegenUserPriority', 2114, 'current', NULL, 'The Regenerated User Priority that the incoming User  Priority is mapped to for this port.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2117, '.1.3.6.1.2.1.17.6.1.2.3', 'dot1dTrafficClassTable', 2100, 'current', 'ISO/IEC 15802-3 Table 7-2', 'A table mapping evaluated User Priority to Traffic Class, for forwarding by the bridge. Traffic class is a number in the range (0..(dot1dPortNumTrafficClasses-1)).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2118, '.1.3.6.1.2.1.17.6.1.2.3.1', 'dot1dTrafficClassEntry', 2117, 'current', NULL, 'User Priority to Traffic Class mapping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2119, '.1.3.6.1.2.1.17.6.1.2.3.1.1', 'dot1dTrafficClassPriority', 2118, 'current', NULL, 'The Priority value determined for the received frame. This value is equivalent to the priority indicated in the tagged frame received, or one of the evaluated priorities, determined according to the media-type.  For untagged frames received from Ethernet media, this value is equal to the dot1dPortDefaultUserPriority value for the ingress port.  For untagged frames received from non-Ethernet media, this value is equal to the dot1dRegenUserPriority value for the ingress port and media-specific user priority.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2120, '.1.3.6.1.2.1.17.6.1.2.3.1.2', 'dot1dTrafficClass', 2118, 'current', NULL, 'The Traffic Class the received frame is mapped to.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4587, '.1.3.6.1.2.1.16.2.3.1.17', 'tokenRingMLHistoryBurstErrors', 4570, 'current', NULL, 'The total number of burst errors reported in error reporting packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2121, '.1.3.6.1.2.1.17.6.1.2.4', 'dot1dPortOutboundAccessPriorityTable', 2100, 'current', 'ISO/IEC 15802-3 Table 7-3', 'A table mapping Regenerated User Priority to Outbound Access Priority. This is a fixed mapping for all port types, with two options for 802.5 Token Ring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2122, '.1.3.6.1.2.1.17.6.1.2.4.1', 'dot1dPortOutboundAccessPriorityEntry', 2121, 'current', NULL, 'Regenerated User Priority to Outbound Access Priority mapping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2123, '.1.3.6.1.2.1.17.6.1.2.4.1.1', 'dot1dPortOutboundAccessPriority', 2122, 'current', NULL, 'The Outbound Access Priority the received frame is mapped to.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2124, '.1.3.6.1.2.1.17.6.1.3.1', 'dot1dPortGarpTable', 2101, 'current', NULL, 'A table of GARP control information about every bridge port. This is indexed by dot1dBasePort.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2125, '.1.3.6.1.2.1.17.6.1.3.1.1', 'dot1dPortGarpEntry', 2124, 'current', NULL, 'GARP control information for a bridge port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2126, '.1.3.6.1.2.1.17.6.1.3.1.1.1', 'dot1dPortGarpJoinTime', 2125, 'current', NULL, 'The GARP Join time, in centiseconds.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2127, '.1.3.6.1.2.1.17.6.1.3.1.1.2', 'dot1dPortGarpLeaveTime', 2125, 'current', NULL, 'The GARP Leave time, in centiseconds.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2128, '.1.3.6.1.2.1.17.6.1.3.1.1.3', 'dot1dPortGarpLeaveAllTime', 2125, 'current', NULL, 'The GARP LeaveAll time, in centiseconds.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2129, '.1.3.6.1.2.1.17.6.1.4.1', 'dot1dPortGmrpTable', 2102, 'current', NULL, 'A table of GMRP control and status information about every bridge port. Augments the dot1dBasePortTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2130, '.1.3.6.1.2.1.17.6.1.4.1.1', 'dot1dPortGmrpEntry', 2129, 'current', NULL, 'GMRP control and status information for a bridge port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2131, '.1.3.6.1.2.1.17.6.1.4.1.1.1', 'dot1dPortGmrpStatus', 2130, 'current', NULL, 'The administrative state of GMRP operation on this port. The value enabled(1) indicates that GMRP is enabled on this port in all VLANs as long as dot1dGmrpStatus is also enabled(1). A value of disabled(2) indicates that GMRP is disabled on this port in all VLANs: any GMRP packets received will be silently discarded, and no GMRP registrations will be propagated from other ports. Setting this to a value of enabled(1) will be stored by the agent but will only take effect on the GMRP protocol operation if dot1dGmrpStatus also indicates the value enabled(1). This object affects all GMRP Applicant and Registrar state machines on this port. A transition from disabled(2) to enabled(1) will cause a reset of all GMRP state machines on this port.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2132, '.1.3.6.1.2.1.17.6.1.4.1.1.2', 'dot1dPortGmrpFailedRegistrations', 2130, 'current', NULL, 'The total number of failed GMRP registrations, for any reason, in all VLANs, on this port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2133, '.1.3.6.1.2.1.17.6.1.4.1.1.3', 'dot1dPortGmrpLastPduOrigin', 2130, 'current', NULL, 'The Source MAC Address of the last GMRP message received on this port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2134, '.1.3.6.1.2.1.17.6.1.4.1.1.4', 'dot1dPortRestrictedGroupRegistration', 2130, 'current', 'IEEE 802.1t clause 10.3.2.3, 14.10.1.3.', 'The state of Restricted Group Registration on this port. If the value of this control is true(1), then creation of a new dynamic entry is permitted only if there is a Static Filtering Entry for the VLAN concerned, in which the Registrar Administrative Control value is Normal Registration.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2135, '.1.3.6.1.2.1.17.6.2', 'pBridgeConformance', 2087, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2136, '.1.3.6.1.2.1.17.6.2.1', 'pBridgeGroups', 2135, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2137, '.1.3.6.1.2.1.17.6.2.2', 'pBridgeCompliances', 2135, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2138, '.1.3.6.1.2.1.17.6.2.1.1', 'pBridgeExtCapGroup', 2136, 'current', NULL, 'A collection of objects indicating the optional capabilities of the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2139, '.1.3.6.1.2.1.17.6.2.1.2', 'pBridgeDeviceGmrpGroup', 2136, 'current', NULL, 'A collection of objects providing device-level control for the Multicast Filtering extended bridge services.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2140, '.1.3.6.1.2.1.17.6.2.1.3', 'pBridgeDevicePriorityGroup', 2136, 'current', NULL, 'A collection of objects providing device-level control for the Priority services.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2141, '.1.3.6.1.2.1.17.6.2.1.4', 'pBridgeDefaultPriorityGroup', 2136, 'current', NULL, 'A collection of objects defining the User Priority applicable to each port for media that do not support native User Priority.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2142, '.1.3.6.1.2.1.17.6.2.1.5', 'pBridgeRegenPriorityGroup', 2136, 'current', NULL, 'A collection of objects defining the User Priorities applicable to each port for media that support native User Priority.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2143, '.1.3.6.1.2.1.17.6.2.1.6', 'pBridgePriorityGroup', 2136, 'current', NULL, 'A collection of objects defining the traffic classes within a bridge for each evaluated User Priority.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2144, '.1.3.6.1.2.1.17.6.2.1.7', 'pBridgeAccessPriorityGroup', 2136, 'current', NULL, 'A collection of objects defining the media-dependent outbound access level for each priority.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2145, '.1.3.6.1.2.1.17.6.2.1.8', 'pBridgePortGarpGroup', 2136, 'current', NULL, 'A collection of objects providing port level control and status information for GARP operation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2146, '.1.3.6.1.2.1.17.6.2.1.9', 'pBridgePortGmrpGroup', 2136, 'deprecated', NULL, 'A collection of objects providing port level control and status information for GMRP operation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2147, '.1.3.6.1.2.1.17.6.2.1.10', 'pBridgeHCPortGroup', 2136, 'current', NULL, 'A collection of objects providing 64-bit statistics counters for high-capacity bridge ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2148, '.1.3.6.1.2.1.17.6.2.1.11', 'pBridgePortOverflowGroup', 2136, 'current', NULL, 'A collection of objects providing overflow statistics counters for high-capacity bridge ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2149, '.1.3.6.1.2.1.17.6.2.1.12', 'pBridgePortGmrpGroup2', 2136, 'current', NULL, 'A collection of objects providing port level control and status information for GMRP operation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2150, '.1.3.6.1.2.1.17.6.2.2.1', 'pBridgeCompliance', 2137, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (2151, '.1.3.6.1.2.1.17.6.2.2.2', 'pBridgeCompliance2', 2137, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4518, '.1.3.6.1.2.1.16.10', 'tokenRing', 380, 'current', NULL, 'Remote network monitoring devices, often called monitors or probes, are instruments that exist for the purpose of managing a network. This MIB defines objects for managing remote network monitoring devices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4519, '.1.3.6.1.2.1.16.1.2', 'tokenRingMLStatsTable', 381, 'current', NULL, 'A list of Mac-Layer Token Ring statistics entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4520, '.1.3.6.1.2.1.16.1.2.1', 'tokenRingMLStatsEntry', 4519, 'current', NULL, 'A collection of Mac-Layer statistics kept for a particular Token Ring interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4521, '.1.3.6.1.2.1.16.1.2.1.1', 'tokenRingMLStatsIndex', 4520, 'current', NULL, 'The value of this object uniquely identifies this tokenRingMLStats entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4555, '.1.3.6.1.2.1.16.1.3.1.6', 'tokenRingPStatsDataBroadcastPkts', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were directed to an LLC broadcast address (0xFFFFFFFFFFFF or 0xC000FFFFFFFF).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4556, '.1.3.6.1.2.1.16.1.3.1.7', 'tokenRingPStatsDataMulticastPkts', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were directed to a local or global multicast or functional address. Note that this number does not include packets directed to the broadcast address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6782, '.1.3.6.1.4.1.9.2.2.1.1.94', 'locIflanmanInPkts', 6689, 'mandatory', NULL, 'LanMan protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4522, '.1.3.6.1.2.1.16.1.2.1.2', 'tokenRingMLStatsDataSource', 4520, 'current', NULL, 'This object identifies the source of the data that this tokenRingMLStats entry is configured to analyze. This source can be any tokenRing interface on this device. In order to identify a particular interface, this object shall identify the instance of the ifIndex object, defined in the IF-MIB [17], for the desired interface. For example, if an entry were to receive data from interface #1, this object would be set to ifIndex.1.  The statistics in this group reflect all error reports on the local network segment attached to the identified interface.  This object may not be modified if the associated tokenRingMLStatsStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4523, '.1.3.6.1.2.1.16.1.2.1.3', 'tokenRingMLStatsDropEvents', 4520, 'current', NULL, 'The total number of events in which packets were dropped by the probe due to lack of resources. Note that this number is not necessarily the number of packets dropped; it is just the number of times this condition has been detected. This value is the same as the corresponding tokenRingPStatsDropEvents.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4524, '.1.3.6.1.2.1.16.1.2.1.4', 'tokenRingMLStatsMacOctets', 4520, 'current', NULL, 'The total number of octets of data in MAC packets (excluding those that were not good frames) received on the network (excluding framing bits but including FCS octets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4525, '.1.3.6.1.2.1.16.1.2.1.5', 'tokenRingMLStatsMacPkts', 4520, 'current', NULL, 'The total number of MAC packets (excluding packets that were not good frames) received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4526, '.1.3.6.1.2.1.16.1.2.1.6', 'tokenRingMLStatsRingPurgeEvents', 4520, 'current', NULL, 'The total number of times that the ring enters the ring purge state from normal ring state. The ring purge state that comes in response to the claim token or beacon state is not counted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4527, '.1.3.6.1.2.1.16.1.2.1.7', 'tokenRingMLStatsRingPurgePkts', 4520, 'current', NULL, 'The total number of ring purge MAC packets detected by probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4528, '.1.3.6.1.2.1.16.1.2.1.8', 'tokenRingMLStatsBeaconEvents', 4520, 'current', NULL, 'The total number of times that the ring enters a beaconing state (beaconFrameStreamingState, beaconBitStreamingState, beaconSetRecoveryModeState, or beaconRingSignalLossState) from a non-beaconing state. Note that a change of the source address of the beacon packet does not constitute a new beacon event.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4529, '.1.3.6.1.2.1.16.1.2.1.9', 'tokenRingMLStatsBeaconTime', 4520, 'current', NULL, 'The total amount of time that the ring has been in the beaconing state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4530, '.1.3.6.1.2.1.16.1.2.1.10', 'tokenRingMLStatsBeaconPkts', 4520, 'current', NULL, 'The total number of beacon MAC packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4531, '.1.3.6.1.2.1.16.1.2.1.11', 'tokenRingMLStatsClaimTokenEvents', 4520, 'current', NULL, 'The total number of times that the ring enters the claim token state from normal ring state or ring purge state. The claim token state that comes in response to a beacon state is not counted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4532, '.1.3.6.1.2.1.16.1.2.1.12', 'tokenRingMLStatsClaimTokenPkts', 4520, 'current', NULL, 'The total number of claim token MAC packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4533, '.1.3.6.1.2.1.16.1.2.1.13', 'tokenRingMLStatsNAUNChanges', 4520, 'current', NULL, 'The total number of NAUN changes detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4534, '.1.3.6.1.2.1.16.1.2.1.14', 'tokenRingMLStatsLineErrors', 4520, 'current', NULL, 'The total number of line errors reported in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4535, '.1.3.6.1.2.1.16.1.2.1.15', 'tokenRingMLStatsInternalErrors', 4520, 'current', NULL, 'The total number of adapter internal errors reported in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4536, '.1.3.6.1.2.1.16.1.2.1.16', 'tokenRingMLStatsBurstErrors', 4520, 'current', NULL, 'The total number of burst errors reported in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4537, '.1.3.6.1.2.1.16.1.2.1.17', 'tokenRingMLStatsACErrors', 4520, 'current', NULL, 'The total number of AC (Address Copied) errors reported in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4538, '.1.3.6.1.2.1.16.1.2.1.18', 'tokenRingMLStatsAbortErrors', 4520, 'current', NULL, 'The total number of abort delimiters reported in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4539, '.1.3.6.1.2.1.16.1.2.1.19', 'tokenRingMLStatsLostFrameErrors', 4520, 'current', NULL, 'The total number of lost frame errors reported in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4540, '.1.3.6.1.2.1.16.1.2.1.20', 'tokenRingMLStatsCongestionErrors', 4520, 'current', NULL, 'The total number of receive congestion errors reported in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4541, '.1.3.6.1.2.1.16.1.2.1.21', 'tokenRingMLStatsFrameCopiedErrors', 4520, 'current', NULL, 'The total number of frame copied errors reported in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4542, '.1.3.6.1.2.1.16.1.2.1.22', 'tokenRingMLStatsFrequencyErrors', 4520, 'current', NULL, 'The total number of frequency errors reported in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4543, '.1.3.6.1.2.1.16.1.2.1.23', 'tokenRingMLStatsTokenErrors', 4520, 'current', NULL, 'The total number of token errors reported in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4544, '.1.3.6.1.2.1.16.1.2.1.24', 'tokenRingMLStatsSoftErrorReports', 4520, 'current', NULL, 'The total number of soft error report frames detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4545, '.1.3.6.1.2.1.16.1.2.1.25', 'tokenRingMLStatsRingPollEvents', 4520, 'current', NULL, 'The total number of ring poll events detected by the probe (i.e. the number of ring polls initiated by the active monitor that were detected).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4546, '.1.3.6.1.2.1.16.1.2.1.26', 'tokenRingMLStatsOwner', 4520, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4547, '.1.3.6.1.2.1.16.1.2.1.27', 'tokenRingMLStatsStatus', 4520, 'current', NULL, 'The status of this tokenRingMLStats entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4548, '.1.3.6.1.2.1.16.1.3', 'tokenRingPStatsTable', 381, 'current', NULL, 'A list of promiscuous Token Ring statistics entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4549, '.1.3.6.1.2.1.16.1.3.1', 'tokenRingPStatsEntry', 4548, 'current', NULL, 'A collection of promiscuous statistics kept for non-MAC packets on a particular Token Ring interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4550, '.1.3.6.1.2.1.16.1.3.1.1', 'tokenRingPStatsIndex', 4549, 'current', NULL, 'The value of this object uniquely identifies this tokenRingPStats entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4551, '.1.3.6.1.2.1.16.1.3.1.2', 'tokenRingPStatsDataSource', 4549, 'current', NULL, 'This object identifies the source of the data that this tokenRingPStats entry is configured to analyze. This source can be any tokenRing interface on this device. In order to identify a particular interface, this object shall identify the instance of the ifIndex object, defined in IF- MIB [17], for the desired interface. For example, if an entry were to receive data from interface #1, this object would be set to ifIndex.1.  The statistics in this group reflect all non-MAC packets on the local network segment attached to the identified interface.  This object may not be modified if the associated tokenRingPStatsStatus object is equal to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4552, '.1.3.6.1.2.1.16.1.3.1.3', 'tokenRingPStatsDropEvents', 4549, 'current', NULL, 'The total number of events in which packets were dropped by the probe due to lack of resources. Note that this number is not necessarily the number of packets dropped; it is just the number of times this condition has been detected. This value is the same as the corresponding tokenRingMLStatsDropEvents', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4553, '.1.3.6.1.2.1.16.1.3.1.4', 'tokenRingPStatsDataOctets', 4549, 'current', NULL, 'The total number of octets of data in good frames received on the network (excluding framing bits but including FCS octets) in non-MAC packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4558, '.1.3.6.1.2.1.16.1.3.1.9', 'tokenRingPStatsDataPkts64to127Octets', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were between 64 and 127 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4559, '.1.3.6.1.2.1.16.1.3.1.10', 'tokenRingPStatsDataPkts128to255Octets', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were between 128 and 255 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4560, '.1.3.6.1.2.1.16.1.3.1.11', 'tokenRingPStatsDataPkts256to511Octets', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were between 256 and 511 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4561, '.1.3.6.1.2.1.16.1.3.1.12', 'tokenRingPStatsDataPkts512to1023Octets', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were between 512 and 1023 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4562, '.1.3.6.1.2.1.16.1.3.1.13', 'tokenRingPStatsDataPkts1024to2047Octets', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were between 1024 and 2047 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4563, '.1.3.6.1.2.1.16.1.3.1.14', 'tokenRingPStatsDataPkts2048to4095Octets', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were between 2048 and 4095 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4564, '.1.3.6.1.2.1.16.1.3.1.15', 'tokenRingPStatsDataPkts4096to8191Octets', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were between 4096 and 8191 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4565, '.1.3.6.1.2.1.16.1.3.1.16', 'tokenRingPStatsDataPkts8192to18000Octets', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were between 8192 and 18000 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4566, '.1.3.6.1.2.1.16.1.3.1.17', 'tokenRingPStatsDataPktsGreaterThan18000Octets', 4549, 'current', NULL, 'The total number of non-MAC good frames received that were greater than 18000 octets in length, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4567, '.1.3.6.1.2.1.16.1.3.1.18', 'tokenRingPStatsOwner', 4549, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4568, '.1.3.6.1.2.1.16.1.3.1.19', 'tokenRingPStatsStatus', 4549, 'current', NULL, 'The status of this tokenRingPStats entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4569, '.1.3.6.1.2.1.16.2.3', 'tokenRingMLHistoryTable', 382, 'current', NULL, 'A list of Mac-Layer Token Ring statistics entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4570, '.1.3.6.1.2.1.16.2.3.1', 'tokenRingMLHistoryEntry', 4569, 'current', NULL, 'A collection of Mac-Layer statistics kept for a particular Token Ring interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4571, '.1.3.6.1.2.1.16.2.3.1.1', 'tokenRingMLHistoryIndex', 4570, 'current', NULL, 'The history of which this entry is a part. The history identified by a particular value of this index is the same history as identified by the same value of historyControlIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4572, '.1.3.6.1.2.1.16.2.3.1.2', 'tokenRingMLHistorySampleIndex', 4570, 'current', NULL, 'An index that uniquely identifies the particular Mac-Layer sample this entry represents among all Mac-Layer samples associated with the same historyControlEntry. This index starts at 1 and increases by one as each new sample is taken.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4573, '.1.3.6.1.2.1.16.2.3.1.3', 'tokenRingMLHistoryIntervalStart', 4570, 'current', NULL, 'The value of sysUpTime at the start of the interval over which this sample was measured. If the probe keeps track of the time of day, it should start the first sample of the history at a time such that when the next hour of the day begins, a sample is started at that instant. Note that following this rule may require the probe to delay collecting the first sample of the history, as each sample must be of the same interval. Also note that the sample which is currently being collected is not accessible in this table until the end of its interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4574, '.1.3.6.1.2.1.16.2.3.1.4', 'tokenRingMLHistoryDropEvents', 4570, 'current', NULL, 'The total number of events in which packets were dropped by the probe due to lack of resources during this sampling interval. Note that this number is not necessarily the number of packets dropped, it is just the number of times this condition has been detected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4575, '.1.3.6.1.2.1.16.2.3.1.5', 'tokenRingMLHistoryMacOctets', 4570, 'current', NULL, 'The total number of octets of data in MAC packets (excluding those that were not good frames) received on the network during this sampling interval (excluding framing bits but including FCS octets).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4576, '.1.3.6.1.2.1.16.2.3.1.6', 'tokenRingMLHistoryMacPkts', 4570, 'current', NULL, 'The total number of MAC packets (excluding those that were not good frames) received during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4577, '.1.3.6.1.2.1.16.2.3.1.7', 'tokenRingMLHistoryRingPurgeEvents', 4570, 'current', NULL, 'The total number of times that the ring entered the ring purge state from normal ring state during this sampling interval. The ring purge state that comes from the claim token or beacon state is not counted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4578, '.1.3.6.1.2.1.16.2.3.1.8', 'tokenRingMLHistoryRingPurgePkts', 4570, 'current', NULL, 'The total number of Ring Purge MAC packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4579, '.1.3.6.1.2.1.16.2.3.1.9', 'tokenRingMLHistoryBeaconEvents', 4570, 'current', NULL, 'The total number of times that the ring enters a beaconing state (beaconFrameStreamingState, beaconBitStreamingState, beaconSetRecoveryModeState, or beaconRingSignalLossState) during this sampling interval. Note that a change of the source address of the beacon packet does not constitute a new beacon event.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4580, '.1.3.6.1.2.1.16.2.3.1.10', 'tokenRingMLHistoryBeaconTime', 4570, 'current', NULL, 'The amount of time that the ring has been in the beaconing state during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4581, '.1.3.6.1.2.1.16.2.3.1.11', 'tokenRingMLHistoryBeaconPkts', 4570, 'current', NULL, 'The total number of beacon MAC packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4582, '.1.3.6.1.2.1.16.2.3.1.12', 'tokenRingMLHistoryClaimTokenEvents', 4570, 'current', NULL, 'The total number of times that the ring enters the claim token state from normal ring state or ring purge state during this sampling interval. The claim token state that comes from the beacon state is not counted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4583, '.1.3.6.1.2.1.16.2.3.1.13', 'tokenRingMLHistoryClaimTokenPkts', 4570, 'current', NULL, 'The total number of claim token MAC packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4584, '.1.3.6.1.2.1.16.2.3.1.14', 'tokenRingMLHistoryNAUNChanges', 4570, 'current', NULL, 'The total number of NAUN changes detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4585, '.1.3.6.1.2.1.16.2.3.1.15', 'tokenRingMLHistoryLineErrors', 4570, 'current', NULL, 'The total number of line errors reported in error reporting packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4586, '.1.3.6.1.2.1.16.2.3.1.16', 'tokenRingMLHistoryInternalErrors', 4570, 'current', NULL, 'The total number of adapter internal errors reported in error reporting packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4588, '.1.3.6.1.2.1.16.2.3.1.18', 'tokenRingMLHistoryACErrors', 4570, 'current', NULL, 'The total number of AC (Address Copied) errors reported in error reporting packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4618, '.1.3.6.1.2.1.16.10.1', 'ringStationControlTable', 4518, 'current', NULL, 'A list of ringStation table control entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4589, '.1.3.6.1.2.1.16.2.3.1.19', 'tokenRingMLHistoryAbortErrors', 4570, 'current', NULL, 'The total number of abort delimiters reported in error reporting packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4590, '.1.3.6.1.2.1.16.2.3.1.20', 'tokenRingMLHistoryLostFrameErrors', 4570, 'current', NULL, 'The total number of lost frame errors reported in error reporting packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4591, '.1.3.6.1.2.1.16.2.3.1.21', 'tokenRingMLHistoryCongestionErrors', 4570, 'current', NULL, 'The total number of receive congestion errors reported in error reporting packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4592, '.1.3.6.1.2.1.16.2.3.1.22', 'tokenRingMLHistoryFrameCopiedErrors', 4570, 'current', NULL, 'The total number of frame copied errors reported in error reporting packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4593, '.1.3.6.1.2.1.16.2.3.1.23', 'tokenRingMLHistoryFrequencyErrors', 4570, 'current', NULL, 'The total number of frequency errors reported in error reporting packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4594, '.1.3.6.1.2.1.16.2.3.1.24', 'tokenRingMLHistoryTokenErrors', 4570, 'current', NULL, 'The total number of token errors reported in error reporting packets detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4595, '.1.3.6.1.2.1.16.2.3.1.25', 'tokenRingMLHistorySoftErrorReports', 4570, 'current', NULL, 'The total number of soft error report frames detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4596, '.1.3.6.1.2.1.16.2.3.1.26', 'tokenRingMLHistoryRingPollEvents', 4570, 'current', NULL, 'The total number of ring poll events detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4597, '.1.3.6.1.2.1.16.2.3.1.27', 'tokenRingMLHistoryActiveStations', 4570, 'current', NULL, 'The maximum number of active stations on the ring detected by the probe during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4598, '.1.3.6.1.2.1.16.2.4', 'tokenRingPHistoryTable', 382, 'current', NULL, 'A list of promiscuous Token Ring statistics entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4599, '.1.3.6.1.2.1.16.2.4.1', 'tokenRingPHistoryEntry', 4598, 'current', NULL, 'A collection of promiscuous statistics kept for a particular Token Ring interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4600, '.1.3.6.1.2.1.16.2.4.1.1', 'tokenRingPHistoryIndex', 4599, 'current', NULL, 'The history of which this entry is a part. The history identified by a particular value of this index is the same history as identified by the same value of historyControlIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4601, '.1.3.6.1.2.1.16.2.4.1.2', 'tokenRingPHistorySampleIndex', 4599, 'current', NULL, 'An index that uniquely identifies the particular sample this entry represents among all samples associated with the same historyControlEntry. This index starts at 1 and increases by one as each new sample is taken.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4602, '.1.3.6.1.2.1.16.2.4.1.3', 'tokenRingPHistoryIntervalStart', 4599, 'current', NULL, 'The value of sysUpTime at the start of the interval over which this sample was measured. If the probe keeps track of the time of day, it should start the first sample of the history at a time such that when the next hour of the day begins, a sample is started at that instant. Note that following this rule may require the probe to delay collecting the first sample of the history, as each sample must be of the same interval. Also note that the sample which is currently being collected is not accessible in this table until the end of its interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4603, '.1.3.6.1.2.1.16.2.4.1.4', 'tokenRingPHistoryDropEvents', 4599, 'current', NULL, 'The total number of events in which packets were dropped by the probe due to lack of resources during this sampling interval. Note that this number is not necessarily the number of packets dropped, it is just the number of times this condition has been detected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4604, '.1.3.6.1.2.1.16.2.4.1.5', 'tokenRingPHistoryDataOctets', 4599, 'current', NULL, 'The total number of octets of data in good frames received on the network (excluding framing bits but including FCS octets) in non-MAC packets during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4605, '.1.3.6.1.2.1.16.2.4.1.6', 'tokenRingPHistoryDataPkts', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4606, '.1.3.6.1.2.1.16.2.4.1.7', 'tokenRingPHistoryDataBroadcastPkts', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were directed to an LLC broadcast address (0xFFFFFFFFFFFF or 0xC000FFFFFFFF).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4607, '.1.3.6.1.2.1.16.2.4.1.8', 'tokenRingPHistoryDataMulticastPkts', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were directed to a local or global multicast or functional address. Note that this number does not include packets directed to the broadcast address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4608, '.1.3.6.1.2.1.16.2.4.1.9', 'tokenRingPHistoryDataPkts18to63Octets', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were between 18 and 63 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4609, '.1.3.6.1.2.1.16.2.4.1.10', 'tokenRingPHistoryDataPkts64to127Octets', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were between 64 and 127 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4610, '.1.3.6.1.2.1.16.2.4.1.11', 'tokenRingPHistoryDataPkts128to255Octets', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were between 128 and 255 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4611, '.1.3.6.1.2.1.16.2.4.1.12', 'tokenRingPHistoryDataPkts256to511Octets', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were between 256 and 511 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4612, '.1.3.6.1.2.1.16.2.4.1.13', 'tokenRingPHistoryDataPkts512to1023Octets', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were between 512 and 1023 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4613, '.1.3.6.1.2.1.16.2.4.1.14', 'tokenRingPHistoryDataPkts1024to2047Octets', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were between 1024 and 2047 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4614, '.1.3.6.1.2.1.16.2.4.1.15', 'tokenRingPHistoryDataPkts2048to4095Octets', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were between 2048 and 4095 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4615, '.1.3.6.1.2.1.16.2.4.1.16', 'tokenRingPHistoryDataPkts4096to8191Octets', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were between 4096 and 8191 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4616, '.1.3.6.1.2.1.16.2.4.1.17', 'tokenRingPHistoryDataPkts8192to18000Octets', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were between 8192 and 18000 octets in length inclusive, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4617, '.1.3.6.1.2.1.16.2.4.1.18', 'tokenRingPHistoryDataPktsGreaterThan18000Octets', 4599, 'current', NULL, 'The total number of non-MAC good frames received during this sampling interval that were greater than 18000 octets in length, excluding framing bits but including FCS octets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4619, '.1.3.6.1.2.1.16.10.1.1', 'ringStationControlEntry', 4618, 'current', NULL, 'A list of parameters that set up the discovery of stations on a particular interface and the collection of statistics about these stations.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4620, '.1.3.6.1.2.1.16.10.1.1.1', 'ringStationControlIfIndex', 4619, 'current', NULL, 'The value of this object uniquely identifies the interface on this remote network monitoring device from which ringStation data is collected. The interface identified by a particular value of this object is the same interface as identified by the same value of the ifIndex object, defined in IF- MIB [17].', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4621, '.1.3.6.1.2.1.16.10.1.1.2', 'ringStationControlTableSize', 4619, 'current', NULL, 'The number of ringStationEntries in the ringStationTable associated with this ringStationControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4622, '.1.3.6.1.2.1.16.10.1.1.3', 'ringStationControlActiveStations', 4619, 'current', NULL, 'The number of active ringStationEntries in the ringStationTable associated with this ringStationControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4623, '.1.3.6.1.2.1.16.10.1.1.4', 'ringStationControlRingState', 4619, 'current', NULL, 'The current status of this ring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4624, '.1.3.6.1.2.1.16.10.1.1.5', 'ringStationControlBeaconSender', 4619, 'current', NULL, 'The address of the sender of the last beacon frame received by the probe on this ring. If no beacon frames have been received, this object shall be equal to six octets of zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4625, '.1.3.6.1.2.1.16.10.1.1.6', 'ringStationControlBeaconNAUN', 4619, 'current', NULL, 'The address of the NAUN in the last beacon frame received by the probe on this ring. If no beacon frames have been received, this object shall be equal to six octets of zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4626, '.1.3.6.1.2.1.16.10.1.1.7', 'ringStationControlActiveMonitor', 4619, 'current', NULL, 'The address of the Active Monitor on this segment. If this address is unknown, this object shall be equal to six octets of zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4627, '.1.3.6.1.2.1.16.10.1.1.8', 'ringStationControlOrderChanges', 4619, 'current', NULL, 'The number of add and delete events in the ringStationOrderTable optionally associated with this ringStationControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4628, '.1.3.6.1.2.1.16.10.1.1.9', 'ringStationControlOwner', 4619, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4629, '.1.3.6.1.2.1.16.10.1.1.10', 'ringStationControlStatus', 4619, 'current', NULL, 'The status of this ringStationControl entry.  If this object is not equal to valid(1), all associated entries in the ringStationTable shall be deleted by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4630, '.1.3.6.1.2.1.16.10.2', 'ringStationTable', 4518, 'current', NULL, 'A list of ring station entries. An entry will exist for each station that is now or has previously been detected as physically present on this ring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4631, '.1.3.6.1.2.1.16.10.2.1', 'ringStationEntry', 4630, 'current', NULL, 'A collection of statistics for a particular station that has been discovered on a ring monitored by this device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4632, '.1.3.6.1.2.1.16.10.2.1.1', 'ringStationIfIndex', 4631, 'current', NULL, 'The value of this object uniquely identifies the interface on this remote network monitoring device on which this station was detected. The interface identified by a particular value of this object is the same interface as identified by the same value of the ifIndex object, defined in IF-MIB [17].', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4633, '.1.3.6.1.2.1.16.10.2.1.2', 'ringStationMacAddress', 4631, 'current', NULL, 'The physical address of this station.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4634, '.1.3.6.1.2.1.16.10.2.1.3', 'ringStationLastNAUN', 4631, 'current', NULL, 'The physical address of last known NAUN of this station.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4635, '.1.3.6.1.2.1.16.10.2.1.4', 'ringStationStationStatus', 4631, 'current', NULL, 'The status of this station on the ring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4636, '.1.3.6.1.2.1.16.10.2.1.5', 'ringStationLastEnterTime', 4631, 'current', NULL, 'The value of sysUpTime at the time this station last entered the ring. If the time is unknown, this value shall be zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4637, '.1.3.6.1.2.1.16.10.2.1.6', 'ringStationLastExitTime', 4631, 'current', NULL, 'The value of sysUpTime at the time the probe detected that this station last exited the ring. If the time is unknown, this value shall be zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4638, '.1.3.6.1.2.1.16.10.2.1.7', 'ringStationDuplicateAddresses', 4631, 'current', NULL, 'The number of times this station experienced a duplicate address error.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4639, '.1.3.6.1.2.1.16.10.2.1.8', 'ringStationInLineErrors', 4631, 'current', NULL, 'The total number of line errors reported by this station in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4640, '.1.3.6.1.2.1.16.10.2.1.9', 'ringStationOutLineErrors', 4631, 'current', NULL, 'The total number of line errors reported in error reporting packets sent by the nearest active downstream neighbor of this station and detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4641, '.1.3.6.1.2.1.16.10.2.1.10', 'ringStationInternalErrors', 4631, 'current', NULL, 'The total number of adapter internal errors reported by this station in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4642, '.1.3.6.1.2.1.16.10.2.1.11', 'ringStationInBurstErrors', 4631, 'current', NULL, 'The total number of burst errors reported by this station in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4643, '.1.3.6.1.2.1.16.10.2.1.12', 'ringStationOutBurstErrors', 4631, 'current', NULL, 'The total number of burst errors reported in error reporting packets sent by the nearest active downstream neighbor of this station and detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4644, '.1.3.6.1.2.1.16.10.2.1.13', 'ringStationACErrors', 4631, 'current', NULL, 'The total number of AC (Address Copied) errors reported in error reporting packets sent by the nearest active downstream neighbor of this station and detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4645, '.1.3.6.1.2.1.16.10.2.1.14', 'ringStationAbortErrors', 4631, 'current', NULL, 'The total number of abort delimiters reported by this station in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4646, '.1.3.6.1.2.1.16.10.2.1.15', 'ringStationLostFrameErrors', 4631, 'current', NULL, 'The total number of lost frame errors reported by this station in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4647, '.1.3.6.1.2.1.16.10.2.1.16', 'ringStationCongestionErrors', 4631, 'current', NULL, 'The total number of receive congestion errors reported by this station in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4648, '.1.3.6.1.2.1.16.10.2.1.17', 'ringStationFrameCopiedErrors', 4631, 'current', NULL, 'The total number of frame copied errors reported by this station in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4649, '.1.3.6.1.2.1.16.10.2.1.18', 'ringStationFrequencyErrors', 4631, 'current', NULL, 'The total number of frequency errors reported by this station in error reporting packets detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4650, '.1.3.6.1.2.1.16.10.2.1.19', 'ringStationTokenErrors', 4631, 'current', NULL, 'The total number of token errors reported by this station in error reporting frames detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4651, '.1.3.6.1.2.1.16.10.2.1.20', 'ringStationInBeaconErrors', 4631, 'current', NULL, 'The total number of beacon frames sent by this station and detected by the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4652, '.1.3.6.1.2.1.16.10.2.1.21', 'ringStationOutBeaconErrors', 4631, 'current', NULL, 'The total number of beacon frames detected by the probe that name this station as the NAUN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4655, '.1.3.6.1.2.1.16.10.3.1', 'ringStationOrderEntry', 4654, 'current', NULL, 'A collection of statistics for a particular station that is active on a ring monitored by this device. If implemented, this table will contain information for every interface that has a ringStationControlStatus equal to valid.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6783, '.1.3.6.1.4.1.9.2.2.1.1.95', 'locIflanmanOutPkts', 6689, 'mandatory', NULL, 'LanMan protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4656, '.1.3.6.1.2.1.16.10.3.1.1', 'ringStationOrderIfIndex', 4655, 'current', NULL, 'The value of this object uniquely identifies the interface on this remote network monitoring device on which this station was detected. The interface identified by a particular value of this object is the same interface as identified by the same value of the ifIndex object, defined in IF-MIB [17].', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4657, '.1.3.6.1.2.1.16.10.3.1.2', 'ringStationOrderOrderIndex', 4655, 'current', NULL, 'This index denotes the location of this station with respect to other stations on the ring. This index is one more than the number of hops downstream that this station is from the rmon probe. The rmon probe itself gets the value one.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4658, '.1.3.6.1.2.1.16.10.3.1.3', 'ringStationOrderMacAddress', 4655, 'current', NULL, 'The physical address of this station.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4659, '.1.3.6.1.2.1.16.10.4', 'ringStationConfigControlTable', 4518, 'current', NULL, 'A list of ring station configuration control entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4660, '.1.3.6.1.2.1.16.10.4.1', 'ringStationConfigControlEntry', 4659, 'current', NULL, 'This entry controls active management of stations by the probe. One entry exists in this table for each active station in the ringStationTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4661, '.1.3.6.1.2.1.16.10.4.1.1', 'ringStationConfigControlIfIndex', 4660, 'current', NULL, 'The value of this object uniquely identifies the interface on this remote network monitoring device on which this station was detected. The interface identified by a particular value of this object is the same interface as identified by the same value of the ifIndex object, defined in IF-MIB [17].', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4662, '.1.3.6.1.2.1.16.10.4.1.2', 'ringStationConfigControlMacAddress', 4660, 'current', NULL, 'The physical address of this station.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4663, '.1.3.6.1.2.1.16.10.4.1.3', 'ringStationConfigControlRemove', 4660, 'current', NULL, 'Setting this object to `removing(2)'' causes a Remove Station MAC frame to be sent. The agent will set this object to `stable(1)'' after processing the request.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4664, '.1.3.6.1.2.1.16.10.4.1.4', 'ringStationConfigControlUpdateStats', 4660, 'current', NULL, 'Setting this object to `updating(2)'' causes the configuration information associate with this entry to be updated. The agent will set this object to `stable(1)'' after processing the request.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4665, '.1.3.6.1.2.1.16.10.5', 'ringStationConfigTable', 4518, 'current', NULL, 'A list of configuration entries for stations on a ring monitored by this probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4666, '.1.3.6.1.2.1.16.10.5.1', 'ringStationConfigEntry', 4665, 'current', NULL, 'A collection of statistics for a particular station that has been discovered on a ring monitored by this probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4667, '.1.3.6.1.2.1.16.10.5.1.1', 'ringStationConfigIfIndex', 4666, 'current', NULL, 'The value of this object uniquely identifies the interface on this remote network monitoring device on which this station was detected. The interface identified by a particular value of this object is the same interface as identified by the same value of the ifIndex object, defined in IF-MIB [17].', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4668, '.1.3.6.1.2.1.16.10.5.1.2', 'ringStationConfigMacAddress', 4666, 'current', NULL, 'The physical address of this station.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4669, '.1.3.6.1.2.1.16.10.5.1.3', 'ringStationConfigUpdateTime', 4666, 'current', NULL, 'The value of sysUpTime at the time this configuration information was last updated (completely).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4670, '.1.3.6.1.2.1.16.10.5.1.4', 'ringStationConfigLocation', 4666, 'current', NULL, 'The assigned physical location of this station.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4671, '.1.3.6.1.2.1.16.10.5.1.5', 'ringStationConfigMicrocode', 4666, 'current', NULL, 'The microcode EC level of this station.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4672, '.1.3.6.1.2.1.16.10.5.1.6', 'ringStationConfigGroupAddress', 4666, 'current', NULL, 'The low-order 4 octets of the group address recognized by this station.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4673, '.1.3.6.1.2.1.16.10.5.1.7', 'ringStationConfigFunctionalAddress', 4666, 'current', NULL, 'the functional addresses recognized by this station.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4674, '.1.3.6.1.2.1.16.10.6', 'sourceRoutingStatsTable', 4518, 'current', NULL, 'A list of source routing statistics entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4675, '.1.3.6.1.2.1.16.10.6.1', 'sourceRoutingStatsEntry', 4674, 'current', NULL, 'A collection of source routing statistics kept for a particular Token Ring interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4676, '.1.3.6.1.2.1.16.10.6.1.1', 'sourceRoutingStatsIfIndex', 4675, 'current', NULL, 'The value of this object uniquely identifies the interface on this remote network monitoring device on which source routing statistics will be detected. The interface identified by a particular value of this object is the same interface as identified by the same value of the ifIndex object, defined in IF-MIB [17].', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4677, '.1.3.6.1.2.1.16.10.6.1.2', 'sourceRoutingStatsRingNumber', 4675, 'current', NULL, 'The ring number of the ring monitored by this entry. When any object in this entry is created, the probe will attempt to discover the ring number. Only after the ring number is discovered will this object be created. After creating an object in this entry, the management station should poll this object to detect when it is created. Only after this object is created can the management station set the sourceRoutingStatsStatus entry to valid(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4678, '.1.3.6.1.2.1.16.10.6.1.3', 'sourceRoutingStatsInFrames', 4675, 'current', NULL, 'The count of frames sent into this ring from another ring that were not All Routes Broadcasts or Single Route Broadcast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4679, '.1.3.6.1.2.1.16.10.6.1.4', 'sourceRoutingStatsOutFrames', 4675, 'current', NULL, 'The count of frames sent from this ring to another ring that were not All Routes Broadcasts or Single Route Broadcast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4680, '.1.3.6.1.2.1.16.10.6.1.5', 'sourceRoutingStatsThroughFrames', 4675, 'current', NULL, 'The count of frames sent from another ring, through this ring, to another ring that were not All Routes Broadcasts or Single Route Broadcast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4681, '.1.3.6.1.2.1.16.10.6.1.6', 'sourceRoutingStatsAllRoutesBroadcastFrames', 4675, 'current', NULL, 'The total number of good frames received that were All Routes Broadcast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4682, '.1.3.6.1.2.1.16.10.6.1.7', 'sourceRoutingStatsSingleRouteBroadcastFrames', 4675, 'current', NULL, 'The total number of good frames received that were Single Route Broadcast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4683, '.1.3.6.1.2.1.16.10.6.1.8', 'sourceRoutingStatsInOctets', 4675, 'current', NULL, 'The count of octets in good frames sent into this ring from another ring that were not All Routes Broadcasts or Single Route Broadcast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4684, '.1.3.6.1.2.1.16.10.6.1.9', 'sourceRoutingStatsOutOctets', 4675, 'current', NULL, 'The count of octets in good frames sent from this ring to another ring that were not All Routes Broadcasts or Single Route Broadcast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4685, '.1.3.6.1.2.1.16.10.6.1.10', 'sourceRoutingStatsThroughOctets', 4675, 'current', NULL, 'The count of octets in good frames sent another ring, through this ring, to another ring that were not All Routes Broadcasts or Single Route Broadcast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4686, '.1.3.6.1.2.1.16.10.6.1.11', 'sourceRoutingStatsAllRoutesBroadcastOctets', 4675, 'current', NULL, 'The total number of octets in good frames received that were All Routes Broadcast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4687, '.1.3.6.1.2.1.16.10.6.1.12', 'sourceRoutingStatsSingleRoutesBroadcastOctets', 4675, 'current', NULL, 'The total number of octets in good frames received that were Single Route Broadcast.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6376, '.1.3.6.1.2.1.15.4', 'bgpIdentifier', 6347, 'current', NULL, 'The BGP Identifier of local system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4688, '.1.3.6.1.2.1.16.10.6.1.13', 'sourceRoutingStatsLocalLLCFrames', 4675, 'current', NULL, 'The total number of frames received which had no RIF field (or had a RIF field that only included the local ring''s number) and were not All Route Broadcast Frames or Single Route Broadcast Frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4689, '.1.3.6.1.2.1.16.10.6.1.14', 'sourceRoutingStats1HopFrames', 4675, 'current', NULL, 'The total number of frames received whose route had 1 hop, were not All Route Broadcast Frames or Single Route Broadcast Frames, and whose source or destination were on this ring (i.e. frames that had a RIF field and had this ring number in the first or last entry of the RIF field).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4690, '.1.3.6.1.2.1.16.10.6.1.15', 'sourceRoutingStats2HopsFrames', 4675, 'current', NULL, 'The total number of frames received whose route had 2 hops, were not All Route Broadcast Frames or Single Route Broadcast Frames, and whose source or destination were on this ring (i.e. frames that had a RIF field and had this ring number in the first or last entry of the RIF field).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4691, '.1.3.6.1.2.1.16.10.6.1.16', 'sourceRoutingStats3HopsFrames', 4675, 'current', NULL, 'The total number of frames received whose route had 3 hops, were not All Route Broadcast Frames or Single Route Broadcast Frames, and whose source or destination were on this ring (i.e. frames that had a RIF field and had this ring number in the first or last entry of the RIF field).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4692, '.1.3.6.1.2.1.16.10.6.1.17', 'sourceRoutingStats4HopsFrames', 4675, 'current', NULL, 'The total number of frames received whose route had 4 hops, were not All Route Broadcast Frames or Single Route Broadcast Frames, and whose source or destination were on this ring (i.e. frames that had a RIF field and had this ring number in the first or last entry of the RIF field).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4693, '.1.3.6.1.2.1.16.10.6.1.18', 'sourceRoutingStats5HopsFrames', 4675, 'current', NULL, 'The total number of frames received whose route had 5 hops, were not All Route Broadcast Frames or Single Route Broadcast Frames, and whose source or destination were on this ring (i.e. frames that had a RIF field and had this ring number in the first or last entry of the RIF field).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4694, '.1.3.6.1.2.1.16.10.6.1.19', 'sourceRoutingStats6HopsFrames', 4675, 'current', NULL, 'The total number of frames received whose route had 6 hops, were not All Route Broadcast Frames or Single Route Broadcast Frames, and whose source or destination were on this ring (i.e. frames that had a RIF field and had this ring number in the first or last entry of the RIF field).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4695, '.1.3.6.1.2.1.16.10.6.1.20', 'sourceRoutingStats7HopsFrames', 4675, 'current', NULL, 'The total number of frames received whose route had 7 hops, were not All Route Broadcast Frames or Single Route Broadcast Frames, and whose source or destination were on this ring (i.e. frames that had a RIF field and had this ring number in the first or last entry of the RIF field).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4696, '.1.3.6.1.2.1.16.10.6.1.21', 'sourceRoutingStats8HopsFrames', 4675, 'current', NULL, 'The total number of frames received whose route had 8 hops, were not All Route Broadcast Frames or Single Route Broadcast Frames, and whose source or destination were on this ring (i.e. frames that had a RIF field and had this ring number in the first or last entry of the RIF field).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4697, '.1.3.6.1.2.1.16.10.6.1.22', 'sourceRoutingStatsMoreThan8HopsFrames', 4675, 'current', NULL, 'The total number of frames received whose route had more than 8 hops, were not All Route Broadcast Frames or Single Route Broadcast Frames, and whose source or destination were on this ring (i.e. frames that had a RIF field and had this ring number in the first or last entry of the RIF field).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4698, '.1.3.6.1.2.1.16.10.6.1.23', 'sourceRoutingStatsOwner', 4675, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4699, '.1.3.6.1.2.1.16.10.6.1.24', 'sourceRoutingStatsStatus', 4675, 'current', NULL, 'The status of this sourceRoutingStats entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4700, '.1.3.6.1.2.1.16.11', 'protocolDir', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4701, '.1.3.6.1.2.1.16.12', 'protocolDist', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4702, '.1.3.6.1.2.1.16.13', 'addressMap', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4703, '.1.3.6.1.2.1.16.14', 'nlHost', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4704, '.1.3.6.1.2.1.16.15', 'nlMatrix', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4705, '.1.3.6.1.2.1.16.16', 'alHost', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4706, '.1.3.6.1.2.1.16.17', 'alMatrix', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4707, '.1.3.6.1.2.1.16.18', 'usrHistory', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4708, '.1.3.6.1.2.1.16.19', 'probeConfig', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4709, '.1.3.6.1.2.1.16.20', 'rmonConformance', 380, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4710, '.1.3.6.1.2.1.16.11.1', 'SYNTAX', 4700, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4711, '.1.3.6.1.2.1.16.11.2', 'protocolDirTable', 4700, 'current', NULL, 'This table lists the protocols that this agent has the capability to decode and count. There is one entry in this table for each such protocol. These protocols represent different network layer, transport layer, and higher-layer protocols. The agent should boot up with this table preconfigured with those protocols that it knows about and wishes to monitor. Implementations are strongly encouraged to support protocols higher than the network layer (at least for the protocol distribution group), even for implementations that don''t support the application layer groups.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4712, '.1.3.6.1.2.1.16.11.2.1', 'protocolDirEntry', 4711, 'current', NULL, 'A conceptual row in the protocolDirTable.  An example of the indexing of this entry is protocolDirLocalIndex.8.0.0.0.1.0.0.8.0.2.0.0, which is the encoding of a length of 8, followed by 8 subids encoding the protocolDirID of 1.2048, followed by a length of 2 and the 2 subids encoding zero-valued parameters.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4713, '.1.3.6.1.2.1.16.11.2.1.1', 'protocolDirID', 4712, 'current', NULL, 'A unique identifier for a particular protocol. Standard identifiers will be defined in a manner such that they can often be used as specifications for new protocols - i.e. a tree-structured assignment mechanism that matches the protocol encapsulation `tree'' and which has algorithmic assignment mechanisms for certain subtrees. See RFC XXX for more details.  Despite the algorithmic mechanism, the probe will only place entries in here for those protocols it chooses to collect. In other words, it need not populate this table with all of the possible ethernet protocol types, nor need it create them on the fly when it sees them. Whether or not it does these things is a matter of product definition (cost/benefit, usability), and is up to the designer of the product.  If an entry is written to this table with a protocolDirID that the agent doesn''t understand, either directly or algorithmically, the SET request will be rejected with an inconsistentName or badValue (for SNMPv1) error.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4714, '.1.3.6.1.2.1.16.11.2.1.2', 'protocolDirParameters', 4712, 'current', NULL, 'A set of parameters for the associated protocolDirID. See the associated RMON2 Protocol Identifiers document for a description of the possible parameters. There will be one octet in this string for each sub-identifier in the protocolDirID, and the parameters will appear here in the same order as the associated sub-identifiers appear in the protocolDirID.  Every node in the protocolDirID tree has a different, optional set of parameters defined (that is, the definition of parameters for a node is optional). The proper parameter value for each node is included in this string. Note that the inclusion of a parameter value in this string for each node is not optional - what is optional is that a node may have no parameters defined, in which case the parameter field for that node will be zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4724, '.1.3.6.1.2.1.16.12.1.1', 'protocolDistControlEntry', 4723, 'current', NULL, 'A conceptual row in the protocolDistControlTable.  An example of the indexing of this entry is      protocolDistControlDroppedFrames.7', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4725, '.1.3.6.1.2.1.16.12.1.1.1', 'protocolDistControlIndex', 4724, 'current', NULL, 'A unique index for this protocolDistControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4715, '.1.3.6.1.2.1.16.11.2.1.3', 'protocolDirLocalIndex', 4712, 'current', NULL, 'The locally arbitrary, but unique identifier associated with this protocolDir entry.  The value for each supported protocol must remain constant at least from one re-initialization of the entity''s network management system to the next re-initialization, except that if a protocol is deleted and re-created, it must be re-created with a new value that has not been used since the last re-initialization.  The specific value is meaningful only within a given SNMP entity. A protocolDirLocalIndex must not be re-used until the next agent-restart in the event the protocol directory entry is deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4716, '.1.3.6.1.2.1.16.11.2.1.4', 'protocolDirDescr', 4712, 'current', NULL, 'A textual description of the protocol encapsulation. A probe may choose to describe only a subset of the entire encapsulation (e.g. only the highest layer).  This object is intended for human consumption only.  This object may not be modified if the associated protocolDirStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4717, '.1.3.6.1.2.1.16.11.2.1.5', 'protocolDirType', 4712, 'current', NULL, 'This object describes 2 attributes of this protocol directory entry.  The presence or absence of the `extensible'' bit describes whether or not this protocol directory entry can be extended      by the user by creating protocol directory entries which are children of this protocol.  An example of an entry that will often allow extensibility is `ip.udp''. The probe may automatically populate some children of this node such as `ip.udp.snmp'' and `ip.udp.dns''. A probe administrator or user may also populate additional children via remote SNMP requests that create entries in this table. When a child node is added for a protocol for which the probe has no built in support, extending a parent node (for which the probe does have built in support), that child node is not extendible. This is termed `limited extensibility''.  When a child node is added through this extensibility mechanism, the values of protocolDirLocalIndex and protocolDirType shall be assigned by the agent.  The other objects in the entry will be assigned by the manager who is creating the new entry.  This object also describes whether or not this agent can recognize addresses for this protocol, should it be a network level protocol. That is, while a probe may be able to recognize packets of a particular network layer protocol and count them, it takes additional logic to be able to recognize the addresses in this protocol and to populate network layer or application layer tables with the addresses in this protocol. If this bit is set, the agent will recognize network layer addresses for this protoocl and populate the network and application layer host and matrix tables with these protocols.  Note that when an entry is created, the agent will supply values for the bits that match the capabilities of the agent with respect to this protocol. Note that since row creations usually exercise the limited extensibility feature, these bits will usually be set to zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4718, '.1.3.6.1.2.1.16.11.2.1.6', 'protocolDirAddressMapConfig', 4712, 'current', NULL, 'This object describes and configures the probe''s support for address mapping for this protocol. When the probe creates entries in this table for all protocols that it understands, it will set the entry to notSupported(1) if it doesn''t have the capability to perform address mapping for the protocol or if this protocol is not a network-layer protocol. When an entry is created in this table by a management operation as part of the limited extensibility feature, the probe must set this value to notSupported(1), because limited extensibility of the protocolDirTable does not extend to interpreting addresses of the extended protocols.  If the value of this object is notSupported(1), the probe will not perform address mapping for this protocol and shall not allow this object to be changed to any other value. If the value of this object is supportedOn(3), the probe supports address mapping for this protocol and is configured to perform address mapping for this protocol for all addressMappingControlEntries and all interfaces. If the value of this object is supportedOff(2), the probe supports address mapping for this protocol but is configured to not perform address mapping for this protocol for any addressMappingControlEntries and all interfaces. Whenever this value changes from supportedOn(3) to supportedOff(2), the probe shall delete all related entries in the addressMappingTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4719, '.1.3.6.1.2.1.16.11.2.1.7', 'protocolDirHostConfig', 4712, 'current', NULL, 'This object describes and configures the probe''s support for the network layer and application layer host tables for this protocol. When the probe creates entries in this table for all protocols that it understands, it will set the entry to notSupported(1) if it doesn''t have the capability to track the nlHostTable for this protocol or if the alHostTable is implemented but doesn''t have the capability to track this protocol. Note that if the alHostTable is implemented, the probe may only support a protocol if it is supported in both the nlHostTable and the alHostTable.      If the associated protocolDirType object has the addressRecognitionCapable bit set, then this is a network layer protocol for which the probe recognizes addresses, and thus the probe will populate the nlHostTable and alHostTable with addresses it discovers for this protocol.  If the value of this object is notSupported(1), the probe will not track the nlHostTable or alHostTable for this protocol and shall not allow this object to be changed to any other value. If the value of this object is supportedOn(3), the probe supports tracking of the nlHostTable and alHostTable for this protocol and is configured to track both tables for this protocol for all control entries and all interfaces. If the value of this object is supportedOff(2), the probe supports tracking of the nlHostTable and alHostTable for this protocol but is configured to not track these tables for any control entries or interfaces. Whenever this value changes from supportedOn(3) to supportedOff(2), the probe shall delete all related entries in the nlHostTable and alHostTable.  Note that since each alHostEntry references 2 protocol directory entries, one for the network address and one for the type of the highest protocol recognized, that an entry will only be created in that table if this value is supportedOn(3) for both protocols.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4720, '.1.3.6.1.2.1.16.11.2.1.8', 'protocolDirMatrixConfig', 4712, 'current', NULL, 'This object describes and configures the probe''s support for the network layer and application layer matrix tables for this protocol. When the probe creates entries in this table for all protocols that it understands, it will set the entry to notSupported(1) if it doesn''t have the capability to track the nlMatrixTables for this protocol or if the alMatrixTables are implemented but don''t have the capability to track this protocol. Note that if the alMatrix tables are implemented, the probe may only support a protocol if it is supported in the the both of the nlMatrixTables and both of the alMatrixTables.      If the associated protocolDirType object has the addressRecognitionCapable bit set, then this is a network layer protocol for which the probe recognizes addresses, and thus the probe will populate both of the nlMatrixTables and both of the alMatrixTables with addresses it discovers for this protocol.  If the value of this object is notSupported(1), the probe will not track either of the nlMatrixTables or the alMatrixTables for this protocol and shall not allow this object to be changed to any other value. If the value of this object is supportedOn(3), the probe supports tracking of both of the nlMatrixTables and (if implemented) both of the alMatrixTables for this protocol and is configured to track these tables for this protocol for all control entries and all interfaces. If the value of this object is supportedOff(2), the probe supports tracking of both of the nlMatrixTables and (if implemented) both of the alMatrixTables for this protocol but is configured to not track these tables for this protocol for any control entries or interfaces. Whenever this value changes from supportedOn(3) to supportedOff(2), the probe shall delete all related entries in the nlMatrixTables and the alMatrixTables.  Note that since each alMatrixEntry references 2 protocol directory entries, one for the network address and one for the type of the highest protocol recognized, that an entry will only be created in that table if this value is supportedOn(3) for both protocols.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4721, '.1.3.6.1.2.1.16.11.2.1.9', 'protocolDirOwner', 4712, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4722, '.1.3.6.1.2.1.16.11.2.1.10', 'protocolDirStatus', 4712, 'current', NULL, 'The status of this protocol directory entry.  An entry may not exist in the active state unless all      objects in the entry have an appropriate value.  If this object is not equal to active(1), all associated entries in the nlHostTable, nlMatrixSDTable, nlMatrixDSTable, alHostTable, alMatrixSDTable, and alMatrixDSTable shall be deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4723, '.1.3.6.1.2.1.16.12.1', 'protocolDistControlTable', 4701, 'current', NULL, 'Controls the setup of protocol type distribution statistics tables.  Implementations are encouraged to add an entry per monitored interface upon initialization so that a default collection of protocol statistics is available.  Rationale: This table controls collection of very basic statistics for any or all of the protocols detected on a given interface. An NMS can use this table to quickly determine bandwidth allocation utilized by different protocols.  A media-specific statistics collection could also be configured (e.g. etherStats, trPStats) to easily obtain total frame, octet, and droppedEvents for the same interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4726, '.1.3.6.1.2.1.16.12.1.1.2', 'protocolDistControlDataSource', 4724, 'current', NULL, 'The source of data for the this protocol distribution.  The statistics in this group reflect all packets on the local network segment attached to the identified interface.  This object may not be modified if the associated protocolDistControlStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4727, '.1.3.6.1.2.1.16.12.1.1.3', 'protocolDistControlDroppedFrames', 4724, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.       This count does not include packets that were not counted because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4728, '.1.3.6.1.2.1.16.12.1.1.4', 'protocolDistControlCreateTime', 4724, 'current', NULL, 'The value of sysUpTime when this control entry was last activated. This can be used by the management station to ensure that the table has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4729, '.1.3.6.1.2.1.16.12.1.1.5', 'protocolDistControlOwner', 4724, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4730, '.1.3.6.1.2.1.16.12.1.1.6', 'protocolDistControlStatus', 4724, 'current', NULL, 'The status of this row.  An entry may not exist in the active state unless all objects in the entry have an appropriate value.  If this object is not equal to active(1), all associated entries in the protocolDistStatsTable shall be deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4731, '.1.3.6.1.2.1.16.12.2', 'protocolDistStatsTable', 4701, 'current', NULL, 'An entry is made in this table for every protocol in the      protocolDirTable which has been seen in at least one packet. Counters are updated in this table for every protocol type that is encountered when parsing a packet, but no counters are updated for packets with MAC-layer errors.  Note that if a protocolDirEntry is deleted, all associated entries in this table are removed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4732, '.1.3.6.1.2.1.16.12.2.1', 'protocolDistStatsEntry', 4731, 'current', NULL, 'A conceptual row in the protocolDistStatsTable.  The index is composed of the protocolDistControlIndex of the associated protocolDistControlEntry followed by the protocolDirLocalIndex of the associated protocol that this entry represents. In other words, the index identifies the protocol distribution an entry is a part of as well as the particular protocol that it represents.  An example of the indexing of this entry is protocolDistStatsPkts.1.18', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4733, '.1.3.6.1.2.1.16.12.2.1.1', 'protocolDistStatsPkts', 4732, 'current', NULL, 'The number of packets without errors received of this protocol type. Note that this is the number of link-layer packets, so if a single network-layer packet is fragmented into several link-layer frames, this counter is incremented several times.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4734, '.1.3.6.1.2.1.16.12.2.1.2', 'protocolDistStatsOctets', 4732, 'current', NULL, 'The number of octets in packets received of this protocol type since it was added to the protocolDistStatsTable (excluding framing bits but including FCS octets), except for those octets in packets that contained errors.  Note this doesn''t count just those octets in the particular protocol frames, but includes the entire packet that contained the protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4735, '.1.3.6.1.2.1.16.13.1', 'addressMapInserts', 4702, 'current', NULL, 'The number of times an address mapping entry has been inserted into the addressMapTable. If an entry is inserted, then deleted, and then inserted, this counter will be incremented by 2.  Note that the table size can be determined by subtracting addressMapDeletes from addressMapInserts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4736, '.1.3.6.1.2.1.16.13.2', 'addressMapDeletes', 4702, 'current', NULL, 'The number of times an address mapping entry has been deleted from the addressMapTable (for any reason). If an entry is deleted, then inserted, and then deleted, this counter will be incremented by 2.  Note that the table size can be determined by subtracting addressMapDeletes from addressMapInserts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4737, '.1.3.6.1.2.1.16.13.3', 'addressMapMaxDesiredEntries', 4702, 'current', NULL, 'The maximum number of entries that are desired in the addressMapTable. The probe will not create more than this number of entries in the table, but may choose to create fewer entries in this table for any reason including the lack of resources.  If this object is set to a value less than the current number of entries, enough entries are chosen in an implementation-dependent manner and deleted so that the number of entries in the table equals the value of this object.  If this value is set to -1, the probe may create any number of entries in this table.  This object may be used to control how resources are allocated on the probe for the various RMON functions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4738, '.1.3.6.1.2.1.16.13.4', 'addressMapControlTable', 4702, 'current', NULL, 'A table to control the collection of network layer address to physical address to interface mappings.  Note that this is not like the typical RMON controlTable and dataTable in which each entry creates its own data table. Each entry in this table enables the discovery of addresses on a new interface and the placement of address mappings into the central addressMapTable.  Implementations are encouraged to add an entry per monitored interface upon initialization so that a default collection of address mappings is available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4739, '.1.3.6.1.2.1.16.13.4.1', 'addressMapControlEntry', 4738, 'current', NULL, 'A conceptual row in the addressMapControlTable.      An example of the indexing of this entry is addressMapControlDroppedFrames.1', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4740, '.1.3.6.1.2.1.16.13.4.1.1', 'addressMapControlIndex', 4739, 'current', NULL, 'A unique index for this entry in the addressMapControlTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4741, '.1.3.6.1.2.1.16.13.4.1.2', 'addressMapControlDataSource', 4739, 'current', NULL, 'The source of data for this addressMapControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4742, '.1.3.6.1.2.1.16.13.4.1.3', 'addressMapControlDroppedFrames', 4739, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4743, '.1.3.6.1.2.1.16.13.4.1.4', 'addressMapControlOwner', 4739, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4744, '.1.3.6.1.2.1.16.13.4.1.5', 'addressMapControlStatus', 4739, 'current', NULL, 'The status of this addressMap control entry.  An entry may not exist in the active state unless all objects in the entry have an appropriate value.  If this object is not equal to active(1), all associated entries in the addressMapTable shall be deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4982, '.1.3.6.1.2.1.16.20.2.1', 'protocolDirectoryGroup', 4979, 'current', NULL, 'Lists the inventory of protocols the probe has the capability of monitoring and allows the addition, deletion, and configuration of entries in this list.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4775, '.1.3.6.1.2.1.16.14.2.1.8', 'nlHostCreateTime', 4767, 'current', NULL, 'The value of sysUpTime when this entry was last activated. This can be used by the management station to ensure that the entry has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6784, '.1.3.6.1.4.1.9.2.2.1.1.96', 'locIflanmanInOctets', 6689, 'mandatory', NULL, 'LanMan protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4745, '.1.3.6.1.2.1.16.13.5', 'addressMapTable', 4702, 'current', NULL, 'A table of network layer address to physical address to interface mappings.  The probe will add entries to this table based on the source MAC and network addresses seen in packets without MAC-level errors. The probe will populate this table for all protocols in the protocol directory table whose value of protocolDirAddressMapConfig is equal to supportedOn(3), and will delete any entries whose protocolDirEntry is deleted or has a protocolDirAddressMapConfig value of supportedOff(2).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4746, '.1.3.6.1.2.1.16.13.5.1', 'addressMapEntry', 4745, 'current', NULL, 'A conceptual row in the addressMapTable. The protocolDirLocalIndex in the index identifies the network layer protocol of the addressMapNetworkAddress.      An example of the indexing of this entry is addressMapSource.783495.18.4.128.2.6.6.11.1.3.6.1.2.1.2.2.1.1.1', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4747, '.1.3.6.1.2.1.16.13.5.1.1', 'addressMapTimeMark', 4746, 'current', NULL, 'A TimeFilter for this entry. See the TimeFilter textual convention to see how this works.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4748, '.1.3.6.1.2.1.16.13.5.1.2', 'addressMapNetworkAddress', 4746, 'current', NULL, 'The network address for this relation.  This is represented as an octet string with specific semantics and length as identified by the protocolDirLocalIndex component of the index.  For example, if the protocolDirLocalIndex indicates an encapsulation of ip, this object is encoded as a length octet of 4, followed by the 4 octets of the ip address, in network byte order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4749, '.1.3.6.1.2.1.16.13.5.1.3', 'addressMapSource', 4746, 'current', NULL, 'The interface or port on which the associated network address was most recently seen.      If this address mapping was discovered on an interface, this object shall identify the instance of the ifIndex object, defined in [3,5], for the desired interface. For example, if an entry were to receive data from interface #1, this object would be set to ifIndex.1.  If this address mapping was discovered on a port, this object shall identify the instance of the rptrGroupPortIndex object, defined in [RFC1516], for the desired port. For example, if an entry were to receive data from group #1, port #1, this object would be set to rptrGroupPortIndex.1.1.  Note that while the dataSource associated with this entry may only point to index objects, this object may at times point to repeater port objects. This situation occurs when the dataSource points to an interface which is a locally attached repeater and the agent has additional information about the source port of traffic seen on that repeater.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4750, '.1.3.6.1.2.1.16.13.5.1.4', 'addressMapPhysicalAddress', 4746, 'current', NULL, 'The last source physical address on which the associated network address was seen. If the protocol of the associated network address was encapsulated inside of a network-level or higher protocol, this will be the address of the next-lower protocol with the addressRecognitionCapable bit enabled and will be formatted as specified for that protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4751, '.1.3.6.1.2.1.16.13.5.1.5', 'addressMapLastChange', 4746, 'current', NULL, 'The value of sysUpTime at the time this entry was last created or the values of the physical address changed.  This can be used to help detect duplicate address problems, in which case this object will be updated frequently.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4752, '.1.3.6.1.2.1.16.14.1', 'hlHostControlTable', 4703, 'current', NULL, 'A list of higher layer (i.e. non-MAC) host table control entries.  These entries will enable the collection of the network and application level host tables indexed by network addresses. Both the network and application level host tables are controlled by this table is so that they will both be created and deleted at the same time, further increasing the ease with which they can be implemented as a single datastore (note that if an implementation stores application layer host records in memory, it can derive network layer host records from them).  Entries in the nlHostTable will be created on behalf of each entry in this table. Additionally, if this probe implements the alHostTable, entries in the alHostTable will be created on behalf of each entry in this table.  Implementations are encouraged to add an entry per monitored interface upon initialization so that a default collection of host statistics is available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4753, '.1.3.6.1.2.1.16.14.1.1', 'hlHostControlEntry', 4752, 'current', NULL, 'A conceptual row in the hlHostControlTable.  An example of the indexing of this entry is hlHostControlNlDroppedFrames.1', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4754, '.1.3.6.1.2.1.16.14.1.1.1', 'hlHostControlIndex', 4753, 'current', NULL, 'An index that uniquely identifies an entry in the hlHostControlTable. Each such entry defines a function that discovers hosts on a particular interface and places statistics about them in the nlHostTable, and optionally in the alHostTable, on behalf of this hlHostControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4755, '.1.3.6.1.2.1.16.14.1.1.2', 'hlHostControlDataSource', 4753, 'current', NULL, 'The source of data for the associated host tables.  The statistics in this group reflect all packets on the local network segment attached to the identified interface.  This object may not be modified if the associated hlHostControlStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4756, '.1.3.6.1.2.1.16.14.1.1.3', 'hlHostControlNlDroppedFrames', 4753, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for the associated      nlHost entries for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that if the nlHostTable is inactive because no protocols are enabled in the protocol directory, this value should be 0.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4757, '.1.3.6.1.2.1.16.14.1.1.4', 'hlHostControlNlInserts', 4753, 'current', NULL, 'The number of times an nlHost entry has been inserted into the nlHost table. If an entry is inserted, then deleted, and then inserted, this counter will be incremented by 2.  To allow for efficient implementation strategies, agents may delay updating this object for short periods of time. For example, an implementation strategy may allow internal data structures to differ from those visible via SNMP for short periods of time. This counter may reflect the internal data structures for those short periods of time.  Note that the table size can be determined by subtracting hlHostControlNlDeletes from hlHostControlNlInserts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4758, '.1.3.6.1.2.1.16.14.1.1.5', 'hlHostControlNlDeletes', 4753, 'current', NULL, 'The number of times an nlHost entry has been deleted from the nlHost table (for any reason). If an entry is deleted, then inserted, and then deleted, this counter will be incremented by 2.  To allow for efficient implementation strategies, agents may delay updating this object for short periods of time. For example, an implementation strategy may allow internal      data structures to differ from those visible via SNMP for short periods of time. This counter may reflect the internal data structures for those short periods of time.  Note that the table size can be determined by subtracting hlHostControlNlDeletes from hlHostControlNlInserts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4774, '.1.3.6.1.2.1.16.14.2.1.7', 'nlHostOutMacNonUnicastPkts', 4767, 'current', NULL, 'The number of packets without errors transmitted by this address that were directed to any MAC broadcast addresses or to any MAC multicast addresses since this host was added to the nlHostTable. Note that this is the number of link-layer packets, so if a single network-layer packet is fragmented into several link-layer frames, this counter is incremented several times.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4759, '.1.3.6.1.2.1.16.14.1.1.6', 'hlHostControlNlMaxDesiredEntries', 4753, 'current', NULL, 'The maximum number of entries that are desired in the nlHostTable on behalf of this control entry. The probe will not create more than this number of associated entries in the table, but may choose to create fewer entries in this table for any reason including the lack of resources.  If this object is set to a value less than the current number of entries, enough entries are chosen in an implementation-dependent manner and deleted so that the number of entries in the table equals the value of this object.  If this value is set to -1, the probe may create any number of entries in this table. If the associated hlHostControlStatus object is equal to `active'', this object may not be modified.  This object may be used to control how resources are allocated on the probe for the various RMON functions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4760, '.1.3.6.1.2.1.16.14.1.1.7', 'hlHostControlAlDroppedFrames', 4753, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for the associated alHost entries for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.       Note that if the alHostTable is not implemented or is inactive because no protocols are enabled in the protocol directory, this value should be 0.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4761, '.1.3.6.1.2.1.16.14.1.1.8', 'hlHostControlAlInserts', 4753, 'current', NULL, 'The number of times an alHost entry has been inserted into the alHost table. If an entry is inserted, then deleted, and then inserted, this counter will be incremented by 2.  To allow for efficient implementation strategies, agents may delay updating this object for short periods of time. For example, an implementation strategy may allow internal data structures to differ from those visible via SNMP for short periods of time. This counter may reflect the internal data structures for those short periods of time.  Note that the table size can be determined by subtracting hlHostControlAlDeletes from hlHostControlAlInserts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4762, '.1.3.6.1.2.1.16.14.1.1.9', 'hlHostControlAlDeletes', 4753, 'current', NULL, 'The number of times an alHost entry has been deleted from the alHost table (for any reason). If an entry is deleted, then inserted, and then deleted, this counter will be incremented by 2.  To allow for efficient implementation strategies, agents may delay updating this object for short periods of time. For example, an implementation strategy may allow internal data structures to differ from those visible via SNMP for short periods of time. This counter may reflect the internal data structures for those short periods of time.  Note that the table size can be determined by subtracting hlHostControlAlDeletes from hlHostControlAlInserts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4763, '.1.3.6.1.2.1.16.14.1.1.10', 'hlHostControlAlMaxDesiredEntries', 4753, 'current', NULL, 'The maximum number of entries that are desired in the alHost table on behalf of this control entry. The probe will not create more than this number of associated entries in the table, but may choose to create fewer entries in this table for any reason including the lack of resources.  If this object is set to a value less than the current number of entries, enough entries are chosen in an implementation-dependent manner and deleted so that the number of entries in the table equals the value of this object.  If this value is set to -1, the probe may create any number of entries in this table. If the associated hlHostControlStatus object is equal to `active'', this object may not be modified.  This object may be used to control how resources are allocated on the probe for the various RMON functions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4764, '.1.3.6.1.2.1.16.14.1.1.11', 'hlHostControlOwner', 4753, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4765, '.1.3.6.1.2.1.16.14.1.1.12', 'hlHostControlStatus', 4753, 'current', NULL, 'The status of this hlHostControlEntry.  An entry may not exist in the active state unless all objects in the entry have an appropriate value.  If this object is not equal to active(1), all associated entries in the nlHostTable and alHostTable shall be deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4766, '.1.3.6.1.2.1.16.14.2', 'nlHostTable', 4703, 'current', NULL, 'A collection of statistics for a particular network layer address that has been discovered on an interface of this device.  The probe will populate this table for all network layer protocols in the protocol directory table whose value of protocolDirHostConfig is equal to supportedOn(3), and will delete any entries whose protocolDirEntry is deleted or has a protocolDirHostConfig value of supportedOff(2).  The probe will add to this table all addresses seen as the source or destination address in all packets with no MAC errors, and will increment octet and packet counts in the table for all packets with no MAC errors.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4767, '.1.3.6.1.2.1.16.14.2.1', 'nlHostEntry', 4766, 'current', NULL, 'A conceptual row in the nlHostTable.  The hlHostControlIndex value in the index identifies the hlHostControlEntry on whose behalf this entry was created. The protocolDirLocalIndex value in the index identifies the network layer protocol of the nlHostAddress.  An example of the indexing of this entry is nlHostOutPkts.1.783495.18.4.128.2.6.6.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4768, '.1.3.6.1.2.1.16.14.2.1.1', 'nlHostTimeMark', 4767, 'current', NULL, 'A TimeFilter for this entry. See the TimeFilter textual convention to see how this works.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4769, '.1.3.6.1.2.1.16.14.2.1.2', 'nlHostAddress', 4767, 'current', NULL, 'The network address for this nlHostEntry.  This is represented as an octet string with specific semantics and length as identified by the protocolDirLocalIndex component of the index.  For example, if the protocolDirLocalIndex indicates an encapsulation of ip, this object is encoded as a length octet of 4, followed by the 4 octets of the ip address, in network byte order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4770, '.1.3.6.1.2.1.16.14.2.1.3', 'nlHostInPkts', 4767, 'current', NULL, 'The number of packets without errors transmitted to this address since it was added to the nlHostTable. Note that this is the number of link-layer packets, so if a single network-layer packet is fragmented into several link-layer frames, this counter is incremented several times.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4771, '.1.3.6.1.2.1.16.14.2.1.4', 'nlHostOutPkts', 4767, 'current', NULL, 'The number of packets without errors transmitted by      this address since it was added to the nlHostTable. Note that this is the number of link-layer packets, so if a single network-layer packet is fragmented into several link-layer frames, this counter is incremented several times.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4772, '.1.3.6.1.2.1.16.14.2.1.5', 'nlHostInOctets', 4767, 'current', NULL, 'The number of octets transmitted to this address since it was added to the nlHostTable (excluding framing bits but including FCS octets), excluding those octets in packets that contained errors.  Note this doesn''t count just those octets in the particular protocol frames, but includes the entire packet that contained the protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4773, '.1.3.6.1.2.1.16.14.2.1.6', 'nlHostOutOctets', 4767, 'current', NULL, 'The number of octets transmitted by this address since it was added to the nlHostTable (excluding framing bits but including FCS octets), excluding those octets in packets that contained errors.  Note this doesn''t count just those octets in the particular protocol frames, but includes the entire packet that contained the protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5130, '.1.3.6.1.4.1.9.9.692.1.1.1', 'cfmFlowMonitorTable', 5129, 'current', NULL, 'This table lists the flow monitors contained by the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4776, '.1.3.6.1.2.1.16.15.1', 'hlMatrixControlTable', 4704, 'current', NULL, 'A list of higher layer (i.e. non-MAC) matrix control entries.  These entries will enable the collection of the network and application level matrix tables containing conversation statistics indexed by pairs of network addresses. Both the network and application level matrix tables are controlled by this table is so that they will both be created and deleted at the same time, further increasing the ease with which they can be implemented as a single datastore (note that if an implementation stores application layer matrix records in memory, it can derive network layer matrix records from them).  Entries in the nlMatrixSDTable and nlMatrixDSTable will be created on behalf of each entry in this table. Additionally, if this probe implements the alMatrix tables, entries in the alMatrix tables will be created on behalf of each entry in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4777, '.1.3.6.1.2.1.16.15.1.1', 'hlMatrixControlEntry', 4776, 'current', NULL, 'A conceptual row in the hlMatrixControlTable.  An example of indexing of this entry is hlMatrixControlNlDroppedFrames.1', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4778, '.1.3.6.1.2.1.16.15.1.1.1', 'hlMatrixControlIndex', 4777, 'current', NULL, 'An index that uniquely identifies an entry in the hlMatrixControlTable. Each such entry defines a function that discovers conversations on a particular interface and places statistics about them in the nlMatrixSDTable and the nlMatrixDSTable, and optionally the alMatrixSDTable and alMatrixDSTable, on behalf of this hlMatrixControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4779, '.1.3.6.1.2.1.16.15.1.1.2', 'hlMatrixControlDataSource', 4777, 'current', NULL, 'The source of the data for the associated matrix tables.  The statistics in this group reflect all packets on the local network segment attached to the      identified interface.  This object may not be modified if the associated hlMatrixControlStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4780, '.1.3.6.1.2.1.16.15.1.1.3', 'hlMatrixControlNlDroppedFrames', 4777, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that if the nlMatrixTables are inactive because no protocols are enabled in the protocol directory, this value should be 0.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4781, '.1.3.6.1.2.1.16.15.1.1.4', 'hlMatrixControlNlInserts', 4777, 'current', NULL, 'The number of times an nlMatrix entry has been inserted into the nlMatrix tables. If an entry is inserted, then deleted, and then inserted, this counter will be incremented by 2. The addition of a conversation into both the nlMatrixSDTable and nlMatrixDSTable shall be counted as two insertions (even though every addition into one table must be accompanied by an insertion into the other).  To allow for efficient implementation strategies, agents may delay updating this object for short periods of time. For example, an implementation strategy may allow internal data structures to differ from those visible via SNMP for short periods of time. This counter may reflect the internal data structures for those short periods of time.      Note that the sum of then nlMatrixSDTable and nlMatrixDSTable sizes can be determined by subtracting hlMatrixControlNlDeletes from hlMatrixControlNlInserts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4782, '.1.3.6.1.2.1.16.15.1.1.5', 'hlMatrixControlNlDeletes', 4777, 'current', NULL, 'The number of times an nlMatrix entry has been deleted from the nlMatrix tables (for any reason). If an entry is deleted, then inserted, and then deleted, this counter will be incremented by 2. The deletion of a conversation from both the nlMatrixSDTable and nlMatrixDSTable shall be counted as two deletions (even though every deletion from one table must be accompanied by a deletion from the other).  To allow for efficient implementation strategies, agents may delay updating this object for short periods of time. For example, an implementation strategy may allow internal data structures to differ from those visible via SNMP for short periods of time. This counter may reflect the internal data structures for those short periods of time.  Note that the table size can be determined by subtracting hlMatrixControlNlDeletes from hlMatrixControlNlInserts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4783, '.1.3.6.1.2.1.16.15.1.1.6', 'hlMatrixControlNlMaxDesiredEntries', 4777, 'current', NULL, 'The maximum number of entries that are desired in the nlMatrix tables on behalf of this control entry. The probe will not create more than this number of associated entries in the table, but may choose to create fewer entries in this table for any reason including the lack of resources.  If this object is set to a value less than the current number of entries, enough entries are chosen in an implementation-dependent manner and deleted so that the number of entries in the table equals the value of this object.  If this value is set to -1, the probe may create any number of entries in this table. If the associated      hlMatrixControlStatus object is equal to `active'', this object may not be modified.  This object may be used to control how resources are allocated on the probe for the various RMON functions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4784, '.1.3.6.1.2.1.16.15.1.1.7', 'hlMatrixControlAlDroppedFrames', 4777, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that if the alMatrixTables are not implemented or are inactive because no protocols are enabled in the protocol directory, this value should be 0.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4785, '.1.3.6.1.2.1.16.15.1.1.8', 'hlMatrixControlAlInserts', 4777, 'current', NULL, 'The number of times an alMatrix entry has been inserted into the alMatrix tables. If an entry is inserted, then deleted, and then inserted, this counter will be incremented by 2. The addition of a conversation into both the alMatrixSDTable and alMatrixDSTable shall be counted as two insertions (even though every addition into one table must be accompanied by an insertion into the other).  To allow for efficient implementation strategies, agents may delay updating this object for short periods of time. For example, an implementation strategy may allow internal data structures to differ from those visible via SNMP for short periods of time. This counter may reflect the internal      data structures for those short periods of time.  Note that the table size can be determined by subtracting hlMatrixControlAlDeletes from hlMatrixControlAlInserts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4801, '.1.3.6.1.2.1.16.15.3.1.2', 'nlMatrixDSSourceAddress', 4799, 'current', NULL, 'The network source address for this nlMatrixDSEntry.  This is represented as an octet string with specific semantics and length as identified by the protocolDirLocalIndex component of the index.  For example, if the protocolDirLocalIndex indicates an encapsulation of ip, this object is encoded as a length octet of 4, followed by the 4 octets of the ip address, in network byte order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4983, '.1.3.6.1.2.1.16.20.2.2', 'protocolDistributionGroup', 4979, 'current', NULL, 'Collects the relative amounts of octets and packets for the different protocols detected on a network segment.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4786, '.1.3.6.1.2.1.16.15.1.1.9', 'hlMatrixControlAlDeletes', 4777, 'current', NULL, 'The number of times an alMatrix entry has been deleted from the alMatrix tables. If an entry is deleted, then inserted, and then deleted, this counter will be incremented by 2. The deletion of a conversation from both the alMatrixSDTable and alMatrixDSTable shall be counted as two deletions (even though every deletion from one table must be accompanied by a deletion from the other).  To allow for efficient implementation strategies, agents may delay updating this object for short periods of time. For example, an implementation strategy may allow internal data structures to differ from those visible via SNMP for short periods of time. This counter may reflect the internal data structures for those short periods of time.  Note that the table size can be determined by subtracting hlMatrixControlAlDeletes from hlMatrixControlAlInserts.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4787, '.1.3.6.1.2.1.16.15.1.1.10', 'hlMatrixControlAlMaxDesiredEntries', 4777, 'current', NULL, 'The maximum number of entries that are desired in the alMatrix tables on behalf of this control entry. The probe will not create more than this number of associated entries in the table, but may choose to create fewer entries in this table for any reason including the lack of resources.  If this object is set to a value less than the current number of entries, enough entries are chosen in an implementation-dependent manner and deleted so that the number of entries in the table equals the value of this object.  If this value is set to -1, the probe may create any number of entries in this table. If the associated      hlMatrixControlStatus object is equal to `active'', this object may not be modified.  This object may be used to control how resources are allocated on the probe for the various RMON functions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4788, '.1.3.6.1.2.1.16.15.1.1.11', 'hlMatrixControlOwner', 4777, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4789, '.1.3.6.1.2.1.16.15.1.1.12', 'hlMatrixControlStatus', 4777, 'current', NULL, 'The status of this hlMatrixControlEntry.  An entry may not exist in the active state unless all objects in the entry have an appropriate value.  If this object is not equal to active(1), all associated entries in the nlMatrixSDTable, nlMatrixDSTable, alMatrixSDTable, and the alMatrixDSTable shall be deleted by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4790, '.1.3.6.1.2.1.16.15.2', 'nlMatrixSDTable', 4704, 'current', NULL, 'A list of traffic matrix entries which collect statistics for conversations between two network-level addresses. This table is indexed first by the source address and then by the destination address to make it convenient to collect all conversations from a particular address.  The probe will populate this table for all network layer protocols in the protocol directory table whose value of protocolDirMatrixConfig is equal to supportedOn(3), and will delete any entries whose protocolDirEntry is deleted or has a protocolDirMatrixConfig value of supportedOff(2).      The probe will add to this table all pairs of addresses seen in all packets with no MAC errors, and will increment octet and packet counts in the table for all packets with no MAC errors.  Further, this table will only contain entries that have a corresponding entry in the nlMatrixDSTable with the same source address and destination address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4791, '.1.3.6.1.2.1.16.15.2.1', 'nlMatrixSDEntry', 4790, 'current', NULL, 'A conceptual row in the nlMatrixSDTable.  The hlMatrixControlIndex value in the index identifies the hlMatrixControlEntry on whose behalf this entry was created. The protocolDirLocalIndex value in the index identifies the network layer protocol of the nlMatrixSDSourceAddress and nlMatrixSDDestAddress.  An example of the indexing of this table is nlMatrixSDPkts.1.783495.18.4.128.2.6.6.4.128.2.6.7', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4792, '.1.3.6.1.2.1.16.15.2.1.1', 'nlMatrixSDTimeMark', 4791, 'current', NULL, 'A TimeFilter for this entry. See the TimeFilter textual convention to see how this works.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4793, '.1.3.6.1.2.1.16.15.2.1.2', 'nlMatrixSDSourceAddress', 4791, 'current', NULL, 'The network source address for this nlMatrixSDEntry.  This is represented as an octet string with specific semantics and length as identified by the protocolDirLocalIndex component of the index.  For example, if the protocolDirLocalIndex indicates an encapsulation of ip, this object is encoded as a length octet of 4, followed by the 4 octets of the ip address, in network byte order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4794, '.1.3.6.1.2.1.16.15.2.1.3', 'nlMatrixSDDestAddress', 4791, 'current', NULL, 'The network destination address for this nlMatrixSDEntry.  This is represented as an octet string with specific semantics and length as identified by the protocolDirLocalIndex component of the index.  For example, if the protocolDirLocalIndex indicates an encapsulation of ip, this object is encoded as a length octet of 4, followed by the 4 octets of the ip address, in network byte order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4795, '.1.3.6.1.2.1.16.15.2.1.4', 'nlMatrixSDPkts', 4791, 'current', NULL, 'The number of packets without errors transmitted from the source address to the destination address since this entry was added to the nlMatrixSDTable. Note that this is the number of link-layer packets, so if a single network-layer packet is fragmented into several link-layer frames, this counter is incremented several times.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4796, '.1.3.6.1.2.1.16.15.2.1.5', 'nlMatrixSDOctets', 4791, 'current', NULL, 'The number of octets transmitted from the source address to the destination address since this entry was added to the nlMatrixSDTable (excluding framing bits but including FCS octets), excluding those octets in packets that contained errors.  Note this doesn''t count just those octets in the particular protocol frames, but includes the entire packet that contained the protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4797, '.1.3.6.1.2.1.16.15.2.1.6', 'nlMatrixSDCreateTime', 4791, 'current', NULL, 'The value of sysUpTime when this entry was last activated. This can be used by the management station to ensure that the entry has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4798, '.1.3.6.1.2.1.16.15.3', 'nlMatrixDSTable', 4704, 'current', NULL, 'A list of traffic matrix entries which collect statistics for conversations between two network-level addresses. This table is indexed first by the destination address and then by the source address to make it convenient to collect all conversations to a particular address.  The probe will populate this table for all network layer protocols in the protocol directory table whose value of protocolDirMatrixConfig is equal to supportedOn(3), and will delete any entries whose protocolDirEntry is deleted or has a protocolDirMatrixConfig value of supportedOff(2).  The probe will add to this table all pairs of addresses seen in all packets with no MAC errors, and will increment      octet and packet counts in the table for all packets with no MAC errors.  Further, this table will only contain entries that have a corresponding entry in the nlMatrixSDTable with the same source address and destination address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4799, '.1.3.6.1.2.1.16.15.3.1', 'nlMatrixDSEntry', 4798, 'current', NULL, 'A conceptual row in the nlMatrixDSTable.  The hlMatrixControlIndex value in the index identifies the hlMatrixControlEntry on whose behalf this entry was created. The protocolDirLocalIndex value in the index identifies the network layer protocol of the nlMatrixDSSourceAddress and nlMatrixDSDestAddress.  An example of the indexing of this table is nlMatrixDSPkts.1.783495.18.4.128.2.6.7.4.128.2.6.6', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4800, '.1.3.6.1.2.1.16.15.3.1.1', 'nlMatrixDSTimeMark', 4799, 'current', NULL, 'A TimeFilter for this entry. See the TimeFilter textual convention to see how this works.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4868, '.1.3.6.1.2.1.16.17.4.1.5', 'alMatrixTopNAppProtocolDirLocalIndex', 4863, 'current', NULL, 'The type of the protocol counted by this matrix entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4802, '.1.3.6.1.2.1.16.15.3.1.3', 'nlMatrixDSDestAddress', 4799, 'current', NULL, 'The network destination address for this nlMatrixDSEntry.  This is represented as an octet string with specific semantics and length as identified by the protocolDirLocalIndex component of the index.  For example, if the protocolDirLocalIndex indicates an encapsulation of ip, this object is encoded as a length octet of 4, followed by the 4 octets of the ip address, in network byte order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4803, '.1.3.6.1.2.1.16.15.3.1.4', 'nlMatrixDSPkts', 4799, 'current', NULL, 'The number of packets without errors transmitted from the source address to the destination address since this entry was added to the nlMatrixDSTable. Note that this is the number of link-layer packets, so if a single network-layer packet is fragmented into several link-layer frames, this counter is incremented several times.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4804, '.1.3.6.1.2.1.16.15.3.1.5', 'nlMatrixDSOctets', 4799, 'current', NULL, 'The number of octets transmitted from the source address to the destination address since this entry was added to the nlMatrixDSTable (excluding framing bits but including FCS octets), excluding those octets in packets that contained errors.  Note this doesn''t count just those octets in the particular protocol frames, but includes the entire packet that contained the protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4805, '.1.3.6.1.2.1.16.15.3.1.6', 'nlMatrixDSCreateTime', 4799, 'current', NULL, 'The value of sysUpTime when this entry was last activated. This can be used by the management station to ensure that the entry has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4806, '.1.3.6.1.2.1.16.15.4', 'nlMatrixTopNControlTable', 4704, 'current', NULL, 'A set of parameters that control the creation of a report of the top N matrix entries according to a selected metric.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4807, '.1.3.6.1.2.1.16.15.4.1', 'nlMatrixTopNControlEntry', 4806, 'current', NULL, 'A conceptual row in the nlMatrixTopNControlTable.  An example of the indexing of this table is nlMatrixTopNControlDuration.3', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4808, '.1.3.6.1.2.1.16.15.4.1.1', 'nlMatrixTopNControlIndex', 4807, 'current', NULL, 'An index that uniquely identifies an entry in the nlMatrixTopNControlTable. Each such entry defines one top N report prepared for one interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4809, '.1.3.6.1.2.1.16.15.4.1.2', 'nlMatrixTopNControlMatrixIndex', 4807, 'current', NULL, 'The nlMatrix[SD/DS] table for which a top N report will be prepared on behalf of this entry. The nlMatrix[SD/DS] table is identified by the value of the hlMatrixControlIndex for that table - that value is used here to identify the particular table.  This object may not be modified if the associated nlMatrixTopNControlStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4810, '.1.3.6.1.2.1.16.15.4.1.3', 'nlMatrixTopNControlRateBase', 4807, 'current', NULL, 'The variable for each nlMatrix[SD/DS] entry that the nlMatrixTopNEntries are sorted by.      This object may not be modified if the associated nlMatrixTopNControlStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4811, '.1.3.6.1.2.1.16.15.4.1.4', 'nlMatrixTopNControlTimeRemaining', 4807, 'current', NULL, 'The number of seconds left in the report currently being collected. When this object is modified by the management station, a new collection is started, possibly aborting a currently running report. The new value is used as the requested duration of this report, and is immediately loaded into the associated nlMatrixTopNControlDuration object. When the report finishes, the probe will automatically start another collection with the same initial value of nlMatrixTopNControlTimeRemaining. Thus the management station may simply read the resulting reports repeatedly, checking the startTime and duration each time to ensure that a report was not missed or that the report parameters were not changed.  While the value of this object is non-zero, it decrements by one per second until it reaches zero. At the time that this object decrements to zero, the report is made accessible in the nlMatrixTopNTable, overwriting any report that may be there.  When this object is modified by the management station, any associated entries in the nlMatrixTopNTable shall be deleted.  (Note that this is a different algorithm than the one used in the hostTopNTable).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4812, '.1.3.6.1.2.1.16.15.4.1.5', 'nlMatrixTopNControlGeneratedReports', 4807, 'current', NULL, 'The number of reports that have been generated by this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4813, '.1.3.6.1.2.1.16.15.4.1.6', 'nlMatrixTopNControlDuration', 4807, 'current', NULL, 'The number of seconds that this report has collected during the last sampling interval.  When the associated nlMatrixTopNControlTimeRemaining object is set, this object shall be set by the probe to the same value and shall not be modified until the next time the nlMatrixTopNControlTimeRemaining is set. This value shall be zero if no reports have been requested for this nlMatrixTopNControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4814, '.1.3.6.1.2.1.16.15.4.1.7', 'nlMatrixTopNControlRequestedSize', 4807, 'current', NULL, 'The maximum number of matrix entries requested for this report.  When this object is created or modified, the probe should set nlMatrixTopNControlGrantedSize as closely to this object as is possible for the particular probe implementation and available resources.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4815, '.1.3.6.1.2.1.16.15.4.1.8', 'nlMatrixTopNControlGrantedSize', 4807, 'current', NULL, 'The maximum number of matrix entries in this report.  When the associated nlMatrixTopNControlRequestedSize object is created or modified, the probe should set this object as closely to the requested value as is possible for the particular implementation and available resources. The probe must not lower this value except as a result of a set to the associated nlMatrixTopNControlRequestedSize object.  If the value of nlMatrixTopNControlRateBase is equal to nlMatrixTopNPkts, when the next topN report is generated, matrix entries with the highest value of nlMatrixTopNPktRate shall be placed in this table in decreasing order of this rate until there is no more room or until there are no more      matrix entries.  If the value of nlMatrixTopNControlRateBase is equal to nlMatrixTopNOctets, when the next topN report is generated, matrix entries with the highest value of nlMatrixTopNOctetRate shall be placed in this table in decreasing order of this rate until there is no more room or until there are no more matrix entries.  It is an implementation-specific matter how entries with the same value of nlMatrixTopNPktRate or nlMatrixTopNOctetRate are sorted. It is also an implementation-specific matter as to whether or not zero-valued entries are available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4816, '.1.3.6.1.2.1.16.15.4.1.9', 'nlMatrixTopNControlStartTime', 4807, 'current', NULL, 'The value of sysUpTime when this top N report was last started. In other words, this is the time that the associated nlMatrixTopNControlTimeRemaining object was modified to start the requested report or the time the report was last automatically (re)started.  This object may be used by the management station to determine if a report was missed or not.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4817, '.1.3.6.1.2.1.16.15.4.1.10', 'nlMatrixTopNControlOwner', 4807, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4818, '.1.3.6.1.2.1.16.15.4.1.11', 'nlMatrixTopNControlStatus', 4807, 'current', NULL, 'The status of this nlMatrixTopNControlEntry.  An entry may not exist in the active state unless all objects in the entry have an appropriate value.      If this object is not equal to active(1), all associated entries in the nlMatrixTopNTable shall be deleted by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4819, '.1.3.6.1.2.1.16.15.5', 'nlMatrixTopNTable', 4704, 'current', NULL, 'A set of statistics for those network layer matrix entries that have counted the highest number of octets or packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6785, '.1.3.6.1.4.1.9.2.2.1.1.97', 'locIflanmanOutOctets', 6689, 'mandatory', NULL, 'LanMan protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4820, '.1.3.6.1.2.1.16.15.5.1', 'nlMatrixTopNEntry', 4819, 'current', NULL, 'A conceptual row in the nlMatrixTopNTable.  The nlMatrixTopNControlIndex value in the index identifies the nlMatrixTopNControlEntry on whose behalf this entry was created.  An example of the indexing of this table is nlMatrixTopNPktRate.3.10', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4821, '.1.3.6.1.2.1.16.15.5.1.1', 'nlMatrixTopNIndex', 4820, 'current', NULL, 'An index that uniquely identifies an entry in the nlMatrixTopNTable among those in the same report.      This index is between 1 and N, where N is the number of entries in this report.  If the value of nlMatrixTopNControlRateBase is equal to nlMatrixTopNPkts, increasing values of nlMatrixTopNIndex shall be assigned to entries with decreasing values of nlMatrixTopNPktRate until index N is assigned or there are no more nlMatrixTopNEntries.  If the value of nlMatrixTopNControlRateBase is equal to nlMatrixTopNOctets, increasing values of nlMatrixTopNIndex shall be assigned to entries with decreasing values of nlMatrixTopNOctetRate until index N is assigned or there are no more nlMatrixTopNEntries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4822, '.1.3.6.1.2.1.16.15.5.1.2', 'nlMatrixTopNProtocolDirLocalIndex', 4820, 'current', NULL, 'The protocolDirLocalIndex of the network layer protocol of this entry''s network address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4823, '.1.3.6.1.2.1.16.15.5.1.3', 'nlMatrixTopNSourceAddress', 4820, 'current', NULL, 'The network layer address of the source host in this conversation.  This is represented as an octet string with specific semantics and length as identified by the associated nlMatrixTopNProtocolDirLocalIndex.  For example, if the protocolDirLocalIndex indicates an encapsulation of ip, this object is encoded as a length octet of 4, followed by the 4 octets of the ip address, in network byte order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4824, '.1.3.6.1.2.1.16.15.5.1.4', 'nlMatrixTopNDestAddress', 4820, 'current', NULL, 'The network layer address of the destination host in this conversation.  This is represented as an octet string with specific semantics and length as identified by the associated nlMatrixTopNProtocolDirLocalIndex.  For example, if the nlMatrixTopNProtocolDirLocalIndex indicates an encapsulation of ip, this object is encoded as a length octet of 4, followed by the 4 octets of the ip address, in network byte order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4825, '.1.3.6.1.2.1.16.15.5.1.5', 'nlMatrixTopNPktRate', 4820, 'current', NULL, 'The number of packets seen from the source host to the destination host during this sampling interval, counted using the rules for counting the nlMatrixSDPkts object. If the value of nlMatrixTopNControlRateBase is nlMatrixTopNPkts, this variable will be used to sort this report.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4826, '.1.3.6.1.2.1.16.15.5.1.6', 'nlMatrixTopNReversePktRate', 4820, 'current', NULL, 'The number of packets seen from the destination host to the source host during this sampling interval, counted using the rules for counting the nlMatrixSDPkts object (note that the corresponding nlMatrixSDPkts object selected is the one whose source address is equal to nlMatrixTopNDestAddress and whose destination address is equal to nlMatrixTopNSourceAddress.)  Note that if the value of nlMatrixTopNControlRateBase is equal to nlMatrixTopNPkts, the sort of topN entries is based entirely on nlMatrixTopNPktRate, and not on the value of this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4827, '.1.3.6.1.2.1.16.15.5.1.7', 'nlMatrixTopNOctetRate', 4820, 'current', NULL, 'The number of octets seen from the source host to the destination host during this sampling interval, counted using the rules for counting the nlMatrixSDOctets object. If the value of nlMatrixTopNControlRateBase is nlMatrixTopNOctets, this variable will be used to sort this report.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4828, '.1.3.6.1.2.1.16.15.5.1.8', 'nlMatrixTopNReverseOctetRate', 4820, 'current', NULL, 'The number of octets seen from the destination host to the source host during this sampling interval, counted using the rules for counting the nlMatrixDSOctets object (note that the corresponding nlMatrixSDOctets object selected is the one whose source address is equal to nlMatrixTopNDestAddress and whose destination address is equal to nlMatrixTopNSourceAddress.)  Note that if the value of nlMatrixTopNControlRateBase is equal to nlMatrixTopNOctets, the sort of topN entries is based entirely on nlMatrixTopNOctetRate, and not on the value of this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4829, '.1.3.6.1.2.1.16.16.1', 'alHostTable', 4705, 'current', NULL, 'A collection of statistics for a particular protocol from a particular network address that has been discovered on an interface of this device.  The probe will populate this table for all protocols in the protocol directory table whose value of protocolDirHostConfig is equal to supportedOn(3), and will delete any entries whose protocolDirEntry is deleted or has a protocolDirHostConfig value of supportedOff(2).  The probe will add to this table all addresses seen as the source or destination address in all packets with no MAC errors, and will increment octet and packet counts in the table for all packets with no MAC errors. Further, entries will only be added to this table if their address exists in the nlHostTable and will be deleted from this table if their address is deleted from the nlHostTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4830, '.1.3.6.1.2.1.16.16.1.1', 'alHostEntry', 4829, 'current', NULL, 'A conceptual row in the alHostTable.  The hlHostControlIndex value in the index identifies the hlHostControlEntry on whose behalf this entry was created. The first protocolDirLocalIndex value in the index identifies the network layer protocol of the address. The nlHostAddress value in the index identifies the network layer address of this entry. The second protocolDirLocalIndex value in the index identifies the protocol that is counted by this entry.  An example of the indexing in this entry is alHostOutPkts.1.783495.18.4.128.2.6.6.34', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4831, '.1.3.6.1.2.1.16.16.1.1.1', 'alHostTimeMark', 4830, 'current', NULL, 'A TimeFilter for this entry. See the TimeFilter textual convention to see how this works.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4832, '.1.3.6.1.2.1.16.16.1.1.2', 'alHostInPkts', 4830, 'current', NULL, 'The number of packets of this protocol type without errors transmitted to this address since it was added to the alHostTable. Note that this is the number of link-layer packets, so if a single network-layer packet is fragmented into several link-layer frames, this counter is incremented several times.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4833, '.1.3.6.1.2.1.16.16.1.1.3', 'alHostOutPkts', 4830, 'current', NULL, 'The number of packets of this protocol type without errors transmitted by this address since it was added to the alHostTable. Note that this is the number of link-layer packets, so if a single network-layer packet is fragmented into several link-layer frames, this counter is incremented several times.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4834, '.1.3.6.1.2.1.16.16.1.1.4', 'alHostInOctets', 4830, 'current', NULL, 'The number of octets transmitted to this address of this protocol type since it was added to the alHostTable (excluding framing bits but including      FCS octets), excluding those octets in packets that contained errors.  Note this doesn''t count just those octets in the particular protocol frames, but includes the entire packet that contained the protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4835, '.1.3.6.1.2.1.16.16.1.1.5', 'alHostOutOctets', 4830, 'current', NULL, 'The number of octets transmitted by this address of this protocol type since it was added to the alHostTable (excluding framing bits but including FCS octets), excluding those octets in packets that contained errors.  Note this doesn''t count just those octets in the particular protocol frames, but includes the entire packet that contained the protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4836, '.1.3.6.1.2.1.16.16.1.1.6', 'alHostCreateTime', 4830, 'current', NULL, 'The value of sysUpTime when this entry was last activated. This can be used by the management station to ensure that the entry has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4837, '.1.3.6.1.2.1.16.17.1', 'alMatrixSDTable', 4706, 'current', NULL, 'A list of application traffic matrix entries which collect      statistics for conversations of a particular protocol between two network-level addresses. This table is indexed first by the source address and then by the destination address to make it convenient to collect all statistics from a particular address.  The probe will populate this table for all protocols in the protocol directory table whose value of protocolDirMatrixConfig is equal to supportedOn(3), and will delete any entries whose protocolDirEntry is deleted or has a protocolDirMatrixConfig value of supportedOff(2).  The probe will add to this table all pairs of addresses for all protocols seen in all packets with no MAC errors, and will increment octet and packet counts in the table for all packets with no MAC errors. Further, entries will only be added to this table if their address pair exists in the nlMatrixSDTable and will be deleted from this table if the address pair is deleted from the nlMatrixSDTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4838, '.1.3.6.1.2.1.16.17.1.1', 'alMatrixSDEntry', 4837, 'current', NULL, 'A conceptual row in the alMatrixSDTable.  The hlMatrixControlIndex value in the index identifies the hlMatrixControlEntry on whose behalf this entry was created. The first protocolDirLocalIndex value in the index identifies the network layer protocol of the nlMatrixSDSourceAddress and nlMatrixSDDestAddress. The nlMatrixSDSourceAddress value in the index identifies the network layer address of the source host in this conversation. The nlMatrixSDDestAddress value in the index identifies the network layer address of the destination host in this conversation. The second protocolDirLocalIndex value in the index identifies the protocol that is counted by this entry.  An example of the indexing of this entry is alMatrixSDPkts.1.783495.18.4.128.2.6.6.4.128.2.6.7.34', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4839, '.1.3.6.1.2.1.16.17.1.1.1', 'alMatrixSDTimeMark', 4838, 'current', NULL, 'A TimeFilter for this entry. See the TimeFilter textual convention to see how this works.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4840, '.1.3.6.1.2.1.16.17.1.1.2', 'alMatrixSDPkts', 4838, 'current', NULL, 'The number of packets of this protocol type without errors transmitted from the source address to the destination address since this entry was added to the alMatrixSDTable. Note that this is the number of link-layer packets, so if a single network-layer packet is fragmented into several link-layer frames, this counter is incremented several times.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4841, '.1.3.6.1.2.1.16.17.1.1.3', 'alMatrixSDOctets', 4838, 'current', NULL, 'The number of octets in packets of this protocol type transmitted from the source address to the destination address since this entry was added to the alMatrixSDTable (excluding framing bits but including FCS octets), excluding those octets in packets that contained errors.  Note this doesn''t count just those octets in the particular protocol frames, but includes the entire packet that contained the protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4842, '.1.3.6.1.2.1.16.17.1.1.4', 'alMatrixSDCreateTime', 4838, 'current', NULL, 'The value of sysUpTime when this entry was last activated. This can be used by the management station to ensure that the entry has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4843, '.1.3.6.1.2.1.16.17.2', 'alMatrixDSTable', 4706, 'current', NULL, 'A list of application traffic matrix entries which collect statistics for conversations of a particular protocol between two network-level addresses. This table is indexed first by the destination address and then by the source address to make it convenient to collect all statistics to a particular address.  The probe will populate this table for all protocols in the protocol directory table whose value of protocolDirMatrixConfig is equal to supportedOn(3), and will delete any entries whose protocolDirEntry is deleted or has a protocolDirMatrixConfig value of supportedOff(2).  The probe will add to this table all pairs of addresses for all protocols seen in all packets with no MAC errors, and will increment octet and packet counts in the table for all packets with no MAC errors. Further, entries will only be added to this table if their address pair exists in the nlMatrixDSTable and will be deleted from this table if the address pair is deleted from the nlMatrixDSTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4844, '.1.3.6.1.2.1.16.17.2.1', 'alMatrixDSEntry', 4843, 'current', NULL, 'A conceptual row in the alMatrixDSTable.  The hlMatrixControlIndex value in the index identifies the hlMatrixControlEntry on whose behalf this entry was created. The first protocolDirLocalIndex value in the index identifies the network layer protocol of the alMatrixDSSourceAddress and alMatrixDSDestAddress.      The nlMatrixDSDestAddress value in the index identifies the network layer address of the destination host in this conversation. The nlMatrixDSSourceAddress value in the index identifies the network layer address of the source host in this conversation. The second protocolDirLocalIndex value in the index identifies the protocol that is counted by this entry.  An example of the indexing of this entry is alMatrixDSPkts.1.783495.18.4.128.2.6.7.4.128.2.6.6.34', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4845, '.1.3.6.1.2.1.16.17.2.1.1', 'alMatrixDSTimeMark', 4844, 'current', NULL, 'A TimeFilter for this entry. See the TimeFilter textual convention to see how this works.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4846, '.1.3.6.1.2.1.16.17.2.1.2', 'alMatrixDSPkts', 4844, 'current', NULL, 'The number of packets of this protocol type without errors transmitted from the source address to the destination address since this entry was added to the alMatrixDSTable. Note that this is the number of link-layer packets, so if a single network-layer packet is fragmented into several link-layer frames, this counter is incremented several times.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4847, '.1.3.6.1.2.1.16.17.2.1.3', 'alMatrixDSOctets', 4844, 'current', NULL, 'The number of octets in packets of this protocol type transmitted from the source address to the destination address since this entry was added to the alMatrixDSTable (excluding framing bits but including FCS octets), excluding those octets in packets that contained errors.  Note this doesn''t count just those octets in the particular protocol frames, but includes the entire packet that contained the protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4848, '.1.3.6.1.2.1.16.17.2.1.4', 'alMatrixDSCreateTime', 4844, 'current', NULL, 'The value of sysUpTime when this entry was last activated. This can be used by the management station to ensure that the entry has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4849, '.1.3.6.1.2.1.16.17.3', 'alMatrixTopNControlTable', 4706, 'current', NULL, 'A set of parameters that control the creation of a report of the top N matrix entries according to a selected metric.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4850, '.1.3.6.1.2.1.16.17.3.1', 'alMatrixTopNControlEntry', 4849, 'current', NULL, 'A conceptual row in the alMatrixTopNControlTable.  An example of the indexing of this table is alMatrixTopNControlDuration.3', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4851, '.1.3.6.1.2.1.16.17.3.1.1', 'alMatrixTopNControlIndex', 4850, 'current', NULL, 'An index that uniquely identifies an entry in the alMatrixTopNControlTable. Each such entry defines one top N report prepared for one interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4852, '.1.3.6.1.2.1.16.17.3.1.2', 'alMatrixTopNControlMatrixIndex', 4850, 'current', NULL, 'The alMatrix[SD/DS] table for which a top N report will be prepared on behalf of this entry. The alMatrix[SD/DS] table is identified by the value of the hlMatrixControlIndex for that table - that value is used here to identify the particular table.  This object may not be modified if the associated alMatrixTopNControlStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4949, '.1.3.6.1.2.1.16.4.4.1.2', 'hostControlCreateTime', 4947, 'current', NULL, 'The value of sysUpTime when this control entry was last activated. This can be used by the management station to ensure that the table has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4853, '.1.3.6.1.2.1.16.17.3.1.3', 'alMatrixTopNControlRateBase', 4850, 'current', NULL, 'The variable for each alMatrix[SD/DS] entry that the      alMatrixTopNEntries are sorted by, as well as the selector of the view of the matrix table that will be used.  The values alMatrixTopNTerminalsPkts and alMatrixTopNTerminalsOctets cause collection only from protocols that have no child protocols that are counted. The values alMatrixTopNAllPkts and alMatrixTopNAllOctets cause collection from all alMatrix entries.  This object may not be modified if the associated alMatrixTopNControlStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4854, '.1.3.6.1.2.1.16.17.3.1.4', 'alMatrixTopNControlTimeRemaining', 4850, 'current', NULL, 'The number of seconds left in the report currently being collected. When this object is modified by the management station, a new collection is started, possibly aborting a currently running report. The new value is used as the requested duration of this report, and is immediately loaded into the associated alMatrixTopNControlDuration object. When the report finishes, the probe will automatically start another collection with the same initial value of alMatrixTopNControlTimeRemaining. Thus the management station may simply read the resulting reports repeatedly, checking the startTime and duration each time to ensure that a report was not missed or that the report parameters were not changed.  While the value of this object is non-zero, it decrements by one per second until it reaches zero. At the time that this object decrements to zero, the report is made accessible in the alMatrixTopNTable, overwriting any report that may be there.  When this object is modified by the management station, any associated entries in the alMatrixTopNTable shall be deleted.  (Note that this is a different algorithm than the one used in the hostTopNTable).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4855, '.1.3.6.1.2.1.16.17.3.1.5', 'alMatrixTopNControlGeneratedReports', 4850, 'current', NULL, 'The number of reports that have been generated by this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4856, '.1.3.6.1.2.1.16.17.3.1.6', 'alMatrixTopNControlDuration', 4850, 'current', NULL, 'The number of seconds that this report has collected during the last sampling interval.  When the associated alMatrixTopNControlTimeRemaining object is set, this object shall be set by the probe to the same value and shall not be modified until the next time the alMatrixTopNControlTimeRemaining is set.  This value shall be zero if no reports have been requested for this alMatrixTopNControlEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4857, '.1.3.6.1.2.1.16.17.3.1.7', 'alMatrixTopNControlRequestedSize', 4850, 'current', NULL, 'The maximum number of matrix entries requested for this report.  When this object is created or modified, the probe should set alMatrixTopNControlGrantedSize as closely to this object as is possible for the particular probe implementation and available resources.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4858, '.1.3.6.1.2.1.16.17.3.1.8', 'alMatrixTopNControlGrantedSize', 4850, 'current', NULL, 'The maximum number of matrix entries in this report.  When the associated alMatrixTopNControlRequestedSize object is created or modified, the probe should set this      object as closely to the requested value as is possible for the particular implementation and available resources. The probe must not lower this value except as a result of a set to the associated alMatrixTopNControlRequestedSize object.  If the value of alMatrixTopNControlRateBase is equal to alMatrixTopNTerminalsPkts or alMatrixTopNAllPkts, when the next topN report is generated, matrix entries with the highest value of alMatrixTopNPktRate shall be placed in this table in decreasing order of this rate until there is no more room or until there are no more matrix entries.  If the value of alMatrixTopNControlRateBase is equal to alMatrixTopNTerminalsOctets or alMatrixTopNAllOctets, when the next topN report is generated, matrix entries with the highest value of alMatrixTopNOctetRate shall be placed in this table in decreasing order of this rate until there is no more room or until there are no more matrix entries.  It is an implementation-specific matter how entries with the same value of alMatrixTopNPktRate or alMatrixTopNOctetRate are sorted. It is also an implementation-specific matter as to whether or not zero-valued entries are available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4859, '.1.3.6.1.2.1.16.17.3.1.9', 'alMatrixTopNControlStartTime', 4850, 'current', NULL, 'The value of sysUpTime when this top N report was last started. In other words, this is the time that the associated alMatrixTopNControlTimeRemaining object was modified to start the requested report or the time the report was last automatically (re)started.  This object may be used by the management station to determine if a report was missed or not.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4860, '.1.3.6.1.2.1.16.17.3.1.10', 'alMatrixTopNControlOwner', 4850, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4861, '.1.3.6.1.2.1.16.17.3.1.11', 'alMatrixTopNControlStatus', 4850, 'current', NULL, 'The status of this alMatrixTopNControlEntry.  An entry may not exist in the active state unless all objects in the entry have an appropriate value.  If this object is not equal to active(1), all associated entries in the alMatrixTopNTable shall be deleted by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4862, '.1.3.6.1.2.1.16.17.4', 'alMatrixTopNTable', 4706, 'current', NULL, 'A set of statistics for those application layer matrix entries that have counted the highest number of octets or packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4863, '.1.3.6.1.2.1.16.17.4.1', 'alMatrixTopNEntry', 4862, 'current', NULL, 'A conceptual row in the alMatrixTopNTable.  The alMatrixTopNControlIndex value in the index identifies the alMatrixTopNControlEntry on whose behalf this entry was created.  An example of the indexing of this table is alMatrixTopNPktRate.3.10', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4864, '.1.3.6.1.2.1.16.17.4.1.1', 'alMatrixTopNIndex', 4863, 'current', NULL, 'An index that uniquely identifies an entry in the alMatrixTopNTable among those in the same report. This index is between 1 and N, where N is the number of entries in this report.  If the value of alMatrixTopNControlRateBase is equal to alMatrixTopNTerminalsPkts or alMatrixTopNAllPkts, increasing values of alMatrixTopNIndex shall be assigned to entries with decreasing values of alMatrixTopNPktRate until index N is assigned or there are no more alMatrixTopNEntries.  If the value of alMatrixTopNControlRateBase is equal to alMatrixTopNTerminalsOctets or alMatrixTopNAllOctets, increasing values of alMatrixTopNIndex shall be assigned to entries with decreasing values of alMatrixTopNOctetRate until index N is assigned or there are no more alMatrixTopNEntries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4865, '.1.3.6.1.2.1.16.17.4.1.2', 'alMatrixTopNProtocolDirLocalIndex', 4863, 'current', NULL, 'The protocolDirLocalIndex of the network layer protocol of this entry''s network address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4866, '.1.3.6.1.2.1.16.17.4.1.3', 'alMatrixTopNSourceAddress', 4863, 'current', NULL, 'The network layer address of the source host in this conversation. This is represented as an octet string with specific semantics and length as identified      by the associated alMatrixTopNProtocolDirLocalIndex.  For example, if the alMatrixTopNProtocolDirLocalIndex indicates an encapsulation of ip, this object is encoded as a length octet of 4, followed by the 4 octets of the ip address, in network byte order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4867, '.1.3.6.1.2.1.16.17.4.1.4', 'alMatrixTopNDestAddress', 4863, 'current', NULL, 'The network layer address of the destination host in this conversation.  This is represented as an octet string with specific semantics and length as identified by the associated alMatrixTopNProtocolDirLocalIndex.  For example, if the alMatrixTopNProtocolDirLocalIndex indicates an encapsulation of ip, this object is encoded as a length octet of 4, followed by the 4 octets of the ip address, in network byte order.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4869, '.1.3.6.1.2.1.16.17.4.1.6', 'alMatrixTopNPktRate', 4863, 'current', NULL, 'The number of packets seen of this protocol from the source host to the destination host during this sampling interval, counted using the rules for counting the alMatrixSDPkts object.  If the value of alMatrixTopNControlRateBase is alMatrixTopNTerminalsPkts or alMatrixTopNAllPkts, this variable will be used to sort this report.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4870, '.1.3.6.1.2.1.16.17.4.1.7', 'alMatrixTopNReversePktRate', 4863, 'current', NULL, 'The number of packets seen of this protocol from the destination host to the source host during this sampling interval, counted using the rules for counting the alMatrixDSPkts object (note that the corresponding alMatrixSDPkts object selected is the one whose source address is equal to alMatrixTopNDestAddress and whose destination address is equal to alMatrixTopNSourceAddress.)  Note that if the value of alMatrixTopNControlRateBase is equal to alMatrixTopNTerminalsPkts or alMatrixTopNAllPkts, the sort of topN entries is based entirely on alMatrixTopNPktRate, and not on the value of this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4871, '.1.3.6.1.2.1.16.17.4.1.8', 'alMatrixTopNOctetRate', 4863, 'current', NULL, 'The number of octets seen of this protocol from the source host to the destination host during this sampling interval, counted using the rules for counting the alMatrixSDOctets object.  If the value of alMatrixTopNControlRateBase is alMatrixTopNTerminalsOctets or alMatrixTopNAllOctets, this variable will be used to sort this report.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4872, '.1.3.6.1.2.1.16.17.4.1.9', 'alMatrixTopNReverseOctetRate', 4863, 'current', NULL, 'The number of octets seen of this protocol from the destination host to the source host during this sampling interval, counted using the rules for counting the alMatrixDSOctets object (note that the corresponding alMatrixSDOctets object selected is the one whose source address is equal to alMatrixTopNDestAddress and whose destination address is equal to alMatrixTopNSourceAddress.)  Note that if the value of alMatrixTopNControlRateBase is equal      to alMatrixTopNTerminalsOctets or alMatrixTopNAllOctets, the sort of topN entries is based entirely on alMatrixTopNOctetRate, and not on the value of this object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4873, '.1.3.6.1.2.1.16.18.1', 'usrHistoryControlTable', 4707, 'current', NULL, 'A list of data-collection configuration entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4874, '.1.3.6.1.2.1.16.18.1.1', 'usrHistoryControlEntry', 4873, 'current', NULL, 'A list of parameters that set up a group of user-defined MIB objects to be sampled periodically (called a bucket-group).  For example, an instance of usrHistoryControlInterval might be named usrHistoryControlInterval.1', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4875, '.1.3.6.1.2.1.16.18.1.1.1', 'usrHistoryControlIndex', 4874, 'current', NULL, 'An index that uniquely identifies an entry in the usrHistoryControlTable. Each such entry defines a set of samples at a particular interval for a specified set of MIB instances available from the managed system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4876, '.1.3.6.1.2.1.16.18.1.1.2', 'usrHistoryControlObjects', 4874, 'current', NULL, 'The number of MIB objects to be collected in the portion of usrHistoryTable associated with this usrHistoryControlEntry.  This object may not be modified if the associated instance of usrHistoryControlStatus is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4877, '.1.3.6.1.2.1.16.18.1.1.3', 'usrHistoryControlBucketsRequested', 4874, 'current', NULL, 'The requested number of discrete time intervals over which data is to be saved in the part of the usrHistoryTable associated with this usrHistoryControlEntry.  When this object is created or modified, the probe should set usrHistoryControlBucketsGranted as closely to this object as is possible for the particular probe implementation and available resources.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4878, '.1.3.6.1.2.1.16.18.1.1.4', 'usrHistoryControlBucketsGranted', 4874, 'current', NULL, 'The number of discrete sampling intervals over which data shall be saved in the part of the usrHistoryTable associated with this usrHistoryControlEntry.  When the associated usrHistoryControlBucketsRequested      object is created or modified, the probe should set this object as closely to the requested value as is possible for the particular probe implementation and available resources. The probe must not lower this value except as a result of a modification to the associated usrHistoryControlBucketsRequested object.  The associated usrHistoryControlBucketsRequested object should be set before or at the same time as this object to allow the probe to accurately estimate the resources required for this usrHistoryControlEntry.  There will be times when the actual number of buckets associated with this entry is less than the value of this object. In this case, at the end of each sampling interval, a new bucket will be added to the usrHistoryTable.  When the number of buckets reaches the value of this object and a new bucket is to be added to the usrHistoryTable, the oldest bucket associated with this usrHistoryControlEntry shall be deleted by the agent so that the new bucket can be added.  When the value of this object changes to a value less than the current value, entries are deleted from the usrHistoryTable associated with this usrHistoryControlEntry. Enough of the oldest of these entries shall be deleted by the agent so that their number remains less than or equal to the new value of this object.  When the value of this object changes to a value greater than the current value, the number of associated usrHistory entries may be allowed to grow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4879, '.1.3.6.1.2.1.16.18.1.1.5', 'usrHistoryControlInterval', 4874, 'current', NULL, 'The interval in seconds over which the data is sampled for each bucket in the part of the usrHistory table associated with this usrHistoryControlEntry.  Because the counters in a bucket may overflow at their maximum value with no indication, a prudent manager will take into account the possibility of overflow in any of      the associated counters. It is important to consider the minimum time in which any counter could overflow on a particular media type and set the usrHistoryControlInterval object to a value less than this interval.  This object may not be modified if the associated usrHistoryControlStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4880, '.1.3.6.1.2.1.16.18.1.1.6', 'usrHistoryControlOwner', 4874, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4881, '.1.3.6.1.2.1.16.18.1.1.7', 'usrHistoryControlStatus', 4874, 'current', NULL, 'The status of this variable history control entry.  An entry may not exist in the active state unless all objects in the entry have an appropriate value.  If this object is not equal to active(1), all associated entries in the usrHistoryTable shall be deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4882, '.1.3.6.1.2.1.16.18.2', 'usrHistoryObjectTable', 4707, 'current', NULL, 'A list of data-collection configuration entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4883, '.1.3.6.1.2.1.16.18.2.1', 'usrHistoryObjectEntry', 4882, 'current', NULL, 'A list of MIB instances to be sampled periodically.  Entries in this table are created when an associated usrHistoryControlObjects object is created.  The usrHistoryControlIndex value in the index is that of the associated usrHistoryControlEntry.  For example, an instance of usrHistoryObjectVariable might be usrHistoryObjectVariable.1.3', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4884, '.1.3.6.1.2.1.16.18.2.1.1', 'usrHistoryObjectIndex', 4883, 'current', NULL, 'An index used to uniquely identify an entry in the usrHistoryObject table. Each such entry defines a MIB instance to be collected periodically.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4950, '.1.3.6.1.2.1.16.6.4', 'matrixControl2Table', 386, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4951, '.1.3.6.1.2.1.16.6.4.1', 'matrixControl2Entry', 4950, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6786, '.1.3.6.1.4.1.9.2.2.1.1.98', 'locIfstunInPkts', 6689, 'mandatory', NULL, 'STUN protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4885, '.1.3.6.1.2.1.16.18.2.1.2', 'usrHistoryObjectVariable', 4883, 'current', NULL, 'The object identifier of the particular variable to be sampled.  Only variables that resolve to an ASN.1 primitive type of Integer32 (Integer32, Counter, Gauge, or TimeTicks) may be sampled.  Because SNMP access control is articulated entirely in terms of the contents of MIB views, no access control mechanism exists that can restrict the value of this object to identify only those objects that exist in a particular MIB view. Because there is thus no acceptable means of restricting the read access that could be obtained through the user history      mechanism, the probe must only grant write access to this object in those views that have read access to all objects on the probe.  During a set operation, if the supplied variable name is not available in the selected MIB view, a badValue error must be returned.  This object may not be modified if the associated usrHistoryControlStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4886, '.1.3.6.1.2.1.16.18.2.1.3', 'usrHistoryObjectSampleType', 4883, 'current', NULL, 'The method of sampling the selected variable for storage in the usrHistoryTable.  If the value of this object is absoluteValue(1), the value of the selected variable will be copied directly into the history bucket.  If the value of this object is deltaValue(2), the value of the selected variable at the last sample will be subtracted from the current value, and the difference will be stored in the history bucket. If the associated usrHistoryObjectVariable instance could not be obtained at the previous sample interval, then a delta sample is not possible, and the value of the associated usrHistoryValStatus object for this interval will be valueNotAvailable(1).  This object may not be modified if the associated usrHistoryControlStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4887, '.1.3.6.1.2.1.16.18.3', 'usrHistoryTable', 4707, 'current', NULL, 'A list of user defined history entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4888, '.1.3.6.1.2.1.16.18.3.1', 'usrHistoryEntry', 4887, 'current', NULL, 'A historical sample of user-defined variables. This sample is associated with the usrHistoryControlEntry which set up the parameters for a regular collection of these samples.  The usrHistoryControlIndex value in the index identifies the usrHistoryControlEntry on whose behalf this entry was created.  The usrHistoryObjectIndex value in the index identifies the usrHistoryObjectEntry on whose behalf this entry was created.  For example, an instance of usrHistoryAbsValue, which represents the 14th sample of a variable collected as specified by usrHistoryControlEntry.1 and usrHistoryObjectEntry.1.5, would be named usrHistoryAbsValue.1.14.5', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4889, '.1.3.6.1.2.1.16.18.3.1.1', 'usrHistorySampleIndex', 4888, 'current', NULL, 'An index that uniquely identifies the particular sample this entry represents among all samples associated with the same usrHistoryControlEntry. This index starts at 1 and increases by one as each new sample is taken.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4890, '.1.3.6.1.2.1.16.18.3.1.2', 'usrHistoryIntervalStart', 4888, 'current', NULL, 'The value of sysUpTime at the start of the interval over which this sample was measured. If the probe keeps track of the time of day, it should start the first sample of the history at a time such that when the next hour of the day begins, a sample is started at that instant.  Note that following this rule may require the probe to delay collecting the first sample of the history, as each sample must be of the same interval. Also note that the sample which is currently being collected is not accessible in this table until the end of its interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4891, '.1.3.6.1.2.1.16.18.3.1.3', 'usrHistoryIntervalEnd', 4888, 'current', NULL, 'The value of sysUpTime at the end of the interval over which this sample was measured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4892, '.1.3.6.1.2.1.16.18.3.1.4', 'usrHistoryAbsValue', 4888, 'current', NULL, 'The absolute value (i.e. unsigned value) of the user-specified statistic during the last sampling period. The value during the current sampling period is not made available until the period is completed.  To obtain the true value for this sampling interval, the associated instance of usrHistoryValStatus must be checked, and usrHistoryAbsValue adjusted as necessary.  If the MIB instance could not be accessed during the sampling interval, then this object will have a value of zero and the associated instance of usrHistoryValStatus will be set to ''valueNotAvailable(1)''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4893, '.1.3.6.1.2.1.16.18.3.1.5', 'usrHistoryValStatus', 4888, 'current', NULL, 'This object indicates the validity and sign of the data in the associated instance of usrHistoryAbsValue.  If the MIB instance could not be accessed during the sampling interval, then ''valueNotAvailable(1)'' will be returned.  If the sample is valid and actual value of the sample is greater than or equal to zero then ''valuePositive(2)'' is returned.  If the sample is valid and the actual value of the sample is less than zero, ''valueNegative(3)'' will be returned. The associated instance of usrHistoryAbsValue should be multiplied by -1 to obtain the true sample value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4894, '.1.3.6.1.2.1.16.19.1', 'probeCapabilities', 4708, 'current', NULL, 'An indication of the RMON MIB groups supported on at least one interface by this probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4895, '.1.3.6.1.2.1.16.19.2', 'probeSoftwareRev', 4708, 'current', NULL, 'The software revision of this device. This string will have a zero length if the revision is unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4896, '.1.3.6.1.2.1.16.19.3', 'probeHardwareRev', 4708, 'current', NULL, 'The hardware revision of this device. This string will have a zero length if the revision is unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4897, '.1.3.6.1.2.1.16.19.4', 'probeDateTime', 4708, 'current', NULL, 'Probe''s current date and time.  field octets contents range - ------ -------- ----- 1 1-2 year 0..65536 2 3 month 1..12 3 4 day 1..31 4 5 hour 0..23 5 6 minutes 0..59 6 7 seconds 0..60 (use 60 for leap-second) 7 8 deci-seconds 0..9 8 9 direction from UTC ''+'' / ''-'' 9 10 hours from UTC 0..11 10 11 minutes from UTC 0..59  For example, Tuesday May 26, 1992 at 1:30:15 PM EDT would be displayed as:  1992-5-26,13:30:15.0,-4:0  Note that if only local time is known, then timezone information (fields 8-10) is not present, and if no time information is known, the null string is returned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4898, '.1.3.6.1.2.1.16.19.5', 'probeResetControl', 4708, 'current', NULL, 'Setting this object to warmBoot(2) causes the device to restart the application software with current configuration parameters saved in non-volatile memory. Setting this object to coldBoot(3) causes the device to reinitialize configuration parameters in non-volatile memory to default values and restart the application software. When the device is running normally, this variable has a value of running(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4899, '.1.3.6.1.2.1.16.19.6', 'probeDownloadFile', 4708, 'current', NULL, 'The file name to be downloaded from the TFTP server when a download is next requested via this MIB. This value is set to the zero length string when no file name has been specified.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4900, '.1.3.6.1.2.1.16.19.7', 'probeDownloadTFTPServer', 4708, 'current', NULL, 'The IP address of the TFTP server that contains the boot image to load when a download is next requested via this MIB. This value is set to `0.0.0.0'' when no IP address has been specified.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4923, '.1.3.6.1.2.1.16.19.13.1.2', 'trapDestCommunity', 4921, 'current', NULL, 'A community to which this destination address belongs. This entry is associated with any eventEntries in the RMON      MIB whose value of eventCommunity is equal to the value of this object. Every time an associated event entry sends a trap due to an event, that trap will be sent to each address in the trapDestTable with a trapDestCommunity equal to eventCommunity.  This object may not be modified if the associated trapDestStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4901, '.1.3.6.1.2.1.16.19.8', 'probeDownloadAction', 4708, 'current', NULL, 'When this object is set to downloadToRAM(2) or downloadToPROM(3), the device will discontinue its normal operation and begin download of the image specified by probeDownloadFile from the server specified by probeDownloadTFTPServer using the TFTP protocol. If downloadToRAM(2) is specified, the new image is copied to RAM only (the old image remains unaltered in the flash EPROM). If downloadToPROM(3) is specified the new image is written to the flash EPROM memory after its checksum has been verified to be correct. When the download process is completed, the device will      warm boot to restart the newly loaded application. When the device is not downloading, this object will have a value of notDownloading(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4902, '.1.3.6.1.2.1.16.19.9', 'probeDownloadStatus', 4708, 'current', NULL, 'The status of the last download procedure, if any. This object will have a value of downloadStatusUnknown(2) if no download process has been performed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4903, '.1.3.6.1.2.1.16.19.10', 'serialConfigTable', 4708, 'current', NULL, 'A table of serial interface configuration entries. This data will be stored in non-volatile memory and preserved across probe resets or power loss.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4904, '.1.3.6.1.2.1.16.19.10.1', 'serialConfigEntry', 4903, 'current', NULL, 'A set of configuration parameters for a particular serial interface on this device. If the device has no serial interfaces, this table is empty.  The index is composed of the ifIndex assigned to this serial line interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4905, '.1.3.6.1.2.1.16.19.10.1.1', 'serialMode', 4904, 'current', NULL, 'The type of incoming connection to expect on this serial interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4906, '.1.3.6.1.2.1.16.19.10.1.2', 'serialProtocol', 4904, 'current', NULL, 'The type of data link encapsulation to be used on this serial interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4907, '.1.3.6.1.2.1.16.19.10.1.3', 'serialTimeout', 4904, 'current', NULL, 'This timeout value is used when the Management Station has initiated the conversation over the serial link. This variable represents the number of seconds of inactivity allowed before terminating the connection on this serial interface. Use the      serialDialoutTimeout in the case where the probe has initiated the connection for the purpose of sending a trap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4908, '.1.3.6.1.2.1.16.19.10.1.4', 'serialModemInitString', 4904, 'current', NULL, 'A control string which controls how a modem attached to this serial interface should be initialized. The initialization is performed once during startup and again after each connection is terminated if the associated serialMode has the value of modem(2).  A control string that is appropriate for a wide variety of modems is: ''^s^MATE0Q0V1X4 S0=1 S2=43^M''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4909, '.1.3.6.1.2.1.16.19.10.1.5', 'serialModemHangUpString', 4904, 'current', NULL, 'A control string which specifies how to disconnect a modem connection on this serial interface. This object is only meaningful if the associated serialMode has the value of modem(2). A control string that is appropriate for a wide variety of modems is: ''^d2^s+++^d2^sATH0^M^d2''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4910, '.1.3.6.1.2.1.16.19.10.1.6', 'serialModemConnectResp', 4904, 'current', NULL, 'An ASCII string containing substrings that describe the expected modem connection response code and associated bps rate. The substrings are delimited by the first character in the string, for example: /CONNECT/300/CONNECT 1200/1200/CONNECT 2400/2400/ CONNECT 4800/4800/CONNECT 9600/9600 will be interpreted as: response code bps rate CONNECT 300 CONNECT 1200 1200      CONNECT 2400 2400 CONNECT 4800 4800 CONNECT 9600 9600 The agent will use the information in this string to adjust the bps rate of this serial interface once a modem connection is established.  A value that is appropriate for a wide variety of modems is: ''/CONNECT/300/CONNECT 1200/1200/CONNECT 2400/2400/ CONNECT 4800/4800/CONNECT 9600/9600/CONNECT 14400/14400/ CONNECT 19200/19200/CONNECT 38400/38400/''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4911, '.1.3.6.1.2.1.16.19.10.1.7', 'serialModemNoConnectResp', 4904, 'current', NULL, 'An ASCII string containing response codes that may be generated by a modem to report the reason why a connection attempt has failed. The response codes are delimited by the first character in the string, for example: /NO CARRIER/BUSY/NO DIALTONE/NO ANSWER/ERROR/ If one of these response codes is received via this serial interface while attempting to make a modem connection, the agent will issue the hang up command as specified by serialModemHangUpString.  A value that is appropriate for a wide variety of modems is: ''/NO CARRIER/BUSY/NO DIALTONE/NO ANSWER/ERROR/''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4912, '.1.3.6.1.2.1.16.19.10.1.8', 'serialDialoutTimeout', 4904, 'current', NULL, 'This timeout value is used when the probe initiates the serial connection with the intention of contacting a management station. This variable represents the number of seconds of inactivity allowed before terminating the connection on this serial interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4913, '.1.3.6.1.2.1.16.19.10.1.9', 'serialStatus', 4904, 'current', NULL, 'The status of this serialConfigEntry.  An entry may not exist in the active state unless all objects in the entry have an appropriate value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4914, '.1.3.6.1.2.1.16.19.11', 'netConfigTable', 4708, 'current', NULL, 'A table of netConfigEntries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4915, '.1.3.6.1.2.1.16.19.11.1', 'netConfigEntry', 4914, 'current', NULL, 'A set of configuration parameters for a particular network interface on this device. If the device has no network interface, this table is empty.  The index is composed of the ifIndex assigned to the corresponding interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4916, '.1.3.6.1.2.1.16.19.11.1.1', 'netConfigIPAddress', 4915, 'current', NULL, 'The IP address of this Net interface. The default value for this object is 0.0.0.0. If either the netConfigIPAddress or netConfigSubnetMask are 0.0.0.0, then when the device boots, it may use BOOTP to try to figure out what these values should be. If BOOTP fails, before the device can talk on the network, this value must be configured (e.g., through a terminal attached to the device). If BOOTP is      used, care should be taken to not send BOOTP broadcasts too frequently and to eventually send very infrequently if no replies are received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4917, '.1.3.6.1.2.1.16.19.11.1.2', 'netConfigSubnetMask', 4915, 'current', NULL, 'The subnet mask of this Net interface. The default value for this object is 0.0.0.0. If either the netConfigIPAddress or netConfigSubnetMask are 0.0.0.0, then when the device boots, it may use BOOTP to try to figure out what these values should be. If BOOTP fails, before the device can talk on the network, this value must be configured (e.g., through a terminal attached to the device). If BOOTP is used, care should be taken to not send BOOTP broadcasts too frequently and to eventually send very infrequently if no replies are received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4918, '.1.3.6.1.2.1.16.19.11.1.3', 'netConfigStatus', 4915, 'current', NULL, 'The status of this netConfigEntry.  An entry may not exist in the active state unless all objects in the entry have an appropriate value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4919, '.1.3.6.1.2.1.16.19.12', 'netDefaultGateway', 4708, 'current', NULL, 'The IP Address of the default gateway. If this value is undefined or unknown, it shall have the value 0.0.0.0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4920, '.1.3.6.1.2.1.16.19.13', 'trapDestTable', 4708, 'current', NULL, 'A list of trap destination entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4921, '.1.3.6.1.2.1.16.19.13.1', 'trapDestEntry', 4920, 'current', NULL, 'This entry includes a destination IP address to which to send traps for this community.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4922, '.1.3.6.1.2.1.16.19.13.1.1', 'trapDestIndex', 4921, 'current', NULL, 'A value that uniquely identifies this trapDestEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4924, '.1.3.6.1.2.1.16.19.13.1.3', 'trapDestProtocol', 4921, 'current', NULL, 'The protocol with which to send this trap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4978, '.1.3.6.1.2.1.16.20.1', 'rmon2MIBCompliances', 4709, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4925, '.1.3.6.1.2.1.16.19.13.1.4', 'trapDestAddress', 4921, 'current', NULL, 'The address to send traps on behalf of this entry.  If the associated trapDestProtocol object is equal to ip(1), the encoding of this object is the same as the snmpUDPAddress textual convention in [RFC1906]:       If the associated trapDestProtocol object is equal to ipx(2), the encoding of this object is the same as the snmpIPXAddress textual convention in [RFC1906]:        This object may not be modified if the associated      trapDestStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4926, '.1.3.6.1.2.1.16.19.13.1.5', 'trapDestOwner', 4921, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4927, '.1.3.6.1.2.1.16.19.13.1.6', 'trapDestStatus', 4921, 'current', NULL, 'The status of this trap destination entry.  An entry may not exist in the active state unless all objects in the entry have an appropriate value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4928, '.1.3.6.1.2.1.16.19.14', 'serialConnectionTable', 4708, 'current', NULL, 'A list of serialConnectionEntries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4929, '.1.3.6.1.2.1.16.19.14.1', 'serialConnectionEntry', 4928, 'current', NULL, 'Configuration for a SLIP link over a serial line.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4930, '.1.3.6.1.2.1.16.19.14.1.1', 'serialConnectIndex', 4929, 'current', NULL, 'A value that uniquely identifies this serialConnection entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4931, '.1.3.6.1.2.1.16.19.14.1.2', 'serialConnectDestIpAddress', 4929, 'current', NULL, 'The IP Address that can be reached at the other end of this serial connection. This object may not be modified if the associated serialConnectStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4932, '.1.3.6.1.2.1.16.19.14.1.3', 'serialConnectType', 4929, 'current', NULL, 'The type of outgoing connection to make. If this object has the value direct(1), then a direct serial connection is assumed. If this object has the value modem(2), then serialConnectDialString will be used to make a modem connection. If this object has the value switch(3),      then serialConnectSwitchConnectSeq will be used to establish the connection over a serial data switch, and serialConnectSwitchDisconnectSeq will be used to terminate the connection. If this object has the value modem-switch(4), then a modem connection will be made first followed by the switch connection.  This object may not be modified if the associated serialConnectStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4933, '.1.3.6.1.2.1.16.19.14.1.4', 'serialConnectDialString', 4929, 'current', NULL, 'A control string which specifies how to dial the phone number in order to establish a modem connection. The string should include dialing prefix and suffix. For example: ``^s^MATD9,888-1234^M'''' will instruct the Probe to send a carriage return followed by the dialing prefix ``ATD'''', the phone number ``9,888-1234'''', and a carriage return as the dialing suffix. This object may not be modified if the associated serialConnectStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4934, '.1.3.6.1.2.1.16.19.14.1.5', 'serialConnectSwitchConnectSeq', 4929, 'current', NULL, 'A control string which specifies how to establish a data switch connection. This object may not be modified if the associated serialConnectStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4935, '.1.3.6.1.2.1.16.19.14.1.6', 'serialConnectSwitchDisconnectSeq', 4929, 'current', NULL, 'A control string which specifies how to terminate a data switch connection. This object may not be modified if the associated      serialConnectStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4936, '.1.3.6.1.2.1.16.19.14.1.7', 'serialConnectSwitchResetSeq', 4929, 'current', NULL, 'A control string which specifies how to reset a data switch in the event of a timeout. This object may not be modified if the associated serialConnectStatus object is equal to active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4937, '.1.3.6.1.2.1.16.19.14.1.8', 'serialConnectOwner', 4929, 'current', NULL, 'The entity that configured this entry and is therefore using the resources assigned to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4938, '.1.3.6.1.2.1.16.19.14.1.9', 'serialConnectStatus', 4929, 'current', NULL, 'The status of this serialConnectionEntry.  If the manager attempts to set this object to active(1) when the serialConnectType is set to modem(2) or modem-switch(4) and the serialConnectDialString is a zero-length string or cannot be correctly parsed as a ConnectString, the set request will be rejected with badValue(3).  If the manager attempts to set this object to active(1) when the serialConnectType is set to switch(3) or modem-switch(4) and the serialConnectSwitchConnectSeq, the serialConnectSwitchDisconnectSeq, or the serialConnectSwitchResetSeq are zero-length strings or cannot be correctly parsed as ConnectStrings, the set request will be rejected with badValue(3).  An entry may not exist in the active state unless all objects in the entry have an appropriate value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4939, '.1.3.6.1.2.1.16.1.4', 'etherStats2Table', 381, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4940, '.1.3.6.1.2.1.16.1.4.1', 'etherStats2Entry', 4939, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4941, '.1.3.6.1.2.1.16.1.4.1.1', 'etherStatsDroppedFrames', 4940, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted      because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4942, '.1.3.6.1.2.1.16.1.4.1.2', 'etherStatsCreateTime', 4940, 'current', NULL, 'The value of sysUpTime when this control entry was last activated. This can be used by the management station to ensure that the table has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4943, '.1.3.6.1.2.1.16.2.5', 'historyControl2Table', 382, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4944, '.1.3.6.1.2.1.16.2.5.1', 'historyControl2Entry', 4943, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4945, '.1.3.6.1.2.1.16.2.5.1.1', 'historyControlDroppedFrames', 4944, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this      collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4946, '.1.3.6.1.2.1.16.4.4', 'hostControl2Table', 384, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4947, '.1.3.6.1.2.1.16.4.4.1', 'hostControl2Entry', 4946, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4948, '.1.3.6.1.2.1.16.4.4.1.1', 'hostControlDroppedFrames', 4947, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4979, '.1.3.6.1.2.1.16.20.2', 'rmon2MIBGroups', 4709, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4980, '.1.3.6.1.2.1.16.20.1.1', 'rmon2MIBCompliance', 4978, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4952, '.1.3.6.1.2.1.16.6.4.1.1', 'matrixControlDroppedFrames', 4951, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted      because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4953, '.1.3.6.1.2.1.16.6.4.1.2', 'matrixControlCreateTime', 4951, 'current', NULL, 'The value of sysUpTime when this control entry was last activated. This can be used by the management station to ensure that the table has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4954, '.1.3.6.1.2.1.16.7.3', 'channel2Table', 387, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4955, '.1.3.6.1.2.1.16.7.3.1', 'channel2Entry', 4954, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4956, '.1.3.6.1.2.1.16.7.3.1.1', 'channelDroppedFrames', 4955, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe      is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4957, '.1.3.6.1.2.1.16.7.3.1.2', 'channelCreateTime', 4955, 'current', NULL, 'The value of sysUpTime when this control entry was last activated. This can be used by the management station to ensure that the table has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4958, '.1.3.6.1.2.1.16.1.5', 'tokenRingMLStats2Table', 381, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4959, '.1.3.6.1.2.1.16.1.5.1', 'tokenRingMLStats2Entry', 4958, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4960, '.1.3.6.1.2.1.16.1.5.1.1', 'tokenRingMLStatsDroppedFrames', 4959, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4961, '.1.3.6.1.2.1.16.1.5.1.2', 'tokenRingMLStatsCreateTime', 4959, 'current', NULL, 'The value of sysUpTime when this control entry was last activated. This can be used by the management station to ensure that the table has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4962, '.1.3.6.1.2.1.16.1.6', 'tokenRingPStats2Table', 381, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4963, '.1.3.6.1.2.1.16.1.6.1', 'tokenRingPStats2Entry', 4962, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4964, '.1.3.6.1.2.1.16.1.6.1.1', 'tokenRingPStatsDroppedFrames', 4963, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4965, '.1.3.6.1.2.1.16.1.6.1.2', 'tokenRingPStatsCreateTime', 4963, 'current', NULL, 'The value of sysUpTime when this control entry was last activated. This can be used by the management station to ensure that the table has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4966, '.1.3.6.1.2.1.16.10.7', 'ringStationControl2Table', 4518, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4967, '.1.3.6.1.2.1.16.10.7.1', 'ringStationControl2Entry', 4966, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4968, '.1.3.6.1.2.1.16.10.7.1.1', 'ringStationControlDroppedFrames', 4967, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4969, '.1.3.6.1.2.1.16.10.7.1.2', 'ringStationControlCreateTime', 4967, 'current', NULL, 'The value of sysUpTime when this control entry was last activated. This can be used by the management station to ensure that the table has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4970, '.1.3.6.1.2.1.16.10.8', 'sourceRoutingStats2Table', 4518, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4971, '.1.3.6.1.2.1.16.10.8.1', 'sourceRoutingStats2Entry', 4970, 'current', NULL, 'Contains the RMON-2 augmentations to RMON-1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4972, '.1.3.6.1.2.1.16.10.8.1.1', 'sourceRoutingStatsDroppedFrames', 4971, 'current', NULL, 'The total number of frames which were received by the probe and therefore not accounted for in the *StatsDropEvents, but for which the probe chose not to count for this entry for whatever reason. Most often, this event occurs when the probe is out of some resources and decides to shed load from this collection.  This count does not include packets that were not counted because they had MAC-layer errors.  Note that, unlike the dropEvents counter, this number is the exact number of frames dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4973, '.1.3.6.1.2.1.16.10.8.1.2', 'sourceRoutingStatsCreateTime', 4971, 'current', NULL, 'The value of sysUpTime when this control entry was last activated. This can be used by the management station to ensure that the table has not been deleted and recreated between polls.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4974, '.1.3.6.1.2.1.16.7.4', 'filter2Table', 387, 'current', NULL, 'Provides a variable-length packet filter feature to the RMON-1 filter table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4975, '.1.3.6.1.2.1.16.7.4.1', 'filter2Entry', 4974, 'current', NULL, 'Provides a variable-length packet filter feature to the RMON-1 filter table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4976, '.1.3.6.1.2.1.16.7.4.1.1', 'filterProtocolDirDataLocalIndex', 4975, 'current', NULL, 'When this object is set to a non-zero value, the filter that it is associated with performs the following operations on every packet:  1) - If the packet doesn''t match the protocol directory entry identified by this object, discard the packet and exit (i.e., discard the packet if it is not of the identified protocol). 2) - If the associated filterProtocolDirLocalIndex is non-zero and the packet doesn''t match the protocol directory entry identified by that object, discard the packet and exit 3) - If the packet matches, perform the regular filter algorithm as if the beginning of this named protocol is the beginning of the packet, potentially applying the filterOffset value to move further into the packet.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4977, '.1.3.6.1.2.1.16.7.4.1.2', 'filterProtocolDirLocalIndex', 4975, 'current', NULL, 'When this object is set to a non-zero value, the filter that it is associated with will discard the packet if the packet doesn''t match this protocol directory entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4984, '.1.3.6.1.2.1.16.20.2.3', 'addressMapGroup', 4979, 'current', NULL, 'Lists MAC address to network address bindings discovered by the probe and what interface they were last seen on.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4985, '.1.3.6.1.2.1.16.20.2.4', 'nlHostGroup', 4979, 'current', NULL, 'Counts the amount of traffic sent from and to each network      address discovered by the probe. Note that while the hlHostControlTable also has objects that control an optional alHostTable, implementation of the alHostTable is not required to fully implement this group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4986, '.1.3.6.1.2.1.16.20.2.5', 'nlMatrixGroup', 4979, 'current', NULL, 'Counts the amount of traffic sent between each pair of network addresses discovered by the probe. Note that while the hlMatrixControlTable also has objects that control optional alMatrixTables, implementation of the alMatrixTables is not required to fully implement this group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4987, '.1.3.6.1.2.1.16.20.2.6', 'alHostGroup', 4979, 'current', NULL, 'Counts the amount of traffic, by protocol, sent from and to each network address discovered by the probe. Implementation of this group requires implementation of the Network Layer Host Group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4988, '.1.3.6.1.2.1.16.20.2.7', 'alMatrixGroup', 4979, 'current', NULL, 'Counts the amount of traffic, by protocol, sent between each pair of network addresses discovered by the probe. Implementation of this group requires implementation of the Network Layer Matrix Group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4989, '.1.3.6.1.2.1.16.20.2.8', 'usrHistoryGroup', 4979, 'current', NULL, 'The usrHistoryGroup provides user-defined collection of historical information from MIB objects on the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4990, '.1.3.6.1.2.1.16.20.2.9', 'probeInformationGroup', 4979, 'current', NULL, 'This group describes various operating parameters of the      probe as well as controlling the local time of the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4991, '.1.3.6.1.2.1.16.20.2.10', 'probeConfigurationGroup', 4979, 'current', NULL, 'This group controls the configuration of various operating parameters of the probe.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4992, '.1.3.6.1.2.1.16.20.2.11', 'rmon1EnhancementGroup', 4979, 'current', NULL, 'This group adds some enhancements to RMON-1 that help management stations.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4993, '.1.3.6.1.2.1.16.20.2.12', 'rmon1EthernetEnhancementGroup', 4979, 'current', NULL, 'This group adds some enhancements to RMON-1 that help management stations.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4994, '.1.3.6.1.2.1.16.20.2.13', 'rmon1TokenRingEnhancementGroup', 4979, 'current', NULL, 'This group adds some enhancements to RMON-1 that help management stations.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4995, '.1.3.6.1.2.1.17.7', 'qBridgeMIB', 1945, 'current', NULL, 'The VLAN Bridge MIB module for managing Virtual Bridged Local Area Networks, as defined by IEEE 802.1Q-2003, including Restricted Vlan Registration defined by IEEE 802.1u-2001 and Vlan Classification defined by IEEE 802.1v-2001.  Copyright (C) The Internet Society (2006). This version of this MIB module is part of RFC 4363; See the RFC itself for full legal notices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4996, '.1.3.6.1.2.1.17.7.1', 'qBridgeMIBObjects', 4995, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4997, '.1.3.6.1.2.1.17.7.1.1', 'dot1qBase', 4996, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4998, '.1.3.6.1.2.1.17.7.1.2', 'dot1qTp', 4996, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (4999, '.1.3.6.1.2.1.17.7.1.3', 'dot1qStatic', 4996, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5000, '.1.3.6.1.2.1.17.7.1.4', 'dot1qVlan', 4996, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5001, '.1.3.6.1.2.1.17.7.1.5', 'dot1vProtocol', 4996, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5002, '.1.3.6.1.2.1.17.7.1.1.1', 'dot1qVlanVersionNumber', 4997, 'current', 'IEEE 802.1Q/D11 Section 12.10.1.1', 'The version number of IEEE 802.1Q that this device supports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5003, '.1.3.6.1.2.1.17.7.1.1.2', 'dot1qMaxVlanId', 4997, 'current', 'IEEE 802.1Q/D11 Section 9.3.2.3', 'The maximum IEEE 802.1Q VLAN-ID that this device  supports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5004, '.1.3.6.1.2.1.17.7.1.1.3', 'dot1qMaxSupportedVlans', 4997, 'current', 'IEEE 802.1Q/D11 Section 12.10.1.1', 'The maximum number of IEEE 802.1Q VLANs that this device supports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5005, '.1.3.6.1.2.1.17.7.1.1.4', 'dot1qNumVlans', 4997, 'current', 'IEEE 802.1Q/D11 Section 12.7.1.1', 'The current number of IEEE 802.1Q VLANs that are configured in this device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5006, '.1.3.6.1.2.1.17.7.1.1.5', 'dot1qGvrpStatus', 4997, 'current', NULL, 'The administrative status requested by management for GVRP. The value enabled(1) indicates that GVRP should be enabled on this device, on all ports for which it has not been specifically disabled. When disabled(2), GVRP is disabled on all ports, and all GVRP packets will be forwarded transparently. This object affects all GVRP Applicant and Registrar state machines. A transition from disabled(2) to enabled(1) will cause a reset of all GVRP state machines on all ports.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5007, '.1.3.6.1.2.1.17.7.1.2.1', 'dot1qFdbTable', 4998, 'current', NULL, 'A table that contains configuration and control information for each Filtering Database currently operating on this device. Entries in this table appear automatically when VLANs are assigned FDB IDs in the dot1qVlanCurrentTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5008, '.1.3.6.1.2.1.17.7.1.2.1.1', 'dot1qFdbEntry', 5007, 'current', NULL, 'Information about a specific Filtering Database.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5009, '.1.3.6.1.2.1.17.7.1.2.1.1.1', 'dot1qFdbId', 5008, 'current', NULL, 'The identity of this Filtering Database.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5010, '.1.3.6.1.2.1.17.7.1.2.1.1.2', 'dot1qFdbDynamicCount', 5008, 'current', 'IEEE 802.1Q/D11 Section 12.7.1.1.3', 'The current number of dynamic entries in this Filtering Database.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5011, '.1.3.6.1.2.1.17.7.1.2.2', 'dot1qTpFdbTable', 4998, 'current', 'IEEE 802.1Q/D11 Section 12.7.7', 'A table that contains information about unicast entries for which the device has forwarding and/or filtering information. This information is used by the transparent bridging function in determining how to propagate a received frame.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5012, '.1.3.6.1.2.1.17.7.1.2.2.1', 'dot1qTpFdbEntry', 5011, 'current', NULL, 'Information about a specific unicast MAC address for which the device has some forwarding and/or filtering information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5013, '.1.3.6.1.2.1.17.7.1.2.2.1.1', 'dot1qTpFdbAddress', 5012, 'current', NULL, 'A unicast MAC address for which the device has forwarding and/or filtering information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5014, '.1.3.6.1.2.1.17.7.1.2.2.1.2', 'dot1qTpFdbPort', 5012, 'current', NULL, 'Either the value ''0'', or the port number of the port on which a frame having a source address equal to the value of the corresponding instance of dot1qTpFdbAddress has been seen. A value of ''0'' indicates that the port number has not been learned but that the device does have some forwarding/filtering information about this address (e.g., in the dot1qStaticUnicastTable). Implementors are encouraged to assign the port value to this object whenever it is learned, even for addresses for which the corresponding value of dot1qTpFdbStatus is not learned(3).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5031, '.1.3.6.1.2.1.17.7.1.3.1', 'dot1qStaticUnicastTable', 4999, 'current', 'IEEE 802.1Q/D11 Section 12.7.7, ISO/IEC 15802-3 Section 7.9.1', 'A table containing filtering information for Unicast MAC addresses for each Filtering Database, configured into the device by (local or network) management specifying the set of ports to which frames received from specific ports and containing specific unicast destination addresses are allowed to be forwarded. A value of zero in this table (as the port number from  which frames with a specific destination address are received) is used to specify all ports for which there is no specific entry in this table for that particular destination address. Entries are valid for unicast addresses only.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6292, '.1.0.8802.1.1.2.1.3.7.1.2', 'lldpLocPortIdSubtype', 6290, 'current', 'IEEE 802.1AB-2005 9.5.3.2', 'The type of port identifier encoding used in the associated ''lldpLocPortId'' object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5015, '.1.3.6.1.2.1.17.7.1.2.2.1.3', 'dot1qTpFdbStatus', 5012, 'current', NULL, 'The status of this entry. The meanings of the values are: other(1) - none of the following. This may include the case where some other MIB object (not the corresponding instance of dot1qTpFdbPort, nor an entry in the dot1qStaticUnicastTable) is being used to determine if and how frames addressed to the value of the corresponding instance of dot1qTpFdbAddress are being forwarded. invalid(2) - this entry is no longer valid (e.g., it  was learned but has since aged out), but has not yet been flushed from the table. learned(3) - the value of the corresponding instance of dot1qTpFdbPort was learned and is being used. self(4) - the value of the corresponding instance of dot1qTpFdbAddress represents one of the device''s addresses. The corresponding instance of dot1qTpFdbPort indicates which of the device''s ports has this address. mgmt(5) - the value of the corresponding instance of dot1qTpFdbAddress is also the value of an existing instance of dot1qStaticAddress.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5016, '.1.3.6.1.2.1.17.7.1.2.3', 'dot1qTpGroupTable', 4998, 'current', NULL, 'A table containing filtering information for VLANs configured into the bridge by (local or network) management, or learned dynamically, specifying the set of ports to which frames received on a VLAN for this FDB and containing a specific Group destination address are allowed to be forwarded.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5017, '.1.3.6.1.2.1.17.7.1.2.3.1', 'dot1qTpGroupEntry', 5016, 'current', NULL, 'Filtering information configured into the bridge by management, or learned dynamically, specifying the set of ports to which frames received on a VLAN and containing a specific Group destination address are allowed to be forwarded. The subset of these ports learned dynamically is also provided.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5018, '.1.3.6.1.2.1.17.7.1.2.3.1.1', 'dot1qTpGroupAddress', 5017, 'current', NULL, 'The destination Group MAC address in a frame to which this entry''s filtering information applies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5019, '.1.3.6.1.2.1.17.7.1.2.3.1.2', 'dot1qTpGroupEgressPorts', 5017, 'current', NULL, 'The complete set of ports, in this VLAN, to which frames destined for this Group MAC address are currently being explicitly forwarded. This does not include ports for which this address is only implicitly forwarded, in the dot1qForwardAllPorts list.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5020, '.1.3.6.1.2.1.17.7.1.2.3.1.3', 'dot1qTpGroupLearnt', 5017, 'current', NULL, 'The subset of ports in dot1qTpGroupEgressPorts that were learned by GMRP or some other dynamic mechanism, in this Filtering database.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5021, '.1.3.6.1.2.1.17.7.1.2.4', 'dot1qForwardAllTable', 4998, 'current', 'IEEE 802.1Q/D11 Section 12.7.2, 12.7.7', 'A table containing forwarding information for each  VLAN, specifying the set of ports to which forwarding of all multicasts applies, configured statically by management or dynamically by GMRP. An entry appears in this table for all VLANs that are currently instantiated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5022, '.1.3.6.1.2.1.17.7.1.2.4.1', 'dot1qForwardAllEntry', 5021, 'current', NULL, 'Forwarding information for a VLAN, specifying the set of ports to which all multicasts should be forwarded, configured statically by management or dynamically by GMRP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5023, '.1.3.6.1.2.1.17.7.1.2.4.1.1', 'dot1qForwardAllPorts', 5022, 'current', NULL, 'The complete set of ports in this VLAN to which all multicast group-addressed frames are to be forwarded. This includes ports for which this need has been determined dynamically by GMRP, or configured statically by management.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5024, '.1.3.6.1.2.1.17.7.1.2.4.1.2', 'dot1qForwardAllStaticPorts', 5022, 'current', NULL, 'The set of ports configured by management in this VLAN to which all multicast group-addressed frames are to be forwarded. Ports entered in this list will also appear in the complete set shown by dot1qForwardAllPorts. This value will be restored after the device is reset. This only applies to ports that are members of the VLAN, defined by dot1qVlanCurrentEgressPorts. A port may not be added in this set if it is already a member of the set of ports in dot1qForwardAllForbiddenPorts. The default value is a string of ones of appropriate length, to indicate the standard behaviour of using basic filtering services, i.e., forward all multicasts to all ports.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5025, '.1.3.6.1.2.1.17.7.1.2.4.1.3', 'dot1qForwardAllForbiddenPorts', 5022, 'current', NULL, 'The set of ports configured by management in this VLAN for which the Service Requirement attribute Forward All Multicast Groups may not be dynamically registered by GMRP. This value will be restored after the device is reset. A port may not be added in this set if it is already a member of the set of ports in dot1qForwardAllStaticPorts. The default value is a string of zeros of appropriate length.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5026, '.1.3.6.1.2.1.17.7.1.2.5', 'dot1qForwardUnregisteredTable', 4998, 'current', 'IEEE 802.1Q/D11 Section 12.7.2, 12.7.7', 'A table containing forwarding information for each VLAN, specifying the set of ports to which forwarding of multicast group-addressed frames for which no more specific forwarding information applies. This is configured statically by management and determined dynamically by GMRP. An entry appears in this table for all VLANs that are currently instantiated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5027, '.1.3.6.1.2.1.17.7.1.2.5.1', 'dot1qForwardUnregisteredEntry', 5026, 'current', NULL, 'Forwarding information for a VLAN, specifying the set of ports to which all multicasts for which there is no more specific forwarding information shall be forwarded. This is configured statically by management or dynamically by GMRP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5028, '.1.3.6.1.2.1.17.7.1.2.5.1.1', 'dot1qForwardUnregisteredPorts', 5027, 'current', NULL, 'The complete set of ports in this VLAN to which multicast group-addressed frames for which there is no more specific forwarding information will be forwarded. This includes ports for which this need has been determined dynamically by GMRP, or configured statically by management.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5029, '.1.3.6.1.2.1.17.7.1.2.5.1.2', 'dot1qForwardUnregisteredStaticPorts', 5027, 'current', NULL, 'The set of ports configured by management, in this VLAN, to which multicast group-addressed frames for which there is no more specific forwarding information  are to be forwarded. Ports entered in this list will also appear in the complete set shown by dot1qForwardUnregisteredPorts. This value will be restored after the device is reset. A port may not be added in this set if it is already a member of the set of ports in dot1qForwardUnregisteredForbiddenPorts. The default value is a string of zeros of appropriate length, although this has no effect with the default value of dot1qForwardAllStaticPorts.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5030, '.1.3.6.1.2.1.17.7.1.2.5.1.3', 'dot1qForwardUnregisteredForbiddenPorts', 5027, 'current', NULL, 'The set of ports configured by management in this VLAN for which the Service Requirement attribute Forward Unregistered Multicast Groups may not be dynamically registered by GMRP. This value will be restored after the device is reset. A port may not be added in this set if it is already a member of the set of ports in dot1qForwardUnregisteredStaticPorts. The default value is a string of zeros of appropriate length.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5032, '.1.3.6.1.2.1.17.7.1.3.1.1', 'dot1qStaticUnicastEntry', 5031, 'current', NULL, 'Filtering information configured into the device by (local or network) management specifying the set of ports to which frames received from a specific port and containing a specific unicast destination address are allowed to be forwarded.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5033, '.1.3.6.1.2.1.17.7.1.3.1.1.1', 'dot1qStaticUnicastAddress', 5032, 'current', NULL, 'The destination MAC address in a frame to which this entry''s filtering information applies. This object must take the value of a unicast address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5034, '.1.3.6.1.2.1.17.7.1.3.1.1.2', 'dot1qStaticUnicastReceivePort', 5032, 'current', NULL, 'Either the value ''0'' or the port number of the port from which a frame must be received in order for this entry''s filtering information to apply. A value of zero indicates that this entry applies on all ports of the device for which there is no other applicable entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5035, '.1.3.6.1.2.1.17.7.1.3.1.1.3', 'dot1qStaticUnicastAllowedToGoTo', 5032, 'current', 'IEEE 802.1Q/D11 Table 8-5, ISO/IEC 15802-3 Table 7-5', 'The set of ports for which a frame with a specific unicast address will be flooded in the event that it has not been learned. It also specifies the set of ports on which a specific unicast address may be dynamically learned. The dot1qTpFdbTable will have an equivalent entry with a dot1qTpFdbPort value of ''0'' until this address has been learned, at which point it will be updated with the port the address has been seen on. This only applies to ports that are members of the VLAN, defined by dot1qVlanCurrentEgressPorts. The default value of this object is a string of ones of appropriate length.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5036, '.1.3.6.1.2.1.17.7.1.3.1.1.4', 'dot1qStaticUnicastStatus', 5032, 'current', NULL, 'This object indicates the status of this entry. other(1) - this entry is currently in use, but  the conditions under which it will remain so differ from the following values. invalid(2) - writing this value to the object removes the corresponding entry. permanent(3) - this entry is currently in use and will remain so after the next reset of the bridge. deleteOnReset(4) - this entry is currently in use and will remain so until the next reset of the bridge. deleteOnTimeout(5) - this entry is currently in use and will remain so until it is aged out.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5037, '.1.3.6.1.2.1.17.7.1.3.2', 'dot1qStaticMulticastTable', 4999, 'current', 'IEEE 802.1Q/D11 Section 12.7.7, ISO/IEC 15802-3 Section 7.9.1', 'A table containing filtering information for Multicast and Broadcast MAC addresses for each VLAN, configured into the device by (local or network) management specifying the set of ports to which frames received from specific ports and containing specific Multicast and Broadcast destination addresses are allowed to be forwarded. A value of zero in this table (as the port number from which frames with a specific destination address are received) is used to specify all ports for which there is no specific entry in this table for that particular destination address. Entries are valid for Multicast and Broadcast addresses only.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5038, '.1.3.6.1.2.1.17.7.1.3.2.1', 'dot1qStaticMulticastEntry', 5037, 'current', NULL, 'Filtering information configured into the device by (local or network) management specifying the set of ports to which frames received from this specific port  for this VLAN and containing this Multicast or Broadcast destination address are allowed to be forwarded.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5039, '.1.3.6.1.2.1.17.7.1.3.2.1.1', 'dot1qStaticMulticastAddress', 5038, 'current', NULL, 'The destination MAC address in a frame to which this entry''s filtering information applies. This object must take the value of a Multicast or Broadcast address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5040, '.1.3.6.1.2.1.17.7.1.3.2.1.2', 'dot1qStaticMulticastReceivePort', 5038, 'current', NULL, 'Either the value ''0'' or the port number of the port from which a frame must be received in order for this entry''s filtering information to apply. A value of zero indicates that this entry applies on all ports of the device for which there is no other applicable entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5041, '.1.3.6.1.2.1.17.7.1.3.2.1.3', 'dot1qStaticMulticastStaticEgressPorts', 5038, 'current', NULL, 'The set of ports to which frames received from a specific port and destined for a specific Multicast or Broadcast MAC address must be forwarded, regardless of any dynamic information, e.g., from GMRP. A port may not be added in this set if it is already a member of the set of ports in dot1qStaticMulticastForbiddenEgressPorts. The default value of this object is a string of ones of appropriate length.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5042, '.1.3.6.1.2.1.17.7.1.3.2.1.4', 'dot1qStaticMulticastForbiddenEgressPorts', 5038, 'current', NULL, 'The set of ports to which frames received from a specific port and destined for a specific Multicast or Broadcast MAC address must not be forwarded, regardless of any dynamic information, e.g., from GMRP. A port may not be added in this set if it is already a member of the set of ports in dot1qStaticMulticastStaticEgressPorts. The default value of this object is a string of zeros of appropriate length.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5043, '.1.3.6.1.2.1.17.7.1.3.2.1.5', 'dot1qStaticMulticastStatus', 5038, 'current', NULL, 'This object indicates the status of this entry. other(1) - this entry is currently in use, but the conditions under which it will remain so differ from the following values.  invalid(2) - writing this value to the object removes the corresponding entry. permanent(3) - this entry is currently in use and will remain so after the next reset of the bridge. deleteOnReset(4) - this entry is currently in use and will remain so until the next reset of the bridge. deleteOnTimeout(5) - this entry is currently in use and will remain so until it is aged out.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5044, '.1.3.6.1.2.1.17.7.1.4.1', 'dot1qVlanNumDeletes', 5000, 'current', NULL, 'The number of times a VLAN entry has been deleted from the dot1qVlanCurrentTable (for any reason). If an entry is deleted, then inserted, and then deleted, this counter will be incremented by 2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5045, '.1.3.6.1.2.1.17.7.1.4.2', 'dot1qVlanCurrentTable', 5000, 'current', NULL, 'A table containing current configuration information for each VLAN currently configured into the device by (local or network) management, or dynamically created as a result of GVRP requests received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5046, '.1.3.6.1.2.1.17.7.1.4.2.1', 'dot1qVlanCurrentEntry', 5045, 'current', NULL, 'Information for a VLAN configured into the device by  (local or network) management, or dynamically created as a result of GVRP requests received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5047, '.1.3.6.1.2.1.17.7.1.4.2.1.1', 'dot1qVlanTimeMark', 5046, 'current', NULL, 'A TimeFilter for this entry. See the TimeFilter textual convention to see how this works.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5048, '.1.3.6.1.2.1.17.7.1.4.2.1.2', 'dot1qVlanIndex', 5046, 'current', NULL, 'The VLAN-ID or other identifier referring to this VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5049, '.1.3.6.1.2.1.17.7.1.4.2.1.3', 'dot1qVlanFdbId', 5046, 'current', NULL, 'The Filtering Database used by this VLAN. This is one of the dot1qFdbId values in the dot1qFdbTable. This value is allocated automatically by the device whenever  the VLAN is created: either dynamically by GVRP, or by management, in dot1qVlanStaticTable. Allocation of this value follows the learning constraints defined for this VLAN in dot1qLearningConstraintsTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5050, '.1.3.6.1.2.1.17.7.1.4.2.1.4', 'dot1qVlanCurrentEgressPorts', 5046, 'current', 'IEEE 802.1Q/D11 Section 12.10.2.1', 'The set of ports that are transmitting traffic for this VLAN as either tagged or untagged frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5051, '.1.3.6.1.2.1.17.7.1.4.2.1.5', 'dot1qVlanCurrentUntaggedPorts', 5046, 'current', 'IEEE 802.1Q/D11 Section 12.10.2.1', 'The set of ports that are transmitting traffic for this VLAN as untagged frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5052, '.1.3.6.1.2.1.17.7.1.4.2.1.6', 'dot1qVlanStatus', 5046, 'current', NULL, 'This object indicates the status of this entry. other(1) - this entry is currently in use, but the conditions under which it will remain so differ from the following values. permanent(2) - this entry, corresponding to an entry in dot1qVlanStaticTable, is currently in use and will remain so after the next reset of the device. The port lists for this entry include ports from the equivalent dot1qVlanStaticTable entry and ports learned dynamically. dynamicGvrp(3) - this entry is currently in use  and will remain so until removed by GVRP. There is no static entry for this VLAN, and it will be removed when the last port leaves the VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5053, '.1.3.6.1.2.1.17.7.1.4.2.1.7', 'dot1qVlanCreationTime', 5046, 'current', NULL, 'The value of sysUpTime when this VLAN was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5054, '.1.3.6.1.2.1.17.7.1.4.3', 'dot1qVlanStaticTable', 5000, 'current', NULL, 'A table containing static configuration information for each VLAN configured into the device by (local or network) management. All entries are permanent and will be restored after the device is reset.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5055, '.1.3.6.1.2.1.17.7.1.4.3.1', 'dot1qVlanStaticEntry', 5054, 'current', NULL, 'Static information for a VLAN configured into the device by (local or network) management.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5056, '.1.3.6.1.2.1.17.7.1.4.3.1.1', 'dot1qVlanStaticName', 5055, 'current', 'IEEE 802.1Q/D11 Section 12.10.2.1', 'An administratively assigned string, which may be used to identify the VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5057, '.1.3.6.1.2.1.17.7.1.4.3.1.2', 'dot1qVlanStaticEgressPorts', 5055, 'current', 'IEEE 802.1Q/D11 Section 12.7.7.3, 11.2.3.2.3', 'The set of ports that are permanently assigned to the egress list for this VLAN by management. Changes to a bit in this object affect the per-port, per-VLAN Registrar control for Registration Fixed for the relevant GVRP state machine on each port. A port may not be added in this set if it is already a member of the set of ports in dot1qVlanForbiddenEgressPorts. The default value of this object is a string of zeros of appropriate length, indicating not fixed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5058, '.1.3.6.1.2.1.17.7.1.4.3.1.3', 'dot1qVlanForbiddenEgressPorts', 5055, 'current', 'IEEE 802.1Q/D11 Section 12.7.7.3, 11.2.3.2.3', 'The set of ports that are prohibited by management from being included in the egress list for this VLAN. Changes to this object that cause a port to be included or excluded affect the per-port, per-VLAN Registrar control for Registration Forbidden for the relevant GVRP state machine on each port. A port may not be added in this set if it is already a member of the set of ports in dot1qVlanStaticEgressPorts. The default value of this object is a string of zeros of appropriate length, excluding all ports from the forbidden set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5059, '.1.3.6.1.2.1.17.7.1.4.3.1.4', 'dot1qVlanStaticUntaggedPorts', 5055, 'current', 'IEEE 802.1Q/D11 Section 12.10.2.1', 'The set of ports that should transmit egress packets for this VLAN as untagged. The default value of this object for the default VLAN (dot1qVlanIndex = 1) is a string of appropriate length including all ports. There is no specified default for other VLANs. If a device agent cannot support the set of ports being set, then it will reject the set operation with an error. For example, a manager might attempt to set more than one VLAN to be untagged on egress where the device does not support this IEEE 802.1Q option.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5060, '.1.3.6.1.2.1.17.7.1.4.3.1.5', 'dot1qVlanStaticRowStatus', 5055, 'current', NULL, 'This object indicates the status of this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5061, '.1.3.6.1.2.1.17.7.1.4.4', 'dot1qNextFreeLocalVlanIndex', 5000, 'current', NULL, 'The next available value for dot1qVlanIndex of a local VLAN entry in dot1qVlanStaticTable. This will report values >=4096 if a new Local VLAN may be created or else the value 0 if this is not possible.  A row creation operation in this table for an entry with a local VlanIndex value may fail if the current value of this object is not used as the index. Even if the value read is used, there is no guarantee that it will still be the valid index when the create operation is attempted; another manager may have already got in during the intervening time interval. In this case, dot1qNextFreeLocalVlanIndex should be re-read  and the creation re-tried with the new value.  This value will automatically change when the current value is used to create a new row.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5062, '.1.3.6.1.2.1.17.7.1.4.5', 'dot1qPortVlanTable', 5000, 'current', NULL, 'A table containing per-port control and status information for VLAN configuration in the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5063, '.1.3.6.1.2.1.17.7.1.4.5.1', 'dot1qPortVlanEntry', 5062, 'current', NULL, 'Information controlling VLAN configuration for a port on the device. This is indexed by dot1dBasePort.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5064, '.1.3.6.1.2.1.17.7.1.4.5.1.1', 'dot1qPvid', 5063, 'current', 'IEEE 802.1Q/D11 Section 12.10.1.1', 'The PVID, the VLAN-ID assigned to untagged frames or Priority-Tagged frames received on this port.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5065, '.1.3.6.1.2.1.17.7.1.4.5.1.2', 'dot1qPortAcceptableFrameTypes', 5063, 'current', 'IEEE 802.1Q/D11 Section 12.10.1.3', 'When this is admitOnlyVlanTagged(2), the device will discard untagged frames or Priority-Tagged frames received on this port. When admitAll(1), untagged frames or Priority-Tagged frames received on this port will be accepted and assigned to a VID based on the PVID and VID Set for this port.  This control does not affect VLAN-independent Bridge Protocol Data Unit (BPDU) frames, such as GVRP and Spanning Tree Protocol (STP). It does affect VLAN- dependent BPDU frames, such as GMRP.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5066, '.1.3.6.1.2.1.17.7.1.4.5.1.3', 'dot1qPortIngressFiltering', 5063, 'current', 'IEEE 802.1Q/D11 Section 12.10.1.4', 'When this is true(1), the device will discard incoming frames for VLANs that do not include this Port in its  Member set. When false(2), the port will accept all incoming frames.  This control does not affect VLAN-independent BPDU frames, such as GVRP and STP. It does affect VLAN- dependent BPDU frames, such as GMRP.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5067, '.1.3.6.1.2.1.17.7.1.4.5.1.4', 'dot1qPortGvrpStatus', 5063, 'current', NULL, 'The state of GVRP operation on this port. The value enabled(1) indicates that GVRP is enabled on this port, as long as dot1qGvrpStatus is also enabled for this device. When disabled(2) but dot1qGvrpStatus is still enabled for the device, GVRP is disabled on this port: any GVRP packets received will be silently discarded, and no GVRP registrations will be propagated from other ports. This object affects all GVRP Applicant and Registrar state machines on this port. A transition from disabled(2) to enabled(1) will cause a reset of all GVRP state machines on this port.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5068, '.1.3.6.1.2.1.17.7.1.4.5.1.5', 'dot1qPortGvrpFailedRegistrations', 5063, 'current', NULL, 'The total number of failed GVRP registrations, for any reason, on this port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5069, '.1.3.6.1.2.1.17.7.1.4.5.1.6', 'dot1qPortGvrpLastPduOrigin', 5063, 'current', NULL, 'The Source MAC Address of the last GVRP message received on this port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5124, '.1.3.6.1.4.1.9.9.692', 'ciscoFlowMonitorMIB', 272, 'current', NULL, 'This MIB module defines objects that describe flow monitoring. A typical application of this MIB module will facilitate monitoring media flows, especially flows carrying video streams. However, by no means does the definition of this MIB module prevents other applications from using it.  FLOW MONITORS =================  At the top level, this MIB module describes the notion of a flow monitor. A flow monitor is a hardware or software entity that classifies traffic flows, collects data on conforming traffic flows, and periodically computes metrics that reflect the quality of the traffic flows. Because a device can support more than one flow monitor, the MIB module defines the cfmFlowMonitorTable. Consider an edge router that supports a certain line card that has an integrated capability to monitor video flows. In this example, the cfmFlowMonitorTable would contain a row describing each line card installed in the device.  TRAFFIC FLOWS =================  At the next level, this MIB module describes the notion of a traffic flow. This MIB module uniquely identifies a traffic flow using an auxiliary variable called cfmFlowId; however, an implementation only has guarantee its uniqueness within the scope of the flow monitor that has the responsibility for monitoring the traffic flow. Thus, we can think of the flow monitor as a container for the traffic flows for which it collects data and periodically computes metrics, as the figure below illustrates.  +------------------------+ | cfmFlowTable | | | +------------------+ +--------------------------------+ | cfmFlowMonitorId = 3 ->| +------------------------+ | +------------------+ | | cfmFlowMonitorId = 3 | | | | cfmFlowId = 101 | | | +--------------------+ | | +--------------------+ | | | cfmFlowMonitorId = 3 | | | | cfmFlowId = 102 | | | +--------------------+ | | : | | : | | +--------------------+ | | | cfmFlowMonitorId = 3 | | | | cfmFlowId = 150 | | | +--------------------+ | +----------------------------+ | | +------------------+ +--------------------------------+ | cfmFlowMonitorId = 4 ->| +------------------------+ | +------------------+ | | cfmFlowMonitorId = 4 | | | | cfmFlowId = 1 | | | +--------------------+ | | +--------------------+ | | | cfmFlowMonitorId = 4 | | | | cfmFlowId = 2 | | | +--------------------+ | | : | | : | | +--------------------+ | | | cfmFlowMonitorId = 4 | | | | cfmFlowId = 150 | | | +--------------------+ | +----------------------------+ | | +------------------------+  While the identifying of a traffic flow using this auxiliary variable is convenient for the MIB module, it is does suffice for an EMS/NMS trying to isolate faults in a network delivering these traffic flows. To aid an EMS/NMS in this task, this MIB module defines a number of tables that provide layers of data relating to a traffic flow, including:  o cfmFlowL2VlanTable - describes L2 VLAN data relating to traffic flows.  o cfmFlowIpTable - describes IP data relating to traffic flows.  o cfmFlowUdpTable - describes UDP data relating to traffic flows.  o cfmFlowTcpTable - describes TCP data relating to traffic flows.  o cfmFlowRtpTable - describes RTP data relating to traffic flows.  Each of these tables have a sparse dependent relationship on the cfmFlowTable, as there exist situations when the data may not be available for a traffic flow, including:  1) The flow monitor simply may not collect the particular data for the traffic flows that it has the responsibility of monitoring. For example, a flow monitor may not have any concern for L2 VLAN data.  2) The data may not apply to a traffic flow. For example, a TCP and RTP data do not apply for a UDP traffic flow.  To help an EMS/NMS navigate the data collected for a traffic flow, the corresponding rows are daisy-chained using ''next objects''. An EMS/NMS starts with cfmFlowNext, which indicates a reference to the row in the next table containing data related to the traffic flow. The first object contained by each of these tables is a ''next object''. Consider a RTP traffic flow for which the flow monitor has collected IP, UDP, and RTP data. The figure below illustrates how this MIB module daisy chains this data through the relevant tables.  +---------------------------------------+ | cfmFlowTable | | +-----------------------------------+ | | | cfmFlowMonitorId = 3 | | | | cfmFlowId = 42 | | | | cfmFlowNext = cfmFlowIpNext.3.42 ------+ | +-----------------------------------+ | | +---------------------------------------+ | | +---------------------------------------+ | | cfmFlowIpTable | | | +-----------------------------------+ | | | | cfmFlowMonitorId = 3 |< | | cfmFlowId = 42 | | | | cfmFlowIpNext = cfmFlowUdpNext.3.42 ---+ | +-----------------------------------+ | | +---------------------------------------+ | | +---------------------------------------+ | | cfmFlowUdpTable | | | +-----------------------------------+ | | | | cfmFlowMonitorId = 3 |< | | cfmFlowId = 42 | | | | cfmFlowUdpNext = cfmFlowRtpNext.3.42 --+ | +-----------------------------------+ | | +---------------------------------------+ | | +---------------------------------------+ | | cfmFlowRtpTable | | | +-----------------------------------+ | | | | cfmFlowMonitorId = 3 |< | | cfmFlowId = 42 | | | | cfmFlowRtpNext = zeroDotZero | | | +-----------------------------------+ | +---------------------------------------+  Observe that this structure simplifies the task of extending the MIB module to support additional layers of data. For example, if there is a need for a device to collect data relating to the MPEG-TS layer of a flow carrying a video stream, then it is as simple as defining a table containing this data. However, the definition of such a table must comply with the following requirements:  1) The table must have a sparse dependent relationship on the cfmFlowTable.  2) The first object contained by the table must be a ''next object'' to support daisy chaining.  REPORTING FLOW METRICS ==========================  At the next level, the MIB defines two tables that together form the foundation for reporting metrics. The cfmFlowMetricsTable has a one-to-one dependent relationship on the cfmFlowTable, and it contains data aggregate metrics and data relating to the collection of metrics for the corresponding traffic flow. A row in this table also serves as a container for the historic metrics computed by the corresponding flow monitor, as the figure below illustrates.  +------------------------+ | cfmFlowMetricsIntTable | | | +------------------+ +----------------------------------+ | cfmFlowMetricsEntry |----------------------------+ | | | | | cfmFlowMonitorId = 3 | | | cfmFlowMonitorId = 3 | | | cfmFlowId = 101 | | | cfmFlowid = 101 | | | cfmFlowMetricsIntNumber = 1 | | +------------------+ | +------------------------------+ | | +--------------------------+ | | | cfmFlowMonitorId = 3 | | | | cfmFlowId = 101 | | | | cfmFlowMetricsIntNumber = 2 | | | +--------------------------+ | | : | | : | | +--------------------------+ | | | cfmFlowMonitorId = 3 | | | | cfmFlowId = 101 | | | | cfmFlowMetricsIntNumber = N | | | +--------------------------+ | +------------------------------+ | | +------------------------+  The device collects data for a traffic flow over a configured measurement interval, indicated by cfmFlowMetricsIntervalTime. At the end of a measurement interval, the device computes metrics from this data, generating a report. An EMS/NMS can access this report using the cfmFlowMetricsIntTable. cfmFlowMetricsMaxInterval indicates the maximum number of reports a device will save for the corresponding traffic flow, while cfmFlowMetricsIntervals indicates the number of reports currently saved by the device.  The cfmFlowMetricsTable and cfmFlowMetricsIntTable have the intent of providing a foundation for reporting metrics for a traffic flow. Furthermore, it is the intent that additional MIB modules define extensions to these tables describing specific sets of metrics. The following list provides some examples:  o CISCO-FLOW-MON-MDI-MIB - this MIB module defines extensions that describe MDI metrics defined by RFC-4445.  o CISCO-FLOW-MON-RTP-MIB - this MIB module defines extensions that describe RTP metrics defined by RFC-3550.  o CISCO-FLOW-MON-IP-CBR-MIB - this MIB module defines extension that describe IP CBR metrics.  The tables defined by these MIB modules have a sparse dependent relationhip on the cfmFlowMetricsTable and cfmFlowMetricsIntTable. An EMS/NMS can determine the metrics collected for a traffic flow from the corresponding instance of cfmFlowMetricsCollected, which is nothing more than a bit string-value for which each bit corresponds to a different set of metrics.  FAULT MANAGEMENT ====================  At the next level, this MIB module defines tables that describe standing conditions. A standing condition is a lasting error, fault, or warning resulting from the application of a set of criteria to the state of an entity.  For example, a flow monitor ceases monitoring a traffic flow when it has not received any packets for that traffic flow in a configured interval of time. If flow monitor expires a significantly large number of traffic flows during a measurement interval, then this might signal a fault.  In this example, the ''set of criteria'' is a rising threshold and the ''state of an entity'' is the number of traffic flows expired by a flow monitor.  The cfmConditionTable describes the criteria applied to entities managed by the device, specifically flow monitors and traffic flows. The table groups these criteria into ''conditions profiles''. The device periodically applies these criteria to an entity and saves the results in a bit string-value associated with the entity.  An EMS/NMS can monitor the most recent standing conditions for a flow monitor by retrieving the corresponding instance of cfmFlowMonitorConditions. Likewise, an EMS/NMS can monitor the most recent standing conditions for a traffic flow by retrieving the corresponding instance of cfmFlowMetricsConditions.  It goes without saying that monitoring the standing conditions for significantly large numbers of traffic flows becomes problematic. To aid an EMS/NMS in this task, this MIB module defines many mechanisms. The most basic of these mechanisms is the notion of an alarm, which is simply a standing condition for which the device signals changes in state. This MIB module provides for three means of signaling when the device raises or clears an alarm condition:  1) Logging - the device creates a record of the event and saves it in a historical account.  2) syslog - the device generates a syslog message containing details of the event and sends it to one or more configured syslog server.  3) SNMP - the device generates a SNMP notification containing details of the event and sends it to one or more configured targets.  An EMS/NMS can monitor the most recent alarm conditions for a flow monitor by retrieving the corresponding instance of cfmFlowMonitorAlarms. Likewise, the EMS/NMS can monitor the most recent alarm conditions for a traffic flow by retrieving the corresponding instance of cfmFlowMetricsAlarms.  Additionally, the EMS/NMS can poll a summary of alarm conditions maintained for each flow monitor and the traffic flows that it monitors. The following list summarizes the data contained by this summary:  o cfmFlowMonitorAlarmSeverity o cfmFlowMonitorAlarmCriticalCount o cfmFlowMonitorAlarmMajorCount o cfmFlowMonitorAlarmMinorCount o cfmFlowMonitorAlarmWarningCount o cfmFlowMonitorAlarmInfoCount  An EMS/NMS can also poll cfmAlarmHistoryLastId, which indicates the value of the identifier assigned to the last record saved to the historical account. When it observes a change in the value of this object, then it can retrieve the new records from the cfmAlarmHistoryTable.  The burden of monitoring alarm conditions for sufficiently large numbers of traffic flows can itself become a daunting task. Thus, this MIB module defines the notion of an alarm group, which represents a single alarm condition that aggregates a standing condition for a set of traffic flows. The cfmAlarmGroupTable describes the alarm groups configured for a device, and the cfmAlarmGroupFlowTable describes the sets of flows aggregated by these alarm groups.  GLOSSARY ============  Alarm Action - a method used by the device to signal changes in an alarm condition.  Alarm Aggregation - a technique used to efficiently monitor the same standing condition for a flow set.  Alarm Condition - a standing condition for which the device signals changes in state.  Alarm Group - a flow set for which the device monitors a configured standing condition, raising an alarm when a configured number of flows in the flow set assert the standing standing.  Alarm Severity - the relative disposition of an alarm condition when raised by the device. For example, a provider may regard a flow stop alarm as having a higher severity than a flow''s loss fraction exceeding a configured threshold.  Flow Monitor - a hardware or software entity that classifies traffic flows, collects flow data, and periodically computes flow metrics.  Flow Metric - a measurement that reflects the quality of a traffic flow.  Flow Point - represents the ingress or egress of a traffic flow.  Flow Set - a group of traffic flows.  Measurement Interval - the length of time over which a flow monitor collects data related to a traffic flow, after which the flow monitor computes flow metrics using the collected data.  Standing Condition - represents a lasting error, fault, or warning resulting from the application of a set of criteria to the state of an entity, such as a flow monitor or traffic flow. For example, a flow monitor may assert a standing condition if the number of traffic flows that expire in a measurement interval exceeds a configured threshold.  Traffic Flow - a unidirectional stream of packets conforming to a classifier. For example, packets having a particular source IP address, destination IP address, protocol type, source port number, and destination port number.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5125, '.1.3.6.1.4.1.9.9.692.0', 'ciscoFlowMonitorMIBNotifs', 5124, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5126, '.1.3.6.1.4.1.9.9.692.1', 'ciscoFlowMonitorMIBObjects', 5124, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5127, '.1.3.6.1.4.1.9.9.692.2', 'ciscoFlowMonitorMIBConform', 5124, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5070, '.1.3.6.1.2.1.17.7.1.4.5.1.7', 'dot1qPortRestrictedVlanRegistration', 5063, 'current', 'IEEE 802.1u clause 11.2.3.2.3, 12.10.1.7.', 'The state of Restricted VLAN Registration on this port. If the value of this control is true(1), then creation of a new dynamic VLAN entry is permitted only if there is a Static VLAN Registration Entry for the VLAN concerned, in which the Registrar Administrative Control value for this port is Normal Registration.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5071, '.1.3.6.1.2.1.17.7.1.4.6', 'dot1qPortVlanStatisticsTable', 5000, 'current', NULL, 'A table containing per-port, per-VLAN statistics for traffic received. Separate objects are provided for both the most-significant and least-significant bits of statistics counters for ports that are associated with this transparent bridge. The most-significant bit objects are only required on high-capacity interfaces, as defined in the conformance clauses for these objects. This mechanism is provided as a way to read 64-bit counters for agents that support only SNMPv1.  Note that the reporting of most-significant and least- significant counter bits separately runs the risk of missing an overflow of the lower bits in the interval between sampling. The manager must be aware of this possibility, even within the same varbindlist, when interpreting the results of a request or  asynchronous notification.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5072, '.1.3.6.1.2.1.17.7.1.4.6.1', 'dot1qPortVlanStatisticsEntry', 5071, 'current', NULL, 'Traffic statistics for a VLAN on an interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5073, '.1.3.6.1.2.1.17.7.1.4.6.1.1', 'dot1qTpVlanPortInFrames', 5072, 'current', 'IEEE 802.1Q/D11 Section 12.6.1.1.3(a)', 'The number of valid frames received by this port from its segment that were classified as belonging to this VLAN. Note that a frame received on this port is counted by this object if and only if it is for a protocol being processed by the local forwarding process for this VLAN. This object includes received bridge management frames classified as belonging to this VLAN (e.g., GMRP, but not GVRP or STP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5074, '.1.3.6.1.2.1.17.7.1.4.6.1.2', 'dot1qTpVlanPortOutFrames', 5072, 'current', 'IEEE 802.1Q/D11 Section 12.6.1.1.3(d)', 'The number of valid frames transmitted by this port to its segment from the local forwarding process for this VLAN. This includes bridge management frames originated by this device that are classified as belonging to this VLAN (e.g., GMRP, but not GVRP or STP).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5075, '.1.3.6.1.2.1.17.7.1.4.6.1.3', 'dot1qTpVlanPortInDiscards', 5072, 'current', 'IEEE 802.1Q/D11 Section 12.6.1.1.3', 'The number of valid frames received by this port from its segment that were classified as belonging to this VLAN and that were discarded due to VLAN-related reasons. Specifically, the IEEE 802.1Q counters for Discard Inbound and Discard on Ingress Filtering.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5076, '.1.3.6.1.2.1.17.7.1.4.6.1.4', 'dot1qTpVlanPortInOverflowFrames', 5072, 'current', 'ISO/IEC 15802-3 Section 14.6.1.1.3', 'The number of times the associated dot1qTpVlanPortInFrames counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5077, '.1.3.6.1.2.1.17.7.1.4.6.1.5', 'dot1qTpVlanPortOutOverflowFrames', 5072, 'current', 'ISO/IEC 15802-3 Section 14.6.1.1.3', 'The number of times the associated dot1qTpVlanPortOutFrames counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5078, '.1.3.6.1.2.1.17.7.1.4.6.1.6', 'dot1qTpVlanPortInOverflowDiscards', 5072, 'current', 'ISO/IEC 15802-3 Section 14.6.1.1.3', 'The number of times the associated dot1qTpVlanPortInDiscards counter has overflowed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5079, '.1.3.6.1.2.1.17.7.1.4.7', 'dot1qPortVlanHCStatisticsTable', 5000, 'current', NULL, 'A table containing per-port, per-VLAN statistics for traffic on high-capacity interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5080, '.1.3.6.1.2.1.17.7.1.4.7.1', 'dot1qPortVlanHCStatisticsEntry', 5079, 'current', NULL, 'Traffic statistics for a VLAN on a high-capacity interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5081, '.1.3.6.1.2.1.17.7.1.4.7.1.1', 'dot1qTpVlanPortHCInFrames', 5080, 'current', 'IEEE 802.1Q/D11 Section 12.6.1.1.3(a)', 'The number of valid frames received by this port from its segment that were classified as belonging to this VLAN. Note that a frame received on this port is counted by this object if and only if it is for a  protocol being processed by the local forwarding process for this VLAN. This object includes received bridge management frames classified as belonging to this VLAN (e.g., GMRP, but not GVRP or STP).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5082, '.1.3.6.1.2.1.17.7.1.4.7.1.2', 'dot1qTpVlanPortHCOutFrames', 5080, 'current', 'IEEE 802.1Q/D11 Section 12.6.1.1.3(d)', 'The number of valid frames transmitted by this port to its segment from the local forwarding process for this VLAN. This includes bridge management frames originated by this device that are classified as belonging to this VLAN (e.g., GMRP, but not GVRP or STP).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5083, '.1.3.6.1.2.1.17.7.1.4.7.1.3', 'dot1qTpVlanPortHCInDiscards', 5080, 'current', 'IEEE 802.1Q/D11 Section 12.6.1.1.3', 'The number of valid frames received by this port from its segment that were classified as belonging to this VLAN and that were discarded due to VLAN-related reasons. Specifically, the IEEE 802.1Q counters for Discard Inbound and Discard on Ingress Filtering.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5084, '.1.3.6.1.2.1.17.7.1.4.8', 'dot1qLearningConstraintsTable', 5000, 'current', 'IEEE 802.1Q/D11 Section 12.10.3.1', 'A table containing learning constraints for sets of Shared and Independent VLANs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5085, '.1.3.6.1.2.1.17.7.1.4.8.1', 'dot1qLearningConstraintsEntry', 5084, 'current', NULL, 'A learning constraint defined for a VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5086, '.1.3.6.1.2.1.17.7.1.4.8.1.1', 'dot1qConstraintVlan', 5085, 'current', NULL, 'The index of the row in dot1qVlanCurrentTable for the VLAN constrained by this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5087, '.1.3.6.1.2.1.17.7.1.4.8.1.2', 'dot1qConstraintSet', 5085, 'current', NULL, 'The identity of the constraint set to which dot1qConstraintVlan belongs. These values may be chosen by the management station.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5088, '.1.3.6.1.2.1.17.7.1.4.8.1.3', 'dot1qConstraintType', 5085, 'current', NULL, 'The type of constraint this entry defines. independent(1) - the VLAN, dot1qConstraintVlan, uses a filtering database independent from all other VLANs in the same set, defined by dot1qConstraintSet. shared(2) - the VLAN, dot1qConstraintVlan, shares the same filtering database as all other VLANs in the same set, defined by dot1qConstraintSet.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5089, '.1.3.6.1.2.1.17.7.1.4.8.1.4', 'dot1qConstraintStatus', 5085, 'current', NULL, 'The status of this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5090, '.1.3.6.1.2.1.17.7.1.4.9', 'dot1qConstraintSetDefault', 5000, 'current', NULL, 'The identity of the constraint set to which a VLAN belongs, if there is not an explicit entry for that VLAN in dot1qLearningConstraintsTable.  The value of this object MUST be retained across reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5091, '.1.3.6.1.2.1.17.7.1.4.10', 'dot1qConstraintTypeDefault', 5000, 'current', NULL, 'The type of constraint set to which a VLAN belongs, if there is not an explicit entry for that VLAN in dot1qLearningConstraintsTable. The types are as defined for dot1qConstraintType.  The value of this object MUST be retained across  reinitializations of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5092, '.1.3.6.1.2.1.17.7.1.5.1', 'dot1vProtocolGroupTable', 5001, 'current', 'IEEE 802.1v clause 8.6.4', 'A table that contains mappings from Protocol Templates to Protocol Group Identifiers used for Port-and-Protocol-based VLAN Classification.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5093, '.1.3.6.1.2.1.17.7.1.5.1.1', 'dot1vProtocolGroupEntry', 5092, 'current', NULL, 'A mapping from a Protocol Template to a Protocol Group Identifier.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5094, '.1.3.6.1.2.1.17.7.1.5.1.1.1', 'dot1vProtocolTemplateFrameType', 5093, 'current', 'IEEE 802.1v clause 8.6.2', 'The data-link encapsulation format or the ''detagged_frame_type'' in a Protocol Template.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5095, '.1.3.6.1.2.1.17.7.1.5.1.1.2', 'dot1vProtocolTemplateProtocolValue', 5093, 'current', 'IEEE 802.1v clause 8.6.2', 'The identification of the protocol above the data-link layer in a Protocol Template. Depending on the frame type, the octet string will have one of the following values:  For ''ethernet'', ''rfc1042'' and ''snap8021H'', this is the 16-bit (2-octet) IEEE 802.3 Type Field. For ''snapOther'', this is the 40-bit (5-octet) PID. For ''llcOther'', this is the 2-octet IEEE 802.2 Link Service Access Point (LSAP) pair: first octet for Destination Service Access Point (DSAP) and second octet for Source Service Access Point (SSAP).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5096, '.1.3.6.1.2.1.17.7.1.5.1.1.3', 'dot1vProtocolGroupId', 5093, 'current', 'IEEE 802.1v clause 8.6.3, 12.10.2.1', 'Represents a group of protocols that are associated together when assigning a VID to a frame.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5097, '.1.3.6.1.2.1.17.7.1.5.1.1.4', 'dot1vProtocolGroupRowStatus', 5093, 'current', NULL, 'This object indicates the status of this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5098, '.1.3.6.1.2.1.17.7.1.5.2', 'dot1vProtocolPortTable', 5001, 'current', 'IEEE 802.1v clause 8.4.4', 'A table that contains VID sets used for Port-and-Protocol-based VLAN Classification.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5099, '.1.3.6.1.2.1.17.7.1.5.2.1', 'dot1vProtocolPortEntry', 5098, 'current', NULL, 'A VID set for a port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5100, '.1.3.6.1.2.1.17.7.1.5.2.1.1', 'dot1vProtocolPortGroupId', 5099, 'current', 'IEEE 802.1v clause 8.6.3, 12.10.1.2', 'Designates a group of protocols in the Protocol Group Database.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5101, '.1.3.6.1.2.1.17.7.1.5.2.1.2', 'dot1vProtocolPortGroupVid', 5099, 'current', 'IEEE 802.1v clause 8.4.4, 12.10.1.2', 'The VID associated with a group of protocols for each port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5102, '.1.3.6.1.2.1.17.7.1.5.2.1.3', 'dot1vProtocolPortRowStatus', 5099, 'current', NULL, 'This object indicates the status of this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5103, '.1.3.6.1.2.1.17.7.2', 'qBridgeConformance', 4995, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5104, '.1.3.6.1.2.1.17.7.2.1', 'qBridgeGroups', 5103, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5105, '.1.3.6.1.2.1.17.7.2.2', 'qBridgeCompliances', 5103, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5106, '.1.3.6.1.2.1.17.7.2.1.1', 'qBridgeBaseGroup', 5104, 'current', NULL, 'A collection of objects providing device-level control and status information for the Virtual LAN bridge services.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5107, '.1.3.6.1.2.1.17.7.2.1.2', 'qBridgeFdbUnicastGroup', 5104, 'current', NULL, 'A collection of objects providing information about all unicast addresses, learned dynamically or statically configured by management, in each Filtering Database.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5108, '.1.3.6.1.2.1.17.7.2.1.3', 'qBridgeFdbMulticastGroup', 5104, 'current', NULL, 'A collection of objects providing information about all multicast addresses, learned dynamically or statically configured by management, in each Filtering Database.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5109, '.1.3.6.1.2.1.17.7.2.1.4', 'qBridgeServiceRequirementsGroup', 5104, 'current', NULL, 'A collection of objects providing information about service requirements, learned dynamically or statically configured by management, in each Filtering Database.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5110, '.1.3.6.1.2.1.17.7.2.1.5', 'qBridgeFdbStaticGroup', 5104, 'current', NULL, 'A collection of objects providing information about unicast and multicast addresses statically configured by management, in each Filtering Database or VLAN.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5111, '.1.3.6.1.2.1.17.7.2.1.6', 'qBridgeVlanGroup', 5104, 'current', NULL, 'A collection of objects providing information about all VLANs currently configured on this device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5112, '.1.3.6.1.2.1.17.7.2.1.7', 'qBridgeVlanStaticGroup', 5104, 'current', NULL, 'A collection of objects providing information about VLANs statically configured by management.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5113, '.1.3.6.1.2.1.17.7.2.1.8', 'qBridgePortGroup', 5104, 'deprecated', NULL, 'A collection of objects providing port-level VLAN control and status information for all ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5114, '.1.3.6.1.2.1.17.7.2.1.9', 'qBridgeVlanStatisticsGroup', 5104, 'current', NULL, 'A collection of objects providing per-port packet statistics for all VLANs currently configured on this device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5115, '.1.3.6.1.2.1.17.7.2.1.10', 'qBridgeVlanStatisticsOverflowGroup', 5104, 'current', NULL, 'A collection of objects providing overflow counters for per-port packet statistics for all VLANs currently configured on this device for high-capacity interfaces, defined as those that have the value of the corresponding instance of ifSpeed greater than 650,000,000 bits/second.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5116, '.1.3.6.1.2.1.17.7.2.1.11', 'qBridgeVlanHCStatisticsGroup', 5104, 'current', NULL, 'A collection of objects providing per-port packet statistics for all VLANs currently configured on this device for high-capacity interfaces, defined as those that have the value of the corresponding instance of ifSpeed greater than 650,000,000 bits/second.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5117, '.1.3.6.1.2.1.17.7.2.1.12', 'qBridgeLearningConstraintsGroup', 5104, 'current', NULL, 'A collection of objects defining the Filtering Database constraints all VLANs have with each other.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5118, '.1.3.6.1.2.1.17.7.2.1.13', 'qBridgeLearningConstraintDefaultGroup', 5104, 'current', NULL, 'A collection of objects defining the default Filtering Database constraints for VLANs that have no specific constraints defined.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5119, '.1.3.6.1.2.1.17.7.2.1.14', 'qBridgeClassificationDeviceGroup', 5104, 'current', NULL, 'VLAN classification information for the bridge.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5120, '.1.3.6.1.2.1.17.7.2.1.15', 'qBridgeClassificationPortGroup', 5104, 'current', NULL, 'VLAN classification information for individual ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5121, '.1.3.6.1.2.1.17.7.2.1.16', 'qBridgePortGroup2', 5104, 'current', NULL, 'A collection of objects providing port-level VLAN control and status information for all ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5122, '.1.3.6.1.2.1.17.7.2.2.1', 'qBridgeCompliance', 5105, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5123, '.1.3.6.1.2.1.17.7.2.2.2', 'qBridgeCompliance2', 5105, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5398, '.1.3.6.1.4.1.9.9.703.3.1.8', 'cfmeRtpLostPkts', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the number of lost RTP data packets for a traffic flow during the last measurement interval (cfmRtpMetricsIntLostPkts).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5399, '.1.3.6.1.4.1.9.9.703.3.1.9', 'cfmeRtpLossFraction', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the RTP loss fraction for a traffic flow during the last measurement interval (cfmRtpMetricsIntFrac).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5400, '.1.3.6.1.4.1.9.9.703.3.1.10', 'cfmeRtpLossIntervals', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the number of RTP loss intervals for a traffic flow during the last measurement interval (cfmRtpMetricsIntLIs).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5401, '.1.3.6.1.4.1.9.9.703.3.1.11', 'cfmeRtpAvgLossDuration', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the average duration of a RTP loss interval for a traffic flow during the last measurement interval (cfmRtpMetricsIntAvgLD).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5402, '.1.3.6.1.4.1.9.9.703.3.1.12', 'cfmeRtpAvgLossDistance', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the average RTP loss distance for a traffic flow during the last measurement interval (cfmRtpMetricsIntAvgLossDistance).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5403, '.1.3.6.1.4.1.9.9.703.3.1.13', 'cfmeRtpMaxJitter', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the maximum inter-arrival jitter of RTP data packets for a traffic flow during the last measurement interval (cfmRtpMetricsIntJitter).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5404, '.1.3.6.1.4.1.9.9.703.3.1.14', 'cfmeRtpMaxMinTransit', 5390, 'current', NULL, 'This object identifier represents the monitored element describing the max-min transit time of the RTP data packets for a traffic flow during the last measurement interval (cfmRtpMetricsIntTransit).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5131, '.1.3.6.1.4.1.9.9.692.1.1.1.1', 'cfmFlowMonitorEntry', 5130, 'current', NULL, 'An entry describes a flow monitor, which represents a hardware or software entity that classifies traffic flows, monitors flow data, and periodically computes flow metrics.  A simple device may only support a single flow monitor, where a more sophisticated device may support more than one flow monitor.  A device supporting multiple flow monitors creates a row in the cfmFlowMonitorTable when it recognizes the addition of a new flow monitor, such as might occur upon the insertion of a line card that supports flow monitoring. Likewise, such a device destroys a row in the cfmFlowMonitorTable when a flow monitor has been removed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5132, '.1.3.6.1.4.1.9.9.692.1.1.1.1.1', 'cfmFlowMonitorId', 5131, 'current', NULL, 'This object indicates an arbitrary integer-value that uniquely identifies the flow monitor. Observe that the value assigned to a flow monitor does not necessarily persist across restarts or the removal-insertion of a physical entity supporting flow monitor(s).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5133, '.1.3.6.1.4.1.9.9.692.1.1.1.1.2', 'cfmFlowMonitorDescr', 5131, 'current', NULL, 'This object indicates a human-readable description for the flow monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5134, '.1.3.6.1.4.1.9.9.692.1.1.1.1.3', 'cfmFlowMonitorCaps', 5131, 'current', NULL, 'This object indicates the capabilities of the flow monitor. Specifically, the value of this column indicates a ''1'' for each set of flow metrics the flow monitor is capable of measuring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5135, '.1.3.6.1.4.1.9.9.692.1.1.1.1.4', 'cfmFlowMonitorFlowCount', 5131, 'current', NULL, 'This object indicates the number of traffic flows currently monitored by the flow monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5136, '.1.3.6.1.4.1.9.9.692.1.1.1.1.5', 'cfmFlowMonitorConditionsProfile', 5131, 'current', NULL, 'This object indicates the conditions profile that contains the descriptions of the standing conditions monitored for the flow monitor.  If the flow monitor does not have an associated conditions profile, then the value of this column must be zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5137, '.1.3.6.1.4.1.9.9.692.1.1.1.1.6', 'cfmFlowMonitorConditions', 5131, 'current', NULL, 'This object indicates the current standing conditions for the flow monitor.  If the flow monitor does not have an associated conditions profile, then the value of this column must be the null string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5138, '.1.3.6.1.4.1.9.9.692.1.1.1.1.7', 'cfmFlowMonitorAlarms', 5131, 'current', NULL, 'This object indicates the current alarm conditions for the flow monitor.  If the flow monitor does not have an associated conditions profile, then the value of this column must be the null string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5139, '.1.3.6.1.4.1.9.9.692.1.1.1.1.8', 'cfmFlowMonitorAlarmSeverity', 5131, 'current', NULL, 'This object indicates the high severity alarm condition currently raised by the flow monitor and the traffic flows monitored by the flow monitor.  If no alarm is raised for the flow monitor and the traffic flows monitored for the flow monitor, then the value of this column is ''cleared''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5140, '.1.3.6.1.4.1.9.9.692.1.1.1.1.9', 'cfmFlowMonitorAlarmCriticalCount', 5131, 'current', NULL, 'This object indicates the number of alarm conditions with a critical severity currently raised for traffic flows monitored by the flow monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5141, '.1.3.6.1.4.1.9.9.692.1.1.1.1.10', 'cfmFlowMonitorAlarmMajorCount', 5131, 'current', NULL, 'This object indicates the number of alarm conditions with a major severity currently raised for traffic flows monitored by the flow monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5142, '.1.3.6.1.4.1.9.9.692.1.1.1.1.11', 'cfmFlowMonitorAlarmMinorCount', 5131, 'current', NULL, 'This object indicates the number of alarm conditions with a minor severity currently raised for traffic flows monitored by the flow monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5143, '.1.3.6.1.4.1.9.9.692.1.1.1.1.12', 'cfmFlowMonitorAlarmWarningCount', 5131, 'current', NULL, 'This object indicates the number of alarm conditions with a warning severity currently raised for traffic flows monitored by the flow monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5144, '.1.3.6.1.4.1.9.9.692.1.1.1.1.13', 'cfmFlowMonitorAlarmInfoCount', 5131, 'current', NULL, 'This object indicates the number of alarm conditions with a informational severity currently raised for traffic flows monitored by the flow monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5145, '.1.3.6.1.4.1.9.9.692.1.1.2', 'cfmFlowMonitorTableChanged', 5129, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device created or destroyed a row in cfmFlowMonitorTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5146, '.1.3.6.1.4.1.9.9.692.1.2', 'cfmFlows', 5126, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5147, '.1.3.6.1.4.1.9.9.692.1.2.1', 'cfmFlowTable', 5146, 'current', NULL, 'This table lists the traffic flows monitored by each flow monitor supported by the device.  This table has an expansion dependent relationship on the cfmFlowMonitorTable, containing zero or more rows for each flow monitor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5148, '.1.3.6.1.4.1.9.9.692.1.2.1.1', 'cfmFlowEntry', 5147, 'current', NULL, 'An entry describes a traffic flow monitored by a flow monitor.  The device creates a row in the cfmFlowTable when a flow monitor starts monitoring a traffic flow. Likewise, the device destroys a row in the cfmFlowTable when a traffic flow monitored by a flow monitor has timed out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5149, '.1.3.6.1.4.1.9.9.692.1.2.1.1.1', 'cfmFlowId', 5148, 'current', NULL, 'This object indicates an arbitrary integer-value that uniquely identifies a traffic flow in the scope of the flow monitor that learned it. Observe that the value assigned to a flow does not necessarily persist across restarts or the removal-insertion of a physical entity supporting flow monitor(s).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5150, '.1.3.6.1.4.1.9.9.692.1.2.1.1.2', 'cfmFlowDescr', 5148, 'current', NULL, 'This object indicates a human-readable description of the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5151, '.1.3.6.1.4.1.9.9.692.1.2.1.1.3', 'cfmFlowNext', 5148, 'current', NULL, 'This object indicates a reference to a row in another table containing additional data relating to the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5152, '.1.3.6.1.4.1.9.9.692.1.2.1.1.4', 'cfmFlowCreateTime', 5148, 'current', NULL, 'This object indicates the value of sysUpTime when the row was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5153, '.1.3.6.1.4.1.9.9.692.1.2.1.1.5', 'cfmFlowDiscontinuityTime', 5148, 'current', NULL, 'This object indicates the value of sysUpTime on the most recent occasion at which any one or more of counters associated with the traffic flow suffered a discontinuity (e.g., process restart or failover event).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5154, '.1.3.6.1.4.1.9.9.692.1.2.1.1.6', 'cfmFlowExpirationTime', 5148, 'current', NULL, 'This object indicates the expiration interval for the traffic flow. If the flow monitor receives no packets for the traffic flow in this interval, then it expires the flow; that is, it stops monitoring the traffic and removes the corresponding row from the cfmFlowTable. If this column is ''0'', then the traffic flow was statically configured (as opposed to dynamically learned) and it will never expire.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5155, '.1.3.6.1.4.1.9.9.692.1.2.1.1.7', 'cfmFlowDirection', 5148, 'current', NULL, 'This object indicates the direction of the traffic flow where the flow monitor collects data:  ''unknown'' The SNMP entity does not know the direction of the traffic flow at the point the flow monitor collects data.  ''ingress'' The flow monitor collects data at the point where the traffic flow enters the devices  ''egress'' The flow monitor collects data at the point where the traffic flow leaves the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5183, '.1.3.6.1.4.1.9.9.692.1.2.7.1.3', 'cfmFlowUdpPortDst', 5180, 'current', NULL, 'This object indicates the destination UDP port number of the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5184, '.1.3.6.1.4.1.9.9.692.1.2.8', 'cfmFlowUdpTableChanged', 5146, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device changed the cfmFlowUdpTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5156, '.1.3.6.1.4.1.9.9.692.1.2.1.1.8', 'cfmFlowAdminStatus', 5148, 'current', NULL, 'This object specifies the desired state of the traffic flow:  ''enabled'' The corresponding flow monitor is collecting data and computing metrics for the traffic flow.  ''disabled'' The corresponding flow monitor is not collecting data or computing metrics for the traffic flow. As long as a traffic flow remains in this state, the flow monitor will not expire the traffic flow.  ''expire'' When this column is set to this value, it forces the traffic flow to expire. It is not possible to return this value in a response to a retrieval operation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5157, '.1.3.6.1.4.1.9.9.692.1.2.1.1.9', 'cfmFlowOperStatus', 5148, 'current', NULL, 'This object indicates the operational state of the traffic flow:  ''enabled'' The corresponding flow monitor is actively monitoring the traffic flow.  ''disabled'' The corresponding flow monitor is neither collecting data, nor computing metrics for the traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5158, '.1.3.6.1.4.1.9.9.692.1.2.1.1.10', 'cfmFlowIngressType', 5148, 'current', NULL, 'This object indicates the type of port that receives the traffic for this traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5159, '.1.3.6.1.4.1.9.9.692.1.2.1.1.11', 'cfmFlowIngress', 5148, 'current', NULL, 'This object identifies the port that receives the traffic for this traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5160, '.1.3.6.1.4.1.9.9.692.1.2.1.1.12', 'cfmFlowEgressType', 5148, 'current', NULL, 'This object indicates the type of port that transmits the traffic for this traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5161, '.1.3.6.1.4.1.9.9.692.1.2.1.1.13', 'cfmFlowEgress', 5148, 'current', NULL, 'This object identifies the port that transmits the traffic for this traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5162, '.1.3.6.1.4.1.9.9.692.1.2.2', 'cfmFlowTableChanged', 5146, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device created or destroyed a row in cfmFlowTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5163, '.1.3.6.1.4.1.9.9.692.1.2.3', 'cfmFlowL2VlanTable', 5146, 'current', NULL, 'This table contains additional data relating to the L2 VLAN carrying traffic flows monitored by flow monitors.  This table has a sparse dependent relationship on the cfmFlowTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5164, '.1.3.6.1.4.1.9.9.692.1.2.3.1', 'cfmFlowL2VlanEntry', 5163, 'current', NULL, 'An entry describes data relating to the L2 VLAN carrying the corresponding traffic flow.  A device creates a row in the cfmFlowL2VlanTable when a flow monitor has data relating to the L2 VLAN carrying a corresponding traffic flow. The device destroys a row in the cfmFlowL2VlanTable when the corresponding traffic flow times out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5165, '.1.3.6.1.4.1.9.9.692.1.2.3.1.1', 'cfmFlowL2VlanNext', 5164, 'current', NULL, 'This object indicates a reference to a row in another table containing additional data relating to the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5166, '.1.3.6.1.4.1.9.9.692.1.2.3.1.2', 'cfmFlowL2VlanId', 5164, 'current', NULL, 'This object indicates the tag associated with the VLAN carrying the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5167, '.1.3.6.1.4.1.9.9.692.1.2.3.1.3', 'cfmFlowL2VlanCos', 5164, 'current', NULL, 'This object indicates the layer 2 COS assigned to the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5168, '.1.3.6.1.4.1.9.9.692.1.2.4', 'cfmFlowL2VlanTableChanged', 5146, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device changed the cfmFlowL2VlanTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5169, '.1.3.6.1.4.1.9.9.692.1.2.5', 'cfmFlowIpTable', 5146, 'current', NULL, 'This table contains additional data relating to the IP carrying the corresponding traffic flow.  This table has a sparse dependent relationship on the cfmFlowTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5170, '.1.3.6.1.4.1.9.9.692.1.2.5.1', 'cfmFlowIpEntry', 5169, 'current', NULL, 'An entry describes data relating to the IP carrying the corresponding traffic flow.  A device creates a row in the cfmFlowIpTable when the flow monitor has data relating to the IP carrying the corresponding traffic flow. The device destroys a row in this table when the corresponding traffic flow times out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5171, '.1.3.6.1.4.1.9.9.692.1.2.5.1.1', 'cfmFlowIpNext', 5170, 'current', NULL, 'This object indicates a reference to a row in another table containing additional data relating to the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5172, '.1.3.6.1.4.1.9.9.692.1.2.5.1.2', 'cfmFlowIpAddrType', 5170, 'current', NULL, 'This object indicates the type of IP address indicated by the corresponding instances of cfmFlowIpAddrSrc and cfmFlowIpAddrDst.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5173, '.1.3.6.1.4.1.9.9.692.1.2.5.1.3', 'cfmFlowIpAddrSrc', 5170, 'current', NULL, 'This object indicates the source IP address of the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5174, '.1.3.6.1.4.1.9.9.692.1.2.5.1.4', 'cfmFlowIpAddrDst', 5170, 'current', NULL, 'This object indicates the destination IP address of the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5175, '.1.3.6.1.4.1.9.9.692.1.2.5.1.5', 'cfmFlowIpValid', 5170, 'current', NULL, 'This object indicates whether the corresponding instances of cfmFlowIpTrafficClass and cfmFlowIpHopLimit are valid.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5176, '.1.3.6.1.4.1.9.9.692.1.2.5.1.6', 'cfmFlowIpTrafficClass', 5170, 'current', 'J. Postel, ''Internet Protocol'', RFC-791, September 1981.  J. Deering and R. Hinden, ''Internet Protocol, Version 6 (IPv6) Specification'', RFC-2460, December 1998.', 'This object indicates the traffic class of the corresponding traffic flow.  If version 4 of the IP carries the traffic flow, then the value of this column corresponds to the ''Type of Service'' field of the IP header contained by packets in the traffic flow.  If version 6 of the IP carries the traffic flow, then the value of this column corresponds to the '''' field of the IP header contained by packets in the traffic flow.  The value of this column is valid only if the ''trafficClass'' bit of the corresponding instance of cfmFlowIpValid is ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5177, '.1.3.6.1.4.1.9.9.692.1.2.5.1.7', 'cfmFlowIpHopLimit', 5170, 'current', 'J. Postel, ''Internet Protocol'', RFC-791, September 1981.  J. Deering and R. Hinden, ''Internet Protocol, Version 6 (IPv6) Specification'', RFC-2460, December 1998.', 'This object indicates the hop limit of the corresponding traffic flow.  If version 4 of the IP carries the traffic flow, then the value of this column corresponds to the ''Time to Live'' field of the IP header contained by packets in the traffic flow (as observed by the flow monitor).  If version 6 of the IP carries the traffic flow, then the value of this column corresponds to the ''Hop Limit'' field of the IP header contained by packets in the traffic flow (as observed by the flow monitor).  The value of this column is valid only if the ''hopLimit'' bit of the corresponding instance of cfmFlowIpValid is ''1''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5178, '.1.3.6.1.4.1.9.9.692.1.2.6', 'cfmFlowIpTableChanged', 5146, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device changed the cfmFlowIpTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5179, '.1.3.6.1.4.1.9.9.692.1.2.7', 'cfmFlowUdpTable', 5146, 'current', NULL, 'This table contains additional data relating to the UDP carrying the corresponding traffic flow.  This table has a sparse dependent relationship on the cfmFlowTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5180, '.1.3.6.1.4.1.9.9.692.1.2.7.1', 'cfmFlowUdpEntry', 5179, 'current', NULL, 'An entry describes data relating to the UDP carrying the corresponding traffic flow.  A device creates a row in the cfmFlowUdpTable when the flow monitor has data relating to the UDP carrying the corresponding traffic flow. The device destroys a row in this table when the corresponding traffic flow times out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5181, '.1.3.6.1.4.1.9.9.692.1.2.7.1.1', 'cfmFlowUdpNext', 5180, 'current', NULL, 'This object indicates a reference to a row in another table containing additional data relating to the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5182, '.1.3.6.1.4.1.9.9.692.1.2.7.1.2', 'cfmFlowUdpPortSrc', 5180, 'current', NULL, 'This object indicates the source UDP port number of the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6330, '.1.0.8802.1.1.2.1.4.4.1.1', 'lldpRemOrgDefInfoOUI', 6329, 'current', 'IEEE 802.1AB-2005 9.5.1.3', 'The Organizationally Unique Identifier (OUI), as defined in IEEE std 802-2001, is a 24 bit (three octets) globally unique assigned number referenced by various standards, of the information received from the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5186, '.1.3.6.1.4.1.9.9.692.1.2.9.1', 'cfmFlowTcpEntry', 5185, 'current', NULL, 'An entry describes data relating to the TCP carrying the corresponding traffic flow.  A device creates a row in the cfmFlowTcpTable when the flow monitor has data relating to the TCP carrying the corresponding traffic flow. The device destroys a row in this table when the corresponding traffic flow times out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5187, '.1.3.6.1.4.1.9.9.692.1.2.9.1.1', 'cfmFlowTcpNext', 5186, 'current', NULL, 'This object indicates a reference to a row in another table containing additional data relating to the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5188, '.1.3.6.1.4.1.9.9.692.1.2.9.1.2', 'cfmFlowTcpPortSrc', 5186, 'current', NULL, 'This object indicates the source TCP port number of the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5189, '.1.3.6.1.4.1.9.9.692.1.2.9.1.3', 'cfmFlowTcpPortDst', 5186, 'current', NULL, 'This object indicates the destination TCP port number of the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5190, '.1.3.6.1.4.1.9.9.692.1.2.10', 'cfmFlowTcpTableChanged', 5146, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device changed the cfmFlowTcpTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5191, '.1.3.6.1.4.1.9.9.692.1.2.11', 'cfmFlowRtpTable', 5146, 'current', NULL, 'This table contains additional data relating to the RTP carrying the corresponding traffic flow.  This table has a sparse dependent relationship on the cfmFlowTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5192, '.1.3.6.1.4.1.9.9.692.1.2.11.1', 'cfmFlowRtpEntry', 5191, 'current', NULL, 'An entry describes data relating to the RTP carrying the corresponding traffic flow.  A device creates a row in the cfmFlowRtpTable when the flow monitor has data relating to the RTP carrying the corresponding traffic flow. The device destroys a row in this table when the corresponding traffic flow times out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5193, '.1.3.6.1.4.1.9.9.692.1.2.11.1.1', 'cfmFlowRtpNext', 5192, 'current', NULL, 'This object indicates a reference to a row in another table containing additional data relating to the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5194, '.1.3.6.1.4.1.9.9.692.1.2.11.1.2', 'cfmFlowRtpVersion', 5192, 'current', NULL, 'This object indicates the RTP version of the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5195, '.1.3.6.1.4.1.9.9.692.1.2.11.1.3', 'cfmFlowRtpSsrc', 5192, 'current', NULL, 'This object indicates the RTP synchronized source (SSRC) of the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5196, '.1.3.6.1.4.1.9.9.692.1.2.11.1.4', 'cfmFlowRtpPayloadType', 5192, 'current', NULL, 'This object indicates the RTP payload type of the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5197, '.1.3.6.1.4.1.9.9.692.1.2.12', 'cfmFlowRtpTableChanged', 5146, 'current', NULL, 'This object indicates the value of sysUpTime the last time the device changed the cfmFlowRtpTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5198, '.1.3.6.1.4.1.9.9.692.1.3', 'cfmFlowMetrics', 5126, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5199, '.1.3.6.1.4.1.9.9.692.1.3.1', 'cfmFlowMetricsTable', 5198, 'current', NULL, 'This table contains aggregate metrics and data relating to the collection of metrics for the traffic flows monitored by each of the flow monitors supported by the device.  This table has a sparse dependent relationship on the cfmFlowTable, containing a row for each row in the cfmFlowTable for which the device is actively monitoring.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5200, '.1.3.6.1.4.1.9.9.692.1.3.1.1', 'cfmFlowMetricsEntry', 5199, 'current', NULL, 'An entry contains aggregate metrics and data relating to the collection of metrics for a corresponding traffic flow.  The device creates a row in the cfmFlowMetricsTable when a flow monitor starts monitoring a traffic flow. Likewise, the device destroys a row in the cfmFlowMetricsTable when the corresponding flow monitor has ceased monitoring the traffic flow (e.g., when a traffic flow has timed out). Observe that the device does not destroy the row unless it has not received packets for the corresponding flow for an interval of time equal to the flow''s expiration time, thereby giving an EMS/NMS ample time to retrieve any data relating to the flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5201, '.1.3.6.1.4.1.9.9.692.1.3.1.1.1', 'cfmFlowMetricsCollected', 5200, 'current', NULL, 'This object indicates the metrics collected by the corresponding flow monitor for the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5202, '.1.3.6.1.4.1.9.9.692.1.3.1.1.2', 'cfmFlowMetricsIntervalTime', 5200, 'current', NULL, 'This object indicates the length of the measurement interval for the corresponding traffic flow. The flow monitor computes the collected metrics for the corresponding traffic flow with a frequency equal to the inverse of the value of this column.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5203, '.1.3.6.1.4.1.9.9.692.1.3.1.1.3', 'cfmFlowMetricsMaxIntervals', 5200, 'current', NULL, 'This object indicates the maximum number of measurement intervals for which the corresponding flow monitor maintains metrics for the corresponding traffic flow.  If the value of this column is ''0'', then the corresponding flow monitor does not maintain historical metrics for the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5204, '.1.3.6.1.4.1.9.9.692.1.3.1.1.4', 'cfmFlowMetricsElapsedTime', 5200, 'current', NULL, 'This object indicates the time that has elapsed since the beginning of the current measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5205, '.1.3.6.1.4.1.9.9.692.1.3.1.1.5', 'cfmFlowMetricsIntervals', 5200, 'current', NULL, 'This object indicates the number of measurement intervals for which data has been collected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5206, '.1.3.6.1.4.1.9.9.692.1.3.1.1.6', 'cfmFlowMetricsInvalidIntervals', 5200, 'current', NULL, 'This object indicates the number of measurement intervals in the set of collected measurement intervals that contain invalid data.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5207, '.1.3.6.1.4.1.9.9.692.1.3.1.1.7', 'cfmFlowMetricsConditionsProfile', 5200, 'current', NULL, 'This object indicates the conditions profile that contains the descriptions of the standing conditions monitored for the traffic flow.  If the flow does not have an associated conditions profile, then the value of this column must be zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5208, '.1.3.6.1.4.1.9.9.692.1.3.1.1.8', 'cfmFlowMetricsConditions', 5200, 'current', NULL, 'This object indicates the current standing conditions for the corresponding traffic flow.  If the flow does not have an associated conditions profile, then the value of this column must be the null string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5209, '.1.3.6.1.4.1.9.9.692.1.3.1.1.9', 'cfmFlowMetricsAlarms', 5200, 'current', NULL, 'This object indicates the current alarm conditions for the corresponding traffic flow.  If the flow does not have an associated conditions profile, then the value of this column must be the null string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5210, '.1.3.6.1.4.1.9.9.692.1.3.1.1.10', 'cfmFlowMetricsAlarmSeverity', 5200, 'current', NULL, 'This object indicates the highest severity alarm currently raised for the corresponding traffic flow.  If no alarm is raised for the corresponding traffic flow, then the value of this column is ''cleared''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5211, '.1.3.6.1.4.1.9.9.692.1.3.1.1.11', 'cfmFlowMetricsPkts', 5200, 'current', NULL, 'This object indicates the total number of packets processed by the corresponding flow monitor for the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5212, '.1.3.6.1.4.1.9.9.692.1.3.1.1.12', 'cfmFlowMetricsOctets', 5200, 'current', NULL, 'This object indicates the total number of octets contained by the packets processed by the corresponding flow monitor for the corresponding traffic flow.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (5213, '.1.3.6.1.4.1.9.9.692.1.3.1.1.13', 'cfmFlowMetricsBitRateUnits', 5200, 'current', NULL, 'This object indicates the units for the corresponding instance of cfmFlowMetricsBitRate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6331, '.1.0.8802.1.1.2.1.4.4.1.2', 'lldpRemOrgDefInfoSubtype', 6329, 'current', 'IEEE 802.1AB-2005 9.5.1.4', 'The integer value used to identify the subtype of the organizationally defined information received from the remote system.  The subtype value is required to identify different instances of organizationally defined information that could not be retrieved without a unique identifier that indicates the particular type of information contained in the information string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6332, '.1.0.8802.1.1.2.1.4.4.1.3', 'lldpRemOrgDefInfoIndex', 6329, 'current', NULL, 'This object represents an arbitrary local integer value used by this agent to identify a particular unrecognized organizationally defined information instance, unique only for the lldpRemOrgDefInfoOUI and lldpRemOrgDefInfoSubtype from the same remote system.  An agent is encouraged to assign monotonically increasing index values to new entries, starting with one, after each reboot. It is considered unlikely that the lldpRemOrgDefInfoIndex will wrap between reboots.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6333, '.1.0.8802.1.1.2.1.4.4.1.4', 'lldpRemOrgDefInfo', 6329, 'current', 'IEEE 802.1AB-2005 9.5.1.5', 'The string value used to identify the organizationally defined information of the remote system. The encoding for this object should be as defined for SnmpAdminString TC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6334, '.1.0.8802.1.1.2.0.0', 'lldpNotificationPrefix', 6243, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6335, '.1.0.8802.1.1.2.0.0.1', 'lldpRemTablesChange', 6334, 'current', NULL, 'A lldpRemTablesChange notification is sent when the value of lldpStatsRemTableLastChangeTime changes. It can be utilized by an NMS to trigger LLDP remote systems table maintenance polls.  Note that transmission of lldpRemTablesChange notifications are throttled by the agent, as specified by the ''lldpNotificationInterval'' object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6336, '.1.0.8802.1.1.2.2.1', 'lldpCompliances', 6245, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6337, '.1.0.8802.1.1.2.2.2', 'lldpGroups', 6245, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6338, '.1.0.8802.1.1.2.2.1.1', 'lldpCompliance', 6336, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6339, '.1.0.8802.1.1.2.2.2.1', 'lldpConfigGroup', 6337, 'current', NULL, 'The collection of objects which are used to configure the LLDP implementation behavior.  This group is mandatory for agents which implement the LLDP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6340, '.1.0.8802.1.1.2.2.2.2', 'lldpConfigRxGroup', 6337, 'current', NULL, 'The collection of objects which are used to configure the LLDP implementation behavior.  This group is mandatory for agents which implement the LLDP and have the capability of receiving LLDP frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6341, '.1.0.8802.1.1.2.2.2.3', 'lldpConfigTxGroup', 6337, 'current', NULL, 'The collection of objects which are used to configure the LLDP implementation behavior.  This group is mandatory for agents which implement the LLDP and have the capability of transmitting LLDP frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6342, '.1.0.8802.1.1.2.2.2.4', 'lldpStatsRxGroup', 6337, 'current', NULL, 'The collection of objects which are used to represent LLDP reception statistics.  This group is mandatory for agents which implement the LLDP and have the capability of receiving LLDP frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6343, '.1.0.8802.1.1.2.2.2.5', 'lldpStatsTxGroup', 6337, 'current', NULL, 'The collection of objects which are used to represent LLDP transmission statistics.  This group is mandatory for agents which implement the LLDP and have the capability of transmitting LLDP frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6344, '.1.0.8802.1.1.2.2.2.6', 'lldpLocSysGroup', 6337, 'current', NULL, 'The collection of objects which are used to represent LLDP Local System Information.  This group is mandatory for agents which implement the LLDP and have the capability of transmitting LLDP frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6345, '.1.0.8802.1.1.2.2.2.7', 'lldpRemSysGroup', 6337, 'current', NULL, 'The collection of objects which are used to represent LLDP Remote Systems Information. The objects represent the information associated with the basic TLV set. Please note that even the agent doesn''t implement some of the optional TLVs, it shall recognize all the optional TLV information that the remote system may advertise.  This group is mandatory for agents which implement the LLDP and have the capability of receiving LLDP frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6346, '.1.0.8802.1.1.2.2.2.8', 'lldpNotificationsGroup', 6337, 'current', NULL, 'The collection of notifications used to indicate LLDP MIB data consistency and general status information.  This group is mandatory for agents which implement the LLDP and have the capability of receiving LLDP frames.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6303, '.1.0.8802.1.1.2.1.4.1', 'lldpRemTable', 6249, 'current', NULL, 'This table contains one or more rows per physical network connection known to this agent. The agent may wish to ensure that only one lldpRemEntry is present for each local port, or it may choose to maintain multiple lldpRemEntries for the same local port.  The following procedure may be used to retrieve remote systems information updates from an LLDP agent:  1. NMS polls all tables associated with remote systems and keeps a local copy of the information retrieved. NMS polls periodically the values of the following objects: a. lldpStatsRemTablesInserts b. lldpStatsRemTablesDeletes c. lldpStatsRemTablesDrops d. lldpStatsRemTablesAgeouts e. lldpStatsRxPortAgeoutsTotal for all ports.  2. LLDP agent updates remote systems MIB objects, and sends out notifications to a list of notification destinations.  3. NMS receives the notifications and compares the new values of objects listed in step 1.  Periodically, NMS should poll the object lldpStatsRemTablesLastChangeTime to find out if anything has changed since the last poll. if something has changed, NMS will poll the objects listed in step 1 to figure out what kind of changes occurred in the tables.  if value of lldpStatsRemTablesInserts has changed, then NMS will walk all tables by employing TimeFilter with the last-polled time value. This request will return new objects or objects whose values are updated since the last poll.  if value of lldpStatsRemTablesAgeouts has changed, then NMS will walk the lldpStatsRxPortAgeoutsTotal and compare the new values with previously recorded ones. For ports whose lldpStatsRxPortAgeoutsTotal value is greater than the recorded value, NMS will have to retrieve objects associated with those ports from table(s) without employing a TimeFilter (which is performed by specifying 0 for the TimeFilter.)  lldpStatsRemTablesDeletes and lldpStatsRemTablesDrops objects are provided for informational purposes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6304, '.1.0.8802.1.1.2.1.4.1.1', 'lldpRemEntry', 6303, 'current', NULL, 'Information about a particular physical network connection. Entries may be created and deleted in this table by the agent, if a physical topology discovery process is active.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6305, '.1.0.8802.1.1.2.1.4.1.1.1', 'lldpRemTimeMark', 6304, 'current', 'IETF RFC 2021 section 6', 'A TimeFilter for this entry. See the TimeFilter textual convention in IETF RFC 2021 and http://www.ietf.org/IESG/Implementations/RFC2021-Implementation.txt to see how TimeFilter works.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6306, '.1.0.8802.1.1.2.1.4.1.1.2', 'lldpRemLocalPortNum', 6304, 'current', NULL, 'The index value used to identify the port component (contained in the local chassis with the LLDP agent) associated with this entry. The lldpRemLocalPortNum identifies the port on which the remote system information is received.  The value of this object is used as a port index to the lldpRemTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6290, '.1.0.8802.1.1.2.1.3.7.1', 'lldpLocPortEntry', 6289, 'current', NULL, 'Information about a particular port component.  Entries may be created and deleted in this table by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6291, '.1.0.8802.1.1.2.1.3.7.1.1', 'lldpLocPortNum', 6290, 'current', NULL, 'The index value used to identify the port component (contained in the local chassis with the LLDP agent) associated with this entry.  The value of this object is used as a port index to the lldpLocPortTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6307, '.1.0.8802.1.1.2.1.4.1.1.3', 'lldpRemIndex', 6304, 'current', NULL, 'This object represents an arbitrary local integer value used by this agent to identify a particular connection instance, unique only for the indicated remote system.  An agent is encouraged to assign monotonically increasing index values to new entries, starting with one, after each reboot. It is considered unlikely that the lldpRemIndex will wrap between reboots.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6308, '.1.0.8802.1.1.2.1.4.1.1.4', 'lldpRemChassisIdSubtype', 6304, 'current', 'IEEE 802.1AB-2005 9.5.2.2', 'The type of encoding used to identify the chassis associated with the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6309, '.1.0.8802.1.1.2.1.4.1.1.5', 'lldpRemChassisId', 6304, 'current', 'IEEE 802.1AB-2005 9.5.2.3', 'The string value used to identify the chassis component associated with the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6310, '.1.0.8802.1.1.2.1.4.1.1.6', 'lldpRemPortIdSubtype', 6304, 'current', 'IEEE 802.1AB-2005 9.5.3.2', 'The type of port identifier encoding used in the associated ''lldpRemPortId'' object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6311, '.1.0.8802.1.1.2.1.4.1.1.7', 'lldpRemPortId', 6304, 'current', 'IEEE 802.1AB-2005 9.5.3.3', 'The string value used to identify the port component associated with the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6312, '.1.0.8802.1.1.2.1.4.1.1.8', 'lldpRemPortDesc', 6304, 'current', 'IEEE 802.1AB-2005 9.5.5.2', 'The string value used to identify the description of the given port associated with the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6313, '.1.0.8802.1.1.2.1.4.1.1.9', 'lldpRemSysName', 6304, 'current', 'IEEE 802.1AB-2005 9.5.6.2', 'The string value used to identify the system name of the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6314, '.1.0.8802.1.1.2.1.4.1.1.10', 'lldpRemSysDesc', 6304, 'current', 'IEEE 802.1AB-2005 9.5.7.2', 'The string value used to identify the system description of the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6315, '.1.0.8802.1.1.2.1.4.1.1.11', 'lldpRemSysCapSupported', 6304, 'current', 'IEEE 802.1AB-2005 9.5.8.1', 'The bitmap value used to identify which system capabilities are supported on the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6316, '.1.0.8802.1.1.2.1.4.1.1.12', 'lldpRemSysCapEnabled', 6304, 'current', 'IEEE 802.1AB-2005 9.5.8.2', 'The bitmap value used to identify which system capabilities are enabled on the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6317, '.1.0.8802.1.1.2.1.4.2', 'lldpRemManAddrTable', 6249, 'current', NULL, 'This table contains one or more rows per management address information on the remote system learned on a particular port contained in the local chassis known to this agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6318, '.1.0.8802.1.1.2.1.4.2.1', 'lldpRemManAddrEntry', 6317, 'current', NULL, 'Management address information about a particular chassis component. There may be multiple management addresses configured on the remote system identified by a particular lldpRemIndex whose information is received on lldpRemLocalPortNum of the local system. Each management address should have distinct ''management address type'' (lldpRemManAddrSubtype) and ''management address'' (lldpRemManAddr.)  Entries may be created and deleted in this table by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6319, '.1.0.8802.1.1.2.1.4.2.1.1', 'lldpRemManAddrSubtype', 6318, 'current', 'IEEE 802.1AB-2005 9.5.9.3', 'The type of management address identifier encoding used in the associated ''lldpRemManagmentAddr'' object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6320, '.1.0.8802.1.1.2.1.4.2.1.2', 'lldpRemManAddr', 6318, 'current', 'IEEE 802.1AB-2005 9.5.9.4', 'The string value used to identify the management address component associated with the remote system. The purpose of this address is to contact the management entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6321, '.1.0.8802.1.1.2.1.4.2.1.3', 'lldpRemManAddrIfSubtype', 6318, 'current', 'IEEE 802.1AB-2005 9.5.9.5', 'The enumeration value that identifies the interface numbering method used for defining the interface number, associated with the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6322, '.1.0.8802.1.1.2.1.4.2.1.4', 'lldpRemManAddrIfId', 6318, 'current', 'IEEE 802.1AB-2005 9.5.9.6', 'The integer value used to identify the interface number regarding the management address component associated with the remote system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6323, '.1.0.8802.1.1.2.1.4.2.1.5', 'lldpRemManAddrOID', 6318, 'current', 'IEEE 802.1AB-2005 9.5.9.8', 'The OID value used to identify the type of hardware component or protocol entity associated with the management address advertised by the remote system agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6325, '.1.0.8802.1.1.2.1.4.3.1', 'lldpRemUnknownTLVEntry', 6324, 'current', NULL, 'Information about an unrecognized TLV received from a physical network connection. Entries may be created and deleted in this table by the agent, if a physical topology discovery process is active.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6326, '.1.0.8802.1.1.2.1.4.3.1.1', 'lldpRemUnknownTLVType', 6325, 'current', 'IEEE 802.1AB-2005 10.3.5', 'This object represents the value extracted from the type field of the TLV.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6327, '.1.0.8802.1.1.2.1.4.3.1.2', 'lldpRemUnknownTLVInfo', 6325, 'current', 'IEEE 802.1AB-2005 10.3.5', 'This object represents the value extracted from the value field of the TLV.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6281, '.1.0.8802.1.1.2.1.2.7.1.6', 'lldpStatsRxPortTLVsUnrecognizedTotal', 6275, 'current', 'IEEE 802.1AB-2005 10.5.2.2', 'The number of LLDP TLVs received on the given port that are not recognized by this LLDP agent on the indicated port.  An unrecognized TLV is referred to as the TLV whose type value is in the range of reserved TLV types (000 1001 - 111 1110) in Table 9.1 of IEEE Std 802.1AB-2005. An unrecognized TLV may be a basic management TLV from a later LLDP version.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6282, '.1.0.8802.1.1.2.1.2.7.1.7', 'lldpStatsRxPortAgeoutsTotal', 6275, 'current', 'IEEE 802.1AB-2005 10.5.2.2', 'The counter that represents the number of age-outs that occurred on a given port. An age-out is the number of times the complete set of information advertised by a particular MSAP has been deleted from tables contained in lldpRemoteSystemsData and lldpExtensions objects because the information timeliness interval has expired.  This counter is similar to lldpStatsRemTablesAgeouts, except that the counter is on a per port basis. This enables NMS to poll tables associated with the lldpRemoteSystemsData objects and all LLDP extension objects associated with remote systems on the indicated port only.  This counter should be set to zero during agent initialization and its value should not be saved in non-volatile storage. When a port''s admin status changes from ''disabled'' to ''rxOnly'', ''txOnly'' or ''txAndRx'', the counter associated with the same port should reset to 0. The agent should also flush all remote system information associated with the same port.  This counter should be incremented only once when the complete set of information is invalidated (aged out) from all related tables on a particular port. Partial aging is not allowed, and thus, should not change the value of this counter.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6283, '.1.0.8802.1.1.2.1.3.1', 'lldpLocChassisIdSubtype', 6248, 'current', 'IEEE 802.1AB-2005 9.5.2.2', 'The type of encoding used to identify the chassis associated with the local system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6284, '.1.0.8802.1.1.2.1.3.2', 'lldpLocChassisId', 6248, 'current', 'IEEE 802.1AB-2005 9.5.2.3', 'The string value used to identify the chassis component associated with the local system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6285, '.1.0.8802.1.1.2.1.3.3', 'lldpLocSysName', 6248, 'current', 'IEEE 802.1AB-2005 9.5.6.2', 'The string value used to identify the system name of the local system. If the local agent supports IETF RFC 3418, lldpLocSysName object should have the same value of sysName object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6286, '.1.0.8802.1.1.2.1.3.4', 'lldpLocSysDesc', 6248, 'current', 'IEEE 802.1AB-2005 9.5.7.2', 'The string value used to identify the system description of the local system. If the local agent supports IETF RFC 3418, lldpLocSysDesc object should have the same value of sysDesc object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6293, '.1.0.8802.1.1.2.1.3.7.1.3', 'lldpLocPortId', 6290, 'current', 'IEEE 802.1AB-2005 9.5.3.3', 'The string value used to identify the port component associated with a given port in the local system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6294, '.1.0.8802.1.1.2.1.3.7.1.4', 'lldpLocPortDesc', 6290, 'current', 'IEEE 802.1AB-2005 9.5.5.2', 'The string value used to identify the 802 LAN station''s port description associated with the local system. If the local agent supports IETF RFC 2863, lldpLocPortDesc object should have the same value of ifDescr object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6295, '.1.0.8802.1.1.2.1.3.8', 'lldpLocManAddrTable', 6248, 'current', NULL, 'This table contains management address information on the local system known to this agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6296, '.1.0.8802.1.1.2.1.3.8.1', 'lldpLocManAddrEntry', 6295, 'current', NULL, 'Management address information about a particular chassis component. There may be multiple management addresses configured on the system identified by a particular lldpLocChassisId. Each management address should have distinct ''management address type'' (lldpLocManAddrSubtype) and ''management address'' (lldpLocManAddr.)  Entries may be created and deleted in this table by the agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6297, '.1.0.8802.1.1.2.1.3.8.1.1', 'lldpLocManAddrSubtype', 6296, 'current', 'IEEE 802.1AB-2005 9.5.9.3', 'The type of management address identifier encoding used in the associated ''lldpLocManagmentAddr'' object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6298, '.1.0.8802.1.1.2.1.3.8.1.2', 'lldpLocManAddr', 6296, 'current', 'IEEE 802.1AB-2005 9.5.9.4', 'The string value used to identify the management address component associated with the local system. The purpose of this address is to contact the management entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6299, '.1.0.8802.1.1.2.1.3.8.1.3', 'lldpLocManAddrLen', 6296, 'current', 'IEEE 802.1AB-2005 9.5.9.2', 'The total length of the management address subtype and the management address fields in LLDPDUs transmitted by the local LLDP agent.  The management address length field is needed so that the receiving systems that do not implement SNMP will not be required to implement an iana family numbers/address length equivalency table in order to decode the management adress.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6300, '.1.0.8802.1.1.2.1.3.8.1.4', 'lldpLocManAddrIfSubtype', 6296, 'current', 'IEEE 802.1AB-2005 9.5.9.5', 'The enumeration value that identifies the interface numbering method used for defining the interface number, associated with the local system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6301, '.1.0.8802.1.1.2.1.3.8.1.5', 'lldpLocManAddrIfId', 6296, 'current', 'IEEE 802.1AB-2005 9.5.9.6', 'The integer value used to identify the interface number regarding the management address component associated with the local system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6302, '.1.0.8802.1.1.2.1.3.8.1.6', 'lldpLocManAddrOID', 6296, 'current', 'IEEE 802.1AB-2005 9.5.9.8', 'The OID value used to identify the type of hardware component or protocol entity associated with the management address advertised by the local system agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6324, '.1.0.8802.1.1.2.1.4.3', 'lldpRemUnknownTLVTable', 6249, 'current', 'IEEE 802.1AB-2005 10.3.2', 'This table contains information about an incoming TLV which is not recognized by the receiving LLDP agent. The TLV may be from a later version of the basic management set.  This table should only contain TLVs that are found in a single LLDP frame. Entries in this table, associated with an MAC service access point (MSAP, the access point for MAC services provided to the LCC sublayer, defined in IEEE 100, which is also identified with a particular lldpRemLocalPortNum, lldpRemIndex pair) are overwritten with most recently received unrecognized TLV from the same MSAP, or they will naturally age out when the rxInfoTTL timer (associated with the MSAP) expires.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6263, '.1.0.8802.1.1.2.1.1.7.1', 'lldpConfigManAddrEntry', 6262, 'current', NULL, 'LLDP configuration information that specifies the set of ports (represented as a PortList) on which the local system management address instance will be transmitted.  This configuration object augments the lldpLocManAddrEntry, therefore it is only present along with the management address instance contained in the associated lldpLocManAddrEntry entry.  Each active lldpConfigManAddrEntry must be restored from non-volatile and re-created (along with the corresponding lldpLocManAddrEntry) after a re-initialization of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6264, '.1.0.8802.1.1.2.1.1.7.1.1', 'lldpConfigManAddrPortsTxEnable', 6263, 'current', 'IEEE 802.1AB-2005 10.2.1.1', 'A set of ports that are identified by a PortList, in which each port is represented as a bit. The corresponding local system management address instance will be transmitted on the member ports of the lldpManAddrPortsTxEnable.  The default value for lldpConfigManAddrPortsTxEnable object is empty binary string, which means no ports are specified for advertising indicated management address instance.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6265, '.1.0.8802.1.1.2.1.2.1', 'lldpStatsRemTablesLastChangeTime', 6247, 'current', NULL, 'The value of sysUpTime object (defined in IETF RFC 3418) at the time an entry is created, modified, or deleted in the in tables associated with the lldpRemoteSystemsData objects and all LLDP extension objects associated with remote systems.  An NMS can use this object to reduce polling of the lldpRemoteSystemsData objects.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6266, '.1.0.8802.1.1.2.1.2.2', 'lldpStatsRemTablesInserts', 6247, 'current', NULL, 'The number of times the complete set of information advertised by a particular MSAP has been inserted into tables contained in lldpRemoteSystemsData and lldpExtensions objects.  The complete set of information received from a particular MSAP should be inserted into related tables. If partial information cannot be inserted for a reason such as lack of resources, all of the complete set of information should be removed.  This counter should be incremented only once after the complete set of information is successfully recorded in all related tables. Any failures during inserting information set which result in deletion of previously inserted information should not trigger any changes in lldpStatsRemTablesInserts since the insert is not completed yet or or in lldpStatsRemTablesDeletes, since the deletion would only be a partial deletion. If the failure was the result of lack of resources, the lldpStatsRemTablesDrops counter should be incremented once.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6267, '.1.0.8802.1.1.2.1.2.3', 'lldpStatsRemTablesDeletes', 6247, 'current', NULL, 'The number of times the complete set of information advertised by a particular MSAP has been deleted from tables contained in lldpRemoteSystemsData and lldpExtensions objects.  This counter should be incremented only once when the complete set of information is completely deleted from all related tables. Partial deletions, such as deletion of rows associated with a particular MSAP from some tables, but not from all tables are not allowed, thus should not change the value of this counter.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6268, '.1.0.8802.1.1.2.1.2.4', 'lldpStatsRemTablesDrops', 6247, 'current', NULL, 'The number of times the complete set of information advertised by a particular MSAP could not be entered into tables contained in lldpRemoteSystemsData and lldpExtensions objects because of insufficient resources.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6269, '.1.0.8802.1.1.2.1.2.5', 'lldpStatsRemTablesAgeouts', 6247, 'current', NULL, 'The number of times the complete set of information advertised by a particular MSAP has been deleted from tables contained in lldpRemoteSystemsData and lldpExtensions objects because the information timeliness interval has expired.  This counter should be incremented only once when the complete set of information is completely invalidated (aged out) from all related tables. Partial aging, similar to deletion case, is not allowed, and thus, should not change the value of this counter.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6718, '.1.3.6.1.4.1.9.2.2.1.1.30', 'locIfSlowInPkts', 6689, 'mandatory', NULL, 'Packet count for Inbound traffic routed with slow switching', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6270, '.1.0.8802.1.1.2.1.2.6', 'lldpStatsTxPortTable', 6247, 'current', NULL, 'A table containing LLDP transmission statistics for individual ports. Entries are not required to exist in this table while the lldpPortConfigEntry object is equal to ''disabled(4)''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6271, '.1.0.8802.1.1.2.1.2.6.1', 'lldpStatsTxPortEntry', 6270, 'current', NULL, 'LLDP frame transmission statistics for a particular port. The port must be contained in the same chassis as the LLDP agent.  All counter values in a particular entry shall be maintained on a continuing basis and shall not be deleted upon expiration of rxInfoTTL timing counters in the LLDP remote systems MIB of the receipt of a shutdown frame from a remote LLDP agent.  All statistical counters associated with a particular port on the local LLDP agent become frozen whenever the adminStatus is disabled for the same port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6272, '.1.0.8802.1.1.2.1.2.6.1.1', 'lldpStatsTxPortNum', 6271, 'current', NULL, 'The index value used to identify the port component (contained in the local chassis with the LLDP agent) associated with this entry.  The value of this object is used as a port index to the lldpStatsTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6273, '.1.0.8802.1.1.2.1.2.6.1.2', 'lldpStatsTxPortFramesTotal', 6271, 'current', 'IEEE 802.1AB-2005 10.5.2.1', 'The number of LLDP frames transmitted by this LLDP agent on the indicated port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6274, '.1.0.8802.1.1.2.1.2.7', 'lldpStatsRxPortTable', 6247, 'current', NULL, 'A table containing LLDP reception statistics for individual ports. Entries are not required to exist in this table while the lldpPortConfigEntry object is equal to ''disabled(4)''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6275, '.1.0.8802.1.1.2.1.2.7.1', 'lldpStatsRxPortEntry', 6274, 'current', NULL, 'LLDP frame reception statistics for a particular port. The port must be contained in the same chassis as the LLDP agent.  All counter values in a particular entry shall be maintained on a continuing basis and shall not be deleted upon expiration of rxInfoTTL timing counters in the LLDP remote systems MIB of the receipt of a shutdown frame from a remote LLDP agent.  All statistical counters associated with a particular port on the local LLDP agent become frozen whenever the adminStatus is disabled for the same port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6276, '.1.0.8802.1.1.2.1.2.7.1.1', 'lldpStatsRxPortNum', 6275, 'current', NULL, 'The index value used to identify the port component (contained in the local chassis with the LLDP agent) associated with this entry.  The value of this object is used as a port index to the lldpStatsTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6277, '.1.0.8802.1.1.2.1.2.7.1.2', 'lldpStatsRxPortFramesDiscardedTotal', 6275, 'current', 'IEEE 802.1AB-2005 10.5.2.2', 'The number of LLDP frames received by this LLDP agent on the indicated port, and then discarded for any reason. This counter can provide an indication that LLDP header formating problems may exist with the local LLDP agent in the sending system or that LLDPDU validation problems may exist with the local LLDP agent in the receiving system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6278, '.1.0.8802.1.1.2.1.2.7.1.3', 'lldpStatsRxPortFramesErrors', 6275, 'current', 'IEEE 802.1AB-2005 10.5.2.2', 'The number of invalid LLDP frames received by this LLDP agent on the indicated port, while this LLDP agent is enabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6279, '.1.0.8802.1.1.2.1.2.7.1.4', 'lldpStatsRxPortFramesTotal', 6275, 'current', 'IEEE 802.1AB-2005 10.5.2.2', 'The number of valid LLDP frames received by this LLDP agent on the indicated port, while this LLDP agent is enabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6280, '.1.0.8802.1.1.2.1.2.7.1.5', 'lldpStatsRxPortTLVsDiscardedTotal', 6275, 'current', 'IEEE 802.1AB-2005 10.5.2.2', 'The number of LLDP TLVs discarded for any reason by this LLDP agent on the indicated port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6242, '.1.0.8802.1.1.2', 'lldpMIB', 6241, 'current', NULL, 'Management Information Base module for LLDP configuration, statistics, local system data and remote systems data components.  Copyright (C) IEEE (2005). This version of this MIB module is published as subclause 12.1 of IEEE Std 802.1AB-2005; see the standard itself for full legal notices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6243, '.1.0.8802.1.1.2.0', 'lldpNotifications', 6242, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6244, '.1.0.8802.1.1.2.1', 'lldpObjects', 6242, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6245, '.1.0.8802.1.1.2.2', 'lldpConformance', 6242, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6246, '.1.0.8802.1.1.2.1.1', 'lldpConfiguration', 6244, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6247, '.1.0.8802.1.1.2.1.2', 'lldpStatistics', 6244, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6248, '.1.0.8802.1.1.2.1.3', 'lldpLocalSystemData', 6244, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6249, '.1.0.8802.1.1.2.1.4', 'lldpRemoteSystemsData', 6244, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6250, '.1.0.8802.1.1.2.1.5', 'lldpExtensions', 6244, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6251, '.1.0.8802.1.1.2.1.1.1', 'lldpMessageTxInterval', 6246, 'current', 'IEEE 802.1AB-2005 10.5.3.3', 'The interval at which LLDP frames are transmitted on behalf of this LLDP agent.  The default value for lldpMessageTxInterval object is 30 seconds.  The value of this object must be restored from non-volatile storage after a re-initialization of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6252, '.1.0.8802.1.1.2.1.1.2', 'lldpMessageTxHoldMultiplier', 6246, 'current', 'IEEE 802.1AB-2005 10.5.3.3', 'The time-to-live value expressed as a multiple of the lldpMessageTxInterval object. The actual time-to-live value used in LLDP frames, transmitted on behalf of this LLDP agent, can be expressed by the following formula: TTL = min(65535, (lldpMessageTxInterval * lldpMessageTxHoldMultiplier)) For example, if the value of lldpMessageTxInterval is ''30'', and the value of lldpMessageTxHoldMultiplier is ''4'', then the value ''120'' is encoded in the TTL field in the LLDP header.  The default value for lldpMessageTxHoldMultiplier object is 4.  The value of this object must be restored from non-volatile storage after a re-initialization of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6253, '.1.0.8802.1.1.2.1.1.3', 'lldpReinitDelay', 6246, 'current', 'IEEE 802.1AB-2005 10.5.3.3', 'The lldpReinitDelay indicates the delay (in units of seconds) from when lldpPortConfigAdminStatus object of a particular port becomes ''disabled'' until re-initialization will be attempted.  The default value for lldpReintDelay object is two seconds.  The value of this object must be restored from non-volatile storage after a re-initialization of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6254, '.1.0.8802.1.1.2.1.1.4', 'lldpTxDelay', 6246, 'current', 'IEEE 802.1AB-2005 10.5.3.3', 'The lldpTxDelay indicates the delay (in units of seconds) between successive LLDP frame transmissions initiated by value/status changes in the LLDP local systems MIB. The recommended value for the lldpTxDelay is set by the following formula:  1 <= lldpTxDelay <= (0.25 * lldpMessageTxInterval)  The default value for lldpTxDelay object is two seconds.  The value of this object must be restored from non-volatile storage after a re-initialization of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6363, '.1.3.6.1.2.1.15.3.1.12', 'bgpPeerInTotalMessages', 6351, 'current', NULL, 'The total number of messages received from the remote peer on this connection. This object should be initialized to zero when the connection is established.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6364, '.1.3.6.1.2.1.15.3.1.13', 'bgpPeerOutTotalMessages', 6351, 'current', NULL, 'The total number of messages transmitted to the remote peer on this connection. This object should be initialized to zero when the connection is established.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6365, '.1.3.6.1.2.1.15.3.1.14', 'bgpPeerLastError', 6351, 'current', NULL, 'The last error code and subcode seen by this peer on this connection. If no error has occurred, this field is zero. Otherwise, the first byte of this two byte OCTET STRING contains the error code, and the second byte contains the subcode.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6366, '.1.3.6.1.2.1.15.3.1.15', 'bgpPeerFsmEstablishedTransitions', 6351, 'current', NULL, 'The total number of times the BGP FSM transitioned into the established state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6255, '.1.0.8802.1.1.2.1.1.5', 'lldpNotificationInterval', 6246, 'current', NULL, 'This object controls the transmission of LLDP notifications.  the agent must not generate more than one lldpRemTablesChange notification-event in the indicated period, where a ''notification-event'' is the transmission of a single notification PDU type to a list of notification destinations. If additional changes in lldpRemoteSystemsData object groups occur within the indicated throttling period, then these trap- events must be suppressed by the agent. An NMS should periodically check the value of lldpStatsRemTableLastChangeTime to detect any missed lldpRemTablesChange notification-events, e.g. due to throttling or transmission loss.  If notification transmission is enabled for particular ports, the suggested default throttling period is 5 seconds.  The value of this object must be restored from non-volatile storage after a re-initialization of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6256, '.1.0.8802.1.1.2.1.1.6', 'lldpPortConfigTable', 6246, 'current', NULL, 'The table that controls LLDP frame transmission on individual ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6257, '.1.0.8802.1.1.2.1.1.6.1', 'lldpPortConfigEntry', 6256, 'current', NULL, 'LLDP configuration information for a particular port. This configuration parameter controls the transmission and the reception of LLDP frames on those ports whose rows are created in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6258, '.1.0.8802.1.1.2.1.1.6.1.1', 'lldpPortConfigPortNum', 6257, 'current', NULL, 'The index value used to identify the port component (contained in the local chassis with the LLDP agent) associated with this entry.  The value of this object is used as a port index to the lldpPortConfigTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6259, '.1.0.8802.1.1.2.1.1.6.1.2', 'lldpPortConfigAdminStatus', 6257, 'current', 'IEEE 802.1AB-2005 10.5.1', 'The administratively desired status of the local LLDP agent.  If the associated lldpPortConfigAdminStatus object has a value of ''txOnly(1)'', then LLDP agent will transmit LLDP frames on this port and it will not store any information about the remote systems connected.  If the associated lldpPortConfigAdminStatus object has a value of ''rxOnly(2)'', then the LLDP agent will receive, but it will not transmit LLDP frames on this port.  If the associated lldpPortConfigAdminStatus object has a value of ''txAndRx(3)'', then the LLDP agent will transmit and receive LLDP frames on this port.  If the associated lldpPortConfigAdminStatus object has a value of ''disabled(4)'', then LLDP agent will not transmit or receive LLDP frames on this port. If there is remote systems information which is received on this port and stored in other tables, before the port''s lldpPortConfigAdminStatus becomes disabled, then the information will naturally age out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6260, '.1.0.8802.1.1.2.1.1.6.1.3', 'lldpPortConfigNotificationEnable', 6257, 'current', NULL, 'The lldpPortConfigNotificationEnable controls, on a per port basis, whether or not notifications from the agent are enabled. The value true(1) means that notifications are enabled; the value false(2) means that they are not.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6261, '.1.0.8802.1.1.2.1.1.6.1.4', 'lldpPortConfigTLVsTxEnable', 6257, 'current', 'IEEE 802.1AB-2005 10.2.1.1', 'The lldpPortConfigTLVsTxEnable, defined as a bitmap, includes the basic set of LLDP TLVs whose transmission is allowed on the local LLDP agent by the network management. Each bit in the bitmap corresponds to a TLV type associated with a specific optional TLV.  It should be noted that the organizationally-specific TLVs are excluded from the lldpTLVsTxEnable bitmap.  LLDP Organization Specific Information Extension MIBs should have similar configuration object to control transmission of their organizationally defined TLVs.  The bit ''portDesc(0)'' indicates that LLDP agent should transmit ''Port Description TLV''.  The bit ''sysName(1)'' indicates that LLDP agent should transmit ''System Name TLV''.  The bit ''sysDesc(2)'' indicates that LLDP agent should transmit ''System Description TLV''.  The bit ''sysCap(3)'' indicates that LLDP agent should transmit ''System Capabilities TLV''.  There is no bit reserved for the management address TLV type since transmission of management address TLVs are controlled by another object, lldpConfigManAddrTable.  The default value for lldpPortConfigTLVsTxEnable object is empty set, which means no enumerated values are set.  The value of this object must be restored from non-volatile storage after a re-initialization of the management system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6262, '.1.0.8802.1.1.2.1.1.7', 'lldpConfigManAddrTable', 6246, 'current', NULL, 'The table that controls selection of LLDP management address TLV instances to be transmitted on individual ports.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6347, '.1.3.6.1.2.1.15', 'bgp', 21, 'current', NULL, 'The MIB module for BGP-4.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6348, '.1.3.6.1.2.1.15.1', 'bgpVersion', 6347, 'current', NULL, 'Vector of supported BGP protocol version numbers. Each peer negotiates the version from this vector. Versions are identified via the string of bits contained within this object. The first octet contains bits 0 to 7, the second octet contains bits 8 to 15, and so on, with the most significant bit referring to the lowest bit number in the octet (e.g., the MSB of the first octet refers to bit 0). If a bit, i, is present and set, then the version (i+1) of the BGP is supported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6349, '.1.3.6.1.2.1.15.2', 'bgpLocalAs', 6347, 'current', NULL, 'The local autonomous system number.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6350, '.1.3.6.1.2.1.15.3', 'bgpPeerTable', 6347, 'current', NULL, 'BGP peer table. This table contains, one entry per BGP peer, information about the connections with BGP peers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6351, '.1.3.6.1.2.1.15.3.1', 'bgpPeerEntry', 6350, 'current', NULL, 'Entry containing information about the connection with a BGP peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6352, '.1.3.6.1.2.1.15.3.1.1', 'bgpPeerIdentifier', 6351, 'current', NULL, 'The BGP Identifier of this entry''s BGP peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6353, '.1.3.6.1.2.1.15.3.1.2', 'bgpPeerState', 6351, 'current', NULL, 'The BGP peer connection state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6354, '.1.3.6.1.2.1.15.3.1.3', 'bgpPeerAdminStatus', 6351, 'current', NULL, 'The desired state of the BGP connection. A transition from ''stop'' to ''start'' will cause the BGP Start Event to be generated. A transition from ''start'' to ''stop'' will cause the BGP Stop Event to be generated. This parameter can be used to restart BGP peer connections. Care should be used in providing write access to this object without adequate authentication.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6355, '.1.3.6.1.2.1.15.3.1.4', 'bgpPeerNegotiatedVersion', 6351, 'current', NULL, 'The negotiated version of BGP running between the two peers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6356, '.1.3.6.1.2.1.15.3.1.5', 'bgpPeerLocalAddr', 6351, 'current', NULL, 'The local IP address of this entry''s BGP connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6357, '.1.3.6.1.2.1.15.3.1.6', 'bgpPeerLocalPort', 6351, 'current', NULL, 'The local port for the TCP connection between the BGP peers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6358, '.1.3.6.1.2.1.15.3.1.7', 'bgpPeerRemoteAddr', 6351, 'current', NULL, 'The remote IP address of this entry''s BGP peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6359, '.1.3.6.1.2.1.15.3.1.8', 'bgpPeerRemotePort', 6351, 'current', NULL, 'The remote port for the TCP connection between the BGP peers. Note that the objects bgpPeerLocalAddr, bgpPeerLocalPort, bgpPeerRemoteAddr and bgpPeerRemotePort provide the appropriate reference to the standard MIB TCP connection table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6360, '.1.3.6.1.2.1.15.3.1.9', 'bgpPeerRemoteAs', 6351, 'current', NULL, 'The remote autonomous system number.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6361, '.1.3.6.1.2.1.15.3.1.10', 'bgpPeerInUpdates', 6351, 'current', NULL, 'The number of BGP UPDATE messages received on this connection. This object should be initialized to zero (0) when the connection is established.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6362, '.1.3.6.1.2.1.15.3.1.11', 'bgpPeerOutUpdates', 6351, 'current', NULL, 'The number of BGP UPDATE messages transmitted on this connection. This object should be initialized to zero (0) when the connection is established.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6367, '.1.3.6.1.2.1.15.3.1.16', 'bgpPeerFsmEstablishedTime', 6351, 'current', NULL, 'This timer indicates how long (in seconds) this peer has been in the Established state or how long since this peer was last in the Established state. It is set to zero when a new peer is configured or the router is booted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6368, '.1.3.6.1.2.1.15.3.1.17', 'bgpPeerConnectRetryInterval', 6351, 'current', NULL, 'Time interval in seconds for the ConnectRetry timer. The suggested value for this timer is 120 seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6369, '.1.3.6.1.2.1.15.3.1.18', 'bgpPeerHoldTime', 6351, 'current', NULL, 'Time interval in seconds for the Hold Timer established with the peer. The value of this object is calculated by this BGP speaker by using the smaller of the value in bgpPeerHoldTimeConfigured and the Hold Time received in the OPEN message. This value must be at lease three seconds if it is not zero (0) in which case the Hold Timer has not been established with the peer, or, the value of bgpPeerHoldTimeConfigured is zero (0).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6370, '.1.3.6.1.2.1.15.3.1.19', 'bgpPeerKeepAlive', 6351, 'current', NULL, 'Time interval in seconds for the KeepAlive timer established with the peer. The value of this object is calculated by this BGP speaker such that, when compared with bgpPeerHoldTime, it has the same proportion as what bgpPeerKeepAliveConfigured has when compared with bgpPeerHoldTimeConfigured. If the value of this object is zero (0), it indicates that the KeepAlive timer has not been established with the peer, or, the value of bgpPeerKeepAliveConfigured is zero (0).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6371, '.1.3.6.1.2.1.15.3.1.20', 'bgpPeerHoldTimeConfigured', 6351, 'current', NULL, 'Time interval in seconds for the Hold Time configured for this BGP speaker with this peer. This value is placed in an OPEN message sent to this peer by this BGP speaker, and is compared with the Hold Time field in an OPEN message received from the peer when determining the Hold Time (bgpPeerHoldTime) with the peer. This value must not be less than three seconds if it is not zero (0) in which case the Hold Time is NOT to be established with the peer. The suggested value for this timer is 90 seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6372, '.1.3.6.1.2.1.15.3.1.21', 'bgpPeerKeepAliveConfigured', 6351, 'current', NULL, 'Time interval in seconds for the KeepAlive timer configured for this BGP speaker with this peer. The value of this object will only determine the KEEPALIVE messages'' frequency relative to the value specified in bgpPeerHoldTimeConfigured; the actual time interval for the KEEPALIVE messages is indicated by bgpPeerKeepAlive. A reasonable maximum value for this timer would be configured to be one third of that of bgpPeerHoldTimeConfigured. If the value of this object is zero (0), no periodical KEEPALIVE messages are sent to the peer after the BGP connection has been established. The suggested value for this timer is 30 seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6373, '.1.3.6.1.2.1.15.3.1.22', 'bgpPeerMinASOriginationInterval', 6351, 'current', NULL, 'Time interval in seconds for the MinASOriginationInterval timer. The suggested value for this timer is 15 seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6374, '.1.3.6.1.2.1.15.3.1.23', 'bgpPeerMinRouteAdvertisementInterval', 6351, 'current', NULL, 'Time interval in seconds for the MinRouteAdvertisementInterval timer. The suggested value for this timer is 30 seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6375, '.1.3.6.1.2.1.15.3.1.24', 'bgpPeerInUpdateElapsedTime', 6351, 'current', NULL, 'Elapsed time in seconds since the last BGP UPDATE message was received from the peer. Each time bgpPeerInUpdates is incremented, the value of this object is set to zero (0).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6687, '.1.3.6.1.4.1.9.2.2', 'linterfaces', 265, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6688, '.1.3.6.1.4.1.9.2.2.1', 'lifTable', 6687, 'mandatory', NULL, 'A list of interface entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6689, '.1.3.6.1.4.1.9.2.2.1.1', 'lifEntry', 6688, 'mandatory', NULL, 'A collection of additional objects in the cisco interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6690, '.1.3.6.1.4.1.9.2.2.1.1.1', 'locIfHardType', 6689, 'mandatory', NULL, 'Returns the type of interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6691, '.1.3.6.1.4.1.9.2.2.1.1.2', 'locIfLineProt', 6689, 'mandatory', NULL, 'Boolean whether interface line protocol is up or not.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6692, '.1.3.6.1.4.1.9.2.2.1.1.3', 'locIfLastIn', 6689, 'mandatory', NULL, 'Elapsed time in milliseconds since last line protocol input packet was received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6693, '.1.3.6.1.4.1.9.2.2.1.1.4', 'locIfLastOut', 6689, 'mandatory', NULL, 'Elapsed time in milliseconds since last line protocol output packet was transmitted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6694, '.1.3.6.1.4.1.9.2.2.1.1.5', 'locIfLastOutHang', 6689, 'mandatory', NULL, 'Elapsed time in milliseconds since last line protocol output packet could not be successfully transmitted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6695, '.1.3.6.1.4.1.9.2.2.1.1.6', 'locIfInBitsSec', 6689, 'mandatory', NULL, 'Five minute exponentially-decayed moving average of input bits per second.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6696, '.1.3.6.1.4.1.9.2.2.1.1.7', 'locIfInPktsSec', 6689, 'mandatory', NULL, 'Five minute exponentially-decayed moving average of input packets per second.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6697, '.1.3.6.1.4.1.9.2.2.1.1.8', 'locIfOutBitsSec', 6689, 'mandatory', NULL, 'Five minute exponentially-decayed moving average of output bits per second.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6698, '.1.3.6.1.4.1.9.2.2.1.1.9', 'locIfOutPktsSec', 6689, 'mandatory', NULL, 'Five minute exponentially-decayed moving average of output packets per second.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6699, '.1.3.6.1.4.1.9.2.2.1.1.10', 'locIfInRunts', 6689, 'mandatory', NULL, 'Number of packets input which were smaller then the allowable physical media permitted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6700, '.1.3.6.1.4.1.9.2.2.1.1.11', 'locIfInGiants', 6689, 'mandatory', NULL, 'Number of input packets which were larger then the physical media permitted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6701, '.1.3.6.1.4.1.9.2.2.1.1.12', 'locIfInCRC', 6689, 'mandatory', NULL, 'Number of input packets which had cyclic redundancy checksum errors.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6702, '.1.3.6.1.4.1.9.2.2.1.1.13', 'locIfInFrame', 6689, 'mandatory', NULL, 'Number of input packet which were misaligned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6703, '.1.3.6.1.4.1.9.2.2.1.1.14', 'locIfInOverrun', 6689, 'mandatory', NULL, 'Count of input which arrived too quickly for the to hardware receive.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6704, '.1.3.6.1.4.1.9.2.2.1.1.15', 'locIfInIgnored', 6689, 'mandatory', NULL, 'Number of input packets which were simply ignored by this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6705, '.1.3.6.1.4.1.9.2.2.1.1.16', 'locIfInAbort', 6689, 'mandatory', NULL, 'Number of input packets which were aborted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6706, '.1.3.6.1.4.1.9.2.2.1.1.17', 'locIfResets', 6689, 'mandatory', NULL, 'Number of times the interface internally reset.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6707, '.1.3.6.1.4.1.9.2.2.1.1.18', 'locIfRestarts', 6689, 'mandatory', NULL, 'Number of times interface needed to be completely restarted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6708, '.1.3.6.1.4.1.9.2.2.1.1.19', 'locIfKeep', 6689, 'mandatory', NULL, 'Boolean whether keepalives are enabled on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6709, '.1.3.6.1.4.1.9.2.2.1.1.20', 'locIfReason', 6689, 'mandatory', NULL, 'Reason for interface last status change.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6710, '.1.3.6.1.4.1.9.2.2.1.1.21', 'locIfCarTrans', 6689, 'mandatory', NULL, 'Number of times interface saw the carrier signal transition.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6711, '.1.3.6.1.4.1.9.2.2.1.1.22', 'locIfReliab', 6689, 'mandatory', NULL, 'The reliability of the interface. Used by IGRP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6712, '.1.3.6.1.4.1.9.2.2.1.1.23', 'locIfDelay', 6689, 'mandatory', NULL, 'The amount of delay in microseconds of the interface. Used by IGRP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6713, '.1.3.6.1.4.1.9.2.2.1.1.24', 'locIfLoad', 6689, 'mandatory', NULL, 'The loading factor of the interface. Used by IGRP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6714, '.1.3.6.1.4.1.9.2.2.1.1.25', 'locIfCollisions', 6689, 'mandatory', NULL, 'The number of output collisions detected on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6715, '.1.3.6.1.4.1.9.2.2.1.1.26', 'locIfInputQueueDrops', 6689, 'mandatory', NULL, 'The number of packets dropped because the input queue was full.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6719, '.1.3.6.1.4.1.9.2.2.1.1.31', 'locIfSlowOutPkts', 6689, 'mandatory', NULL, 'Packet count for Outbound traffic routed with slow switching', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6720, '.1.3.6.1.4.1.9.2.2.1.1.32', 'locIfSlowInOctets', 6689, 'mandatory', NULL, 'Octet count for Inbound traffic routed with slow switching', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6721, '.1.3.6.1.4.1.9.2.2.1.1.33', 'locIfSlowOutOctets', 6689, 'mandatory', NULL, 'Octet count for Outbound traffic routed with slow switching', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6722, '.1.3.6.1.4.1.9.2.2.1.1.34', 'locIfFastInPkts', 6689, 'mandatory', NULL, 'Packet count for Inbound traffic routed with fast switching', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6723, '.1.3.6.1.4.1.9.2.2.1.1.35', 'locIfFastOutPkts', 6689, 'mandatory', NULL, 'Packet count for Outbound traffic routed with fast switching', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6724, '.1.3.6.1.4.1.9.2.2.1.1.36', 'locIfFastInOctets', 6689, 'mandatory', NULL, 'Octet count for Inbound traffic routed with fast switching', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6725, '.1.3.6.1.4.1.9.2.2.1.1.37', 'locIfFastOutOctets', 6689, 'mandatory', NULL, 'Octet count for Outbound traffic routed with fast switching', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6726, '.1.3.6.1.4.1.9.2.2.1.1.38', 'locIfotherInPkts', 6689, 'mandatory', NULL, 'Other protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6727, '.1.3.6.1.4.1.9.2.2.1.1.39', 'locIfotherOutPkts', 6689, 'mandatory', NULL, 'Other protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6728, '.1.3.6.1.4.1.9.2.2.1.1.40', 'locIfotherInOctets', 6689, 'mandatory', NULL, 'Other protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6729, '.1.3.6.1.4.1.9.2.2.1.1.41', 'locIfotherOutOctets', 6689, 'mandatory', NULL, 'Other protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6730, '.1.3.6.1.4.1.9.2.2.1.1.42', 'locIfipInPkts', 6689, 'mandatory', NULL, 'ip protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6731, '.1.3.6.1.4.1.9.2.2.1.1.43', 'locIfipOutPkts', 6689, 'mandatory', NULL, 'ip protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6732, '.1.3.6.1.4.1.9.2.2.1.1.44', 'locIfipInOctets', 6689, 'mandatory', NULL, 'ip protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6733, '.1.3.6.1.4.1.9.2.2.1.1.45', 'locIfipOutOctets', 6689, 'mandatory', NULL, 'ip protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6734, '.1.3.6.1.4.1.9.2.2.1.1.46', 'locIfdecnetInPkts', 6689, 'mandatory', NULL, 'Decnet protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6735, '.1.3.6.1.4.1.9.2.2.1.1.47', 'locIfdecnetOutPkts', 6689, 'mandatory', NULL, 'Decnet protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6736, '.1.3.6.1.4.1.9.2.2.1.1.48', 'locIfdecnetInOctets', 6689, 'mandatory', NULL, 'Decnet protocol input byte count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6737, '.1.3.6.1.4.1.9.2.2.1.1.49', 'locIfdecnetOutOctets', 6689, 'mandatory', NULL, 'Decnet protocol output byte count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6738, '.1.3.6.1.4.1.9.2.2.1.1.50', 'locIfxnsInPkts', 6689, 'mandatory', NULL, 'XNS protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6739, '.1.3.6.1.4.1.9.2.2.1.1.51', 'locIfxnsOutPkts', 6689, 'mandatory', NULL, 'XNS protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6740, '.1.3.6.1.4.1.9.2.2.1.1.52', 'locIfxnsInOctets', 6689, 'mandatory', NULL, 'XNS protocol input byte count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6741, '.1.3.6.1.4.1.9.2.2.1.1.53', 'locIfxnsOutOctets', 6689, 'mandatory', NULL, 'XNS protocol output byte count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6742, '.1.3.6.1.4.1.9.2.2.1.1.54', 'locIfclnsInPkts', 6689, 'mandatory', NULL, 'CLNS protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6743, '.1.3.6.1.4.1.9.2.2.1.1.55', 'locIfclnsOutPkts', 6689, 'mandatory', NULL, 'CLNS protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6744, '.1.3.6.1.4.1.9.2.2.1.1.56', 'locIfclnsInOctets', 6689, 'mandatory', NULL, 'CLNS protocol input byte count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6745, '.1.3.6.1.4.1.9.2.2.1.1.57', 'locIfclnsOutOctets', 6689, 'mandatory', NULL, 'CLNS protocol output byte count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6746, '.1.3.6.1.4.1.9.2.2.1.1.58', 'locIfappletalkInPkts', 6689, 'mandatory', NULL, 'Appletalk protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6747, '.1.3.6.1.4.1.9.2.2.1.1.59', 'locIfappletalkOutPkts', 6689, 'mandatory', NULL, 'Appletalk protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6748, '.1.3.6.1.4.1.9.2.2.1.1.60', 'locIfappletalkInOctets', 6689, 'mandatory', NULL, 'Appletalk protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6749, '.1.3.6.1.4.1.9.2.2.1.1.61', 'locIfappletalkOutOctets', 6689, 'mandatory', NULL, 'Appletalk protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6750, '.1.3.6.1.4.1.9.2.2.1.1.62', 'locIfnovellInPkts', 6689, 'mandatory', NULL, 'Novell protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6751, '.1.3.6.1.4.1.9.2.2.1.1.63', 'locIfnovellOutPkts', 6689, 'mandatory', NULL, 'Novell protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6752, '.1.3.6.1.4.1.9.2.2.1.1.64', 'locIfnovellInOctets', 6689, 'mandatory', NULL, 'Novell protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6753, '.1.3.6.1.4.1.9.2.2.1.1.65', 'locIfnovellOutOctets', 6689, 'mandatory', NULL, 'Novell protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6754, '.1.3.6.1.4.1.9.2.2.1.1.66', 'locIfapolloInPkts', 6689, 'mandatory', NULL, 'Apollo protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6755, '.1.3.6.1.4.1.9.2.2.1.1.67', 'locIfapolloOutPkts', 6689, 'mandatory', NULL, 'Apollo protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6756, '.1.3.6.1.4.1.9.2.2.1.1.68', 'locIfapolloInOctets', 6689, 'mandatory', NULL, 'Apollo protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6757, '.1.3.6.1.4.1.9.2.2.1.1.69', 'locIfapolloOutOctets', 6689, 'mandatory', NULL, 'Apollo protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6758, '.1.3.6.1.4.1.9.2.2.1.1.70', 'locIfvinesInPkts', 6689, 'mandatory', NULL, 'Vines protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6759, '.1.3.6.1.4.1.9.2.2.1.1.71', 'locIfvinesOutPkts', 6689, 'mandatory', NULL, 'Vines protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6760, '.1.3.6.1.4.1.9.2.2.1.1.72', 'locIfvinesInOctets', 6689, 'mandatory', NULL, 'Vines protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6761, '.1.3.6.1.4.1.9.2.2.1.1.73', 'locIfvinesOutOctets', 6689, 'mandatory', NULL, 'Vines protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6762, '.1.3.6.1.4.1.9.2.2.1.1.74', 'locIfbridgedInPkts', 6689, 'mandatory', NULL, 'Bridged protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6763, '.1.3.6.1.4.1.9.2.2.1.1.75', 'locIfbridgedOutPkts', 6689, 'mandatory', NULL, 'Bridged protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6764, '.1.3.6.1.4.1.9.2.2.1.1.76', 'locIfbridgedInOctets', 6689, 'mandatory', NULL, 'Bridged protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6765, '.1.3.6.1.4.1.9.2.2.1.1.77', 'locIfbridgedOutOctets', 6689, 'mandatory', NULL, 'Bridged protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6766, '.1.3.6.1.4.1.9.2.2.1.1.78', 'locIfsrbInPkts', 6689, 'mandatory', NULL, 'SRB protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6767, '.1.3.6.1.4.1.9.2.2.1.1.79', 'locIfsrbOutPkts', 6689, 'mandatory', NULL, 'SRB protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6768, '.1.3.6.1.4.1.9.2.2.1.1.80', 'locIfsrbInOctets', 6689, 'mandatory', NULL, 'SRB protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6769, '.1.3.6.1.4.1.9.2.2.1.1.81', 'locIfsrbOutOctets', 6689, 'mandatory', NULL, 'SRB protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6770, '.1.3.6.1.4.1.9.2.2.1.1.82', 'locIfchaosInPkts', 6689, 'mandatory', NULL, 'Choas protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6771, '.1.3.6.1.4.1.9.2.2.1.1.83', 'locIfchaosOutPkts', 6689, 'mandatory', NULL, 'Choas protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6772, '.1.3.6.1.4.1.9.2.2.1.1.84', 'locIfchaosInOctets', 6689, 'mandatory', NULL, 'Choas protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6773, '.1.3.6.1.4.1.9.2.2.1.1.85', 'locIfchaosOutOctets', 6689, 'mandatory', NULL, 'Choas protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6774, '.1.3.6.1.4.1.9.2.2.1.1.86', 'locIfpupInPkts', 6689, 'mandatory', NULL, 'PUP protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6775, '.1.3.6.1.4.1.9.2.2.1.1.87', 'locIfpupOutPkts', 6689, 'mandatory', NULL, 'PUP protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6776, '.1.3.6.1.4.1.9.2.2.1.1.88', 'locIfpupInOctets', 6689, 'mandatory', NULL, 'PUP protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6777, '.1.3.6.1.4.1.9.2.2.1.1.89', 'locIfpupOutOctets', 6689, 'mandatory', NULL, 'PUP protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6778, '.1.3.6.1.4.1.9.2.2.1.1.90', 'locIfmopInPkts', 6689, 'mandatory', NULL, 'MOP protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6779, '.1.3.6.1.4.1.9.2.2.1.1.91', 'locIfmopOutPkts', 6689, 'mandatory', NULL, 'MOP protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6787, '.1.3.6.1.4.1.9.2.2.1.1.99', 'locIfstunOutPkts', 6689, 'mandatory', NULL, 'STUN protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6788, '.1.3.6.1.4.1.9.2.2.1.1.100', 'locIfstunInOctets', 6689, 'mandatory', NULL, 'STUN protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6789, '.1.3.6.1.4.1.9.2.2.1.1.101', 'locIfstunOutOctets', 6689, 'mandatory', NULL, 'STUN protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6790, '.1.3.6.1.4.1.9.2.2.1.1.102', 'locIfspanInPkts', 6689, 'mandatory', NULL, 'Spanning tree input protocol packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6791, '.1.3.6.1.4.1.9.2.2.1.1.103', 'locIfspanOutPkts', 6689, 'mandatory', NULL, 'Spanning tree output protocol packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6792, '.1.3.6.1.4.1.9.2.2.1.1.104', 'locIfspanInOctets', 6689, 'mandatory', NULL, 'Spanning tree input octet packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6793, '.1.3.6.1.4.1.9.2.2.1.1.105', 'locIfspanOutOctets', 6689, 'mandatory', NULL, 'Spanning tree output octet packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6794, '.1.3.6.1.4.1.9.2.2.1.1.106', 'locIfarpInPkts', 6689, 'mandatory', NULL, 'Arp protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6795, '.1.3.6.1.4.1.9.2.2.1.1.107', 'locIfarpOutPkts', 6689, 'mandatory', NULL, 'Arp protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6796, '.1.3.6.1.4.1.9.2.2.1.1.108', 'locIfarpInOctets', 6689, 'mandatory', NULL, 'Arp protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6797, '.1.3.6.1.4.1.9.2.2.1.1.109', 'locIfarpOutOctets', 6689, 'mandatory', NULL, 'Arp protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6798, '.1.3.6.1.4.1.9.2.2.1.1.110', 'locIfprobeInPkts', 6689, 'mandatory', NULL, 'Probe protocol input packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6799, '.1.3.6.1.4.1.9.2.2.1.1.111', 'locIfprobeOutPkts', 6689, 'mandatory', NULL, 'Probe protocol output packet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6800, '.1.3.6.1.4.1.9.2.2.1.1.112', 'locIfprobeInOctets', 6689, 'mandatory', NULL, 'Probe protocol input octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6801, '.1.3.6.1.4.1.9.2.2.1.1.113', 'locIfprobeOutOctets', 6689, 'mandatory', NULL, 'Probe protocol output octet count', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6802, '.1.3.6.1.4.1.9.2.2.1.1.114', 'locIfDribbleInputs', 6689, 'mandatory', NULL, 'The number of good packets received with the dribble condition present', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6803, '.1.3.6.1.4.1.9.2.2.2', 'lFSIPTable', 6687, 'mandatory', NULL, 'A list of card entries for 4T, HSSI, Mx serial or FSIP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6804, '.1.3.6.1.4.1.9.2.2.2.1', 'lFSIPEntry', 6803, 'mandatory', NULL, 'A collection of objects specific to 4T, HSSI, Mx serial or FSIP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6805, '.1.3.6.1.4.1.9.2.2.2.1.1', 'locIfFSIPIndex', 6804, 'mandatory', NULL, 'Interface index of this card corresponding to its ifIndex', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6806, '.1.3.6.1.4.1.9.2.2.2.1.2', 'locIfFSIPtype', 6804, 'mandatory', NULL, 'Is this FSIP line DCE or DTE', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6807, '.1.3.6.1.4.1.9.2.2.2.1.3', 'locIfFSIPrts', 6804, 'mandatory', NULL, 'Is the RTS signal up or down', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6808, '.1.3.6.1.4.1.9.2.2.2.1.4', 'locIfFSIPcts', 6804, 'mandatory', NULL, 'Is the CTS signal up or down', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6809, '.1.3.6.1.4.1.9.2.2.2.1.5', 'locIfFSIPdtr', 6804, 'mandatory', NULL, 'Is the DTR signal up or down', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6810, '.1.3.6.1.4.1.9.2.2.2.1.6', 'locIfFSIPdcd', 6804, 'mandatory', NULL, 'Is the DCD signal up or down', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6811, '.1.3.6.1.4.1.9.2.2.2.1.7', 'locIfFSIPdsr', 6804, 'mandatory', NULL, 'Is the DSR signal up or down', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6812, '.1.3.6.1.4.1.9.2.2.2.1.8', 'locIfFSIPrxClockrate', 6804, 'mandatory', NULL, 'Received clock rate', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6813, '.1.3.6.1.4.1.9.2.2.2.1.9', 'locIfFSIPrxClockrateHi', 6804, 'mandatory', NULL, 'Use when received clock rate is greater than 2^32 (gigabits).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6814, '.1.3.6.1.4.1.9.2.2.2.1.10', 'locIfFSIPportType', 6804, 'mandatory', NULL, 'Cable Type of 4T, HSSI, Mx serial or FSIP', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6829, '.1.3.6.1.4.1.9.9.156', 'ciscoCcmMIB', 272, 'current', NULL, 'The MIB Module for the management of a Cisco Unified Communications Manager (CUCM) application running with a Cisco Communication Network (CCN) System. CUCM is an IP-PBX which controls the call processing of a Voice Over IP (VoIP) network. A CCN system comprises multiple regions, with each region consisting of several CUCM groups with multiple CUCMs. The MIB can be used by the CUCM Application to present Provision and statistics information.  Terminology:  CUCM: Cisco Unified Communications Manager SCCP: Skinny Client Control Protocol SIP: Session Initiation Protocol TLS: Transport Layer Security MGCP: Media Gateway Control Protocol EM: Extension Mobility EMCC: Extension Mobility Cross Cluster', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6830, '.1.3.6.1.4.1.9.9.156.1', 'ciscoCcmMIBObjects', 6829, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6831, '.1.3.6.1.4.1.9.9.156.1.1', 'ccmGeneralInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6832, '.1.3.6.1.4.1.9.9.156.1.2', 'ccmPhoneInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6833, '.1.3.6.1.4.1.9.9.156.1.3', 'ccmGatewayInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6834, '.1.3.6.1.4.1.9.9.156.1.4', 'ccmGatewayTrunkInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6835, '.1.3.6.1.4.1.9.9.156.1.5', 'ccmGlobalInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6836, '.1.3.6.1.4.1.9.9.156.1.6', 'ccmMediaDeviceInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6837, '.1.3.6.1.4.1.9.9.156.1.7', 'ccmGatekeeperInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6838, '.1.3.6.1.4.1.9.9.156.1.8', 'ccmCTIDeviceInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6839, '.1.3.6.1.4.1.9.9.156.1.9', 'ccmAlarmConfigInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6840, '.1.3.6.1.4.1.9.9.156.1.10', 'ccmNotificationsInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6841, '.1.3.6.1.4.1.9.9.156.1.11', 'ccmH323DeviceInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6842, '.1.3.6.1.4.1.9.9.156.1.12', 'ccmVoiceMailDeviceInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6843, '.1.3.6.1.4.1.9.9.156.1.13', 'ccmQualityReportAlarmConfigInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6844, '.1.3.6.1.4.1.9.9.156.1.14', 'ccmSIPDeviceInfo', 6830, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6845, '.1.3.6.1.4.1.9.9.156.1.1.1', 'ccmGroupTable', 6831, 'current', NULL, 'The table containing the CallManager groups in a call manager cluster.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6846, '.1.3.6.1.4.1.9.9.156.1.1.1.1', 'ccmGroupEntry', 6845, 'current', NULL, 'An entry (conceptual row) in the CallManager Group table, containing the information about a CallManager group in a call manager cluster. An entry is created to represent a CallManager Group. New entries to the CallManager Group table in the database are created when the User inserts a new CallManager Group via the CallManager Web Admin pages. This entry is subsequently picked up by the CUCM SNMP Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6847, '.1.3.6.1.4.1.9.9.156.1.1.1.1.1', 'ccmGroupIndex', 6846, 'current', NULL, 'An arbitrary integer, selected by the local CUCM which uniquely identifies a CallManager Group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6848, '.1.3.6.1.4.1.9.9.156.1.1.1.1.2', 'ccmGroupName', 6846, 'current', NULL, 'The name of the CallManager Group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6849, '.1.3.6.1.4.1.9.9.156.1.1.1.1.3', 'ccmGroupTftpDefault', 6846, 'current', NULL, 'Whether this is the default TFTP server group or not.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6850, '.1.3.6.1.4.1.9.9.156.1.1.2', 'ccmTable', 6831, 'current', NULL, 'The table containing information of all the CUCMs in a CUCM cluster that the local CUCM knows about. When the local CUCM is restarted, this table will be refreshed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6851, '.1.3.6.1.4.1.9.9.156.1.1.2.1', 'ccmEntry', 6850, 'current', NULL, 'An entry (conceptual row) in the CallManager table, containing the information about a CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6852, '.1.3.6.1.4.1.9.9.156.1.1.2.1.1', 'ccmIndex', 6851, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which uniquely identifies a CallManager in a call manager cluster.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6853, '.1.3.6.1.4.1.9.9.156.1.1.2.1.2', 'ccmName', 6851, 'current', NULL, 'The host name of the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6854, '.1.3.6.1.4.1.9.9.156.1.1.2.1.3', 'ccmDescription', 6851, 'current', NULL, 'The description for the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6855, '.1.3.6.1.4.1.9.9.156.1.1.2.1.4', 'ccmVersion', 6851, 'current', NULL, 'The version number of the CallManager software.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6891, '.1.3.6.1.4.1.9.9.156.1.1.8.1.2', 'ccmProductType', 6889, 'current', NULL, 'The type of the product as defined in the CUCM database.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6856, '.1.3.6.1.4.1.9.9.156.1.1.2.1.5', 'ccmStatus', 6851, 'current', NULL, 'The current status of the CallManager. A CallManager is up if the SNMP Agent received a system up event from the local CUCM unknown: Current status of the CallManager is Unknown up: CallManager is running & is able to communicate with other CallManagers down: CallManager is down or the Agent is unable to communicate with the local CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6857, '.1.3.6.1.4.1.9.9.156.1.1.2.1.6', 'ccmInetAddressType', 6851, 'current', NULL, 'This object identifies IP address type of the Cisco Call Manager defined in ccmInetAddress.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6858, '.1.3.6.1.4.1.9.9.156.1.1.2.1.7', 'ccmInetAddress', 6851, 'current', NULL, 'This object identifies IP address of the Cisco Call Manager. The type of address for this is identified by ccmInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6859, '.1.3.6.1.4.1.9.9.156.1.1.2.1.8', 'ccmClusterId', 6851, 'current', NULL, 'The unique ID of the Cluster to which this CallManager belongs. At any point in time, the Cluster Id helps in associating a CallManager to any given Cluster.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6860, '.1.3.6.1.4.1.9.9.156.1.1.2.1.9', 'ccmInetAddress2Type', 6851, 'current', NULL, 'This object identifies IP address type of the Cisco Unified Communications Manager defined in ccmInetAddress2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6861, '.1.3.6.1.4.1.9.9.156.1.1.2.1.10', 'ccmInetAddress2', 6851, 'current', NULL, 'This object identifies the additional IP(v4/v6) address details of Cisco Unified Communications Manager. The type of address for this object is identified by ccmInetAddress2Type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6862, '.1.3.6.1.4.1.9.9.156.1.1.3', 'ccmGroupMappingTable', 6831, 'current', NULL, 'The table containing the list of all CallManager to group mappings in a call manager cluster. When the local call manager is down, this table will be empty.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6863, '.1.3.6.1.4.1.9.9.156.1.1.3.1', 'ccmGroupMappingEntry', 6862, 'current', NULL, 'An entry (conceptual row) in the CallManager group Mapping table, containing the information about a mapping between a CallManager and a CallManager group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6864, '.1.3.6.1.4.1.9.9.156.1.1.3.1.1', 'ccmCMGroupMappingCMPriority', 6863, 'current', NULL, 'The priority of the CallManager in the group. Sets the order of the CallManager in the list.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6865, '.1.3.6.1.4.1.9.9.156.1.1.4', 'ccmRegionTable', 6831, 'current', NULL, 'The table containing the list of all geographically separated regions in a CCN system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6866, '.1.3.6.1.4.1.9.9.156.1.1.4.1', 'ccmRegionEntry', 6865, 'current', NULL, 'An entry (conceptual row) in the Region Table, containing the information about a region.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6867, '.1.3.6.1.4.1.9.9.156.1.1.4.1.1', 'ccmRegionIndex', 6866, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which uniquely identifies a Region Name in the table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6868, '.1.3.6.1.4.1.9.9.156.1.1.4.1.2', 'ccmRegionName', 6866, 'current', NULL, 'The name of the CallManager region.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6869, '.1.3.6.1.4.1.9.9.156.1.1.5', 'ccmRegionPairTable', 6831, 'current', NULL, 'The table containing the list of all geographical region pairs defined for a call manager cluster. The pair consists of the Source region and Destination region.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6870, '.1.3.6.1.4.1.9.9.156.1.1.5.1', 'ccmRegionPairEntry', 6869, 'current', NULL, 'An entry (conceptual row) in the Region Pair Table, containing the information about bandwidth restrictions when communicating between the two specified regions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6871, '.1.3.6.1.4.1.9.9.156.1.1.5.1.1', 'ccmRegionSrcIndex', 6870, 'current', NULL, 'The index of the Source Region in the Region table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6872, '.1.3.6.1.4.1.9.9.156.1.1.5.1.2', 'ccmRegionDestIndex', 6870, 'current', NULL, 'The index of the Destination Region in the Region table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6873, '.1.3.6.1.4.1.9.9.156.1.1.5.1.3', 'ccmRegionAvailableBandWidth', 6870, 'current', NULL, 'The maximum available bandwidth between the two given regions. unknown: Unknown Bandwidth other: Unidentified Bandwidth bwG723: For low bandwidth using G.723 codec bwG729: For low bandwidth using G.729 codec bwG711: For high bandwidth using G.711 codec bwGSM: For GSM bandwidth 13K bwWideband: For Wideband 256K.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6874, '.1.3.6.1.4.1.9.9.156.1.1.6', 'ccmTimeZoneTable', 6831, 'current', NULL, 'The table containing the list of all time zone groups in a call manager cluster.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6875, '.1.3.6.1.4.1.9.9.156.1.1.6.1', 'ccmTimeZoneEntry', 6874, 'current', NULL, 'An entry (conceptual row) in the time zone Table, containing the information about a particular time zone group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6876, '.1.3.6.1.4.1.9.9.156.1.1.6.1.1', 'ccmTimeZoneIndex', 6875, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which uniquely identifies a Time Zone group entry in the table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6877, '.1.3.6.1.4.1.9.9.156.1.1.6.1.2', 'ccmTimeZoneName', 6875, 'current', NULL, 'The name of the time zone group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6878, '.1.3.6.1.4.1.9.9.156.1.1.6.1.3', 'ccmTimeZoneOffset', 6875, 'obsolete', NULL, 'The offset of the time zone group''s time zone from GMT.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6879, '.1.3.6.1.4.1.9.9.156.1.1.6.1.4', 'ccmTimeZoneOffsetHours', 6875, 'current', NULL, 'The offset hours of the time zone group''s time zone from GMT.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6880, '.1.3.6.1.4.1.9.9.156.1.1.6.1.5', 'ccmTimeZoneOffsetMinutes', 6875, 'current', NULL, 'The offset minutes of the time zone group''s time zone from GMT.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6881, '.1.3.6.1.4.1.9.9.156.1.1.7', 'ccmDevicePoolTable', 6831, 'current', NULL, 'The table containing the list of all device pools in a call manager cluster. A Device Pool contains Region, Date/Time Group and CallManager Group criteria that will be common among many devices.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6882, '.1.3.6.1.4.1.9.9.156.1.1.7.1', 'ccmDevicePoolEntry', 6881, 'current', NULL, 'An entry (conceptual row) in the device pool Table, containing the information about a particular device pool.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6883, '.1.3.6.1.4.1.9.9.156.1.1.7.1.1', 'ccmDevicePoolIndex', 6882, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which uniquely identifies a Device Pool entry in the table. Each entry contains Region, Date/Time Group and CallManager Group criteria that will be common among many devices, for that entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6884, '.1.3.6.1.4.1.9.9.156.1.1.7.1.2', 'ccmDevicePoolName', 6882, 'current', NULL, 'The name of the device pool.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6885, '.1.3.6.1.4.1.9.9.156.1.1.7.1.3', 'ccmDevicePoolRegionIndex', 6882, 'current', NULL, 'A positive value of this index is used to identify the Region to which this Device Pool entry belongs. A value of 0 indicates that the index to the Region table is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6886, '.1.3.6.1.4.1.9.9.156.1.1.7.1.4', 'ccmDevicePoolTimeZoneIndex', 6882, 'current', NULL, 'A positive value of this index is used to identify the TimeZone to which this Device Pool entry belongs. A value of 0 indicates that the index to the TimeZone table is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6887, '.1.3.6.1.4.1.9.9.156.1.1.7.1.5', 'ccmDevicePoolGroupIndex', 6882, 'current', NULL, 'A positive value of this index is used to identify the CallManager Group to which this Device Pool entry belongs. A value of 0 indicates that the index to the CallManager Group table is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6888, '.1.3.6.1.4.1.9.9.156.1.1.8', 'ccmProductTypeTable', 6831, 'current', NULL, 'The table containing the list of product types supported in a call manager cluster. The product types will include the list of phone types, gateway types, media device types, H323 device types, CTI device types, Voice Messaging device types and SIP device types.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6889, '.1.3.6.1.4.1.9.9.156.1.1.8.1', 'ccmProductTypeEntry', 6888, 'current', NULL, 'An entry (conceptual row) in the ccmProductTypeTable, containing the information about a product type supported in a call manager cluster. An entry is created to represent a product type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6890, '.1.3.6.1.4.1.9.9.156.1.1.8.1.1', 'ccmProductTypeIndex', 6889, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which uniquely identifies an entry in the ccmProductTypeTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6892, '.1.3.6.1.4.1.9.9.156.1.1.8.1.3', 'ccmProductName', 6889, 'current', NULL, 'The name of the product as defined in the CUCM database.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6893, '.1.3.6.1.4.1.9.9.156.1.1.8.1.4', 'ccmProductCategory', 6889, 'current', NULL, 'The category of the product. unknown: Unknown product category notApplicable: Not Applicable phone: Phone gateway: Gateway h323Device: H323 Device ctiDevice: CTI Device voiceMailDevice: Voice Messaging Device mediaResourceDevice: Media Resource Device huntListDevice: Hunt List Device sipDevice: SIP Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6894, '.1.3.6.1.4.1.9.9.156.1.2.1', 'ccmPhoneTable', 6832, 'current', NULL, 'The table containing the list of all IP Phone devices which have tried to register with the local CUCM at least once. When the local CUCM is restarted, this table will be refreshed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6895, '.1.3.6.1.4.1.9.9.156.1.2.1.1', 'ccmPhoneEntry', 6894, 'current', NULL, 'An entry (conceptual row) in the phone Table, containing information about a particular phone device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6896, '.1.3.6.1.4.1.9.9.156.1.2.1.1.1', 'ccmPhoneIndex', 6895, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which uniquely identifies a Phone within the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6897, '.1.3.6.1.4.1.9.9.156.1.2.1.1.2', 'ccmPhonePhysicalAddress', 6895, 'current', NULL, 'The physical address(MAC address) of the IP phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6898, '.1.3.6.1.4.1.9.9.156.1.2.1.1.3', 'ccmPhoneType', 6895, 'obsolete', NULL, 'The type of the phone device. unknown: Unknown phone type other: Unidentified phone type cisco30SPplus: IP Phone 30 SP+ cisco12SPplus: IP Phone 12 SP+ cisco12SP: IP Phone 12 SP cisco12S: IP Phone 12 S cisco30VIP: IP Phone 30 VIP ciscoTeleCasterBid: IP Phone Telecaster 7910 ciscoTeleCasterMgr: IP Phone Telecaster 7960 ciscoTeleCasterBusiness: IP Phone Telecaster 7940 ciscoSoftPhone: Softphone ciscoConferencePhone: IP Conference Station 7935 cisco7902: IP Phone 7902 cisco7905: IP Phone 7905 cisco7912: IP Phone 7912 cisco7970: IP Phone 7970.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6899, '.1.3.6.1.4.1.9.9.156.1.2.1.1.4', 'ccmPhoneDescription', 6895, 'current', NULL, 'The description about the phone itself.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6900, '.1.3.6.1.4.1.9.9.156.1.2.1.1.5', 'ccmPhoneUserName', 6895, 'current', NULL, 'The name of the user of the phone. When the phone is not in use, the name would refer to the last known user of the phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6901, '.1.3.6.1.4.1.9.9.156.1.2.1.1.6', 'ccmPhoneIpAddress', 6895, 'obsolete', NULL, 'The last known IP address of the phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6902, '.1.3.6.1.4.1.9.9.156.1.2.1.1.7', 'ccmPhoneStatus', 6895, 'current', NULL, 'The status of the phone. The status of the Phone changes from Unknown to registered when it registers itself with the local CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6903, '.1.3.6.1.4.1.9.9.156.1.2.1.1.8', 'ccmPhoneTimeLastRegistered', 6895, 'current', NULL, 'The time when the phone last registered with the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6904, '.1.3.6.1.4.1.9.9.156.1.2.1.1.9', 'ccmPhoneE911Location', 6895, 'current', NULL, 'The E911 location of the phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6905, '.1.3.6.1.4.1.9.9.156.1.2.1.1.10', 'ccmPhoneLoadID', 6895, 'current', NULL, 'This object identifies the configured load ID for the phone device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6906, '.1.3.6.1.4.1.9.9.156.1.2.1.1.11', 'ccmPhoneLastError', 6895, 'obsolete', NULL, 'A positive value or 0 indicates the last error reported by the phone. A value of -1 indicates that the last error reported is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6907, '.1.3.6.1.4.1.9.9.156.1.2.1.1.12', 'ccmPhoneTimeLastError', 6895, 'obsolete', NULL, 'The amount of time elapsed since the last phone error occurred. The reference point for this time is the time the last error occurred, as reported by the local CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6908, '.1.3.6.1.4.1.9.9.156.1.2.1.1.13', 'ccmPhoneDevicePoolIndex', 6895, 'current', NULL, 'A positive value of this index is used to identify the Device Pool to which this Phone entry belongs. A value of 0 indicates that the index to the Device Pool table is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6909, '.1.3.6.1.4.1.9.9.156.1.2.1.1.14', 'ccmPhoneInetAddressType', 6895, 'deprecated', NULL, 'This object identifies the IP address type of the phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6910, '.1.3.6.1.4.1.9.9.156.1.2.1.1.15', 'ccmPhoneInetAddress', 6895, 'deprecated', NULL, 'This object identifies the last known IP address of the phone. The type of address for this is identified by ccmPhoneInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6911, '.1.3.6.1.4.1.9.9.156.1.2.1.1.16', 'ccmPhoneStatusReason', 6895, 'deprecated', NULL, 'The reason code associated with the phone status change.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6912, '.1.3.6.1.4.1.9.9.156.1.2.1.1.17', 'ccmPhoneTimeLastStatusUpdt', 6895, 'current', NULL, 'The time the status of the phone changed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6913, '.1.3.6.1.4.1.9.9.156.1.2.1.1.18', 'ccmPhoneProductTypeIndex', 6895, 'current', NULL, 'A positive value of this index is used to identify the related product type entry in the ccmProductTypeTable. A value of 0 indicates that the index to the ccmProductTypeTable is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6914, '.1.3.6.1.4.1.9.9.156.1.2.1.1.19', 'ccmPhoneProtocol', 6895, 'current', NULL, 'The protocol used between the phone and Cisco Call Manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6915, '.1.3.6.1.4.1.9.9.156.1.2.1.1.20', 'ccmPhoneName', 6895, 'current', NULL, 'The name of the phone. The name of the phone can be <prefix> + MAC Address, where <prefix> is SEP for Cisco SCCP and SIP Phones. In the case of other phones such as communicator (soft phone) it can be free-form name, a string which uniquely identifies the phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6916, '.1.3.6.1.4.1.9.9.156.1.2.1.1.21', 'ccmPhoneInetAddressIPv4', 6895, 'current', NULL, 'This object identifies the last known primary IPv4 address of the Phone Device. This object contains value zero if IPV4 address is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6917, '.1.3.6.1.4.1.9.9.156.1.2.1.1.22', 'ccmPhoneInetAddressIPv6', 6895, 'current', NULL, 'This object identifies the last known primary IPv6 address of the Phone device. This object contains value zero if IPV6 address is not available', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6918, '.1.3.6.1.4.1.9.9.156.1.2.1.1.23', 'ccmPhoneIPv4Attribute', 6895, 'current', NULL, 'This object identifies the scope of ccmPhoneInetAddressIPv4. unknown(0): It is not known if ccmPhoneInetAddressIPv4 is used for Administration purpose or Controlling purpose. adminOnly(1): ccmPhoneInetAddressIPv4 is used for the serviceability/administrative purpose. controlOnly(2): ccmPhoneInetAddressIPv4 is used for signaling/registration purpose. adminAndControl(3): ccmPhoneInetAddressIPv4 is used for controlling as well as administrative purpose.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6919, '.1.3.6.1.4.1.9.9.156.1.2.1.1.24', 'ccmPhoneIPv6Attribute', 6895, 'current', NULL, 'This object identifies the scope of ccmPhoneInetAddressIPv6. unknown(0): It is not known if ccmPhoneInetAddressIPv6 is used for Administration purpose or Controlling purpose. adminOnly(1): ccmPhoneInetAddressIPv6 is used for the serviceability/administrative purpose. controlOnly(2): ccmPhoneInetAddressIPv6 is used for signaling/registration purpose. adminAndControl(3):ccmPhoneInetAddressIPv6 is used for controlling as well as administrative purpose.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6920, '.1.3.6.1.4.1.9.9.156.1.2.1.1.25', 'ccmPhoneActiveLoadID', 6895, 'current', NULL, 'This object identifies the ID of actual load that is successfully loaded and running on the phone device. If the phone is successfully upgraded to the new load then ccmPhoneLoadID and ccmPhoneActiveLoadID will have same value. If the upgrade fails then the ccmPhoneLoadID has the configured load ID and ccmPhoneActiveLoadID has the actual load ID that is running on the phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6921, '.1.3.6.1.4.1.9.9.156.1.2.1.1.26', 'ccmPhoneUnregReason', 6895, 'current', NULL, 'The reason code associated with unregistered phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6922, '.1.3.6.1.4.1.9.9.156.1.2.1.1.27', 'ccmPhoneRegFailReason', 6895, 'current', NULL, 'The reason code associated with registration failed phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6923, '.1.3.6.1.4.1.9.9.156.1.2.2', 'ccmPhoneExtensionTable', 6832, 'obsolete', NULL, 'The table containing the list of all phone extensions associated with the registered and unregistered phones in the ccmPhoneTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6924, '.1.3.6.1.4.1.9.9.156.1.2.2.1', 'ccmPhoneExtensionEntry', 6923, 'obsolete', NULL, 'An entry (conceptual row) in the phone extension Table, containing the information about a particular phone extension.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6925, '.1.3.6.1.4.1.9.9.156.1.2.2.1.1', 'ccmPhoneExtensionIndex', 6924, 'obsolete', NULL, 'An arbitrary integer, selected by the local CUCM, which uniquely identifies a Phone Extension within the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6926, '.1.3.6.1.4.1.9.9.156.1.2.2.1.2', 'ccmPhoneExtension', 6924, 'obsolete', NULL, 'The extension number of the extension.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6927, '.1.3.6.1.4.1.9.9.156.1.2.2.1.3', 'ccmPhoneExtensionIpAddress', 6924, 'obsolete', NULL, 'The IP address of the extension.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6928, '.1.3.6.1.4.1.9.9.156.1.2.2.1.4', 'ccmPhoneExtensionMultiLines', 6924, 'obsolete', NULL, 'The number of multiline appearances for each phone extension.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6929, '.1.3.6.1.4.1.9.9.156.1.2.2.1.5', 'ccmPhoneExtensionInetAddressType', 6924, 'obsolete', NULL, 'Represents the type of address stored in ccmPhoneExtensionInetAddress.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6930, '.1.3.6.1.4.1.9.9.156.1.2.2.1.6', 'ccmPhoneExtensionInetAddress', 6924, 'obsolete', NULL, 'The IP address of the extension.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6931, '.1.3.6.1.4.1.9.9.156.1.2.3', 'ccmPhoneFailedTable', 6832, 'current', NULL, 'The table containing the list of all phones which attempted to register with the local call manager and failed. The entries which have not been updated and kept at least for the duration specified in the ccmPhoneFailedStorePeriod will be deleted. Reasons for these failures could be due to configuration error, maximum number of phones has been reached, lost contact, etc.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6932, '.1.3.6.1.4.1.9.9.156.1.2.3.1', 'ccmPhoneFailedEntry', 6931, 'current', NULL, 'An entry (conceptual row) in the PhoneFailed Table, one for each phone failure in the CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6933, '.1.3.6.1.4.1.9.9.156.1.2.3.1.1', 'ccmPhoneFailedIndex', 6932, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which is incremented with each new entry in the ccmPhoneFailedTable. This integer value will wrap if needed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6934, '.1.3.6.1.4.1.9.9.156.1.2.3.1.2', 'ccmPhoneFailedTime', 6932, 'current', NULL, 'The time when the phone failed to register with the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6935, '.1.3.6.1.4.1.9.9.156.1.2.3.1.3', 'ccmPhoneFailedName', 6932, 'obsolete', NULL, 'The name assigned to the phone when it is added to the CallManager. It contains an ASCII form of the phone''s MAC Address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6936, '.1.3.6.1.4.1.9.9.156.1.2.3.1.4', 'ccmPhoneFailedInetAddressType', 6932, 'deprecated', NULL, 'This object identifies the IP address type of the phone that is experiencing communication failure. The value of this object is ''unknown(0)'' if the IP address of a phone is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6937, '.1.3.6.1.4.1.9.9.156.1.2.3.1.5', 'ccmPhoneFailedInetAddress', 6932, 'deprecated', NULL, 'This object identifies the last known IP address of the phone experiencing a communication failure. If the IP address of a device is not available then this object contains an empty string. The type of address for this is identified by ccmPhoneFailedInetAddressType', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6938, '.1.3.6.1.4.1.9.9.156.1.2.3.1.6', 'ccmPhoneFailCauseCode', 6932, 'deprecated', NULL, 'States the reason for the phone device communication error.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6939, '.1.3.6.1.4.1.9.9.156.1.2.3.1.7', 'ccmPhoneFailedMacAddress', 6932, 'current', NULL, 'The MAC address of the failed phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6940, '.1.3.6.1.4.1.9.9.156.1.2.3.1.8', 'ccmPhoneFailedInetAddressIPv4', 6932, 'current', NULL, 'This object identifies the last known primary IPv4 address of the phone experiencing a communication failure. This object contains value zero if IPV4 address is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6941, '.1.3.6.1.4.1.9.9.156.1.2.3.1.9', 'ccmPhoneFailedInetAddressIPv6', 6932, 'current', NULL, 'This object identifies the last known primary IPv6 address of the phone experiencing a communication failure. This object contains value zero if IPV6 address is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6942, '.1.3.6.1.4.1.9.9.156.1.2.3.1.10', 'ccmPhoneFailedIPv4Attribute', 6932, 'current', NULL, 'This object identifies the scope of ccmPhoneFailedInetAddressIPv4. unknown(0):It is not known if ccmPhoneFailedInetAddressIPv4 is used for Administration purpose or Controlling purpose. adminOnly(1): ccmPhoneFailedInetAddressIPv4 is used for the serviceability/administrative purpose. controlOnly(2): ccmPhoneFailedInetAddressIPv4 is used for signaling/registration purpose. adminAndControl(3): ccmPhoneFailedInetAddressIPv4 is used for controlling as well as administrative purpose.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6943, '.1.3.6.1.4.1.9.9.156.1.2.3.1.11', 'ccmPhoneFailedIPv6Attribute', 6932, 'current', NULL, 'This object identifies the scope of ccmPhoneFailedInetAddressIPv6. unknown(0):It is not known if ccmPhoneFailedInetAddressIPv6 is used for Administration purpose or Controlling purpose. adminOnly(1): ccmPhoneFailedInetAddressIPv6 is used for the serviceability/administrative purpose. controlOnly(2): ccmPhoneFailedInetAddressIPv6 is used for signaling/registration purpose. adminAndControl(3): ccmPhoneFailedInetAddressIPv6 is used for controlling as well as administrative purpose.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6944, '.1.3.6.1.4.1.9.9.156.1.2.3.1.12', 'ccmPhoneFailedRegFailReason', 6932, 'current', NULL, 'The reason code associated with registration failed phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6945, '.1.3.6.1.4.1.9.9.156.1.2.4', 'ccmPhoneStatusUpdateTable', 6832, 'current', NULL, 'The table containing the list of all phone status updates with respect to the local call manager. This table will only have registered, unregistered, and partially-registered status updates. The rejected phones are stored in the ccmPhoneFailedTable. Each entry of this table is stored at least for the duration specified in the ccmPhoneStatusUpdateStorePeriod object, after that it will be deleted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6946, '.1.3.6.1.4.1.9.9.156.1.2.4.1', 'ccmPhoneStatusUpdateEntry', 6945, 'current', NULL, 'An entry (conceptual row) in the PhoneStatusUpdate Table, one for each phone status update in the CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6947, '.1.3.6.1.4.1.9.9.156.1.2.4.1.1', 'ccmPhoneStatusUpdateIndex', 6946, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which is incremented with each new entry in the ccmPhoneStatusUpdateTable. This integer value will wrap if needed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6948, '.1.3.6.1.4.1.9.9.156.1.2.4.1.2', 'ccmPhoneStatusPhoneIndex', 6946, 'current', NULL, 'A positive value of this index is used to identify an entry in the ccmPhoneTable. A value of 0 indicates that the index to the ccmPhoneTable is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6949, '.1.3.6.1.4.1.9.9.156.1.2.4.1.3', 'ccmPhoneStatusUpdateTime', 6946, 'current', NULL, 'The time of the phone''s registration status change.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6950, '.1.3.6.1.4.1.9.9.156.1.2.4.1.4', 'ccmPhoneStatusUpdateType', 6946, 'current', NULL, 'States the type of phone status change. unknown: Unknown status phoneRegistered: Phone has registered with the Callmanager phoneUnregistered: Phone is no longer registered with the callmanager phonePartiallyregistered: Phone is partially registered with the callmanager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6951, '.1.3.6.1.4.1.9.9.156.1.2.4.1.5', 'ccmPhoneStatusUpdateReason', 6946, 'deprecated', NULL, 'The reason code associated with the phone status change.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6952, '.1.3.6.1.4.1.9.9.156.1.2.4.1.6', 'ccmPhoneStatusUnregReason', 6946, 'current', NULL, 'The reason code associated with unregistered phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6953, '.1.3.6.1.4.1.9.9.156.1.2.4.1.7', 'ccmPhoneStatusRegFailReason', 6946, 'current', NULL, 'The reason code associated with registration failed phone.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7037, '.1.3.6.1.4.1.9.9.156.1.6.1.1.15', 'ccmMediaDeviceUnregReason', 7022, 'current', NULL, 'The reason code associated with unregistered Media Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6954, '.1.3.6.1.4.1.9.9.156.1.2.5', 'ccmPhoneExtnTable', 6832, 'current', NULL, 'The table containing the list of all phone extensions associated with the registered and unregistered phones in the ccmPhoneTable. This table has combination index ccmPhoneIndex, ccmPhoneExtnIndex so the ccmPhoneTable and the ccmPhoneExtnTable entries can be related.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6955, '.1.3.6.1.4.1.9.9.156.1.2.5.1', 'ccmPhoneExtnEntry', 6954, 'current', NULL, 'An entry (conceptual row) in the phone extension Table, containing the information about a particular phone extension.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6956, '.1.3.6.1.4.1.9.9.156.1.2.5.1.1', 'ccmPhoneExtnIndex', 6955, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which uniquely identifies a Phone Extension within the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6957, '.1.3.6.1.4.1.9.9.156.1.2.5.1.2', 'ccmPhoneExtn', 6955, 'current', NULL, 'The extension number of the extension.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6958, '.1.3.6.1.4.1.9.9.156.1.2.5.1.3', 'ccmPhoneExtnMultiLines', 6955, 'current', NULL, 'The number of multiline appearances for each phone extension.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6959, '.1.3.6.1.4.1.9.9.156.1.2.5.1.4', 'ccmPhoneExtnInetAddressType', 6955, 'current', NULL, 'This object identifies the IP address type of the phone extension.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6960, '.1.3.6.1.4.1.9.9.156.1.2.5.1.5', 'ccmPhoneExtnInetAddress', 6955, 'current', NULL, 'This object identifies the IP address of the phone extension. The type of address for this is identified by ccmPhoneExtnInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6961, '.1.3.6.1.4.1.9.9.156.1.2.5.1.6', 'ccmPhoneExtnStatus', 6955, 'current', NULL, 'Represents the status of this phone line.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6962, '.1.3.6.1.4.1.9.9.156.1.3.1', 'ccmGatewayTable', 6833, 'current', NULL, 'The table containing the list of all gateway devices which have tried to register with the local CUCM at least once. When the local CUCM is restarted, this table will be refreshed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6963, '.1.3.6.1.4.1.9.9.156.1.3.1.1', 'ccmGatewayEntry', 6962, 'current', NULL, 'An entry (conceptual row) in the gateway Table, one for each gateway device in the CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6964, '.1.3.6.1.4.1.9.9.156.1.3.1.1.1', 'ccmGatewayIndex', 6963, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which uniquely identifies a Gateway within the scope of the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6965, '.1.3.6.1.4.1.9.9.156.1.3.1.1.2', 'ccmGatewayName', 6963, 'current', NULL, 'This is the Gateway name assigned to the Gateway in the CallManager. This name is assigned when a new device of type Gateway is added to the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6966, '.1.3.6.1.4.1.9.9.156.1.3.1.1.3', 'ccmGatewayType', 6963, 'obsolete', NULL, 'The type of the gateway device. unknown(1): Unknown Gateway type other(2): Unidentified Gateway type ciscoAnalogAccess(3): Analog Access ciscoDigitalAccessPRI(4): Digital Access PRI ciscoDigitalAccessT1(5): Digital Access T1 ciscoDigitalAccessPRIPlus(6): Digital Access PRI Plus ciscoDigitalAccessWSX6608E1(7): Cat 6000 Digital Access E1 ciscoDigitalAccessWSX6608T1(8): Cat 6000 Digital Access T1 ciscoAnalogAccessWSX6624(9): Cat 6000 Analog Access FXS ciscoMGCPStation(10): MGCP Gateway ciscoDigitalAccessE1Plus(11): Digital Access E1 Plus ciscoDigitalAccessT1Plus(12): Digital Access T1 Plus ciscoDigitalAccessWSX6608PRI(13): Cat 6000 Digital Access PRI ciscoAnalogAccessWSX6612(14): Cat 6000 Analog Access FXO ciscoMGCPTrunk(15): MGCP Trunk ciscoVG200(16): VG200 cisco26XX(17): 26XX cisco362X(18): 362X cisco364X(19): 364X cisco366X(20): 366X ciscoCat4224VoiceGatewaySwitch(21): Cisco Catalyst 4224 Voice Gateway Switch ciscoCat4000AccessGatewayModule(22): Cisco Catalyst 4000 Access Gateway Module ciscoIAD2400(23): Cisco IAD2400 ciscoVGCEndPoint(24): Cisco VGC Phone ciscoVG224VG248Gateway(25): Cisco VGC Gateway ciscoVGCBox(26): Cisco VGC Box ciscoATA186(27): Cisco ATA 186 ciscoICS77XXMRP2XX(28): Cisco ICS77XX-MRP2XX ciscoICS77XXASI81(29): Cisco ICS77XX-ASI81 ciscoICS77XXASI160(30): Cisco ICS77XX-ASI160 ciscoSlotVGCPort(31): Cisco VGC Port ciscoCat6000AVVIDServModule(32): Cisco Catalyst 6000 AVVID Services Module ciscoWSX6600(33): WS-X6600 ciscoWSSVCCMMMS(34): Cisco WS-SVC-CMM-MS cisco3745(35): Cisco 3745 cisco3725(36): Cisco 3725 ciscoICS77XXMRP3XX(37): Cisco ICS77XX MRP3XX ciscoICS77XXMRP38FXS(38): Cisco ICS77XX MRP3 8FXS ciscoICS77XXMRP316FXS(39): Cisco ICS77XX MRP3 16FXS ciscoICS77XXMRP38FXOM1(40): Cisco ICS77XX MRP3 8FXO M1 cisco269X(41): Cisco 269X cisco1760(42): Cisco 1760 cisco1751(43): Cisco 1751 ciscoMGCPBRIPort(44) Cisco MGCP BRI Port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6967, '.1.3.6.1.4.1.9.9.156.1.3.1.1.4', 'ccmGatewayDescription', 6963, 'current', NULL, 'The description attached to the gateway device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6968, '.1.3.6.1.4.1.9.9.156.1.3.1.1.5', 'ccmGatewayStatus', 6963, 'current', NULL, 'The status of the gateway. The Gateway status changes from Unknown to Registered when the Gateway registers itself with the local CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6969, '.1.3.6.1.4.1.9.9.156.1.3.1.1.6', 'ccmGatewayDevicePoolIndex', 6963, 'current', NULL, 'A positive value of this index is used to identify the Device Pool to which this Gateway entry belongs. A value of 0 indicates that the index to the Device Pool table is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6970, '.1.3.6.1.4.1.9.9.156.1.3.1.1.7', 'ccmGatewayInetAddressType', 6963, 'current', NULL, 'This object identifies the IP address type of the Gateway device. The value of this object is ''unknown(0)'' if the IP address of a Gateway device is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6971, '.1.3.6.1.4.1.9.9.156.1.3.1.1.8', 'ccmGatewayInetAddress', 6963, 'current', NULL, 'This object identifies last known IP Address of the gateway. If the IP address is not available then this object contains an empty string. The type of address for this is identified by ccmGatewayInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6972, '.1.3.6.1.4.1.9.9.156.1.3.1.1.9', 'ccmGatewayProductId', 6963, 'obsolete', NULL, 'The product identifier of the gateway device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6973, '.1.3.6.1.4.1.9.9.156.1.3.1.1.10', 'ccmGatewayStatusReason', 6963, 'deprecated', NULL, 'The reason code associated with the gateway status change.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6974, '.1.3.6.1.4.1.9.9.156.1.3.1.1.11', 'ccmGatewayTimeLastStatusUpdt', 6963, 'current', NULL, 'The time the status of the gateway changed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6975, '.1.3.6.1.4.1.9.9.156.1.3.1.1.12', 'ccmGatewayTimeLastRegistered', 6963, 'current', NULL, 'The time the gateway last registered with the call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6976, '.1.3.6.1.4.1.9.9.156.1.3.1.1.13', 'ccmGatewayDChannelStatus', 6963, 'current', NULL, 'The D-Channel status of the gateway. active(1): The D-Channel is up inActive(1): The D-Channel is down unknown(3): The D-Channel status is unknown notApplicable(4): The D-channel status is not applicable for this gateway.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6977, '.1.3.6.1.4.1.9.9.156.1.3.1.1.14', 'ccmGatewayDChannelNumber', 6963, 'current', NULL, 'The D-Channel number of the gateway. A value of -1 in this field indicates that the DChannel number is not applicable for this gateway.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6978, '.1.3.6.1.4.1.9.9.156.1.3.1.1.15', 'ccmGatewayProductTypeIndex', 6963, 'current', NULL, 'A positive value of this index is used to identify the related product type entry in the ccmProductTypeTable. A value of 0 indicates that the index to the ccmProductTypeTable is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6979, '.1.3.6.1.4.1.9.9.156.1.3.1.1.16', 'ccmGatewayUnregReason', 6963, 'current', NULL, 'The reason code associated with unregistered gateway.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6980, '.1.3.6.1.4.1.9.9.156.1.3.1.1.17', 'ccmGatewayRegFailReason', 6963, 'current', NULL, 'The reason code associated with registration failed gateway.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6981, '.1.3.6.1.4.1.9.9.156.1.4.1', 'ccmGatewayTrunkTable', 6834, 'obsolete', NULL, 'The table containing the list of all gateway trunks in a CCN system. When the local CUCM is restarted, this table will be refreshed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6982, '.1.3.6.1.4.1.9.9.156.1.4.1.1', 'ccmGatewayTrunkEntry', 6981, 'obsolete', NULL, 'An entry (conceptual row) in the gateway trunk table, one for each gateway trunk in a CCN system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6983, '.1.3.6.1.4.1.9.9.156.1.4.1.1.1', 'ccmGatewayTrunkIndex', 6982, 'obsolete', NULL, 'An arbitrary integer, selected by the local CUCM, which uniquely identifies a Gateway trunk within the scope of a CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6984, '.1.3.6.1.4.1.9.9.156.1.4.1.1.2', 'ccmGatewayTrunkType', 6982, 'obsolete', NULL, 'The type of the gateway Trunk. unknown: Unknown Trunk other: Unidentified Trunk type trunkGroundStart: Provides Far-End Disconnect Supervision trunkLoopStart: Provides No Far-End Disconnect Supervision trunkDID: Direct Inward Dial trunkPOTS: Plain Old Telephone Service trunkEM1: E&M Type 1 trunkEM2: E&M Type 2 trunkEM3: E&M Type 3 trunkEM4: E&M Type 4 trunkEM5: E&M Type 5 analog: Analog pri: PRI bri: BRI.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6985, '.1.3.6.1.4.1.9.9.156.1.4.1.1.3', 'ccmGatewayTrunkName', 6982, 'obsolete', NULL, 'The name of the trunk.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6986, '.1.3.6.1.4.1.9.9.156.1.4.1.1.4', 'ccmTrunkGatewayIndex', 6982, 'obsolete', NULL, 'A positive value of this index is used to identify the Gateway to which this Trunk entry belongs. A value of 0 indicates that the index to the Gateway table is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6987, '.1.3.6.1.4.1.9.9.156.1.4.1.1.5', 'ccmGatewayTrunkStatus', 6982, 'obsolete', NULL, 'The state of the trunk. The Trunk status changes from Unknown to Up when it registers itself with the local CUCM. unknown: Unknown state of Trunk up: Up and running, and is Idle with no calls busy: The trunk is in a Busy state down: The trunk is Down.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6988, '.1.3.6.1.4.1.9.9.156.1.5.1', 'ccmActivePhones', 6835, 'obsolete', NULL, 'The number of phones connected to this CM and actively in communication (via keepalives) with this CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6989, '.1.3.6.1.4.1.9.9.156.1.5.2', 'ccmInActivePhones', 6835, 'obsolete', NULL, 'The number of phones that are registered with the Call Manager but have lost contact with the CallManager. The phones are said to have lost contact with the CallManager if the CallManager does not receive any keepalives.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6990, '.1.3.6.1.4.1.9.9.156.1.5.3', 'ccmActiveGateways', 6835, 'obsolete', NULL, 'The number of gateways configured with this CallManager and actively in communication (via keepalives) with the Call Manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6991, '.1.3.6.1.4.1.9.9.156.1.5.4', 'ccmInActiveGateways', 6835, 'obsolete', NULL, 'The number of gateways that are registered with the Call Manager but have lost contact with the CallManager. The gateways are said to have lost contact with the CallManager if the CallManager does not receive any keepalives.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6992, '.1.3.6.1.4.1.9.9.156.1.5.5', 'ccmRegisteredPhones', 6835, 'current', NULL, 'The number of phones that are registered and actively in communication with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6993, '.1.3.6.1.4.1.9.9.156.1.5.6', 'ccmUnregisteredPhones', 6835, 'current', NULL, 'The number of phone that are unregistered or have lost contact with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6994, '.1.3.6.1.4.1.9.9.156.1.5.7', 'ccmRejectedPhones', 6835, 'current', NULL, 'The number of phones whose registration requests were rejected by the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6995, '.1.3.6.1.4.1.9.9.156.1.5.8', 'ccmRegisteredGateways', 6835, 'current', NULL, 'The number of gateways that are registered and actively in communication with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6996, '.1.3.6.1.4.1.9.9.156.1.5.9', 'ccmUnregisteredGateways', 6835, 'current', NULL, 'The number of gateways that are unregistered or have lost contact with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6997, '.1.3.6.1.4.1.9.9.156.1.5.10', 'ccmRejectedGateways', 6835, 'current', NULL, 'The number of gateways whose registration requests were rejected by the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6998, '.1.3.6.1.4.1.9.9.156.1.5.11', 'ccmRegisteredMediaDevices', 6835, 'current', NULL, 'The number of media devices that are registered and actively in communication with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (6999, '.1.3.6.1.4.1.9.9.156.1.5.12', 'ccmUnregisteredMediaDevices', 6835, 'current', NULL, 'The number of media devices that are unregistered or have lost contact with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7000, '.1.3.6.1.4.1.9.9.156.1.5.13', 'ccmRejectedMediaDevices', 6835, 'current', NULL, 'The number of media devices whose registration requests were rejected by the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7001, '.1.3.6.1.4.1.9.9.156.1.5.14', 'ccmRegisteredCTIDevices', 6835, 'current', NULL, 'The number of CTI devices that are registered and actively in communication with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7002, '.1.3.6.1.4.1.9.9.156.1.5.15', 'ccmUnregisteredCTIDevices', 6835, 'current', NULL, 'The number of CTI devices that are unregistered or have lost contact with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7003, '.1.3.6.1.4.1.9.9.156.1.5.16', 'ccmRejectedCTIDevices', 6835, 'current', NULL, 'The number of CTI devices whose registration requests were rejected by the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7004, '.1.3.6.1.4.1.9.9.156.1.5.17', 'ccmRegisteredVoiceMailDevices', 6835, 'current', NULL, 'The number of voice messaging devices that are registered and actively in communication with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7005, '.1.3.6.1.4.1.9.9.156.1.5.18', 'ccmUnregisteredVoiceMailDevices', 6835, 'current', NULL, 'The number of voice messaging devices that are unregistered or have lost contact with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7006, '.1.3.6.1.4.1.9.9.156.1.5.19', 'ccmRejectedVoiceMailDevices', 6835, 'current', NULL, 'The number of voice messaging devices whose registration requests were rejected by the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7007, '.1.3.6.1.4.1.9.9.156.1.5.20', 'ccmCallManagerStartTime', 6835, 'current', NULL, 'The last time the local call manager service started. This is available only when the local call manager is up and running.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7008, '.1.3.6.1.4.1.9.9.156.1.5.21', 'ccmPhoneTableStateId', 6835, 'current', NULL, 'The current state of ccmPhoneTable. The initial value of this object is 0 and it will be incremented every time when there is a change (addition/deletion/modification) to the ccmPhoneTable. This value and ccmCallManagerStartTime should be used together to find if the table has changed or not. When the call manager is restarted, this will be reset to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7009, '.1.3.6.1.4.1.9.9.156.1.5.22', 'ccmPhoneExtensionTableStateId', 6835, 'current', NULL, 'The current state of ccmPhoneExtensionTable. The initial value of this object is 0 and it will be incremented every time when there is a change (addition/deletion/modification) to the ccmPhoneExtensionTable. This value and ccmCallManagerStartTime should be used together to find if the table has changed or not. When the call manager is restarted, this will be reset to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7010, '.1.3.6.1.4.1.9.9.156.1.5.23', 'ccmPhoneStatusUpdateTableStateId', 6835, 'current', NULL, 'The current state of ccmPhoneStatusUpdateTable. The initial value of this object is 0 and it will be incremented every time when there is a change (addition/deletion/modification) to the ccmPhoneStatusUpdateTable. This value and sysUpTime should be used together to find if the table has changed or not. When the SNMP service is restarted this value will be reset to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7011, '.1.3.6.1.4.1.9.9.156.1.5.24', 'ccmGatewayTableStateId', 6835, 'current', NULL, 'The current state of ccmGatewayTable. The initial value of this object is 0 and it will be incremented every time when there is a change (addition/deletion/modification) to the ccmGatewayTable. This value and ccmCallManagerStartTime should be used together to find if the table has changed or not. When the call manager is restarted, this will be reset to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7038, '.1.3.6.1.4.1.9.9.156.1.6.1.1.16', 'ccmMediaDeviceRegFailReason', 7022, 'current', NULL, 'The reason code associated with registration failed Media Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7098, '.1.3.6.1.4.1.9.9.156.1.10.20', 'ccmQualityRprtCategory', 6840, 'current', NULL, 'The category of the problem reported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7012, '.1.3.6.1.4.1.9.9.156.1.5.25', 'ccmCTIDeviceTableStateId', 6835, 'current', NULL, 'The current state of ccmCTIDeviceTable. The initial value of this object is 0 and it will be incremented every time when there is a change (addition/deletion/modification) to the ccmCTIDeviceTable. This value and ccmCallManagerStartTime should be used together to find if the table has changed or not. When the call manager is restarted, this will be reset to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7013, '.1.3.6.1.4.1.9.9.156.1.5.26', 'ccmCTIDeviceDirNumTableStateId', 6835, 'current', NULL, 'The current state of ccmCTIDeviceDirNumTable. The initial value of this object is 0 and it will be incremented every time when there is a change (addition/deletion/modification) to the ccmCTIDeviceDirNumTable. This value and ccmCallManagerStartTime should be used together to find if the table has changed or not. When the call manager is restarted, this will be reset to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7014, '.1.3.6.1.4.1.9.9.156.1.5.27', 'ccmPhStatUpdtTblLastAddedIndex', 6835, 'current', NULL, 'The ccmPhoneStatusUpdateIndex value of the last entry that was added to the ccmPhoneStatusUpdateTable. This value together with sysUpTime can be used by the manager applications to identify the new entries in the ccmPhoneStatusUpdateTable since their last poll. This value need not be the same as the highest index in the ccmPhoneStatusUpdateTable as the index could have wrapped around. The initial value of this object is 0 which indicates that there has been no entries added to this table. When the SNMP service is restarted this value will be reset to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7015, '.1.3.6.1.4.1.9.9.156.1.5.28', 'ccmPhFailedTblLastAddedIndex', 6835, 'current', NULL, 'The ccmPhoneFailedIndex value of the last entry that was added to the ccmPhoneFailedTable. This value together with sysUpTime can be used by the manager applications to identify the new entries in the ccmPhoneFailedTable since their last poll. This value need not be the same as the highest index in the ccmPhoneFailedTable as the index could have wrapped around. The initial value of this object is 0 which indicates that there has been no entries added to this table. When the SNMP service is restarted this value will be reset to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7016, '.1.3.6.1.4.1.9.9.156.1.5.29', 'ccmSystemVersion', 6835, 'current', NULL, 'The installed version of the local call manager system.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7017, '.1.3.6.1.4.1.9.9.156.1.5.30', 'ccmInstallationId', 6835, 'current', NULL, 'The installation component identifier of the local call manager component(ccm.exe).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7018, '.1.3.6.1.4.1.9.9.156.1.5.31', 'ccmPartiallyRegisteredPhones', 6835, 'current', NULL, 'The number of phones that are partially registered with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7019, '.1.3.6.1.4.1.9.9.156.1.5.32', 'ccmH323TableEntries', 6835, 'current', NULL, 'The current number of entries in ccmH323DeviceTable. The initial value of this object is 0 and it will be incremented everytime when there is an addition to the ccmH323DeviceTable. When the call manager is restarted, this will be reset to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7020, '.1.3.6.1.4.1.9.9.156.1.5.33', 'ccmSIPTableEntries', 6835, 'current', NULL, 'The current number of entries in ccmSIPDeviceTable. The initial value of this object is 0 and it will be incremented everytime when there is an addition to the ccmSIPDeviceTable. When the call manager is restarted, this will be reset to 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7021, '.1.3.6.1.4.1.9.9.156.1.6.1', 'ccmMediaDeviceTable', 6836, 'current', NULL, 'The table containing a list of all Media Devices which have tried to register with the local CUCM at least once. When the local CUCM is restarted, this table will be refreshed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7022, '.1.3.6.1.4.1.9.9.156.1.6.1.1', 'ccmMediaDeviceEntry', 7021, 'current', NULL, 'An entry (conceptual row) in the MediaDevice Table, containing the information about a particular Media Resource device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7023, '.1.3.6.1.4.1.9.9.156.1.6.1.1.1', 'ccmMediaDeviceIndex', 7022, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which identifies a Media Device entry in the table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7024, '.1.3.6.1.4.1.9.9.156.1.6.1.1.2', 'ccmMediaDeviceName', 7022, 'current', NULL, 'This is the device name assigned to the Media Device. This name is assigned when a new device of this type is added to the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7025, '.1.3.6.1.4.1.9.9.156.1.6.1.1.3', 'ccmMediaDeviceType', 7022, 'obsolete', NULL, 'The type of Media Device. unknown(1): Unknown Media Device ciscoMediaTerminPointWSX6608(2): Hardware based Media Termination Point WSX6608 ciscoConfBridgeWSX6608(3): Hardware based Conference Bridge WSX6608 ciscoSwMediaTerminationPoint(4): Software based Media Termination Point ciscoSwConfBridge(5): Software based Conference Bridge ciscoMusicOnHold(6): Music on Hold Server ciscoToneAnnouncementPlayer(7): Tone Announcement Player ciscoConfBridgeWSSVCCMM(8): Conference Bridge WS-SVC-CMM ciscoMediaServerWSSVCCMMMS(9): Media Server WS-SVC-CMM-MS ciscoMTPWSSVCCMM(10): Media Termination Point WS-SVC-CMM ciscoIOSSWMTPHDV2(11): IOS Software Media Termination Point HDV2 ciscoIOSConfBridgeHDV2(12): IOS Conference Bridge HDV2 ciscoIOSMTPHDV2(13): IOS Media Termination Point HDV2 ciscoVCBIPVC35XX(14): Video Conference Bridge IPVC 35XX.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7026, '.1.3.6.1.4.1.9.9.156.1.6.1.1.4', 'ccmMediaDeviceDescription', 7022, 'current', NULL, 'A description of the Media Device. This description is given when the device is configured in the CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7027, '.1.3.6.1.4.1.9.9.156.1.6.1.1.5', 'ccmMediaDeviceStatus', 7022, 'current', NULL, 'The status of the Media Device. The status changes from unknown to registered when it registers itself with the local CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7028, '.1.3.6.1.4.1.9.9.156.1.6.1.1.6', 'ccmMediaDeviceDevicePoolIndex', 7022, 'current', NULL, 'A positive value of this index is used to identify the Device Pool to which this MediaDevice entry belongs. A value of 0 indicates that the index to the Device Pool table is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7029, '.1.3.6.1.4.1.9.9.156.1.6.1.1.7', 'ccmMediaDeviceInetAddressType', 7022, 'deprecated', NULL, 'This object identifies the IP address type of the Media Device. The value of this object is ''unknown(0)'' if the IP address of a Media Device is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7030, '.1.3.6.1.4.1.9.9.156.1.6.1.1.8', 'ccmMediaDeviceInetAddress', 7022, 'deprecated', NULL, 'This object identifies last known IP Address of the Media Device. If the IP Address is not available then this object contains an empty string. The type of address for this is identified by ccmMediaDeviceInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7031, '.1.3.6.1.4.1.9.9.156.1.6.1.1.9', 'ccmMediaDeviceStatusReason', 7022, 'deprecated', NULL, 'The reason code associated with the media device status change.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7032, '.1.3.6.1.4.1.9.9.156.1.6.1.1.10', 'ccmMediaDeviceTimeLastStatusUpdt', 7022, 'current', NULL, 'The time the status of the media device changed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7033, '.1.3.6.1.4.1.9.9.156.1.6.1.1.11', 'ccmMediaDeviceTimeLastRegistered', 7022, 'current', NULL, 'The time the media device last registered with the call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7034, '.1.3.6.1.4.1.9.9.156.1.6.1.1.12', 'ccmMediaDeviceProductTypeIndex', 7022, 'current', NULL, 'A positive value of this index is used to identify the related product type entry in the ccmProductTypeTable. A value of 0 indicates that the index to the ccmProductTypeTable is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7035, '.1.3.6.1.4.1.9.9.156.1.6.1.1.13', 'ccmMediaDeviceInetAddressIPv4', 7022, 'current', NULL, 'This object identifies the last known primary IPv4 address of the Media Device. This object contains value zero if IPV4 address is not available', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7036, '.1.3.6.1.4.1.9.9.156.1.6.1.1.14', 'ccmMediaDeviceInetAddressIPv6', 7022, 'current', NULL, 'This object identifies the last known primary IPv6 address of the Media Device. This object contains value zero if IPV6 address is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7199, '.1.3.6.1.4.1.9.9.156.3.1.8', 'ciscoCcmMIBComplianceRev7', 7190, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7039, '.1.3.6.1.4.1.9.9.156.1.7.1', 'ccmGatekeeperTable', 6837, 'obsolete', NULL, 'The table containing a list of all Gatekeepers to which the local CUCM has tried to register at least once. When the local CUCM is restarted, this table will be refreshed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7040, '.1.3.6.1.4.1.9.9.156.1.7.1.1', 'ccmGatekeeperEntry', 7039, 'obsolete', NULL, 'An entry (conceptual row) in the Gatekeeper Table, containing the information about a particular Gatekeeper that the local call manager tried to register with.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7041, '.1.3.6.1.4.1.9.9.156.1.7.1.1.1', 'ccmGatekeeperIndex', 7040, 'obsolete', NULL, 'An arbitrary integer, selected by the local CUCM, which identifies a Gatekeeper entry in the table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7042, '.1.3.6.1.4.1.9.9.156.1.7.1.1.2', 'ccmGatekeeperName', 7040, 'obsolete', NULL, 'This is the Gatekeeper name assigned to the Gatekeeper. This name is assigned when a new device of type Gatekeeper is added to the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7043, '.1.3.6.1.4.1.9.9.156.1.7.1.1.3', 'ccmGatekeeperType', 7040, 'obsolete', NULL, 'The type of Gatekeeper. unknown: Unknown Gatekeeper other: Unidentified Gatekeeper terminal: Terminal gateway: Gateway.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7044, '.1.3.6.1.4.1.9.9.156.1.7.1.1.4', 'ccmGatekeeperDescription', 7040, 'obsolete', NULL, 'A description of the Gatekeeper. This description is given when the Gatekeeper is configured in the CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7045, '.1.3.6.1.4.1.9.9.156.1.7.1.1.5', 'ccmGatekeeperStatus', 7040, 'obsolete', NULL, 'The local call manager registration status with the Gatekeeper. The status changes from unknown to registered when the local call manager successfully registers itself with the gatekeeper. unknown: The registration status of the call manager with the gatekeeper is unknown registered: The local call manager has registered with the gatekeeper successfully unregistered: The local call manager is no longer registered with the gatekeeper rejected: Registration request from the local call manager was rejected by the gatekeeper.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7046, '.1.3.6.1.4.1.9.9.156.1.7.1.1.6', 'ccmGatekeeperDevicePoolIndex', 7040, 'obsolete', NULL, 'A positive value of this index is used to identify the Device Pool to which this Gatekeeper entry belongs. A value of 0 indicates that the index to the Device Pool table is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7047, '.1.3.6.1.4.1.9.9.156.1.7.1.1.7', 'ccmGatekeeperInetAddressType', 7040, 'obsolete', NULL, 'This object identifies the IP address type of the Gatekeeper. The value of this object is ''unknown(0)'' if the IP address of a Gatekeeper is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7048, '.1.3.6.1.4.1.9.9.156.1.7.1.1.8', 'ccmGatekeeperInetAddress', 7040, 'obsolete', NULL, 'This object identifies last known IP Address of the gatekeeper. If the IP address is not available then this object contains an empty string. The type of address for this is identified by ccmGatekeeperInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7049, '.1.3.6.1.4.1.9.9.156.1.8.1', 'ccmCTIDeviceTable', 6838, 'current', NULL, 'The table containing a list of all CTI (Computer Telephony Integration) Devices which have tried to register with the local CUCM at least once. When the local CUCM is restarted, this table will be refreshed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7050, '.1.3.6.1.4.1.9.9.156.1.8.1.1', 'ccmCTIDeviceEntry', 7049, 'current', NULL, 'An entry (conceptual row) in the CTIDevice Table, containing the information about a particular CTI Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7051, '.1.3.6.1.4.1.9.9.156.1.8.1.1.1', 'ccmCTIDeviceIndex', 7050, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which identifies a CTI Device entry in the table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7052, '.1.3.6.1.4.1.9.9.156.1.8.1.1.2', 'ccmCTIDeviceName', 7050, 'current', NULL, 'The name of the CTI Device. This name is assigned to the CTI Device when it is added to the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7053, '.1.3.6.1.4.1.9.9.156.1.8.1.1.3', 'ccmCTIDeviceType', 7050, 'obsolete', NULL, 'The type of CTI Device. unknown: Unknown CTI Device other: Unidentified CTI Device ctiRoutePoint: A CTI Route Point ctiPort: A CTI Port.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7054, '.1.3.6.1.4.1.9.9.156.1.8.1.1.4', 'ccmCTIDeviceDescription', 7050, 'current', NULL, 'A description of the CTI Device. This description is given when the CTI Device is configured in the CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7055, '.1.3.6.1.4.1.9.9.156.1.8.1.1.5', 'ccmCTIDeviceStatus', 7050, 'current', NULL, 'The status of the CTI Device. The CTI Device status changes from unknown to registered when it registers itself with the local CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7056, '.1.3.6.1.4.1.9.9.156.1.8.1.1.6', 'ccmCTIDevicePoolIndex', 7050, 'current', NULL, 'A positive value of this index is used to identify the Device Pool to which this CTI Device entry belongs. A value of 0 indicates that the index to the Device Pool table is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7057, '.1.3.6.1.4.1.9.9.156.1.8.1.1.7', 'ccmCTIDeviceInetAddressType', 7050, 'deprecated', NULL, 'This object identifies the IP address type of the CTIDevice. The value of this object is ''unknown(0)'' if the IP address of a CTIDevice is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7058, '.1.3.6.1.4.1.9.9.156.1.8.1.1.8', 'ccmCTIDeviceInetAddress', 7050, 'deprecated', NULL, 'This object identifies IP Address of the host where this CTI Device is running. If the IP address is not available then this object contains an empty string. The type of address for this is identified by ccmCTIDeviceInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7059, '.1.3.6.1.4.1.9.9.156.1.8.1.1.9', 'ccmCTIDeviceAppInfo', 7050, 'obsolete', NULL, 'The appinfo string indicates the application name/ type that uses this CTI Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7060, '.1.3.6.1.4.1.9.9.156.1.8.1.1.10', 'ccmCTIDeviceStatusReason', 7050, 'deprecated', NULL, 'The reason code associated with the CTI Device status change.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7061, '.1.3.6.1.4.1.9.9.156.1.8.1.1.11', 'ccmCTIDeviceTimeLastStatusUpdt', 7050, 'current', NULL, 'The time the status of the CTI device changed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7062, '.1.3.6.1.4.1.9.9.156.1.8.1.1.12', 'ccmCTIDeviceTimeLastRegistered', 7050, 'current', NULL, 'The time the CTI Device last registered with the call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7063, '.1.3.6.1.4.1.9.9.156.1.8.1.1.13', 'ccmCTIDeviceProductTypeIndex', 7050, 'current', NULL, 'A positive value of this index is used to identify the related product type entry in the ccmProductTypeTable. A value of 0 indicates that the index to the ccmProductTypeTable is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7064, '.1.3.6.1.4.1.9.9.156.1.8.1.1.14', 'ccmCTIDeviceInetAddressIPv4', 7050, 'current', NULL, 'This object identifies IPv4 Address of the host where this CTI Device is running. If the IPv4 address is not available then this object contains an empty string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7065, '.1.3.6.1.4.1.9.9.156.1.8.1.1.15', 'ccmCTIDeviceInetAddressIPv6', 7050, 'current', NULL, 'This object identifies IPv6 Address of the host where this CTI Device is running. If the IPv6 address is not available then this object contains an empty string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7066, '.1.3.6.1.4.1.9.9.156.1.8.1.1.16', 'ccmCTIDeviceUnregReason', 7050, 'current', NULL, 'The reason code associated with unregistered CTI Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7067, '.1.3.6.1.4.1.9.9.156.1.8.1.1.17', 'ccmCTIDeviceRegFailReason', 7050, 'current', NULL, 'The reason code associated with registration failed CTI Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7068, '.1.3.6.1.4.1.9.9.156.1.8.2', 'ccmCTIDeviceDirNumTable', 6838, 'current', NULL, 'The table containing a list of directory numbers that are assigned to all of the registered and unregistered CTI Devices in the ccmCTIDeviceTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7069, '.1.3.6.1.4.1.9.9.156.1.8.2.1', 'ccmCTIDeviceDirNumEntry', 7068, 'current', NULL, 'An entry (conceptual row) in the CTIDeviceDirNum Table, containing the information about a particular CTI Device extension.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7070, '.1.3.6.1.4.1.9.9.156.1.8.2.1.1', 'ccmCTIDeviceDirNumIndex', 7069, 'current', NULL, 'An arbitrary integer, selected by the local system, which identifies a Directory Number of a CTI Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7071, '.1.3.6.1.4.1.9.9.156.1.8.2.1.2', 'ccmCTIDeviceDirNum', 7069, 'current', NULL, 'A Directory Number of the CTI Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7072, '.1.3.6.1.4.1.9.9.156.1.9.1', 'ccmCallManagerAlarmEnable', 6839, 'current', NULL, 'Allows the generation of Alarms in response to CallManager general failures. true(1): Enabling this object will allow the CUCM agent to generate the following alarms - ccmCallManagerFailure, ccmMediaResourceListExhausted, ccmRouteListExhausted and ccmTLSConnectionFailure. This is the default value. false(2): Disabling this object will stop the generation of the following alarms by the CUCM agent - ccmCallManagerFailure ccmMediaResourceListExhausted, ccmRouteListExhausted and ccmTLSConnectionFailure.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7073, '.1.3.6.1.4.1.9.9.156.1.9.2', 'ccmPhoneFailedAlarmInterval', 6839, 'current', NULL, 'The minimum interval between sending of the ccmPhoneFailed notification in seconds. The ccmPhoneFailed notification is only sent when there is at least one entry in the ccmPhoneFailedTable and the notification has not been sent for the last ccmPhoneFailedAlarmInterval defined in this object. A value of 0 indicates that the alarm notification is disabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7074, '.1.3.6.1.4.1.9.9.156.1.9.3', 'ccmPhoneFailedStorePeriod', 6839, 'current', NULL, 'The time duration for storing each entry in the ccmPhoneFailedTable. The entries which have not been updated and kept at least this period will be deleted. This value should ideally be set to a higher value than the ccmPhoneFailedAlarmInterval object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7075, '.1.3.6.1.4.1.9.9.156.1.9.4', 'ccmPhoneStatusUpdateAlarmInterv', 6839, 'current', NULL, 'The minimum interval between sending of the ccmPhoneStatusUpdate notification in seconds. The ccmPhoneStatusUpdate notification is only sent when there is at least one entry in the ccmPhoneStatusUpdateTable and the notification has not been sent for the last ccmPhoneStatusUpdateAlarmInterv defined in this object. A value of 0 indicates that the alarm notification is disabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7076, '.1.3.6.1.4.1.9.9.156.1.9.5', 'ccmPhoneStatusUpdateStorePeriod', 6839, 'current', NULL, 'The time duration for storing each entry in the ccmPhoneStatusUpdateTable. The entries which have been kept at least this period will be deleted. This value should ideally be set to a higher value than the ccmPhoneStatusUpdateAlarmInterv object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7077, '.1.3.6.1.4.1.9.9.156.1.9.6', 'ccmGatewayAlarmEnable', 6839, 'current', NULL, 'Allows the generation of Alarms in response to Gateway general failures that the CallManager is aware of. true(1): Enabling this object will allow the CUCM agent to generate the following alarms - ccmGatewayFailedReason and ccmGatewayLayer2Change notifications. This is the default value. false(2): Disabling this object will stop the generation of the following alarms by the CUCM agent - ccmGatewayFailedReason and ccmGatewayLayer2Change.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7078, '.1.3.6.1.4.1.9.9.156.1.9.7', 'ccmMaliciousCallAlarmEnable', 6839, 'current', NULL, 'Allows the generation of alarms for malicious calls that the local call manager is aware of. true(1): Enabling this object will allow the CUCM agent to generate the ccmMaliciousCall alarm. This is the default value. false(2): Disabling this object will stop the generation of the ccmMaliciousCall alarm.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7079, '.1.3.6.1.4.1.9.9.156.1.10.1', 'ccmAlarmSeverity', 6840, 'current', NULL, 'The Alarm Severity code. emergency: System unusable alert: Immediate response needed critical: Critical condition error: Error condition warning: Warning condition notice: Normal but significant condition informational: Informational situation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7080, '.1.3.6.1.4.1.9.9.156.1.10.2', 'ccmFailCauseCode', 6840, 'current', NULL, 'The Cause code of the failure. This cause is derived from a monitoring thread in the CallManager or from a heartbeat monitoring process. unknown: Unknown heartBeatStopped: The CallManager stops generating a heartbeat routerThreadDied: The CallManager detects the death of the router thread timerThreadDied: The CallManager detects the death of the timer thread criticalThreadDied: The CallManager detects the death of one of its critical threads deviceMgrInitFailed: The CallManager fails to start its device manager subsystem digitAnalysisInitFailed: The CallManager fails to start its digit analysis subsystem callControlInitFailed: The CallManager fails to start its call control subsystem linkMgrInitFailed: The CallManager fails to start its link manager subsystem dbMgrInitFailed: The CallManager fails to start its database manager subsystem msgTranslatorInitFailed: The CallManager fails to start its message translation manager subsystem suppServicesInitFailed: The CallManager fails to start its supplementary services subsystem.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7081, '.1.3.6.1.4.1.9.9.156.1.10.3', 'ccmPhoneFailures', 6840, 'current', NULL, 'The count of the phone initialization or communication failures that are stored in the ccmPhoneFailedTable object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7082, '.1.3.6.1.4.1.9.9.156.1.10.4', 'ccmPhoneUpdates', 6840, 'current', NULL, 'The count of the phone status changes that are stored in the ccmPhoneStatusUpdateTable object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7083, '.1.3.6.1.4.1.9.9.156.1.10.5', 'ccmGatewayFailCauseCode', 6840, 'deprecated', NULL, 'States the reason for a gateway device communication error.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7084, '.1.3.6.1.4.1.9.9.156.1.10.6', 'ccmMediaResourceType', 6840, 'current', NULL, 'The type of media resource. unknown: Unknown resource type mediaTerminationPoint: Media Termination Point transcoder: Transcoder conferenceBridge: Conference Bridge musicOnHold: Music On Hold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7085, '.1.3.6.1.4.1.9.9.156.1.10.7', 'ccmMediaResourceListName', 6840, 'current', NULL, 'The name of a Media Resource List. This name is assigned when a new Media Resource List is added to the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7086, '.1.3.6.1.4.1.9.9.156.1.10.8', 'ccmRouteListName', 6840, 'current', NULL, 'The name of a Route List. This name is assigned when a new Route List is added to the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7087, '.1.3.6.1.4.1.9.9.156.1.10.9', 'ccmGatewayPhysIfIndex', 6840, 'current', NULL, 'This object is the identifier of an interface in a gateway that has registered with the local CallManager. On a DS1/E1 interface, this should be the same as the ifIndex value in the gateway.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7088, '.1.3.6.1.4.1.9.9.156.1.10.10', 'ccmGatewayPhysIfL2Status', 6840, 'current', NULL, 'The layer 2 status of a physical interface in a gateway that has registered with the local CallManager. unknown: Unknown status up: Interface is up down: Interface is down.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7089, '.1.3.6.1.4.1.9.9.156.1.10.11', 'ccmMaliCallCalledPartyName', 6840, 'current', NULL, 'The display name of the called party who received the malicious call.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7090, '.1.3.6.1.4.1.9.9.156.1.10.12', 'ccmMaliCallCalledPartyNumber', 6840, 'current', NULL, 'The phone number of the device where the malicious call is received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7091, '.1.3.6.1.4.1.9.9.156.1.10.13', 'ccmMaliCallCalledDeviceName', 6840, 'current', NULL, 'The name of the device where the malicious call is received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7092, '.1.3.6.1.4.1.9.9.156.1.10.14', 'ccmMaliCallCallingPartyName', 6840, 'current', NULL, 'The display name of the caller whose call is registered as malicious with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7093, '.1.3.6.1.4.1.9.9.156.1.10.15', 'ccmMaliCallCallingPartyNumber', 6840, 'current', NULL, 'The phone number of the caller whose call is registered as malicious with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7094, '.1.3.6.1.4.1.9.9.156.1.10.16', 'ccmMaliCallCallingDeviceName', 6840, 'current', NULL, 'The edge device name through which the malicious call originated or passed through.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7095, '.1.3.6.1.4.1.9.9.156.1.10.17', 'ccmMaliCallTime', 6840, 'current', NULL, 'The time when the malicious call is detected by the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7096, '.1.3.6.1.4.1.9.9.156.1.10.18', 'ccmQualityRprtSourceDevName', 6840, 'current', NULL, 'The name of the source device from where the problem was reported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7097, '.1.3.6.1.4.1.9.9.156.1.10.19', 'ccmQualityRprtClusterId', 6840, 'current', NULL, 'The cluster identifier of the source device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7099, '.1.3.6.1.4.1.9.9.156.1.10.21', 'ccmQualityRprtReasonCode', 6840, 'current', NULL, 'The description of the problem reported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7100, '.1.3.6.1.4.1.9.9.156.1.10.22', 'ccmQualityRprtTime', 6840, 'current', NULL, 'The time when the problem was reported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7101, '.1.3.6.1.4.1.9.9.156.1.10.23', 'ccmTLSDevName', 6840, 'current', NULL, 'The device for which TLS connection failure was reported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7102, '.1.3.6.1.4.1.9.9.156.1.10.24', 'ccmTLSDevInetAddressType', 6840, 'current', NULL, 'This object identifies the type of address for the device for which TLS connection failure was reported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7103, '.1.3.6.1.4.1.9.9.156.1.10.25', 'ccmTLSDevInetAddress', 6840, 'current', NULL, 'This object identifies IP Address of the device, for which TLS connection failure was reported. The type of address for this is identified by ccmTLSDevInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7104, '.1.3.6.1.4.1.9.9.156.1.10.26', 'ccmTLSConnFailTime', 6840, 'current', NULL, 'The time when TLS connection failure was detected by the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7105, '.1.3.6.1.4.1.9.9.156.1.10.27', 'ccmTLSConnectionFailReasonCode', 6840, 'current', NULL, 'The reason for connection failure.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7106, '.1.3.6.1.4.1.9.9.156.1.10.28', 'ccmGatewayRegFailCauseCode', 6840, 'current', NULL, 'States the reason for a gateway device registration failure.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7107, '.1.3.6.1.4.1.9.9.156.1.11.1', 'ccmH323DeviceTable', 6841, 'current', NULL, 'The table containing a list of all H323 devices in the CUCM cluster which the local CUCM is aware of. When the local CUCM is restarted, this table will be refreshed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7108, '.1.3.6.1.4.1.9.9.156.1.11.1.1', 'ccmH323DeviceEntry', 7107, 'current', NULL, 'An entry (conceptual row) in the H323Device Table, containing the information about a particular H323 Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7109, '.1.3.6.1.4.1.9.9.156.1.11.1.1.1', 'ccmH323DevIndex', 7108, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which identifies a H323 Device entry in the table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7110, '.1.3.6.1.4.1.9.9.156.1.11.1.1.2', 'ccmH323DevName', 7108, 'current', NULL, 'The device name assigned to the H323 Device. This name is assigned when a new H323 device is added to the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7111, '.1.3.6.1.4.1.9.9.156.1.11.1.1.3', 'ccmH323DevProductId', 7108, 'obsolete', NULL, 'The product identifier of the H323 device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7112, '.1.3.6.1.4.1.9.9.156.1.11.1.1.4', 'ccmH323DevDescription', 7108, 'current', NULL, 'A description of the H323 device. This description is given when the H323 device is configured in the CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7113, '.1.3.6.1.4.1.9.9.156.1.11.1.1.5', 'ccmH323DevInetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the H323 device. The value of this object is ''unknown(0)'' if the IP address of a H323 device is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7114, '.1.3.6.1.4.1.9.9.156.1.11.1.1.6', 'ccmH323DevInetAddress', 7108, 'current', NULL, 'This object identifies last known IP Address of the H323 device. If the IP address is not available then this object contains an empty string. The type of address for this is identified by ccmH323DevInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7115, '.1.3.6.1.4.1.9.9.156.1.11.1.1.7', 'ccmH323DevCnfgGKInetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the gatekeeper device. The value of this object is ''unknown(0)'' if the IP address of a H323 gatekeeper is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7116, '.1.3.6.1.4.1.9.9.156.1.11.1.1.8', 'ccmH323DevCnfgGKInetAddress', 7108, 'current', NULL, 'This object represents configured gatekeeper DNS name or IP address for this H323 device. This is applicable only for H323 devices with gatekeepers configured. When there is no H323 gatekeeper configured, this object contains an empty string. The type of address for this is identified by ccmH323DevCnfgGKInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7117, '.1.3.6.1.4.1.9.9.156.1.11.1.1.9', 'ccmH323DevAltGK1InetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the first alternate gatekeeper. The value of this object is ''unknown(0)'' if the IP address of a H323 gatekeeper is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7118, '.1.3.6.1.4.1.9.9.156.1.11.1.1.10', 'ccmH323DevAltGK1InetAddress', 7108, 'current', NULL, 'This object identifies the first alternate gatekeeper DNS name or IP address for this H323 device. This is applicable only for H323 devices with gatekeepers configured. When there is no first alternate H323 gatekeeper, this object contains an empty string. The type of address for this is identified by ccmH323DevAltGK1InetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7119, '.1.3.6.1.4.1.9.9.156.1.11.1.1.11', 'ccmH323DevAltGK2InetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the second alternate gatekeeper. The value of this object is ''unknown(0)'' if the IP address of a H323 gatekeeper is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7120, '.1.3.6.1.4.1.9.9.156.1.11.1.1.12', 'ccmH323DevAltGK2InetAddress', 7108, 'current', NULL, 'This object identifies the second alternate gatekeeper DNS name or IP address for this H323 device. This is applicable only for H323 devices with gatekeepers configured. When there is no second alternate H323 gatekeeper, this object contains an empty string. The type of address for this is identified by ccmH323DevAltGK2InetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7121, '.1.3.6.1.4.1.9.9.156.1.11.1.1.13', 'ccmH323DevAltGK3InetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the third alternate gatekeeper. The value of this object is ''unknown(0)'' if the IP address of a H323 gatekeeper is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7122, '.1.3.6.1.4.1.9.9.156.1.11.1.1.14', 'ccmH323DevAltGK3InetAddress', 7108, 'current', NULL, 'This object identifies the third alternate gatekeeper DNS name or IP address for this H323 device. This is applicable only for H323 devices with gatekeepers configured. When there is no third alternate H323 gatekeeper, this object contains an empty string. The type of address for this is identified by ccmH323DevAltGK3InetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7123, '.1.3.6.1.4.1.9.9.156.1.11.1.1.15', 'ccmH323DevAltGK4InetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the fourth alternate gatekeeper. The value of this object is ''unknown(0)'' if the IP address of a H323 gatekeeper is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7124, '.1.3.6.1.4.1.9.9.156.1.11.1.1.16', 'ccmH323DevAltGK4InetAddress', 7108, 'current', NULL, 'This object identifies the fourth alternate gatekeeper DNS name or IP address for this H323 device. This is applicable only for H323 devices with gatekeepers configured. When there is no fourth H323 alternate gatekeeper, this object contains an empty string. The type of address for this is identified by ccmH323DevAltGK4InetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7125, '.1.3.6.1.4.1.9.9.156.1.11.1.1.17', 'ccmH323DevAltGK5InetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the fifth alternate gatekeeper. The value of this object is ''unknown(0)'' if the IP address of a H323 gatekeeper is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7126, '.1.3.6.1.4.1.9.9.156.1.11.1.1.18', 'ccmH323DevAltGK5InetAddress', 7108, 'current', NULL, 'This object identifies the fifth alternate gatekeeper DNS name or IP address for this H323 device. This is applicable only for H323 devices with gatekeepers configured. When there is no fifth H323 alternate gatekeeper, this object contains an empty string. The type of address for this is identified by ccmH323DevAltGK5InetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7127, '.1.3.6.1.4.1.9.9.156.1.11.1.1.19', 'ccmH323DevActGKInetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the active gatekeeper. The value of this object is ''unknown(0)'' if the IP address of a gatekeeper is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7231, '.1.3.6.1.4.1.9.9.156.3.2.32', 'ccmNotificationsInfoGroupRev3', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all the Notifications generated by the CUCM Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7128, '.1.3.6.1.4.1.9.9.156.1.11.1.1.20', 'ccmH323DevActGKInetAddress', 7108, 'current', NULL, 'This object identifies the active alternate gatekeeper DNS name or IP address for this H323 device. This is applicable only for H323 devices with gatekeepers configured. When there is no active alternate H323 gatekeeper, this object contains an empty string. The type of address for this is identified by ccmH323DevActGKInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7129, '.1.3.6.1.4.1.9.9.156.1.11.1.1.21', 'ccmH323DevStatus', 7108, 'current', NULL, 'The H323 device registration status with the gatekeeper. The status changes from unknown to registered when the H323 device successfully registers itself with the gatekeeper. notApplicable: The registration status is not applicable for this H323 device unknown: The registration status of the H323 device with the gatekeeper is unknown registered: The H323 device has registered with the gatekeeper successfully unregistered: The H323 device is no longer registered with the gatekeeper rejected: Registration request from the H323 device was rejected by the gatekeeper.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7130, '.1.3.6.1.4.1.9.9.156.1.11.1.1.22', 'ccmH323DevStatusReason', 7108, 'deprecated', NULL, 'The reason code associated with ccmH233DevStatus change. This is applicable only for H323 devices with gatekeepers configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7131, '.1.3.6.1.4.1.9.9.156.1.11.1.1.23', 'ccmH323DevTimeLastStatusUpdt', 7108, 'current', NULL, 'The time the registration status with the gatekeeper changed. This is applicable only for H323 devices with gatekeepers configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7132, '.1.3.6.1.4.1.9.9.156.1.11.1.1.24', 'ccmH323DevTimeLastRegistered', 7108, 'current', NULL, 'The time when the H323 device last registered with the gatekeeper. This is applicable only for H323 devices with gatekeepers configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7133, '.1.3.6.1.4.1.9.9.156.1.11.1.1.25', 'ccmH323DevRmtCM1InetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the first remote call manager. The value of this object is ''unknown(0)'' if the first remote call manager is not configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7134, '.1.3.6.1.4.1.9.9.156.1.11.1.1.26', 'ccmH323DevRmtCM1InetAddress', 7108, 'current', NULL, 'This object identifies the first remote call manager DNS name or IP address configured for this H323 device. When there is no first remote call manager configured, this object contains an empty string. The type of address for this is identified by ccmH323DevRmtCM1InetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7135, '.1.3.6.1.4.1.9.9.156.1.11.1.1.27', 'ccmH323DevRmtCM2InetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the second remote call manager. The value of this object is ''unknown(0)'' if the second remote call manager is not configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7136, '.1.3.6.1.4.1.9.9.156.1.11.1.1.28', 'ccmH323DevRmtCM2InetAddress', 7108, 'current', NULL, 'This object identifies the second remote call manager DNS name or IP address configured for this H323 device. When there is no second remote call manager configured, this object contains an empty string. The type of address for this is identified by ccmH323DevRmtCM2InetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7137, '.1.3.6.1.4.1.9.9.156.1.11.1.1.29', 'ccmH323DevRmtCM3InetAddressType', 7108, 'current', NULL, 'This object identifies the IP address type of the third remote call manager. The value of this object is ''unknown(0)'' if the third remote call manager is not configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7138, '.1.3.6.1.4.1.9.9.156.1.11.1.1.30', 'ccmH323DevRmtCM3InetAddress', 7108, 'current', NULL, 'This object identifies the third remote call manager DNS name or IP address configured for this H323 device. When there is no third remote call manager configured, this object contains an empty string. The type of address for this is identified by ccmH323DevRmtCM3InetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7139, '.1.3.6.1.4.1.9.9.156.1.11.1.1.31', 'ccmH323DevProductTypeIndex', 7108, 'current', NULL, 'A positive value of this index is used to identify the related product type entry in the ccmProductTypeTable. A value of 0 indicates that the index to the ccmProductTypeTable is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7140, '.1.3.6.1.4.1.9.9.156.1.11.1.1.32', 'ccmH323DevUnregReason', 7108, 'current', NULL, 'The reason code associated with unregistered H323 Device. This is applicable only for H323 devices with gatekeepers configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7141, '.1.3.6.1.4.1.9.9.156.1.11.1.1.33', 'ccmH323DevRegFailReason', 7108, 'current', NULL, 'The reason code associated with registration failed H323 Device. This is applicable only for H323 devices with gatekeepers configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7142, '.1.3.6.1.4.1.9.9.156.1.12.1', 'ccmVoiceMailDeviceTable', 6842, 'current', NULL, 'The table containing a list of all voice messaging devices which have tried to register with the local CUCM at least once. When the local CUCM is restarted, this table will be refreshed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7143, '.1.3.6.1.4.1.9.9.156.1.12.1.1', 'ccmVoiceMailDeviceEntry', 7142, 'current', NULL, 'An entry (conceptual row) in the VoiceMailDevice Table, containing the information about a particular Voice Messaging Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7144, '.1.3.6.1.4.1.9.9.156.1.12.1.1.1', 'ccmVMailDevIndex', 7143, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which identifies a voice messaging device entry in the table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7145, '.1.3.6.1.4.1.9.9.156.1.12.1.1.2', 'ccmVMailDevName', 7143, 'current', NULL, 'The name of the Voice Messaging Device. This name is assigned to the Voice Messaging Device when it is added to the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7146, '.1.3.6.1.4.1.9.9.156.1.12.1.1.3', 'ccmVMailDevProductId', 7143, 'obsolete', NULL, 'The product identifier of the Voice Messaging device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7147, '.1.3.6.1.4.1.9.9.156.1.12.1.1.4', 'ccmVMailDevDescription', 7143, 'current', NULL, 'The description of the Voice Messaging Device. This description is given when the Voice Messaging Device is configured in the CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7148, '.1.3.6.1.4.1.9.9.156.1.12.1.1.5', 'ccmVMailDevStatus', 7143, 'current', NULL, 'The status of the Voice Messaging Device. The Voice Messaging Device status changes from unknown to registered when it registers itself with the local CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7149, '.1.3.6.1.4.1.9.9.156.1.12.1.1.6', 'ccmVMailDevInetAddressType', 7143, 'current', NULL, 'This object identifies the IP address type of the Voice Messaging device. The value of this object is ''unknown(0)''if the IP address of the Voice Messaging device is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7150, '.1.3.6.1.4.1.9.9.156.1.12.1.1.7', 'ccmVMailDevInetAddress', 7143, 'current', NULL, 'This object identifies the IP Address of the Voice Messaging Device. If the IP Address is not available then this object contains an empty string. The type of address for this is identified by ccmVMailDevInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7151, '.1.3.6.1.4.1.9.9.156.1.12.1.1.8', 'ccmVMailDevStatusReason', 7143, 'deprecated', NULL, 'The reason code associated with the Voice Messaging Device status change.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7152, '.1.3.6.1.4.1.9.9.156.1.12.1.1.9', 'ccmVMailDevTimeLastStatusUpdt', 7143, 'current', NULL, 'The time the status of the voice messaging device changed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7153, '.1.3.6.1.4.1.9.9.156.1.12.1.1.10', 'ccmVMailDevTimeLastRegistered', 7143, 'current', NULL, 'The time the Voice Messaging Device has last registered with the call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7154, '.1.3.6.1.4.1.9.9.156.1.12.1.1.11', 'ccmVMailDevProductTypeIndex', 7143, 'current', NULL, 'A positive value of this index is used to identify the related product type entry in the ccmProductTypeTable. A value of 0 indicates that the index to the ccmProductTypeTable is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7155, '.1.3.6.1.4.1.9.9.156.1.12.1.1.12', 'ccmVMailDevUnregReason', 7143, 'current', NULL, 'The reason code associated with unregistered Voice Messaging Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7156, '.1.3.6.1.4.1.9.9.156.1.12.1.1.13', 'ccmVMailDevRegFailReason', 7143, 'current', NULL, 'The reason code associated with registration failed Voice Messaging Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7157, '.1.3.6.1.4.1.9.9.156.1.12.2', 'ccmVoiceMailDeviceDirNumTable', 6842, 'current', NULL, 'The table containing a list of directory numbers that are assigned to all of the registered and unregistered Voice Messaging Devices in the ccmVoiceMailDeviceTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7158, '.1.3.6.1.4.1.9.9.156.1.12.2.1', 'ccmVoiceMailDeviceDirNumEntry', 7157, 'current', NULL, 'An entry (conceptual row) in the VoiceMailDirNum Table, has the associated directory number for a Voice Messaging Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7159, '.1.3.6.1.4.1.9.9.156.1.12.2.1.1', 'ccmVMailDevDirNumIndex', 7158, 'current', NULL, 'An arbitrary integer, selected by the local system, which identifies a Directory Number of a Voice Messaging Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7160, '.1.3.6.1.4.1.9.9.156.1.12.2.1.2', 'ccmVMailDevDirNum', 7158, 'current', NULL, 'The Directory Number of the Voice Messaging Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7161, '.1.3.6.1.4.1.9.9.156.1.13.1', 'ccmQualityReportAlarmEnable', 6843, 'current', NULL, 'Allows the generation of the quality report alarm. true(1): Enabling this object will allow the CUCM agent to generate the ccmQualityReport alarm. This is the default value. false(2): Disabling this object will stop the generation of the ccmQualityReport alarm by the CUCM agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7162, '.1.3.6.1.4.1.9.9.156.1.14.1', 'ccmSIPDeviceTable', 6844, 'current', NULL, 'The table containing a list of all SIP trunk in the CUCM cluster which the local CUCM is aware of. When the local CUCM is restarted, this table will be refreshed. If the local CUCM is down, then this table will be empty.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7163, '.1.3.6.1.4.1.9.9.156.1.14.1.1', 'ccmSIPDeviceEntry', 7162, 'current', NULL, 'An entry (conceptual row) in the SIP Device Table, containing the information about a particular SIP Trunk Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7164, '.1.3.6.1.4.1.9.9.156.1.14.1.1.1', 'ccmSIPDevIndex', 7163, 'current', NULL, 'An arbitrary integer, selected by the local CUCM, which identifies a SIP Trunk Device entry in the table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7165, '.1.3.6.1.4.1.9.9.156.1.14.1.1.2', 'ccmSIPDevName', 7163, 'current', NULL, 'The device name assigned to the SIP Trunk Device. This name is assigned when a new SIP Trunk device is added to the CallManager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7166, '.1.3.6.1.4.1.9.9.156.1.14.1.1.3', 'ccmSIPDevProductTypeIndex', 7163, 'current', NULL, 'A positive value of this index is used to identify the related product type entry in the ccmProductTypeTable. A value of 0 indicates that the index to the ccmProductTypeTable is Unknown.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7167, '.1.3.6.1.4.1.9.9.156.1.14.1.1.4', 'ccmSIPDevDescription', 7163, 'current', NULL, 'A description of the SIP Trunk device. This description is given when the SIP Trunk device is configured in the CUCM.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7168, '.1.3.6.1.4.1.9.9.156.1.14.1.1.5', 'ccmSIPDevInetAddressType', 7163, 'deprecated', NULL, 'Identifies the IP address type of the SIP Trunk Device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7169, '.1.3.6.1.4.1.9.9.156.1.14.1.1.6', 'ccmSIPDevInetAddress', 7163, 'deprecated', NULL, 'Identifies last known IP Address of the SIP Trunk device. The type of address for this is identified by ccmSIPDevInetAddressType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7170, '.1.3.6.1.4.1.9.9.156.1.14.1.1.7', 'ccmSIPInTransportProtocolType', 7163, 'current', NULL, 'Specifies the transport protocol type used by CallManager for setting up incoming SIP call.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7171, '.1.3.6.1.4.1.9.9.156.1.14.1.1.8', 'ccmSIPInPortNumber', 7163, 'current', NULL, 'Specifies the port number used by CallManager for setting up incoming SIP call.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7172, '.1.3.6.1.4.1.9.9.156.1.14.1.1.9', 'ccmSIPOutTransportProtocolType', 7163, 'current', NULL, 'Specifies the transport protocol type used by CallManager for setting up outgoing SIP call.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7173, '.1.3.6.1.4.1.9.9.156.1.14.1.1.10', 'ccmSIPOutPortNumber', 7163, 'current', NULL, 'Specifies the port number used by CallManager for setting up outgoing SIP call.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7174, '.1.3.6.1.4.1.9.9.156.1.14.1.1.11', 'ccmSIPDevInetAddressIPv4', 7163, 'current', NULL, 'This object identifies the last known primary IPv4 address of the SIP Trunk Device. This object contains value zero if IPV4 address is not available', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7175, '.1.3.6.1.4.1.9.9.156.1.14.1.1.12', 'ccmSIPDevInetAddressIPv6', 7163, 'current', NULL, 'This object identifies the last known primary IPv6 address of the SIP Trunk Device. This object contains value zero if IPV6 address is not available', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7176, '.1.3.6.1.4.1.9.9.156.2', 'ccmMIBNotificationPrefix', 6829, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7177, '.1.3.6.1.4.1.9.9.156.2.0', 'ccmMIBNotifications', 7176, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7178, '.1.3.6.1.4.1.9.9.156.2.0.1', 'ccmCallManagerFailed', 7177, 'current', NULL, 'This Notification signifies that the CallManager process detects a failure in one of its critical subsystems. It can also be detected from a heartbeat/event monitoring process.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7179, '.1.3.6.1.4.1.9.9.156.2.0.2', 'ccmPhoneFailed', 7177, 'current', NULL, 'This Notification will be generated in the intervals specified in ccmPhoneFailedAlarmInterval if there is at least one entry in the ccmPhoneFailedTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7180, '.1.3.6.1.4.1.9.9.156.2.0.3', 'ccmPhoneStatusUpdate', 7177, 'current', NULL, 'This Notification will be generated in the intervals specified in ccmPhoneStatusUpdateInterv if there is at least one entry in the ccmPhoneStatusUpdateTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7181, '.1.3.6.1.4.1.9.9.156.2.0.4', 'ccmGatewayFailed', 7177, 'deprecated', NULL, 'This Notification indicates that at least one gateway has attempted to register or communicate with the CallManager and failed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7182, '.1.3.6.1.4.1.9.9.156.2.0.5', 'ccmMediaResourceListExhausted', 7177, 'current', NULL, 'This Notification indicates that the CallManager has run out a certain specified type of resource.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7183, '.1.3.6.1.4.1.9.9.156.2.0.6', 'ccmRouteListExhausted', 7177, 'current', NULL, 'This Notification indicates that the CallManager could not find an available route in the indicated route list.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7184, '.1.3.6.1.4.1.9.9.156.2.0.7', 'ccmGatewayLayer2Change', 7177, 'current', NULL, 'This Notification is sent when the D-Channel/Layer 2 of an interface in a skinny gateway that has registered with the CallManager changes state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7185, '.1.3.6.1.4.1.9.9.156.2.0.8', 'ccmMaliciousCall', 7177, 'current', NULL, 'This Notification is sent when a user registers a call as malicious with the local call manager.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7186, '.1.3.6.1.4.1.9.9.156.2.0.9', 'ccmQualityReport', 7177, 'current', NULL, 'This Notification is sent when a user reports a quality problem using the Quality Report Tool.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7187, '.1.3.6.1.4.1.9.9.156.2.0.10', 'ccmTLSConnectionFailure', 7177, 'current', NULL, 'This Notification is sent when CallManager fails to open TLS connection for the indicated device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7188, '.1.3.6.1.4.1.9.9.156.2.0.11', 'ccmGatewayFailedReason', 7177, 'current', NULL, 'This Notification indicates that at least one gateway has attempted to register or communicate with the CallManager and failed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7189, '.1.3.6.1.4.1.9.9.156.3', 'ciscoCcmMIBConformance', 6829, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7190, '.1.3.6.1.4.1.9.9.156.3.1', 'ciscoCcmMIBCompliances', 7189, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7191, '.1.3.6.1.4.1.9.9.156.3.2', 'ciscoCcmMIBGroups', 7189, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7192, '.1.3.6.1.4.1.9.9.156.3.1.1', 'ciscoCcmMIBCompliance', 7190, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7193, '.1.3.6.1.4.1.9.9.156.3.1.2', 'ciscoCcmMIBComplianceRev1', 7190, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7194, '.1.3.6.1.4.1.9.9.156.3.1.3', 'ciscoCcmMIBComplianceRev2', 7190, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7195, '.1.3.6.1.4.1.9.9.156.3.1.4', 'ciscoCcmMIBComplianceRev3', 7190, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7196, '.1.3.6.1.4.1.9.9.156.3.1.5', 'ciscoCcmMIBComplianceRev4', 7190, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7197, '.1.3.6.1.4.1.9.9.156.3.1.6', 'ciscoCcmMIBComplianceRev5', 7190, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7198, '.1.3.6.1.4.1.9.9.156.3.1.7', 'ciscoCcmMIBComplianceRev6', 7190, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7200, '.1.3.6.1.4.1.9.9.156.3.2.1', 'ccmInfoGroup', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all CallManagers and its related information within a call manager cluster. It comprises of all the CallManager tables, apart from Region, TimeZone and Device Pool tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7201, '.1.3.6.1.4.1.9.9.156.3.2.2', 'ccmPhoneInfoGroup', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all phones within the scope of a CallManager. It comprises of the Phone and Phone Extension tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7202, '.1.3.6.1.4.1.9.9.156.3.2.3', 'ccmGatewayInfoGroup', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all Gateways and Gateway Trunks within the scope of a CallManager. It comprises of the Gateway and Gateway Trunk tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7203, '.1.3.6.1.4.1.9.9.156.3.2.4', 'ccmInfoGroupRev1', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all CallManagers and its related information within a call manager cluster. It comprises of all the CallManager tables, apart from Region, TimeZone and Device Pool tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7204, '.1.3.6.1.4.1.9.9.156.3.2.5', 'ccmPhoneInfoGroupRev1', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all phones within the scope of a CallManager. It comprises of the Phone and Phone Extension tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7205, '.1.3.6.1.4.1.9.9.156.3.2.6', 'ccmGatewayInfoGroupRev1', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all Gateways and Gateway Trunks within the scope of a CallManager. It comprises of the Gateway and Gateway Trunk tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7206, '.1.3.6.1.4.1.9.9.156.3.2.7', 'ccmMediaDeviceInfoGroup', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all Media Devices within the scope of a CallManager. It comprises of the MediaDevice table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7207, '.1.3.6.1.4.1.9.9.156.3.2.8', 'ccmGatekeeperInfoGroup', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all Gatekeeper within the scope of a CallManager. It comprises of the Gatekeeper table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7208, '.1.3.6.1.4.1.9.9.156.3.2.9', 'ccmCTIDeviceInfoGroup', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all CTI Devices within the scope of a CallManager. It comprises of the ccmCTIDevice and ccmCTIDeviceDirNum tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7209, '.1.3.6.1.4.1.9.9.156.3.2.10', 'ccmNotificationsInfoGroup', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all the Notifications generated by the CUCM Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7210, '.1.3.6.1.4.1.9.9.156.3.2.11', 'ccmNotificationsGroup', 7191, 'obsolete', NULL, 'A collection of notifications that are generated by the CUCM Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7211, '.1.3.6.1.4.1.9.9.156.3.2.12', 'ccmInfoGroupRev2', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all CallManagers and its related information within a call manager cluster. It comprises of GroupTable, ccmTable, GroupMappingTable, Region, TimeZone, and Device Pool tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7212, '.1.3.6.1.4.1.9.9.156.3.2.13', 'ccmPhoneInfoGroupRev2', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all phones within the scope of the local CallManager. It comprises of the Phone and Phone Extension tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7213, '.1.3.6.1.4.1.9.9.156.3.2.14', 'ccmGatewayInfoGroupRev2', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all Gateways within the scope of the local CallManager. It comprises of the Gateway table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7214, '.1.3.6.1.4.1.9.9.156.3.2.15', 'ccmMediaDeviceInfoGroupRev1', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all Media Devices within the scope of the local CallManager. It comprises of the MediaDevice table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7215, '.1.3.6.1.4.1.9.9.156.3.2.16', 'ccmCTIDeviceInfoGroupRev1', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all CTI Devices within the scope of the local CallManager. It comprises of the ccmCTIDevice and ccmCTIDeviceDirNum tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7216, '.1.3.6.1.4.1.9.9.156.3.2.17', 'ccmH323DeviceInfoGroup', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all H323 devices within the scope of the local CallManager. It comprises of the H323Device table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7217, '.1.3.6.1.4.1.9.9.156.3.2.18', 'ccmVoiceMailDeviceInfoGroup', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all Voice Messaging Devices within the scope of the local CallManager. It comprises of the ccmVoiceMailDevice and ccmVoiceMailDirNum tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7218, '.1.3.6.1.4.1.9.9.156.3.2.19', 'ccmNotificationsInfoGroupRev1', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all the Notifications generated by the CUCM Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7219, '.1.3.6.1.4.1.9.9.156.3.2.20', 'ccmInfoGroupRev3', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all CallManagers and its related information within a call manager cluster. It comprises of GroupTable, ccmTable, GroupMappingTable, Region, TimeZone, Device Pool and ProductType tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7220, '.1.3.6.1.4.1.9.9.156.3.2.21', 'ccmNotificationsInfoGroupRev2', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all the Notifications generated by the CUCM Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7221, '.1.3.6.1.4.1.9.9.156.3.2.22', 'ccmNotificationsGroupRev1', 7191, 'obsolete', NULL, 'A collection of notifications that are generated by the CUCM Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7222, '.1.3.6.1.4.1.9.9.156.3.2.23', 'ccmSIPDeviceInfoGroup', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all SIP devices within the scope of the local CallManager. It comprises of the SIP Device table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7223, '.1.3.6.1.4.1.9.9.156.3.2.24', 'ccmPhoneInfoGroupRev3', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all phones within the scope of the local CallManager. It comprises of the Phone and Phone Extension tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7224, '.1.3.6.1.4.1.9.9.156.3.2.25', 'ccmGatewayInfoGroupRev3', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all Gateways within the scope of the local CallManager. It comprises of the Gateway table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7225, '.1.3.6.1.4.1.9.9.156.3.2.26', 'ccmMediaDeviceInfoGroupRev2', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all Media Devices within the scope of the local CallManager. It comprises of the MediaDevice table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7226, '.1.3.6.1.4.1.9.9.156.3.2.27', 'ccmCTIDeviceInfoGroupRev2', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all CTI Devices within the scope of the local CallManager. It comprises of the ccmCTIDevice and ccmCTIDeviceDirNum tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7227, '.1.3.6.1.4.1.9.9.156.3.2.28', 'ccmH323DeviceInfoGroupRev1', 7191, 'obsolete', NULL, 'A collection of objects which provide info about all H323 devices within the scope of the local CallManager. It comprises of the H323Device table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7228, '.1.3.6.1.4.1.9.9.156.3.2.29', 'ccmVoiceMailDeviceInfoGroupRev1', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all Voice Messaging Devices within the scope of the local CallManager. It comprises of the ccmVoiceMailDevice and ccmVoiceMailDirNum tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7229, '.1.3.6.1.4.1.9.9.156.3.2.30', 'ccmPhoneInfoGroupRev4', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all phones within the scope of the local CallManager. It comprises of the Phone and Phone Extension tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7230, '.1.3.6.1.4.1.9.9.156.3.2.31', 'ccmSIPDeviceInfoGroupRev1', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all SIP Trunk devices within the scope of the local CallManager. It comprises of the SIP Device table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7232, '.1.3.6.1.4.1.9.9.156.3.2.33', 'ccmNotificationsGroupRev2', 7191, 'deprecated', NULL, 'A collection of notifications that are generated by the CUCM Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7233, '.1.3.6.1.4.1.9.9.156.3.2.34', 'ccmInfoGroupRev4', 7191, 'current', NULL, 'A collection of objects which provide info about all Cisco Unified Communications Managers and its related information within a CUCM cluster. It comprises of GroupTable, ccmTable, GroupMappingTable, Region, TimeZone, Device Pool and ProductType tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7234, '.1.3.6.1.4.1.9.9.156.3.2.35', 'ccmPhoneInfoGroupRev5', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all phones within the scope of the local Cisco Unified Communications Manager. It comprises of the Phone and Phone Extension tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7235, '.1.3.6.1.4.1.9.9.156.3.2.36', 'ccmMediaDeviceInfoGroupRev3', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all Media Devices within the scope of the local Cisco Unified Communications Manager. It comprises of the MediaDevice table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7236, '.1.3.6.1.4.1.9.9.156.3.2.37', 'ccmSIPDeviceInfoGroupRev2', 7191, 'current', NULL, 'A collection of objects which provide info about all SIP Trunk devices within the scope of the local Cisco Unified Communications Manager. It comprises of the SIP Device table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7237, '.1.3.6.1.4.1.9.9.156.3.2.38', 'ccmNotificationsInfoGroupRev4', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all the Notifications generated by the CISCO CUCM Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7238, '.1.3.6.1.4.1.9.9.156.3.2.39', 'ccmH323DeviceInfoGroupRev2', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all H323 devices within the scope of the local Cisco Unified Communications Manager. It comprises of the H323Device table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7239, '.1.3.6.1.4.1.9.9.156.3.2.40', 'ccmCTIDeviceInfoGroupRev3', 7191, 'deprecated', NULL, 'A collection of objects which provide info about all CTI Devices within the scope of the local CUCM. It comprises of the ccmCTIDevice and ccmCTIDeviceDirNum tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7240, '.1.3.6.1.4.1.9.9.156.3.2.41', 'ccmPhoneInfoGroupRev6', 7191, 'current', NULL, 'A collection of objects which provide info about all phones within the scope of the local Cisco Unified Communications Manager. It comprises of the Phone and Phone Extension tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7241, '.1.3.6.1.4.1.9.9.156.3.2.42', 'ccmNotificationsInfoGroupRev5', 7191, 'current', NULL, 'A collection of objects which provide info about all the Notifications generated by the CISCO CUCM Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7242, '.1.3.6.1.4.1.9.9.156.3.2.43', 'ccmGatewayInfoGroupRev4', 7191, 'current', NULL, 'A collection of objects which provide info about all Gateways within the scope of the local CallManager. It comprises of the Gateway table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7243, '.1.3.6.1.4.1.9.9.156.3.2.44', 'ccmMediaDeviceInfoGroupRev4', 7191, 'current', NULL, 'A collection of objects which provide info about all Media Devices within the scope of the local Cisco Unified Communications Manager. It comprises of the MediaDevice table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7244, '.1.3.6.1.4.1.9.9.156.3.2.45', 'ccmCTIDeviceInfoGroupRev4', 7191, 'current', NULL, 'A collection of objects which provide info about all CTI Devices within the scope of the local CUCM. It comprises of the ccmCTIDevice and ccmCTIDeviceDirNum tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7245, '.1.3.6.1.4.1.9.9.156.3.2.46', 'ccmH323DeviceInfoGroupRev3', 7191, 'current', NULL, 'A collection of objects which provide info about all H323 devices within the scope of the local Cisco Unified Communications Manager. It comprises of the H323Device table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7246, '.1.3.6.1.4.1.9.9.156.3.2.47', 'ccmVoiceMailDeviceInfoGroupRev2', 7191, 'current', NULL, 'A collection of objects which provide info about all Voice Messaging Devices within the scope of the local CallManager. It comprises of the ccmVoiceMailDevice and ccmVoiceMailDirNum tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7247, '.1.3.6.1.4.1.9.9.156.3.2.48', 'ccmNotificationsGroupRev3', 7191, 'current', NULL, 'A collection of notifications that are generated by the CUCM Agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7248, '.1.3.6.1.2.1.10.20', 'isdnMib', 22, 'current', NULL, 'The MIB module to describe the management of ISDN interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7249, '.1.3.6.1.2.1.10.20.1', 'isdnMibObjects', 7248, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7250, '.1.3.6.1.2.1.10.20.1.1', 'isdnBasicRateGroup', 7249, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7251, '.1.3.6.1.2.1.10.20.1.1.1', 'isdnBasicRateTable', 7250, 'current', NULL, 'Table containing configuration and operational parameters for all physical Basic Rate interfaces on this managed device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7252, '.1.3.6.1.2.1.10.20.1.1.1.1', 'isdnBasicRateEntry', 7251, 'current', NULL, 'An entry in the ISDN Basic Rate Table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7253, '.1.3.6.1.2.1.10.20.1.1.1.1.1', 'isdnBasicRateIfType', 7252, 'current', NULL, 'The physical interface type. For ''S/T'' interfaces, also called ''Four-wire Basic Access Interface'', the value of this object is isdns(75). For ''U'' interfaces, also called ''Two-wire Basic Access Interface'', the value of this object is isdnu(76).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7254, '.1.3.6.1.2.1.10.20.1.1.1.1.2', 'isdnBasicRateLineTopology', 7252, 'current', NULL, 'The line topology to be used for this interface. Note that setting isdnBasicRateIfType to isdns(75) does not necessarily mean a line topology of point-to-multipoint.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7255, '.1.3.6.1.2.1.10.20.1.1.1.1.3', 'isdnBasicRateIfMode', 7252, 'current', NULL, 'The physical interface mode. For TE mode, the value of this object is te(1). For NT mode, the value of this object is nt(2).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7256, '.1.3.6.1.2.1.10.20.1.1.1.1.4', 'isdnBasicRateSignalMode', 7252, 'current', NULL, 'The signaling channel operational mode for this interface. If active(1) there is a signaling channel on this interface. If inactive(2) a signaling channel is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7257, '.1.3.6.1.2.1.10.20.1.2', 'isdnBearerGroup', 7249, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7258, '.1.3.6.1.2.1.10.20.1.2.1', 'isdnBearerTable', 7257, 'current', NULL, 'This table defines port specific operational, statistics and active call data for ISDN B channels. Each entry in this table describes one B (bearer) channel.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7259, '.1.3.6.1.2.1.10.20.1.2.1.1', 'isdnBearerEntry', 7258, 'current', NULL, 'Operational and statistics information relating to one port. A port is a single B channel.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7260, '.1.3.6.1.2.1.10.20.1.2.1.1.1', 'isdnBearerChannelType', 7259, 'current', NULL, 'The B channel type. If the B channel is connected to a dialup line, this object has a value of dialup(1). In this case, it is controlled by an associated signaling channel. If the B channel is connected to a leased line, this object has a value of leased(2). For leased line B channels, there is no signaling channel control available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7261, '.1.3.6.1.2.1.10.20.1.2.1.1.2', 'isdnBearerOperStatus', 7259, 'current', NULL, 'The current call control state for this port. idle(1): The B channel is idle. No call or call attempt is going on. connecting(2): A connection attempt (outgoing call) is being made on this interface. connected(3): An incoming call is in the process of validation. active(4): A call is active on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7262, '.1.3.6.1.2.1.10.20.1.2.1.1.3', 'isdnBearerChannelNumber', 7259, 'current', NULL, 'The identifier being used by a signaling protocol to identify this B channel, also referred to as B channel number. If the Agent also supports the DS0 MIB, the values of isdnBearerChannelNumber and dsx0Ds0Number must be identical for a given B channel.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7286, '.1.3.6.1.2.1.10.20.1.3.3.1.2', 'isdnSigStatsInConnected', 7284, 'current', NULL, 'The number of incoming calls on this interface which were actually connected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7287, '.1.3.6.1.2.1.10.20.1.3.3.1.3', 'isdnSigStatsOutCalls', 7284, 'current', NULL, 'The number of outgoing calls on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7263, '.1.3.6.1.2.1.10.20.1.2.1.1.4', 'isdnBearerPeerAddress', 7259, 'current', 'ITU-T E.164, Q.931 chapter 4.5.10', 'The ISDN address the current or last call is or was connected to.  In some cases, the format of this information can not be predicted, since it largely depends on the type of switch or PBX the device is connected to. Therefore, the detailed format of this information is not specified and is implementation dependent.  If possible, the agent should supply this information using the E.164 format. In this case, the number must start with ''+''. Otherwise, IA5 number digits must be used.  If the peer ISDN address is not available, this object has a length of zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7264, '.1.3.6.1.2.1.10.20.1.2.1.1.5', 'isdnBearerPeerSubAddress', 7259, 'current', 'ITU-T I.330, Q.931 chapter 4.5.11', 'The ISDN subaddress the current or last call is or was connected to.  The subaddress is an user supplied string of up to 20 IA5 characters and is transmitted transparently through the network.  If the peer subaddress is not available, this object has a length of zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7265, '.1.3.6.1.2.1.10.20.1.2.1.1.6', 'isdnBearerCallOrigin', 7259, 'current', NULL, 'The call origin for the current or last call. If since system startup there was no call on this interface, this object has a value of unknown(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7266, '.1.3.6.1.2.1.10.20.1.2.1.1.7', 'isdnBearerInfoType', 7259, 'current', 'Q.931 [8], chapter 4.5.5, octet 3 of bearer capability information element, combined with the User Rate (as defined in octets 5 and 5a to 5d), if rate adaption is being used.', 'The Information Transfer Capability for the current or last call.  speech(2) refers to a non-data connection, whereas audio31(6) and audio7(7) refer to data mode connections.  Note that Q.931, chapter 4.5.5, originally defined audio7(7) as ''7 kHz audio'' and now defines it as ''Unrestricted digital information with tones/ announcements''.  If since system startup there has been no call on this interface, this object has a value of unknown(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7267, '.1.3.6.1.2.1.10.20.1.2.1.1.8', 'isdnBearerMultirate', 7259, 'current', 'Q.931 [8], chapter 4.5.5.', 'This flag indicates if the current or last call used multirate. The actual information transfer rate, in detail specified in octet 4.1 (rate multiplier), is the sum of all B channel ifSpeed values for the hyperchannel.  If since system startup there was no call on this interface, this object has a value of false(2).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7268, '.1.3.6.1.2.1.10.20.1.2.1.1.9', 'isdnBearerCallSetupTime', 7259, 'current', NULL, 'The value of sysUpTime when the ISDN setup message for the current or last call was sent or received. If since system startup there has been no call on this interface, this object has a value of zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7269, '.1.3.6.1.2.1.10.20.1.2.1.1.10', 'isdnBearerCallConnectTime', 7259, 'current', NULL, 'The value of sysUpTime when the ISDN connect message for the current or last call was sent or received. If since system startup there has been no call on this interface, this object has a value of zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7270, '.1.3.6.1.2.1.10.20.1.2.1.1.11', 'isdnBearerChargedUnits', 7259, 'current', NULL, 'The number of charged units for the current or last connection. For incoming calls or if charging information is not supplied by the switch, the value of this object is zero.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7271, '.1.3.6.1.2.1.10.20.1.3', 'isdnSignalingGroup', 7249, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7272, '.1.3.6.1.2.1.10.20.1.3.1', 'isdnSignalingGetIndex', 7271, 'current', 'RFC1903, TestAndIncr textual convention.', 'The recommended procedure for selecting a new index for isdnSignalingTable row creation is to GET the value of this object, and then to SET the object with the same value. If the SET operation succeeds, the manager can use this value as an index to create a new row in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7273, '.1.3.6.1.2.1.10.20.1.3.2', 'isdnSignalingTable', 7271, 'current', NULL, 'ISDN signaling table containing configuration and operational parameters for all ISDN signaling channels on this managed device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7274, '.1.3.6.1.2.1.10.20.1.3.2.1', 'isdnSignalingEntry', 7273, 'current', NULL, 'An entry in the ISDN Signaling Table. To create a new entry, only isdnSignalingProtocol needs to be specified before isdnSignalingStatus can become active(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7275, '.1.3.6.1.2.1.10.20.1.3.2.1.1', 'isdnSignalingIndex', 7274, 'current', NULL, 'The index value which uniquely identifies an entry in the isdnSignalingTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7276, '.1.3.6.1.2.1.10.20.1.3.2.1.2', 'isdnSignalingIfIndex', 7274, 'current', NULL, 'The ifIndex value of the interface associated with this signaling channel.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7277, '.1.3.6.1.2.1.10.20.1.3.2.1.3', 'isdnSignalingProtocol', 7274, 'current', NULL, 'The particular protocol type supported by the switch providing access to the ISDN network to which this signaling channel is connected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7278, '.1.3.6.1.2.1.10.20.1.3.2.1.4', 'isdnSignalingCallingAddress', 7274, 'current', 'ITU-T E.164, Q.931 chapter 4.5.10', 'The ISDN Address to be assigned to this signaling channel. More specifically, this is the ''Calling Address information element'' as being passed to the switch in outgoing call setup messages.  It can be an EAZ (1TR6), a calling number (DSS1, ETSI) or any other number necessary to identify a signaling interface. If there is no such number defined or required, this is a zero length string. It is represented in DisplayString form.  Incoming calls can also be identified by this number. If the Directory Number, i.e. the Called Number in incoming calls, is different to this number, the isdnDirectoryTable has to be used to specify all possible Directory Numbers.  The format of this information largely depends on the type of switch or PBX the device is connected to. Therefore, the detailed format of this information is not specified and is implementation dependent.  If possible, the agent should implement this information using the E.164 number format. In this case, the number must start with ''+''. Otherwise, IA5 number digits must be used.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7279, '.1.3.6.1.2.1.10.20.1.3.2.1.5', 'isdnSignalingSubAddress', 7274, 'current', 'ITU-T I.330, Q.931 chapter 4.5.11', 'Supplementary information to the ISDN address assigned to this signaling channel. Usually, this is the subaddress as defined in Q.931. If there is no such number defined or required, this is a zero length string. The subaddress is used for incoming calls as well as for outgoing calls. The subaddress is an user supplied string of up to 20 IA5 characters and is transmitted transparently through the network.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7280, '.1.3.6.1.2.1.10.20.1.3.2.1.6', 'isdnSignalingBchannelCount', 7274, 'current', NULL, 'The total number of B channels (bearer channels) managed by this signaling channel. The default value of this object depends on the physical interface type and is either 2 for Basic Rate interfaces or 24 (30) for Primary Rate interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7281, '.1.3.6.1.2.1.10.20.1.3.2.1.7', 'isdnSignalingInfoTrapEnable', 7274, 'current', NULL, 'Indicates whether isdnMibCallInformation traps should be generated for calls on this signaling channel.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7282, '.1.3.6.1.2.1.10.20.1.3.2.1.8', 'isdnSignalingStatus', 7274, 'current', NULL, 'This object is used to create and delete rows in the isdnSignalingTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7283, '.1.3.6.1.2.1.10.20.1.3.3', 'isdnSignalingStatsTable', 7271, 'current', NULL, 'ISDN signaling table containing statistics information for all ISDN signaling channels on this managed device. Only statistical information which is not already being counted in the ifTable is being defined in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7284, '.1.3.6.1.2.1.10.20.1.3.3.1', 'isdnSignalingStatsEntry', 7283, 'current', NULL, 'An entry in the ISDN Signaling statistics Table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7285, '.1.3.6.1.2.1.10.20.1.3.3.1.1', 'isdnSigStatsInCalls', 7284, 'current', NULL, 'The number of incoming calls on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7288, '.1.3.6.1.2.1.10.20.1.3.3.1.4', 'isdnSigStatsOutConnected', 7284, 'current', NULL, 'The number of outgoing calls on this interface which were actually connected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7289, '.1.3.6.1.2.1.10.20.1.3.3.1.5', 'isdnSigStatsChargedUnits', 7284, 'current', NULL, 'The number of charging units on this interface since system startup. Only the charging units applying to the local interface, i.e. for originated calls or for calls with ''Reverse charging'' being active, are counted here.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7290, '.1.3.6.1.2.1.10.20.1.3.4', 'isdnLapdTable', 7271, 'current', NULL, 'Table containing configuration and statistics information for all LAPD (D channel Data Link) interfaces on this managed device. Only statistical information which is not already being counted in the ifTable is being defined in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7291, '.1.3.6.1.2.1.10.20.1.3.4.1', 'isdnLapdEntry', 7290, 'current', NULL, 'An entry in the LAPD Table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7292, '.1.3.6.1.2.1.10.20.1.3.4.1.1', 'isdnLapdPrimaryChannel', 7291, 'current', 'Q.931 [8], Annex F, D channel backup procedures.', 'If set to true(1), this D channel is the designated primary D channel if D channel backup is active. There must be exactly one primary D channel configured. If D channel backup is not used, this object has a value of true(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7293, '.1.3.6.1.2.1.10.20.1.3.4.1.2', 'isdnLapdOperStatus', 7291, 'current', NULL, 'The operational status of this interface:  inactive all layers are inactive l1Active layer 1 is activated, layer 2 datalink not established l2Active layer 1 is activated, layer 2 datalink established.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7294, '.1.3.6.1.2.1.10.20.1.3.4.1.3', 'isdnLapdPeerSabme', 7291, 'current', NULL, 'The number of peer SABME frames received on this interface. This is the number of peer-initiated new connections on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7295, '.1.3.6.1.2.1.10.20.1.3.4.1.4', 'isdnLapdRecvdFrmr', 7291, 'current', NULL, 'The number of LAPD FRMR response frames received. This is the number of framing errors on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7296, '.1.3.6.1.2.1.10.20.1.4', 'isdnEndpointGroup', 7249, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7297, '.1.3.6.1.2.1.10.20.1.4.1', 'isdnEndpointGetIndex', 7296, 'current', 'RFC1903, TestAndIncr textual convention.', 'The recommended procedure for selecting a new index for isdnEndpointTable row creation is to GET the value of this object, and then to SET the object with the same value. If the SET operation succeeds, the manager can use this value as an index to create a new row in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7298, '.1.3.6.1.2.1.10.20.1.4.2', 'isdnEndpointTable', 7296, 'current', NULL, 'Table containing configuration for Terminal Endpoints.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7299, '.1.3.6.1.2.1.10.20.1.4.2.1', 'isdnEndpointEntry', 7298, 'current', NULL, 'An entry in the Terminal Endpoint Table. The value of isdnEndpointIfType must be supplied for a row in this table to become active.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7300, '.1.3.6.1.2.1.10.20.1.4.2.1.1', 'isdnEndpointIndex', 7299, 'current', NULL, 'The index value which uniquely identifies an entry in the isdnEndpointTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7301, '.1.3.6.1.2.1.10.20.1.4.2.1.2', 'isdnEndpointIfIndex', 7299, 'current', NULL, 'The ifIndex value of the interface associated with this Terminal Endpoint.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7302, '.1.3.6.1.2.1.10.20.1.4.2.1.3', 'isdnEndpointIfType', 7299, 'current', NULL, 'The interface type for this Terminal Endpoint. Interface types of x25ple(40) and isdn(63) are allowed. The interface type is identical to the value of ifType in the associated ifEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7303, '.1.3.6.1.2.1.10.20.1.4.2.1.4', 'isdnEndpointTeiType', 7299, 'current', NULL, 'The type of TEI (Terminal Endpoint Identifier) used for this Terminal Endpoint. In case of dynamic(1), the TEI value is selected by the switch. In case of static(2), a valid TEI value has to be entered in the isdnEndpointTeiValue object. The default value for this object depends on the interface type as well as the Terminal Endpoint type. On Primary Rate interfaces the default value is static(2). On Basic Rate interfaces the default value is dynamic(1) for isdn(63) Terminal Endpoints and static(2) for x25ple(40) Terminal Endpoints.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7304, '.1.3.6.1.2.1.10.20.1.4.2.1.5', 'isdnEndpointTeiValue', 7299, 'current', NULL, 'The TEI (Terminal Endpoint Identifier) value for this Terminal Endpoint. If isdnEndpointTeiType is set to static(2), valid numbers are 0..63, while otherwise the value is set internally. The default value of this object is 0 for static TEI assignment. The default value for dynamic TEI assignment is also 0 as long as no TEI has been assigned. After TEI assignment, the assigned TEI value is returned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7305, '.1.3.6.1.2.1.10.20.1.4.2.1.6', 'isdnEndpointSpid', 7299, 'current', 'Bellcore SR-NWT-001953, Generic Guidelines for ISDN Terminal Equipment on Basic Access Interfaces, Chapter 8.5.1.', 'The Service profile IDentifier (SPID) information for this Terminal Endpoint.  The SPID is composed of 9-20 numeric characters.  This information has to be defined in addition to the local number for some switch protocol types, e.g. Bellcore NI-1 and NI-2.  If this object is not required, it is a zero length string.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7306, '.1.3.6.1.2.1.10.20.1.4.2.1.7', 'isdnEndpointStatus', 7299, 'current', NULL, 'This object is used to create and delete rows in the isdnEndpointTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7307, '.1.3.6.1.2.1.10.20.1.5', 'isdnDirectoryGroup', 7249, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7308, '.1.3.6.1.2.1.10.20.1.5.1', 'isdnDirectoryTable', 7307, 'current', NULL, 'Table containing Directory Numbers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7309, '.1.3.6.1.2.1.10.20.1.5.1.1', 'isdnDirectoryEntry', 7308, 'current', NULL, 'An entry in the Directory Number Table. All objects in an entry must be set for a new row to become active.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7310, '.1.3.6.1.2.1.10.20.1.5.1.1.1', 'isdnDirectoryIndex', 7309, 'current', NULL, 'The index value which uniquely identifies an entry in the isdnDirectoryTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7311, '.1.3.6.1.2.1.10.20.1.5.1.1.2', 'isdnDirectoryNumber', 7309, 'current', 'ITU-T E.164, Q.931 chapter 4.5.10', 'A Directory Number. Directory Numbers are used to identify incoming calls on the signaling channel given in isdnDirectorySigIndex.  The format of this information largely depends on the type of switch or PBX the device is connected to. Therefore, the detailed format of this information is not specified and is implementation dependent.  If possible, the agent should implement this information using the E.164 number format. In this case, the number must start with ''+''. Otherwise, IA5 number digits must be used.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7312, '.1.3.6.1.2.1.10.20.1.5.1.1.3', 'isdnDirectorySigIndex', 7309, 'current', NULL, 'An index pointing to an ISDN signaling channel. Incoming calls are accepted on this signaling channel if the isdnDirectoryNumber is presented as Called Number in the SETUP message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7313, '.1.3.6.1.2.1.10.20.1.5.1.1.4', 'isdnDirectoryStatus', 7309, 'current', NULL, 'This object is used to create and delete rows in the isdnDirectoryTable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7314, '.1.3.6.1.2.1.10.20.2', 'isdnMibTrapPrefix', 7248, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7315, '.1.3.6.1.2.1.10.20.2.0', 'isdnMibTraps', 7314, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7359, '.1.3.6.1.4.1.9.9.26.3.2.1', 'ciscoIsdnMibGroup', 7356, 'current', NULL, 'A collection of objects providing the ISDN MIB capability.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7360, '.1.3.6.1.4.1.9.9.26.3.2.2', 'ciscoIsdnMibGroupRev1', 7356, 'current', NULL, 'A collection of objects providing the call origin capability.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7393, '.1.3.6.1.4.1.9.9.392.1.3.21.1.3', 'crasSessionIndex', 7390, 'current', NULL, 'Unique index to distinguish between multiple Remote Access Sessions associated with the same user.  The value of crasSessionIndex must increase monotonically till it wraps. An implementation may choose to wrap this index before the value of 2147483647.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7394, '.1.3.6.1.4.1.9.9.392.1.3.21.1.4', 'crasAuthenMethod', 7390, 'current', NULL, 'The method used to authenticate the user prior to establishing the session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7316, '.1.3.6.1.2.1.10.20.2.0.1', 'isdnMibCallInformation', 7315, 'current', NULL, 'This trap/inform is sent to the manager under the following condidions: - on incoming calls for each call which is rejected for policy reasons (e.g. unknown neighbor or access violation) - on outgoing calls whenever a call attempt is determined to have ultimately failed. In the event that call retry is active, then this will be after all retry attempts have failed. - whenever a call connects. In this case, the object isdnBearerCallConnectTime should be included in the trap.  Only one such trap is sent in between successful or unsuccessful call attempts from or to a single neighbor; subsequent call attempts result in no trap.  If the Dial Control MIB objects dialCtlNbrCfgId and dialCtlNbrCfgIndex are known by the entity generating this trap, both objects should be included in the trap as well. The receipt of this trap with no dial neighbor information indicates that the manager must poll the callHistoryTable of the Dial Control MIB to see what changed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7317, '.1.3.6.1.2.1.10.20.3', 'isdnMibConformance', 7248, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7318, '.1.3.6.1.2.1.10.20.3.1', 'isdnMibCompliances', 7317, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7319, '.1.3.6.1.2.1.10.20.3.2', 'isdnMibGroups', 7317, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7320, '.1.3.6.1.2.1.10.20.3.1.1', 'isdnMibCompliance', 7318, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7321, '.1.3.6.1.2.1.10.20.3.2.1', 'isdnMibBasicRateGroup', 7319, 'current', NULL, 'A collection of objects required for ISDN Basic Rate physical interface configuration and statistics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7322, '.1.3.6.1.2.1.10.20.3.2.2', 'isdnMibBearerGroup', 7319, 'current', NULL, 'A collection of objects required for ISDN Bearer channel control and statistics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7323, '.1.3.6.1.2.1.10.20.3.2.3', 'isdnMibSignalingGroup', 7319, 'current', NULL, 'A collection of objects required for ISDN D channel configuration and statistics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7324, '.1.3.6.1.2.1.10.20.3.2.4', 'isdnMibEndpointGroup', 7319, 'current', NULL, 'A collection of objects describing Terminal Endpoints.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7325, '.1.3.6.1.2.1.10.20.3.2.5', 'isdnMibDirectoryGroup', 7319, 'current', NULL, 'A collection of objects describing directory numbers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7326, '.1.3.6.1.4.1.9.9.26', 'ciscoIsdnMib', 272, 'current', NULL, 'The MIB module to describe the status of the ISDN Interfaces on the routers.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7327, '.1.3.6.1.4.1.9.9.26.1', 'ciscoIsdnMibObjects', 7326, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7328, '.1.3.6.1.4.1.9.9.26.1.1', 'isdnNeighbor', 7327, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7329, '.1.3.6.1.4.1.9.9.26.1.1.1', 'demandNbrTable', 7328, 'current', NULL, 'The list of neighbors from which the router will accept calls or to which it will place them.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7330, '.1.3.6.1.4.1.9.9.26.1.1.1.1', 'demandNbrEntry', 7329, 'current', NULL, 'A single Neighbor. This entry is effectively permanent, and contains information describing the neighbor, his permissions, his last call attempt, and his cumulative effects.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7331, '.1.3.6.1.4.1.9.9.26.1.1.1.1.1', 'demandNbrPhysIf', 7330, 'current', NULL, 'ifIndex value of the physical interface the neighbor will be called on. On an ISDN interface, this is the ifIndex value of the D channel.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7332, '.1.3.6.1.4.1.9.9.26.1.1.1.1.2', 'demandNbrId', 7330, 'current', NULL, 'arbitrary sequence number associated with the neighbor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7333, '.1.3.6.1.4.1.9.9.26.1.1.1.1.3', 'demandNbrLogIf', 7330, 'current', NULL, 'ifIndex value of virtual interface associated with the neighbor. This interface maintains a queue of messages holding for the neighbor awaiting call completion, and all statistics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7334, '.1.3.6.1.4.1.9.9.26.1.1.1.1.4', 'demandNbrName', 7330, 'current', NULL, 'ASCII name of the neighbor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7335, '.1.3.6.1.4.1.9.9.26.1.1.1.1.5', 'demandNbrAddress', 7330, 'current', NULL, 'Call Address at which the neighbor should be called. Think of this as the set of characters following ''ATDT '' or the ''phone number'' included in a D channel call request.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7336, '.1.3.6.1.4.1.9.9.26.1.1.1.1.6', 'demandNbrPermission', 7330, 'current', NULL, 'applicable permissions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7337, '.1.3.6.1.4.1.9.9.26.1.1.1.1.7', 'demandNbrMaxDuration', 7330, 'current', NULL, 'Maximum call duration in seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7338, '.1.3.6.1.4.1.9.9.26.1.1.1.1.8', 'demandNbrLastDuration', 7330, 'current', NULL, 'Duration of last call in seconds.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7339, '.1.3.6.1.4.1.9.9.26.1.1.1.1.9', 'demandNbrClearReason', 7330, 'current', NULL, 'ASCII reason that the last call terminated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7340, '.1.3.6.1.4.1.9.9.26.1.1.1.1.10', 'demandNbrClearCode', 7330, 'current', NULL, 'encoded reason for the last call tear down.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7341, '.1.3.6.1.4.1.9.9.26.1.1.1.1.11', 'demandNbrSuccessCalls', 7330, 'current', NULL, 'number of completed calls to neighbor since system reset.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7342, '.1.3.6.1.4.1.9.9.26.1.1.1.1.12', 'demandNbrFailCalls', 7330, 'current', NULL, 'Number of call attempts that have failed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7343, '.1.3.6.1.4.1.9.9.26.1.1.1.1.13', 'demandNbrAcceptCalls', 7330, 'current', NULL, 'Number of calls accepted from the neighbor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7344, '.1.3.6.1.4.1.9.9.26.1.1.1.1.14', 'demandNbrRefuseCalls', 7330, 'current', NULL, 'Number of calls from neighbor that we have refused.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7345, '.1.3.6.1.4.1.9.9.26.1.1.1.1.15', 'demandNbrLastAttemptTime', 7330, 'current', NULL, 'sysUpTime of last call attempt.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7346, '.1.3.6.1.4.1.9.9.26.1.1.1.1.16', 'demandNbrStatus', 7330, 'current', NULL, 'Somebody might want to manage the device using SNMP some day...', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7347, '.1.3.6.1.4.1.9.9.26.1.1.1.1.17', 'demandNbrCallOrigin', 7330, 'current', NULL, 'Indication of outgoing or incoming call.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7348, '.1.3.6.1.4.1.9.9.26.2', 'ciscoIsdnMibTrapPrefix', 7326, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7349, '.1.3.6.1.4.1.9.9.26.2.0', 'ciscoIsdnMibTraps', 7348, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7350, '.1.3.6.1.4.1.9.9.26.2.0.1', 'demandNbrCallInformation', 7349, 'obsolete', NULL, 'This trap/inform is sent to the manager whenever a successful call clears, or a failed call attempt is determined to have ultimately failed. In the event that call retry is active, then this is after all retry attempts have failed. However, only one such trap is sent in between successful call attempts; subsequent call attempts result in no trap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7351, '.1.3.6.1.4.1.9.9.26.2.0.2', 'demandNbrCallDetails', 7349, 'current', NULL, 'This trap/inform is sent to the manager whenever a call connects, or clears, or a failed call attempt is determined to have ultimately failed. In the event that call retry is active, then this is after all retry attempts have failed. However, only one such trap is sent in between successful call attempts; subsequent call attempts result in no trap.  Whenever a call connects, demandNbrLastDuration, demandNbrClearReason, and demandNbrClearCode objects are not included in the trap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7352, '.1.3.6.1.4.1.9.9.26.2.0.3', 'demandNbrLayer2Change', 7349, 'current', NULL, 'This trap/inform is sent to the manager whenever the D-channel of an interface changes state.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7353, '.1.3.6.1.4.1.9.9.26.2.0.4', 'demandNbrCNANotification', 7349, 'current', NULL, 'This trap/inform is sent to the manager whenever the an incoming call request is rejected with cause ''requested circuit/channel not available'' (CNA), code number 44.  isdnSignalingIfIndex is the ifIndex value of the interface associated with this signaling channel.  ifIndex is the interface index of the requested bearer channel', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7354, '.1.3.6.1.4.1.9.9.26.3', 'ciscoIsdnMibConformance', 7326, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7355, '.1.3.6.1.4.1.9.9.26.3.1', 'ciscoIsdnMibCompliances', 7354, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7356, '.1.3.6.1.4.1.9.9.26.3.2', 'ciscoIsdnMibGroups', 7354, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7357, '.1.3.6.1.4.1.9.9.26.3.1.1', 'ciscoIsdnMibCompliance', 7355, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7358, '.1.3.6.1.4.1.9.9.26.3.1.2', 'ciscoIsdnMibComplianceRev1', 7355, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7361, '.1.3.6.1.4.1.9.9.392', 'ciscoRemoteAccessMonitorMIB', 272, 'current', NULL, 'Acronyms and Definitions The following acronyms and terms are used in this document:  IPSec: Secure IP Protocol  VPN: Virtual Private Network  RAS: Remote Access Service  ISP: Internet Service Provider.  LAN: Local Area Network  Group: A collection of remote access users grouped and managed together as a single entity for administrative convenience.  Session: A Remote Access Session.  SVC: SSL VPN Client  Webvpn: VPN connection established using web browser.  Overview of the MIB  This is a MIB Module for monitoring the structures in Virtual Private Networks based remote access networks. The MIB seeks to create a common model of Remote Access across implementations of the service on layer 2 (PPTP, L2TP, L2F), layer 3 (IPsec) and layer 4 (SSL) virtual private networks. The MIB defines counters and objects of interest to performance/fault monitoring in a way which is independent of the technology of the remote access implementation.  MIB contains eight major groups of objects which are used to manage Remote Access connections: a) Remote Access capacity group This section defines metrics to gauge the limits of resources on this device which are critical to RAS service.  b) Remote Access resource usage group This section defines metrics to gauge the usage of resources on this device which are critical to RAS service service.  c) Current activity and performance of RAS service This section defines metrics to gauge the current remote access activity.  d) Remote Access Service failures This section defines metrics to monitor session failures and failures of the service itself, measured at aggregate level, session level and group level.  e) Security violations in the Remote Access service This section defines metrics which reflect the state of remote access service of interest to Security Operations staff in an enterprise.  f) Threshold group (allows definition of high water marks) This section allows the management entity to define thresholds to set high water marks on critical metrics.  g) Notifications This section defines notifications to signal significant events pertaining to the Remote Access Service.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7362, '.1.3.6.1.4.1.9.9.392.0', 'ciscoRasMonitorMIBNotifs', 7361, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7363, '.1.3.6.1.4.1.9.9.392.1', 'ciscoRasMonitorMIBObjects', 7361, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7364, '.1.3.6.1.4.1.9.9.392.2', 'ciscoRasMonitorMIBConform', 7361, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7365, '.1.3.6.1.4.1.9.9.392.1.1', 'crasCapacity', 7363, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7366, '.1.3.6.1.4.1.9.9.392.1.2', 'crasResourceUsage', 7363, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7367, '.1.3.6.1.4.1.9.9.392.1.3', 'crasActivity', 7363, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7368, '.1.3.6.1.4.1.9.9.392.1.4', 'crasFailures', 7363, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7369, '.1.3.6.1.4.1.9.9.392.1.5', 'crasSecurity', 7363, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7370, '.1.3.6.1.4.1.9.9.392.1.6', 'crasThresholds', 7363, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7371, '.1.3.6.1.4.1.9.9.392.1.7', 'crasNotifCntl', 7363, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7372, '.1.3.6.1.4.1.9.9.392.1.1.1', 'crasMaxSessionsSupportable', 7365, 'current', NULL, 'The maximum number of remote access sessions that may be supported on this device.  If the device imposes no arbitrary limit on the maximum number of sessions, it should return a value of 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7373, '.1.3.6.1.4.1.9.9.392.1.1.2', 'crasMaxUsersSupportable', 7365, 'current', NULL, 'The maximum number of remote access users for whom Remote Access sessions may be supported on this device.  If the device imposes no arbitrary limit on the maximum number of users, it should return a value of 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7374, '.1.3.6.1.4.1.9.9.392.1.1.3', 'crasMaxGroupsSupportable', 7365, 'current', NULL, 'The maximum number of remote access groups that may be defined on this device. ''Group'' refers to a collection of users grouped together for administrative convenience.  If the device imposes no arbitrary limit on the maximum number of groups, it should return a value of 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7375, '.1.3.6.1.4.1.9.9.392.1.1.4', 'crasNumCryptoAccelerators', 7365, 'current', NULL, 'The maximum number of hardware crypto accelerators which can be installed on this device to support remote access sessions. ''cryptoaccelerator'' denotes a hardware/software entity which the managed entity uses to offload some or all computations pertaining to cryptographic operations.  If the device imposes no arbitrary limit on the number of crypto accelerators to support Remote Access function, it should return a value of 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7376, '.1.3.6.1.4.1.9.9.392.1.2.1', 'crasGlobalBwUsage', 7366, 'current', NULL, 'The average bandwidth used by all the active remote access sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7377, '.1.3.6.1.4.1.9.9.392.1.3.1', 'crasNumSessions', 7367, 'current', NULL, 'The number of currently active sessions.  A session is a connection terminating on the managed entity which has been established to provide remote access connectivity to a user. A session is said to be ''active'' if it is ready to carry application traffic between the user and the managed entity. A session which is not active is defined to be ''dormant''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7378, '.1.3.6.1.4.1.9.9.392.1.3.2', 'crasNumPrevSessions', 7367, 'current', NULL, 'The number of remote access sessions which were previously active but which where since terminated.  Measured since the last reboot of the device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7379, '.1.3.6.1.4.1.9.9.392.1.3.3', 'crasNumUsers', 7367, 'current', NULL, 'The number of users who have active sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7380, '.1.3.6.1.4.1.9.9.392.1.3.4', 'crasNumGroups', 7367, 'current', NULL, 'The number of user groups whose members have active sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7381, '.1.3.6.1.4.1.9.9.392.1.3.5', 'crasGlobalInPkts', 7367, 'current', NULL, 'The total number of packets received by all currently and previously active remote access sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7382, '.1.3.6.1.4.1.9.9.392.1.3.6', 'crasGlobalOutPkts', 7367, 'current', NULL, 'The total number of packets transmitted by all currently and previously active remote access sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7383, '.1.3.6.1.4.1.9.9.392.1.3.7', 'crasGlobalInOctets', 7367, 'current', NULL, 'The total number of octets received by all currently and previously active remote access sessions. This value is accumulated BEFORE determining whether or not the packet should be decompressed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7384, '.1.3.6.1.4.1.9.9.392.1.3.8', 'crasGlobalInDecompOctets', 7367, 'current', NULL, 'The total number of decompressed octets received by all current and previous remote access sessions. This value is accumulated AFTER the packet is decompressed. If compression is not being used, this value will match the value of crasGlobalInOctets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7385, '.1.3.6.1.4.1.9.9.392.1.3.9', 'crasGlobalOutOctets', 7367, 'current', NULL, 'The total number of octets transmitted by all currently and previously active remote access sessions.  This value is accumulated AFTER determining whether or not the packet should be compressed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7386, '.1.3.6.1.4.1.9.9.392.1.3.10', 'crasGlobalOutUncompOctets', 7367, 'current', NULL, 'The total number of uncompressed octets sent by all current and previous remote access sessions. This value is accumulated BEFORE the packet is compressed. If compression is not being used, this value will match the value of crasGlobalOutOctets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7387, '.1.3.6.1.4.1.9.9.392.1.3.11', 'crasGlobalInDropPkts', 7367, 'current', NULL, 'The total number of packets which were dropped during receive processing by all currently and previously active remote access sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7388, '.1.3.6.1.4.1.9.9.392.1.3.12', 'crasGlobalOutDropPkts', 7367, 'current', NULL, 'The total number of packets which were dropped during receive processing by all currently and previously active remote access sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7389, '.1.3.6.1.4.1.9.9.392.1.3.21', 'crasSessionTable', 7367, 'current', NULL, 'This table lists all the currently active sessions. For each session, it lists the attributes (user, group, protocol, security), statistics (packet and octets) and status.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7390, '.1.3.6.1.4.1.9.9.392.1.3.21.1', 'crasSessionEntry', 7389, 'current', NULL, 'Each entry contains the attributes, statistics and status of an active session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7391, '.1.3.6.1.4.1.9.9.392.1.3.21.1.1', 'crasUsername', 7390, 'current', NULL, 'The name of the user associated with this remote access session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7392, '.1.3.6.1.4.1.9.9.392.1.3.21.1.2', 'crasGroup', 7390, 'current', NULL, 'The name of the user group to which this remote access session belongs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7395, '.1.3.6.1.4.1.9.9.392.1.3.21.1.5', 'crasAuthorMethod', 7390, 'current', NULL, 'The method used to authorize the user prior to establishing the session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7396, '.1.3.6.1.4.1.9.9.392.1.3.21.1.6', 'crasSessionDuration', 7390, 'current', NULL, 'The number of seconds elapsed since this session was established.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7397, '.1.3.6.1.4.1.9.9.392.1.3.21.1.7', 'crasLocalAddressType', 7390, 'current', NULL, 'The type of the address returned in ''crasLocalAddress''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7398, '.1.3.6.1.4.1.9.9.392.1.3.21.1.8', 'crasLocalAddress', 7390, 'current', NULL, 'The IP address assigned to the client of this session in the private network assigned by the managed entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7399, '.1.3.6.1.4.1.9.9.392.1.3.21.1.9', 'crasISPAddressType', 7390, 'current', NULL, 'The type of the address returned in ''crasISPAddress''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7400, '.1.3.6.1.4.1.9.9.392.1.3.21.1.10', 'crasISPAddress', 7390, 'current', NULL, 'The IP address of the peer (client) assigned by the ISP. This is the address of the client device in the public network.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7401, '.1.3.6.1.4.1.9.9.392.1.3.21.1.11', 'crasSessionProtocol', 7390, 'current', NULL, 'The protocol underlying this remote access session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7402, '.1.3.6.1.4.1.9.9.392.1.3.21.1.12', 'crasProtocolElement', 7390, 'current', NULL, 'A reference to MIB definitions specific to the protocol underlying corresponding to the session or tunnel used to realized the remote access session corresponding to this conceptual row.  For instance, if this remote access session is based on IPsec, then this object must contain the complete instance identifier of the IPsec tunnel corresponding to this remote access session.  If no MIB definitions specific to the underlying protocol are available, the value should be set to the OBJECT IDENTIFIER { 0 0 }.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7403, '.1.3.6.1.4.1.9.9.392.1.3.21.1.13', 'crasSessionEncryptionAlgo', 7390, 'current', NULL, 'The algorithm used by this remote access session to encrypt its payload.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7404, '.1.3.6.1.4.1.9.9.392.1.3.21.1.14', 'crasSessionPktAuthenAlgo', 7390, 'current', NULL, 'The algorithm used by this remote access session to to validate packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7405, '.1.3.6.1.4.1.9.9.392.1.3.21.1.15', 'crasSessionCompressionAlgo', 7390, 'current', NULL, 'The algorithm used by this remote access session to compress packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7406, '.1.3.6.1.4.1.9.9.392.1.3.21.1.16', 'crasHeartbeatInterval', 7390, 'current', NULL, 'The interval in seconds between two successive heartbeats employed by this session. Value of 0 denotes that no heartbeat is used.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7407, '.1.3.6.1.4.1.9.9.392.1.3.21.1.17', 'crasClientVendorString', 7390, 'current', NULL, 'The string identifying the vendor of the client application initiating this Remote Access session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7408, '.1.3.6.1.4.1.9.9.392.1.3.21.1.18', 'crasClientVersionString', 7390, 'current', NULL, 'The string identifying the version of the of the client application initiating the Remote Access session. This can be used by the administrator to identify which users are running unsupported client versions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7409, '.1.3.6.1.4.1.9.9.392.1.3.21.1.19', 'crasClientOSVendorString', 7390, 'current', NULL, 'The string identifying the vendor of the operating system on which the client application initiating the Remote Access Session is running.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7410, '.1.3.6.1.4.1.9.9.392.1.3.21.1.20', 'crasClientOSVersionString', 7390, 'current', NULL, 'The string identifying the version of the operating system of the entity which initiated this Remote Access session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7411, '.1.3.6.1.4.1.9.9.392.1.3.21.1.21', 'crasPrimWINSServerAddrType', 7390, 'current', NULL, 'The type of the address returned in ''crasPrimWINSServer''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7412, '.1.3.6.1.4.1.9.9.392.1.3.21.1.22', 'crasPrimWINSServer', 7390, 'current', NULL, 'The IP address of the primary WINS server assigned managed entity to this client session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7413, '.1.3.6.1.4.1.9.9.392.1.3.21.1.23', 'crasSecWINSServerAddrType', 7390, 'current', NULL, 'The type of the address returned in ''crasSecWINSServer''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7414, '.1.3.6.1.4.1.9.9.392.1.3.21.1.24', 'crasSecWINSServer', 7390, 'current', NULL, 'The IP address of the secondary WINS server assigned by the managed entity to this client session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7415, '.1.3.6.1.4.1.9.9.392.1.3.21.1.25', 'crasPrimDNSServerAddrType', 7390, 'current', NULL, 'The type of the address returned in ''crasPrimDNSServer''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7416, '.1.3.6.1.4.1.9.9.392.1.3.21.1.26', 'crasPrimDNSServer', 7390, 'current', NULL, 'The IP address of the primary DNS server assigned by the managed entity to this client session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7417, '.1.3.6.1.4.1.9.9.392.1.3.21.1.27', 'crasSecDNSServerAddrType', 7390, 'current', NULL, 'The type of the address returned in ''crasSecDNSServer''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7418, '.1.3.6.1.4.1.9.9.392.1.3.21.1.28', 'crasSecDNSServer', 7390, 'current', NULL, 'The IP address of the secondary DNS server assigned by the managed entity to this client session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7419, '.1.3.6.1.4.1.9.9.392.1.3.21.1.29', 'crasDHCPServerAddrType', 7390, 'current', NULL, 'The type of the address returned in ''crasDHCPServer''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7420, '.1.3.6.1.4.1.9.9.392.1.3.21.1.30', 'crasDHCPServer', 7390, 'current', NULL, 'The IP address of the DHCP server assigned by the managed entity to this client session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7421, '.1.3.6.1.4.1.9.9.392.1.3.21.1.31', 'crasSessionInPkts', 7390, 'current', NULL, 'The total number of packets received by this Remote Access session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7422, '.1.3.6.1.4.1.9.9.392.1.3.21.1.32', 'crasSessionOutPkts', 7390, 'current', NULL, 'The total number of packets transmitted by this Remote Access Session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7423, '.1.3.6.1.4.1.9.9.392.1.3.21.1.33', 'crasSessionInDropPkts', 7390, 'current', NULL, 'The total number of packets received for processing on this session which were dropped by the managed entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7424, '.1.3.6.1.4.1.9.9.392.1.3.21.1.34', 'crasSessionOutDropPkts', 7390, 'current', NULL, 'The total number of outgoing packets on this session which were dropped during transmit processing by the managed entity.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7425, '.1.3.6.1.4.1.9.9.392.1.3.21.1.35', 'crasSessionInOctets', 7390, 'current', NULL, 'The total number of octets received by this Remote Access Session.  This value is accumulated BEFORE determining whether or not the packet should be decompressed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7426, '.1.3.6.1.4.1.9.9.392.1.3.21.1.36', 'crasSessionOutOctets', 7390, 'current', NULL, 'The total number of octets transmitted by this Remote Access Session.  This value is accumulated AFTER determining whether or not the packet should be compressed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7427, '.1.3.6.1.4.1.9.9.392.1.3.21.1.37', 'crasSessionState', 7390, 'current', NULL, 'The state of the remote access session corresponding to this conceptual row.  The management entity may use this object to terminate an established session by setting value of the object to ''terminating''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7428, '.1.3.6.1.4.1.9.9.392.1.3.22', 'crasActGroupTable', 7367, 'current', NULL, 'This table lists all the currently active remote access user groups. For each group, it lists the attributes (group, aggregate activity, aggregate traffic), and status.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7429, '.1.3.6.1.4.1.9.9.392.1.3.22.1', 'crasActGroupEntry', 7428, 'current', NULL, 'Each entry contains the attributes, statistics and status of an active session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7430, '.1.3.6.1.4.1.9.9.392.1.3.22.1.1', 'crasActGrpName', 7429, 'current', NULL, 'The name of the active user group corresponding to this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7431, '.1.3.6.1.4.1.9.9.392.1.3.22.1.2', 'crasActGrNumUsers', 7429, 'current', NULL, 'The number of users in this group currently connected to the managed device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7432, '.1.3.6.1.4.1.9.9.392.1.3.22.1.3', 'crasActGrpInPkts', 7429, 'current', NULL, 'The total number of packets received by this session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7433, '.1.3.6.1.4.1.9.9.392.1.3.22.1.4', 'crasActGrpOutPkts', 7429, 'current', NULL, 'The total number of packets transmitted by this session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7434, '.1.3.6.1.4.1.9.9.392.1.3.22.1.5', 'crasActGrpInDropPkts', 7429, 'current', NULL, 'The total number of packets dropped by this session which were received for processing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7435, '.1.3.6.1.4.1.9.9.392.1.3.22.1.6', 'crasActGrpOutDropPkts', 7429, 'current', NULL, 'The total number of outgoing packets which were dropped during transmit processing by this session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7436, '.1.3.6.1.4.1.9.9.392.1.3.22.1.7', 'crasActGrpInOctets', 7429, 'current', NULL, 'The total number of octets received by this session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7437, '.1.3.6.1.4.1.9.9.392.1.3.22.1.8', 'crasActGrpOutOctets', 7429, 'current', NULL, 'The total number of octets transmitted by this session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7438, '.1.3.6.1.4.1.9.9.392.1.3.23', 'crasEmailNumSessions', 7367, 'current', NULL, 'The number of currently active Email proxy sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7439, '.1.3.6.1.4.1.9.9.392.1.3.24', 'crasEmailCumulateSessions', 7367, 'current', NULL, 'The number of cumulative Email proxy sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7440, '.1.3.6.1.4.1.9.9.392.1.3.25', 'crasEmailPeakConcurrentSessions', 7367, 'current', NULL, 'The number of peak concurrent Email proxy sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7441, '.1.3.6.1.4.1.9.9.392.1.3.26', 'crasIPSecNumSessions', 7367, 'current', NULL, 'The number of currently active IPSec sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7442, '.1.3.6.1.4.1.9.9.392.1.3.27', 'crasIPSecCumulateSessions', 7367, 'current', NULL, 'The number of cumulative IPSec sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7443, '.1.3.6.1.4.1.9.9.392.1.3.28', 'crasIPSecPeakConcurrentSessions', 7367, 'current', NULL, 'The number of peak concurrent Email proxy sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7444, '.1.3.6.1.4.1.9.9.392.1.3.29', 'crasL2LNumSessions', 7367, 'current', NULL, 'The number of currently active LAN to LAN sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7445, '.1.3.6.1.4.1.9.9.392.1.3.30', 'crasL2LCumulateSessions', 7367, 'current', NULL, 'The number of cumulative LAN to LAN sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7446, '.1.3.6.1.4.1.9.9.392.1.3.31', 'crasL2LPeakConcurrentSessions', 7367, 'current', NULL, 'The number of peak concurrent LAN to LAN sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7447, '.1.3.6.1.4.1.9.9.392.1.3.32', 'crasLBNumSessions', 7367, 'current', NULL, 'The number of currently active Load Balancing sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7448, '.1.3.6.1.4.1.9.9.392.1.3.33', 'crasLBCumulateSessions', 7367, 'current', NULL, 'The number of cumulative Load Balancing sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7449, '.1.3.6.1.4.1.9.9.392.1.3.34', 'crasLBPeakConcurrentSessions', 7367, 'current', NULL, 'The number of peak concurrent Load Balancing sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7450, '.1.3.6.1.4.1.9.9.392.1.3.35', 'crasSVCNumSessions', 7367, 'current', NULL, 'The number of currently active SVC sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7451, '.1.3.6.1.4.1.9.9.392.1.3.36', 'crasSVCCumulateSessions', 7367, 'current', NULL, 'The number of cumulative SVC sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7452, '.1.3.6.1.4.1.9.9.392.1.3.37', 'crasSVCPeakConcurrentSessions', 7367, 'current', NULL, 'The number of peak concurrent SVC sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7453, '.1.3.6.1.4.1.9.9.392.1.3.38', 'crasWebvpnNumSessions', 7367, 'current', NULL, 'The number of currently active Webvpn sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7454, '.1.3.6.1.4.1.9.9.392.1.3.39', 'crasWebvpnCumulateSessions', 7367, 'current', NULL, 'The number of cumulative Webvpn sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7455, '.1.3.6.1.4.1.9.9.392.1.3.40', 'crasWebvpnPeakConcurrentSessions', 7367, 'current', NULL, 'The number of peak concurrent Webvpn sessions since system up.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7456, '.1.3.6.1.4.1.9.9.392.1.4.1', 'crasFailuresGlobals', 7368, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7457, '.1.3.6.1.4.1.9.9.392.1.4.1.1', 'crasNumTotalFailures', 7456, 'current', NULL, 'The number of attempts to establish sessions which failed, since the last reboot of the managed device.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7458, '.1.3.6.1.4.1.9.9.392.1.4.1.2', 'crasNumDeclinedSessions', 7456, 'current', NULL, 'The number of session setup attempts, counted since the last time the notification ''ciscoRasTooManyFailedAuths'' was issued, which were declined due to authentication or authorization failure.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7459, '.1.3.6.1.4.1.9.9.392.1.4.1.3', 'crasNumSetupFailInsufResources', 7456, 'current', NULL, 'The number of session setup attempts that failed due to insufficient resources.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7460, '.1.3.6.1.4.1.9.9.392.1.4.1.4', 'crasNumAbortedSessions', 7456, 'current', NULL, 'The number of sessions which were successfully setup but were since terminated abnormally.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7461, '.1.3.6.1.4.1.9.9.392.1.4.2', 'crasFailGlobalCntl', 7368, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7462, '.1.3.6.1.4.1.9.9.392.1.4.2.1', 'crasFailTableSize', 7461, 'current', NULL, 'The window size of the Remote Access Failure tables.  The failure tables for session and group failures maintain only the last crasFailTableSize number of failure records. A value of 0 for this MIB variable indicates that archiving of the failures is disabled.  An implementation may choose suitable minimum and maximum values for this element based on the local policy and available resources. If an SNMP SET request specifies a value outside this window for this element, a BAD VALUE may be returned.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7463, '.1.3.6.1.4.1.9.9.392.1.4.3', 'crasSessFailures', 7368, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7464, '.1.3.6.1.4.1.9.9.392.1.4.3.1', 'crasSessFailTable', 7463, 'current', NULL, 'This table records the last ''N'' session failures, where ''N'' is the value of the MIB element ''crasFailTableSize'' defined earlier.  A failure could be a failure to establish a session (''setup'' failure) or a failure of a session after it was established (''operational'' failure).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7465, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1', 'crasSessFailEntry', 7464, 'current', NULL, 'Each entry contains the attributes associated with a remote access session failure.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7466, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.1', 'crasSessFailIndex', 7465, 'current', NULL, 'The index of the session failure table. The value of the index is a number which begins at one and is incremented with each session failure. The value of this object will wrap at 4,294,967,295.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7467, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.2', 'crasSessFailUsername', 7465, 'current', NULL, 'The name of the user associated with this failed remote access session.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7468, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.3', 'crasSessFailGroupname', 7465, 'current', NULL, 'The name of the user group to which this failed remote access session belongs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7469, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.4', 'crasSessFailType', 7465, 'current', NULL, 'The type of the failure: 1 = failure occurred during session setup 2 = failed occurred after the session was setup successfully.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7470, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.5', 'crasSessFailReason', 7465, 'current', NULL, 'The reason for the failure. Possible reasons include: 1 = other (error which cannot be classified in any of the types listed below). 2 = internal error occurred 3 = failed to authenticate the peer/user 4 = failed to authorize the peer/user 5 = system capacity exceeded (memory, cpu, max users etc) 6 = peer requested to abort the session or the setup 7 = lost peer''s heartbeat 8 = local management request.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7471, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.6', 'crasSessFailTime', 7465, 'current', NULL, 'The value of the MIB element ''sysUpTime'' at the time of the failure.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7472, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.7', 'crasSessFailSessionIndex', 7465, 'current', NULL, 'The index of the session which failed (in case this was an operational failure). In case of setup failures (where the value of ''crasSessFailType'' of this conceptual row is ''operationalFailure''), the value of this object is undefined and should not be processed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7473, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.8', 'crasSessFailISPAddrType', 7465, 'current', NULL, 'The type of the address returned in ''crasSessFailISPAddr''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7474, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.9', 'crasSessFailISPAddr', 7465, 'current', NULL, 'The public address of the peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7475, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.10', 'crasSessFailLocalAddrType', 7465, 'current', NULL, 'The type of the address returned in ''crasSessFailLocalAddr''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7476, '.1.3.6.1.4.1.9.9.392.1.4.3.1.1.11', 'crasSessFailLocalAddr', 7465, 'current', NULL, 'The address assigned to the peer by the local address management mechanism. In case no address was assigned to the peer when the failure occurred, this MIB variable would contain the IPv4 address value 0.0.0.0', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7477, '.1.3.6.1.4.1.9.9.392.1.4.3.2', 'crasFailLastFailIndex', 7463, 'current', NULL, 'The value of column ''crasSessFailIndex'' corresponding to the last row added to the crasSessFailTable.  The value of this object is undefined and should not be processed by the management entity if the value of the object ''crasFailTableSize'' is 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7478, '.1.3.6.1.4.1.9.9.392.1.4.4', 'crasGroupFailures', 7368, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7479, '.1.3.6.1.4.1.9.9.392.1.4.4.1', 'crasGrpFailTable', 7478, 'current', NULL, 'This table records the last ''N'' occurrences of failures (setup or operational) per user group, where ''N'' is the value of the MIB element ''crasFailTableSize'' defined earlier.  When ''N'' entries have been created, the failure information about a new user group must be created by deleting the oldest entry in this table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7480, '.1.3.6.1.4.1.9.9.392.1.4.4.1.1', 'crasGrpFailEntry', 7479, 'current', NULL, 'Each entry contains the summary of failures for a specific user group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7481, '.1.3.6.1.4.1.9.9.392.1.4.4.1.1.1', 'crasGrpFailGroupname', 7480, 'current', NULL, 'The name of the user group to which this failure record corresponds.  This is the index of the group failure table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7482, '.1.3.6.1.4.1.9.9.392.1.4.4.1.1.2', 'crasGrpFailNumFailAuths', 7480, 'current', NULL, 'The number of sessions belonging to this group which failed authentication; counted since last reboot.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7483, '.1.3.6.1.4.1.9.9.392.1.4.4.1.1.3', 'crasGrpFailNumResourceFailures', 7480, 'current', NULL, 'The number of session setup attempts which failed due to insufficient resources.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7484, '.1.3.6.1.4.1.9.9.392.1.4.4.1.1.4', 'crasGrpFailNumDeclined', 7480, 'current', NULL, 'The number of session setup attempts which were declined by the managed entity due to local policy. These would include sessions which were denied due to rate control settings.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7485, '.1.3.6.1.4.1.9.9.392.1.4.4.1.1.5', 'crasGrpFailNumTerminatedMgmt', 7480, 'current', NULL, 'The number of established sessions which were terminated by explicit management action. The termination may have been triggered locally or based on a request from the peer.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7486, '.1.3.6.1.4.1.9.9.392.1.4.4.1.1.6', 'crasGrpFailNumTerminatedOther', 7480, 'current', NULL, 'The number of established sessions which were terminated due to insufficient reasons, internal error or other reasons not caused by management action.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7487, '.1.3.6.1.4.1.9.9.392.1.5.1', 'crasSecurityGlobals', 7369, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7488, '.1.3.6.1.4.1.9.9.392.1.5.1.1', 'crasNumDisabledAccounts', 7487, 'current', NULL, 'The total number of user accounts which were disabled due to repeated login failures.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7489, '.1.3.6.1.4.1.9.9.392.1.6.1', 'crasThrMaxSessions', 7370, 'current', NULL, 'The maximum number of sessions which are successfully setup after which the managed entity should alert the network management entity using the notification ''ciscoRasTooManySessions'', if the notification has been enabled.  A value of 0 indicates that the threshold has not been set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7490, '.1.3.6.1.4.1.9.9.392.1.6.2', 'crasThrMaxFailedAuths', 7370, 'current', NULL, 'The value of object ''crasNumDeclinedSessions'' at which the managed entity should alert the network management entity using the notification ''ciscoRasTooManyFailedAuths'', if the notification has been enabled.  A value of 0 indicates that the threshold has not been set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7491, '.1.3.6.1.4.1.9.9.392.1.6.3', 'crasThrMaxThroughput', 7370, 'current', NULL, 'The highest throughput of the Remote Access Service at which the managed entity should alert the network management entity using the notification ''ciscoRasTooHighThroughput'', if the notification has been enabled.  The notification is disabled till the value of the aggregate throughput of the managed entity drops below the value of this object.  A value of 0 indicates that the threshold has not been set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7492, '.1.3.6.1.4.1.9.9.392.1.7.1', 'crasCntlTooManySessions', 7371, 'current', NULL, 'This object defines the administrative state of sending the trap to signal the violation of the Max session threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7493, '.1.3.6.1.4.1.9.9.392.1.7.2', 'crasCntlTooManyFailedAuths', 7371, 'current', NULL, 'This object defines the administrative state of sending the trap to signal the violation of the Max authentication failure count threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7494, '.1.3.6.1.4.1.9.9.392.1.7.3', 'crasCntlTooHighThroughput', 7371, 'current', NULL, 'This object defines the administrative state of sending the trap to signal the violation of the Max throughput threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7495, '.1.3.6.1.4.1.9.9.392.0.1', 'ciscoRasTooManySessions', 7362, 'current', NULL, 'This notification is generated when the managed entity detects that the number of sessions established exceeds the set threshold crasThrMaxSessions.  Once the notification has been issued, further notifications are suppressed till the value returns below the specified threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7496, '.1.3.6.1.4.1.9.9.392.0.2', 'ciscoRasTooManyFailedAuths', 7362, 'current', NULL, 'This notification is generated when the managed entity detects that the number of login attempts (over all users) exceeds the set threshold for throughput (crasThrMaxFailedAuths).  Once the notification has been issued, further notifications are suppressed till the value returns below the specified threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7497, '.1.3.6.1.4.1.9.9.392.0.3', 'ciscoRasTooHighThroughput', 7362, 'current', NULL, 'This notification is generated when the managed entity detects that the current throughput of the device exceeds the set threshold for throughput (crasThrMaxThroughput).  Once the notification has been issued, further notiifcations are suppressed till the value returns below the specified threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7498, '.1.3.6.1.4.1.9.9.392.2.1', 'ciscoRasMonitorMIBCompliances', 7364, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7499, '.1.3.6.1.4.1.9.9.392.2.2', 'ciscoRasMonitorMIBGroups', 7364, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7500, '.1.3.6.1.4.1.9.9.392.2.1.1', 'ciscoRasMonitorMIBCompliance', 7498, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7501, '.1.3.6.1.4.1.9.9.392.2.1.2', 'ciscoRasMonitorMIBComplianceRev1', 7498, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7502, '.1.3.6.1.4.1.9.9.392.2.2.1', 'ciscoRasCapacityGroup', 7499, 'current', NULL, 'This group consists of the MIB objects pertaining to Remote Access Service capacity parameters defined in the Cisco Remote Access MIB.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7503, '.1.3.6.1.4.1.9.9.392.2.2.2', 'ciscoRasResourceUsageGroup', 7499, 'current', NULL, 'This group consists of the MIB objects pertaining to Remote Access Service resource usage parameters defined in the Cisco Remote Access MIB.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7504, '.1.3.6.1.4.1.9.9.392.2.2.3', 'ciscoRasActivityGroup', 7499, 'current', NULL, 'This group consists of the MIB objects pertaining to the Cisco Remote Access MIB Activity group.  Following are definitions of some terms used in this compliance group:  User: A remote access user.  Group: A collection of remote access users grouped and managed together as a single entity for administrative convenience.  ISP: Internet Service Provider.  Crypto Accelerator ''Crypto Accelerator'' denotes a device which the managed entity uses to offload some or all computations pertaining to cryptographic operations.  Session A connection terminating on the managed device which has been established to provide remote access connectivity to a user.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7505, '.1.3.6.1.4.1.9.9.392.2.2.4', 'ciscoRasGrpActivityGroup', 7499, 'current', NULL, 'This group consists of the MIB objects pertaining to activity of user groups.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7506, '.1.3.6.1.4.1.9.9.392.2.2.5', 'ciscoRasMandatoryFailureGroup', 7499, 'current', NULL, 'This group categorizes objects pertaining to failures in the Remote Access Service which are essential for successful monitoring of the service.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7507, '.1.3.6.1.4.1.9.9.392.2.2.6', 'ciscoRasOptionalFailureGroup', 7499, 'current', NULL, 'This group categorizes optional objects pertaining to failures in the Remote Access Service.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7508, '.1.3.6.1.4.1.9.9.392.2.2.7', 'ciscoRasSecurityGroup', 7499, 'current', NULL, 'This group categorizes objects pertaining to the monitoring state of security in the Remote Access Service.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7509, '.1.3.6.1.4.1.9.9.392.2.2.8', 'ciscoRasThresholdsGroup', 7499, 'current', NULL, 'This group categorizes objects which are used to establish baseline values of metrics instrumenting the Remote Access Service.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7510, '.1.3.6.1.4.1.9.9.392.2.2.9', 'ciscoRasNotificationCntlGroup', 7499, 'current', NULL, 'This group of objects controls the sending of notifications defined in this MIB module.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7511, '.1.3.6.1.4.1.9.9.392.2.2.10', 'ciscoRasNotificationsGroup', 7499, 'current', NULL, 'This group contains the notifications for the Remote Access MIB.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7512, '.1.3.6.1.4.1.9.9.392.2.2.11', 'ciscoRasActivityGroupRev1', 7499, 'current', NULL, 'This group contains activity information related to sessions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7513, '.1.3.6.1.4.1.9.2.4', 'lip', 265, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7514, '.1.3.6.1.4.1.9.2.4.1', 'lipAddrTable', 7513, 'mandatory', NULL, 'A list of IP address entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7515, '.1.3.6.1.4.1.9.2.4.1.1', 'lipAddrEntry', 7514, 'mandatory', NULL, 'A collection of additional objects in the cisco IP implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7516, '.1.3.6.1.4.1.9.2.4.1.1.1', 'locIPHow', 7515, 'mandatory', NULL, 'Method of how this interface obtained its IP address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7517, '.1.3.6.1.4.1.9.2.4.1.1.2', 'locIPWho', 7515, 'mandatory', NULL, 'IP address of who supplied this interface its IP address.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7518, '.1.3.6.1.4.1.9.2.4.1.1.3', 'locIPHelper', 7515, 'mandatory', NULL, 'IP helper address for broadcast forwarding support.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7519, '.1.3.6.1.4.1.9.2.4.1.1.4', 'locIPSecurity', 7515, 'mandatory', NULL, 'IP security level. See RFC 1038.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7520, '.1.3.6.1.4.1.9.2.4.1.1.5', 'locIPRedirects', 7515, 'mandatory', NULL, 'Boolean whether ICMP redirects will be sent or not.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7521, '.1.3.6.1.4.1.9.2.4.1.1.6', 'locIPUnreach', 7515, 'mandatory', NULL, 'Boolean whether ICMP unreachables will be sent or not.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7522, '.1.3.6.1.4.1.9.2.4.2', 'lipRouteTable', 7513, 'mandatory', NULL, 'A list of IP routing entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7523, '.1.3.6.1.4.1.9.2.4.2.1', 'lipRouteEntry', 7522, 'mandatory', NULL, 'A collection of additional objects in the cisco IP routing implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7524, '.1.3.6.1.4.1.9.2.4.2.1.1', 'locRtMask', 7523, 'mandatory', NULL, 'Routing table network mask.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7525, '.1.3.6.1.4.1.9.2.4.2.1.2', 'locRtCount', 7523, 'mandatory', NULL, 'Number of parallel routes within routing table.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7526, '.1.3.6.1.4.1.9.2.4.2.1.3', 'locRtUses', 7523, 'mandatory', NULL, 'Number of times this route was used in a forward operation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7527, '.1.3.6.1.4.1.9.2.4.4', 'actThresh', 7513, 'mandatory', NULL, 'Threshold of IP accounting records in use before IP traffic will be unaccounted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7528, '.1.3.6.1.4.1.9.2.4.5', 'actLostPkts', 7513, 'mandatory', NULL, 'Lost IP packets due to memory limitations.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7529, '.1.3.6.1.4.1.9.2.4.6', 'actLostByts', 7513, 'mandatory', NULL, 'Total bytes of lost IP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7530, '.1.3.6.1.4.1.9.2.4.7', 'lipAccountingTable', 7513, 'mandatory', NULL, 'A list of IP accounting entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7531, '.1.3.6.1.4.1.9.2.4.7.1', 'lipAccountEntry', 7530, 'mandatory', NULL, 'A collection of objects necessary for IP accounting.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7532, '.1.3.6.1.4.1.9.2.4.7.1.1', 'actSrc', 7531, 'mandatory', NULL, 'IP Source address for host traffic matrix.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7533, '.1.3.6.1.4.1.9.2.4.7.1.2', 'actDst', 7531, 'mandatory', NULL, 'IP Destination address for host traffic matrix.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7534, '.1.3.6.1.4.1.9.2.4.7.1.3', 'actPkts', 7531, 'mandatory', NULL, 'Number of IP packets sent from source to destination.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7535, '.1.3.6.1.4.1.9.2.4.7.1.4', 'actByts', 7531, 'mandatory', NULL, 'Total number of bytes in IP packets from source to destination.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7536, '.1.3.6.1.4.1.9.2.4.7.1.5', 'actViolation', 7531, 'mandatory', NULL, 'Access list number violated by packets from this source to this destination. A zero value indicates that no access list was violated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7537, '.1.3.6.1.4.1.9.2.4.8', 'actAge', 7513, 'mandatory', NULL, 'The age of the data in the current data matrix.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7538, '.1.3.6.1.4.1.9.2.4.9', 'lipCkAccountingTable', 7513, 'mandatory', NULL, 'A list of IP checkpoint accounting entries.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7539, '.1.3.6.1.4.1.9.2.4.9.1', 'lipCkAccountEntry', 7538, 'mandatory', NULL, 'A collection of objects necessary for IP checkpoint accounting.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7540, '.1.3.6.1.4.1.9.2.4.9.1.1', 'ckactSrc', 7539, 'mandatory', NULL, 'IP Source address for host in checkpoint traffic matrix.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7541, '.1.3.6.1.4.1.9.2.4.9.1.2', 'ckactDst', 7539, 'mandatory', NULL, 'IP Destination address for host in checkpoint traffic matrix.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7542, '.1.3.6.1.4.1.9.2.4.9.1.3', 'ckactPkts', 7539, 'mandatory', NULL, 'Number of IP packets sent from source to destination in checkpoint matrix.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7543, '.1.3.6.1.4.1.9.2.4.9.1.4', 'ckactByts', 7539, 'mandatory', NULL, 'Total number of bytes in IP packets from source to destination in checkpoint matrix. A zero value indicates that no access list was violated.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7544, '.1.3.6.1.4.1.9.2.4.9.1.5', 'ckactViolation', 7539, 'mandatory', NULL, 'Access list number violated by packets from source to destination in checkpoint matrix.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7545, '.1.3.6.1.4.1.9.2.4.10', 'ckactAge', 7513, 'mandatory', NULL, 'Age of data in the checkpoint matrix.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7546, '.1.3.6.1.4.1.9.2.4.11', 'actCheckPoint', 7513, 'mandatory', NULL, 'Check points the accounting database. This mib variable must be read and then set with the same value for the check point to succeed. The value read and then set will be incremented after a successful set request', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7547, '.1.3.6.1.4.1.9.2.4.12', 'ipNoaccess', 7513, 'mandatory', NULL, 'Total number of packets dropped due to access control failure.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7548, '.1.3.6.1.2.1.10.32', 'frame-relay', 22, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7549, '.1.3.6.1.2.1.10.32.1', 'frDlcmiTable', 7548, 'mandatory', 'Draft American National Standard T1.617-1991, Annex D', 'The Parameters for the Data Link Connection Management Interface for the frame relay service on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7550, '.1.3.6.1.2.1.10.32.1.1', 'frDlcmiEntry', 7549, 'mandatory', NULL, 'The Parameters for a particular Data Link Con- nection Management Interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7551, '.1.3.6.1.2.1.10.32.1.1.1', 'frDlcmiIfIndex', 7550, 'mandatory', NULL, 'The ifIndex value of the corresponding ifEn- try.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7552, '.1.3.6.1.2.1.10.32.1.1.2', 'frDlcmiState', 7550, 'mandatory', 'Draft American National Standard T1.617-1991', 'This variable states which Data Link Connec- tion Management scheme is active (and by impli- cation, what DLCI it uses) on the Frame Relay interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7553, '.1.3.6.1.2.1.10.32.1.1.3', 'frDlcmiAddress', 7550, 'mandatory', NULL, 'This variable states which address format is in use on the Frame Relay interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7554, '.1.3.6.1.2.1.10.32.1.1.4', 'frDlcmiAddressLen', 7550, 'mandatory', NULL, 'This variable states which address length in octets. In the case of Q922 format, the length indicates the entire length of the address in- cluding the control portion.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7555, '.1.3.6.1.2.1.10.32.1.1.5', 'frDlcmiPollingInterval', 7550, 'mandatory', 'Draft American National Standard T1.617-1991, Section D.7 Timer T391.', 'This is the number of seconds between succes- sive status enquiry messages.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7556, '.1.3.6.1.2.1.10.32.1.1.6', 'frDlcmiFullEnquiryInterval', 7550, 'mandatory', 'Draft American National Standard T1.617-1991, Section D.7 Counter N391.', 'Number of status enquiry intervals that pass before issuance of a full status enquiry mes- sage.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7557, '.1.3.6.1.2.1.10.32.1.1.7', 'frDlcmiErrorThreshold', 7550, 'mandatory', 'Draft American National Standard T1.617-1991, Section D.5.1 Counter N392.', 'This is the maximum number of unanswered Status Enquiries the equipment shall accept be- fore declaring the interface down.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7558, '.1.3.6.1.2.1.10.32.1.1.8', 'frDlcmiMonitoredEvents', 7550, 'mandatory', 'Draft American National Standard T1.617-1991, Section D.5.2 Counter N393.', 'This is the number of status polling intervals over which the error threshold is counted. For example, if within ''MonitoredEvents'' number of events the station receives ''ErrorThreshold'' number of errors, the interface is marked as down.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7559, '.1.3.6.1.2.1.10.32.1.1.9', 'frDlcmiMaxSupportedVCs', 7550, 'mandatory', NULL, 'The maximum number of Virtual Circuits allowed for this interface. Usually dictated by the Frame Relay network.  In response to a SET, if a value less than zero or higher than the agent''s maximal capability is configured, the agent should respond bad- Value', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7560, '.1.3.6.1.2.1.10.32.1.1.10', 'frDlcmiMulticast', 7550, 'mandatory', NULL, 'This indicates whether the Frame Relay inter- face is using a multicast service.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7561, '.1.3.6.1.2.1.10.32.2', 'frCircuitTable', 7548, 'mandatory', NULL, 'A table containing information about specific Data Link Connection Identifiers and corresponding virtual circuits.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7562, '.1.3.6.1.2.1.10.32.2.1', 'frCircuitEntry', 7561, 'mandatory', NULL, 'The information regarding a single Data Link Connection Identifier.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7563, '.1.3.6.1.2.1.10.32.2.1.1', 'frCircuitIfIndex', 7562, 'mandatory', NULL, 'The ifIndex Value of the ifEntry this virtual circuit is layered onto.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7564, '.1.3.6.1.2.1.10.32.2.1.2', 'frCircuitDlci', 7562, 'mandatory', 'Draft American National Standard T1.618-1991, Section 3.3.6', 'The Data Link Connection Identifier for this virtual circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7565, '.1.3.6.1.2.1.10.32.2.1.3', 'frCircuitState', 7562, 'mandatory', NULL, 'Indicates whether the particular virtual cir- cuit is operational. In the absence of a Data Link Connection Management Interface, virtual circuit entries (rows) may be created by set- ting virtual circuit state to ''active'', or deleted by changing Circuit state to ''invalid''. Whether or not the row actually disappears is left to the implementation, so this object may actually read as ''invalid'' for some arbitrary length of time. It is also legal to set the state of a virtual circuit to ''inactive'' to temporarily disable a given circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7566, '.1.3.6.1.2.1.10.32.2.1.4', 'frCircuitReceivedFECNs', 7562, 'mandatory', 'Draft American National Standard T1.618-1991, Section 3.3.3', 'Number of frames received from the network in- dicating forward congestion since the virtual circuit was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7567, '.1.3.6.1.2.1.10.32.2.1.5', 'frCircuitReceivedBECNs', 7562, 'mandatory', 'Draft American National Standard T1.618-1991, Section 3.3.4', 'Number of frames received from the network in- dicating backward congestion since the virtual circuit was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7568, '.1.3.6.1.2.1.10.32.2.1.6', 'frCircuitSentFrames', 7562, 'mandatory', NULL, 'The number of frames sent from this virtual circuit since it was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7569, '.1.3.6.1.2.1.10.32.2.1.7', 'frCircuitSentOctets', 7562, 'mandatory', NULL, 'The number of octets sent from this virtual circuit since it was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7570, '.1.3.6.1.2.1.10.32.2.1.8', 'frCircuitReceivedFrames', 7562, 'mandatory', NULL, 'Number of frames received over this virtual circuit since it was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7571, '.1.3.6.1.2.1.10.32.2.1.9', 'frCircuitReceivedOctets', 7562, 'mandatory', NULL, 'Number of octets received over this virtual circuit since it was created.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7572, '.1.3.6.1.2.1.10.32.2.1.10', 'frCircuitCreationTime', 7562, 'mandatory', NULL, 'The value of sysUpTime when the virtual cir- cuit was created, whether by the Data Link Con- nection Management Interface or by a SetRe- quest.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7573, '.1.3.6.1.2.1.10.32.2.1.11', 'frCircuitLastTimeChange', 7562, 'mandatory', NULL, 'The value of sysUpTime when last there was a change in the virtual circuit state', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7574, '.1.3.6.1.2.1.10.32.2.1.12', 'frCircuitCommittedBurst', 7562, 'mandatory', 'Draft American National Standard T1.617-1991, Section 6.5.19', 'This variable indicates the maximum amount of data, in bits, that the network agrees to transfer under normal conditions, during the measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7575, '.1.3.6.1.2.1.10.32.2.1.13', 'frCircuitExcessBurst', 7562, 'mandatory', 'Draft American National Standard T1.617-1991, Section 6.5.19', 'This variable indicates the maximum amount of uncommitted data bits that the network will at- tempt to deliver over the measurement interval.  By default, if not configured when creating the entry, the Excess Information Burst Size is set to the value of ifSpeed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7576, '.1.3.6.1.2.1.10.32.2.1.14', 'frCircuitThroughput', 7562, 'mandatory', 'Draft American National Standard T1.617-1991, Section 6.5.19', 'Throughput is the average number of ''Frame Re- lay Information Field'' bits transferred per second across a user network interface in one direction, measured over the measurement inter- val.  If the configured committed burst rate and throughput are both non-zero, the measurement interval T=frCircuitCommittedBurst/frCircuitThroughput.  If the configured committed burst rate and throughput are both zero, the measurement in- terval T=frCircuitExcessBurst/ifSpeed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7577, '.1.3.6.1.2.1.10.32.3', 'frErrTable', 7548, 'mandatory', NULL, 'A table containing information about Errors on the Frame Relay interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7578, '.1.3.6.1.2.1.10.32.3.1', 'frErrEntry', 7577, 'mandatory', NULL, 'The error information for a single frame relay interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7579, '.1.3.6.1.2.1.10.32.3.1.1', 'frErrIfIndex', 7578, 'mandatory', NULL, 'The ifIndex Value of the corresponding ifEn- try.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7580, '.1.3.6.1.2.1.10.32.3.1.2', 'frErrType', 7578, 'mandatory', NULL, 'The type of error that was last seen on this interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7581, '.1.3.6.1.2.1.10.32.3.1.3', 'frErrData', 7578, 'mandatory', NULL, 'An octet string containing as much of the er- ror packet as possible. As a minimum, it must contain the Q.922 Address or as much as was delivered. It is desirable to include all in- formation up to the PDU.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7582, '.1.3.6.1.2.1.10.32.3.1.4', 'frErrTime', 7578, 'mandatory', NULL, 'The value of sysUpTime at which the error was detected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7583, '.1.3.6.1.2.1.10.32.4', 'frame-relay-globals', 7548, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7584, '.1.3.6.1.2.1.10.32.4.1', 'frTrapState', 7583, 'mandatory', NULL, 'This variable indicates whether the system produces the frDLCIStatusChange trap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7585, '.1.3.6.1.2.1.10.32.0', 'frame-relayPrefix', 7548, 'current', NULL, 'Prefix for TRAP-TYPE objects', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7586, '.1.3.6.1.2.1.10.32.0.1', 'frDLCIStatusChange', 7585, 'current', NULL, 'This trap indicates that the indicated Virtual Circuit has changed state. It has either been created or invalidated, or has toggled between the active and inactive states.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7587, '.1.3.6.1.4.1.9.9.49', 'ciscoFrameRelayMIB', 272, 'current', NULL, 'Cisco Frame Relay MIB', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7588, '.1.3.6.1.4.1.9.9.49.1', 'ciscoFrMIBObjects', 7587, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7589, '.1.3.6.1.4.1.9.9.49.1.1', 'cfrLmiObjs', 7588, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7590, '.1.3.6.1.4.1.9.9.49.1.2', 'cfrCircuitObjs', 7588, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7591, '.1.3.6.1.4.1.9.9.49.1.3', 'cfrMapObjs', 7588, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7592, '.1.3.6.1.4.1.9.9.49.1.4', 'cfrSvcObjs', 7588, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7593, '.1.3.6.1.4.1.9.9.49.1.5', 'cfrElmiObjs', 7588, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7594, '.1.3.6.1.4.1.9.9.49.1.6', 'cfrFragObjs', 7588, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7595, '.1.3.6.1.4.1.9.9.49.1.7', 'cfrConnectionObjs', 7588, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7596, '.1.3.6.1.4.1.9.9.49.1.1.1', 'cfrLmiTable', 7589, 'current', 'American National Standard T1.617-1991, Annex D', 'Table of Frame Relay LMI information that are either supplemental to the frDlcmiTable of RFC 1315 or specific to Cisco''s implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7597, '.1.3.6.1.4.1.9.9.49.1.1.1.1', 'cfrLmiEntry', 7596, 'current', NULL, 'Each entry of the table contains information of Frame Relay LMI over one physical interface. They are mostly FR generic and some Cisco specific.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7598, '.1.3.6.1.4.1.9.9.49.1.1.1.1.1', 'cfrLmiLinkstatus', 7597, 'current', NULL, 'Data link status via LMI.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7599, '.1.3.6.1.4.1.9.9.49.1.1.1.1.2', 'cfrLmiLinkType', 7597, 'current', NULL, 'Frame Relay link type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7600, '.1.3.6.1.4.1.9.9.49.1.1.1.1.3', 'cfrLmiEnquiryIns', 7597, 'current', NULL, 'Number of Status Enquiry messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7601, '.1.3.6.1.4.1.9.9.49.1.1.1.1.4', 'cfrLmiEnquiryOuts', 7597, 'current', NULL, 'Number of Status Enquiry messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7602, '.1.3.6.1.4.1.9.9.49.1.1.1.1.5', 'cfrLmiStatusIns', 7597, 'current', NULL, 'Number of Status messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7603, '.1.3.6.1.4.1.9.9.49.1.1.1.1.6', 'cfrLmiStatusOuts', 7597, 'current', NULL, 'Number of Status messages sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7604, '.1.3.6.1.4.1.9.9.49.1.1.1.1.7', 'cfrLmiUpdateStatusIns', 7597, 'current', NULL, 'Number of Update Status messages received.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7605, '.1.3.6.1.4.1.9.9.49.1.1.1.1.8', 'cfrLmiUpdateStatusOuts', 7597, 'current', NULL, 'Number of Update Status messages sent', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7606, '.1.3.6.1.4.1.9.9.49.1.1.1.1.9', 'cfrLmiStatusTimeouts', 7597, 'current', NULL, 'Number of times when timeout occurred on waiting for Status message', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7607, '.1.3.6.1.4.1.9.9.49.1.1.1.1.10', 'cfrLmiStatusEnqTimeouts', 7597, 'current', NULL, 'Number of times when timeout occurred on waiting for Status Enquiry message', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7608, '.1.3.6.1.4.1.9.9.49.1.1.1.1.11', 'cfrLmiN392Dce', 7597, 'current', NULL, 'LMI error threshold for DCE interface. For DTE, value becomes 0.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7609, '.1.3.6.1.4.1.9.9.49.1.1.1.1.12', 'cfrLmiN393Dce', 7597, 'current', NULL, 'LMI monitored event count for DCE interface. For DTE, value becomes zero (0).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7610, '.1.3.6.1.4.1.9.9.49.1.1.1.1.13', 'cfrLmiT392Dce', 7597, 'current', NULL, 'DCE polling verification timer for DCE interface For DTE, the value becomes zero (0).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7611, '.1.3.6.1.4.1.9.9.49.1.2.1', 'cfrCircuitTable', 7590, 'current', NULL, 'Table of descriptive and statistics information that are generic to Frame Relay virtual circuits.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7612, '.1.3.6.1.4.1.9.9.49.1.2.1.1', 'cfrCircuitEntry', 7611, 'current', NULL, 'Each entry of the table contains information of a circuit that are not included in frCircuitTable of RFC1315 but are generic to Frame Relay.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7613, '.1.3.6.1.4.1.9.9.49.1.2.1.1.1', 'cfrCircuitDEins', 7612, 'current', NULL, 'Number of packets received with the Discarded Eligibility indictor (the DE bit) set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7614, '.1.3.6.1.4.1.9.9.49.1.2.1.1.2', 'cfrCircuitDEouts', 7612, 'current', NULL, 'Number of packets transmitted with DE bit set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7615, '.1.3.6.1.4.1.9.9.49.1.2.1.1.3', 'cfrCircuitDropPktsOuts', 7612, 'current', NULL, 'Number of discarded packets that were to be sent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7616, '.1.3.6.1.4.1.9.9.49.1.2.1.1.4', 'cfrCircuitType', 7612, 'current', NULL, 'Basic circuit type', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7617, '.1.3.6.1.4.1.9.9.49.1.2.2', 'cfrExtCircuitTable', 7590, 'current', NULL, 'Table of Cisco implementation specific FR circuit information. This is a Cisco extension for the frCircuitTable of RFC 1315.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7618, '.1.3.6.1.4.1.9.9.49.1.2.2.1', 'cfrExtCircuitEntry', 7617, 'current', NULL, 'Each entry of the table contains information of a Frame Relay virtual circuit that are specific to Cisco implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7619, '.1.3.6.1.4.1.9.9.49.1.2.2.1.1', 'cfrExtCircuitIfName', 7618, 'current', NULL, 'The textual name of the main interface or the subinterface that this DLCI is associated with. This is the same name string of an interface used in the configuration and all console displays, such as ''serial 0'', ''serial 3/0.3'', etc.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7620, '.1.3.6.1.4.1.9.9.49.1.2.2.1.2', 'cfrExtCircuitIfType', 7618, 'current', NULL, 'Type of the subinterface this DLCI is associated with, if configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7621, '.1.3.6.1.4.1.9.9.49.1.2.2.1.3', 'cfrExtCircuitSubifIndex', 7618, 'current', NULL, 'For value greater than zero (0), it indicates the network management interface index for the subinterface associated with this DLCI. Value 0 means the DLCI is not associated with any subinterface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7622, '.1.3.6.1.4.1.9.9.49.1.2.2.1.4', 'cfrExtCircuitMapStatus', 7618, 'current', NULL, 'The mapping protocols (internally considered as the ''link type'') applied on this circuit. The value ranges from 0 to 2047. For point-to-point DLCI, the value stays zero. Otherwise, the value is a sum. It initially takes the value zero, then, for each type of Protocol, 2 raised to a power is added to the sum. The following table presents respective power and equivalent value for each applicable type:  Protocol Power Value ---- ----- ----- IP 0 1 IPX 1 2 Appletalk 2 4 XNS 3 8 VINES 4 16 DECnet 5 32 CLNS 6 64 Bridging 7 128 RSRB 8 256 STUN 9 512 LLC2 10 1024  For example, value 3 means the circuit''s mapping protocols include IP and IPX. (3 = 2**1 + 2**0, where 0 corresponds to IP and 1 to IPX.) Value 0 means there is currently no mapping protocol for the circuit. See cfrMapTable for more mapping information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7623, '.1.3.6.1.4.1.9.9.49.1.2.2.1.5', 'cfrExtCircuitCreateType', 7618, 'current', NULL, 'Identify the last source of the circuit''s creation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7624, '.1.3.6.1.4.1.9.9.49.1.2.2.1.6', 'cfrExtCircuitMulticast', 7618, 'current', NULL, 'Indicate if this DLCI is a multicast DLCI.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7625, '.1.3.6.1.4.1.9.9.49.1.2.2.1.7', 'cfrExtCircuitRoutedDlci', 7618, 'current', NULL, 'The routed DLCI to pair up with this DLCI for switching function. NOTE: Value zero (0) indicates that there is no such routed DLCI corresponding to this DLCI.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7626, '.1.3.6.1.4.1.9.9.49.1.2.2.1.8', 'cfrExtCircuitRoutedIf', 7618, 'current', NULL, 'The interface for the routed DLCI that pairs up with this DLCI for switching. Value greater than 0 is the InterfaceIndex for that interface. Value zero (0) indicates that there is no such routed DLCI corresponding to this DLCI.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7627, '.1.3.6.1.4.1.9.9.49.1.2.2.1.9', 'cfrExtCircuitUncompressIns', 7618, 'current', NULL, 'Number of inbound octets of the data packets, accounted at Frame Relay level after FRF.9 payload decompression is applied. In the case of non-FRF.9, this value could be identical to frCircuitReceivedOctets, unless otherwise noted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7628, '.1.3.6.1.4.1.9.9.49.1.2.2.1.10', 'cfrExtCircuitUncompressOuts', 7618, 'current', NULL, 'Number of outbound octets of the data packets, accounted at Frame Relay level before FRF.9 payload compression is applied. In the case of non-FRF.9, this value could be identical to frCircuitSentOctets, unless otherwise noted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7629, '.1.3.6.1.4.1.9.9.49.1.2.2.1.11', 'cfrExtCircuitFECNOuts', 7618, 'current', NULL, 'Total number of frames sent out to the network indicating forward congestion.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7630, '.1.3.6.1.4.1.9.9.49.1.2.2.1.12', 'cfrExtCircuitBECNOuts', 7618, 'current', NULL, 'Total number of frames sent out to the network indicating backward congestion.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7631, '.1.3.6.1.4.1.9.9.49.1.2.2.1.13', 'cfrExtCircuitMinThruputOut', 7618, 'current', NULL, 'Circuit''s outgoing minimal Throughput based on configuration.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7632, '.1.3.6.1.4.1.9.9.49.1.2.2.1.14', 'cfrExtCircuitMinThruputIn', 7618, 'current', NULL, 'Circuit''s incoming minimal Throughput based on configuration.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7633, '.1.3.6.1.4.1.9.9.49.1.2.2.1.15', 'cfrExtCircuitBcastPktOuts', 7618, 'current', NULL, 'Total number of broadcast packets sent out to the network.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7634, '.1.3.6.1.4.1.9.9.49.1.2.2.1.16', 'cfrExtCircuitBcastByteOuts', 7618, 'current', NULL, 'Total number of bytes sent out to the network in broadcast packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7635, '.1.3.6.1.4.1.9.9.49.1.2.2.1.17', 'cfrExtCircuitBandwidth', 7618, 'current', NULL, 'Bandwidth of the virtual circuit, acquired from Cisco typed LMI Full Status message.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7636, '.1.3.6.1.4.1.9.9.49.1.2.2.1.18', 'cfrExtCircuitShapeByteLimit', 7618, 'current', NULL, 'Maximum number of tokens a token bucket can hold in any time interval in case of traffic shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7637, '.1.3.6.1.4.1.9.9.49.1.2.2.1.19', 'cfrExtCircuitShapeInterval', 7618, 'current', NULL, 'Committed rate measurement interval.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7638, '.1.3.6.1.4.1.9.9.49.1.2.2.1.20', 'cfrExtCircuitShapeByteIncrement', 7618, 'current', NULL, 'Number of tokens added into the token bucket per time interval in case of traffic shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7639, '.1.3.6.1.4.1.9.9.49.1.2.2.1.21', 'cfrExtCircuitShapePkts', 7618, 'current', NULL, 'Total number of packets that went through traffic shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7640, '.1.3.6.1.4.1.9.9.49.1.2.2.1.22', 'cfrExtCircuitShapeBytes', 7618, 'current', NULL, 'Total number of bytes that went through traffic shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7641, '.1.3.6.1.4.1.9.9.49.1.2.2.1.23', 'cfrExtCircuitShapePktsDelay', 7618, 'current', NULL, 'Total number of packets that were delayed by the traffic shaper.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7642, '.1.3.6.1.4.1.9.9.49.1.2.2.1.24', 'cfrExtCircuitShapeBytesDelay', 7618, 'current', NULL, 'Total number of bytes that were delayed by the traffic shaper.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7643, '.1.3.6.1.4.1.9.9.49.1.2.2.1.25', 'cfrExtCircuitShapeActive', 7618, 'current', NULL, 'Shows whether shaping is active or not.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7644, '.1.3.6.1.4.1.9.9.49.1.2.2.1.26', 'cfrExtCircuitShapeAdapting', 7618, 'current', NULL, 'Type of Adaptive Shaping configured. none(1) - No adaptive shaping configured becn(2) - Backward Explicit Congestion Notification foreSight(3) - ForeSight is the network traffic control software used in Cisco WAN switches', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7645, '.1.3.6.1.4.1.9.9.49.1.2.2.1.27', 'cfrExtCircuitTxDataRate', 7618, 'current', NULL, 'The average rate (bytes/second) at which data is transmitted in this circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7646, '.1.3.6.1.4.1.9.9.49.1.2.2.1.28', 'cfrExtCircuitTxPktRate', 7618, 'current', NULL, 'The average number of packets sent in a second in this circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7647, '.1.3.6.1.4.1.9.9.49.1.2.2.1.29', 'cfrExtCircuitRcvDataRate', 7618, 'current', NULL, 'The average rate (bytes/second) at which data is received in this circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7648, '.1.3.6.1.4.1.9.9.49.1.2.2.1.30', 'cfrExtCircuitRcvPktRate', 7618, 'current', NULL, 'The average number of packets received in a second in this circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7649, '.1.3.6.1.4.1.9.9.49.1.3.1', 'cfrMapTable', 7591, 'current', NULL, 'Table of protocols and addresses mapping information of FR virtual circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7650, '.1.3.6.1.4.1.9.9.49.1.3.1.1', 'cfrMapEntry', 7649, 'current', NULL, 'Each entry of the table contains one mapping information of a Frame Relay virtual circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7651, '.1.3.6.1.4.1.9.9.49.1.3.1.1.1', 'cfrMapIndex', 7650, 'current', NULL, 'An arbitrary Index to the mapping information associated with a certain circuit. The maximum value is arbitrarily picked which is considered sufficient for usual configuration.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7652, '.1.3.6.1.4.1.9.9.49.1.3.1.1.2', 'cfrMapProtocol', 7650, 'current', NULL, 'Mapping protocol for this circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7653, '.1.3.6.1.4.1.9.9.49.1.3.1.1.3', 'cfrMapAddress', 7650, 'current', NULL, 'Mapping protocol address at remote end for this DLCI. NOTE: For point-to-point DLCI, the string is fixed to be point-to-point.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7654, '.1.3.6.1.4.1.9.9.49.1.3.1.1.4', 'cfrMapType', 7650, 'current', NULL, 'Type for the map creation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7655, '.1.3.6.1.4.1.9.9.49.1.3.1.1.5', 'cfrMapEncaps', 7650, 'current', NULL, 'Indication of the encapsulation type for this mapping protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7656, '.1.3.6.1.4.1.9.9.49.1.3.1.1.6', 'cfrMapBroadcast', 7650, 'current', NULL, 'Broadcast enabled or disabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7657, '.1.3.6.1.4.1.9.9.49.1.3.1.1.7', 'cfrMapPayloadCompress', 7650, 'deprecated', NULL, 'Indicate if payload compression is enabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7658, '.1.3.6.1.4.1.9.9.49.1.3.1.1.8', 'cfrMapTcpHdrCompress', 7650, 'current', NULL, 'TCP header compression type, if applicable.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7659, '.1.3.6.1.4.1.9.9.49.1.3.1.1.9', 'cfrMapRtpHdrCompress', 7650, 'current', NULL, 'RTP header compression type, if applicable. The value ''passive'' means that the header of an outgoing RTP/IP packet is compressed only if an incoming RTP/IP packet had a compressed header. The value ''active'' means the header of every outgoing RTP/IP packet is compressed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7660, '.1.3.6.1.4.1.9.9.49.1.3.1.1.10', 'cfrMapPayloadCompressType', 7650, 'current', 'Frame Relay Forum document number FRF.9', 'FR payload compression type, if applicable. FRF.9 is the Frame Relay Forum Implementation Agreement on FR payload compression. The compression can be done by either software or hardware (when equipped with the supporting hardware), depending on configuration.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7661, '.1.3.6.1.4.1.9.9.49.1.4.1', 'cfrSvcTable', 7592, 'current', NULL, 'Table of FR SVC specific, descriptive and statistics information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7662, '.1.3.6.1.4.1.9.9.49.1.4.1.1', 'cfrSvcEntry', 7661, 'current', NULL, 'Each entry of the table contains circuit information specific to a Frame Relay Switched Virtual Circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7663, '.1.3.6.1.4.1.9.9.49.1.4.1.1.1', 'cfrSvcAddrLocal', 7662, 'current', NULL, 'Local E.164/X.125 address for the circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7664, '.1.3.6.1.4.1.9.9.49.1.4.1.1.2', 'cfrSvcAddrRemote', 7662, 'current', NULL, 'Remote E.164/X.125 address for the circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7665, '.1.3.6.1.4.1.9.9.49.1.4.1.1.3', 'cfrSvcThroughputIn', 7662, 'current', NULL, 'Circuit''s incoming throughput. For outgoing throughput (commonly referred to as CIR) see frCircuitThroughput per RFC1315.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7666, '.1.3.6.1.4.1.9.9.49.1.4.1.1.4', 'cfrSvcMinThruputOut', 7662, 'deprecated', NULL, 'Circuit''s outgoing minimal Throughput.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7667, '.1.3.6.1.4.1.9.9.49.1.4.1.1.5', 'cfrSvcMinThruputIn', 7662, 'deprecated', NULL, 'Circuit''s incoming minimal Throughput.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7668, '.1.3.6.1.4.1.9.9.49.1.4.1.1.6', 'cfrSvcCommitBurstIn', 7662, 'current', NULL, 'Circuit''s incoming Committed Burst Rate. See ANSI and/or ITU specifications for definition and calculations. For outgoing CBR, see frCircuitCommittedBurst per RFC 1315.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7669, '.1.3.6.1.4.1.9.9.49.1.4.1.1.7', 'cfrSvcExcessBurstIn', 7662, 'current', NULL, 'Circuit''s incoming Excess Burst Rate. See ANSI and/or ITU specifications for definition and calculations. For outgoing EBR, see frCircuitExcessBurst per RFC 1315.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7670, '.1.3.6.1.4.1.9.9.49.1.4.1.1.8', 'cfrSvcIdleTime', 7662, 'current', NULL, 'Circuit''s idle time period. If expires, the circuit is cleared.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7671, '.1.3.6.1.4.1.9.9.49.1.5.1', 'cfrElmiIpAddr', 7593, 'current', NULL, 'This object represents the Management address of the device used for address registration. Network management station can send management messages to this IP address. This can be user configured address or the address of one of the interfaces on the device. If address registration is disabled then this will have a value of 0.0.0.0. This object is accessible only if the ELMI protocol is supported on the device', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7672, '.1.3.6.1.4.1.9.9.49.1.5.2', 'cfrElmiTable', 7593, 'current', NULL, 'Table of CISCO Frame Relay ELMI information that is specific to CISCO implementation', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7673, '.1.3.6.1.4.1.9.9.49.1.5.2.1', 'cfrElmiEntry', 7672, 'current', NULL, 'Each entry of the table contains information about a physical interface. The table can be accessible only if the device supports ELMI protocol and if LMI is enabled on the interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7674, '.1.3.6.1.4.1.9.9.49.1.5.2.1.1', 'cfrElmiLinkStatus', 7673, 'current', NULL, 'This variable states whether Enhanced Link Management Interface(ELMI) protocol is enabled or not on a frame relay interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7675, '.1.3.6.1.4.1.9.9.49.1.5.2.1.2', 'cfrElmiArStatus', 7673, 'current', NULL, 'This variable states whether the Enhanced Link Management Interface(ELMI) address registration(AR) mechanism is enabled or not on a frame relay interface. A value of 1 indicates ELMI AR is supported on the interface. A value of 2 indicates ELMI AR is supported but the user disabled the exchange of IP address and ifIndex with the neighboring device. This object doesn''t have any significance if cfrElmiLinkStatus is disabled on the interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7676, '.1.3.6.1.4.1.9.9.49.1.5.2.1.3', 'cfrElmiRemoteStatus', 7673, 'current', NULL, 'This variable states the Enhanced Link Management(ELMI) status on the other end of the interface. If cfrElmiLinkStatus is enabled on the other end a value of 1 will be returned, else 2 will be returned. This object doesn''t have any significance if cfrElmiLinkStatus is disabled on the interface', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7677, '.1.3.6.1.4.1.9.9.49.1.5.3', 'cfrElmiNeighborTable', 7593, 'current', NULL, 'Table of CISCO Frame Relay Neighbor ELMI information that is specific to CISCO implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7678, '.1.3.6.1.4.1.9.9.49.1.5.3.1', 'cfrElmiNeighborEntry', 7677, 'current', NULL, 'Each entry of the table contains information of the neighboring device connected to a physical interface. The entry will be present only if ELMI is enabled on the neighboring device interface. If the value of the cfrElmiRemoteStatus in the cfrElmiEntry is 1 then a valid entry exists for the interface. If ELMI is not supported on the remote end then, the neighbor information for the interface will not be present', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7679, '.1.3.6.1.4.1.9.9.49.1.5.3.1.1', 'cfrElmiNeighborArStatus', 7678, 'current', NULL, 'This variable indicates the status of ELMI Address registration(AR) on the neighboring device. A value of 1 indicates ELMI AR is not supported on the neighboring device. A value of 2 indicates ELMI AR is enabled on the interface. A value of 3 indicates AR is supported, but user disabled the exchange of IP address and ifIndex with the neighbor.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7680, '.1.3.6.1.4.1.9.9.49.1.5.3.1.2', 'cfrElmiNeighborIpAddress', 7678, 'current', NULL, 'The Management IP address of the neighboring device to which the other end of this interface is connected. Network management system can use this address to send management messages to the device. If address registration is not supported on the remote end then the value will be 0.0.0.0. NMS uses this object in the topology discovery of the network.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7681, '.1.3.6.1.4.1.9.9.49.1.5.3.1.3', 'cfrElmiNeighborIfIndex', 7678, 'current', NULL, 'The Interface index of the neighboring device to which this interface is connected. If the value of cfrElmiNeighborArStatus is 2 then this will have a valid value. If the value of cfrElmiNeighborArStatus is 3 or 1 then value of this object will be 0. NMS uses this object in the topology discovery of the network.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7682, '.1.3.6.1.4.1.9.9.49.1.5.3.1.4', 'cfrElmiNeighborVendorName', 7678, 'current', NULL, 'Vendor name of the neighboring device to which the other end of this interface is connected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7683, '.1.3.6.1.4.1.9.9.49.1.5.3.1.5', 'cfrElmiNeighborPlatformName', 7678, 'current', NULL, 'Platform name of the neighboring device to which the other end of this interface is connected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7684, '.1.3.6.1.4.1.9.9.49.1.5.3.1.6', 'cfrElmiNeighborDeviceName', 7678, 'current', NULL, 'Device name of the neighboring device to which the other end of this interface is connected.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7685, '.1.3.6.1.4.1.9.9.49.1.6.1', 'cfrFragTable', 7594, 'current', NULL, 'Table of Frame Relay Fragmentation information. These are specific to Cisco''s implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7686, '.1.3.6.1.4.1.9.9.49.1.6.1.1', 'cfrFragEntry', 7685, 'current', NULL, 'Each entry of the table contains details of fragmentation configured on this circuit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7687, '.1.3.6.1.4.1.9.9.49.1.6.1.1.1', 'cfrFragSize', 7686, 'current', NULL, 'cfrFragSize defines the payload size of a fragment and it excludes the FR headers and any FR fragmentation header.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7688, '.1.3.6.1.4.1.9.9.49.1.6.1.1.2', 'cfrFragType', 7686, 'current', NULL, 'Fragmentation type configured by the user. The types supported are end-to-end, VoFR-cisco and VoFR.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7689, '.1.3.6.1.4.1.9.9.49.1.6.1.1.3', 'cfrFragInPkts', 7686, 'current', NULL, 'Total number of frames received that have a fragmentation header.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7690, '.1.3.6.1.4.1.9.9.49.1.6.1.1.4', 'cfrFragOutPkts', 7686, 'current', NULL, 'Total number of fragments that are transmitted with a fragmenation header.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7691, '.1.3.6.1.4.1.9.9.49.1.6.1.1.5', 'cfrFragInOctets', 7686, 'current', NULL, 'Total number of bytes received in frames that have a fragmentation header. The number of bytes include the FR header.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7692, '.1.3.6.1.4.1.9.9.49.1.6.1.1.6', 'cfrFragOutOctets', 7686, 'current', NULL, 'Total number of bytes that are transmitted in frames with a fragmenation header. The number of bytes also includes the FR header.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7693, '.1.3.6.1.4.1.9.9.49.1.6.1.1.7', 'cfrFragNotInPkts', 7686, 'current', NULL, 'Total number of frames received that do not require reassembly and therefore will not contain the fragmentation header. This counter is valid only when end-to-end fragmentation type is set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7694, '.1.3.6.1.4.1.9.9.49.1.6.1.1.8', 'cfrFragNotOutPkts', 7686, 'current', NULL, 'Total number of frames transmitted without fragmenting and therefore will not contain the fragmentation header. This counter is valid only when end-to-end fragmentation type is set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7695, '.1.3.6.1.4.1.9.9.49.1.6.1.1.9', 'cfrFragNotInOctets', 7686, 'current', NULL, 'Total number of bytes received in frames that do not require reassembly and therefore will not contain the fragmentation header. This counter is valid only when end-to-end fragmentation type is set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7696, '.1.3.6.1.4.1.9.9.49.1.6.1.1.10', 'cfrFragNotOutOctets', 7686, 'current', NULL, 'Total number of bytes transmitted in frames that are not fragmented and therefore will not contain the fragmentation header. This counter is valid only when end-to-end fragmentation type is set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7697, '.1.3.6.1.4.1.9.9.49.1.6.1.1.11', 'cfrFragAssembledInPkts', 7686, 'current', NULL, 'Total number of fully reassembled frames. It also counts the number of packets received without FR fragmentation header (i.e. in un-fragmentated pkts).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7698, '.1.3.6.1.4.1.9.9.49.1.6.1.1.12', 'cfrFragAssembledInOctets', 7686, 'current', NULL, 'Total number of bytes received in fully reassembled frames. It also counts the number of packets received without FR fragmentation header (i.e.in un-fragmentated pkts).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7699, '.1.3.6.1.4.1.9.9.49.1.6.1.1.13', 'cfrFragPreOutPkts', 7686, 'current', NULL, 'Total number of frames fragmented and trasmitted. It also counts the number of packets trasmitted without FR fragmentation header (i.e. in un-fragmentated pkts).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7700, '.1.3.6.1.4.1.9.9.49.1.6.1.1.14', 'cfrFragPreOutOctets', 7686, 'current', NULL, 'Total number of bytes transmitted in fragmented frames. It also counts the number of bytes trasmitted in frames without FR fragmentation header (i.e. in un-fragmentated pkts).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7701, '.1.3.6.1.4.1.9.9.49.1.6.1.1.15', 'cfrFragDroppedReAssembledInPkts', 7686, 'current', NULL, 'Number of received fragments dropped for reasons such as : running out of memory, receiving segments out of sequence, receiving an unexpected frame with a B bit set, timing out on a reassembling frame.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7702, '.1.3.6.1.4.1.9.9.49.1.6.1.1.16', 'cfrFragDroppedFragmentedOutPkts', 7686, 'current', NULL, 'Number of fragments dropped because of running out of memory.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7703, '.1.3.6.1.4.1.9.9.49.1.6.1.1.17', 'cfrFragTimeoutsIn', 7686, 'current', NULL, 'Number of reassemble timer timeouts for this circuit. A frame requiring more than two minutes to fully reassemble is dropped and timeout will be incremented by one.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7704, '.1.3.6.1.4.1.9.9.49.1.6.1.1.18', 'cfrFragOutOfSeqFragPkts', 7686, 'current', NULL, 'Indicates the total number of packets received with an unexpected sequence number. All fragments being reassembled are dropped. Start a new packet with the received segment only if the B bit is set on the segment. Otherwise the new segment is also dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7705, '.1.3.6.1.4.1.9.9.49.1.6.1.1.19', 'cfrFragUnexpectedBBitSetPkts', 7686, 'current', NULL, 'Number of fragments received in this circuit with a B bit set. All fragments being reassembled are dropped and a new packet is started with this segment.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7706, '.1.3.6.1.4.1.9.9.49.1.6.1.1.20', 'cfrFragSeqMissedPkts', 7686, 'current', NULL, 'Number of fragments received in this circuit with skipped sequence number.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7707, '.1.3.6.1.4.1.9.9.49.1.6.1.1.21', 'cfrFragInterleavedOutPkts', 7686, 'current', NULL, 'Number of packets that have been interleaved between segments.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7708, '.1.3.6.1.4.1.9.9.49.1.7.1', 'cfrConnectionTable', 7595, 'current', NULL, 'Table of Frame Relay/Frame Relay and Frame Relay/ATM Network/Service Interworking connection information. These are specific to Cisco''s implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7709, '.1.3.6.1.4.1.9.9.49.1.7.1.1', 'cfrConnectionEntry', 7708, 'current', NULL, 'Each entry of the table contains information of a connection that is established for Frame Relay/Frame Relay and Frame Relay/ATM Network/Service Interworking.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7710, '.1.3.6.1.4.1.9.9.49.1.7.1.1.1', 'cfrConnName', 7709, 'current', NULL, 'The textual name of a for FR/FR or FR/ATM Network/Service Interworking connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7711, '.1.3.6.1.4.1.9.9.49.1.7.1.1.2', 'cfrConnID', 7709, 'current', NULL, 'The numerical identifier of a FR/FR or FR/ATM Network/Service Interworking connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7712, '.1.3.6.1.4.1.9.9.49.1.7.1.1.3', 'cfrConnState', 7709, 'current', NULL, 'Status of a FR/FR or FR/ATM Network/Service Interworking connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7713, '.1.3.6.1.4.1.9.9.49.1.7.1.1.4', 'cfrConnSegment1Name', 7709, 'current', NULL, 'The textual name used to identify the first segment of a FR/FR or FR/ATM Network/Service Interworking connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7714, '.1.3.6.1.4.1.9.9.49.1.7.1.1.5', 'cfrConnSegment1VCGroup', 7709, 'current', NULL, 'The textual name used to identify the VC-Group in the first segment of a Frame Relay/ATM Network Interworking (FRF.5)connection. This field is not applicabe in case of, FRF.8 (Frame Relay/ATM Service Interworking) and FR-FR connectione.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7715, '.1.3.6.1.4.1.9.9.49.1.7.1.1.6', 'cfrConnSegment1Dlci', 7709, 'current', NULL, 'The DLCI used as the first segment of a FR-FR or FR-ATM Network/Service Interworking connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7716, '.1.3.6.1.4.1.9.9.49.1.7.1.1.7', 'cfrConnSegment2Name', 7709, 'current', NULL, 'The interface on which second segment of a FR-FR or FR-ATM Network/Service Interworking connection is configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7717, '.1.3.6.1.4.1.9.9.49.1.7.1.1.8', 'cfrConnSegment2Vpi', 7709, 'current', NULL, 'The value of VPI, in the ATM connection, used as the second segment of a FR-ATM Network/Service Interworking connection. In case of FR-FR connection, the same will be used to display the DLCI used as the second segment.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7718, '.1.3.6.1.4.1.9.9.49.1.7.1.1.9', 'cfrConnSegment2Vci', 7709, 'current', NULL, 'The value of VCI, in the ATM connection, used as the second segment of a FR-ATM Network/Service Interworking connection. In case of FR-FR connection, this is not supported.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7719, '.1.3.6.1.4.1.9.9.49.1.7.1.1.10', 'cfrConnServiceTranslation', 7709, 'current', NULL, 'Shows whether Service Translation Mode is supported or not. Translation Mode is the interworking of internetworking (routed and/or bridged) protocols used in FR-ATM Service PVC Interworking(FRF.8). This is not supported in case of FRF.5 (FR-ATM network Interworking) and FR-FR connections.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7720, '.1.3.6.1.4.1.9.9.49.1.7.1.1.11', 'cfrConnFrSscsDlci', 7709, 'current', NULL, 'The DLCI value used at the FR-SSCS layer. This is one of connection multiplexing methods used in Frame Relay/ATM Network Interworking. Not supported in case of FRF.8 (FR-ATM Service PVC Interworking) and FR-FR connections', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7721, '.1.3.6.1.4.1.9.9.49.1.7.1.1.12', 'cfrConnEfciBit', 7709, 'current', NULL, 'Shows whether the FECN field in the FR frame is mapped to the ATM EFCI field of every cell generated out of the FR frame. This is used to indicate congestion in FR to ATM direction in case of Frame Relay/ATM Service PVC Interworking. Not supported in FRF.5 (Frame Relay/ATM Network Interworking and FR-FR connections.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7722, '.1.3.6.1.4.1.9.9.49.1.7.1.1.13', 'cfrConnDeBit', 7709, 'current', NULL, 'The method of operation for loss priority mapping in the B-ISDN to FR direction.. Not supported in case of FR-FR connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7723, '.1.3.6.1.4.1.9.9.49.1.7.1.1.14', 'cfrConnClpBit', 7709, 'current', NULL, 'The method of operation used to map loss priority mapping in the FR to ATM direction. Not supported in case of FR-FR connection.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7724, '.1.3.6.1.4.1.9.9.49.3', 'ciscoFrMIBConformance', 7587, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7725, '.1.3.6.1.4.1.9.9.49.3.1', 'ciscoFrMIBCompliances', 7724, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7726, '.1.3.6.1.4.1.9.9.49.3.2', 'ciscoFrMIBGroups', 7724, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7727, '.1.3.6.1.4.1.9.9.49.3.1.1', 'ciscoFrMIBCompliance', 7725, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7728, '.1.3.6.1.4.1.9.9.49.3.1.2', 'ciscoFrMIBCompliancesRev1', 7725, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7729, '.1.3.6.1.4.1.9.9.49.3.1.3', 'ciscoFrMIBCompliancesRev2', 7725, 'obsolete', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7730, '.1.3.6.1.4.1.9.9.49.3.1.4', 'ciscoFrMIBCompliancesRev3', 7725, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7731, '.1.3.6.1.4.1.9.9.49.3.1.5', 'ciscoFrMIBCompliancesRev4', 7725, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7732, '.1.3.6.1.4.1.9.9.49.3.2.1', 'ciscoFrMIBGroup', 7726, 'deprecated', NULL, 'The compliance statement for entities which implement this Cisco Frame Relay MIB.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7733, '.1.3.6.1.4.1.9.9.49.3.2.2', 'ciscoFrMIBGroupRev1', 7726, 'deprecated', NULL, 'A collection of objects providing router''s Frame Relay configuration and statistics information that are additional to the IETF standard Frame Relay DTE MIB.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7734, '.1.3.6.1.4.1.9.9.49.3.2.3', 'ciscoFrLmiMIBGroup', 7726, 'current', NULL, 'A collection of objects providing router''s Frame Relay LMI configuration and statistics information either supplemental to the frDlcmiTable of RFC 1315 or specific to Cisco''s implementation.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7735, '.1.3.6.1.4.1.9.9.49.3.2.4', 'ciscoFrCircuitMIBGroup', 7726, 'current', NULL, 'A collection of objects providing information of a circuit that are not included in frCircuitTable of RFC1315 but are generic to Frame Relay.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7736, '.1.3.6.1.4.1.9.9.49.3.2.5', 'ciscoExtCircuitMIBGroup', 7726, 'deprecated', NULL, 'A collection of objects that provide Cisco implementation specific FR circuit information. This is a Cisco extension for the frCircuitTable of RFC 1315.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7737, '.1.3.6.1.4.1.9.9.49.3.2.13', 'ciscoExtCircuitMIBGroup1', 7726, 'current', NULL, 'A collection of objects that provide Cisco implementation specific FR circuit information. This is a Cisco extension for the frCircuitTable of RFC 1315.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7738, '.1.3.6.1.4.1.9.9.49.3.2.6', 'ciscoFrTsMIBGroup', 7726, 'current', NULL, 'A collection of objects that provide information about Frame Relay Traffic Shaping. These are additional to the IETF standard Frame Relay DTE MIB.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7819, '.1.3.6.1.4.1.9.9.166.1.5.1.1.1', 'cbQosObjectsIndex', 7818, 'current', NULL, 'An arbitrary (system-assigned) instance specific index for cbQosObjectsEntry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7739, '.1.3.6.1.4.1.9.9.49.3.2.7', 'ciscoFrMapMIBGroup', 7726, 'current', NULL, 'A collection of objects to provide mapping information of a Frame Relay virtual circuit. These are additional to the IETF standard Frame Relay DTE MIB.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7740, '.1.3.6.1.4.1.9.9.49.3.2.8', 'ciscoFrSvcMIBGroup', 7726, 'current', NULL, 'A collection of objects to provide circuit information specific to a Frame Relay Switched Virtual Circuit.This is in addition to the IETF standard Frame Relay DTE MIB.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7741, '.1.3.6.1.4.1.9.9.49.3.2.9', 'ciscoFrElmiMIBGroup', 7726, 'deprecated', NULL, 'A collection of objects providing router''s ELMI information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7742, '.1.3.6.1.4.1.9.9.49.3.2.10', 'ciscoFrElmiMIBGroup1', 7726, 'current', NULL, 'A collection of objects providing router''s ELMI information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7743, '.1.3.6.1.4.1.9.9.49.3.2.11', 'ciscoFrFragMIBGroup', 7726, 'current', NULL, 'A collection of objects providing router''s fragmentation information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7744, '.1.3.6.1.4.1.9.9.49.3.2.12', 'ciscoFrConnMIBGroup', 7726, 'current', NULL, 'A collection of objects providing router''s fragmentation information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7745, '.1.3.6.1.2.1.78', 'hcnumTC', 21, 'current', NULL, 'A MIB module containing textual conventions for high capacity data types. This module addresses an immediate need for data types not directly supported in the SMIv2. This short-term solution is meant to be deprecated as a long-term solution is deployed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7746, '.1.3.6.1.4.1.9.9.166', 'ciscoCBQosMIB', 272, 'current', NULL, 'Cisco Class-Based QoS MIB  ********************************** Overview ********************************** This MIB provides read access to Quality of Service (QoS) configuration and statistics information for Cisco platforms that support the Modular Quality of Service Command-line Interface (Modular QoS CLI). We recommend users of this MIB to review the user documentation of MQC based QoS features.  Configuration information available through this MIB includes all ClassMap, PolicyMap, Match Statements, and Feature Actions configuration parameters. The definitions of each objects mentioned above are explained in the QoS objects section.  Statistics available through this MIB include summary counts/rates by traffic class before and after any configured QoS policies are enforced. In addition, detailed feature-specific statistics are available for select PolicyMap features.  Contact your Cisco representative to determine on which platforms the MIB is currently supported.  ********************************** QoS Acronyms ********************************** BECN: Frame Relay Backward Explicit Congestion Notification CIR : Committed Information Rate DSCP: Differentiated Service Code Point EB : Estimate Bandwidth ECN : Explicite Congestion Notification FECN: Frame Relay Forward Explicit Congestion Notification IPHC: Internet Protocol Header Compression IPSLAs: IP Service Level Agreement Technologies PIR : Peak Information Rate PREC: Precedence QoS : Quality Of Services RED : Random Early Detect SRP : Spatial Reuse Protocol WRED: Weighted Random Early Detect C3PL: Cisco Common Classification Programming Language  ********************************** MIB Objects ********************************** This MIB consists of the following object groups: 1 : cbQosServicePolicy 2 : cbQosInterfacePolicy 3 : cbQosFrameRelayVCPolicy 4 : cbQosATMPVCPolicy 5 : cbQosObjects 6 : cbQosPolicyMapCfg 7 : cbQosClassMapCfg 8 : cbQosMatchStmtCfg 9 : cbQosQueueingCfg 10: cbQosREDCfg 11: cbQosREDClassCfg 12: cbQosPoliceCfg 13: cbQosTSCfg 14: cbQosSetCfg 15: cbQosClassMapStats 16: cbQosMatchStmtStats 17: cbQosPoliceStats 18: cbQosQueueingStats 19: cbQosTSStats 20: cbQosREDClassStats 21: cbQosPoliceActionCfg 22: cbQosIPHCCfg 23: cbQosIPHCStats 24: cbQosSetStats 25: cbQosPoliceColorStats 26: cbQosTableMapCfg 27: cbQosTableMapValueCfg 28: cbQosTableMapSetCfg 29: cbQosEBCfg 30: cbQosEBStats 31: cbQosMeasureIPSLACfg 32: cbQosC3plAccountCfg 33: cbQosC3plAccountStats  ********************************** Definitions ********************************** A logical interface in the context of this MIB is either a main-interface, a sub-interface, a Frame Relay DLCI, an ATM virtual circuit or the control-plane on the router.  The (aggregate) control-plane on the router is defined as a collection of processes running at process level on the platform (route) processor. This includes the functions related to networking control capabilities such as routing, signaling, provisioning, as well as resource and service discovery. Also includes process switched traffic on the device.  The term distributed control plane, in the context of this mib, represents the control-plane functionality at the level of individual linecards. This is only applicable for the case of distributed platforms.  ********************************** QoS Objects ********************************** To understand Class-Based QoS features and how to navigate the MIB tables above, the key element is to comprehend the relationships among the different QoS objects. QoS objects consist of ClassMaps, Match Statements and PolicyMaps, and each Feature Actions.  Match Statement - The specific match criteria to identify packets for classification purposes.  ClassMap - A user-defined traffic class that contains one or many match statements used to classify packets into different categories.  Feature Action - An action is a QoS feature. Features include police, traffic-shaping, queueing, random detect and packet marking(set). After the traffic is being classified, based on the traffic classification, we can apply these action to each traffic class.  PolicyMap - A user-defined policy that associates each QoS action to the user-defined traffic class (ClassMap).  Service Policy - Service policy is a policymap that is being attached to a logical interface. Because a policymap can also be a part of the hierarchical structure (inside a classmap), only a policymap that is directly attached to a logical interface is considered a service policy. Each service policy is uniquely identified by an index called cbQosPolicyIndex. This number is usually identical to its cbQosObjectsIndex as a policymap.  ***************************************** Runtime Instance vs Configuration objects *****************************************  Each QoS objects have 2 sets of behaviours : 1: A configuration instance - Each QoS objects has it''s configuration portion of information attached to it. This information does not change whether this object is attached on multiple logical interfaces and used multiple times. We uniquely identify each QoS object with identical configuration with the same index - cbQosConfigIndex. This index is used in all configuration related tables.  2: A runtime instance - Each QoS objects has it''s statistical portion of information attached to it. This information changes when this object is attached on multiple logical interfaces and used in various different places. We uniquely identify each QoS runtime object instance with an index that is unique across multiple instances of the identical object - cbQosObjectsIndex. This index is used in all statistical related tables.  In summary, a QoS object has 2 indexes associated with it: cbQosConfigIndex is used to identify it''s configuration, which does not change regardless of number of times and where it is being used; and cbQosObjectsIndex is used to identify it''s runtime statistics, depending on which logical interface and where in a given PolicyMap hierarchy this object is used, it may have multiple unique identifiers to distinguish each unique usage (instance) of the same object.  ********************************** Navigation ********************************** The recommended method of navigating through all of the MIB tables is to start by learning the cbQosServicePolicyTable and cbQosObjectsTable MIB tables. In particular, Cisco Systems recommends understanding the cbQosObjectsIndex and cbQosParentObjectsIndex of each QoS feature.  The cbQosPolicyIndex and cbQosObjectsIndex are system-assigned numbers that identify each unique instance of a QoS feature. These indexes are never reused between router reboots, even when changes are made to the QoS configuration. The cbQosPolicyIndex is designed to identify the service policies attached to logical interfaces, while the cbQosObjectsIndex is designed to identify each QoS feature on a specified device.  The cbQosParentObjectsIndex is designed to show the hierarchical relationship of each QoS feature.  ********************************** cbQosServicePolicyTable ********************************** Accessing cbQosServicePolicyTable requires cbQosPolicyIndex. This index is a system-assigned number to uniquely identify each service policy hanging off of each logical interface. Given cbQosPolicyIndex the tables provide the type of logical interface/media type on which this policy is applied, the direction in which this policy is enforced, and the SNMP interface index and/or the entity index of the underlying interface/entity. In the case of a policy being applied on a Frame Relay DLCI, the cbQosFrDLCI gives you the Frame Relay DLCI number to which this policy is attached. In the case of policy being attached to an ATM VC, cbQosAtmVPI and cbQosAtmVCI display the VPI and VCI of the ATM interface respectively.  ********************************** cbQosObjectsTable ********************************** Accessing cbQosObjectsTable requires two indexes, cbQosPolicyIndex and cbQosObjectsIndex.  Given a particular service policy on a given logical interface, there could be PolicyMaps, ClassMaps, Match Statements and Feature Actions being used. Each instance of these objects is uniquely identified by cbQosObjectsIndex.  Users need to decide which QoS object is interesting and use the cbQosPolicyIndex and cbQosObjectsIndex to locate the right element of interest. This tables provides cbQosObjectsType, cbQosConfigIndex, and cbQosParentObjectsIndex.  To understand the relationship of cbQosObjectsIndex, cbQosParentObjectsIndex and the hierarchical relationship of the QoS objects, consider the following QoS configuration example:  Interface ethernet 0/1 Input Service Policy cntlWebTraffic ClassMap http match ip http set ip precedence 5  Output Service Policy cntlSNMP_Telnet ClassMap snmp match ip snmp shape average 8000 32 32 ClassMap Telnet match ip telnet shape average 10000 32 32  Interface ethernet 0/2 Input Service Policy cntlWebTraffic ClassMap http match ip http set ip precedence 5  Output Service Policy cntlSNMP_Telnet ClassMap snmp match ip snmp shape average 8000 32 32 ClassMap Telnet match ip telnet shape average 10000 32 32  *** In Ethernet 0/1 *** Assume the router assigned a cbQosConfigIndex=1024 and cbQosObjectsIndex=1084 to Policy cntlWebTraffic. Because it is attached to an interface, it has no parent QoS object, and thus cbQosParentObjectsIndex=0. In addition, because cntlWebTraffic is also the service policy of the interface, it has a unique cbQosPolicyIndex assigned to it. In most cases, it would be the same as the cbQosObjectsIndex, which is 1084 in this case. Therefore, the indexes are: cbQosPolicyIndex = 1084 cbQosObjectsIndex = 1084 cbQosConfigIndex = 1024  Assuming the router assigned a cbQosObjectsIndex=1085 and cbQosConfigIndex=1025 to ClassMap http, it is directly being used by Policy cntlWebTraffic, and therefore the cbQosParentObjectsIndex of ClassMap http will be 1084.  Assuming the router assigned a cbQosConfigIndex=1026 and cbQosObjectsIndex=1086 to match ip http, it is directly used by ClassMap http, therefore the cbQosParentObjectsIndex of match ip http will be 1085.  Assuming the router assigned a cbQosConfigIndex=1027 and cbQosObjectsIndex=1087 to set ip precedence 5, it is directly used by ClassMap http, therefore the cbQosParentObjectsIndex of match ip http will be 1085.  Assuming the router assigned a cbQosConfigIndex=1028 and cbQosObjectsIndex=1088 to Policy cntlSNMP_Telnet. Because it is attached to an interface, it has no parent QoS object, and thus cbQosParentObjectsIndex=0. In addition, because cntlSNMP_Telnet is also the service policy of the interface, it has a unique cbQosPolicyIndex assigned to it. In most cases, it would be the same as the cbQosObjectsIndex, which is 1088 in this case.  Assuming the router assigned a cbQosConfigIndex=1029 and cbQosObjectsIndex=1089 to ClassMap snmp, it is directly being used by Policy cntlSNMP_Telnet, and therefore the cbQosParentObjectsIndex of ClassMap snmp will be 1088.  Assuming the router assigned a cbQosConfigIndex=1030 and cbQosObjectsIndex=1090 to match ip snmp, it is directly used by ClassMap snmp, and therefore the cbQosParentObjectsIndex of match ip snmp will be 1089.  Assuming the router assigned a cbQosConfigIndex=1031 and cbQosObjectsIndex=1091 to shape average 8000 32 32, it is directly used by ClassMap snmp, therefore the cbQosParentObjectsIndex of match ip snmp will be 1089.  Assuming the router assigned a cbQosConfigIndex=1032 and cbQosObjectsIndex=1092 to ClassMap Telnet, it is directly being used by Policy cntlSNMP_Telnet, and therefore the cbQosParentObjectsIndex of ClassMap Telnet will be 1088.  Assuming the router assigned a cbQosConfigIndex=1033 and cbQosObjectsIndex=1093 to match ip telnet, it is directly used by ClassMap Telnet, and therefore the cbQosParentObjectsIndex of match ip telnet will be 1092.  Assuming the router assigned a cbQosConfigIndex=1034 and cbQosObjectsIndex=1094 to shape 10000 32 32, it is directly used by ClassMap telnet, therefore the cbQosParentObjectsIndex of match ip telnet will be 1092.  *** In Ethernet 0/2 *** Every objects will have a unique combination of cbQosPolicyIndex and cbQosObjectsIndex, but cbQosConfigIndex will be shared across the same objects that are applied in different places.  ********************************** All Config Tables ********************************** Accessing config related tables requires the same index - cbQosConfigIndex. (Per precedence based tables requires a second index, which is IP precedence value) Users should have already gone through the cbQosObjectsTable at this point and understood each cbQosConfigIndex and the corresponding QoS objects. Users can uniquely identify each QoS object defined on the router and query the entries in each stats table on a per QoS object basis.  ********************************** All Stats Tables ********************************** Accessing all stats related tables requires the same 2 indexes. They are cbQosPolicyIndex and cbQosObjectsIndex. (Per precedence based tables requires a third index, which is IP precedence value) Users should have already gone through the cbQosObjectsTable at this point and understood the relationship of each cbQosPolicyIndex and cbQosObjectsIndex pair and the corresponding QoS objects. Users can uniquely identify each QoS object defined on the router and query the entries in each stats table on a per QoS object basis.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7747, '.1.3.6.1.4.1.9.9.166.1', 'ciscoCBQosMIBObjects', 7746, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7748, '.1.3.6.1.4.1.9.9.166.2', 'ciscocbQosMIBConformance', 7746, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7749, '.1.3.6.1.4.1.9.9.166.1.1', 'cbQosServicePolicy', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7750, '.1.3.6.1.4.1.9.9.166.1.2', 'cbQosInterfacePolicy', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7751, '.1.3.6.1.4.1.9.9.166.1.3', 'cbQosFrameRelayVCPolicy', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7752, '.1.3.6.1.4.1.9.9.166.1.4', 'cbQosATMPVCPolicy', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7753, '.1.3.6.1.4.1.9.9.166.1.5', 'cbQosObjects', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7754, '.1.3.6.1.4.1.9.9.166.1.6', 'cbQosPolicyMapCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7755, '.1.3.6.1.4.1.9.9.166.1.7', 'cbQosClassMapCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7756, '.1.3.6.1.4.1.9.9.166.1.8', 'cbQosMatchStmtCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7757, '.1.3.6.1.4.1.9.9.166.1.9', 'cbQosQueueingCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7758, '.1.3.6.1.4.1.9.9.166.1.10', 'cbQosREDCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7759, '.1.3.6.1.4.1.9.9.166.1.11', 'cbQosREDClassCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7760, '.1.3.6.1.4.1.9.9.166.1.12', 'cbQosPoliceCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7761, '.1.3.6.1.4.1.9.9.166.1.13', 'cbQosTSCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7762, '.1.3.6.1.4.1.9.9.166.1.14', 'cbQosSetCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7763, '.1.3.6.1.4.1.9.9.166.1.15', 'cbQosClassMapStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7764, '.1.3.6.1.4.1.9.9.166.1.16', 'cbQosMatchStmtStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7765, '.1.3.6.1.4.1.9.9.166.1.17', 'cbQosPoliceStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7766, '.1.3.6.1.4.1.9.9.166.1.18', 'cbQosQueueingStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7767, '.1.3.6.1.4.1.9.9.166.1.19', 'cbQosTSStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7768, '.1.3.6.1.4.1.9.9.166.1.20', 'cbQosREDClassStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7769, '.1.3.6.1.4.1.9.9.166.1.21', 'cbQosPoliceActionCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7770, '.1.3.6.1.4.1.9.9.166.1.22', 'cbQosIPHCCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7771, '.1.3.6.1.4.1.9.9.166.1.23', 'cbQosIPHCStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7772, '.1.3.6.1.4.1.9.9.166.1.24', 'cbQosSetStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7773, '.1.3.6.1.4.1.9.9.166.1.25', 'cbQosPoliceColorStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7774, '.1.3.6.1.4.1.9.9.166.1.26', 'cbQosTableMapCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7775, '.1.3.6.1.4.1.9.9.166.1.27', 'cbQosTableMapValueCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7776, '.1.3.6.1.4.1.9.9.166.1.28', 'cbQosTableMapSetCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7777, '.1.3.6.1.4.1.9.9.166.1.29', 'cbQosEBCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7778, '.1.3.6.1.4.1.9.9.166.1.30', 'cbQosEBStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7779, '.1.3.6.1.4.1.9.9.166.1.31', 'cbQosMeasureIPSLACfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7780, '.1.3.6.1.4.1.9.9.166.1.32', 'cbQosQueueingClassCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7781, '.1.3.6.1.4.1.9.9.166.1.33', 'cbQosC3plAccountCfg', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7782, '.1.3.6.1.4.1.9.9.166.1.34', 'cbQosC3plAccountStats', 7747, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7783, '.1.3.6.1.4.1.9.9.166.1.32.1', 'cbQosQueueingClassCfgTable', 7780, 'current', NULL, 'This table specifies the configuration information for weighted queue limit action per IP precedence basis.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7784, '.1.3.6.1.4.1.9.9.166.1.32.1.1', 'cbQosQueueingClassCfgEntry', 7783, 'current', NULL, 'Each entry in this table describes configuration information about a weighted queueing action. The information includes: Threshold value, Units and wieght Type (ip,dscp,mplsExp)  This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex(which refers to cbQosConfigIndex of cbQosQueueingCfgEntry) and cbQosQueueingClassConfigIndex cbQosQlimitWeightValue i.e(prec,dscp,discard-class,qos-group,atm-clp, mplsExp) of each Weighted Queueing Action.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7785, '.1.3.6.1.4.1.9.9.166.1.32.1.1.1', 'cbQosQueueingClassConfigIndex', 7784, 'current', NULL, 'This objects depict the config index for Weighted Queue limit configured.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7786, '.1.3.6.1.4.1.9.9.166.1.32.1.1.2', 'cbQosQlimitWeightValue', 7784, 'current', NULL, 'This object depict the weight value configured for weighted Queue-limit. The Weight value is IP precedence or IP DSCP of this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7787, '.1.3.6.1.4.1.9.9.166.1.32.1.1.3', 'cbQosQueueingClassCfgThreshold', 7784, 'current', NULL, 'This object is used to depict the Threshold value for the Weighted Queue Limit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7788, '.1.3.6.1.4.1.9.9.166.1.32.1.1.4', 'cbQosQueueingClassCfgThresholdUnit', 7784, 'current', NULL, 'This object is used to depict the Threshold Unit for the Weighted Queue Limit', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7789, '.1.3.6.1.4.1.9.9.166.1.32.1.1.5', 'cbQosQueueingClassCfgQLimitWeight', 7784, 'current', NULL, 'This objects depict the weight value for Weighted Queue limit configured i.e(precedence,dscp,qos-group,atm-clp,discard-class,mplsExp)  .', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7790, '.1.3.6.1.4.1.9.9.166.1.31.1', 'cbQosMeasureIPSLACfgTable', 7779, 'current', NULL, 'This table specifies configuration information for measure type IPSLA action. The measure action relates the policy class to a specific IPSLAs auto group. Configuration of measure action of type IPSLA results in automatic generation of IPSLAs synthetic test operations when the policy is attached to interface. The operations are created according to the characteristics specified and to the destinations specified in IPSLA auto group. The IPSLAs sythentic test operations measure network statistics such as latency, packet loss and jitter. This table is to be used only for retrieving the measure action configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7791, '.1.3.6.1.4.1.9.9.166.1.31.1.1', 'cbQosMeasureIPSLACfgEntry', 7790, 'current', NULL, 'Each entry describes configuration information about one instance of IPSLAs measure action in the policy map. The table is indexed by the cbQosConfigIndex and cbQosMeasureIPSLACfgGroupIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7820, '.1.3.6.1.4.1.9.9.166.1.5.1.1.2', 'cbQosConfigIndex', 7818, 'current', NULL, 'An arbitrary (system-assigned) config (instance independent) index for each Object. Each objects having the same configuration share the same config index.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7821, '.1.3.6.1.4.1.9.9.166.1.5.1.1.3', 'cbQosObjectsType', 7818, 'current', NULL, 'The type of the QoS object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7792, '.1.3.6.1.4.1.9.9.166.1.31.1.1.1', 'cbQosMeasureIPSLACfgGroupIndex', 7791, 'current', NULL, 'An arbitrary (system-assigned) index for each instance of IPSLAs measure action. The index is unique for each instance for a particular class in particular policy-map. For example consider following configuration: policy-map p1 class c1 measure type ip-sla group g1 measure type ip-sla group g2 class c2 measure type ip-sla group g3  In this case the cbQosMeasureIPSLACfgGroupIndex value for first measure action instance under class c1 will be 1, for second instance it will be 1, and so on. The value for the index will start over again from 1 for class c2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7793, '.1.3.6.1.4.1.9.9.166.1.31.1.1.2', 'cbQosMeasureIPSLACfgGroupName', 7791, 'current', NULL, 'IPSLAs auto group name. Group is an aggregation of operations sharing the same type, for example udp-jitter type, with common characteristics like frequency, interval etc. Groups are formed by policies dictated either by customer, or by service level or any other requirements.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7794, '.1.3.6.1.4.1.9.9.166.1.1.1', 'cbQosServicePolicyTable', 7749, 'current', NULL, 'This table describes the logical interfaces/media types and the policymap that are attached to it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7795, '.1.3.6.1.4.1.9.9.166.1.1.1.1', 'cbQosServicePolicyEntry', 7794, 'current', NULL, 'Each entry in this table describes to which a logical interface a given policymap is attached. Depending on the logical interface/media type, some fields may have meaningful values, and some may not. Please see each individual descriptions.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7796, '.1.3.6.1.4.1.9.9.166.1.1.1.1.1', 'cbQosPolicyIndex', 7795, 'current', NULL, 'An arbitrary (system-assigned) index for all service policies (PolicyMap that has been attached to a given logical interface).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7797, '.1.3.6.1.4.1.9.9.166.1.1.1.1.2', 'cbQosIfType', 7795, 'current', NULL, 'This describes the logical interface/media type to which this service policy is attached.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7798, '.1.3.6.1.4.1.9.9.166.1.1.1.1.3', 'cbQosPolicyDirection', 7795, 'current', NULL, 'This indicates the direction of traffic for which this service policy is applied.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7799, '.1.3.6.1.4.1.9.9.166.1.1.1.1.4', 'cbQosIfIndex', 7795, 'current', NULL, 'ifIndex for the interface to which this service is attached. This field makes sense only if the logical interface has a snmp ifIndex. For e.g. the value of this field is meaningless when the cbQosIfType is controlPlane.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7800, '.1.3.6.1.4.1.9.9.166.1.1.1.1.5', 'cbQosFrDLCI', 7795, 'current', NULL, 'DLCI for the FRVC to which this service is attached. This field only make sense if the service policy is attached to a Frame Relay DLCI.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7801, '.1.3.6.1.4.1.9.9.166.1.1.1.1.6', 'cbQosAtmVPI', 7795, 'current', NULL, 'VPI for the ATMVC to which this service is attached. This field only make sense if the service policy is attached to a ATM VC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7802, '.1.3.6.1.4.1.9.9.166.1.1.1.1.7', 'cbQosAtmVCI', 7795, 'current', NULL, 'VCI for the ATMVC to which this service is attached. This field only make sense if the service policy is attached to a ATM VC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7803, '.1.3.6.1.4.1.9.9.166.1.1.1.1.8', 'cbQosEntityIndex', 7795, 'current', NULL, 'In cases where the policy is attached to an entity e.g. control-plane, this object represents the entity physical index of the entity to which the policy has been attached. A value zero may be returned if the policy is not attached to a physical entity or the entPhysicalTable is not supported on the SNMP agent.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7804, '.1.3.6.1.4.1.9.9.166.1.1.1.1.9', 'cbQosVlanIndex', 7795, 'current', NULL, 'If the service policy is attached to a particular vlan on a trunk or multi-vlan access port, then this object specifies the corresponding VLAN. In all other cases the value of this object is ''0''.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7805, '.1.3.6.1.4.1.9.9.166.1.1.1.1.10', 'cbQosEVC', 7795, 'current', NULL, 'for the EVC to which this service is attached. This field only make sense if the service policy is attached to an EVC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7806, '.1.3.6.1.4.1.9.9.166.1.1.1.1.11', 'cbQosPolicyDiscontinuityTime', 7795, 'current', NULL, 'The value of sysUpTime on the most recent occasion at which any one or more objects of cbQosServicePolicyEntry table for a given instance suffered a discontinuity. If no such discontinuities have occurred since the last re-initialization of the local management subsystem, this object contains a zero value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7807, '.1.3.6.1.4.1.9.9.166.1.1.1.1.12', 'cbQosParentPolicyIndex', 7795, 'current', NULL, 'The value refering to service-policy index of a virtual interface on which PolicyMap applied directly. Value set would imply the entry is for a physical interface which is a member of a virtual interface. Value zero implies the entry is for a interface on which PolicyMap applied directly.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7808, '.1.3.6.1.4.1.9.9.166.1.2.1', 'cbQosInterfacePolicyTable', 7750, 'current', NULL, 'This table describes the service polices that are attached to main and sub interfaces.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7809, '.1.3.6.1.4.1.9.9.166.1.2.1.1', 'cbQosInterfacePolicyEntry', 7808, 'current', NULL, 'Using ifIndex and Direction, each unique index pair translates to a service policy that is attached to a main/sub interface, for particular traffic direction.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7810, '.1.3.6.1.4.1.9.9.166.1.2.1.1.1', 'cbQosIFPolicyIndex', 7809, 'current', NULL, 'An arbitrary (system-assigned) index for all Service Policies.  This is identical to cbQosPolicyIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7811, '.1.3.6.1.4.1.9.9.166.1.3.1', 'cbQosFrameRelayPolicyTable', 7751, 'current', NULL, 'This table describes the service polices that are attached to Frame Relay DLCIs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7812, '.1.3.6.1.4.1.9.9.166.1.3.1.1', 'cbQosFrameRelayPolicyEntry', 7811, 'current', NULL, 'Using ifIndex, FR DLCI, and Direction, each unique index combination translates to a service policy that is attached to a FR DLCI, for particular traffic direction.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7813, '.1.3.6.1.4.1.9.9.166.1.3.1.1.1', 'cbQosFRPolicyIndex', 7812, 'current', NULL, 'An arbitrary (system-assigned) index for all Service Policies.  This is identical to cbQosPolicyIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7814, '.1.3.6.1.4.1.9.9.166.1.4.1', 'cbQosATMPVCPolicyTable', 7752, 'current', NULL, 'This table describes the policies that are attached to a ATM PVC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7815, '.1.3.6.1.4.1.9.9.166.1.4.1.1', 'cbQosATMPVCPolicyEntry', 7814, 'current', NULL, 'Using ifIndex, VPI, VCI, and Direction, each unique index combination translates to a service policy that is attached to a ATM VC, for particular traffic direction.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7816, '.1.3.6.1.4.1.9.9.166.1.4.1.1.1', 'cbQosATMPolicyIndex', 7815, 'current', NULL, 'An arbitrary (system-assigned) index for all Service Policies.  This is identical to cbQosPolicyIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7817, '.1.3.6.1.4.1.9.9.166.1.5.1', 'cbQosObjectsTable', 7753, 'current', NULL, 'This table specifies QoS objects (classmap, policymap, match statements, and actions) hierarchy. This table also provide relationship between each PolicyIndex/ObjectsIndex pair and the ConfigIndex. ConfigIndex is essential for querying any configuration tables.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7818, '.1.3.6.1.4.1.9.9.166.1.5.1.1', 'cbQosObjectsEntry', 7817, 'current', NULL, 'A QoS object entry. Objects covered in this table are PolicyMap, ClassMap, Match Statements, and Actions. Each entry is indexed by system-generated cbQosPolicyIndex, and cbQosObjectsIndex, which represents a runtime instance of a QoS object. In conjunction with the cbQosParentObjectsIndex, a management station can determine the hierarchical relationship of those QoS objects. Given that classmaps and service policies can be nested entites, each entry in this table represents a unique instance of such object. Each runtime object instance has a corresponding config object, which contains the configuration information of such QoS object. The config object is indexed by cbQosConfigIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7822, '.1.3.6.1.4.1.9.9.166.1.5.1.1.4', 'cbQosParentObjectsIndex', 7818, 'current', NULL, 'The parent instance index of a QoS object.  For a ClassMap, the parent index would be the index of the attached PolicyMap.  For a Match Statement, the parent index would be the index of the ClassMap that uses this Match Statement.  For an action, the parent index would be the index of the ClassMap that applies such Action.  For a non-hierarchical PolicyMap, the parent would be the logical interface to which the policy is attached, thus the parent index would be 0.  For a hierarchical PolicyMap, the parent index would be the index of the ClassMap to which the nested policy is attached.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7823, '.1.3.6.1.4.1.9.9.166.1.6.1', 'cbQosPolicyMapCfgTable', 7754, 'current', NULL, 'This table specifies Policymap configuration information', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7824, '.1.3.6.1.4.1.9.9.166.1.6.1.1', 'cbQosPolicyMapCfgEntry', 7823, 'current', NULL, 'Each entry in this table describes configuration information about a policymap. The information includes: Name, and it''s description. This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex of each PolicyMap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7825, '.1.3.6.1.4.1.9.9.166.1.6.1.1.1', 'cbQosPolicyMapName', 7824, 'current', NULL, 'Name of the Policymap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7826, '.1.3.6.1.4.1.9.9.166.1.6.1.1.2', 'cbQosPolicyMapDesc', 7824, 'current', NULL, 'Description of the PolicyMap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7827, '.1.3.6.1.4.1.9.9.166.1.7.1', 'cbQosCMCfgTable', 7755, 'current', NULL, 'This table specifies ClassMap configuration information', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7828, '.1.3.6.1.4.1.9.9.166.1.7.1.1', 'cbQosCMCfgEntry', 7827, 'current', NULL, 'Each entry in this table describes configuration information about a classmap. The information includes: Name, and it''s description and whether it is a Match-All or Match-Any class. This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex of each ClassMap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7829, '.1.3.6.1.4.1.9.9.166.1.7.1.1.1', 'cbQosCMName', 7828, 'current', NULL, 'Name of the Classmap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7830, '.1.3.6.1.4.1.9.9.166.1.7.1.1.2', 'cbQosCMDesc', 7828, 'current', NULL, 'Description of the Classmap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7831, '.1.3.6.1.4.1.9.9.166.1.7.1.1.3', 'cbQosCMInfo', 7828, 'current', NULL, 'Match all vs Match any in a given class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7832, '.1.3.6.1.4.1.9.9.166.1.8.1', 'cbQosMatchStmtCfgTable', 7756, 'current', NULL, 'This table specifies ClassMap configuration information', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7833, '.1.3.6.1.4.1.9.9.166.1.8.1.1', 'cbQosMatchStmtCfgEntry', 7832, 'current', NULL, 'Each entry in this table describes configuration information about a MatchStatement. The information includes: Name, and whether it is a Match or Match-Not statement. This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex of each MatchStatement.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7834, '.1.3.6.1.4.1.9.9.166.1.8.1.1.1', 'cbQosMatchStmtName', 7833, 'current', NULL, 'Name of the Match Statement.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7835, '.1.3.6.1.4.1.9.9.166.1.8.1.1.2', 'cbQosMatchStmtInfo', 7833, 'current', NULL, 'Match vs Match Not in a given class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7836, '.1.3.6.1.4.1.9.9.166.1.9.1', 'cbQosQueueingCfgTable', 7757, 'current', NULL, 'This table specifies Queueing Action configuration information', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7837, '.1.3.6.1.4.1.9.9.166.1.9.1.1', 'cbQosQueueingCfgEntry', 7836, 'current', NULL, 'Each entry in this table describes configuration information about a queueing action. The information includes: Bandwidth, Units, Flow Enabled, Priority Enabled, and Q size.  This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex of each Queueing Action.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7838, '.1.3.6.1.4.1.9.9.166.1.9.1.1.1', 'cbQosQueueingCfgBandwidth', 7837, 'deprecated', NULL, 'The type of bandwidth configuration value represented by this object is indicated by the value of cbQosQueueingCfgBandwidthUnits for this entry.  If the cbQosQueueingCfgBandwidthUnits value is ''kbps(1)'' or ''percentage(2)'', this object represents the configured bandwidth allocated to this traffic class.In the case of a bandwidth policy, this value represents a minimum bandwidth guarantee for the traffic class. In the case of a priority policy, this value represents the maximum rate at which priority service is guaranteed.  If the cbQosQueueingCfgBandwidthUnits value is ''percentageRemaining(3)'', this object represents the the percentage of the unallocated bandwidth to allocate to this class. If the cbQosQueueingCfgBandwidthUnits value is ''ratioRemaining(4)'', this object represents the ratio value, relative to other class'' configured ratio values, used to determine the portion of the unallocated bandwidth to apply to this class.  cbQosQueueingCfgBandwidth object is superseded by cbQosQueueingCfgBandwidth64.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7839, '.1.3.6.1.4.1.9.9.166.1.9.1.1.2', 'cbQosQueueingCfgBandwidthUnits', 7837, 'current', NULL, 'Units of the accompanying cbQosQueueingCfgbandwidth parameter', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7840, '.1.3.6.1.4.1.9.9.166.1.9.1.1.3', 'cbQosQueueingCfgFlowEnabled', 7837, 'current', NULL, 'Boolean to indicate if flow-based fair-queue is enabled for this class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7841, '.1.3.6.1.4.1.9.9.166.1.9.1.1.4', 'cbQosQueueingCfgPriorityEnabled', 7837, 'current', NULL, 'Boolean to indicate if low latency queueing (priority) is enabled for this class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7842, '.1.3.6.1.4.1.9.9.166.1.9.1.1.5', 'cbQosQueueingCfgAggregateQSize', 7837, 'deprecated', NULL, 'Maximum number of packets that can be held in all the individual queues associated with this class before packets are dropped. cbQosQueueingCfgAggregateQSize object is superseded by cbQosQueueingCfgAggregateQLimit.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7843, '.1.3.6.1.4.1.9.9.166.1.9.1.1.6', 'cbQosQueueingCfgIndividualQSize', 7837, 'deprecated', NULL, 'Maximum number of packets that can be held in an individual Flow-based fair-queue associated with this class before it drops packets (once the AggregateQSize has been reached).  This field only makes sense in the context of Flow-based fair-queueing.  cbQosQueueingCfgIndividualQSize object is superseded by cbQosQueueingCfgIndividualQSize64.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7844, '.1.3.6.1.4.1.9.9.166.1.9.1.1.7', 'cbQosQueueingCfgDynamicQNumber', 7837, 'current', NULL, 'Number of dynamic queues supported when flow-based fair-queue is in use.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7845, '.1.3.6.1.4.1.9.9.166.1.9.1.1.8', 'cbQosQueueingCfgPrioBurstSize', 7837, 'current', NULL, 'In the priority queue, this is the number of bytes allowed in a single burst. This parameter only makes sense if Priority is enabled', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7846, '.1.3.6.1.4.1.9.9.166.1.9.1.1.9', 'cbQosQueueingCfgQLimitUnits', 7837, 'current', NULL, 'Represents the unit type of cbQosQueueingCfgAggregateQLimit object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7847, '.1.3.6.1.4.1.9.9.166.1.9.1.1.10', 'cbQosQueueingCfgAggregateQLimit', 7837, 'current', NULL, 'Maximum allowed queue size for all the individual queues associated with this class. When the queue size exceed this value, the packets will be dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7848, '.1.3.6.1.4.1.9.9.166.1.9.1.1.11', 'cbQosQueueingCfgAggrQLimitTime', 7837, 'current', NULL, 'Maximum allowed queue size in milli-seconds for all individual queues associated with this class. It is internally converted to bytes by using the bandwidth that is available for the class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7849, '.1.3.6.1.4.1.9.9.166.1.9.1.1.12', 'cbQosQueueingCfgPriorityLevel', 7837, 'current', NULL, 'The priority level of the queue into which packets matching this class are queued into. A larger priority level indicates higher priority.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7929, '.1.3.6.1.4.1.9.9.166.1.14.1.1.4', 'cbQosSetCfgQosGroupValue', 7925, 'current', NULL, 'The QoS Group number at which the packet is being set by the packet marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7850, '.1.3.6.1.4.1.9.9.166.1.9.1.1.13', 'cbQosQueueingCfgBandwidth64', 7837, 'current', NULL, 'This object indicates the guaranteed bandwidth for a particular traffic class.  The type of bandwidth configuration value represented by this object is indicated by the value of cbQosQueueingCfgBandwidthUnits.  If the cbQosQueueingCfgBandwidthUnits value is ''kbps(1)'' or ''percentage(2)'', this object represents the configured bandwidth allocated to this traffic class.In the case of a bandwidth policy, this value represents a minimum bandwidth guarantee for the traffic class. In the case of a priority policy, this value represents the maximum rate at which priority service is guaranteed.  If the cbQosQueueingCfgBandwidthUnits value is ''percentageRemaining(3)'', this object represents the the percentage of the unallocated bandwidth to allocate to this class. If the cbQosQueueingCfgBandwidthUnits value is ''ratioRemaining(4)'', this object represents the ratio value, relative to other class'' configured ratio values, used to determine the portion of the unallocated bandwidth to apply to this class.  If a device implements cbQosQueueingCfgBandwidth64, it should not implement cbQosQueueingCfgBandwidth.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7851, '.1.3.6.1.4.1.9.9.166.1.9.1.1.14', 'cbQosQueueingCfgIndividualQSize64', 7837, 'current', NULL, 'Maximum number of packets that can be held in an individual Flow-based fair-queue associated with this class before it drops packets (once the AggregateQSize has been reached).  If a device implements cbQosQueueingCfgIndividualQSize64, then it should not implement cbQosQueueingCfgIndividualQSize.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7852, '.1.3.6.1.4.1.9.9.166.1.10.1', 'cbQosREDCfgTable', 7758, 'current', NULL, 'This table specifies WRED Action configuration information', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7853, '.1.3.6.1.4.1.9.9.166.1.10.1.1', 'cbQosREDCfgEntry', 7852, 'current', NULL, 'Each entry in this table describes configuration information about a WRED Action. The table holds global (per traffic class) configuration like: Expon Weight and Mean Q size.  This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex of each WRED Action.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7854, '.1.3.6.1.4.1.9.9.166.1.10.1.1.1', 'cbQosREDCfgExponWeight', 7853, 'current', NULL, 'The decay factor for the queue average calculation. The decay factor is equal to raising 2 to the power of N, where N could be up to 16. The smaller the number, the faster it decays.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7855, '.1.3.6.1.4.1.9.9.166.1.10.1.1.2', 'cbQosREDCfgMeanQsize', 7853, 'deprecated', NULL, 'The average queue size, computed and used by the WRED algorithm. cbQosREDCfgMeanQsize object is superseded by cbQosREDMeanQsize.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7856, '.1.3.6.1.4.1.9.9.166.1.10.1.1.3', 'cbQosREDCfgDscpPrec', 7853, 'current', NULL, 'The Classification mechanism used by RED', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7857, '.1.3.6.1.4.1.9.9.166.1.10.1.1.4', 'cbQosREDCfgECNEnabled', 7853, 'current', NULL, 'Boolean to indicate if explicit congestion notification enabled for this class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7858, '.1.3.6.1.4.1.9.9.166.1.11.1', 'cbQosREDClassCfgTable', 7759, 'current', NULL, 'This table specifies WRED Action configuration information on a per IP precedence basis.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7859, '.1.3.6.1.4.1.9.9.166.1.11.1.1', 'cbQosREDClassCfgEntry', 7858, 'current', NULL, 'Each entry in this table describes configuration information about a WRED Action. The table holds the per IP precedence based WRED configuration parameters.  This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex and cbQosREDValue of each WRED Action.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7860, '.1.3.6.1.4.1.9.9.166.1.11.1.1.1', 'cbQosREDValue', 7859, 'current', NULL, 'The IP precedence or IP DSCP of this entry.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7861, '.1.3.6.1.4.1.9.9.166.1.11.1.1.2', 'cbQosREDCfgMinThreshold', 7859, 'deprecated', NULL, 'Minimum threshold in number of packets. When the average queue length reaches this number, WRED begins to drop packets with the specified IP precedence. cbQosREDCfgMinThreshold object is superseded by cbQosREDClassCfgMinThreshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7862, '.1.3.6.1.4.1.9.9.166.1.11.1.1.3', 'cbQosREDCfgMaxThreshold', 7859, 'deprecated', NULL, 'Maximum threshold in number of packets. When the average queue length exceeds this number, WRED drops all packets with the specified IP precedence. cbQosREDCfgMaxThreshold object is superseded by cbQosREDClassCfgMaxThreshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7863, '.1.3.6.1.4.1.9.9.166.1.11.1.1.4', 'cbQosREDCfgPktDropProb', 7859, 'current', NULL, 'Denominator for the fraction of packets dropped when the average queue depth is MaxDepthThreshold. For example, if the denominator is 10, one out of every 10 packets is dropped when the average queue is at the MaxDepthThreshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7864, '.1.3.6.1.4.1.9.9.166.1.11.1.1.5', 'cbQosREDClassCfgThresholdUnit', 7859, 'deprecated', NULL, 'Represents the unit type to measure the RED thresholds. The objects covered are cbQosREDClassCfgMinThreshold and cbQosREDClassCfgMaxThreshold cbQosREDClassCfgThresholdUnit object is superseded by cbQosREDClassCfgMinThreshold, cbQosREDClassCfgMaxThreshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7865, '.1.3.6.1.4.1.9.9.166.1.11.1.1.6', 'cbQosREDClassCfgMinThreshold', 7859, 'current', NULL, 'The minimum WRED threshold value. When the average queue length reaches this number, WRED begins to drop packets according to REDMechanism specificed in cbQosREDCfgDscpPrec.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7866, '.1.3.6.1.4.1.9.9.166.1.11.1.1.7', 'cbQosREDClassCfgMaxThreshold', 7859, 'current', NULL, 'The maximum WRED threshold value. When the average queue length exceeds this number, WRED drops all packets according to REDMechanism specificed in cbQosREDCfgDscpPrec.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7867, '.1.3.6.1.4.1.9.9.166.1.11.1.1.8', 'cbQosREDClassCfgMinThresholdTime', 7859, 'current', NULL, 'The minimum WRED threshold value specified in milli-seconds. The milli-second value is internally converted to bytes by using the bandwidth that is available for the class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7868, '.1.3.6.1.4.1.9.9.166.1.11.1.1.9', 'cbQosREDClassCfgMaxThresholdTime', 7859, 'current', NULL, 'The maximum WRED threshold value specified in milli-seconds. The milli-second value is internally converted to bytes by using the bandwidth that is available for the class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7869, '.1.3.6.1.4.1.9.9.166.1.11.1.1.10', 'cbQosREDClassCfgMaxThresholdUnit', 7859, 'current', NULL, 'Represents the unit type to measure the RED Maximum thresholds. The objects covered is cbQosREDClassCfgMaxThreshold', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7870, '.1.3.6.1.4.1.9.9.166.1.11.1.1.11', 'cbQosREDClassCfgMinThresholdUnit', 7859, 'current', NULL, 'Represents the unit type to measure the RED Minimum thresholds. The objects covered is cbQosREDClassCfgMinThreshold', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7871, '.1.3.6.1.4.1.9.9.166.1.12.1', 'cbQosPoliceCfgTable', 7760, 'current', NULL, 'This table specifies Police Action configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7872, '.1.3.6.1.4.1.9.9.166.1.12.1.1', 'cbQosPoliceCfgEntry', 7871, 'current', NULL, 'Each entry in this table describes configuration information about a Police Action. The table holds Policy configuration parameters, such as rate, burst size, and actions based on traffic rates.  This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7873, '.1.3.6.1.4.1.9.9.166.1.12.1.1.1', 'cbQosPoliceCfgRate', 7872, 'current', NULL, 'The committed policing rate. This is the sustained rate permitted by policing.  If a committed policing rate greater than 4294967295 is configurable on the system, then the configured rate is available in cbQosPoliceCfgRate64.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7874, '.1.3.6.1.4.1.9.9.166.1.12.1.1.2', 'cbQosPoliceCfgBurstSize', 7872, 'deprecated', NULL, 'The amount of traffic, in bytes, in excess of the committed policing rate that will be permitted by the policing feature.  cbQosPoliceCfgBurstSize object is superseded by cbQosPoliceCfgBurstSize64.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7875, '.1.3.6.1.4.1.9.9.166.1.12.1.1.3', 'cbQosPoliceCfgExtBurstSize', 7872, 'deprecated', NULL, 'The amount of traffic, in bytes, in excess of the burst limit, which may be conditionally permitted by the policing feature. The probability that the traffic is not permitted increases as the received burst size increases.  cbQosPoliceCfgExtBurstSize object is superseded by cbQosPoliceCfgExtBurstSize64.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7876, '.1.3.6.1.4.1.9.9.166.1.12.1.1.4', 'cbQosPoliceCfgConformAction', 7872, 'deprecated', NULL, 'Action to be taken when the traffic is within the configured rate, that is, the traffic rate is conforming.  cbQosPoliceCfgConformAction object is superseded by cbQosPoliceActionCfgConform.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7877, '.1.3.6.1.4.1.9.9.166.1.12.1.1.5', 'cbQosPoliceCfgConformSetValue', 7872, 'deprecated', NULL, 'New packet attribute values for each packets that conforms to the configured Police rate.  cbQosPoliceCfgConformSetValue object is superseded by cbQosPoliceActionCfgConformSetValue.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7878, '.1.3.6.1.4.1.9.9.166.1.12.1.1.6', 'cbQosPoliceCfgExceedAction', 7872, 'deprecated', NULL, 'Action to be taken when the traffic exceeds the configured rate, that is, the traffic is non-conforming.  cbQosPoliceCfgExceedAction object is superseded by cbQosPoliceActionCfgExceed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7879, '.1.3.6.1.4.1.9.9.166.1.12.1.1.7', 'cbQosPoliceCfgExceedSetValue', 7872, 'deprecated', NULL, 'New packet attribute values for each packets that conforms to the configured Police rate.  cbQosPoliceCfgExceedSetValue object is superseded by cbQosPoliceActionCfgExceedSetValue.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7880, '.1.3.6.1.4.1.9.9.166.1.12.1.1.8', 'cbQosPoliceCfgViolateAction', 7872, 'deprecated', NULL, 'Action to be taken when the traffic exceeds the conform and exceed token buckets.  cbQosPoliceCfgViolateAction object is superseded by cbQosPoliceActionCfgViolate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7881, '.1.3.6.1.4.1.9.9.166.1.12.1.1.9', 'cbQosPoliceCfgViolateSetValue', 7872, 'deprecated', NULL, 'New packet attribute values for each packets that conforms to the Police violate action. The packet attibute values depend on the action that is taken for the particular packet. For example, if the action was to set the dscp value, this entry describes the value it is set to.  cbQosPoliceCfgViolateSetValue object is superseded by cbQosPoliceActionCfgViolateSetValue.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7882, '.1.3.6.1.4.1.9.9.166.1.12.1.1.10', 'cbQosPoliceCfgPir', 7872, 'deprecated', NULL, 'The committed policing rate. This is the peak rate permitted by two rate policing.  cbQosPoliceCfgPir object is superseded by cbQosPoliceCfgPir64.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7883, '.1.3.6.1.4.1.9.9.166.1.12.1.1.11', 'cbQosPoliceCfgRate64', 7872, 'current', NULL, 'The committed policing rate. This is the sustained rate permitted by policing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7884, '.1.3.6.1.4.1.9.9.166.1.12.1.1.12', 'cbQosPoliceCfgRateType', 7872, 'current', NULL, 'The rate type that configured for CIR & PIR. 1 means rates are configured in bps. 2 means rates are configured in percentage. 3 means rates are configured in cps. 4 means rates are configured in parts per-thousand. 5 means rates are configured in parts per-million.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7885, '.1.3.6.1.4.1.9.9.166.1.12.1.1.13', 'cbQosPoliceCfgPercentRateValue', 7872, 'current', NULL, 'The committed policing rate in percentage. Its value is valid only when cbQosPoliceCfgRateType equals to 2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7886, '.1.3.6.1.4.1.9.9.166.1.12.1.1.14', 'cbQosPoliceCfgPercentPirValue', 7872, 'current', NULL, 'The peak policing rate in percentage. Its value is valid only when cbQosPoliceCfgRateType equals to 2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7887, '.1.3.6.1.4.1.9.9.166.1.12.1.1.15', 'cbQosPoliceCfgCellRate', 7872, 'current', NULL, 'The committed policing rate in cells/second. Its value is valid only when cbQosPoliceCfgRateType equals to 3.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7888, '.1.3.6.1.4.1.9.9.166.1.12.1.1.16', 'cbQosPoliceCfgCellPir', 7872, 'current', NULL, 'The peak policing rate in cells/second. Its value is valid only when cbQosPoliceCfgRateType equals to 3.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7889, '.1.3.6.1.4.1.9.9.166.1.12.1.1.17', 'cbQosPoliceCfgBurstCell', 7872, 'current', NULL, 'The amount of traffic, in cells, in excess of the committed policing rate that will be permitted by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7890, '.1.3.6.1.4.1.9.9.166.1.12.1.1.18', 'cbQosPoliceCfgExtBurstCell', 7872, 'current', NULL, 'The amount of traffic, in cells, in excess of the burst limit, which may be conditionally permitted by the policing feature. The probability that the traffic is not permitted increases as the received burst size increases.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7891, '.1.3.6.1.4.1.9.9.166.1.12.1.1.19', 'cbQosPoliceCfgBurstTime', 7872, 'current', NULL, 'The amount of traffic time, in ms, in excess of the committed policing rate that will be permitted by the policing feature. The milli-second value is internally converted to bytes by using the bandwidth that is available for the class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7892, '.1.3.6.1.4.1.9.9.166.1.12.1.1.20', 'cbQosPoliceCfgExtBurstTime', 7872, 'current', NULL, 'The amount of traffic time, in ms, in excess of the burst limit, which may be conditionally permitted by the policing feature. The probability that the traffic is not permitted increases as the received burst size increases. The milli-second value is internally converted to bytes by using the bandwidth that is available for the class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7893, '.1.3.6.1.4.1.9.9.166.1.12.1.1.21', 'cbQosPoliceCfgCdvt', 7872, 'current', NULL, 'The ATM Cell Delay Variation Tolerance value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7894, '.1.3.6.1.4.1.9.9.166.1.12.1.1.22', 'cbQosPoliceCfgConformColor', 7872, 'current', NULL, 'The Classmap name used in AF color-aware mode to specify the conform-color for the incoming packets which was marked by the previous node.  At least conform-color must be specified. If only conform-color is specified, all other packets are assumed to be marked exceed.  See RFC 2697, A Single Rate Three Color Marker. See RFC 2698, A Two Rate Three Color Marker.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7895, '.1.3.6.1.4.1.9.9.166.1.12.1.1.23', 'cbQosPoliceCfgExceedColor', 7872, 'current', NULL, 'The Classmap name used in AF color-aware mode to specify the exceed-color for the incoming packets which was marked by the previous node.  If both conform-color and exceed-color are specified, all other packets are assumed to be marked violate. Violate-color configuration is not needed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7896, '.1.3.6.1.4.1.9.9.166.1.12.1.1.24', 'cbQosPoliceCfgConditional', 7872, 'current', NULL, 'This object is use to depict weather police is configured as a conditioniler policer or not', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7897, '.1.3.6.1.4.1.9.9.166.1.12.1.1.25', 'cbQosPoliceCfgBurstSize64', 7872, 'current', NULL, 'This object indicated the amount of traffic, in bytes, in excess of the committed policing rate that will be permitted by the policing feature.  If a device implements cbQosPoliceCfgBurstSize64, then it should not implement cbQosPoliceCfgBurstSize.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7898, '.1.3.6.1.4.1.9.9.166.1.12.1.1.26', 'cbQosPoliceCfgExtBurstSize64', 7872, 'current', NULL, 'This object indicated the amount of traffic, in bytes, in excess of the burst limit, which may be conditionally permitted by the policing feature. The probability that the traffic is not permitted increases as the received burst size increases.  If a device implements cbQosPoliceCfgBurstSize64, then it should not implement cbQosPoliceCfgBurstSize.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7899, '.1.3.6.1.4.1.9.9.166.1.12.1.1.27', 'cbQosPoliceCfgPir64', 7872, 'current', NULL, 'This object indicates the committed policing rate. This is the peak rate permitted by two rate policing.  If a device implements cbQosPoliceCfgPir64, then it should not implement cbQosPoliceCfgPir.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7900, '.1.3.6.1.4.1.9.9.166.1.21.1', 'cbQosPoliceActionCfgTable', 7769, 'current', NULL, 'This table specifies Police Action configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7930, '.1.3.6.1.4.1.9.9.166.1.14.1.1.5', 'cbQosSetCfgL2CosValue', 7925, 'current', NULL, 'The Layer 2 Cos value at which the packet is being set by the packet marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7901, '.1.3.6.1.4.1.9.9.166.1.21.1.1', 'cbQosPoliceActionCfgEntry', 7900, 'current', NULL, 'Each entry in this table describes configuration information about Actions for one Police. The table holds Police action specific configuration parameters. This table is a sub-table for cbQosPoliceCfgTable. There is a 1-to-1 association between one entry here and one entry in cbQosPoliceCfgTable. This table contains configuration information only, no statistics associated with it. This table has two indices. The first is cbQosConfigIndex which is drived directly from cbQosPoliceCfgTable to keep the 1-to-1 mapping nature between two tables. The second is cbQosPoliceActionCfgIndex used to reference the actual actions configured. The maximum number of actions supported is determined by the system, which is 5 currently.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7902, '.1.3.6.1.4.1.9.9.166.1.21.1.1.1', 'cbQosPoliceActionCfgIndex', 7901, 'current', NULL, 'An arbitrary (system-assigned) index for police actions that are defined by a police configuration.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7903, '.1.3.6.1.4.1.9.9.166.1.21.1.1.2', 'cbQosPoliceActionCfgConform', 7901, 'current', NULL, 'Action to be taken when the traffic exceeds the conform and exceed token buckets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7904, '.1.3.6.1.4.1.9.9.166.1.21.1.1.3', 'cbQosPoliceActionCfgConformSetValue', 7901, 'current', NULL, 'New packet attribute values for each packet set by police action defined in cbQosPoliceActionCfgConform. This object will be set to zero if the corresponding police action does not require a set value, such as no action, drop action or transmit action.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7905, '.1.3.6.1.4.1.9.9.166.1.21.1.1.4', 'cbQosPoliceActionCfgExceed', 7901, 'current', NULL, 'Action to be taken when the traffic exceeds the conform and exceed token buckets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7906, '.1.3.6.1.4.1.9.9.166.1.21.1.1.5', 'cbQosPoliceActionCfgExceedSetValue', 7901, 'current', NULL, 'New packet attribute values for each packet set by police action defined in cbQosPoliceActionCfgExceed. This object will be set to zero if the corresponding police action does not require a set value, such as no action, drop action or transmit action.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7907, '.1.3.6.1.4.1.9.9.166.1.21.1.1.6', 'cbQosPoliceActionCfgViolate', 7901, 'current', NULL, 'Action to be taken when the traffic exceeds the conform and exceed token buckets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7908, '.1.3.6.1.4.1.9.9.166.1.21.1.1.7', 'cbQosPoliceActionCfgViolateSetValue', 7901, 'current', NULL, 'New packet attribute values for each packet set by police action defined in cbQosPoliceActionCfgViolate. This object will be set to zero if the corresponding police action does not require a set value, such as no action, drop action or transmit action.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7909, '.1.3.6.1.4.1.9.9.166.1.13.1', 'cbQosTSCfgTable', 7761, 'current', NULL, 'This table specifies traffic-shaping Action configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7910, '.1.3.6.1.4.1.9.9.166.1.13.1.1', 'cbQosTSCfgEntry', 7909, 'current', NULL, 'Each entry in this table describes configuration information about a traffic-shaping Action. The table holds Traffic Shaping configuration parameters, such as rate, burst size, and Shaping types.  This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7911, '.1.3.6.1.4.1.9.9.166.1.13.1.1.1', 'cbQosTSCfgRate', 7910, 'current', NULL, 'The committed traffic-shaping rate. This is the sustained rate permitted by the traffic-shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7912, '.1.3.6.1.4.1.9.9.166.1.13.1.1.2', 'cbQosTSCfgBurstSize', 7910, 'deprecated', NULL, 'The amount of traffic, in bits, in excess of the committed traffic-shaping rate that will be instantaneously permitted by this feature.  cbQosTSCfgBurstSize object is superseded by cbQosTSCfgBurstSize64.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7913, '.1.3.6.1.4.1.9.9.166.1.13.1.1.3', 'cbQosTSCfgExtBurstSize', 7910, 'deprecated', NULL, 'The amount of traffic, in bits, in excess of the burst limit, which may be conditionally permitted by traffic-shaping feature.  cbQosTSCfgExtBurstSize object is superseded by cbQosTSCfgExtBurstSize64.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7914, '.1.3.6.1.4.1.9.9.166.1.13.1.1.4', 'cbQosTSCfgAdaptiveEnabled', 7910, 'current', NULL, 'This object indicates is adaptive traffic-shaping has been enabled.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7915, '.1.3.6.1.4.1.9.9.166.1.13.1.1.5', 'cbQosTSCfgAdaptiveRate', 7910, 'current', NULL, 'This object represents the current adaptive traffic shaping rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7916, '.1.3.6.1.4.1.9.9.166.1.13.1.1.6', 'cbQosTSCfgLimitType', 7910, 'current', NULL, 'This object indicates if traffic-shaping is limiting traffic based on the peak rate or the average rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7917, '.1.3.6.1.4.1.9.9.166.1.13.1.1.7', 'cbQosTSCfgRateType', 7910, 'current', NULL, 'The rate type that configured for traffic-shaping. 1 means rate is configured in bps. 2 means rate is configured in percentage. 4 means rates are configured in parts per-thousand. 5 means rates are configured in parts per-million.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7918, '.1.3.6.1.4.1.9.9.166.1.13.1.1.8', 'cbQosTSCfgPercentRateValue', 7910, 'current', NULL, 'The committed traffic-shaping rate in percentage. Its value is valid only when cbQosTSCfgRateType equals to 2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7919, '.1.3.6.1.4.1.9.9.166.1.13.1.1.9', 'cbQosTSCfgBurstTime', 7910, 'current', NULL, 'The amount of traffic, in ms, in excess of the committed traffic-shaping rate that will be instantaneously permitted by this feature. The milli-second value is internally converted to bits by using the bandwidth that is available for the class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7920, '.1.3.6.1.4.1.9.9.166.1.13.1.1.10', 'cbQosTSCfgExtBurstTime', 7910, 'current', NULL, 'The amount of traffic, in ms, in excess of the burst limit, which may be conditionnally permitted by traffic-shaping feature. The milli-second value is internally converted to bits by using the bandwidth that is available for the class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7921, '.1.3.6.1.4.1.9.9.166.1.13.1.1.11', 'cbQosTSCfgRate64', 7910, 'current', NULL, 'The committed shape rate. This is the sustained rate permitted by shaping. This object represents the 64 bit value of object cbQosTSCfgRate', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7922, '.1.3.6.1.4.1.9.9.166.1.13.1.1.12', 'cbQosTSCfgBurstSize64', 7910, 'current', NULL, 'This object indicates the the amount of traffic, in bits, in excess of the committed traffic-shaping rate that will be instantaneously permitted by this feature.  If a device implements cbQosTSCfgBurstSize64, then it should not implement cbQosTSCfgBurstSize.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7923, '.1.3.6.1.4.1.9.9.166.1.13.1.1.13', 'cbQosTSCfgExtBurstSize64', 7910, 'current', NULL, 'This object indicates the amount of traffic, in bits, in excess of the burst limit, which may be conditionally permitted by traffic-shaping feature.  If a device implements cbQosTSCfgExtBurstSize64, then it should not implement cbQosTSCfgExtBurstSize.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7924, '.1.3.6.1.4.1.9.9.166.1.14.1', 'cbQosSetCfgTable', 7762, 'current', NULL, 'This table specifies Packet Marking Action configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7925, '.1.3.6.1.4.1.9.9.166.1.14.1.1', 'cbQosSetCfgEntry', 7924, 'current', NULL, 'Each entry in this table describes configuration information about a Packet Marking Action. The table holds Packet Marking configuration parameters, such as type of packet marking and values being set to.  This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7926, '.1.3.6.1.4.1.9.9.166.1.14.1.1.1', 'cbQosSetCfgFeature', 7925, 'current', NULL, 'The bit-wise position of each packet marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7927, '.1.3.6.1.4.1.9.9.166.1.14.1.1.2', 'cbQosSetCfgIpDSCPValue', 7925, 'current', NULL, 'The IP DSCP value at which the packet is being set by the packet marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7928, '.1.3.6.1.4.1.9.9.166.1.14.1.1.3', 'cbQosSetCfgIpPrecedenceValue', 7925, 'current', NULL, 'The IP precedence value at which the packet is being set by the packet marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7931, '.1.3.6.1.4.1.9.9.166.1.14.1.1.6', 'cbQosSetCfgMplsExpValue', 7925, 'current', NULL, 'The MPLS experimental value at which the packet is being set by the packet marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7932, '.1.3.6.1.4.1.9.9.166.1.14.1.1.7', 'cbQosSetCfgDiscardClassValue', 7925, 'current', NULL, 'The Discard Class value at which the packet is being set by the packet marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7933, '.1.3.6.1.4.1.9.9.166.1.14.1.1.8', 'cbQosSetCfgMplsExpTopMostValue', 7925, 'current', NULL, 'The MPLS experimental value on the topmost label at which the packet is being set by the packet marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7934, '.1.3.6.1.4.1.9.9.166.1.14.1.1.9', 'cbQosSetCfgSrpPriority', 7925, 'current', NULL, 'The SRP Priority value at which the packet is being set by the packet marking feature. The higher the value the higher the priority. SRP is a Cisco developed protocol. RFC 2892: The Cisco SRP MAC Layer Protocol.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7935, '.1.3.6.1.4.1.9.9.166.1.14.1.1.10', 'cbQosSetCfgFrFecnBecn', 7925, 'current', NULL, 'This is a configurable parameter in percentage of the queue size. When the current queue size out of the queue limit is greater than this parameter, both Frame Relay FECN and BECN bits will be set for Frame Relay congestion notification mechanism.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7936, '.1.3.6.1.4.1.9.9.166.1.14.1.1.11', 'cbQosSetCfgL2CosInnerValue', 7925, 'current', NULL, 'The value to be set in the 802.1p priority field in the inner 802.1q VLAN tag (QinQ). This object is applicable when cbQosSetCfgFeature has the ''l2CosInner'' bit set.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7937, '.1.3.6.1.4.1.9.9.166.1.14.1.1.12', 'cbQosSetCfgFrDe', 7925, 'current', NULL, 'The Discard Eligibility (DE) bit is used to indicate that a frame has lower importance than other frames. The DE bit is part of the Address field in the Frame Relay frame header. DTE devices can set the value of the DE bit of a frame to 1 to indicate that the frame has lower importance than other frames. When the network becomes congested, DCE devices will discard frames with the DE bit set before discarding those that do not. This reduces the likelihood of critical data being dropped by Frame Relay DCE devices during periods of congestion.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7938, '.1.3.6.1.4.1.9.9.166.1.14.1.1.13', 'cbQosSetCfgIpPrecedenceTunnelValue', 7925, 'current', NULL, 'The IP precedence value at which the packet is being set by the packet marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7939, '.1.3.6.1.4.1.9.9.166.1.14.1.1.14', 'cbQosSetCfgIpDSCPTunnelValue', 7925, 'current', NULL, 'The IP DSCP value at which the packet is being set by the packet marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7940, '.1.3.6.1.4.1.9.9.166.1.14.1.1.15', 'cbQosSetCfgDei', 7925, 'current', NULL, 'Indicates whether the DEI bit is set in the topmost 802.1ad header.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7941, '.1.3.6.1.4.1.9.9.166.1.14.1.1.16', 'cbQosSetCfgDeiImposition', 7925, 'current', NULL, 'Indicates whether the DEI bit is set in the imposed 802.1ad header.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7942, '.1.3.6.1.4.1.9.9.166.1.15.1', 'cbQosCMStatsTable', 7763, 'current', NULL, 'This table specifies ClassMap related Statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7943, '.1.3.6.1.4.1.9.9.166.1.15.1.1', 'cbQosCMStatsEntry', 7942, 'current', NULL, 'Each entry in this table describes the statistical information about ClassMap. ClassMap specific information you can find in this table are : pre/post policy pkt/byte counts, bit rates, drop pkt/bytes and no buffer drops.  This table contains statistical information only, no configuration information associated with it. Therefore, it is indexed by the instance specific IDs, such as cbQosPolicyIndex and cbQosObjectsIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7944, '.1.3.6.1.4.1.9.9.166.1.15.1.1.1', 'cbQosCMPrePolicyPktOverflow', 7943, 'current', NULL, 'The upper 32 bits count of inbound packets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7945, '.1.3.6.1.4.1.9.9.166.1.15.1.1.2', 'cbQosCMPrePolicyPkt', 7943, 'current', NULL, 'The lower 32 bits count of inbound packets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7946, '.1.3.6.1.4.1.9.9.166.1.15.1.1.3', 'cbQosCMPrePolicyPkt64', 7943, 'current', NULL, 'The 64 bits count of inbound packets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7947, '.1.3.6.1.4.1.9.9.166.1.15.1.1.4', 'cbQosCMPrePolicyByteOverflow', 7943, 'current', NULL, 'The upper 32 bits count of inbound octets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7948, '.1.3.6.1.4.1.9.9.166.1.15.1.1.5', 'cbQosCMPrePolicyByte', 7943, 'current', NULL, 'The lower 32 bits count of inbound octets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7949, '.1.3.6.1.4.1.9.9.166.1.15.1.1.6', 'cbQosCMPrePolicyByte64', 7943, 'current', NULL, 'The 64 bits count of inbound octets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7950, '.1.3.6.1.4.1.9.9.166.1.15.1.1.7', 'cbQosCMPrePolicyBitRate', 7943, 'current', NULL, 'The bit rate of the traffic prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7951, '.1.3.6.1.4.1.9.9.166.1.15.1.1.8', 'cbQosCMPostPolicyByteOverflow', 7943, 'current', NULL, 'The upper 32 bits count of outbound octets after executing QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7952, '.1.3.6.1.4.1.9.9.166.1.15.1.1.9', 'cbQosCMPostPolicyByte', 7943, 'current', NULL, 'The lower 32 bits count of outbound octets after executing QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7953, '.1.3.6.1.4.1.9.9.166.1.15.1.1.10', 'cbQosCMPostPolicyByte64', 7943, 'current', NULL, 'The 64 bits count of outbound octets after executing QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7954, '.1.3.6.1.4.1.9.9.166.1.15.1.1.11', 'cbQosCMPostPolicyBitRate', 7943, 'current', NULL, 'The bit rate of the traffic after executing QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7955, '.1.3.6.1.4.1.9.9.166.1.15.1.1.12', 'cbQosCMDropPktOverflow', 7943, 'current', NULL, 'The upper 32 bits counter of dropped pkts per class as the result of all features that can produce drops (e.g., police, random detect, etc.).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7956, '.1.3.6.1.4.1.9.9.166.1.15.1.1.13', 'cbQosCMDropPkt', 7943, 'current', NULL, 'The lower 32 bits counter of dropped pkts per class as the result of all features that can produce drops (e.g., police, random detect, etc.).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7957, '.1.3.6.1.4.1.9.9.166.1.15.1.1.14', 'cbQosCMDropPkt64', 7943, 'current', NULL, 'The 64 bits counter of dropped pkts per class as the result of all features that can produce drops (e.g., police, random detect, etc.).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7958, '.1.3.6.1.4.1.9.9.166.1.15.1.1.15', 'cbQosCMDropByteOverflow', 7943, 'current', NULL, 'The upper 32 bits counter of dropped bytes per class as the result of all features that can produce drops (e.g., police, random detect, etc.).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7959, '.1.3.6.1.4.1.9.9.166.1.15.1.1.16', 'cbQosCMDropByte', 7943, 'current', NULL, 'The lower 32 bits counter of dropped bytes per class as the result of all features that can produce drops (e.g., police, random detect, etc.).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7960, '.1.3.6.1.4.1.9.9.166.1.15.1.1.17', 'cbQosCMDropByte64', 7943, 'current', NULL, 'The 64 bits counter of dropped bytes per class as the result of all features that can produce drops (e.g., police, random detect, etc.).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7961, '.1.3.6.1.4.1.9.9.166.1.15.1.1.18', 'cbQosCMDropBitRate', 7943, 'current', NULL, 'The bit rate of the drops per class as the result of all features that can produce drops (e.g., police, random detect, etc.).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7962, '.1.3.6.1.4.1.9.9.166.1.15.1.1.19', 'cbQosCMNoBufDropPktOverflow', 7943, 'current', NULL, 'The upper 32 bits drop packet count which occured due to a lack of SRAM buffers during output processing on an interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7963, '.1.3.6.1.4.1.9.9.166.1.15.1.1.20', 'cbQosCMNoBufDropPkt', 7943, 'current', NULL, 'The lower 32 bits drop packet count which occured due to a lack of SRAM buffers during output processing on an interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7964, '.1.3.6.1.4.1.9.9.166.1.15.1.1.21', 'cbQosCMNoBufDropPkt64', 7943, 'current', NULL, 'The 64 bits drop packet count which occured due to a lack of SRAM buffers during output processing on an interface.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7965, '.1.3.6.1.4.1.9.9.166.1.15.1.1.22', 'cbQosCMFragmentPktOverflow', 7943, 'current', NULL, 'The upper 32 bits counter for aggregate fragment pkts', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7966, '.1.3.6.1.4.1.9.9.166.1.15.1.1.23', 'cbQosCMFragmentPkt', 7943, 'current', NULL, 'The lower 32 bits counter for aggregate fragment pkts', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7967, '.1.3.6.1.4.1.9.9.166.1.15.1.1.24', 'cbQosCMFragmentPkt64', 7943, 'current', NULL, 'The 64 bits counter for aggregate fragment pkts', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7968, '.1.3.6.1.4.1.9.9.166.1.15.1.1.25', 'cbQosCMFragmentByteOverflow', 7943, 'current', NULL, 'The upper 32 bits counter for aggregate fragment bytes', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7969, '.1.3.6.1.4.1.9.9.166.1.15.1.1.26', 'cbQosCMFragmentByte', 7943, 'current', NULL, 'The lower 32 bits counter for aggregate fragment bytes', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7970, '.1.3.6.1.4.1.9.9.166.1.15.1.1.27', 'cbQosCMFragmentByte64', 7943, 'current', NULL, 'The 64 bits counter for aggregate fragment bytes', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7971, '.1.3.6.1.4.1.9.9.166.1.15.1.1.28', 'cbQosCMPrePolicyBitRate64', 7943, 'current', NULL, 'The bit rate of the traffic prior to executing any QoS policies.This object is a 64-bit version of cbQosCMPrePolicyBitRate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7972, '.1.3.6.1.4.1.9.9.166.1.15.1.1.29', 'cbQosCMPostPolicyBitRate64', 7943, 'current', NULL, 'The bit rate of the traffic after executing QoS policies. This object is a 64-bit version of cbQosCMPostPolicyBitRate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7973, '.1.3.6.1.4.1.9.9.166.1.15.1.1.30', 'cbQosCMDropBitRate64', 7943, 'current', NULL, 'The bit rate of the drops per class as the result of all features that can produce drops (e.g., police, random detect, etc.). This object is a 64-bit version of cbQosCMDropBitRate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7974, '.1.3.6.1.4.1.9.9.166.1.16.1', 'cbQosMatchStmtStatsTable', 7764, 'current', NULL, 'This table specifies Match Statement related statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7975, '.1.3.6.1.4.1.9.9.166.1.16.1.1', 'cbQosMatchStmtStatsEntry', 7974, 'current', NULL, 'Each entry in this table describes the statistical information about Match Statement. Match Statement specific information you can find in this table are : Pre policy pkt/byte counters, and bit rates.  This table contains statistical information only, no configuration information associated with it. Therefore, it is indexed by the instance specific IDs, such as cbQosPolicyIndex and cbQosObjectsIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7976, '.1.3.6.1.4.1.9.9.166.1.16.1.1.1', 'cbQosMatchPrePolicyPktOverflow', 7975, 'current', NULL, 'The upper 32 bits count of inbound packets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7977, '.1.3.6.1.4.1.9.9.166.1.16.1.1.2', 'cbQosMatchPrePolicyPkt', 7975, 'current', NULL, 'The lower 32 bits count of inbound packets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7978, '.1.3.6.1.4.1.9.9.166.1.16.1.1.3', 'cbQosMatchPrePolicyPkt64', 7975, 'current', NULL, 'The 64 bits count of inbound packets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7979, '.1.3.6.1.4.1.9.9.166.1.16.1.1.4', 'cbQosMatchPrePolicyByteOverflow', 7975, 'current', NULL, 'The upper 32 bits count of inbound octets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7980, '.1.3.6.1.4.1.9.9.166.1.16.1.1.5', 'cbQosMatchPrePolicyByte', 7975, 'current', NULL, 'The lower 32 bits count of inbound octets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7981, '.1.3.6.1.4.1.9.9.166.1.16.1.1.6', 'cbQosMatchPrePolicyByte64', 7975, 'current', NULL, 'The 64 bits count of inbound octets prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7982, '.1.3.6.1.4.1.9.9.166.1.16.1.1.7', 'cbQosMatchPrePolicyBitRate', 7975, 'current', NULL, 'The bit rate of the traffic prior to executing any QoS policies.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7983, '.1.3.6.1.4.1.9.9.166.1.17.1', 'cbQosPoliceStatsTable', 7765, 'current', NULL, 'This table specifies Police Action related Statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7984, '.1.3.6.1.4.1.9.9.166.1.17.1.1', 'cbQosPoliceStatsEntry', 7983, 'current', NULL, 'Each entry in this table describes the statistical information about Police Action. Police Action specific information you can find in this table are : Conformed/Exceeded pkt/byte counters, bit rates.  This table contains statistical information only, no configuration information associated with it. Therefore, it is indexed by the instance specific IDs, such as cbQosPolicyIndex and cbQosObjectsIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7985, '.1.3.6.1.4.1.9.9.166.1.17.1.1.1', 'cbQosPoliceConformedPktOverflow', 7984, 'current', NULL, 'The upper 32 bits count of packets treated as conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7986, '.1.3.6.1.4.1.9.9.166.1.17.1.1.2', 'cbQosPoliceConformedPkt', 7984, 'current', NULL, 'The lower 32 bits count of packets treated as conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7987, '.1.3.6.1.4.1.9.9.166.1.17.1.1.3', 'cbQosPoliceConformedPkt64', 7984, 'current', NULL, 'The 64 bits count of packets treated as conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7988, '.1.3.6.1.4.1.9.9.166.1.17.1.1.4', 'cbQosPoliceConformedByteOverflow', 7984, 'current', NULL, 'The upper 32 bits count of octets treated as conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7989, '.1.3.6.1.4.1.9.9.166.1.17.1.1.5', 'cbQosPoliceConformedByte', 7984, 'current', NULL, 'The lower 32 bits count of octets treated as conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7990, '.1.3.6.1.4.1.9.9.166.1.17.1.1.6', 'cbQosPoliceConformedByte64', 7984, 'current', NULL, 'The 64 bits count of octets treated as conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7991, '.1.3.6.1.4.1.9.9.166.1.17.1.1.7', 'cbQosPoliceConformedBitRate', 7984, 'current', NULL, 'The bit rate of conforming traffic.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7992, '.1.3.6.1.4.1.9.9.166.1.17.1.1.8', 'cbQosPoliceExceededPktOverflow', 7984, 'current', NULL, 'The upper 32 bits count of packets treated as non-conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7993, '.1.3.6.1.4.1.9.9.166.1.17.1.1.9', 'cbQosPoliceExceededPkt', 7984, 'current', NULL, 'The 32 bits count of packets treated as non-conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7994, '.1.3.6.1.4.1.9.9.166.1.17.1.1.10', 'cbQosPoliceExceededPkt64', 7984, 'current', NULL, 'The 64 bits count of packets treated as non-conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7995, '.1.3.6.1.4.1.9.9.166.1.17.1.1.11', 'cbQosPoliceExceededByteOverflow', 7984, 'current', NULL, 'The upper 32 bits count of octets treated as non-conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7996, '.1.3.6.1.4.1.9.9.166.1.17.1.1.12', 'cbQosPoliceExceededByte', 7984, 'current', NULL, 'The lower 32 bits count of octets treated as non-conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7997, '.1.3.6.1.4.1.9.9.166.1.17.1.1.13', 'cbQosPoliceExceededByte64', 7984, 'current', NULL, 'The 64 bits count of octets treated as non-conforming by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7998, '.1.3.6.1.4.1.9.9.166.1.17.1.1.14', 'cbQosPoliceExceededBitRate', 7984, 'current', NULL, 'The bit rate of the non-conforming traffic.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (7999, '.1.3.6.1.4.1.9.9.166.1.17.1.1.15', 'cbQosPoliceViolatedPktOverflow', 7984, 'current', NULL, 'The upper 32 bits count of packets treated as violated by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8000, '.1.3.6.1.4.1.9.9.166.1.17.1.1.16', 'cbQosPoliceViolatedPkt', 7984, 'current', NULL, 'The 32 bits count of packets treated as violated by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8001, '.1.3.6.1.4.1.9.9.166.1.17.1.1.17', 'cbQosPoliceViolatedPkt64', 7984, 'current', NULL, 'The 64 bits count of packets treated as violated by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8002, '.1.3.6.1.4.1.9.9.166.1.17.1.1.18', 'cbQosPoliceViolatedByteOverflow', 7984, 'current', NULL, 'The upper 32 bits count of octets treated as violated by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8003, '.1.3.6.1.4.1.9.9.166.1.17.1.1.19', 'cbQosPoliceViolatedByte', 7984, 'current', NULL, 'The lower 32 bits count of octets treated as violated by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8004, '.1.3.6.1.4.1.9.9.166.1.17.1.1.20', 'cbQosPoliceViolatedByte64', 7984, 'current', NULL, 'The 64 bits count of octets treated as violated by the policing feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8005, '.1.3.6.1.4.1.9.9.166.1.17.1.1.21', 'cbQosPoliceViolatedBitRate', 7984, 'current', NULL, 'The bit rate of the violating traffic.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8079, '.1.3.6.1.4.1.9.9.166.1.23.1.1.7', 'cbQosIPHCRtpSavedByteOverflow', 8072, 'current', NULL, 'The upper 32 bits count of UDP/RTP bytes that saved due to IPHC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8006, '.1.3.6.1.4.1.9.9.166.1.17.1.1.22', 'cbQosPoliceConformedBitRate64', 7984, 'current', NULL, 'The bit rate of conforming traffic. This object is a 64-bit version of cbQosPoliceConformedBitRate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8007, '.1.3.6.1.4.1.9.9.166.1.17.1.1.23', 'cbQosPoliceExceededBitRate64', 7984, 'current', NULL, 'The bit rate of non-conforming traffic. This object is a 64-bit version of cbQosPoliceExceededBitRate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8008, '.1.3.6.1.4.1.9.9.166.1.17.1.1.24', 'cbQosPoliceViolatedBitRate64', 7984, 'current', NULL, 'The bit rate of the violating traffic. This object is a 64-bit version of cbQosPoliceViolatedBitRate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8009, '.1.3.6.1.4.1.9.9.166.1.18.1', 'cbQosQueueingStatsTable', 7766, 'current', NULL, 'This table specifies Queueing Action related Statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8010, '.1.3.6.1.4.1.9.9.166.1.18.1.1', 'cbQosQueueingStatsEntry', 8009, 'current', NULL, 'Each entry in this table describes the statistical information about queueing action. Queueing action specific information you can find in this table are : various Q depth, and discard pkt/byte counters.  This table contains statistical information only, no configuration information associated with it. Therefore, it is indexed by the instance specific IDs, such as cbQosPolicyIndex and cbQosObjectsIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8011, '.1.3.6.1.4.1.9.9.166.1.18.1.1.1', 'cbQosQueueingCurrentQDepth', 8010, 'current', NULL, 'The current depth of the queue.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8012, '.1.3.6.1.4.1.9.9.166.1.18.1.1.2', 'cbQosQueueingMaxQDepth', 8010, 'current', NULL, 'The maximum depth of the queue.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8013, '.1.3.6.1.4.1.9.9.166.1.18.1.1.3', 'cbQosQueueingDiscardByteOverflow', 8010, 'current', NULL, 'The upper 32 bit count of octets, associated with this class, that were dropped by queueing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8014, '.1.3.6.1.4.1.9.9.166.1.18.1.1.4', 'cbQosQueueingDiscardByte', 8010, 'current', NULL, 'The lower 32 bits count of octets, associated with this class, that were dropped by queueing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8015, '.1.3.6.1.4.1.9.9.166.1.18.1.1.5', 'cbQosQueueingDiscardByte64', 8010, 'current', NULL, 'The count of octets, associated with this class, that were dropped by queueing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8016, '.1.3.6.1.4.1.9.9.166.1.18.1.1.6', 'cbQosQueueingDiscardPktOverflow', 8010, 'current', NULL, 'The upper 32 bits count of packets, associated with this class, that were dropped by queueing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8017, '.1.3.6.1.4.1.9.9.166.1.18.1.1.7', 'cbQosQueueingDiscardPkt', 8010, 'current', NULL, 'The number of packets, associated with this class, that were dropped by queueing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8018, '.1.3.6.1.4.1.9.9.166.1.18.1.1.8', 'cbQosQueueingDiscardPkt64', 8010, 'current', NULL, 'The number of packets, associated with this class, that were dropped by queueing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8019, '.1.3.6.1.4.1.9.9.166.1.18.1.1.9', 'cbQosQueueingCurrentQDepthPkt', 8010, 'current', NULL, 'The current number of packets sitting in the queue', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8020, '.1.3.6.1.4.1.9.9.166.1.18.1.1.10', 'cbQosQueueingMaxQDepthPkt', 8010, 'current', NULL, 'The maximum depth of the queue in packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8021, '.1.3.6.1.4.1.9.9.166.1.18.1.1.11', 'cbQosQueueingTransmitByte64', 8010, 'current', NULL, 'The count of octets, associated with this class, that were transmitted by queueing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8022, '.1.3.6.1.4.1.9.9.166.1.18.1.1.12', 'cbQosQueueingTransmitPkt64', 8010, 'current', NULL, 'The number of packets, associated with this class, that were transmitted by queueing.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8023, '.1.3.6.1.4.1.9.9.166.1.19.1', 'cbQosTSStatsTable', 7767, 'current', NULL, 'This table specifies traffic-shaping Action related Statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8024, '.1.3.6.1.4.1.9.9.166.1.19.1.1', 'cbQosTSStatsEntry', 8023, 'current', NULL, 'Each entry in this table describes the statistical information about traffic-shaping Action. Traffic-shaping Action specific information you can find in this table are : various delay/drop pkt/byte counters, state of feature, and Q size.  This table contains statistical information only, no configuration information associated with it. Therefore, it is indexed by the instance specific IDs, such as cbQosPolicyIndex and cbQosObjectsIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8025, '.1.3.6.1.4.1.9.9.166.1.19.1.1.1', 'cbQosTSStatsDelayedByteOverflow', 8024, 'current', NULL, 'This object represents the upper 32 bits counter of octets that have been delayed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8026, '.1.3.6.1.4.1.9.9.166.1.19.1.1.2', 'cbQosTSStatsDelayedByte', 8024, 'current', NULL, 'This object represents the lower 32 bits counter of octets that have been delayed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8027, '.1.3.6.1.4.1.9.9.166.1.19.1.1.3', 'cbQosTSStatsDelayedByte64', 8024, 'current', NULL, 'This object represents the 64 bits counter of octets that have been delayed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8028, '.1.3.6.1.4.1.9.9.166.1.19.1.1.4', 'cbQosTSStatsDelayedPktOverflow', 8024, 'current', NULL, 'This object represents the upper 32 bits counter of packets that have been delayed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8029, '.1.3.6.1.4.1.9.9.166.1.19.1.1.5', 'cbQosTSStatsDelayedPkt', 8024, 'current', NULL, 'This object represents the lower 32 bits counter of packets that have been delayed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8030, '.1.3.6.1.4.1.9.9.166.1.19.1.1.6', 'cbQosTSStatsDelayedPkt64', 8024, 'current', NULL, 'This object represents the 64 bits counter of packets that have been delayed.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8031, '.1.3.6.1.4.1.9.9.166.1.19.1.1.7', 'cbQosTSStatsDropByteOverflow', 8024, 'current', NULL, 'This object represents the upper 32 bits counter of octets that have been dropped during shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8032, '.1.3.6.1.4.1.9.9.166.1.19.1.1.8', 'cbQosTSStatsDropByte', 8024, 'current', NULL, 'This object represents the lower 32 bits counter of octets that have been dropped during shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8033, '.1.3.6.1.4.1.9.9.166.1.19.1.1.9', 'cbQosTSStatsDropByte64', 8024, 'current', NULL, 'This object represents the 64 bits counter of octets that have been dropped during shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8034, '.1.3.6.1.4.1.9.9.166.1.19.1.1.10', 'cbQosTSStatsDropPktOverflow', 8024, 'current', NULL, 'This object represents the upper 32 bits counter of packets that have been dropped during shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8035, '.1.3.6.1.4.1.9.9.166.1.19.1.1.11', 'cbQosTSStatsDropPkt', 8024, 'current', NULL, 'This object represents the lower 32 bits counter of packets that have been dropped during shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8036, '.1.3.6.1.4.1.9.9.166.1.19.1.1.12', 'cbQosTSStatsDropPkt64', 8024, 'current', NULL, 'This object represents the 64 bits counter of packets that have been dropped during shaping.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8037, '.1.3.6.1.4.1.9.9.166.1.19.1.1.13', 'cbQosTSStatsActive', 8024, 'current', NULL, 'This object indicates the current traffic-shaping state. When traffic-shaping is enabled and the traffic rate exceeds the shape rate, traffic-shaping is considered to be active. Otherwise, it is considered inactive.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8038, '.1.3.6.1.4.1.9.9.166.1.19.1.1.14', 'cbQosTSStatsCurrentQSize', 8024, 'current', NULL, 'This object indicates the current traffic-shaping queue depth in packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8039, '.1.3.6.1.4.1.9.9.166.1.20.1', 'cbQosREDClassStatsTable', 7768, 'current', NULL, 'This table specifies per Precedence WRED Action related Statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8040, '.1.3.6.1.4.1.9.9.166.1.20.1.1', 'cbQosREDClassStatsEntry', 8039, 'current', NULL, 'Each entry in this table describes the statistical information about per Precedence WRED Action. per Precedence WRED Action specific information you can find in this table are : Random pkt/byte counters, and Tail drop pkt/byte counters.  This table contains per Precedence/dscp based statistical information only, no configuration information associated with it. Therefore, it is indexed by the instance specific IDs, and a per Precedence identifier: cbQosPolicyIndex, cbQosObjectsIndex and cbQosREDValue.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8041, '.1.3.6.1.4.1.9.9.166.1.20.1.1.1', 'cbQosREDRandomDropPktOverflow', 8040, 'current', NULL, 'The upper 32 bits count of packets dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8042, '.1.3.6.1.4.1.9.9.166.1.20.1.1.2', 'cbQosREDRandomDropPkt', 8040, 'current', NULL, 'The lower 32 bits count of packets dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8043, '.1.3.6.1.4.1.9.9.166.1.20.1.1.3', 'cbQosREDRandomDropPkt64', 8040, 'current', NULL, 'The 64 bits count of packets dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8044, '.1.3.6.1.4.1.9.9.166.1.20.1.1.4', 'cbQosREDRandomDropByteOverflow', 8040, 'current', NULL, 'The upper 32 bits count of bytes dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8045, '.1.3.6.1.4.1.9.9.166.1.20.1.1.5', 'cbQosREDRandomDropByte', 8040, 'current', NULL, 'The lower 32 bits count of bytes dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8046, '.1.3.6.1.4.1.9.9.166.1.20.1.1.6', 'cbQosREDRandomDropByte64', 8040, 'current', NULL, 'The 64 bits count of bytes dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8047, '.1.3.6.1.4.1.9.9.166.1.20.1.1.7', 'cbQosREDTailDropPktOverflow', 8040, 'current', NULL, 'The upper 32 bits count of packets dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8048, '.1.3.6.1.4.1.9.9.166.1.20.1.1.8', 'cbQosREDTailDropPkt', 8040, 'current', NULL, 'The lower 32 bits count of packets dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8049, '.1.3.6.1.4.1.9.9.166.1.20.1.1.9', 'cbQosREDTailDropPkt64', 8040, 'current', NULL, 'The 64 bits count of packets dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8050, '.1.3.6.1.4.1.9.9.166.1.20.1.1.10', 'cbQosREDTailDropByteOverflow', 8040, 'current', NULL, 'The upper 32 bits count of bytes dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8051, '.1.3.6.1.4.1.9.9.166.1.20.1.1.11', 'cbQosREDTailDropByte', 8040, 'current', NULL, 'The lower 32 bits count of bytes dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8052, '.1.3.6.1.4.1.9.9.166.1.20.1.1.12', 'cbQosREDTailDropByte64', 8040, 'current', NULL, 'The 64 bits count of bytes dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8053, '.1.3.6.1.4.1.9.9.166.1.20.1.1.13', 'cbQosREDTransmitPktOverflow', 8040, 'current', NULL, 'The upper 32 bits count of bytes transmitted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8054, '.1.3.6.1.4.1.9.9.166.1.20.1.1.14', 'cbQosREDTransmitPkt', 8040, 'current', NULL, 'The lower 32 bits count of bytes trasmitted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8055, '.1.3.6.1.4.1.9.9.166.1.20.1.1.15', 'cbQosREDTransmitPkt64', 8040, 'current', NULL, 'The 64 bits count of packets transmitted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8056, '.1.3.6.1.4.1.9.9.166.1.20.1.1.16', 'cbQosREDTransmitByteOverflow', 8040, 'current', NULL, 'The upper 32 bits count of octets transmitted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8057, '.1.3.6.1.4.1.9.9.166.1.20.1.1.17', 'cbQosREDTransmitByte', 8040, 'current', NULL, 'The lower 32 bits count of octets trasmitted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8058, '.1.3.6.1.4.1.9.9.166.1.20.1.1.18', 'cbQosREDTransmitByte64', 8040, 'current', NULL, 'The 64 bits count of octets transmitted.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8059, '.1.3.6.1.4.1.9.9.166.1.20.1.1.19', 'cbQosREDECNMarkPktOverflow', 8040, 'current', NULL, 'The upper 32 bits count of packets ecn marked when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8060, '.1.3.6.1.4.1.9.9.166.1.20.1.1.20', 'cbQosREDECNMarkPkt', 8040, 'current', NULL, 'The lower 32 bits count of packets ecn marked when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8061, '.1.3.6.1.4.1.9.9.166.1.20.1.1.21', 'cbQosREDECNMarkPkt64', 8040, 'current', NULL, 'The 64 bits count of packets ecn marked when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8062, '.1.3.6.1.4.1.9.9.166.1.20.1.1.22', 'cbQosREDECNMarkByteOverflow', 8040, 'current', NULL, 'The upper 32 bits count of bytes ecn marked when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8063, '.1.3.6.1.4.1.9.9.166.1.20.1.1.23', 'cbQosREDECNMarkByte', 8040, 'current', NULL, 'The lower 32 bits count of bytes ecn marked when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8064, '.1.3.6.1.4.1.9.9.166.1.20.1.1.24', 'cbQosREDECNMarkByte64', 8040, 'current', NULL, 'The 64 bits count of bytes ecn marked when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8065, '.1.3.6.1.4.1.9.9.166.1.20.1.1.25', 'cbQosREDMeanQSizeUnits', 8040, 'current', NULL, 'Represents the unit type of cbQosREDMeanQSize object.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8066, '.1.3.6.1.4.1.9.9.166.1.20.1.1.26', 'cbQosREDMeanQSize', 8040, 'current', NULL, 'The average queue size computed and used by the WRED algorithm.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8067, '.1.3.6.1.4.1.9.9.166.1.22.1', 'cbQosIPHCCfgTable', 7770, 'current', NULL, 'This table specifies IP Header Compression configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8068, '.1.3.6.1.4.1.9.9.166.1.22.1.1', 'cbQosIPHCCfgEntry', 8067, 'current', NULL, 'Each entry in this table describes configuration information about IP Header compression. This includes the compression option of UDP/RTP header, TCP header or both.  This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by cbQosConfigIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8069, '.1.3.6.1.4.1.9.9.166.1.22.1.1.1', 'cbQosIPHCCfgOption', 8068, 'current', NULL, 'The configured IP header compression option. The value is defined by IPHCOption.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8070, '.1.3.6.1.4.1.9.9.166.1.22.1.1.2', 'cbQosIPHCCfgEnabled', 8068, 'current', NULL, 'Boolean to indicate if IPHC is enabled for policy class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8071, '.1.3.6.1.4.1.9.9.166.1.23.1', 'cbQosIPHCStatsTable', 7771, 'current', NULL, 'This table specifies IP Header Compression statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8072, '.1.3.6.1.4.1.9.9.166.1.23.1.1', 'cbQosIPHCStatsEntry', 8071, 'current', NULL, 'Each entry in this table describes statistical information about IP Header compression.  This table contains statistical information only, no configuration information associated with it. Therefore, it is indexed by the instance specific IDs, namely cbQosPolicyIndex and cbQosObjectsIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8073, '.1.3.6.1.4.1.9.9.166.1.23.1.1.1', 'cbQosIPHCRtpSentPktOverflow', 8072, 'current', NULL, 'The upper 32 bits count of outbound UDP/RTP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8074, '.1.3.6.1.4.1.9.9.166.1.23.1.1.2', 'cbQosIPHCRtpSentPkt', 8072, 'current', NULL, 'The lower 32 bits count of outbound UDP/RTP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8075, '.1.3.6.1.4.1.9.9.166.1.23.1.1.3', 'cbQosIPHCRtpSentPkt64', 8072, 'current', NULL, 'The 64 bits count of outbound UDP/RTP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8076, '.1.3.6.1.4.1.9.9.166.1.23.1.1.4', 'cbQosIPHCRtpCmprsOutPktOverflow', 8072, 'current', NULL, 'The upper 32 bits count of outbound compressed UDP/RTP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8077, '.1.3.6.1.4.1.9.9.166.1.23.1.1.5', 'cbQosIPHCRtpCmprsOutPkt', 8072, 'current', NULL, 'The lower 32 bits count of outbound compressed UDP/RTP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8078, '.1.3.6.1.4.1.9.9.166.1.23.1.1.6', 'cbQosIPHCRtpCmprsOutPkt64', 8072, 'current', NULL, 'The 64 bits count of outbound compressed UDP/RTP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8080, '.1.3.6.1.4.1.9.9.166.1.23.1.1.8', 'cbQosIPHCRtpSavedByte', 8072, 'current', NULL, 'The lower 32 bits count of UDP/RTP bytes that saved due to IPHC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8081, '.1.3.6.1.4.1.9.9.166.1.23.1.1.9', 'cbQosIPHCRtpSavedByte64', 8072, 'current', NULL, 'The 64 bits count of UDP/RTP bytes that saved due to IPHC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8082, '.1.3.6.1.4.1.9.9.166.1.23.1.1.10', 'cbQosIPHCRtpSentByteOverflow', 8072, 'current', NULL, 'The upper 32 bits count of outbound UDP/RTP bytes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8083, '.1.3.6.1.4.1.9.9.166.1.23.1.1.11', 'cbQosIPHCRtpSentByte', 8072, 'current', NULL, 'The lower 32 bits count of outbound UDP/RTP bytes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8084, '.1.3.6.1.4.1.9.9.166.1.23.1.1.12', 'cbQosIPHCRtpSentByte64', 8072, 'current', NULL, 'The 64 bits count of outbound UDP/RTP bytes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8085, '.1.3.6.1.4.1.9.9.166.1.23.1.1.13', 'cbQosIPHCRtpSentByteRate', 8072, 'current', NULL, 'The 32 bits count of outbound UDP/RTP byte rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8086, '.1.3.6.1.4.1.9.9.166.1.23.1.1.14', 'cbQosIPHCTcpSentPktOverflow', 8072, 'current', NULL, 'The upper 32 bits count of outbound TCP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8087, '.1.3.6.1.4.1.9.9.166.1.23.1.1.15', 'cbQosIPHCTcpSentPkt', 8072, 'current', NULL, 'The lower 32 bits count of outbound TCP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8088, '.1.3.6.1.4.1.9.9.166.1.23.1.1.16', 'cbQosIPHCTcpSentPkt64', 8072, 'current', NULL, 'The 64 bits count of outbound TCP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8089, '.1.3.6.1.4.1.9.9.166.1.23.1.1.17', 'cbQosIPHCTcpCmprsOutPktOverflow', 8072, 'current', NULL, 'The upper 32 bits count of outbound compressed TCP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8090, '.1.3.6.1.4.1.9.9.166.1.23.1.1.18', 'cbQosIPHCTcpCmprsOutPkt', 8072, 'current', NULL, 'The lower 32 bits count of outbound compressed TCP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8091, '.1.3.6.1.4.1.9.9.166.1.23.1.1.19', 'cbQosIPHCTcpCmprsOutPkt64', 8072, 'current', NULL, 'The 64 bits count of outbound compressed TCP packets.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8092, '.1.3.6.1.4.1.9.9.166.1.23.1.1.20', 'cbQosIPHCTcpSavedByteOverflow', 8072, 'current', NULL, 'The upper 32 bits count of TCP bytes that saved due to IPHC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8093, '.1.3.6.1.4.1.9.9.166.1.23.1.1.21', 'cbQosIPHCTcpSavedByte', 8072, 'current', NULL, 'The lower 32 bits count of TCP bytes that saved due to IPHC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8094, '.1.3.6.1.4.1.9.9.166.1.23.1.1.22', 'cbQosIPHCTcpSavedByte64', 8072, 'current', NULL, 'The 64 bits count of TCP bytes that saved due to IPHC.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8095, '.1.3.6.1.4.1.9.9.166.1.23.1.1.23', 'cbQosIPHCTcpSentByteOverflow', 8072, 'current', NULL, 'The upper 32 bits count of outbound TCP bytes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8096, '.1.3.6.1.4.1.9.9.166.1.23.1.1.24', 'cbQosIPHCTcpSentByte', 8072, 'current', NULL, 'The lower 32 bits count of outbound TCP bytes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8097, '.1.3.6.1.4.1.9.9.166.1.23.1.1.25', 'cbQosIPHCTcpSentByte64', 8072, 'current', NULL, 'The 64 bits count of outbound TCP bytes.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8098, '.1.3.6.1.4.1.9.9.166.1.23.1.1.26', 'cbQosIPHCTcpSentByteRate', 8072, 'current', NULL, 'The 32 bits count of outbound TCP byte rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8099, '.1.3.6.1.4.1.9.9.166.1.23.1.1.27', 'cbQosIPHCRtpFullHdrSentPktOverflow', 8072, 'current', NULL, 'The upper 32 bits count of total full header UDP/RTP packets sent out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8100, '.1.3.6.1.4.1.9.9.166.1.23.1.1.28', 'cbQosIPHCRtpFullHdrSentPkt', 8072, 'current', NULL, 'The lower 32 bits count of total full header UDP/RTP packets sent out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8101, '.1.3.6.1.4.1.9.9.166.1.23.1.1.29', 'cbQosIPHCRtpFullHdrSentPkt64', 8072, 'current', NULL, 'The 64 bits count of total fullheader UDP/RTP packets sent out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8102, '.1.3.6.1.4.1.9.9.166.1.23.1.1.30', 'cbQosIPHCTcpFullHdrSentPktOverflow', 8072, 'current', NULL, 'The upper 32 bits count of total fullheader TCP packets sent out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8103, '.1.3.6.1.4.1.9.9.166.1.23.1.1.31', 'cbQosIPHCTcpFullHdrSentPkt', 8072, 'current', NULL, 'The lower 32 bits count of total fullheader TCP packets sent out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8104, '.1.3.6.1.4.1.9.9.166.1.23.1.1.32', 'cbQosIPHCTcpFullHdrSentPkt64', 8072, 'current', NULL, 'The 64 bits count of total fullheader TCP packets sent out.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8105, '.1.3.6.1.4.1.9.9.166.1.24.1', 'cbQosSetStatsTable', 7772, 'current', NULL, 'This table specifies packet marking statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8106, '.1.3.6.1.4.1.9.9.166.1.24.1.1', 'cbQosSetStatsEntry', 8105, 'current', NULL, 'Each entry in this table describes the packets that marked by each marking type.  This table contains statistical information only, no configuration information associated with it. Therefore, it is indexed by the instance specific IDs, namely cbQosPolicyIndex and cbQosObjectsIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8107, '.1.3.6.1.4.1.9.9.166.1.24.1.1.1', 'cbQosSetDscpPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose DSCP field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8108, '.1.3.6.1.4.1.9.9.166.1.24.1.1.2', 'cbQosSetPrecedencePkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose Precedence field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8109, '.1.3.6.1.4.1.9.9.166.1.24.1.1.3', 'cbQosSetQosGroupPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose Qos Group field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8110, '.1.3.6.1.4.1.9.9.166.1.24.1.1.4', 'cbQosSetFrDePkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose Frame Relay DE Bit is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8111, '.1.3.6.1.4.1.9.9.166.1.24.1.1.5', 'cbQosSetAtmClpPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose ATM CLP Bit is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8112, '.1.3.6.1.4.1.9.9.166.1.24.1.1.6', 'cbQosSetL2CosPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose Layer 2 Cos field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8113, '.1.3.6.1.4.1.9.9.166.1.24.1.1.7', 'cbQosSetMplsExpImpositionPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose MPLS Experimental Imposition field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8114, '.1.3.6.1.4.1.9.9.166.1.24.1.1.8', 'cbQosSetDiscardClassPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose Discard Class field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8115, '.1.3.6.1.4.1.9.9.166.1.24.1.1.9', 'cbQosSetMplsExpTopMostPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose MPLS Experimental TopMost field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8116, '.1.3.6.1.4.1.9.9.166.1.24.1.1.10', 'cbQosSetSrpPriorityPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose SRP Priority field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8117, '.1.3.6.1.4.1.9.9.166.1.24.1.1.11', 'cbQosSetFrFecnBecnPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose Frame Relay FECN BECN field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8118, '.1.3.6.1.4.1.9.9.166.1.24.1.1.12', 'cbQosSetDscpTunnelPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose DSCP Tunnel field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8119, '.1.3.6.1.4.1.9.9.166.1.24.1.1.13', 'cbQosSetPrecedenceTunnelPkt64', 8106, 'current', NULL, 'The 64 bits count of packets whose Precedence Tunnel field is marked by Set feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8120, '.1.3.6.1.4.1.9.9.166.1.25.1', 'cbQosPoliceColorStatsTable', 7773, 'current', NULL, 'This table specifies Police Action related Statistical information for two rate color aware marker.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8121, '.1.3.6.1.4.1.9.9.166.1.25.1.1', 'cbQosPoliceColorStatsEntry', 8120, 'current', NULL, 'Each entry in this table describes the statistical information about Police Action for Two Rate Color Aware Marker.  This table contains statistical information only, no configuration information associated with it. Therefore, it is indexed by the instance specific IDs, such as cbQosPolicyIndex and cbQosObjectsIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8122, '.1.3.6.1.4.1.9.9.166.1.25.1.1.1', 'cbQosPoliceCfmColorCfmPkt64', 8121, 'current', NULL, 'The 64 bits count of packets which are marked as Conform-Color by previous node and treated as conforming by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8155, '.1.3.6.1.4.1.9.9.166.1.28.1.1.4', 'cbQosTMSetIpPrecedenceMapName', 8151, 'current', NULL, 'The name of a pre-configured table-map used to convert and set IpPrecedence value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8123, '.1.3.6.1.4.1.9.9.166.1.25.1.1.2', 'cbQosPoliceCfmColorCfmByte64', 8121, 'current', NULL, 'The 64 bits count of bytes which are marked as Conform-Color by previous node and treated as conforming by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8124, '.1.3.6.1.4.1.9.9.166.1.25.1.1.3', 'cbQosPoliceCfmColorExdPkt64', 8121, 'current', NULL, 'The 64 bits count of packets which are marked as Conform-Color by previous node and treated as exceeding by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8125, '.1.3.6.1.4.1.9.9.166.1.25.1.1.4', 'cbQosPoliceCfmColorExdByte64', 8121, 'current', NULL, 'The 64 bits count of bytes which are marked as Conform-Color by previous node and treated as exceeding by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8126, '.1.3.6.1.4.1.9.9.166.1.25.1.1.5', 'cbQosPoliceCfmColorVltPkt64', 8121, 'current', NULL, 'The 64 bits count of packets which are marked as Conform-Color by previous node and treated as violating by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8127, '.1.3.6.1.4.1.9.9.166.1.25.1.1.6', 'cbQosPoliceCfmColorVltByte64', 8121, 'current', NULL, 'The 64 bits count of bytes which are marked as Conform-Color by previous node and treated as violating by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8128, '.1.3.6.1.4.1.9.9.166.1.25.1.1.7', 'cbQosPoliceExdColorExdPkt64', 8121, 'current', NULL, 'The 64 bits count of packets which are marked as Exceed-Color by previous node and treated as exceeding by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8129, '.1.3.6.1.4.1.9.9.166.1.25.1.1.8', 'cbQosPoliceExdColorExdByte64', 8121, 'current', NULL, 'The 64 bits count of bytes which are marked as Exceed-Color by previous node and treated as exceeding by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8130, '.1.3.6.1.4.1.9.9.166.1.25.1.1.9', 'cbQosPoliceExdColorVltPkt64', 8121, 'current', NULL, 'The 64 bits count of packets which are marked as Exceed-Color by previous node and treated as violating by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8131, '.1.3.6.1.4.1.9.9.166.1.25.1.1.10', 'cbQosPoliceExdColorVltByte64', 8121, 'current', NULL, 'The 64 bits count of bytes which are marked as Exceed-Color by previous node and treated as violating by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8132, '.1.3.6.1.4.1.9.9.166.1.25.1.1.11', 'cbQosPoliceVltColorVltPkt64', 8121, 'current', NULL, 'The 64 bits count of packets which are marked as Violate-Color by previous node and treated as violating by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8133, '.1.3.6.1.4.1.9.9.166.1.25.1.1.12', 'cbQosPoliceVltColorVltByte64', 8121, 'current', NULL, 'The 64 bits count of bytes which are marked as Violate-Color by previous node and treated as violating by the policing feature on this node.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8134, '.1.3.6.1.4.1.9.9.166.1.25.1.1.13', 'cbQosPoliceCfmColorCfmBitRate', 8121, 'current', NULL, 'The bit rate of conform color class conform rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8135, '.1.3.6.1.4.1.9.9.166.1.25.1.1.14', 'cbQosPoliceCfmColorExdBitRate', 8121, 'current', NULL, 'The bit rate of conform color class exceed rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8136, '.1.3.6.1.4.1.9.9.166.1.25.1.1.15', 'cbQosPoliceCfmColorVltBitRate', 8121, 'current', NULL, 'The bit rate of conform color class violate rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8137, '.1.3.6.1.4.1.9.9.166.1.25.1.1.16', 'cbQosPoliceExdColorExdBitRate', 8121, 'current', NULL, 'The bit rate of exceed color class exceed rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8138, '.1.3.6.1.4.1.9.9.166.1.25.1.1.17', 'cbQosPoliceExdColorVltBitRate', 8121, 'current', NULL, 'The bit rate of exceed color class violate rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8139, '.1.3.6.1.4.1.9.9.166.1.25.1.1.18', 'cbQosPoliceVltColorVltBitRate', 8121, 'current', NULL, 'The bit rate of violate color class violate rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8140, '.1.3.6.1.4.1.9.9.166.1.26.1', 'cbQosTableMapCfgTable', 7774, 'current', NULL, 'This table specifies Table Map basic configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8141, '.1.3.6.1.4.1.9.9.166.1.26.1.1', 'cbQosTableMapCfgEntry', 8140, 'current', NULL, 'Each entry in this table describes configuration information about a tablemap name, behavior and default value. Each cbQosTableMapCfgName is a unique character string in QOS. This table contains configuration information only, no statistics associated with it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8142, '.1.3.6.1.4.1.9.9.166.1.26.1.1.1', 'cbQosTableMapCfgIndex', 8141, 'current', NULL, 'An arbitrary (system-assigned) index for tablemap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8143, '.1.3.6.1.4.1.9.9.166.1.26.1.1.2', 'cbQosTableMapCfgName', 8141, 'current', NULL, 'Name of the tablemap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8144, '.1.3.6.1.4.1.9.9.166.1.26.1.1.3', 'cbQosTableMapCfgBehavior', 8141, 'current', NULL, 'The behavior of a tablemap. value(1) Always set to-value to be a configurable default value <0-99> which is defined in cbQosTableMapCfgDftValue.  copy(2) Always copy from-value to to-value in case the from-value is not found in the tablemap. This is the default behavior for a tablemap.  ignore(3) Ignore to set to-value when from-value is not found in the tablemap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8145, '.1.3.6.1.4.1.9.9.166.1.26.1.1.4', 'cbQosTableMapCfgDftValue', 8141, 'current', NULL, 'The configurable default value used when cbQosTableMapCfgBehavior is value(1).', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8146, '.1.3.6.1.4.1.9.9.166.1.27.1', 'cbQosTableMapValueCfgTable', 7775, 'current', NULL, 'This table specifies the from-value to to-value conversion pairs for a tablemap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8147, '.1.3.6.1.4.1.9.9.166.1.27.1.1', 'cbQosTableMapValueCfgEntry', 8146, 'current', NULL, 'Each entry in this table specifies a from-value to to-value conversion pair for a given tablemap. This table contains configuration information only, no statistics associated with it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8148, '.1.3.6.1.4.1.9.9.166.1.27.1.1.1', 'cbQosTableMapValueCfgFrom', 8147, 'current', NULL, 'This is the from-value in the tablemap. If cbQosTableMapCfgBehavior equals to either copy(2) or ignore(3), when the content in the from-type(e.g., cbQosTMSetIpDscpFromType) equals to this value, the value in the to-type(e.g., IpDscp) will be set to cbQosTableMapValueCfgTo. Each tablemap can configure multiple from-value/to-value pairs.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8149, '.1.3.6.1.4.1.9.9.166.1.27.1.1.2', 'cbQosTableMapValueCfgTo', 8147, 'current', NULL, 'This is the to-value in the tablemap. Its usage is described in cbQosTableMapValueCfgFrom.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8150, '.1.3.6.1.4.1.9.9.166.1.28.1', 'cbQosTableMapSetCfgTable', 7776, 'current', NULL, 'This table specifies enhanced packet marking configuration using a pre-defined tablemap.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8151, '.1.3.6.1.4.1.9.9.166.1.28.1.1', 'cbQosTableMapSetCfgEntry', 8150, 'current', NULL, 'Each entry in this table describes configuration information for an Enhanced Packet Marking Action. The enhanced packet marking action uses a pre-configured table-map to do the from-value to to-value conversion. The packet marking to-type and from-type relationship can be established by using the table-map. Following is an example: cbQosTMSetIpDscpFromType == qosGroup(3) cbQosTMSetIpDscpMapName == ''MyTableMap'', it means that table-map ''MyTableMap'' will be used to convert the QosGroup value and the converted value will be used to set IpDSCP.  cbQosConfigIndex is drived directly from cbQosSetCfgTable to keep the 1-to-1 mapping between two tables. This table contains configuration information only, no statistics associated with it.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8152, '.1.3.6.1.4.1.9.9.166.1.28.1.1.1', 'cbQosTMSetIpDscpFromType', 8151, 'current', NULL, 'The packet marking type whose value will be converted to a to-value based on a pre-configured table-map. The to-value will then be used to set IpDSCP.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8153, '.1.3.6.1.4.1.9.9.166.1.28.1.1.2', 'cbQosTMSetIpDscpMapName', 8151, 'current', NULL, 'The name of a pre-configured table-map used to convert and set IpDSCP value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8154, '.1.3.6.1.4.1.9.9.166.1.28.1.1.3', 'cbQosTMSetIpPrecedenceFromType', 8151, 'current', NULL, 'The packet marking type whose value will be converted to a to-value based on a pre-configured table-map. The to-value will then be used to set IpPrecedence.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8156, '.1.3.6.1.4.1.9.9.166.1.28.1.1.5', 'cbQosTMSetQosGroupFromType', 8151, 'current', NULL, 'The packet marking type whose value will be converted to a to-value based on a pre-configured table-map. The to-value will then be used to set QosGroup.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8157, '.1.3.6.1.4.1.9.9.166.1.28.1.1.6', 'cbQosTMSetQosGroupMapName', 8151, 'current', NULL, 'The name of a pre-configured table-map used to convert and set QosGroup value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8158, '.1.3.6.1.4.1.9.9.166.1.28.1.1.7', 'cbQosTMSetL2CosFromType', 8151, 'current', NULL, 'The packet marking type whose value will be converted to a to-value based on a pre-configured table-map. The to-value will then be used to set L2Cos.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8159, '.1.3.6.1.4.1.9.9.166.1.28.1.1.8', 'cbQosTMSetL2CosMapName', 8151, 'current', NULL, 'The name of a pre-configured table-map used to convert and set L2Cos value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8160, '.1.3.6.1.4.1.9.9.166.1.28.1.1.9', 'cbQosTMSetMplsExpImpFromType', 8151, 'current', NULL, 'The packet marking type whose value will be converted to a to-value based on a pre-configured table-map. The to-value will then be used to set MplsExpImposition.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8161, '.1.3.6.1.4.1.9.9.166.1.28.1.1.10', 'cbQosTMSetMplsExpImpMapName', 8151, 'current', NULL, 'The name of a pre-configured table-map used to convert and set MplsExpImposition value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8162, '.1.3.6.1.4.1.9.9.166.1.28.1.1.11', 'cbQosTMSetMplsExpTopFromType', 8151, 'current', NULL, 'The packet marking type whose value will be converted to a to-value based on a pre-configured table-map. The to-value will then be used to set MplsExpTopMost.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8163, '.1.3.6.1.4.1.9.9.166.1.28.1.1.12', 'cbQosTMSetMplsExpTopMapName', 8151, 'current', NULL, 'The name of a pre-configured table-map used to convert and set MplsExpTopMost value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8164, '.1.3.6.1.4.1.9.9.166.1.29.1', 'cbQosEBCfgTable', 7777, 'current', NULL, 'This table specifies Estimate Bandwidth related configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8165, '.1.3.6.1.4.1.9.9.166.1.29.1.1', 'cbQosEBCfgEntry', 8164, 'current', NULL, 'Each entry in this table describes configuration information about Estimate Bandwidth. It includes: drop target, delay target and delay threshold.  This table contains configuration information only. It is indexed by the cbQosConfigIndex.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8166, '.1.3.6.1.4.1.9.9.166.1.29.1.1.1', 'cbQosEBCfgMechanism', 8165, 'current', NULL, 'Bandwidth estimate algorithm type.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8167, '.1.3.6.1.4.1.9.9.166.1.29.1.1.2', 'cbQosEBCfgDropTarget', 8165, 'current', NULL, 'One-in-Number target indicating that no more than one packet in (this) number will be dropped.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8168, '.1.3.6.1.4.1.9.9.166.1.29.1.1.3', 'cbQosEBCfgDelayTarget', 8165, 'current', NULL, 'One-in-Number target indicating that no more than one packet in (this) number will exceed the delay threshold specified by cbQosEBCfgDelayThreshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8169, '.1.3.6.1.4.1.9.9.166.1.29.1.1.4', 'cbQosEBCfgDelayThreshold', 8165, 'current', NULL, 'The time in milliseconds for the delay threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8170, '.1.3.6.1.4.1.9.9.166.1.30.1', 'cbQosEBStatsTable', 7778, 'current', NULL, 'This table specifies Estimate Bandwidth related statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8171, '.1.3.6.1.4.1.9.9.166.1.30.1.1', 'cbQosEBStatsEntry', 8170, 'current', NULL, 'Each entry in this table describes Estimate Bandwidth related statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8172, '.1.3.6.1.4.1.9.9.166.1.30.1.1.1', 'cbQosEBStatsCorvilEBValue', 8171, 'current', NULL, 'The current Corvil EB bandwidth value.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8173, '.1.3.6.1.4.1.9.9.166.1.30.1.1.2', 'cbQosEBStatsCorvilEBStatus', 8171, 'current', NULL, 'Boolean to indicate if Corvil EB is ready. true - Bandwidth estimate is available. false - Bandwidth estimate is not available.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8174, '.1.3.6.1.4.1.9.9.166.1.30.1.1.3', 'cbQosEBStatsCorvilCTD', 8171, 'current', NULL, 'The Corvil CTD value defined by CbQosEBCtd.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8175, '.1.3.6.1.4.1.9.9.166.1.33.1', 'cbQosC3plAccountCfgTable', 7781, 'current', NULL, 'This table specifies C3pl Account Action configuration information', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8176, '.1.3.6.1.4.1.9.9.166.1.33.1.1', 'cbQosC3plAccountCfgEntry', 8175, 'current', NULL, 'Each entry in this table describes configuration information about a c3pl account action. The information includes: feature type.  This table contains configuration information only, no statistics associated with it. Therefore, it is indexed by the cbQosConfigIndex of each C3pl Account Action.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8177, '.1.3.6.1.4.1.9.9.166.1.33.1.1.1', 'cbQosC3plAccountFeatureType', 8176, 'current', NULL, 'The feature type is used to indicated different drop statistics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8178, '.1.3.6.1.4.1.9.9.166.1.34.1', 'cbQosC3plAccountStatsTable', 7782, 'current', NULL, 'This table specifies C3pl Account Action related statistics information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8179, '.1.3.6.1.4.1.9.9.166.1.34.1.1', 'cbQosC3plAccountStatsEntry', 8178, 'current', NULL, 'Each entry in this table describes the statistical information about C3pl Account Action. Account action specific information you can find in this table are : queueing drop pkt/byte counters, wred drop pkt/byte counters, police pkt/byte counters.  This table contains statistical information only, no configuration information associated with it. Therefore, it is indexed by the instance specific IDs, such as cbQosPolicyIndex, cbQosObjectsIndex, and cbQosC3plAccountFeatureType.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8180, '.1.3.6.1.4.1.9.9.166.1.34.1.1.1', 'cbQosC3plAccountDropPktOverflow', 8179, 'current', NULL, 'The upper 32 bits count of packets dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8181, '.1.3.6.1.4.1.9.9.166.1.34.1.1.2', 'cbQosC3plAccountDropPkt', 8179, 'current', NULL, 'The lower 32 bits count of packets dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8182, '.1.3.6.1.4.1.9.9.166.1.34.1.1.3', 'cbQosC3plAccountDropPkt64', 8179, 'current', NULL, 'The 64 bits count of packets dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8183, '.1.3.6.1.4.1.9.9.166.1.34.1.1.4', 'cbQosC3plAccountDropByteOverflow', 8179, 'current', NULL, 'The upper 32 bits count of bytes dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8184, '.1.3.6.1.4.1.9.9.166.1.34.1.1.5', 'cbQosC3plAccountDropByte', 8179, 'current', NULL, 'The lower 32 bits count of bytes dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8185, '.1.3.6.1.4.1.9.9.166.1.34.1.1.6', 'cbQosC3plAccountDropByte64', 8179, 'current', NULL, 'The 64 bits count of bytes dropped when the number of packets in the associated queue was greater than the minimum threshold and less than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8186, '.1.3.6.1.4.1.9.9.166.1.34.1.1.7', 'cbQosC3plAccountTailDropPktOverflow', 8179, 'current', NULL, 'The upper 32 bits count of packets dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8187, '.1.3.6.1.4.1.9.9.166.1.34.1.1.8', 'cbQosC3plAccountTailDropPkt', 8179, 'current', NULL, 'The lower 32 bits count of packets dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8188, '.1.3.6.1.4.1.9.9.166.1.34.1.1.9', 'cbQosC3plAccountTailDropPkt64', 8179, 'current', NULL, 'The 64 bits count of packets dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8189, '.1.3.6.1.4.1.9.9.166.1.34.1.1.10', 'cbQosC3plAccountTailDropByteOverflow', 8179, 'current', NULL, 'The upper 32 bits count of bytes dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8190, '.1.3.6.1.4.1.9.9.166.1.34.1.1.11', 'cbQosC3plAccountTailDropByte', 8179, 'current', NULL, 'The lower 32 bits count of bytes dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8191, '.1.3.6.1.4.1.9.9.166.1.34.1.1.12', 'cbQosC3plAccountTailDropByte64', 8179, 'current', NULL, 'The 64 bits count of bytes dropped when the number of packets in the associated queue was greater than the maximum threshold.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8192, '.1.3.6.1.4.1.9.9.166.2.1', 'ciscocbQosMIBCompliances', 7748, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8193, '.1.3.6.1.4.1.9.9.166.2.2', 'ciscocbQosMIBGroups', 7748, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8194, '.1.3.6.1.4.1.9.9.166.2.1.1', 'ciscocbQosMIBCompliance', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8195, '.1.3.6.1.4.1.9.9.166.2.1.2', 'ciscocbQosMIBComplianceRev1', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8196, '.1.3.6.1.4.1.9.9.166.2.1.3', 'ciscocbQosMIBComplianceRev2', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8197, '.1.3.6.1.4.1.9.9.166.2.1.4', 'ciscocbQosMIBComplianceRev3', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8198, '.1.3.6.1.4.1.9.9.166.2.1.5', 'ciscocbQosMIBComplianceRev4', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8199, '.1.3.6.1.4.1.9.9.166.2.1.6', 'ciscocbQosMIBComplianceRev5', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8200, '.1.3.6.1.4.1.9.9.166.2.1.7', 'ciscocbQosMIBComplianceRev6', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8201, '.1.3.6.1.4.1.9.9.166.2.1.8', 'ciscocbQosMIBComplianceRev7', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8202, '.1.3.6.1.4.1.9.9.166.2.1.9', 'ciscocbQosMIBComplianceRev8', 8192, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8203, '.1.3.6.1.4.1.9.9.166.2.1.10', 'ciscocbQosMIBComplianceRev9', 8192, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8204, '.1.3.6.1.4.1.9.9.166.2.1.11', 'ciscocbQosMIBComplianceRev10', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8205, '.1.3.6.1.4.1.9.9.166.2.1.12', 'ciscocbQosMIBComplianceRev11', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8206, '.1.3.6.1.4.1.9.9.166.2.1.13', 'ciscocbQosMIBComplianceRev12', 8192, 'deprecated', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8207, '.1.3.6.1.4.1.9.9.166.2.1.14', 'ciscocbQosMIBComplianceRev13', 8192, 'current', NULL, NULL, NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8208, '.1.3.6.1.4.1.9.9.166.2.2.1', 'cbQosServicePolicyGroup', 8193, 'deprecated', NULL, 'Required objects to provide CB QoS objects configuration information. cbQosServicePolicyGroup object is superseded by cbQosServicePolicyGroupRev1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8209, '.1.3.6.1.4.1.9.9.166.2.2.2', 'cbQosInterfacePolicyGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8210, '.1.3.6.1.4.1.9.9.166.2.2.3', 'cbQosFrameRelayVCPolicyGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8211, '.1.3.6.1.4.1.9.9.166.2.2.4', 'cbQosATMPVCPolicyGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8212, '.1.3.6.1.4.1.9.9.166.2.2.5', 'cbQosObjectsGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8213, '.1.3.6.1.4.1.9.9.166.2.2.6', 'cbQosPolicyMapCfgGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8214, '.1.3.6.1.4.1.9.9.166.2.2.7', 'cbQosClassMapCfgGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8215, '.1.3.6.1.4.1.9.9.166.2.2.8', 'cbQosMatchStmtCfgGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8216, '.1.3.6.1.4.1.9.9.166.2.2.9', 'cbQosQueueingCfgGroup', 8193, 'deprecated', NULL, 'Required objects to provide CB QoS objects configuration information. cbQosQueueingCfgGroup object is superseded by cbQosQueueingCfgGroupRev1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8217, '.1.3.6.1.4.1.9.9.166.2.2.10', 'cbQosREDCfgGroup', 8193, 'deprecated', NULL, 'Required objects to provide CB QoS objects configuration information. cbQosREDCfgGroup object is superseded by cbQosREDCfgGroupRev1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8218, '.1.3.6.1.4.1.9.9.166.2.2.11', 'cbQosREDClassCfgGroup', 8193, 'deprecated', NULL, 'Required objects to provide CB QoS objects configuration information. cbQosREDClassCfgGroup object is superseded by cbQosREDClassCfgGroupRev1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8219, '.1.3.6.1.4.1.9.9.166.2.2.12', 'cbQosPoliceCfgGroup', 8193, 'deprecated', NULL, 'Required objects to provide CB QoS objects configuration information. cbQosPoliceCfgGroup object is superseded by cbQosPoliceCfgGroupRev1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8220, '.1.3.6.1.4.1.9.9.166.2.2.13', 'cbQosTSCfgGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8221, '.1.3.6.1.4.1.9.9.166.2.2.14', 'cbQosSetCfgGroup', 8193, 'deprecated', NULL, 'Required objects to provide CB QoS objects configuration information. cbQosSetCfgGroup object is superseded by cbQosSetCfgGroupRev1.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8222, '.1.3.6.1.4.1.9.9.166.2.2.15', 'cbQosClassMapStatsGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8223, '.1.3.6.1.4.1.9.9.166.2.2.16', 'cbQosNoBufferDropGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS summary statistics.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8224, '.1.3.6.1.4.1.9.9.166.2.2.17', 'cbQosQueueingDynamicQNumberGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS Queueing information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8225, '.1.3.6.1.4.1.9.9.166.2.2.18', 'cbQosTrafficShapingDelayCountersGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS traffic-shaping information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8226, '.1.3.6.1.4.1.9.9.166.2.2.19', 'cbQosMatchStmtStatsGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8227, '.1.3.6.1.4.1.9.9.166.2.2.20', 'cbQosPoliceStatsGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8228, '.1.3.6.1.4.1.9.9.166.2.2.21', 'cbQosQueueingStatsGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8229, '.1.3.6.1.4.1.9.9.166.2.2.22', 'cbQosTSStatsGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8230, '.1.3.6.1.4.1.9.9.166.2.2.23', 'cbQosREDClassStatsGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8231, '.1.3.6.1.4.1.9.9.166.2.2.24', 'cbQosREDClassXmitCountersGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8232, '.1.3.6.1.4.1.9.9.166.2.2.25', 'cbQosAFPoliceStatsGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8233, '.1.3.6.1.4.1.9.9.166.2.2.26', 'cbQosAFPoliceCfgGroup', 8193, 'deprecated', NULL, 'Optional objects to provide CB QoS objects configuration information. cbQosAFPoliceCfgGroup object is superseded by cbQosAFPoliceViolateCfgGroup.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8234, '.1.3.6.1.4.1.9.9.166.2.2.27', 'cbQosREDDscpCfgGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8235, '.1.3.6.1.4.1.9.9.166.2.2.28', 'cbQosNewSetCfgGroup', 8193, 'deprecated', NULL, 'Optional objects to provide CB QoS objects configuration information. cbQosNewSetCfgGroup object is superseded by cbQosSetCfgL2Group.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8236, '.1.3.6.1.4.1.9.9.166.2.2.29', 'cbQosQueueingCfgGroupRev1', 8193, 'deprecated', NULL, 'Required objects to provide CB QoS objects configuration information. cbQosQueueingCfgGroupRev1 object is superseded by cbQosQueueingCfgGroupRev2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8237, '.1.3.6.1.4.1.9.9.166.2.2.30', 'cbQosREDCfgGroupRev1', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8281, '.1.3.6.1.4.1.9.9.166.2.2.74', 'cbQosEVCGroup', 8193, 'current', NULL, 'Optional objects to provide EVC information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8238, '.1.3.6.1.4.1.9.9.166.2.2.31', 'cbQosREDClassCfgGroupRev1', 8193, 'deprecated', NULL, 'Required objects to provide CB QoS objects configuration information. cbQosREDClassCfgGroupRev1 object is superseded by .', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8239, '.1.3.6.1.4.1.9.9.166.2.2.32', 'cbQosPoliceCfgGroupRev1', 8193, 'deprecated', NULL, 'Required objects to provide CB QoS objects configuration information. cbQosPoliceCfgGroupRev1 object is superseded by cbQosPoliceCfgGroupRev2.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8240, '.1.3.6.1.4.1.9.9.166.2.2.33', 'cbQosPoliceActionCfgGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8241, '.1.3.6.1.4.1.9.9.166.2.2.34', 'cbQosAFPoliceViolateCfgGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8242, '.1.3.6.1.4.1.9.9.166.2.2.35', 'cbQosREDECNCfgGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8243, '.1.3.6.1.4.1.9.9.166.2.2.36', 'cbQosREDClassECNMarkCountersGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8244, '.1.3.6.1.4.1.9.9.166.2.2.37', 'cbQosPoliceCfgExtGroup', 8193, 'current', NULL, 'Optional objects to provide the information of the committed policing rate that is greater than the maximum value reportable by cbQosPoliceCfgRate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8245, '.1.3.6.1.4.1.9.9.166.2.2.38', 'cbQosSetCfgGroupRev1', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information for SET/Marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8246, '.1.3.6.1.4.1.9.9.166.2.2.39', 'cbQosSetCfgMplsImpositionGroup', 8193, 'current', NULL, 'Optional object to provide CB QoS objects configuration information for SET/Marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8247, '.1.3.6.1.4.1.9.9.166.2.2.40', 'cbQosSetCfgDiscardClassGroup', 8193, 'current', NULL, 'Optional object to provide CB QoS objects configuration information for SET/Marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8248, '.1.3.6.1.4.1.9.9.166.2.2.41', 'cbQosSetCfgMPLSTopMostGroup', 8193, 'current', NULL, 'Optional object to provide CB QoS objects configuration information for SET/Marking feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8249, '.1.3.6.1.4.1.9.9.166.2.2.42', 'cbQosPoliceCfgGroupRev2', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information for POLICE feature.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8250, '.1.3.6.1.4.1.9.9.166.2.2.43', 'cbQosPoliceCfgPirGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS policing PIR rate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8251, '.1.3.6.1.4.1.9.9.166.2.2.44', 'cbQosPoliceCfgPercentGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS policing CIR and PIR rates in percentage.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8252, '.1.3.6.1.4.1.9.9.166.2.2.45', 'cbQosTSCfgPercentGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS committed traffic-shaping rate in percentage.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8253, '.1.3.6.1.4.1.9.9.166.2.2.46', 'cbQosIPHCCfgGroup', 8193, 'current', NULL, 'Optional object to provide CB QoS IP header compression configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8254, '.1.3.6.1.4.1.9.9.166.2.2.47', 'cbQosIPHCStatsGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS IP header compression statistic information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8255, '.1.3.6.1.4.1.9.9.166.2.2.48', 'cbQosServicePolicyGroupRev1', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information. This group deprecates cbQosServicePolicyGroup.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8256, '.1.3.6.1.4.1.9.9.166.2.2.49', 'cbQosQueueingCfgQLimitTimeGroup', 8193, 'current', NULL, 'Optional object to provide Aggregate Queue time based Limit configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8257, '.1.3.6.1.4.1.9.9.166.2.2.50', 'cbQosREDCfgThresholdTimeGroup', 8193, 'current', NULL, 'Optional objects to provide WRED time based threshold Limit configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8258, '.1.3.6.1.4.1.9.9.166.2.2.51', 'cbQosPoliceCfgCellGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS policing cell based rate configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8259, '.1.3.6.1.4.1.9.9.166.2.2.52', 'cbQosPoliceCfgTimeGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS policing time based burst size configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8260, '.1.3.6.1.4.1.9.9.166.2.2.53', 'cbQosPoliceCfgCdvtGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS policing ATM CDVT configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8261, '.1.3.6.1.4.1.9.9.166.2.2.54', 'cbQosPoliceCfgColorGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS policing color aware configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8262, '.1.3.6.1.4.1.9.9.166.2.2.55', 'cbQosTSCfgTimeGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS traffic-shaping time based burst size configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8263, '.1.3.6.1.4.1.9.9.166.2.2.56', 'cbQosSetCfgSrpPriorityGroup', 8193, 'current', NULL, 'Optional object to provide CB QoS SET SRP Priority configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8264, '.1.3.6.1.4.1.9.9.166.2.2.57', 'cbQosSetCfgFrFecnBecnGroup', 8193, 'current', NULL, 'Optional object to provide CB QoS SET Frame Relay FECN BECN configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8265, '.1.3.6.1.4.1.9.9.166.2.2.58', 'cbQosSetStatsGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS SET statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8266, '.1.3.6.1.4.1.9.9.166.2.2.59', 'cbQosPoliceColorStatsGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS Assured Forwarding Policing Color Aware statistical information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8267, '.1.3.6.1.4.1.9.9.166.2.2.60', 'cbQosTableMapCfgGroup', 8193, 'current', NULL, 'Optional objects to provide CB QoS Enhanced Packet Marking configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8268, '.1.3.6.1.4.1.9.9.166.2.2.61', 'cbQosEBCfgGroup', 8193, 'current', NULL, 'Optional objects to provide Estimate Bandwidth configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8269, '.1.3.6.1.4.1.9.9.166.2.2.62', 'cbQosEBStatsGroup', 8193, 'current', NULL, 'Optional objects to provide Estimate Bandwidth status information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8270, '.1.3.6.1.4.1.9.9.166.2.2.63', 'cbQosServicePolicyExtGroup', 8193, 'current', NULL, 'Optional objects to provide more information about a particular service policy instance.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8271, '.1.3.6.1.4.1.9.9.166.2.2.64', 'cbQosMeasureIPSLACfgGroup', 8193, 'current', NULL, 'Optional objects to configure IPSLA measure action.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8272, '.1.3.6.1.4.1.9.9.166.2.2.65', 'cbQosTSCfgExtGroup', 8193, 'current', NULL, 'Objects to provide the information of the committed shaping rate that is greater than the maximum value reportable by cbQosTSCfgRate.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8273, '.1.3.6.1.4.1.9.9.166.2.2.66', 'cbQosQueueingCfgGroupRev2', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8274, '.1.3.6.1.4.1.9.9.166.2.2.67', 'cbQosSetCfgL2Group', 8193, 'current', NULL, 'Optional objects to provide CB QoS objects configuration information', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8275, '.1.3.6.1.4.1.9.9.166.2.2.68', 'cbQosREDClassCfgGroupRev2', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8276, '.1.3.6.1.4.1.9.9.166.2.2.69', 'cbQosQueueingClassCfgGroup', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8277, '.1.3.6.1.4.1.9.9.166.2.2.70', 'cbQosPoliceCfgGroupRev3', 8193, 'current', NULL, 'Required objects to provide CB QoS objects configuration information for POLICE feature', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8278, '.1.3.6.1.4.1.9.9.166.2.2.71', 'cbQosC3plAccountCfgGroup', 8193, 'current', NULL, 'Required objects to provide c3pl account action configuration information (provide drop types) .', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8279, '.1.3.6.1.4.1.9.9.166.2.2.72', 'cbQosC3plAccountStatsGroup', 8193, 'current', NULL, 'Optional objects to provide c3pl account action statistics information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8280, '.1.3.6.1.4.1.9.9.166.2.2.73', 'cbQosSetCfgFrDeGroup', 8193, 'current', NULL, 'Optional object to provide CB QoS objects marking configuration information on frame relay header.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8282, '.1.3.6.1.4.1.9.9.166.2.2.75', 'cbQosFragmentGroup', 8193, 'current', NULL, 'Optional objects to provide Service Fragment information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8283, '.1.3.6.1.4.1.9.9.166.2.2.76', 'cbQosSetCfgExt', 8193, 'current', NULL, 'Additional objects for configuring mark action on precedence tunnel,dscp tunnel, dei, dei imposition.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8284, '.1.3.6.1.4.1.9.9.166.2.2.77', 'cbQosPoliceColorStatsExt', 8193, 'current', NULL, 'Additional objects for police color aware stats on conform rate, exceed rate, violate rate', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8285, '.1.3.6.1.4.1.9.9.166.2.2.78', 'cbQosIPHCCfgExt', 8193, 'current', NULL, 'Additional object to indicate IPHC action configured in policy class.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8286, '.1.3.6.1.4.1.9.9.166.2.2.79', 'cbQosIPHCStatsExt', 8193, 'current', NULL, 'Additional objects for IPHC stats.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8287, '.1.3.6.1.4.1.9.9.166.2.2.80', 'cbQos421XRCfgExt', 8193, 'current', NULL, 'The following 4 changes have been made  1. Added 64 bit objects ======================== cbQosQueueingCfgBandwidth64, cbQosQueueingCfgIndividualQSize64, cbQosPoliceCfgBurstSize64, cbQosPoliceCfgExtBurstSize64, cbQosPoliceCfgPir64, cbQosTSCfgBurstSize64, cbQosTSCfgExtBurstSize64  2. Deprecated the objects corresponding to the newly added 64 bit objects ================================================================  cbQosQueueingCfgBandwidth, cbQosQueueingCfgIndividualQSize, cbQosPoliceCfgBurstSize, cbQosPoliceCfgExtBurstSize, cbQosPoliceCfgPir, cbQosTSCfgBurstSize, cbQosTSCfgExtBurstSize  2. Range expanded for ================== cbQosQueueingCfgBandwidth, cbQosQueueingCfgIndividualQSize, cbQosPoliceCfgBurstSize, cbQosPoliceCfgExtBurstSize, cbQosPoliceCfgPir, cbQosTSCfgBurstSize, cbQosTSCfgExtBurstSize,  cbQosREDCfgMinThreshold, cbQosREDCfgMaxThreshold, cbQosPoliceCfgRate, cbQosPoliceCfgBurstCell, cbQosPoliceCfgExtBurstCell, cbQosPoliceCfgBurstTime, cbQosPoliceCfgExtBurstTime, cbQosPoliceCfgCdvt, cbQosTSCfgRate,cbQosTSCfgBurstTime, cbQosTSCfgExtBurstTime  3. New object added ================ cbQosPolicyDiscontinuityTime  4. Added new type (srp-priority) to ================================== PoliceAction', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8288, '.1.3.6.1.4.1.9.9.166.2.2.81', 'cbQosBitRateExt', 8193, 'current', NULL, 'Added the following 64-bit Bit Rate Objects  cbQosCMPrePolicyBitRate64 cbQosCMPostPolicyBitRate64 cbQosCMDropBitRate64 cbQosPoliceConformedBitRate64 cbQosPoliceExceededBitRate64 cbQosPoliceViolatedBitRate64', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8289, '.1.3.6.1.4.1.9.9.166.2.2.82', 'cbQosQueueingStatsGroupRev1', 8193, 'current', NULL, 'Optional objects to provide CB QoS objects configuration information.', NULL);
INSERT INTO mib_element (id_mib_element, oid, name, id_mib_element_parent, status, reference, description, dtype) VALUES (8290, '.1.3.6.1.4.1.9.9.166.2.2.83', 'cbQosServicePolicyExtGroupRev2', 8193, 'current', NULL, 'Added cbQosParentPolicyIndex to cbQosServicePolicyTable.', NULL);


--
-- TOC entry 5769 (class 0 OID 17881)
-- Dependencies: 268
-- Data for Name: mib_module; Type: TABLE DATA; Schema: mib;
--

INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (17, 'SNMPv2-SMI', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (21, 'RFC1155-SMI', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (22, 'RFC-1212', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (25, 'RFC1213-MIB', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (26, 'SNMPv2-TC', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (27, 'SNMPv2-CONF', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (28, 'SNMPv2-MIB', '2002-01-16 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (29, 'CISCO-SMI', '2000-01-10 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (30, 'CISCO-TC', '2006-01-13 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (31, 'IANAifType-MIB', '2004-01-22 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (32, 'IF-MIB', '2000-01-14 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (33, 'SNMP-FRAMEWORK-MIB', '2002-01-14 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (35, 'RMON-MIB', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (37, 'CISCO-VTP-MIB', '2000-01-10 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (38, 'CISCO-CDP-MIB', '2001-01-23 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (39, 'CISCO-ENVMON-MIB', '2003-01-01 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (40, 'CISCO-FTP-CLIENT-MIB', '2006-01-31 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (41, 'INET-ADDRESS-MIB', '2005-01-04 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (42, 'CISCO-SYSLOG-MIB', '2005-01-03 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (44, 'NETWORK-SERVICES-MIB', '2000-01-03 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (50, 'SYSAPPL-MIB', '1997-01-20 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (97, 'IANA-ADDRESS-FAMILY-NUMBERS-MIB', '2002-01-14 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (54, 'CISCO-FLOW-MONITOR-TC-MIB', '2008-01-09 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (82, 'ENTITY-MIB', '1996-01-16 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (55, 'CISCO-REPORT-INTERVAL-TC-MIB', '2008-01-22 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (98, 'LLDP-MIB', '2005-01-06 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (56, 'BRIDGE-MIB', '2005-01-19 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (99, 'BGP4-MIB', '1994-01-05 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (58, 'P-BRIDGE-MIB', '2006-01-09 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (84, 'CISCO-IP-STAT-MIB', '1997-01-18 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (85, 'CISCO-NTP-MIB', '2000-01-16 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (86, 'CISCO-SWITCH-ENGINE-MIB', '1999-01-09 11:30:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (87, 'CISCO-MEMORY-POOL-MIB', '1996-01-12 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (88, 'CISCO-CIRCUIT-INTERFACE-MIB', '2000-01-09 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (89, 'CISCO-ENTITY-ASSET-MIB', '1999-01-02 16:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (90, 'CHARACTER-MIB', '1994-01-26 17:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (76, 'TOKEN-RING-RMON-MIB', '2000-01-05 15:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (77, 'RMON2-MIB', '1996-01-27 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (78, 'Q-BRIDGE-MIB', '2006-01-09 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (79, 'CISCO-FLOW-MONITOR-MIB', '2009-01-08 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (80, 'CISCO-IP-CBR-METRICS-MIB', '2009-01-11 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (81, 'CISCO-RTP-METRICS-MIB', '2009-01-17 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (103, 'OLD-CISCO-INTERFACES-MIB', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (104, 'CISCO-CCM-MIB', '2010-01-07 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (105, 'ISDN-MIB', '1996-01-23 16:42:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (106, 'CISCO-ISDN-MIB', '2001-01-09 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (107, 'CISCO-REMOTE-ACCESS-MONITOR-MIB', '2004-01-03 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (108, 'OLD-CISCO-IP-MIB', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (109, 'RFC1271-MIB', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (110, 'RFC-1215', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (111, 'RFC1315-MIB', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (112, 'CISCO-FRAME-RELAY-MIB', '2000-01-13 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (113, 'SNMPv2-TC-v1', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (114, 'SNMPv2-SMI-v1', '1970-01-01 01:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (115, 'HCNUM-TC', '2000-01-08 00:00:00');
INSERT INTO mib_module (id_mib_module, name, release_date) VALUES (116, 'CISCO-CLASS-BASED-QOS-MIB', '2014-01-24 00:00:00');

INSERT INTO element_module (element_id, module_id) VALUES (13, 17);
INSERT INTO element_module (element_id, module_id) VALUES (14, 17);
INSERT INTO element_module (element_id, module_id) VALUES (15, 17);
INSERT INTO element_module (element_id, module_id) VALUES (16, 17);
INSERT INTO element_module (element_id, module_id) VALUES (17, 17);
INSERT INTO element_module (element_id, module_id) VALUES (18, 17);
INSERT INTO element_module (element_id, module_id) VALUES (19, 17);
INSERT INTO element_module (element_id, module_id) VALUES (20, 17);
INSERT INTO element_module (element_id, module_id) VALUES (21, 17);
INSERT INTO element_module (element_id, module_id) VALUES (22, 17);
INSERT INTO element_module (element_id, module_id) VALUES (23, 17);
INSERT INTO element_module (element_id, module_id) VALUES (24, 17);
INSERT INTO element_module (element_id, module_id) VALUES (25, 17);
INSERT INTO element_module (element_id, module_id) VALUES (26, 17);
INSERT INTO element_module (element_id, module_id) VALUES (27, 17);
INSERT INTO element_module (element_id, module_id) VALUES (28, 17);
INSERT INTO element_module (element_id, module_id) VALUES (29, 17);
INSERT INTO element_module (element_id, module_id) VALUES (30, 17);
INSERT INTO element_module (element_id, module_id) VALUES (15, 21);
INSERT INTO element_module (element_id, module_id) VALUES (16, 21);
INSERT INTO element_module (element_id, module_id) VALUES (17, 21);
INSERT INTO element_module (element_id, module_id) VALUES (18, 21);
INSERT INTO element_module (element_id, module_id) VALUES (19, 21);
INSERT INTO element_module (element_id, module_id) VALUES (20, 21);
INSERT INTO element_module (element_id, module_id) VALUES (23, 21);
INSERT INTO element_module (element_id, module_id) VALUES (24, 21);
INSERT INTO element_module (element_id, module_id) VALUES (25, 21);
INSERT INTO element_module (element_id, module_id) VALUES (21, 25);
INSERT INTO element_module (element_id, module_id) VALUES (31, 25);
INSERT INTO element_module (element_id, module_id) VALUES (32, 25);
INSERT INTO element_module (element_id, module_id) VALUES (33, 25);
INSERT INTO element_module (element_id, module_id) VALUES (34, 25);
INSERT INTO element_module (element_id, module_id) VALUES (35, 25);
INSERT INTO element_module (element_id, module_id) VALUES (36, 25);
INSERT INTO element_module (element_id, module_id) VALUES (37, 25);
INSERT INTO element_module (element_id, module_id) VALUES (38, 25);
INSERT INTO element_module (element_id, module_id) VALUES (22, 25);
INSERT INTO element_module (element_id, module_id) VALUES (39, 25);
INSERT INTO element_module (element_id, module_id) VALUES (40, 25);
INSERT INTO element_module (element_id, module_id) VALUES (41, 25);
INSERT INTO element_module (element_id, module_id) VALUES (42, 25);
INSERT INTO element_module (element_id, module_id) VALUES (43, 25);
INSERT INTO element_module (element_id, module_id) VALUES (44, 25);
INSERT INTO element_module (element_id, module_id) VALUES (45, 25);
INSERT INTO element_module (element_id, module_id) VALUES (46, 25);
INSERT INTO element_module (element_id, module_id) VALUES (47, 25);
INSERT INTO element_module (element_id, module_id) VALUES (48, 25);
INSERT INTO element_module (element_id, module_id) VALUES (49, 25);
INSERT INTO element_module (element_id, module_id) VALUES (50, 25);
INSERT INTO element_module (element_id, module_id) VALUES (51, 25);
INSERT INTO element_module (element_id, module_id) VALUES (52, 25);
INSERT INTO element_module (element_id, module_id) VALUES (53, 25);
INSERT INTO element_module (element_id, module_id) VALUES (54, 25);
INSERT INTO element_module (element_id, module_id) VALUES (55, 25);
INSERT INTO element_module (element_id, module_id) VALUES (56, 25);
INSERT INTO element_module (element_id, module_id) VALUES (57, 25);
INSERT INTO element_module (element_id, module_id) VALUES (58, 25);
INSERT INTO element_module (element_id, module_id) VALUES (59, 25);
INSERT INTO element_module (element_id, module_id) VALUES (60, 25);
INSERT INTO element_module (element_id, module_id) VALUES (61, 25);
INSERT INTO element_module (element_id, module_id) VALUES (62, 25);
INSERT INTO element_module (element_id, module_id) VALUES (63, 25);
INSERT INTO element_module (element_id, module_id) VALUES (64, 25);
INSERT INTO element_module (element_id, module_id) VALUES (65, 25);
INSERT INTO element_module (element_id, module_id) VALUES (66, 25);
INSERT INTO element_module (element_id, module_id) VALUES (67, 25);
INSERT INTO element_module (element_id, module_id) VALUES (68, 25);
INSERT INTO element_module (element_id, module_id) VALUES (69, 25);
INSERT INTO element_module (element_id, module_id) VALUES (70, 25);
INSERT INTO element_module (element_id, module_id) VALUES (71, 25);
INSERT INTO element_module (element_id, module_id) VALUES (72, 25);
INSERT INTO element_module (element_id, module_id) VALUES (73, 25);
INSERT INTO element_module (element_id, module_id) VALUES (74, 25);
INSERT INTO element_module (element_id, module_id) VALUES (75, 25);
INSERT INTO element_module (element_id, module_id) VALUES (76, 25);
INSERT INTO element_module (element_id, module_id) VALUES (77, 25);
INSERT INTO element_module (element_id, module_id) VALUES (78, 25);
INSERT INTO element_module (element_id, module_id) VALUES (79, 25);
INSERT INTO element_module (element_id, module_id) VALUES (80, 25);
INSERT INTO element_module (element_id, module_id) VALUES (81, 25);
INSERT INTO element_module (element_id, module_id) VALUES (82, 25);
INSERT INTO element_module (element_id, module_id) VALUES (83, 25);
INSERT INTO element_module (element_id, module_id) VALUES (84, 25);
INSERT INTO element_module (element_id, module_id) VALUES (85, 25);
INSERT INTO element_module (element_id, module_id) VALUES (86, 25);
INSERT INTO element_module (element_id, module_id) VALUES (87, 25);
INSERT INTO element_module (element_id, module_id) VALUES (88, 25);
INSERT INTO element_module (element_id, module_id) VALUES (89, 25);
INSERT INTO element_module (element_id, module_id) VALUES (90, 25);
INSERT INTO element_module (element_id, module_id) VALUES (91, 25);
INSERT INTO element_module (element_id, module_id) VALUES (92, 25);
INSERT INTO element_module (element_id, module_id) VALUES (93, 25);
INSERT INTO element_module (element_id, module_id) VALUES (94, 25);
INSERT INTO element_module (element_id, module_id) VALUES (95, 25);
INSERT INTO element_module (element_id, module_id) VALUES (96, 25);
INSERT INTO element_module (element_id, module_id) VALUES (97, 25);
INSERT INTO element_module (element_id, module_id) VALUES (98, 25);
INSERT INTO element_module (element_id, module_id) VALUES (99, 25);
INSERT INTO element_module (element_id, module_id) VALUES (100, 25);
INSERT INTO element_module (element_id, module_id) VALUES (101, 25);
INSERT INTO element_module (element_id, module_id) VALUES (102, 25);
INSERT INTO element_module (element_id, module_id) VALUES (103, 25);
INSERT INTO element_module (element_id, module_id) VALUES (104, 25);
INSERT INTO element_module (element_id, module_id) VALUES (105, 25);
INSERT INTO element_module (element_id, module_id) VALUES (106, 25);
INSERT INTO element_module (element_id, module_id) VALUES (107, 25);
INSERT INTO element_module (element_id, module_id) VALUES (108, 25);
INSERT INTO element_module (element_id, module_id) VALUES (109, 25);
INSERT INTO element_module (element_id, module_id) VALUES (110, 25);
INSERT INTO element_module (element_id, module_id) VALUES (111, 25);
INSERT INTO element_module (element_id, module_id) VALUES (112, 25);
INSERT INTO element_module (element_id, module_id) VALUES (113, 25);
INSERT INTO element_module (element_id, module_id) VALUES (114, 25);
INSERT INTO element_module (element_id, module_id) VALUES (115, 25);
INSERT INTO element_module (element_id, module_id) VALUES (116, 25);
INSERT INTO element_module (element_id, module_id) VALUES (117, 25);
INSERT INTO element_module (element_id, module_id) VALUES (118, 25);
INSERT INTO element_module (element_id, module_id) VALUES (119, 25);
INSERT INTO element_module (element_id, module_id) VALUES (120, 25);
INSERT INTO element_module (element_id, module_id) VALUES (121, 25);
INSERT INTO element_module (element_id, module_id) VALUES (122, 25);
INSERT INTO element_module (element_id, module_id) VALUES (123, 25);
INSERT INTO element_module (element_id, module_id) VALUES (124, 25);
INSERT INTO element_module (element_id, module_id) VALUES (125, 25);
INSERT INTO element_module (element_id, module_id) VALUES (126, 25);
INSERT INTO element_module (element_id, module_id) VALUES (127, 25);
INSERT INTO element_module (element_id, module_id) VALUES (128, 25);
INSERT INTO element_module (element_id, module_id) VALUES (129, 25);
INSERT INTO element_module (element_id, module_id) VALUES (130, 25);
INSERT INTO element_module (element_id, module_id) VALUES (131, 25);
INSERT INTO element_module (element_id, module_id) VALUES (132, 25);
INSERT INTO element_module (element_id, module_id) VALUES (133, 25);
INSERT INTO element_module (element_id, module_id) VALUES (134, 25);
INSERT INTO element_module (element_id, module_id) VALUES (135, 25);
INSERT INTO element_module (element_id, module_id) VALUES (136, 25);
INSERT INTO element_module (element_id, module_id) VALUES (137, 25);
INSERT INTO element_module (element_id, module_id) VALUES (138, 25);
INSERT INTO element_module (element_id, module_id) VALUES (139, 25);
INSERT INTO element_module (element_id, module_id) VALUES (140, 25);
INSERT INTO element_module (element_id, module_id) VALUES (141, 25);
INSERT INTO element_module (element_id, module_id) VALUES (142, 25);
INSERT INTO element_module (element_id, module_id) VALUES (143, 25);
INSERT INTO element_module (element_id, module_id) VALUES (144, 25);
INSERT INTO element_module (element_id, module_id) VALUES (145, 25);
INSERT INTO element_module (element_id, module_id) VALUES (146, 25);
INSERT INTO element_module (element_id, module_id) VALUES (147, 25);
INSERT INTO element_module (element_id, module_id) VALUES (148, 25);
INSERT INTO element_module (element_id, module_id) VALUES (149, 25);
INSERT INTO element_module (element_id, module_id) VALUES (150, 25);
INSERT INTO element_module (element_id, module_id) VALUES (151, 25);
INSERT INTO element_module (element_id, module_id) VALUES (152, 25);
INSERT INTO element_module (element_id, module_id) VALUES (153, 25);
INSERT INTO element_module (element_id, module_id) VALUES (154, 25);
INSERT INTO element_module (element_id, module_id) VALUES (155, 25);
INSERT INTO element_module (element_id, module_id) VALUES (156, 25);
INSERT INTO element_module (element_id, module_id) VALUES (157, 25);
INSERT INTO element_module (element_id, module_id) VALUES (158, 25);
INSERT INTO element_module (element_id, module_id) VALUES (159, 25);
INSERT INTO element_module (element_id, module_id) VALUES (160, 25);
INSERT INTO element_module (element_id, module_id) VALUES (161, 25);
INSERT INTO element_module (element_id, module_id) VALUES (162, 25);
INSERT INTO element_module (element_id, module_id) VALUES (163, 25);
INSERT INTO element_module (element_id, module_id) VALUES (164, 25);
INSERT INTO element_module (element_id, module_id) VALUES (165, 25);
INSERT INTO element_module (element_id, module_id) VALUES (166, 25);
INSERT INTO element_module (element_id, module_id) VALUES (167, 25);
INSERT INTO element_module (element_id, module_id) VALUES (168, 25);
INSERT INTO element_module (element_id, module_id) VALUES (169, 25);
INSERT INTO element_module (element_id, module_id) VALUES (170, 25);
INSERT INTO element_module (element_id, module_id) VALUES (171, 25);
INSERT INTO element_module (element_id, module_id) VALUES (172, 25);
INSERT INTO element_module (element_id, module_id) VALUES (173, 25);
INSERT INTO element_module (element_id, module_id) VALUES (174, 25);
INSERT INTO element_module (element_id, module_id) VALUES (175, 25);
INSERT INTO element_module (element_id, module_id) VALUES (176, 25);
INSERT INTO element_module (element_id, module_id) VALUES (177, 25);
INSERT INTO element_module (element_id, module_id) VALUES (178, 25);
INSERT INTO element_module (element_id, module_id) VALUES (179, 25);
INSERT INTO element_module (element_id, module_id) VALUES (180, 25);
INSERT INTO element_module (element_id, module_id) VALUES (181, 25);
INSERT INTO element_module (element_id, module_id) VALUES (182, 25);
INSERT INTO element_module (element_id, module_id) VALUES (183, 25);
INSERT INTO element_module (element_id, module_id) VALUES (184, 25);
INSERT INTO element_module (element_id, module_id) VALUES (185, 25);
INSERT INTO element_module (element_id, module_id) VALUES (186, 25);
INSERT INTO element_module (element_id, module_id) VALUES (187, 25);
INSERT INTO element_module (element_id, module_id) VALUES (188, 25);
INSERT INTO element_module (element_id, module_id) VALUES (189, 25);
INSERT INTO element_module (element_id, module_id) VALUES (190, 25);
INSERT INTO element_module (element_id, module_id) VALUES (191, 25);
INSERT INTO element_module (element_id, module_id) VALUES (192, 25);
INSERT INTO element_module (element_id, module_id) VALUES (193, 25);
INSERT INTO element_module (element_id, module_id) VALUES (194, 25);
INSERT INTO element_module (element_id, module_id) VALUES (195, 25);
INSERT INTO element_module (element_id, module_id) VALUES (196, 25);
INSERT INTO element_module (element_id, module_id) VALUES (197, 25);
INSERT INTO element_module (element_id, module_id) VALUES (198, 25);
INSERT INTO element_module (element_id, module_id) VALUES (199, 25);
INSERT INTO element_module (element_id, module_id) VALUES (200, 25);
INSERT INTO element_module (element_id, module_id) VALUES (201, 25);
INSERT INTO element_module (element_id, module_id) VALUES (202, 25);
INSERT INTO element_module (element_id, module_id) VALUES (203, 25);
INSERT INTO element_module (element_id, module_id) VALUES (204, 25);
INSERT INTO element_module (element_id, module_id) VALUES (205, 25);
INSERT INTO element_module (element_id, module_id) VALUES (206, 25);
INSERT INTO element_module (element_id, module_id) VALUES (207, 25);
INSERT INTO element_module (element_id, module_id) VALUES (208, 25);
INSERT INTO element_module (element_id, module_id) VALUES (209, 25);
INSERT INTO element_module (element_id, module_id) VALUES (210, 25);
INSERT INTO element_module (element_id, module_id) VALUES (211, 25);
INSERT INTO element_module (element_id, module_id) VALUES (212, 25);
INSERT INTO element_module (element_id, module_id) VALUES (213, 25);
INSERT INTO element_module (element_id, module_id) VALUES (214, 25);
INSERT INTO element_module (element_id, module_id) VALUES (215, 25);
INSERT INTO element_module (element_id, module_id) VALUES (216, 25);
INSERT INTO element_module (element_id, module_id) VALUES (217, 25);
INSERT INTO element_module (element_id, module_id) VALUES (218, 25);
INSERT INTO element_module (element_id, module_id) VALUES (219, 25);
INSERT INTO element_module (element_id, module_id) VALUES (220, 25);
INSERT INTO element_module (element_id, module_id) VALUES (221, 25);
INSERT INTO element_module (element_id, module_id) VALUES (222, 25);
INSERT INTO element_module (element_id, module_id) VALUES (223, 25);
INSERT INTO element_module (element_id, module_id) VALUES (224, 25);
INSERT INTO element_module (element_id, module_id) VALUES (225, 25);
INSERT INTO element_module (element_id, module_id) VALUES (226, 25);
INSERT INTO element_module (element_id, module_id) VALUES (227, 25);
INSERT INTO element_module (element_id, module_id) VALUES (228, 25);
INSERT INTO element_module (element_id, module_id) VALUES (229, 25);
INSERT INTO element_module (element_id, module_id) VALUES (230, 28);
INSERT INTO element_module (element_id, module_id) VALUES (231, 28);
INSERT INTO element_module (element_id, module_id) VALUES (31, 28);
INSERT INTO element_module (element_id, module_id) VALUES (40, 28);
INSERT INTO element_module (element_id, module_id) VALUES (41, 28);
INSERT INTO element_module (element_id, module_id) VALUES (42, 28);
INSERT INTO element_module (element_id, module_id) VALUES (43, 28);
INSERT INTO element_module (element_id, module_id) VALUES (44, 28);
INSERT INTO element_module (element_id, module_id) VALUES (45, 28);
INSERT INTO element_module (element_id, module_id) VALUES (46, 28);
INSERT INTO element_module (element_id, module_id) VALUES (232, 28);
INSERT INTO element_module (element_id, module_id) VALUES (233, 28);
INSERT INTO element_module (element_id, module_id) VALUES (234, 28);
INSERT INTO element_module (element_id, module_id) VALUES (235, 28);
INSERT INTO element_module (element_id, module_id) VALUES (236, 28);
INSERT INTO element_module (element_id, module_id) VALUES (237, 28);
INSERT INTO element_module (element_id, module_id) VALUES (238, 28);
INSERT INTO element_module (element_id, module_id) VALUES (39, 28);
INSERT INTO element_module (element_id, module_id) VALUES (202, 28);
INSERT INTO element_module (element_id, module_id) VALUES (204, 28);
INSERT INTO element_module (element_id, module_id) VALUES (205, 28);
INSERT INTO element_module (element_id, module_id) VALUES (206, 28);
INSERT INTO element_module (element_id, module_id) VALUES (207, 28);
INSERT INTO element_module (element_id, module_id) VALUES (229, 28);
INSERT INTO element_module (element_id, module_id) VALUES (239, 28);
INSERT INTO element_module (element_id, module_id) VALUES (240, 28);
INSERT INTO element_module (element_id, module_id) VALUES (241, 28);
INSERT INTO element_module (element_id, module_id) VALUES (242, 28);
INSERT INTO element_module (element_id, module_id) VALUES (243, 28);
INSERT INTO element_module (element_id, module_id) VALUES (244, 28);
INSERT INTO element_module (element_id, module_id) VALUES (245, 28);
INSERT INTO element_module (element_id, module_id) VALUES (246, 28);
INSERT INTO element_module (element_id, module_id) VALUES (247, 28);
INSERT INTO element_module (element_id, module_id) VALUES (248, 28);
INSERT INTO element_module (element_id, module_id) VALUES (249, 28);
INSERT INTO element_module (element_id, module_id) VALUES (250, 28);
INSERT INTO element_module (element_id, module_id) VALUES (251, 28);
INSERT INTO element_module (element_id, module_id) VALUES (252, 28);
INSERT INTO element_module (element_id, module_id) VALUES (253, 28);
INSERT INTO element_module (element_id, module_id) VALUES (254, 28);
INSERT INTO element_module (element_id, module_id) VALUES (255, 28);
INSERT INTO element_module (element_id, module_id) VALUES (256, 28);
INSERT INTO element_module (element_id, module_id) VALUES (257, 28);
INSERT INTO element_module (element_id, module_id) VALUES (258, 28);
INSERT INTO element_module (element_id, module_id) VALUES (259, 28);
INSERT INTO element_module (element_id, module_id) VALUES (260, 28);
INSERT INTO element_module (element_id, module_id) VALUES (261, 28);
INSERT INTO element_module (element_id, module_id) VALUES (203, 28);
INSERT INTO element_module (element_id, module_id) VALUES (208, 28);
INSERT INTO element_module (element_id, module_id) VALUES (209, 28);
INSERT INTO element_module (element_id, module_id) VALUES (210, 28);
INSERT INTO element_module (element_id, module_id) VALUES (211, 28);
INSERT INTO element_module (element_id, module_id) VALUES (212, 28);
INSERT INTO element_module (element_id, module_id) VALUES (213, 28);
INSERT INTO element_module (element_id, module_id) VALUES (214, 28);
INSERT INTO element_module (element_id, module_id) VALUES (215, 28);
INSERT INTO element_module (element_id, module_id) VALUES (216, 28);
INSERT INTO element_module (element_id, module_id) VALUES (217, 28);
INSERT INTO element_module (element_id, module_id) VALUES (218, 28);
INSERT INTO element_module (element_id, module_id) VALUES (219, 28);
INSERT INTO element_module (element_id, module_id) VALUES (220, 28);
INSERT INTO element_module (element_id, module_id) VALUES (221, 28);
INSERT INTO element_module (element_id, module_id) VALUES (222, 28);
INSERT INTO element_module (element_id, module_id) VALUES (223, 28);
INSERT INTO element_module (element_id, module_id) VALUES (224, 28);
INSERT INTO element_module (element_id, module_id) VALUES (225, 28);
INSERT INTO element_module (element_id, module_id) VALUES (226, 28);
INSERT INTO element_module (element_id, module_id) VALUES (227, 28);
INSERT INTO element_module (element_id, module_id) VALUES (228, 28);
INSERT INTO element_module (element_id, module_id) VALUES (262, 28);
INSERT INTO element_module (element_id, module_id) VALUES (263, 29);
INSERT INTO element_module (element_id, module_id) VALUES (264, 29);
INSERT INTO element_module (element_id, module_id) VALUES (265, 29);
INSERT INTO element_module (element_id, module_id) VALUES (266, 29);
INSERT INTO element_module (element_id, module_id) VALUES (267, 29);
INSERT INTO element_module (element_id, module_id) VALUES (268, 29);
INSERT INTO element_module (element_id, module_id) VALUES (269, 29);
INSERT INTO element_module (element_id, module_id) VALUES (270, 29);
INSERT INTO element_module (element_id, module_id) VALUES (271, 29);
INSERT INTO element_module (element_id, module_id) VALUES (272, 29);
INSERT INTO element_module (element_id, module_id) VALUES (273, 29);
INSERT INTO element_module (element_id, module_id) VALUES (274, 29);
INSERT INTO element_module (element_id, module_id) VALUES (275, 29);
INSERT INTO element_module (element_id, module_id) VALUES (276, 29);
INSERT INTO element_module (element_id, module_id) VALUES (277, 29);
INSERT INTO element_module (element_id, module_id) VALUES (278, 29);
INSERT INTO element_module (element_id, module_id) VALUES (279, 29);
INSERT INTO element_module (element_id, module_id) VALUES (280, 29);
INSERT INTO element_module (element_id, module_id) VALUES (281, 29);
INSERT INTO element_module (element_id, module_id) VALUES (282, 29);
INSERT INTO element_module (element_id, module_id) VALUES (283, 29);
INSERT INTO element_module (element_id, module_id) VALUES (284, 29);
INSERT INTO element_module (element_id, module_id) VALUES (285, 29);
INSERT INTO element_module (element_id, module_id) VALUES (286, 29);
INSERT INTO element_module (element_id, module_id) VALUES (287, 29);
INSERT INTO element_module (element_id, module_id) VALUES (288, 29);
INSERT INTO element_module (element_id, module_id) VALUES (289, 29);
INSERT INTO element_module (element_id, module_id) VALUES (290, 29);
INSERT INTO element_module (element_id, module_id) VALUES (291, 29);
INSERT INTO element_module (element_id, module_id) VALUES (292, 29);
INSERT INTO element_module (element_id, module_id) VALUES (293, 29);
INSERT INTO element_module (element_id, module_id) VALUES (294, 29);
INSERT INTO element_module (element_id, module_id) VALUES (295, 29);
INSERT INTO element_module (element_id, module_id) VALUES (296, 29);
INSERT INTO element_module (element_id, module_id) VALUES (297, 29);
INSERT INTO element_module (element_id, module_id) VALUES (298, 30);
INSERT INTO element_module (element_id, module_id) VALUES (299, 31);
INSERT INTO element_module (element_id, module_id) VALUES (300, 32);
INSERT INTO element_module (element_id, module_id) VALUES (301, 32);
INSERT INTO element_module (element_id, module_id) VALUES (32, 32);
INSERT INTO element_module (element_id, module_id) VALUES (47, 32);
INSERT INTO element_module (element_id, module_id) VALUES (302, 32);
INSERT INTO element_module (element_id, module_id) VALUES (48, 32);
INSERT INTO element_module (element_id, module_id) VALUES (49, 32);
INSERT INTO element_module (element_id, module_id) VALUES (50, 32);
INSERT INTO element_module (element_id, module_id) VALUES (51, 32);
INSERT INTO element_module (element_id, module_id) VALUES (52, 32);
INSERT INTO element_module (element_id, module_id) VALUES (53, 32);
INSERT INTO element_module (element_id, module_id) VALUES (54, 32);
INSERT INTO element_module (element_id, module_id) VALUES (55, 32);
INSERT INTO element_module (element_id, module_id) VALUES (56, 32);
INSERT INTO element_module (element_id, module_id) VALUES (57, 32);
INSERT INTO element_module (element_id, module_id) VALUES (58, 32);
INSERT INTO element_module (element_id, module_id) VALUES (59, 32);
INSERT INTO element_module (element_id, module_id) VALUES (60, 32);
INSERT INTO element_module (element_id, module_id) VALUES (61, 32);
INSERT INTO element_module (element_id, module_id) VALUES (62, 32);
INSERT INTO element_module (element_id, module_id) VALUES (63, 32);
INSERT INTO element_module (element_id, module_id) VALUES (64, 32);
INSERT INTO element_module (element_id, module_id) VALUES (65, 32);
INSERT INTO element_module (element_id, module_id) VALUES (66, 32);
INSERT INTO element_module (element_id, module_id) VALUES (67, 32);
INSERT INTO element_module (element_id, module_id) VALUES (68, 32);
INSERT INTO element_module (element_id, module_id) VALUES (69, 32);
INSERT INTO element_module (element_id, module_id) VALUES (70, 32);
INSERT INTO element_module (element_id, module_id) VALUES (71, 32);
INSERT INTO element_module (element_id, module_id) VALUES (303, 32);
INSERT INTO element_module (element_id, module_id) VALUES (304, 32);
INSERT INTO element_module (element_id, module_id) VALUES (305, 32);
INSERT INTO element_module (element_id, module_id) VALUES (306, 32);
INSERT INTO element_module (element_id, module_id) VALUES (307, 32);
INSERT INTO element_module (element_id, module_id) VALUES (308, 32);
INSERT INTO element_module (element_id, module_id) VALUES (309, 32);
INSERT INTO element_module (element_id, module_id) VALUES (310, 32);
INSERT INTO element_module (element_id, module_id) VALUES (311, 32);
INSERT INTO element_module (element_id, module_id) VALUES (312, 32);
INSERT INTO element_module (element_id, module_id) VALUES (313, 32);
INSERT INTO element_module (element_id, module_id) VALUES (314, 32);
INSERT INTO element_module (element_id, module_id) VALUES (315, 32);
INSERT INTO element_module (element_id, module_id) VALUES (316, 32);
INSERT INTO element_module (element_id, module_id) VALUES (317, 32);
INSERT INTO element_module (element_id, module_id) VALUES (318, 32);
INSERT INTO element_module (element_id, module_id) VALUES (319, 32);
INSERT INTO element_module (element_id, module_id) VALUES (320, 32);
INSERT INTO element_module (element_id, module_id) VALUES (321, 32);
INSERT INTO element_module (element_id, module_id) VALUES (322, 32);
INSERT INTO element_module (element_id, module_id) VALUES (323, 32);
INSERT INTO element_module (element_id, module_id) VALUES (324, 32);
INSERT INTO element_module (element_id, module_id) VALUES (325, 32);
INSERT INTO element_module (element_id, module_id) VALUES (326, 32);
INSERT INTO element_module (element_id, module_id) VALUES (327, 32);
INSERT INTO element_module (element_id, module_id) VALUES (328, 32);
INSERT INTO element_module (element_id, module_id) VALUES (329, 32);
INSERT INTO element_module (element_id, module_id) VALUES (330, 32);
INSERT INTO element_module (element_id, module_id) VALUES (331, 32);
INSERT INTO element_module (element_id, module_id) VALUES (332, 32);
INSERT INTO element_module (element_id, module_id) VALUES (333, 32);
INSERT INTO element_module (element_id, module_id) VALUES (334, 32);
INSERT INTO element_module (element_id, module_id) VALUES (335, 32);
INSERT INTO element_module (element_id, module_id) VALUES (336, 32);
INSERT INTO element_module (element_id, module_id) VALUES (337, 32);
INSERT INTO element_module (element_id, module_id) VALUES (338, 32);
INSERT INTO element_module (element_id, module_id) VALUES (339, 32);
INSERT INTO element_module (element_id, module_id) VALUES (340, 32);
INSERT INTO element_module (element_id, module_id) VALUES (341, 32);
INSERT INTO element_module (element_id, module_id) VALUES (342, 32);
INSERT INTO element_module (element_id, module_id) VALUES (343, 32);
INSERT INTO element_module (element_id, module_id) VALUES (344, 32);
INSERT INTO element_module (element_id, module_id) VALUES (345, 32);
INSERT INTO element_module (element_id, module_id) VALUES (346, 32);
INSERT INTO element_module (element_id, module_id) VALUES (347, 32);
INSERT INTO element_module (element_id, module_id) VALUES (348, 32);
INSERT INTO element_module (element_id, module_id) VALUES (349, 32);
INSERT INTO element_module (element_id, module_id) VALUES (350, 32);
INSERT INTO element_module (element_id, module_id) VALUES (351, 32);
INSERT INTO element_module (element_id, module_id) VALUES (352, 32);
INSERT INTO element_module (element_id, module_id) VALUES (353, 32);
INSERT INTO element_module (element_id, module_id) VALUES (354, 32);
INSERT INTO element_module (element_id, module_id) VALUES (355, 32);
INSERT INTO element_module (element_id, module_id) VALUES (356, 32);
INSERT INTO element_module (element_id, module_id) VALUES (357, 32);
INSERT INTO element_module (element_id, module_id) VALUES (358, 32);
INSERT INTO element_module (element_id, module_id) VALUES (359, 32);
INSERT INTO element_module (element_id, module_id) VALUES (360, 32);
INSERT INTO element_module (element_id, module_id) VALUES (361, 32);
INSERT INTO element_module (element_id, module_id) VALUES (362, 32);
INSERT INTO element_module (element_id, module_id) VALUES (363, 32);
INSERT INTO element_module (element_id, module_id) VALUES (364, 32);
INSERT INTO element_module (element_id, module_id) VALUES (365, 33);
INSERT INTO element_module (element_id, module_id) VALUES (366, 33);
INSERT INTO element_module (element_id, module_id) VALUES (367, 33);
INSERT INTO element_module (element_id, module_id) VALUES (368, 33);
INSERT INTO element_module (element_id, module_id) VALUES (369, 33);
INSERT INTO element_module (element_id, module_id) VALUES (370, 33);
INSERT INTO element_module (element_id, module_id) VALUES (371, 33);
INSERT INTO element_module (element_id, module_id) VALUES (372, 33);
INSERT INTO element_module (element_id, module_id) VALUES (373, 33);
INSERT INTO element_module (element_id, module_id) VALUES (374, 33);
INSERT INTO element_module (element_id, module_id) VALUES (375, 33);
INSERT INTO element_module (element_id, module_id) VALUES (376, 33);
INSERT INTO element_module (element_id, module_id) VALUES (377, 33);
INSERT INTO element_module (element_id, module_id) VALUES (378, 33);
INSERT INTO element_module (element_id, module_id) VALUES (379, 33);
INSERT INTO element_module (element_id, module_id) VALUES (380, 35);
INSERT INTO element_module (element_id, module_id) VALUES (381, 35);
INSERT INTO element_module (element_id, module_id) VALUES (382, 35);
INSERT INTO element_module (element_id, module_id) VALUES (383, 35);
INSERT INTO element_module (element_id, module_id) VALUES (384, 35);
INSERT INTO element_module (element_id, module_id) VALUES (385, 35);
INSERT INTO element_module (element_id, module_id) VALUES (386, 35);
INSERT INTO element_module (element_id, module_id) VALUES (387, 35);
INSERT INTO element_module (element_id, module_id) VALUES (388, 35);
INSERT INTO element_module (element_id, module_id) VALUES (389, 35);
INSERT INTO element_module (element_id, module_id) VALUES (390, 35);
INSERT INTO element_module (element_id, module_id) VALUES (391, 35);
INSERT INTO element_module (element_id, module_id) VALUES (392, 35);
INSERT INTO element_module (element_id, module_id) VALUES (393, 35);
INSERT INTO element_module (element_id, module_id) VALUES (394, 35);
INSERT INTO element_module (element_id, module_id) VALUES (395, 35);
INSERT INTO element_module (element_id, module_id) VALUES (396, 35);
INSERT INTO element_module (element_id, module_id) VALUES (397, 35);
INSERT INTO element_module (element_id, module_id) VALUES (398, 35);
INSERT INTO element_module (element_id, module_id) VALUES (399, 35);
INSERT INTO element_module (element_id, module_id) VALUES (400, 35);
INSERT INTO element_module (element_id, module_id) VALUES (401, 35);
INSERT INTO element_module (element_id, module_id) VALUES (402, 35);
INSERT INTO element_module (element_id, module_id) VALUES (403, 35);
INSERT INTO element_module (element_id, module_id) VALUES (404, 35);
INSERT INTO element_module (element_id, module_id) VALUES (405, 35);
INSERT INTO element_module (element_id, module_id) VALUES (406, 35);
INSERT INTO element_module (element_id, module_id) VALUES (407, 35);
INSERT INTO element_module (element_id, module_id) VALUES (408, 35);
INSERT INTO element_module (element_id, module_id) VALUES (409, 35);
INSERT INTO element_module (element_id, module_id) VALUES (410, 35);
INSERT INTO element_module (element_id, module_id) VALUES (411, 35);
INSERT INTO element_module (element_id, module_id) VALUES (412, 35);
INSERT INTO element_module (element_id, module_id) VALUES (413, 35);
INSERT INTO element_module (element_id, module_id) VALUES (414, 35);
INSERT INTO element_module (element_id, module_id) VALUES (415, 35);
INSERT INTO element_module (element_id, module_id) VALUES (416, 35);
INSERT INTO element_module (element_id, module_id) VALUES (417, 35);
INSERT INTO element_module (element_id, module_id) VALUES (418, 35);
INSERT INTO element_module (element_id, module_id) VALUES (419, 35);
INSERT INTO element_module (element_id, module_id) VALUES (420, 35);
INSERT INTO element_module (element_id, module_id) VALUES (421, 35);
INSERT INTO element_module (element_id, module_id) VALUES (422, 35);
INSERT INTO element_module (element_id, module_id) VALUES (423, 35);
INSERT INTO element_module (element_id, module_id) VALUES (424, 35);
INSERT INTO element_module (element_id, module_id) VALUES (425, 35);
INSERT INTO element_module (element_id, module_id) VALUES (426, 35);
INSERT INTO element_module (element_id, module_id) VALUES (427, 35);
INSERT INTO element_module (element_id, module_id) VALUES (428, 35);
INSERT INTO element_module (element_id, module_id) VALUES (429, 35);
INSERT INTO element_module (element_id, module_id) VALUES (430, 35);
INSERT INTO element_module (element_id, module_id) VALUES (431, 35);
INSERT INTO element_module (element_id, module_id) VALUES (432, 35);
INSERT INTO element_module (element_id, module_id) VALUES (433, 35);
INSERT INTO element_module (element_id, module_id) VALUES (434, 35);
INSERT INTO element_module (element_id, module_id) VALUES (435, 35);
INSERT INTO element_module (element_id, module_id) VALUES (436, 35);
INSERT INTO element_module (element_id, module_id) VALUES (437, 35);
INSERT INTO element_module (element_id, module_id) VALUES (438, 35);
INSERT INTO element_module (element_id, module_id) VALUES (439, 35);
INSERT INTO element_module (element_id, module_id) VALUES (440, 35);
INSERT INTO element_module (element_id, module_id) VALUES (441, 35);
INSERT INTO element_module (element_id, module_id) VALUES (442, 35);
INSERT INTO element_module (element_id, module_id) VALUES (443, 35);
INSERT INTO element_module (element_id, module_id) VALUES (444, 35);
INSERT INTO element_module (element_id, module_id) VALUES (445, 35);
INSERT INTO element_module (element_id, module_id) VALUES (446, 35);
INSERT INTO element_module (element_id, module_id) VALUES (447, 35);
INSERT INTO element_module (element_id, module_id) VALUES (448, 35);
INSERT INTO element_module (element_id, module_id) VALUES (449, 35);
INSERT INTO element_module (element_id, module_id) VALUES (450, 35);
INSERT INTO element_module (element_id, module_id) VALUES (451, 35);
INSERT INTO element_module (element_id, module_id) VALUES (452, 35);
INSERT INTO element_module (element_id, module_id) VALUES (453, 35);
INSERT INTO element_module (element_id, module_id) VALUES (454, 35);
INSERT INTO element_module (element_id, module_id) VALUES (455, 35);
INSERT INTO element_module (element_id, module_id) VALUES (456, 35);
INSERT INTO element_module (element_id, module_id) VALUES (457, 35);
INSERT INTO element_module (element_id, module_id) VALUES (458, 35);
INSERT INTO element_module (element_id, module_id) VALUES (459, 35);
INSERT INTO element_module (element_id, module_id) VALUES (460, 35);
INSERT INTO element_module (element_id, module_id) VALUES (461, 35);
INSERT INTO element_module (element_id, module_id) VALUES (462, 35);
INSERT INTO element_module (element_id, module_id) VALUES (463, 35);
INSERT INTO element_module (element_id, module_id) VALUES (464, 35);
INSERT INTO element_module (element_id, module_id) VALUES (465, 35);
INSERT INTO element_module (element_id, module_id) VALUES (466, 35);
INSERT INTO element_module (element_id, module_id) VALUES (467, 35);
INSERT INTO element_module (element_id, module_id) VALUES (468, 35);
INSERT INTO element_module (element_id, module_id) VALUES (469, 35);
INSERT INTO element_module (element_id, module_id) VALUES (470, 35);
INSERT INTO element_module (element_id, module_id) VALUES (471, 35);
INSERT INTO element_module (element_id, module_id) VALUES (472, 35);
INSERT INTO element_module (element_id, module_id) VALUES (473, 35);
INSERT INTO element_module (element_id, module_id) VALUES (474, 35);
INSERT INTO element_module (element_id, module_id) VALUES (475, 35);
INSERT INTO element_module (element_id, module_id) VALUES (476, 35);
INSERT INTO element_module (element_id, module_id) VALUES (477, 35);
INSERT INTO element_module (element_id, module_id) VALUES (478, 35);
INSERT INTO element_module (element_id, module_id) VALUES (479, 35);
INSERT INTO element_module (element_id, module_id) VALUES (480, 35);
INSERT INTO element_module (element_id, module_id) VALUES (481, 35);
INSERT INTO element_module (element_id, module_id) VALUES (482, 35);
INSERT INTO element_module (element_id, module_id) VALUES (483, 35);
INSERT INTO element_module (element_id, module_id) VALUES (484, 35);
INSERT INTO element_module (element_id, module_id) VALUES (485, 35);
INSERT INTO element_module (element_id, module_id) VALUES (486, 35);
INSERT INTO element_module (element_id, module_id) VALUES (487, 35);
INSERT INTO element_module (element_id, module_id) VALUES (488, 35);
INSERT INTO element_module (element_id, module_id) VALUES (489, 35);
INSERT INTO element_module (element_id, module_id) VALUES (490, 35);
INSERT INTO element_module (element_id, module_id) VALUES (491, 35);
INSERT INTO element_module (element_id, module_id) VALUES (492, 35);
INSERT INTO element_module (element_id, module_id) VALUES (493, 35);
INSERT INTO element_module (element_id, module_id) VALUES (494, 35);
INSERT INTO element_module (element_id, module_id) VALUES (495, 35);
INSERT INTO element_module (element_id, module_id) VALUES (496, 35);
INSERT INTO element_module (element_id, module_id) VALUES (497, 35);
INSERT INTO element_module (element_id, module_id) VALUES (498, 35);
INSERT INTO element_module (element_id, module_id) VALUES (499, 35);
INSERT INTO element_module (element_id, module_id) VALUES (500, 35);
INSERT INTO element_module (element_id, module_id) VALUES (501, 35);
INSERT INTO element_module (element_id, module_id) VALUES (502, 35);
INSERT INTO element_module (element_id, module_id) VALUES (503, 35);
INSERT INTO element_module (element_id, module_id) VALUES (504, 35);
INSERT INTO element_module (element_id, module_id) VALUES (505, 35);
INSERT INTO element_module (element_id, module_id) VALUES (506, 35);
INSERT INTO element_module (element_id, module_id) VALUES (507, 35);
INSERT INTO element_module (element_id, module_id) VALUES (508, 35);
INSERT INTO element_module (element_id, module_id) VALUES (509, 35);
INSERT INTO element_module (element_id, module_id) VALUES (510, 35);
INSERT INTO element_module (element_id, module_id) VALUES (511, 35);
INSERT INTO element_module (element_id, module_id) VALUES (512, 35);
INSERT INTO element_module (element_id, module_id) VALUES (513, 35);
INSERT INTO element_module (element_id, module_id) VALUES (514, 35);
INSERT INTO element_module (element_id, module_id) VALUES (515, 35);
INSERT INTO element_module (element_id, module_id) VALUES (516, 35);
INSERT INTO element_module (element_id, module_id) VALUES (517, 35);
INSERT INTO element_module (element_id, module_id) VALUES (518, 35);
INSERT INTO element_module (element_id, module_id) VALUES (519, 35);
INSERT INTO element_module (element_id, module_id) VALUES (520, 35);
INSERT INTO element_module (element_id, module_id) VALUES (521, 35);
INSERT INTO element_module (element_id, module_id) VALUES (522, 35);
INSERT INTO element_module (element_id, module_id) VALUES (523, 35);
INSERT INTO element_module (element_id, module_id) VALUES (524, 35);
INSERT INTO element_module (element_id, module_id) VALUES (525, 35);
INSERT INTO element_module (element_id, module_id) VALUES (526, 35);
INSERT INTO element_module (element_id, module_id) VALUES (527, 35);
INSERT INTO element_module (element_id, module_id) VALUES (528, 35);
INSERT INTO element_module (element_id, module_id) VALUES (529, 35);
INSERT INTO element_module (element_id, module_id) VALUES (530, 35);
INSERT INTO element_module (element_id, module_id) VALUES (531, 35);
INSERT INTO element_module (element_id, module_id) VALUES (532, 35);
INSERT INTO element_module (element_id, module_id) VALUES (533, 35);
INSERT INTO element_module (element_id, module_id) VALUES (534, 35);
INSERT INTO element_module (element_id, module_id) VALUES (535, 35);
INSERT INTO element_module (element_id, module_id) VALUES (536, 35);
INSERT INTO element_module (element_id, module_id) VALUES (537, 35);
INSERT INTO element_module (element_id, module_id) VALUES (538, 35);
INSERT INTO element_module (element_id, module_id) VALUES (539, 35);
INSERT INTO element_module (element_id, module_id) VALUES (540, 35);
INSERT INTO element_module (element_id, module_id) VALUES (541, 35);
INSERT INTO element_module (element_id, module_id) VALUES (542, 35);
INSERT INTO element_module (element_id, module_id) VALUES (543, 35);
INSERT INTO element_module (element_id, module_id) VALUES (544, 35);
INSERT INTO element_module (element_id, module_id) VALUES (545, 35);
INSERT INTO element_module (element_id, module_id) VALUES (546, 35);
INSERT INTO element_module (element_id, module_id) VALUES (547, 35);
INSERT INTO element_module (element_id, module_id) VALUES (548, 35);
INSERT INTO element_module (element_id, module_id) VALUES (549, 35);
INSERT INTO element_module (element_id, module_id) VALUES (550, 35);
INSERT INTO element_module (element_id, module_id) VALUES (551, 35);
INSERT INTO element_module (element_id, module_id) VALUES (552, 35);
INSERT INTO element_module (element_id, module_id) VALUES (553, 35);
INSERT INTO element_module (element_id, module_id) VALUES (554, 35);
INSERT INTO element_module (element_id, module_id) VALUES (555, 35);
INSERT INTO element_module (element_id, module_id) VALUES (556, 35);
INSERT INTO element_module (element_id, module_id) VALUES (557, 35);
INSERT INTO element_module (element_id, module_id) VALUES (558, 35);
INSERT INTO element_module (element_id, module_id) VALUES (559, 35);
INSERT INTO element_module (element_id, module_id) VALUES (560, 35);
INSERT INTO element_module (element_id, module_id) VALUES (561, 35);
INSERT INTO element_module (element_id, module_id) VALUES (562, 35);
INSERT INTO element_module (element_id, module_id) VALUES (563, 35);
INSERT INTO element_module (element_id, module_id) VALUES (564, 35);
INSERT INTO element_module (element_id, module_id) VALUES (565, 35);
INSERT INTO element_module (element_id, module_id) VALUES (566, 35);
INSERT INTO element_module (element_id, module_id) VALUES (567, 35);
INSERT INTO element_module (element_id, module_id) VALUES (568, 35);
INSERT INTO element_module (element_id, module_id) VALUES (569, 35);
INSERT INTO element_module (element_id, module_id) VALUES (570, 35);
INSERT INTO element_module (element_id, module_id) VALUES (571, 35);
INSERT INTO element_module (element_id, module_id) VALUES (572, 35);
INSERT INTO element_module (element_id, module_id) VALUES (573, 35);
INSERT INTO element_module (element_id, module_id) VALUES (574, 35);
INSERT INTO element_module (element_id, module_id) VALUES (575, 35);
INSERT INTO element_module (element_id, module_id) VALUES (576, 35);
INSERT INTO element_module (element_id, module_id) VALUES (577, 35);
INSERT INTO element_module (element_id, module_id) VALUES (578, 35);
INSERT INTO element_module (element_id, module_id) VALUES (579, 35);
INSERT INTO element_module (element_id, module_id) VALUES (580, 35);
INSERT INTO element_module (element_id, module_id) VALUES (581, 35);
INSERT INTO element_module (element_id, module_id) VALUES (582, 35);
INSERT INTO element_module (element_id, module_id) VALUES (583, 35);
INSERT INTO element_module (element_id, module_id) VALUES (584, 35);
INSERT INTO element_module (element_id, module_id) VALUES (585, 35);
INSERT INTO element_module (element_id, module_id) VALUES (586, 35);
INSERT INTO element_module (element_id, module_id) VALUES (587, 35);
INSERT INTO element_module (element_id, module_id) VALUES (588, 35);
INSERT INTO element_module (element_id, module_id) VALUES (589, 35);
INSERT INTO element_module (element_id, module_id) VALUES (590, 35);
INSERT INTO element_module (element_id, module_id) VALUES (591, 35);
INSERT INTO element_module (element_id, module_id) VALUES (592, 35);
INSERT INTO element_module (element_id, module_id) VALUES (593, 35);
INSERT INTO element_module (element_id, module_id) VALUES (594, 35);
INSERT INTO element_module (element_id, module_id) VALUES (595, 35);
INSERT INTO element_module (element_id, module_id) VALUES (797, 37);
INSERT INTO element_module (element_id, module_id) VALUES (798, 37);
INSERT INTO element_module (element_id, module_id) VALUES (799, 37);
INSERT INTO element_module (element_id, module_id) VALUES (800, 37);
INSERT INTO element_module (element_id, module_id) VALUES (801, 37);
INSERT INTO element_module (element_id, module_id) VALUES (802, 37);
INSERT INTO element_module (element_id, module_id) VALUES (803, 37);
INSERT INTO element_module (element_id, module_id) VALUES (804, 37);
INSERT INTO element_module (element_id, module_id) VALUES (805, 37);
INSERT INTO element_module (element_id, module_id) VALUES (806, 37);
INSERT INTO element_module (element_id, module_id) VALUES (807, 37);
INSERT INTO element_module (element_id, module_id) VALUES (808, 37);
INSERT INTO element_module (element_id, module_id) VALUES (809, 37);
INSERT INTO element_module (element_id, module_id) VALUES (810, 37);
INSERT INTO element_module (element_id, module_id) VALUES (811, 37);
INSERT INTO element_module (element_id, module_id) VALUES (812, 37);
INSERT INTO element_module (element_id, module_id) VALUES (813, 37);
INSERT INTO element_module (element_id, module_id) VALUES (814, 37);
INSERT INTO element_module (element_id, module_id) VALUES (815, 37);
INSERT INTO element_module (element_id, module_id) VALUES (816, 37);
INSERT INTO element_module (element_id, module_id) VALUES (817, 37);
INSERT INTO element_module (element_id, module_id) VALUES (818, 37);
INSERT INTO element_module (element_id, module_id) VALUES (819, 37);
INSERT INTO element_module (element_id, module_id) VALUES (820, 37);
INSERT INTO element_module (element_id, module_id) VALUES (821, 37);
INSERT INTO element_module (element_id, module_id) VALUES (822, 37);
INSERT INTO element_module (element_id, module_id) VALUES (823, 37);
INSERT INTO element_module (element_id, module_id) VALUES (824, 37);
INSERT INTO element_module (element_id, module_id) VALUES (825, 37);
INSERT INTO element_module (element_id, module_id) VALUES (826, 37);
INSERT INTO element_module (element_id, module_id) VALUES (827, 37);
INSERT INTO element_module (element_id, module_id) VALUES (828, 37);
INSERT INTO element_module (element_id, module_id) VALUES (829, 37);
INSERT INTO element_module (element_id, module_id) VALUES (830, 37);
INSERT INTO element_module (element_id, module_id) VALUES (831, 37);
INSERT INTO element_module (element_id, module_id) VALUES (832, 37);
INSERT INTO element_module (element_id, module_id) VALUES (833, 37);
INSERT INTO element_module (element_id, module_id) VALUES (834, 37);
INSERT INTO element_module (element_id, module_id) VALUES (835, 37);
INSERT INTO element_module (element_id, module_id) VALUES (836, 37);
INSERT INTO element_module (element_id, module_id) VALUES (837, 37);
INSERT INTO element_module (element_id, module_id) VALUES (838, 37);
INSERT INTO element_module (element_id, module_id) VALUES (839, 37);
INSERT INTO element_module (element_id, module_id) VALUES (840, 37);
INSERT INTO element_module (element_id, module_id) VALUES (841, 37);
INSERT INTO element_module (element_id, module_id) VALUES (842, 37);
INSERT INTO element_module (element_id, module_id) VALUES (843, 37);
INSERT INTO element_module (element_id, module_id) VALUES (844, 37);
INSERT INTO element_module (element_id, module_id) VALUES (845, 37);
INSERT INTO element_module (element_id, module_id) VALUES (846, 37);
INSERT INTO element_module (element_id, module_id) VALUES (847, 37);
INSERT INTO element_module (element_id, module_id) VALUES (848, 37);
INSERT INTO element_module (element_id, module_id) VALUES (849, 37);
INSERT INTO element_module (element_id, module_id) VALUES (850, 37);
INSERT INTO element_module (element_id, module_id) VALUES (851, 37);
INSERT INTO element_module (element_id, module_id) VALUES (852, 37);
INSERT INTO element_module (element_id, module_id) VALUES (853, 37);
INSERT INTO element_module (element_id, module_id) VALUES (854, 37);
INSERT INTO element_module (element_id, module_id) VALUES (855, 37);
INSERT INTO element_module (element_id, module_id) VALUES (856, 37);
INSERT INTO element_module (element_id, module_id) VALUES (857, 37);
INSERT INTO element_module (element_id, module_id) VALUES (858, 37);
INSERT INTO element_module (element_id, module_id) VALUES (859, 37);
INSERT INTO element_module (element_id, module_id) VALUES (860, 37);
INSERT INTO element_module (element_id, module_id) VALUES (861, 37);
INSERT INTO element_module (element_id, module_id) VALUES (862, 37);
INSERT INTO element_module (element_id, module_id) VALUES (863, 37);
INSERT INTO element_module (element_id, module_id) VALUES (864, 37);
INSERT INTO element_module (element_id, module_id) VALUES (865, 37);
INSERT INTO element_module (element_id, module_id) VALUES (866, 37);
INSERT INTO element_module (element_id, module_id) VALUES (867, 37);
INSERT INTO element_module (element_id, module_id) VALUES (868, 37);
INSERT INTO element_module (element_id, module_id) VALUES (869, 37);
INSERT INTO element_module (element_id, module_id) VALUES (870, 37);
INSERT INTO element_module (element_id, module_id) VALUES (871, 37);
INSERT INTO element_module (element_id, module_id) VALUES (872, 37);
INSERT INTO element_module (element_id, module_id) VALUES (873, 37);
INSERT INTO element_module (element_id, module_id) VALUES (874, 37);
INSERT INTO element_module (element_id, module_id) VALUES (875, 37);
INSERT INTO element_module (element_id, module_id) VALUES (876, 37);
INSERT INTO element_module (element_id, module_id) VALUES (877, 37);
INSERT INTO element_module (element_id, module_id) VALUES (878, 37);
INSERT INTO element_module (element_id, module_id) VALUES (879, 37);
INSERT INTO element_module (element_id, module_id) VALUES (880, 37);
INSERT INTO element_module (element_id, module_id) VALUES (881, 37);
INSERT INTO element_module (element_id, module_id) VALUES (882, 37);
INSERT INTO element_module (element_id, module_id) VALUES (883, 37);
INSERT INTO element_module (element_id, module_id) VALUES (884, 37);
INSERT INTO element_module (element_id, module_id) VALUES (885, 37);
INSERT INTO element_module (element_id, module_id) VALUES (886, 37);
INSERT INTO element_module (element_id, module_id) VALUES (887, 37);
INSERT INTO element_module (element_id, module_id) VALUES (888, 37);
INSERT INTO element_module (element_id, module_id) VALUES (889, 37);
INSERT INTO element_module (element_id, module_id) VALUES (890, 37);
INSERT INTO element_module (element_id, module_id) VALUES (891, 37);
INSERT INTO element_module (element_id, module_id) VALUES (892, 37);
INSERT INTO element_module (element_id, module_id) VALUES (893, 37);
INSERT INTO element_module (element_id, module_id) VALUES (894, 37);
INSERT INTO element_module (element_id, module_id) VALUES (895, 37);
INSERT INTO element_module (element_id, module_id) VALUES (896, 37);
INSERT INTO element_module (element_id, module_id) VALUES (897, 37);
INSERT INTO element_module (element_id, module_id) VALUES (898, 37);
INSERT INTO element_module (element_id, module_id) VALUES (899, 37);
INSERT INTO element_module (element_id, module_id) VALUES (900, 37);
INSERT INTO element_module (element_id, module_id) VALUES (901, 37);
INSERT INTO element_module (element_id, module_id) VALUES (902, 37);
INSERT INTO element_module (element_id, module_id) VALUES (903, 37);
INSERT INTO element_module (element_id, module_id) VALUES (904, 37);
INSERT INTO element_module (element_id, module_id) VALUES (905, 37);
INSERT INTO element_module (element_id, module_id) VALUES (906, 37);
INSERT INTO element_module (element_id, module_id) VALUES (907, 37);
INSERT INTO element_module (element_id, module_id) VALUES (908, 37);
INSERT INTO element_module (element_id, module_id) VALUES (909, 37);
INSERT INTO element_module (element_id, module_id) VALUES (910, 37);
INSERT INTO element_module (element_id, module_id) VALUES (911, 37);
INSERT INTO element_module (element_id, module_id) VALUES (912, 37);
INSERT INTO element_module (element_id, module_id) VALUES (913, 37);
INSERT INTO element_module (element_id, module_id) VALUES (914, 37);
INSERT INTO element_module (element_id, module_id) VALUES (915, 37);
INSERT INTO element_module (element_id, module_id) VALUES (916, 37);
INSERT INTO element_module (element_id, module_id) VALUES (917, 37);
INSERT INTO element_module (element_id, module_id) VALUES (918, 37);
INSERT INTO element_module (element_id, module_id) VALUES (919, 37);
INSERT INTO element_module (element_id, module_id) VALUES (920, 37);
INSERT INTO element_module (element_id, module_id) VALUES (921, 37);
INSERT INTO element_module (element_id, module_id) VALUES (922, 37);
INSERT INTO element_module (element_id, module_id) VALUES (923, 37);
INSERT INTO element_module (element_id, module_id) VALUES (924, 37);
INSERT INTO element_module (element_id, module_id) VALUES (925, 37);
INSERT INTO element_module (element_id, module_id) VALUES (926, 37);
INSERT INTO element_module (element_id, module_id) VALUES (927, 37);
INSERT INTO element_module (element_id, module_id) VALUES (928, 37);
INSERT INTO element_module (element_id, module_id) VALUES (929, 37);
INSERT INTO element_module (element_id, module_id) VALUES (930, 37);
INSERT INTO element_module (element_id, module_id) VALUES (931, 37);
INSERT INTO element_module (element_id, module_id) VALUES (932, 37);
INSERT INTO element_module (element_id, module_id) VALUES (933, 37);
INSERT INTO element_module (element_id, module_id) VALUES (934, 37);
INSERT INTO element_module (element_id, module_id) VALUES (935, 37);
INSERT INTO element_module (element_id, module_id) VALUES (936, 37);
INSERT INTO element_module (element_id, module_id) VALUES (937, 37);
INSERT INTO element_module (element_id, module_id) VALUES (938, 38);
INSERT INTO element_module (element_id, module_id) VALUES (939, 38);
INSERT INTO element_module (element_id, module_id) VALUES (940, 38);
INSERT INTO element_module (element_id, module_id) VALUES (941, 38);
INSERT INTO element_module (element_id, module_id) VALUES (942, 38);
INSERT INTO element_module (element_id, module_id) VALUES (943, 38);
INSERT INTO element_module (element_id, module_id) VALUES (944, 38);
INSERT INTO element_module (element_id, module_id) VALUES (945, 38);
INSERT INTO element_module (element_id, module_id) VALUES (946, 38);
INSERT INTO element_module (element_id, module_id) VALUES (947, 38);
INSERT INTO element_module (element_id, module_id) VALUES (948, 38);
INSERT INTO element_module (element_id, module_id) VALUES (949, 38);
INSERT INTO element_module (element_id, module_id) VALUES (950, 38);
INSERT INTO element_module (element_id, module_id) VALUES (951, 38);
INSERT INTO element_module (element_id, module_id) VALUES (952, 38);
INSERT INTO element_module (element_id, module_id) VALUES (953, 38);
INSERT INTO element_module (element_id, module_id) VALUES (954, 38);
INSERT INTO element_module (element_id, module_id) VALUES (955, 38);
INSERT INTO element_module (element_id, module_id) VALUES (956, 38);
INSERT INTO element_module (element_id, module_id) VALUES (957, 38);
INSERT INTO element_module (element_id, module_id) VALUES (958, 38);
INSERT INTO element_module (element_id, module_id) VALUES (959, 38);
INSERT INTO element_module (element_id, module_id) VALUES (960, 38);
INSERT INTO element_module (element_id, module_id) VALUES (961, 38);
INSERT INTO element_module (element_id, module_id) VALUES (962, 38);
INSERT INTO element_module (element_id, module_id) VALUES (963, 38);
INSERT INTO element_module (element_id, module_id) VALUES (964, 38);
INSERT INTO element_module (element_id, module_id) VALUES (965, 38);
INSERT INTO element_module (element_id, module_id) VALUES (966, 38);
INSERT INTO element_module (element_id, module_id) VALUES (967, 38);
INSERT INTO element_module (element_id, module_id) VALUES (968, 38);
INSERT INTO element_module (element_id, module_id) VALUES (969, 38);
INSERT INTO element_module (element_id, module_id) VALUES (970, 38);
INSERT INTO element_module (element_id, module_id) VALUES (971, 38);
INSERT INTO element_module (element_id, module_id) VALUES (972, 38);
INSERT INTO element_module (element_id, module_id) VALUES (973, 38);
INSERT INTO element_module (element_id, module_id) VALUES (974, 38);
INSERT INTO element_module (element_id, module_id) VALUES (975, 38);
INSERT INTO element_module (element_id, module_id) VALUES (976, 38);
INSERT INTO element_module (element_id, module_id) VALUES (977, 38);
INSERT INTO element_module (element_id, module_id) VALUES (978, 38);
INSERT INTO element_module (element_id, module_id) VALUES (979, 38);
INSERT INTO element_module (element_id, module_id) VALUES (980, 38);
INSERT INTO element_module (element_id, module_id) VALUES (981, 38);
INSERT INTO element_module (element_id, module_id) VALUES (982, 38);
INSERT INTO element_module (element_id, module_id) VALUES (983, 38);
INSERT INTO element_module (element_id, module_id) VALUES (984, 38);
INSERT INTO element_module (element_id, module_id) VALUES (985, 38);
INSERT INTO element_module (element_id, module_id) VALUES (986, 38);
INSERT INTO element_module (element_id, module_id) VALUES (987, 38);
INSERT INTO element_module (element_id, module_id) VALUES (988, 38);
INSERT INTO element_module (element_id, module_id) VALUES (989, 38);
INSERT INTO element_module (element_id, module_id) VALUES (990, 38);
INSERT INTO element_module (element_id, module_id) VALUES (991, 38);
INSERT INTO element_module (element_id, module_id) VALUES (992, 38);
INSERT INTO element_module (element_id, module_id) VALUES (993, 38);
INSERT INTO element_module (element_id, module_id) VALUES (994, 38);
INSERT INTO element_module (element_id, module_id) VALUES (995, 38);
INSERT INTO element_module (element_id, module_id) VALUES (996, 38);
INSERT INTO element_module (element_id, module_id) VALUES (997, 38);
INSERT INTO element_module (element_id, module_id) VALUES (998, 38);
INSERT INTO element_module (element_id, module_id) VALUES (999, 38);
INSERT INTO element_module (element_id, module_id) VALUES (1000, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1001, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1002, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1003, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1004, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1005, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1006, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1007, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1008, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1009, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1010, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1011, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1012, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1013, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1014, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1015, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1016, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1017, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1018, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1019, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1020, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1021, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1022, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1023, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1024, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1025, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1026, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1027, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1028, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1029, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1030, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1031, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1032, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1033, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1034, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1035, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1036, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1037, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1038, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1039, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1040, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1041, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1042, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1043, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1044, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1045, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1046, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1047, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1048, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1049, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1050, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1051, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1052, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1053, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1054, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1055, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1056, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1057, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1058, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1059, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1060, 39);
INSERT INTO element_module (element_id, module_id) VALUES (1061, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1062, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1063, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1064, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1065, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1066, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1067, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1068, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1069, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1070, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1071, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1072, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1073, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1074, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1075, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1076, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1077, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1078, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1079, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1080, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1081, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1082, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1083, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1084, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1085, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1086, 40);
INSERT INTO element_module (element_id, module_id) VALUES (1087, 41);
INSERT INTO element_module (element_id, module_id) VALUES (1088, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1089, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1090, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1091, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1092, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1093, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1094, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1095, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1096, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1097, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1098, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1099, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1100, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1101, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1102, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1103, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1104, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1105, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1106, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1107, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1108, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1109, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1110, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1111, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1112, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1113, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1114, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1115, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1116, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1117, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1118, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1119, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1120, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1121, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1122, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1123, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1124, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1125, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1126, 42);
INSERT INTO element_module (element_id, module_id) VALUES (1127, 42);
INSERT INTO element_module (element_id, module_id) VALUES (6288, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6289, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6290, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6291, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6292, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6293, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6294, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6295, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6296, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6297, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6298, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6299, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6300, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6301, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6302, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6303, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6304, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6305, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6306, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6307, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6308, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6309, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6310, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6311, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6312, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6313, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6314, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6315, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6316, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6317, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6318, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6319, 98);
INSERT INTO element_module (element_id, module_id) VALUES (1160, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1161, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1162, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1163, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1164, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1165, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1166, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1167, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1168, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1169, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1170, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1171, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1172, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1173, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1174, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1175, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1176, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1177, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1178, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1179, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1180, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1181, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1182, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1183, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1184, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1185, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1186, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1187, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1188, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1189, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1190, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1191, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1192, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1193, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1194, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1195, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1196, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1197, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1198, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1199, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1200, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1201, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1202, 44);
INSERT INTO element_module (element_id, module_id) VALUES (1203, 44);
INSERT INTO element_module (element_id, module_id) VALUES (5890, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5891, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5892, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5893, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5894, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5895, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5896, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5897, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5898, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5899, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5900, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5901, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5902, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5903, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5664, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5665, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5666, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5667, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5668, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5669, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5670, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5671, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5672, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5673, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5674, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5675, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5676, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5677, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5678, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5679, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5680, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5681, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5682, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5683, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5684, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5685, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5686, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5687, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5688, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5689, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5690, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5691, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5692, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5693, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5694, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5695, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5696, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5697, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5698, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5699, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5700, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5701, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5702, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5703, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5704, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5705, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5706, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5707, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5708, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5709, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5710, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5711, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5712, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5713, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5714, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5715, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5716, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5717, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5718, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5719, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5720, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5721, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5722, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5723, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5724, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5725, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5726, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5727, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5728, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5729, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5730, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5731, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5732, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5733, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5734, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5735, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5736, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5737, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5738, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5739, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5740, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5741, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5742, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5743, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5744, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5745, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5746, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5747, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5748, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5749, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5750, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5751, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5752, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5753, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5754, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5755, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5756, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5757, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5758, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5759, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5760, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5761, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5762, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5763, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5764, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5765, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5766, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5767, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5768, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5769, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5770, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5771, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5772, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5773, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5774, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5775, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5776, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5777, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5778, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5779, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5780, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5781, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5782, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5783, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5784, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5785, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5786, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5787, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5788, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5789, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5790, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5791, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5792, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5793, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5794, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5795, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5796, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5797, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5798, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5799, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5800, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5801, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5802, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5803, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5804, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5805, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5806, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5807, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5808, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5809, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5810, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5811, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5812, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5813, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5814, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5815, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5816, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5817, 87);
INSERT INTO element_module (element_id, module_id) VALUES (5818, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5819, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5820, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5821, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5822, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5823, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5824, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5825, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5826, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5827, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5828, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5829, 88);
INSERT INTO element_module (element_id, module_id) VALUES (5830, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5831, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5832, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5833, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5834, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5835, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5836, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5837, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5838, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5839, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5840, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5841, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5842, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5843, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5844, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5845, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5846, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5847, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5848, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5849, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5850, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5851, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5852, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5853, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5854, 89);
INSERT INTO element_module (element_id, module_id) VALUES (5855, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5856, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5857, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5858, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5859, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5860, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5861, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5862, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5863, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5864, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5865, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5866, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5867, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5868, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5869, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5870, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5871, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5872, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5873, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5874, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5875, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5876, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5877, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5878, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5879, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5880, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5881, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5882, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5883, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5884, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5885, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5886, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5887, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5888, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5889, 90);
INSERT INTO element_module (element_id, module_id) VALUES (5438, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5439, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5440, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5441, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5442, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5443, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5444, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5445, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5446, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5447, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5448, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5449, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5450, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5451, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5452, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5453, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5511, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5512, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5513, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5514, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5515, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5516, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5517, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5518, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5519, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5520, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5521, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5522, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5523, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5524, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5525, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5526, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5527, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5528, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5529, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5530, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5531, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5532, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5533, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5534, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5535, 84);
INSERT INTO element_module (element_id, module_id) VALUES (5536, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5537, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5538, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5539, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5540, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5541, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5542, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5543, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5544, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5545, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5546, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5547, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5548, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5549, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5550, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5551, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5552, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5553, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5554, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5555, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5556, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5557, 85);
INSERT INTO element_module (element_id, module_id) VALUES (1504, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1505, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1506, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1507, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1508, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1509, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1510, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1511, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1512, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1513, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1514, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1515, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1516, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1517, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1518, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1519, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1520, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1521, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1522, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1523, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1524, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1525, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1526, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1527, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1528, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1529, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1530, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1531, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1532, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1533, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1534, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1535, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1536, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1537, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1538, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1539, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1540, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1541, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1542, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1543, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1544, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1545, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1546, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1547, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1548, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1549, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1550, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1551, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1552, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1553, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1554, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1555, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1556, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1557, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1558, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1559, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1560, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1561, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1562, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1563, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1564, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1565, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1566, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1567, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1568, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1569, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1570, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1571, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1572, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1573, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1574, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1575, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1576, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1577, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1578, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1579, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1580, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1581, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1582, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1583, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1584, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1585, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1586, 50);
INSERT INTO element_module (element_id, module_id) VALUES (1587, 50);
INSERT INTO element_module (element_id, module_id) VALUES (5558, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5559, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5560, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5561, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5562, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5563, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5564, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5565, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5566, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5567, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5568, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5569, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5570, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5571, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5572, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5573, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5574, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5575, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5576, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5577, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5578, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5579, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5580, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5581, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5582, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5583, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5584, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5585, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5586, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5587, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5588, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5589, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5590, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5591, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5592, 85);
INSERT INTO element_module (element_id, module_id) VALUES (5593, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5594, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5595, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5596, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5597, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5598, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5599, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5600, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5601, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5602, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5603, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5604, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5605, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5606, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5607, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5608, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5609, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5610, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5611, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5612, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5613, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5614, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5615, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5616, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5617, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5618, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5619, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5620, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5621, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5622, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5623, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5624, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5625, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5626, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5627, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5628, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5629, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5630, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5631, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5632, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5633, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5634, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5635, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5636, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5637, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5638, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5639, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5640, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5641, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5642, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5643, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5644, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5645, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5646, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5647, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5648, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5649, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5650, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5651, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5652, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5653, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5654, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5655, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5656, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5657, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5658, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5659, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5660, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5661, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5662, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5663, 86);
INSERT INTO element_module (element_id, module_id) VALUES (5212, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5213, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5214, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5215, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5216, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5217, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5218, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5219, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5220, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5221, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5222, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5223, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5224, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5225, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5226, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5227, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5228, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5229, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5230, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5231, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5232, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5233, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5234, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5235, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5236, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5237, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5238, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5239, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5240, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5241, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5242, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5243, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5244, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5245, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5246, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5247, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5248, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5249, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5250, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5251, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5252, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5253, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5254, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5255, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5256, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5257, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5258, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5259, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5260, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5261, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5262, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5263, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5264, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5265, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5266, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5267, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5268, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5269, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5270, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5271, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5272, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5273, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5274, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5275, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5276, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5277, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5278, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5279, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5280, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5281, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5282, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5283, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5284, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5285, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5286, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5287, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5288, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5289, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5290, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5291, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5292, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5293, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5294, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5295, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5296, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5297, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5298, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5299, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5300, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5301, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5302, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5303, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5304, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5305, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5306, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5307, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5308, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5309, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5310, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5311, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5312, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5313, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5314, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5315, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5316, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5317, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5318, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5319, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5320, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5321, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5322, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5323, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5324, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5325, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5326, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5327, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5328, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5329, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5330, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5331, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5332, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5333, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5334, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5335, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5336, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5337, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5338, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5339, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5340, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5341, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5342, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5343, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5344, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5345, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5346, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5347, 80);
INSERT INTO element_module (element_id, module_id) VALUES (5348, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5349, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5350, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5351, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5352, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5353, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5354, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5355, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5356, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5357, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5358, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5359, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5360, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5361, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5362, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5363, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5364, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5365, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5366, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5367, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5368, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5369, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5370, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5371, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5372, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5373, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5374, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5375, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5376, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5377, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5378, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5379, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5380, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5381, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5382, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5383, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5384, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5385, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5386, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5387, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5388, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5389, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5390, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5391, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5392, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5393, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5394, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5395, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5396, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5397, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5398, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5399, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5400, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5401, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5402, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5403, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5404, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5405, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5406, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5407, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5408, 81);
INSERT INTO element_module (element_id, module_id) VALUES (5409, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5410, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5411, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5412, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5413, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5414, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5415, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5416, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5417, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5418, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5419, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5420, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5421, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5422, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5423, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5424, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5425, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5426, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5427, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5428, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5429, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5430, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5431, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5432, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5433, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5434, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5435, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5436, 82);
INSERT INTO element_module (element_id, module_id) VALUES (5437, 82);
INSERT INTO element_module (element_id, module_id) VALUES (4986, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4987, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4988, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4989, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4990, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4991, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4992, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4993, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4994, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4995, 78);
INSERT INTO element_module (element_id, module_id) VALUES (4996, 78);
INSERT INTO element_module (element_id, module_id) VALUES (4997, 78);
INSERT INTO element_module (element_id, module_id) VALUES (4998, 78);
INSERT INTO element_module (element_id, module_id) VALUES (4999, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5000, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5001, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5002, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5003, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5004, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5005, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5006, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5007, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5008, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5009, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5010, 78);
INSERT INTO element_module (element_id, module_id) VALUES (1943, 54);
INSERT INTO element_module (element_id, module_id) VALUES (1944, 55);
INSERT INTO element_module (element_id, module_id) VALUES (1945, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1946, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1947, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1948, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1949, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1950, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1951, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1952, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1953, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1954, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1955, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1956, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1957, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1958, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1959, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1960, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1961, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1962, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1963, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1964, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1965, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1966, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1967, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1968, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1969, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1970, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1971, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1972, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1973, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1974, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1975, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1976, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1977, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1978, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1979, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1980, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1981, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1982, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1983, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1984, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1985, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1986, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1987, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1988, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1989, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1990, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1991, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1992, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1993, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1994, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1995, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1996, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1997, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1998, 56);
INSERT INTO element_module (element_id, module_id) VALUES (1999, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2000, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2001, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2002, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2003, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2004, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2005, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2006, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2007, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2008, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2009, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2010, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2011, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2012, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2013, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2014, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2015, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2016, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2017, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2018, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2019, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2020, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2021, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2022, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2023, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2024, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2025, 56);
INSERT INTO element_module (element_id, module_id) VALUES (2026, 56);
INSERT INTO element_module (element_id, module_id) VALUES (5011, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5012, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5013, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5014, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5015, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5016, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5017, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5018, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5019, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5020, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5021, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5022, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5023, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5024, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5025, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5026, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5027, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5028, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5029, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5030, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5031, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5032, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5033, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5034, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5035, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5036, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5037, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5038, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5039, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5040, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5041, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5042, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5043, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5044, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5045, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5046, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5047, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5048, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5049, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5050, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5051, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5052, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5053, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5054, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5055, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5056, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5057, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5058, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5059, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5060, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5061, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5062, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5063, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5064, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5065, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5066, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5067, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5068, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5069, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5070, 78);
INSERT INTO element_module (element_id, module_id) VALUES (2087, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2088, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2089, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2090, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2091, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2092, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2093, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2094, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2095, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2096, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2097, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2098, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2099, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2100, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2101, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2102, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2103, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2104, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2105, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2106, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2107, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2108, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2109, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2110, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2111, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2112, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2113, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2114, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2115, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2116, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2117, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2118, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2119, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2120, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2121, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2122, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2123, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2124, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2125, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2126, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2127, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2128, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2129, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2130, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2131, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2132, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2133, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2134, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2135, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2136, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2137, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2138, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2139, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2140, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2141, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2142, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2143, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2144, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2145, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2146, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2147, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2148, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2149, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2150, 58);
INSERT INTO element_module (element_id, module_id) VALUES (2151, 58);
INSERT INTO element_module (element_id, module_id) VALUES (4518, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4519, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4520, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4521, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4522, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4523, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4524, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4525, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4526, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4527, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4528, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4529, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4530, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4531, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4532, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4533, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4534, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4535, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4536, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4537, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4538, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4539, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4540, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4541, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4542, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4543, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4544, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4545, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4546, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4547, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4548, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4549, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4550, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4551, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4552, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4553, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4554, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4555, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4556, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4557, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4558, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4559, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4560, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4561, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4562, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4563, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4564, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4565, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4566, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4567, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4568, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4569, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4570, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4571, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4572, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4573, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4574, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4575, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4576, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4577, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4578, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4579, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4580, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4581, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4582, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4583, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4584, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4585, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4586, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4587, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4588, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4589, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4590, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4591, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4592, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4593, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4594, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4595, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4596, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4597, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4598, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4599, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4600, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4601, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4602, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4603, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4604, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4605, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4606, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4607, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4608, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4609, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4610, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4611, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4612, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4613, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4614, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4615, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4616, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4617, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4618, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4619, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4620, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4621, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4622, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4623, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4624, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4625, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4626, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4627, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4628, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4629, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4630, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4631, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4632, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4633, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4634, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4635, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4636, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4637, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4638, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4639, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4640, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4641, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4642, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4643, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4644, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4645, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4646, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4647, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4648, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4649, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4650, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4651, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4652, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4653, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4654, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4655, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4656, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4657, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4658, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4659, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4660, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4661, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4662, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4663, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4664, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4665, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4666, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4667, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4668, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4669, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4670, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4671, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4672, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4673, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4674, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4675, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4676, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4677, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4678, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4679, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4680, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4681, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4682, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4683, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4684, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4685, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4686, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4687, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4688, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4689, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4690, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4691, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4692, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4693, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4694, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4695, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4696, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4697, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4698, 76);
INSERT INTO element_module (element_id, module_id) VALUES (4699, 76);
INSERT INTO element_module (element_id, module_id) VALUES (380, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4700, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4701, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4702, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4703, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4704, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4705, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4706, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4707, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4708, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4709, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4710, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4711, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4712, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4713, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4714, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4715, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4716, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4717, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4718, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4719, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4720, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4721, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4722, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4723, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4724, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4725, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4726, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4727, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4728, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4729, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4730, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4731, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4732, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4733, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4734, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4735, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4736, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4737, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4738, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4739, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4740, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4741, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4742, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4743, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4744, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4745, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4746, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4747, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4748, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4749, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4750, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4751, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4752, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4753, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4754, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4755, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4756, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4757, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4758, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4759, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4760, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4761, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4762, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4763, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4764, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4765, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4766, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4767, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4768, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4769, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4770, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4771, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4772, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4773, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4774, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4775, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4776, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4777, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4778, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4779, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4780, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4781, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4782, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4783, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4784, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4785, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4786, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4787, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4788, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4789, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4790, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4791, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4792, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4793, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4794, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4795, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4796, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4797, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4798, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4799, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4800, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4801, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4802, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4803, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4804, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4805, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4806, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4807, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4808, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4809, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4810, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4811, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4812, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4813, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4814, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4815, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4816, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4817, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4818, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4819, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4820, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4821, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4822, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4823, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4824, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4825, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4826, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4827, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4828, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4829, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4830, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4831, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4832, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4833, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4834, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4835, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4836, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4837, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4838, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4839, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4840, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4841, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4842, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4843, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4844, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4845, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4846, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4847, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4848, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4849, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4850, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4851, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4852, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4853, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4854, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4855, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4856, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4857, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4858, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4859, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4860, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4861, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4862, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4863, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4864, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4865, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4866, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4867, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4868, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4869, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4870, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4871, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4872, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4873, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4874, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4875, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4876, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4877, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4878, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4879, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4880, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4881, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4882, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4883, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4884, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4885, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4886, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4887, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4888, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4889, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4890, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4891, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4892, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4893, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4894, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4895, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4896, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4897, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4898, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4899, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4900, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4901, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4902, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4903, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4904, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4905, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4906, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4907, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4908, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4909, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4910, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4911, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4912, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4913, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4914, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4915, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4916, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4917, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4918, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4919, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4920, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4921, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4922, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4923, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4924, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4925, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4926, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4927, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4928, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4929, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4930, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4931, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4932, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4933, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4934, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4935, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4936, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4937, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4938, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4939, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4940, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4941, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4942, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4943, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4944, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4945, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4946, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4947, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4948, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4949, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4950, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4951, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4952, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4953, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4954, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4955, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4956, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4957, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4958, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4959, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4960, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4961, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4962, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4963, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4964, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4965, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4966, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4967, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4968, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4969, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4970, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4971, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4972, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4973, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4974, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4975, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4976, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4977, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4978, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4979, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4980, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4981, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4982, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4983, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4984, 77);
INSERT INTO element_module (element_id, module_id) VALUES (4985, 77);
INSERT INTO element_module (element_id, module_id) VALUES (6320, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6321, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6322, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6323, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6324, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6325, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6326, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6327, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6328, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6329, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6330, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6331, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6332, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6333, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6334, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6335, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6336, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6337, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6338, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6339, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6340, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6341, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6342, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6343, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6344, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6345, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6346, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6347, 99);
INSERT INTO element_module (element_id, module_id) VALUES (5071, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5072, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5073, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5074, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5075, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5076, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5077, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5078, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5079, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5080, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5081, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5082, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5083, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5084, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5085, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5086, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5087, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5088, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5089, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5090, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5091, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5092, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5093, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5094, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5095, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5096, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5097, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5098, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5099, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5100, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5101, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5102, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5103, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5104, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5105, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5106, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5107, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5108, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5109, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5110, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5111, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5112, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5113, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5114, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5115, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5116, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5117, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5118, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5119, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5120, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5121, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5122, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5123, 78);
INSERT INTO element_module (element_id, module_id) VALUES (5124, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5125, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5126, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5127, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5128, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5129, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5130, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5131, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5132, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5133, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5134, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5135, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5136, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5137, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5138, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5139, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5140, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5141, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5142, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5143, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5144, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5145, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5146, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5147, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5148, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5149, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5150, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5151, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5152, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5153, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5154, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5155, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5156, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5157, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5158, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5159, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5160, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5161, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5162, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5163, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5164, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5165, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5166, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5167, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5168, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5169, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5170, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5171, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5172, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5173, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5174, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5175, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5176, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5177, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5178, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5179, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5180, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5181, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5182, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5183, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5184, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5185, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5186, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5187, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5188, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5189, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5190, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5191, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5192, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5193, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5194, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5195, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5196, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5197, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5198, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5199, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5200, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5201, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5202, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5203, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5204, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5205, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5206, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5207, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5208, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5209, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5210, 79);
INSERT INTO element_module (element_id, module_id) VALUES (5211, 79);
INSERT INTO element_module (element_id, module_id) VALUES (6237, 97);
INSERT INTO element_module (element_id, module_id) VALUES (6238, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6239, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6240, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6241, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6242, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6243, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6244, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6245, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6246, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6247, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6248, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6249, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6250, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6251, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6252, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6253, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6254, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6255, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6256, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6257, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6258, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6259, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6260, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6261, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6262, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6263, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6264, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6265, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6266, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6267, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6268, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6269, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6270, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6271, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6272, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6273, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6274, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6275, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6276, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6277, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6278, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6279, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6280, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6281, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6282, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6283, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6284, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6285, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6286, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6287, 98);
INSERT INTO element_module (element_id, module_id) VALUES (6348, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6349, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6350, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6351, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6352, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6353, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6354, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6355, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6356, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6357, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6358, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6359, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6360, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6361, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6362, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6363, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6364, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6365, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6366, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6367, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6368, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6369, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6370, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6371, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6372, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6373, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6374, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6375, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6376, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6377, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6378, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6379, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6380, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6381, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6382, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6383, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6384, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6385, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6386, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6387, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6388, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6389, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6390, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6391, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6392, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6393, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6394, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6395, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6396, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6397, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6398, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6399, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6400, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6401, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6402, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6403, 99);
INSERT INTO element_module (element_id, module_id) VALUES (6687, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6688, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6689, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6690, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6691, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6692, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6693, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6694, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6695, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6696, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6697, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6698, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6699, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6700, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6701, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6702, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6703, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6704, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6705, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6706, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6707, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6708, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6709, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6710, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6711, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6712, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6713, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6714, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6715, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6716, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6717, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6718, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6719, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6720, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6721, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6722, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6723, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6724, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6725, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6726, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6727, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6728, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6729, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6730, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6731, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6732, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6733, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6734, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6735, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6736, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6737, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6738, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6739, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6740, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6741, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6742, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6743, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6744, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6745, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6746, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6747, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6748, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6749, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6750, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6751, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6752, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6753, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6754, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6755, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6756, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6757, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6758, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6759, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6760, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6761, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6762, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6763, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6764, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6765, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6766, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6767, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6768, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6769, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6770, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6771, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6772, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6773, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6774, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6775, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6776, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6777, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6778, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6779, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6780, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6781, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6782, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6783, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6784, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6785, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6786, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6787, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6788, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6789, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6790, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6791, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6792, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6793, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6794, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6795, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6796, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6797, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6798, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6799, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6800, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6801, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6802, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6803, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6804, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6805, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6806, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6807, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6808, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6809, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6810, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6811, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6812, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6813, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6814, 103);
INSERT INTO element_module (element_id, module_id) VALUES (6829, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6830, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6831, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6832, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6833, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6834, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6835, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6836, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6837, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6838, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6839, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6840, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6841, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6842, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6843, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6844, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6845, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6846, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6847, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6848, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6849, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6850, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6851, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6852, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6853, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6854, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6855, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6856, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6857, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6858, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6859, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6860, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6861, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6862, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6863, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6864, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6865, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6866, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6867, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6868, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6869, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6870, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6871, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6872, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6873, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6874, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6875, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6876, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6877, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6878, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6879, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6880, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6881, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6882, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6883, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6884, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6885, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6886, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6887, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6888, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6889, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6890, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6891, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6892, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6893, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6894, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6895, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6896, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6897, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6898, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6899, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6900, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6901, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6902, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6903, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6904, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6905, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6906, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6907, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6908, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6909, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6910, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6911, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6912, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6913, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6914, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6915, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6916, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6917, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6918, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6919, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6920, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6921, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6922, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6923, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6924, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6925, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6926, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6927, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6928, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6929, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6930, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6931, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6932, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6933, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6934, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6935, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6936, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6937, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6938, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6939, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6940, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6941, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6942, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6943, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6944, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6945, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6946, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6947, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6948, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6949, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6950, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6951, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6952, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6953, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6954, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6955, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6956, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6957, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6958, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6959, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6960, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6961, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6962, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6963, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6964, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6965, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6966, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6967, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6968, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6969, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6970, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6971, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6972, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6973, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6974, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6975, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6976, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6977, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6978, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6979, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6980, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6981, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6982, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6983, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6984, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6985, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6986, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6987, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6988, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6989, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6990, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6991, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6992, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6993, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6994, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6995, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6996, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6997, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6998, 104);
INSERT INTO element_module (element_id, module_id) VALUES (6999, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7000, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7001, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7002, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7003, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7004, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7005, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7006, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7007, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7008, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7009, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7010, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7011, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7012, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7013, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7014, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7015, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7016, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7017, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7018, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7019, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7020, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7021, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7022, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7023, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7024, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7025, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7026, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7027, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7028, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7029, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7030, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7031, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7032, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7033, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7034, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7035, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7036, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7037, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7038, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7039, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7040, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7041, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7042, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7043, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7044, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7045, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7046, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7047, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7048, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7049, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7050, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7051, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7052, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7053, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7054, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7055, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7056, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7057, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7058, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7059, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7060, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7061, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7062, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7063, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7064, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7065, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7066, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7067, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7068, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7069, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7070, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7071, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7072, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7073, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7074, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7075, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7076, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7077, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7078, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7079, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7080, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7081, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7082, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7083, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7084, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7085, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7086, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7087, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7088, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7089, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7090, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7091, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7092, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7093, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7094, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7095, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7096, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7097, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7098, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7099, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7100, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7101, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7102, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7103, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7104, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7105, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7106, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7107, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7108, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7109, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7110, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7111, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7112, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7113, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7114, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7115, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7116, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7117, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7118, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7119, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7120, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7121, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7122, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7123, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7124, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7125, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7126, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7127, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7128, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7129, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7130, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7131, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7132, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7133, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7134, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7135, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7136, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7137, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7138, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7139, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7140, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7141, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7142, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7143, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7144, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7145, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7146, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7147, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7148, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7149, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7150, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7151, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7152, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7153, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7154, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7155, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7156, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7157, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7158, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7159, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7160, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7161, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7162, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7163, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7164, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7165, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7166, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7167, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7168, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7169, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7170, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7171, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7172, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7173, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7174, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7175, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7176, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7177, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7178, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7179, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7180, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7181, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7182, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7183, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7184, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7185, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7186, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7187, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7188, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7189, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7190, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7191, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7192, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7193, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7194, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7195, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7196, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7197, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7198, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7199, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7200, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7201, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7202, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7203, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7204, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7205, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7206, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7207, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7208, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7209, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7210, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7211, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7212, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7213, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7214, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7215, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7216, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7217, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7218, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7219, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7220, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7221, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7222, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7223, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7224, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7225, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7226, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7227, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7228, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7229, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7230, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7231, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7232, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7233, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7234, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7235, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7236, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7237, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7238, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7239, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7240, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7241, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7242, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7243, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7244, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7245, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7246, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7247, 104);
INSERT INTO element_module (element_id, module_id) VALUES (7248, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7249, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7250, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7251, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7252, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7253, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7254, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7255, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7256, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7257, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7258, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7259, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7260, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7261, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7262, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7263, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7264, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7265, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7266, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7267, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7268, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7269, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7270, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7271, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7272, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7273, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7274, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7275, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7276, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7277, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7278, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7279, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7280, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7281, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7282, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7283, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7284, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7285, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7286, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7287, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7288, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7289, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7290, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7291, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7292, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7293, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7294, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7295, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7296, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7297, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7298, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7299, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7300, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7301, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7302, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7303, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7304, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7305, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7306, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7307, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7308, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7309, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7310, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7311, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7312, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7313, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7314, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7315, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7316, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7317, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7318, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7319, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7320, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7321, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7322, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7323, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7324, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7325, 105);
INSERT INTO element_module (element_id, module_id) VALUES (7326, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7327, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7328, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7329, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7330, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7331, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7332, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7333, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7334, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7335, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7336, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7337, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7338, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7339, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7340, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7341, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7342, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7343, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7344, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7345, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7346, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7347, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7348, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7349, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7350, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7351, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7352, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7353, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7354, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7355, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7356, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7357, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7358, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7359, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7360, 106);
INSERT INTO element_module (element_id, module_id) VALUES (7361, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7362, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7363, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7364, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7365, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7366, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7367, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7368, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7369, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7370, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7371, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7372, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7373, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7374, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7375, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7376, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7377, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7378, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7379, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7380, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7381, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7382, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7383, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7384, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7385, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7386, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7387, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7388, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7389, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7390, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7391, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7392, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7393, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7394, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7395, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7396, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7397, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7398, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7399, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7400, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7401, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7402, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7403, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7404, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7405, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7406, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7407, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7408, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7409, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7410, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7411, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7412, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7413, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7414, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7415, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7416, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7417, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7418, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7419, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7420, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7421, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7422, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7423, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7424, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7425, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7426, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7427, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7428, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7429, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7430, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7431, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7432, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7433, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7434, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7435, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7436, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7437, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7438, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7439, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7440, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7441, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7442, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7443, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7444, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7445, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7446, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7447, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7448, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7449, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7450, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7451, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7452, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7453, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7454, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7455, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7456, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7457, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7458, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7459, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7460, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7461, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7462, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7463, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7464, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7465, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7466, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7467, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7468, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7469, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7470, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7471, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7472, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7473, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7474, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7475, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7476, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7477, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7478, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7479, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7480, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7481, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7482, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7483, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7484, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7485, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7486, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7487, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7488, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7489, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7490, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7491, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7492, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7493, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7494, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7495, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7496, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7497, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7498, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7499, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7500, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7501, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7502, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7503, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7504, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7505, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7506, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7507, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7508, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7509, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7510, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7511, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7512, 107);
INSERT INTO element_module (element_id, module_id) VALUES (7513, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7514, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7515, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7516, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7517, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7518, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7519, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7520, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7521, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7522, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7523, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7524, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7525, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7526, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7527, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7528, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7529, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7530, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7531, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7532, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7533, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7534, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7535, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7536, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7537, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7538, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7539, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7540, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7541, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7542, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7543, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7544, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7545, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7546, 108);
INSERT INTO element_module (element_id, module_id) VALUES (7547, 108);
INSERT INTO element_module (element_id, module_id) VALUES (380, 109);
INSERT INTO element_module (element_id, module_id) VALUES (381, 109);
INSERT INTO element_module (element_id, module_id) VALUES (382, 109);
INSERT INTO element_module (element_id, module_id) VALUES (383, 109);
INSERT INTO element_module (element_id, module_id) VALUES (384, 109);
INSERT INTO element_module (element_id, module_id) VALUES (385, 109);
INSERT INTO element_module (element_id, module_id) VALUES (386, 109);
INSERT INTO element_module (element_id, module_id) VALUES (387, 109);
INSERT INTO element_module (element_id, module_id) VALUES (388, 109);
INSERT INTO element_module (element_id, module_id) VALUES (389, 109);
INSERT INTO element_module (element_id, module_id) VALUES (390, 109);
INSERT INTO element_module (element_id, module_id) VALUES (391, 109);
INSERT INTO element_module (element_id, module_id) VALUES (392, 109);
INSERT INTO element_module (element_id, module_id) VALUES (393, 109);
INSERT INTO element_module (element_id, module_id) VALUES (394, 109);
INSERT INTO element_module (element_id, module_id) VALUES (395, 109);
INSERT INTO element_module (element_id, module_id) VALUES (396, 109);
INSERT INTO element_module (element_id, module_id) VALUES (397, 109);
INSERT INTO element_module (element_id, module_id) VALUES (398, 109);
INSERT INTO element_module (element_id, module_id) VALUES (399, 109);
INSERT INTO element_module (element_id, module_id) VALUES (400, 109);
INSERT INTO element_module (element_id, module_id) VALUES (401, 109);
INSERT INTO element_module (element_id, module_id) VALUES (402, 109);
INSERT INTO element_module (element_id, module_id) VALUES (403, 109);
INSERT INTO element_module (element_id, module_id) VALUES (404, 109);
INSERT INTO element_module (element_id, module_id) VALUES (405, 109);
INSERT INTO element_module (element_id, module_id) VALUES (406, 109);
INSERT INTO element_module (element_id, module_id) VALUES (407, 109);
INSERT INTO element_module (element_id, module_id) VALUES (408, 109);
INSERT INTO element_module (element_id, module_id) VALUES (409, 109);
INSERT INTO element_module (element_id, module_id) VALUES (410, 109);
INSERT INTO element_module (element_id, module_id) VALUES (411, 109);
INSERT INTO element_module (element_id, module_id) VALUES (412, 109);
INSERT INTO element_module (element_id, module_id) VALUES (413, 109);
INSERT INTO element_module (element_id, module_id) VALUES (414, 109);
INSERT INTO element_module (element_id, module_id) VALUES (415, 109);
INSERT INTO element_module (element_id, module_id) VALUES (416, 109);
INSERT INTO element_module (element_id, module_id) VALUES (417, 109);
INSERT INTO element_module (element_id, module_id) VALUES (418, 109);
INSERT INTO element_module (element_id, module_id) VALUES (419, 109);
INSERT INTO element_module (element_id, module_id) VALUES (420, 109);
INSERT INTO element_module (element_id, module_id) VALUES (421, 109);
INSERT INTO element_module (element_id, module_id) VALUES (422, 109);
INSERT INTO element_module (element_id, module_id) VALUES (423, 109);
INSERT INTO element_module (element_id, module_id) VALUES (424, 109);
INSERT INTO element_module (element_id, module_id) VALUES (425, 109);
INSERT INTO element_module (element_id, module_id) VALUES (426, 109);
INSERT INTO element_module (element_id, module_id) VALUES (427, 109);
INSERT INTO element_module (element_id, module_id) VALUES (428, 109);
INSERT INTO element_module (element_id, module_id) VALUES (429, 109);
INSERT INTO element_module (element_id, module_id) VALUES (430, 109);
INSERT INTO element_module (element_id, module_id) VALUES (431, 109);
INSERT INTO element_module (element_id, module_id) VALUES (432, 109);
INSERT INTO element_module (element_id, module_id) VALUES (433, 109);
INSERT INTO element_module (element_id, module_id) VALUES (434, 109);
INSERT INTO element_module (element_id, module_id) VALUES (435, 109);
INSERT INTO element_module (element_id, module_id) VALUES (436, 109);
INSERT INTO element_module (element_id, module_id) VALUES (437, 109);
INSERT INTO element_module (element_id, module_id) VALUES (438, 109);
INSERT INTO element_module (element_id, module_id) VALUES (439, 109);
INSERT INTO element_module (element_id, module_id) VALUES (440, 109);
INSERT INTO element_module (element_id, module_id) VALUES (441, 109);
INSERT INTO element_module (element_id, module_id) VALUES (442, 109);
INSERT INTO element_module (element_id, module_id) VALUES (443, 109);
INSERT INTO element_module (element_id, module_id) VALUES (444, 109);
INSERT INTO element_module (element_id, module_id) VALUES (445, 109);
INSERT INTO element_module (element_id, module_id) VALUES (446, 109);
INSERT INTO element_module (element_id, module_id) VALUES (447, 109);
INSERT INTO element_module (element_id, module_id) VALUES (448, 109);
INSERT INTO element_module (element_id, module_id) VALUES (449, 109);
INSERT INTO element_module (element_id, module_id) VALUES (450, 109);
INSERT INTO element_module (element_id, module_id) VALUES (451, 109);
INSERT INTO element_module (element_id, module_id) VALUES (452, 109);
INSERT INTO element_module (element_id, module_id) VALUES (453, 109);
INSERT INTO element_module (element_id, module_id) VALUES (454, 109);
INSERT INTO element_module (element_id, module_id) VALUES (455, 109);
INSERT INTO element_module (element_id, module_id) VALUES (456, 109);
INSERT INTO element_module (element_id, module_id) VALUES (457, 109);
INSERT INTO element_module (element_id, module_id) VALUES (458, 109);
INSERT INTO element_module (element_id, module_id) VALUES (459, 109);
INSERT INTO element_module (element_id, module_id) VALUES (460, 109);
INSERT INTO element_module (element_id, module_id) VALUES (461, 109);
INSERT INTO element_module (element_id, module_id) VALUES (462, 109);
INSERT INTO element_module (element_id, module_id) VALUES (463, 109);
INSERT INTO element_module (element_id, module_id) VALUES (464, 109);
INSERT INTO element_module (element_id, module_id) VALUES (465, 109);
INSERT INTO element_module (element_id, module_id) VALUES (466, 109);
INSERT INTO element_module (element_id, module_id) VALUES (467, 109);
INSERT INTO element_module (element_id, module_id) VALUES (468, 109);
INSERT INTO element_module (element_id, module_id) VALUES (469, 109);
INSERT INTO element_module (element_id, module_id) VALUES (470, 109);
INSERT INTO element_module (element_id, module_id) VALUES (471, 109);
INSERT INTO element_module (element_id, module_id) VALUES (472, 109);
INSERT INTO element_module (element_id, module_id) VALUES (473, 109);
INSERT INTO element_module (element_id, module_id) VALUES (474, 109);
INSERT INTO element_module (element_id, module_id) VALUES (475, 109);
INSERT INTO element_module (element_id, module_id) VALUES (476, 109);
INSERT INTO element_module (element_id, module_id) VALUES (477, 109);
INSERT INTO element_module (element_id, module_id) VALUES (478, 109);
INSERT INTO element_module (element_id, module_id) VALUES (479, 109);
INSERT INTO element_module (element_id, module_id) VALUES (480, 109);
INSERT INTO element_module (element_id, module_id) VALUES (481, 109);
INSERT INTO element_module (element_id, module_id) VALUES (482, 109);
INSERT INTO element_module (element_id, module_id) VALUES (483, 109);
INSERT INTO element_module (element_id, module_id) VALUES (484, 109);
INSERT INTO element_module (element_id, module_id) VALUES (485, 109);
INSERT INTO element_module (element_id, module_id) VALUES (486, 109);
INSERT INTO element_module (element_id, module_id) VALUES (487, 109);
INSERT INTO element_module (element_id, module_id) VALUES (488, 109);
INSERT INTO element_module (element_id, module_id) VALUES (489, 109);
INSERT INTO element_module (element_id, module_id) VALUES (490, 109);
INSERT INTO element_module (element_id, module_id) VALUES (491, 109);
INSERT INTO element_module (element_id, module_id) VALUES (492, 109);
INSERT INTO element_module (element_id, module_id) VALUES (493, 109);
INSERT INTO element_module (element_id, module_id) VALUES (494, 109);
INSERT INTO element_module (element_id, module_id) VALUES (495, 109);
INSERT INTO element_module (element_id, module_id) VALUES (496, 109);
INSERT INTO element_module (element_id, module_id) VALUES (497, 109);
INSERT INTO element_module (element_id, module_id) VALUES (498, 109);
INSERT INTO element_module (element_id, module_id) VALUES (499, 109);
INSERT INTO element_module (element_id, module_id) VALUES (500, 109);
INSERT INTO element_module (element_id, module_id) VALUES (501, 109);
INSERT INTO element_module (element_id, module_id) VALUES (502, 109);
INSERT INTO element_module (element_id, module_id) VALUES (503, 109);
INSERT INTO element_module (element_id, module_id) VALUES (504, 109);
INSERT INTO element_module (element_id, module_id) VALUES (505, 109);
INSERT INTO element_module (element_id, module_id) VALUES (506, 109);
INSERT INTO element_module (element_id, module_id) VALUES (507, 109);
INSERT INTO element_module (element_id, module_id) VALUES (508, 109);
INSERT INTO element_module (element_id, module_id) VALUES (509, 109);
INSERT INTO element_module (element_id, module_id) VALUES (510, 109);
INSERT INTO element_module (element_id, module_id) VALUES (511, 109);
INSERT INTO element_module (element_id, module_id) VALUES (512, 109);
INSERT INTO element_module (element_id, module_id) VALUES (513, 109);
INSERT INTO element_module (element_id, module_id) VALUES (514, 109);
INSERT INTO element_module (element_id, module_id) VALUES (515, 109);
INSERT INTO element_module (element_id, module_id) VALUES (516, 109);
INSERT INTO element_module (element_id, module_id) VALUES (517, 109);
INSERT INTO element_module (element_id, module_id) VALUES (518, 109);
INSERT INTO element_module (element_id, module_id) VALUES (519, 109);
INSERT INTO element_module (element_id, module_id) VALUES (520, 109);
INSERT INTO element_module (element_id, module_id) VALUES (521, 109);
INSERT INTO element_module (element_id, module_id) VALUES (522, 109);
INSERT INTO element_module (element_id, module_id) VALUES (523, 109);
INSERT INTO element_module (element_id, module_id) VALUES (524, 109);
INSERT INTO element_module (element_id, module_id) VALUES (525, 109);
INSERT INTO element_module (element_id, module_id) VALUES (526, 109);
INSERT INTO element_module (element_id, module_id) VALUES (527, 109);
INSERT INTO element_module (element_id, module_id) VALUES (528, 109);
INSERT INTO element_module (element_id, module_id) VALUES (529, 109);
INSERT INTO element_module (element_id, module_id) VALUES (530, 109);
INSERT INTO element_module (element_id, module_id) VALUES (531, 109);
INSERT INTO element_module (element_id, module_id) VALUES (532, 109);
INSERT INTO element_module (element_id, module_id) VALUES (533, 109);
INSERT INTO element_module (element_id, module_id) VALUES (534, 109);
INSERT INTO element_module (element_id, module_id) VALUES (535, 109);
INSERT INTO element_module (element_id, module_id) VALUES (536, 109);
INSERT INTO element_module (element_id, module_id) VALUES (537, 109);
INSERT INTO element_module (element_id, module_id) VALUES (538, 109);
INSERT INTO element_module (element_id, module_id) VALUES (539, 109);
INSERT INTO element_module (element_id, module_id) VALUES (540, 109);
INSERT INTO element_module (element_id, module_id) VALUES (541, 109);
INSERT INTO element_module (element_id, module_id) VALUES (542, 109);
INSERT INTO element_module (element_id, module_id) VALUES (543, 109);
INSERT INTO element_module (element_id, module_id) VALUES (544, 109);
INSERT INTO element_module (element_id, module_id) VALUES (545, 109);
INSERT INTO element_module (element_id, module_id) VALUES (546, 109);
INSERT INTO element_module (element_id, module_id) VALUES (547, 109);
INSERT INTO element_module (element_id, module_id) VALUES (548, 109);
INSERT INTO element_module (element_id, module_id) VALUES (549, 109);
INSERT INTO element_module (element_id, module_id) VALUES (550, 109);
INSERT INTO element_module (element_id, module_id) VALUES (551, 109);
INSERT INTO element_module (element_id, module_id) VALUES (552, 109);
INSERT INTO element_module (element_id, module_id) VALUES (553, 109);
INSERT INTO element_module (element_id, module_id) VALUES (554, 109);
INSERT INTO element_module (element_id, module_id) VALUES (555, 109);
INSERT INTO element_module (element_id, module_id) VALUES (556, 109);
INSERT INTO element_module (element_id, module_id) VALUES (557, 109);
INSERT INTO element_module (element_id, module_id) VALUES (558, 109);
INSERT INTO element_module (element_id, module_id) VALUES (559, 109);
INSERT INTO element_module (element_id, module_id) VALUES (560, 109);
INSERT INTO element_module (element_id, module_id) VALUES (561, 109);
INSERT INTO element_module (element_id, module_id) VALUES (562, 109);
INSERT INTO element_module (element_id, module_id) VALUES (563, 109);
INSERT INTO element_module (element_id, module_id) VALUES (564, 109);
INSERT INTO element_module (element_id, module_id) VALUES (565, 109);
INSERT INTO element_module (element_id, module_id) VALUES (566, 109);
INSERT INTO element_module (element_id, module_id) VALUES (567, 109);
INSERT INTO element_module (element_id, module_id) VALUES (568, 109);
INSERT INTO element_module (element_id, module_id) VALUES (569, 109);
INSERT INTO element_module (element_id, module_id) VALUES (570, 109);
INSERT INTO element_module (element_id, module_id) VALUES (571, 109);
INSERT INTO element_module (element_id, module_id) VALUES (572, 109);
INSERT INTO element_module (element_id, module_id) VALUES (573, 109);
INSERT INTO element_module (element_id, module_id) VALUES (574, 109);
INSERT INTO element_module (element_id, module_id) VALUES (575, 109);
INSERT INTO element_module (element_id, module_id) VALUES (576, 109);
INSERT INTO element_module (element_id, module_id) VALUES (577, 109);
INSERT INTO element_module (element_id, module_id) VALUES (578, 109);
INSERT INTO element_module (element_id, module_id) VALUES (579, 109);
INSERT INTO element_module (element_id, module_id) VALUES (580, 109);
INSERT INTO element_module (element_id, module_id) VALUES (581, 109);
INSERT INTO element_module (element_id, module_id) VALUES (582, 109);
INSERT INTO element_module (element_id, module_id) VALUES (583, 109);
INSERT INTO element_module (element_id, module_id) VALUES (584, 109);
INSERT INTO element_module (element_id, module_id) VALUES (585, 109);
INSERT INTO element_module (element_id, module_id) VALUES (586, 109);
INSERT INTO element_module (element_id, module_id) VALUES (587, 109);
INSERT INTO element_module (element_id, module_id) VALUES (588, 109);
INSERT INTO element_module (element_id, module_id) VALUES (589, 109);
INSERT INTO element_module (element_id, module_id) VALUES (590, 109);
INSERT INTO element_module (element_id, module_id) VALUES (591, 109);
INSERT INTO element_module (element_id, module_id) VALUES (592, 109);
INSERT INTO element_module (element_id, module_id) VALUES (7548, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7549, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7550, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7551, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7552, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7553, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7554, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7555, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7556, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7557, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7558, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7559, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7560, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7561, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7562, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7563, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7564, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7565, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7566, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7567, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7568, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7569, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7570, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7571, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7572, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7573, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7574, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7575, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7576, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7577, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7578, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7579, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7580, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7581, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7582, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7583, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7584, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7585, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7586, 111);
INSERT INTO element_module (element_id, module_id) VALUES (7587, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7588, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7589, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7590, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7591, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7592, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7593, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7594, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7595, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7596, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7597, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7598, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7599, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7600, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7601, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7602, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7603, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7604, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7605, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7606, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7607, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7608, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7609, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7610, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7611, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7612, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7613, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7614, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7615, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7616, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7617, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7618, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7619, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7620, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7621, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7622, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7623, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7624, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7625, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7626, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7627, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7628, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7629, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7630, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7631, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7632, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7633, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7634, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7635, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7636, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7637, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7638, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7639, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7640, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7641, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7642, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7643, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7644, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7645, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7646, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7647, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7648, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7649, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7650, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7651, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7652, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7653, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7654, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7655, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7656, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7657, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7658, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7659, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7660, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7661, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7662, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7663, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7664, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7665, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7666, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7667, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7668, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7669, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7670, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7671, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7672, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7673, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7674, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7675, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7676, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7677, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7678, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7679, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7680, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7681, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7682, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7683, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7684, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7685, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7686, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7687, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7688, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7689, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7690, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7691, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7692, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7693, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7694, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7695, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7696, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7697, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7698, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7699, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7700, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7701, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7702, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7703, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7704, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7705, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7706, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7707, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7708, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7709, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7710, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7711, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7712, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7713, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7714, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7715, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7716, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7717, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7718, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7719, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7720, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7721, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7722, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7723, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7724, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7725, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7726, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7727, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7728, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7729, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7730, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7731, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7732, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7733, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7734, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7735, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7736, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7737, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7738, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7739, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7740, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7741, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7742, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7743, 112);
INSERT INTO element_module (element_id, module_id) VALUES (7744, 112);
INSERT INTO element_module (element_id, module_id) VALUES (16, 114);
INSERT INTO element_module (element_id, module_id) VALUES (17, 114);
INSERT INTO element_module (element_id, module_id) VALUES (18, 114);
INSERT INTO element_module (element_id, module_id) VALUES (19, 114);
INSERT INTO element_module (element_id, module_id) VALUES (20, 114);
INSERT INTO element_module (element_id, module_id) VALUES (21, 114);
INSERT INTO element_module (element_id, module_id) VALUES (22, 114);
INSERT INTO element_module (element_id, module_id) VALUES (23, 114);
INSERT INTO element_module (element_id, module_id) VALUES (24, 114);
INSERT INTO element_module (element_id, module_id) VALUES (25, 114);
INSERT INTO element_module (element_id, module_id) VALUES (26, 114);
INSERT INTO element_module (element_id, module_id) VALUES (27, 114);
INSERT INTO element_module (element_id, module_id) VALUES (28, 114);
INSERT INTO element_module (element_id, module_id) VALUES (29, 114);
INSERT INTO element_module (element_id, module_id) VALUES (30, 114);
INSERT INTO element_module (element_id, module_id) VALUES (7745, 115);
INSERT INTO element_module (element_id, module_id) VALUES (7746, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7747, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7748, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7749, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7750, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7751, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7752, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7753, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7754, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7755, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7756, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7757, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7758, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7759, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7760, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7761, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7762, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7763, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7764, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7765, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7766, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7767, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7768, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7769, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7770, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7771, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7772, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7773, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7774, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7775, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7776, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7777, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7778, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7779, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7780, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7781, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7782, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7783, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7784, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7785, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7786, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7787, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7788, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7789, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7790, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7791, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7792, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7793, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7794, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7795, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7796, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7797, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7798, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7799, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7800, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7801, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7802, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7803, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7804, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7805, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7806, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7807, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7808, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7809, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7810, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7811, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7812, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7813, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7814, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7815, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7816, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7817, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7818, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7819, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7820, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7821, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7822, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7823, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7824, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7825, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7826, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7827, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7828, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7829, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7830, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7831, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7832, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7833, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7834, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7835, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7836, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7837, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7838, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7839, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7840, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7841, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7842, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7843, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7844, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7845, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7846, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7847, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7848, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7849, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7850, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7851, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7852, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7853, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7854, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7855, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7856, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7857, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7858, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7859, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7860, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7861, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7862, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7863, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7864, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7865, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7866, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7867, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7868, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7869, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7870, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7871, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7872, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7873, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7874, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7875, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7876, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7877, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7878, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7879, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7880, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7881, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7882, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7883, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7884, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7885, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7886, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7887, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7888, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7889, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7890, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7891, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7892, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7893, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7894, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7895, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7896, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7897, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7898, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7899, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7900, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7901, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7902, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7903, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7904, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7905, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7906, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7907, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7908, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7909, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7910, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7911, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7912, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7913, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7914, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7915, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7916, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7917, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7918, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7919, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7920, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7921, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7922, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7923, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7924, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7925, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7926, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7927, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7928, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7929, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7930, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7931, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7932, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7933, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7934, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7935, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7936, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7937, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7938, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7939, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7940, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7941, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7942, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7943, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7944, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7945, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7946, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7947, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7948, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7949, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7950, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7951, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7952, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7953, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7954, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7955, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7956, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7957, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7958, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7959, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7960, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7961, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7962, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7963, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7964, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7965, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7966, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7967, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7968, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7969, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7970, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7971, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7972, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7973, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7974, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7975, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7976, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7977, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7978, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7979, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7980, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7981, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7982, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7983, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7984, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7985, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7986, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7987, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7988, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7989, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7990, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7991, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7992, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7993, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7994, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7995, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7996, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7997, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7998, 116);
INSERT INTO element_module (element_id, module_id) VALUES (7999, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8000, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8001, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8002, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8003, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8004, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8005, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8006, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8007, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8008, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8009, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8010, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8011, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8012, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8013, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8014, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8015, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8016, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8017, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8018, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8019, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8020, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8021, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8022, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8023, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8024, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8025, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8026, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8027, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8028, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8029, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8030, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8031, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8032, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8033, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8034, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8035, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8036, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8037, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8038, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8039, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8040, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8041, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8042, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8043, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8044, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8045, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8046, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8047, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8048, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8049, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8050, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8051, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8052, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8053, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8054, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8055, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8056, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8057, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8058, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8059, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8060, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8061, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8062, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8063, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8064, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8065, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8066, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8067, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8068, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8069, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8070, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8071, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8072, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8073, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8074, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8075, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8076, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8077, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8078, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8079, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8080, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8081, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8082, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8083, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8084, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8085, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8086, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8087, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8088, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8089, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8090, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8091, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8092, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8093, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8094, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8095, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8096, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8097, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8098, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8099, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8100, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8101, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8102, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8103, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8104, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8105, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8106, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8107, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8108, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8109, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8110, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8111, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8112, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8113, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8114, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8115, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8116, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8117, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8118, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8119, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8120, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8121, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8122, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8123, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8124, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8125, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8126, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8127, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8128, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8129, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8130, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8131, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8132, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8133, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8134, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8135, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8136, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8137, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8138, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8139, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8140, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8141, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8142, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8143, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8144, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8145, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8146, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8147, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8148, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8149, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8150, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8151, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8152, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8153, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8154, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8155, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8156, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8157, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8158, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8159, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8160, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8161, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8162, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8163, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8164, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8165, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8166, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8167, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8168, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8169, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8170, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8171, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8172, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8173, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8174, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8175, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8176, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8177, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8178, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8179, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8180, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8181, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8182, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8183, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8184, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8185, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8186, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8187, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8188, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8189, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8190, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8191, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8192, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8193, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8194, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8195, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8196, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8197, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8198, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8199, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8200, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8201, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8202, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8203, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8204, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8205, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8206, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8207, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8208, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8209, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8210, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8211, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8212, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8213, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8214, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8215, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8216, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8217, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8218, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8219, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8220, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8221, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8222, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8223, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8224, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8225, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8226, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8227, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8228, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8229, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8230, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8231, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8232, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8233, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8234, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8235, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8236, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8237, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8238, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8239, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8240, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8241, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8242, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8243, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8244, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8245, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8246, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8247, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8248, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8249, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8250, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8251, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8252, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8253, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8254, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8255, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8256, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8257, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8258, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8259, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8260, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8261, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8262, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8263, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8264, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8265, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8266, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8267, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8268, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8269, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8270, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8271, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8272, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8273, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8274, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8275, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8276, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8277, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8278, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8279, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8280, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8281, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8282, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8283, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8284, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8285, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8286, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8287, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8288, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8289, 116);
INSERT INTO element_module (element_id, module_id) VALUES (8290, 116);

SELECT pg_catalog.setval('id_capability_support_seq', 1, false);

SELECT pg_catalog.setval('id_capability_support_variation_seq', 1, false);

SELECT pg_catalog.setval('id_compliance_module_group_seq', 681, true);

SELECT pg_catalog.setval('id_compliance_module_object_seq', 160, true);

SELECT pg_catalog.setval('id_compliance_module_seq', 100, true);

SELECT pg_catalog.setval('id_identity_revision_seq', 261, true);

SELECT pg_catalog.setval('id_mib_element_seq', 8290, true);

SELECT pg_catalog.setval('id_mib_module_import_seq', 1190, true);

SELECT pg_catalog.setval('id_mib_module_seq', 116, true);

SELECT pg_catalog.setval('id_mib_textual_convention_seq', 199, true);

INSERT INTO mib_app_property (id_mib_app_property, value) VALUES ('tmp_folder', 'temp');
INSERT INTO mib_app_property (id_mib_app_property, value) VALUES ('snmp_list_limit', '100');
INSERT INTO mib_app_property (id_mib_app_property, value) VALUES ('max_search_result', '50');
INSERT INTO mib_app_property (id_mib_app_property, value) VALUES ('snmp_table_limit', '200');

INSERT INTO mib_compliance (id_mib_element) VALUES (340);
INSERT INTO mib_compliance (id_mib_element) VALUES (363);
INSERT INTO mib_compliance (id_mib_element) VALUES (364);
INSERT INTO mib_compliance (id_mib_element) VALUES (378);
INSERT INTO mib_compliance (id_mib_element) VALUES (923);
INSERT INTO mib_compliance (id_mib_element) VALUES (924);
INSERT INTO mib_compliance (id_mib_element) VALUES (925);
INSERT INTO mib_compliance (id_mib_element) VALUES (990);
INSERT INTO mib_compliance (id_mib_element) VALUES (991);
INSERT INTO mib_compliance (id_mib_element) VALUES (992);
INSERT INTO mib_compliance (id_mib_element) VALUES (993);
INSERT INTO mib_compliance (id_mib_element) VALUES (1053);
INSERT INTO mib_compliance (id_mib_element) VALUES (1054);
INSERT INTO mib_compliance (id_mib_element) VALUES (1085);
INSERT INTO mib_compliance (id_mib_element) VALUES (1122);
INSERT INTO mib_compliance (id_mib_element) VALUES (1123);
INSERT INTO mib_compliance (id_mib_element) VALUES (1190);
INSERT INTO mib_compliance (id_mib_element) VALUES (1191);
INSERT INTO mib_compliance (id_mib_element) VALUES (1192);
INSERT INTO mib_compliance (id_mib_element) VALUES (1193);
INSERT INTO mib_compliance (id_mib_element) VALUES (1194);
INSERT INTO mib_compliance (id_mib_element) VALUES (1195);
INSERT INTO mib_compliance (id_mib_element) VALUES (1584);
INSERT INTO mib_compliance (id_mib_element) VALUES (6338);
INSERT INTO mib_compliance (id_mib_element) VALUES (253);
INSERT INTO mib_compliance (id_mib_element) VALUES (254);
INSERT INTO mib_compliance (id_mib_element) VALUES (2025);
INSERT INTO mib_compliance (id_mib_element) VALUES (2026);
INSERT INTO mib_compliance (id_mib_element) VALUES (2150);
INSERT INTO mib_compliance (id_mib_element) VALUES (2151);
INSERT INTO mib_compliance (id_mib_element) VALUES (4980);
INSERT INTO mib_compliance (id_mib_element) VALUES (4981);
INSERT INTO mib_compliance (id_mib_element) VALUES (5122);
INSERT INTO mib_compliance (id_mib_element) VALUES (5123);
INSERT INTO mib_compliance (id_mib_element) VALUES (5297);
INSERT INTO mib_compliance (id_mib_element) VALUES (5346);
INSERT INTO mib_compliance (id_mib_element) VALUES (5407);
INSERT INTO mib_compliance (id_mib_element) VALUES (5449);
INSERT INTO mib_compliance (id_mib_element) VALUES (5534);
INSERT INTO mib_compliance (id_mib_element) VALUES (5589);
INSERT INTO mib_compliance (id_mib_element) VALUES (5790);
INSERT INTO mib_compliance (id_mib_element) VALUES (5816);
INSERT INTO mib_compliance (id_mib_element) VALUES (5828);
INSERT INTO mib_compliance (id_mib_element) VALUES (5853);
INSERT INTO mib_compliance (id_mib_element) VALUES (5902);
INSERT INTO mib_compliance (id_mib_element) VALUES (7192);
INSERT INTO mib_compliance (id_mib_element) VALUES (7193);
INSERT INTO mib_compliance (id_mib_element) VALUES (7194);
INSERT INTO mib_compliance (id_mib_element) VALUES (7195);
INSERT INTO mib_compliance (id_mib_element) VALUES (7196);
INSERT INTO mib_compliance (id_mib_element) VALUES (7197);
INSERT INTO mib_compliance (id_mib_element) VALUES (7198);
INSERT INTO mib_compliance (id_mib_element) VALUES (7199);
INSERT INTO mib_compliance (id_mib_element) VALUES (7320);
INSERT INTO mib_compliance (id_mib_element) VALUES (7357);
INSERT INTO mib_compliance (id_mib_element) VALUES (7358);
INSERT INTO mib_compliance (id_mib_element) VALUES (7500);
INSERT INTO mib_compliance (id_mib_element) VALUES (7501);
INSERT INTO mib_compliance (id_mib_element) VALUES (7727);
INSERT INTO mib_compliance (id_mib_element) VALUES (7728);
INSERT INTO mib_compliance (id_mib_element) VALUES (7729);
INSERT INTO mib_compliance (id_mib_element) VALUES (7730);
INSERT INTO mib_compliance (id_mib_element) VALUES (7731);
INSERT INTO mib_compliance (id_mib_element) VALUES (8194);
INSERT INTO mib_compliance (id_mib_element) VALUES (8195);
INSERT INTO mib_compliance (id_mib_element) VALUES (8196);
INSERT INTO mib_compliance (id_mib_element) VALUES (8197);
INSERT INTO mib_compliance (id_mib_element) VALUES (8198);
INSERT INTO mib_compliance (id_mib_element) VALUES (8199);
INSERT INTO mib_compliance (id_mib_element) VALUES (8200);
INSERT INTO mib_compliance (id_mib_element) VALUES (8201);
INSERT INTO mib_compliance (id_mib_element) VALUES (8202);
INSERT INTO mib_compliance (id_mib_element) VALUES (8203);
INSERT INTO mib_compliance (id_mib_element) VALUES (8204);
INSERT INTO mib_compliance (id_mib_element) VALUES (8205);
INSERT INTO mib_compliance (id_mib_element) VALUES (8206);
INSERT INTO mib_compliance (id_mib_element) VALUES (8207);

INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (1, 253, 'this module', 'snmpGroup, snmpSetGroup, systemGroup, snmpBasicNotificationsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (2, 254, 'this module', 'snmpGroup, snmpSetGroup, systemGroup, snmpBasicNotificationsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (3, 340, 'this module', 'ifGeneralInformationGroup, linkUpDownNotificationsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (4, 363, 'this module', 'ifGeneralGroup, ifStackGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (5, 364, 'this module', 'ifGeneralInformationGroup, ifStackGroup2, ifCounterDiscontinuityGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (6, 378, 'this module', 'snmpEngineGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (19, 923, 'this module', 'vtpBasicGroup, vtpVlanInfoGroup,  vtpStatsGroup, vtpTrunkPortGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (20, 924, 'this module', 'vtpBasicGroup, vtpVlanInfoGroup,  vtpStatsGroup, vtpTrunkPortGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (21, 925, 'this module', 'vtpBasicGroup, vtpVlanInfoGroup,  vtpStatsGroup, vtpTrunkPortGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (22, 990, 'this module', 'ciscoCdpMIBGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (23, 991, 'this module', 'ciscoCdpMIBGroupV11R01');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (24, 992, 'this module', 'ciscoCdpMIBGroupV11R02');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (25, 993, 'this module', 'ciscoCdpMIBGroupV12R02');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (26, 1053, 'this module', 'ciscoEnvMonMIBGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (27, 1054, 'this module', 'ciscoEnvMonMIBGroupRev, ciscoEnvMonMIBNotifGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (28, 1085, 'this module', 'ciscoFtpClientRequestGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (29, 1122, 'this module', 'ciscoSyslogMIBGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (30, 1123, 'this module', 'ciscoSyslogMIBGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (33, 1190, 'this module', 'applRFC1565Group');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (34, 1191, 'this module', 'applRFC1565Group, assocRFC1565Group');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (35, 1192, 'this module', 'applRFC2248Group');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (36, 1193, 'this module', 'applRFC2248Group, assocRFC2248Group');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (37, 1194, 'this module', 'applRFC2788Group');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (38, 1195, 'this module', 'applRFC2788Group, assocRFC2788Group');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (68, 6338, 'this module', 'lldpConfigGroup, lldpConfigRxGroup, lldpConfigTxGroup, lldpStatsRxGroup, lldpStatsTxGroup, lldpLocSysGroup, lldpRemSysGroup, lldpNotificationsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (42, 1584, 'this module', 'sysApplInstalledGroup, sysApplRunGroup, sysApplMapGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (44, 2025, 'this module', 'dot1dBaseBridgeGroup, dot1dBasePortGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (45, 2026, 'this module', 'dot1dBaseBridgeGroup, dot1dBasePortGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (47, 2150, 'this module', 'pBridgeExtCapGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (48, 2151, 'this module', 'pBridgeExtCapGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (49, 4980, 'this module', 'protocolDirectoryGroup, protocolDistributionGroup, addressMapGroup, nlHostGroup, nlMatrixGroup, usrHistoryGroup, probeInformationGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (50, 4981, 'this module', 'protocolDirectoryGroup, protocolDistributionGroup, addressMapGroup, nlHostGroup, nlMatrixGroup, alHostGroup, alMatrixGroup, usrHistoryGroup, probeInformationGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (51, 5122, 'this module', 'qBridgeBaseGroup, qBridgeVlanGroup, qBridgeVlanStaticGroup, qBridgePortGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (52, 5123, 'this module', 'qBridgeBaseGroup, qBridgeVlanGroup, qBridgeVlanStaticGroup, qBridgePortGroup2');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (53, 5297, 'this module', 'cfmFlowMonitorGroup, cfmFlowGroup, cfmFlowMetricsGroup, cfmFlowConditionsGroup, cfmAlarmAggregationGroup, cfmAlarmHistoryGroup, cfmNotifySupportGroup, cfmNotifyGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (54, 5346, 'this module', 'cfmIpCbrMetricsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (55, 5407, 'this module', 'cfmRtpMetricsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (56, 5449, 'this module', 'entityPhysicalGroup, entityLogicalGroup, entityMappingGroup, entityGeneralGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (57, 5534, 'this module', 'ciscoIpStatMIBGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (58, 5589, 'this module', 'ciscoNtpSysGroup, ciscoNtpPeersGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (59, 5790, 'this module', 'cseStatisticsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (60, 5816, 'this module', 'ciscoMemoryPoolGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (61, 5828, 'this module', 'ciscoCircuitInterfaceGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (62, 5853, 'this module', 'ceAssetGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (63, 5902, 'this module', 'charGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (69, 7192, 'this module', 'ccmInfoGroup, ccmPhoneInfoGroup, ccmGatewayInfoGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (70, 7193, 'this module', 'ccmInfoGroupRev1, ccmPhoneInfoGroupRev1, ccmGatewayInfoGroupRev1, ccmMediaDeviceInfoGroup, ccmGatekeeperInfoGroup, ccmCTIDeviceInfoGroup, ccmNotificationsInfoGroup, ccmNotificationsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (71, 7194, 'this module', 'ccmInfoGroupRev2, ccmPhoneInfoGroupRev2, ccmGatewayInfoGroupRev2, ccmMediaDeviceInfoGroupRev1, ccmCTIDeviceInfoGroupRev1, ccmNotificationsInfoGroupRev1, ccmNotificationsGroup, ccmH323DeviceInfoGroup, ccmVoiceMailDeviceInfoGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (72, 7195, 'this module', 'ccmInfoGroupRev3, ccmPhoneInfoGroupRev3, ccmGatewayInfoGroupRev3, ccmMediaDeviceInfoGroupRev2, ccmCTIDeviceInfoGroupRev2, ccmNotificationsInfoGroupRev2, ccmNotificationsGroupRev1, ccmH323DeviceInfoGroupRev1, ccmVoiceMailDeviceInfoGroupRev1, ccmSIPDeviceInfoGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (73, 7196, 'this module', 'ccmInfoGroupRev3, ccmPhoneInfoGroupRev4, ccmGatewayInfoGroupRev3, ccmMediaDeviceInfoGroupRev2, ccmCTIDeviceInfoGroupRev2, ccmNotificationsInfoGroupRev3, ccmNotificationsGroupRev2, ccmH323DeviceInfoGroupRev1, ccmVoiceMailDeviceInfoGroupRev1, ccmSIPDeviceInfoGroupRev1');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (74, 7197, 'this module', 'ccmInfoGroupRev4, ccmPhoneInfoGroupRev5, ccmGatewayInfoGroupRev3, ccmMediaDeviceInfoGroupRev3, ccmCTIDeviceInfoGroupRev2, ccmNotificationsInfoGroupRev4, ccmNotificationsGroupRev2, ccmH323DeviceInfoGroupRev2, ccmVoiceMailDeviceInfoGroupRev1, ccmSIPDeviceInfoGroupRev2');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (75, 7198, 'this module', 'ccmInfoGroupRev4, ccmPhoneInfoGroupRev5, ccmGatewayInfoGroupRev3, ccmMediaDeviceInfoGroupRev3, ccmCTIDeviceInfoGroupRev3, ccmNotificationsInfoGroupRev4, ccmNotificationsGroupRev2, ccmH323DeviceInfoGroupRev2, ccmVoiceMailDeviceInfoGroupRev1, ccmSIPDeviceInfoGroupRev2');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (76, 7199, 'this module', 'ccmInfoGroupRev4, ccmPhoneInfoGroupRev6, ccmGatewayInfoGroupRev4, ccmMediaDeviceInfoGroupRev4, ccmCTIDeviceInfoGroupRev4, ccmNotificationsInfoGroupRev5, ccmNotificationsGroupRev3, ccmH323DeviceInfoGroupRev3, ccmVoiceMailDeviceInfoGroupRev2, ccmSIPDeviceInfoGroupRev2');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (77, 7320, 'this module', NULL);
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (78, 7357, 'this module', 'ciscoIsdnMibGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (79, 7358, 'this module', 'ciscoIsdnMibGroupRev1');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (80, 7500, 'this module', 'ciscoRasCapacityGroup, ciscoRasResourceUsageGroup, ciscoRasActivityGroup, ciscoRasMandatoryFailureGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (81, 7501, 'this module', 'ciscoRasCapacityGroup, ciscoRasResourceUsageGroup, ciscoRasActivityGroup, ciscoRasActivityGroupRev1, ciscoRasMandatoryFailureGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (82, 7727, 'this module', 'ciscoFrMIBGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (83, 7728, 'this module', 'ciscoFrMIBGroupRev1');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (84, 7729, 'this module', 'ciscoFrLmiMIBGroup, ciscoFrCircuitMIBGroup, ciscoExtCircuitMIBGroup, ciscoFrTsMIBGroup, ciscoFrMapMIBGroup, ciscoFrSvcMIBGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (85, 7730, 'this module', 'ciscoFrLmiMIBGroup, ciscoFrCircuitMIBGroup, ciscoExtCircuitMIBGroup, ciscoFrTsMIBGroup, ciscoFrMapMIBGroup, ciscoFrSvcMIBGroup, ciscoFrElmiMIBGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (86, 7731, 'this module', 'ciscoFrLmiMIBGroup, ciscoFrCircuitMIBGroup, ciscoExtCircuitMIBGroup1, ciscoFrTsMIBGroup, ciscoFrMapMIBGroup, ciscoFrSvcMIBGroup, ciscoFrElmiMIBGroup1, ciscoFrFragMIBGroup, ciscoFrConnMIBGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (87, 8194, 'this module', 'cbQosServicePolicyGroup, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroup, cbQosREDCfgGroup, cbQosREDClassCfgGroup, cbQosPoliceCfgGroup, cbQosTSCfgGroup, cbQosSetCfgGroup, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (88, 8195, 'this module', 'cbQosServicePolicyGroup, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev1, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev1, cbQosPoliceCfgGroupRev1, cbQosTSCfgGroup, cbQosSetCfgGroup, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (89, 8196, 'this module', 'cbQosServicePolicyGroup, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev1, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev1, cbQosPoliceCfgGroupRev2, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (90, 8197, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev1, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev1, cbQosPoliceCfgGroupRev2, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (91, 8198, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev1, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev1, cbQosPoliceCfgGroupRev2, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (92, 8199, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev1, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev1, cbQosPoliceCfgGroupRev2, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (93, 8200, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev2, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev2, cbQosPoliceCfgGroupRev3, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup, cbQosQueueingClassCfgGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (94, 8201, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev2, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev2, cbQosPoliceCfgGroupRev3, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup, cbQosQueueingClassCfgGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (95, 8202, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev2, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev2, cbQosPoliceCfgGroupRev3, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup, cbQosQueueingClassCfgGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (96, 8203, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev2, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev2, cbQosPoliceCfgGroupRev3, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup, cbQosQueueingClassCfgGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (97, 8204, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev2, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev2, cbQosPoliceCfgGroupRev3, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup, cbQosQueueingClassCfgGroup');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (98, 8205, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev2, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev2, cbQosPoliceCfgGroupRev3, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup, cbQosQueueingClassCfgGroup, cbQos421XRCfgExt');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (99, 8206, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev2, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev2, cbQosPoliceCfgGroupRev3, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup, cbQosQueueingClassCfgGroup, cbQos421XRCfgExt, cbQosBitRateExt');
INSERT INTO mib_compliance_module (id_compliance_module, id_mib_element, name, mandatory_groups) VALUES (100, 8207, 'this module', 'cbQosServicePolicyGroupRev1, cbQosObjectsGroup, cbQosPolicyMapCfgGroup, cbQosClassMapCfgGroup, cbQosMatchStmtCfgGroup, cbQosQueueingCfgGroupRev2, cbQosREDDscpCfgGroup, cbQosREDCfgGroupRev1, cbQosREDClassCfgGroupRev2, cbQosPoliceCfgGroupRev3, cbQosTSCfgGroup, cbQosSetCfgGroupRev1, cbQosClassMapStatsGroup, cbQosMatchStmtStatsGroup, cbQosPoliceStatsGroup, cbQosQueueingStatsGroup, cbQosTSStatsGroup, cbQosREDClassStatsGroup, cbQosQueueingClassCfgGroup, cbQos421XRCfgExt, cbQosBitRateExt');

INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (1, 1, 'snmpCommunityGroup', 'This group is mandatory for SNMPv2 entities which support community-based authentication.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (2, 2, 'snmpWarmStartNotificationGroup', 'This group is mandatory for an SNMP entity which supports command responder applications, and is able to reinitialize itself such that its configuration is unaltered.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (3, 2, 'snmpCommunityGroup', 'This group is mandatory for SNMP entities which support community-based authentication.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (4, 3, 'ifRcvAddressGroup', 'The applicability of this group MUST be defined by the media-specific MIBs. Media-specific MIBs must define the exact meaning, use, and semantics of the addresses in this group.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (5, 3, 'ifFixedLengthGroup', 'This group is mandatory for those network interfaces which are character-oriented or transmit data in fixed-length transmission units, and for which the value of the corresponding instance of ifSpeed is less than or equal to 20,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (6, 3, 'ifVHCPacketGroup', 'This group is mandatory only for those network interfaces which are packet-oriented and for which the value of the corresponding instance of ifSpeed is greater than 650,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (7, 3, 'ifHCFixedLengthGroup', 'This group is mandatory for those network interfaces which are character-oriented or transmit data in fixed-length transmission units, and for which the value of the corresponding instance of ifSpeed is greater than 20,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (8, 3, 'ifCounterDiscontinuityGroup', 'This group is mandatory for those network interfaces that are required to maintain counters (i.e., those for which one of the ifFixedLengthGroup, ifHCFixedLengthGroup, ifPacketGroup, ifHCPacketGroup, or ifVHCPacketGroup is mandatory).');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (9, 3, 'ifPacketGroup', 'This group is mandatory for those network interfaces which are packet-oriented, and for which the value of the corresponding instance of ifSpeed is less than or equal to 20,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (10, 3, 'ifHCPacketGroup', 'This group is mandatory only for those network interfaces which are packet-oriented and for which the value of the corresponding instance of ifSpeed is greater than 20,000,000 bits/second but less than or equal to 650,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (11, 4, 'ifPacketGroup', 'This group is mandatory for all network interfaces which are packet-oriented.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (12, 4, 'ifHCFixedLengthGroup', 'This group is mandatory only for those network interfaces which are character-oriented or transmit data in fixed- length transmission units, and for which the value of the corresponding instance of ifSpeed is greater than 20,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (13, 4, 'ifFixedLengthGroup', 'This group is mandatory for all network interfaces which are character-oriented or transmit data in fixed-length transmission units.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (14, 4, 'ifTestGroup', 'This group is optional. Media-specific MIBs which require interface tests are strongly encouraged to use this group for invoking tests and reporting results. A medium specific MIB which has mandatory tests may make implementation of this group mandatory.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (15, 4, 'ifRcvAddressGroup', 'The applicability of this group MUST be defined by the media-specific MIBs. Media-specific MIBs must define the exact meaning, use, and semantics of the addresses in this group.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (16, 4, 'ifHCPacketGroup', 'This group is mandatory only for those network interfaces which are packet-oriented and for which the value of the corresponding instance of ifSpeed is greater than 650,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (17, 5, 'ifHCFixedLengthGroup', 'This group is mandatory only for those network interfaces which are character-oriented or transmit data in fixed- length transmission units, and for which the value of the corresponding instance of ifSpeed is greater than 20,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (18, 5, 'ifRcvAddressGroup', 'The applicability of this group MUST be defined by the media-specific MIBs. Media-specific MIBs must define the exact meaning, use, and semantics of the addresses in this group.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (19, 5, 'ifPacketGroup', 'This group is mandatory for all network interfaces which are packet-oriented.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (20, 5, 'ifHCPacketGroup', 'This group is mandatory only for those network interfaces which are packet-oriented and for which the value of the corresponding instance of ifSpeed is greater than 650,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (21, 5, 'ifFixedLengthGroup', 'This group is mandatory for all network interfaces which are character-oriented or transmit data in fixed-length transmission units.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (82, 19, 'vtpVlanInfoEditGroup', 'This group must be implemented by VTP Servers. VTP Clients need not implement these objects, and must not allow VLANs to be created, modified, or destroyed using these objects.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (83, 20, 'vtpVlanInfoEditGroup', 'This group must be implemented by VTP Servers. VTP Clients need not implement these objects, and must not allow VLANs to be created, modified, or destroyed using these objects.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (84, 20, 'vtp4kVlanGroup', 'This group must be implemented by the VTP Servers which support the range of VlanIndex between 1024 and 4095.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (85, 21, 'vtpDot1qTunnelGroup', 'This group is mandatory for all the ports which implement dot1qtunnel feature.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (86, 21, 'vtp4kVlanGroup', 'This group must be implemented by the VTP Servers which support the range of VlanIndex between 1024 and 4095.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (87, 21, 'vtpVlanInfoEditGroup', 'This group must be implemented by VTP Servers. VTP Clients need not implement these objects, and must not allow VLANs to be created, modified, or destroyed using these objects.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (88, 27, 'ciscoEnvMonEnableStatChangeGroup', 'The ciscoEnvMonEnableStatChangeGroup is optional. This group is applicable for implementations which need status change notifications for environmental monitoring.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (89, 27, 'ciscoEnvMonStatChangeNotifGroup', 'The ciscoEnvMonStatChangeNotifGroup is optional. This group is applicable for implementations which need status change notifications for environmental monitoring.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (90, 30, 'clogServerGroup', 'The implementation of this group is mandatory for those systems where configuration of remote syslog server hosts is supported.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (91, 30, 'clogNotificationsGroup', 'The implementation of this group is mandatory for those systems where syslog notification is supported.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (92, 30, 'clogOriginIDGroup', 'The implementation of this group is mandatory for those systems where syslog origin identifier is supported.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (136, 51, 'qBridgeLearningConstraintDefaultGroup', 'This group is mandatory for devices implementing both Independent VLAN Learning (IVL) and Shared VLAN Learning (SVL) modes of operation of the filtering database, as defined by IEEE 802.1Q.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (137, 51, 'qBridgeServiceRequirementsGroup', 'This group is mandatory for bridges that implement extended filtering services. All objects must be read-write if extended-filtering services are enabled.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (138, 51, 'qBridgeFdbStaticGroup', 'This group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (139, 51, 'qBridgeVlanHCStatisticsGroup', 'This group is optional as there may be significant implementation cost associated with its support. It is most relevant for high-capacity interfaces.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (140, 51, 'qBridgeFdbMulticastGroup', 'This group is mandatory for bridges that implement 802.1Q transparent bridging.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (141, 51, 'qBridgeVlanStatisticsGroup', 'This group is optional as there may be significant implementation cost associated with its support.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (99, 44, 'dot1dTpBridgeGroup', 'Implementation of this group is mandatory for bridges that support the transparent bridging mode. A transparent or SRT bridge will implement this group.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (100, 44, 'dot1dStpBridgeGroup', 'Implementation of this group is mandatory for bridges that support the Spanning Tree Protocol.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (101, 44, 'dot1dStpPortGroup', 'Implementation of this group is mandatory for bridges that support the Spanning Tree Protocol.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (102, 44, 'dot1dStaticGroup', 'Implementation of this group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (103, 44, 'dot1dNotificationGroup', 'Implementation of this group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (104, 44, 'dot1dTpGroup', 'Implementation of this group is mandatory for bridges  that support the transparent bridging mode. A transparent or SRT bridge will implement this group.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (105, 44, 'dot1dTpFdbGroup', 'Implementation of this group is mandatory for bridges that support the transparent bridging mode. A transparent or SRT bridge will implement this group.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (106, 45, 'dot1dStaticGroup', 'Implementation of this group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (107, 45, 'dot1dTpFdbGroup', 'Implementation of this group is mandatory for bridges that support the transparent bridging mode. A transparent or SRT bridge will implement this group.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (108, 45, 'dot1dStpPortGroup3', 'Implementation of this group is mandatory for bridges that support the Spanning Tree Protocol and 32-bit path costs. In particular, this includes devices supporting IEEE 802.1t and IEEE 802.1w.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (109, 45, 'dot1dStpBridgeGroup', 'Implementation of this group is mandatory for bridges that support the Spanning Tree Protocol.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (110, 45, 'dot1dTpGroup', 'Implementation of this group is mandatory for bridges that support the transparent bridging mode. A transparent or SRT bridge will implement this group.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (111, 45, 'dot1dNotificationGroup', 'Implementation of this group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (112, 45, 'dot1dTpBridgeGroup', 'Implementation of this group is mandatory for bridges that support the transparent bridging mode. A transparent or SRT bridge will implement this group.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (113, 45, 'dot1dStpPortGroup2', 'Implementation of this group is mandatory for bridges that support the Spanning Tree Protocol.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (114, 47, 'pBridgeDefaultPriorityGroup', 'This group is mandatory only for devices supporting the priority forwarding operations defined by the extended bridge services with media types, such as Ethernet, that do not support native User Priority.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (115, 47, 'pBridgeDevicePriorityGroup', 'This group is mandatory only for devices supporting the priority forwarding operations defined by IEEE 802.1D.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (116, 47, 'pBridgePriorityGroup', 'This group is mandatory only for devices supporting the priority forwarding operations defined by IEEE 802.1D.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (117, 47, 'pBridgePortGarpGroup', 'This group is mandatory for devices supporting any of the GARP applications: e.g., GMRP, defined by the extended filtering services of 802.1D; or GVRP, defined by 802.1Q (refer to the Q-BRIDGE-MIB for conformance statements for GVRP).');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (118, 47, 'pBridgePortGmrpGroup', 'This group is mandatory for devices supporting the GMRP application, as defined by IEEE 802.1D Extended Filtering Services.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (119, 47, 'pBridgeDeviceGmrpGroup', 'This group is mandatory for devices supporting the GMRP application, defined by IEEE 802.1D Extended Filtering Services.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (120, 47, 'pBridgeAccessPriorityGroup', 'This group is optional and is relevant only for devices supporting the priority forwarding operations defined by  IEEE 802.1D and that have interface media types that support native Access Priority, e.g., IEEE 802.5.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (121, 47, 'pBridgePortOverflowGroup', 'Support for this group in a device is mandatory for those bridge ports that map to network interfaces that have the value of the corresponding instance of ifSpeed greater than 650,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (122, 47, 'pBridgeRegenPriorityGroup', 'This group is mandatory only for devices supporting the priority forwarding operations defined by IEEE 802.1D and that have interface media types that support native User Priority, e.g., IEEE 802.5.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (123, 47, 'pBridgeHCPortGroup', 'Support for this group in a device is mandatory for those bridge ports that map to network interfaces that have the value of the corresponding instance of ifSpeed greater than 650,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (124, 48, 'pBridgeRegenPriorityGroup', 'This group is mandatory only for devices supporting the priority forwarding operations defined by IEEE 802.1D and that have interface media types that support native User Priority, e.g., IEEE 802.5.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (125, 48, 'pBridgeDevicePriorityGroup', 'This group is mandatory only for devices supporting the priority forwarding operations defined by IEEE 802.1D.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (126, 48, 'pBridgePortGmrpGroup2', 'This group is mandatory for devices supporting the GMRP application, as defined by IEEE 802.1D Extended Filtering Services.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (127, 48, 'pBridgeHCPortGroup', 'Support for this group in a device is mandatory for those bridge ports that map to network interfaces that have the value of the corresponding instance of ifSpeed greater than 650,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (128, 48, 'pBridgePriorityGroup', 'This group is mandatory only for devices supporting the priority forwarding operations defined by IEEE 802.1D.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (129, 48, 'pBridgeAccessPriorityGroup', 'This group is optional and is relevant only for devices supporting the priority forwarding operations defined by IEEE 802.1D and that have interface media types that support native Access Priority, e.g., IEEE 802.5.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (130, 48, 'pBridgeDeviceGmrpGroup', 'This group is mandatory for devices supporting the GMRP application, defined by IEEE 802.1D Extended Filtering Services.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (131, 48, 'pBridgePortGarpGroup', 'This group is mandatory for devices supporting any of the GARP applications: e.g., GMRP, defined by the extended filtering services of 802.1D; or GVRP, defined by 802.1Q (refer to the Q-BRIDGE-MIB for conformance statements for GVRP).');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (132, 48, 'pBridgePortOverflowGroup', 'Support for this group in a device is mandatory for those bridge ports that map to network interfaces that have the value of the corresponding instance of ifSpeed greater than 650,000,000 bits/second.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (133, 48, 'pBridgeDefaultPriorityGroup', 'This group is mandatory only for devices supporting the priority forwarding operations defined by the extended bridge services with media types, such as Ethernet, that do not support native User Priority.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (134, 49, 'rmon1EnhancementGroup', 'The rmon1EnhancementGroup is mandatory for systems which implement RMON [RFC1757]');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (135, 50, 'rmon1EnhancementGroup', 'The rmon1EnhancementGroup is mandatory for systems which implement RMON [RFC1757]');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (142, 51, 'qBridgeVlanStatisticsOverflowGroup', 'This group is optional as there may be significant implementation cost associated with its support. It is most relevant for high-capacity interfaces where the SNMP agent supports only SNMPv1.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (143, 51, 'qBridgeFdbUnicastGroup', 'This group is mandatory for bridges that implement 802.1Q transparent bridging.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (144, 51, 'qBridgeLearningConstraintsGroup', 'This group is mandatory for devices implementing both Independent VLAN Learning (IVL) and Shared VLAN Learning (SVL) modes of operation of the filtering database, as defined by IEEE 802.1Q.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (145, 52, 'qBridgeClassificationDeviceGroup', 'This group is mandatory ONLY for devices implementing VLAN Classification as specified in IEEE 802.1v.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (146, 52, 'qBridgeFdbUnicastGroup', 'This group is mandatory for bridges that implement 802.1Q transparent bridging.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (147, 52, 'qBridgeVlanStatisticsGroup', 'This group is optional as there may be significant implementation cost associated with its support.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (148, 52, 'qBridgeFdbStaticGroup', 'This group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (149, 52, 'qBridgeLearningConstraintDefaultGroup', 'This group is mandatory for devices implementing both Independent VLAN Learning (IVL) and Shared VLAN Learning (SVL) modes of operation of the filtering database, as defined by IEEE 802.1Q.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (150, 52, 'qBridgeVlanHCStatisticsGroup', 'This group is optional as there may be significant implementation cost associated with its support. It is most relevant for high-capacity interfaces.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (151, 52, 'qBridgeServiceRequirementsGroup', 'This group is mandatory for bridges that implement extended filtering services. All objects must be read-write if extended-filtering services are enabled.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (152, 52, 'qBridgeFdbMulticastGroup', 'This group is mandatory for bridges that implement 802.1Q transparent bridging.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (153, 52, 'qBridgeClassificationPortGroup', 'This group is mandatory ONLY for devices implementing VLAN Classification as specified in IEEE 802.1v.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (154, 52, 'qBridgeVlanStatisticsOverflowGroup', 'This group is optional as there may be significant implementation cost associated with its support. It is most relevant for high-capacity interfaces where the SNMP agent supports only SNMPv1.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (155, 52, 'qBridgeLearningConstraintsGroup', 'This group is mandatory for devices implementing both Independent VLAN Learning (IVL) and Shared VLAN Learning (SVL) modes of operation of the filtering database, as defined by IEEE 802.1Q.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (156, 58, 'ciscoNtpFilterGroup', 'This group is required only if the clock-filer algorithms defined in RFC-1305, Section 4 are implemented by the agent.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (157, 59, 'cseFlowMgmtGroup', 'This group is mandatory only for those switches which support layer 3 switching in the system.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (158, 59, 'cseUcastCachePurgeGroup', 'This group is mandatory only for those switches which supports IP/IPX unicast flow cache purging in the system.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (159, 59, 'cseVlanStatisticsGroup', 'This group is mandatory only for those switches which can provide per-vlan statistics.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (160, 59, 'cseRouterGroup', 'This group is mandatory only for those switches which support layer 3 switching in the system.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (161, 59, 'cseMcastCachePurgeGroup', 'This group is mandatory only for those switches which supports IP multicast flow cache purging in the system.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (162, 59, 'cseFlowMcastMgmtGroup', 'This group is mandatory only for those switches which support layer 3 IP multicast switching in the system.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (171, 80, 'ciscoRasSecurityGroup', 'This group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (172, 80, 'ciscoRasNotificationsGroup', 'This group is mandatory if and only if the SNMP agent on the managed entity implements the group ''ciscoRasThresholdsGroup''.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (173, 80, 'ciscoRasOptionalFailureGroup', 'This group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (174, 80, 'ciscoRasGrpActivityGroup', 'This group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (175, 80, 'ciscoRasThresholdsGroup', 'This group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (176, 80, 'ciscoRasNotificationCntlGroup', 'This group is mandatory if and only if the SNMP agent on the managed entity implements the group ''ciscoRasNotificationsGroup''.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (177, 81, 'ciscoRasOptionalFailureGroup', 'This group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (178, 81, 'ciscoRasGrpActivityGroup', 'This group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (179, 81, 'ciscoRasSecurityGroup', 'This group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (180, 81, 'ciscoRasNotificationCntlGroup', 'This group is mandatory if and only if the SNMP agent on the managed entity implements the group ''ciscoRasNotificationsGroup''.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (181, 81, 'ciscoRasThresholdsGroup', 'This group is optional.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (182, 81, 'ciscoRasNotificationsGroup', 'This group is mandatory if and only if the SNMP agent on the managed entity implements the group ''ciscoRasThresholdsGroup''.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (183, 87, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (184, 87, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (185, 87, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (186, 87, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (187, 87, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (188, 87, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (189, 88, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (190, 88, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (191, 88, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (192, 88, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (193, 88, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (194, 88, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (195, 89, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (196, 89, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (197, 89, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (198, 89, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (199, 89, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (200, 89, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (201, 89, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (202, 89, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (203, 89, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (204, 89, 'cbQosNewSetCfgGroup', 'This group is only available on platforms that supporting SET L2 Cos config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (205, 89, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (206, 89, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (207, 89, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (208, 89, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (209, 89, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (210, 89, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (211, 89, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (212, 89, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (213, 89, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (214, 89, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (215, 89, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (216, 89, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (217, 90, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (218, 90, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (219, 90, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (220, 90, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (221, 90, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (222, 90, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (223, 90, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (224, 90, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (225, 90, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (226, 90, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (227, 90, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (228, 90, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (229, 90, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (230, 90, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (231, 90, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (232, 90, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (233, 90, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (234, 90, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (235, 90, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (236, 90, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (237, 90, 'cbQosNewSetCfgGroup', 'This group is only available on platforms that supporting SET L2 Cos config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (238, 90, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (239, 90, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (240, 90, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (241, 90, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (242, 90, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (243, 90, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (244, 90, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (245, 90, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (246, 90, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (247, 90, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (248, 90, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (249, 90, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (250, 90, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (251, 90, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (252, 90, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (253, 91, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (254, 91, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (255, 91, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (256, 91, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (257, 91, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (258, 91, 'cbQosNewSetCfgGroup', 'This group is only available on platforms that supporting SET L2 Cos config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (259, 91, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (260, 91, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (261, 91, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (262, 91, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (263, 91, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (264, 91, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (265, 91, 'cbQosMeasureIPSLACfgGroup', 'Optional objects to configure IPSLA measure action.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (266, 91, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (267, 91, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (268, 91, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (269, 91, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (270, 91, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (271, 91, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (272, 91, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (273, 91, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (274, 91, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (275, 91, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (276, 91, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (277, 91, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (278, 91, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (279, 91, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (280, 91, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (281, 91, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (282, 91, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (283, 91, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (284, 91, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (285, 91, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (286, 91, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (287, 91, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (288, 91, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (289, 91, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (290, 92, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (291, 92, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (292, 92, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (293, 92, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (294, 92, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (295, 92, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (296, 92, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (297, 92, 'cbQosNewSetCfgGroup', 'This group is only available on platforms that supporting SET L2 Cos config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (298, 92, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (299, 92, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (300, 92, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (301, 92, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (302, 92, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (303, 92, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (304, 92, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (305, 92, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (306, 92, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (307, 92, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (308, 92, 'cbQosTSCfgExtGroup', 'This group is applicable for those platforms that support shape rate greater than maximum value reportable by cbQosTSCfgRate.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (309, 92, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (310, 92, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (311, 92, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (312, 92, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (313, 92, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (314, 92, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (315, 92, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (316, 92, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (317, 92, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (318, 92, 'cbQosMeasureIPSLACfgGroup', 'Optional objects to configure IPSLA measure action.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (319, 92, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (320, 92, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (321, 92, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (322, 92, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (323, 92, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (324, 92, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (325, 92, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (326, 92, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (327, 92, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (328, 93, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (329, 93, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (330, 93, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (331, 93, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (332, 93, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (333, 93, 'cbQosSetCfgL2Group', 'This group is only available on platforms that supporting SET L2 Cos or SET L2 Cos Inner config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (334, 93, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (335, 93, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (336, 93, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (337, 93, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (338, 93, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (339, 93, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (340, 93, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (341, 93, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (342, 93, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (343, 93, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (344, 93, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (345, 93, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (346, 93, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (347, 93, 'cbQosTSCfgExtGroup', 'This group is applicable for those platforms that support shape rate greater than maximum value reportable by cbQosTSCfgRate.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (348, 93, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (349, 93, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (350, 93, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (351, 93, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (352, 93, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (353, 93, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (354, 93, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (355, 93, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (356, 93, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (357, 93, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (358, 93, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (359, 93, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (360, 93, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (361, 93, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (362, 93, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (363, 93, 'cbQosServicePolicyExtGroup', 'Optional objects to provide more information about a particular service policy instance.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (364, 93, 'cbQosMeasureIPSLACfgGroup', 'Optional objects to configure IPSLA measure action.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (365, 93, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (366, 93, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (367, 94, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (368, 94, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (369, 94, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (370, 94, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (371, 94, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (372, 94, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (373, 94, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (374, 94, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (375, 94, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (376, 94, 'cbQosServicePolicyExtGroup', 'Optional objects to provide more information about a particular service policy instance.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (377, 94, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (378, 94, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (379, 94, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (380, 94, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (381, 94, 'cbQosC3plAccountStatsGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (382, 94, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (383, 94, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (384, 94, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (385, 94, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (386, 94, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (387, 94, 'cbQosTSCfgExtGroup', 'This group is applicable for those platforms that support shape rate greater than maximum value reportable by cbQosTSCfgRate.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (388, 94, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (389, 94, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (390, 94, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (391, 94, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (392, 94, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (393, 94, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (394, 94, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (395, 94, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (396, 94, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (397, 94, 'cbQosMeasureIPSLACfgGroup', 'Optional objects to configure IPSLA measure action.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (398, 94, 'cbQosC3plAccountCfgGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (399, 94, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (400, 94, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (401, 94, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (402, 94, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (403, 94, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (404, 94, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (405, 94, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (406, 94, 'cbQosSetCfgL2Group', 'This group is only available on platforms that supporting SET L2 Cos or SET L2 Cos Inner config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (407, 94, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (408, 95, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (409, 95, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (410, 95, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (411, 95, 'cbQosC3plAccountStatsGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (412, 95, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (413, 95, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (414, 95, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (415, 95, 'cbQosC3plAccountCfgGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (416, 95, 'cbQosMeasureIPSLACfgGroup', 'Optional objects to configure IPSLA measure action.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (417, 95, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (418, 95, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (419, 95, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (420, 95, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (421, 95, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (422, 95, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (423, 95, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (424, 95, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (425, 95, 'cbQosSetCfgFrDeGroup', 'Optional group providing information on frame-relay discard bit in frame-relay header on platforms supporting frame-relay.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (426, 95, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (427, 95, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (428, 95, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (429, 95, 'cbQosSetCfgL2Group', 'This group is only available on platforms that supporting SET L2 Cos or SET L2 Cos Inner config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (430, 95, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (431, 95, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (432, 95, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (433, 95, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (434, 95, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (435, 95, 'cbQosServicePolicyExtGroup', 'Optional objects to provide more information about a particular service policy instance.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (436, 95, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (437, 95, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (438, 95, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (439, 95, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (440, 95, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (441, 95, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (442, 95, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (443, 95, 'cbQosTSCfgExtGroup', 'This group is applicable for those platforms that support shape rate greater than maximum value reportable by cbQosTSCfgRate.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (444, 95, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (445, 95, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (446, 95, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (447, 95, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (448, 95, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (449, 95, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (450, 96, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (451, 96, 'cbQosTSCfgExtGroup', 'This group is applicable for those platforms that support shape rate greater than maximum value reportable by cbQosTSCfgRate.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (452, 96, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (453, 96, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (454, 96, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (455, 96, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (456, 96, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (457, 96, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (458, 96, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (459, 96, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (460, 96, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (461, 96, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (462, 96, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (463, 96, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (464, 96, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (465, 96, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (466, 96, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (467, 96, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (468, 96, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (469, 96, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (470, 96, 'cbQosC3plAccountCfgGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (471, 96, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (472, 96, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (473, 96, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (474, 96, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (475, 96, 'cbQosMeasureIPSLACfgGroup', 'Optional objects to configure IPSLA measure action.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (476, 96, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (477, 96, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (478, 96, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (479, 96, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (480, 96, 'cbQosFragmentGroup', 'This group is only available on platforms supporting service fragment.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (481, 96, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (482, 96, 'cbQosServicePolicyExtGroup', 'Optional objects to provide more information about a particular service policy instance.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (483, 96, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (484, 96, 'cbQosSetCfgL2Group', 'This group is only available on platforms that supporting SET L2 Cos or SET L2 Cos Inner config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (485, 96, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (486, 96, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (487, 96, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (488, 96, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (489, 96, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (490, 96, 'cbQosC3plAccountStatsGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (491, 96, 'cbQosEVCGroup', 'This group is only available on platforms supporting EVC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (492, 96, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (493, 97, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (494, 97, 'cbQosIPHCCfgExt', 'This group is only available on platforms supporting policy action IPHC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (495, 97, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (496, 97, 'cbQosMeasureIPSLACfgGroup', 'Optional objects to configure IPSLA measure action.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (497, 97, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (498, 97, 'cbQosIPHCStatsExt', 'This group is only available on platforms supporting IPHC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (499, 97, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (500, 97, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (501, 97, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (502, 97, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (503, 97, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (504, 97, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (505, 97, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (506, 97, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (507, 97, 'cbQosC3plAccountCfgGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (508, 97, 'cbQosEVCGroup', 'This group is only available on platforms supporting EVC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (509, 97, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (510, 97, 'cbQosPoliceColorStatsExt', 'This group is only available on platforms supporting police color aware feature.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (511, 97, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (512, 97, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (513, 97, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (514, 97, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (515, 97, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (516, 97, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (517, 97, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (518, 97, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (519, 97, 'cbQosTSCfgExtGroup', 'This group is applicable for those platforms that support shape rate greater than maximum value reportable by cbQosTSCfgRate.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (520, 97, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (521, 97, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (522, 97, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (523, 97, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (524, 97, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (525, 97, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (526, 97, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (527, 97, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (528, 97, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (529, 97, 'cbQosServicePolicyExtGroup', 'Optional objects to provide more information about a particular service policy instance.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (530, 97, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (531, 97, 'cbQosC3plAccountStatsGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (532, 97, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (533, 97, 'cbQosSetCfgL2Group', 'This group is only available on platforms that supporting SET L2 Cos or SET L2 Cos Inner config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (534, 97, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (535, 97, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (536, 97, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (537, 97, 'cbQosSetCfgExt', 'This group is only available on platforms supporting marking on dei and tunnel.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (538, 97, 'cbQosFragmentGroup', 'This group is only available on platforms supporting service fragment.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (539, 97, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (540, 98, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (541, 98, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (542, 98, 'cbQosFragmentGroup', 'This group is only available on platforms supporting service fragment.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (543, 98, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (544, 98, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (545, 98, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (546, 98, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (547, 98, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (548, 98, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (549, 98, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (550, 98, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (551, 98, 'cbQosTSCfgExtGroup', 'This group is applicable for those platforms that support shape rate greater than maximum value reportable by cbQosTSCfgRate.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (552, 98, 'cbQosSetCfgExt', 'This group is only available on platforms supporting marking on dei and tunnel.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (553, 98, 'cbQosMeasureIPSLACfgGroup', 'Optional objects to configure IPSLA measure action.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (554, 98, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (555, 98, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (556, 98, 'cbQosEVCGroup', 'This group is only available on platforms supporting EVC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (557, 98, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (558, 98, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (559, 98, 'cbQosIPHCStatsExt', 'This group is only available on platforms supporting IPHC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (560, 98, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (561, 98, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (562, 98, 'cbQosSetCfgL2Group', 'This group is only available on platforms that supporting SET L2 Cos or SET L2 Cos Inner config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (563, 98, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (564, 98, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (565, 98, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (566, 98, 'cbQosPoliceColorStatsExt', 'This group is only available on platforms supporting police color aware feature.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (567, 98, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (568, 98, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (569, 98, 'cbQosServicePolicyExtGroup', 'Optional objects to provide more information about a particular service policy instance.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (570, 98, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (571, 98, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (572, 98, 'cbQosIPHCCfgExt', 'This group is only available on platforms supporting policy action IPHC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (573, 98, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (574, 98, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (575, 98, 'cbQosC3plAccountStatsGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (576, 98, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (577, 98, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (578, 98, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (579, 98, 'cbQosC3plAccountCfgGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (580, 98, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (581, 98, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (582, 98, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (583, 98, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (584, 98, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (585, 98, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (586, 98, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (587, 99, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (588, 99, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (589, 99, 'cbQosSetCfgL2Group', 'This group is only available on platforms that supporting SET L2 Cos or SET L2 Cos Inner config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (590, 99, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (591, 99, 'cbQosC3plAccountStatsGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (592, 99, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (593, 99, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (594, 99, 'cbQosMeasureIPSLACfgGroup', 'Optional objects to configure IPSLA measure action.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (595, 99, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (596, 99, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (597, 99, 'cbQosPoliceColorStatsExt', 'This group is only available on platforms supporting police color aware feature.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (598, 99, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (599, 99, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (600, 99, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (601, 99, 'cbQosIPHCCfgExt', 'This group is only available on platforms supporting policy action IPHC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (602, 99, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (603, 99, 'cbQosIPHCStatsExt', 'This group is only available on platforms supporting IPHC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (604, 99, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (605, 99, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (606, 99, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (607, 99, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (608, 99, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (609, 99, 'cbQosTSCfgExtGroup', 'This group is applicable for those platforms that support shape rate greater than maximum value reportable by cbQosTSCfgRate.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (610, 99, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (611, 99, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (612, 99, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (613, 99, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (614, 99, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (615, 99, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (616, 99, 'cbQosSetCfgExt', 'This group is only available on platforms supporting marking on dei and tunnel.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (617, 99, 'cbQosFragmentGroup', 'This group is only available on platforms supporting service fragment.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (618, 99, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (619, 99, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (620, 99, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (621, 99, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (622, 99, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (623, 99, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (624, 99, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (625, 99, 'cbQosServicePolicyExtGroup', 'Optional objects to provide more information about a particular service policy instance.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (626, 99, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (627, 99, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (628, 99, 'cbQosC3plAccountCfgGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (629, 99, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (630, 99, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (631, 99, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (632, 99, 'cbQosEVCGroup', 'This group is only available on platforms supporting EVC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (633, 99, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (634, 100, 'cbQosFrameRelayVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (635, 100, 'cbQosTSCfgExtGroup', 'This group is applicable for those platforms that support shape rate greater than maximum value reportable by cbQosTSCfgRate.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (636, 100, 'cbQosPoliceActionCfgGroup', 'This group is only available on platforms that supporting multiple POLICE conform/exceed actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (637, 100, 'cbQosREDECNCfgGroup', 'This group is only available on platforms that supporting WRED ECN configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (638, 100, 'cbQosAFPoliceViolateCfgGroup', 'This group is only available on platforms that supporting multiple POLICE violate actions.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (639, 100, 'cbQosSetCfgMplsImpositionGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Imposition config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (640, 100, 'cbQosQueueingStatsGroupRev1', 'This group is only available on platforms supporting these additional queueing related information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (641, 100, 'cbQosPoliceCfgPercentGroup', 'This group is only available on platforms that supporting police CIR/PIR in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (642, 100, 'cbQosSetCfgSrpPriorityGroup', 'This group is only available on platforms that supporting SRP Priority SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (643, 100, 'cbQosEBCfgGroup', 'This group is only available on platforms supporting Estimate Bandwidth.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (644, 100, 'cbQosIPHCStatsGroup', 'This group is only available on platforms that supporting IPHC stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (645, 100, 'cbQosSetCfgExt', 'This group is only available on platforms supporting marking on dei and tunnel.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (646, 100, 'cbQosQueueingDynamicQNumberGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (647, 100, 'cbQosREDClassXmitCountersGroup', 'This group is only available on platforms that supporting WRED transmit stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (648, 100, 'cbQosREDClassECNMarkCountersGroup', 'This group is only available on platforms that supporting WRED ECN stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (649, 100, 'cbQosSetStatsGroup', 'This group is only available on platforms that supporting SET stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (650, 100, 'cbQosPoliceCfgTimeGroup', 'This group is only available on platforms that supporting time-based Policing Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (651, 100, 'cbQosSetCfgMPLSTopMostGroup', 'This group is only available on platforms that supporting SET MPLS Experimental Top Most config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (652, 100, 'cbQosC3plAccountCfgGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (653, 100, 'cbQosInterfacePolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (654, 100, 'cbQosEBStatsGroup', 'This group is only available on platforms supporting Estimate Bandwidth stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (655, 100, 'cbQosPoliceCfgCellGroup', 'This group is only available on platforms that supporting cell-based Policing Rate and Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (656, 100, 'cbQosSetCfgFrFecnBecnGroup', 'This group is only available on platforms that supporting Frame Relay FECN BECN SET configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (657, 100, 'cbQosC3plAccountStatsGroup', 'This group is only available on platform that supporting c3pl account action configuration information.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (658, 100, 'cbQosTSCfgPercentGroup', 'This group is only available on platforms that supporting committed shaping rate in percentage.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (659, 100, 'cbQosPoliceColorStatsGroup', 'This group is only available on platforms that supporting Policing Color Aware stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (660, 100, 'cbQosSetCfgL2Group', 'This group is only available on platforms that supporting SET L2 Cos or SET L2 Cos Inner config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (661, 100, 'cbQosPoliceColorStatsExt', 'This group is only available on platforms supporting police color aware feature.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (662, 100, 'cbQosEVCGroup', 'This group is only available on platforms supporting EVC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (663, 100, 'cbQosIPHCCfgExt', 'This group is only available on platforms supporting policy action IPHC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (664, 100, 'cbQosATMPVCPolicyGroup', 'This is a optional group of information');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (665, 100, 'cbQosSetCfgDiscardClassGroup', 'This group is only available on platforms that supporting SET Discard Class config.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (666, 100, 'cbQosPoliceCfgPirGroup', 'This group is only available on platforms that supporting police PIR configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (667, 100, 'cbQosAFPoliceStatsGroup', 'This group is only available on platforms that supporting POLICE violate action stats.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (668, 100, 'cbQosServicePolicyExtGroup', 'Optional objects to provide more information about a particular service policy instance.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (669, 100, 'cbQosFragmentGroup', 'This group is only available on platforms supporting service fragment.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (670, 100, 'cbQosQueueingCfgQLimitTimeGroup', 'This group is only available on platforms that supporting time-based Queue limit configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (671, 100, 'cbQosTrafficShapingDelayCountersGroup', 'This group is only available for code running on the 7200 and/or lower platforms.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (672, 100, 'cbQosREDCfgThresholdTimeGroup', 'This group is only available on platforms that supporting time-based RED threshold configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (673, 100, 'cbQosMeasureIPSLACfgGroup', 'Optional objects to configure IPSLA measure action.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (674, 100, 'cbQosPoliceCfgExtGroup', 'This group is only available for code running on the Catalyst 4000 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (675, 100, 'cbQosTableMapCfgGroup', 'This group is only available on platforms that supporting Enhanced Packet Marking.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (676, 100, 'cbQosNoBufferDropGroup', 'This group is only available for code running on the 7500 platform.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (677, 100, 'cbQosPoliceCfgColorGroup', 'This group is only available on platforms that supporting Policing Color Aware configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (678, 100, 'cbQosIPHCCfgGroup', 'This group is only available on platforms that supporting IPHC configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (679, 100, 'cbQosIPHCStatsExt', 'This group is only available on platforms supporting IPHC.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (680, 100, 'cbQosTSCfgTimeGroup', 'This group is only available on platforms that supporting time-based Shaping Burst configuration.');
INSERT INTO mib_compliance_module_group (id_compliance_module_group, id_compliance_module, compliance_group, description) VALUES (681, 100, 'cbQosPoliceCfgCdvtGroup', 'This group is only available on platforms that supporting Policing ATM CDVT configuration.');

INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (1, 3, 'ifPromiscuousMode', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (2, 3, 'ifLinkUpDownTrapEnable', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (3, 3, 'ifAlias', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (4, 4, 'ifPromiscuousMode', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (5, 4, 'ifLinkUpDownTrapEnable', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (6, 5, 'ifAlias', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (7, 5, 'ifLinkUpDownTrapEnable', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (8, 5, 'ifPromiscuousMode', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (91, 19, 'vlanTrunkPortNativeVlan', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (92, 19, 'vlanTrunkPortEncapsulationType', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (93, 19, 'vlanTrunkPortManagementDomain', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (94, 20, 'vlanTrunkPortNativeVlan', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (95, 20, 'vlanTrunkPortManagementDomain', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (96, 20, 'vlanTrunkPortEncapsulationType', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (97, 21, 'vlanTrunkPortDot1qTunnel', 'This object is read-only for interface which doesn''t support dot1q tunnel feature.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (98, 21, 'vlanTrunkPortEncapsulationType', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (99, 21, 'vlanTrunkPortManagementDomain', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (100, 21, 'vlanTrunkPortNativeVlan', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (109, 47, 'dot1dRegenUserPriority', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (110, 47, 'dot1dTrafficClass', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (111, 47, 'dot1dPortNumTrafficClasses', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (112, 48, 'dot1dTrafficClass', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (113, 48, 'dot1dRegenUserPriority', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (114, 48, 'dot1dPortNumTrafficClasses', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (115, 51, 'dot1qConstraintTypeDefault', 'Write access is not required as this is an optional capability in IEEE 802.1Q.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (116, 51, 'dot1qConstraintSetDefault', 'Write access is not required as this is an optional capability in IEEE 802.1Q.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (117, 51, 'dot1qPortAcceptableFrameTypes', 'Write access is not required as this is an optional capability in IEEE 802.1Q.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (118, 51, 'dot1qPortIngressFiltering', 'Write access is not required as this is an optional capability in IEEE 802.1Q.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (119, 52, 'dot1qPortIngressFiltering', 'Write access is not required as this is an optional capability in IEEE 802.1Q.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (120, 52, 'dot1vProtocolGroupId', 'Write access is not required as this is an optional capability in IEEE 802.1v.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (121, 52, 'dot1qConstraintSetDefault', 'Write access is not required as this is an optional capability in IEEE 802.1Q.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (122, 52, 'dot1qConstraintTypeDefault', 'Write access is not required as this is an optional capability in IEEE 802.1Q.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (123, 52, 'dot1qPortAcceptableFrameTypes', 'Write access is not required as this is an optional capability in IEEE 802.1Q.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (124, 52, 'dot1vProtocolGroupRowStatus', 'Write access is not required as this is an optional capability in IEEE 802.1v.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (153, 80, 'crasCntlTooHighThroughput', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (154, 80, 'crasCntlTooManySessions', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (155, 80, 'crasSessionState', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (156, 80, 'crasCntlTooManyFailedAuths', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (157, 81, 'crasSessionState', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (158, 81, 'crasCntlTooHighThroughput', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (159, 81, 'crasCntlTooManySessions', 'Write access is not required.', 'read-only', NULL, NULL);
INSERT INTO mib_compliance_module_object (id_compliance_module_object, id_compliance_module, name, description, minimum_access, syntax, write_syntax) VALUES (160, 81, 'crasCntlTooManyFailedAuths', 'Write access is not required.', 'read-only', NULL, NULL);

INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (230, 'IETF SNMPv3 Working Group', 'WG-EMail: snmpv3@lists.tislabs.com Subscribe: snmpv3-request@lists.tislabs.com  Co-Chair: Russ Mundy Network Associates Laboratories postal: 15204 Omega Drive, Suite 300 Rockville, MD 20850-4601 USA EMail: mundy@tislabs.com phone: +1 301 947-7107  Co-Chair: David Harrington Enterasys Networks postal: 35 Industrial Way P. O. Box 5005 Rochester, NH 03866-5005 USA EMail: dbh@enterasys.com phone: +1 603 337-2614  Editor: Randy Presuhn BMC Software, Inc. postal: 2141 North First Street San Jose, CA 95131 USA EMail: randy_presuhn@bmc.com phone: +1 408 546-1006', '2002-01-16 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (263, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 West Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2000-01-10 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (298, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2006-01-13 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (299, 'IANA', 'Internet Assigned Numbers Authority  Postal: ICANN 4676 Admiralty Way, Suite 330 Marina del Rey, CA 90292  Tel: +1 310 823 9358 E-Mail: iana@iana.org', '2004-01-22 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (300, 'IETF Interfaces MIB Working Group', 'Keith McCloghrie Cisco Systems, Inc. 170 West Tasman Drive San Jose, CA 95134-1706 US  408-526-5260 kzm@cisco.com', '2000-01-14 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (365, 'SNMPv3 Working Group', 'WG-EMail: snmpv3@lists.tislabs.com Subscribe: snmpv3-request@lists.tislabs.com  Co-Chair: Russ Mundy Network Associates Laboratories postal: 15204 Omega Drive, Suite 300 Rockville, MD 20850-4601 USA EMail: mundy@tislabs.com phone: +1 301-947-7107  Co-Chair & Co-editor: David Harrington Enterasys Networks postal: 35 Industrial Way P. O. Box 5005 Rochester, New Hampshire 03866-5005 USA EMail: dbh@enterasys.com phone: +1 603-337-2614  Co-editor: Randy Presuhn BMC Software, Inc. postal: 2141 North First Street San Jose, California 95131 USA EMail: randy_presuhn@bmc.com phone: +1 408-546-1006  Co-editor: Bert Wijnen Lucent Technologies postal: Schagen 33 3461 GL Linschoten Netherlands   EMail: bwijnen@lucent.com phone: +31 348-680-485', '2002-01-14 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (797, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-wbu@cisco.com', '2000-01-10 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (938, 'Cisco System Inc.', 'Cisco Systems Customer Service  Postal: 170 West Tasman Drive, San Jose CA 95134-1706. USA  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2001-01-23 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (1000, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2003-01-01 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (1061, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2006-01-31 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (1087, 'IETF Operations and Management Area', 'Juergen Schoenwaelder (Editor) International University Bremen P.O. Box 750 561 28725 Bremen, Germany  Phone: +49 421 200-3587 EMail: j.schoenwaelder@iu-bremen.de  Send comments to <ietfmibs@ops.ietf.org>.', '2005-01-04 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (1088, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2005-01-03 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (1160, 'IETF Mail and Directory Management Working Group', 'Ned Freed  Postal: Innosoft International, Inc. 1050 Lakes Drive West Covina, CA 91790 US  Tel: +1 626 919 3600 Fax: +1 626 919 3614  E-Mail: ned.freed@innosoft.com', '2000-01-03 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5511, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W. Tasman Drive San Jose, CA 95134-1706 USA  Tel: +1 800 553-NETS  E-mail: tgrennan-group@cisco.com', '1997-01-18 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (1504, 'IETF Applications MIB Working Group', 'Cheryl Krupczak (Editor, WG Advisor) Postal: Empire Technologies, Inc. 541 Tenth Street NW Suite 169 Atlanta, GA 30318 USA Phone: (770) 384-0184 Email: cheryl@empiretech.com  Jon Saperia (WG Chair) Postal: BGS Systems, Inc. One First Avenue Waltham, MA 02254-9111 USA Phone: (617) 891-0000 Email: saperia@networks.bgs.com', '1997-01-20 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5536, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W. Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2000-01-16 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (1943, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2008-01-09 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (1944, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2008-01-22 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (1945, 'IETF Bridge MIB Working Group', 'Email: bridge-mib@ietf.org  K.C. Norseth (Editor) L-3 Communications Tel: +1 801-594-2809 Email: kenyon.c.norseth@L-3com.com Postal: 640 N. 2200 West. Salt Lake City, Utah 84116-0850  Les Bell (Editor) 3Com Europe Limited Phone: +44 1442 438025 Email: elbell@ntlworld.com Postal: 3Com Centre, Boundary Way Hemel Hempstead Herts. HP2 7YU UK  Send comments to <bridge-mib@ietf.org>', '2005-01-19 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5593, 'Cisco Systems Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-wbu@cisco.com', '1999-01-09 11:30:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (2087, 'IETF Bridge MIB Working Group', 'Email: bridge-mib@ietf.org ietfmibs@ops.ietf.org  David Levi Postal: Nortel Networks 4655 Great America Parkway Santa Clara, CA 95054 USA Phone: +1 865 686 0432 Email: dlevi@nortel.com  David Harrington Postal: Effective Software 50 Harding Rd. Portsmouth, NH 03801 USA Phone: +1 603 436 8634 Email: ietfdbh@comcast.net  Les Bell Postal: Hemel Hempstead, Herts. HP2 7YU UK Email: elbell@ntlworld.com  Vivian Ngai  Email: vivian_ngai@acm.org  Andrew Smith Postal: Beijing Harbour Networks Jiuling Building 21 North Xisanhuan Ave. Beijing, 100089 PRC Fax: +1 415 345 1827 Email: ah_smith@acm.org  Paul Langille Postal: Newbridge Networks 5 Corporate Drive Andover, MA 01810 USA Phone: +1 978 691 4665 Email: langille@newbridge.com  Anil Rijhsinghani Postal: Accton Technology Corporation 5 Mount Royal Ave Marlboro, MA 01752 USA Phone: Email: anil@accton.com  Keith McCloghrie Postal: Cisco Systems, Inc. 170 West Tasman Drive San Jose, CA 95134-1706 USA Phone: +1 408 526 5260 Email: kzm@cisco.com', '2006-01-09 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (4518, 'IETF RMON MIB Working Group', 'Steve Waldbusser  Phone: +1-650-948-6500 Fax: +1-650-745-0671 Email: waldbusser@nextbeacon.com', '2000-01-05 15:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5409, 'IETF ENTMIB Working Group', 'WG E-mail: entmib@cisco.com Subscribe: majordomo@cisco.com msg body: subscribe entmib  Keith McCloghrie ENTMIB Working Group Chair Cisco Systems Inc. 170 West Tasman Drive San Jose, CA 95134 408-526-5260 kzm@cisco.com  Andy Bierman ENTMIB Working Group Editor Cisco Systems Inc. 170 West Tasman Drive San Jose, CA 95134 408-527-3711 abierman@cisco.com', '1996-01-16 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5801, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '1996-01-12 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5818, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W. Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2000-01-09 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5830, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: Cisco Systems, Inc. 170 West Tasman Drive San Jose, CA 95134-1706 USA  Tel: +1 408 526 4000  E-mail: cs-snmp@cisco.com', '1999-01-02 16:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (6237, 'IANA', 'Postal: Internet Assigned Numbers Authority Internet Corporation for Assigned Names and Numbers 4676 Admiralty Way, Suite 330 Marina del Rey, CA 90292-6601 USA  Tel: +1 310-823-9358 E-Mail: iana@iana.org', '2002-01-14 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (6242, 'IEEE 802.1 Working Group', 'WG-URL: http://grouper.ieee.org/groups/802/1/index.html WG-EMail: stds-802-1@ieee.org  Contact: Paul Congdon Postal: Hewlett-Packard Company 8000 Foothills Blvd. Roseville, CA 95747 USA Tel: +1-916-785-5753 E-mail: paul_congdon@hp.com', '2005-01-06 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (6347, 'IETF BGP Working Group', 'John Chu (Editor) Postal: IBM Corp. P.O.Box 218 Yorktown Heights, NY 10598 US Tel: +1 914 945 3156 Fax: +1 914 945 2141 E-mail: jychu@watson.ibm.com', '1994-01-05 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5855, 'IETF Character MIB Working Group', 'Bob Stewart Postal: Xyplex, Inc. 295 Foster Street Littleton, MA 01460  Tel: 508-952-4816 Fax: 508-952-4887  E-mail: rlstewart@eng.xyplex.com', '1994-01-26 17:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (4995, 'IETF Bridge MIB Working Group', 'Email: Bridge-mib@ietf.org ietfmibs@ops.ietf.org  David Levi Postal: Nortel Networks 4655 Great America Parkway Santa Clara, CA 95054 USA Phone: +1 865 686 0432 Email: dlevi@nortel.com  David Harrington Postal: Effective Software 50 Harding Rd. Portsmouth, NH 03801 USA Phone: +1 603 436 8634 Email: ietfdbh@comcast.net  Les Bell Postal: Hemel Hempstead, Herts. HP2 7YU UK Email: elbell@ntlworld.com  Andrew Smith Postal: Beijing Harbour Networks Jiuling Building 21 North Xisanhuan Ave. Beijing, 100089 PRC Fax: +1 415 345 1827 Email: ah_smith@acm.org  Paul Langille Postal: Newbridge Networks 5 Corporate Drive Andover, MA 01810 USA Phone: +1 978 691 4665 Email: langille@newbridge.com  Anil Rijhsinghani Postal: Accton Technology Corporation 5 Mount Royal Ave Marlboro, MA 01752 USA Phone: Email: anil@accton.com  Keith McCloghrie Postal: Cisco Systems, Inc. 170 West Tasman Drive San Jose, CA 95134-1706 USA Phone: +1 408 526 5260 Email: kzm@cisco.com', '2006-01-09 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5124, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2009-01-08 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5306, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2009-01-11 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (5348, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134  Tel: +1 800 553-NETS  E-mail: cs-snmp@cisco.com', '2009-01-17 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (6829, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W. Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-selsius@cisco.com', '2010-01-07 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (7248, 'IETF ISDN MIB Working Group', 'Guenter Roeck Postal: cisco Systems 170 West Tasman Drive San Jose, CA 95134 U.S.A. Phone: +1 408 527 3143 E-mail: groeck@cisco.com', '1996-01-23 16:42:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (7326, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-isdn@cisco.com', '2001-01-09 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (7361, 'Cisco Systems', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS E-mail: cs-snmp@cisco.com', '2004-01-03 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (7587, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W Tasman Drive San Jose, CA 95134 USA  Tel: +1 800 553-NETS  E-mail: cs-framerelay@cisco.com', '2000-01-13 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (7745, 'IETF OPS Area', 'E-mail: mibs@ops.ietf.org Subscribe: majordomo@psg.com with msg body: subscribe mibs  Andy Bierman Cisco Systems Inc. 170 West Tasman Drive San Jose, CA 95134 USA +1 408-527-3711 abierman@cisco.com  Keith McCloghrie Cisco Systems Inc. 170 West Tasman Drive San Jose, CA 95134 USA +1 408-526-5260 kzm@cisco.com  Randy Presuhn BMC Software, Inc. Office 1-3141 2141 North First Street San Jose, California 95131 USA +1 408 546-1006 rpresuhn@bmc.com', '2000-01-08 00:00:00');
INSERT INTO mib_identity (id_mib_element, organization, contact_info, last_updated) VALUES (7746, 'Cisco Systems, Inc.', 'Cisco Systems Customer Service  Postal: 170 W. Tasman Drive San Jose, CA 95134-1706 USA  Tel: +1 800 553-NETS  E-mail: cs-qos@cisco.com', '2014-01-24 00:00:00');

INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (3, 230, 'This revision of this MIB module was published as RFC 3418.', '2002-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (4, 230, 'This revision of this MIB module was published as RFC 1907.', '1995-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (5, 230, 'The initial revision of this MIB module was published as RFC 1450.', '1993-01-01 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (6, 263, 'Added ciscoPartnerProducts to generate sysObjectID for partner platforms', '1997-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (7, 263, 'Added ciscoPolicy, ciscoPolicyAuto, ciscoPIB, and ciscoPibToMib.', '2000-01-11 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (8, 263, 'Initial version of this MIB module.', '1994-01-26 20:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (9, 263, 'New oid assignments for Cisco REPEATER MIB and others.', '1995-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (10, 298, 'Added Unsigned64 textual convention.', '2002-01-02 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (11, 298, 'Changed MilliSeconds TC to CiscoMilliSeconds as it was overlapping with the one in a standard MIB.', '2002-01-18 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (12, 298, 'Added ListIndex, ListIndexOrZero, TimeIntervalSec, TimeintervalMin, MicroSeconds and MicroSeconds TC from Andiamo''s TC MIB .', '2002-01-22 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (13, 298, 'Added CiscoRowOperStatus, EntPhysicalIndexOrZero, Port and IpProtocol textual conventions.', '1998-01-28 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (14, 298, 'Added CiscoPortListRange textual convention.', '2004-01-08 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (15, 298, 'Added enumerations to CiscoNetworkProtocol', '2001-01-07 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (16, 298, 'Added InterfaceIndexOrZero textual convention.', '1996-01-14 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (17, 298, 'Added SAPType, CountryCode textual convention.', '1997-01-13 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (18, 298, 'Added CvE164Address textual convention.', '2005-01-24 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (19, 298, 'Added the ''http'' enumeration to CiscoNetworkProtocol.', '2002-01-12 16:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (20, 298, 'Added following textual conventions: CiscoURLString CiscoHTTPResponseStatusCode EntLogicalIndexOrZero.', '2005-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (21, 298, 'Miscellaneous updates/corrections, including making CiscoNetworkProtocol enumerations contiguous.', '1995-01-07 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (22, 298, 'Added CiscoLocationClass, CiscoLocationSpecifier CiscoInetAddressMask, CiscoAbsZeroBasedCounter32, CiscoSnapShotAbsCounter32 textual conventions.', '2000-01-21 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (23, 298, 'Added IfOperStatusReason textual convention.', '2004-01-11 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (24, 298, 'Added ConfigIterator & BulkConfigResult textual convention for bulk provisioning. Added CountryCodeITU textual convention for ITU-T defined country codes for non-standard facilities.', '2002-01-17 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (25, 298, 'Added enumeration to IfOperStatusReason from 113-131 (''dpvmVsanSuspended'' to ''domainOther'').', '2006-01-13 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (26, 298, 'Added CiscoAlarmSeverity textual convention. Changed SAPType display hint to d. Changed INTEGER to Integer32 in CiscoPort and CiscoIpProtocol TCs. Changed SnmpAdminString to OCTET STRING in CiscoLocationSpecifier. Removed IMPORTs for ciscoProducts and SnmpAdminString.', '2001-01-18 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (27, 298, 'Added Unsigned32 textual conventions.', '1996-01-22 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (28, 298, 'Added new CiscoNetworkProtocol enumerations.', '1996-01-08 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (29, 298, 'Added PerfHighIntervalCount TEXTUAL-CONVENTION.', '2002-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (30, 298, 'Added CiscoPortList textual convention. Removed Unsigned32 textual convention.', '2004-01-14 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (31, 299, 'Added description for IANAifType 6, and changed the descriptions for IANAifTypes 180, 181, and 182.', '2004-01-12 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (32, 299, 'Registration of new IANAifType 206.', '2001-01-06 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (33, 299, 'Registration of new IANAifType 190.', '2000-01-04 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (34, 299, 'Registration of new IANAifTypes 184, 185, and 186.', '2000-01-01 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (35, 299, 'Include new name assignments up to cnr(85). This is the first version available via the WWW at: ftp://ftp.isi.edu/mib/ianaiftype.mib', '1999-01-08 14:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (36, 299, 'Registration of new IANAifTypes 195 and 196.', '2001-01-12 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (37, 299, 'Registration of new IANAifType 187.', '2000-01-02 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (38, 299, 'Registration of new IANAifType 198.', '2001-01-19 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (39, 299, 'Registration of new IANAifTypes 191 and 192.', '2000-01-07 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (40, 299, 'Registration of new IANAifTypes 168 and 169.', '2000-01-25 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (41, 299, 'Registration of new IANAifTypes 170, 171, 172 and 173.', '2000-01-22 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (42, 299, 'Registration of new IANAifType 219.', '2002-01-17 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (43, 299, 'Registration of new IANAifTypes 207 and 208.', '2001-01-15 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (44, 299, 'Registration of new IANAifTypes 174-182.', '2000-01-23 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (45, 299, 'Registration of new IANAifTypes 199, 200, 201, 202, 203, and 204.', '2001-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (46, 299, 'Registration of new IANAifTypes 215 and 216.', '2002-01-10 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (47, 299, 'Registration of new IANAifTypes 193 and 194.', '2000-01-19 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (48, 299, 'Deprecated IANAifTypes 7 and 11. Obsoleted IANAifTypes 62, 69, and 117. ethernetCsmacd (6) should be used instead of these values', '2003-01-25 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (49, 299, 'Registration of new IANA ifType 226.', '2004-01-17 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (50, 299, 'Registration of new IANAifType 221.', '2003-01-18 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (51, 299, 'Registration of new IANAifType 183.', '2000-01-24 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (52, 299, 'Registration of new IANAifTypes 188 and 189.', '2000-01-17 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (53, 299, 'Registration of new IANA ifType 227.', '2004-01-22 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (54, 299, 'Registration of new IANAifType 205.', '2001-01-02 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (55, 299, 'Registration of new IANAifType 214.', '2002-01-19 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (56, 299, 'Registration of new IANAifTypes 209 and 210.', '2001-01-20 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (57, 299, 'Fixed a missing semi-colon in the IMPORT. Also cleaned up the REVISION log a bit. It is not complete, but from now on it will be maintained and kept up to date with each change to this MIB module.', '2000-01-06 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (58, 299, 'Registration of new IANAifTypes 211, 212 and 213.', '2002-01-04 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (59, 299, 'Registration of new IANAifType 225.', '2004-01-07 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (60, 299, 'Initial version of this MIB as published in RFC 1573.', '1994-01-31 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (61, 299, 'Registration of new IANAifType 220.', '2003-01-13 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (62, 299, 'Registration of new IANAifTypes 222 and 223.', '2003-01-07 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (63, 299, 'Registration of new IANAifType 224.', '2003-01-18 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (64, 299, 'Registration of new IANAifTypes 217 and 218.', '2002-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (65, 299, 'Registration of new IANAifType 197.', '2001-01-11 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (66, 300, 'Initial revision, published as part of RFC 1573.', '1993-01-08 21:55:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (67, 300, 'Clarifications agreed upon by the Interfaces MIB WG, and published as RFC 2863.', '2000-01-14 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (68, 300, 'Revisions made by the Interfaces MIB WG, and published in RFC 2233.', '1996-01-28 21:55:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (69, 365, 'Updated editors'' addresses, fixed typos. Published as RFC 2571.', '1999-01-19 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (70, 365, 'The initial version, published in RFC 2271.', '1997-01-20 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (134, 1087, 'Initial version, published as RFC 2851.', '2000-01-08 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (135, 1087, 'Third version, published as RFC 4001. This revision introduces the InetZoneIndex, InetScopeType, and InetVersion textual conventions.', '2005-01-04 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (136, 1088, 'Added clogServerGroup.', '2005-01-01 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (137, 1088, 'Added following objects: clogOriginIDType clogOriginID', '2005-01-11 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (138, 1088, 'Removed UNITS clause for clogOriginIDType as UNITS clause is not applicable.', '2005-01-03 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (139, 1088, 'Initial version of this MIB module.', '1995-01-07 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (182, 4518, 'Reformatted into SMIv2 format.  This version published as RFC XXXX.', '2000-01-05 15:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (71, 365, 'Changes in this revision: - Updated various administrative information. - Corrected some typos. - Corrected typo in description of SnmpEngineID that led to range overlap for 127. - Changed ''255a'' to ''255t'' in definition of SnmpAdminString to align with current SMI. - Reworded ''reserved'' for value zero in DESCRIPTION of SnmpSecurityModel. - The algorithm for allocating security models should give 256 per enterprise block, rather than 255. - The example engine ID of ''abcd'' is not legal. Replaced with ''800002b804616263''H based on example enterprise 696, string ''abc''. - Added clarification that engineID should persist across re-initializations. This revision published as RFC 3411.', '2002-01-14 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (183, 4518, 'The original version of this MIB, published as RFC1513.', '1993-01-01 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (145, 1160, 'The original version of this MIB was published in RFC 1565', '1993-01-28 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (146, 1160, 'This revision, published in RFC 2788, changes a number of DisplayStrings to SnmpAdminStrings. Note that this change is not strictly supported by SMIv2. However, the alternative of deprecating the old objects and defining new objects would have a more adverse impact on backward compatibility and interoperability, given the particular semantics of these objects. The defining reference for distinguished names has also been updated from RFC 1779 to RFC 2253.', '2000-01-03 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (147, 1160, 'This revision, published in RFC 2248, adds the applDescription and applURL objects, adds the quiescing state to the applOperStatus object and renames the MIB from the APPLICATION-MIB to the NETWORK-SERVICE-MIB.', '1997-01-17 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (148, 1160, 'This revision fixes a few small technical problems found in previous versions, mostly in regards to the conformance groups for different versions of this MIB. No changes have been made to the objects this MIB defines since RFC 2248.', '1999-01-12 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (96, 797, 'Added support for encapsulation type negotiation', '1998-01-19 11:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (97, 797, 'Updated the Token-Ring support.', '1996-01-16 12:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (98, 797, 'Added support for version 2 features.', '1997-01-27 17:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (99, 797, 'Added import of NOTIFICATION-GROUP', '1999-01-25 11:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (100, 797, 'Added 4k VLAN editing and Dot1qTunnel support', '2000-01-10 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (101, 797, 'Added Backup CRF object', '1997-01-08 11:38:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (102, 797, 'Initial version of this MIB module.', '1996-01-18 18:20:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (103, 797, 'Updated to include objects in support of VTP pruning.', '1996-01-17 12:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (104, 797, 'Added support for turning on VTP for Trunk cards.', '1997-01-24 11:15:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (105, 797, 'Added ARE and STE hop counts.', '1997-01-09 11:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (106, 797, 'Added support for encapsulation type notApplicable', '1999-01-05 11:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (107, 797, 'Added 4k VLAN support', '2000-01-06 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (108, 938, 'Added the following objects: cdpGlobalDeviceIdFormatCpb, cdpGlobalDeviceIdFormat.', '2001-01-23 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (109, 938, 'Correct range of cdpInterfaceMessageInterval.', '1995-01-27 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (110, 938, 'Added the following objects: cdpCacheApplianceID, cdpCacheVlanID, cdpCachePowerConsumption, cdpCacheMTU, cdpCachePrimaryMgmtAddrType, cdpCachePrimaryMgmtAddr, cdpCacheSecondaryMgmtAddrType, cdpCacheSecondaryMgmtAddr, cdpCacheLastChange, cdpCachePhysLocation, cdpCacheSysName, cdpCacheSysObjectID, cdpGlobalLastChange', '2000-01-22 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (111, 938, 'Move from ciscoExperiment to ciscoMgmt oid subtree.', '1995-01-25 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (112, 938, 'added these objects to cdpCacheTable: cdpCacheVTPMgmtDomain, cdpCacheNativeVLAN, cdpCacheDuplex.', '1998-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (113, 938, 'Added cdpInterfaceExtTable which contains the following objects: cdpInterfaceExtendedTrust, cdpInterfaceCosForUntrustedPort.', '2001-01-23 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (114, 938, 'Obsolete cdpInterfaceMessageInterval and newly define cdpGlobal object.', '1996-01-08 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (115, 938, 'Added cdpGlobalDeviceId object.', '1998-01-10 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (116, 938, 'Specify a correct (non-negative) range for several index objects.', '1995-01-15 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (117, 1000, 'Added optional groups ciscoEnvMonEnableStatChangeGroup and ciscoEnvMonStatChangeNotifGroup.', '2002-01-17 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (118, 1000, 'Added ciscoEnvMonMIBMiscNotifGroup.', '2003-01-25 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (119, 1000, 'Add monitoring support for c3600 series router', '1996-01-12 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (120, 1000, 'Miscellaneous changes including monitoring support for c7000 series redundant power supplies.', '1995-01-13 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (121, 1000, 'Specify a correct (non-negative) range for several index objects.', '1995-01-15 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (122, 1000, 'Renamed enumerated value internalRPS(5) as internalRedundant(5) and added description for ciscoEnvMonSupplySource enumerated values.', '1998-01-22 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (123, 1000, 'Added c10000(10) as values for ciscoEnvMonPresent', '2001-01-30 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (124, 1000, 'Added c37xx (13) and other (14) as values for ciscoEnvMonPresent', '2003-01-01 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (125, 1000, 'Added c7600(12) as values for ciscoEnvMonPresent', '2002-01-15 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (126, 1000, 'Added cat4000(9) as values for ciscoEnvMonPresent', '2001-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (127, 1000, 'Add notFunctioning to CiscoEnvMonState.', '2000-01-31 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (128, 1000, 'Add enumerated value internalRPS(5) to ciscoEnvMonSupplySource.', '1998-01-05 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (129, 1000, 'Added osr7600(11) as values for ciscoEnvMonPresent', '2002-01-04 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (130, 1000, 'Added cat6000(7),ubr7200(8) as values for ciscoEnvMonPresent', '2001-01-07 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (131, 1061, 'Updated the imports such that Unsigned32 is imported from SNMPv2-SMI instead of CISCO-TC.', '2006-01-31 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (132, 1061, 'Initial version.', '1997-01-09 17:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (133, 1087, 'Second version, published as RFC 3291. This revision contains several clarifications and introduces several new textual conventions: InetAddressPrefixLength, InetPortNumber, InetAutonomousSystemNumber, InetAddressIPv4z, and InetAddressIPv6z.', '2002-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (149, 1943, 'The initial version of the MIB module.', '2008-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (150, 1944, 'The initial version of the MIB module.', '2008-01-22 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (151, 1945, 'Second revision, published as part of RFC 1493.', '1993-01-31 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (152, 1945, 'Initial revision, published as part of RFC 1286.', '1991-01-31 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (153, 1945, 'Third revision, published as part of RFC 4188.  The MIB module has been converted to SMIv2 format. Conformance statements have been added and some description and reference clauses have been updated.  The object dot1dStpPortPathCost32 was added to support IEEE 802.1t and the permissible values of dot1dStpPriority and dot1dStpPortPriority have been clarified for bridges supporting IEEE 802.1t or IEEE 802.1w.  The interpretation of dot1dStpTimeSinceTopologyChange has been clarified for bridges supporting the Rapid Spanning Tree Protocol (RSTP).', '2005-01-19 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (154, 2087, 'The Bridge MIB Extension module for managing Priority and Multicast Filtering, defined by IEEE 802.1D-1998.  Initial version, published as RFC 2674.', '1999-01-25 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (155, 2087, 'Added dot1dPortRestrictedGroupRegistration. Deprecated pBridgePortGmrpGroup and pBridgeCompliance and added pBridgePortGmrpGroup2 and pBridgeCompliance2.', '2006-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (184, 4995, 'Added Vlan TEXTUAL-CONVENTIONs, dot1qPortRestrictedVlanRegistration, dot1vProtocol subtree, qBridgeClassificationDeviceGroup, qBridgePortGroup2, qBridgeClassificationPortGroup, and qBridgeCompliance2. Clarified dot1qForwardAllStaticPorts, qPortAcceptableFrameTypes, and qBridgeCompliance. Deprecated qBridgePortGroup and qBridgeCompliance.', '2006-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (185, 4995, 'The VLAN Bridge MIB module for managing Virtual Bridged Local Area Networks, as defined by IEEE 802.1Q-1998.  Initial version, published as RFC 2674.', '1999-01-25 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (186, 5124, 'The initial version of the MIB module.', '2009-01-08 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (187, 5306, 'The initial version of the MIB module.', '2009-01-11 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (188, 5348, 'The initial version of the MIB module.', '2009-01-17 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (189, 5511, 'Initial version of this MIB module.', '1997-01-18 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (190, 5536, 'Initial version of this MIB module.', '2000-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (191, 5593, 'This MIB module defines management objects for Cisco Layer 2/3 switches. These devices may either have a single (central) switching engine entity or may consist of multiple (distributed) switching engine entities which are inter-connected via a common ''switching fabric''. In the central switching engine model, all the physical ports in the system are handled by the only switching engine in the system. In the distributed switching model, each switching engine will handle a set of ''local'' physical ports and when necessary, packets are also switched between switching engines over the switching fabric.  Cisco L2/L3 switching devices use regular routers to assist them in learning packet ''flows'' by observing how a router routes a candidate flow. A flow is some combination of source network address, destination network address and the transport port numbers, as applicable. Once a flow is established (learned), all traffic belonging to that flow will be switched at Layer 3 by the switch engine, effectively bypassing the router, until the flow has been ''aged'' out. Most Cisco L2/L3 switching devices employ built-in (internal) router module(s) for integrating Layer 3 switching with Layer 2 forwarding. However, they can also learn ''flows'' through other physically-separate (external) Cisco routers that are connected to the switch-engine through the network.', '1998-01-28 11:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (192, 5593, 'Added MIB objects to manage Switch Engine (SE) portion of Multicast MLS control protocol.', '2000-01-31 11:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (193, 5593, 'Added 2 groups, for the purging (clearing) of layer 3 unicast and multicast flow entries stored in the cache. Also added new objects for layer 3 flow statistics.', '1998-01-24 11:30:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (194, 5818, 'Initial version of this MIB module.', '2000-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (204, 6237, 'AddressFamilyNumbers assignment 19 to xtpOverIpv4. AddressFamilyNumbers assignment 20 to xtpOverIpv6. AddressFamilyNumbers assignment 21 to xtpNativeModeXTP.', '2000-01-08 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (205, 6237, 'AddressFamilyNumbers assignment 22 to fibreChannelWWPN. AddressFamilyNumbers assignment 23 to fibreChannelWWNN. AddressFamilyNumers assignment 24 to gwid.', '2002-01-14 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (206, 6237, 'Initial version, published as RFC 2677.', '1999-01-26 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (207, 6237, 'AddressFamilyNumbers assignment 16 to dns.', '2000-01-04 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (208, 6237, 'AddressFamilyNumbers assignment 17 to distinguishedName. AddressFamilyNumbers assignment 18 to asNumber.', '2000-01-01 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (209, 6242, 'Published as part of IEEE Std 802.1AB-2005 initial version.', '2005-01-06 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (210, 6829, '(1)Added partiallyregistered to CcmDeviceStatus TC (2)Added phonePartiallyregistered to ccmPhoneStatusUpdateType TC (3)Added following TCs CcmPhoneProtocolType, CcmDeviceLineStatus CcmSIPTransportProtocolType (4)Added following objects to ccmPhoneTable: ccmPhoneProtocol, ccmPhoneName (5)Added ccmPhoneExtnStatus to ccmPhoneExtnTable (6)Added following objects to ccmSIPDeviceTable: ccmSIPInTransportProtocolType, ccmSIPOutTransportProtocolType, ccmSIPInPortNumber, ccmSIPOutPortNumber (7)Added ccmTLSConnectionFailure notification (8)Updated description of following objects under ccmSIPDeviceTable: ccmTLSConnectionFailReasonCode, ccmSIPDevName, ccmSIPDevDescription, ccmSIPDevInetAddress (9)Updated description of ccmCallManagerAlarmEnable (10) Added the following object groups: ccmPhoneInfoGroupRev4, ccmNotificationsInfoGroupRev3, ccmSIPDeviceInfoGroupRev1 (11) Added the following notification groups: ccmNotificationsGroupRev2 (12) Added MIB compliance ciscoCcmMIBComplianceRev4.', '2005-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (211, 6829, '(1) Added the definition of ccmMaliciousCall and ccmQualityReport notifications and its objects; (2) Added the definition of ccmSystemVersion and ccmInstallationId objects to ccmGlobalInfo group; (3) Added H323 trunk types and SIP trunk type in ccmDeviceProductId; (4) Added more media device types in ccmMediaDevice table; (5) Added ccmSIPDeviceInfo definition (6) Added more phone types (7) Added the definition of ccmProductTypeTable to list the product types supported at run time. Also added ccmPhoneProductTypeIndex, ccmGatewayProductTypeIndex, ccmMediaDeviceProductTypeIndex, ccmCTIDeviceProductTypeIndex, ccmH323DevProductTypeIndex, and ccmVMailDevProductTypeIndex objects. Deprecated the ccmPhoneType, ccmGatewayType, ccmGatewayProductId, ccmMediaDeviceType, ccmCTIDeviceTYpe, ccmH323DevProductId and ccmVMailDevProductId and objects (8) Deprecated the CcmDeviceProductId definition.', '2003-01-25 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (212, 6829, '(1)Updated CcmDevFailCauseCode definition to include more cause codes authenticationError, invalidX509NameInCertificate, invalidTLSCipher, directoryNumberMismatch and malformedRegisterMsg. (2)Updated description of following objects: ccmPhoneFailedInetAddress, ccmGatewayInetAddress, ccmMediaDeviceInetAddress, ccmGatekeeperInetAddress, ccmCTIDeviceInetAddress, ccmH323DevInetAddress, ccmH323DevCnfgGKInetAddress, ccmH323DevAltGK2InetAddress, ccmH323DevAltGK3InetAddress, ccmH323DevAltGK4InetAddress, ccmH323DevAltGK5InetAddress, ccmH323DevActGKInetAddress, ccmH323DevRmtCM1InetAddress, ccmH323DevRmtCM2InetAddress, ccmH323DevRmtCM3InetAddress, ccmVMailDevInetAddress .', '2005-01-14 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (213, 6829, '(1) Obsoleted CcmDeviceProductId, ccmTimeZoneOffset ccmPhoneType, ccmPhoneLastError, ccmPhoneTimeLastError, ccmPhoneExtensionTable, ccmPhoneExtensionEntry, ccmPhoneExtensionIndex, ccmPhoneExtension, ccmPhoneExtensionMultiLines, ccmPhoneExtensionInetAddressType, ccmPhoneExtensionInetAddress, ccmPhoneFailedName, ccmGatewayType, ccmGatewayProductId, ccmActivePhones, ccmInActivePhones, ccmActiveGateways, ccmInActiveGateways, ccmMediaDeviceType,ccmCTIDeviceType, ccmCTIDeviceAppInfo,ccmH323DevProductId, ccmVMailDevProductId, ciscoCcmMIBComplianceRev2, ccmInfoGroupRev1, ccmPhoneInfoGroupRev1, ccmGatewayInfoGroupRev1 ccmCTIDeviceInfoGroup, ccmNotificationsInfoGroup ccmPhoneInfoGroupRev2, ccmGatewayInfoGroupRev2 ccmMediaDeviceInfoGroupRev1, ccmCTIDeviceInfoGroupRev1 ccmH323DeviceInfoGroup, ccmVoiceMailDeviceInfoGroup .', '2004-01-02 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (214, 6829, '(1)Updated the following TEXTUAL-CONVENTIONs: CcmDevUnregCauseCode, CcmDevRegFailCauseCode; (2)Replaced the previous references of CISCO CCM MIB to CISCO-CCM-MIB (3)Replaced previous references of CCM to CUCM', '2010-01-07 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (215, 6829, '(1) Updated CcmDevFailCauseCode definition to include more cause codes deviceInitiatedReset, callManagerReset and noError; (2) Added ccmH323DeviceInfo and ccmVoiceMailDeviceInfo objects; (3) Updated ccmRegionAvailableBandwidth definition to include two more bandwidth types bwGSM and bwWideband; (4) Deprecated ccmTimeZoneOffset object; (5) Added ccmTimeZoneOffsetHours and ccmTimeZoneOffsetMinutes to ccmTimeZoneTable; (6) Added ccmPhoneStatusUpdateReason object to ccmPhoneStatusUpdate table; (7) Added ccmGatewayProductId, ccmGatewayStatusReason, ccmGatewayTimeLastStatusUpdt, ccmGatewayTimeLastRegistered, ccmGatewayDChannelStatus and ccmGatewayDChannelNumber objects to ccmGatewayTable; (8) Added new types to ccmGatewayType; (9) Added rejected status to ccmGatewayStatus; (10)Obsoleted the ccmGatewayTrunkInfo (this was never supported); (11)Added ccmMediaDeviceStatusReason, ccmMediaDeviceTimeLastStatusUpdt and ccmMediaDeviceTimeLastRegistered to ccmMediaDeviceTable; (12)Added more types to ccmMediaDeviceType; (13)Added rejected status to ccmMediaDeviceStatus; (14)Deprecated the ccmGatekeeperTable definition; (15)Added rejected status to ccmGatekeeperstatus; (16)Added ccmCTIDeviceStatusReason, ccmCTIDeviceTimeLastStatusUpdt and ccmCTIDeviceTimeLastRegistered to ccmCTIDeviceTable; (17)Added rejected status to ccmCTIDeviceStatus; (18)Added more objects to the ccmGlobalInfo; (19)Added ccmPhoneStatusReason, ccmPhoneTimeLastStatusUpdt to ccmPhoneTable; (20)Added rejected status to ccmPhoneStatus; (21)Deprecated ccmPhoneFailedName and added ccmPhoneMacAddress to ccmPhoneFailedTable; (22)Deprecated ccmPhoneLastError and ccmPhoneTimeLastError in ccmPhoneTable; (23)Deprecated ccmCTIDeviceAppInfo in ccmCTIDeviceTable; (24)Defined CcmDeviceProductId and CcmDeviceStatus textual conventions; (25)Added ccmPhoneExtnTable, ccmPhStatUpdtTblLastAddedIndex and ccmPhFailedTblLastAddedIndex. Deprecated ccmPhoneExtensionTable. (26)Changed the default value of ccmCallManagerAlarmEnable, ccmGatewayAlarmEnable, ccmPhoneFailedStorePeriod and ccmPhoneStatusUpdateStorePeriod objects. Also changed the minimum value of ccmPhoneFailedStorePeriod and ccmPhoneStatusUpdateStorePeriod objects. (27)Updated ccmMIBCompliance statements; (28)Added this revision clause.', '2002-01-11 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (216, 6829, '(1)Added following objects in ccmCTIDeviceTable: ccmCTIDeviceInetAddressIPv4, ccmCTIDeviceInetAddressIPv6. These objects replaced the ccmCTIDeviceInetAddressType and ccmCTIDeviceInetAddress; (2)Deprecated following objects in ccmCTIDeviceTable: ccmCTIDeviceInetAddressType, ccmCTIDeviceInetAddress; (3)Added following OBJECT-GROUP ccmCTIDeviceInfoGroupRev3. This group replaced the ccmCTIDeviceInfoGroupRev2; (4)Deprecated following OBJECT-GROUP ccmCTIDeviceInfoGroupRev2; (5)Added ciscoCcmMIBComplianceRev6 MODULE-COMPLIANCE. This compliance replaced the ciscoCcmMIBComplianceRev5; (6)Deprecated ciscoCcmMIBComplianceRev5 MODULE-COMPLIANCE;', '2008-01-21 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (217, 6829, '(1) Added more phone types in the ccmPhoneType definition; (2) Added more gateway types in the ccmGatewayType and CcmDeviceProductId definition.', '2003-01-08 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (218, 6829, 'The initial version of this MIB module.', '2000-01-10 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (219, 6829, '(1)Added following TEXTUAL-CONVENTIONs: CcmDevRegFailCauseCode, CcmDevUnregCauseCode. These objects replaced the CcmDevFailCauseCode; (2)Added following objects in ccmPhoneTable: ccmPhoneUnregReason, ccmPhoneRegFailReason. These objects replaced the ccmPhoneStatusReason; (3)Added following object in ccmPhoneFailedTable: ccmPhoneFailedRegFailReason. This object replaced the ccmPhoneFailCauseCode; (4)Added following objects in ccmPhoneStatusUpdateTable: ccmPhoneStatusUnregReason, ccmPhoneStatusRegFailReason. These objects replaced the ccmPhoneStatusUpdateReason; (5)Added following object in ccmGatewayTable: ccmGatewayUnregReason, ccmGatewayRegFailReason. These objects replaced the ccmGatewayStatusReason; (6)Added following objects in ccmMediaDeviceTable: ccmMediaDeviceUnregReason, ccmMediaDeviceRegFailReason. These objects replaced the ccmMediaDeviceStatusReason; (7)Added following objects in ccmCTIDeviceTable: ccmCTIDeviceUnregReason, ccmCTIDeviceRegFailReason. These objects replaced the ccmCTIDeviceStatusReason; (8)Added following objects in ccmH323DeviceTable: ccmH323DevUnregReason, ccmH323DevRegFailReason. These objects replaced the ccmH323DevStatusReason; (9)Added following objects in ccmVoiceMailDeviceTable: ccmVMailDevUnregReason, ccmVMailDevRegFailReason. These objects replaced the ccmVMailDevStatusReason; (10)Added following objects in ccmNotificationsInfo: ccmGatewayRegFailCauseCode. This object replaced the ccmGatewayFailCauseCode; (11)Added following NOTIFICATION-TYPE: ccmGatewayFailedReason. This notification replaced the ccmGatewayFailed; (12)Added following OBJECT_GROUPS: ccmPhoneInfoGroupRev6, ccmNotificationsInfoGroupRev5, ccmGatewayInfoGroupRev4, ccmMediaDeviceInfoGroupRev4, ccmCTIDeviceInfoGroupRev4, ccmH323DeviceInfoGroupRev3, ccmVoiceMailDeviceInfoGroupRev2, ccmNotificationsGroupRev3. These groups replaced the following groups respectively: ccmPhoneInfoGroupRev5, ccmNotificationsInfoGroupRev4, ccmGatewayInfoGroupRev3, ccmMediaDeviceInfoGroupRev3, ccmCTIDeviceInfoGroupRev3, ccmH323DeviceInfoGroupRev2, ccmVoiceMailDeviceInfoGroupRev1, ccmNotificationsGroupRev2; (13)Added following MODULE-COMPLIANCE: ciscoCcmMIBComplianceRev7. This compliance replaced the ciscoCcmMIBComplianceRev6; (14)Deprecated following TEXTUAL-CONVENTION: CcmDevFailCauseCode; (15)Deprecated following object in ccmPhoneTable: ccmPhoneStatusReason; (16)Deprecated following object in ccmPhoneFailedTable: ccmPhoneFailCauseCode; (17)Deprecated following object in ccmPhoneStatusUpdateTable: ccmPhoneStatusUpdateReason; (18)Deprecated following object in ccmGatewayTable: ccmGatewayStatusReason; (19)Deprecated following object in ccmMediaDeviceTable: ccmMediaDeviceStatusReason; (20)Deprecated following object in ccmCTIDeviceTable: ccmCTIDeviceStatusReason; (21)Deprecated following object in ccmH323DeviceTable: ccmH323DevStatusReason; (22)Deprecated following object in ccmVoiceMailDeviceTable: ccmVMailDevStatusReason; (23)Deprecated following object in ccmNotificationsInfo: ccmGatewayFailCauseCode; (24)Deprecated following NOTIFICATION-TYPE: ccmGatewayFailed; (25)Deprecated following OBJECT_GROUPS: ccmPhoneInfoGroupRev5, ccmGatewayInfoGroupRev3, ccmMediaDeviceInfoGroupRev3, ccmCTIDeviceInfoGroupRev3, ccmH323DeviceInfoGroupRev2, ccmVoiceMailDeviceInfoGroupRev1, ccmNotificationsGroupRev2, ccmNotificationsInfoGroupRev4; (26)Obsoleted following OBJECT_GROUPS: ccmInfoGroupRev3, ccmH323DeviceInfoGroupRev1; (27)Deprecated following MODULE-COMPLIANCE: ciscoCcmMIBComplianceRev6;', '2009-01-03 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (220, 6829, '(1)Added following objects in ccmTable: ccmInetAddress2, ccmInetAddress2Type; (2)Added following objects in ccmPhoneTable: ccmPhoneInetAddressIPv4, ccmPhoneInetAddressIPv6, ccmPhoneIPv4Attribute, ccmPhoneIPv6Attribute, ccmPhoneActiveLoadID; (3)Added following objects in ccmPhoneFailedTable: ccmPhoneFailedInetAddressIPv4, ccmPhoneFailedInetAddressIPv6, ccmPhoneFailedIPv4Attribute, ccmPhoneFailedIPv6Attribute; (4)Added following objects in ccmSIPDeviceTable: ccmSIPDevInetAddressIPv4, ccmSIPDevInetAddressIPv6; (5)Added following objects in ccmMediaDeviceTable: ccmMediaDeviceInetAddressIPv4, ccmMediaDeviceInetAddressIPv6; (6)Deprecated following objects in ccmPhoneTable: ccmPhoneInetAddressType, ccmPhoneInetAddress; (7)Deprecated following objects in ccmPhoneFailedTable: ccmPhoneFailedInetAddressType, ccmPhoneFailedInetAddress; (8)Deprecated following objects in ccmSIPDeviceTable: ccmSIPDevInetAddressType, ccmSIPDevInetAddress; (9)Deprecated following objects in ccmMediaDeviceTable: ccmMediaDeviceInetAddressType, ccmMediaDeviceInetAddress; (10)Added following scalar objects ccmH323TableEntries, ccmSIPTableEntries; (11)Obsoleted ciscoCcmMIBComplianceRev3 MODULE-COMPLIANCE; (12)Deprecated ciscoCcmMIBComplianceRev4 MODULE-COMPLIANCE; (13)Added ciscoCcmMIBComplianceRev5 MODULE-COMPLIANCE; (14)Obsoleted following NOTIFICATION-GROUPS ccmNotificationsGroup, ccmNotificationsGroupRev1; (15)Obsoleted following OBJECT-GROUPS ccmInfoGroupRev2, ccmPhoneInfoGroupRev3, ccmSIPDeviceInfoGroup, ccmNotificationsInfoGroupRev1, ccmNotificationsInfoGroupRev2; (16)Deprecated following OBJECT-GROUPS ccmInfoGroupRev3, ccmPhoneInfoGroupRev4, ccmSIPDeviceInfoGroupRev1, ccmMediaDeviceInfoGroupRev2, ccmH323DeviceInfoGroupRev1, ccmNotificationsInfoGroupRev3; (17)Added following OBJECT-GROUPS ccmInfoGroupRev4, ccmPhoneInfoGroupRev5, ccmMediaDeviceInfoGroupRev3, ccmNotificationsInfoGroupRev4, ccmH323DeviceInfoGroupRev2, ccmSIPDeviceInfoGroupRev2;', '2008-01-12 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (221, 6829, '(1) Add ccmMediaDeviceInfo, ccmGatekeeperInfo, ccmCTIDeviceInfo, ccmAlarmConfigInfo and ccmNotificationsInfo objects; (2) Add ccmClusterId to the ccmEntry; (3) Deprecated the ccmGatewayTrunkInfo (this was never implemented and it should''ve been in the gateway MIB); (4) Add ccmPhoneFailedTable and ccmPhoneStatusUpdateTable; (5) Add ccmMIBNotifications; (6) Add new ccmGatewayType and ccmPhoneType; (7) Add this Revision clause.', '2000-01-01 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (222, 7326, 'Removed an instantiated clause in description for ciscoCallHistoryCallingNumber.', '2000-01-23 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (223, 7326, 'For a call connects, demandNbrLastDuration, demandNbrClearReason, and demandNbrClearCode objects are not included in the trap.', '2001-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (224, 7326, 'Added a new trap for PRI layer 2 state changes.', '1999-01-07 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (225, 7326, 'Initial version of Cisco ISDN MIB.', '1995-01-30 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (226, 7326, 'Added demandNbrCNANotification when call rejected with channel not available cause code', '2000-01-27 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (227, 7326, 'Specify a correct (non-negative) range for an index object.', '1995-01-15 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (228, 7326, 'Add a new object demandNbrCallOrigin.', '1996-01-21 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (229, 7361, 'Added crasEmailNumSessions crasEmailCumulateSessions crasEmailPeakConcurrentSessions crasIPSecNumSessions crasIPSecCumulateSessions crasIPSecPeakConcurrentSessions crasL2LNumSessions crasL2LCumulateSessions crasL2LPeakConcurrentSessions crasLBNumSessions crasLBCumulateSessions crasLBPeakConcurrentSessions crasSVCNumSessions crasSVCCumulateSessions crasSVCPeakConcurrentSessions crasWebvpnNumSessions crasWebvpnCumulateSessions crasWebvpnPeakConcurrentSessions objects', '2008-01-28 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (230, 7587, '(1) Added objects of FR Switching, FR Fragmentation and FR/ATM Interworking. (2) Objects for per PVC I/O rate is added to cfrExtCircuitTable', '2000-01-13 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (231, 7587, '(1) Added Traffic Shaping parameter objects to cfrExtCircuitTable. (2) Deprecated cfrSvcMinThruputOut and cfrSvcMinThruputIn. Added cfrExtCircuitMinThruputOut and cfrExtCircuitMinThruputIn in cfrExtCircuitTable inorder to make them applicable to both PVC/SVC. (3) Added cfrExtCircuitBandwidth object to cfrExtCircuitTable.', '2000-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (232, 7587, '(1) Added cfrExtCircuitUncompressOuts and cfrExtCircuitUncompressIns to the circuit subgroup; (2) Added cfrMapRtpHdrCompress and cfrMapPayloadCompressType to the mapping subgroup; (3) cfrMapPayloadCompress becomes deprecated, obsoleted by cfrMapPayloadCompressType; (4) frCircuitSentOctets and frCircuitReceivedOctets per RFC1315 will reflect the number of bytes in Frame Relay frames sent to and received from the physical layer. Same effect is applied to ifOutOctets and ifInOctets as well when ifIndex refers to a Frame Relay subinterface.', '1999-01-21 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (233, 7587, 'Initial version of this MIB module.', '1996-01-15 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (234, 7587, '(1) Added ELMI subgroup for ELMI objects.', '2000-01-22 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (235, 7587, '(1) add an integer value for cfrMapPayloadCompressType; (2) reword the Description statements for { cfrMapPayloadCompressType, cfrExtCircuitUncompressIns, cfrExtCircuitUncompressOuts } so that they are not limited to software compression.', '2000-01-26 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (236, 7745, 'Initial Version of the High Capacity Numbers MIB module, published as RFC 2856.', '2000-01-08 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (237, 7746, 'Added Percentage as a unit for cbQoSQueueUnitType', '2013-01-15 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (238, 7746, 'Added ''setL2CosInner'' value to PoliceAction TC.', '2007-01-30 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (239, 7746, 'Added support for ECN; Pir policing; multiple police actions; added MPLS-EXP/ATM-CLP/DR-DE/ L2Cos/DiscardClass marking in police action; added MPLS-EXP and DiscardClass marking; modified ATM-CLP and FR-DE marking. Added objects to handle queue depth unit type and queue depth pair related objects (e.g., cbQosQueueingCfgQLimitUnits and cbQosQueueingCfgAggregateQLimit pair) to support queue depth in different units.', '2002-01-24 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (240, 7746, 'Added cbQosQueueingStatsGroupRev1 Added ciscocbQosMIBComplianceRev13', '2013-01-10 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (241, 7746, 'Added unconfigured(15) value to PoliceAction TC. Added cbQosCMFragmentPktOverflow, cbQosCMFragmentPkt, cbQosCMFragmentPkt64, cbQosCMFragmentByteOverflow, cbQosCMFragmentByte, cbQosCMFragmentByte64 in CbQosCMStatsEntry. Added evc(7) enum value in InterfaceType TC. Added cbQosEVC in CbQosServicePolicyEntry Changed comments for cbQosPolicyIndex and cbQosObjectsIndex. Added ciscocbQosMIBComplianceRev9.', '2009-01-16 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (242, 7746, 'Added controlPlane to the InterfaceType TC. Added cbQosEntityIndex to the cbQosServicePolicyTable.', '2003-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (243, 7746, 'Added support for Police Violate counters and DSCP WRED counters', '2000-01-08 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (244, 7746, '-Added ratioRemaining in QueueingBandwidthUnits -Added l2CosInner in SetFeatureType -Added cbQosQueueingCfgPriorityLevel in cbQosQueueingCfgTable -Added cbQosSetCfgL2CosInnerValue in cbQosSetCfgTable -Added in cbQosREDClassCfgTable cbQosREDClassCfgMaxThresholdUnit, cbQosREDClassCfgMinThresholdUnit -Added cbQosQueueingClassCfgTable - Added following OBJECT-GROUPs cbQosQueueingCfgGroupRev2 cbQosSetCfgL2Group cbQosQueueingClassCfgGroup cbQosPoliceCfgGroupRev3 - Added MODULE-COMPLIANCE cisco cbQosMIBComplianceRev6', '2008-01-17 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (245, 7746, 'Added support for Estimate Bandwidth and its Corvil implementation. Corvil''s algorithm generates the estimated bandwidth for a class of traffic from knowledge of the QoS targets such as delay and drop, and the observed traffic behavior.', '2004-01-12 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (246, 7746, '1. Added cbQosTSCfgRate64 to cbQosTSCfgTable to support shaping rates greater than that fit in the range defined for cbQosTSCfgRate. 2. Created cbQosTSCfgExtGroup. 3. Created new compliance module ciscocbQosMIBComplianceRev5 which deprecates ciscocbQosMIBComplianceRev4.', '2007-01-09 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (247, 7746, '- Added cbQosSetCfgFrDe to hold the Fr-De marking configuration value in cbQosSetCfgTable. - Updated the optional groups of ciscocbQosMIBComplianceRev7 with cbQosSetCfgFrDeGroup. - Added MODULE-COMPLIANCE ciscocbQosMIBComplianceRev8.', '2009-01-24 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (248, 7746, 'Added following enumerations to RedMechanism TC: mplsExp redDefault redUserDefault', '2007-01-10 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (249, 7746, 'Added new object cbQosParentPolicyIndex in cbQosServicePolicyTable', '2014-01-24 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (250, 7746, 'Added the following 64-bit Objects  cbQosCMPrePolicyBitRate64 cbQosCMPostPolicyBitRate64 cbQosCMDropBitRate64 cbQosPoliceConformedBitRate64 cbQosPoliceExceededBitRate64 cbQosPoliceViolatedBitRate64', '2013-01-20 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (251, 7746, 'Added setIpDscpTunnel, setIpPrecedenceTunnel to the PoliceAction TC. Added srpPriority, frFecnBecn, ipDscpTunnel, ipPrecedenceTunnel to the SetFeatureType TC. Added l2Cos, atmClp to the REDMechanism TC. Added cps to the CbQosRateType TC. Added CbQosTMSetType TC. Added cbQosQueueingCfgAggrQLimitTime to the cbQosQueueingCfgTable. Added cbQosREDClassCfgMinThresholdTime, cbQosREDClassCfgMaxThresholdTime to the cbQosREDClassCfgTable. Added cbQosPoliceCfgCellRate, cbQosPoliceCfgCellPir, cbQosPoliceCfgBurstCell, cbQosPoliceCfgExtBurstCell, cbQosPoliceCfgBurstTime, cbQosPoliceCfgExtBurstTime, cbQosPoliceCfgCdvt, cbQosPoliceCfgConformColor, cbQosPoliceCfgExceedColor to the cbQosPoliceCfgTable. Added cbQosTSCfgBurstTime, cbQosTSCfgExtBurstTime to the cbQosTSCfgTable. Added cbQosSetCfgSrpPriority, cbQosSetCfgFrFecnBecn to the cbQosSetCfgTable. Added cbQosSetStatsTable. Added cbQosPoliceColorStatsTable. Added cbQosTableMapCfgTable. Added cbQosTableMapValueCfgTable. Added cbQosTableMapSetCfgTable.', '2003-01-24 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (252, 7746, 'Added account feature in QosObjectType.', '2009-01-26 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (253, 7746, '1. Added vlan-port as a new InterfaceType. 2. Created cbQosServicePolicyExtGroup.', '2004-01-20 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (254, 7746, 'Added compression(9) in QosObjectType TC for IPHC; Added setMplsExpTopMost(11) in PoliceAction TC for POLICE; Added mplsExpTopMost(8) in SetFeatureType TC for SET; Added discardClass(13) in REDMechanism TC for WRED; Added CbQosRateType TC for POLICE and SHAPE; Added IPHCOption TC for IPHC; Added cbQosPoliceCfgRateType, cbQosPoliceCfgPercentRateValue, cbQosPoliceCfgPercentPirValue for POLICE; Added cbQosTSCfgRateType, cbQosTSCfgPercentRateValue for SHAPE; Added cbQosSetCfgMplsExpTopMostValue for SET; Added cbQosIPHCCfg and cbQosIPHCStats tables for IPHC.', '2003-01-21 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (255, 7746, 'Added cbQosC3plAccountCfgGroup and cbQosC3plAccountStatsGroup.', '2008-01-20 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (256, 7746, 'The following 4 changes have been made  1. Added the following 64 bit objects and deprecated the corresponding 32 bit objects ================================================= cbQosQueueingCfgBandwidth64, cbQosQueueingCfgIndividualQSize64, cbQosPoliceCfgBurstSize64, cbQosPoliceCfgExtBurstSize64, cbQosPoliceCfgPir64, cbQosTSCfgBurstSize64, cbQosTSCfgExtBurstSize64  2. Range expanded for ================== cbQosQueueingCfgBandwidth, cbQosQueueingCfgIndividualQSize, cbQosPoliceCfgBurstSize,  cbQosPoliceCfgExtBurstSize, cbQosPoliceCfgPir, cbQosTSCfgBurstSize, cbQosTSCfgExtBurstSize, cbQosREDCfgMinThreshold, cbQosREDCfgMaxThreshold, cbQosPoliceCfgRate, cbQosPoliceCfgBurstCell, cbQosPoliceCfgExtBurstCell, cbQosPoliceCfgBurstTime, cbQosPoliceCfgExtBurstTime, cbQosPoliceCfgCdvt, cbQosTSCfgRate,cbQosTSCfgBurstTime, cbQosTSCfgExtBurstTime  3. New object added ================ cbQosPolicyDiscontinuityTime  4. Added new type (srp-priority) to ================================== PoliceAction', '2012-01-22 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (257, 7746, 'The following 2 objects are expanded to include perThousand and perMillion units.  1. QueueingBandwidthUnits 2. CbQosRateType', '2012-01-24 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (258, 7746, 'Added new cbQosPoliceCfgRate64 to cbQosPoliceCfgEntry table to support policing rates greater than fit in the range defined for cbQosPoliceCfgRate', '2002-01-03 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (259, 7746, 'Initial version of Class-based QoS configuration and statistical parameters MIB', '2000-01-13 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (260, 7746, 'Added support for FR DE, ATM CLP and L2 marking. Added Bandwidth remaining percent option', '2001-01-14 00:00:00');
INSERT INTO mib_identity_revision (id_identity_revision, id_mib_element, description, revision) VALUES (261, 7746, 'Added setDei(16), setDeiImposition(17) to the TC PoliceAction. Added dei(14), deiImposition(15) to the TC SetFeatureType. Added dei(9) to the TC REDMechanism.  Added objects cbQosSetCfgIpPrecedenceTunnelValue, cbQosSetCfgIpDscpTunnelValue, cbQosSetCfgDei, cbQosSetCfgDeiImposition to CbQosSetCfgEntry  Added objects cbQosPoliceCfmColorCfmRate, cbQosPoliceCfmColorExdRate, cbQosPoliceCfmColorVltRate, cbQosPoliceExdColorExdRate, cbQosPoliceExdColorVltRate, cbQosPoliceVltColorVltRate to cbQosPoliceColorStatsEntry.  Added Objects cbQosIPHCCfgEnabled to cbQosIPHCCfgEntry  Added Objects cbQosIPHCRtpFullHdrPktOverflow, cbQosIPHCRtpFullHdrPkt, cbQosIPHCRtpFullHdrPkt64, cbQosIPHCTcpFullHdrPktOverflow, cbQosIPHCTcpFullHdrPkt, cbQosIPHCTcpFullHdrPkt64 to cbQosIPHCStatsEntry  Added ciscocbQosMIBComplianceRev10.', '2009-01-25 00:00:00');

INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (196, 37, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (197, 37, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (198, 37, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (199, 37, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (200, 37, 'IpAddress', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (201, 37, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (202, 37, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (203, 37, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (204, 37, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (205, 37, 'DateAndTime', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (206, 37, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (207, 37, 'TestAndIncr', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (208, 37, 'InterfaceIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (209, 37, 'ifIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (210, 37, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (211, 37, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (212, 37, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (213, 38, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (214, 38, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (215, 38, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (216, 38, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (217, 38, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (218, 38, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (219, 38, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (220, 38, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (221, 38, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (222, 38, 'CiscoNetworkProtocol', 30);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (223, 38, 'CiscoNetworkAddress', 30);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (224, 38, 'Unsigned32', 30);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (225, 38, 'VlanIndex', 37);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (226, 38, 'ifIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (227, 39, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (228, 39, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (229, 39, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (230, 39, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (231, 39, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (232, 39, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (233, 39, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (234, 39, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (92, 25, 'mgmt', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (93, 25, 'NetworkAddress', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (94, 25, 'IpAddress', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (95, 25, 'Counter', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (96, 25, 'Gauge', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (97, 25, 'TimeTicks', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (98, 25, 'OBJECT-TYPE', 22);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (99, 26, 'ObjectSyntax', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (100, 26, 'TimeTicks', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (101, 28, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (102, 28, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (103, 28, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (104, 28, 'TimeTicks', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (105, 28, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (106, 28, 'snmpModules', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (107, 28, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (108, 28, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (109, 28, 'TestAndIncr', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (110, 28, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (111, 28, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (112, 28, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (113, 28, 'NOTIFICATION-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (114, 29, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (115, 29, 'OBJECT-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (116, 29, 'enterprises', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (117, 30, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (118, 30, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (119, 30, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (120, 30, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (121, 30, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (122, 30, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (123, 30, 'ciscoModules', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (124, 31, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (125, 31, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (126, 31, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (127, 32, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (128, 32, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (129, 32, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (130, 32, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (131, 32, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (132, 32, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (133, 32, 'TimeTicks', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (134, 32, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (135, 32, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (136, 32, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (137, 32, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (138, 32, 'PhysAddress', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (139, 32, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (140, 32, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (141, 32, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (142, 32, 'AutonomousType', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (143, 32, 'TestAndIncr', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (144, 32, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (145, 32, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (146, 32, 'NOTIFICATION-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (147, 32, 'snmpTraps', 28);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (148, 32, 'IANAifType', 31);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (149, 33, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (150, 33, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (151, 33, 'OBJECT-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (152, 33, 'snmpModules', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (153, 33, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (154, 33, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (155, 33, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (235, 39, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (236, 39, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (237, 39, 'NOTIFICATION-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (238, 39, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (239, 40, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (240, 40, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (241, 40, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (242, 40, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (243, 40, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (244, 40, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (245, 40, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (246, 40, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (168, 35, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (169, 35, 'TimeTicks', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (170, 35, 'Counter', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (171, 35, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (247, 40, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (248, 40, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (249, 40, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (250, 41, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (251, 41, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (252, 41, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (253, 41, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (254, 42, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (255, 42, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (256, 42, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (257, 42, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (258, 42, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (259, 42, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (260, 42, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (261, 42, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (262, 42, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (263, 42, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (264, 42, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (265, 42, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (266, 42, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (267, 42, 'NOTIFICATION-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (268, 42, 'SnmpAdminString', 33);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (269, 42, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (270, 42, 'InetAddress', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (271, 42, 'InetAddressType', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (991, 97, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (992, 97, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (993, 97, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (994, 98, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (995, 98, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (996, 98, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (997, 98, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (998, 98, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (999, 98, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1000, 98, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1001, 98, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1002, 98, 'SnmpAdminString', 33);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1003, 98, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1004, 98, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (286, 44, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (287, 44, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (288, 44, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (289, 44, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (290, 44, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (291, 44, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (292, 44, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (293, 44, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (294, 44, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (295, 44, 'SnmpAdminString', 33);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (818, 82, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (819, 82, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (820, 82, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (821, 82, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (822, 82, 'TDomain', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (823, 82, 'TAddress', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (824, 82, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (825, 82, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (826, 82, 'AutonomousType', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (827, 82, 'RowPointer', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (828, 82, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (829, 82, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (830, 82, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (814, 81, 'cfmFlowMonitorId', 79);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (815, 81, 'cfmFlowId', 79);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (816, 81, 'cfmFlowMetricsIntNumber', 79);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (817, 81, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (839, 84, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (840, 84, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (841, 84, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (842, 84, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (843, 84, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (844, 84, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (845, 84, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (846, 84, 'MacAddress', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (847, 84, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (848, 84, 'ifIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (849, 84, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (850, 85, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (851, 85, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (852, 85, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (853, 85, 'IpAddress', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (854, 85, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (855, 85, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (856, 85, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (857, 85, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (858, 85, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (333, 50, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (334, 50, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (335, 50, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (336, 50, 'TimeTicks', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (337, 50, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (338, 50, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (339, 50, 'DateAndTime', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (340, 50, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (341, 50, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (342, 50, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (343, 50, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (859, 85, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (860, 85, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (861, 86, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (862, 86, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (863, 86, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (864, 86, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (865, 86, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (866, 86, 'IpAddress', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (867, 86, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (868, 86, 'ifIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (869, 86, 'OwnerString', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (870, 86, 'CiscoNetworkProtocol', 30);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (871, 86, 'Unsigned32', 30);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (872, 86, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (873, 86, 'VlanIndex', 37);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (874, 86, 'entPhysicalIndex', 82);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (875, 86, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (876, 86, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (877, 86, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (878, 86, 'TimeInterval', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (879, 86, 'MacAddress', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (880, 86, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (881, 86, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (882, 86, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (883, 86, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (884, 87, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (885, 87, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (886, 87, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (887, 87, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (888, 87, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (889, 87, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (890, 87, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (891, 87, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (892, 87, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (893, 87, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (379, 54, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (380, 54, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (381, 54, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (382, 54, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (383, 54, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (384, 55, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (385, 55, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (386, 55, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (387, 55, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (388, 56, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (389, 56, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (390, 56, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (391, 56, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (392, 56, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (393, 56, 'TimeTicks', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (394, 56, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (395, 56, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (396, 56, 'MacAddress', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (397, 56, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (398, 56, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (399, 56, 'NOTIFICATION-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (400, 56, 'InterfaceIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (894, 88, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (895, 88, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (896, 88, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (897, 88, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (898, 88, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (899, 88, 'SnmpAdminString', 33);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (900, 88, 'ifIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (901, 88, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (902, 89, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (411, 58, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (412, 58, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (413, 58, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (414, 58, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (415, 58, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (416, 58, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (417, 58, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (418, 58, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (419, 58, 'TimeInterval', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (420, 58, 'MacAddress', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (421, 58, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (422, 58, 'dot1dTp', 56);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (423, 58, 'dot1dTpPort', 56);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (424, 58, 'dot1dBridge', 56);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (425, 58, 'dot1dBasePortEntry', 56);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (426, 58, 'dot1dBasePort', 56);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (798, 80, 'cfmFlowMonitorId', 79);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (799, 80, 'cfmFlowId', 79);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (800, 80, 'cfmFlowMetricsIntNumber', 79);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (801, 80, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (802, 81, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (803, 81, 'OBJECT-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (804, 81, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (805, 81, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (806, 81, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (807, 81, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (808, 81, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (809, 81, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (810, 81, 'ReportIntervalCount', 55);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (811, 81, 'FlowMetricScale', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (812, 81, 'FlowMetricPrecision', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (813, 81, 'FlowMetricValue', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (678, 76, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (679, 76, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (680, 76, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (681, 76, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (682, 76, 'TimeInterval', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (683, 76, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (684, 76, 'MacAddress', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (685, 76, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (686, 76, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (687, 76, 'InterfaceIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (688, 76, 'OwnerString', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (689, 76, 'EntryStatus', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (690, 76, 'rmon', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (691, 76, 'statistics', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (692, 76, 'history', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (693, 76, 'rmonCompliances', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (694, 76, 'rmonGroups', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (695, 77, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (696, 77, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (697, 77, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (698, 77, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (699, 77, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (700, 77, 'IpAddress', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (701, 77, 'TimeTicks', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (702, 77, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (703, 77, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (704, 77, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (705, 77, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (706, 77, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (707, 77, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (708, 77, 'mib-2', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (709, 77, 'ifIndex', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (710, 77, 'OwnerString', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (711, 77, 'statistics', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (712, 77, 'history', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (713, 77, 'hosts', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (714, 77, 'matrix', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (715, 77, 'filter', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (716, 77, 'etherStatsEntry', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (717, 77, 'historyControlEntry', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (718, 77, 'hostControlEntry', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (719, 77, 'matrixControlEntry', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (720, 77, 'filterEntry', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (721, 77, 'channelEntry', 35);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (722, 77, 'tokenRing', 76);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (723, 77, 'tokenRingMLStatsEntry', 76);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (724, 77, 'tokenRingPStatsEntry', 76);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (725, 77, 'ringStationControlEntry', 76);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (726, 77, 'sourceRoutingStatsEntry', 76);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (727, 78, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (728, 78, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (729, 78, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (730, 78, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (731, 78, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (732, 78, 'TimeTicks', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (733, 78, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (734, 78, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (735, 78, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (736, 78, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (737, 78, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (738, 78, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (739, 78, 'MacAddress', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (740, 78, 'SnmpAdminString', 33);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (741, 78, 'dot1dBridge', 56);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (742, 78, 'dot1dBasePortEntry', 56);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (743, 78, 'dot1dBasePort', 56);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (744, 78, 'EnabledStatus', 58);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (745, 78, 'TimeFilter', 77);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (746, 79, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (747, 79, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (748, 79, 'OBJECT-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (749, 79, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (750, 79, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (751, 79, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (752, 79, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (753, 79, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (754, 79, 'NOTIFICATION-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (755, 79, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (756, 79, 'AutonomousType', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (757, 79, 'RowPointer', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (758, 79, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (759, 79, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (760, 79, 'SnmpAdminString', 33);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (761, 79, 'InetAddressType', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (762, 79, 'InetAddress', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (763, 79, 'InetPortNumber', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (764, 79, 'VlanId', 78);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (765, 79, 'CiscoAlarmSeverity', 30);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (766, 79, 'Layer2Cos', 30);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (767, 79, 'ReportIntervalCount', 55);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (768, 79, 'FlowMonitorIdentifier', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (769, 79, 'FlowIdentifier', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (770, 79, 'FlowPointType', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (771, 79, 'FlowPointIdentifier', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (772, 79, 'FlowMetrics', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (773, 79, 'FlowBitRateUnits', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (774, 79, 'FlowMetricValue', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (775, 79, 'FlowMetricScale', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (776, 79, 'FlowMetricPrecision', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (777, 79, 'FlowMonitorConditions', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (778, 79, 'FlowMonitorConditionsProfile', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (779, 79, 'FlowMonitorConditionsProfileOrZero', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (780, 79, 'FlowMonitorConditionIdentifier', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (781, 79, 'FlowMonitorAlarmGroupIdentifier', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (782, 79, 'FlowSetIdentifier', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (783, 79, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (784, 80, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (785, 80, 'OBJECT-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (786, 80, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (787, 80, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (788, 80, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (789, 80, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (790, 80, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (791, 80, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (792, 80, 'ReportIntervalCount', 55);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (793, 80, 'FlowCfgRateType', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (794, 80, 'FlowBitRateUnits', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (795, 80, 'FlowMetricScale', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (796, 80, 'FlowMetricPrecision', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (797, 80, 'FlowMetricValue', 54);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1005, 98, 'NOTIFICATION-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1006, 98, 'TimeFilter', 77);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1007, 98, 'ZeroBasedCounter32', 77);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1008, 98, 'AddressFamilyNumbers', 97);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1009, 99, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1010, 99, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1011, 99, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1012, 99, 'IpAddress', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1013, 99, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1014, 99, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1015, 99, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1016, 99, 'mib-2', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (903, 89, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (904, 89, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (905, 89, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (906, 89, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (907, 89, 'entPhysicalIndex', 82);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (908, 89, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (909, 89, 'SnmpAdminString', 33);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (910, 90, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (911, 90, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (912, 90, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (913, 90, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (914, 90, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (915, 90, 'TimeTicks', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (916, 90, 'AutonomousType', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (917, 90, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (918, 90, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (919, 90, 'InterfaceIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (920, 90, 'mib-2', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (921, 90, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (922, 90, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1051, 103, 'Counter', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1052, 103, 'OBJECT-TYPE', 22);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1053, 103, 'DisplayString', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1054, 103, 'ifIndex', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1055, 103, 'local', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1056, 104, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1057, 104, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1058, 104, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1059, 104, 'IpAddress', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1060, 104, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1061, 104, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1062, 104, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1063, 104, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1064, 104, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1065, 104, 'NOTIFICATION-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1066, 104, 'DateAndTime', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1067, 104, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1068, 104, 'MacAddress', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1069, 104, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1070, 104, 'SnmpAdminString', 33);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1071, 104, 'InetAddressType', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1072, 104, 'InetAddress', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1073, 104, 'InetPortNumber', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1074, 104, 'InetAddressIPv4', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1075, 104, 'InetAddressIPv6', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1076, 104, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1077, 105, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1078, 105, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1079, 105, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1080, 105, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1081, 105, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1082, 105, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1083, 105, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1084, 105, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1085, 105, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1086, 105, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1087, 105, 'TestAndIncr', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1088, 105, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1089, 105, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1090, 105, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1091, 105, 'ifIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1092, 105, 'InterfaceIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1093, 105, 'IANAifType', 31);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1094, 105, 'transmission', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1095, 106, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1096, 106, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1097, 106, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1098, 106, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1099, 106, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1100, 106, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1101, 106, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1102, 106, 'RowStatus', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1103, 106, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1104, 106, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1105, 106, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1106, 106, 'ifIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1107, 106, 'isdnLapdOperStatus', 105);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1108, 106, 'isdnSignalingIndex', 105);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1109, 106, 'isdnSignalingIfIndex', 105);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1110, 107, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1111, 107, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1112, 107, 'NOTIFICATION-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1113, 107, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1114, 107, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1115, 107, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1116, 107, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1117, 107, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1118, 107, 'zeroDotZero', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1119, 107, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1120, 107, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1121, 107, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1122, 107, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1123, 107, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1124, 107, 'NOTIFICATION-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1125, 107, 'InetAddressType', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1126, 107, 'InetAddress', 41);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1127, 107, 'SnmpAdminString', 33);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1128, 107, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1129, 108, 'IpAddress', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1130, 108, 'Counter', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1131, 108, 'TimeTicks', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1132, 108, 'OBJECT-TYPE', 22);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1133, 108, 'ipAdEntAddr', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1134, 108, 'ipRouteDest', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1135, 108, 'DisplayString', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1136, 108, 'local', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1137, 109, 'Counter', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1138, 109, 'mib-2', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1139, 109, 'DisplayString', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1140, 109, 'OBJECT-TYPE', 22);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1141, 110, 'ObjectName', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1142, 111, 'OBJECT-TYPE', 22);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1143, 111, 'transmission', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1144, 111, 'TimeTicks', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1145, 111, 'Counter', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1146, 111, 'TRAP-TYPE', 110);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1147, 112, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1148, 112, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1149, 112, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1150, 112, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1151, 112, 'IpAddress', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1152, 112, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1153, 112, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1154, 112, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1155, 112, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1156, 112, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1157, 112, 'ciscoMgmt', 29);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1158, 112, 'InterfaceIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1159, 112, 'ifIndex', 25);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1160, 112, 'frDlcmiEntry', 111);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1161, 112, 'frCircuitEntry', 111);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1162, 112, 'frCircuitIfIndex', 111);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1163, 112, 'frCircuitDlci', 111);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1164, 113, 'TimeTicks', 21);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1165, 115, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1166, 115, 'mib-2', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1167, 115, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1168, 115, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1169, 116, 'MODULE-IDENTITY', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1170, 116, 'OBJECT-TYPE', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1171, 116, 'Integer32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1172, 116, 'Counter32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1173, 116, 'Gauge32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1174, 116, 'Unsigned32', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1175, 116, 'Counter64', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1176, 116, 'dod', 17);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1177, 116, 'MODULE-COMPLIANCE', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1178, 116, 'OBJECT-GROUP', 27);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1179, 116, 'TEXTUAL-CONVENTION', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1180, 116, 'DisplayString', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1181, 116, 'TruthValue', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1182, 116, 'TimeStamp', 26);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1183, 116, 'ifIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1184, 116, 'InterfaceIndex', 32);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1185, 116, 'VlanIndex', 78);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1186, 116, 'CounterBasedGauge64', 115);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1187, 116, 'Unsigned64', 30);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1188, 116, 'EntPhysicalIndexOrZero', 30);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1189, 116, 'DlciNumber', 112);
INSERT INTO mib_module_import (id_mib_module_import, id_mib_module, import, id_mib_module_import_from) VALUES (1190, 116, 'ciscoMgmt', 29);

INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (259, 'coldStart, authenticationFailure');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (260, 'warmStart');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (350, 'linkUp, linkDown');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (1058, 'ciscoEnvMonShutdownNotification');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (1059, 'ciscoEnvMonVoltStatusChangeNotif, ciscoEnvMonTempStatusChangeNotif, ciscoEnvMonFanStatusChangeNotif, ciscoEnvMonSuppStatusChangeNotif');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (1060, 'ciscoEnvMonVoltageNotification, ciscoEnvMonTemperatureNotification, ciscoEnvMonFanNotification, ciscoEnvMonRedundantSupplyNotification');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (1125, 'clogMessageGenerated');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (2024, 'newRoot,  topologyChange');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (5305, 'cfmNotifyAlarm');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (6346, 'lldpRemTablesChange');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (7210, 'ccmCallManagerFailed, ccmPhoneFailed, ccmPhoneStatusUpdate, ccmGatewayFailed, ccmMediaResourceListExhausted, ccmRouteListExhausted, ccmGatewayLayer2Change');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (7221, 'ccmCallManagerFailed, ccmPhoneFailed, ccmPhoneStatusUpdate, ccmGatewayFailed, ccmMediaResourceListExhausted, ccmRouteListExhausted, ccmGatewayLayer2Change, ccmMaliciousCall, ccmQualityReport');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (7232, 'ccmCallManagerFailed, ccmPhoneFailed, ccmPhoneStatusUpdate, ccmGatewayFailed, ccmMediaResourceListExhausted, ccmRouteListExhausted, ccmGatewayLayer2Change, ccmMaliciousCall, ccmQualityReport, ccmTLSConnectionFailure');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (7247, 'ccmCallManagerFailed, ccmPhoneFailed, ccmPhoneStatusUpdate, ccmGatewayFailedReason, ccmMediaResourceListExhausted, ccmRouteListExhausted, ccmGatewayLayer2Change, ccmMaliciousCall, ccmQualityReport, ccmTLSConnectionFailure');
INSERT INTO mib_notification_group (id_mib_element, notifications) VALUES (7511, 'ciscoRasTooHighThroughput, ciscoRasTooManyFailedAuths, ciscoRasTooManySessions');

INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (245, NULL);
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (246, NULL);
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (247, NULL);
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (335, 'ifIndex, ifAdminStatus, ifOperStatus');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (336, 'ifIndex, ifAdminStatus, ifOperStatus');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (594, 'alarmIndex, alarmVariable, alarmSampleType, alarmValue, alarmRisingThreshold');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (595, 'alarmIndex, alarmVariable, alarmSampleType, alarmValue, alarmFallingThreshold');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (912, 'managementDomainConfigRevNumber');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (913, 'managementDomainConfigRevNumber');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (914, 'managementDomainConfigRevNumber, vtpMaxVlanStorage');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (915, 'vlanTrunkPortManagementDomain, vtpVlanState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (916, 'vtpVlanIndex, vtpVlanRingNumber, ifIndex, vtpVlanPortLocalSegment');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (917, 'vlanTrunkPortManagementDomain');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (918, 'vlanTrunkPortDynamicStatus');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (1041, NULL);
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (1042, 'ciscoEnvMonVoltageStatusDescr, ciscoEnvMonVoltageStatusValue, ciscoEnvMonVoltageState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (1043, 'ciscoEnvMonTemperatureStatusDescr, ciscoEnvMonTemperatureStatusValue, ciscoEnvMonTemperatureState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (1044, 'ciscoEnvMonFanStatusDescr, ciscoEnvMonFanState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (1045, 'ciscoEnvMonSupplyStatusDescr, ciscoEnvMonSupplyState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (1046, 'ciscoEnvMonVoltageStatusDescr, ciscoEnvMonVoltageStatusValue, ciscoEnvMonVoltageState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (1047, 'ciscoEnvMonTemperatureStatusDescr, ciscoEnvMonTemperatureStatusValue, ciscoEnvMonTemperatureState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (1048, 'ciscoEnvMonFanStatusDescr, ciscoEnvMonFanState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (1049, 'ciscoEnvMonSupplyStatusDescr, ciscoEnvMonSupplyState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (1118, 'clogHistFacility, clogHistSeverity, clogHistMsgName, clogHistMsgText, clogHistTimestamp');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (6335, 'lldpStatsRemTablesInserts, lldpStatsRemTablesDeletes, lldpStatsRemTablesDrops, lldpStatsRemTablesAgeouts');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (6402, 'bgpPeerLastError, bgpPeerState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (6403, 'bgpPeerLastError, bgpPeerState');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (2010, NULL);
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (2011, NULL);
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (5285, 'cfmAlarmHistoryType, cfmAlarmHistoryEntity, cfmAlarmHistoryConditionsProfile, cfmAlarmHistoryConditionId, cfmAlarmHistorySeverity, cfmAlarmHistoryTime');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (5445, NULL);
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7178, 'ccmAlarmSeverity, ccmFailCauseCode');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7179, 'ccmAlarmSeverity, ccmPhoneFailures');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7180, 'ccmAlarmSeverity, ccmPhoneUpdates');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7181, 'ccmAlarmSeverity, ccmGatewayName, ccmGatewayInetAddressType, ccmGatewayInetAddress, ccmGatewayFailCauseCode');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7182, 'ccmAlarmSeverity, ccmMediaResourceType, ccmMediaResourceListName');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7183, 'ccmAlarmSeverity, ccmRouteListName');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7184, 'ccmAlarmSeverity, ccmGatewayName, ccmGatewayInetAddressType, ccmGatewayInetAddress, ccmGatewayPhysIfIndex, ccmGatewayPhysIfL2Status');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7185, 'ccmAlarmSeverity, ccmMaliCallCalledPartyName, ccmMaliCallCalledPartyNumber, ccmMaliCallCalledDeviceName, ccmMaliCallCallingPartyName, ccmMaliCallCallingPartyNumber, ccmMaliCallCallingDeviceName, ccmMaliCallTime');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7186, 'ccmAlarmSeverity, ccmQualityRprtSourceDevName, ccmQualityRprtClusterId, ccmQualityRprtCategory, ccmQualityRprtReasonCode, ccmQualityRprtTime');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7187, 'ccmAlarmSeverity, ccmTLSDevName, ccmTLSDevInetAddressType, ccmTLSDevInetAddress, ccmTLSConnectionFailReasonCode, ccmTLSConnFailTime');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7188, 'ccmAlarmSeverity, ccmGatewayName, ccmGatewayInetAddressType, ccmGatewayInetAddress, ccmGatewayRegFailCauseCode');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7316, 'ifIndex, isdnBearerOperStatus, isdnBearerPeerAddress, isdnBearerPeerSubAddress, isdnBearerCallSetupTime, isdnBearerInfoType, isdnBearerCallOrigin');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7350, 'demandNbrLogIf, demandNbrName, demandNbrAddress, demandNbrLastDuration, demandNbrClearReason, demandNbrClearCode');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7351, 'demandNbrLogIf, demandNbrName, demandNbrAddress, demandNbrLastDuration, demandNbrClearReason, demandNbrClearCode, demandNbrCallOrigin');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7352, 'ifIndex, isdnLapdOperStatus');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7353, 'isdnSignalingIfIndex, ifIndex');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7495, 'crasNumSessions, crasNumUsers, crasMaxSessionsSupportable, crasMaxUsersSupportable, crasThrMaxSessions');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7496, 'crasNumDeclinedSessions, crasThrMaxFailedAuths');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7497, 'crasGlobalInOctets, crasGlobalOutOctets, crasThrMaxThroughput');
INSERT INTO mib_notification_type (id_mib_element, objects) VALUES (7586, 'frCircuitIfIndex, frCircuitDlci, frCircuitState');

INSERT INTO mib_object_group (id_mib_element, objects) VALUES (255, 'snmpInPkts, snmpInBadVersions, snmpInASNParseErrs, snmpSilentDrops, snmpProxyDrops, snmpEnableAuthenTraps');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (256, 'snmpInBadCommunityNames, snmpInBadCommunityUses');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (257, 'snmpSetSerialNo');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (258, 'sysDescr, sysObjectID, sysUpTime, sysContact, sysName, sysLocation, sysServices, sysORLastChange, sysORID, sysORUpTime, sysORDescr');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (261, 'snmpTrapOID, snmpTrapEnterprise');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (262, 'snmpOutPkts, snmpInTooBigs, snmpInNoSuchNames, snmpInBadValues, snmpInReadOnlys, snmpInGenErrs, snmpInTotalReqVars, snmpInTotalSetVars, snmpInGetRequests, snmpInGetNexts, snmpInSetRequests, snmpInGetResponses, snmpInTraps, snmpOutTooBigs, snmpOutNoSuchNames, snmpOutBadValues, snmpOutGenErrs, snmpOutGetRequests, snmpOutGetNexts, snmpOutSetRequests, snmpOutGetResponses, snmpOutTraps');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (341, 'ifIndex, ifDescr, ifType, ifSpeed, ifPhysAddress, ifAdminStatus, ifOperStatus, ifLastChange, ifLinkUpDownTrapEnable, ifConnectorPresent, ifHighSpeed, ifName, ifNumber, ifAlias, ifTableLastChange');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (342, 'ifInOctets, ifOutOctets, ifInUnknownProtos, ifInErrors, ifOutErrors');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (343, 'ifHCInOctets, ifHCOutOctets, ifInOctets, ifOutOctets, ifInUnknownProtos, ifInErrors, ifOutErrors');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (344, 'ifInOctets, ifOutOctets, ifInUnknownProtos, ifInErrors, ifOutErrors, ifMtu, ifInUcastPkts, ifInMulticastPkts, ifInBroadcastPkts, ifInDiscards, ifOutUcastPkts, ifOutMulticastPkts, ifOutBroadcastPkts, ifOutDiscards, ifPromiscuousMode');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (345, 'ifHCInOctets, ifHCOutOctets, ifInOctets, ifOutOctets, ifInUnknownProtos, ifInErrors, ifOutErrors, ifMtu, ifInUcastPkts, ifInMulticastPkts, ifInBroadcastPkts, ifInDiscards, ifOutUcastPkts, ifOutMulticastPkts, ifOutBroadcastPkts, ifOutDiscards, ifPromiscuousMode');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (346, 'ifHCInUcastPkts, ifHCInMulticastPkts, ifHCInBroadcastPkts, ifHCOutUcastPkts, ifHCOutMulticastPkts, ifHCOutBroadcastPkts, ifHCInOctets, ifHCOutOctets, ifInOctets, ifOutOctets, ifInUnknownProtos, ifInErrors, ifOutErrors, ifMtu, ifInUcastPkts, ifInMulticastPkts, ifInBroadcastPkts, ifInDiscards, ifOutUcastPkts, ifOutMulticastPkts, ifOutBroadcastPkts, ifOutDiscards, ifPromiscuousMode');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (347, 'ifRcvAddressStatus, ifRcvAddressType');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (348, 'ifStackStatus, ifStackLastChange');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (349, 'ifCounterDiscontinuityTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (359, 'ifDescr, ifType, ifSpeed, ifPhysAddress, ifAdminStatus, ifOperStatus, ifLastChange, ifLinkUpDownTrapEnable, ifConnectorPresent, ifHighSpeed, ifName');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (360, 'ifTestId, ifTestStatus, ifTestType, ifTestResult, ifTestCode, ifTestOwner');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (361, 'ifStackStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (362, 'ifInNUcastPkts, ifOutNUcastPkts, ifOutQLen, ifSpecific');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (379, 'snmpEngineID, snmpEngineBoots, snmpEngineTime, snmpEngineMaxMessageSize');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1585, 'sysApplInstallPkgManufacturer, sysApplInstallPkgProductName, sysApplInstallPkgVersion, sysApplInstallPkgSerialNumber, sysApplInstallPkgDate, sysApplInstallPkgLocation, sysApplInstallElmtName, sysApplInstallElmtType, sysApplInstallElmtDate, sysApplInstallElmtPath, sysApplInstallElmtSizeHigh, sysApplInstallElmtSizeLow, sysApplInstallElmtRole, sysApplInstallElmtModifyDate, sysApplInstallElmtCurSizeHigh, sysApplInstallElmtCurSizeLow');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1586, 'sysApplRunStarted, sysApplRunCurrentState, sysApplPastRunStarted, sysApplPastRunExitState, sysApplPastRunTimeEnded, sysApplElmtRunInstallID, sysApplElmtRunTimeStarted, sysApplElmtRunState, sysApplElmtRunName, sysApplElmtRunParameters, sysApplElmtRunCPU, sysApplElmtRunMemory, sysApplElmtRunNumFiles, sysApplElmtRunUser, sysApplElmtPastRunInstallID, sysApplElmtPastRunTimeStarted, sysApplElmtPastRunTimeEnded, sysApplElmtPastRunName, sysApplElmtPastRunParameters, sysApplElmtPastRunCPU, sysApplElmtPastRunMemory, sysApplElmtPastRunNumFiles, sysApplElmtPastRunUser, sysApplPastRunMaxRows, sysApplPastRunTableRemItems, sysApplPastRunTblTimeLimit, sysApplElemPastRunMaxRows, sysApplElemPastRunTableRemItems, sysApplElemPastRunTblTimeLimit, sysApplAgentPollInterval');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1587, 'sysApplMapInstallPkgIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5452, 'entLPPhysicalIndex, entAliasMappingIdentifier, entPhysicalChildIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5453, 'entLastChangeTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5535, 'cipPrecedenceSwitchedPkts, cipPrecedenceSwitchedBytes, cipMacSwitchedPkts, cipMacSwitchedBytes, cipMacFreeCount');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5590, 'cntpSysLeap, cntpSysStratum, cntpSysPrecision, cntpSysRootDelay, cntpSysRootDispersion, cntpSysRefId, cntpSysRefTime, cntpSysPoll, cntpSysPeer, cntpSysClock');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (926, 'vtpVersion, vtpMaxVlanStorage, vtpNotificationsEnabled, managementDomainName, managementDomainLocalMode, managementDomainConfigRevNumber, managementDomainLastUpdater, managementDomainLastChange, managementDomainTftpServer, managementDomainTftpPathname, managementDomainRowStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (927, 'vtpVlanState, vtpVlanType, vtpVlanName, vtpVlanMtu, vtpVlanDot10Said, vtpVlanRingNumber, vtpVlanBridgeNumber, vtpVlanStpType, vtpVlanParentVlan, vtpVlanTranslationalVlan1, vtpVlanTranslationalVlan2, vtpVlanBridgeType, vtpVlanAreHopCount, vtpVlanSteHopCount, vtpVlanIsCRFBackup');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (928, 'vtpVlanEditOperation, vtpVlanApplyStatus, vtpVlanEditBufferOwner, vtpVlanEditConfigRevNumber, vtpVlanEditState, vtpVlanEditType, vtpVlanEditName, vtpVlanEditMtu, vtpVlanEditDot10Said, vtpVlanEditRingNumber, vtpVlanEditBridgeNumber, vtpVlanEditStpType, vtpVlanEditParentVlan, vtpVlanEditRowStatus, vtpVlanEditTranslationalVlan1, vtpVlanEditTranslationalVlan2, vtpVlanEditBridgeType, vtpVlanEditAreHopCount, vtpVlanEditSteHopCount, vtpVlanEditIsCRFBackup');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (929, 'vtpInSummaryAdverts, vtpInSubsetAdverts, vtpInAdvertRequests, vtpOutSummaryAdverts, vtpOutSubsetAdverts, vtpOutAdvertRequests, vtpConfigRevNumberErrors, vtpConfigDigestErrors');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (930, 'vlanTrunkPortManagementDomain, vlanTrunkPortEncapsulationType, vlanTrunkPortVlansEnabled, vlanTrunkPortNativeVlan, vlanTrunkPortRowStatus, vlanTrunkPortSetSerialNo');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (931, 'vlanTrunkPortDynamicState, vlanTrunkPortDynamicStatus, vlanTrunkPortVtpEnabled');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (932, 'vlanTrunkPortEncapsulationOperType');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (933, 'vlanTrunkPortInJoins, vlanTrunkPortOutJoins, vlanTrunkPortOldAdverts, vlanTrunkPortVlansPruningEligible, vlanTrunkPortVlansXmitJoined, vlanTrunkPortVlansRcvJoined');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (934, 'managementDomainPruningState');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (935, 'managementDomainVersionInUse');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5450, 'entPhysicalDescr, entPhysicalVendorType, entPhysicalContainedIn, entPhysicalClass, entPhysicalParentRelPos, entPhysicalName');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5591, 'cntpPeersConfigured, cntpPeersPeerAddress, cntpPeersPeerPort, cntpPeersHostAddress, cntpPeersHostPort, cntpPeersLeap, cntpPeersMode, cntpPeersStratum, cntpPeersPeerPoll, cntpPeersHostPoll, cntpPeersPrecision, cntpPeersRootDelay, cntpPeersRootDispersion, cntpPeersRefId, cntpPeersRefTime, cntpPeersOrgTime, cntpPeersReceiveTime, cntpPeersTransmitTime, cntpPeersUpdateTime, cntpPeersReach, cntpPeersTimer, cntpPeersOffset, cntpPeersDelay, cntpPeersDispersion, cntpPeersFilterValidEntries, cntpPeersEntryStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5592, 'cntpFilterPeersOffset, cntpFilterPeersDelay, cntpFilterPeersDispersion');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5817, 'ciscoMemoryPoolName, ciscoMemoryPoolAlternate, ciscoMemoryPoolValid, ciscoMemoryPoolUsed, ciscoMemoryPoolFree, ciscoMemoryPoolLargestFree');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5829, 'cciDescr, cciStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (936, 'vtpVlanTypeExt, vtpVlanEditTypeExt, vlanTrunkPortVlansEnabled2k, vlanTrunkPortVlansEnabled3k, vlanTrunkPortVlansEnabled4k, vtpVlansPruningEligible2k, vtpVlansPruningEligible3k, vtpVlansPruningEligible4k, vlanTrunkPortVlansXmitJoined2k, vlanTrunkPortVlansXmitJoined3k, vlanTrunkPortVlansXmitJoined4k, vlanTrunkPortVlansRcvJoined2k, vlanTrunkPortVlansRcvJoined3k, vlanTrunkPortVlansRcvJoined4k');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (937, 'vlanTrunkPortsDot1qTag, vlanTrunkPortDot1qTunnel');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (994, 'cdpInterfaceEnable, cdpInterfaceMessageInterval, cdpCacheAddressType, cdpCacheAddress, cdpCacheVersion, cdpCacheDeviceId, cdpCacheDevicePort, cdpCacheCapabilities, cdpCachePlatform');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (995, 'cdpInterfaceEnable, cdpInterfaceMessageInterval, cdpInterfaceGroup, cdpInterfacePort, cdpCacheAddressType, cdpCacheAddress, cdpCacheVersion, cdpCacheDeviceId, cdpCacheDevicePort, cdpCacheCapabilities, cdpCachePlatform');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (996, 'cdpInterfaceEnable, cdpInterfaceGroup, cdpInterfacePort, cdpCacheAddressType, cdpCacheAddress, cdpCacheVersion, cdpCacheDeviceId, cdpCacheDevicePort, cdpCacheCapabilities, cdpCachePlatform, cdpGlobalRun, cdpGlobalMessageInterval, cdpGlobalHoldTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (997, 'cdpInterfaceEnable, cdpInterfaceGroup, cdpInterfacePort, cdpCacheAddressType, cdpCacheAddress, cdpCacheVersion, cdpCacheDeviceId, cdpCacheDevicePort, cdpCacheCapabilities, cdpCachePlatform, cdpCacheVTPMgmtDomain, cdpCacheNativeVLAN, cdpCacheDuplex, cdpGlobalRun, cdpGlobalMessageInterval, cdpGlobalHoldTime, cdpGlobalDeviceId');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (998, 'cdpCacheApplianceID, cdpCacheVlanID, cdpCachePowerConsumption, cdpCacheMTU, cdpCacheSysName, cdpCacheSysObjectID, cdpCacheLastChange, cdpCachePhysLocation, cdpCachePrimaryMgmtAddrType, cdpCachePrimaryMgmtAddr, cdpCacheSecondaryMgmtAddrType, cdpCacheSecondaryMgmtAddr, cdpGlobalLastChange, cdpGlobalDeviceIdFormatCpb, cdpGlobalDeviceIdFormat');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (999, 'cdpInterfaceExtendedTrust, cdpInterfaceCosForUntrustedPort');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1055, 'ciscoEnvMonPresent,  ciscoEnvMonVoltageStatusDescr, ciscoEnvMonVoltageStatusValue, ciscoEnvMonVoltageThresholdLow, ciscoEnvMonVoltageThresholdHigh, ciscoEnvMonVoltageLastShutdown, ciscoEnvMonVoltageState,  ciscoEnvMonTemperatureStatusDescr, ciscoEnvMonTemperatureStatusValue, ciscoEnvMonTemperatureThreshold, ciscoEnvMonTemperatureLastShutdown, ciscoEnvMonTemperatureState,  ciscoEnvMonFanStatusDescr, ciscoEnvMonFanState,  ciscoEnvMonSupplyStatusDescr, ciscoEnvMonSupplyState, ciscoEnvMonSupplySource,  ciscoEnvMonAlarmContacts,  ciscoEnvMonEnableShutdownNotification, ciscoEnvMonEnableVoltageNotification, ciscoEnvMonEnableTemperatureNotification, ciscoEnvMonEnableFanNotification, ciscoEnvMonEnableRedundantSupplyNotification');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1056, 'ciscoEnvMonPresent,  ciscoEnvMonVoltageStatusDescr, ciscoEnvMonVoltageStatusValue, ciscoEnvMonVoltageThresholdLow, ciscoEnvMonVoltageThresholdHigh, ciscoEnvMonVoltageLastShutdown, ciscoEnvMonVoltageState,  ciscoEnvMonTemperatureStatusDescr, ciscoEnvMonTemperatureStatusValue, ciscoEnvMonTemperatureThreshold, ciscoEnvMonTemperatureLastShutdown, ciscoEnvMonTemperatureState,  ciscoEnvMonFanStatusDescr, ciscoEnvMonFanState,  ciscoEnvMonSupplyStatusDescr, ciscoEnvMonSupplyState, ciscoEnvMonSupplySource,  ciscoEnvMonAlarmContacts,  ciscoEnvMonEnableShutdownNotification');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1057, 'ciscoEnvMonEnableStatChangeNotif');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1086, 'cfcRequestMaximum, cfcRequests, cfcRequestsHigh, cfcRequestsBumped, cfcRequestOperation, cfcRequestLocalFile, cfcRequestRemoteFile, cfcRequestServer, cfcRequestUser, cfcRequestPassword, cfcRequestResult, cfcRequestCompletionTime, cfcRequestStop, cfcRequestOperationState, cfcRequestEntryStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1124, 'clogNotificationsSent, clogNotificationsEnabled, clogMaxSeverity, clogMsgIgnores, clogMsgDrops, clogHistTableMaxLength, clogHistMsgsFlushed, clogHistFacility, clogHistSeverity, clogHistMsgName, clogHistMsgText, clogHistTimestamp');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1126, 'clogMaxServers, clogServerStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1127, 'clogOriginIDType, clogOriginID');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (6340, 'lldpNotificationInterval, lldpPortConfigNotificationEnable');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (6341, 'lldpMessageTxInterval, lldpMessageTxHoldMultiplier, lldpReinitDelay, lldpTxDelay, lldpPortConfigTLVsTxEnable, lldpConfigManAddrPortsTxEnable');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1196, 'applName, applVersion, applUptime, applOperStatus, applLastChange, applInboundAssociations, applOutboundAssociations, applAccumulatedInboundAssociations, applAccumulatedOutboundAssociations, applLastInboundActivity, applLastOutboundActivity, applRejectedInboundAssociations, applFailedOutboundAssociations');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1197, 'assocRemoteApplication, assocApplicationProtocol, assocApplicationType, assocDuration');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1198, 'applName, applVersion, applUptime, applOperStatus, applLastChange, applInboundAssociations, applOutboundAssociations, applAccumulatedInboundAssociations, applAccumulatedOutboundAssociations, applLastInboundActivity, applLastOutboundActivity, applRejectedInboundAssociations, applFailedOutboundAssociations, applDescription, applURL');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1199, 'assocRemoteApplication, assocApplicationProtocol, assocApplicationType, assocDuration');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1200, 'applName, applDirectoryName, applVersion, applUptime, applOperStatus, applLastChange, applInboundAssociations, applOutboundAssociations, applAccumulatedInboundAssociations, applAccumulatedOutboundAssociations, applLastInboundActivity, applLastOutboundActivity, applRejectedInboundAssociations, applFailedOutboundAssociations, applDescription, applURL');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (1201, 'assocRemoteApplication, assocApplicationProtocol, assocApplicationType, assocDuration');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5791, 'cseL2ForwardedLocalPkts, cseL2ForwardedLocalOctets, cseL2ForwardedTotalPkts, cseL2NewAddressLearns, cseL2AddrLearnFailures, cseL2DstAddrLookupMisses, cseL3SwitchedTotalPkts, cseL3SwitchedTotalOctets, cseL3CandidateFlowHits, cseL3EstablishedFlowHits, cseL3ActiveFlows, cseL3FlowLearnFailures, cseL3IntFlowInvalids, cseL3ExtFlowInvalids, cseL2HCOverflowForwardedLocalPkts, cseL2HCForwardedLocalPkts, cseL2HCOverflowForwardedTotalPkts, cseL2HCForwardedTotalPkts, cseL2HCOverflowIpPkts, cseL2HCIpPkts, cseL2HCOverflowIpxPkts, cseL2HCIpxPkts, cseL2HCOverflowAssignedProtoPkts, cseL2HCAssignedProtoPkts, cseL2HCOverflowOtherProtoPkts, cseL2HCOtherProtoPkts');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4989, 'usrHistoryControlObjects, usrHistoryControlBucketsRequested, usrHistoryControlBucketsGranted, usrHistoryControlInterval, usrHistoryControlOwner, usrHistoryControlStatus, usrHistoryObjectVariable, usrHistoryObjectSampleType, usrHistoryIntervalStart, usrHistoryIntervalEnd, usrHistoryAbsValue, usrHistoryValStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4990, 'probeCapabilities, probeSoftwareRev, probeHardwareRev, probeDateTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5792, 'cseStatsFlowAged, cseStatsFlowPurged, cseStatsFlowParityFail, cseCacheUtilization');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5793, 'cseL3VlanInPkts, cseL3VlanInOctets, cseL3VlanOutPkts, cseL3VlanOutOctets');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5794, 'cseRouterFlowMask, cseRouterName, cseRouterStatic, cseStaticRouterOwner, cseStaticRouterName, cseStaticRouterType, cseStaticRouterStatus, cseRouterIpxFlowMask, cseStaticIpxRouterOwner, cseStaticIpxRouterName, cseStaticIpxRouterStatus, cseRouterMac, cseRouterProtocol');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (6342, 'lldpStatsRemTablesLastChangeTime, lldpStatsRemTablesInserts, lldpStatsRemTablesDeletes, lldpStatsRemTablesDrops, lldpStatsRemTablesAgeouts, lldpStatsRxPortFramesDiscardedTotal, lldpStatsRxPortFramesErrors, lldpStatsRxPortFramesTotal, lldpStatsRxPortTLVsDiscardedTotal, lldpStatsRxPortTLVsUnrecognizedTotal, lldpStatsRxPortAgeoutsTotal');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (6343, 'lldpStatsTxPortFramesTotal');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5795, 'cseFlowEstablishedAgingTime, cseFlowFastAgingTime, cseFlowFastAgePktThreshold, cseFlowIPXEstablishedAgingTime, cseFlowMaxQueries, cseFlowQueryMask, cseFlowQueryTransport, cseFlowQuerySource, cseFlowQuerySourceMask, cseFlowQueryDestination, cseFlowQueryDestinationMask, cseFlowQueryRouterIndex, cseFlowQueryOwner, cseFlowQueryResultingRows, cseFlowQueryResultTotalPkts, cseFlowQueryResultTotalOctets, cseFlowQueryResultAvgDuration, cseFlowQueryResultAvgIdle, cseFlowQueryStatus, cseFlowQueryCreateTime, cseFlowDataSrcMac, cseFlowDataDstMac, cseFlowDataEncapType, cseFlowDataSource, cseFlowDataStaticFlow, cseFlowDataDestination, cseFlowDataDestVlan, cseFlowDataIpQOS, cseFlowDataIpQOSPolicy, cseFlowDataWhenCreated, cseFlowDataLastUsed, cseFlowDataPkts, cseFlowDataOctets, cseFlowSwitchStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5796, 'cseNetflowLSExportHost, cseNetflowLSExportTransportNumber, cseNetflowLSExportStatus, cseNetflowLSExportDataSource, cseNetflowLSExportDataSourceMask, cseNetflowLSExportDataDest, cseNetflowLSExportDataDestMask, cseNetflowLSExportDataProtocol, cseNetflowLSExportDataFilterSelection, cseNetflowLSExportNDEVersionNumber');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5797, 'cseProtocolFilterPortAdminStatus, cseProtocolFilterPortOperStatus, cseL2IpPkts, cseL2IpxPkts, cseL2AssignedProtoPkts, cseL2OtherProtoPkts');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5798, 'cseFlowMcastMaxQueries, cseFlowMcastQueryMask, cseFlowMcastQuerySrc, cseFlowMcastQueryGrp, cseFlowMcastQuerySrcVlan, cseFlowMcastQueryRtrIndex, cseFlowMcastQuerySkipNFlows, cseFlowMcastQueryOwner, cseFlowMcastQueryTotalFlows, cseFlowMcastQueryRows, cseFlowMcastQueryStatus, cseFlowMcastQueryCreateTime, cseFlowMcastResultSrc, cseFlowMcastResultGrp, cseFlowMcastResultSrcVlan, cseFlowMcastResultRtrIp, cseFlowMcastResultRtrMac, cseFlowMcastResultCreatedTS, cseFlowMcastResultLastUsedTS, cseFlowMcastResultPkts, cseFlowMcastResultOctets, cseFlowMcastResultDstVlans, cseFlowMcastSwitchStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5799, 'cseUcastCacheFlowType, cseUcastCacheTransport, cseUcastCacheDest, cseUcastCacheDestMask, cseUcastCacheSource, cseUcastCacheSrcMask, cseUcastCacheRtrIp, cseUcastCacheOwner, cseUcastCacheStatus, cseUcastCacheResult');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2014, 'dot1dBaseBridgeAddress, dot1dBaseNumPorts, dot1dBaseType');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2015, 'dot1dBasePort, dot1dBasePortIfIndex, dot1dBasePortCircuit,  dot1dBasePortDelayExceededDiscards, dot1dBasePortMtuExceededDiscards');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2016, 'dot1dStpProtocolSpecification, dot1dStpPriority, dot1dStpTimeSinceTopologyChange, dot1dStpTopChanges, dot1dStpDesignatedRoot, dot1dStpRootCost, dot1dStpRootPort, dot1dStpMaxAge, dot1dStpHelloTime, dot1dStpHoldTime, dot1dStpForwardDelay, dot1dStpBridgeMaxAge, dot1dStpBridgeHelloTime, dot1dStpBridgeForwardDelay');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2017, 'dot1dStpPort, dot1dStpPortPriority, dot1dStpPortState, dot1dStpPortEnable, dot1dStpPortPathCost, dot1dStpPortDesignatedRoot, dot1dStpPortDesignatedCost, dot1dStpPortDesignatedBridge, dot1dStpPortDesignatedPort, dot1dStpPortForwardTransitions');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2018, 'dot1dStpPort, dot1dStpPortPriority, dot1dStpPortState, dot1dStpPortEnable, dot1dStpPortDesignatedRoot, dot1dStpPortDesignatedCost, dot1dStpPortDesignatedBridge, dot1dStpPortDesignatedPort, dot1dStpPortForwardTransitions, dot1dStpPortPathCost32');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2019, 'dot1dStpPortPathCost32');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2020, 'dot1dTpLearnedEntryDiscards, dot1dTpAgingTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2021, 'dot1dTpFdbAddress, dot1dTpFdbPort, dot1dTpFdbStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2022, 'dot1dTpPort, dot1dTpPortMaxInfo, dot1dTpPortInFrames, dot1dTpPortOutFrames, dot1dTpPortInDiscards');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2023, 'dot1dStaticAddress, dot1dStaticReceivePort, dot1dStaticAllowedToGoTo, dot1dStaticStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5800, 'cseMcastCacheFlowType, cseMcastCacheGrp, cseMcastCacheSrc, cseMcastCacheRtrIp, cseMcastCacheOwner, cseMcastCacheStatus, cseMcastCacheResult');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (6339, 'lldpPortConfigAdminStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2138, 'dot1dDeviceCapabilities, dot1dPortCapabilities');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2139, 'dot1dGmrpStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2140, 'dot1dTrafficClassesEnabled');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2141, 'dot1dPortDefaultUserPriority');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2142, 'dot1dRegenUserPriority');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2143, 'dot1dPortNumTrafficClasses, dot1dTrafficClass');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2144, 'dot1dPortOutboundAccessPriority');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2145, 'dot1dPortGarpJoinTime, dot1dPortGarpLeaveTime, dot1dPortGarpLeaveAllTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2146, 'dot1dPortGmrpStatus, dot1dPortGmrpFailedRegistrations, dot1dPortGmrpLastPduOrigin');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2147, 'dot1dTpHCPortInFrames, dot1dTpHCPortOutFrames, dot1dTpHCPortInDiscards');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2148, 'dot1dTpPortInOverflowFrames, dot1dTpPortOutOverflowFrames, dot1dTpPortInOverflowDiscards');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (2149, 'dot1dPortGmrpStatus, dot1dPortGmrpFailedRegistrations, dot1dPortGmrpLastPduOrigin, dot1dPortRestrictedGroupRegistration');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4982, 'protocolDirLastChange, protocolDirLocalIndex, protocolDirDescr, protocolDirType, protocolDirAddressMapConfig, protocolDirHostConfig, protocolDirMatrixConfig,      protocolDirOwner, protocolDirStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4983, 'protocolDistControlDataSource, protocolDistControlDroppedFrames, protocolDistControlCreateTime, protocolDistControlOwner, protocolDistControlStatus, protocolDistStatsPkts, protocolDistStatsOctets');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4984, 'addressMapInserts, addressMapDeletes, addressMapMaxDesiredEntries, addressMapControlDataSource, addressMapControlDroppedFrames, addressMapControlOwner, addressMapControlStatus, addressMapPhysicalAddress, addressMapLastChange');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4985, 'hlHostControlDataSource, hlHostControlNlDroppedFrames, hlHostControlNlInserts, hlHostControlNlDeletes, hlHostControlNlMaxDesiredEntries, hlHostControlAlDroppedFrames, hlHostControlAlInserts, hlHostControlAlDeletes, hlHostControlAlMaxDesiredEntries, hlHostControlOwner, hlHostControlStatus, nlHostInPkts, nlHostOutPkts, nlHostInOctets, nlHostOutOctets, nlHostOutMacNonUnicastPkts, nlHostCreateTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4986, 'hlMatrixControlDataSource, hlMatrixControlNlDroppedFrames, hlMatrixControlNlInserts, hlMatrixControlNlDeletes, hlMatrixControlNlMaxDesiredEntries, hlMatrixControlAlDroppedFrames, hlMatrixControlAlInserts, hlMatrixControlAlDeletes, hlMatrixControlAlMaxDesiredEntries, hlMatrixControlOwner, hlMatrixControlStatus, nlMatrixSDPkts, nlMatrixSDOctets, nlMatrixSDCreateTime, nlMatrixDSPkts, nlMatrixDSOctets, nlMatrixDSCreateTime, nlMatrixTopNControlMatrixIndex, nlMatrixTopNControlRateBase, nlMatrixTopNControlTimeRemaining, nlMatrixTopNControlGeneratedReports, nlMatrixTopNControlDuration, nlMatrixTopNControlRequestedSize, nlMatrixTopNControlGrantedSize, nlMatrixTopNControlStartTime, nlMatrixTopNControlOwner, nlMatrixTopNControlStatus, nlMatrixTopNProtocolDirLocalIndex, nlMatrixTopNSourceAddress, nlMatrixTopNDestAddress, nlMatrixTopNPktRate, nlMatrixTopNReversePktRate, nlMatrixTopNOctetRate, nlMatrixTopNReverseOctetRate');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4987, 'alHostInPkts, alHostOutPkts, alHostInOctets, alHostOutOctets, alHostCreateTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4988, 'alMatrixSDPkts, alMatrixSDOctets, alMatrixSDCreateTime, alMatrixDSPkts, alMatrixDSOctets, alMatrixDSCreateTime, alMatrixTopNControlMatrixIndex, alMatrixTopNControlRateBase, alMatrixTopNControlTimeRemaining, alMatrixTopNControlGeneratedReports, alMatrixTopNControlDuration, alMatrixTopNControlRequestedSize, alMatrixTopNControlGrantedSize, alMatrixTopNControlStartTime, alMatrixTopNControlOwner, alMatrixTopNControlStatus, alMatrixTopNProtocolDirLocalIndex, alMatrixTopNSourceAddress, alMatrixTopNDestAddress, alMatrixTopNAppProtocolDirLocalIndex, alMatrixTopNPktRate, alMatrixTopNReversePktRate, alMatrixTopNOctetRate, alMatrixTopNReverseOctetRate');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4991, 'probeResetControl, probeDownloadFile, probeDownloadTFTPServer, probeDownloadAction, probeDownloadStatus, serialMode, serialProtocol, serialTimeout, serialModemInitString, serialModemHangUpString, serialModemConnectResp, serialModemNoConnectResp, serialDialoutTimeout, serialStatus, netConfigIPAddress, netConfigSubnetMask, netConfigStatus, netDefaultGateway, trapDestCommunity, trapDestProtocol, trapDestAddress, trapDestOwner, trapDestStatus, serialConnectDestIpAddress, serialConnectType, serialConnectDialString, serialConnectSwitchConnectSeq, serialConnectSwitchDisconnectSeq, serialConnectSwitchResetSeq, serialConnectOwner, serialConnectStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4992, 'historyControlDroppedFrames, hostControlDroppedFrames, hostControlCreateTime, matrixControlDroppedFrames, matrixControlCreateTime, channelDroppedFrames, channelCreateTime, filterProtocolDirDataLocalIndex, filterProtocolDirLocalIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4993, 'etherStatsDroppedFrames, etherStatsCreateTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (4994, 'tokenRingMLStatsDroppedFrames,      tokenRingMLStatsCreateTime, tokenRingPStatsDroppedFrames, tokenRingPStatsCreateTime, ringStationControlDroppedFrames, ringStationControlCreateTime, sourceRoutingStatsDroppedFrames, sourceRoutingStatsCreateTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5106, 'dot1qVlanVersionNumber, dot1qMaxVlanId, dot1qMaxSupportedVlans, dot1qNumVlans, dot1qGvrpStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5107, 'dot1qFdbDynamicCount, dot1qTpFdbPort, dot1qTpFdbStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5108, 'dot1qTpGroupEgressPorts, dot1qTpGroupLearnt');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5109, 'dot1qForwardAllPorts, dot1qForwardAllStaticPorts, dot1qForwardAllForbiddenPorts, dot1qForwardUnregisteredPorts, dot1qForwardUnregisteredStaticPorts, dot1qForwardUnregisteredForbiddenPorts');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5110, 'dot1qStaticUnicastAllowedToGoTo, dot1qStaticUnicastStatus, dot1qStaticMulticastStaticEgressPorts, dot1qStaticMulticastForbiddenEgressPorts, dot1qStaticMulticastStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5111, 'dot1qVlanNumDeletes, dot1qVlanFdbId, dot1qVlanCurrentEgressPorts, dot1qVlanCurrentUntaggedPorts, dot1qVlanStatus, dot1qVlanCreationTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5112, 'dot1qVlanStaticName, dot1qVlanStaticEgressPorts, dot1qVlanForbiddenEgressPorts, dot1qVlanStaticUntaggedPorts, dot1qVlanStaticRowStatus, dot1qNextFreeLocalVlanIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5113, 'dot1qPvid, dot1qPortAcceptableFrameTypes, dot1qPortIngressFiltering, dot1qPortGvrpStatus, dot1qPortGvrpFailedRegistrations, dot1qPortGvrpLastPduOrigin');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5114, 'dot1qTpVlanPortInFrames, dot1qTpVlanPortOutFrames, dot1qTpVlanPortInDiscards');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5115, 'dot1qTpVlanPortInOverflowFrames, dot1qTpVlanPortOutOverflowFrames, dot1qTpVlanPortInOverflowDiscards');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5116, 'dot1qTpVlanPortHCInFrames, dot1qTpVlanPortHCOutFrames, dot1qTpVlanPortHCInDiscards');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5117, 'dot1qConstraintType, dot1qConstraintStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5118, 'dot1qConstraintSetDefault, dot1qConstraintTypeDefault');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5119, 'dot1vProtocolGroupId, dot1vProtocolGroupRowStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5120, 'dot1vProtocolPortGroupVid, dot1vProtocolPortRowStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5121, 'dot1qPvid, dot1qPortAcceptableFrameTypes, dot1qPortIngressFiltering, dot1qPortGvrpStatus, dot1qPortGvrpFailedRegistrations, dot1qPortGvrpLastPduOrigin, dot1qPortRestrictedVlanRegistration');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5298, 'cfmFlowMonitorDescr, cfmFlowMonitorCaps, cfmFlowMonitorFlowCount, cfmFlowMonitorConditionsProfile, cfmFlowMonitorConditions, cfmFlowMonitorAlarms, cfmFlowMonitorAlarmSeverity, cfmFlowMonitorAlarmCriticalCount, cfmFlowMonitorAlarmMajorCount, cfmFlowMonitorAlarmMinorCount, cfmFlowMonitorAlarmWarningCount, cfmFlowMonitorAlarmInfoCount, cfmFlowMonitorTableChanged');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5299, 'cfmFlowDescr, cfmFlowNext, cfmFlowCreateTime, cfmFlowDiscontinuityTime, cfmFlowExpirationTime, cfmFlowDirection, cfmFlowAdminStatus, cfmFlowOperStatus, cfmFlowIngressType, cfmFlowIngress, cfmFlowEgressType, cfmFlowEgress, cfmFlowTableChanged, cfmFlowL2VlanNext, cfmFlowL2VlanId, cfmFlowL2VlanCos, cfmFlowL2VlanTableChanged, cfmFlowIpNext, cfmFlowIpAddrType, cfmFlowIpAddrSrc, cfmFlowIpAddrDst, cfmFlowIpValid, cfmFlowIpTrafficClass, cfmFlowIpHopLimit, cfmFlowIpTableChanged, cfmFlowUdpNext, cfmFlowUdpPortSrc, cfmFlowUdpPortDst, cfmFlowUdpTableChanged, cfmFlowTcpNext, cfmFlowTcpPortSrc, cfmFlowTcpPortDst, cfmFlowTcpTableChanged, cfmFlowRtpNext, cfmFlowRtpVersion, cfmFlowRtpSsrc, cfmFlowRtpPayloadType, cfmFlowRtpTableChanged');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5300, 'cfmFlowMetricsCollected, cfmFlowMetricsIntervalTime, cfmFlowMetricsMaxIntervals, cfmFlowMetricsElapsedTime, cfmFlowMetricsIntervals, cfmFlowMetricsInvalidIntervals, cfmFlowMetricsConditionsProfile, cfmFlowMetricsConditions, cfmFlowMetricsAlarms, cfmFlowMetricsAlarmSeverity, cfmFlowMetricsPkts, cfmFlowMetricsOctets, cfmFlowMetricsBitRateUnits, cfmFlowMetricsBitRate, cfmFlowMetricsPktRate, cfmFlowMetricsTableChanged, cfmFlowMetricsIntValid, cfmFlowMetricsIntTime, cfmFlowMetricsIntConditions, cfmFlowMetricsIntAlarms, cfmFlowMetricsIntAlarmSeverity, cfmFlowMetricsIntPkts, cfmFlowMetricsIntOctets, cfmFlowMetricsIntBitRateUnits, cfmFlowMetricsIntBitRate, cfmFlowMetricsIntPktRate');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5301, 'cfmConditionDescr, cfmConditionMonitoredElement, cfmConditionType, cfmConditionThreshRiseScale, cfmConditionThreshRisePrecision, cfmConditionThreshRise, cfmConditionThreshFallScale, cfmConditionThreshFallPrecision, cfmConditionThreshFall, cfmConditionSampleType, cfmConditionSampleWindow, cfmConditionAlarm, cfmConditionAlarmActions, cfmConditionAlarmSeverity, cfmConditionAlarmGroup, cfmConditionTableChanged');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5302, 'cfmAlarmGroupDescr, cfmAlarmGroupConditionsProfile, cfmAlarmGroupConditionId, cfmAlarmGroupFlowSet, cfmAlarmGroupFlowCount, cfmAlarmGroupThresholdUnits, cfmAlarmGroupThreshold, cfmAlarmGroupRaised, cfmAlarmGroupCurrentCount, cfmAlarmGroupTableChanged, cfmAlarmGroupFlowId, cfmAlarmGroupFlowTableChanged');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5303, 'cfmAlarmHistorySize, cfmAlarmHistoryLastId, cfmAlarmHistoryType, cfmAlarmHistoryEntity, cfmAlarmHistoryConditionsProfile, cfmAlarmHistoryConditionId, cfmAlarmHistorySeverity, cfmAlarmHistoryTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5304, 'cfmNotifyEnable');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5347, 'cfmIpCbrMetricsCfgRateType, cfmIpCbrMetricsCfgBitRate, cfmIpCbrMetricsCfgRate, cfmIpCbrMetricsCfgMediaPktSize, cfmIpCbrMetricsValid, cfmIpCbrMetricsLostPkts, cfmIpCbrMetricsMrvScale, cfmIpCbrMetricsMrvPrecision, cfmIpCbrMetricsMrv, cfmIpCbrMetricsTableChanged, cfmIpCbrMetricsIntValid, cfmIpCbrMetricsIntLostPkts, cfmIpCbrMetricsIntVbMin, cfmIpCbrMetricsIntVbMax, cfmIpCbrMetricsIntMrUnits, cfmIpCbrMetricsIntMr, cfmIpCbrMetricsIntDfScale, cfmIpCbrMetricsIntDfPrecision, cfmIpCbrMetricsIntDf, cfmIpCbrMetricsIntMrvScale, cfmIpCbrMetricsIntMrvPrecision, cfmIpCbrMetricsIntMrv');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5408, 'cfmRtpMetricsValid, cfmRtpMetricsExpectedPkts, cfmRtpMetricsLostPkts, cfmRtpMetricsFracScale, cfmRtpMetricsFracPrecision, cfmRtpMetricsFrac, cfmRtpMetricsLIs, cfmRtpMetricsAvgLDScale, cfmRtpMetricsAvgLDPrecision, cfmRtpMetricsAvgLD, cfmRtpMetricsAvgLossDistance, cfmRtpMetricsJitterScale, cfmRtpMetricsJitterPrecision, cfmRtpMetricsJitter, cfmRtpMetricsTableChanged, cfmRtpMetricsIntValid, cfmRtpMetricsIntExpectedPkts, cfmRtpMetricsIntLostPkts, cfmRtpMetricsIntFracScale, cfmRtpMetricsIntFracPrecision, cfmRtpMetricsIntFrac, cfmRtpMetricsIntLIs, cfmRtpMetricsIntAvgLDScale, cfmRtpMetricsIntAvgLDPrecision, cfmRtpMetricsIntAvgLD, cfmRtpMetricsIntAvgLossDistance, cfmRtpMetricsIntJitterScale, cfmRtpMetricsIntJitterPrecision, cfmRtpMetricsIntJitter, cfmRtpMetricsIntTransitScale, cfmRtpMetricsIntTransitPrecision, cfmRtpMetricsIntTransit');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5451, 'entLogicalDescr, entLogicalType, entLogicalCommunity, entLogicalTAddress, entLogicalTDomain');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (6344, 'lldpLocChassisIdSubtype, lldpLocChassisId, lldpLocPortIdSubtype, lldpLocPortId, lldpLocPortDesc, lldpLocSysDesc, lldpLocSysName, lldpLocSysCapSupported, lldpLocSysCapEnabled, lldpLocManAddrLen, lldpLocManAddrIfSubtype, lldpLocManAddrIfId, lldpLocManAddrOID');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (6345, 'lldpRemChassisIdSubtype, lldpRemChassisId, lldpRemPortIdSubtype, lldpRemPortId, lldpRemPortDesc, lldpRemSysName, lldpRemSysDesc, lldpRemSysCapSupported, lldpRemSysCapEnabled, lldpRemManAddrIfSubtype, lldpRemManAddrIfId, lldpRemManAddrOID, lldpRemUnknownTLVInfo, lldpRemOrgDefInfo');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5854, 'ceAssetOEMString, ceAssetSerialNumber, ceAssetOrderablePartNumber, ceAssetHardwareRevision, ceAssetMfgAssyNumber, ceAssetMfgAssyRevision, ceAssetFirmwareID, ceAssetFirmwareRevision, ceAssetSoftwareID, ceAssetSoftwareRevision, ceAssetCLEI, ceAssetAlias, ceAssetTag, ceAssetIsFRU');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (5903, 'charNumber, charPortIndex, charPortName, charPortType, charPortHardware, charPortReset, charPortAdminStatus, charPortOperStatus, charPortLastChange, charPortInFlowState, charPortOutFlowState, charPortAdminOrigin, charPortSessionMaximum, charPortInFlowTypes, charPortOutFlowTypes, charPortInCharacters, charPortOutCharacters, charPortSessionNumber, charPortSessionIndex, charPortLowerIfIndex, charSessPortIndex, charSessIndex, charSessKill, charSessState, charSessProtocol, charSessOperOrigin, charSessInCharacters, charSessOutCharacters, charSessConnectionId, charSessStartTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7200, 'ccmGroupName, ccmGroupTftpDefault, ccmName, ccmDescription, ccmVersion, ccmStatus, ccmCMGroupMappingCMPriority, ccmRegionName, ccmRegionAvailableBandWidth, ccmTimeZoneName, ccmTimeZoneOffset, ccmDevicePoolName, ccmDevicePoolRegionIndex, ccmDevicePoolTimeZoneIndex, ccmDevicePoolGroupIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7201, 'ccmPhonePhysicalAddress, ccmPhoneType, ccmPhoneDescription, ccmPhoneUserName, ccmPhoneIpAddress, ccmPhoneStatus, ccmPhoneTimeLastRegistered, ccmPhoneE911Location, ccmPhoneLoadID, ccmPhoneLastError, ccmPhoneTimeLastError, ccmPhoneDevicePoolIndex, ccmPhoneExtension, ccmPhoneExtensionIpAddress, ccmPhoneExtensionMultiLines, ccmActivePhones, ccmInActivePhones');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7202, 'ccmGatewayName, ccmGatewayType, ccmGatewayDescription, ccmGatewayStatus, ccmGatewayDevicePoolIndex, ccmGatewayTrunkType, ccmGatewayTrunkName, ccmTrunkGatewayIndex, ccmGatewayTrunkStatus, ccmActiveGateways, ccmInActiveGateways');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7203, 'ccmGroupName, ccmGroupTftpDefault, ccmName, ccmDescription, ccmVersion, ccmStatus, ccmInetAddressType, ccmInetAddress, ccmClusterId, ccmCMGroupMappingCMPriority, ccmRegionName, ccmRegionAvailableBandWidth, ccmTimeZoneName, ccmTimeZoneOffset, ccmDevicePoolName, ccmDevicePoolRegionIndex, ccmDevicePoolTimeZoneIndex, ccmDevicePoolGroupIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7204, 'ccmPhonePhysicalAddress, ccmPhoneType, ccmPhoneDescription, ccmPhoneUserName, ccmPhoneInetAddressType, ccmPhoneInetAddress, ccmPhoneStatus, ccmPhoneTimeLastRegistered, ccmPhoneE911Location, ccmPhoneLoadID, ccmPhoneLastError, ccmPhoneTimeLastError, ccmPhoneDevicePoolIndex, ccmPhoneExtension, ccmPhoneExtensionInetAddressType, ccmPhoneExtensionInetAddress, ccmPhoneExtensionMultiLines, ccmActivePhones, ccmInActivePhones');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7205, 'ccmGatewayName, ccmGatewayType, ccmGatewayDescription, ccmGatewayStatus, ccmGatewayDevicePoolIndex, ccmGatewayInetAddressType, ccmGatewayInetAddress, ccmActiveGateways, ccmInActiveGateways');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7206, 'ccmMediaDeviceName, ccmMediaDeviceType, ccmMediaDeviceDescription, ccmMediaDeviceStatus, ccmMediaDeviceDevicePoolIndex, ccmMediaDeviceInetAddressType, ccmMediaDeviceInetAddress');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7207, 'ccmGatekeeperName, ccmGatekeeperType, ccmGatekeeperDescription, ccmGatekeeperStatus, ccmGatekeeperDevicePoolIndex, ccmGatekeeperInetAddressType, ccmGatekeeperInetAddress');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7208, 'ccmCTIDeviceName, ccmCTIDeviceType, ccmCTIDeviceDescription, ccmCTIDeviceStatus, ccmCTIDevicePoolIndex, ccmCTIDeviceInetAddressType, ccmCTIDeviceInetAddress, ccmCTIDeviceAppInfo, ccmCTIDeviceDirNum');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7209, 'ccmAlarmSeverity, ccmCallManagerAlarmEnable, ccmFailCauseCode, ccmPhoneFailures, ccmPhoneFailedTime, ccmPhoneFailedName, ccmPhoneFailedInetAddressType, ccmPhoneFailedInetAddress, ccmPhoneFailCauseCode, ccmPhoneFailedAlarmInterval, ccmPhoneFailedStorePeriod, ccmPhoneUpdates, ccmPhoneStatusPhoneIndex, ccmPhoneStatusUpdateTime, ccmPhoneStatusUpdateType, ccmPhoneStatusUpdateAlarmInterv, ccmPhoneStatusUpdateStorePeriod, ccmGatewayAlarmEnable, ccmGatewayFailCauseCode, ccmMediaResourceType, ccmMediaResourceListName, ccmRouteListName, ccmGatewayPhysIfIndex, ccmGatewayPhysIfL2Status');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7211, 'ccmGroupName, ccmGroupTftpDefault, ccmName, ccmDescription, ccmVersion, ccmStatus, ccmInetAddressType, ccmInetAddress, ccmClusterId, ccmCMGroupMappingCMPriority, ccmRegionName, ccmRegionAvailableBandWidth, ccmTimeZoneName, ccmTimeZoneOffsetHours, ccmTimeZoneOffsetMinutes, ccmDevicePoolName, ccmDevicePoolRegionIndex, ccmDevicePoolTimeZoneIndex, ccmDevicePoolGroupIndex, ccmCallManagerStartTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7212, 'ccmPhonePhysicalAddress, ccmPhoneType, ccmPhoneDescription, ccmPhoneUserName, ccmPhoneInetAddressType, ccmPhoneInetAddress, ccmPhoneStatus, ccmPhoneTimeLastRegistered, ccmPhoneE911Location, ccmPhoneLoadID, ccmPhoneDevicePoolIndex, ccmPhoneStatusReason, ccmPhoneTimeLastStatusUpdt, ccmPhoneExtn, ccmPhoneExtnMultiLines, ccmPhoneExtnInetAddressType, ccmPhoneExtnInetAddress, ccmRegisteredPhones, ccmUnregisteredPhones, ccmRejectedPhones, ccmPhoneTableStateId, ccmPhoneExtensionTableStateId');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7213, 'ccmGatewayName, ccmGatewayType, ccmGatewayDescription, ccmGatewayStatus, ccmGatewayDevicePoolIndex, ccmGatewayInetAddressType, ccmGatewayInetAddress, ccmGatewayProductId, ccmGatewayStatusReason, ccmGatewayTimeLastStatusUpdt, ccmGatewayTimeLastRegistered, ccmGatewayDChannelStatus, ccmGatewayDChannelNumber, ccmRegisteredGateways, ccmUnregisteredGateways, ccmRejectedGateways, ccmGatewayTableStateId');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7214, 'ccmMediaDeviceName, ccmMediaDeviceType, ccmMediaDeviceDescription, ccmMediaDeviceStatus, ccmMediaDeviceDevicePoolIndex, ccmMediaDeviceInetAddressType, ccmMediaDeviceInetAddress, ccmMediaDeviceStatusReason, ccmMediaDeviceTimeLastStatusUpdt, ccmMediaDeviceTimeLastRegistered, ccmRegisteredMediaDevices, ccmUnregisteredMediaDevices, ccmRejectedMediaDevices');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7215, 'ccmCTIDeviceName, ccmCTIDeviceType, ccmCTIDeviceDescription, ccmCTIDeviceStatus, ccmCTIDevicePoolIndex, ccmCTIDeviceInetAddressType, ccmCTIDeviceInetAddress, ccmCTIDeviceStatusReason, ccmCTIDeviceTimeLastStatusUpdt, ccmCTIDeviceTimeLastRegistered, ccmCTIDeviceDirNum, ccmRegisteredCTIDevices, ccmUnregisteredCTIDevices, ccmRejectedCTIDevices, ccmCTIDeviceTableStateId, ccmCTIDeviceDirNumTableStateId');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7216, 'ccmH323DevName, ccmH323DevProductId, ccmH323DevDescription, ccmH323DevInetAddressType, ccmH323DevInetAddress, ccmH323DevCnfgGKInetAddressType, ccmH323DevCnfgGKInetAddress, ccmH323DevAltGK1InetAddressType, ccmH323DevAltGK1InetAddress, ccmH323DevAltGK2InetAddressType, ccmH323DevAltGK2InetAddress, ccmH323DevAltGK3InetAddressType, ccmH323DevAltGK3InetAddress, ccmH323DevAltGK4InetAddressType, ccmH323DevAltGK4InetAddress, ccmH323DevAltGK5InetAddressType, ccmH323DevAltGK5InetAddress, ccmH323DevActGKInetAddressType, ccmH323DevActGKInetAddress, ccmH323DevStatus, ccmH323DevStatusReason, ccmH323DevTimeLastStatusUpdt, ccmH323DevTimeLastRegistered, ccmH323DevRmtCM1InetAddressType, ccmH323DevRmtCM1InetAddress, ccmH323DevRmtCM2InetAddressType, ccmH323DevRmtCM2InetAddress, ccmH323DevRmtCM3InetAddressType, ccmH323DevRmtCM3InetAddress');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7217, 'ccmVMailDevName, ccmVMailDevProductId, ccmVMailDevDescription, ccmVMailDevStatus, ccmVMailDevInetAddressType, ccmVMailDevInetAddress, ccmVMailDevStatusReason, ccmVMailDevTimeLastStatusUpdt, ccmVMailDevTimeLastRegistered, ccmVMailDevDirNum, ccmRegisteredVoiceMailDevices, ccmUnregisteredVoiceMailDevices, ccmRejectedVoiceMailDevices');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7218, 'ccmAlarmSeverity, ccmCallManagerAlarmEnable, ccmFailCauseCode, ccmPhoneFailures, ccmPhoneFailedTime, ccmPhoneFailedInetAddressType, ccmPhoneFailedInetAddress, ccmPhoneFailCauseCode, ccmPhoneFailedMacAddress, ccmPhoneFailedAlarmInterval, ccmPhoneFailedStorePeriod, ccmPhFailedTblLastAddedIndex, ccmPhoneUpdates, ccmPhoneStatusPhoneIndex, ccmPhoneStatusUpdateTime, ccmPhoneStatusUpdateType, ccmPhoneStatusUpdateReason, ccmPhoneStatusUpdateAlarmInterv, ccmPhoneStatusUpdateStorePeriod, ccmPhoneStatusUpdateTableStateId, ccmPhStatUpdtTblLastAddedIndex, ccmGatewayAlarmEnable, ccmGatewayFailCauseCode, ccmMediaResourceType, ccmMediaResourceListName, ccmRouteListName, ccmGatewayPhysIfIndex, ccmGatewayPhysIfL2Status');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7219, 'ccmGroupName, ccmGroupTftpDefault, ccmName, ccmDescription, ccmVersion, ccmStatus, ccmInetAddressType, ccmInetAddress, ccmClusterId, ccmCMGroupMappingCMPriority, ccmRegionName, ccmRegionAvailableBandWidth, ccmTimeZoneName, ccmTimeZoneOffsetHours, ccmTimeZoneOffsetMinutes, ccmDevicePoolName, ccmDevicePoolRegionIndex, ccmDevicePoolTimeZoneIndex, ccmDevicePoolGroupIndex, ccmProductType, ccmProductName, ccmProductCategory, ccmCallManagerStartTime, ccmSystemVersion, ccmInstallationId');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7220, 'ccmAlarmSeverity, ccmCallManagerAlarmEnable, ccmFailCauseCode, ccmPhoneFailures, ccmPhoneFailedTime, ccmPhoneFailedInetAddressType, ccmPhoneFailedInetAddress, ccmPhoneFailCauseCode, ccmPhoneFailedMacAddress, ccmPhoneFailedAlarmInterval, ccmPhoneFailedStorePeriod, ccmPhFailedTblLastAddedIndex, ccmPhoneUpdates, ccmPhoneStatusPhoneIndex, ccmPhoneStatusUpdateTime, ccmPhoneStatusUpdateType, ccmPhoneStatusUpdateReason, ccmPhoneStatusUpdateAlarmInterv, ccmPhoneStatusUpdateStorePeriod, ccmPhoneStatusUpdateTableStateId, ccmPhStatUpdtTblLastAddedIndex, ccmGatewayAlarmEnable, ccmGatewayFailCauseCode, ccmMediaResourceType, ccmMediaResourceListName, ccmRouteListName, ccmGatewayPhysIfIndex, ccmGatewayPhysIfL2Status, ccmMaliciousCallAlarmEnable, ccmMaliCallCalledPartyName, ccmMaliCallCalledPartyNumber, ccmMaliCallCalledDeviceName, ccmMaliCallCallingPartyName, ccmMaliCallCallingPartyNumber, ccmMaliCallCallingDeviceName, ccmMaliCallTime, ccmQualityReportAlarmEnable, ccmQualityRprtSourceDevName, ccmQualityRprtClusterId, ccmQualityRprtCategory, ccmQualityRprtReasonCode, ccmQualityRprtTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7222, 'ccmSIPDevName, ccmSIPDevProductTypeIndex, ccmSIPDevDescription, ccmSIPDevInetAddressType, ccmSIPDevInetAddress');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7223, 'ccmPhonePhysicalAddress, ccmPhoneDescription, ccmPhoneUserName, ccmPhoneInetAddressType, ccmPhoneInetAddress, ccmPhoneStatus, ccmPhoneTimeLastRegistered, ccmPhoneE911Location, ccmPhoneLoadID, ccmPhoneDevicePoolIndex, ccmPhoneStatusReason, ccmPhoneTimeLastStatusUpdt, ccmPhoneProductTypeIndex, ccmPhoneExtn, ccmPhoneExtnMultiLines, ccmPhoneExtnInetAddressType, ccmPhoneExtnInetAddress, ccmRegisteredPhones, ccmUnregisteredPhones, ccmRejectedPhones, ccmPhoneTableStateId, ccmPhoneExtensionTableStateId');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7224, 'ccmGatewayName, ccmGatewayDescription, ccmGatewayStatus, ccmGatewayDevicePoolIndex, ccmGatewayInetAddressType, ccmGatewayInetAddress, ccmGatewayStatusReason, ccmGatewayTimeLastStatusUpdt, ccmGatewayTimeLastRegistered, ccmGatewayDChannelStatus, ccmGatewayDChannelNumber, ccmGatewayProductTypeIndex, ccmRegisteredGateways, ccmUnregisteredGateways, ccmRejectedGateways, ccmGatewayTableStateId');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7225, 'ccmMediaDeviceName, ccmMediaDeviceDescription, ccmMediaDeviceStatus, ccmMediaDeviceDevicePoolIndex, ccmMediaDeviceInetAddressType, ccmMediaDeviceInetAddress, ccmMediaDeviceStatusReason, ccmMediaDeviceTimeLastStatusUpdt, ccmMediaDeviceTimeLastRegistered, ccmMediaDeviceProductTypeIndex, ccmRegisteredMediaDevices, ccmUnregisteredMediaDevices, ccmRejectedMediaDevices');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7226, 'ccmCTIDeviceName, ccmCTIDeviceDescription, ccmCTIDeviceStatus, ccmCTIDevicePoolIndex, ccmCTIDeviceInetAddressType, ccmCTIDeviceInetAddress, ccmCTIDeviceStatusReason, ccmCTIDeviceTimeLastStatusUpdt, ccmCTIDeviceTimeLastRegistered, ccmCTIDeviceProductTypeIndex, ccmCTIDeviceDirNum, ccmRegisteredCTIDevices, ccmUnregisteredCTIDevices, ccmRejectedCTIDevices, ccmCTIDeviceTableStateId, ccmCTIDeviceDirNumTableStateId');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7227, 'ccmH323DevName, ccmH323DevDescription, ccmH323DevInetAddressType, ccmH323DevInetAddress, ccmH323DevCnfgGKInetAddressType, ccmH323DevCnfgGKInetAddress, ccmH323DevAltGK1InetAddressType, ccmH323DevAltGK1InetAddress, ccmH323DevAltGK2InetAddressType, ccmH323DevAltGK2InetAddress, ccmH323DevAltGK3InetAddressType, ccmH323DevAltGK3InetAddress, ccmH323DevAltGK4InetAddressType, ccmH323DevAltGK4InetAddress, ccmH323DevAltGK5InetAddressType, ccmH323DevAltGK5InetAddress, ccmH323DevActGKInetAddressType, ccmH323DevActGKInetAddress, ccmH323DevStatus, ccmH323DevStatusReason, ccmH323DevTimeLastStatusUpdt, ccmH323DevTimeLastRegistered, ccmH323DevRmtCM1InetAddressType, ccmH323DevRmtCM1InetAddress, ccmH323DevRmtCM2InetAddressType, ccmH323DevRmtCM2InetAddress, ccmH323DevRmtCM3InetAddressType, ccmH323DevRmtCM3InetAddress, ccmH323DevProductTypeIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7228, 'ccmVMailDevName, ccmVMailDevDescription, ccmVMailDevStatus, ccmVMailDevInetAddressType, ccmVMailDevInetAddress, ccmVMailDevStatusReason, ccmVMailDevTimeLastStatusUpdt, ccmVMailDevTimeLastRegistered, ccmVMailDevProductTypeIndex, ccmVMailDevDirNum, ccmRegisteredVoiceMailDevices, ccmUnregisteredVoiceMailDevices, ccmRejectedVoiceMailDevices');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7229, 'ccmPhonePhysicalAddress, ccmPhoneDescription, ccmPhoneUserName, ccmPhoneInetAddressType, ccmPhoneInetAddress, ccmPhoneStatus, ccmPhoneTimeLastRegistered, ccmPhoneE911Location, ccmPhoneLoadID, ccmPhoneDevicePoolIndex, ccmPhoneStatusReason, ccmPhoneTimeLastStatusUpdt, ccmPhoneProductTypeIndex, ccmPhoneProtocol, ccmPhoneName, ccmPhoneExtn, ccmPhoneExtnMultiLines, ccmPhoneExtnInetAddressType, ccmPhoneExtnInetAddress, ccmPhoneExtnStatus, ccmRegisteredPhones, ccmUnregisteredPhones, ccmRejectedPhones, ccmPartiallyRegisteredPhones, ccmPhoneTableStateId, ccmPhoneExtensionTableStateId');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7230, 'ccmSIPDevName, ccmSIPDevProductTypeIndex, ccmSIPDevDescription, ccmSIPDevInetAddressType, ccmSIPDevInetAddress, ccmSIPInTransportProtocolType, ccmSIPInPortNumber, ccmSIPOutTransportProtocolType, ccmSIPOutPortNumber');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7231, 'ccmAlarmSeverity, ccmCallManagerAlarmEnable, ccmFailCauseCode, ccmPhoneFailures, ccmPhoneFailedTime, ccmPhoneFailedInetAddressType, ccmPhoneFailedInetAddress, ccmPhoneFailCauseCode, ccmPhoneFailedMacAddress, ccmPhoneFailedAlarmInterval, ccmPhoneFailedStorePeriod, ccmPhFailedTblLastAddedIndex, ccmPhoneUpdates, ccmPhoneStatusPhoneIndex, ccmPhoneStatusUpdateTime, ccmPhoneStatusUpdateType, ccmPhoneStatusUpdateReason, ccmPhoneStatusUpdateAlarmInterv, ccmPhoneStatusUpdateStorePeriod, ccmPhoneStatusUpdateTableStateId, ccmPhStatUpdtTblLastAddedIndex, ccmGatewayAlarmEnable, ccmGatewayFailCauseCode, ccmMediaResourceType, ccmMediaResourceListName, ccmRouteListName, ccmGatewayPhysIfIndex, ccmGatewayPhysIfL2Status, ccmMaliciousCallAlarmEnable, ccmMaliCallCalledPartyName, ccmMaliCallCalledPartyNumber, ccmMaliCallCalledDeviceName, ccmMaliCallCallingPartyName, ccmMaliCallCallingPartyNumber, ccmMaliCallCallingDeviceName, ccmMaliCallTime, ccmQualityReportAlarmEnable, ccmQualityRprtSourceDevName, ccmQualityRprtClusterId, ccmQualityRprtCategory, ccmQualityRprtReasonCode, ccmQualityRprtTime, ccmTLSDevName, ccmTLSDevInetAddressType, ccmTLSDevInetAddress, ccmTLSConnFailTime, ccmTLSConnectionFailReasonCode');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7233, 'ccmGroupName, ccmGroupTftpDefault, ccmName, ccmDescription, ccmVersion, ccmStatus, ccmInetAddressType, ccmInetAddress, ccmClusterId, ccmCMGroupMappingCMPriority, ccmRegionName, ccmRegionAvailableBandWidth, ccmTimeZoneName, ccmTimeZoneOffsetHours, ccmTimeZoneOffsetMinutes, ccmDevicePoolName, ccmDevicePoolRegionIndex, ccmDevicePoolTimeZoneIndex, ccmDevicePoolGroupIndex, ccmProductType, ccmProductName, ccmProductCategory, ccmCallManagerStartTime, ccmSystemVersion, ccmInstallationId, ccmInetAddress2Type, ccmInetAddress2');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7234, 'ccmPhonePhysicalAddress, ccmPhoneDescription, ccmPhoneUserName, ccmPhoneStatus, ccmPhoneTimeLastRegistered, ccmPhoneE911Location, ccmPhoneLoadID, ccmPhoneDevicePoolIndex, ccmPhoneStatusReason, ccmPhoneTimeLastStatusUpdt, ccmPhoneProductTypeIndex, ccmPhoneProtocol, ccmPhoneName, ccmPhoneExtn, ccmPhoneExtnMultiLines, ccmPhoneExtnInetAddressType, ccmPhoneExtnInetAddress, ccmPhoneExtnStatus, ccmRegisteredPhones, ccmUnregisteredPhones, ccmRejectedPhones, ccmPartiallyRegisteredPhones, ccmPhoneTableStateId, ccmPhoneExtensionTableStateId, ccmPhoneInetAddressIPv4, ccmPhoneInetAddressIPv6, ccmPhoneIPv4Attribute, ccmPhoneIPv6Attribute, ccmPhoneActiveLoadID');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7235, 'ccmMediaDeviceName, ccmMediaDeviceDescription, ccmMediaDeviceStatus, ccmMediaDeviceDevicePoolIndex, ccmMediaDeviceStatusReason, ccmMediaDeviceTimeLastStatusUpdt, ccmMediaDeviceTimeLastRegistered, ccmMediaDeviceProductTypeIndex, ccmRegisteredMediaDevices, ccmUnregisteredMediaDevices, ccmRejectedMediaDevices, ccmMediaDeviceInetAddressIPv4, ccmMediaDeviceInetAddressIPv6');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7236, 'ccmSIPDevName, ccmSIPDevProductTypeIndex, ccmSIPDevDescription, ccmSIPInTransportProtocolType, ccmSIPInPortNumber, ccmSIPOutTransportProtocolType, ccmSIPOutPortNumber, ccmSIPDevInetAddressIPv4, ccmSIPDevInetAddressIPv6, ccmSIPTableEntries');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7237, 'ccmAlarmSeverity, ccmCallManagerAlarmEnable, ccmFailCauseCode, ccmPhoneFailures, ccmPhoneFailedTime, ccmPhoneFailCauseCode, ccmPhoneFailedMacAddress, ccmPhoneFailedAlarmInterval, ccmPhoneFailedStorePeriod, ccmPhFailedTblLastAddedIndex, ccmPhoneUpdates, ccmPhoneStatusPhoneIndex, ccmPhoneStatusUpdateTime, ccmPhoneStatusUpdateType, ccmPhoneStatusUpdateReason, ccmPhoneStatusUpdateAlarmInterv, ccmPhoneStatusUpdateStorePeriod, ccmPhoneStatusUpdateTableStateId, ccmPhStatUpdtTblLastAddedIndex, ccmGatewayAlarmEnable, ccmGatewayFailCauseCode, ccmMediaResourceType, ccmMediaResourceListName, ccmRouteListName, ccmGatewayPhysIfIndex, ccmGatewayPhysIfL2Status, ccmMaliciousCallAlarmEnable, ccmMaliCallCalledPartyName, ccmMaliCallCalledPartyNumber, ccmMaliCallCalledDeviceName, ccmMaliCallCallingPartyName, ccmMaliCallCallingPartyNumber, ccmMaliCallCallingDeviceName, ccmMaliCallTime, ccmQualityReportAlarmEnable, ccmQualityRprtSourceDevName, ccmQualityRprtClusterId, ccmQualityRprtCategory, ccmQualityRprtReasonCode, ccmQualityRprtTime, ccmTLSDevName, ccmTLSDevInetAddressType, ccmTLSDevInetAddress, ccmTLSConnFailTime, ccmTLSConnectionFailReasonCode, ccmPhoneFailedInetAddressIPv4, ccmPhoneFailedInetAddressIPv6, ccmPhoneFailedIPv4Attribute, ccmPhoneFailedIPv6Attribute');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7238, 'ccmH323DevName, ccmH323DevDescription, ccmH323DevInetAddressType, ccmH323DevInetAddress, ccmH323DevCnfgGKInetAddressType, ccmH323DevCnfgGKInetAddress, ccmH323DevAltGK1InetAddressType, ccmH323DevAltGK1InetAddress, ccmH323DevAltGK2InetAddressType, ccmH323DevAltGK2InetAddress, ccmH323DevAltGK3InetAddressType, ccmH323DevAltGK3InetAddress, ccmH323DevAltGK4InetAddressType, ccmH323DevAltGK4InetAddress, ccmH323DevAltGK5InetAddressType, ccmH323DevAltGK5InetAddress, ccmH323DevActGKInetAddressType, ccmH323DevActGKInetAddress, ccmH323DevStatus, ccmH323DevStatusReason, ccmH323DevTimeLastStatusUpdt, ccmH323DevTimeLastRegistered, ccmH323DevRmtCM1InetAddressType, ccmH323DevRmtCM1InetAddress, ccmH323DevRmtCM2InetAddressType, ccmH323DevRmtCM2InetAddress, ccmH323DevRmtCM3InetAddressType, ccmH323DevRmtCM3InetAddress, ccmH323DevProductTypeIndex, ccmH323TableEntries');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7239, 'ccmCTIDeviceName, ccmCTIDeviceDescription, ccmCTIDeviceStatus, ccmCTIDevicePoolIndex, ccmCTIDeviceStatusReason, ccmCTIDeviceTimeLastStatusUpdt, ccmCTIDeviceTimeLastRegistered, ccmCTIDeviceProductTypeIndex, ccmCTIDeviceDirNum, ccmRegisteredCTIDevices, ccmUnregisteredCTIDevices, ccmRejectedCTIDevices, ccmCTIDeviceTableStateId, ccmCTIDeviceDirNumTableStateId, ccmCTIDeviceInetAddressIPv4, ccmCTIDeviceInetAddressIPv6');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7240, 'ccmPhonePhysicalAddress, ccmPhoneDescription, ccmPhoneUserName, ccmPhoneStatus, ccmPhoneTimeLastRegistered, ccmPhoneE911Location, ccmPhoneLoadID, ccmPhoneDevicePoolIndex, ccmPhoneTimeLastStatusUpdt, ccmPhoneProductTypeIndex, ccmPhoneProtocol, ccmPhoneName, ccmPhoneExtn, ccmPhoneExtnMultiLines, ccmPhoneExtnInetAddressType, ccmPhoneExtnInetAddress, ccmPhoneExtnStatus, ccmRegisteredPhones, ccmUnregisteredPhones, ccmRejectedPhones, ccmPartiallyRegisteredPhones, ccmPhoneTableStateId, ccmPhoneExtensionTableStateId, ccmPhoneInetAddressIPv4, ccmPhoneInetAddressIPv6, ccmPhoneIPv4Attribute, ccmPhoneIPv6Attribute, ccmPhoneActiveLoadID, ccmPhoneUnregReason, ccmPhoneRegFailReason');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7241, 'ccmAlarmSeverity, ccmCallManagerAlarmEnable, ccmFailCauseCode, ccmPhoneFailures, ccmPhoneFailedTime, ccmPhoneFailedMacAddress, ccmPhoneFailedAlarmInterval, ccmPhoneFailedStorePeriod, ccmPhFailedTblLastAddedIndex, ccmPhoneUpdates, ccmPhoneStatusPhoneIndex, ccmPhoneStatusUpdateTime, ccmPhoneStatusUpdateType, ccmPhoneStatusUpdateAlarmInterv, ccmPhoneStatusUpdateStorePeriod, ccmPhoneStatusUpdateTableStateId, ccmPhStatUpdtTblLastAddedIndex, ccmGatewayAlarmEnable, ccmMediaResourceType, ccmMediaResourceListName, ccmRouteListName, ccmGatewayPhysIfIndex, ccmGatewayPhysIfL2Status, ccmMaliciousCallAlarmEnable, ccmMaliCallCalledPartyName, ccmMaliCallCalledPartyNumber, ccmMaliCallCalledDeviceName, ccmMaliCallCallingPartyName, ccmMaliCallCallingPartyNumber, ccmMaliCallCallingDeviceName, ccmMaliCallTime, ccmQualityReportAlarmEnable, ccmQualityRprtSourceDevName, ccmQualityRprtClusterId, ccmQualityRprtCategory, ccmQualityRprtReasonCode, ccmQualityRprtTime, ccmTLSDevName, ccmTLSDevInetAddressType, ccmTLSDevInetAddress, ccmTLSConnFailTime, ccmTLSConnectionFailReasonCode, ccmPhoneFailedInetAddressIPv4, ccmPhoneFailedInetAddressIPv6, ccmPhoneFailedIPv4Attribute, ccmPhoneFailedIPv6Attribute, ccmPhoneFailedRegFailReason, ccmPhoneStatusUnregReason, ccmPhoneStatusRegFailReason, ccmGatewayRegFailCauseCode');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7242, 'ccmGatewayName, ccmGatewayDescription, ccmGatewayStatus, ccmGatewayDevicePoolIndex, ccmGatewayInetAddressType, ccmGatewayInetAddress, ccmGatewayTimeLastStatusUpdt, ccmGatewayTimeLastRegistered, ccmGatewayDChannelStatus, ccmGatewayDChannelNumber, ccmGatewayProductTypeIndex, ccmRegisteredGateways, ccmUnregisteredGateways, ccmRejectedGateways, ccmGatewayTableStateId, ccmGatewayUnregReason, ccmGatewayRegFailReason');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7243, 'ccmMediaDeviceName, ccmMediaDeviceDescription, ccmMediaDeviceStatus, ccmMediaDeviceDevicePoolIndex, ccmMediaDeviceTimeLastStatusUpdt, ccmMediaDeviceTimeLastRegistered, ccmMediaDeviceProductTypeIndex, ccmRegisteredMediaDevices, ccmUnregisteredMediaDevices, ccmRejectedMediaDevices, ccmMediaDeviceInetAddressIPv4, ccmMediaDeviceInetAddressIPv6, ccmMediaDeviceUnregReason, ccmMediaDeviceRegFailReason');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7244, 'ccmCTIDeviceName, ccmCTIDeviceDescription, ccmCTIDeviceStatus, ccmCTIDevicePoolIndex, ccmCTIDeviceTimeLastStatusUpdt, ccmCTIDeviceTimeLastRegistered, ccmCTIDeviceProductTypeIndex, ccmCTIDeviceDirNum, ccmRegisteredCTIDevices, ccmUnregisteredCTIDevices, ccmRejectedCTIDevices, ccmCTIDeviceTableStateId, ccmCTIDeviceDirNumTableStateId, ccmCTIDeviceInetAddressIPv4, ccmCTIDeviceInetAddressIPv6, ccmCTIDeviceUnregReason, ccmCTIDeviceRegFailReason');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7245, 'ccmH323DevName, ccmH323DevDescription, ccmH323DevInetAddressType, ccmH323DevInetAddress, ccmH323DevCnfgGKInetAddressType, ccmH323DevCnfgGKInetAddress, ccmH323DevAltGK1InetAddressType, ccmH323DevAltGK1InetAddress, ccmH323DevAltGK2InetAddressType, ccmH323DevAltGK2InetAddress, ccmH323DevAltGK3InetAddressType, ccmH323DevAltGK3InetAddress, ccmH323DevAltGK4InetAddressType, ccmH323DevAltGK4InetAddress, ccmH323DevAltGK5InetAddressType, ccmH323DevAltGK5InetAddress, ccmH323DevActGKInetAddressType, ccmH323DevActGKInetAddress, ccmH323DevStatus, ccmH323DevTimeLastStatusUpdt, ccmH323DevTimeLastRegistered, ccmH323DevRmtCM1InetAddressType, ccmH323DevRmtCM1InetAddress, ccmH323DevRmtCM2InetAddressType, ccmH323DevRmtCM2InetAddress, ccmH323DevRmtCM3InetAddressType, ccmH323DevRmtCM3InetAddress, ccmH323DevProductTypeIndex, ccmH323TableEntries, ccmH323DevUnregReason, ccmH323DevRegFailReason');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7246, 'ccmVMailDevName, ccmVMailDevDescription, ccmVMailDevStatus, ccmVMailDevInetAddressType, ccmVMailDevInetAddress, ccmVMailDevTimeLastStatusUpdt, ccmVMailDevTimeLastRegistered, ccmVMailDevProductTypeIndex, ccmVMailDevDirNum, ccmRegisteredVoiceMailDevices, ccmUnregisteredVoiceMailDevices, ccmRejectedVoiceMailDevices, ccmVMailDevUnregReason, ccmVMailDevRegFailReason');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7321, 'isdnBasicRateIfType, isdnBasicRateLineTopology, isdnBasicRateIfMode, isdnBasicRateSignalMode');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7322, 'isdnBearerChannelType, isdnBearerOperStatus, isdnBearerChannelNumber, isdnBearerPeerAddress, isdnBearerPeerSubAddress, isdnBearerCallOrigin, isdnBearerInfoType, isdnBearerMultirate, isdnBearerCallSetupTime, isdnBearerCallConnectTime, isdnBearerChargedUnits');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7323, 'isdnSignalingGetIndex, isdnSignalingIfIndex, isdnSignalingProtocol, isdnSignalingCallingAddress, isdnSignalingSubAddress, isdnSignalingBchannelCount, isdnSignalingInfoTrapEnable, isdnSignalingStatus, isdnSigStatsInCalls, isdnSigStatsInConnected, isdnSigStatsOutCalls, isdnSigStatsOutConnected, isdnSigStatsChargedUnits, isdnLapdPrimaryChannel, isdnLapdOperStatus, isdnLapdPeerSabme, isdnLapdRecvdFrmr');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7324, 'isdnEndpointGetIndex, isdnEndpointIfIndex, isdnEndpointIfType, isdnEndpointTeiType, isdnEndpointTeiValue, isdnEndpointSpid, isdnEndpointStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7325, 'isdnDirectoryNumber, isdnDirectorySigIndex, isdnDirectoryStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7359, 'demandNbrLogIf, demandNbrName, demandNbrAddress, demandNbrPermission, demandNbrMaxDuration, demandNbrLastDuration, demandNbrClearReason, demandNbrClearCode, demandNbrSuccessCalls, demandNbrFailCalls, demandNbrAcceptCalls, demandNbrRefuseCalls, demandNbrLastAttemptTime, demandNbrStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7360, 'demandNbrLogIf, demandNbrName, demandNbrAddress, demandNbrPermission, demandNbrMaxDuration, demandNbrLastDuration, demandNbrClearReason, demandNbrClearCode, demandNbrSuccessCalls, demandNbrFailCalls, demandNbrAcceptCalls, demandNbrRefuseCalls, demandNbrLastAttemptTime, demandNbrStatus, demandNbrCallOrigin');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7502, 'crasMaxSessionsSupportable , crasMaxUsersSupportable , crasMaxGroupsSupportable , crasNumCryptoAccelerators');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7503, 'crasGlobalBwUsage');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7504, 'crasNumSessions , crasNumPrevSessions , crasNumUsers , crasGlobalInPkts , crasGlobalOutPkts , crasGlobalInOctets , crasGlobalOutOctets , crasGlobalInDecompOctets, crasGlobalOutUncompOctets, crasGlobalInDropPkts , crasGlobalOutDropPkts , crasGroup , crasAuthenMethod , crasAuthorMethod , crasSessionDuration , crasLocalAddressType, crasLocalAddress , crasISPAddressType , crasISPAddress , crasSessionProtocol , crasProtocolElement, crasSessionEncryptionAlgo , crasSessionPktAuthenAlgo , crasSessionCompressionAlgo , crasHeartbeatInterval , crasClientVendorString , crasClientVersionString , crasClientOSVendorString , crasClientOSVersionString ,  crasPrimWINSServerAddrType , crasPrimWINSServer , crasSecWINSServerAddrType , crasSecWINSServer , crasPrimDNSServerAddrType, crasPrimDNSServer , crasSecDNSServerAddrType , crasSecDNSServer , crasDHCPServerAddrType , crasDHCPServer ,  crasSessionInPkts , crasSessionOutPkts , crasSessionInDropPkts , crasSessionOutDropPkts , crasSessionInOctets , crasSessionOutOctets, crasSessionState');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7505, 'crasNumGroups, crasActGrNumUsers, crasActGrpInPkts, crasActGrpOutPkts, crasActGrpInDropPkts, crasActGrpOutDropPkts, crasActGrpInOctets, crasActGrpOutOctets');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7506, 'crasNumTotalFailures, crasNumDeclinedSessions, crasNumAbortedSessions, crasFailTableSize');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7507, 'crasNumSetupFailInsufResources, crasSessFailUsername, crasSessFailGroupname, crasSessFailType, crasSessFailReason, crasSessFailTime, crasSessFailSessionIndex, crasSessFailISPAddr, crasSessFailLocalAddr, crasSessFailISPAddrType, crasSessFailLocalAddrType, crasFailLastFailIndex, crasGrpFailNumFailAuths, crasGrpFailNumResourceFailures, crasGrpFailNumDeclined, crasGrpFailNumTerminatedMgmt, crasGrpFailNumTerminatedOther');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7508, 'crasNumDisabledAccounts');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7509, 'crasThrMaxSessions, crasThrMaxFailedAuths, crasThrMaxThroughput');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7510, 'crasCntlTooManySessions, crasCntlTooManyFailedAuths, crasCntlTooHighThroughput');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7512, 'crasEmailNumSessions, crasEmailCumulateSessions, crasEmailPeakConcurrentSessions, crasIPSecNumSessions, crasIPSecCumulateSessions, crasIPSecPeakConcurrentSessions, crasL2LNumSessions, crasL2LCumulateSessions, crasL2LPeakConcurrentSessions, crasLBNumSessions, crasLBCumulateSessions, crasLBPeakConcurrentSessions, crasSVCNumSessions, crasSVCCumulateSessions, crasSVCPeakConcurrentSessions, crasWebvpnNumSessions, crasWebvpnCumulateSessions, crasWebvpnPeakConcurrentSessions');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7732, 'cfrLmiLinkstatus, cfrLmiLinkType, cfrLmiEnquiryIns, cfrLmiEnquiryOuts, cfrLmiStatusIns, cfrLmiStatusOuts, cfrLmiUpdateStatusIns, cfrLmiUpdateStatusOuts, cfrLmiStatusTimeouts, cfrLmiStatusEnqTimeouts, cfrLmiN392Dce, cfrLmiN393Dce, cfrLmiT392Dce, cfrCircuitDEins, cfrCircuitDEouts, cfrCircuitDropPktsOuts, cfrCircuitType, cfrExtCircuitIfName, cfrExtCircuitIfType, cfrExtCircuitSubifIndex, cfrExtCircuitMapStatus, cfrExtCircuitCreateType, cfrExtCircuitMulticast, cfrExtCircuitRoutedDlci, cfrExtCircuitRoutedIf, cfrMapIndex, cfrMapProtocol, cfrMapAddress, cfrMapType, cfrMapEncaps, cfrMapBroadcast, cfrMapPayloadCompress, cfrMapTcpHdrCompress, cfrSvcAddrLocal, cfrSvcAddrRemote, cfrSvcThroughputIn, cfrSvcMinThruputOut, cfrSvcMinThruputIn, cfrSvcCommitBurstIn, cfrSvcExcessBurstIn, cfrSvcIdleTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7733, 'cfrLmiLinkstatus, cfrLmiLinkType, cfrLmiEnquiryIns, cfrLmiEnquiryOuts, cfrLmiStatusIns, cfrLmiStatusOuts, cfrLmiUpdateStatusIns, cfrLmiUpdateStatusOuts, cfrLmiStatusTimeouts, cfrLmiStatusEnqTimeouts, cfrLmiN392Dce, cfrLmiN393Dce, cfrLmiT392Dce, cfrCircuitDEins, cfrCircuitDEouts, cfrCircuitDropPktsOuts, cfrCircuitType, cfrExtCircuitIfName, cfrExtCircuitIfType, cfrExtCircuitSubifIndex, cfrExtCircuitMapStatus, cfrExtCircuitCreateType, cfrExtCircuitMulticast, cfrExtCircuitRoutedDlci, cfrExtCircuitRoutedIf, cfrExtCircuitUncompressIns, cfrExtCircuitUncompressOuts, cfrMapIndex, cfrMapProtocol, cfrMapAddress, cfrMapType, cfrMapEncaps, cfrMapBroadcast,  cfrMapTcpHdrCompress, cfrMapRtpHdrCompress, cfrMapPayloadCompressType, cfrSvcAddrLocal, cfrSvcAddrRemote, cfrSvcThroughputIn, cfrSvcMinThruputOut, cfrSvcMinThruputIn, cfrSvcCommitBurstIn, cfrSvcExcessBurstIn, cfrSvcIdleTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7734, 'cfrLmiLinkstatus, cfrLmiLinkType, cfrLmiEnquiryIns, cfrLmiEnquiryOuts, cfrLmiStatusIns, cfrLmiStatusOuts, cfrLmiUpdateStatusIns, cfrLmiUpdateStatusOuts, cfrLmiStatusTimeouts, cfrLmiStatusEnqTimeouts, cfrLmiN392Dce, cfrLmiN393Dce, cfrLmiT392Dce');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7735, 'cfrCircuitDEins, cfrCircuitDEouts, cfrCircuitDropPktsOuts, cfrCircuitType');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7736, 'cfrExtCircuitIfName, cfrExtCircuitIfType, cfrExtCircuitSubifIndex, cfrExtCircuitMapStatus, cfrExtCircuitCreateType, cfrExtCircuitMulticast, cfrExtCircuitRoutedDlci, cfrExtCircuitRoutedIf, cfrExtCircuitUncompressIns, cfrExtCircuitUncompressOuts, cfrExtCircuitFECNOuts, cfrExtCircuitBECNOuts, cfrExtCircuitMinThruputOut, cfrExtCircuitMinThruputIn, cfrExtCircuitBcastPktOuts, cfrExtCircuitBcastByteOuts, cfrExtCircuitBandwidth');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7737, 'cfrExtCircuitIfName, cfrExtCircuitIfType, cfrExtCircuitSubifIndex, cfrExtCircuitMapStatus, cfrExtCircuitCreateType, cfrExtCircuitMulticast, cfrExtCircuitRoutedDlci, cfrExtCircuitRoutedIf, cfrExtCircuitUncompressIns, cfrExtCircuitUncompressOuts, cfrExtCircuitFECNOuts, cfrExtCircuitBECNOuts, cfrExtCircuitMinThruputOut, cfrExtCircuitMinThruputIn, cfrExtCircuitBcastPktOuts, cfrExtCircuitBcastByteOuts, cfrExtCircuitBandwidth, cfrExtCircuitTxDataRate, cfrExtCircuitTxPktRate, cfrExtCircuitRcvDataRate, cfrExtCircuitRcvPktRate');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7738, 'cfrExtCircuitShapeByteLimit, cfrExtCircuitShapeInterval, cfrExtCircuitShapeByteIncrement, cfrExtCircuitShapePkts, cfrExtCircuitShapeBytes, cfrExtCircuitShapePktsDelay, cfrExtCircuitShapeBytesDelay, cfrExtCircuitShapeActive, cfrExtCircuitShapeAdapting');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7739, 'cfrMapIndex, cfrMapProtocol, cfrMapAddress, cfrMapType, cfrMapEncaps, cfrMapBroadcast, cfrMapTcpHdrCompress, cfrMapRtpHdrCompress, cfrMapPayloadCompressType');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7740, 'cfrSvcAddrLocal, cfrSvcAddrRemote, cfrSvcThroughputIn, cfrSvcCommitBurstIn, cfrSvcExcessBurstIn, cfrSvcIdleTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7741, 'cfrElmiIpAddr, cfrElmiArStatus, cfrElmiRemoteStatus, cfrElmiNeighborArStatus, cfrElmiNeighborIpAddress, cfrElmiNeighborIfIndex, cfrElmiNeighborVendorName, cfrElmiNeighborPlatformName, cfrElmiNeighborDeviceName');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7742, 'cfrElmiIpAddr, cfrElmiArStatus, cfrElmiRemoteStatus, cfrElmiNeighborArStatus, cfrElmiNeighborIpAddress, cfrElmiNeighborIfIndex, cfrElmiNeighborVendorName, cfrElmiNeighborPlatformName, cfrElmiNeighborDeviceName, cfrElmiLinkStatus');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7743, 'cfrFragSize, cfrFragType, cfrFragInPkts, cfrFragOutPkts, cfrFragInOctets, cfrFragOutOctets, cfrFragNotInPkts, cfrFragNotOutPkts, cfrFragNotInOctets, cfrFragNotOutOctets, cfrFragAssembledInPkts, cfrFragAssembledInOctets, cfrFragPreOutPkts, cfrFragPreOutOctets, cfrFragDroppedReAssembledInPkts, cfrFragDroppedFragmentedOutPkts, cfrFragTimeoutsIn, cfrFragOutOfSeqFragPkts, cfrFragUnexpectedBBitSetPkts, cfrFragSeqMissedPkts, cfrFragInterleavedOutPkts');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (7744, 'cfrConnName, cfrConnID, cfrConnState, cfrConnSegment1Name, cfrConnSegment1VCGroup, cfrConnSegment1Dlci, cfrConnSegment2Name, cfrConnSegment2Vpi, cfrConnSegment2Vci, cfrConnServiceTranslation, cfrConnFrSscsDlci, cfrConnEfciBit, cfrConnDeBit, cfrConnClpBit');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8208, 'cbQosIfType, cbQosPolicyDirection, cbQosIfIndex, cbQosFrDLCI, cbQosAtmVPI, cbQosAtmVCI');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8209, 'cbQosIFPolicyIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8210, 'cbQosFRPolicyIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8211, 'cbQosATMPolicyIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8212, 'cbQosConfigIndex, cbQosObjectsType, cbQosParentObjectsIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8213, 'cbQosPolicyMapName, cbQosPolicyMapDesc');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8214, 'cbQosCMName, cbQosCMDesc, cbQosCMInfo');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8215, 'cbQosMatchStmtName, cbQosMatchStmtInfo');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8216, 'cbQosQueueingCfgBandwidth, cbQosQueueingCfgBandwidthUnits, cbQosQueueingCfgFlowEnabled, cbQosQueueingCfgPriorityEnabled, cbQosQueueingCfgAggregateQSize, cbQosQueueingCfgIndividualQSize, cbQosQueueingCfgPrioBurstSize');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8217, 'cbQosREDCfgExponWeight, cbQosREDCfgMeanQsize');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8218, 'cbQosREDCfgMinThreshold, cbQosREDCfgMaxThreshold, cbQosREDCfgPktDropProb');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8219, 'cbQosPoliceCfgRate, cbQosPoliceCfgBurstSize, cbQosPoliceCfgExtBurstSize, cbQosPoliceCfgConformAction, cbQosPoliceCfgConformSetValue, cbQosPoliceCfgExceedAction, cbQosPoliceCfgExceedSetValue, cbQosPoliceCfgPir');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8220, 'cbQosTSCfgRate, cbQosTSCfgBurstSize, cbQosTSCfgExtBurstSize, cbQosTSCfgAdaptiveEnabled, cbQosTSCfgAdaptiveRate, cbQosTSCfgLimitType');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8221, 'cbQosSetCfgFeature, cbQosSetCfgIpDSCPValue, cbQosSetCfgIpPrecedenceValue, cbQosSetCfgQosGroupValue, cbQosSetCfgL2CosValue, cbQosSetCfgMplsExpValue, cbQosSetCfgDiscardClassValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8222, 'cbQosCMPrePolicyPktOverflow, cbQosCMPrePolicyPkt, cbQosCMPrePolicyPkt64, cbQosCMPrePolicyByteOverflow, cbQosCMPrePolicyByte, cbQosCMPrePolicyByte64, cbQosCMPrePolicyBitRate, cbQosCMPostPolicyByteOverflow, cbQosCMPostPolicyByte, cbQosCMPostPolicyByte64, cbQosCMPostPolicyBitRate, cbQosCMDropPktOverflow, cbQosCMDropPkt, cbQosCMDropPkt64, cbQosCMDropByteOverflow, cbQosCMDropByte, cbQosCMDropByte64, cbQosCMDropBitRate');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8223, 'cbQosCMNoBufDropPktOverflow, cbQosCMNoBufDropPkt, cbQosCMNoBufDropPkt64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8224, 'cbQosQueueingCfgDynamicQNumber');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8225, 'cbQosTSStatsDelayedByteOverflow, cbQosTSStatsDelayedByte, cbQosTSStatsDelayedByte64, cbQosTSStatsDelayedPktOverflow, cbQosTSStatsDelayedPkt, cbQosTSStatsDelayedPkt64, cbQosTSStatsActive');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8226, 'cbQosMatchPrePolicyPktOverflow, cbQosMatchPrePolicyPkt, cbQosMatchPrePolicyPkt64, cbQosMatchPrePolicyByteOverflow, cbQosMatchPrePolicyByte, cbQosMatchPrePolicyByte64, cbQosMatchPrePolicyBitRate');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8227, 'cbQosPoliceConformedPktOverflow, cbQosPoliceConformedPkt, cbQosPoliceConformedPkt64, cbQosPoliceConformedByteOverflow, cbQosPoliceConformedByte, cbQosPoliceConformedByte64, cbQosPoliceConformedBitRate, cbQosPoliceExceededPktOverflow, cbQosPoliceExceededPkt, cbQosPoliceExceededPkt64, cbQosPoliceExceededByteOverflow, cbQosPoliceExceededByte, cbQosPoliceExceededByte64, cbQosPoliceExceededBitRate');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8228, 'cbQosQueueingCurrentQDepth, cbQosQueueingMaxQDepth, cbQosQueueingDiscardByteOverflow, cbQosQueueingDiscardByte, cbQosQueueingDiscardByte64, cbQosQueueingDiscardPktOverflow, cbQosQueueingDiscardPkt, cbQosQueueingDiscardPkt64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8229, 'cbQosTSStatsDropByteOverflow, cbQosTSStatsDropByte, cbQosTSStatsDropByte64, cbQosTSStatsDropPktOverflow, cbQosTSStatsDropPkt, cbQosTSStatsDropPkt64, cbQosTSStatsCurrentQSize');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8230, 'cbQosREDRandomDropPktOverflow, cbQosREDRandomDropPkt, cbQosREDRandomDropPkt64, cbQosREDRandomDropByteOverflow, cbQosREDRandomDropByte, cbQosREDRandomDropByte64, cbQosREDTailDropPktOverflow, cbQosREDTailDropPkt, cbQosREDTailDropPkt64, cbQosREDTailDropByteOverflow, cbQosREDTailDropByte, cbQosREDTailDropByte64, cbQosREDMeanQSizeUnits, cbQosREDMeanQSize');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8231, 'cbQosREDTransmitPktOverflow, cbQosREDTransmitPkt, cbQosREDTransmitPkt64, cbQosREDTransmitByteOverflow, cbQosREDTransmitByte, cbQosREDTransmitByte64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8232, 'cbQosPoliceViolatedPktOverflow, cbQosPoliceViolatedPkt, cbQosPoliceViolatedPkt64, cbQosPoliceViolatedByteOverflow, cbQosPoliceViolatedByte, cbQosPoliceViolatedByte64, cbQosPoliceViolatedBitRate');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8233, 'cbQosPoliceCfgViolateAction, cbQosPoliceCfgViolateSetValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8234, 'cbQosREDCfgDscpPrec');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8235, 'cbQosSetCfgL2CosValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8236, 'cbQosQueueingCfgBandwidth, cbQosQueueingCfgBandwidthUnits, cbQosQueueingCfgFlowEnabled, cbQosQueueingCfgPriorityEnabled, cbQosQueueingCfgIndividualQSize, cbQosQueueingCfgPrioBurstSize, cbQosQueueingCfgQLimitUnits, cbQosQueueingCfgAggregateQLimit');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8237, 'cbQosREDCfgExponWeight');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8238, 'cbQosREDCfgPktDropProb, cbQosREDClassCfgThresholdUnit, cbQosREDClassCfgMinThreshold, cbQosREDClassCfgMaxThreshold');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8239, 'cbQosPoliceCfgRate, cbQosPoliceCfgBurstSize, cbQosPoliceCfgExtBurstSize, cbQosPoliceCfgPir');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8240, 'cbQosPoliceActionCfgConform, cbQosPoliceActionCfgConformSetValue, cbQosPoliceActionCfgExceed, cbQosPoliceActionCfgExceedSetValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8241, 'cbQosPoliceActionCfgViolate, cbQosPoliceActionCfgViolateSetValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8242, 'cbQosREDCfgECNEnabled');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8243, 'cbQosREDECNMarkPktOverflow, cbQosREDECNMarkPkt, cbQosREDECNMarkPkt64, cbQosREDECNMarkByteOverflow, cbQosREDECNMarkByte, cbQosREDECNMarkByte64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8244, 'cbQosPoliceCfgRate64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8245, 'cbQosSetCfgFeature, cbQosSetCfgIpDSCPValue, cbQosSetCfgIpPrecedenceValue, cbQosSetCfgQosGroupValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8246, 'cbQosSetCfgMplsExpValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8247, 'cbQosSetCfgDiscardClassValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8248, 'cbQosSetCfgMplsExpTopMostValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8249, 'cbQosPoliceCfgRate, cbQosPoliceCfgBurstSize, cbQosPoliceCfgExtBurstSize');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8250, 'cbQosPoliceCfgPir');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8251, 'cbQosPoliceCfgRateType, cbQosPoliceCfgPercentRateValue, cbQosPoliceCfgPercentPirValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8252, 'cbQosTSCfgRateType, cbQosTSCfgPercentRateValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8253, 'cbQosIPHCCfgOption');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8254, 'cbQosIPHCRtpSentPktOverflow, cbQosIPHCRtpSentPkt, cbQosIPHCRtpSentPkt64, cbQosIPHCRtpCmprsOutPktOverflow, cbQosIPHCRtpCmprsOutPkt, cbQosIPHCRtpCmprsOutPkt64, cbQosIPHCRtpSavedByteOverflow, cbQosIPHCRtpSavedByte, cbQosIPHCRtpSavedByte64, cbQosIPHCRtpSentByteOverflow, cbQosIPHCRtpSentByte, cbQosIPHCRtpSentByte64, cbQosIPHCRtpSentByteRate, cbQosIPHCTcpSentPktOverflow, cbQosIPHCTcpSentPkt, cbQosIPHCTcpSentPkt64, cbQosIPHCTcpCmprsOutPktOverflow, cbQosIPHCTcpCmprsOutPkt, cbQosIPHCTcpCmprsOutPkt64, cbQosIPHCTcpSavedByteOverflow, cbQosIPHCTcpSavedByte, cbQosIPHCTcpSavedByte64, cbQosIPHCTcpSentByteOverflow, cbQosIPHCTcpSentByte, cbQosIPHCTcpSentByte64, cbQosIPHCTcpSentByteRate');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8255, 'cbQosIfType, cbQosPolicyDirection, cbQosIfIndex, cbQosFrDLCI, cbQosAtmVPI, cbQosAtmVCI, cbQosEntityIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8256, 'cbQosQueueingCfgAggrQLimitTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8257, 'cbQosREDClassCfgMinThresholdTime, cbQosREDClassCfgMaxThresholdTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8258, 'cbQosPoliceCfgCellRate, cbQosPoliceCfgCellPir, cbQosPoliceCfgBurstCell, cbQosPoliceCfgExtBurstCell');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8259, 'cbQosPoliceCfgBurstTime, cbQosPoliceCfgExtBurstTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8260, 'cbQosPoliceCfgCdvt');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8261, 'cbQosPoliceCfgConformColor, cbQosPoliceCfgExceedColor');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8262, 'cbQosTSCfgBurstTime, cbQosTSCfgExtBurstTime');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8263, 'cbQosSetCfgSrpPriority');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8264, 'cbQosSetCfgFrFecnBecn');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8265, 'cbQosSetDscpPkt64, cbQosSetPrecedencePkt64, cbQosSetQosGroupPkt64, cbQosSetFrDePkt64, cbQosSetAtmClpPkt64, cbQosSetL2CosPkt64, cbQosSetMplsExpImpositionPkt64, cbQosSetDiscardClassPkt64, cbQosSetMplsExpTopMostPkt64, cbQosSetSrpPriorityPkt64, cbQosSetFrFecnBecnPkt64, cbQosSetDscpTunnelPkt64, cbQosSetPrecedenceTunnelPkt64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8266, 'cbQosPoliceCfmColorCfmPkt64, cbQosPoliceCfmColorCfmByte64, cbQosPoliceCfmColorExdPkt64, cbQosPoliceCfmColorExdByte64, cbQosPoliceCfmColorVltPkt64, cbQosPoliceCfmColorVltByte64, cbQosPoliceExdColorExdPkt64, cbQosPoliceExdColorExdByte64, cbQosPoliceExdColorVltPkt64, cbQosPoliceExdColorVltByte64, cbQosPoliceVltColorVltPkt64, cbQosPoliceVltColorVltByte64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8267, 'cbQosTableMapCfgName, cbQosTableMapCfgBehavior, cbQosTableMapCfgDftValue, cbQosTableMapValueCfgTo, cbQosTMSetIpDscpFromType, cbQosTMSetIpDscpMapName, cbQosTMSetIpPrecedenceFromType, cbQosTMSetIpPrecedenceMapName, cbQosTMSetQosGroupFromType, cbQosTMSetQosGroupMapName, cbQosTMSetL2CosFromType, cbQosTMSetL2CosMapName, cbQosTMSetMplsExpImpFromType, cbQosTMSetMplsExpImpMapName, cbQosTMSetMplsExpTopFromType, cbQosTMSetMplsExpTopMapName');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8268, 'cbQosEBCfgMechanism, cbQosEBCfgDropTarget, cbQosEBCfgDelayTarget, cbQosEBCfgDelayThreshold');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8269, 'cbQosEBStatsCorvilEBValue, cbQosEBStatsCorvilEBStatus, cbQosEBStatsCorvilCTD');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8270, 'cbQosVlanIndex');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8271, 'cbQosMeasureIPSLACfgGroupIndex, cbQosMeasureIPSLACfgGroupName');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8272, 'cbQosTSCfgRate64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8273, 'cbQosQueueingCfgBandwidth, cbQosQueueingCfgBandwidthUnits, cbQosQueueingCfgFlowEnabled, cbQosQueueingCfgPriorityEnabled, cbQosQueueingCfgIndividualQSize, cbQosQueueingCfgPrioBurstSize, cbQosQueueingCfgQLimitUnits, cbQosQueueingCfgAggregateQLimit, cbQosQueueingCfgPriorityLevel');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8274, 'cbQosSetCfgL2CosValue, cbQosSetCfgL2CosInnerValue');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8275, 'cbQosREDCfgPktDropProb, cbQosREDClassCfgMinThreshold, cbQosREDClassCfgMaxThreshold, cbQosREDClassCfgMinThresholdTime, cbQosREDClassCfgMaxThresholdTime, cbQosREDClassCfgMaxThresholdUnit, cbQosREDClassCfgMinThresholdUnit');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8276, 'cbQosQueueingClassCfgThreshold, cbQosQueueingClassCfgThresholdUnit, cbQosQueueingClassCfgQLimitWeight');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8277, 'cbQosPoliceCfgRate, cbQosPoliceCfgBurstSize, cbQosPoliceCfgExtBurstSize, cbQosPoliceCfgConditional');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8278, 'cbQosC3plAccountFeatureType');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8279, 'cbQosC3plAccountDropPktOverflow, cbQosC3plAccountDropPkt, cbQosC3plAccountDropPkt64, cbQosC3plAccountDropByteOverflow, cbQosC3plAccountDropByte, cbQosC3plAccountDropByte64, cbQosC3plAccountTailDropPktOverflow, cbQosC3plAccountTailDropPkt, cbQosC3plAccountTailDropPkt64, cbQosC3plAccountTailDropByteOverflow, cbQosC3plAccountTailDropByte, cbQosC3plAccountTailDropByte64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8280, 'cbQosSetCfgFrDe');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8281, 'cbQosEVC');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8282, 'cbQosCMFragmentPktOverflow, cbQosCMFragmentPkt, cbQosCMFragmentPkt64, cbQosCMFragmentByteOverflow, cbQosCMFragmentByte, cbQosCMFragmentByte64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8283, 'cbQosSetCfgIpPrecedenceTunnelValue, cbQosSetCfgIpDSCPTunnelValue, cbQosSetCfgDei, cbQosSetCfgDeiImposition');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8284, 'cbQosPoliceExdColorExdBitRate, cbQosPoliceCfmColorCfmBitRate, cbQosPoliceCfmColorExdBitRate, cbQosPoliceCfmColorVltBitRate, cbQosPoliceExdColorVltBitRate, cbQosPoliceVltColorVltBitRate');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8285, 'cbQosIPHCCfgEnabled');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8286, 'cbQosIPHCRtpFullHdrSentPktOverflow, cbQosIPHCRtpFullHdrSentPkt, cbQosIPHCRtpFullHdrSentPkt64, cbQosIPHCTcpFullHdrSentPktOverflow, cbQosIPHCTcpFullHdrSentPkt, cbQosIPHCTcpFullHdrSentPkt64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8287, 'cbQosPolicyDiscontinuityTime, cbQosQueueingCfgBandwidth64, cbQosQueueingCfgIndividualQSize64, cbQosPoliceCfgBurstSize64, cbQosPoliceCfgExtBurstSize64, cbQosPoliceCfgPir64, cbQosTSCfgBurstSize64, cbQosTSCfgExtBurstSize64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8288, 'cbQosCMPrePolicyBitRate64, cbQosCMPostPolicyBitRate64, cbQosCMDropBitRate64, cbQosPoliceConformedBitRate64, cbQosPoliceExceededBitRate64, cbQosPoliceViolatedBitRate64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8289, 'cbQosQueueingCurrentQDepthPkt, cbQosQueueingMaxQDepthPkt, cbQosQueueingTransmitByte64, cbQosQueueingTransmitPkt64');
INSERT INTO mib_object_group (id_mib_element, objects) VALUES (8290, 'cbQosParentPolicyIndex');

INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (40, 'DisplayString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (41, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (42, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (43, 'DisplayString', 'SIZE (0..255)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (44, 'DisplayString', 'SIZE (0..255)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (45, 'DisplayString', 'SIZE (0..255)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (46, 'INTEGER', '0..127', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (47, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (48, 'SEQUENCE OF IfEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (49, 'IfEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (50, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (51, 'DisplayString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (52, 'INTEGER', 'other(1), regular1822(2), hdh1822(3), ddn-x25(4), rfc877-x25(5), ethernet-csmacd(6), iso88023-csmacd(7), iso88024-tokenBus(8), iso88025-tokenRing(9), iso88026-man(10), starLan(11), proteon-10Mbit(12), proteon-80Mbit(13), hyperchannel(14), fddi(15), lapb(16), sdlc(17), ds1(18), e1(19), basicISDN(20), primaryISDN(21), propPointToPointSerial(22), ppp(23), softwareLoopback(24), eon(25), ethernet-3Mbit(26), nsip(27), slip(28), ultra(29), ds3(30), sip(31), frame-relay(32)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (53, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (54, 'Gauge', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (55, 'PhysAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (56, 'INTEGER', 'up(1), down(2), testing(3)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (57, 'INTEGER', 'up(1), down(2), testing(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (58, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (59, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (60, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (61, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (62, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (63, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (64, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (65, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (66, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (67, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (68, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (69, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (70, 'Gauge', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (71, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (72, 'SEQUENCE OF AtEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (73, 'AtEntry', '', NULL, 'not-accessible', 'atIfIndex, atNetAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (74, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (75, 'PhysAddress', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (76, 'NetworkAddress', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (77, 'INTEGER', 'forwarding(1), not-forwarding(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (78, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (79, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (80, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (81, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (82, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (83, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (84, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (85, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (86, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (87, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (88, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (89, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (90, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (91, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (92, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (93, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (94, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (95, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (96, 'SEQUENCE OF IpAddrEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (97, 'IpAddrEntry', '', NULL, 'not-accessible', 'ipAdEntAddr', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (98, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (99, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (100, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (101, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (102, 'INTEGER', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (103, 'SEQUENCE OF IpRouteEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (104, 'IpRouteEntry', '', NULL, 'not-accessible', 'ipRouteDest', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (105, 'IpAddress', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (106, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (107, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (108, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (109, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (110, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (111, 'IpAddress', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (112, 'INTEGER', 'other(1),  invalid(2),  direct(3),   indirect(4)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (113, 'INTEGER', 'other(1),    local(2),   netmgmt(3),   icmp(4),     egp(5), ggp(6), hello(7), rip(8), is-is(9), es-is(10), ciscoIgrp(11), bbnSpfIgp(12), ospf(13), bgp(14)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (114, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (115, 'IpAddress', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (116, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (117, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (118, 'SEQUENCE OF IpNetToMediaEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (119, 'IpNetToMediaEntry', '', NULL, 'not-accessible', 'ipNetToMediaIfIndex, ipNetToMediaNetAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (120, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (121, 'PhysAddress', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (122, 'IpAddress', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (123, 'INTEGER', 'other(1), invalid(2), dynamic(3), static(4)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (124, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (125, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (126, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (127, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (128, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (129, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (130, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (131, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (132, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (133, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (134, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (135, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (136, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (137, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (138, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (139, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (140, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (141, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (142, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (143, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (144, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (145, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (146, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (147, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (148, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (149, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (150, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (151, 'INTEGER', 'other(1),  constant(2), rsre(3), vanj(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (152, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (153, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (154, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (155, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (156, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (157, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (158, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (159, 'Gauge', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (160, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (161, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (162, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (163, 'SEQUENCE OF TcpConnEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (164, 'TcpConnEntry', '', NULL, 'not-accessible', 'tcpConnLocalAddress, tcpConnLocalPort, tcpConnRemAddress, tcpConnRemPort', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (396, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (397, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (165, 'INTEGER', 'closed(1), listen(2), synSent(3), synReceived(4), established(5), finWait1(6), finWait2(7), closeWait(8), lastAck(9), closing(10), timeWait(11), deleteTCB(12)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (166, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (167, 'INTEGER', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (168, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (169, 'INTEGER', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (170, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (171, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (172, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (173, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (174, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (175, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (176, 'SEQUENCE OF UdpEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (177, 'UdpEntry', '', NULL, 'not-accessible', 'udpLocalAddress, udpLocalPort', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (178, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (179, 'INTEGER', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (180, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (181, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (182, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (183, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (184, 'SEQUENCE OF EgpNeighEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (185, 'EgpNeighEntry', '', NULL, 'not-accessible', 'egpNeighAddr', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (186, 'INTEGER', 'idle(1), acquisition(2), down(3), up(4), cease(5)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (187, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (188, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (189, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (190, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (191, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (192, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (193, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (194, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (195, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (196, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (197, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (198, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (199, 'INTEGER', 'active(1), passive(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (200, 'INTEGER', 'start(1), stop(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (201, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (202, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (203, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (204, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (205, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (206, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (207, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (208, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (209, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (210, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (211, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (212, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (213, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (214, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (215, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (216, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (217, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (218, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (219, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (220, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (221, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (222, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (223, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (224, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (225, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (226, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (227, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (228, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (229, 'INTEGER', 'enabled(1), disabled(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (232, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (233, 'SEQUENCE OF SysOREntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (234, 'SysOREntry', '', NULL, 'not-accessible', 'sysORIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (235, 'INTEGER', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (236, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (237, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (238, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (239, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (240, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (242, 'OBJECT IDENTIFIER', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (243, 'OBJECT IDENTIFIER', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (249, 'TestAndIncr', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (302, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (303, 'SEQUENCE OF IfXEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (304, 'IfXEntry', '', NULL, 'not-accessible', 'ifEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (305, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (306, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (307, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (308, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (309, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (310, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (311, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (312, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (313, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (314, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (315, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (316, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (317, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (318, 'INTEGER', 'enabled(1), disabled(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (319, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (320, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (321, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (322, 'DisplayString', 'SIZE(0..64)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (323, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (324, 'SEQUENCE OF IfStackEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (325, 'IfStackEntry', '', NULL, 'not-accessible', 'ifStackHigherLayer, ifStackLowerLayer', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (326, 'InterfaceIndexOrZero', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (327, 'InterfaceIndexOrZero', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (328, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (329, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (330, 'SEQUENCE OF IfRcvAddressEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (331, 'IfRcvAddressEntry', '', NULL, 'not-accessible', 'ifIndex, ifRcvAddressAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (332, 'PhysAddress', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (333, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (334, 'INTEGER', 'other(1), volatile(2), nonVolatile(3)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (351, 'SEQUENCE OF IfTestEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (352, 'IfTestEntry', '', NULL, 'not-accessible', 'ifEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (353, 'TestAndIncr', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (354, 'INTEGER', 'notInUse(1), inUse(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (355, 'AutonomousType', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (356, 'INTEGER', 'none(1), success(2), inProgress(3), notSupported(4), unAbleToRun(5), aborted(6), failed(7)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (357, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (358, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (370, 'SnmpEngineID', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (371, 'INTEGER', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (372, 'INTEGER', '0..2147483647', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (373, 'INTEGER', '484..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (390, 'SEQUENCE OF EtherStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (391, 'EtherStatsEntry', '', NULL, 'not-accessible', 'etherStatsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (392, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (393, 'OBJECT IDENTIFIER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (394, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (395, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (398, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (399, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (400, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (401, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (402, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (403, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (404, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (405, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (406, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (407, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (408, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (409, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (410, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (411, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (412, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (413, 'SEQUENCE OF HistoryControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (414, 'HistoryControlEntry', '', NULL, 'not-accessible', 'historyControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (415, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (416, 'OBJECT IDENTIFIER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (417, 'INTEGER', '1..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (418, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (419, 'INTEGER', '1..3600', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (420, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (421, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (422, 'SEQUENCE OF EtherHistoryEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (423, 'EtherHistoryEntry', '', NULL, 'not-accessible', 'etherHistoryIndex , etherHistorySampleIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (424, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (425, 'INTEGER', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (426, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (427, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (428, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (429, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (430, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (431, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (432, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (433, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (434, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (435, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (436, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (437, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (438, 'INTEGER', '0..10000', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (439, 'SEQUENCE OF AlarmEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (440, 'AlarmEntry', '', NULL, 'not-accessible', 'alarmIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (441, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (442, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (443, 'OBJECT IDENTIFIER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (444, 'INTEGER', 'absoluteValue(1), deltaValue(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (445, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (446, 'INTEGER', 'risingAlarm(1), fallingAlarm(2), risingOrFallingAlarm(3)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (447, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (448, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (449, 'INTEGER', '0..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (450, 'INTEGER', '0..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (451, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (452, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (453, 'SEQUENCE OF HostControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (454, 'HostControlEntry', '', NULL, 'not-accessible', 'hostControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (455, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (456, 'OBJECT IDENTIFIER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (457, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (458, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (459, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (460, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (461, 'SEQUENCE OF HostEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (462, 'HostEntry', '', NULL, 'not-accessible', 'hostIndex, hostAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (463, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (464, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (465, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (466, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (467, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (468, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (469, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (470, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (471, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (472, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (473, 'SEQUENCE OF HostTimeEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (474, 'HostTimeEntry', '', NULL, 'not-accessible', 'hostTimeIndex, hostTimeCreationOrder', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (475, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (476, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (477, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (478, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (479, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (480, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (481, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (482, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (483, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (484, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (485, 'SEQUENCE OF HostTopNControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (486, 'HostTopNControlEntry', '', NULL, 'not-accessible', 'hostTopNControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (487, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (488, 'INTEGER', '1..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (489, 'INTEGER', 'hostTopNInPkts(1), hostTopNOutPkts(2), hostTopNInOctets(3), hostTopNOutOctets(4), hostTopNOutErrors(5), hostTopNOutBroadcastPkts(6), hostTopNOutMulticastPkts(7)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (490, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (491, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (492, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (493, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (494, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (495, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (496, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (497, 'SEQUENCE OF HostTopNEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (498, 'HostTopNEntry', '', NULL, 'not-accessible', 'hostTopNReport, hostTopNIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (499, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (500, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (501, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (502, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (503, 'SEQUENCE OF MatrixControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (504, 'MatrixControlEntry', '', NULL, 'not-accessible', 'matrixControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (505, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (506, 'OBJECT IDENTIFIER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (507, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (508, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (509, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (510, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (511, 'SEQUENCE OF MatrixSDEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (512, 'MatrixSDEntry', '', NULL, 'not-accessible', 'matrixSDIndex, matrixSDSourceAddress, matrixSDDestAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (513, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (514, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (515, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (516, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (517, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (518, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (519, 'SEQUENCE OF MatrixDSEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (520, 'MatrixDSEntry', '', NULL, 'not-accessible', 'matrixDSIndex, matrixDSDestAddress, matrixDSSourceAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (521, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (522, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (523, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (524, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (525, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (526, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (527, 'SEQUENCE OF FilterEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (528, 'FilterEntry', '', NULL, 'not-accessible', 'filterIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (529, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (530, 'INTEGER', '1..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (531, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (532, 'OCTET STRING', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (533, 'OCTET STRING', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (534, 'OCTET STRING', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (535, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (536, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (537, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (538, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (539, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (540, 'SEQUENCE OF ChannelEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (541, 'ChannelEntry', '', NULL, 'not-accessible', 'channelIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (542, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (543, 'INTEGER', '1..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (544, 'INTEGER', 'acceptMatched(1), acceptFailed(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (545, 'INTEGER', 'on(1), off(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (546, 'INTEGER', '0..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (547, 'INTEGER', '0..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (548, 'INTEGER', '0..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (549, 'INTEGER', 'eventReady(1), eventFired(2), eventAlwaysReady(3)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (550, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (551, 'DisplayString', 'SIZE (0..127)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (552, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (553, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (554, 'SEQUENCE OF BufferControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (555, 'BufferControlEntry', '', NULL, 'not-accessible', 'bufferControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (556, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (557, 'INTEGER', '1..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (558, 'INTEGER', 'spaceAvailable(1), full(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (559, 'INTEGER', 'lockWhenFull(1), wrapWhenFull(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (560, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (561, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (562, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (563, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (564, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (565, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (566, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (567, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (568, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (569, 'SEQUENCE OF CaptureBufferEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (570, 'CaptureBufferEntry', '', NULL, 'not-accessible', 'captureBufferControlIndex, captureBufferIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (571, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (572, 'INTEGER', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (573, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (574, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (575, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (576, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (577, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (578, 'SEQUENCE OF EventEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (579, 'EventEntry', '', NULL, 'not-accessible', 'eventIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (580, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (581, 'DisplayString', 'SIZE (0..127)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (582, 'INTEGER', 'none(1), log(2), snmp-trap(3), log-and-trap(4)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (583, 'STRING', 'SIZE (0..127)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (584, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (585, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (586, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (587, 'SEQUENCE OF LogEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (588, 'LogEntry', '', NULL, 'not-accessible', 'logEventIndex, logIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (589, 'INTEGER', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (590, 'INTEGER', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (591, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (592, 'DisplayString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (800, 'INTEGER', 'one(1), two(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (801, 'INTEGER', '-1..1023', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (802, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (804, 'SEQUENCE OF ManagementDomainEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (805, 'ManagementDomainEntry', '', NULL, 'not-accessible', 'managementDomainIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (806, 'ManagementDomainIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (807, 'DisplayString', 'SIZE (0..32)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (808, 'INTEGER', 'client(1), server(2), transparent(3)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (809, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (810, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (811, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (812, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (813, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (814, 'DisplayString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (815, 'INTEGER', 'enabled(1), disabled(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (816, 'INTEGER', 'version1 (1), version2 (2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (818, 'SEQUENCE OF VtpVlanEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (819, 'VtpVlanEntry', '', NULL, 'not-accessible', 'managementDomainIndex, vtpVlanIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (820, 'VlanIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (821, 'INTEGER', 'operational(1), suspended(2), mtuTooBigForDevice(3), mtuTooBigForTrunk(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (822, 'VlanType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (823, 'DisplayString', 'SIZE (1..32)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (824, 'INTEGER', '1500..18190', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (825, 'STRING', 'SIZE (4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (826, 'INTEGER', '0..4095', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (827, 'INTEGER', '0..15', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (828, 'INTEGER', 'ieee(1), ibm(2), hybrid(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (829, 'VlanIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (830, 'VlanIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (831, 'VlanIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (832, 'INTEGER', 'srt(1), srb(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (833, 'INTEGER', '1..13', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (834, 'INTEGER', '1..13', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (835, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (836, 'VlanTypeExt', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (838, 'SEQUENCE OF VtpEditControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (839, 'VtpEditControlEntry', '', NULL, 'not-accessible', 'managementDomainEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (840, 'INTEGER', 'none(1), copy(2), apply(3), release(4), restartTimer(5)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (841, 'INTEGER', 'inProgress(1), succeeded(2), configNumberError(3), inconsistentEdit(4), tooBig(5), localNVStoreFail(6), remoteNVStoreFail(7), editBufferEmpty(8), someOtherError(9)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (842, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (843, 'Gauge32', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (844, 'SEQUENCE OF VtpVlanEditEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (845, 'VtpVlanEditEntry', '', NULL, 'not-accessible', 'managementDomainIndex, vtpVlanEditIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (846, 'VlanIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (847, 'INTEGER', 'operational(1), suspended(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (848, 'VlanType', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (849, 'DisplayString', 'SIZE (1..32)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (850, 'INTEGER', '1500..18190', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (851, 'STRING', 'SIZE (4)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (852, 'INTEGER', '0..4095', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (853, 'INTEGER', '0..15', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (854, 'INTEGER', 'ieee(1), ibm(2), auto(3)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (855, 'VlanIndex', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (856, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (857, 'VlanIndex', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (858, 'VlanIndex', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (859, 'INTEGER', 'srt(1), srb(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (860, 'INTEGER', '1..13', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (861, 'INTEGER', '1..13', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (862, 'TruthValue', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (863, 'VlanTypeExt', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (865, 'SEQUENCE OF VtpStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (866, 'VtpStatsEntry', '', NULL, 'not-accessible', 'managementDomainEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (867, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (868, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (869, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (870, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (871, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (872, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (873, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (874, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (876, 'SEQUENCE OF VlanTrunkPortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (877, 'VlanTrunkPortEntry', '', NULL, 'not-accessible', 'vlanTrunkPortIfIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (878, 'InterfaceIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (879, 'ManagementDomainIndex', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (880, 'INTEGER', 'isl(1), dot10(2), lane(3), dot1Q(4), negotiate(5)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (881, 'STRING', 'SIZE (128)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (882, 'VlanIndex', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (883, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (884, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (885, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (886, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (887, 'STRING', 'SIZE (128)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (888, 'STRING', 'SIZE (128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (889, 'STRING', 'SIZE (128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (890, 'INTEGER', 'on(1), off(2), desirable(3), auto(4), onNoNegotiate(5)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (891, 'INTEGER', 'trunking(1), notTrunking(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (892, 'TruthValue', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (893, 'INTEGER', 'isl(1), dot10(2), lane(3), dot1Q(4), negotiating(5), notApplicable(6)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (894, 'STRING', 'SIZE (0..128)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (895, 'STRING', 'SIZE (0..128)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (896, 'STRING', 'SIZE (0..128)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (897, 'STRING', 'SIZE (0..128)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (898, 'STRING', 'SIZE (0..128)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (899, 'STRING', 'SIZE (0..128)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (900, 'STRING', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (901, 'STRING', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (902, 'STRING', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (903, 'STRING', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (904, 'STRING', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (905, 'STRING', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (906, 'INTEGER', 'trunk(1), access(2), disabled(3)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (907, 'TestAndIncr', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (908, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (919, 'INTEGER', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (943, 'SEQUENCE OF CdpInterfaceEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (944, 'CdpInterfaceEntry', '', NULL, 'not-accessible', 'cdpInterfaceIfIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (945, 'Integer32', '0..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (946, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (947, 'INTEGER', '5..254', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (948, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (949, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (950, 'SEQUENCE OF CdpInterfaceExtEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (951, 'CdpInterfaceExtEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (952, 'INTEGER', 'trusted(1), noTrust(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (953, 'Unsigned32', '0..7', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (954, 'SEQUENCE OF CdpCacheEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (955, 'CdpCacheEntry', '', NULL, 'not-accessible', 'cdpCacheIfIndex, cdpCacheDeviceIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (956, 'Integer32', '0..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (957, 'Integer32', '0..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (958, 'CiscoNetworkProtocol', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (959, 'CiscoNetworkAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (960, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (961, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (962, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (963, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (964, 'STRING', 'SIZE (0..4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (965, 'DisplayString', 'SIZE (0..32)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (966, 'VlanIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (967, 'INTEGER', 'unknown(1), halfduplex(2), fullduplex(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (968, 'Unsigned32', '0..255', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (969, 'Unsigned32', '0..4095', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (970, 'Unsigned32', '', 'milliwatts', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (971, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (972, 'DisplayString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (973, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (974, 'CiscoNetworkProtocol', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (975, 'CiscoNetworkAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (976, 'CiscoNetworkProtocol', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (977, 'CiscoNetworkAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (978, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (979, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (980, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (981, 'INTEGER', '5..254', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (982, 'INTEGER', '10..255', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (983, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (984, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (985, 'BITS', 'serialNumber(0), macAddress(1), other (2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (986, 'INTEGER', 'serialNumber(1), macAddress(2), other(3)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1002, 'INTEGER', 'oldAgs (1), ags (2), c7000 (3), ci (4), c7200 (5), cAccessMon (6), cat6000 (7), ubr7200 (8), cat4000 (9), c10000 (10), osr7600(11), c7600 (12), c37xx (13), other (14)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1003, 'SEQUENCE OF CiscoEnvMonVoltageStatusEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1004, 'CiscoEnvMonVoltageStatusEntry', '', NULL, 'not-accessible', 'ciscoEnvMonVoltageStatusIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1005, 'Integer32', '0..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1006, 'DisplayString', 'SIZE (0..32)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1007, 'CiscoSignedGauge', '', 'millivolts', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1008, 'Integer32', '', 'millivolts', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1009, 'Integer32', '', 'millivolts', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1010, 'Integer32', '', 'millivolts', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1011, 'CiscoEnvMonState', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1012, 'SEQUENCE OF CiscoEnvMonTemperatureStatusEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1013, 'CiscoEnvMonTemperatureStatusEntry', '', NULL, 'not-accessible', 'ciscoEnvMonTemperatureStatusIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1014, 'Integer32', '0..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1015, 'DisplayString', 'SIZE (0..32)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1016, 'Gauge32', '', 'degrees Celsius', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1017, 'Integer32', '', 'degrees Celsius', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1018, 'Integer32', '', 'degrees Celsius', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1019, 'CiscoEnvMonState', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1020, 'SEQUENCE OF CiscoEnvMonFanStatusEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1021, 'CiscoEnvMonFanStatusEntry', '', NULL, 'not-accessible', 'ciscoEnvMonFanStatusIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1022, 'Integer32', '0..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1023, 'DisplayString', 'SIZE (0..32)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1024, 'CiscoEnvMonState', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1025, 'SEQUENCE OF CiscoEnvMonSupplyStatusEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1026, 'CiscoEnvMonSupplyStatusEntry', '', NULL, 'not-accessible', 'ciscoEnvMonSupplyStatusIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1027, 'Integer32', '0..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1028, 'DisplayString', 'SIZE (0..32)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1029, 'CiscoEnvMonState', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1030, 'INTEGER', 'unknown(1), ac(2), dc(3), externalPowerSupply(4), internalRedundant(5)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1031, 'BITS', 'minorVisual(0), majorVisual(1), criticalVisual(2), minorAudible(3), majorAudible(4), criticalAudible(5), input(6)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1033, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1034, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1035, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1036, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1037, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1038, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1064, 'Unsigned32', '0..4294967295', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1065, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1066, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1067, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1068, 'SEQUENCE OF CfcRequestEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1069, 'CfcRequestEntry', '', NULL, 'not-accessible', 'cfcRequestIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1070, 'Unsigned32', '1..4294967295', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1071, 'INTEGER', 'putBinary(1), putASCII(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1072, 'DisplayString', 'SIZE (1..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1073, 'DisplayString', 'SIZE (1..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1074, 'DisplayString', 'SIZE (1..64)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1075, 'DisplayString', 'SIZE (1..32)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1076, 'DisplayString', 'SIZE (0..16)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1077, 'INTEGER', 'pending(1), success(2), aborted(3), fileOpenFailLocal(4), fileOpenFailRemote(5), badDomainName(6), unreachableIpAddress(7), linkFailed(8), fileReadFailed(9), fileWriteFailed(10)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1078, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1079, 'INTEGER', 'ready(1), stop(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1080, 'INTEGER', 'running(1), stopping(2), stopped(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1081, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1093, 'Counter32', '', 'notifications', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1094, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1095, 'SyslogSeverity', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1096, 'Counter32', '', 'messages', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1097, 'Counter32', '', 'messages', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1098, 'INTEGER', 'none (1), other (2), hostName (3), ipv4Address (4), contextName (5), userDefined (6)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1099, 'SnmpAdminString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1100, 'Integer32', '0..500', 'entries', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1101, 'Counter32', '', 'messages', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1102, 'SEQUENCE OF ClogHistoryEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1103, 'ClogHistoryEntry', '', NULL, 'not-accessible', 'clogHistIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1104, 'Integer32', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1105, 'DisplayString', 'SIZE (1..20)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1106, 'SyslogSeverity', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1107, 'DisplayString', 'SIZE (1..30)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1108, 'DisplayString', 'SIZE (1..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1109, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1110, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1111, 'SEQUENCE OF ClogServerConfigEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1112, 'ClogServerConfigEntry', '', NULL, 'not-accessible', 'clogServerAddrType, clogServerAddr', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1113, 'InetAddressType', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1114, 'InetAddress', 'SIZE(0..64)', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1115, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6251, 'Integer32(5..32768)', '', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6252, 'Integer32(2..10)', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6253, 'Integer32(1..10)', '', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6254, 'Integer32(1..8192)', '', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6255, 'Integer32(5..3600)', '', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6256, 'SEQUENCE OF LldpPortConfigEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6257, 'LldpPortConfigEntry', '', NULL, 'not-accessible', 'lldpPortConfigPortNum', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6258, 'LldpPortNumber', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6259, 'INTEGER', 'txOnly(1), rxOnly(2), txAndRx(3), disabled(4)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6260, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6261, 'BITS', 'portDesc(0), sysName(1), sysDesc(2), sysCap(3)', NULL, 'read-write', NULL, '{');
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6262, 'SEQUENCE OF LldpConfigManAddrEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6263, 'LldpConfigManAddrEntry', '', NULL, 'not-accessible', 'lldpLocManAddrEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6264, 'LldpPortList', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6265, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6266, 'ZeroBasedCounter32', '', 'table entries', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6267, 'ZeroBasedCounter32', '', 'table entries', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1161, 'SEQUENCE OF ApplEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1162, 'ApplEntry', '', NULL, 'not-accessible', 'applIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1163, 'INTEGER', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1164, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1165, 'DistinguishedName', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1166, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1167, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1168, 'INTEGER', 'up(1), down(2), halted(3), congested(4), restarting(5), quiescing(6)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1169, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1170, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1171, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1172, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1173, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1174, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1175, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1176, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1177, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1178, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1179, 'URLString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1180, 'SEQUENCE OF AssocEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1181, 'AssocEntry', '', NULL, 'not-accessible', 'applIndex, assocIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1182, 'INTEGER', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1183, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1184, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1185, 'INTEGER', 'uainitiator(1), uaresponder(2), peerinitiator(3), peerresponder(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1186, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5876, 'INTEGER', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5877, 'STRING', 'SIZE (1)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5878, 'STRING', 'SIZE (1)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5879, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5880, 'SEQUENCE OF CharSessEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5881, 'CharSessEntry', '', NULL, 'not-accessible', 'charSessPortIndex, charSessIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5882, 'PortIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5883, 'INTEGER', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5884, 'INTEGER', 'ready(1), execute(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5885, 'INTEGER', 'connecting(1), connected(2), disconnecting(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5886, 'AutonomousType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5894, 'INTEGER', 'unknown(1), network(2), local(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5895, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5896, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5897, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5898, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5721, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5722, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5723, 'ControlStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5724, 'DisplayString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5725, 'Unsigned32', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5726, 'FlowAddressComponent', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5727, 'FlowAddressComponent', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5728, 'FlowAddressComponent', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5729, 'FlowAddressComponent', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5730, 'INTEGER', '1..255', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5731, 'INTEGER', 'included(1), excluded(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5732, 'Integer32', '1..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5733, 'SEQUENCE OF CseL3StatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5734, 'CseL3StatsEntry', '', NULL, 'not-accessible', 'entPhysicalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5735, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5736, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5737, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5738, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5739, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5740, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5741, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5742, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5743, 'SEQUENCE OF CseL3VlanStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5744, 'CseL3VlanStatsEntry', '', NULL, 'not-accessible', 'entPhysicalIndex, cseL3VlanIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5745, 'VlanIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5746, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5747, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5748, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5749, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5750, 'SEQUENCE OF CseStatsFlowEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5751, 'CseStatsFlowEntry', '', NULL, 'not-accessible', 'cseL3StatsEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5752, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5753, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5754, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5755, 'SEQUENCE OF CseCacheUtilEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5756, 'CseCacheUtilEntry', '', NULL, 'not-accessible', 'entPhysicalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5757, 'Gauge32', '0..100', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5758, 'SEQUENCE OF CseProtocolFilterPortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5759, 'CseProtocolFilterPortEntry', '', NULL, 'not-accessible', 'ifIndex, cseProtocolFilterPortProtocol', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5760, 'INTEGER', 'ip(1), ipx(2), grpProtocols(3)', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5761, 'INTEGER', 'on(1), off(2), auto(3)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5762, 'INTEGER', 'on(1), off(2), notSupported(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5763, 'SEQUENCE OF CseUcastCacheEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5764, 'CseUcastCacheEntry', '', NULL, 'not-accessible', 'cseUcastCacheIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5765, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5766, 'INTEGER', 'any(1), dstOnly(2), srcOrDst(3), srcAndDst(4), fullFlow(5), ipxDstOnly(6), ipxSrcAndDst(7)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5767, 'INTEGER', 'udp(1), tcp(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5768, 'FlowAddressComponent', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5769, 'FlowAddressComponent', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5770, 'FlowAddressComponent', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5771, 'FlowAddressComponent', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5772, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5773, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5774, 'INTEGER', 'purging(1), notPurging(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5775, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5776, 'SEQUENCE OF CseMcastCacheEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5777, 'CseMcastCacheEntry', '', NULL, 'not-accessible', 'cseMcastCacheIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5778, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5779, 'INTEGER', 'any(1), group(2), grpAndSrc(3)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5780, 'McastGroupIp', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5781, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5782, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5783, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5784, 'INTEGER', 'purging(1), notPurging(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5785, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5803, 'SEQUENCE OF CiscoMemoryPoolEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5804, 'CiscoMemoryPoolEntry', '', NULL, 'not-accessible', 'ciscoMemoryPoolType', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5805, 'CiscoMemoryPoolTypes', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5806, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5807, 'Integer32', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5808, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5809, 'Gauge32', '', 'bytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5810, 'Gauge32', '', 'bytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5811, 'Gauge32', '', 'bytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5821, 'SEQUENCE OF CciDescriptionEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5822, 'CciDescriptionEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5823, 'SnmpAdminString', 'SIZE(0..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5824, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5832, 'SEQUENCE OF CeAssetEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5833, 'CeAssetEntry', '', NULL, 'not-accessible', 'entPhysicalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5834, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5835, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5836, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5837, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5838, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5839, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5840, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5841, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5842, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5843, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5844, 'SnmpAdminString', 'SIZE (0|10)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5845, 'SnmpAdminString', 'SIZE (0..32)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5846, 'SnmpAdminString', 'SIZE (0..32)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5847, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5856, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5857, 'SEQUENCE OF CharPortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5858, 'CharPortEntry', '', NULL, 'not-accessible', 'charPortIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5859, 'PortIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5860, 'DisplayString', 'SIZE (0..32)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5861, 'INTEGER', 'physical(1), virtual(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5862, 'AutonomousType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5863, 'INTEGER', 'ready(1), execute(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5864, 'INTEGER', 'enabled(1), disabled(2), off(3), maintenance(4)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5865, 'INTEGER', 'up(1), down(2), maintenance(3), absent(4), active(5)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5866, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5867, 'INTEGER', 'none(1), xonXoff(2), hardware(3), ctsRts(4), dsrDtr(5)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5868, 'INTEGER', 'none(1), xonXoff(2), hardware(3), ctsRts(4), dsrDtr(5)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5869, 'INTEGER', 'none(1), unknown(2), stop(3), go(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5870, 'INTEGER', 'none(1), unknown(2), stop(3), go(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5871, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5872, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5873, 'INTEGER', 'dynamic(1), network(2), local(3), none(4)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5874, 'INTEGER', '-1..2147483647', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5875, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5604, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5605, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5606, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5607, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5608, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5609, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5610, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5611, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5612, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5613, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5614, 'SEQUENCE OF CseL2StatsHCEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5615, 'CseL2StatsHCEntry', '', NULL, 'not-accessible', 'entPhysicalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5616, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5617, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5618, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5619, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5620, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5621, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5622, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5623, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5624, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5625, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5626, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5627, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5628, 'INTEGER', '1..4294967295', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5629, 'Unsigned32', '', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5630, 'Unsigned32', '', 'packets', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5631, 'SEQUENCE OF CseRouterEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5632, 'CseRouterEntry', '', NULL, 'not-accessible', 'cseRouterIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5633, 'IpAddress', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5634, 'INTEGER', 'dstOnly(1), srcDst(2), fullFlow(3), notApplicable(4), srcDstVlan(5)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5635, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5636, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5637, 'INTEGER', 'dstOnly(1), srcDst(2), fullFlow(3), notApplicable(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5638, 'SEQUENCE OF CseStaticExtRouterEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5639, 'CseStaticExtRouterEntry', '', NULL, 'not-accessible', 'cseRouterIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5640, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5641, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5642, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5643, 'STRING', 'SIZE(1)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5644, 'SEQUENCE OF CseRouterVlanEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5645, 'CseRouterVlanEntry', '', NULL, 'not-accessible', 'cseRouterIndex, cseRouterMac, cseRouterVlan', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5646, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5647, 'VlanIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5648, 'OCTET STRING(SIZE(1))', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5649, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5650, 'SEQUENCE OF CseFlowQueryEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5651, 'CseFlowQueryEntry', '', NULL, 'not-accessible', 'entPhysicalIndex, cseFlowQueryIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5652, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5653, 'INTEGER', 'dstOnly(1), srcOrDst(2), srcAndDst(3), fullFlow(4), ipxDstOnly(5), ipxSrcAndDst(6), any(7)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5654, 'OCTET STRING(SIZE(1))', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5655, 'FlowAddressComponent', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5656, 'FlowAddressComponent', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5657, 'FlowAddressComponent', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5658, 'FlowAddressComponent', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5659, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5660, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5661, 'INTEGER', '-1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5662, 'CiscoGauge64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5663, 'CiscoGauge64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5664, 'TimeInterval', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5665, 'TimeInterval', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5666, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5667, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5668, 'SEQUENCE OF CseFlowDataEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5669, 'CseFlowDataEntry', '', NULL, 'not-accessible', 'entPhysicalIndex, cseFlowQueryIndex, cseFlowDataIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5670, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5671, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5672, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5673, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5674, 'INTEGER', 'ipArpa(1), ipxEthernet(2), ipx802raw(3), ipx802sap(4), ipx802snap(5), other(6)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5675, 'FlowAddressComponent', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5676, 'FlowAddressComponent', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5677, 'VlanIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5678, 'INTEGER', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5679, 'INTEGER', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5680, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5681, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5682, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5683, 'CiscoGauge64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5684, 'SEQUENCE OF CseFlowSwitchControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5685, 'CseFlowSwitchControlEntry', '', NULL, 'not-accessible', 'cseFlowSwitchProtocol', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5686, 'CiscoNetworkProtocol', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5687, 'ControlStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5688, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5689, 'SEQUENCE OF CseFlowMcastQueryEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5690, 'CseFlowMcastQueryEntry', '', NULL, 'not-accessible', 'cseFlowMcastQueryIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5691, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5692, 'OCTET STRING(SIZE(1))', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5693, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5694, 'McastGroupIp', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5695, 'VlanIndex', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5696, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5697, 'INTEGER', '0..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5698, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5699, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5700, 'Integer32', '-1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5701, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5702, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5703, 'SEQUENCE OF CseFlowMcastResultEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5547, 'NTPTimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5548, 'NTPPollInterval', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5549, 'NTPAssocIdentifier', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5704, 'CseFlowMcastResultEntry', '', NULL, 'not-accessible', 'cseFlowMcastQueryIndex, entPhysicalIndex, cseFlowMcastResultIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5705, 'Integer32', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5706, 'McastGroupIp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5707, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5708, 'VlanIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5709, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5710, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5711, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5712, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5713, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5714, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5715, 'STRING', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5716, 'ControlStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5717, 'INTEGER', '1..4294967295', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5718, 'SEQUENCE OF CseStaticIpxExtRouterEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5719, 'CseStaticIpxExtRouterEntry', '', NULL, 'not-accessible', 'cseRouterIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1511, 'SEQUENCE OF SysApplInstallPkgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1512, 'SysApplInstallPkgEntry', '', NULL, 'not-accessible', 'sysApplInstallPkgIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1513, 'Unsigned32', '1..''ffffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1514, 'Utf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1515, 'Utf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1516, 'Utf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1517, 'Utf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1518, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1519, 'LongUtf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1520, 'SEQUENCE OF SysApplInstallElmtEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1521, 'SysApplInstallElmtEntry', '', NULL, 'not-accessible', 'sysApplInstallPkgIndex, sysApplInstallElmtIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1522, 'Unsigned32', '1..''ffffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1523, 'Utf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1524, 'INTEGER', 'unknown(1), nonexecutable(2), operatingSystem(3), deviceDriver(4), application(5)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1525, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1526, 'LongUtf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1527, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1528, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1529, 'BITS', 'executable(0),     exclusive(1),    primary(2),          required(3),      dependent(4),    unknown(5)', NULL, 'read-write', NULL, '{ unknown');
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1530, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1531, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1532, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1533, 'SEQUENCE OF SysApplRunEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1534, 'SysApplRunEntry', '', NULL, 'not-accessible', 'sysApplInstallPkgIndex, sysApplRunIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1535, 'Unsigned32', '1..''ffffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1536, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1537, 'RunState', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1538, 'SEQUENCE OF SysApplPastRunEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1539, 'SysApplPastRunEntry', '', NULL, 'not-accessible', 'sysApplInstallPkgIndex, sysApplPastRunIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1540, 'Unsigned32', '1..''ffffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1541, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1542, 'INTEGER', 'complete (1), failed (2), other (3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1543, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1544, 'SEQUENCE OF SysApplElmtRunEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1545, 'SysApplElmtRunEntry', '', NULL, 'not-accessible', 'sysApplElmtRunInstallPkg, sysApplElmtRunInvocID, sysApplElmtRunIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1546, 'Unsigned32', '0..''ffffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1547, 'Unsigned32', '0..''ffffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1548, 'Unsigned32', '0..''ffffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1549, 'Unsigned32', '0..''ffffffff''h', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1550, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1551, 'RunState', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1552, 'LongUtf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1553, 'Utf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1554, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1555, 'Gauge32', '', 'Kbytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1556, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1557, 'Utf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1558, 'SEQUENCE OF SysApplElmtPastRunEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1559, 'SysApplElmtPastRunEntry', '', NULL, 'not-accessible', 'sysApplInstallPkgIndex, sysApplElmtPastRunInvocID, sysApplElmtPastRunIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1560, 'Unsigned32', '1..''ffffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1561, 'Unsigned32', '0..''ffffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1562, 'Unsigned32', '1..''ffffffff''h', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1563, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1564, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1565, 'LongUtf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1566, 'Utf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1567, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1568, 'Unsigned32', '0..''ffffffff''h', 'Kbytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1569, 'Unsigned32', '0..''ffffffff''h', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1570, 'Utf8String', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1571, 'Unsigned32', '0..''ffffffff''h', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1572, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1573, 'Unsigned32', '0..''ffffffff''h', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1574, 'Unsigned32', '0..''ffffffff''h', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1575, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1576, 'Unsigned32', '0..''ffffffff''h', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1577, 'Unsigned32', '0..''ffffffff''h', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1578, 'SEQUENCE OF SysApplMapEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1579, 'SysApplMapEntry', '', NULL, 'not-accessible', 'sysApplElmtRunIndex, sysApplElmtRunInvocID, sysApplMapInstallElmtIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1580, 'Unsigned32', '0..''ffffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1581, 'Unsigned32', '0..''ffffffff''h', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5720, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5515, 'SEQUENCE OF CipPrecedenceEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5516, 'CipPrecedenceEntry', '', NULL, 'not-accessible', 'ifIndex, cipPrecedenceDirection, cipPrecedenceIpPrecedence', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5517, 'PacketSource', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5518, 'Integer32', '0..7', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5519, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5520, 'Counter32', '', 'bytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5521, 'SEQUENCE OF CipMacEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5522, 'CipMacEntry', '', NULL, 'not-accessible', 'ifIndex, cipMacDirection, cipMacAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5523, 'PacketSource', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5524, 'MacAddress', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5525, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5526, 'Counter32', '', 'bytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5527, 'SEQUENCE OF CipMacFreeEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5528, 'CipMacFreeEntry', '', NULL, 'not-accessible', 'ifIndex, cipMacFreeDirection', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5529, 'PacketSource', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5530, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5541, 'NTPLeapIndicator', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5542, 'NTPStratum', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5543, 'Integer32', '-20..20', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5544, 'NTPSignedTimeValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5545, 'NTPUnsignedTimeValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5546, 'NTPRefId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5550, 'NTPTimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5551, 'SEQUENCE OF CntpPeersVarEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5552, 'CntpPeersVarEntry', '', NULL, 'not-accessible', 'cntpPeersAssocId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5553, 'NTPAssocIdentifier', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5554, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5555, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5556, 'Integer32', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5557, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5558, 'Integer32', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5559, 'NTPLeapIndicator', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5560, 'INTEGER', 'unspecified (0), symmetricActive (1), symmetricPassive (2), client (3), server(4), broadcast (5), reservedControl (6), reservedPrivate (7)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5561, 'NTPStratum', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5562, 'NTPPollInterval', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5563, 'NTPPollInterval', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5564, 'Integer32', '-20..20', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5565, 'NTPSignedTimeValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5566, 'NTPUnsignedTimeValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5567, 'NTPRefId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5568, 'NTPTimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5569, 'NTPTimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5570, 'NTPTimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5571, 'NTPTimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5572, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5573, 'Integer32', '0..255', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5574, 'Integer32', '0..2147483647', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5575, 'NTPSignedTimeValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5576, 'NTPSignedTimeValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5577, 'NTPUnsignedTimeValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5578, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5579, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5580, 'SEQUENCE OF CntpFilterRegisterEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5581, 'CntpFilterRegisterEntry', '', NULL, 'not-accessible', 'cntpPeersAssocId, cntpFilterIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5582, 'Integer32', '1..8', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5583, 'NTPSignedTimeValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5584, 'NTPSignedTimeValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5585, 'NTPUnsignedTimeValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5602, 'SEQUENCE OF CseL2StatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5603, 'CseL2StatsEntry', '', NULL, 'not-accessible', 'entPhysicalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5440, 'EntPhysicalContainsEntry', '', NULL, 'not-accessible', 'entPhysicalIndex, entPhysicalChildIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5441, 'PhysicalIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5442, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5415, 'SEQUENCE OF EntPhysicalEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5416, 'EntPhysicalEntry', '', NULL, 'not-accessible', 'entPhysicalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5417, 'PhysicalIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5418, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5419, 'AutonomousType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5420, 'INTEGER', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5421, 'PhysicalClass', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5422, 'INTEGER', '-1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5423, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5424, 'SEQUENCE OF EntLogicalEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5425, 'EntLogicalEntry', '', NULL, 'not-accessible', 'entLogicalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5426, 'INTEGER', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5427, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5428, 'AutonomousType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5429, 'STRING', 'SIZE (1..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5430, 'TAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5431, 'TDomain', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5432, 'SEQUENCE OF EntLPMappingEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5433, 'EntLPMappingEntry', '', NULL, 'not-accessible', 'entLogicalIndex, entLPPhysicalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5434, 'PhysicalIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5435, 'SEQUENCE OF EntAliasMappingEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5436, 'EntAliasMappingEntry', '', NULL, 'not-accessible', 'entPhysicalIndex, entAliasLogicalIndexOrZero', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5437, 'INTEGER', '0..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5438, 'RowPointer', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5439, 'SEQUENCE OF EntPhysicalContainsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5090, 'Integer32', '0..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5091, 'INTEGER', 'independent(1), shared(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5092, 'SEQUENCE OF Dot1vProtocolGroupEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5093, 'Dot1vProtocolGroupEntry', '', NULL, 'not-accessible', 'dot1vProtocolTemplateFrameType, dot1vProtocolTemplateProtocolValue', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5094, 'INTEGER', 'ethernet(1), rfc1042(2), snap8021H(3), snapOther(4), llcOther(5)', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5095, 'STRING', 'SIZE (2 | 5)', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5096, 'Integer32', '0..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5097, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5098, 'SEQUENCE OF Dot1vProtocolPortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5099, 'Dot1vProtocolPortEntry', '', NULL, 'not-accessible', 'dot1dBasePort, dot1vProtocolPortGroupId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5100, 'Integer32', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5101, 'Integer32', '1..4094', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5102, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5130, 'SEQUENCE OF CfmFlowMonitorEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5131, 'CfmFlowMonitorEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5132, 'FlowMonitorIdentifier', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5133, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5134, 'FlowMetrics', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5135, 'Gauge32', '', 'traffic flows', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5136, 'FlowMonitorConditionsProfileOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5137, 'FlowMonitorConditions', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5138, 'FlowMonitorConditions', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5139, 'CiscoAlarmSeverity', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5140, 'Gauge32', '', 'alarms', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5141, 'Gauge32', '', 'alarms', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5142, 'Gauge32', '', 'alarms', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5143, 'Gauge32', '', 'alarms', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5144, 'Gauge32', '', 'alarms', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5145, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5147, 'SEQUENCE OF CfmFlowEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5148, 'CfmFlowEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5149, 'FlowIdentifier', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5150, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5151, 'RowPointer', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5152, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5153, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5154, 'Unsigned32', '0..4294967295', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5155, 'INTEGER', 'unknown(1), ingress(2), egress(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5156, 'INTEGER', 'enabled(1), disabled(2), expire(3)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5157, 'INTEGER', 'enabled(1), disabled(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5158, 'FlowPointType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5159, 'FlowPointIdentifier', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5160, 'FlowPointType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5161, 'FlowPointIdentifier', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5162, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5163, 'SEQUENCE OF CfmFlowL2VlanEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5164, 'CfmFlowL2VlanEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5165, 'RowPointer', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5166, 'VlanId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5167, 'Layer2Cos', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5168, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5169, 'SEQUENCE OF CfmFlowIpEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5170, 'CfmFlowIpEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5171, 'RowPointer', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5172, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5173, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5174, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5175, 'BITS', 'trafficClass(0), hopLimit(1)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5176, 'Unsigned32', '0..255', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5177, 'Unsigned32', '0..255', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5178, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5179, 'SEQUENCE OF CfmFlowUdpEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5180, 'CfmFlowUdpEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5181, 'RowPointer', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5182, 'InetPortNumber', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5183, 'InetPortNumber', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5184, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5185, 'SEQUENCE OF CfmFlowTcpEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5186, 'CfmFlowTcpEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5187, 'RowPointer', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5188, 'InetPortNumber', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5189, 'InetPortNumber', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5190, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5191, 'SEQUENCE OF CfmFlowRtpEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5192, 'CfmFlowRtpEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5193, 'RowPointer', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5194, 'Unsigned32', '0..3', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5195, 'Unsigned32', '0..4294967295', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5196, 'Unsigned32', '0..127', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5197, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5199, 'SEQUENCE OF CfmFlowMetricsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5200, 'CfmFlowMetricsEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5201, 'FlowMetrics', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5202, 'Unsigned32', '1..3600', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5203, 'Unsigned32', '0..4294967295', 'intervals', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5204, 'Gauge32', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5205, 'Gauge32', '', 'intervals', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5206, 'Gauge32', '', 'intervals', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4932, 'INTEGER', 'direct(1), modem(2), switch(3), modemSwitch(4)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4933, 'ControlString', 'SIZE(0..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4934, 'ControlString', 'SIZE(0..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4935, 'ControlString', 'SIZE(0..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4936, 'ControlString', 'SIZE(0..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4937, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4938, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4939, 'SEQUENCE OF EtherStats2Entry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4940, 'EtherStats2Entry', '', NULL, 'not-accessible', 'etherStatsEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4941, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4942, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4943, 'SEQUENCE OF HistoryControl2Entry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4944, 'HistoryControl2Entry', '', NULL, 'not-accessible', 'historyControlEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4945, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4946, 'SEQUENCE OF HostControl2Entry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4947, 'HostControl2Entry', '', NULL, 'not-accessible', 'hostControlEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4948, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4949, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4950, 'SEQUENCE OF MatrixControl2Entry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4951, 'MatrixControl2Entry', '', NULL, 'not-accessible', 'matrixControlEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4952, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4953, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4954, 'SEQUENCE OF Channel2Entry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4955, 'Channel2Entry', '', NULL, 'not-accessible', 'channelEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4956, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4957, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4958, 'SEQUENCE OF TokenRingMLStats2Entry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4959, 'TokenRingMLStats2Entry', '', NULL, 'not-accessible', 'tokenRingMLStatsEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4960, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4961, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4962, 'SEQUENCE OF TokenRingPStats2Entry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4963, 'TokenRingPStats2Entry', '', NULL, 'not-accessible', 'tokenRingPStatsEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4964, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4965, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4966, 'SEQUENCE OF RingStationControl2Entry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4967, 'RingStationControl2Entry', '', NULL, 'not-accessible', 'ringStationControlEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4968, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4969, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4970, 'SEQUENCE OF SourceRoutingStats2Entry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4971, 'SourceRoutingStats2Entry', '', NULL, 'not-accessible', 'sourceRoutingStatsEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4972, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4973, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4974, 'SEQUENCE OF Filter2Entry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4975, 'Filter2Entry', '', NULL, 'not-accessible', 'filterEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4976, 'Integer32', '0..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4977, 'Integer32', '0..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5002, 'INTEGER', 'version1(1)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5003, 'VlanId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5004, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5005, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5006, 'EnabledStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5007, 'SEQUENCE OF Dot1qFdbEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5008, 'Dot1qFdbEntry', '', NULL, 'not-accessible', 'dot1qFdbId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5009, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5010, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5011, 'SEQUENCE OF Dot1qTpFdbEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5012, 'Dot1qTpFdbEntry', '', NULL, 'not-accessible', 'dot1qFdbId, dot1qTpFdbAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5013, 'MacAddress', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5014, 'Integer32', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5015, 'INTEGER', 'other(1), invalid(2), learned(3), self(4), mgmt(5)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5016, 'SEQUENCE OF Dot1qTpGroupEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5017, 'Dot1qTpGroupEntry', '', NULL, 'not-accessible', 'dot1qVlanIndex, dot1qTpGroupAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5018, 'MacAddress', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5019, 'PortList', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5020, 'PortList', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5021, 'SEQUENCE OF Dot1qForwardAllEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5022, 'Dot1qForwardAllEntry', '', NULL, 'not-accessible', 'dot1qVlanIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5023, 'PortList', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5024, 'PortList', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5025, 'PortList', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5026, 'SEQUENCE OF Dot1qForwardUnregisteredEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5027, 'Dot1qForwardUnregisteredEntry', '', NULL, 'not-accessible', 'dot1qVlanIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5028, 'PortList', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5029, 'PortList', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5030, 'PortList', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5031, 'SEQUENCE OF Dot1qStaticUnicastEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5032, 'Dot1qStaticUnicastEntry', '', NULL, 'not-accessible', 'dot1qFdbId, dot1qStaticUnicastAddress, dot1qStaticUnicastReceivePort', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5033, 'MacAddress', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5034, 'Integer32', '0..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5035, 'PortList', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5036, 'INTEGER', 'other(1), invalid(2), permanent(3), deleteOnReset(4), deleteOnTimeout(5)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5037, 'SEQUENCE OF Dot1qStaticMulticastEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5038, 'Dot1qStaticMulticastEntry', '', NULL, 'not-accessible', 'dot1qVlanIndex, dot1qStaticMulticastAddress, dot1qStaticMulticastReceivePort', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5039, 'MacAddress', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5040, 'Integer32', '0..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5041, 'PortList', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5042, 'PortList', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5043, 'INTEGER', 'other(1), invalid(2), permanent(3), deleteOnReset(4), deleteOnTimeout(5)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5044, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5045, 'SEQUENCE OF Dot1qVlanCurrentEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5046, 'Dot1qVlanCurrentEntry', '', NULL, 'not-accessible', 'dot1qVlanTimeMark, dot1qVlanIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5047, 'TimeFilter', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5048, 'VlanIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5049, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5050, 'PortList', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5051, 'PortList', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5052, 'INTEGER', 'other(1), permanent(2), dynamicGvrp(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5053, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5054, 'SEQUENCE OF Dot1qVlanStaticEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5055, 'Dot1qVlanStaticEntry', '', NULL, 'not-accessible', 'dot1qVlanIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5056, 'SnmpAdminString', 'SIZE (0..32)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5057, 'PortList', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5058, 'PortList', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5059, 'PortList', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5060, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5061, 'Integer32', '0 | 4096..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5062, 'SEQUENCE OF Dot1qPortVlanEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5063, 'Dot1qPortVlanEntry', '', NULL, 'not-accessible', 'dot1dBasePortEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5064, 'VlanIndex', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4826, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4827, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4828, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4829, 'SEQUENCE OF AlHostEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4830, 'AlHostEntry', '', NULL, 'not-accessible', 'hlHostControlIndex, alHostTimeMark, protocolDirLocalIndex, nlHostAddress, protocolDirLocalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4831, 'TimeFilter', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4832, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4833, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4834, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4835, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4836, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4837, 'SEQUENCE OF AlMatrixSDEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4838, 'AlMatrixSDEntry', '', NULL, 'not-accessible', 'hlMatrixControlIndex, alMatrixSDTimeMark, protocolDirLocalIndex, nlMatrixSDSourceAddress, nlMatrixSDDestAddress, protocolDirLocalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4839, 'TimeFilter', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4840, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4841, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4842, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4843, 'SEQUENCE OF AlMatrixDSEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4844, 'AlMatrixDSEntry', '', NULL, 'not-accessible', 'hlMatrixControlIndex, alMatrixDSTimeMark, protocolDirLocalIndex, nlMatrixDSDestAddress, nlMatrixDSSourceAddress, protocolDirLocalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4845, 'TimeFilter', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4846, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4847, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4848, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4849, 'SEQUENCE OF AlMatrixTopNControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4850, 'AlMatrixTopNControlEntry', '', NULL, 'not-accessible', 'alMatrixTopNControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4851, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4852, 'Integer32', '1..65535', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4853, 'INTEGER', 'alMatrixTopNTerminalsPkts(1), alMatrixTopNTerminalsOctets(2), alMatrixTopNAllPkts(3), alMatrixTopNAllOctets(4)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4854, 'Integer32', '0..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4855, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4856, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4857, 'Integer32', '0..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1953, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1954, 'Integer32', '', 'ports', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1955, 'INTEGER', 'unknown(1), transparent-only(2), sourceroute-only(3), srt(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1956, 'SEQUENCE OF Dot1dBasePortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1957, 'Dot1dBasePortEntry', '', NULL, 'not-accessible', 'dot1dBasePort', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1958, 'Integer32', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1959, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1960, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1961, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1962, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1963, 'INTEGER', 'unknown(1), decLb100(2), ieee8021d(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1964, 'Integer32', '0..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1965, 'TimeTicks', '', 'centi-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1966, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1967, 'BridgeId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1968, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1969, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1970, 'Timeout', '', 'centi-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1971, 'Timeout', '', 'centi-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1972, 'Integer32', '', 'centi-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1973, 'Timeout', '', 'centi-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1974, 'Timeout', '600..4000', 'centi-seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1975, 'Timeout', '100..1000', 'centi-seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1976, 'Timeout', '400..3000', 'centi-seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1977, 'SEQUENCE OF Dot1dStpPortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1978, 'Dot1dStpPortEntry', '', NULL, 'not-accessible', 'dot1dStpPort', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1979, 'Integer32', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1980, 'Integer32', '0..255', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1981, 'INTEGER', 'disabled(1), blocking(2), listening(3), learning(4), forwarding(5), broken(6)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1982, 'INTEGER', 'enabled(1), disabled(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1983, 'Integer32', '1..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1984, 'BridgeId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1985, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1986, 'BridgeId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1987, 'STRING', 'SIZE (2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1988, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1989, 'Integer32', '1..200000000', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1990, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1991, 'Integer32', '10..1000000', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1992, 'SEQUENCE OF Dot1dTpFdbEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1993, 'Dot1dTpFdbEntry', '', NULL, 'not-accessible', 'dot1dTpFdbAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1994, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1995, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1996, 'INTEGER', 'other(1), invalid(2), learned(3), self(4), mgmt(5)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1997, 'SEQUENCE OF Dot1dTpPortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1998, 'Dot1dTpPortEntry', '', NULL, 'not-accessible', 'dot1dTpPort', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (1999, 'Integer32', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2000, 'Integer32', '', 'bytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2001, 'Counter32', '', 'frames', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2002, 'Counter32', '', 'frames', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2003, 'Counter32', '', 'frames', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2004, 'SEQUENCE OF Dot1dStaticEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2005, 'Dot1dStaticEntry', '', NULL, 'not-accessible', 'dot1dStaticAddress, dot1dStaticReceivePort', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2006, 'MacAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2007, 'Integer32', '0..65535', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2008, 'STRING', 'SIZE (0..512)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2009, 'INTEGER', 'other(1), invalid(2), permanent(3), deleteOnReset(4), deleteOnTimeout(5)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4858, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4859, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4860, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4861, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4862, 'SEQUENCE OF AlMatrixTopNEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4863, 'AlMatrixTopNEntry', '', NULL, 'not-accessible', 'alMatrixTopNControlIndex, alMatrixTopNIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4864, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4865, 'Integer32', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4866, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4867, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4868, 'Integer32', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4869, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4870, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4871, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4872, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4873, 'SEQUENCE OF UsrHistoryControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4874, 'UsrHistoryControlEntry', '', NULL, 'not-accessible', 'usrHistoryControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4875, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4876, 'Integer32', '1..65535', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4877, 'Integer32', '1..65535', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4878, 'Integer32', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4879, 'Integer32', '1..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4880, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4881, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4882, 'SEQUENCE OF UsrHistoryObjectEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4883, 'UsrHistoryObjectEntry', '', NULL, 'not-accessible', 'usrHistoryControlIndex, usrHistoryObjectIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4884, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4885, 'OBJECT IDENTIFIER', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4886, 'INTEGER', 'absoluteValue(1), deltaValue(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4887, 'SEQUENCE OF UsrHistoryEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4888, 'UsrHistoryEntry', '', NULL, 'not-accessible', 'usrHistoryControlIndex, usrHistorySampleIndex, usrHistoryObjectIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4889, 'Integer32', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4890, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4891, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4892, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4893, 'INTEGER', 'valueNotAvailable(1), valuePositive(2),      valueNegative(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4894, 'STRING', 'SIZE(1)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4895, 'DisplayString', 'SIZE(0..15)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4896, 'DisplayString', 'SIZE(0..31)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4897, 'STRING', 'SIZE (0 | 8 | 11)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4898, 'INTEGER', 'running(1), warmBoot(2), coldBoot(3)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4899, 'DisplayString', 'SIZE(0..127)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4900, 'IpAddress', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4901, 'INTEGER', 'notDownloading(1), downloadToPROM(2), downloadToRAM(3)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2088, 'SEQUENCE OF Dot1dTpHCPortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2089, 'Dot1dTpHCPortEntry', '', NULL, 'not-accessible', 'dot1dTpPort', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2090, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2091, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2092, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2093, 'SEQUENCE OF Dot1dTpPortOverflowEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2094, 'Dot1dTpPortOverflowEntry', '', NULL, 'not-accessible', 'dot1dTpPort', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2095, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2096, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2097, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2103, 'BITS', 'dot1dExtendedFilteringServices(0), dot1dTrafficClasses(1), dot1qStaticEntryIndividualPort(2), dot1qIVLCapable(3), dot1qSVLCapable(4), dot1qHybridCapable(5), dot1qConfigurablePvidTagging(6), dot1dLocalVlanCapable(7)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2104, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2105, 'EnabledStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2106, 'SEQUENCE OF Dot1dPortCapabilitiesEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2107, 'Dot1dPortCapabilitiesEntry', '', NULL, 'not-accessible', 'dot1dBasePortEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2108, 'BITS', 'dot1qDot1qTagging(0), dot1qConfigurableAcceptableFrameTypes(1), dot1qIngressFiltering(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2109, 'SEQUENCE OF Dot1dPortPriorityEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2110, 'Dot1dPortPriorityEntry', '', NULL, 'not-accessible', 'dot1dBasePortEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2111, 'Integer32', '0..7', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2112, 'Integer32', '1..8', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2113, 'SEQUENCE OF Dot1dUserPriorityRegenEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2114, 'Dot1dUserPriorityRegenEntry', '', NULL, 'not-accessible', 'dot1dBasePort, dot1dUserPriority', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2115, 'Integer32', '0..7', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2116, 'Integer32', '0..7', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2117, 'SEQUENCE OF Dot1dTrafficClassEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2118, 'Dot1dTrafficClassEntry', '', NULL, 'not-accessible', 'dot1dBasePort, dot1dTrafficClassPriority', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2119, 'Integer32', '0..7', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2120, 'Integer32', '0..7', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2121, 'SEQUENCE OF Dot1dPortOutboundAccessPriorityEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2122, 'Dot1dPortOutboundAccessPriorityEntry', '', NULL, 'not-accessible', 'dot1dBasePort, dot1dRegenUserPriority', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2123, 'Integer32', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2124, 'SEQUENCE OF Dot1dPortGarpEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2125, 'Dot1dPortGarpEntry', '', NULL, 'not-accessible', 'dot1dBasePortEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2126, 'TimeInterval', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2127, 'TimeInterval', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2128, 'TimeInterval', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2129, 'SEQUENCE OF Dot1dPortGmrpEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2130, 'Dot1dPortGmrpEntry', '', NULL, 'not-accessible', 'dot1dBasePortEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2131, 'EnabledStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2132, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2133, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (2134, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5363, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5364, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5365, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5366, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5367, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5368, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5369, 'FlowMetricValue', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5370, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5371, 'SEQUENCE OF CfmRtpMetricsIntEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5372, 'CfmRtpMetricsIntEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId, cfmFlowMetricsIntNumber', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5373, 'BITS', 'expectedPkts(0), lostPkts(1), lossFraction(2), lossIntervals(3), avgLossIntervalDuration(4), avgLossDistance(5), maxJitter(6), maxMinTransit(7)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5374, 'ReportIntervalCount', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5375, 'ReportIntervalCount', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5376, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5377, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5378, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5379, 'ReportIntervalCount', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5380, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5381, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5382, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5383, 'ReportIntervalCount', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5384, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5385, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5386, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5387, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5388, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5389, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5207, 'FlowMonitorConditionsProfileOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5208, 'FlowMonitorConditions', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5209, 'FlowMonitorConditions', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5210, 'CiscoAlarmSeverity', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5211, 'Counter64', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5212, 'Counter64', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5213, 'FlowBitRateUnits', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5214, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5215, 'Gauge32', '', 'packets per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5216, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5217, 'SEQUENCE OF CfmFlowMetricsIntEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5218, 'CfmFlowMetricsIntEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId, cfmFlowMetricsIntNumber', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5219, 'Unsigned32', '1..4294967295', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5220, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5221, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5222, 'FlowMonitorConditions', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5223, 'FlowMonitorConditions', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5224, 'CiscoAlarmSeverity', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5225, 'ReportIntervalCount', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5226, 'ReportIntervalCount', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5227, 'FlowBitRateUnits', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5228, 'ReportIntervalCount', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5229, 'ReportIntervalCount', '', 'packets per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5231, 'SEQUENCE OF CfmConditionEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5232, 'CfmConditionEntry', '', NULL, 'not-accessible', 'cfmConditionProfile, cfmConditionId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5233, 'FlowMonitorConditionsProfile', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5234, 'FlowMonitorConditionIdentifier', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5235, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5236, 'AutonomousType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5237, 'INTEGER', 'other(1), boolean(2), risingThreshold(3), fallingThreshold(4), risingAndFallingThreshold(5)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5238, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5239, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5240, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5241, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5242, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5243, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5244, 'INTEGER', 'other(1), raw(2), slidingWindowAvg(3), expDecayingAvg(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5245, 'Unsigned32', '0..4294967295', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5246, 'INTEGER', 'none(1), discrete(2), grouped(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5247, 'BITS', 'syslog(0), snmp(1)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5248, 'CiscoAlarmSeverity', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5249, 'FlowMonitorAlarmGroupIdentifier', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5250, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5252, 'SEQUENCE OF CfmAlarmGroupEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5253, 'CfmAlarmGroupEntry', '', NULL, 'not-accessible', 'cfmAlarmGroupId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5254, 'FlowMonitorAlarmGroupIdentifier', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5255, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5256, 'FlowMonitorConditionsProfile', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5257, 'FlowMonitorConditionIdentifier', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5258, 'FlowSetIdentifier', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5259, 'Gauge32', '', 'traffic flows', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5260, 'INTEGER', 'other(1), flows(2), percent(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5261, 'Unsigned32', '0..4294967295', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5262, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5263, 'Gauge32', '', 'traffic flows', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5264, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5265, 'SEQUENCE OF CfmAlarmGroupFlowEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5266, 'CfmAlarmGroupFlowEntry', '', NULL, 'not-accessible', 'cfmAlarmGroupFlowSetId, cfmAlarmGroupFlowMonitorId, cfmAlarmGroupFlowId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5267, 'FlowSetIdentifier', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5268, 'FlowMonitorIdentifier', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5269, 'FlowIdentifier', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5270, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5272, 'Unsigned32', '1..4294967295', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5273, 'Unsigned32', '1..4294967295', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5274, 'SEQUENCE OF CfmAlarmHistoryEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5275, 'CfmAlarmHistoryEntry', '', NULL, 'not-accessible', 'cfmAlarmHistoryId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5276, 'Unsigned32', '1..4294967295', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5277, 'INTEGER', 'cleared(1), raised(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5278, 'RowPointer', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5279, 'FlowMonitorConditionsProfile', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5280, 'FlowMonitorConditionIdentifier', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5281, 'CiscoAlarmSeverity', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5282, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5284, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5312, 'SEQUENCE OF CfmIpCbrMetricsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5313, 'CfmIpCbrMetricsEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5314, 'FlowCfgRateType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5315, 'FlowBitRateUnits', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5316, 'Unsigned32', '1..4294967295', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5317, 'Unsigned32', '64..65535', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5089, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5318, 'BITS', 'lostPkts(0), mediaRateVariation(1)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5319, 'Counter64', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5320, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5321, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5322, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5323, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5324, 'SEQUENCE OF CfmIpCbrMetricsIntEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5325, 'CfmIpCbrMetricsIntEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId, cfmFlowMetricsIntNumber', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5326, 'BITS', 'lostPkts(0), vbMin(1), vbMax(2), mediaRate(3), delayFactor(4), mediaRateVariation(5)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5327, 'ReportIntervalCount', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5328, 'ReportIntervalCount', '', 'bytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5329, 'ReportIntervalCount', '', 'bytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5330, 'FlowBitRateUnits', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5331, 'ReportIntervalCount', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5332, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5333, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5334, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5335, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5336, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5337, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5354, 'SEQUENCE OF CfmRtpMetricsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5355, 'CfmRtpMetricsEntry', '', NULL, 'not-accessible', 'cfmFlowMonitorId, cfmFlowId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5356, 'BITS', 'expectedPkts(0), lostPkts(1), lossFraction(2), lossIntervals(3), avgLossDuration(4), avgLossDistance(5), jitter(6)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5357, 'Counter64', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5358, 'Counter64', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5359, 'FlowMetricScale', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5360, 'FlowMetricPrecision', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5361, 'FlowMetricValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5362, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5065, 'INTEGER', 'admitAll(1), admitOnlyVlanTagged(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5066, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5067, 'EnabledStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5068, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5069, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5070, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5071, 'SEQUENCE OF Dot1qPortVlanStatisticsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5072, 'Dot1qPortVlanStatisticsEntry', '', NULL, 'not-accessible', 'dot1dBasePort, dot1qVlanIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5073, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5074, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5075, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5076, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5077, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5078, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5079, 'SEQUENCE OF Dot1qPortVlanHCStatisticsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5080, 'Dot1qPortVlanHCStatisticsEntry', '', NULL, 'not-accessible', 'dot1dBasePort, dot1qVlanIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5081, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5082, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5083, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5084, 'SEQUENCE OF Dot1qLearningConstraintsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5085, 'Dot1qLearningConstraintsEntry', '', NULL, 'not-accessible', 'dot1qConstraintVlan, dot1qConstraintSet', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5086, 'VlanIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5087, 'Integer32', '0..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (5088, 'INTEGER', 'independent(1), shared(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4519, 'SEQUENCE OF TokenRingMLStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4520, 'TokenRingMLStatsEntry', '', NULL, 'not-accessible', 'tokenRingMLStatsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4521, 'Integer32', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4522, 'OBJECT IDENTIFIER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4523, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4524, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4525, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4526, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4527, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4528, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4529, 'TimeInterval', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4530, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4531, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4532, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4533, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4534, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4535, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4536, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4537, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4538, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4539, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4540, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4541, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4542, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4543, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4544, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4545, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4546, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4547, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4548, 'SEQUENCE OF TokenRingPStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4549, 'TokenRingPStatsEntry', '', NULL, 'not-accessible', 'tokenRingPStatsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4550, 'Integer32', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4551, 'OBJECT IDENTIFIER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4552, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4553, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4554, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4555, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4556, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4557, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4558, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4559, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4560, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4561, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4562, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4563, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4564, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4565, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4566, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4567, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4568, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4569, 'SEQUENCE OF TokenRingMLHistoryEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4570, 'TokenRingMLHistoryEntry', '', NULL, 'not-accessible', 'tokenRingMLHistoryIndex, tokenRingMLHistorySampleIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4571, 'Integer32', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4572, 'Integer32', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4573, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4574, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4575, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4576, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4577, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4578, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4579, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4580, 'TimeInterval', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4581, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4582, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4583, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4584, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4585, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4586, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4587, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4588, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4589, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4590, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4591, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4592, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4593, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4594, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4595, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4596, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4597, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4598, 'SEQUENCE OF TokenRingPHistoryEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4599, 'TokenRingPHistoryEntry', '', NULL, 'not-accessible', 'tokenRingPHistoryIndex, tokenRingPHistorySampleIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4600, 'Integer32', '1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4601, 'Integer32', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4602, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4603, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4604, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4605, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4606, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4607, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4608, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4609, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4610, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4611, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4612, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4613, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4614, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4615, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4616, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4617, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4618, 'SEQUENCE OF RingStationControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4619, 'RingStationControlEntry', '', NULL, 'not-accessible', 'ringStationControlIfIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4620, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4621, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4622, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4623, 'INTEGER', 'normalOperation(1), ringPurgeState(2), claimTokenState(3), beaconFrameStreamingState(4), beaconBitStreamingState(5), beaconRingSignalLossState(6), beaconSetRecoveryModeState(7)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4624, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4625, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4626, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4627, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4628, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4629, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4630, 'SEQUENCE OF RingStationEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4631, 'RingStationEntry', '', NULL, 'not-accessible', 'ringStationIfIndex, ringStationMacAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4632, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4633, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4634, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4635, 'INTEGER', 'active(1), inactive(2), forcedRemoval(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4636, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4637, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4638, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4639, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4640, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4641, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4642, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4643, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4644, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4645, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4646, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4647, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4648, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4649, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4650, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4651, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4652, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4653, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4654, 'SEQUENCE OF RingStationOrderEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4655, 'RingStationOrderEntry', '', NULL, 'not-accessible', 'ringStationOrderIfIndex, ringStationOrderOrderIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4656, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4657, 'Integer32', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4658, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4659, 'SEQUENCE OF RingStationConfigControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4660, 'RingStationConfigControlEntry', '', NULL, 'not-accessible', 'ringStationConfigControlIfIndex, ringStationConfigControlMacAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4661, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4662, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4663, 'INTEGER', 'stable(1), removing(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4664, 'INTEGER', 'stable(1), updating(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4665, 'SEQUENCE OF RingStationConfigEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4666, 'RingStationConfigEntry', '', NULL, 'not-accessible', 'ringStationConfigIfIndex, ringStationConfigMacAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4667, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4668, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4669, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4670, 'STRING', 'SIZE(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4671, 'STRING', 'SIZE(10)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4672, 'STRING', 'SIZE(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4673, 'STRING', 'SIZE(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4674, 'SEQUENCE OF SourceRoutingStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4675, 'SourceRoutingStatsEntry', '', NULL, 'not-accessible', 'sourceRoutingStatsIfIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4676, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4677, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4678, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4679, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4680, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4681, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4682, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4683, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4684, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4685, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4686, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4687, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4688, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4689, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4690, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4691, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4692, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4693, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4694, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4695, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4696, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4697, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4698, 'OwnerString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4699, 'EntryStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4711, 'SEQUENCE OF ProtocolDirEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4712, 'ProtocolDirEntry', '', NULL, 'not-accessible', 'protocolDirID, protocolDirParameters', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4713, 'OCTET STRING', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4714, 'OCTET STRING', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4715, 'Integer32', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4716, 'DisplayString', 'SIZE (1..64)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4717, 'STRING', 'SIZE(1)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4718, 'INTEGER', 'notSupported(1), supportedOff(2), supportedOn(3)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4719, 'INTEGER', 'notSupported(1), supportedOff(2), supportedOn(3)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4720, 'INTEGER', 'notSupported(1), supportedOff(2), supportedOn(3)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4721, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4722, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4723, 'SEQUENCE OF ProtocolDistControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4724, 'ProtocolDistControlEntry', '', NULL, 'not-accessible', 'protocolDistControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4725, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4726, 'DataSource', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4727, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4728, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4729, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4730, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4731, 'SEQUENCE OF ProtocolDistStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4732, 'ProtocolDistStatsEntry', '', NULL, 'not-accessible', 'protocolDistControlIndex, protocolDirLocalIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4733, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4734, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4735, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4736, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4737, 'Integer32', '-1..2147483647', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4738, 'SEQUENCE OF AddressMapControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4739, 'AddressMapControlEntry', '', NULL, 'not-accessible', 'addressMapControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4740, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4741, 'DataSource', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4742, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4743, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4744, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4745, 'SEQUENCE OF AddressMapEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4746, 'AddressMapEntry', '', NULL, 'not-accessible', 'addressMapTimeMark, protocolDirLocalIndex, addressMapNetworkAddress, addressMapSource', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4747, 'TimeFilter', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4748, 'OCTET STRING', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4749, 'OBJECT IDENTIFIER', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4750, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4751, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4752, 'SEQUENCE OF HlHostControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4753, 'HlHostControlEntry', '', NULL, 'not-accessible', 'hlHostControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4754, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4755, 'DataSource', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4756, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4757, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4758, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4759, 'Integer32', '-1..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4760, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4761, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4762, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4763, 'Integer32', '-1..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4764, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4765, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4766, 'SEQUENCE OF NlHostEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4767, 'NlHostEntry', '', NULL, 'not-accessible', 'hlHostControlIndex, nlHostTimeMark, protocolDirLocalIndex, nlHostAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4768, 'TimeFilter', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4769, 'OCTET STRING', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4770, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4771, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4772, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4773, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4774, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4775, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4776, 'SEQUENCE OF HlMatrixControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4777, 'HlMatrixControlEntry', '', NULL, 'not-accessible', 'hlMatrixControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4778, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4779, 'DataSource', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4780, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4781, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4782, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4783, 'Integer32', '-1..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4784, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4785, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4786, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4787, 'Integer32', '-1..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4788, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4789, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4790, 'SEQUENCE OF NlMatrixSDEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4791, 'NlMatrixSDEntry', '', NULL, 'not-accessible', 'hlMatrixControlIndex, nlMatrixSDTimeMark, protocolDirLocalIndex, nlMatrixSDSourceAddress, nlMatrixSDDestAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4792, 'TimeFilter', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4793, 'OCTET STRING', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4794, 'OCTET STRING', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4795, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4796, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4797, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4798, 'SEQUENCE OF NlMatrixDSEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4799, 'NlMatrixDSEntry', '', NULL, 'not-accessible', 'hlMatrixControlIndex, nlMatrixDSTimeMark, protocolDirLocalIndex, nlMatrixDSDestAddress, nlMatrixDSSourceAddress', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4800, 'TimeFilter', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4801, 'OCTET STRING', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4802, 'OCTET STRING', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4803, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4804, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4805, 'LastCreateTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4806, 'SEQUENCE OF NlMatrixTopNControlEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4807, 'NlMatrixTopNControlEntry', '', NULL, 'not-accessible', 'nlMatrixTopNControlIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4808, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4809, 'Integer32', '1..65535', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4810, 'INTEGER', 'nlMatrixTopNPkts(1), nlMatrixTopNOctets(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4811, 'Integer32', '0..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4812, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4813, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4814, 'Integer32', '0..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4815, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4816, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4817, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4818, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4819, 'SEQUENCE OF NlMatrixTopNEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4820, 'NlMatrixTopNEntry', '', NULL, 'not-accessible', 'nlMatrixTopNControlIndex, nlMatrixTopNIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4821, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4822, 'Integer32', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4823, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4824, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4825, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6268, 'ZeroBasedCounter32', '', 'table entries', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6269, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6270, 'SEQUENCE OF LldpStatsTxPortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6271, 'LldpStatsTxPortEntry', '', NULL, 'not-accessible', 'lldpStatsTxPortNum', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6272, 'LldpPortNumber', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6273, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6274, 'SEQUENCE OF LldpRxStatsPortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6275, 'LldpRxStatsPortEntry', '', NULL, 'not-accessible', 'lldpStatsRxPortNum', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6276, 'LldpPortNumber', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6277, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6278, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6279, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6280, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6281, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6282, 'ZeroBasedCounter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6283, 'LldpChassisIdSubtype', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6284, 'LldpChassisId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6285, 'SnmpAdminString', 'SIZE(0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6286, 'SnmpAdminString', 'SIZE(0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6287, 'LldpSystemCapabilitiesMap', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6288, 'LldpSystemCapabilitiesMap', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6289, 'SEQUENCE OF LldpLocPortEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6290, 'LldpLocPortEntry', '', NULL, 'not-accessible', 'lldpLocPortNum', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6291, 'LldpPortNumber', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6292, 'LldpPortIdSubtype', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6293, 'LldpPortId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6294, 'SnmpAdminString', 'SIZE(0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6295, 'SEQUENCE OF LldpLocManAddrEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6296, 'LldpLocManAddrEntry', '', NULL, 'not-accessible', 'lldpLocManAddrSubtype, lldpLocManAddr', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6297, 'AddressFamilyNumbers', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6298, 'LldpManAddress', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6299, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6300, 'LldpManAddrIfSubtype', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6301, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6302, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6303, 'SEQUENCE OF LldpRemEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6304, 'LldpRemEntry', '', NULL, 'not-accessible', 'lldpRemTimeMark, lldpRemLocalPortNum, lldpRemIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6305, 'TimeFilter', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6306, 'LldpPortNumber', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6307, 'Integer32(1..2147483647)', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6308, 'LldpChassisIdSubtype', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6309, 'LldpChassisId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6310, 'LldpPortIdSubtype', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6311, 'LldpPortId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6312, 'SnmpAdminString', 'SIZE(0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6313, 'SnmpAdminString', 'SIZE(0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6314, 'SnmpAdminString', 'SIZE(0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6315, 'LldpSystemCapabilitiesMap', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6316, 'LldpSystemCapabilitiesMap', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4902, 'INTEGER', 'downloadSuccess(1), downloadStatusUnknown(2), downloadGeneralError(3), downloadNoResponseFromServer(4), downloadChecksumError(5), downloadIncompatibleImage(6), downloadTftpFileNotFound(7), downloadTftpAccessViolation(8)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4903, 'SEQUENCE OF SerialConfigEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4904, 'SerialConfigEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4905, 'INTEGER', 'direct(1), modem(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4906, 'INTEGER', 'other(1), slip(2), ppp(3)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4907, 'Integer32', '1..65535', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4908, 'ControlString', 'SIZE (0..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4909, 'ControlString', 'SIZE (0..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4910, 'DisplayString', 'SIZE (0..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4911, 'DisplayString', 'SIZE (0..255)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4912, 'Integer32', '1..65535', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4913, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4914, 'SEQUENCE OF NetConfigEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4915, 'NetConfigEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4916, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4917, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4918, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4919, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4920, 'SEQUENCE OF TrapDestEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4921, 'TrapDestEntry', '', NULL, 'not-accessible', 'trapDestIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4922, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4923, 'STRING', 'SIZE(0..127)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4924, 'INTEGER', 'ip(1), ipx(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4925, 'OCTET STRING', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4926, 'OwnerString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4927, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4928, 'SEQUENCE OF SerialConnectionEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4929, 'SerialConnectionEntry', '', NULL, 'not-accessible', 'serialConnectIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4930, 'Integer32', '1..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (4931, 'IpAddress', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6374, 'INTEGER', '1..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6375, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6376, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6377, 'SEQUENCE OF BgpPathAttrEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6378, 'BgpPathAttrEntry', '', NULL, 'not-accessible', 'bgpPathAttrDestNetwork, bgpPathAttrPeer', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6379, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6380, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6381, 'INTEGER', 'igp(1), egp(2), incomplete(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6382, 'STRING', 'SIZE (2..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6383, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6384, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6385, 'SEQUENCE OF Bgp4PathAttrEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6386, 'Bgp4PathAttrEntry', '', NULL, 'not-accessible', 'bgp4PathAttrIpAddrPrefix, bgp4PathAttrIpAddrPrefixLen, bgp4PathAttrPeer', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6387, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6388, 'INTEGER', '0..32', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6389, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6390, 'INTEGER', 'igp(1), egp(2),  incomplete(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6391, 'STRING', 'SIZE (2..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6392, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6393, 'INTEGER', '-1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6394, 'INTEGER', '-1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6395, 'INTEGER', 'lessSpecificRrouteNotSelected(1), lessSpecificRouteSelected(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6396, 'INTEGER', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6397, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6398, 'INTEGER', '-1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6399, 'INTEGER', 'false(1), true(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6400, 'STRING', 'SIZE(0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6317, 'SEQUENCE OF LldpRemManAddrEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6318, 'LldpRemManAddrEntry', '', NULL, 'not-accessible', 'lldpRemTimeMark, lldpRemLocalPortNum, lldpRemIndex, lldpRemManAddrSubtype, lldpRemManAddr', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6319, 'AddressFamilyNumbers', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6320, 'LldpManAddress', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6321, 'LldpManAddrIfSubtype', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6322, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6323, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6324, 'SEQUENCE OF LldpRemUnknownTLVEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6325, 'LldpRemUnknownTLVEntry', '', NULL, 'not-accessible', 'lldpRemTimeMark, lldpRemLocalPortNum, lldpRemIndex, lldpRemUnknownTLVType', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6326, 'Integer32(9..126)', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6327, 'STRING', 'SIZE(0..511)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6328, 'SEQUENCE OF LldpRemOrgDefInfoEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6329, 'LldpRemOrgDefInfoEntry', '', NULL, 'not-accessible', 'lldpRemTimeMark, lldpRemLocalPortNum, lldpRemIndex, lldpRemOrgDefInfoOUI, lldpRemOrgDefInfoSubtype, lldpRemOrgDefInfoIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6330, 'STRING', 'SIZE(3)', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6331, 'Integer32(1..255)', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6332, 'Integer32(1..2147483647)', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6333, 'OCTET STRING(SIZE(0..507))', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6348, 'STRING', 'SIZE (1..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6349, 'INTEGER', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6350, 'SEQUENCE OF BgpPeerEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6351, 'BgpPeerEntry', '', NULL, 'not-accessible', 'bgpPeerRemoteAddr', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6352, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6353, 'INTEGER', 'idle(1), connect(2), active(3), opensent(4), openconfirm(5), established(6)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6354, 'INTEGER', 'stop(1), start(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6355, 'Integer32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6356, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6357, 'INTEGER', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6358, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6359, 'INTEGER', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6360, 'INTEGER', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6361, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6362, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6363, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6364, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6365, 'STRING', 'SIZE (2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6366, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6367, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6368, 'INTEGER', '1..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6369, 'INTEGER', '0 | 3..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6370, 'INTEGER', '0 | 1..21845', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6371, 'INTEGER', '0 | 3..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6372, 'INTEGER', '0 | 1..21845', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6373, 'INTEGER', '1..65535', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6688, 'SEQUENCE OF LifEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6689, 'LifEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6690, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6691, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6692, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6693, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6694, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6695, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6696, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6697, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6698, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6699, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6700, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6701, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6702, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6703, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6704, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6705, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6706, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6707, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6708, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6709, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6710, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6711, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6712, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6713, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6714, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6715, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6716, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6717, 'DisplayString', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6718, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6719, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6720, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6721, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6722, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6723, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6724, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6725, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6726, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6727, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6728, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6729, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6730, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6731, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6732, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6733, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6734, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6735, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6736, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6737, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6738, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6739, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6740, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6741, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6742, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6743, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6744, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6745, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6746, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6747, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6748, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6749, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6750, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6751, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6752, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6753, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6754, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6755, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6756, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6757, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6758, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6759, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6760, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6761, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6762, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6763, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6764, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6765, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6766, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6767, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6768, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6769, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6770, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6771, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6772, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6773, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6774, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6775, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6776, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6777, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6778, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6779, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6780, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6781, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6782, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6783, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6784, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6785, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6786, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6787, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6788, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6789, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6790, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6791, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6792, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6793, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6794, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6795, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6796, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6797, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6798, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6799, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6800, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6801, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6802, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6803, 'SEQUENCE OF LFSIPEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6804, 'LFSIPEntry', '', NULL, 'not-accessible', 'locIfFSIPIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6805, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6806, 'INTEGER', 'notAvailable(1), dte(2), dce(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6807, 'INTEGER', 'notAvailable(1), up(2), down(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6808, 'INTEGER', 'notAvailable(1), up(2), down(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6809, 'INTEGER', 'notAvailable(1), up(2), down(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6810, 'INTEGER', 'notAvailable(1), up(2), down(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6811, 'INTEGER', 'notAvailable(1), up(2), down(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6812, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6813, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6814, 'INTEGER', 'noCable(1), rs232(2), rs422(3), rs423(4), v35(5), x21(6), rs449(7), rs530(8), hssi(9)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6845, 'SEQUENCE OF CcmGroupEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6846, 'CcmGroupEntry', '', NULL, 'not-accessible', 'ccmGroupIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6847, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6848, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6849, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6850, 'SEQUENCE OF CcmEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6851, 'CcmEntry', '', NULL, 'not-accessible', 'ccmIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6852, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6853, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6854, 'SnmpAdminString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6855, 'SnmpAdminString', 'SIZE (0..24)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6856, 'INTEGER', 'unknown(1), up(2), down(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6857, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6858, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6859, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6860, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6861, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6862, 'SEQUENCE OF CcmGroupMappingEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6863, 'CcmGroupMappingEntry', '', NULL, 'not-accessible', 'ccmGroupIndex, ccmIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6864, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6865, 'SEQUENCE OF CcmRegionEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6866, 'CcmRegionEntry', '', NULL, 'not-accessible', 'ccmRegionIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6867, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6868, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6869, 'SEQUENCE OF CcmRegionPairEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6870, 'CcmRegionPairEntry', '', NULL, 'not-accessible', 'ccmRegionSrcIndex, ccmRegionDestIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6871, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6872, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6873, 'INTEGER', 'unknown(1), other(2), bwG723(3), bwG729(4), bwG711(5), bwGSM(6), bwWideband(7)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6874, 'SEQUENCE OF CcmTimeZoneEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6875, 'CcmTimeZoneEntry', '', NULL, 'not-accessible', 'ccmTimeZoneIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6876, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6877, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6878, 'Integer32', '-12..12', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6879, 'Integer32', '-12..12', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6880, 'Integer32', '-59..59', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6881, 'SEQUENCE OF CcmDevicePoolEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6882, 'CcmDevicePoolEntry', '', NULL, 'not-accessible', 'ccmDevicePoolIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6883, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6884, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6885, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6886, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6887, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6888, 'SEQUENCE OF CcmProductTypeEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6889, 'CcmProductTypeEntry', '', NULL, 'not-accessible', 'ccmProductTypeIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6890, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6891, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6892, 'SnmpAdminString', 'SIZE (0..100)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6893, 'INTEGER', 'unknown(-1), notApplicable(0), phone(1), gateway(2), h323Device(3), ctiDevice(4), voiceMailDevice(5), mediaResourceDevice(6), huntListDevice(7), sipDevice(8)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6894, 'SEQUENCE OF CcmPhoneEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6895, 'CcmPhoneEntry', '', NULL, 'not-accessible', 'ccmPhoneIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6896, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6897, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6898, 'INTEGER', 'unknown(1), other(2), cisco30SPplus(3), cisco12SPplus(4), cisco12SP(5), cisco12S(6), cisco30VIP(7), ciscoTeleCasterBid(8), ciscoTeleCasterMgr(9), ciscoTeleCasterBusiness(10), ciscoSoftPhone(11), ciscoConferencePhone(12), cisco7902(13), cisco7905(14), cisco7912(15), cisco7970(16)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6899, 'SnmpAdminString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6900, 'SnmpAdminString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6901, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6902, 'CcmDeviceStatus', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6903, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6904, 'SnmpAdminString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6905, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6906, 'Integer32', '-1..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6907, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6908, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6909, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6910, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6911, 'CcmDevFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6912, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6913, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6914, 'CcmPhoneProtocolType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6915, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6916, 'InetAddressIPv4', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6917, 'InetAddressIPv6', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6918, 'INTEGER', 'unknown(0), adminOnly(1), controlOnly(2), adminAndControl(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6919, 'INTEGER', 'unknown(0), adminOnly(1), controlOnly(2), adminAndControl(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6920, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6921, 'CcmDevUnregCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6922, 'CcmDevRegFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6923, 'SEQUENCE OF CcmPhoneExtensionEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6924, 'CcmPhoneExtensionEntry', '', NULL, 'not-accessible', 'ccmPhoneExtensionIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6925, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6926, 'SnmpAdminString', 'SIZE (0..24)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6927, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6928, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6929, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6930, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6931, 'SEQUENCE OF CcmPhoneFailedEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6932, 'CcmPhoneFailedEntry', '', NULL, 'not-accessible', 'ccmPhoneFailedIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6933, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6934, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6935, 'SnmpAdminString', 'SIZE (0..64)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6936, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6937, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6938, 'CcmDevFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6939, 'MacAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6940, 'InetAddressIPv4', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6941, 'InetAddressIPv6', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6942, 'INTEGER', 'unknown(0), adminOnly(1), controlOnly(2), adminAndControl(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6943, 'INTEGER', 'unknown(0), adminOnly(1), controlOnly(2), adminAndControl(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6944, 'CcmDevRegFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6945, 'SEQUENCE OF CcmPhoneStatusUpdateEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6946, 'CcmPhoneStatusUpdateEntry', '', NULL, 'not-accessible', 'ccmPhoneStatusUpdateIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6947, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6948, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6949, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6950, 'INTEGER', 'unknown(1), phoneRegistered(2), phoneUnregistered(3), phonePartiallyregistered(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6951, 'CcmDevFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6952, 'CcmDevUnregCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6953, 'CcmDevRegFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6954, 'SEQUENCE OF CcmPhoneExtnEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6955, 'CcmPhoneExtnEntry', '', NULL, 'not-accessible', 'ccmPhoneIndex, ccmPhoneExtnIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6956, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6957, 'SnmpAdminString', 'SIZE (0..24)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6958, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6959, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6960, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6961, 'CcmDeviceLineStatus', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6962, 'SEQUENCE OF CcmGatewayEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6963, 'CcmGatewayEntry', '', NULL, 'not-accessible', 'ccmGatewayIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6964, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6965, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6966, 'INTEGER', 'unknown(1), other(2), ciscoAnalogAccess(3), ciscoDigitalAccessPRI(4), ciscoDigitalAccessT1(5), ciscoDigitalAccessPRIPlus(6), ciscoDigitalAccessWSX6608E1(7), ciscoDigitalAccessWSX6608T1(8), ciscoAnalogAccessWSX6624(9), ciscoMGCPStation(10), ciscoDigitalAccessE1Plus(11), ciscoDigitalAccessT1Plus(12), ciscoDigitalAccessWSX6608PRI(13), ciscoAnalogAccessWSX6612(14), ciscoMGCPTrunk(15), ciscoVG200(16), cisco26XX(17), cisco362X(18), cisco364X(19), cisco366X(20), ciscoCat4224VoiceGatewaySwitch(21), ciscoCat4000AccessGatewayModule(22), ciscoIAD2400(23), ciscoVGCEndPoint(24), ciscoVG224VG248Gateway(25), ciscoVGCBox(26), ciscoATA186(27), ciscoICS77XXMRP2XX(28), ciscoICS77XXASI81(29), ciscoICS77XXASI160(30), ciscoSlotVGCPort(31), ciscoCat6000AVVIDServModule(32), ciscoWSX6600(33), ciscoWSSVCCMMMS(34), cisco3745(35), cisco3725(36), ciscoICS77XXMRP3XX(37), ciscoICS77XXMRP38FXS(38), ciscoICS77XXMRP316FXS(39), ciscoICS77XXMRP38FXOM1(40), cisco269X(41), cisco1760(42), cisco1751(43), ciscoMGCPBRIPort(44)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6967, 'SnmpAdminString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6968, 'CcmDeviceStatus', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6969, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6970, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6971, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6972, 'CcmDeviceProductId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6973, 'CcmDevFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6974, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6975, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6976, 'INTEGER', 'active(1), inActive(2), unknown(3), notApplicable(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6977, 'Integer32', '-1..24', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6978, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6979, 'CcmDevUnregCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6980, 'CcmDevRegFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6981, 'SEQUENCE OF CcmGatewayTrunkEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6982, 'CcmGatewayTrunkEntry', '', NULL, 'not-accessible', 'ccmGatewayTrunkIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6983, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6984, 'INTEGER', 'unknown(1), other(2), trunkGroundStart(3), trunkLoopStart(4), trunkDID(5), trunkPOTS(6), trunkEM1(7), trunkEM2(8), trunkEM3(9), trunkEM4(10), trunkEM5(11), analog(12), pri(13), bri(14)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6985, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6986, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6987, 'INTEGER', 'unknown(1), up(2), busy(3), down(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6988, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6989, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6990, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6991, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6992, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6993, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6994, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6995, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6996, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6997, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6998, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (6999, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7000, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7001, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7002, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7003, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7004, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7005, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7006, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7007, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7008, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7009, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7010, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7011, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7012, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7013, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7014, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7015, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7016, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7017, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7018, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7019, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7020, 'Integer32', '0..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7021, 'SEQUENCE OF CcmMediaDeviceEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7022, 'CcmMediaDeviceEntry', '', NULL, 'not-accessible', 'ccmMediaDeviceIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7023, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7024, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7025, 'INTEGER', 'unknown(1), ciscoMediaTerminPointWSX6608(2), ciscoConfBridgeWSX6608(3), ciscoSwMediaTerminationPoint(4), ciscoSwConfBridge(5), ciscoMusicOnHold(6), ciscoToneAnnouncementPlayer(7), ciscoConfBridgeWSSVCCMM(8), ciscoMediaServerWSSVCCMMMS(9), ciscoMTPWSSVCCMM(10), ciscoIOSSWMTPHDV2(11), ciscoIOSConfBridgeHDV2(12), ciscoIOSMTPHDV2(13), ciscoVCBIPVC35XX(14)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7026, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7027, 'CcmDeviceStatus', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7028, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7029, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7030, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7031, 'CcmDevFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7032, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7033, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7034, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7035, 'InetAddressIPv4', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7036, 'InetAddressIPv6', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7037, 'CcmDevUnregCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7038, 'CcmDevRegFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7039, 'SEQUENCE OF CcmGatekeeperEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7040, 'CcmGatekeeperEntry', '', NULL, 'not-accessible', 'ccmGatekeeperIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7041, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7042, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7043, 'INTEGER', 'unknown(1), other(2), terminal(3), gateway(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7044, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7045, 'INTEGER', 'unknown(1), registered(2), unregistered(3), rejected(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7046, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7047, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7048, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7049, 'SEQUENCE OF CcmCTIDeviceEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7050, 'CcmCTIDeviceEntry', '', NULL, 'not-accessible', 'ccmCTIDeviceIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7051, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7052, 'SnmpAdminString', 'SIZE (0..64)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7053, 'INTEGER', 'unknown(1), other(2), ctiRoutePoint(3), ctiPort(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7054, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7055, 'CcmDeviceStatus', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7056, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7057, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7058, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7059, 'SnmpAdminString', 'SIZE (0..64)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7060, 'CcmDevFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7061, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7062, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7063, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7064, 'InetAddressIPv4', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7065, 'InetAddressIPv6', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7066, 'CcmDevUnregCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7067, 'CcmDevRegFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7068, 'SEQUENCE OF CcmCTIDeviceDirNumEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7069, 'CcmCTIDeviceDirNumEntry', '', NULL, 'not-accessible', 'ccmCTIDeviceIndex, ccmCTIDeviceDirNumIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7070, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7071, 'SnmpAdminString', 'SIZE (0..24)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7072, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7073, 'Integer32', '0 | 30..3600', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7074, 'Integer32', '1800..3600', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7075, 'Integer32', '0 | 30..3600', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7076, 'Integer32', '1800..3600', 'seconds', 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7077, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7078, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7079, 'INTEGER', 'emergency(1), alert(2), critical(3), error(4), warning(5), notice(6), informational(7)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7080, 'INTEGER', 'unknown(1), heartBeatStopped(2), routerThreadDied(3), timerThreadDied(4), criticalThreadDied(5), deviceMgrInitFailed(6), digitAnalysisInitFailed(7), callControlInitFailed(8), linkMgrInitFailed(9), dbMgrInitFailed(10), msgTranslatorInitFailed(11), suppServicesInitFailed(12)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7081, 'Unsigned32', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7082, 'Unsigned32', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7083, 'CcmDevFailCauseCode', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7084, 'INTEGER', 'unknown(1), mediaTerminationPoint(2), transcoder(3), conferenceBridge(4), musicOnHold(5)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7085, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7086, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7087, 'Integer32', '1..2147483647', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7088, 'INTEGER', 'unknown(1), up(2), down(3)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7089, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7090, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7091, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7092, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7093, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7094, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7095, 'DateAndTime', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7096, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7097, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7098, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7099, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7100, 'DateAndTime', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7101, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7102, 'InetAddressType', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7103, 'InetAddress', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7104, 'DateAndTime', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7105, 'INTEGER', 'unknown(1), authenticationerror(2), invalidx509nameincertificate(3), invalidtlscipher(4)', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7106, 'CcmDevRegFailCauseCode', '', NULL, 'accessible-for-notify', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7107, 'SEQUENCE OF CcmH323DeviceEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7108, 'CcmH323DeviceEntry', '', NULL, 'not-accessible', 'ccmH323DevIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7109, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7110, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7111, 'CcmDeviceProductId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7112, 'SnmpAdminString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7113, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7114, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7115, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7116, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7117, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7118, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7119, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7120, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7121, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7122, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7123, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7124, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7125, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7126, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7127, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7128, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7129, 'INTEGER', 'notApplicable(0), unknown(1), registered(2), unregistered(3), rejected(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7130, 'CcmDevFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7131, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7132, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7133, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7134, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7135, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7136, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7137, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7138, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7139, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7140, 'CcmDevUnregCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7141, 'CcmDevRegFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7142, 'SEQUENCE OF CcmVoiceMailDeviceEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7143, 'CcmVoiceMailDeviceEntry', '', NULL, 'not-accessible', 'ccmVMailDevIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7144, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7145, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7146, 'CcmDeviceProductId', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7147, 'SnmpAdminString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7148, 'CcmDeviceStatus', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7149, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7150, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7151, 'CcmDevFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7152, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7153, 'DateAndTime', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7154, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7155, 'CcmDevUnregCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7156, 'CcmDevRegFailCauseCode', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7157, 'SEQUENCE OF CcmVoiceMailDeviceDirNumEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7158, 'CcmVoiceMailDeviceDirNumEntry', '', NULL, 'not-accessible', 'ccmVMailDevIndex, ccmVMailDevDirNumIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7159, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7160, 'SnmpAdminString', 'SIZE (0..24)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7161, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7162, 'SEQUENCE OF CcmSIPDeviceEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7163, 'CcmSIPDeviceEntry', '', NULL, 'not-accessible', 'ccmSIPDevIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7164, 'CcmIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7165, 'SnmpAdminString', 'SIZE (0..128)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7166, 'CcmIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7167, 'SnmpAdminString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7168, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7169, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7170, 'CcmSIPTransportProtocolType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7171, 'InetPortNumber', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7172, 'CcmSIPTransportProtocolType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7173, 'InetPortNumber', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7174, 'InetAddressIPv4', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7175, 'InetAddressIPv6', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7251, 'SEQUENCE OF IsdnBasicRateEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7252, 'IsdnBasicRateEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7253, 'INTEGER', 'isdns(75), isdnu(76)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7254, 'INTEGER', 'pointToPoint(1), pointToMultipoint(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7255, 'INTEGER', 'te(1), nt(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7256, 'INTEGER', 'active(1), inactive(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7258, 'SEQUENCE OF IsdnBearerEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7259, 'IsdnBearerEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7260, 'INTEGER', 'dialup(1), leased(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7261, 'INTEGER', 'idle(1), connecting(2), connected(3), active(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7262, 'INTEGER', '1..30', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7263, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7264, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7265, 'INTEGER', 'unknown(1), originate(2), answer(3), callback(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7266, 'INTEGER', 'unknown(1), speech(2), unrestrictedDigital(3), unrestrictedDigital56(4), restrictedDigital(5), audio31(6), audio7(7), video(8), packetSwitched(9)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7267, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7268, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7269, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7270, 'Gauge32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7272, 'TestAndIncr', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7273, 'SEQUENCE OF IsdnSignalingEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7274, 'IsdnSignalingEntry', '', NULL, 'not-accessible', 'isdnSignalingIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7275, 'INTEGER', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7276, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7277, 'IsdnSignalingProtocol', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7278, 'DisplayString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7279, 'DisplayString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7280, 'Integer32', '1..65535', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7281, 'INTEGER', 'enabled(1), disabled(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7282, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7283, 'SEQUENCE OF IsdnSignalingStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7284, 'IsdnSignalingStatsEntry', '', NULL, 'not-accessible', 'isdnSignalingEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7285, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7286, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7287, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7288, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7289, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7290, 'SEQUENCE OF IsdnLapdEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7291, 'IsdnLapdEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7292, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7293, 'INTEGER', 'inactive(1), l1Active(2), l2Active(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7294, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7295, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7297, 'TestAndIncr', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7298, 'SEQUENCE OF IsdnEndpointEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7299, 'IsdnEndpointEntry', '', NULL, 'not-accessible', 'isdnEndpointIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7300, 'INTEGER', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7301, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7302, 'IANAifType', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7303, 'INTEGER', 'dynamic(1), static(2)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7304, 'INTEGER', '0..255', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7305, 'DisplayString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7306, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7308, 'SEQUENCE OF IsdnDirectoryEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7309, 'IsdnDirectoryEntry', '', NULL, 'not-accessible', 'isdnDirectoryIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7310, 'INTEGER', '1..''7fffffff''h', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7311, 'DisplayString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7312, 'INTEGER', '1..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7313, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7329, 'SEQUENCE OF DemandNbrEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7330, 'DemandNbrEntry', '', NULL, 'not-accessible', 'demandNbrPhysIf, demandNbrId', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7331, 'Integer32', '1..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7332, 'Integer32', '0..2147483647', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7333, 'Integer32', '1..2147483647', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7334, 'DisplayString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7335, 'DisplayString', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7336, 'INTEGER', 'iCanCallHim (1), heCanCallMe (2), weCanCallEachOther (3)', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7337, 'Integer32', '1..2147483647', 'seconds', 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7338, 'Integer32', '1..2147483647', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7339, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7340, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7341, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7342, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7343, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7344, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7345, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7346, 'RowStatus', '', NULL, 'read-create', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7347, 'INTEGER', 'originate(1), answer(2), callback(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7372, 'Integer32', '0..2147483647', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7373, 'Integer32', '0..2147483647', 'Users', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7374, 'Integer32', '0..2147483647', 'Groups', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7375, 'Integer32', '0..2147483647', 'Users', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7376, 'Gauge32', '', 'MBytes/second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7377, 'Gauge32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7378, 'Counter32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7379, 'Gauge32', '', 'Users', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7380, 'Gauge32', '', 'Groups', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7381, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7382, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7383, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7384, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7385, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7386, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7387, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7388, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7389, 'SEQUENCE OF CrasSessionEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7390, 'CrasSessionEntry', '', NULL, 'not-accessible', 'crasUsername, crasSessionIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7391, 'SnmpAdminString', 'SIZE(0..128)', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7392, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7393, 'SessionIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7394, 'UserAuthenMethod', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7395, 'UserAuthorMethod', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7396, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7397, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7398, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7399, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7400, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7401, 'RasProtocol', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7402, 'OBJECT IDENTIFIER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7403, 'SessionEncrAlgo', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7404, 'SessionAuthAlgo', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7405, 'SessionCompressionAlgo', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7406, 'Unsigned32', '0..4294967295', 'Seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7407, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7408, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7409, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7410, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7411, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7412, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7413, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7414, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7415, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7416, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7417, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7418, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7419, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7420, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7421, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7422, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7423, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7424, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7425, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7426, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7427, 'SessionStatus', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7428, 'SEQUENCE OF CrasActGroupEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7429, 'CrasActGroupEntry', '', NULL, 'not-accessible', 'crasActGrpName', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7430, 'SnmpAdminString', 'SIZE(0..64)', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7431, 'Integer32', '1..2147483647', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7432, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7433, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7434, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7435, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7436, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7437, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7438, 'Gauge32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7439, 'Counter32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7440, 'Unsigned32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7441, 'Gauge32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7442, 'Counter32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7443, 'Unsigned32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7444, 'Gauge32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7445, 'Counter32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7446, 'Unsigned32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7447, 'Gauge32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7448, 'Counter32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7449, 'Unsigned32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7450, 'Gauge32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7451, 'Counter32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7452, 'Unsigned32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7453, 'Gauge32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7454, 'Counter32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7455, 'Unsigned32', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7457, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7458, 'Unsigned32', '0..4294967295', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7459, 'Counter64', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7460, 'Counter64', '', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7462, 'Unsigned32', '0..4294967295', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7464, 'SEQUENCE OF CrasSessFailEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7465, 'CrasSessFailEntry', '', NULL, 'not-accessible', 'crasSessFailIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7466, 'FailureRecordIndex', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7467, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7468, 'SnmpAdminString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7469, 'INTEGER{ setupFailure(1), operationalFailure(2) }', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7470, 'INTEGER{ other(1), internalError(2), authenticationFailure(3), authorizationFailure(4), sysCapExceeded(5), peerAbortRequest(6), peerLost(7), operRequest(8) }', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7471, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7472, 'SessionIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7473, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7474, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7475, 'InetAddressType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7476, 'InetAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7477, 'FailureRecordIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7479, 'SEQUENCE OF CrasGrpFailEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7480, 'CrasGrpFailEntry', '', NULL, 'not-accessible', 'crasGrpFailGroupname', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7481, 'SnmpAdminString', 'SIZE(0..64)', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7482, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7483, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7484, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7485, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7486, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7488, 'Counter64', '', 'Users', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7489, 'Integer32', '0..2147483647', 'Sessions', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7490, 'Unsigned32', '0..4294967295', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7491, 'Integer32', '0..2147483647', 'Octets Per Second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7492, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7493, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7494, 'TruthValue', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7514, 'SEQUENCE OF LipAddrEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7515, 'LipAddrEntry', '', NULL, 'not-accessible', 'ipAdEntAddr', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7516, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7517, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7518, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7519, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7520, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7521, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7522, 'SEQUENCE OF LipRouteEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7523, 'LipRouteEntry', '', NULL, 'not-accessible', 'ipRouteDest', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7524, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7525, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7526, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7527, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7528, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7529, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7530, 'SEQUENCE OF LipAccountEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7531, 'LipAccountEntry', '', NULL, 'not-accessible', 'actSrc, actDst', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7532, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7533, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7534, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7535, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7536, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7537, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7538, 'SEQUENCE OF LipCkAccountEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7539, 'LipCkAccountEntry', '', NULL, 'not-accessible', 'ckactSrc, ckactDst', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7540, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7541, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7542, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7543, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7544, 'INTEGER', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7545, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7546, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7547, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7549, 'SEQUENCE OF FrDlcmiEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7550, 'FrDlcmiEntry', '', NULL, 'not-accessible', 'frDlcmiIfIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7551, 'Index', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7552, 'INTEGER', 'noLmiConfigured (1), lmiRev1 (2), ansiT1-617-D (3), ansiT1-617-B (4)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7553, 'INTEGER', 'q921 (1), q922March90 (2), q922November90 (3), q922 (4)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7554, 'INTEGER', 'two-octets (2), three-octets (3), four-octets (4)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7555, 'INTEGER', '5..30', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7556, 'INTEGER', '1..255', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7557, 'INTEGER', '1..10', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7558, 'INTEGER', '1..10', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7559, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7560, 'INTEGER', 'nonBroadcast (1), broadcast (2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7561, 'SEQUENCE OF FrCircuitEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7562, 'FrCircuitEntry', '', NULL, 'not-accessible', 'frCircuitIfIndex, frCircuitDlci', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7563, 'Index', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7564, 'DLCI', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7565, 'INTEGER', 'invalid (1), active (2), inactive (3)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7566, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7567, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7568, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7569, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7570, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7571, 'Counter', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7572, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7573, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7574, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7575, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7576, 'INTEGER', '', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7577, 'SEQUENCE OF FrErrEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7578, 'FrErrEntry', '', NULL, 'not-accessible', 'frErrIfIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7579, 'Index', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7580, 'INTEGER', 'unknownError(1), receiveShort(2), receiveLong(3), illegalDLCI(4), unknownDLCI(5), dlcmiProtoErr(6), dlcmiUnknownIE(7), dlcmiSequenceErr(8), dlcmiUnknownRpt(9), noErrorSinceReset(10)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7581, 'OCTET STRING', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7582, 'TimeTicks', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7584, 'INTEGER', 'enabled(1), disabled(2)', NULL, 'read-write', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7596, 'SEQUENCE OF CfrLmiEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7597, 'CfrLmiEntry', '', NULL, 'not-accessible', 'frDlcmiEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7598, 'INTEGER', 'up(1), down(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7599, 'INTEGER', 'dte(1), dce(2), nni(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7600, 'Counter32', '', 'messages', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7601, 'Counter32', '', 'messages', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7602, 'Counter32', '', 'messages', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7603, 'Counter32', '', 'messages', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7604, 'Counter32', '', 'messages', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7605, 'Counter32', '', 'messages', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7606, 'Counter32', '', 'times', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7607, 'Counter32', '', 'times', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7608, 'INTEGER', '0..10', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7609, 'INTEGER', '0..10', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7610, 'INTEGER', '0..30', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7611, 'SEQUENCE OF CfrCircuitEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7612, 'CfrCircuitEntry', '', NULL, 'not-accessible', 'frCircuitEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7613, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7614, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7615, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7616, 'INTEGER', 'pvc(1), svc(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7617, 'SEQUENCE OF CfrExtCircuitEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7618, 'CfrExtCircuitEntry', '', NULL, 'not-accessible', 'frCircuitEntry', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7619, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7620, 'INTEGER', 'mainInterface(1), pointToPoint(2), multipoint(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7621, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7622, 'INTEGER', '0..2047', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7623, 'INTEGER', 'dynamic(1),   static(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7624, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7625, 'DlciNumber', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7626, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7627, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7628, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7629, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7630, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7631, 'Integer32', '9600..1544000', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7632, 'Integer32', '9600..1544000', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7633, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7634, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7635, 'Integer32', '0..16777215', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7636, 'Integer32', '125..2147483647', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7637, 'Integer32', '10..125', 'milliseconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7638, 'Integer32', '125..2147483647', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7639, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7640, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7641, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7642, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7643, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7644, 'INTEGER', 'none(1), becn(2), foreSight(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7645, 'INTEGER', '1..45000000', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7646, 'INTEGER', '1..45000000', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7647, 'INTEGER', '1..45000000', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7648, 'INTEGER', '1..45000000', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7649, 'SEQUENCE OF CfrMapEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7650, 'CfrMapEntry', '', NULL, 'not-accessible', 'frCircuitIfIndex, frCircuitDlci, cfrMapIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7651, 'INTEGER', '1..999', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7652, 'CfrMapProtocols', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7653, 'STRING', 'SIZE(0..64)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7654, 'INTEGER', 'static(1), dynamic(2), svc(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7655, 'INTEGER', 'ietf(1),  cisco(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7656, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7657, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7658, 'INTEGER', 'inapplicable(1), passive(2), active(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7659, 'INTEGER', 'inapplicable(1), passive(2), active(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7660, 'INTEGER', 'inapplicable(1), cisco(2),  frf9Software(3), frf9Hardware(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7661, 'SEQUENCE OF CfrSvcEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7662, 'CfrSvcEntry', '', NULL, 'not-accessible', 'frCircuitIfIndex, frCircuitDlci', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7663, 'STRING', 'SIZE(0..64)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7664, 'STRING', 'SIZE(0..64)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7665, 'Integer32', '9600..1544000', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7666, 'Integer32', '9600..1544000', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7667, 'Integer32', '9600..1544000', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7668, 'Integer32', '9600..1544000', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7669, 'Integer32', '9600..2440000', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7670, 'Integer32', '', 'seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7671, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7672, 'SEQUENCE OF CfrElmiEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7673, 'CfrElmiEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7674, 'INTEGER', 'enabled(1), disabled(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7675, 'INTEGER', 'enabled(1), disabled(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7676, 'INTEGER', 'enabled(1), disabled(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7677, 'SEQUENCE OF CfrElmiNeighborEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7678, 'CfrElmiNeighborEntry', '', NULL, 'not-accessible', 'ifIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7679, 'INTEGER', 'notsupported(1), enabled(2), disabled(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7680, 'IpAddress', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7681, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7682, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7683, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7684, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7685, 'SEQUENCE OF CfrFragEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7686, 'CfrFragEntry', '', NULL, 'not-accessible', 'frCircuitIfIndex, frCircuitDlci', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7687, 'INTEGER', '16..1600', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7688, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7689, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7690, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7691, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7692, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7693, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7694, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7695, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7696, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7697, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7698, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7699, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7700, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7701, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7702, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7703, 'INTEGER', '0..1000', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7704, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7705, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7706, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7707, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7708, 'SEQUENCE OF CfrConnectionEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7709, 'CfrConnectionEntry', '', NULL, 'not-accessible', 'frCircuitIfIndex, frCircuitDlci', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7710, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7711, 'INTEGER', '1..2000', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7712, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7713, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7714, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7715, 'DlciNumber', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7716, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7717, 'INTEGER', '0..4095', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7718, 'INTEGER', '0..4095', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7719, 'INTEGER', 'serviceTranslationEnabled(1), serviceTranslationNotEnabled(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7720, 'DlciNumber', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7721, 'INTEGER', 'mapFecn(1), notMapFecn(2)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7722, 'INTEGER', 'noMapClp(1), mapClp(2), setDe0(3), setDe1(4)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7723, 'INTEGER', 'setClpTo0AndCopyDeToFrsscsDe(1), setClpTo1AndCopyDeToFrsscsDe(2), copyDeToFrsscsDeAndClp(3), copyDeToClp(4), setClp1(5), setClp0(6)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7783, 'SEQUENCE OF CbQosQueueingClassCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7784, 'CbQosQueueingClassCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex, cbQosQueueingClassConfigIndex, cbQosQlimitWeightValue', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7785, 'Integer32', '0..65535', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7786, 'Integer32', '0..63', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7787, 'CbQosQueueDepth', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7788, 'CbQosQueueUnitType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7789, 'QueueMechanism', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7790, 'SEQUENCE OF CbQosMeasureIPSLACfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7791, 'CbQosMeasureIPSLACfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex, cbQosMeasureIPSLACfgGroupIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7792, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7793, 'DisplayString', 'SIZE (0..64)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7794, 'SEQUENCE OF CbQosServicePolicyEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7795, 'CbQosServicePolicyEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7796, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7797, 'InterfaceType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7798, 'TrafficDirection', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7799, 'InterfaceIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7800, 'DlciNumber', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7801, 'Unsigned32', '0..4095', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7802, 'Unsigned32', '0..65535', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7803, 'EntPhysicalIndexOrZero', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7804, 'VlanIndex', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7805, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7806, 'TimeStamp', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7807, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7808, 'SEQUENCE OF CbQosInterfacePolicyEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7809, 'CbQosInterfacePolicyEntry', '', NULL, 'not-accessible', 'ifIndex, cbQosPolicyDirection', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7810, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7811, 'SEQUENCE OF CbQosFrameRelayPolicyEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7923, 'Unsigned64', '', 'bits', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7812, 'CbQosFrameRelayPolicyEntry', '', NULL, 'not-accessible', 'ifIndex, cbQosFrDLCI, cbQosPolicyDirection', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7813, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7814, 'SEQUENCE OF CbQosATMPVCPolicyEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7815, 'CbQosATMPVCPolicyEntry', '', NULL, 'not-accessible', 'ifIndex, cbQosAtmVPI, cbQosAtmVCI, cbQosPolicyDirection', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7816, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7817, 'SEQUENCE OF CbQosObjectsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7818, 'CbQosObjectsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7819, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7820, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7821, 'QosObjectType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7822, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7823, 'SEQUENCE OF CbQosPolicyMapCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7824, 'CbQosPolicyMapCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7825, 'DisplayString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7826, 'DisplayString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7827, 'SEQUENCE OF CbQosCMCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7828, 'CbQosCMCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7829, 'DisplayString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7830, 'DisplayString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7831, 'QosClassInfo', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7832, 'SEQUENCE OF CbQosMatchStmtCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7833, 'CbQosMatchStmtCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7834, 'DisplayString', 'SIZE (0..255)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7835, 'QosMatchInfo', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7836, 'SEQUENCE OF CbQosQueueingCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7837, 'CbQosQueueingCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7838, 'Integer32', '0..2000000', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7839, 'QueueingBandwidthUnits', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7840, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7841, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7842, 'Integer32', '0..65535', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7843, 'Integer32', '1..32768', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7844, 'Integer32', '1..32768', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7845, 'Unsigned32', '32..64000000', 'Bytes', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7846, 'CbQosQueueUnitType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7847, 'CbQosQueueDepth', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7848, 'Unsigned32', '', 'milli-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7849, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7850, 'Unsigned64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7851, 'Unsigned64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7852, 'SEQUENCE OF CbQosREDCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7853, 'CbQosREDCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7854, 'Integer32', '1..16', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7855, 'Integer32', '0..65535', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7856, 'REDMechanism', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7857, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7858, 'SEQUENCE OF CbQosREDClassCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7859, 'CbQosREDClassCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex, cbQosREDValue', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7860, 'Integer32', '0..63', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7861, 'Integer32', '1..32768', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7862, 'Integer32', '1..32768', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7863, 'Integer32', '1..65536', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7864, 'CbQosQueueUnitType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7865, 'CbQosQueueDepth', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7866, 'CbQosQueueDepth', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7867, 'Unsigned32', '', 'milli-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7868, 'Unsigned32', '', 'milli-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7869, 'CbQosQueueUnitType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7870, 'CbQosQueueUnitType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7871, 'SEQUENCE OF CbQosPoliceCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7872, 'CbQosPoliceCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7873, 'Unsigned32', '0..4294967295', 'bits/second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7874, 'Unsigned32', '1000..512000000', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7875, 'Unsigned32', '1000..512000000', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7876, 'PoliceAction', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7877, 'Unsigned32', '1..99', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7878, 'PoliceAction', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7879, 'Unsigned32', '1..99', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7880, 'PoliceAction', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7881, 'Unsigned32', '1..99', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7882, 'Unsigned32', '8000..2000000000', 'bits/second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7883, 'Unsigned64', '', 'bits/second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7884, 'CbQosRateType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7885, 'Unsigned32', '0..100', '% of Interface Bandwidth', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7886, 'Unsigned32', '0..100', '% of Interface Bandwidth', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7887, 'Unsigned32', '', 'cells/second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7888, 'Unsigned32', '', 'cells/second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7889, 'Unsigned32', '0..4294967295', 'Cells', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7890, 'Unsigned32', '0..4294967295', 'Cells', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7891, 'Unsigned32', '0..4294967295', 'milli-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7892, 'Unsigned32', '0..4294967295', 'milli-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7893, 'Unsigned32', '0..4294967295', 'micro-second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7894, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7895, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7896, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7897, 'Unsigned64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7898, 'Unsigned64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7899, 'Unsigned64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7900, 'SEQUENCE OF CbQosPoliceActionCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7901, 'CbQosPoliceActionCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex, cbQosPoliceActionCfgIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7902, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7903, 'PoliceAction', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7904, 'Unsigned32', '0..99', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7905, 'PoliceAction', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7906, 'Unsigned32', '0..99', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7907, 'PoliceAction', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7908, 'Unsigned32', '0..99', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7909, 'SEQUENCE OF CbQosTSCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7910, 'CbQosTSCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7911, 'Integer32', '0..2147483647', 'bits/second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7912, 'Integer32', '256..154400000', 'bits', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7913, 'Integer32', '0..154400000', 'bits', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7914, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7915, 'Integer32', '8000..154400000', 'bits/second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7916, 'TrafficShapingLimit', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7917, 'CbQosRateType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7918, 'Unsigned32', '0..100', '% of Interface Bandwidth', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7919, 'Unsigned32', '0..4294967295', 'milli-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7920, 'Unsigned32', '0..4294967295', 'milli-seconds', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7921, 'Unsigned64', '', 'bits/second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7922, 'Unsigned64', '', 'bits', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7924, 'SEQUENCE OF CbQosSetCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7925, 'CbQosSetCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7926, 'SetFeatureType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7927, 'Integer32', '0..63', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7928, 'Integer32', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7929, 'Integer32', '0..99', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7930, 'Integer32', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7931, 'Unsigned32', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7932, 'Unsigned32', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7933, 'Unsigned32', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7934, 'Unsigned32', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7935, 'Unsigned32', '0..99', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7936, 'Integer32', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7937, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7938, 'Unsigned32', '0..7', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7939, 'Unsigned32', '0..63', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7940, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7941, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7942, 'SEQUENCE OF CbQosCMStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7943, 'CbQosCMStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7944, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7945, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7946, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7947, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7948, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7949, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7950, 'Gauge32', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7951, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7952, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7953, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7954, 'Gauge32', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7955, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7956, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7957, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7958, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7959, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7960, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7961, 'Gauge32', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7962, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7963, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7964, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7965, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7966, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7967, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7968, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7969, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7970, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7971, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7972, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7973, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7974, 'SEQUENCE OF CbQosMatchStmtStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7975, 'CbQosMatchStmtStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7976, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7977, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7978, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7979, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7980, 'Counter32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7981, 'Counter64', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7982, 'Gauge32', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7983, 'SEQUENCE OF CbQosPoliceStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7984, 'CbQosPoliceStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7985, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7986, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7987, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7988, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7989, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7990, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7991, 'Gauge32', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7992, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7993, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7994, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7995, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7996, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7997, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7998, 'Gauge32', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (7999, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8000, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8001, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8002, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8003, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8004, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8005, 'Gauge32', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8006, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8007, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8008, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8009, 'SEQUENCE OF CbQosQueueingStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8010, 'CbQosQueueingStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8011, 'Gauge32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8012, 'Gauge32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8013, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8014, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8015, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8016, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8017, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8018, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8019, 'Gauge32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8020, 'Gauge32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8021, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8022, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8023, 'SEQUENCE OF CbQosTSStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8024, 'CbQosTSStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8025, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8026, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8027, 'Counter64', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8028, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8029, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8030, 'Counter64', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8031, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8032, 'Counter32', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8033, 'Counter64', '', 'octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8034, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8035, 'Counter32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8036, 'Counter64', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8037, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8038, 'Gauge32', '', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8039, 'SEQUENCE OF CbQosREDClassStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8040, 'CbQosREDClassStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex, cbQosREDValue', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8041, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8042, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8043, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8044, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8045, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8046, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8047, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8048, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8049, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8050, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8051, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8052, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8053, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8054, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8055, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8056, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8057, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8058, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8059, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8060, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8061, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8062, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8063, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8064, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8065, 'CbQosQueueUnitType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8066, 'CbQosQueueDepth', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8067, 'SEQUENCE OF CbQosIPHCCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8068, 'CbQosIPHCCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8069, 'IPHCOption', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8070, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8071, 'SEQUENCE OF CbQosIPHCStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8072, 'CbQosIPHCStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8073, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8074, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8075, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8076, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8077, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8078, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8079, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8080, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8081, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8082, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8083, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8084, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8085, 'Gauge32', '', 'Octets per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8086, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8087, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8088, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8089, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8090, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8091, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8092, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8093, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8094, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8095, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8096, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8097, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8098, 'Gauge32', '', 'Octets per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8099, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8100, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8101, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8102, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8103, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8104, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8105, 'SEQUENCE OF CbQosSetStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8106, 'CbQosSetStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8107, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8108, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8109, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8110, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8111, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8112, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8113, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8114, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8115, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8116, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8117, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8118, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8119, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8120, 'SEQUENCE OF CbQosPoliceColorStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8121, 'CbQosPoliceColorStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8122, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8123, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8124, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8125, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8126, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8127, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8128, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8129, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8130, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8131, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8132, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8133, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8134, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8135, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8136, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8137, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8138, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8139, 'CounterBasedGauge64', '', 'bits per second', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8140, 'SEQUENCE OF CbQosTableMapCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8141, 'CbQosTableMapCfgEntry', '', NULL, 'not-accessible', 'cbQosTableMapCfgIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8142, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8143, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8144, 'INTEGER', 'value(1), copy(2), ignore(3)', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8145, 'Unsigned32', '0..99', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8146, 'SEQUENCE OF CbQosTableMapValueCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8147, 'CbQosTableMapValueCfgEntry', '', NULL, 'not-accessible', 'cbQosTableMapCfgIndex, cbQosTableMapValueCfgFrom', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8148, 'Unsigned32', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8149, 'Unsigned32', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8150, 'SEQUENCE OF CbQosTableMapSetCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8151, 'CbQosTableMapSetCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8152, 'CbQosTMSetType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8153, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8154, 'CbQosTMSetType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8155, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8156, 'CbQosTMSetType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8157, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8158, 'CbQosTMSetType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8159, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8160, 'CbQosTMSetType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8161, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8162, 'CbQosTMSetType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8163, 'DisplayString', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8164, 'SEQUENCE OF CbQosEBCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8165, 'CbQosEBCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8166, 'CbQosEBType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8167, 'Unsigned32', '50..1000000', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8168, 'Unsigned32', '50..1000000', 'packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8169, 'Unsigned32', '16..1000', 'millisecond', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8170, 'SEQUENCE OF CbQosEBStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8171, 'CbQosEBStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8172, 'Gauge32', '', 'kbps', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8173, 'TruthValue', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8174, 'CbQosEBCtd', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8175, 'SEQUENCE OF CbQosC3plAccountCfgEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8176, 'CbQosC3plAccountCfgEntry', '', NULL, 'not-accessible', 'cbQosConfigIndex', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8177, 'SetC3plAccountFeatureType', '', NULL, 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8178, 'SEQUENCE OF CbQosC3plAccountStatsEntry', '', NULL, 'not-accessible', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8179, 'CbQosC3plAccountStatsEntry', '', NULL, 'not-accessible', 'cbQosPolicyIndex, cbQosObjectsIndex, cbQosC3plAccountFeatureType', NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8180, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8181, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8182, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8183, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8184, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8185, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8186, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8187, 'Counter32', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8188, 'Counter64', '', 'Packets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8189, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8190, 'Counter32', '', 'Octets', 'read-only', NULL, NULL);
INSERT INTO mib_object_type (id_mib_element, syntax, syntax_values, units, access, index, default_value) VALUES (8191, 'Counter64', '', 'Octets', 'read-only', NULL, NULL);

INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (1, 'DisplayString', 'Represents textual information taken from the NVT ASCII character set, as defined in pages 4, 10-11 of RFC 854.  To summarize RFC 854, the NVT ASCII repertoire specifies:  - the use of character codes 0-127 (decimal)  - the graphics characters (32-126) are interpreted as US ASCII  - NUL, LF, CR, BEL, BS, HT, VT and FF have the special meanings specified in RFC 854  - the other 25 codes have no standard interpretation  - the sequence ''CR LF'' means newline  - the sequence ''CR NUL'' means carriage-return  - an ''LF'' not preceded by a ''CR'' means moving to the same column on the next line.  - the sequence ''CR x'' for any x other than LF or NUL is illegal. (Note that this also means that a string may end with either ''CR LF'' or ''CR NUL'', but not with CR.)  Any object defined using this syntax may not exceed 255 characters in length.', NULL, 'OCTET STRING (SIZE (0..255))', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (2, 'PhysAddress', 'Represents media- or physical-level addresses.', NULL, 'OCTET STRING', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (3, 'MacAddress', 'Represents an 802 MAC address represented in the `canonical'' order defined by IEEE 802.1a, i.e., as if it were transmitted least significant bit first, even though 802.5 (in contrast to other 802.x protocols) requires MAC addresses to be transmitted most significant bit first.', NULL, 'OCTET STRING (SIZE (6))', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (4, 'TruthValue', 'Represents a boolean value.', NULL, 'INTEGER { true(1), false(2) }', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (5, 'TestAndIncr', 'Represents integer-valued information used for atomic operations. When the management protocol is used to specify that an object instance having this syntax is to be modified, the new value supplied via the management protocol must precisely match the value presently held by the instance. If not, the management protocol set operation fails with an error of `inconsistentValue''. Otherwise, if the current value is the maximum value of 2^31-1 (2147483647 decimal), then the value held by the instance is wrapped to zero; otherwise, the value held by the instance is incremented by one. (Note that regardless of whether the management protocol set operation succeeds, the variable- binding in the request and response PDUs are identical.)  The value of the ACCESS clause for objects having this syntax is either `read-write'' or `read-create''. When an instance of a columnar object having this syntax is created, any value may be supplied via the management protocol.  When the network management portion of the system is re- initialized, the value of every object instance having this syntax must either be incremented from its value prior to the re-initialization, or (if the value prior to the re- initialization is unknown) be set to a pseudo-randomly generated value.', NULL, 'INTEGER (0..2147483647)', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (6, 'AutonomousType', 'Represents an independently extensible type identification value. It may, for example, indicate a particular sub-tree with further MIB definitions, or define a particular type of protocol or hardware.', NULL, 'OBJECT IDENTIFIER', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (7, 'InstancePointer', 'A pointer to either a specific instance of a MIB object or a conceptual row of a MIB table in the managed device. In the latter case, by convention, it is the name of the particular instance of the first accessible columnar object in the conceptual row.  The two uses of this textual convention are replaced by VariablePointer and RowPointer, respectively.', NULL, 'OBJECT IDENTIFIER', 'obsolete', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (8, 'VariablePointer', 'A pointer to a specific object instance. For example, sysContact.0 or ifInOctets.3.', NULL, 'OBJECT IDENTIFIER', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (9, 'RowPointer', 'Represents a pointer to a conceptual row. The value is the name of the instance of the first accessible columnar object in the conceptual row.  For example, ifIndex.3 would point to the 3rd row in the ifTable (note that if ifIndex were not-accessible, then ifDescr.3 would be used instead).', NULL, 'OBJECT IDENTIFIER', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (10, 'RowStatus', 'The RowStatus textual convention is used to manage the creation and deletion of conceptual rows, and is used as the value of the SYNTAX clause for the status column of a conceptual row (as described in Section 7.7.1 of [2].)  The status column has six defined values:  - `active'', which indicates that the conceptual row is available for use by the managed device;  - `notInService'', which indicates that the conceptual row exists in the agent, but is unavailable for use by the managed device (see NOTE below);  - `notReady'', which indicates that the conceptual row exists in the agent, but is missing information necessary in order to be available for use by the managed device;  - `createAndGo'', which is supplied by a management station wishing to create a new instance of a conceptual row and to have its status automatically set to active, making it available for use by the managed device;  - `createAndWait'', which is supplied by a management station wishing to create a new instance of a conceptual row (but not make it available for use by the managed device); and,  - `destroy'', which is supplied by a management station wishing to delete all of the instances associated with an existing conceptual row.  Whereas five of the six values (all except `notReady'') may be specified in a management protocol set operation, only three values will be returned in response to a management protocol retrieval operation: `notReady'', `notInService'' or `active''. That is, when queried, an existing conceptual row has only three states: it is either available for use by the managed device (the status column has value `active''); it is not available for use by the managed device, though the agent has sufficient information to make it so (the status column has value `notInService''); or, it is not available for use by the managed device, and an attempt to make it so would fail because the agent has insufficient information (the state column has value `notReady'').  NOTE WELL  This textual convention may be used for a MIB table, irrespective of whether the values of that table''s conceptual rows are able to be modified while it is active, or whether its conceptual rows must be taken out of service in order to be modified. That is, it is the responsibility of the DESCRIPTION clause of the status column to specify whether the status column must not be `active'' in order for the value of some other column of the same conceptual row to be modified. If such a specification is made, affected columns may be changed by an SNMP set PDU if the RowStatus would not be equal to `active'' either immediately before or after processing the PDU. In other words, if the PDU also contained a varbind that would change the RowStatus value, the column in question may be changed if the RowStatus was not equal to `active'' as the PDU was received, or if the varbind sets the status to a value other than ''active''.   Also note that whenever any elements of a row exist, the RowStatus column must also exist.   To summarize the effect of having a conceptual row with a status column having a SYNTAX clause value of RowStatus, consider the following state diagram:   STATE +----------+-----------+-------------+------------- | A | B | C | D | |status col.|status column| |status column | is | is |status column ACTION |does not exist| notReady | notInService| is active ----------+--------------+-----------+-------------+------------- set status |noError ->D|inconsist- |inconsistent-|inconsistent- column to | or | entValue| Value| Value createAndGo |inconsistent- | | | | Value| | | ----------+--------------+-----------+-------------+------------- set status |noError see 1|inconsist- |inconsistent-|inconsistent- column to | or | entValue| Value| Value createAndWait |wrongValue | | | ----------+--------------+-----------+-------------+------------- set status |inconsistent- |inconsist- |noError |noError column to | Value| entValue| | active | | | | | | or | | | | | | | |see 2 ->D| ->D| ->D ----------+--------------+-----------+-------------+------------- set status |inconsistent- |inconsist- |noError |noError ->C column to | Value| entValue| | notInService | | | | | | or | | or | | | | | |see 3 ->C| ->C|wrongValue ----------+--------------+-----------+-------------+------------- set status |noError |noError |noError |noError column to | | | | destroy | ->A| ->A| ->A| ->A ----------+--------------+-----------+-------------+------------- set any other |see 4 |noError |noError |see 5 column to some| | | | value | | see 1| ->C| ->D ----------+--------------+-----------+-------------+-------------  (1) goto B or C, depending on information available to the agent.  (2) if other variable bindings included in the same PDU, provide values for all columns which are missing but required, then return noError and goto D.  (3) if other variable bindings included in the same PDU, provide values for all columns which are missing but required, then return noError and goto C.  (4) at the discretion of the agent, the return value may be either:  inconsistentName: because the agent does not choose to create such an instance when the corresponding RowStatus instance does not exist, or  inconsistentValue: if the supplied value is inconsistent with the state of some other MIB object''s value, or  noError: because the agent chooses to create the instance.  If noError is returned, then the instance of the status column must also be created, and the new state is B or C, depending on the information available to the agent. If inconsistentName or inconsistentValue is returned, the row remains in state A.  (5) depending on the MIB definition for the column/table, either noError or inconsistentValue may be returned.  NOTE: Other processing of the set request may result in a response other than noError being returned, e.g., wrongValue, noCreation, etc.   Conceptual Row Creation  There are four potential interactions when creating a conceptual row: selecting an instance-identifier which is not in use; creating the conceptual row; initializing any objects for which the agent does not supply a default; and, making the conceptual row available for use by the managed device.  Interaction 1: Selecting an Instance-Identifier  The algorithm used to select an instance-identifier varies for each conceptual row. In some cases, the instance- identifier is semantically significant, e.g., the destination address of a route, and a management station selects the instance-identifier according to the semantics.  In other cases, the instance-identifier is used solely to distinguish conceptual rows, and a management station without specific knowledge of the conceptual row might examine the instances present in order to determine an unused instance-identifier. (This approach may be used, but it is often highly sub-optimal; however, it is also a questionable practice for a naive management station to attempt conceptual row creation.)  Alternately, the MIB module which defines the conceptual row might provide one or more objects which provide assistance in determining an unused instance-identifier. For example, if the conceptual row is indexed by an integer-value, then an object having an integer-valued SYNTAX clause might be defined for such a purpose, allowing a management station to issue a management protocol retrieval operation. In order to avoid unnecessary collisions between competing management stations, `adjacent'' retrievals of this object should be different.  Finally, the management station could select a pseudo-random number to use as the index. In the event that this index was already in use and an inconsistentValue was returned in response to the management protocol set operation, the management station should simply select a new pseudo-random number and retry the operation.  A MIB designer should choose between the two latter algorithms based on the size of the table (and therefore the efficiency of each algorithm). For tables in which a large number of entries are expected, it is recommended that a MIB object be defined that returns an acceptable index for creation. For tables with small numbers of entries, it is recommended that the latter pseudo-random index mechanism be used.  Interaction 2: Creating the Conceptual Row  Once an unused instance-identifier has been selected, the management station determines if it wishes to create and activate the conceptual row in one transaction or in a negotiated set of interactions.  Interaction 2a: Creating and Activating the Conceptual Row  The management station must first determine the column requirements, i.e., it must determine those columns for which it must or must not provide values. Depending on the complexity of the table and the management station''s knowledge of the agent''s capabilities, this determination can be made locally by the management station. Alternately, the management station issues a management protocol get operation to examine all columns in the conceptual row that it wishes to create. In response, for each column, there are three possible outcomes:  - a value is returned, indicating that some other management station has already created this conceptual row. We return to interaction 1.  - the exception `noSuchInstance'' is returned, indicating that the agent implements the object-type associated with this column, and that this column in at least one conceptual row would be accessible in the MIB view used by the retrieval were it to exist. For those columns to which the agent provides read-create access, the `noSuchInstance'' exception tells the management station that it should supply a value for this column when the conceptual row is to be created.  - the exception `noSuchObject'' is returned, indicating that the agent does not implement the object-type associated with this column or that there is no conceptual row for which this column would be accessible in the MIB view used by the retrieval. As such, the management station can not issue any management protocol set operations to create an instance of this column.  Once the column requirements have been determined, a management protocol set operation is accordingly issued. This operation also sets the new instance of the status column to `createAndGo''.  When the agent processes the set operation, it verifies that it has sufficient information to make the conceptual row available for use by the managed device. The information available to the agent is provided by two sources: the management protocol set operation which creates the conceptual row, and, implementation-specific defaults supplied by the agent (note that an agent must provide implementation-specific defaults for at least those objects which it implements as read-only). If there is sufficient information available, then the conceptual row is created, a `noError'' response is returned, the status column is set to `active'', and no further interactions are necessary (i.e., interactions 3 and 4 are skipped). If there is insufficient information, then the conceptual row is not created, and the set operation fails with an error of `inconsistentValue''. On this error, the management station can issue a management protocol retrieval operation to determine if this was because it failed to specify a value for a required column, or, because the selected instance of the status column already existed. In the latter case, we return to interaction 1. In the former case, the management station can re-issue the set operation with the additional information, or begin interaction 2 again using `createAndWait'' in order to negotiate creation of the conceptual row.  NOTE WELL  Regardless of the method used to determine the column requirements, it is possible that the management station might deem a column necessary when, in fact, the agent will not allow that particular columnar instance to be created or written. In this case, the management protocol set operation will fail with an error such as `noCreation'' or `notWritable''. In this case, the management station decides whether it needs to be able to set a value for that particular columnar instance. If not, the management station re-issues the management protocol set operation, but without setting a value for that particular columnar instance; otherwise, the management station aborts the row creation algorithm.  Interaction 2b: Negotiating the Creation of the Conceptual Row  The management station issues a management protocol set operation which sets the desired instance of the status column to `createAndWait''. If the agent is unwilling to process a request of this sort, the set operation fails with an error of `wrongValue''. (As a consequence, such an agent must be prepared to accept a single management protocol set operation, i.e., interaction 2a above, containing all of the columns indicated by its column requirements.) Otherwise, the conceptual row is created, a `noError'' response is returned, and the status column is immediately set to either `notInService'' or `notReady'', depending on whether it has sufficient information to make the conceptual row available for use by the managed device. If there is sufficient information available, then the status column is set to `notInService''; otherwise, if there is insufficient information, then the status column is set to `notReady''. Regardless, we proceed to interaction 3.  Interaction 3: Initializing non-defaulted Objects  The management station must now determine the column requirements. It issues a management protocol get operation to examine all columns in the created conceptual row. In the response, for each column, there are three possible outcomes:  - a value is returned, indicating that the agent implements the object-type associated with this column and had sufficient information to provide a value. For those columns to which the agent provides read-create access (and for which the agent allows their values to be changed after their creation), a value return tells the management station that it may issue additional management protocol set operations, if it desires, in order to change the value associated with this column.  - the exception `noSuchInstance'' is returned, indicating that the agent implements the object-type associated with this column, and that this column in at least one conceptual row would be accessible in the MIB view used by the retrieval were it to exist. However, the agent does not have sufficient information to provide a value, and until a value is provided, the conceptual row may not be made available for use by the managed device. For those columns to which the agent provides read-create access, the `noSuchInstance'' exception tells the management station that it must issue additional management protocol set operations, in order to provide a value associated with this column.  - the exception `noSuchObject'' is returned, indicating that the agent does not implement the object-type associated with this column or that there is no conceptual row for which this column would be accessible in the MIB view used by the retrieval. As such, the management station can not issue any management protocol set operations to create an instance of this column.  If the value associated with the status column is `notReady'', then the management station must first deal with all `noSuchInstance'' columns, if any. Having done so, the value of the status column becomes `notInService'', and we proceed to interaction 4.  Interaction 4: Making the Conceptual Row Available  Once the management station is satisfied with the values associated with the columns of the conceptual row, it issues a management protocol set operation to set the status column to `active''. If the agent has sufficient information to make the conceptual row available for use by the managed device, the management protocol set operation succeeds (a `noError'' response is returned). Otherwise, the management protocol set operation fails with an error of `inconsistentValue''.   NOTE WELL  A conceptual row having a status column with value `notInService'' or `notReady'' is unavailable to the managed device. As such, it is possible for the managed device to create its own instances during the time between the management protocol set operation which sets the status column to `createAndWait'' and the management protocol set operation which sets the status column to `active''. In this case, when the management protocol set operation is issued to set the status column to `active'', the values held in the agent supersede those used by the managed device.  If the management station is prevented from setting the status column to `active'' (e.g., due to management station or network failure) the conceptual row will be left in the `notInService'' or `notReady'' state, consuming resources indefinitely. The agent must detect conceptual rows that have been in either state for an abnormally long period of time and remove them. It is the responsibility of the DESCRIPTION clause of the status column to indicate what an abnormally long period of time would be. This period of time should be long enough to allow for human response time (including `think time'') between the creation of the conceptual row and the setting of the status to `active''. In the absense of such information in the DESCRIPTION clause, it is suggested that this period be approximately 5 minutes in length. This removal action applies not only to newly-created rows, but also to previously active rows which are set to, and left in, the notInService state for a prolonged period exceeding that which is considered normal for such a conceptual row.   Conceptual Row Suspension  When a conceptual row is `active'', the management station may issue a management protocol set operation which sets the instance of the status column to `notInService''. If the agent is unwilling to do so, the set operation fails with an error of `wrongValue''. Otherwise, the conceptual row is taken out of service, and a `noError'' response is returned. It is the responsibility of the DESCRIPTION clause of the status column to indicate under what circumstances the status column should be taken out of service (e.g., in order for the value of some other column of the same conceptual row to be modified).   Conceptual Row Deletion  For deletion of conceptual rows, a management protocol set operation is issued which sets the instance of the status column to `destroy''. This request may be made regardless of the current value of the status column (e.g., it is possible to delete conceptual rows which are either `notReady'', `notInService'' or `active''.) If the operation succeeds, then all instances associated with the conceptual row are immediately removed.', NULL, 'INTEGER { active(1), notInService(2), notReady(3), createAndGo(4), createAndWait(5), destroy(6) }', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (11, 'TimeStamp', 'The value of the sysUpTime object at which a specific occurrence happened. The specific occurrence must be defined in the description of any object defined using this type.', NULL, 'TimeTicks', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (12, 'TimeInterval', 'A period of time, measured in units of 0.01 seconds.', NULL, 'INTEGER (0..2147483647)', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (13, 'DateAndTime', 'A date-time specification.  field octets contents range - ------ -------- ----- 1 1-2 year 0..65536 2 3 month 1..12 3 4 day 1..31 4 5 hour 0..23 5 6 minutes 0..59 6 7 seconds 0..60 (use 60 for leap-second) 7 8 deci-seconds 0..9 8 9 direction from UTC ''+'' / ''-'' 9 10 hours from UTC 0..11 10 11 minutes from UTC 0..59  For example, Tuesday May 26, 1992 at 1:30:15 PM EDT would be displayed as:  1992-5-26,13:30:15.0,-4:0  Note that if only local time is known, then timezone information (fields 8-10) is not present.', NULL, 'OCTET STRING (SIZE (8 | 11))', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (14, 'StorageType', 'Describes the memory realization of a conceptual row. A row which is volatile(2) is lost upon reboot. A row which is either nonVolatile(3), permanent(4) or readOnly(5), is backed up by stable storage. A row which is permanent(4) can be changed but not deleted. A row which is readOnly(5) cannot be changed nor deleted.  If the value of an object with this syntax is either permanent(4) or readOnly(5), it cannot be modified. Conversely, if the value is either other(1), volatile(2) or nonVolatile(3), it cannot be modified to be permanent(4) or readOnly(5).  Every usage of this textual convention is required to specify the columnar objects which a permanent(4) row must at a minimum allow to be writable.', NULL, 'INTEGER { other(1), volatile(2), nonVolatile(3), permanent(4), readOnly(5) }', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (15, 'TDomain', 'Denotes a kind of transport service.  Some possible values, such as snmpUDPDomain, are defined in ''Transport Mappings for Version 2 of the Simple Network Management Protocol (SNMPv2)''.', NULL, 'OBJECT IDENTIFIER', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (16, 'TAddress', 'Denotes a transport service address.  For snmpUDPDomain, a TAddress is 6 octets long, the initial 4 octets containing the IP-address in network-byte order and the last 2 containing the UDP port in network-byte order. Consult ''Transport Mappings for Version 2 of the Simple Network Management Protocol (SNMPv2)'' for further information on snmpUDPDomain.', NULL, 'OCTET STRING (SIZE (1..255))', 'current', NULL, 26);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (17, 'CiscoNetworkProtocol', 'Represents the different types of network layer protocols.', NULL, 'INTEGER { ip (1), decnet (2), pup (3), chaos (4), xns (5), x121 (6), appletalk (7), clns (8), lat (9), vines (10), cons (11), apollo (12), stun (13), novell (14), qllc (15), snapshot (16), atmIlmi (17), bstun (18), x25pvc (19), ipv6 (20), cdm (21), nbf (22), bpxIgx (23), clnsPfx(24), http(25), unknown (65535) }', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (56, 'SnmpSecurityLevel', 'A Level of Security at which SNMP messages can be sent or with which operations are being processed; in particular, one of:  noAuthNoPriv - without authentication and without privacy, authNoPriv - with authentication but without privacy, authPriv - with authentication and with privacy.  These three values are ordered such that noAuthNoPriv is less than authNoPriv and authNoPriv is less than authPriv.', NULL, 'INTEGER { noAuthNoPriv(1), authNoPriv(2), authPriv(3) }', 'current', NULL, 33);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (32, 'CiscoSnapShotAbsCounter32', 'This TC describes an object which stores a snap-shot value with the following semantics: objects of this type will take a snap-shot value from their associated CiscoAbsZeroBasedCounter32 type objects on creation.', NULL, 'Unsigned32', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (18, 'CiscoNetworkAddress', 'Represents a network layer address. The length and format of the address is protocol dependent as follows: ip 4 octets decnet 2 octets pup obsolete chaos 2 octets xns 10 octets first 4 octets are the net number last 6 octets are the host number x121 appletalk 3 octets first 2 octets are the net number last octet is the host number clns lat vines 6 octets first 4 octets are the net number last 2 octets are the host number cons apollo 10 octets first 4 octets are the net number last 6 octets are the host number stun 8 octets novell 10 octets first 4 octets are the net number last 6 octets are the host number qllc 6 octets bstun 1 octet - bi-sync serial tunnel snapshot 1 octet atmIlmi 4 octets x25 pvc 2 octets (12 bits) ipv6 16 octets cdm nbf bgpIgx clnsPfx upto 20 octets http upto 70 octets first 4 octets are the IPv4 host address next 2 octets are the TCP port number remaining(1 upto 64) octets are the URI', NULL, 'OCTET STRING', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (19, 'Unsigned64', 'An unsigned 64 bit integer. We use SYNTAX Counter64 for the encoding rules.', NULL, 'Counter64', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (20, 'InterfaceIndexOrZero', 'Either the value 0, or the ifIndex value of an interface in the ifTable.', NULL, 'Integer32 (0..2147483647)', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (21, 'SAPType', 'Service Access Point - is a term that denotes the means by which a user entity in layer n+1 accesses a service of a provider entity in layer n.', NULL, 'Integer32 (0..254)', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (22, 'CountryCode', 'Represents a case-insensitive 2-letter country code taken from ISO-3166. Unrecognized countries are represented as empty string.', NULL, 'OCTET STRING (SIZE (0 | 2))', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (23, 'CountryCodeITU', 'This textual convention represents a country or area code for non-standard facilities in telematic services.', NULL, 'Unsigned32 (0..255)', 'current', 'ITU-T T.35 - Section 3.1 Country Code', 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (24, 'EntPhysicalIndexOrZero', 'This textual convention is an extension of entPhysicalIndex. If non-zero, the object is an entPhysicalIndex. If zero, no appropriate entPhysicalIndex exists. Any additional semantics are object specific.', NULL, 'Integer32 (0..2147483647)', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (25, 'CiscoRowOperStatus', 'Represents the operational status of an table entry. This textual convention allows explicitly representing the states of rows dependent on rows in other tables.  active(1) - Indicates this entry''s RowStatus is active and the RowStatus for each dependency is active.  activeDependencies(2) - Indicates that the RowStatus for each dependency is active, but the entry''s RowStatus is not active.  inactiveDependency(3) - Indicates that the RowStatus for at least one dependency is not active.  missingDependency(4) - Indicates that at least one dependency does not exist in it''s table.', NULL, 'INTEGER { active(1), activeDependencies(2), inactiveDependency(3), missingDependency(4) }', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (26, 'CiscoPort', 'The TCP or UDP port number range.', NULL, 'Integer32 ( 0..65535 )', 'current', 'Transmission Control Protocol. J. Postel. RFC793, User Datagram Protocol. J. Postel. RFC768', 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (27, 'CiscoIpProtocol', 'IP protocol number range.', NULL, 'Integer32 ( 0..255 )', 'current', 'Internet Protocol. J. Postel. RFC791', 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (28, 'CiscoLocationClass', 'An enumerated value which provides an indication of the general location type of a particular physical and/or logical interface. chassis - a system framework for mounting one or more shelves/slots/cards. shelf - a cabinet that holds one or more slots. slot - card or subSlot holder. subSlot - daughter-card holder. port - a physical port (e.g., a DS1 or DS3 physical port). subPort - a logical port on a physical port (e.g., a DS1 subPort on a DS3 physical port). channel - a logical interface (e.g., a DS0 channel, signaling channel, ATM port, other virtual interfaces). subChannel - a sub-channel on a logical interface.', NULL, 'INTEGER { chassis(1), shelf(2), slot(3), subSlot(4), port(5), subPort(6), channel(7), subChannel(8) }', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (29, 'CiscoLocationSpecifier', 'Use this TC to define objects that indicate the physical entity and/or logical interface location of a managed entity on a managed device. In SNMP, a standard mechanism for indicating the physical location of entities is via the ENTITY-MIB. However, that approach is not satisfactory in some cases because:  1. The entity requiring a location-based naming may be associated with an entity which can not be represented as a physical entity in the ENTITY-MIB, 2. NMS applications may desire a more direct name/representation of a physical entity than is available via the ENTITY-MIB, e.g., a physical entity which is named via a hierarchy of levels in the ENTITY-MIB.  The value of an object defined using this TC is an ASCII string consisting of zero or more elements separated by commas. Each element is of the form = .  An example of this syntax is ''slot=5,port=3''.  The syntax of the string is formally specified using ABNF notation (with one exception, noted below), as follows:  location-specifier = elem *('','' elem) ; subject to ; size restriction specified in the SYNTAX ; clause below  elem = loctype ''='' number  number = %x00-FFFFFFFF / %d0-4294967295  loctype = 1*32VCHAR  It is recommended that loctype use one of the enumerated labels defined for CiscoLocationClass.  (NOTE: To conform to ABNF notation as defined in RFC2234, substitute the single-quote symbol with a double-quote symbol in the above rules.)  A zero length of CiscoLocationSpecifier is object-specific and must be defined as part of the description of any object which uses this syntax.', NULL, 'OCTET STRING (SIZE (0..255))', 'current', 'RFC2234, Augmented BNF for syntax specifications: ABNF', 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (30, 'CiscoInetAddressMask', 'Denotes a generic Internet subnet address mask. The Internet subnet address mask is represented as the number of contiguous 1-bit from MSB (most significant bit) of the Internet subnet address mask. A CiscoInetAddressMask value is always interpreted within the context of an InetAddressType value. The InetAddressType only object or InetAddressType with InetAddress objects which define the context must be registered immediately before the object which uses the CiscoInetAddressMask textual convention. In other words, the object identifiers for the InetAddressType object and the CiscoInetAddressMask object MUST have the same length and the last sub-identifier of the InetAddressType object MUST be 1 less than the last sub-identifier of the CiscoInetAddressMask object and MUST be 2 less than the last sub-identifier of the CiscoInetAddressMask object if an InetAddress object is defined between InetAddressType and CiscoInetAddressMask objects. The maximum value of the CiscoInetAddressMask TC is 32 for the value ''ipv4(1)'' in InetAddressType object and 128 for the value ''ipv6(2)'' in InetAddressType object. The value zero is object-specific and must therefore be defined as part of the description of any object which uses this syntax. Examples of the usage of zero might include situations where Internet subnet mask was unknown, or when none subnet masks need to be referenced.', NULL, 'Unsigned32 (0..128)', 'current', 'RFC2851, Textual Conventions for Internet Network Addresses.', 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (31, 'CiscoAbsZeroBasedCounter32', 'This TC describes an object which counts events with the following semantics: objects of this type will be set to zero(0) on creation and will thereafter count appropriate events, it locks at the maximum value of 4,294,967,295 if the counter overflows. This TC may be used only in situations where wrapping is not possible or extremely unlikely situation.', NULL, 'Gauge32', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (33, 'CiscoAlarmSeverity', 'Represents the perceived alarm severity associated with a service or safety affecting condition and/or event. These are based on ITU severities, except that info(7) is added.  cleared(1) - Indicates a previous alarm condition has been cleared. It is not required (unless specifically stated elsewhere on a case by case basis) that an alarm condition that has been cleared will produce a notification or other event containing an alarm severity with this value.  indeterminate(2) - Indicates that the severity level cannot be determined.  critical(3) - Indicates that a service or safety affecting condition has occurred and an immediate corrective action is required.  major(4) - Indicates that a service affecting condition has occurred and an urgent corrective action is required.  minor(5) - Indicates the existence of a non-service affecting condition and that corrective action should be taken in order to prevent a more serious (for example, service or safety affecting) condition.  warning(6) - Indicates the detection of a potential or impending service or safety affecting condition, before any significant effects have been felt.  info(7) - Indicates an alarm condition that does not meet any other severity definition. This can include important, but non-urgent, notices or informational events.', NULL, 'INTEGER { cleared(1), indeterminate(2), critical(3), major(4), minor(5), warning(6), info(7) }', 'current', 'ITU-X.733', 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (34, 'PerfHighIntervalCount', 'A 64 bit counter associated with a performance measurement in a previous 15 minute measurement interval. In the case where the agent has no valid data available for a particular interval the corresponding object instance is not available and upon a retrieval request a corresponding error message shall be returned to indicate that this instance does not exist (for example, a noSuchName error for SNMPv1 and a noSuchInstance for SNMPv2 GET operation). In a system supporting a history of n intervals with IntervalCount(1) and IntervalCount(n) the most and least recent intervals respectively, the following applies at the end of a 15 minute interval: - discard the value of IntervalCount(n) - the value of IntervalCount(i) becomes that of IntervalCount(i-1) for n >= i > 1 - the value of IntervalCount(1) becomes that of CurrentCount - the TotalCount, if supported, is adjusted.  This definition is based on CounterBasedGauge64 TEXTUAL CONVENTION defined in RFC2856. The PerfHighIntervalCount type represents a non-negative integer, which may increase or decrease, but shall never exceed a maximum value, nor fall below a minimum value. The maximum value can not be greater than 2^64-1 (18446744073709551615 decimal), and the minimum value can not be smaller than 0. The value of a PerfHighIntervalCount, has its maximum value whenever the information being modeled is greater than or equal to its maximum value, and has its minimum value whenever the information being modeled is smaller than or equal to its minimum value. If the information being modeled subsequently decreases below (increases above) the maximum (minimum) value, the PerfHighIntervalCount also decreases (increases).  Note that this TC is not strictly supported in SMIv2, because the ''always increasing'' and ''counter wrap'' semantics associated with the Counter64 base type are not preserved. It is possible that management applications which rely solely upon the (Counter64) ASN.1 tag to determine object semantics will mistakenly operate upon objects of this type as they would for Counter64 objects.  This textual convention represents a limited and short-term solution, and may be deprecated as a long term solution is defined and deployed to replace it.', NULL, 'Counter64', 'current', 'RFC 2856(HCNUM-TC MIB). RFC 2493(PerfHist-TC-MIB).', 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (35, 'ConfigIterator', 'This object type is a control object type which applies to writable objects in the same SNMP PDU related to the same table containing those objects. It controls an operation which repeatedly applies the specified configuration data to more than one rows in a table. The operation starts from the row specified by the index of the instance and repeats for the number of rows as the value of the object.  ConfigIterator object needs to be accompanied by one set of writable objects which are of the same instance to apply to.  For example, a SNMP PDU contains { objectA.10 = 1, objectB.10 = ''E1'', objectC.10 = 44, objectRepetition.10 = 100 }  The SYNTAX of objectRepetition is ConfigIterator. This will apply value 1 to objectA, value ''E1'' to objectB, value 44 to objectC in the table starting from row 10 repeatedly for 100 rows.  The iteration is based on the number of rows, not based on the value of the index. For sparse tables, the index 10, 20, 30, 110, and 120 counts for 5 rows, the operation will go beyond index 100 in the previous SNMP PDU example.  The iteration will stop prematurely when it comes to the following situations: (1) When the number of the rows in the table is less than the designated row indicated by the ConfigIterator object. (2) When it encounters the first error in any row, the operation won''t continue to next row.  The operation of ConfigIterator object applies only to the writable objects having the same index as the ConfigIterator object in one SNMP PDU.  For example, a SNMP PDU contains { objectD.5 = 38, objectE.6 = ''T1'', objectF.5 = ''false'', objectIterator.5 = 10 }  The SYNTAX of objectIterator is ConfigIterator. This will apply value 38 to objectD, value ''false'' to objectF in the table starting from row 5 repeatedly for 10 rows. Since the object objectE.6 has different index (6) from the index of objectIterator, the repetition won''t be applied to it. However the value of objectE in the row 6 will be set to ''T1'' according to regular SNMP SET orperation.  If there is row overlapping of the iteration in a SNMP PDU, it will be operated as they are in two different SNMP PDUs.  For example, a SNMP PDU contains { objectD.5 = 38, objectD.6 = 40, objectE.6 = ''T1'', objectF.5 = ''false'', objectIterator.5 = 10 objectIterator.6 = 10 }  This will apply value 38 to objectD, value ''false'' to objectF starting from row 5 repeatedly for 10 rows, and apply value 40 to objectD, value ''T1'' to objectE starting from row 6 repeatedly for 10 rows. The final value of objectD.6 can be 38 or 40, it depends on the SNMP stack of the system starts SNMP SET for the row 5 before the row 6 or the other way around.  The object defined as ConfigIterator will be set to value 1 after the iteration operation is kick-off regardless the system has completed the operation to the designated rows or not. Therefore retrieving the value of this object is meaningless. It acts as the one time operation for bulk configuration.  The object defined as ConfigIterator has no meaning by itself, it has to be combined with one or more than one writable objects from the same table and within the same SNMP PDU for the repetition operation.  For example, a SNMP PDU contains { objectG.2 = 49, objectH.2 = ''AE''h objectIterator.4 = 20 }  The SYNTAX of objectIterator is ConfigIterator. Since there are no objects having the same index as the index of objectIterator in the PDU, the result of this SNMP operation will set value 49 to objectG and value 0xAE to objectH of the row 2 only as regular SNMP SET operation.  The index of the instance indicates the starting row for the iteration. The order of the iteration depends, for instance, on: (1) physical hardware position, or (2) logical index.  It depends on the characters of the table which contains the ConfigIterator object.  Iteration can be done through some or all the components of the index for a table. The description of the iterator object in that table should describe which part of the index the iteration is applied to.  The operation for this object type is based on the best effort. When the agent receives a SNMP PDU containing this data type, the return status of the SNMP request reflects only the result of the SET operation has applied to the starting row. It may return a SNMP response with SUCCESS status regardless the number of rows for the data actually been deployed later on. Therefore it is possible the data might not be completely deployed to the number of rows designated by the ConfigIterator and the operation stops prematurely due to an error it first encounters after n rows (n < the value of ConfigIterator object).  Usually the error report mechanism for this type of operation is accomplished by combining this type of object with the other two objects in the same table:  (1) An OwnerString object (2) An object indicates the result of the operation.  When issuing this bulk configuration request, the SNMP manager should provide its identifier in (1) object. After issuing the request, it should check the value of (1) object if it is the same with it own name. If they are the same, then the value of the object presents in (2) is the result from the previous operation from this manager. Otherwise, another SNMP manager might issue the bulk configuration to the same table before the previous bulk operation has been completed. These two objects will represent the last bulk operation in the table.', NULL, 'Unsigned32 (1..4294967295)', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (36, 'BulkConfigResult', 'This textual convention defines the format of the displayable textual result from the bulk configuration operation specified as ConfigIterator type.  The format should be: ''COMPLETION= error occured>/, ERROR=/: ''  For example: ''COMPLETION=22/100,ERROR=38/44:Invalid Ds1 line coding for the line type''', NULL, 'OCTET STRING (SIZE(0..255))', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (37, 'ListIndex', 'A unique value greater than zero, for each of the list that is defined. The object using this convention should give all the object specific details including the list type.', NULL, 'Integer32 (1..2147483647)', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (38, 'ListIndexOrZero', 'This textual convention is an extension of the ListIndex. In addition to the ListIndex range, this also includes 0 in its range of values. This value could be object specific and should be given the description of that object. In most cases, a value 0 means that the it does not represent any lists.', NULL, 'Integer32 (0..2147483647)', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (39, 'TimeIntervalSec', 'A period of time, measured in units of 1 second.', NULL, 'Unsigned32', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (40, 'TimeIntervalMin', 'A period of time, measured in units of 1 minute.', NULL, 'Unsigned32', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (41, 'CiscoMilliSeconds', 'Represents time unit value in milliseconds.', NULL, 'Unsigned32', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (42, 'MicroSeconds', 'Represents time unit value in microseconds.', NULL, 'Unsigned32', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (43, 'CiscoPortList', 'Each octet within this value specifies a set of eight ports. The object defined by this textual convention can specify a port range of 2k ports in its description. Example: 1 - 2048, 2049 - 4096, etc. The first octet represents the first 8 ports of the range of ports specified by the object, the second octet represents the next 8 ports, etc. When a port range is not specified, a default port range of ''1 - 2048'' is assumed.  Within each octet, the most significant bit represents the lowest numbered port, and the least significant bit represents the highest numbered port. Thus, each port of the bridge is represented by a single bit within the value of this object. If that bit has a value of ''1'' then that port is included in the set of ports; the port is not included if its bit has a value of ''0''.  Note that if the length of this string is less than 256 octets, any ''missing'' octets are assumed to contain the value zero. An NMS may omit any zero-valued octets from the end of this string in order to reduce SetPDU size, and the agent may also omit zero-valued trailing octets, to reduce the size of GetResponse PDUs.', NULL, 'OCTET STRING (SIZE (0..256))', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (44, 'CiscoPortListRange', 'Indicates the port range.  oneto2K(1) indicates that the port number range is from 1 to 2048.  twoKto4K(2) indicates that the port number range is from 2049 to 4096.  fourKto6K(3) indicates that the port number range is from 4097 to 6144.  sixKto8K(4) indicates that the port number range is from 6145 to 8192.  eightKto10K(5) indicates that the port number range is from 8193 to 10240.  tenKto12K(6) indicates that the port number range is from 10241 to 12288.  twelveKto14K(7) indicates that the port number range is from 12289 to 14336.  fourteenKto16K(8) indicates that the port number range is from 14337 to 16384.  When an object is defined with this textual convention, it must be accompanied by an object of CiscoPortList syntax.', NULL, 'INTEGER { oneto2k(1), twoKto4K(2), fourKto6K(3), sixKto8K(4), eightKto10K(5), tenKto12K(6), twelveKto14K(7), fourteenKto16K(8) }', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (45, 'IfOperStatusReason', 'The cause of current operational state of the interface.  GLOSSARY:  BB - Buffer-to-Buffer.  BB_Credit - Buffer-to-Buffer credit, a link level flow control mechanism.  B_Port - A Fibre Channel, Bridging port.  Class F - A connectionless service with notification on non-delivery between E_Ports, used for control, coordination, and configuration of the Fabric.  Class N - Refers to any class of service (different types of frame delivery services) other than Class F.  E_D_TOV - Error Detect Timeout Value.  ELP - Exchange Link Parameter.  E-mode - A fibre channel port providing E_Port functionality.  E_Port - A Fabric Expansion Port.  EPP - Exchange Peer Parameters.  ESC - Exchange Switch Capabilities.  Fabric - The set of physically connected fibre channel switches.  FC-FS - Fibre Channel Framing and Signaling.  FCIP - Fibre Channel over IP protocol.  FCOT - Fibre channel optical transmitter.  FC-PH - The Fibre Channel Physical and Signaling standard.  FCSP - Fibre Channel Security Protocol.  Fibre Channel - The primary protocol for building SANs.  FICON - An I\O protocol used between IBM (and compatible) mainframes and storage.  FLOGI - Fabric Login, used by a node port to establish a session with the fabric.  GBIC - Gigabit Interface Converter; a removable transceiver module permitting Fibre Channel and Gigabit Ethernet physical-layer transport.  Interconnect_Ports - Switch Ports that assume either the E_Port or B_Port mode are generally referred to as Interconnect_Ports.  LIP - Loop Initialization Primitive sequence.  LR - Link Reset, the FC-PH defined primitive sequence used to initiate a link reset.  NOS - Not Operational Sequence, the FC-PH defined primitive sequence to indicate that the transmitting port has detected a link failure (or) offline condition.  Nx_Port - A Fiber Channel Node Port.  OLS - Offline Sequence, the FC-PH defined primitive sequence to indicate that the port is entering into offline state.  OHMS - Online Health Management System.  R_A_TOV - Resource Allocation Timeout Value.  RCF - Reconfigure Fabric.  Rxbbcredit - Receive BB credit value configured for a FC interface.  SAN - Storage Area Network; a network linking computing devices to disk or tape arrays and other devices over Fibre Channel.  TE_Port - Trunking E_Port.  TOV - Time out value.  VSAN - Virtual Storage Area Network.  WWN - World Wide Name.  xE_Port - A Fiber channel port that can assume either E_Port or TE_Port mode.  The enumerated values which provides the cause of the current operational state of the interface are,  ''other(1)'' - reasons other than defined here.  ''none(2)'' - no failure.  ''hwFailure(3)'' - hardware failure.  ''loopbackDiagFailure(4)'' - loopback diagnostics failure.  ''errorDisabled(5)'' - the port is not operational due to some error conditions that require administrative attention.  ''swFailure(6)'' - software failure.  ''linkFailure(7)'' - physical link failure.  ''offline(8)'' - physical link is in offline state as defined in the FC-FS standards.  ''nonParticipating(9)'' - during loop initialization, the port is not allowed to participate in loop operations.  ''initializing(10)'' - port is being initialized.  ''vsanInactive(11)''- port VSAN is inactive. The port becomes operational again when the port VSAN is active.  ''adminDown(12)'' - ifAdminStatus is ''down''.  ''channelAdminDown(13)'' - this port is a member of a port channel and that port channel''s ifAdminStatus is ''down''.  ''channelOperSuspended(14)'' - this port is a member of a port channel and its operational parameters are incompatible with the port channel parameters.  ''channelConfigurationInProgress(15)'' - this port is undergoing a port channel configuration.  ''rcfInProgress(16)'' - an isolated xE_port is transmitting an reconfigure fabric, requesting a disruptive reconfiguration in an attempt to build a single, non-isolated fabric. Only the Interconnect_Ports can become isolated.  ''elpFailureIsolation(17)'' - during a port initialization the prospective Interconnect_Ports find incompatible link parameters.  ''escFailureIsolation(18) - during a port initialization the prospective Interconnect_Ports are unable to proceed with initialization as a result of ESC.  ''domainOverlapIsolation(19)'' - there is a overlap in domains while attempting to connect two existing fabrics.  ''domainAddrAssignFailureIsolation(20)'' - the elected principal switch is not capable of performing domain address manager functions so no Nx_port traffic can be forwarded across switches, hence all Interconnect_Ports in the switch are isolated.  ''domainOtherSideEportIsolation(21)'' - the peer E_port is isolated.  ''domainInvalidRcfReceived(22)'' - invalid RCF received.  ''domainManagerDisabled(23) - domain manager is disabled.  ''zoneMergeFailureIsolation(24)'' - the two Interconnect_Ports cannot merge zoning configuration after having exchanged merging request for zoning.  ''vsanMismatchIsolation(25)'' - this VSAN is not configured on both sides of a trunk port.  ''parentDown(26)'' - the physical port to which this interface is bound is down.  ''srcPortNotBound(27)''- no source port is specified for this interface.  ''interfaceRemoved(28)'' - interface is being removed.  ''fcotNotPresent(29)'' - FCOT (GBIC) not present.  ''fcotVendorNotSupported(30)'' - FCOT (GBIC) vendor is not supported.  ''incompatibleAdminMode(31)'' - port administrative mode is incompatible with port capabilities.  ''incompatibleAdminSpeed(32)'' - port speed is incompatible with port capabilities.  ''suspendedByMode(33)'' - port that belongs to a port channel is suspended due to incompatible operational mode.  ''suspendedBySpeed(34)'' - port that belongs to a port channel is suspended due to incompatible operational speed.  ''suspendedByWwn(35)'' - port that belongs to a port channel is suspended due to incompatible remote switch WWN.  ''domainMaxReTxFailure(36)'' - domain manager failure after maximum retries.  ''eppFailure(37)'' - trunk negotiation protocol failure after maximum retries.  ''portVsanMismatchIsolation(38)'' - an attempt is made to connect two switches using non-trunking ports having different port VSANs.  ''loopbackIsolation(39)'' - port is connected to another port in the same switch.  ''upgradeInProgress(40)'' - linecard upgrade in progress.  ''incompatibleAdminRxBbCredit(41)'' - receive BB credit is incompatible.  ''incompatibleAdminRxBufferSize(42)'' - receive buffer size is incompatible.  ''portChannelMembersDown(43)'' - no operational members.  ''zoneRemoteNoRespIsolation(44)'' - isolation due to remote zone server not responding.  ''firstPortUpAsEport(45)'' - in a over subscribed line card, when the first port in a group is up in E-mode, other ports in that group cannot be brought up.  ''firstPortNotUp(46)'' - in a over subscribed line card, first port cannot be brought up in E-mode when the other ports in the group are up.  ''peerFcipPortClosedConnection(47)'' - port went down because peer FCIP port closed TCP connection.  ''peerFcipPortResetConnection(48)'' - port went down because the TCP connection was reset by the peer FCIP port.  ''fcipPortMaxReTx(49)'' - FCIP port went down due to maximum TCP re-transmissions reached the configured limit.  ''fcipPortKeepAliveTimerExpire(50)'' - FCIP port went down due to TCP keep alive timer expired.  ''fcipPortPersistTimerExpire(51)'' - FCIP port went down due to TCP persist timer expired.  ''fcipPortSrcLinkDown(52)'' - FCIP port went down due to Ethernet link down.  ''fcipPortSrcAdminDown(53)'' - FCIP port went down because the source Ethernet link was administratively shutdown.  ''fcipPortAdminCfgChange(54)'' - FCIP port went down due to configuration change.  ''fcipSrcPortRemoved(55)'' - FCIP port went down due to source port removal.  ''fcipSrcModuleNotOnline(56)'' - FCIP port went down due to source module not online.  ''invalidConfig(57)'' - this port has a misconfiguration with respect to port channels.  ''portBindFailure(58)'' - port got isolated due to port bind failure.  ''portFabricBindFailure(59)'' - port got isolated due to fabric bind failure.  ''noCommonVsanIsolation(60)'' - trunk is isolated because there are no common VSANs with peer.  ''ficonVsanDown (61)'' - FICON VSAN down.  ''invalidAttachment (62)'' - invalid attachment.  ''portBlocked (63)'' - port blocked due to FICON.  ''incomAdminRxBbCreditPerBuf (64)'' - disabled due to incompatible administrative port rxbbcredit, performance buffers.  ''tooManyInvalidFlogis (65)'' - suspended due to too many invalid FLOGIs.  ''deniedDueToPortBinding (66)'' - suspended due to port binding.  ''elpFailureRevMismatch (67)'' - isolated for ELP failure due to revision mismatch.  ''elpFailureClassFParamErr (68)'' - isolated for ELP failure due to Class F parameter error.  ''elpFailureClassNParamErr (69)'' - isolated for ELP failure due to Class N parameter error.  ''elpFailureUnknownFlowCtlCode (70)'' - isolated for ELP failure due to invalid flow control code.  ''elpFailureInvalidFlowCtlParam (71)'' - isolated for ELP failure due to invalid flow control parameter.  ''elpFailureInvalidPortName(72)'' - isolated for ELP failure due to invalid port name.  ''elpFailureInvalidSwitchName (73)'' - isolated for ELP failure due to invalid switch name.  ''elpFailureRatovEdtovMismatch (74)'' - isolated for ELP failure due to R_A_TOV or E_D_TOV mismatch.  ''elpFailureLoopbackDetected (75)'' - isolated for ELP failure due to loopback detected.  ''elpFailureInvalidTxBbCredit (76)'' - isolated for ELP failure due to invalid transmit BB credit.  ''elpFailureInvalidPayloadSize (77)'' - isolated for ELP failure due to invalid payload size.  ''bundleMisCfg (78)'' - misconfiguration in port channel membership detected.  ''bitErrRuntimeThreshExceeded (79)'' - bit error rate too high. It has exceeded the run time threshold.  ''linkFailLinkReset (80)'' - link failure due to link reset.  ''linkFailPortInitFail (81)'' - link failure due to port initialization failure.  ''linkFailPortUnusable (82)'' - link failure due to port unusable.  ''linkFailLossOfSignal (83)'' - link failure due to loss of signal.  ''linkFailLossOfSync (84)'' - link failure due to loss of sync.  ''linkFailNosRcvd (85)'' - link failure due to non-operational sequences received.  ''linkFailOlsRcvd (86)'' - link failure due to offline sequences received.  ''linkFailDebounceTimeout (87)'' - link failure due to re-negotiation failed.  ''linkFailLrRcvd (88)'' - link failure when link reset(LR) operation fails due to non-empty receive queue.  ''linkFailCreditLoss (89)'' - link failure due to excessive credit loss indications.  ''linkFailRxQOverflow (90)'' - link failure due to receive queue overflow.  ''linkFailTooManyInterrupts (91)'' - link failure due to excessive port interrupts.  ''linkFailLipRcvdBb (92)'' - link failure when loop initialization(LIP) operation fails due to non empty receive queue.  ''linkFailBbCreditLoss (93)'' - link failure when link reset(LR) operation fails due to queue not empty.  ''linkFailOpenPrimSignalTimeout (94)'' - link failure due to open primitive signal timeout while receive queue not empty.  ''linkFailOpenPrimSignalReturned (95)'' - link failure due to open primitive signal returned while receive queue not empty.  ''linkFailLipF8Rcvd (96)'' - link failure due to F8 LIP received.  ''linkFailLineCardPortShutdown (97)'' - link failure due to port shutdown.  ''fcspAuthenFailure (98)'' - fibre channel security protocol authorization fail.  ''fcotChecksumError (99)'' - FCOT SPROM checksum error.  ''ohmsExtLoopbackTest (100)'' - link suspended due to external loopback diagnostics failure.  ''invalidFabricBindExchange (101)'' - invalid fabric binding exchange.  ''tovMismatch (102)'' - link isolation due to TOV mismatch.  ''ficonNotEnabled (103)'' - FICON not enabled.  ''ficonNoPortNumber (104)'' - no FICON port number.  ''ficonBeingEnabled (105)'' - FICON is being enabled.  ''ePortProhibited (106)'' - port down because FICON prohibit mask in place for E/TE port.  ''portGracefulShutdown (107)'' - port has been shutdown gracefully.  ''trunkNotFullyActive (108)'' - some of the VSANs which are common with the peer are not up.  ''fabricBindingSwitchWwnNotFound (109)'' - peer switch WWN not found in fabric binding active database.  ''fabricBindingDomainInvalid (110)'' - peer domain ID is invalid in fabric binding active database.  ''fabricBindingDbMismatch (111)'' - fabric binding active database mismatch with peer.  ''fabricBindingNoRspFromPeer (112)'' - fabric binding no response from peer.  ''dpvmVsanSuspended (113)'' - dpvm vsan is suspended.  ''dpvmVsanNotFound (114)'' - dpvm vsan not found.  ''trackedPortDown (115)'' - port down because tracked port is down.  ''ecSuspendedOnLoop (116)'' - port suspended because extended BB credits are configured on loop port.  ''isolateBundleMisCfg (117)'' - port isolated due to bundle mis-configuration.  ''noPeerBundleSupport (118)'' - peer port does not support bundle.  ''portBringupIsolation (119)'' - trunk port isolated during bringup time.  ''domainNotAllowedIsolated (120)'' - port isolated due to domain not allowed.  ''virtualIvrDomainOverlapIsolation (121)'' - port isolated due to virtual IVR domain overlap.  ''outOfService (122)'' - port is in out of service state.  ''portAuthFailed (123)'' - port has encountered an 802.1x authentication failure.  ''bundleStandby (124)'' - port cannot be brought up in a bundle, since the bundle has max members.  ''portConnectorTypeErr (125)'' - Error in the port connector type (SFP).  ''errorDisabledReInitLmtReached (126)'' - the port is not operational after trying to initialize the port multiple times due to some erorrs.  ''ficonDupPortNum (127)'' - the ficon vsan has a duplicate port number.  ''localRcf (128)'' - fcdomain applied a locally disruptive reconfiguration (the local domain became invalid; no RCF frames have been sent outside the local switch).  ''twoSwitchesWithSameWWN (129)'' - merge attempt between VSANs containing the same WWN. If the user attempts to merge two different VSANs and both have at least one switch with the same WWN then the link in between the VSANs is isolated.  ''invalidOtherSidePrincEFPReqRecd (130)'' - EFP request frame indicating a principal switch other than the locally known one.  ''domainOther (131)'' - other domain manager reasons not defined here.', NULL, 'INTEGER { other(1), none(2), hwFailure(3), loopbackDiagFailure(4), errorDisabled(5), swFailure(6), linkFailure(7), offline(8), nonParticipating(9), initializing(10), vsanInactive(11), adminDown(12), channelAdminDown(13), channelOperSuspended(14), channelConfigurationInProgress(15), rcfInProgress(16), elpFailureIsolation(17), escFailureIsolation(18), domainOverlapIsolation(19), domainAddrAssignFailureIsolation(20), domainOtherSideEportIsolation(21), domainInvalidRcfReceived(22), domainManagerDisabled(23), zoneMergeFailureIsolation(24), vsanMismatchIsolation(25), parentDown(26), srcPortNotBound(27), interfaceRemoved(28), fcotNotPresent(29), fcotVendorNotSupported(30), incompatibleAdminMode(31), incompatibleAdminSpeed(32), suspendedByMode(33), suspendedBySpeed(34), suspendedByWWN(35), domainMaxReTxFailure(36), eppFailure(37), portVsanMismatchIsolation(38), loopbackIsolation(39), upgradeInProgress(40), incompatibleAdminRxBbCredit(41), incompatibleAdminRxBufferSize(42), portChannelMembersDown(43), zoneRemoteNoRespIsolation(44), firstPortUpAsEport(45), firstPortNotUp(46), peerFCIPPortClosedConnection(47), peerFCIPPortResetConnection(48), fcipPortMaxReTx(49), fcipPortKeepAliveTimerExpire(50), fcipPortPersistTimerExpire(51), fcipPortSrcLinkDown(52), fcipPortSrcAdminDown(53), fcipPortAdminCfgChange(54), fcipSrcPortRemoved(55), fcipSrcModuleNotOnline(56), invalidConfig(57), portBindFailure(58), portFabricBindFailure(59), noCommonVsanIsolation(60), ficonVsanDown(61), invalidAttachment(62), portBlocked(63), incomAdminRxBbCreditPerBuf(64), tooManyInvalidFlogis(65), deniedDueToPortBinding(66), elpFailureRevMismatch(67), elpFailureClassFParamErr(68), elpFailureClassNParamErr(69), elpFailureUnknownFlowCtlCode(70), elpFailureInvalidFlowCtlParam(71), elpFailureInvalidPortName(72), elpFailureInvalidSwitchName(73), elpFailureRatovEdtovMismatch(74), elpFailureLoopbackDetected(75), elpFailureInvalidTxBbCredit(76), elpFailureInvalidPayloadSize(77), bundleMisCfg(78), bitErrRuntimeThreshExceeded(79), linkFailLinkReset(80), linkFailPortInitFail(81), linkFailPortUnusable(82), linkFailLossOfSignal(83), linkFailLossOfSync(84), linkFailNosRcvd(85), linkFailOlsRcvd(86), linkFailDebounceTimeout(87), linkFailLrRcvd(88), linkFailCreditLoss(89), linkFailRxQOverflow(90), linkFailTooManyInterrupts(91), linkFailLipRcvdBb(92), linkFailBbCreditLoss(93), linkFailOpenPrimSignalTimeout(94), linkFailOpenPrimSignalReturned(95), linkFailLipF8Rcvd(96), linkFailLineCardPortShutdown(97), fcspAuthenfailure(98), fcotChecksumError(99), ohmsExtLoopbackTest(100), invalidFabricBindExchange(101), tovMismatch(102), ficonNotEnabled(103), ficonNoPortNumber(104), ficonBeingEnabled(105), ePortProhibited(106), portGracefulShutdown(107), trunkNotFullyActive(108), fabricBindingSwitchWwnNotFound(109), fabricBindingDomainInvalid(110), fabricBindingDbMismatch(111), fabricBindingNoRspFromPeer(112), dpvmVsanSuspended(113), dpvmVsanNotFound(114), trackedPortDown(115), ecSuspendedOnLoop(116), isolateBundleMisCfg(117), noPeerBundleSupport(118), portBringupIsolation(119), domainNotAllowedIsolated(120), virtualIvrDomainOverlapIsolation(121), outOfService(122), portAuthFailed(123), bundleStandby(124), portConnectorTypeErr(125), errorDisabledReInitLmtReached(126), ficonDupPortNum(127), localRcf(128), twoSwitchesWithSameWWN(129), invalidOtherSidePrincEFPReqRecd(130), domainOther(131) }', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (46, 'EntLogicalIndexOrZero', 'This textual convention is an extension of entLogicalIndex. If non-zero, the semantic is same as entLogicalIndex object. If zero, no appropriate entLogicalIndex exists. Any additional semantics must be defined as part of the description of any object which uses this syntax.', NULL, 'Integer32 (0..2147483647)', 'current', NULL, 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (47, 'CiscoURLString', 'This textual convention defines the URL string. The Universal Resource Locator(URL). The URL strings are compact string representation for a resource available via internet. This is the address location of the page to load. The string should represent a fully qualifying string with the format ''protocol:/server/page''. In general the string should point to any value that can be saved/loaded. Any limitation for the URL must be defined as part of the description of any object which uses this syntax.', NULL, 'OCTET STRING (SIZE(1..255))', 'current', 'Uniform Resource Locators. RFC 1738.', 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (48, 'CiscoHTTPResponseStatusCode', 'This corresponds to the HTTP Status code. The Status-Code element in HTTP response is a 3-digit integer result code of the attempt to understand and satisfy the HTTP request The Status-Code is intended for use by automata.  The first digit of the Status-Code defines the class of response. The last two digits do not have any categorization role. There are 5 values for the first digit:  - 1xx: Informational - Request received, continuing process  - 2xx: Success - The action was successfully received, understood, and accepted  - 3xx: Redirection - Further action must be taken in order to complete the request  - 4xx: Client Error - The request contains bad syntax or cannot be fulfilled  - 5xx: Server Error - The server failed to fulfill an apparently valid request.', NULL, 'Unsigned32 (100..599)', 'current', 'RFC 2616 Section 6.1.1 Status Code and Reason Phrase.', 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (49, 'CvE164Address', 'A UTF-8 string limited to the character set defined for E.164, ''0123456789*#,''. Note that represents the double quote which cannot be contained in a SMI description clause. OR An IA5String limited to the character set ''0123456789*#,.''', NULL, 'OCTET STRING (SIZE (1..128))', 'current', 'ITU-T E.164, Q.931 chapter 4.5.10 ITU-H H.225.0 Annex H', 30);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (50, 'IANAifType', 'This data type is used as the syntax of the ifType object in the (updated) definition of MIB-II''s ifTable.  The definition of this textual convention with the addition of newly assigned values is published periodically by the IANA, in either the Assigned Numbers RFC, or some derivative of it specific to Internet Network Management number assignments. (The latest arrangements can be obtained by contacting the IANA.)  Requests for new values should be made to IANA via email (iana@iana.org).  The relationship between the assignment of ifType values and of OIDs to particular media-specific MIBs is solely the purview of IANA and is subject to change without notice. Quite often, a media-specific MIB''s OID-subtree assignment within MIB-II''s ''transmission'' subtree will be the same as its ifType value. However, in some circumstances this will not be the case, and implementors must not pre-assume any specific relationship between ifType values and transmission subtree OIDs.', NULL, 'INTEGER { other(1), regular1822(2), hdh1822(3), ddnX25(4), rfc877x25(5), ethernetCsmacd(6), iso88023Csmacd(7), iso88024TokenBus(8), iso88025TokenRing(9), iso88026Man(10), starLan(11), proteon10Mbit(12), proteon80Mbit(13), hyperchannel(14), fddi(15), lapb(16), sdlc(17), ds1(18), e1(19), basicISDN(20), primaryISDN(21), propPointToPointSerial(22), ppp(23), softwareLoopback(24), eon(25), ethernet3Mbit(26), nsip(27), slip(28), ultra(29), ds3(30), sip(31), frameRelay(32), rs232(33), para(34), arcnet(35), arcnetPlus(36), atm(37), miox25(38), sonet(39), x25ple(40), iso88022llc(41), localTalk(42), smdsDxi(43), frameRelayService(44), v35(45), hssi(46), hippi(47), modem(48), aal5(49), sonetPath(50), sonetVT(51), smdsIcip(52), propVirtual(53), propMultiplexor(54), ieee80212(55), fibreChannel(56), hippiInterface(57), frameRelayInterconnect(58), aflane8023(59), aflane8025(60), cctEmul(61), fastEther(62), isdn(63), v11(64), v36(65), g703at64k(66), g703at2mb(67), qllc(68), fastEtherFX(69), channel(70), ieee80211(71), ibm370parChan(72), escon(73), dlsw(74), isdns(75), isdnu(76), lapd(77), ipSwitch(78), rsrb(79), atmLogical(80), ds0(81), ds0Bundle(82), bsc(83), async(84), cnr(85), iso88025Dtr(86), eplrs(87), arap(88), propCnls(89), hostPad(90), termPad(91), frameRelayMPI(92), x213(93), adsl(94), radsl(95), sdsl(96), vdsl(97), iso88025CRFPInt(98), myrinet(99), voiceEM(100), voiceFXO(101), voiceFXS(102), voiceEncap(103), voiceOverIp(104), atmDxi(105), atmFuni(106), atmIma (107), pppMultilinkBundle(108), ipOverCdlc (109), ipOverClaw (110), stackToStack (111), virtualIpAddress (112), mpc (113), ipOverAtm (114), iso88025Fiber (115), tdlc (116), gigabitEthernet (117), hdlc (118), lapf (119), v37 (120), x25mlp (121), x25huntGroup (122), trasnpHdlc (123), interleave (124), fast (125), ip (126), docsCableMaclayer (127), docsCableDownstream (128), docsCableUpstream (129), a12MppSwitch (130), tunnel (131), coffee (132), ces (133), atmSubInterface (134), l2vlan (135), l3ipvlan (136), l3ipxvlan (137), digitalPowerline (138), mediaMailOverIp (139), dtm (140), dcn (141), ipForward (142), msdsl (143), ieee1394 (144), if-gsn (145), dvbRccMacLayer (146), dvbRccDownstream (147), dvbRccUpstream (148), atmVirtual (149), mplsTunnel (150), srp (151), voiceOverAtm (152), voiceOverFrameRelay (153), idsl (154), compositeLink (155), ss7SigLink (156), propWirelessP2P (157), frForward (158), rfc1483 (159), usb (160), ieee8023adLag (161), bgppolicyaccounting (162), frf16MfrBundle (163), h323Gatekeeper (164), h323Proxy (165), mpls (166), mfSigLink (167), hdsl2 (168), shdsl (169), ds1FDL (170), pos (171), dvbAsiIn (172), dvbAsiOut (173), plc (174), nfas (175), tr008 (176), gr303RDT (177), gr303IDT (178), isup (179), propDocsWirelessMaclayer (180), propDocsWirelessDownstream (181), propDocsWirelessUpstream (182), hiperlan2 (183), propBWAp2Mp (184), sonetOverheadChannel (185), digitalWrapperOverheadChannel (186), aal2 (187), radioMAC (188), atmRadio (189), imt (190), mvl (191), reachDSL (192), frDlciEndPt (193), atmVciEndPt (194), opticalChannel (195), opticalTransport (196), propAtm (197), voiceOverCable (198), infiniband (199), teLink (200), q2931 (201), virtualTg (202), sipTg (203), sipSig (204), docsCableUpstreamChannel (205), econet (206), pon155 (207), pon622 (208), bridge (209), linegroup (210), voiceEMFGD (211), voiceFGDEANA (212), voiceDID (213), mpegTransport (214), sixToFour (215), gtp (216), pdnEtherLoop1 (217), pdnEtherLoop2 (218), opticalChannelGroup (219), homepna (220), gfp (221), ciscoISLvlan (222), actelisMetaLOOP (223), fcipLink (224), rpr (225), qam (226), lmp (227) }', 'current', NULL, 31);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (77, 'InetVersion', 'A value representing a version of the IP protocol.  unknown(0) An unknown or unspecified version of the IP protocol.   ipv4(1) The IPv4 protocol as defined in RFC 791 (STD 5).  ipv6(2) The IPv6 protocol as defined in RFC 2460.  Note that this textual convention SHOULD NOT be used to distinguish different address types associated with IP protocols. The InetAddressType has been designed for this purpose.', NULL, 'INTEGER { unknown(0), ipv4(1), ipv6(2) }', 'current', 'RFC 791, RFC 2460', 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (52, 'InterfaceIndex', 'A unique value, greater than zero, for each interface or interface sub-layer in the managed system. It is recommended that values are assigned contiguously starting from 1. The value for each interface sub-layer must remain constant at least from one re-initialization of the entity''s network management system to the next re-initialization.', NULL, 'Integer32 (1..2147483647)', 'current', NULL, 32);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (53, 'SnmpEngineID', 'An SNMP engine''s administratively-unique identifier. Objects of this type are for identification, not for addressing, even though it is possible that an address may have been used in the generation of a specific value.   The value for this object may not be all zeros or all ''ff''H or the empty (zero length) string.  The initial value for this object may be configured via an operator console entry or via an algorithmic function. In the latter case, the following example algorithm is recommended.  In cases where there are multiple engines on the same system, the use of this algorithm is NOT appropriate, as it would result in all of those engines ending up with the same ID value.  1) The very first bit is used to indicate how the rest of the data is composed.  0 - as defined by enterprise using former methods that existed before SNMPv3. See item 2 below.  1 - as defined by this architecture, see item 3 below.  Note that this allows existing uses of the engineID (also known as AgentID [RFC1910]) to co-exist with any new uses.  2) The snmpEngineID has a length of 12 octets.  The first four octets are set to the binary equivalent of the agent''s SNMP management private enterprise number as assigned by the Internet Assigned Numbers Authority (IANA). For example, if Acme Networks has been assigned { enterprises 696 }, the first four octets would be assigned ''000002b8''H.  The remaining eight octets are determined via one or more enterprise-specific methods. Such methods must be designed so as to maximize the possibility that the value of this object will be unique in the agent''s administrative domain. For example, it may be the IP address of the SNMP entity, or the MAC address of one of the interfaces, with each address suitably padded with random octets. If multiple methods are defined, then it is recommended that the first octet indicate the method being used and the remaining octets be a function of the method.   3) The length of the octet string varies.  The first four octets are set to the binary equivalent of the agent''s SNMP management private enterprise number as assigned by the Internet Assigned Numbers Authority (IANA). For example, if Acme Networks has been assigned { enterprises 696 }, the first four octets would be assigned ''000002b8''H.  The very first bit is set to 1. For example, the above value for Acme Networks now changes to be ''800002b8''H.  The fifth octet indicates how the rest (6th and following octets) are formatted. The values for the fifth octet are:  0 - reserved, unused.  1 - IPv4 address (4 octets) lowest non-special IP address  2 - IPv6 address (16 octets) lowest non-special IP address  3 - MAC address (6 octets) lowest IEEE MAC address, canonical order  4 - Text, administratively assigned Maximum remaining length 27  5 - Octets, administratively assigned Maximum remaining length 27  6-127 - reserved, unused  128-255 - as defined by the enterprise Maximum remaining length 27', NULL, 'OCTET STRING (SIZE(5..32))', 'current', NULL, 33);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (54, 'SnmpSecurityModel', 'An identifier that uniquely identifies a Security Model of the Security Subsystem within this SNMP Management Architecture.  The values for securityModel are allocated as follows:  - The zero value does not identify any particular security model.  - Values between 1 and 255, inclusive, are reserved for standards-track Security Models and are managed by the Internet Assigned Numbers Authority (IANA). - Values greater than 255 are allocated to enterprise-specific Security Models. An enterprise-specific securityModel value is defined to be:  enterpriseID * 256 + security model within enterprise  For example, the fourth Security Model defined by the enterprise whose enterpriseID is 1 would be 259.  This scheme for allocation of securityModel values allows for a maximum of 255 standards- based Security Models, and for a maximum of 256 Security Models per enterprise.  It is believed that the assignment of new securityModel values will be rare in practice because the larger the number of simultaneously utilized Security Models, the larger the chance that interoperability will suffer. Consequently, it is believed that such a range will be sufficient. In the unlikely event that the standards committee finds this number to be insufficient over time, an enterprise number can be allocated to obtain an additional 256 possible values.  Note that the most significant bit must be zero; hence, there are 23 bits allocated for various organizations to design and define non-standard   securityModels. This limits the ability to define new proprietary implementations of Security Models to the first 8,388,608 enterprises.  It is worthwhile to note that, in its encoded form, the securityModel value will normally require only a single byte since, in practice, the leftmost bits will be zero for most messages and sign extension is suppressed by the encoding rules.  As of this writing, there are several values of securityModel defined for use with SNMP or reserved for use with supporting MIB objects. They are as follows:  0 reserved for ''any'' 1 reserved for SNMPv1 2 reserved for SNMPv2c 3 User-Based Security Model (USM)', NULL, 'INTEGER(0 .. 2147483647)', 'current', NULL, 33);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (55, 'SnmpMessageProcessingModel', 'An identifier that uniquely identifies a Message Processing Model of the Message Processing Subsystem within this SNMP Management Architecture.  The values for messageProcessingModel are allocated as follows:  - Values between 0 and 255, inclusive, are reserved for standards-track Message Processing Models and are managed by the Internet Assigned Numbers Authority (IANA).  - Values greater than 255 are allocated to enterprise-specific Message Processing Models. An enterprise messageProcessingModel value is defined to be:  enterpriseID * 256 + messageProcessingModel within enterprise  For example, the fourth Message Processing Model defined by the enterprise whose enterpriseID   is 1 would be 259.  This scheme for allocating messageProcessingModel values allows for a maximum of 255 standards- based Message Processing Models, and for a maximum of 256 Message Processing Models per enterprise.  It is believed that the assignment of new messageProcessingModel values will be rare in practice because the larger the number of simultaneously utilized Message Processing Models, the larger the chance that interoperability will suffer. It is believed that such a range will be sufficient. In the unlikely event that the standards committee finds this number to be insufficient over time, an enterprise number can be allocated to obtain an additional 256 possible values.  Note that the most significant bit must be zero; hence, there are 23 bits allocated for various organizations to design and define non-standard messageProcessingModels. This limits the ability to define new proprietary implementations of Message Processing Models to the first 8,388,608 enterprises.  It is worthwhile to note that, in its encoded form, the messageProcessingModel value will normally require only a single byte since, in practice, the leftmost bits will be zero for most messages and sign extension is suppressed by the encoding rules.  As of this writing, there are several values of messageProcessingModel defined for use with SNMP. They are as follows:  0 reserved for SNMPv1 1 reserved for SNMPv2c 2 reserved for SNMPv2u and SNMPv2* 3 reserved for SNMPv3', NULL, 'INTEGER(0 .. 2147483647)', 'current', NULL, 33);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (102, 'FlowMonitorAlarmGroupIdentifier', 'This textual convention denotes an arbitrary integer-value that uniquely identifies an alarm group. An alarm group represents an alarm condition that the device raises if a configured number of traffic flows in a configured set of traffic flows asserts a given standing condition.', NULL, 'Unsigned32 (1..4294967295)', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (57, 'SnmpAdminString', 'An octet string containing administrative information, preferably in human-readable form.  To facilitate internationalization, this information is represented using the ISO/IEC IS 10646-1 character set, encoded as an octet string using the UTF-8 transformation format described in [RFC2279].  Since additional code points are added by amendments to the 10646 standard from time to time, implementations must be prepared to encounter any code point from 0x00000000 to 0x7fffffff. Byte sequences that do not correspond to the valid UTF-8 encoding of a code point or are outside this range are prohibited.  The use of control codes should be avoided.  When it is necessary to represent a newline, the control code sequence CR LF should be used.   The use of leading or trailing white space should be avoided.  For code points not directly supported by user interface hardware or software, an alternative means of entry and display, such as hexadecimal, may be provided.  For information encoded in 7-bit US-ASCII, the UTF-8 encoding is identical to the US-ASCII encoding.  UTF-8 may require multiple bytes to represent a single character / code point; thus the length of this object in octets may be different from the number of characters encoded. Similarly, size constraints refer to the number of encoded octets, not the number of characters represented by an encoding.  Note that when this TC is used for an object that is used or envisioned to be used as an index, then a SIZE restriction MUST be specified so that the number of sub-identifiers for any object instance does not exceed the limit of 128, as defined by [RFC3416].  Note that the size of an SnmpAdminString object is measured in octets, not characters.', NULL, 'OCTET STRING (SIZE (0..255))', 'current', NULL, 33);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (118, 'PhysicalIndex', 'An arbitrary value which uniquely identifies the physical entity. The value is a small positive integer; index values for different physical entities are not necessarily contiguous.', NULL, 'INTEGER (1..2147483647)', 'current', NULL, 82);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (59, 'ManagementDomainIndex', 'An arbitrary integer-value to uniquely identify a management domain on the local system.', NULL, 'INTEGER (1..255)', 'current', NULL, 37);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (60, 'OwnerString', 'This data type is used to model an administratively assigned name of the owner of a resource. This information is taken from the NVT ASCII character set. It is suggested that this name contain one or more of the following: IP address, management station name, network manager''s name, location, or phone number. In some cases the agent itself will be the owner of an entry. In these cases, this string shall be set to a string starting with ''monitor''.  This definition is identical to that contained in RFC 1271.', NULL, 'OCTET STRING', 'current', NULL, 37);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (61, 'VlanType', 'The type of a VLAN.  Note that the ''ethernet'' type, is used for any ethernet or 802.3 VLAN, including an ATM Ethernet ELAN; and the ''tokenRing'' (''trCrf'') type is used for each VLAN representing a single logical 802.5 ring including an ATM Token-Ring ELAN.  The ''trCrf'' type is used for token ring VLANs made up of (at most) one transparently bridged LAN segment.  The ''trBrf'' type is used for VLANs which represent the scope of many ''trCrf'' VLANs all connected together via source route bridging. The token ring ''trBrf'' can be said to represent the bridged broadcast domain.', NULL, 'INTEGER { ethernet(1), fddi(2), tokenRing(3), fddiNet(4), trNet(5), deprecated(6) }', 'current', NULL, 37);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (62, 'VlanTypeExt', 'The additional type information of VLAN.  vtpmanageable(0) An user defined VLAN which is manageable through VTP protocol. internal(1) An internal VLAN created by the device. Internal VLAN can not be created or deleted. Configuration of an internal VLAN is read only. reserved(2) A VLAN reserved by the device. Reserved VLAN can not be created or deleted. Configuration of an reserved VLAN is read only.', NULL, 'OCTET STRING(SIZE(1))', 'current', NULL, 37);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (63, 'CiscoEnvMonState', 'Represents the state of a device being monitored. Valid values are:  normal(1): the environment is good, such as low temperature.  warning(2): the environment is bad, such as temperature above normal operation range but not too high.  critical(3): the environment is very bad, such as temperature much higher than normal operation limit.  shutdown(4): the environment is the worst, the system should be shutdown immediately.  notPresent(5): the environmental monitor is not present, such as temperature sensors do not exist.  notFunctioning(6): the environmental monitor does not function properly, such as a temperature sensor generates a abnormal data like 1000 C.', NULL, 'INTEGER { normal(1), warning(2), critical(3), shutdown(4), notPresent(5), notFunctioning(6) }', 'current', NULL, 39);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (64, 'CiscoSignedGauge', 'Represents the current value of an entity, as a signed integer.', NULL, 'Integer32', 'current', NULL, 39);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (65, 'InetAddressType', 'A value that represents a type of Internet address.  unknown(0) An unknown address type. This value MUST be used if the value of the corresponding InetAddress object is a zero-length string. It may also be used to indicate an IP address that is not in one of the formats defined below.  ipv4(1) An IPv4 address as defined by the InetAddressIPv4 textual convention.  ipv6(2) An IPv6 address as defined by the InetAddressIPv6 textual convention.  ipv4z(3) A non-global IPv4 address including a zone index as defined by the InetAddressIPv4z textual convention.  ipv6z(4) A non-global IPv6 address including a zone index as defined by the InetAddressIPv6z textual convention.  dns(16) A DNS domain name as defined by the InetAddressDNS textual convention.  Each definition of a concrete InetAddressType value must be accompanied by a definition of a textual convention for use with that InetAddressType.  To support future extensions, the InetAddressType textual convention SHOULD NOT be sub-typed in object type definitions. It MAY be sub-typed in compliance statements in order to require only a subset of these address types for a compliant implementation.  Implementations must ensure that InetAddressType objects and any dependent objects (e.g., InetAddress objects) are consistent. An inconsistentValue error must be generated if an attempt to change an InetAddressType object would, for example, lead to an undefined InetAddress value. In   particular, InetAddressType/InetAddress pairs must be changed together if the address type changes (e.g., from ipv6(2) to ipv4(1)).', NULL, 'INTEGER { unknown(0), ipv4(1), ipv6(2), ipv4z(3), ipv6z(4), dns(16) }', 'current', NULL, 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (66, 'InetAddress', 'Denotes a generic Internet address.  An InetAddress value is always interpreted within the context of an InetAddressType value. Every usage of the InetAddress textual convention is required to specify the InetAddressType object that provides the context. It is suggested that the InetAddressType object be logically registered before the object(s) that use the InetAddress textual convention, if they appear in the same logical row.  The value of an InetAddress object must always be consistent with the value of the associated InetAddressType object. Attempts to set an InetAddress object to a value inconsistent with the associated InetAddressType must fail with an inconsistentValue error.  When this textual convention is used as the syntax of an index object, there may be issues with the limit of 128 sub-identifiers specified in SMIv2, STD 58. In this case, the object definition MUST include a ''SIZE'' clause to limit the number of potential instance sub-identifiers; otherwise the applicable constraints MUST be stated in the appropriate conceptual row DESCRIPTION clauses, or in the surrounding documentation if there is no single DESCRIPTION clause that is appropriate.', NULL, 'OCTET STRING (SIZE (0..255))', 'current', NULL, 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (67, 'InetAddressIPv4', 'Represents an IPv4 network address:   Octets Contents Encoding 1-4 IPv4 address network-byte order  The corresponding InetAddressType value is ipv4(1).  This textual convention SHOULD NOT be used directly in object definitions, as it restricts addresses to a specific format. However, if it is used, it MAY be used either on its own or in conjunction with InetAddressType, as a pair.', NULL, 'OCTET STRING (SIZE (4))', 'current', NULL, 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (68, 'InetAddressIPv6', 'Represents an IPv6 network address:  Octets Contents Encoding 1-16 IPv6 address network-byte order  The corresponding InetAddressType value is ipv6(2).  This textual convention SHOULD NOT be used directly in object definitions, as it restricts addresses to a specific format. However, if it is used, it MAY be used either on its own or in conjunction with InetAddressType, as a pair.', NULL, 'OCTET STRING (SIZE (16))', 'current', NULL, 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (69, 'InetAddressIPv4z', 'Represents a non-global IPv4 network address, together with its zone index:  Octets Contents Encoding 1-4 IPv4 address network-byte order 5-8 zone index network-byte order  The corresponding InetAddressType value is ipv4z(3).  The zone index (bytes 5-8) is used to disambiguate identical address values on nodes that have interfaces attached to different zones of the same scope. The zone index may contain the special value 0, which refers to the default zone for each scope.  This textual convention SHOULD NOT be used directly in object   definitions, as it restricts addresses to a specific format. However, if it is used, it MAY be used either on its own or in conjunction with InetAddressType, as a pair.', NULL, 'OCTET STRING (SIZE (8))', 'current', NULL, 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (70, 'InetAddressIPv6z', 'Represents a non-global IPv6 network address, together with its zone index:  Octets Contents Encoding 1-16 IPv6 address network-byte order 17-20 zone index network-byte order  The corresponding InetAddressType value is ipv6z(4).  The zone index (bytes 17-20) is used to disambiguate identical address values on nodes that have interfaces attached to different zones of the same scope. The zone index may contain the special value 0, which refers to the default zone for each scope.  This textual convention SHOULD NOT be used directly in object definitions, as it restricts addresses to a specific format. However, if it is used, it MAY be used either on its own or in conjunction with InetAddressType, as a pair.', NULL, 'OCTET STRING (SIZE (20))', 'current', NULL, 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (71, 'InetAddressDNS', 'Represents a DNS domain name. The name SHOULD be fully qualified whenever possible.  The corresponding InetAddressType is dns(16).  The DESCRIPTION clause of InetAddress objects that may have InetAddressDNS values MUST fully describe how (and when) these names are to be resolved to IP addresses.  The resolution of an InetAddressDNS value may require to query multiple DNS records (e.g., A for IPv4 and AAAA for IPv6). The order of the resolution process and which DNS record takes precedence depends on the configuration of the resolver.   This textual convention SHOULD NOT be used directly in object definitions, as it restricts addresses to a specific format. However, if it is used, it MAY be used either on its own or in conjunction with InetAddressType, as a pair.', NULL, 'OCTET STRING (SIZE (1..255))', 'current', NULL, 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (72, 'InetAddressPrefixLength', 'Denotes the length of a generic Internet network address prefix. A value of n corresponds to an IP address mask that has n contiguous 1-bits from the most significant bit (MSB), with all other bits set to 0.  An InetAddressPrefixLength value is always interpreted within the context of an InetAddressType value. Every usage of the InetAddressPrefixLength textual convention is required to specify the InetAddressType object that provides the context. It is suggested that the InetAddressType object be logically registered before the object(s) that use the InetAddressPrefixLength textual convention, if they appear in the same logical row.  InetAddressPrefixLength values larger than the maximum length of an IP address for a specific InetAddressType are treated as the maximum significant value applicable for the InetAddressType. The maximum significant value is 32 for the InetAddressType ''ipv4(1)'' and ''ipv4z(3)'' and 128 for the InetAddressType ''ipv6(2)'' and ''ipv6z(4)''. The maximum significant value for the InetAddressType ''dns(16)'' is 0.  The value zero is object-specific and must be defined as part of the description of any object that uses this syntax. Examples of the usage of zero might include situations where the Internet network address prefix is unknown or does not apply.  The upper bound of the prefix length has been chosen to be consistent with the maximum size of an InetAddress.', NULL, 'Unsigned32 (0..2040)', 'current', NULL, 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (73, 'InetPortNumber', 'Represents a 16 bit port number of an Internet transport   layer protocol. Port numbers are assigned by IANA. A current list of all assignments is available from <http://www.iana.org/>.  The value zero is object-specific and must be defined as part of the description of any object that uses this syntax. Examples of the usage of zero might include situations where a port number is unknown, or when the value zero is used as a wildcard in a filter.', NULL, 'Unsigned32 (0..65535)', 'current', 'STD 6 (RFC 768), STD 7 (RFC 793) and RFC 2960', 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (74, 'InetAutonomousSystemNumber', 'Represents an autonomous system number that identifies an Autonomous System (AS). An AS is a set of routers under a single technical administration, using an interior gateway protocol and common metrics to route packets within the AS, and using an exterior gateway protocol to route packets to other ASes''. IANA maintains the AS number space and has delegated large parts to the regional registries.  Autonomous system numbers are currently limited to 16 bits (0..65535). There is, however, work in progress to enlarge the autonomous system number space to 32 bits. Therefore, this textual convention uses an Unsigned32 value without a range restriction in order to support a larger autonomous system number space.', NULL, 'Unsigned32', 'current', 'RFC 1771, RFC 1930', 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (75, 'InetScopeType', 'Represents a scope type. This textual convention can be used in cases where a MIB has to represent different scope types and there is no context information, such as an InetAddress object, that implicitly defines the scope type.  Note that not all possible values have been assigned yet, but they may be assigned in future revisions of this specification. Applications should therefore be able to deal with values not yet assigned.', NULL, 'INTEGER { interfaceLocal(1), linkLocal(2), subnetLocal(3), adminLocal(4), siteLocal(5), organizationLocal(8), global(14) }', 'current', 'RFC 3513', 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (76, 'InetZoneIndex', 'A zone index identifies an instance of a zone of a specific scope.  The zone index MUST disambiguate identical address values. For link-local addresses, the zone index will typically be the interface index (ifIndex as defined in the IF-MIB) of the interface on which the address is configured.  The zone index may contain the special value 0, which refers to the default zone. The default zone may be used in cases where the valid zone index is not known (e.g., when a management application has to write a link-local IPv6 address without knowing the interface index value). The default zone SHOULD NOT be used as an easy way out in cases where the zone index for a non-global IPv6 address is known.', NULL, 'Unsigned32', 'current', 'RFC4007', 41);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (103, 'FlowSetIdentifier', 'This textual convention denotes an arbitrary integer-value that uniquely identifies a set of traffic flows.', NULL, 'Unsigned32 (1..4294967295)', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (78, 'SyslogSeverity', 'The severity of a syslog message. The enumeration values are equal to the values that syslog uses + 1. For example, with syslog, emergency=0.  ''emergency'' : system is unusable ''alert'' : action must be taken immediately ''critical'' : critical conditions ''error'' : error conditions ''warning'' : warning conditions ''notice'' : normal but significant condition ''informational'': informational messages ''debug'' : debug-level messages.', NULL, 'INTEGER { emergency(1), alert(2), critical(3), error(4), warning(5), notice(6), info(7), debug(8) }', 'current', 'RFC 3164, Section 4.1 - syslog Message Parts', 42);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (79, 'DistinguishedName', 'A Distinguished Name represented in accordance with RFC 2253, presented in the UTF-8 charset defined in RFC 2279.', NULL, 'OCTET STRING (SIZE (0..255))', 'current', NULL, 44);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (80, 'URLString', 'A Uniform Resource Locator represented in accordance with RFCs 1738 and 2368, presented in the NVT ASCII charset defined in RFC 854.', NULL, 'OCTET STRING (SIZE (0..255))', 'current', NULL, 44);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (81, 'RunState', 'This TC describes the current execution state of a running application or process. The possible values are: running(1), runnable(2), - waiting for a resource (CPU, etc.) waiting(3), - waiting for an event exiting(4), other(5) - other invalid state', NULL, 'INTEGER { running (1), runnable (2), waiting (3), exiting (4), other (5) }', 'current', NULL, 50);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (82, 'LongUtf8String', 'To facilitate internationalization, this TC represents information taken from the ISO/IEC IS 10646-1 character set, encoded as an octet string using the UTF-8 character encoding scheme described in RFC 2044 [10]. For strings in 7-bit US-ASCII, there is no impact since the UTF-8 representation is identical to the US-ASCII encoding.', NULL, 'OCTET STRING (SIZE (0..1024))', 'current', NULL, 50);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (83, 'Utf8String', 'To facilitate internationalization, this TC represents information taken from the ISO/IEC IS 10646-1 character set, encoded as an octet string using the UTF-8 character encoding scheme described in RFC 2044 [10]. For strings in 7-bit US-ASCII, there is no impact since the UTF-8 representation is identical to the US-ASCII encoding.', NULL, 'OCTET STRING (SIZE (0..255))', 'current', NULL, 50);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (86, 'FlowMonitorIdentifier', 'This textual convention denotes an arbitrary integer-value that uniquely identifies a flow monitor.', NULL, 'Unsigned32 (1..4294967295)', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (87, 'FlowIdentifier', 'This textual convention denotes an arbitrary integer-value that uniquely identifies a traffic flow within the scope of the flow monitor that collects data and periodically computes metrics for the traffic flow.', NULL, 'Unsigned32 (1..4294967295)', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (88, 'FlowPointType', 'This textual convention denotes an enumerated integer-value that represents a point at which a flow monitor collects data for a traffic flow:  ''other'' The implementation of the MIB module using this textual convention does not recognize the flow point.  ''unknown'' The device is unable to ascertain the point at which the flow monitor collects data for the traffic flow.  ''none'' There is no point at which the flow monitor collects data for the traffic flow.  ''interface'' The flow point is an interface represented by a row in the ifTable (defined by the IF-MIB [RFC2863].  ''dot1qVlan'' The flow point is an IEEE 802.1q VLAN represented by a row in the ifTable (defined by the IF-MIB [RFC2863]) and a tag representing the VLAN.  With the exception of the values ''unknown'' and ''none'', each definition of a concrete FlowPointType value MUST have a corresponding textual convention for use with the particular type of flow point.  To support future extensions, a MIB module SHOULD NOT sub-type the FlowPointType textual convention in an object type definition. However, a compliance statement MAY sub-type it in order to require only a subset of the flow point types for a compliant implementation.  Implementations must ensure that FlowPointType objects and any dependent objects (e.g., FlowPointIdentifier objects) are consistent. For example, an implementation must respond with an ''inconsistentValue'' error if an attempt is made to modify a FlowPointType object without changing the corresponding FlowPointIdentifier object.', NULL, 'INTEGER { other(1), unknown(2), none(3), interface(4), dot1qVlan(5) }', 'current', 'K. McCloghrie and F. Kastenholz, ''The Interfaces Group MIB'', RFC-2863, June 2000.', 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (89, 'FlowPointIdentifier', 'This textual convention denotes an octet string-value that identifies a point at which a flow monitor collects data for a traffic flow.  An implementation MUST ALWAYS interpret a FlowPointIdentifier value within the context of a FlowPointType value. Every use of the FlowPointIdentifier textual convention requires the specification of a FlowPointType object to provide the context. A MIB module SHOULD logically register the FlowPointType object before the FlowPointIdentifier object(s).  The value of a FlowPointIdentifier object MUST BE the null string if the value of the FlowPointType object providing the context is ''unknown'' or ''none''.  Implementations must ensure that a FlowPointIdentifier object remains consistent with the FlowPointType object providing the context. For example, an implementation must respond with an ''inconsistentValue'' error if an attempt is made to modify a FlowPointIdentifier object without changing the corresponding FlowPointType object.', NULL, 'OCTET STRING (SIZE (0..255))', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (90, 'FlowPointInterface', 'This textual convention denotes an octet string-value identifying a row in ifTable (defined by the IF-MIB [RFC2863]).  Octets Contents Encoding ========================================= 1-4 ifIndex-value network-byte order  The corresponding FlowPointType value is ''interface''.  A MIB module SHOULD NOT directly use this textual convention in defining object, as it restricts flow points to specific type. However, if a MIB module does chose to directly use the textual convention, it MAY chose to do so without a FlowPointType object to define the context, since this textual convention implies the context.', NULL, 'OCTET STRING (SIZE (4))', 'current', 'K. McCloghrie and F. Kastenholz, ''The Interfaces Group MIB'', RFC-2863, June 2000.', 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (91, 'FlowPointDot1qVlan', 'This textual convention denotes an octet string-value identifying an IEEE 802.1q VLAN.  Octets Contents Encoding ========================================= 1-4 ifIndex-value network-byte order 5-6 VLAN tag network-byte order  The corresponding FlowPointType value is ''dot1qVlan''.  A MIB module SHOULD NOT directly use this textual convention in defining object, as it restricts flow points to specific type. However, if a MIB module does chose to directly use the textual convention, it MAY chose to do so without a FlowPointType object to define the context, since this textual convention implies the context.', NULL, 'OCTET STRING (SIZE (6))', 'current', 'K. McCloghrie and F. Kastenholz, ''The Interfaces Group MIB'', RFC-2863, June 2000.', 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (119, 'PhysicalClass', 'An enumerated value which provides an indication of the general hardware type of a particular physical entity.', NULL, 'INTEGER { other(1), unknown(2), chassis(3), backplane(4), container(5), powerSupply(6), fan(7), sensor(8), module(9), port(10) }', 'current', NULL, 82);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (104, 'ReportCurrentCount', 'An integer-value representing a counter associated with measurement in the current report interval. The length of the report interval is configured previous to the measurement. The value of this counter starts from ''0'' and increases when associated events occur, until the end of the report interval. At that time, the system optionally stores the value of the counter in the first history interval, after which the value of the counter is set to ''0''.', NULL, 'Gauge32', 'current', NULL, 55);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (92, 'FlowMetrics', 'This textual convention denotes an enumerated integer-value that represents a set of metrics:  ''mdi'' This set of metrics consists of the Media Delivery Index (MDI) [RFC4445]  ''rtp'' This set of metrics consists of data similar to that computed and sent by a RTP client in a RTCP receiver report [RFC3550].  ''ipCbr'' This set of metrics complements MDI, measuring the notion of Media Rate Variation (MRV).', NULL, 'BITS { mdi(0), rtp(1), ipCbr(2) }', 'current', 'H. Schulzrinne, S. Casner, R. Fredrick, and V. Jacobson, ''RTP: A Transport Protocol for Real-Time Applications'', RFC-3550, July 2003.  J. Welch and J. Clark, ''A Proposed Media Delivery Index (MDI)'', RFC-4445, APril 2006.', 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (93, 'FlowCfgRateType', 'This textual convention denotes an enumerated integer-value that represents the media rate used by the flow monitor to compute the delay factor for a traffic flow:  ''auto'' The device automatically determines the media rate.  ''ipPktRate'' The device uses a configured media rate expressed as an IP packet rate.  ''ipBitRate'' The device uses a configured media rate expressed as an IP packet rate.  ''mediaRate'' The device uses a configured media rate expressed as a media bit rate.', NULL, 'INTEGER { auto(1), ipPktRate(2), ipBitRate(3), mediaRate(4) }', 'current', 'J. Welch and J. Clark, ''A Proposed Media Delivery Index (MDI)'', RFC-4445, APril 2006.', 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (94, 'FlowBitRateUnits', 'This textual convention denotes an enumerated integer-value that represents the units used when presenting a bit rate value.  ''bps'' The device presents the rate of a traffic flow in bits per second (bps).  ''kbps'' The device presents the rate of a traffic flow in Kbps.  ''mbps'' The device presents the rate of a traffic flow in Mbps.  ''gbps'' The device presents the rate of a traffic flow in Gbps.', NULL, 'INTEGER { bps(1), kbps(2), mbps(3), gbps(4) }', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (95, 'FlowMetricScale', 'This textual convention denotes an enumerated integer-value that represents an International System of Units (SI) prefix used as a scaling factor for fixed-point values:  Prefix Scale Factor ========================= ''yocto'' 10E-24 ''zepto'' 10E-21 ''atto'' 10E-18 ''femto'' 10E-15 ''pico'' 10E-12 ''nano'' 10E-9 ''micro'' 10E-6 ''milli'' 10E-3 ''units'' 10E0 ''kilo'' 10E3 ''mega'' 10E6 ''giga'' 10E9 ''tera'' 10E12 ''exa'' 10E15 ''peta'' 10E18 ''zetta'' 10E21 ''yotta'' 10E24  A MIB module may abstract a fixed-point value by defining three objects together:  1) A FlowMetricScale object, which indicates the scale of the value.  2) A FlowMetricPrecision object, which indicates the precision of the value. In the case that the value has a fractional portion, this object indicates the number of digits comprising the fractional portion.  3) A FlowMetricValue object, which indicates the value before scaling.', NULL, 'INTEGER { yocto(1), zepto(2), atto(3), femto(4), pico(5), nano(6), micro(7), milli(8), units(9), kilo(10), mega(11), giga(12), tera(13), exa(14), peta(15), zetta(16), yotta(17) }', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (96, 'FlowMetricPrecision', 'This textual convention denotes the precision or accuracy of a fixed-point value.  A MIB module may abstract a fixed-point value by defining three objects together:  1) A FlowMetricScale object, which indicates the scale of the value.  2) A FlowMetricPrecision object, which indicates the precision of the value. In the case that the value has a fractional portion, this object indicates the number of digits comprising the fractional portion.  3) A FlowMetricValue object, which indicates the value before scaling.  If an instance of an object of this type has a value in the range of 1 to 9, then it represents the precision of the associated value; that is, the number of decimal places in the fractional part of the associated value. For example, if the Media Loss Rate (MLR) computed for a traffic flow is 350.9E-6, then the FlowMetricScale object is ''micro'', the FlowMetricPrecision object is 1, and the object indicating the value is 3509.  If an instance of an object of this type has a value in the range of -8 to -1, then it represents the number of accurate digits in the associated value. For example, if the jitter measured for a traffic flow can range between -100,000 and 100,000 microseconds in 10 microsecond increments, with an accuracy of +/- 5 microseconds, the FlowMetricScale object is ''micro'', the FlowMetricPrecision object is -2, and the object indicating the value has range of -100,000 to 100,000.', NULL, 'Integer32 (-8..-1 | 1..9)', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (97, 'FlowMetricValue', 'This textual convention denotes the value of a fixed-point value.  A MIB module may abstract a fixed-point value by defining three objects together:  1) A FlowMetricScale object, which indicates the scale of the value.  2) A FlowMetricPrecision object, which indicates the precision of the value. In the case that the value has a fractional portion, this object indicates the number of digits comprising the fractional portion.  3) A FlowMetricValue object, which indicates the value before scaling.', NULL, 'Integer32 (-1000000000..1000000000)', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (98, 'FlowMonitorConditions', 'This textual convention denotes a octet string-value that represents the standing conditions associated with an entity, such as a flow monitor a traffic flow.  Each bit in the string corresponds to a single standing condition. The device should present a description of the standing condition in the cfmConditionTable, which uniquely identifies such a description by the following tuple:  [cfmConditionProfile, cfmConditionId]  where cfmConditionProfile uniquely identifies the conditions profile containing the description and cfmConditionId corresponds to the bit position within the string. The figure below illustrates a representation of the string containing N octets:  Octet 0 Octet N-1 7 6 5 4 3 2 1 0 7 6 5 4 3 2 1 0 +-+-+-+-+-+-+-+-+ +-+-+-+-+-+-+-+-+ | |...| | +-+-+-+-+-+-+-+-+ +-+-+-+-+-+-+-+-+ | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | +- Condition 8(n-1) | | | | | | | | | | | | | | + | | | | | | | | | | | | | +- Condition 8(n-1)+2 | | | | | | | | | | | | +--- Condition 8(n-1)+3 | | | | | | | | | | | +----- Condition 8(n-1)+4 | | | | | | | | | | +------- Condition 8(n-1)+5 | | | | | | | | | +--------- Condition 8(n-1)+6 | | | | | | | | +----------- Condition 8(n-1)+7 | | | | | | | | : | | | | | | | | : | | | | | | | +----------------- Condition 0 | | | | | | +------------------- Condition 1 | | | | | +--------------------- Condition 2 | | | | +----------------------- Condition 3 | | | +------------------------- Condition 4 | | +--------------------------- Condition 5 | +----------------------------- Condition 6 +------------------------------- Condition 7', NULL, 'OCTET STRING (SIZE (0..255))', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (99, 'FlowMonitorConditionsProfile', 'This textual convention denotes an arbitrary integer-value that uniquely identifies a conditions profile. A conditions profile is a set of descriptions of standing/alarm conditions that can be applied to an entity, such as a flow alarm or a traffic flow.', NULL, 'Unsigned32 (1..4294967295)', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (100, 'FlowMonitorConditionsProfileOrZero', 'This textual convention serves as an extension of the FlowMonitorConditionsProfile textual convention, which permits the value ''0''. The use of the value ''0'' is specific to an object, thus requiring the descriptive text associated with the object to describe the semantics of its use.', NULL, 'Unsigned32 (0..4294967295)', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (101, 'FlowMonitorConditionIdentifier', 'This textual convention denotes an integer-value representing a standing/alarm condition within a conditions profile. It has a direct correspondence to the position of the bit representing the standing/alarm condition in a FlowMonitorConditions object.', NULL, 'Unsigned32 (0..2039)', 'current', NULL, 54);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (105, 'ReportIntervalCount', 'An integer-value representing the value of a counter associated with the measurement taken during a previous report interval. An implementation supporting a history of N report intervals with IntervalCount(1) and IntervalCount(N) representing the most and least recent intervals, respectively, the following applies at the end of each report interval:  - Discards the value of IntervalCount(N).  - The value of IntervalCount(i) becomes that of IntervalCount(i-1) for N >= i > 1.  - The value of IntervalCount(1) becomes that of CurrentCount.', NULL, 'Gauge32', 'current', NULL, 55);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (106, 'BridgeId', 'The Bridge-Identifier, as used in the Spanning Tree Protocol, to uniquely identify a bridge. Its first two octets (in network byte order) contain a priority value, and its last 6 octets contain the MAC address used to refer to a bridge in a unique fashion (typically, the numerically smallest MAC address of all ports on the bridge).', NULL, 'OCTET STRING (SIZE (8))', 'current', NULL, 56);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (107, 'Timeout', 'A Spanning Tree Protocol (STP) timer in units of 1/100 seconds. Several objects in this MIB module represent values of timers used by the Spanning Tree Protocol. In this MIB, these timers have values in units of hundredths of a second (i.e., 1/100 secs).  These timers, when stored in a Spanning Tree Protocol''s BPDU, are in units of 1/256 seconds. Note, however, that 802.1D-1998 specifies a settable granularity of no more than one second for these timers. To avoid ambiguity, a conversion algorithm is defined below for converting between the different units, which ensures a timer''s value is not distorted by multiple conversions.  To convert a Timeout value into a value in units of 1/256 seconds, the following algorithm should be used:  b = floor( (n * 256) / 100)  where: floor = quotient [ignore remainder] n is the value in 1/100 second units b is the value in 1/256 second units  To convert the value from 1/256 second units back to 1/100 seconds, the following algorithm should be used:  n = ceiling( (b * 100) / 256)  where: ceiling = quotient [if remainder is 0], or quotient + 1 [if remainder is nonzero] n is the value in 1/100 second units  b is the value in 1/256 second units  Note: it is important that the arithmetic operations are done in the order specified (i.e., multiply first, divide second).', NULL, 'Integer32', 'current', NULL, 56);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (108, 'EnabledStatus', 'A simple status value for the object.', NULL, 'INTEGER { enabled(1), disabled(2) }', 'current', NULL, 58);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (109, 'ZeroBasedCounter32', 'This TC describes an object which counts events with the following semantics: objects of this type will be set to zero(0) on creation and will thereafter count appropriate events, wrapping back to zero(0) when the value 2^32 is reached.  Provided that an application discovers the new object within the minimum time to wrap it can use the initial value as a delta since it last polled the table of which this object is part. It is important for a management station to be aware of this minimum time and the actual time between polls, and to discard data if the actual time is too long or there is no defined minimum time.  Typically this TC is used in tables where the INDEX space is constantly changing and/or the TimeFilter mechanism is in use.', NULL, 'Gauge32', 'current', NULL, 77);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (110, 'LastCreateTime', 'This TC describes an object that stores the last time its entry was created.  This can be used for polling applications to determine that an entry has been deleted and re-created between polls, causing an otherwise undetectable discontinuity in the data.', NULL, 'TimeStamp', 'current', NULL, 77);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (111, 'TimeFilter', 'To be used for the index to a table. Allows an application to download only those rows changed since a particular time. A row is considered changed if the value of any object in the row changes or if the row is created or deleted.  When sysUpTime is equal to zero, this table shall be empty.  One entry exists for each past value of sysUpTime, except that the whole table is purged should sysUpTime wrap.  As this basic row is updated new conceptual rows are created (which still share the now updated object values with all other instances). The number of instances which are created is determined by the value of sysUpTime at which the basic row was last updated. One instance will exist for each value of sysUpTime at the last update time for the row. A new timeMark instance is created for each new sysUpTime value. Each new conceptual row will be associated with the timeMark instance which was created at the value of sysUpTime with which the conceptual row is to be associated.  By definition all conceptual rows were updated at or after time zero and so at least one conceptual row (associated with timeMark.0) must exist for each underlying (basic) row.  See the appendix for further discussion of this variable.  Consider the following fooTable:  fooTable ... INDEX { fooTimeMark, fooIndex }  FooEntry { fooTimeMark TimeFilter fooIndex INTEGER, fooCounts Counter }  Should there be two basic rows in this table (fooIndex == 1, fooIndex == 2) and row 1 was updated most recently at time 6, while row 2 was updated most recently at time 8, and both rows had been updated on several earlier occasions such that the current values were 5 and 9 respectively then the following fooCounts instances would exist.  fooCounts.0.1 5 fooCounts.0.2 9 fooCounts.1.1 5      fooCounts.1.2 9 fooCounts.2.1 5 fooCounts.2.2 9 fooCounts.3.1 5 fooCounts.3.2 9 fooCounts.4.1 5 fooCounts.4.2 9 fooCounts.5.1 5 fooCounts.5.2 9 fooCounts.6.1 5 fooCounts.6.2 9 fooCounts.7.2 9 fooCounts.8.2 9 SYNTAX TimeTicks  DataSource ::= TEXTUAL-CONVENTION STATUS current DESCRIPTION "Identifies the source of the data that the associated function is configured to analyze. This source can be any interface on this device.  In order to identify a particular interface, this object shall identify the instance of the ifIndex object, defined in [3,5], for the desired interface.  For example, if an entry were to receive data from interface #1, this object would be set to ifIndex.1."                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             ControlString ::= TEXTUAL-CONVENTION STATUS current DESCRIPTION "This data type is used to communicate with a modem or a serial data switch. A ControlString contains embedded commands to control how the device will interact with the remote device through the serial interface. Commands are represented as two character sequences beginning with the `^'' character.  The following commands are recognized by the device (note that command characters are case sensitive):  ^s Send string that follows which is terminated by the next command or the end of string. ^c Delay for the number of seconds that follows. Toss out any data received rather than storing it in a buffer for parsing. ^t Set timeout to the value represented by the decimal digits that follow. The default timeout is 20 seconds. Note that this timeout may be overridden by a smaller serialTimeout configured for the      associated serial interface (see serialConfigTable). ^w Wait for the reply string that follows which is terminated by the next command or the end of string. Partial and case insensitive matching is applied, ie. if the reply string (any case combination) is found anywhere in the received string, then the a match is found. If the current timeout elapses without a match, then the remaining control string is ignored. ^! The ^ character. ^d Delay the number of seconds specified by the decimal digits that follow. ^b Send break for the number of milliseconds specified by the decimal digits that follow. If no digits follow, break will be enforced for 250 milliseconds by default.  The following ASCII control characters may be inserted into the `^s'' send string or the `^w'' reply string:  ^@ 0x00 ^A 0x01 .. ^M 0x0D .. ^Z 0x1A ^[ 0x1B ^ 0x1C ^] 0x1D ^^ 0x1E ^_ 0x1F  Binary data may also be inserted into the data stream. The control sequence for each byte of binary data is ^0x##, where ## is the hexadecimal representation of the data byte. Two ASCII characters (0-9, a-f, A-F) must follow the `^0x'' control prefix. For example, `^0x0D^0x0A'' is interpreted as a carriage return followed by a line feed.', NULL, 'DisplayString', 'current', NULL, 77);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (112, 'PortList', 'Each octet within this value specifies a set of eight ports, with the first octet specifying ports 1 through 8, the second octet specifying ports 9 through 16, etc. Within each octet, the most significant bit represents the lowest numbered port, and the least significant bit represents the highest numbered port. Thus, each port of the bridge is represented by a single bit within the value of this object. If that bit has a value of ''1'', then that port is included in the set of ports; the port is not included if its bit has a value of ''0''.', NULL, 'OCTET STRING', 'current', NULL, 78);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (113, 'VlanIndex', 'A value used to index per-VLAN tables: values of 0 and 4095 are not permitted. If the value is between 1 and 4094 inclusive, it represents an IEEE 802.1Q VLAN-ID with global scope within a given bridged domain (see VlanId textual convention). If the value is greater than 4095,  then it represents a VLAN with scope local to the particular agent, i.e., one without a global VLAN-ID assigned to it. Such VLANs are outside the scope of IEEE 802.1Q, but it is convenient to be able to manage them in the same way using this MIB.', NULL, 'Unsigned32', 'current', NULL, 78);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (114, 'VlanId', 'The VLAN-ID that uniquely identifies a VLAN. This is the 12-bit VLAN-ID used in the VLAN Tag header. The range is defined by the REFERENCEd specification.', NULL, 'Integer32 (1..4094 )', 'current', 'IEEE Std 802.1Q 2003 Edition, Virtual Bridged Local Area Networks.', 78);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (115, 'VlanIdOrAny', 'The VLAN-ID that uniquely identifies a specific VLAN, or any VLAN. The special value of 4095 is used to indicate a wildcard, i.e., any VLAN. This can be used in any situation where an object or table entry must refer either to a specific VLAN or to any VLAN.  Note that a MIB object that is defined using this TEXTUAL-CONVENTION should clarify the meaning of ''any VLAN'' (i.e., the special value 4095).', NULL, 'Integer32 (1..4094 | 4095 )', 'current', NULL, 78);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (116, 'VlanIdOrNone', 'The VLAN-ID that uniquely identifies a specific VLAN, or no VLAN. The special value of zero is used to indicate that no VLAN-ID is present or used. This can be used in any situation where an object or a table entry must refer either to a specific VLAN, or to no VLAN.  Note that a MIB object that is defined using this TEXTUAL-CONVENTION should clarify the meaning of ''no VLAN'' (i.e., the special value 0).', NULL, 'Integer32 (0 | 1..4094 )', 'current', NULL, 78);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (117, 'VlanIdOrAnyOrNone', 'The VLAN-ID that uniquely identifies a specific VLAN, any VLAN, or no VLAN. The special values 0 and 4095 have the same meaning as described in the VlanIdOrAny and VlanIdOrNone TEXTUAL-CONVENTIONs.  Note that a MIB object that is defined using this TEXTUAL-CONVENTION should clarify the meaning of ''any VLAN'' and ''no VLAN'' (i.e., the special values 0 and 4095).', NULL, 'Integer32 (0 | 1..4094 | 4095 ) -----------------------------------------------------------', 'current', NULL, 78);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (120, 'PacketSource', 'The source of the packet the statistics is for.  input statistics of the input packets. output statistics of the output packets.', NULL, 'INTEGER { input(1), output(2) }', 'current', NULL, 84);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (121, 'NTPTimeStamp', 'NTP timestamps are represented as a 64-bit unsigned fixed-point number, in seconds relative to 00:00 on 1 January 1900. The integer part is in the first 32 bits and the fraction part is in the last 32 bits.', NULL, 'OCTET STRING (SIZE (8))', 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Section 3.1', 85);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (122, 'NTPLeapIndicator', 'This is a two-bit code warning of an impending leap second to be inserted in the NTP timescale. The bits are set before 23:59 on the day of insertion and reset after 00:00 on the following day. This causes the number of seconds (rollover interval) in the day of insertion to be increased or decreased by one. The two bits are coded as below, 00, no warning 01, last minute has 61 seconds 10, last minute has 59 seconds 11, alarm condition (clock not synchronized)', NULL, 'INTEGER { noWarning(0), addSecond(1), subtractSecond(2), alarm(3) }', 'current', 'D.L. Mills, ''Network Time Protocol(Version 3)'', RFC-1305, March 1992, Section 3.2.1', 85);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (123, 'NTPSignedTimeValue', 'The time in seconds that could represent signed quantities like time delay with respect to some source. This textual-convention is specific to Cisco implementation of NTP where 32-bit integers are used for such quantities. The signed integer part is in the first 16 bits and the fraction part is in the last 16 bits.', NULL, 'OCTET STRING (SIZE (4))', 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Sections 2, 3.2.1', 85);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (124, 'NTPUnsignedTimeValue', 'The time in seconds that could represent unsigned quantities like maximum error of the local clock with respect to some source. This textual-convention is specific to Cisco implementation of NTP where 32-bit integers are used for such quantities. The unsigned integer part is in the first 16 bits and the fraction part is in the last 16 bits.', NULL, 'OCTET STRING (SIZE (4))', 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Sections 2, 3.2.1', 85);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (125, 'NTPStratum', 'Indicates the stratum of the clock. The stratum defines the accuracy of a time server. Higher the stratum, lower the accuracy. 0, unspecified 1, primary reference (e.g., calibrated atomic clock, radio clock) 2-255, secondary reference (via NTP)', NULL, 'Integer32 (0..255)', 'current', 'D.L. Mills, ''Network Time Protocol (Version 3)'', RFC-1305, March 1992, Section 2.2', 85);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (126, 'NTPRefId', 'The reference clock identifier. In the case of stratum 0 (unspecified) or stratum 1 (primary reference source), this is a four-octet, left-justified, zero-padded ASCII string as defined in RFC-1305. In the case of stratum 2 and greater (secondary reference) this is the four-octet Internet address of the peer selected for synchronization.  Some examples of stratum 0 identifiers are, DCN, DCN routing protocol NIST, NIST public modem TSP, TSP time protocol DTS, Digital Time Service  Some examples of stratum 1 identifiers are, ATOM, Atomic clock (calibrated) VLF, VLF radio (OMEGA,, etc.) LORC, LORAN-C radionavigation GOES, GOES UHF environment satellite GPS, GPS UHF satellite positioning', NULL, 'OCTET STRING (SIZE (4))', 'current', 'D.L. Mills, Network Time Protocol (Version 3)'', RFC-1305, March 1992, Section 3.2.1', 85);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (127, 'NTPPollInterval', 'The minimum interval between transmitted NTP messages, in seconds as a power of two. For instance, a value of six indicates a minimum interval of 64 seconds.', NULL, 'Integer32 (-20..20)', 'current', NULL, 85);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (128, 'NTPAssocIdentifier', 'The association identifier of the peer. Every peer with which an NTP server is associated with is identified by an association identifier.', NULL, 'Integer32 (0..2147483647)', 'current', NULL, 85);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (129, 'CiscoGauge64', 'This TC describes an object with a nonnegative integer value that may increase or decrease, with a maximum value of 2^64-1.', NULL, 'Counter64', 'current', NULL, 86);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (130, 'ControlStatus', 'This TC describes the current status of a controlled object value.', NULL, 'INTEGER { enabled(1), disabled(2) }', 'current', NULL, 86);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (131, 'McastGroupIp', 'This TC specifies an multicast group IP address, a class D IP address with the first byte in the range of 224 to 239.', NULL, 'IpAddress', 'current', NULL, 86);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (132, 'FlowAddressComponent', 'Represents a network layer address. The length and format of the address is protocol dependent as follows: ip 6 octets first 4 octets are the IP address in network order last 2 bytes is the transport''s port number. ipx 10 octets first 4 octets are the net number last 6 octets are the host number', NULL, 'OCTET STRING (SIZE (6 | 10))', 'current', NULL, 86);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (133, 'CiscoMemoryPoolTypes', 'Represents the different types of memory pools that may be present in a managed device. Memory pools can be roughly categorized into two groups, predefined pools and dynamic pools. The following pool types are currently predefined: 1: processor memory 2: i/o memory 3: pci memory 4: fast memory 5: multibus memory  Dynamic pools will have a pool type value greater than any of the predefined types listed above.  Note that only the processor pool is required to be supported by all devices. Support for other pool types is dependent on the device being managed.', NULL, 'Integer32 (1..65535)', 'current', NULL, 87);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (134, 'PortIndex', 'A unique value, greater than zero, for each character port in the managed system. It is recommended that values are assigned contiguously starting from 1. The value for each interface sub- layer must remain constant at least from one re- initialization of the entity''s network management system to the next re-initialization.  In a system where the character ports are attached to hardware represented by an ifIndex, it is conventional, but not required, to make the character port index equal to the corresponding ifIndex.', NULL, 'Integer32', 'current', NULL, 90);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (147, 'AddressFamilyNumbers', 'The definition of this textual convention with the addition of newly assigned values is published periodically by the IANA, in either the Assigned Numbers RFC, or some derivative of it specific to Internet Network Management number assignments. (The latest arrangements can be obtained by contacting the IANA.)  The enumerations are described as:  other(0), ipV4(1), ipV6(2), nsap(3), hdlc(4), bbn1822(5), all802(6),  e163(7), e164(8), f69(9), x121(10), ipx(11), appleTalk(12), decnetIV(13), banyanVines(14), e164withNsap(15),  dns(16), distinguishedName(17), asNumber(18), xtpOverIpv4(19), xtpOverIpv6(20), xtpNativeModeXTP(21), fibreChannelWWPN(22), fibreChannelWWNN(23), gwid(24), afi(25), reserved(65535)    Requests for new values should be made to IANA via email (iana@iana.org).', NULL, 'INTEGER { other(0), ipV4(1), ipV6(2), nsap(3), hdlc(4), bbn1822(5), all802(6), e163(7), e164(8), f69(9), x121(10), ipx(11), appleTalk(12), decnetIV(13), banyanVines(14), e164withNsap(15), dns(16), distinguishedName(17), asNumber(18), xtpOverIpv4(19), xtpOverIpv6(20), xtpNativeModeXTP(21), fibreChannelWWPN(22), fibreChannelWWNN(23), gwid(24), afi(25), reserved(65535) }', 'current', NULL, 97);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (154, 'LldpSystemCapabilitiesMap', 'This TC describes the system capabilities.  The bit ''other(0)'' indicates that the system has capabilities other than those listed below.  The bit ''repeater(1)'' indicates that the system has repeater capability.  The bit ''bridge(2)'' indicates that the system has bridge capability.  The bit ''wlanAccessPoint(3)'' indicates that the system has WLAN access point capability.  The bit ''router(4)'' indicates that the system has router capability.  The bit ''telephone(5)'' indicates that the system has telephone capability.  The bit ''docsisCableDevice(6)'' indicates that the system has DOCSIS Cable Device capability (IETF RFC 2669 & 2670).  The bit ''stationOnly(7)'' indicates that the system has only station capability and nothing else.', NULL, 'BITS { other(0), repeater(1), bridge(2), wlanAccessPoint(3), router(4), telephone(5), docsisCableDevice(6), stationOnly(7) }', 'current', NULL, 98);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (156, 'LldpPortList', 'Each octet within this value specifies a set of eight ports, with the first octet specifying ports 1 through 8, the second octet specifying ports 9 through 16, etc. Within each octet, the most significant bit represents the lowest numbered port, and the least significant bit represents the highest numbered port. Thus, each port of the system is represented by a single bit within the value of this object. If that bit has a value of ''1'' then that port is included in the set of ports; the port is not included if its bit has a value of ''0''.', NULL, 'OCTET STRING(SIZE(0..512))', 'current', 'IETF RFC 2674 section 5', 98);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (148, 'LldpChassisIdSubtype', 'This TC describes the source of a chassis identifier.  The enumeration ''chassisComponent(1)'' represents a chassis identifier based on the value of entPhysicalAlias object (defined in IETF RFC 2737) for a chassis component (i.e., an entPhysicalClass value of ''chassis(3)'').  The enumeration ''interfaceAlias(2)'' represents a chassis identifier based on the value of ifAlias object (defined in IETF RFC 2863) for an interface on the containing chassis.  The enumeration ''portComponent(3)'' represents a chassis identifier based on the value of entPhysicalAlias object (defined in IETF RFC 2737) for a port or backplane component (i.e., entPhysicalClass value of ''port(10)'' or ''backplane(4)''), within the containing chassis.  The enumeration ''macAddress(4)'' represents a chassis identifier based on the value of a unicast source address (encoded in network byte order and IEEE 802.3 canonical bit order), of a port on the containing chassis as defined in IEEE Std 802-2001.  The enumeration ''networkAddress(5)'' represents a chassis identifier based on a network address, associated with a particular chassis. The encoded address is actually composed of two fields. The first field is a single octet, representing the IANA AddressFamilyNumbers value for the specific address type, and the second field is the network address value.  The enumeration ''interfaceName(6)'' represents a chassis identifier based on the value of ifName object (defined in IETF RFC 2863) for an interface on the containing chassis.  The enumeration ''local(7)'' represents a chassis identifier based on a locally defined value.', NULL, 'INTEGER { chassisComponent(1), interfaceAlias(2), portComponent(3), macAddress(4), networkAddress(5), interfaceName(6), local(7) }', 'current', NULL, 98);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (149, 'LldpChassisId', 'This TC describes the format of a chassis identifier string. Objects of this type are always used with an associated LldpChassisIdSubtype object, which identifies the format of the particular LldpChassisId object instance.  If the associated LldpChassisIdSubtype object has a value of ''chassisComponent(1)'', then the octet string identifies a particular instance of the entPhysicalAlias object (defined in IETF RFC 2737) for a chassis component (i.e., an entPhysicalClass value of ''chassis(3)'').  If the associated LldpChassisIdSubtype object has a value of ''interfaceAlias(2)'', then the octet string identifies a particular instance of the ifAlias object (defined in IETF RFC 2863) for an interface on the containing chassis. If the particular ifAlias object does not contain any values, another chassis identifier type should be used.  If the associated LldpChassisIdSubtype object has a value of ''portComponent(3)'', then the octet string identifies a particular instance of the entPhysicalAlias object (defined in IETF RFC 2737) for a port or backplane component within the containing chassis.  If the associated LldpChassisIdSubtype object has a value of ''macAddress(4)'', then this string identifies a particular unicast source address (encoded in network byte order and IEEE 802.3 canonical bit order), of a port on the containing chassis as defined in IEEE Std 802-2001.  If the associated LldpChassisIdSubtype object has a value of ''networkAddress(5)'', then this string identifies a particular network address, encoded in network byte order, associated with one or more ports on the containing chassis. The first octet contains the IANA Address Family Numbers enumeration value for the specific address type, and octets 2 through N contain the network address value in network byte order.  If the associated LldpChassisIdSubtype object has a value of ''interfaceName(6)'', then the octet string identifies a particular instance of the ifName object (defined in IETF RFC 2863) for an interface on the containing chassis. If the particular ifName object does not contain any values, another chassis identifier type should be used.  If the associated LldpChassisIdSubtype object has a value of ''local(7)'', then this string identifies a locally assigned Chassis ID.', NULL, 'OCTET STRING (SIZE (1..255))', 'current', NULL, 98);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (150, 'LldpPortIdSubtype', 'This TC describes the source of a particular type of port identifier used in the LLDP MIB.  The enumeration ''interfaceAlias(1)'' represents a port identifier based on the ifAlias MIB object, defined in IETF RFC 2863.  The enumeration ''portComponent(2)'' represents a port identifier based on the value of entPhysicalAlias (defined in IETF RFC 2737) for a port component (i.e., entPhysicalClass value of ''port(10)''), within the containing chassis.  The enumeration ''macAddress(3)'' represents a port identifier based on a unicast source address (encoded in network byte order and IEEE 802.3 canonical bit order), which has been detected by the agent and associated with a particular port (IEEE Std 802-2001).  The enumeration ''networkAddress(4)'' represents a port identifier based on a network address, detected by the agent and associated with a particular port.  The enumeration ''interfaceName(5)'' represents a port identifier based on the ifName MIB object, defined in IETF RFC 2863.  The enumeration ''agentCircuitId(6)'' represents a port identifier based on the agent-local identifier of the circuit (defined in RFC 3046), detected by the agent and associated with a particular port.  The enumeration ''local(7)'' represents a port identifier based on a value locally assigned.', NULL, 'INTEGER { interfaceAlias(1), portComponent(2), macAddress(3), networkAddress(4), interfaceName(5), agentCircuitId(6), local(7) }', 'current', NULL, 98);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (151, 'LldpPortId', 'This TC describes the format of a port identifier string. Objects of this type are always used with an associated LldpPortIdSubtype object, which identifies the format of the particular LldpPortId object instance.  If the associated LldpPortIdSubtype object has a value of ''interfaceAlias(1)'', then the octet string identifies a particular instance of the ifAlias object (defined in IETF RFC 2863). If the particular ifAlias object does not contain any values, another port identifier type should be used.  If the associated LldpPortIdSubtype object has a value of ''portComponent(2)'', then the octet string identifies a particular instance of the entPhysicalAlias object (defined in IETF RFC 2737) for a port or backplane component.  If the associated LldpPortIdSubtype object has a value of ''macAddress(3)'', then this string identifies a particular unicast source address (encoded in network byte order and IEEE 802.3 canonical bit order) associated with the port (IEEE Std 802-2001).  If the associated LldpPortIdSubtype object has a value of ''networkAddress(4)'', then this string identifies a network address associated with the port. The first octet contains the IANA AddressFamilyNumbers enumeration value for the specific address type, and octets 2 through N contain the networkAddress address value in network byte order.  If the associated LldpPortIdSubtype object has a value of ''interfaceName(5)'', then the octet string identifies a particular instance of the ifName object (defined in IETF RFC 2863). If the particular ifName object does not contain any values, another port identifier type should be used.  If the associated LldpPortIdSubtype object has a value of ''agentCircuitId(6)'', then this string identifies a agent-local identifier of the circuit (defined in RFC 3046).  If the associated LldpPortIdSubtype object has a value of ''local(7)'', then this string identifies a locally assigned port ID.', NULL, 'OCTET STRING (SIZE (1..255))', 'current', NULL, 98);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (152, 'LldpManAddrIfSubtype', 'This TC describes the basis of a particular type of interface associated with the management address.  The enumeration ''unknown(1)'' represents the case where the interface is not known.  The enumeration ''ifIndex(2)'' represents interface identifier based on the ifIndex MIB object.  The enumeration ''systemPortNumber(3)'' represents interface identifier based on the system port numbering convention.', NULL, 'INTEGER { unknown(1), ifIndex(2), systemPortNumber(3) }', 'current', 'IEEE 802.1AB-2005 9.5.9.5', 98);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (153, 'LldpManAddress', 'The value of a management address associated with the LLDP agent that may be used to reach higher layer entities to assist discovery by network management.  It should be noted that appropriate security credentials, such as SNMP engineId, may be required to access the LLDP agent using a management address. These necessary credentials should be known by the network management and the objects associated with the credentials are not included in the LLDP agent.', NULL, 'OCTET STRING (SIZE (1..31))', 'current', NULL, 98);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (155, 'LldpPortNumber', 'Each port contained in the chassis (that is known to the LLDP agent) is uniquely identified by a port number.  A port number has no mandatory relationship to an InterfaceIndex object (of the interfaces MIB, IETF RFC 2863). If the LLDP agent is a IEEE 802.1D, IEEE 802.1Q bridge, the LldpPortNumber will have the same value as the dot1dBasePort object (defined in IETF RFC 1493) associated corresponding bridge port. If the system hosting LLDP agent is not an IEEE 802.1D or an IEEE 802.1Q bridge, the LldpPortNumber will have the same value as the corresponding interface''s InterfaceIndex object.  Port numbers should be in the range of 1 and 4096 since a particular port is also represented by the corresponding port number bit in LldpPortList.', NULL, 'Integer32(1..4096)', 'current', NULL, 98);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (157, 'CcmIndex', 'This syntax is used as the Index into a table. A positive value is used to identify a unique entry in the table.', NULL, 'Unsigned32 (1..4294967295)', 'current', NULL, 104);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (158, 'CcmIndexOrZero', 'This textual convention is an extension of the CcmIndex convention. The latter defines a greater than zero to identify an entry of the CUCM MIB table in the managed system. This extension permits the additional value of zero. The value zero is object- specific and must be defined as part of the description of any object which uses this syntax.', NULL, 'Unsigned32 (0..4294967295)', 'current', NULL, 104);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (159, 'CcmDevFailCauseCode', 'This syntax is used as means of identifying the reasons for a device communication error. noError: No Error unknown: Unknown error cause noEntryInDatabase: Device not configured properly in the CUCM database databaseConfigurationError: Device configuration error in the CUCM database deviceNameUnresolveable: The CallManager is unable to resolve the device name to an IP Address internally maxDevRegReached: Maximum number of device registrations have been reached connectivityError: CallManager is unable to establish communication with the device during registration initializationError: Indicates an error occurred when the CallManager tries to initialize the device deviceInitiatedReset: Indicates that the error was due to device initiated reset callManagerReset: Indicates that the error was due to call manager reset. authenticationError: Indicates mismatch between configured authentication mode and the authentication mode that the device is using to connect to the CallManager. invalidX509NameInCertificate: Indicates mismatch between the peer X.509 certificate subject name and what is configured for the device. invalidTLSCipher: Indicates Cipher mismatch during TLS handshake process. directoryNumberMismatch: Indicates mismatch between the directory number that the SIP device is trying to register with and the directory number configured in the CallManager for the SIP device. malformedRegisterMsg: Indicates that SIP device attempted to register with CallManager, but the REGISTER message contained formatting errors.', NULL, 'INTEGER { noError(0), unknown(1), noEntryInDatabase(2), databaseConfigurationError(3), deviceNameUnresolveable(4), maxDevRegReached(5), connectivityError(6), initializationError(7), deviceInitiatedReset(8), callManagerReset(9), authenticationError(10), invalidX509NameInCertificate(11), invalidTLSCipher(12), directoryNumberMismatch(13), malformedRegisterMsg(14) }', 'deprecated', NULL, 104);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (160, 'CcmDevRegFailCauseCode', 'This syntax is used as means of identifying the reasons for a device registration failure. The scope of this enumeration can expand to comply with RFC 2578. noError: No Error unknown: Unknown error cause noEntryInDatabase: Device not configured properly in the CUCM database databaseConfigurationError: Device configuration error in the CUCM database deviceNameUnresolveable: The CallManager is unable to resolve the device name to an IP Address internally maxDevRegExceeded: Maximum number of device registrations have been reached connectivityError: CallManager is unable to establish communication with the device during registration initializationError: Indicates an error occurred when the CallManager tries to initialize the device deviceInitiatedReset: Indicates that the error was due to device initiated reset callManagerReset: Indicates that the error was due to call manager reset. authenticationError: Indicates mismatch between configured authentication mode and the authentication mode that the device is using to connect to the CallManager. invalidX509NameInCertificate: Indicates mismatch between the peer X.509 certificate subject name and what is configured for the device. invalidTLSCipher: Indicates Cipher mismatch during TLS handshake process. directoryNumberMismatch: Indicates mismatch between the directory number that the SIP device is trying to register with and the directory number configured in the CallManager for the SIP device. malformedRegisterMsg: Indicates that SIP device attempted to register with CallManager, but the REGISTER message contained formatting errors. protocolMismatch: The protocol of the device (SIP or SCCP) does not match the configured protocol in CUCM. deviceNotActive: The device has not been activated. authenticatedDeviceAlreadyExists: A device with the same name is already registered with CUCM. obsoleteProtocolVersion: The SCCP device registered with an obsolete protocol version. databaseTimeout: CUCM requested device configuration data from the database but did not receive a response within 10 minutes. registrationSequenceError: A device requested configuration information from the CUCM at an unexpected time. The CUCM had not yet obtained the requested information. The device will automatically attempt to register again. If this alarm occurs again, manually reset the device. If this alarm continues to occur after the manual reset, there may be an internal firmware error. This is applicable for SCCP protocol only. invalidCapabilities: The CUCM detected an error in the media capabilities reported in the StationCapabilitiesRes message by the device during registration. The device will automatically attempt to register again. If this alarm occurs again, manually reset the device. If this alarm continues to occur after the manual reset, there may be a protocol error. This is applicable for SCCP protocol only. capabilityResponseTimeout: The CUCM timed out while waiting for the device to respond to a request to report its media capabilities. Possible causes include device power outage, network power outage, network configuration error, network delay, packet drops, and packet corruption. It is also possible to get this error if the CUCM node is experiencing high CPU usage. Verify that the device is powered up and operating. Verify that network connectivity exists between the device and CUCM, and verify that the CPU utilization is in the safe range. This is applicable for SCCP protocol only. securityMismatch: The CUCM detected a mismatch in the security settings of the device and/or the CUCM. The mismatches that can be detected are: 1) The device established a secure connection, yet reported that it does not have the ability to do authenticated signaling. 2) The device did not establish a secure connection, but the security mode configured for the device indicates that it should have done so. 3) The device established a secure connection, but the security mode configured for the device indicates that it should not have done so autoRegisterDBError: Auto-registration of a device failed for one of the following reasons: 1)Auto-registration is not allowed for the device type. 2)An error occurred while adding the auto-registering device to the database (stored procedure). dbAccessError: Device registration failed because of an error that occurred while building the station registration profile. This usually indicates a synchronization problem with the database. autoRegisterDBConfigTimeout: The CUCM timed out during auto-registration of a device. The registration profile of the device did not get inserted into the database in time. The device will automatically attempt to register again. This is applicable for SCCP protocol only. deviceTypeMismatch: The device type reported by the device does not match the device type configured on the CUCM addressingModeMismatch: The CUCM detected an error related to the addressing mode configured for the device. One of the following errors were detected: 1)The device is configured to use only IPv4 addressing, but did not specify an IPv4 address. 2)The device is configured to use only IPv6 addressing, but did not specify an IPv6 address. This is applicable for SCCP protocol only.', NULL, 'INTEGER { noError(0), unknown(1), noEntryInDatabase(2), databaseConfigurationError(3), deviceNameUnresolveable(4), maxDevRegExceeded(5), connectivityError(6), initializationError(7), deviceInitiatedReset(8), callManagerReset(9), authenticationError(10), invalidX509NameInCertificate(11), invalidTLSCipher(12), directoryNumberMismatch(13), malformedRegisterMsg(14), protocolMismatch(15), deviceNotActive(16), authenticatedDeviceAlreadyExists(17), obsoleteProtocolVersion(18), databaseTimeout(23), registrationSequenceError(25), invalidCapabilities(26), capabilityResponseTimeout(27), securityMismatch(28), autoRegisterDBError(29), dbAccessError(30), autoRegisterDBConfigTimeout(31), deviceTypeMismatch(32), addressingModeMismatch(33) }', 'current', NULL, 104);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (161, 'CcmDevUnregCauseCode', 'This syntax is used as means of identifying the reasons for a device getting unregistered. The scope of this enumeration can expand to comply with RFC 2578. noError: No Error unknown: Unknown error cause noEntryInDatabase: Device not configured properly in the CUCM database databaseConfigurationError: Device configuration error in the CUCM database deviceNameUnresolveable: The CallManager is unable to resolve the device name to an IP Address internally maxDevRegExceeded: Maximum number of device registrations have been reached connectivityError: CallManager is unable to establish communication with the device during registration initializationError: Indicates an error occurred when the CallManager tries to initialize the device deviceInitiatedReset: Indicates that the error was due to device initiated reset callManagerReset: Indicates that the error was due to call manager reset. deviceUnregistered: DeviceUnregistered. malformedRegisterMsg: Indicates that SIP device attempted to register with CallManager, but the REGISTER message contained formatting errors. sccpDeviceThrottling: The indicated SCCP device exceeded the maximum number of events allowed per-SCCP device. keepAliveTimeout: A KeepAlive message was not received. Possible causes include device power outage, network power outage, network configuration error, network delay,packet drops, packet corruption and CUCM node experiencing high CPU usage. configurationMismatch: The configuration on the SIP device does not match the configuration in CUCM. callManagerRestart: A device restart was initiated from CUCM Administration, either due to an explicit command from an administrator or due to a configuration change such as adding, deleting or changing a directory number associated with the device. duplicateRegistration: CUCM detected that the device attempted to register to two nodes at the same time. CUCM initiated a restart to the phone to force it to re-home to a single node. callManagerApplyConfig: CUCM configuration is changed. deviceNoResponse: Device is not responding Service Control Notify from CUCM. emLoginLogout: The device has been unregistered due to an Extension Mobility login or logout. emccLoginLogout: The device has been unregistered due to an Extension Mobility Cross Cluster login or logout. powerSavePlus: The device powered off as a result of the Power Save Plus feature that is enabled for this device. When the device powers off, it remains unregistered from CUCM until the Phone On Time defined in the Product Specific Configuration for this device. callManagerForcedRestart: The device did not respond to an Apply Config request and as a result, CUCM had sent a restart request to the device. The device may be offline due to a power outage or network problem. Confirm that the device is powered-up and that network connectivity exists between the device and CUCM. This is applicable for SIP protocol only. sourceIPAddrChanged: The device has been unregistered because the IP address in the Contact header of the REGISTER message has changed. The device will be automatically re-registered. No action is necessary. This is applicable for SIP protocol only. sourcePortChanged: The device has been unregistered because the port number in the Contact header of the REGISTER message has changed. The device will be automatically re-registered. No action is necessary. This is applicable for SIP protocol only. registrationSequenceError: A device requested configuration information from the CUCM at an unexpected time. The CUCM no longer had the requested information in memory. invalidCapabilities: The CUCM detected an error in the updated media capabilities reported by the device. The device reported the capabilities in one of the StationUpdateCapabilities message variants. This is applicable for SCCP protocol only. fallbackInitiated The device has initiated a fallback and will automatically re-register to a higher-priority CUCM. No action is necessary. deviceSwitch A second instance of an endpoint with the same device name has registered and assumed control. No action is necessary.', NULL, 'INTEGER { noError(0), unknown(1), noEntryInDatabase(2), databaseConfigurationError(3), deviceNameUnresolveable(4), maxDevRegExceeded(5), connectivityError(6), initializationError(7), deviceInitiatedReset(8), callManagerReset(9), deviceUnregistered(10), malformedRegisterMsg(11), sccpDeviceThrottling(12), keepAliveTimeout(13), configurationMismatch(14), callManagerRestart(15), duplicateRegistration(16), callManagerApplyConfig(17), deviceNoResponse(18), emLoginLogout(19), emccLoginLogout(20), energywisePowerSavePlus(21), callManagerForcedRestart(22), sourceIPAddrChanged(23), sourcePortChanged(24), registrationSequenceError(25), invalidCapabilities(26), fallbackInitiated(28), deviceSwitch(29) }', 'current', NULL, 104);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (162, 'CcmDeviceStatus', 'This syntax is used to identify the registration status of a device with the local call manager. unknown: The registration status of the device is unknown registered: The device has successfully registered with the local call manager unregistered: The device is no longer registered with the local call manager rejected: Registration request from the device was rejected by the local call manager. partiallyregistered: At least one but not all of the lines are successfully registered to the local call manager. Applicable only to SIP phones.', NULL, 'INTEGER { unknown(1), registered(2), unregistered(3), rejected(4), partiallyregistered(5) }', 'current', NULL, 104);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (163, 'CcmPhoneProtocolType', 'This syntax is used to identify the protocol between phone and Cisco Call Manager. unknown: The phone protocol is unknown  sccp: The phone protocol is SCCP  sip: The phone protocol is SIP.', NULL, 'INTEGER { unknown(1), sccp(2), sip(3) }', 'current', NULL, 104);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (164, 'CcmDeviceLineStatus', 'This syntax is used to identify the registration status of a line of the device with the local call manager. unknown: The registration status of the device line is unknown registered: The device line has successfully registered with the local call manager unregistered: The device line is no longer registered with the local call manager rejected: Registration request from the device line was rejected by the local call manager.', NULL, 'INTEGER { unknown(1), registered(2), unregistered(3), rejected(4) }', 'current', NULL, 104);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (165, 'CcmSIPTransportProtocolType', 'This textual convention defines the possible transport protocol types which are used for setting up SIP calls unknown: The SIP Trunk transport type is unknown tcp: The SIP Trunk transport type is tcp udp: The SIP Trunk transport type is udp tcpAndUdp: The SIP Trunk transport type is tcp and udp. Applicable only for InTransportProtocolType. tls: The SIP Trunk transport type is tls.', NULL, 'INTEGER { unknown(1), tcp(2), udp(3), tcpAndUdp(4), tls(5) }', 'current', NULL, 104);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (166, 'CcmDeviceProductId', 'This syntax is used to identify the product id of a device. gwyCiscoCat6KT1(1): Cisco Catalyst 6000 T1 VoIP Gateway gwyCiscoCat6KE1(2): Cisco Catalyst 6000 E1 VoIP Gateway gwyCiscoCat6KFXS(3): Cisco Catalyst 6000 24 Port FXS Gateway gwyCiscoCat6KFXO(4): Cisco Catalyst 6000 12 Port FXO Gateway gwyCiscoDT24Plus(7): Cisco DT-24+ Gateway gwyCiscoDT30Plus(8): Cisco DT-30+ Gateway gwyCiscoDT24(9): Cisco DT-24 Gateway gwyCiscoAT2(10): Cisco AT2 Gateway gwyCiscoAT4(11): Cisco AT4 Gateway gwyCiscoAT8(12): Cisco AT8 Gateway gwyCiscoAS2(13): Cisco AS2 Gateway gwyCiscoAS4(14): Cisco AS4 Gateway gwyCiscoAS8(15): Cisco AS8 Gateway gwyCiscoMGCPFXOPort(18): Cisco MGCP FXO Port gwyCiscoMGCPFXSPort(19): Cisco MGCP FXS Port gwyCiscoVG200(43): Cisco VG200 gwyCisco26XX(44): Cisco 26XX gwyCisco362X(45): Cisco 362X gwyCisco364X(46): Cisco 364X gwyCisco366X(47): Cisco 366X gwyCiscoMGCPT1Port(52): Cisco MGCP T1 Port gwyCiscoMGCPE1Port(55): Cisco MGCP E1 Port gwyCiscoCat4224VoiceGwySwitch(58): Cisco CAT 4224 Voice Gateway Switch gwyCiscoCat4000AccessGwyModule(59): Cisco CAT 4000 Access Gateway Module gwyCiscoIAD2400(62): Cisco IAD2400 gwyCiscoVGCEndPoint(65): Cisco VGC PHONE gwyCiscoVG224AndV248(66): Cisco VGC Gateway gwyCiscoSlotVGCPort(67): Cisco VGC Port gwyciscoVGCBox(68): Cisco VGC Box gwyCiscoATA186(69): Cisco ATA 186 gwyCiscoICS77XXMRP2XX(70): Cisco ICS77XX-MRP2XX gwyCiscoICS77XXASI81(71): Cisco ICS77XX-ASI81 gwyCiscoICS77XXASI160(72): Cisco ICS77XX-ASI160 gwyCiscoCat6000AVVIDServModule(80): Cisco Catalyst 6000 AVVID Services Module gwyCiscoWSX6600(81): Cisco WS-X6600 gwyCiscoMGCPBRIPort(90): Cisco MGCP BRI Port gwyCiscoWSSVCCMMMS(10001): Cisco WS-SVC-CMM-MS gwyCisco3745(20000): Cisco 3745 gwyCisco3725(20002): Cisco 3725 gwyCiscoICS77XXMRP3XX(30004): Cisco ICS77XX MRP3XX gwyCiscoICS77XXMRP38FXS(30005): Cisco ICS77XX MRP3 8FXS gwyCiscoICS77XXMRP316FXS(30006): Cisco ICS77XX MRP3 16FXS gwyCiscoICS77XXMRP38FXOM1(30007): Cisco ICS77XX MRP3 8FXO M1 gwyCisco269X(30011): Cisco 269X gwyCisco1760(30019): Cisco 1760 gwyCisco1751(30020): Cisco 1751 h323Phone(16): H323 Phone h323Trunk(17): H323 Trunk h323AnonymousGateway(49): H323 Anonymous Gateway h323H225GKControlledTrunk(75): H225 Trunk Gatekeeper Controlled h323ICTGKControlled(76): Inter-Cluster Trunk Gatekeeper Controlled h323ICTNonGKControlled(77): Inter-Cluster Trunk Non-Gatekeeper Controlled voiceMailUOnePort(27): Uone Port sipTrunk(95): SIP Trunk unknown(-1): Unknown Device Product Id other(-2): Unidentified Device Product Id.', NULL, 'INTEGER { other(-2), unknown(-1), gwyCiscoCat6KT1(1), gwyCiscoCat6KE1(2), gwyCiscoCat6KFXS(3), gwyCiscoCat6KFXO(4), gwyCiscoDT24Plus(7), gwyCiscoDT30Plus(8), gwyCiscoDT24(9), gwyCiscoAT2(10), gwyCiscoAT4(11), gwyCiscoAT8(12), gwyCiscoAS2(13), gwyCiscoAS4(14), gwyCiscoAS8(15), h323Phone(16), h323Trunk(17), gwyCiscoMGCPFXOPort(18), gwyCiscoMGCPFXSPort(19), voiceMailUOnePort(27), gwyCiscoVG200(43), gwyCisco26XX(44), gwyCisco362X(45), gwyCisco364X(46), gwyCisco366X(47), h323AnonymousGatewy(49), gwyCiscoMGCPT1Port(52), gwyCiscoMGCPE1Port(55), gwyCiscoCat4224VoiceGwySwitch(58), gwyCiscoCat4000AccessGwyModule(59), gwyCiscoIAD2400(62), gwyCiscoVGCEndPoint(65), gwyCiscoVG224AndV248(66), gwyCiscoSlotVGCPort(67), gwyCiscoVGCBox(68), gwyCiscoATA186(69), gwyCiscoICS77XXMRP2XX(70), gwyCiscoICS77XXASI81(71), gwyCiscoICS77XXASI160(72), h323H225GKControlledTrunk(75), h323ICTGKControlled(76), h323ICTNonGKControlled(77), gwyCiscoCat6000AVVIDServModule(80), gwyCiscoWSX6600(81), gwyCiscoMGCPBRIPort(90), sipTrunk(95), gwyCiscoWSSVCCMMMS(10001), gwyCisco3745(20000), gwyCisco3725(20002), gwyCiscoICS77XXMRP3XX(30004), gwyCiscoICS77XXMRP38FXS(30005), gwyCiscoICS77XXMRP316FXS(30006), gwyCiscoICS77XXMRP38FXOM1(30007), gwyCisco269X(30011), gwyCisco1760(30019), gwyCisco1751(30020) }', 'obsolete', NULL, 104);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (167, 'IsdnSignalingProtocol', 'This data type is used as the syntax of the isdnSignalingProtocol object in the definition of ISDN-MIB''s isdnSignalingTable.  The definition of this textual convention with the addition of newly assigned values is published periodically by the IANA, in either the Assigned Numbers RFC, or some derivative of it specific to Internet Network Management number assignments. (The latest arrangements can be obtained by contacting the IANA.)  Requests for new values should be made to IANA via email (iana@iana.org).', NULL, 'INTEGER { other(1), dss1(2), etsi(3), dass2(4), ess4(5), ess5(6), dms100(7), dms250(8), ni1(9), ni2(10), ni3(11), vn2(12), vn3(13), vn4(14), vn6(15), kdd(16), ins64(17), ins1500(18), itr6(19), cornet(20), ts013(21), ts014(22), qsig(23), swissnet2(24), swissnet3(25) }', 'current', NULL, 105);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (168, 'RasProtocol', 'The protocol immediately underlying the remote access session.  The value ''other'' has been listed to allow for the MIB to be supported on proprietary protocols not listed here.', NULL, 'INTEGER { other(1), ipsec(2), l2tp(3), l2tpoveripsec(4), pptp(5), l2f(6), ssl(7) }', 'current', NULL, 107);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (169, 'UserAuthenMethod', 'The mechanism used to authenticate the user.  The value ''other'' has been listed to allow for the MIB to support proprietary authentication methods not listed here.', NULL, 'INTEGER { none(1), other(2), radius(3), tacacsplus(4), kerberos(5), local(6), ldap(7), ntlm(8), sdi(9) }', 'current', NULL, 107);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (170, 'UserAuthorMethod', 'The mechanism used to authorize the user. The value ''other'' has been listed to allow for the MIB to support proprietary authorization mechanisms not listed here.', NULL, 'INTEGER { none(1), other(2), radius(3), tacacsplus(4), kerberos(5), local(6), ldap(7) }', 'current', NULL, 107);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (171, 'SessionEncrAlgo', 'The encryption algorithm used to secure the remote access session.', NULL, 'INTEGER { none(1), des(2), des3(3), rc4(4), rc5(5), idea(6), cast(7), blowfish(8), aes(9) }', 'current', NULL, 107);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (172, 'SessionAuthAlgo', 'The authentication algorithm used by to perform packet authentication in the remote access session.  The value ''other'' has been listed to allow for the MIB to support packet validation algorithms not listed here.', NULL, 'INTEGER{ none(1), other(2), hmacMd5(3), hmacSha(4) }', 'current', NULL, 107);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (173, 'SessionCompressionAlgo', 'The compression algorithm used in the remote access session.  The value ''other'' has been listed to allow for the MIB to support compression not listed here.', NULL, 'INTEGER{ none(1), other(2), lzs(3) }', 'current', NULL, 107);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (174, 'SessionStatus', 'The status of a remote access session.  initializing: the session is in the process of being established  established : the session is established and is ready to carry application traffic. Sessions in this state may also be referred to as ''active'' sessions.  terminating : the session is in the process of termination.  Objects of this type may be used to terminate an established session by setting value of the object to terminating(3).  Management entity may not write values initializing(1) or established(2) onto objects of this type. Doing so would cause the managed entity to return an error condition.', NULL, 'INTEGER { initializing(1), established(2), terminating(3) }', 'current', NULL, 107);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (175, 'SessionIndex', 'The type used to index a remote access session.', NULL, 'Integer32 (1..2147483647)', 'current', NULL, 107);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (176, 'FailureRecordIndex', 'The type used to index failure records in the failure archive.', NULL, 'Unsigned32 (1..4294967295)', 'current', NULL, 107);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (177, 'DlciNumber', 'Numerical format of Data Link Connection Identifier (DLCI) in decimal, identical to the ''DLCI'' as INTEGER of 0..DLCINumber in RFC1315. The maximum value depends on Frame Relay implementation, which is currently set to be 1023 for 2-octet address format per UNI Implementation Agreement FRF.1.', NULL, 'INTEGER (0..1023)', 'current', NULL, 112);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (178, 'CfrMapProtocols', 'Cisco link types (network protocols) that run over Frame Relay. Associated values, except for wildcard, match assigned values of internal software respectively.', NULL, 'INTEGER { arp(1), serialArp(6), ip(7), xns(10), novell(11), apollo(12), vines(13), appletalk(16), ieeeSpanning(18), decnet(22), clns(25), rsrb(37), bridge(38), stun(39), frArp(40), uncompressedTcp(47), compressedTcp(48), llc2(49), frSwitch(53), dlsw(63), nhrp(74), compressedRtp(83), wildcard(999) }', 'current', NULL, 112);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (179, 'CounterBasedGauge64', 'The CounterBasedGauge64 type represents a non-negative integer, which may increase or decrease, but shall never exceed a maximum value, nor fall below a minimum value. The maximum value can not be greater than 2^64-1 (18446744073709551615 decimal), and the minimum value can      not be smaller than 0. The value of a CounterBasedGauge64 has its maximum value whenever the information being modeled is greater than or equal to its maximum value, and has its minimum value whenever the information being modeled is smaller than or equal to its minimum value. If the information being modeled subsequently decreases below (increases above) the maximum (minimum) value, the CounterBasedGauge64 also decreases (increases).  Note that this TC is not strictly supported in SMIv2, because the ''always increasing'' and ''counter wrap'' semantics associated with the Counter64 base type are not preserved. It is possible that management applications which rely solely upon the (Counter64) ASN.1 tag to determine object semantics will mistakenly operate upon objects of this type as they would for Counter64 objects.  This textual convention represents a limited and short-term solution, and may be deprecated as a long term solution is defined and deployed to replace it.', NULL, 'Counter64', 'current', NULL, 115);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (180, 'ZeroBasedCounter64', 'This TC describes an object which counts events with the following semantics: objects of this type will be set to zero(0) on creation and will thereafter count appropriate events, wrapping back to zero(0) when the value 2^64 is reached.  Provided that an application discovers the new object within the minimum time to wrap it can use the initial value as a delta since it last polled the table of which this object is part. It is important for a management station to be aware of this minimum time and the actual time between polls, and to discard data if the actual time is too long or there is no defined minimum time.  Typically this TC is used in tables where the INDEX space is constantly changing and/or the TimeFilter mechanism is in use.  Note that this textual convention does not retain all the semantics of the Counter64 base type. Specifically, a Counter64 has an arbitrary initial value, but objects defined with this TC are required to start at the value      zero. This behavior is not likely to have any adverse effects on management applications which are expecting Counter64 semantics.  This textual convention represents a limited and short-term solution, and may be deprecated as a long term solution is defined and deployed to replace it.', NULL, 'Counter64', 'current', NULL, 115);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (181, 'QueueMechanism', 'This denotes which mechanism is used with QueueLimit.  precedence Based on IP precedence dscp Based on DSCP values discardClass Based on discard class qosGroup Based on qosgroup class atmClp Based on atm-clp class mplsExp Based on MPLS Experimental class', NULL, 'INTEGER { precedence(1), dscp(2), discardClass(3), qosGroup(4), atmClp(5), mplsExp(6) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (182, 'QosObjectType', 'Enums to indicate different QoS objects . policymap - The object in query is a PolicyMap, being attached on a logical interface. classmap - The object in query is a ClassMap, being used by it''s parent PolicyMap. matchStatement - The object in query is a Match Statement, being used by it''s parent ClassMap. queueing - The object in query is a queueing feature being applied on the parent ClassMap. randomDetect - The object in query is a Random Detect feature being applied on the parent ClassMap. trafficShaping - The object in query is a traffic-shaping feature being applied on the parent ClassMap. police - The object in query is a Police feature being applied on the parent ClassMap. set - The object in query is a Packet Marking feature being applied on the parent ClassMap. compression - The object in query is a IP header compression feature being applied on the parent ClassMap. ipslaMeasure - The object in query is Measure IPSLAs feature being applied on the parent ClassMap. account - The object in query is C3Pl_Account feature being applied on the parent ClassMap.', NULL, 'INTEGER { policymap(1), classmap(2), matchStatement(3), queueing(4), randomDetect(5), trafficShaping(6), police(7), set(8), compression(9), ipslaMeasure(10), account(11) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (183, 'TrafficDirection', 'Enums to indicate whether the Policymap is for Input or Output direction.', NULL, 'INTEGER { input(1), output(2) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (184, 'QosClassInfo', 'Enums to indicate whether the Classmap is for Match All or Match Any.', NULL, 'INTEGER { none(1), matchAll(2), matchAny(3) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (185, 'QosMatchInfo', 'Enums to indicate whether the MatchStatement is matching on negated criteria (Match Not).', NULL, 'INTEGER { none(1), matchNot(2) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (186, 'InterfaceType', 'Enums to indicate the type of logical interface to which a particular service policy is attached. Main Interface - Service policy is attached on the main interface. Sub Interface - Service policy is attached on the sub interface. Frame Relay DLCI - Service policy is attached on the a Frame Relay DLCI. ATM VC - Service policy is attached on the an ATM Virtual Circuit. Control Plane - Service policy is attached to the control plane of the device. Vlan Port - Service policy is attached to a particular vlan of a layer 2 interface that can carry traffic on multiple vlans. EVC - Service policy is attached to the Ethernet Virtual Connections.', NULL, 'INTEGER { mainInterface(1), subInterface(2), frDLCI(3), atmPVC(4), controlPlane(5), vlanPort(6), evc(7) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (187, 'QueueingBandwidthUnits', 'The units of the bandwidth, used to allocate bandwidth. Bandwidth can be either an absolute kbps number, or be expressed as a percentage of the available bandwidth.  kbps Allocated bandwidth in Kilo bits Per Second  percentage Allocated bandwidth as percentage of reference bandwidth.  percentageRemaining Percentage of unallocated bandwidth reserved for this class.  ratioRemaining Ratio of unallocated bandwidth reserved for this class (in relation to other classes).  perThousand Allocated bandwidth in Parts Per Thousand  perMillion Allocated bandwidth in Parts Per Million.', NULL, 'INTEGER { kbps(1), percentage(2), percentageRemaining(3), ratioRemaining(4), perThousand(5), perMillion(6) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (188, 'TrafficShapingLimit', 'The limit used by the traffic-shaping feature. This value may be ''average'' or ''peak'', which indicates whether it is shaping by average rate or peak rate.', NULL, 'INTEGER { average(1), peak(2) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (189, 'PoliceAction', 'The available actions taken on packets upon conforming, exceeding or violating the configured police rate.  Transmit - Transmit the packet if the packet conforms or exceeds the configured police rate. Set IP DSCP - Set the IP DSCP value if the packet conforms or exceeds the configured police rate. Set IP Precedence - Set the IP precedence value if the packet conforms or exceeds the configured police rate. Set Qos Group - Set the QoS Group value if the packet conforms or exceeds the configured police rate. Set MPLS Exp - Set the MPLS Experimental Imposition vaule for the applicable action. Set ATM CLP - Set the ATM CLP bit for the applicable action. Set FR DE - Set the FR DE bit for the applicable action. Set L2 COS - Set the 802.1p priority field in 802.1Q VLAN tag for the applicable action. Set Discard Class - Set the Discard Class value for the applicable action. Drop - Drop the packet if the packet conforms or exceeds the configured police rate. Set MPLS Exp TopMost - Set the MPLS Experimental TopMost vaule for the applicable action. Set IP DSCP Tunnel - Set the IP DSCP Tunnel value for the applicable action. Set IP Precedence Tunnel - Set the IP Precedence Tunnel value for the applicable action. Set Inner L2 COS - Set the 802.1p priority field in inner 802.1q VLAN tag (QinQ) for the applicable action. Unconfigured - No action is set for this police. Set Dei - Set the DEI(Discard Eligiable Indicator) bit in the topmost 802.1ad header. Set Dei Imposition - Set the DEI bit on all imposed 802.1ad header. Set SRP Priority - Sets the spatial reuse protocol (SRP) priority value of an outgoing packet.', NULL, 'INTEGER { transmit(1), setIpDSCP(2), setIpPrecedence(3), setQosGroup(4), drop(5), setMplsExp(6), setAtmClp(7), setFrDe(8), setL2Cos(9), setDiscardClass(10), setMplsExpTopMost(11), setIpDscpTunnel(12), setIpPrecedenceTunnel(13), setL2CosInner(14), unconfigured(15), setDei(16), setDeiImposition(17), setSrpPriority(18) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (190, 'SetFeatureType', 'Bit-wise representation of packet marking feature available today. For historical reason, both packet marking and SET terms have been used across Cisco Class-Based QOS, but they have the same meaning. This feature is used to mark/set appropriate fields(e.g, dscp, precedence, mpls-experimental -topmost,l2CosInner) for applicable packets. ipDscp Packet set/mark with DSCP bit ipPrecedence Packet set/mark with Precedence bit qosGroupNumber Packet set/mark with QosGroup bit frDeBit Packet set/mark with FR-DE bit l2Cos Packet set/mark with COS bit mplsExp Packet set/mark with MPLS Experimental bit discardClass Packet set/mark with discard class bit mplsExpTopMost Packet set/mark with MPLS Experimental topmost bit srpPriority Packet set/mark with srp priority bit frFecnBecn Packet set/mark with FECN bit ipDscpTunnel Packet set/mark with DSCP tunnel bit ipPrecedenceTunnel Packet set/mark with Precedence tunnel bit l2CosInner Packet set/mark with COS inner bit dei Packet set/mark with DEI bit deiImposition Packet set/mark with DEI Imposition bit', NULL, 'BITS { ipDscp(0), ipPrecedence(1), qosGroupNumber(2), frDeBit(3), atmClpBit(4), l2Cos(5), mplsExp(6), discardClass(7), mplsExpTopMost(8), srpPriority(9), frFecnBecn(10), ipDscpTunnel(11), ipPrecedenceTunnel(12), l2CosInner(13), dei(14), deiImposition(15) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (191, 'REDMechanism', 'This denotes which mechanism is used with RED.  precedence Based on IP precedence dscp Based on DSCP values discardClass Based on discard class l2Cos Based on L2-COS class atmClp Based on ATM-CLP class mplsExp Based on MPLS Experimental values redDefault Default RED profile redUserDefault User specified Default RED profile dei Based on DEI bit', NULL, 'INTEGER { precedence(1), dscp(2), discardClass(3), l2Cos(4), atmClp(5), mplsExp(6), redDefault(7), redUserDefault(8), dei(9) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (192, 'CbQosQueueUnitType', 'A value that represents an unit type of queue size.  packets(1) Represents the UNITS of ''packets'' for queue size.  cells(2) Represents the UNITS of ''cells'' for queue size.  bytes(3) Represents the UNITS of ''bytes'' for queue size.  ms(4) Represents the UNITS of ''milli-seconds'' for queue size  us(5) Represents the UNITS of ''micro-seconds'' for queue size  percentage(6) Represents the UNITS of ''percentage'' for queue size  To support future extensions, the CbQosQueueUnitType textual convention SHOULD NOT be sub-typed in object type definitions.  It MAY be sub-typed in compliance statements in order to require only a subset of these queue size types for a compliant implementation.  Implementations must ensure that CbQosQueueUnitType objects and any dependent object (e.g. CbQosQueueDepth) are consistent. An inconsistentValue error must be generated if an attempt to change an CbQosQueueUnitType object would lead to an undefined CbQosQueueDepth value. In particular, CbQoSQueueUnitType/CbQosQueueDepth pairs must be changed together if the CbQosQueueUnitType type changes (e.g. from packets(1) to cells(2)).', NULL, 'INTEGER { packets(1), cells(2), bytes(3), ms(4), us(5), percentage(6) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (193, 'CbQosQueueDepth', 'Denotes a generic Queue depth value.  An CbQoSQueueDepth value is always interpreted within the context of an CbQosQueueUnitType value. Every usage of the CbQosQueueDepth textual convention is required to specify the CbQosQueueUnitType object which provides the context. It is suggested that the CbQoSQueueUnitType object is logically registered before the object(s) which use the CbQosQueueDepth textual convention if they appear in the same logical row. The value of an CbQosQueueDepth object must always be consistent with the value of the associated CbQosQueueUnitType object. Attempts to set an CbQosQueueDepth object to a value which is inconsistent with the associated CbQosQueueUnitType must fail with an inconsistentValue error.', NULL, 'Unsigned32', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (194, 'CbQosRateType', 'The type of rate. Rate type can be either an absolute bps number, or be expressed as a percentage of the available interface bandwidth, or an absolute cps number.  bps Bits Per Second percentage % cps Cells Per Second perThousand Parts Per Thousand perMillion Parts Per Million', NULL, 'INTEGER { bps(1), percentage(2), cps(3), perThousand(4), perMillion(5) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (195, 'IPHCOption', 'Enums to indicate the type of IP header compression. rtp(1) UDP/RTP compression. tcp(2) TCP compression. bothRtpTcp(3) Both UDP/RTP and TCP compression.', NULL, 'INTEGER { rtp(1), tcp(2), bothRtpTcp(3) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (196, 'CbQosTMSetType', 'The available packet marking types which can use tablemap to establish to-from relationship for enhanced packeting marking.', NULL, 'INTEGER { none(0), ipDscp(1), ipPrecedence(2), qosGroup(3), l2Cos(4), mplsExpImp(5), mplsExpTop(6) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (197, 'CbQosEBType', 'A value that indicates the type of bandwidth estimate algorithm. typeNone no algorithm is selected typeCorvil algorithm based on Corvil bandwidth calculation.', NULL, 'INTEGER { typeNone(0), typeCorvil(1) }', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (198, 'CbQosEBCtd', 'A CTD (Corvil Traffic Descriptor) specific value.', NULL, 'OCTET STRING', 'current', NULL, 116);
INSERT INTO mib_textual_convention (id_mib_textual_convention, name, description, display_hint, syntax, status, reference, id_mib_module) VALUES (199, 'SetC3plAccountFeatureType', 'Enums to indicate drop types for C3PL Account action.', NULL, 'INTEGER { queueing(0), wred(1), police(2) }', 'current', NULL, 116);


-- enable triggers
ALTER TABLE element_module DISABLE TRIGGER ALL;
ALTER TABLE mib_app_property DISABLE TRIGGER ALL;
ALTER TABLE mib_capability DISABLE TRIGGER ALL;
ALTER TABLE mib_capability_support DISABLE TRIGGER ALL;
ALTER TABLE mib_capability_support_variation DISABLE TRIGGER ALL;
ALTER TABLE mib_compliance DISABLE TRIGGER ALL;
ALTER TABLE mib_compliance_module DISABLE TRIGGER ALL;
ALTER TABLE mib_compliance_module_group DISABLE TRIGGER ALL;
ALTER TABLE mib_compliance_module_object DISABLE TRIGGER ALL;
ALTER TABLE mib_element DISABLE TRIGGER ALL;
ALTER TABLE mib_favorite DISABLE TRIGGER ALL;
ALTER TABLE mib_identity DISABLE TRIGGER ALL;
ALTER TABLE mib_identity_revision DISABLE TRIGGER ALL;
ALTER TABLE mib_module DISABLE TRIGGER ALL;
ALTER TABLE mib_module_import DISABLE TRIGGER ALL;
ALTER TABLE mib_notification_group DISABLE TRIGGER ALL;
ALTER TABLE mib_notification_type DISABLE TRIGGER ALL;
ALTER TABLE mib_textual_convention DISABLE TRIGGER ALL;

COMMIT;
